local addonName, addon = ...

-- source: https://github.com/TyrsDev/WoW-Classic-Quests
-- Thanks to TyrsDev!

addon.questsDB = {
   [2] = {
      ["name_ru"] = "Коготь гиппогрифа Острокогтя";
      ["type"] = "Solo";
      ["name_fr"] = "La griffe de Serres-tranchantes";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Klaue von Scharfkralle";
      ["followup"] = 247;
      ["name_cn"] = "沙普塔隆的爪子";
      ["objective"] = "Bring Sharptalon's Claw to Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["faction"] = "Horde";
      ["name"] = "Sharptalon's Claw";
      ["sort"] = "Ashenvale";
      ["prev"] = 6383;
      ["prequests"] = {
         [1] = 6383;
      };
      ["level"] = 30;
      ["name_es"] = "La garfa de Garfafilada";
      ["req"] = 20;
   };
   [5] = {
      ["name_ru"] = "Урчащий живот Трясунчика";
      ["type"] = "Solo";
      ["name_fr"] = "L'estomac qui gargouille";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Bibbers' knurrender Magen";
      ["name"] = "Jitters' Growling Gut";
      ["name_cn"] = "????的基特斯";
      ["objective"] = "Speak with Chef Grual.";
      ["next"] = 93;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 163;
      ["prequests"] = {
         [1] = 163;
      };
      ["level"] = 20;
      ["name_es"] = "La hambruna de Alterio";
      ["req"] = 17;
   };
   [6] = {
      ["name_ru"] = "Награда за голову Гаррика Тихокрада";
      ["type"] = "Solo";
      ["objective"] = "Kill Garrick Padfoot and bring his head to Deputy Willem at Northshire Abbey.";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Kopfgeld auf Garrick Schleichfus";
      ["reward"] = {
         [1] = 6076;
         [2] = 60;
         [3] = 3070;
      };
      ["name_cn"] = "加瑞克・?德弗特的?金";
      ["name_fr"] = "La prime pour Garrick Ladetrousse";
      ["faction"] = "Alliance";
      ["name"] = "Bounty on Garrick Padfoot";
      ["sort"] = "Northshire Valley";
      ["prev"] = 18;
      ["prequests"] = {
         [1] = 18;
      };
      ["level"] = 5;
      ["name_es"] = "La recompensa por Garrick Piesuaves";
      ["req"] = 2;
   };
   [7] = {
      ["name_ru"] = "Нападение на лагерь кобольдов";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage du camp des kobolds";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "140211";
      ["name_cn"] = "剿?狗?人";
      ["name"] = "Kobold Camp Cleanup";
      ["objective"] = "Kill 10 Kobold Vermin, then return to Marshal McBride.";
      ["faction"] = "Alliance";
      ["sort"] = "Northshire Valley";
      ["prev"] = 783;
      ["prequests"] = {
         [1] = 783;
      };
      ["level"] = 2;
      ["name_es"] = "La Limpieza del Campamento Kobold";
      ["req"] = 1;
   };
   [8] = {
      ["name_ru"] = "Выгодная сделка";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Nondescript Letter to Innkeeper Renee in Tirisfal Glades.";
      ["repgain"] = {
         [68] = 25;
      };
      ["sort"] = "Deathknell";
      ["name_fr"] = "Un marche de voleur";
      ["name_cn"] = "潜行者的交易";
      ["reward"] = {
         [1] = 4604;
         [2] = 159;
      };
      ["name_de"] = "Ein Schurkenhandel";
      ["faction"] = "Horde";
      ["name"] = "A Rogue's Deal";
      ["level"] = 5;
      ["name_es"] = "Un trato de picaro";
      ["req"] = 1;
   };
   [9] = {
      ["name_ru"] = "Поля смерти";
      ["type"] = "Solo";
      ["objective"] = "Farmer Saldean wants you to kill 20 Harvest Watchers.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Les champs de mort";
      ["name_cn"] = "清理荒野";
      ["reward"] = {
         [1] = 3578;
         [2] = 1561;
      };
      ["name_de"] = "Tod auf den Feldern";
      ["faction"] = "Alliance";
      ["name"] = "The Killing Fields";
      ["level"] = 15;
      ["name_es"] = "Campos de la muerte";
      ["req"] = 8;
   };
   [10] = {
      ["name_ru"] = "Спасение Холстомера";
      ["type"] = "Solo";
      ["name_fr"] = "La redemption de Scrimshank";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_de"] = "Die Erlosung von Kieselschliff";
      ["name"] = "The Scrimshank Redemption";
      ["name_cn"] = "?申克的救?";
      ["objective"] = "Discover the fate of Junior Surveyor Scrimshank, and bring either him or his surveying equipment to Senior Surveyor Fizzledowser in Gadgetzan.";
      ["next"] = 110;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 82;
      ["prequests"] = {
         [1] = 82;
      };
      ["level"] = 48;
      ["name_es"] = "La redencion de Patagolpe";
      ["req"] = 39;
   };
   [11] = {
      ["name_ru"] = "Награда за гноллов из стаи Речной Лапы";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Painted Gnoll Armbands to Deputy Rainer at the Barracks.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Kopfgeld auf die Flusspfotengnolle";
      ["reward"] = {
         [1] = 2249;
         [2] = 2238;
      };
      ["name_cn"] = "??河爪豺狼人";
      ["name_fr"] = "Prime pour les gnolls Rivepatte";
      ["faction"] = "Alliance";
      ["name"] = "Riverpaw Gnoll Bounty";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 239;
      ["prequests"] = {
         [1] = 239;
      };
      ["level"] = 10;
      ["name_es"] = "Recompensas por los gnolls Zarparrio";
      ["req"] = 6;
   };
   [12] = {
      ["name_ru"] = "Народное ополчение";
      ["type"] = "Solo";
      ["name_fr"] = "La milice du peuple";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Volksmiliz";
      ["name_cn"] = "西部荒野人民?";
      ["objective"] = "Gryan Stoutmantle wants you to kill 15 Defias Trappers and 15 Defias Smugglers then return to him on Sentinel Hill.";
      ["next"] = 13;
      ["sort"] = "Westfall";
      ["name"] = "The People's Militia";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 12;
      ["name_es"] = "La Milicia Popular";
      ["req"] = 9;
   };
   [13] = {
      ["name_ru"] = "Народное ополчение";
      ["objective"] = "Gryan Stoutmantle wants you to kill 15 Defias Pillagers and 15 Defias Looters and return to him on Sentinel Hill.";
      ["name_cn"] = "西部荒野人民?";
      ["sort"] = "Westfall";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "La milice du peuple";
      ["next"] = 14;
      ["name_de"] = "Die Volksmiliz";
      ["repgain"] = {
         [72] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The People's Militia";
      ["prev"] = 12;
      ["prequests"] = {
         [1] = 12;
      };
      ["series"] = 2;
      ["name_es"] = "La Milicia Popular";
      ["req"] = 9;
   };
   [14] = {
      ["name_ru"] = "Народное ополчение";
      ["objective"] = "Gryan Stoutmantle wants you to kill 15 Defias Highwaymen, 5 Defias Pathstalkers and 5 Defias Knuckledusters then return to him on Sentinel Hill.";
      ["name_cn"] = "西部荒野人民?";
      ["sort"] = "Westfall";
      ["level"] = 17;
      ["type"] = "Solo";
      ["name_fr"] = "La milice du peuple";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Die Volksmiliz";
      ["reward"] = {
         [1] = 1566;
         [2] = 1480;
         [3] = 12296;
      };
      ["faction"] = "Alliance";
      ["name"] = "The People's Militia";
      ["prev"] = 13;
      ["prequests"] = {
         [1] = 13;
      };
      ["series"] = 3;
      ["name_es"] = "La Milicia Popular";
      ["req"] = 9;
   };
   [15] = {
      ["name_ru"] = "Разведка в руднике Горного эха";
      ["type"] = "Solo";
      ["name_fr"] = "Enquete sur la crete aux echos";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Uberprufung der Echokammmine";
      ["name"] = "Investigate Echo Ridge";
      ["name_cn"] = "回音山??行?";
      ["objective"] = "Kill 10 Kobold Workers, then report back to Marshal McBride.";
      ["next"] = 21;
      ["faction"] = "Alliance";
      ["sort"] = "Northshire Valley";
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 3;
      ["name_es"] = "Investigar la Mina del Eco";
      ["req"] = 1;
   };
   [16] = {
      ["name_ru"] = "Жажда Джерарда";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [72] = 1;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Procurer de l'eau a Gerard";
      ["name_cn"] = "葛拉德的?料";
      ["reward"] = {
         [1] = 4536;
      };
      ["name_de"] = "Etwas zu trinken fur Gerard";
      ["faction"] = "Alliance";
      ["name"] = "Give Gerard a Drink";
      ["level"] = 1;
      ["name_es"] = "Dale de beber a Gerard";
      ["req"] = 1;
   };
   [17] = {
      ["name_ru"] = "В Ульдаман за реактивом";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Magenta Fungus Caps to Ghak Healtouch in Thelsamar.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Reagenzsuche in Uldaman";
      ["reward"] = {
         [1] = 9030;
      };
      ["name_cn"] = "奥?曼的?菇";
      ["name_fr"] = "Rechercher les composants a Uldaman";
      ["faction"] = "Alliance";
      ["name"] = "Uldaman Reagent Run";
      ["sort"] = "Uldaman";
      ["prev"] = 2500;
      ["prequests"] = {
         [1] = 2500;
      };
      ["level"] = 42;
      ["name_es"] = "Componentes de Uldaman";
      ["req"] = 36;
   };
   [18] = {
      ["name_ru"] = "Братство воров";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Red Burlap Bandanas to Deputy Willem outside the Northshire Abbey.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Bruderschaft der Diebe";
      ["reward"] = {
         [1] = 2224;
         [2] = 5580;
         [3] = 1161;
         [4] = 5579;
         [5] = 1159;
      };
      ["name_cn"] = "盗?兄弟会";
      ["name_fr"] = "La confrerie des voleurs";
      ["faction"] = "Alliance";
      ["name"] = "Brotherhood of Thieves";
      ["sort"] = "Northshire Valley";
      ["prev"] = 783;
      ["prequests"] = {
         [1] = 783;
      };
      ["level"] = 4;
      ["name_es"] = "Hermandad de ladrones";
      ["req"] = 2;
   };
   [19] = {
      ["name_ru"] = "Тарил'зун";
      ["type"] = "Group";
      ["objective"] = "Bring Tharil'zun's Head to Marshal Marris in Redridge.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Tharil'zun";
      ["reward"] = {
         [1] = 1276;
         [2] = 6093;
      };
      ["name_cn"] = "?瑞?祖恩";
      ["name_fr"] = "Tharil'zun";
      ["faction"] = "Alliance";
      ["name"] = "Tharil'zun";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 20;
      ["prequests"] = {
         [1] = 20;
      };
      ["level"] = 25;
      ["name_es"] = "Tharil'zun";
      ["req"] = 18;
   };
   [20] = {
      ["name_ru"] = "Угроза Черной горы";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Battleworn Axes to Marshal Marris in Lakeshire.";
      ["next"] = 19;
      ["name_fr"] = "La menace des Rochenoires";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "黑石氏族的威?";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Bedrohung durch den Schwarzfelsklan";
      ["faction"] = "Alliance";
      ["name"] = "Blackrock Menace";
      ["level"] = 21;
      ["name_es"] = "La amenaza de los Roca Negra";
      ["req"] = 18;
   };
   [21] = {
      ["name_ru"] = "Схватка у рудника Горного эха";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Kobold Laborers, then return to Marshal McBride at Northshire Abbey.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Scharmutzel in der Echokammmine";
      ["reward"] = {
         [1] = 2186;
         [2] = 2691;
         [3] = 11192;
      };
      ["name_cn"] = "回音山清剿行?";
      ["name_fr"] = "Reglement de comptes a Echo-Coron";
      ["faction"] = "Alliance";
      ["name"] = "Skirmish at Echo Ridge";
      ["sort"] = "Northshire Valley";
      ["prev"] = 15;
      ["prequests"] = {
         [1] = 15;
      };
      ["level"] = 5;
      ["name_es"] = "Escaramuza en la Mina del Eco";
      ["req"] = 1;
   };
   [22] = {
      ["name_ru"] = "Пирог из печени кровоклыка";
      ["type"] = "Solo";
      ["objective"] = "Salma Saldean needs 8 Goretusk livers to make a Goretusk Liver Pie.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "La tourte au foie de broche-tripes";
      ["name_cn"] = "猪肝??";
      ["reward"] = {
         [1] = 724;
         [2] = 2697;
      };
      ["name_de"] = "Pastete aus Geiferzahnleber";
      ["faction"] = "Alliance";
      ["name"] = "Goretusk Liver Pie";
      ["level"] = 12;
      ["name_es"] = "Pastel de higado de dentosangre";
      ["req"] = 9;
   };
   [23] = {
      ["name_ru"] = "Лапа Топтыжня";
      ["type"] = "Solo";
      ["name_fr"] = "La patte d'Ursangous";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ursangus' Tatze";
      ["followup"] = 247;
      ["name_cn"] = "??苟斯的爪子";
      ["objective"] = "Bring Ursangous's Paw to Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["faction"] = "Horde";
      ["name"] = "Ursangous's Paw";
      ["sort"] = "Ashenvale";
      ["prev"] = 6383;
      ["prequests"] = {
         [1] = 6383;
      };
      ["level"] = 24;
      ["name_es"] = "La pata de Ursangous";
      ["req"] = 20;
   };
   [24] = {
      ["name_ru"] = "Голова Тенумбры";
      ["type"] = "Solo";
      ["name_fr"] = "La tete de Shadumbra";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Schattumbras Kopf";
      ["followup"] = 247;
      ["name_cn"] = "?杜布拉的??";
      ["objective"] = "Bring Shadumbra's Head to Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["faction"] = "Horde";
      ["name"] = "Shadumbra's Head";
      ["sort"] = "Ashenvale";
      ["prev"] = 6383;
      ["prequests"] = {
         [1] = 6383;
      };
      ["level"] = 27;
      ["name_es"] = "La cabeza de Shadumbra";
      ["req"] = 20;
   };
   [25] = {
      ["name_ru"] = "Остановка у Каменного Когтя";
      ["type"] = "Solo";
      ["objective"] = "Dispatch 12 Befouled Water Elementals at Mystral Lake, due east of the Talondeep Path and southwest of Splintertree Post.$B$BScout the gazebo on Mystral Lake that overlooks the nearby Alliance outpost.$B$BReturn to Mastok Wrilehiss at Splintertree Post, Ashenvale.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Impasse aux Serres-Rocheuses";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "石爪山的困境";
      ["name_de"] = "Und dann langsam abkuhlen lassen";
      ["faction"] = "Horde";
      ["name"] = "Stonetalon Standstill";
      ["level"] = 25;
      ["name_es"] = "Un jarro de agua fria";
      ["req"] = 23;
   };
   [26] = {
      ["name_ru"] = "Необходимый урок";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dendrite Starblaze in the village of Nighthaven, Moonglade.";
      ["next"] = 28;
      ["name_de"] = "Eine wertvolle Lektion";
      ["sort"] = "Druid";
      ["name_cn"] = "必修的?程";
      ["name_fr"] = "Une lecon a apprendre";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "A Lesson to Learn";
      ["level"] = 16;
      ["name_es"] = "Una leccion que aprender";
      ["req"] = 16;
   };
   [27] = {
      ["name_ru"] = "Необходимый урок";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dendrite Starblaze in the village of Nighthaven, Moonglade.";
      ["next"] = 29;
      ["name_de"] = "Eine wertvolle Lektion";
      ["sort"] = "Druid";
      ["name_cn"] = "必修的?程";
      ["name_fr"] = "Une lecon a apprendre";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "A Lesson to Learn";
      ["level"] = 16;
      ["name_es"] = "Una leccion que aprender";
      ["req"] = 16;
   };
   [28] = {
      ["name_ru"] = "Испытание озера";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve du lac";
      ["next"] = 30;
      ["name_de"] = "Prufung des Sees";
      ["objective"] = "Find a Shrine Bauble in Lake Elune'ara, and take it to the Shrine of Remulos in northwestern Moonglade.  Once there, use the Shrine Bauble.$B$BYou must speak with Tajarri at the shrine afterwards in order to complete the trial.";
      ["name_cn"] = "湖中??";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Trial of the Lake";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 26;
      ["prequests"] = {
         [1] = 26;
      };
      ["level"] = 16;
      ["name_es"] = "La prueba del lago";
      ["req"] = 16;
   };
   [29] = {
      ["name_ru"] = "Испытание озера";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve du lac";
      ["next"] = 272;
      ["name_de"] = "Prufung des Sees";
      ["objective"] = "Find a Shrine Bauble in Lake Elune'ara, and take it to the Shrine of Remulos in northwestern Moonglade.  Once there, use the Shrine Bauble.$B$BYou must speak with Tajarri at the shrine afterwards in order to complete the trial.";
      ["name_cn"] = "湖中??";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Trial of the Lake";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 27;
      ["prequests"] = {
         [1] = 27;
      };
      ["level"] = 16;
      ["name_es"] = "La prueba del lago";
      ["req"] = 16;
   };
   [30] = {
      ["name_ru"] = "Испытание Морского Льва";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve du lion de mer";
      ["next"] = 31;
      ["name_de"] = "Prufung des Seelowen";
      ["objective"] = "Find the Half Pendant of Aquatic Agility and the Half Pendant of Aquatic Endurance.  Speak with the residents of Moonglade to learn clues as to where these items may be located.$B$BForm the Pendant of the Sea Lion from the two pendant halves.  You need to be in proximity of the Shrine of Remulos to do this.$B$BBring the joined pendant to Dendrite Starblaze in the village of Nighthaven, Moonglade.";
      ["name_cn"] = "海???";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Trial of the Sea Lion";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 28;
      ["prequests"] = {
         [1] = 28;
      };
      ["level"] = 16;
      ["name_es"] = "La prueba del leon marino";
      ["req"] = 16;
   };
   [31] = {
      ["name_ru"] = "Водный облик";
      ["objective"] = "Return to Thunder Bluff and show Turak Runetotem the Pendant of the Sea Lion.";
      ["name_cn"] = "水栖形?";
      ["sort"] = "Druid";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Forme aquatique";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Wassergestalt";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Aquatic Form";
      ["prev"] = 30;
      ["prequests"] = {
         [1] = 30;
      };
      ["reward"] = {
         [1] = 16608;
      };
      ["name_es"] = "Forma acuatica";
      ["req"] = 16;
   };
   [32] = {
      ["name_ru"] = "Возвышение силитидов";
      ["type"] = "Solo";
      ["name_fr"] = "L'ascension des silithides";
      ["repgain"] = {
         [76] = 350;
         [369] = 350;
         [81] = 350;
         [530] = 350;
      };
      ["name_de"] = "Aufstieg der Silithiden";
      ["name_cn"] = "??蝎的威?";
      ["name"] = "Rise of the Silithid";
      ["objective"] = "Take the report to Zilzibin Drumlore in Orgrimmar.";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 113;
      ["prequests"] = {
         [1] = 113;
      };
      ["level"] = 48;
      ["name_es"] = "La sublevacion de los silitidos";
      ["req"] = 39;
   };
   [33] = {
      ["name_ru"] = "Волки на границе";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 pieces of Tough Wolf Meat to Eagan Peltskinner outside Northshire Abbey.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Wolfe an der Grenze";
      ["reward"] = {
         [1] = 80;
         [2] = 6070;
      };
      ["name_cn"] = "林中的群狼";
      ["name_fr"] = "Les loups derriere la frontiere";
      ["faction"] = "Alliance";
      ["name"] = "Wolves Across the Border";
      ["sort"] = "Northshire Valley";
      ["prev"] = 5261;
      ["prequests"] = {
         [1] = 5261;
      };
      ["level"] = 2;
      ["name_es"] = "Los lobos cruzan la frontera";
      ["req"] = 1;
   };
   [34] = {
      ["name_ru"] = "Незваный гость";
      ["type"] = "Solo";
      ["objective"] = "Martie Jainrose of Lakeshire wants you to kill Bellygrub.  Bring her his tusk as proof.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Un indesirable";
      ["name_cn"] = "不速之客";
      ["reward"] = {
         [1] = 2562;
      };
      ["name_de"] = "Ein ungebetener Gast";
      ["faction"] = "Alliance";
      ["name"] = "An Unwelcome Guest";
      ["level"] = 24;
      ["name_es"] = "Una visita poco grata";
      ["req"] = 18;
   };
   [35] = {
      ["name_ru"] = "Новые заботы";
      ["type"] = "Solo";
      ["name_fr"] = "Inquietudes supplementaires";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Weitere Sorgen";
      ["name"] = "Further Concerns";
      ["name_cn"] = "?兵托?斯";
      ["objective"] = "Marshal Dughan wants you to speak with Guard Thomas.";
      ["next"] = 37;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 40;
      ["prequests"] = {
         [1] = 40;
      };
      ["level"] = 10;
      ["name_es"] = "Mas preocupaciones";
      ["req"] = 7;
   };
   [36] = {
      ["name_ru"] = "Похлебка Западного Края";
      ["type"] = "Solo";
      ["name_fr"] = "Le ragout de la marche de l'Ouest";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Westfalleintopf";
      ["name_cn"] = "?味?肉";
      ["objective"] = "Verna Furlbrow wants you to deliver her recipe for Westfall Stew to Salma Saldean.";
      ["next"] = 38;
      ["sort"] = "Westfall";
      ["name"] = "Westfall Stew";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 10;
      ["name_es"] = "Estofado de los Paramos de Poniente";
      ["req"] = 9;
   };
   [37] = {
      ["name_ru"] = "Пропавшие стражи";
      ["type"] = "Solo";
      ["name_fr"] = "Trouver les gardes disparus";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Suche nach den vermissten Wachen";
      ["name"] = "Find the Lost Guards";
      ["name_cn"] = "失踪的?兵";
      ["objective"] = "Guard Thomas wants you to travel north up the river and search for the two lost guards, Rolf and Malakai.";
      ["next"] = 45;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 35;
      ["prequests"] = {
         [1] = 35;
      };
      ["level"] = 10;
      ["name_es"] = "Encuentra a los guardias perdidos";
      ["req"] = 7;
   };
   [38] = {
      ["name_ru"] = "Похлебка Западного Края";
      ["objective"] = "Salma Saldean wants 3 Stringy Vulture Meat, 3 Goretusk Snouts, 3 Murloc Eyes, 3 Okra.";
      ["name_cn"] = "?味?肉";
      ["sort"] = "Westfall";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Le ragout de la marche de l'Ouest";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Westfalleintopf";
      ["reward"] = {
         [1] = 733;
         [2] = 728;
         [3] = 1479;
         [4] = 2225;
      };
      ["faction"] = "Alliance";
      ["name"] = "Westfall Stew";
      ["prev"] = 36;
      ["prequests"] = {
         [1] = 36;
      };
      ["series"] = 2;
      ["name_es"] = "Estofado de los Paramos de Poniente";
      ["req"] = 9;
   };
   [39] = {
      ["name_ru"] = "Донесение Томаса";
      ["type"] = "Solo";
      ["name_fr"] = "Remettre le rapport de Thomas";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Zustellung von Thomas' Bericht";
      ["name"] = "Deliver Thomas' Report";
      ["name_cn"] = "托?斯的?告";
      ["objective"] = "Report to Marshal Dughan in Goldshire.";
      ["next"] = 59;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 71;
      ["prequests"] = {
         [1] = 71;
      };
      ["level"] = 10;
      ["name_es"] = "Entrega el informe de Thomas";
      ["req"] = 7;
   };
   [40] = {
      ["name_ru"] = "Водяная нечисть";
      ["type"] = "Solo";
      ["objective"] = "Remy Two Times\" wants you to speak with Marshal Dughan in Goldshire.\"";
      ["next"] = 35;
      ["name_fr"] = "Peril en la riviere";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "?人的威?";
      ["repgain"] = {
         [72] = 10;
      };
      ["name_de"] = "Gefahr aus dem Wasser";
      ["faction"] = "Alliance";
      ["name"] = "A Fishy Peril";
      ["level"] = 10;
      ["name_es"] = "Un peligro con olor a pescado";
      ["req"] = 7;
   };
   [45] = {
      ["name_ru"] = "Судьба Рольфа";
      ["type"] = "Solo";
      ["name_fr"] = "La destinee de Rolf";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Rolfs Schicksal";
      ["name"] = "Discover Rolf's Fate";
      ["name_cn"] = "??夫的下落";
      ["objective"] = "Search the murloc village for Rolf, or signs of his death.";
      ["next"] = 71;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 37;
      ["prequests"] = {
         [1] = 37;
      };
      ["level"] = 10;
      ["name_es"] = "Descubre el destino de Rolf";
      ["req"] = 7;
   };
   [46] = {
      ["name_ru"] = "Награда за мурлоков";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Torn Murloc Fins to Guard Thomas at the east Elwynn bridge.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Des primes pour les murlocs";
      ["name_cn"] = "???人";
      ["reward"] = {
         [1] = 4840;
         [2] = 1158;
         [3] = 1008;
      };
      ["name_de"] = "Kopfgeld auf die Murlocs";
      ["faction"] = "Alliance";
      ["name"] = "Bounty on Murlocs";
      ["level"] = 10;
      ["name_es"] = "Recompensas por los murlocs";
      ["req"] = 7;
   };
   [47] = {
      ["name_ru"] = "Золотая пыль";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Gold Dust to Remy Two Times\" in Goldshire.  Gold Dust is gathered from Kobolds in Elwynn Forest.\"";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "L'echange de poussiere d'or";
      ["name_cn"] = "金砂交易";
      ["reward"] = {
         [1] = 1191;
      };
      ["name_de"] = "Tauschhandel mit Goldstaub";
      ["faction"] = "Alliance";
      ["name"] = "Gold Dust Exchange";
      ["level"] = 7;
      ["name_es"] = "Intercambio de polvo de oro";
      ["req"] = 4;
   };
   [48] = {
      ["name_ru"] = "Янтарное сладкое";
      ["type"] = "Solo";
      ["objective"] = "Bring Holy Spring Water to Grimbooze Thunderbrew.";
      ["next"] = 49;
      ["name_fr"] = "Doux whisky";
      ["sort"] = "Westfall";
      ["name_cn"] = "琥珀酒";
      ["series"] = 1;
      ["name_de"] = "Goldbrauner Samt";
      ["faction"] = "Alliance";
      ["name"] = "Sweet Amber";
      ["level"] = 44;
      ["name_es"] = "Dulce ambar";
      ["req"] = 40;
   };
   [49] = {
      ["name_ru"] = "Янтарное сладкое";
      ["type"] = "Solo";
      ["name_fr"] = "Doux whisky";
      ["next"] = 50;
      ["name_de"] = "Goldbrauner Samt";
      ["name"] = "Sweet Amber";
      ["name_cn"] = "琥珀酒";
      ["objective"] = "Grimbooze Thunderbrew wants a Sack of Barley, a Sack of Rye and a Sack of Corn.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Westfall";
      ["prev"] = 48;
      ["prequests"] = {
         [1] = 48;
      };
      ["level"] = 44;
      ["name_es"] = "Dulce ambar";
      ["req"] = 40;
   };
   [50] = {
      ["name_ru"] = "Янтарное сладкое";
      ["type"] = "Solo";
      ["name_fr"] = "Doux whisky";
      ["next"] = 51;
      ["name_de"] = "Goldbrauner Samt";
      ["name"] = "Sweet Amber";
      ["name_cn"] = "琥珀酒";
      ["objective"] = "Grimbooze Thunderbrew wants Truesilver.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Westfall";
      ["prev"] = 49;
      ["prequests"] = {
         [1] = 49;
      };
      ["level"] = 44;
      ["name_es"] = "Dulce ambar";
      ["req"] = 40;
   };
   [51] = {
      ["name_ru"] = "Янтарное сладкое";
      ["type"] = "Solo";
      ["name_fr"] = "Doux whisky";
      ["next"] = 53;
      ["name_de"] = "Goldbrauner Samt";
      ["name"] = "Sweet Amber";
      ["name_cn"] = "琥珀酒";
      ["objective"] = "Bring a Sycamore Branch to Grimbooze Thunderbrew.";
      ["series"] = 4;
      ["faction"] = "Alliance";
      ["sort"] = "Westfall";
      ["prev"] = 50;
      ["prequests"] = {
         [1] = 50;
      };
      ["level"] = 44;
      ["name_es"] = "Dulce ambar";
      ["req"] = 40;
   };
   [52] = {
      ["name_ru"] = "Защита границы";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Prowlers and 5 Young Forest Bears, and then return to Guard Thomas at the east Elwynn bridge.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Proteger la frontiere";
      ["name_cn"] = "保??境";
      ["reward"] = {
         [1] = 858;
      };
      ["name_de"] = "Grenzschutz";
      ["faction"] = "Alliance";
      ["name"] = "Protect the Frontier";
      ["level"] = 10;
      ["name_es"] = "Proteger la frontera";
      ["req"] = 7;
   };
   [53] = {
      ["name_ru"] = "Янтарное сладкое";
      ["type"] = "Solo";
      ["objective"] = "Bring Grimbooze Thunderbrew a bundle of Charred Oak.";
      ["name_de"] = "Goldbrauner Samt";
      ["name_fr"] = "Doux whisky";
      ["reward"] = {
         [1] = 744;
      };
      ["name_cn"] = "琥珀酒";
      ["series"] = 5;
      ["faction"] = "Alliance";
      ["name"] = "Sweet Amber";
      ["sort"] = "Westfall";
      ["prev"] = 51;
      ["prequests"] = {
         [1] = 51;
      };
      ["level"] = 44;
      ["name_es"] = "Dulce ambar";
      ["req"] = 40;
   };
   [54] = {
      ["name_ru"] = "Донесение в Златоземье";
      ["type"] = "Solo";
      ["objective"] = "Take Marshal McBride's Documents to Marshal Dughan in Goldshire.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Meldung in Goldhain";
      ["reward"] = {
         [1] = 6078;
      };
      ["name_cn"] = "去?金??到";
      ["name_fr"] = "Rapport pour Comte-de-l’or";
      ["faction"] = "Alliance";
      ["name"] = "Report to Goldshire";
      ["sort"] = "Northshire Valley";
      ["prev"] = 21;
      ["prequests"] = {
         [1] = 21;
      };
      ["level"] = 5;
      ["name_es"] = "Informa en Villadorada";
      ["req"] = 1;
   };
   [55] = {
      ["name_ru"] = "Морбент Скверн";
      ["type"] = "Group";
      ["objective"] = "Use Morbent's Bane on Morbent Fel, kill Morbent Fel, then return Morbent's Bane to Sven at his camp.";
      ["repgain"] = {
         [54] = 150;
         [72] = 500;
      };
      ["name_de"] = "Morbent Teufel";
      ["reward"] = {
         [1] = 2954;
         [2] = 7344;
         [3] = 2953;
         [4] = 1282;
      };
      ["name_cn"] = "摩本特・??";
      ["name_fr"] = "Morbent Lagangrene";
      ["faction"] = "Alliance";
      ["name"] = "Morbent Fel";
      ["sort"] = "Duskwood";
      ["prev"] = 325;
      ["prequests"] = {
         [1] = 325;
      };
      ["level"] = 32;
      ["name_es"] = "Morbent Vil";
      ["req"] = 20;
   };
   [56] = {
      ["name_ru"] = "Ночной Дозор";
      ["type"] = "Solo";
      ["name_fr"] = "Les Veilleurs";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Die Nachtwache";
      ["name_cn"] = "守夜人";
      ["objective"] = "Commander Althea Ebonlocke of Darkshire wants you to kill 8 Skeletal Warriors and 6 Skeletal Mages.";
      ["next"] = 57;
      ["sort"] = "Duskwood";
      ["name"] = "The Night Watch";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 24;
      ["name_es"] = "La Guardia Nocturna";
      ["req"] = 18;
   };
   [57] = {
      ["name_ru"] = "Ночной Дозор";
      ["objective"] = "Commander Althea Ebonlocke of Darkshire wants you to kill 15 Skeletal Fiends and 15 Skeletal Horrors.";
      ["name_cn"] = "守夜人";
      ["sort"] = "Duskwood";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "Les Veilleurs";
      ["next"] = 58;
      ["name_de"] = "Die Nachtwache";
      ["repgain"] = {
         [72] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Night Watch";
      ["prev"] = 56;
      ["prequests"] = {
         [1] = 56;
      };
      ["series"] = 2;
      ["name_es"] = "La Guardia Nocturna";
      ["req"] = 18;
   };
   [58] = {
      ["name_ru"] = "Ночной Дозор";
      ["objective"] = "Commander Althea Ebonlocke of Darkshire wants you to kill 20 Plague Spreaders in the eastern Raven Hill mausoleum.";
      ["name_cn"] = "守夜人";
      ["sort"] = "Duskwood";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Les Veilleurs";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Nachtwache";
      ["reward"] = {
         [1] = 3604;
         [2] = 3605;
         [3] = 1729;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Night Watch";
      ["prev"] = 57;
      ["prequests"] = {
         [1] = 57;
      };
      ["series"] = 3;
      ["name_es"] = "La Guardia Nocturna";
      ["req"] = 18;
   };
   [59] = {
      ["name_ru"] = "Броня из кожи и ткани";
      ["type"] = "Solo";
      ["objective"] = "Give Sara Timberlain the Stormwind Armor Marker.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Rustung aus Tuch und aus Leder";
      ["reward"] = {
         [1] = 1171;
         [2] = 2237;
      };
      ["name_cn"] = "布甲和皮甲";
      ["name_fr"] = "Les armures de cuir et d'etoffe";
      ["faction"] = "Alliance";
      ["name"] = "Cloth and Leather Armor";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 39;
      ["prequests"] = {
         [1] = 39;
      };
      ["level"] = 10;
      ["name_es"] = "Armadura de pano y cuero";
      ["req"] = 7;
   };
   [60] = {
      ["name_ru"] = "Свечи кобольдов";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Large Candles to William Pestle in Goldshire.";
      ["next"] = 61;
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Les bougies de kobolds";
      ["name_cn"] = "狗?人的??";
      ["repgain"] = {
         [72] = 150;
      };
      ["reward"] = {
         [1] = 1434;
      };
      ["name_de"] = "Koboldkerzen";
      ["faction"] = "Alliance";
      ["name"] = "Kobold Candles";
      ["level"] = 7;
      ["name_es"] = "Las velas de los kobolds";
      ["req"] = 3;
   };
   [61] = {
      ["name_ru"] = "Посылка в Штормград";
      ["type"] = "Solo";
      ["objective"] = "Bring William's Shipment to Morgan Pestle in the Stormwind Trade District.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Lieferung nach Sturmwind";
      ["reward"] = {
         [1] = 1178;
         [2] = 1177;
         [3] = 2454;
      };
      ["name_cn"] = "送往暴?城的?物";
      ["name_fr"] = "Une cargaison pour Hurlevent";
      ["faction"] = "Alliance";
      ["name"] = "Shipment to Stormwind";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 60;
      ["prequests"] = {
         [1] = 60;
      };
      ["level"] = 7;
      ["name_es"] = "Un envio para Ventormenta";
      ["req"] = 3;
   };
   [62] = {
      ["name_ru"] = "Рудник Подземных глубин";
      ["type"] = "Solo";
      ["objective"] = "Explore the Fargodeep Mine, then return to Marshal Dughan in Goldshire.";
      ["next"] = 76;
      ["name_fr"] = "La mine de Fondugouffre";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "法戈第?洞";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Die Tiefenschachtmine";
      ["faction"] = "Alliance";
      ["name"] = "The Fargodeep Mine";
      ["level"] = 7;
      ["name_es"] = "La Mina Abisal";
      ["req"] = 4;
   };
   [63] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 100;
      ["name_de"] = "Ruf des Wassers";
      ["objective"] = "Defeat the Corrupt Manifestation of Water and place the Corrupted Manifestation's Bracers along with the Remaining Drops of Purest Water on the Brazier of Everfount in Silverpine Forest.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 220;
      ["prequests"] = {
         [1] = 220;
      };
      ["level"] = 23;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [64] = {
      ["name_ru"] = "Забытая вещь";
      ["type"] = "Solo";
      ["objective"] = "Farmer Furlbrow wants you to retrieve his pocket watch from the wardrobe in his farmhouse at the pumpkin farm to the West.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Le cadeau oublie";
      ["name_cn"] = "?失的?表";
      ["reward"] = {
         [1] = 4541;
         [2] = 1179;
      };
      ["name_de"] = "Das vergessene Erbstuck";
      ["faction"] = "Alliance";
      ["name"] = "The Forgotten Heirloom";
      ["level"] = 12;
      ["name_es"] = "La reliquia olvidada";
      ["req"] = 9;
   };
   [65] = {
      ["name_ru"] = "Братство Справедливости";
      ["type"] = "Solo";
      ["name_fr"] = "La Confrerie defias";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Bruderschaft der Defias";
      ["name_cn"] = "迪菲?兄弟会";
      ["objective"] = "Gryan Stoutmantle wants you to talk to Wiley in Lakeshire.";
      ["next"] = 132;
      ["sort"] = "Westfall";
      ["name"] = "The Defias Brotherhood";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 18;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [66] = {
      ["name_ru"] = "Легенда о Сталване";
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Die Legende von Stalvan";
      ["name_cn"] = "斯塔文的??";
      ["objective"] = "Seek out the Clerk Daltry in the Darkshire Town Hall.";
      ["next"] = 67;
      ["sort"] = "Duskwood";
      ["name"] = "The Legend of Stalvan";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 28;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [67] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Travel to the Moonbrook Schoolhouse and bring back any updated information about Stalvan to Clerk Daltry.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 68;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 66;
      ["prequests"] = {
         [1] = 66;
      };
      ["series"] = 2;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [68] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Take the Dusty Unsent Letter to Clerk Daltry.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 69;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 67;
      ["prequests"] = {
         [1] = 67;
      };
      ["series"] = 3;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [69] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Go to The Lion's Pride Inn to see if anyone there has heard of the name Stalvan.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 70;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 68;
      ["prequests"] = {
         [1] = 68;
      };
      ["series"] = 4;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [70] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Retrieve Stalvan's Undelivered Letter from the chest and deliver it to the Canal District in Stormwind.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 72;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 69;
      ["prequests"] = {
         [1] = 69;
      };
      ["series"] = 5;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [71] = {
      ["name_ru"] = "Доклад для Томаса";
      ["type"] = "Solo";
      ["name_fr"] = "Faire son rapport au garde Thomas";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Meldung an Thomas";
      ["name"] = "Report to Thomas";
      ["name_cn"] = "回?托?斯";
      ["objective"] = "Deliver Rolf and Malakai's Medallions to Guard Thomas at the eastern Elwynn bridge.";
      ["next"] = 39;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 45;
      ["prequests"] = {
         [1] = 45;
      };
      ["level"] = 10;
      ["name_es"] = "Informa a Thomas";
      ["req"] = 7;
   };
   [72] = {
      ["name_ru"] = "Легенда о Сталване";
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 74;
      ["name_de"] = "Die Legende von Stalvan";
      ["name"] = "The Legend of Stalvan";
      ["name_cn"] = "斯塔文的??";
      ["objective"] = "Search through the packed up possessions for a clue.";
      ["series"] = 6;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 70;
      ["prequests"] = {
         [1] = 70;
      };
      ["level"] = 28;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [74] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "The Torn Journal page you discovered provides your next clue.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 75;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 72;
      ["prequests"] = {
         [1] = 72;
      };
      ["series"] = 7;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [75] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Marshal Haggard wants you to check the chest upstairs for the Faded Journal Page.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 78;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 74;
      ["prequests"] = {
         [1] = 74;
      };
      ["series"] = 8;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [76] = {
      ["name_ru"] = "Яшмовая шахта";
      ["type"] = "Solo";
      ["name_fr"] = "La mine Veine-de-jaspe";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Jaspismine";
      ["name_cn"] = "玉石?洞";
      ["name"] = "The Jasperlode Mine";
      ["objective"] = "Explore the Jasperlode Mine, then report back to Marshal Dughan in Goldshire.";
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 62;
      ["prequests"] = {
         [1] = 62;
      };
      ["level"] = 10;
      ["name_es"] = "La Cantera de Jaspe";
      ["req"] = 4;
   };
   [77] = {
      ["name_ru"] = "Грязное дело";
      ["type"] = "Solo";
      ["name_fr"] = "Une situation delicate";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Eine schleimige Angelegenheit";
      ["name_cn"] = "收集蜜糖";
      ["name"] = "A Sticky Situation";
      ["objective"] = "Recover 10 bottles of Hinterlands Honey Ripple from the crates located around the abandoned Horde base in Skulk Rock.";
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 650;
      ["prequests"] = {
         [1] = 650;
      };
      ["level"] = 48;
      ["name_es"] = "Una situacion peliaguda";
      ["req"] = 42;
   };
   [78] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Take the Faded Journal Page to Tavernkeep Smitts.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 79;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 75;
      ["prequests"] = {
         [1] = 75;
      };
      ["series"] = 9;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [79] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Take the muddy page to Commander Ebonlocke.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 80;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["reward"] = {
         [1] = 939;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 78;
      ["prequests"] = {
         [1] = 78;
      };
      ["series"] = 10;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [80] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Show Clerk Daltry the Bloodstained Journal Page.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 97;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 79;
      ["prequests"] = {
         [1] = 79;
      };
      ["series"] = 11;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [81] = {
      ["name_ru"] = "Груз медовухи";
      ["type"] = "Solo";
      ["name_fr"] = "La livraison de Houle";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Weinlieferung";
      ["name_cn"] = "送回蜜酒";
      ["name"] = "Ripple Delivery";
      ["objective"] = "Deliver the barrel to Dran Droffers in Orgrimmar.";
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 77;
      ["prequests"] = {
         [1] = 77;
      };
      ["level"] = 48;
      ["name_es"] = "Entrega el calimocho";
      ["req"] = 42;
   };
   [82] = {
      ["name_ru"] = "Исследование Ядовитого улья";
      ["type"] = "Solo";
      ["name_fr"] = "Enquete au Repaire nuisible";
      ["repgain"] = {
         [369] = 150;
      };
      ["name_de"] = "Erkundung des Giftigen Unterschlupfes";
      ["name_cn"] = "腐化之?";
      ["name"] = "Noxious Lair Investigation";
      ["objective"] = "Bring five Centipaar insect parts from the Noxious Lair to Alchemist Pestlezugg in Gadgetzan.";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 992;
      ["prequests"] = {
         [1] = 992;
      };
      ["level"] = 47;
      ["name_es"] = "Investigacion en la Guarida Ponzonosa";
      ["req"] = 39;
   };
   [83] = {
      ["name_ru"] = "Красный лен";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Red Linen Bandanas to Sara Timberlain at the Eastvale Logging Camp.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Articles rouges en lin";
      ["name_cn"] = "?色?麻布";
      ["reward"] = {
         [1] = 2575;
         [2] = 983;
      };
      ["name_de"] = "Feine Leinenwaren";
      ["faction"] = "Alliance";
      ["name"] = "Red Linen Goods";
      ["level"] = 9;
      ["name_es"] = "Panuelos de lino rojo";
      ["req"] = 4;
   };
   [84] = {
      ["name_ru"] = "Назад к Билли";
      ["type"] = "Solo";
      ["name_fr"] = "Revenir voir Billy";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Zuruck zu Billy";
      ["name"] = "Back to Billy";
      ["name_cn"] = "比利的??";
      ["objective"] = "Bring the Pork Belly Pie to Billy Maclure at the Maclure Vineyards.";
      ["next"] = 87;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 86;
      ["prequests"] = {
         [1] = 86;
      };
      ["level"] = 6;
      ["name_es"] = "Vuelve con Billy";
      ["req"] = 5;
   };
   [85] = {
      ["name_ru"] = "Потерянное ожерелье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Billy Maclure.";
      ["next"] = 86;
      ["name_fr"] = "Le collier perdu";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "?失的??";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Die verlorene Halskette";
      ["faction"] = "Alliance";
      ["name"] = "Lost Necklace";
      ["level"] = 6;
      ["name_es"] = "El collar perdido";
      ["req"] = 5;
   };
   [86] = {
      ["name_ru"] = "Пирог для Билли";
      ["type"] = "Solo";
      ["name_fr"] = "Une tourte pour Billy";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Pastete fur Billy";
      ["name"] = "Pie for Billy";
      ["name_cn"] = "比利的??";
      ["objective"] = "Bring 4 Chunks of Boar Meat to Auntie Bernice Stonefield at the Stonefield's Farm.";
      ["next"] = 84;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 85;
      ["prequests"] = {
         [1] = 85;
      };
      ["level"] = 6;
      ["name_es"] = "Un pastel para Billy";
      ["req"] = 5;
   };
   [87] = {
      ["name_ru"] = "Фикс";
      ["type"] = "Solo";
      ["objective"] = "Bring Bernice's Necklace to Auntie\" Bernice Stonefield at the Stonefield Farm.\"";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Goldzahn";
      ["reward"] = {
         [1] = 1359;
      };
      ["name_cn"] = "金牙";
      ["name_fr"] = "Dent-d'or";
      ["faction"] = "Alliance";
      ["name"] = "Goldtooth";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 84;
      ["prequests"] = {
         [1] = 84;
      };
      ["level"] = 8;
      ["name_es"] = "Dientes de Oro";
      ["req"] = 5;
   };
   [88] = {
      ["name_ru"] = "Принцесса должна умереть!";
      ["type"] = "Solo";
      ["objective"] = "Kill Princess, grab her collar, then bring it back to Ma Stonefield at the Stonefield Farm.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Princesse doit mourir?!";
      ["name_cn"] = "公主必?死！";
      ["reward"] = {
         [1] = 1173;
         [2] = 1182;
         [3] = 11191;
      };
      ["name_de"] = "Prinzessin muss sterben!";
      ["faction"] = "Alliance";
      ["name"] = "Princess Must Die!";
      ["level"] = 9;
      ["name_es"] = "!Princesa debe morir!";
      ["req"] = 6;
   };
   [89] = {
      ["name_ru"] = "Мост Безмолвия";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Iron Pikes and 5 Iron Rivets to Foreman Oslow in Lakeshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Immerruhbrucke";
      ["reward"] = {
         [1] = 1310;
         [2] = 1303;
         [3] = 1304;
      };
      ["name_cn"] = "止水湖上的?";
      ["name_fr"] = "Le pont sur le lac";
      ["faction"] = "Alliance";
      ["name"] = "The Everstill Bridge";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 125;
      ["prequests"] = {
         [1] = 125;
      };
      ["level"] = 20;
      ["name_es"] = "El puente sempiterno";
      ["req"] = 15;
   };
   [90] = {
      ["name_ru"] = "Пряные котлеты из волчатины";
      ["type"] = "Solo";
      ["objective"] = "Gather 10 Lean Wolf Flanks and Stormwind Seasoning Herbs and return to Chef Grual in Darkshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Duskwood";
      ["name_fr"] = "Kebab de loup assaisonne";
      ["name_cn"] = "干?狼肉串";
      ["reward"] = {
         [1] = 1017;
         [2] = 2701;
      };
      ["name_de"] = "Gewurzte Wolfkebabs";
      ["faction"] = "Alliance";
      ["name"] = "Seasoned Wolf Kabobs";
      ["level"] = 25;
      ["name_es"] = "Kebab de lobo sazonado";
      ["req"] = 18;
   };
   [91] = {
      ["name_ru"] = "Закон Соломона";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Shadowhide Pendants to Bailiff Conacher in the Lakeshire Town Hall.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "La loi de Salomon";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "所??的律法";
      ["name_de"] = "Das Gesetz des Solomon";
      ["faction"] = "Alliance";
      ["name"] = "Solomon's Law";
      ["level"] = 23;
      ["name_es"] = "Ley de Solomon";
      ["req"] = 17;
   };
   [92] = {
      ["name_ru"] = "Гуляш по-красногорски";
      ["type"] = "Solo";
      ["objective"] = "Chef Breanna of Lakeshire wants five pieces of Tough Condor Meat, five Great Goretusk Snouts and five helpings of Crisp Spider Meat.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Goulash des Carmines";
      ["name_cn"] = "赤脊山?肉";
      ["reward"] = {
         [1] = 1082;
         [2] = 2699;
      };
      ["name_de"] = "Rotkammgulasch";
      ["faction"] = "Alliance";
      ["name"] = "Redridge Goulash";
      ["level"] = 18;
      ["name_es"] = "Estofado Crestagrana";
      ["req"] = 15;
   };
   [93] = {
      ["name_ru"] = "Темные пирожки с крабами";
      ["objective"] = " but the cakes have a nice";
      ["name_cn"] = "黑蟹蛋?";
      ["sort"] = "Duskwood";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Gateaux au crabe brun";
      ["next"] = 240;
      ["name_de"] = "Schwarzliche Krebskuchlein";
      ["repgain"] = {
         [72] = 75;
      };
      ["reward"] = {
         [1] = 3683;
      };
      ["name"] = "Dusky Crab Cakes";
      ["prev"] = 5;
      ["prequests"] = {
         [1] = 5;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Los pasteles de cangrejo oscuro";
      ["req"] = 17;
   };
   [94] = {
      ["name_ru"] = "Недремлющее Око";
      ["type"] = "Solo";
      ["objective"] = "Take the Glyph of Azora to the Lion Statue near the Tower of Ilgalar in Redridge.";
      ["next"] = 248;
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "法?的眼?";
      ["name_fr"] = "L'?il attentif";
      ["name_de"] = "Ein wachsames Auge";
      ["faction"] = "Alliance";
      ["name"] = "A Watchful Eye";
      ["level"] = 21;
      ["name_es"] = "Un ojo vigilante";
      ["req"] = 20;
   };
   [95] = {
      ["name_ru"] = "Месть Свена";
      ["type"] = "Solo";
      ["objective"] = "Go to Sven's Farm and find what was buried behind the old stump.";
      ["next"] = 230;
      ["name_fr"] = "La vengeance de Sven";
      ["sort"] = "Duskwood";
      ["name_cn"] = "斯温的?仇";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Svens Rache";
      ["faction"] = "Alliance";
      ["name"] = "Sven's Revenge";
      ["level"] = 25;
      ["name_es"] = "La venganza de Sven";
      ["req"] = 20;
   };
   [96] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["name_de"] = "Ruf des Wassers";
      ["objective"] = "Bring the Shard of Water to Islen Waterseer in the Barrens.";
      ["reward"] = {
         [1] = 5177;
      };
      ["name_cn"] = "水之召?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Call of Water";
      ["sort"] = "Shaman";
      ["prev"] = 100;
      ["prequests"] = {
         [1] = 100;
      };
      ["level"] = 23;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [97] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Report the news to Commander Ebonlocke.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["next"] = 98;
      ["name_de"] = "Die Legende von Stalvan";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 80;
      ["prequests"] = {
         [1] = 80;
      };
      ["series"] = 12;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [98] = {
      ["name_ru"] = "Легенда о Сталване";
      ["objective"] = "Kill Stalvan Mistmantle and show Madame Eva his family ring.";
      ["name_cn"] = "斯塔文的??";
      ["sort"] = "Duskwood";
      ["level"] = 35;
      ["type"] = "Solo";
      ["name_fr"] = "La legende de Stalvan";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Die Legende von Stalvan";
      ["reward"] = {
         [1] = 2044;
         [2] = 2043;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Legend of Stalvan";
      ["prev"] = 97;
      ["prequests"] = {
         [1] = 97;
      };
      ["series"] = 13;
      ["name_es"] = "La leyenda de Stalvan";
      ["req"] = 22;
   };
   [99] = {
      ["name_ru"] = "Безрассудство Аругала";
      ["objective"] = "Bring 6 Pyrewood Shackles to Dalar Dawnweaver at the Sepulcher.";
      ["name_cn"] = "阿?高的愚行";
      ["sort"] = "Silverpine Forest";
      ["level"] = 15;
      ["type"] = "Group";
      ["name_fr"] = "La folie d'Arugal";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Arugals Torheit";
      ["reward"] = {
         [1] = 3586;
         [2] = 3570;
         [3] = 5242;
      };
      ["faction"] = "Horde";
      ["name"] = "Arugal's Folly";
      ["prev"] = 424;
      ["prequests"] = {
         [1] = 424;
      };
      ["series"] = 4;
      ["name_es"] = "La locura de Arugal";
      ["req"] = 9;
   };
   [100] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 96;
      ["name_de"] = "Ruf des Wassers";
      ["objective"] = "Speak to the Minor Manifestation of Water in Silverpine Forest.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 63;
      ["prequests"] = {
         [1] = 63;
      };
      ["level"] = 23;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [101] = {
      ["name_ru"] = "Тотем кары";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Ghoul Fangs, 10 Skeleton Fingers and 5 Vials of Spider Venom to Madame Eva in Darkshire.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Duskwood";
      ["name_fr"] = "Le Totem d'affliction";
      ["name_cn"] = "????";
      ["reward"] = {
         [1] = 1131;
      };
      ["name_de"] = "Das Totem des Gegenschlages";
      ["faction"] = "Alliance";
      ["name"] = "The Totem of Infliction";
      ["level"] = 25;
      ["name_es"] = "El Totem de castigo";
      ["req"] = 18;
   };
   [102] = {
      ["name_ru"] = "Патрулирование Западного Края";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Gnoll Paws to Captain Danuvin on Sentinel Hill.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Patrouilles dans la marche de l'Ouest";
      ["name_cn"] = "西部荒野的豺狼人";
      ["reward"] = {
         [1] = 1154;
         [2] = 710;
      };
      ["name_de"] = "Auf Patrouille durch Westfall";
      ["faction"] = "Alliance";
      ["name"] = "Patrolling Westfall";
      ["level"] = 14;
      ["name_es"] = "En patrulla por los Paramos de Poniente";
      ["req"] = 8;
   };
   [103] = {
      ["name_ru"] = "Хранитель пламени";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Flasks of Oil to Captain Grayson at the Westfall Lighthouse.";
      ["name_fr"] = "Le gardien de la flamme";
      ["sort"] = "Westfall";
      ["name_cn"] = "?明的灯塔";
      ["reward"] = {
         [1] = 2455;
         [2] = 955;
         [3] = 118;
         [4] = 1180;
      };
      ["name_de"] = "Bewahrer der Flamme";
      ["faction"] = "Horde";
      ["name"] = "Keeper of the Flame";
      ["level"] = 16;
      ["name_es"] = "Guardian de la Llama";
      ["req"] = 10;
   };
   [104] = {
      ["name_ru"] = "Опасность на побережье";
      ["type"] = "Solo";
      ["objective"] = "Bring a scale of Old Murk-Eye to Captain Grayson at the Westfall Lighthouse.";
      ["name_fr"] = "Menace sur la cote";
      ["sort"] = "Westfall";
      ["name_cn"] = "海岸上的威?";
      ["reward"] = {
         [1] = 1172;
         [2] = 1557;
         [3] = 5240;
      };
      ["name_de"] = "Bedrohung an der Kuste";
      ["faction"] = "Horde";
      ["name"] = "The Coastal Menace";
      ["level"] = 20;
      ["name_es"] = "La amenaza costera";
      ["req"] = 15;
   };
   [105] = {
      ["name_ru"] = "Увы тебе, Андорал";
      ["type"] = "Group";
      ["objective"] = "Bring Araj's Phylactery Shard to High Executor Derrington at the Bulwark, Western Plaguelands.";
      ["repgain"] = {
         [67] = 350;
         [529] = 350;
      };
      ["name_de"] = "Weh dir, Andorhal";
      ["reward"] = {
         [1] = 17759;
      };
      ["name_cn"] = "?，安多哈?！";
      ["name_fr"] = "Helas, Andorhal";
      ["faction"] = "Horde";
      ["name"] = "Alas, Andorhal";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5098;
      ["prequests"] = {
         [1] = 5098;
      };
      ["level"] = 60;
      ["name_es"] = "Ah, Andorhal";
      ["req"] = 50;
   };
   [106] = {
      ["name_ru"] = "Юные влюбленные";
      ["type"] = "Solo";
      ["objective"] = "Give Maybell's Love Letter to Tommy Joe Stonefield.";
      ["next"] = 111;
      ["name_fr"] = "Jeunes amoureux";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "年?的恋人";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Junge Liebende";
      ["faction"] = "Alliance";
      ["name"] = "Young Lovers";
      ["level"] = 6;
      ["name_es"] = "Jovenes enamorados";
      ["req"] = 5;
   };
   [107] = {
      ["name_ru"] = "Записка для Вильяма";
      ["type"] = "Solo";
      ["name_fr"] = "Note pour William";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Nachricht an William";
      ["name"] = "Note to William";
      ["name_cn"] = "?威廉・匹斯特的信";
      ["objective"] = "Take Gramma Stonefield's Note to William Pestle.";
      ["next"] = 112;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 111;
      ["prequests"] = {
         [1] = 111;
      };
      ["level"] = 6;
      ["name_es"] = "Una nota para William";
      ["req"] = 5;
   };
   [109] = {
      ["name_ru"] = "Доклад Гриану Камнегриву";
      ["type"] = "Solo";
      ["objective"] = "Talk to Gryan Stoutmantle.  He usually can be found in the stone tower on Sentinel Hill, just off the road, in the middle of Westfall.";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_fr"] = "Aller voir Gryan Roidemantel";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "向格里安・斯托曼?到";
      ["name_de"] = "Meldung bei Gryan Starkmantel";
      ["faction"] = "Alliance";
      ["name"] = "Report to Gryan Stoutmantle";
      ["level"] = 10;
      ["name_es"] = "Habla con Gryan Mantorrecio";
      ["req"] = 9;
   };
   [110] = {
      ["name_ru"] = "Анализ частей насекомых";
      ["objective"] = "Check in Gadgetzan for Alchemist Pestlezugg and his analysis of the insect parts.";
      ["name_cn"] = "昆虫研究";
      ["sort"] = "Tanaris";
      ["level"] = 48;
      ["type"] = "Solo";
      ["name_fr"] = "Analyse des morceaux d'insectes";
      ["next"] = 113;
      ["name_de"] = "Insektenteil-Analyse";
      ["repgain"] = {
         [369] = 10;
      };
      ["faction"] = "Horde";
      ["name"] = "Insect Part Analysis";
      ["prev"] = 10;
      ["prequests"] = {
         [1] = 10;
      };
      ["series"] = 1;
      ["name_es"] = "Analisis de trozos de insecto";
      ["req"] = 39;
   };
   [111] = {
      ["name_ru"] = "Разговор с бабулей";
      ["type"] = "Solo";
      ["name_fr"] = "Discuter avec Mamie";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Gesprach mit Oma";
      ["name"] = "Speak with Gramma";
      ["name_cn"] = "托米的祖母";
      ["objective"] = "Speak with Gramma Stonefield.";
      ["next"] = 107;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 106;
      ["prequests"] = {
         [1] = 106;
      };
      ["level"] = 6;
      ["name_es"] = "Habla con la abuelita";
      ["req"] = 5;
   };
   [112] = {
      ["name_ru"] = "Хрустальный фукус";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche du varech";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Die Suche nach dem Tang";
      ["followup"] = 114;
      ["name_cn"] = "收集海藻";
      ["objective"] = "Bring 4 Crystal Kelp Fronds to William Pestle in Goldshire.";
      ["faction"] = "Alliance";
      ["name"] = "Collecting Kelp";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 107;
      ["prequests"] = {
         [1] = 107;
      };
      ["level"] = 7;
      ["name_es"] = "La recoleccion de algas";
      ["req"] = 5;
   };
   [113] = {
      ["name_ru"] = "Анализ частей насекомых";
      ["type"] = "Solo";
      ["objective"] = "Deliver the report to Senior Surveyor Fizzledowser in Gadgetzan.  Be sure he gives you a copy of the report, as Alchemist Pestlezugg has requested.";
      ["repgain"] = {
         [369] = 10;
      };
      ["name_de"] = "Insektenteil-Analyse";
      ["name"] = "Insect Part Analysis";
      ["name_cn"] = "昆虫研究";
      ["name_fr"] = "Analyse des morceaux d'insectes";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 110;
      ["prequests"] = {
         [1] = 110;
      };
      ["level"] = 48;
      ["name_es"] = "Analisis de trozos de insecto";
      ["req"] = 39;
   };
   [114] = {
      ["name_ru"] = "Бегство";
      ["type"] = "Solo";
      ["objective"] = "Take the Invisibility Liquor to Maybell Maclure.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Die Flucht";
      ["reward"] = {
         [1] = 118;
      };
      ["name_cn"] = "梅??的?形水";
      ["name_fr"] = "La fuite";
      ["faction"] = "Alliance";
      ["name"] = "The Escape";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 112;
      ["prequests"] = {
         [1] = 112;
      };
      ["level"] = 7;
      ["name_es"] = "La fuga";
      ["req"] = 5;
   };
   [115] = {
      ["name_ru"] = "Темная магия";
      ["type"] = "Group";
      ["name_fr"] = "Magie des Tenebres";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Schattenmagie";
      ["name_cn"] = "暗影魔法";
      ["name"] = "Shadow Magic";
      ["objective"] = "Bring 3 Midnight Orbs to Marshal Marris in Lakeshire.";
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 20;
      ["prequests"] = {
         [1] = 20;
      };
      ["level"] = 23;
      ["name_es"] = "Magia de las Sombras";
      ["req"] = 18;
   };
   [116] = {
      ["name_ru"] = "Сухие времена";
      ["type"] = "Solo";
      ["objective"] = "Barkeep Daniels of Lakeshire needs a keg of Thunderbrew Lager, a cask of Merlot, a bottle of Moonshine and a skin of Sweet Rum.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Regime sec";
      ["name_cn"] = "旱季";
      ["reward"] = {
         [1] = 1270;
         [2] = 10456;
      };
      ["name_de"] = "Trockene Zeiten";
      ["faction"] = "Alliance";
      ["name"] = "Dry Times";
      ["level"] = 15;
      ["name_es"] = "Tiempos de sequia";
      ["req"] = 12;
   };
   [117] = {
      ["name_ru"] = "Громоварское светлое";
      ["type"] = "Solo";
      ["objective"] = "Bring Grimbooze Thunderbrew 5 hops to complete his special brew.";
      ["repgain"] = {
         [47] = 1;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Hymne a la Tonnebiere";
      ["name_cn"] = "雷霆?酒";
      ["reward"] = {
         [1] = 1262;
      };
      ["name_de"] = "Donnerbrau Lagerbier";
      ["faction"] = "Alliance";
      ["name"] = "Thunderbrew Lager";
      ["level"] = 15;
      ["name_es"] = "Cerveza Cebatruenos";
      ["req"] = 0;
   };
   [118] = {
      ["name_ru"] = "Цена подков";
      ["type"] = "Solo";
      ["objective"] = "Take Verner's Note to Smith Argus in Goldshire.";
      ["next"] = 119;
      ["name_fr"] = "Le prix des fers";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "?掌";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der Preis fur Hufeisen";
      ["faction"] = "Alliance";
      ["name"] = "The Price of Shoes";
      ["level"] = 18;
      ["name_es"] = "El precio de unas herraduras";
      ["req"] = 14;
   };
   [119] = {
      ["name_ru"] = "Доставка подков";
      ["type"] = "Solo";
      ["name_fr"] = "Le retour chez Verner";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Zuruck zu Verner";
      ["name_cn"] = "回?弗?";
      ["name"] = "Return to Verner";
      ["objective"] = "Return to Verner Osgood in Redridge.  Give him the Crate of Horseshoes.";
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 118;
      ["prequests"] = {
         [1] = 118;
      };
      ["level"] = 18;
      ["name_es"] = "Regresa junto a Verner";
      ["req"] = 13;
   };
   [120] = {
      ["name_ru"] = "Гонец в Штормград";
      ["type"] = "Solo";
      ["name_fr"] = "Un message pour Hurlevent";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Botschaft nach Sturmwind";
      ["name_cn"] = "送往暴?城的信";
      ["objective"] = "Magistrate Solomon has given you a report which must be delivered to General Marcus Jonathan in Stormwind.  The judge wants you to return to him as soon as the delivery has been made.";
      ["next"] = 121;
      ["sort"] = "Redridge Mountains";
      ["name"] = "Messenger to Stormwind";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 14;
      ["name_es"] = "Mensajero a Ventormenta";
      ["req"] = 14;
   };
   [121] = {
      ["name_ru"] = "Гонец в Штормград";
      ["type"] = "Solo";
      ["objective"] = "Take General Marcus Jonathan's letter of response to Magistrate Solomon in Lakeshire.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Botschaft nach Sturmwind";
      ["name"] = "Messenger to Stormwind";
      ["name_cn"] = "送往暴?城的信";
      ["name_fr"] = "Un message pour Hurlevent";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 120;
      ["prequests"] = {
         [1] = 120;
      };
      ["level"] = 14;
      ["name_es"] = "Mensajero a Ventormenta";
      ["req"] = 14;
   };
   [122] = {
      ["name_ru"] = "Брюшная чешуя";
      ["type"] = "Solo";
      ["objective"] = "Gather 6 Underbelly Whelp Scales from Black Dragon Whelps, and bring them to Verner Osgood in Redridge.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Bauchschuppen";
      ["reward"] = {
         [1] = 6092;
         [2] = 1302;
      };
      ["name_cn"] = "??的?片";
      ["name_fr"] = "Les ecailles de dragonnet";
      ["faction"] = "Alliance";
      ["name"] = "Underbelly Scales";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 119;
      ["prequests"] = {
         [1] = 119;
      };
      ["level"] = 18;
      ["name_es"] = "Escamas de barriga";
      ["req"] = 14;
   };
   [123] = {
      ["name_ru"] = "Вымогатель";
      ["type"] = "Solo";
      ["objective"] = " it looks as if the Collector resides near the Brackwell Pumpkin Patch in eastern Elwynn.$B$BThis sounds important.  You should report it to Marshal Dughan in Goldshire.\"";
      ["next"] = 147;
      ["name_fr"] = "Le collecteur";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "收?人";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der Sammler";
      ["faction"] = "Alliance";
      ["name"] = "The Collector";
      ["level"] = 10;
      ["name_es"] = "El Coleccionista";
      ["req"] = 7;
   };
   [124] = {
      ["name_ru"] = "Лай гноллов";
      ["type"] = "Solo";
      ["name_fr"] = "Le hurlement des gnolls";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Das Bellen der Gnolle";
      ["name"] = "A Baying of Gnolls";
      ["name_cn"] = "豺狼人的乱吠";
      ["objective"] = "Kill 10 Redridge Brutes and 8 Redridge Mystics, then return to Verner Osgood.";
      ["next"] = 126;
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 119;
      ["prequests"] = {
         [1] = 119;
      };
      ["level"] = 20;
      ["name_es"] = "El aullido de los gnolls";
      ["req"] = 15;
   };
   [125] = {
      ["name_ru"] = "Утраченные инструменты";
      ["type"] = "Solo";
      ["objective"] = "Foreman Oslow of Lakeshire wants you to retrieve his toolbox from the bottom of Lake Everstill.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Les outils perdus";
      ["name_cn"] = "?失的工具";
      ["reward"] = {
         [1] = 2313;
      };
      ["name_de"] = "Die verlorenen Werkzeuge";
      ["faction"] = "Alliance";
      ["name"] = "The Lost Tools";
      ["level"] = 16;
      ["name_es"] = "Las herramientas perdidas";
      ["req"] = 15;
   };
   [126] = {
      ["name_ru"] = "Вой в холмах";
      ["type"] = "Solo";
      ["objective"] = "Bring Yowler's Paw to Verner Osgood in Lakeshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Geheul in den Hugeln";
      ["reward"] = {
         [1] = 1319;
         [2] = 2910;
      };
      ["name_cn"] = "群山中的?叫";
      ["name_fr"] = "Les collines aux hurlements";
      ["faction"] = "Alliance";
      ["name"] = "Howling in the Hills";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 124;
      ["prequests"] = {
         [1] = 124;
      };
      ["level"] = 25;
      ["name_es"] = "El aullido de las colinas";
      ["req"] = 15;
   };
   [127] = {
      ["name_ru"] = "Продажа рыбы";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Spotted Sunfish to Dockmaster Baren in Lakeshire.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Criee aux poissons";
      ["name_cn"] = "??";
      ["reward"] = {
         [1] = 3663;
         [2] = 3680;
         [3] = 1322;
      };
      ["name_de"] = "Fischhandel";
      ["faction"] = "Alliance";
      ["name"] = "Selling Fish";
      ["level"] = 21;
      ["name_es"] = "Pescado a la venta";
      ["req"] = 16;
   };
   [128] = {
      ["name_ru"] = "Награда за головы орков Черной горы";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Blackrock Champions and Guard Howe in Lakeshire will reward you.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "La prime Rochenoire";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "??：黑石氏族";
      ["name_de"] = "Kopfgeld auf den Schwarzfelsklan";
      ["faction"] = "Alliance";
      ["name"] = "Blackrock Bounty";
      ["level"] = 25;
      ["name_es"] = "La recompensa de Roca Negra";
      ["req"] = 20;
   };
   [129] = {
      ["name_ru"] = "Бесплатный обед";
      ["type"] = "Solo";
      ["objective"] = "Bring Parker's lunch to Guard Parker.  He patrols the road leading to Darkshire.";
      ["next"] = 130;
      ["name_fr"] = "Un repas gratuit";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "免?的午餐";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Ein geschenktes Mittagessen";
      ["faction"] = "Alliance";
      ["name"] = "A Free Lunch";
      ["level"] = 15;
      ["name_es"] = "Una comida gratis";
      ["req"] = 12;
   };
   [130] = {
      ["name_ru"] = "Визит к травнице";
      ["type"] = "Solo";
      ["name_fr"] = "Une visite chez l'herboriste";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Besuch im Krauterladen";
      ["name"] = "Visit the Herbalist";
      ["name_cn"] = "??草??";
      ["objective"] = "Speak with the Redridge Herbalist, Martie Jainrose.";
      ["next"] = 131;
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 129;
      ["prequests"] = {
         [1] = 129;
      };
      ["level"] = 15;
      ["name_es"] = "Una visita al herborista";
      ["req"] = 12;
   };
   [131] = {
      ["name_ru"] = "Доставка нарциссов";
      ["type"] = "Solo";
      ["objective"] = "Give Darcy the Daffodil Bouquet.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Narzissen fur eine Dame";
      ["reward"] = {
         [1] = 1326;
      };
      ["name_cn"] = "水仙?衷情";
      ["name_fr"] = "Bouquet de jonquilles";
      ["faction"] = "Alliance";
      ["name"] = "Delivering Daffodils";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 130;
      ["prequests"] = {
         [1] = 130;
      };
      ["level"] = 15;
      ["name_es"] = "Un ramo de narcisos";
      ["req"] = 12;
   };
   [132] = {
      ["name_ru"] = "Братство Справедливости";
      ["objective"] = "Take Wiley's Note to Gryan Stoutmantle in Westfall.";
      ["name_cn"] = "迪菲?兄弟会";
      ["sort"] = "Westfall";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "La Confrerie defias";
      ["next"] = 135;
      ["name_de"] = "Die Bruderschaft der Defias";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Defias Brotherhood";
      ["prev"] = 65;
      ["prequests"] = {
         [1] = 65;
      };
      ["series"] = 2;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [133] = {
      ["name_ru"] = "Фигурка вурдалака";
      ["type"] = "Solo";
      ["name_fr"] = "L'epouvantail a goules";
      ["next"] = 134;
      ["name_de"] = "Ein Ghulbildnis";
      ["name_cn"] = "食尸鬼假人";
      ["objective"] = " Bone Chewers";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Ghoulish Effigy";
      ["prev"] = 159;
      ["prequests"] = {
         [1] = 159;
      };
      ["level"] = 27;
      ["name_es"] = "Un espantapajaros para necrofagos";
      ["req"] = 20;
   };
   [134] = {
      ["name_ru"] = "Нападение огров";
      ["type"] = "Solo";
      ["name_fr"] = "Les ogres voleurs";
      ["next"] = 160;
      ["name_de"] = "Ogerdiebe";
      ["name_cn"] = "食人魔盗?";
      ["objective"] = "Return Abercrombie's Crate to Abercrombie.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Ogre Thieves";
      ["prev"] = 133;
      ["prequests"] = {
         [1] = 133;
      };
      ["level"] = 30;
      ["name_es"] = "Ladrones ogros";
      ["req"] = 20;
   };
   [135] = {
      ["name_ru"] = "Братство Справедливости";
      ["objective"] = "Take Wiley's Note to Mathias Shaw in Stormwind.";
      ["name_cn"] = "迪菲?兄弟会";
      ["sort"] = "Westfall";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "La Confrerie defias";
      ["next"] = 141;
      ["name_de"] = "Die Bruderschaft der Defias";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Defias Brotherhood";
      ["prev"] = 132;
      ["prequests"] = {
         [1] = 132;
      };
      ["series"] = 3;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [136] = {
      ["name_ru"] = "Спрятанное сокровище капитана Сандерса";
      ["type"] = "Solo";
      ["objective"] = "Find Captain Sanders' footlocker and search it for the next clue.";
      ["next"] = 138;
      ["name_fr"] = "Le tresor cache du capitaine Sanders";
      ["sort"] = "Westfall";
      ["name_cn"] = "杉德?船?的宝藏";
      ["series"] = 1;
      ["name_de"] = "Kapt'n Sanders' versteckter Schatz";
      ["faction"] = "Horde";
      ["name"] = "Captain Sander's Hidden Treasure";
      ["level"] = 16;
      ["name_es"] = "El tesoro escondido del capitan Sanders";
      ["req"] = 10;
   };
   [138] = {
      ["name_ru"] = "Спрятанное сокровище капитана Сандерса";
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor cache du capitaine Sanders";
      ["next"] = 139;
      ["name_de"] = "Kapt'n Sanders' versteckter Schatz";
      ["name"] = "Captain Sander's Hidden Treasure";
      ["name_cn"] = "杉德?船?的宝藏";
      ["objective"] = "Find the old barrel near the ruined chimney and search it for your next clue.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Westfall";
      ["prev"] = 136;
      ["prequests"] = {
         [1] = 136;
      };
      ["level"] = 16;
      ["name_es"] = "El tesoro escondido del capitan Sanders";
      ["req"] = 10;
   };
   [139] = {
      ["name_ru"] = "Спрятанное сокровище капитана Сандерса";
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor cache du capitaine Sanders";
      ["next"] = 140;
      ["name_de"] = "Kapt'n Sanders' versteckter Schatz";
      ["name"] = "Captain Sander's Hidden Treasure";
      ["name_cn"] = "杉德?船?的宝藏";
      ["objective"] = "Search the empty jug next to the windmill for the next clue.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Westfall";
      ["prev"] = 138;
      ["prequests"] = {
         [1] = 138;
      };
      ["level"] = 16;
      ["name_es"] = "El tesoro escondido del capitan Sanders";
      ["req"] = 10;
   };
   [140] = {
      ["name_ru"] = "Спрятанное сокровище капитана Сандерса";
      ["type"] = "Solo";
      ["objective"] = "Locate Captain Sanders' chest and open it for your reward.";
      ["name_de"] = "Kapt'n Sanders' versteckter Schatz";
      ["name_fr"] = "Le tresor cache du capitaine Sanders";
      ["reward"] = {
         [1] = 2842;
         [2] = 3342;
         [3] = 3344;
         [4] = 3343;
      };
      ["name_cn"] = "杉德?船?的宝藏";
      ["series"] = 4;
      ["faction"] = "Horde";
      ["name"] = "Captain Sander's Hidden Treasure";
      ["sort"] = "Westfall";
      ["prev"] = 139;
      ["prequests"] = {
         [1] = 139;
      };
      ["level"] = 16;
      ["name_es"] = "El tesoro escondido del capitan Sanders";
      ["req"] = 10;
   };
   [141] = {
      ["name_ru"] = "Братство Справедливости";
      ["objective"] = "Take Shaw's report to Gryan Stoutmantle in Westfall.";
      ["name_cn"] = "迪菲?兄弟会";
      ["sort"] = "Westfall";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "La Confrerie defias";
      ["next"] = 142;
      ["name_de"] = "Die Bruderschaft der Defias";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Defias Brotherhood";
      ["prev"] = 135;
      ["prequests"] = {
         [1] = 135;
      };
      ["series"] = 4;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [142] = {
      ["name_ru"] = "Братство Справедливости";
      ["type"] = "Solo";
      ["objective"] = "Track down the Defias Messenger in Westfall and bring his message to Stoutmantle.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Bruderschaft der Defias";
      ["name"] = "The Defias Brotherhood";
      ["name_cn"] = "迪菲?兄弟会";
      ["name_fr"] = "La Confrerie defias";
      ["series"] = 5;
      ["faction"] = "Alliance";
      ["sort"] = "Westfall";
      ["prev"] = 141;
      ["prequests"] = {
         [1] = 141;
      };
      ["level"] = 18;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [143] = {
      ["name_ru"] = "Гонец в Западный Край";
      ["objective"] = "Magistrate Solomon wants you to take his written plea to Gryan Stoutmantle in Westfall.";
      ["name_cn"] = "送往西部荒野的信";
      ["sort"] = "Redridge Mountains";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Un message pour la marche de l'Ouest";
      ["next"] = 144;
      ["name_de"] = "Botschaft nach Westfall";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "Messenger to Westfall";
      ["prev"] = 121;
      ["prequests"] = {
         [1] = 121;
      };
      ["series"] = 1;
      ["name_es"] = "Mensajero a los Paramos de Poniente";
      ["req"] = 14;
   };
   [144] = {
      ["name_ru"] = "Гонец в Западный Край";
      ["type"] = "Solo";
      ["objective"] = "Return to Magistrate Solomon with Gryan Stoutmantle's response.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Botschaft nach Westfall";
      ["name"] = "Messenger to Westfall";
      ["name_cn"] = "送往西部荒野的信";
      ["name_fr"] = "Un message pour la marche de l'Ouest";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 143;
      ["prequests"] = {
         [1] = 143;
      };
      ["level"] = 14;
      ["name_es"] = "Mensajero a los Paramos de Poniente";
      ["req"] = 14;
   };
   [145] = {
      ["name_ru"] = "Гонец в Темнолесье";
      ["objective"] = "Magistrate Solomon wants you to take a letter to Lord Ebonlocke in Darkshire.";
      ["name_cn"] = "送往夜色?的信";
      ["sort"] = "Redridge Mountains";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Un message pour Sombre-comte";
      ["next"] = 146;
      ["name_de"] = "Botschaft nach Dunkelhain";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Messenger to Darkshire";
      ["prev"] = 144;
      ["prequests"] = {
         [1] = 144;
      };
      ["series"] = 1;
      ["name_es"] = "Mensajero a Villa Oscura";
      ["req"] = 18;
   };
   [146] = {
      ["name_ru"] = "Гонец в Темнолесье";
      ["type"] = "Solo";
      ["objective"] = "Return to Magistrate Solomon with Lord Ebonlocke's letter of response.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Botschaft nach Dunkelhain";
      ["name"] = "Messenger to Darkshire";
      ["name_cn"] = "送往夜色?的信";
      ["name_fr"] = "Un message pour Sombre-comte";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 145;
      ["prequests"] = {
         [1] = 145;
      };
      ["level"] = 18;
      ["name_es"] = "Mensajero a Villa Oscura";
      ["req"] = 18;
   };
   [147] = {
      ["name_ru"] = "Охота на человека";
      ["type"] = "Solo";
      ["objective"] = " and bring me the ring mentioned in the pickup schedule you gave me.  It may tell us whom the Collector is working for...$B$BThat Pickup Schedule says the Collector is hiding out at the Brackwell Pumpkin Patch.  You should search for him there.\"";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Menschenjagd";
      ["reward"] = {
         [1] = 1360;
         [2] = 1183;
      };
      ["name_cn"] = "??收?人";
      ["name_fr"] = "Chasse a l'homme";
      ["faction"] = "Alliance";
      ["name"] = "Manhunt";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 123;
      ["prequests"] = {
         [1] = 123;
      };
      ["level"] = 10;
      ["name_es"] = "La persecucion";
      ["req"] = 7;
   };
   [148] = {
      ["name_ru"] = "Припасы из Темнолесья";
      ["type"] = "Solo";
      ["name_fr"] = "Fournitures en provenance de Sombre-comte";
      ["next"] = 149;
      ["name_de"] = "Lieferung aus Dunkelhain";
      ["name_cn"] = "来自夜色?的?物";
      ["objective"] = "Speak with Madame Eva.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Supplies from Darkshire";
      ["prev"] = 165;
      ["prequests"] = {
         [1] = 165;
      };
      ["level"] = 24;
      ["name_es"] = "Suministros de Villa Oscura";
      ["req"] = 20;
   };
   [149] = {
      ["name_ru"] = "Прядь призрачных волос";
      ["type"] = "Solo";
      ["name_fr"] = "Meche de cheveux fantomes";
      ["next"] = 154;
      ["name_de"] = "Geisterhaarfaden";
      ["name_cn"] = "幽?的??";
      ["objective"] = "Bring the Spectral Comb to Blind Mary.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Ghost Hair Thread";
      ["prev"] = 148;
      ["prequests"] = {
         [1] = 148;
      };
      ["level"] = 24;
      ["name_es"] = "Hilo de cabello de fantasma";
      ["req"] = 20;
   };
   [150] = {
      ["name_ru"] = "Мурлоки-браконьеры";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Murloc Fins to Dockmaster Baren in Lakeshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Les braconniers murlocs";
      ["name_cn"] = "?人??者";
      ["reward"] = {
         [1] = 3567;
      };
      ["name_de"] = "Murlocwilderer";
      ["faction"] = "Alliance";
      ["name"] = "Murloc Poachers";
      ["level"] = 20;
      ["name_es"] = "Cazadores furtivos";
      ["req"] = 20;
   };
   [151] = {
      ["name_ru"] = "Бедная старая Савраска";
      ["type"] = "Solo";
      ["objective"] = "Verna Furlbrow in Westfall wants you to bring her 8 Handfuls of Oats.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Pauvre Vieille Blanchette?!";
      ["name_cn"] = "老?布?契";
      ["reward"] = {
         [1] = 2165;
         [2] = 1537;
      };
      ["name_de"] = "Die arme Graumahne";
      ["faction"] = "Alliance";
      ["name"] = "Poor Old Blanchy";
      ["level"] = 14;
      ["name_es"] = "La pobre y vieja Blanchy";
      ["req"] = 9;
   };
   [152] = {
      ["name_ru"] = "Зачистка побережья";
      ["type"] = "Solo";
      ["objective"] = "Kill 7 Tidehunters, 7 Warriors, 7 Oracles and 7 Coastrunners and return to Captain Grayson at the Westfall Lighthouse.";
      ["sort"] = "Westfall";
      ["name_cn"] = "清理海岸";
      ["name_fr"] = "La cote n'est pas sure";
      ["name_de"] = "Arger an der Kuste";
      ["faction"] = "Horde";
      ["name"] = "The Coast Isn't Clear";
      ["level"] = 19;
      ["name_es"] = "Hay moros en la costa";
      ["req"] = 10;
   };
   [153] = {
      ["name_ru"] = "Красные кожаные банданы";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Red Leather Bandanas to Scout Galiaan at Sentinel Hill.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Les masques en cuir rouge";
      ["name_cn"] = "?色皮?面罩";
      ["reward"] = {
         [1] = 3511;
         [2] = 5944;
         [3] = 12295;
      };
      ["name_de"] = "Rote Lederkopftucher";
      ["faction"] = "Alliance";
      ["name"] = "Red Leather Bandanas";
      ["level"] = 15;
      ["name_es"] = "Panuelos rojos de cuero";
      ["req"] = 10;
   };
   [154] = {
      ["name_ru"] = "Гребень для Евы";
      ["type"] = "Solo";
      ["name_fr"] = "Rendre le peigne";
      ["next"] = 157;
      ["name_de"] = "Ruckkehr mit dem Kamm";
      ["name_cn"] = "??梳子";
      ["objective"] = "Return the Ghost Hair Comb to Madame Eva in Darkshire.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Return the Comb";
      ["prev"] = 149;
      ["prequests"] = {
         [1] = 149;
      };
      ["level"] = 24;
      ["name_es"] = "Devuelve el peine";
      ["req"] = 20;
   };
   [155] = {
      ["name_ru"] = "Братство Справедливости";
      ["type"] = "Group";
      ["name_fr"] = "La Confrerie defias";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Die Bruderschaft der Defias";
      ["name"] = "The Defias Brotherhood";
      ["name_cn"] = "迪菲?兄弟会";
      ["objective"] = "Escort the Defias Traitor to the secret hideout of the Defias Brotherhood.  Once the Defias Traitor shows you where VanCleef and his men are hiding out, return to Gryan Stoutmantle with the information.";
      ["next"] = 166;
      ["faction"] = "Alliance";
      ["sort"] = "Westfall";
      ["prev"] = 142;
      ["prequests"] = {
         [1] = 142;
      };
      ["level"] = 18;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [156] = {
      ["name_ru"] = "Сбор цветков гнили";
      ["type"] = "Solo";
      ["name_fr"] = "Cueillette de racines pourries";
      ["next"] = 159;
      ["name_de"] = "Das Sammeln von Faulbluten";
      ["name_cn"] = "收集腐?之花";
      ["objective"] = "Gather 8 Rot Blossoms and bring them to Tavernkeep Smitts in Darkshire.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Gather Rot Blossoms";
      ["prev"] = 158;
      ["prequests"] = {
         [1] = 158;
      };
      ["level"] = 24;
      ["name_es"] = "Busca flores podridas";
      ["req"] = 20;
   };
   [157] = {
      ["name_ru"] = "Доставка ниток";
      ["type"] = "Solo";
      ["name_fr"] = "Apporter la meche";
      ["next"] = 158;
      ["name_de"] = "Abliefern des Fadens";
      ["name_cn"] = "幽?的??";
      ["objective"] = "Bring the Ghost Hair Thread to Abercrombie, in his shack north of the Raven Hill Cemetery.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Deliver the Thread";
      ["prev"] = 154;
      ["prequests"] = {
         [1] = 154;
      };
      ["level"] = 24;
      ["name_es"] = "Devolver el pelo";
      ["req"] = 20;
   };
   [158] = {
      ["name_ru"] = "Сок зомби";
      ["type"] = "Solo";
      ["name_fr"] = "Le suc de zombie";
      ["next"] = 156;
      ["name_de"] = "Zombiesaft";
      ["name_cn"] = "僵尸";
      ["objective"] = "Speak with Tavernkeep Smitts.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Zombie Juice";
      ["prev"] = 157;
      ["prequests"] = {
         [1] = 157;
      };
      ["level"] = 24;
      ["name_es"] = "Zumo de zombi";
      ["req"] = 20;
   };
   [159] = {
      ["name_ru"] = "Доставка сока";
      ["type"] = "Solo";
      ["name_fr"] = "Livrer le Suc";
      ["next"] = 133;
      ["name_de"] = "Saftlieferung";
      ["name_cn"] = "僵尸酒";
      ["objective"] = "Bring the Zombie Juice to Abercrombie at his shack.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Juice Delivery";
      ["prev"] = 156;
      ["prequests"] = {
         [1] = 156;
      };
      ["level"] = 24;
      ["name_es"] = "Entrega de zumo";
      ["req"] = 20;
   };
   [160] = {
      ["name_ru"] = "Записка для мэра";
      ["type"] = "Solo";
      ["name_fr"] = "Une lettre pour le Maire";
      ["next"] = 251;
      ["name_de"] = "Ein Brief fur den Burgermeister";
      ["name_cn"] = "???的信";
      ["objective"] = "Bring Abercrombie's Letter to Ello Ebonlocke, Mayor of Darkshire.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Note to the Mayor";
      ["prev"] = 134;
      ["prequests"] = {
         [1] = 134;
      };
      ["level"] = 30;
      ["name_es"] = "Nota para el alcalde";
      ["req"] = 20;
   };
   [161] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "Chief Engineer Hinderweir wants you to take the strange smelling powder to Ashlan Stonesmirk, the explosives expert in Dun Modr.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["next"] = 274;
      ["name_de"] = "Eine dunkle Bedrohung";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 199;
      ["prequests"] = {
         [1] = 199;
      };
      ["series"] = 3;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [162] = {
      ["name_ru"] = "Возвышение силитидов";
      ["type"] = "Solo";
      ["name_fr"] = "L'ascension des silithides";
      ["repgain"] = {
         [69] = 350;
         [54] = 350;
         [47] = 350;
         [369] = 350;
      };
      ["name_de"] = "Aufstieg der Silithiden";
      ["name_cn"] = "??蝎的威?";
      ["name"] = "Rise of the Silithid";
      ["objective"] = "Take the Insect Analysis Report to Gracina Spiritmight in Darnassus.";
      ["faction"] = "Alliance";
      ["sort"] = "Tanaris";
      ["prev"] = 113;
      ["prequests"] = {
         [1] = 113;
      };
      ["level"] = 49;
      ["name_es"] = "La sublevacion de los silitidos";
      ["req"] = 39;
   };
   [163] = {
      ["name_ru"] = "Вороний холм";
      ["type"] = "Solo";
      ["objective"] = "Find out what is haunting Raven Hill.";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_fr"] = "Colline-aux-Corbeaux";
      ["sort"] = "Duskwood";
      ["name_cn"] = "???";
      ["name_de"] = "Rabenflucht";
      ["faction"] = "Alliance";
      ["name"] = "Raven Hill";
      ["level"] = 20;
      ["name_es"] = "Cerro del Cuervo";
      ["req"] = 17;
   };
   [164] = {
      ["name_ru"] = "Припасы для Свена";
      ["type"] = "Solo";
      ["objective"] = "Deliver the supplies to Sven.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_fr"] = "Livraison a Sven";
      ["sort"] = "Duskwood";
      ["name_cn"] = "斯温的?物";
      ["name_de"] = "Lieferung an Sven";
      ["faction"] = "Alliance";
      ["name"] = "Deliveries to Sven";
      ["level"] = 23;
      ["name_es"] = "Entrega a Sven";
      ["req"] = 17;
   };
   [165] = {
      ["name_ru"] = "Отшельник";
      ["type"] = "Solo";
      ["objective"] = "Check on the old man in the shack near Raven Hill cemetery.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_fr"] = "L'ermite";
      ["sort"] = "Duskwood";
      ["name_cn"] = "?士";
      ["name_de"] = "Der Einsiedler";
      ["faction"] = "Alliance";
      ["name"] = "The Hermit";
      ["level"] = 25;
      ["name_es"] = "El ermitano";
      ["req"] = 17;
   };
   [166] = {
      ["name_ru"] = "Братство Справедливости";
      ["type"] = "Dungeon";
      ["objective"] = "Kill Edwin VanCleef and bring his head to Gryan Stoutmantle.";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Die Bruderschaft der Defias";
      ["reward"] = {
         [1] = 6087;
         [2] = 2041;
         [3] = 2042;
      };
      ["name_cn"] = "迪菲?兄弟会";
      ["name_fr"] = "La Confrerie defias";
      ["faction"] = "Alliance";
      ["name"] = "The Defias Brotherhood";
      ["sort"] = "The Deadmines";
      ["prev"] = 155;
      ["prequests"] = {
         [1] = 155;
      };
      ["level"] = 22;
      ["name_es"] = "La hermandad de los Defias";
      ["req"] = 14;
   };
   [167] = {
      ["name_ru"] = "О, брат мой...";
      ["type"] = "Solo";
      ["objective"] = "Bring Foreman Thistlenettle's Explorers' League Badge to Wilder Thistlenettle in Stormwind.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "The Deadmines";
      ["name_fr"] = "Adieu mon frere…";
      ["name_cn"] = "我的兄弟……";
      ["reward"] = {
         [1] = 1893;
      };
      ["name_de"] = "Oh Bruder...";
      ["faction"] = "Alliance";
      ["name"] = "Oh Brother. . .";
      ["level"] = 20;
      ["name_es"] = "Oh, hermano...";
      ["req"] = 15;
   };
   [168] = {
      ["name_ru"] = "Сбор воспоминаний";
      ["type"] = "Solo";
      ["objective"] = "Retrieve 4 Miners' Union Cards and return them to Wilder Thistlenettle in Stormwind.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "The Deadmines";
      ["name_fr"] = "A la recherche de Cartes du Syndicat des Mineurs";
      ["name_cn"] = "收集??";
      ["reward"] = {
         [1] = 2037;
         [2] = 2036;
      };
      ["name_de"] = "Die Suche nach Andenken";
      ["faction"] = "Alliance";
      ["name"] = "Collecting Memories";
      ["level"] = 18;
      ["name_es"] = "Recoleccion de recuerdos";
      ["req"] = 14;
   };
   [169] = {
      ["name_ru"] = "Разыскивается: Гат'Илзогг";
      ["type"] = "Group";
      ["objective"] = "Kill Gath'Ilzogg and bring his head to Magistrate Solomon in Lakeshire for the reward.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_fr"] = "On recherche?: Gath'Ilzogg";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "通?：加塞?佐格";
      ["name_de"] = "GESUCHT: Gath'Ilzogg";
      ["faction"] = "Alliance";
      ["name"] = "Wanted: Gath'Ilzogg";
      ["level"] = 26;
      ["name_es"] = "Se busca: Gath'Ilzogg";
      ["req"] = 15;
   };
   [170] = {
      ["name_ru"] = "Новая угроза";
      ["type"] = "Solo";
      ["objective"] = "Balir Frosthammer wants you to kill 6 Rockjaw Troggs and 6 Burly Rockjaw Troggs.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Eine neue Bedrohung";
      ["reward"] = {
         [1] = 6185;
         [2] = 2172;
         [3] = 6173;
      };
      ["name_cn"] = "新的威?";
      ["name_fr"] = "Une nouvelle menace";
      ["faction"] = "Alliance";
      ["name"] = "A New Threat";
      ["sort"] = "Coldridge Valley";
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 2;
      ["name_es"] = "Una nueva amenaza";
      ["req"] = 1;
   };
   [171] = {
      ["name_ru"] = "Опекун Альянса";
      ["type"] = "Solo";
      ["name_fr"] = "Un surveillant de l'Alliance";
      ["repgain"] = {
         [469] = 500;
      };
      ["name_de"] = "Tageseltern der Allianz";
      ["name_cn"] = "?盟孤儿的看?者*  ";
      ["reward"] = {
         [1] = 23007;
         [2] = 23015;
         [3] = 23002;
         [4] = 23022;
      };
      ["objective"] = "Return your ward to the Stormwind orphanage by handing in the Human Orphan Whistle to Orphan Matron Nightingale in the Cathedral District.";
      ["name"] = "A Warden of the Alliance";
      ["sort"] = "Children's Week";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 558;
      };
      ["level"] = 60;
      ["name_es"] = "Alcaide de la Alianza";
      ["req"] = 10;
   };
   [172] = {
      ["name_ru"] = "Детская неделя";
      ["type"] = "Solo";
      ["objective"] = "Use the Orcish Orphan Whistle to talk with the child you will be looking after during Children's Week.";
      ["sort"] = "Children's Week";
      ["name_cn"] = "儿童周";
      ["name_fr"] = "La Semaine des enfants";
      ["name_de"] = "Die Kinderwoche";
      ["faction"] = "Horde";
      ["name"] = "Children's Week";
      ["level"] = 60;
      ["name_es"] = "Semana de los Ninos";
      ["req"] = 10;
   };
   [173] = {
      ["name_ru"] = "Воргены в лесу";
      ["type"] = "Solo";
      ["name_fr"] = "Worgens dans les bois";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Worgen in den Waldern";
      ["name_cn"] = "森林里的狼人";
      ["objective"] = "Kill 6 Nightbane Shadow Weaver worgen for Calor in Darkshire.";
      ["next"] = 221;
      ["sort"] = "Duskwood";
      ["name"] = "Worgen in the Woods";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 28;
      ["name_es"] = "Huargen en el bosque";
      ["req"] = 23;
   };
   [174] = {
      ["name_ru"] = "Взгляни на звезды";
      ["type"] = "Solo";
      ["name_fr"] = "Les yeux dans les etoiles";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Der Blick zu den Sternen";
      ["name_cn"] = "仰望星空";
      ["objective"] = "Viktori Prism'Antras of Darkshire wants you to bring him a bronze tube.";
      ["next"] = 175;
      ["sort"] = "Duskwood";
      ["name"] = "Look To The Stars";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 25;
      ["name_es"] = "Mira las estrellas";
      ["req"] = 20;
   };
   [175] = {
      ["name_ru"] = "Взгляни на звезды";
      ["type"] = "Solo";
      ["name_fr"] = "Les yeux dans les etoiles";
      ["next"] = 177;
      ["name_de"] = "Der Blick zu den Sternen";
      ["name"] = "Look To The Stars";
      ["name_cn"] = "仰望星空";
      ["objective"] = "Locate Mary and persuade her to give up a reflective surface for Viktori's project.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 174;
      ["prequests"] = {
         [1] = 174;
      };
      ["level"] = 25;
      ["name_es"] = "Mira las estrellas";
      ["req"] = 20;
   };
   [176] = {
      ["name_ru"] = "Разыскивается: \"Дробитель\"";
      ["type"] = "Group";
      ["objective"] = "Slay the gnoll Hogger and bring his Huge Gnoll Claw to Marshal Dughan.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "On recherche?: ≪?Lardeur?≫";
      ["name_cn"] = "通?：霍格";
      ["reward"] = {
         [1] = 6085;
         [2] = 6084;
         [3] = 6215;
      };
      ["name_de"] = "GESUCHT: \"Hogger\"";
      ["faction"] = "Alliance";
      ["name"] = "Wanted:  Hogger\"\"";
      ["level"] = 11;
      ["name_es"] = "Se busca: Hogger";
      ["req"] = 5;
   };
   [177] = {
      ["name_ru"] = "Взгляни на звезды";
      ["objective"] = "Retrieve Blind Mary's Looking Glass from the Insane Ghoul and give it to Viktori in Darkshire.";
      ["name_cn"] = "仰望星空";
      ["sort"] = "Duskwood";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "Les yeux dans les etoiles";
      ["next"] = 181;
      ["name_de"] = "Der Blick zu den Sternen";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Look To The Stars";
      ["prev"] = 175;
      ["prequests"] = {
         [1] = 175;
      };
      ["series"] = 3;
      ["name_es"] = "Mira las estrellas";
      ["req"] = 20;
   };
   [178] = {
      ["name_ru"] = "Поручение Теокрита";
      ["type"] = "Solo";
      ["objective"] = "Bring the Faded Shadowhide Pendant to Theocritus the Mage.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Theocritus recupere son Pendentif";
      ["name_cn"] = "塞欧克瑞?斯的??";
      ["reward"] = {
         [1] = 1970;
      };
      ["name_de"] = "Wiederbeschaffung fur Theocritus";
      ["faction"] = "Alliance";
      ["name"] = "Theocritus' Retrieval";
      ["level"] = 23;
      ["name_es"] = "Theocritus recupera el colgante";
      ["req"] = 15;
   };
   [179] = {
      ["name_ru"] = "Дворфские экипировщики";
      ["type"] = "Solo";
      ["objective"] = "Sten Stoutarm would like 8 pieces of Tough Wolf Meat.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["sort"] = "Coldridge Valley";
      ["name_fr"] = "Tailleur chez les nains";
      ["name_cn"] = "矮人的交易";
      ["reward"] = {
         [1] = 719;
         [2] = 6171;
         [3] = 2547;
      };
      ["name_de"] = "Zwergenausstatter";
      ["faction"] = "Alliance";
      ["name"] = "Dwarven Outfitters";
      ["level"] = 1;
      ["name_es"] = "Los enanos modistos";
      ["req"] = 1;
   };
   [180] = {
      ["name_ru"] = "Разыскивается: лейтенант Фангор";
      ["type"] = "Solo";
      ["objective"] = "Kill Lieutenant Fangore and return to Magistrate Solomon in Lakeshire with his paw.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_fr"] = "On recherche?: lieutenant Tripecroc";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "通?：范高雷中尉";
      ["name_de"] = "GESUCHT: Leutnant Fangor";
      ["faction"] = "Alliance";
      ["name"] = "Wanted: Lieutenant Fangore";
      ["level"] = 26;
      ["name_es"] = "Se busca: Teniente Fangore";
      ["req"] = 15;
   };
   [181] = {
      ["name_ru"] = "Взгляни на звезды";
      ["objective"] = "Locate Zzarc'Vul in the southern ogre mound in Duskwood and return his monocle to Viktori in Darkshire.";
      ["name_cn"] = "仰望星空";
      ["sort"] = "Duskwood";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Les yeux dans les etoiles";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Der Blick zu den Sternen";
      ["reward"] = {
         [1] = 7106;
         [2] = 7107;
      };
      ["faction"] = "Alliance";
      ["name"] = "Look To The Stars";
      ["prev"] = 177;
      ["prequests"] = {
         [1] = 177;
      };
      ["series"] = 4;
      ["name_es"] = "Mira las estrellas";
      ["req"] = 20;
   };
   [182] = {
      ["name_ru"] = "Пещера троллей";
      ["type"] = "Solo";
      ["objective"] = "Grelin Whitebeard would like you to kill 14 Frostmane Troll Whelps.";
      ["next"] = 218;
      ["sort"] = "Coldridge Valley";
      ["name_fr"] = "La caverne des trolls";
      ["name_cn"] = "巨魔洞穴";
      ["reward"] = {
         [1] = 2047;
         [2] = 961;
         [3] = 2048;
         [4] = 2195;
         [5] = 5761;
      };
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Die Trollbedrohung";
      ["faction"] = "Alliance";
      ["name"] = "The Troll Cave";
      ["level"] = 4;
      ["name_es"] = "La amenaza trol";
      ["req"] = 1;
   };
   [183] = {
      ["name_ru"] = "Охотник на вепрей";
      ["type"] = "Solo";
      ["objective"] = "Talin Keeneye would like you to kill 12 Small Crag Boars.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["sort"] = "Coldridge Valley";
      ["name_fr"] = "Chasseur de sangliers";
      ["name_cn"] = "??野猪";
      ["reward"] = {
         [1] = 79;
         [2] = 61;
      };
      ["name_de"] = "Der Eberjager";
      ["faction"] = "Alliance";
      ["name"] = "The Boar Hunter";
      ["level"] = 3;
      ["name_es"] = "Cazador de jabalies";
      ["req"] = 1;
   };
   [184] = {
      ["name_ru"] = "Документ Хмуроброва";
      ["type"] = "Solo";
      ["objective"] = " stuck with a broken wagon.\"$B$BYou think the Furlbrows might want their deed back...\"";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Westfall";
      ["name_fr"] = "Titre de propriete de Froncebouille";
      ["name_cn"] = "法布隆的地契";
      ["reward"] = {
         [1] = 5057;
         [2] = 4656;
      };
      ["name_de"] = "Brauenwirbels Urkunde";
      ["faction"] = "Alliance";
      ["name"] = "Furlbrow's Deed";
      ["level"] = 9;
      ["name_es"] = "Las escrituras de Cejade";
      ["req"] = 8;
   };
   [185] = {
      ["name_ru"] = "Охота на тигров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse au tigre";
      ["next"] = 186;
      ["name_de"] = "Tigerjagd";
      ["name"] = "Tiger Mastery";
      ["name_cn"] = "?虎";
      ["objective"] = "Ajeck Rouack of Nesingwary's Expedition wants you to kill 10 Young Stranglethorn Tigers.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 583;
      ["prequests"] = {
         [1] = 583;
      };
      ["level"] = 31;
      ["name_es"] = "Caza al tigre";
      ["req"] = 28;
   };
   [186] = {
      ["name_ru"] = "Охота на тигров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse au tigre";
      ["next"] = 187;
      ["name_de"] = "Tigerpirsch";
      ["name"] = "Tiger Mastery";
      ["name_cn"] = "?虎";
      ["objective"] = "Ajeck Rouack of Nesingwary's Expedition wants you to kill 10 Stranglethorn Tigers.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 185;
      ["prequests"] = {
         [1] = 185;
      };
      ["level"] = 33;
      ["name_es"] = "Persigue al tigre";
      ["req"] = 28;
   };
   [187] = {
      ["name_ru"] = "Охота на тигров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse au tigre";
      ["next"] = 188;
      ["name_de"] = "Tigerhatz";
      ["name"] = "Tiger Mastery";
      ["name_cn"] = "?虎";
      ["objective"] = "Ajeck Rouack of Nesingwary's Expedition wants you to kill 10 Elder Stranglethorn Tigers.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 186;
      ["prequests"] = {
         [1] = 186;
      };
      ["level"] = 35;
      ["name_es"] = "Somete al tigre";
      ["req"] = 28;
   };
   [188] = {
      ["name_ru"] = "Охота на тигров";
      ["objective"] = "Ajeck Rouack of Nesingwary's Expedition wants you to kill Sin'Dall and return with her paw.";
      ["name_cn"] = "?虎";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse au tigre";
      ["name_de"] = "Beherrschen der Tigerjagd";
      ["reward"] = {
         [1] = 4107;
      };
      ["followup"] = 208;
      ["faction"] = "Horde";
      ["name"] = "Tiger Mastery";
      ["prev"] = 187;
      ["prequests"] = {
         [1] = 187;
      };
      ["series"] = 4;
      ["name_es"] = "Domina el tigre";
      ["req"] = 28;
   };
   [189] = {
      ["name_ru"] = "Уши троллей Кровавого Скальпа";
      ["type"] = "Solo";
      ["objective"] = "Acquire 15 Bloodscalp Ears and return them to Kebok in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Oreilles de Scalps-rouges";
      ["name_cn"] = "血?巨魔的耳?";
      ["reward"] = {
         [1] = 4598;
      };
      ["name_de"] = "Ohren der Blutskalpe";
      ["faction"] = "Horde";
      ["name"] = "Bloodscalp Ears";
      ["level"] = 35;
      ["name_es"] = "Orejas de Sangrapellejo";
      ["req"] = 30;
   };
   [190] = {
      ["name_ru"] = "Охота на пантер";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse a la panthere";
      ["next"] = 191;
      ["name_de"] = "Pantherjagd";
      ["name"] = "Panther Mastery";
      ["name_cn"] = "?豹";
      ["objective"] = "Sir S. J. Erlgadin of Nesingwary's Expedition wants you to kill 10 Young Panthers.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 583;
      ["prequests"] = {
         [1] = 583;
      };
      ["level"] = 31;
      ["name_es"] = "Caza la pantera";
      ["req"] = 28;
   };
   [191] = {
      ["name_ru"] = "Охота на пантер";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse a la panthere";
      ["next"] = 192;
      ["name_de"] = "Pantherpirsch";
      ["name"] = "Panther Mastery";
      ["name_cn"] = "?豹";
      ["objective"] = "Sir S. J. Erlgadin of Nesingwary's Expedition wants you to kill 10 Panthers.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 190;
      ["prequests"] = {
         [1] = 190;
      };
      ["level"] = 33;
      ["name_es"] = "Persigue a la pantera";
      ["req"] = 28;
   };
   [192] = {
      ["name_ru"] = "Охота на пантер";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse a la panthere";
      ["next"] = 193;
      ["name_de"] = "Pantherhatz";
      ["name"] = "Panther Mastery";
      ["name_cn"] = "?豹";
      ["objective"] = "Sir S. J. Erlgadin of Nesingwary's Expedition wants you to kill 10 Shadowmaw Panthers.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 191;
      ["prequests"] = {
         [1] = 191;
      };
      ["level"] = 38;
      ["name_es"] = "Somete a la pantera";
      ["req"] = 28;
   };
   [193] = {
      ["name_ru"] = "Охота на пантер";
      ["objective"] = "Sir S. J. Erlgadin of Nesingwary's Expedition wants you to bring him the Fang of Bhag'thera.";
      ["name_cn"] = "?豹";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 40;
      ["type"] = "Group";
      ["name_fr"] = "Maitrise de la chasse a la panthere";
      ["name_de"] = "Beherrschen der Pantherjagd";
      ["reward"] = {
         [1] = 4108;
      };
      ["followup"] = 208;
      ["faction"] = "Horde";
      ["name"] = "Panther Mastery";
      ["prev"] = 192;
      ["prequests"] = {
         [1] = 192;
      };
      ["series"] = 4;
      ["name_es"] = "Domina la pantera";
      ["req"] = 28;
   };
   [194] = {
      ["name_ru"] = "Охота на ящеров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse aux raptors";
      ["next"] = 195;
      ["name_de"] = "Raptorenjagd";
      ["name"] = "Raptor Mastery";
      ["name_cn"] = "??";
      ["objective"] = "Hemet Nesingwary wants you to kill 10 Stranglethorn Raptors.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 583;
      ["prequests"] = {
         [1] = 583;
      };
      ["level"] = 34;
      ["name_es"] = "Caza al raptor";
      ["req"] = 28;
   };
   [195] = {
      ["name_ru"] = "Охота на ящеров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse aux raptors";
      ["next"] = 196;
      ["name_de"] = "Raptorenpirsch";
      ["name"] = "Raptor Mastery";
      ["name_cn"] = "??";
      ["objective"] = "Hemet Nesingwary wants you to kill 10 Lashtail Raptors.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 194;
      ["prequests"] = {
         [1] = 194;
      };
      ["level"] = 36;
      ["name_es"] = "Persigue al raptor";
      ["req"] = 28;
   };
   [196] = {
      ["name_ru"] = "Охота на ящеров";
      ["type"] = "Solo";
      ["name_fr"] = "Maitrise de la chasse aux raptors";
      ["next"] = 197;
      ["name_de"] = "Raptorenhatz";
      ["name"] = "Raptor Mastery";
      ["name_cn"] = "??";
      ["objective"] = "Hemet Nesingwary wants you to kill 10 Jungle Stalkers.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 195;
      ["prequests"] = {
         [1] = 195;
      };
      ["level"] = 41;
      ["name_es"] = "Somete al raptor";
      ["req"] = 28;
   };
   [197] = {
      ["name_ru"] = "Охота на ящеров";
      ["objective"] = "Hemet Nesingwary wants you to kill Tethis, an elusive, dangerous raptor in Stranglethorn.";
      ["name_cn"] = "??";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 43;
      ["type"] = "Group";
      ["name_fr"] = "Maitrise de la chasse aux raptors";
      ["name_de"] = "Beherrschen der Raptorenjagd";
      ["reward"] = {
         [1] = 4119;
      };
      ["followup"] = 208;
      ["faction"] = "Horde";
      ["name"] = "Raptor Mastery";
      ["prev"] = 196;
      ["prequests"] = {
         [1] = 196;
      };
      ["series"] = 4;
      ["name_es"] = "Domina el raptor";
      ["req"] = 28;
   };
   [198] = {
      ["name_ru"] = "Припасы для рядового Торсена";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Miscellaneous Goblin Supplies to Private Thorsen.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_fr"] = "Les marchandises du soldat Thorsen";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "列兵索?森的??物?";
      ["name_de"] = "Vorrate fur den Gefreiten Thorsen";
      ["faction"] = "Alliance";
      ["name"] = "Supplies to Private Thorsen";
      ["level"] = 32;
      ["name_es"] = "Suministros para el soldado Thorsen";
      ["req"] = 30;
   };
   [199] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "Return to Chief Engineer Hinderweir and show him the clue that you discovered.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["next"] = 161;
      ["name_de"] = "Eine dunkle Bedrohung";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 250;
      ["prequests"] = {
         [1] = 250;
      };
      ["series"] = 2;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [200] = {
      ["name_ru"] = "Букмекер Ирод";
      ["type"] = "Solo";
      ["name_fr"] = "Herode la Paperasse";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Buchmacher Herod";
      ["name"] = "Bookie Herod";
      ["name_cn"] = "?呆子赫?德";
      ["objective"] = "Find Bookie Herod's Records.";
      ["next"] = 328;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 215;
      ["prequests"] = {
         [1] = 215;
      };
      ["level"] = 35;
      ["name_es"] = "Corredor Herod";
      ["req"] = 30;
   };
   [201] = {
      ["name_ru"] = "Поиск лагеря";
      ["type"] = "Solo";
      ["objective"] = "Find the hunters' camp and report its location to Krazek in Booty Bay.";
      ["repgain"] = {
         [21] = 75;
      };
      ["name_fr"] = "L'enquete au camp";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "???地";
      ["name_de"] = "Untersuchung des Lagers";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Camp";
      ["level"] = 32;
      ["name_es"] = "Investiga el campamento";
      ["req"] = 28;
   };
   [202] = {
      ["name_ru"] = "Полковник Курцен";
      ["type"] = "Group";
      ["objective"] = "Kill 6 Kurzen Elite, 4 Kurzen Subchiefs, and bring Kurzen's Head to Lieutenant Doren at the Rebel Camp.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Colonel Kurzen";
      ["reward"] = {
         [1] = 4127;
      };
      ["name_cn"] = "??森上校";
      ["name_fr"] = "Le colonel Kurzen";
      ["faction"] = "Alliance";
      ["name"] = "Colonel Kurzen";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 574;
      ["prequests"] = {
         [1] = 574;
      };
      ["level"] = 40;
      ["name_es"] = "Coronel Kurzen";
      ["req"] = 30;
   };
   [203] = {
      ["name_ru"] = "Второе восстание";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Kurzen Jungle Fighters.$B$BReturn to Sergeant Yohwa at the Rebel Camp.";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_fr"] = "La seconde rebellion";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "以彼之道?施彼身";
      ["followup"] = 574;
      ["name_de"] = "Die zweite Rebellion";
      ["faction"] = "Alliance";
      ["name"] = "The Second Rebellion";
      ["level"] = 33;
      ["name_es"] = "La segunda rebelion";
      ["req"] = 30;
   };
   [204] = {
      ["name_ru"] = "Дурное лекарство";
      ["type"] = "Solo";
      ["objective"] = "Bring 7 Jungle Remedies and 1 Venom Fern Extract to Sergeant Yohwa at the Rebel Camp.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Mauvaise medecine";
      ["name_cn"] = "??森的?物";
      ["followup"] = 574;
      ["reward"] = {
         [1] = 4140;
         [2] = 4126;
      };
      ["name_de"] = "Schlechte Medizin";
      ["faction"] = "Alliance";
      ["name"] = "Bad Medicine";
      ["level"] = 34;
      ["name_es"] = "Mala medicina";
      ["req"] = 30;
   };
   [205] = {
      ["name_ru"] = "Тролльское колдовство";
      ["type"] = "Solo";
      ["name_fr"] = "Sorcellerie troll";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Trollhexerei";
      ["name_cn"] = "巨魔巫?";
      ["name"] = "Troll Witchery";
      ["objective"] = "Bring 4 Skullsplitter Fetishes to Brother Nimetz at the Rebel Camp.";
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 207;
      ["prequests"] = {
         [1] = 207;
      };
      ["level"] = 40;
      ["name_es"] = "Brujeria trol";
      ["req"] = 30;
   };
   [206] = {
      ["name_ru"] = "Май'Зот";
      ["type"] = "Group";
      ["objective"] = "Bring the Mind's Eye to Brother Nimetz at the Rebel Camp.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Mai'Zoth";
      ["reward"] = {
         [1] = 4125;
      };
      ["name_cn"] = "麦佐斯";
      ["name_fr"] = "Mai'Zoth";
      ["faction"] = "Alliance";
      ["name"] = "Mai'Zoth";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 205;
      ["prequests"] = {
         [1] = 205;
      };
      ["level"] = 46;
      ["name_es"] = "Mai'Zoth";
      ["req"] = 30;
   };
   [207] = {
      ["name_ru"] = "Тайна Курцена";
      ["type"] = "Solo";
      ["name_fr"] = "Le mystere de Kurzen";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Das Geheimnis um Kurzen";
      ["name"] = "Kurzen's Mystery";
      ["name_cn"] = "??森的秘密";
      ["objective"] = "Find the 4 tablets and bring their legends back to Brother Nimetz.";
      ["next"] = 205;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 203;
      ["prequests"] = {
         [1] = 203;
      };
      ["level"] = 38;
      ["name_es"] = "El misterio de Kurzen";
      ["req"] = 30;
   };
   [208] = {
      ["name_ru"] = "Охотник на крупную дичь";
      ["type"] = "Group";
      ["name_fr"] = "La chasse au gros gibier";
      ["name_de"] = "Groswildjagd";
      ["name_cn"] = "王牌?人";
      ["objective"] = "Hemet Nesingwary wants you to bring him the head of King Bangalash, the great white tiger.";
      ["sort"] = "Stranglethorn Valley";
      ["reward"] = {
         [1] = 17686;
         [2] = 17687;
      };
      ["name"] = "Big Game Hunter";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 188;
         [2] = 193;
         [3] = 197;
      };
      ["level"] = 43;
      ["name_es"] = "Caza mayor";
      ["req"] = 28;
   };
   [209] = {
      ["name_ru"] = "Клыки троллей";
      ["type"] = "Solo";
      ["name_fr"] = "Les defenses Casse-crane";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Hauer der Schadelspalter";
      ["name_cn"] = "劈?巨魔的?牙";
      ["name"] = "Skullsplitter Tusks";
      ["objective"] = "Acquire 18 Skullsplitter Tusks and return them to Kebok.";
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 189;
      ["prequests"] = {
         [1] = 189;
      };
      ["level"] = 42;
      ["name_es"] = "Colmillos Machacacraneos";
      ["req"] = 37;
   };
   [210] = {
      ["name_ru"] = "Горшок Кразека";
      ["type"] = "Solo";
      ["objective"] = "Bring Krazek's Crock Pot to Krazek the goblin.";
      ["next"] = 627;
      ["name_fr"] = "La cuisine de Krazek";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "克拉?克的烹??";
      ["repgain"] = {
         [21] = 75;
      };
      ["name_de"] = "Kochen mit Krazek";
      ["faction"] = "Alliance";
      ["name"] = "Krazek's Cookery";
      ["level"] = 37;
      ["name_es"] = "La cocina de Krazek";
      ["req"] = 32;
   };
   [211] = {
      ["name_ru"] = "Увы тебе, Андорал";
      ["type"] = "Group";
      ["objective"] = "Bring Araj's Phylactery Shard to Commander Ashlam Valorfist at Chillwind Camp, Western Plaguelands.";
      ["repgain"] = {
         [469] = 350;
         [529] = 350;
      };
      ["name_de"] = "Weh dir, Andorhal";
      ["reward"] = {
         [1] = 17759;
      };
      ["name_cn"] = "?，安多哈?！";
      ["name_fr"] = "Helas, Andorhal";
      ["faction"] = "Alliance";
      ["name"] = "Alas, Andorhal";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5097;
      ["prequests"] = {
         [1] = 5097;
      };
      ["level"] = 60;
      ["name_es"] = "Ah, Andorhal";
      ["req"] = 50;
   };
   [212] = {
      ["name_ru"] = "Холодный обед";
      ["type"] = "Solo";
      ["objective"] = "Kill a Cold Eye Basilisk, get a Chilled Basilisk Haunch, and return it to Angus Stern in the Blue Recluse.";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_fr"] = "Un repas servi froid";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "冷餐会";
      ["name_de"] = "Eine kalte Mahlzeit";
      ["faction"] = "Alliance";
      ["name"] = "A Meal Served Cold";
      ["level"] = 40;
      ["name_es"] = "Un plato bien frio";
      ["req"] = 35;
   };
   [213] = {
      ["name_ru"] = "Недружественное поглощение";
      ["type"] = "Solo";
      ["objective"] = "Retrieve 8 Tumbled Crystals and return them to Kebok in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Une ponction musclee";
      ["name_cn"] = "?性?争";
      ["reward"] = {
         [1] = 4121;
      };
      ["name_de"] = "Feindliche Ubernahme";
      ["faction"] = "Horde";
      ["name"] = "Hostile Takeover";
      ["level"] = 36;
      ["name_es"] = "OPA hostil";
      ["req"] = 31;
   };
   [214] = {
      ["name_ru"] = "Красные шелковые банданы";
      ["type"] = "Dungeon";
      ["objective"] = "Scout Riell at the Sentinel Hill Tower wants you to bring her 10 Red Silk Bandanas.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Rote Seidenkopftucher";
      ["reward"] = {
         [1] = 2074;
         [2] = 2089;
         [3] = 6094;
      };
      ["name_cn"] = "?色??面罩";
      ["name_fr"] = "Les masques rouges en soie";
      ["faction"] = "Alliance";
      ["name"] = "Red Silk Bandanas";
      ["sort"] = "The Deadmines";
      ["prev"] = 155;
      ["prequests"] = {
         [1] = 155;
      };
      ["level"] = 17;
      ["name_es"] = "Panuelos rojos de seda";
      ["req"] = 14;
   };
   [215] = {
      ["name_ru"] = "Тайны джунглей";
      ["type"] = "Solo";
      ["objective"] = "Speak with Lieutenant Doren at the Rebel Camp.";
      ["next"] = 200;
      ["name_fr"] = "Les secrets de la jungle";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?林中的秘密";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Geheimnisse im Dschungel";
      ["faction"] = "Alliance";
      ["name"] = "Jungle Secrets";
      ["level"] = 33;
      ["name_es"] = "Los secretos de la jungla";
      ["req"] = 30;
   };
   [216] = {
      ["name_ru"] = "Между молотом и Колючим Мехом";
      ["type"] = "Solo";
      ["objective"] = "Take down 8 Thistlefur Avengers and 8 Thistlefur Shaman; most are located east of Zoram Strand in Thistlefur Village.  Once completed, return to Karang Amakkar at Zoram'gar Outpost, Ashenvale.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Entre un roc et un Crin-de-Chardon";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "?皮熊怪的麻?";
      ["name_de"] = "Hart auf hart";
      ["faction"] = "Horde";
      ["name"] = "Between a Rock and a Thistlefur";
      ["level"] = 24;
      ["name_es"] = "Entre una roca y un Piel de Cardo";
      ["req"] = 21;
   };
   [217] = {
      ["name_ru"] = "Защита королевских земель";
      ["type"] = "Solo";
      ["objective"] = "Kill the Trogg leader, Grawmug, and his two guards, Gnasher and Brawler then report back to Captain Rugelfuss in the southern guard tower.";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Ein Entscheidungsschlag";
      ["reward"] = {
         [1] = 1436;
         [2] = 6187;
         [3] = 1832;
      };
      ["name_cn"] = "保?国王的?土";
      ["name_fr"] = "A la defense des terres du roi";
      ["faction"] = "Alliance";
      ["name"] = "In Defense of the King's Lands";
      ["sort"] = "Loch Modan";
      ["prev"] = 263;
      ["prequests"] = {
         [1] = 263;
      };
      ["level"] = 17;
      ["name_es"] = "Un golpe decisivo";
      ["req"] = 10;
   };
   [218] = {
      ["name_ru"] = "Украденные записи";
      ["objective"] = "Grelin Whitebeard wants you to kill Grik'nir the Cold, and retrieve his journal.";
      ["name_cn"] = "被窃取的日?";
      ["sort"] = "Coldridge Valley";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "Le journal vole";
      ["next"] = 282;
      ["name_de"] = "Eis und Feuer";
      ["repgain"] = {
         [54] = 500;
         [47] = 350;
      };
      ["reward"] = {
         [1] = 6176;
         [2] = 5581;
      };
      ["name"] = "The Stolen Journal";
      ["prev"] = 182;
      ["prequests"] = {
         [1] = 182;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Hielo y fuego";
      ["req"] = 1;
   };
   [219] = {
      ["name_ru"] = "Пропавший без вести";
      ["type"] = "Solo";
      ["objective"] = "Protect Corporal Keeshan on the journey back to Redridge.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Redridge Mountains";
      ["name_fr"] = "Porte disparu";
      ["name_cn"] = "失踪人?";
      ["reward"] = {
         [1] = 3555;
         [2] = 1275;
         [3] = 3431;
      };
      ["name_de"] = "Vermisst";
      ["faction"] = "Alliance";
      ["name"] = "Missing In Action";
      ["level"] = 25;
      ["name_es"] = "Desaparecido en combate";
      ["req"] = 19;
   };
   [220] = {
      ["name_ru"] = "Зов воды";
      ["objective"] = "Bring the Vial of Purest Water to Islen Waterseer in the Barrens.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["level"] = 23;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["name_de"] = "Ruf des Wassers";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 6637;
      };
      ["name"] = "Call of Water";
      ["prev"] = 1534;
      ["prequests"] = {
         [1] = 1534;
      };
      ["series"] = 5;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [221] = {
      ["name_ru"] = "Воргены в лесу";
      ["objective"] = "Kill 12 Nightbane Dark Runner worgen for Calor in Darkshire.";
      ["name_cn"] = "森林里的狼人";
      ["sort"] = "Duskwood";
      ["level"] = 29;
      ["type"] = "Solo";
      ["name_fr"] = "Worgens dans les bois";
      ["next"] = 222;
      ["name_de"] = "Worgen in den Waldern";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Worgen in the Woods";
      ["prev"] = 173;
      ["prequests"] = {
         [1] = 173;
      };
      ["series"] = 2;
      ["name_es"] = "Huargen en el bosque";
      ["req"] = 23;
   };
   [222] = {
      ["name_ru"] = "Воргены в лесу";
      ["objective"] = "Kill 8 Nightbane Vile Fang and 8 Nightbane Tainted One worgen for Calor in Darkshire.";
      ["name_cn"] = "森林里的狼人";
      ["sort"] = "Duskwood";
      ["level"] = 31;
      ["type"] = "Solo";
      ["name_fr"] = "Worgens dans les bois";
      ["next"] = 223;
      ["name_de"] = "Worgen in den Waldern";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Worgen in the Woods";
      ["prev"] = 221;
      ["prequests"] = {
         [1] = 221;
      };
      ["series"] = 3;
      ["name_es"] = "Huargen en el bosque";
      ["req"] = 23;
   };
   [223] = {
      ["name_ru"] = "Воргены в лесу";
      ["objective"] = "Bring Calor's note to Jonathan Carevin.";
      ["name_cn"] = "森林里的狼人";
      ["sort"] = "Duskwood";
      ["level"] = 31;
      ["type"] = "Solo";
      ["name_fr"] = "Worgens dans les bois";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Worgen in den Waldern";
      ["reward"] = {
         [1] = 2902;
         [2] = 5244;
         [3] = 1547;
      };
      ["faction"] = "Alliance";
      ["name"] = "Worgen in the Woods";
      ["prev"] = 222;
      ["prequests"] = {
         [1] = 222;
      };
      ["series"] = 4;
      ["name_es"] = "Huargen en el bosque";
      ["req"] = 23;
   };
   [224] = {
      ["name_ru"] = "Защита королевских земель";
      ["type"] = "Solo";
      ["objective"] = "Mountaineer Cobbleflint of the southern guard tower wants you to kill 10 Stonesplinter Troggs and 10 Stonesplinter Scouts.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "A la defense des terres du roi";
      ["name_cn"] = "保?国王的?土";
      ["reward"] = {
         [1] = 414;
      };
      ["name_de"] = "Verteidigung der Lander des Konigs";
      ["faction"] = "Alliance";
      ["name"] = "In Defense of the King's Lands";
      ["level"] = 12;
      ["name_es"] = "En defensa de las tierras del rey";
      ["req"] = 10;
   };
   [225] = {
      ["name_ru"] = "Заброшенная могила";
      ["type"] = "Solo";
      ["objective"] = "Speak with Sirra Von'Indi in Darkshire.";
      ["next"] = 227;
      ["name_fr"] = "La tombe effritee";
      ["sort"] = "Duskwood";
      ["name_cn"] = "???霜的墓碑";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Das verwitterte Grab";
      ["faction"] = "Alliance";
      ["name"] = "The Weathered Grave";
      ["level"] = 35;
      ["name_es"] = "La lapida desgastada";
      ["req"] = 28;
   };
   [226] = {
      ["name_ru"] = "Волки идут по пятам";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Starving Dire Wolves and 8 Rabid Dire Wolves, then return to Lars at Sven's Camp on the western border of Duskwood.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Duskwood";
      ["name_fr"] = "Des loups aux trousses";
      ["name_cn"] = "?狼成群";
      ["reward"] = {
         [1] = 1127;
      };
      ["name_de"] = "Wolfe sind uns auf den Fersen";
      ["faction"] = "Alliance";
      ["name"] = "Wolves at Our Heels";
      ["level"] = 21;
      ["name_es"] = "Con los lobos en los talones";
      ["req"] = 19;
   };
   [227] = {
      ["name_ru"] = "Морган Ладимор";
      ["objective"] = "Speak with Commander Althea Ebonlocke in Darkshire.";
      ["name_cn"] = "摩根・拉迪莫?";
      ["sort"] = "Duskwood";
      ["level"] = 35;
      ["type"] = "Solo";
      ["name_fr"] = "Morgan Ladimore";
      ["next"] = 228;
      ["name_de"] = "Morgan Ladimore";
      ["repgain"] = {
         [72] = 25;
      };
      ["reward"] = {
         [1] = 2154;
      };
      ["name"] = "Morgan Ladimore";
      ["prev"] = 225;
      ["prequests"] = {
         [1] = 225;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Morgan Ladimor";
      ["req"] = 28;
   };
   [228] = {
      ["name_ru"] = "Мор'Ладим";
      ["type"] = "Group";
      ["name_fr"] = "Mor'Ladim";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Mor'Ladim";
      ["name"] = "Mor'Ladim";
      ["name_cn"] = "摩拉迪姆";
      ["objective"] = "Kill Mor'Ladim, then return his skull to Commander Althea Ebonlocke in Darkshire.";
      ["next"] = 229;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 227;
      ["prequests"] = {
         [1] = 227;
      };
      ["level"] = 35;
      ["name_es"] = "Mor'Ladim";
      ["req"] = 28;
   };
   [229] = {
      ["name_ru"] = "Выжившая дочь";
      ["type"] = "Solo";
      ["name_fr"] = "La fille qui survecut";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Die uberlebende Tochter";
      ["name"] = "The Daughter Who Lived";
      ["name_cn"] = "幸存的女儿";
      ["objective"] = "Speak with Watcher Sarah Ladimore in Darkshire.";
      ["next"] = 231;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 228;
      ["prequests"] = {
         [1] = 228;
      };
      ["level"] = 35;
      ["name_es"] = "La hija superviviente";
      ["req"] = 28;
   };
   [230] = {
      ["name_ru"] = "Лагерь Свена";
      ["type"] = "Solo";
      ["name_fr"] = "Le camp de Sven";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Svens Lager";
      ["name"] = "Sven's Camp";
      ["name_cn"] = "斯温的?地";
      ["objective"] = "Bring the Book from Sven's Farm to Sven.";
      ["next"] = 262;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 95;
      ["prequests"] = {
         [1] = 95;
      };
      ["level"] = 25;
      ["name_es"] = "El campamento de Sven";
      ["req"] = 20;
   };
   [231] = {
      ["name_ru"] = "Дочерняя любовь";
      ["type"] = "Solo";
      ["name_fr"] = "L'amour d'une fille";
      ["name_de"] = "Die Liebe einer Tochter";
      ["reward"] = {
         [1] = 2000;
      };
      ["name_cn"] = "女儿的?";
      ["objective"] = "Take Sarah Ladimore's ring to Morgan Ladimore's grave.";
      ["faction"] = "Alliance";
      ["name"] = "A Daughter's Love";
      ["sort"] = "Duskwood";
      ["prev"] = 229;
      ["prequests"] = {
         [1] = 229;
      };
      ["level"] = 35;
      ["name_es"] = "El amor de una hija";
      ["req"] = 28;
   };
   [232] = {
      ["name_ru"] = "Посылка для аптекаря Зинг";
      ["type"] = "Solo";
      ["name_fr"] = "Course pour l'apothicaire Zinge";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Kurierdienst fur Apothekerin Zinge";
      ["name_cn"] = "金格的?物";
      ["objective"] = "Take the purchase order to Alessandro Luca in the Undercity.";
      ["next"] = 238;
      ["sort"] = "Undercity";
      ["name"] = "Errand for Apothecary Zinge";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 45;
      ["name_es"] = "Un recado para la boticaria Zinge";
      ["req"] = 38;
   };
   [233] = {
      ["name_ru"] = "Почта Холодной долины";
      ["objective"] = "Deliver the stack of letters to Talin Keeneye.";
      ["name_cn"] = "寒脊山谷的送信任?";
      ["sort"] = "Coldridge Valley";
      ["level"] = 3;
      ["type"] = "Solo";
      ["name_fr"] = "La distribution du courrier de la Vallee des Frigeres";
      ["next"] = 234;
      ["name_de"] = "Postbeforderung im Eisklammtal";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Coldridge Valley Mail Delivery";
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["series"] = 1;
      ["name_es"] = "Entrega de correo en el Valle de Crestanevada";
      ["req"] = 1;
   };
   [234] = {
      ["name_ru"] = "Почта Холодной долины";
      ["type"] = "Solo";
      ["objective"] = "Deliver the letter to Grelin Whitebeard.";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_de"] = "Postbeforderung im Eisklammtal";
      ["name"] = "Coldridge Valley Mail Delivery";
      ["name_cn"] = "寒脊山谷的送信任?";
      ["name_fr"] = "La distribution du courrier de la Vallee des Frigeres";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Coldridge Valley";
      ["prev"] = 233;
      ["prequests"] = {
         [1] = 233;
      };
      ["level"] = 4;
      ["name_es"] = "Entrega de correo en el Valle de Crestanevada";
      ["req"] = 1;
   };
   [235] = {
      ["name_ru"] = "Большая охота";
      ["type"] = "Solo";
      ["objective"] = "Speak with Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "灰谷狩?";
      ["name_fr"] = "La Chasse d'Orneval";
      ["followup"] = 6383;
      ["name_de"] = "Die Jagd im Eschental";
      ["faction"] = "Horde";
      ["name"] = "The Ashenvale Hunt";
      ["level"] = 20;
      ["name_es"] = "La Caza de Vallefresno";
      ["req"] = 20;
   };
   [237] = {
      ["name_ru"] = "Защита королевских земель";
      ["type"] = "Solo";
      ["objective"] = "Mountaineer Gravelgaw in the southern guard tower wants you to kill 10 Stonesplinter Skullthumpers and 10 Stonesplinter Seers and report back to him.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Verteidigung der Lander des Konigs";
      ["reward"] = {
         [1] = 858;
      };
      ["name_cn"] = "保?国王的?土";
      ["name_fr"] = "A la defense des terres du roi";
      ["faction"] = "Alliance";
      ["name"] = "In Defense of the King's Lands";
      ["sort"] = "Loch Modan";
      ["prev"] = 224;
      ["prequests"] = {
         [1] = 224;
      };
      ["level"] = 15;
      ["name_es"] = "En defensa de las tierras del rey";
      ["req"] = 10;
   };
   [238] = {
      ["name_ru"] = "Посылка для аптекаря Зинг";
      ["objective"] = "Bring the Field Sampling Kit to Apothecary Zinge in the Undercity.";
      ["name_cn"] = "金格的?物";
      ["sort"] = "Undercity";
      ["level"] = 45;
      ["type"] = "Solo";
      ["name_fr"] = "Course pour l'apothicaire Zinge";
      ["next"] = 243;
      ["name_de"] = "Kurierdienst fur Apothekerin Zinge";
      ["repgain"] = {
         [68] = 10;
      };
      ["faction"] = "Horde";
      ["name"] = "Errand for Apothecary Zinge";
      ["prev"] = 232;
      ["prequests"] = {
         [1] = 232;
      };
      ["series"] = 2;
      ["name_es"] = "Un recado para la boticaria Zinge";
      ["req"] = 38;
   };
   [239] = {
      ["name_ru"] = "Гарнизон у Западного ручья просит помощи!";
      ["type"] = "Solo";
      ["name_fr"] = "Au secours de la garnison du ruisseau de l'ouest?!";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Hilfe fur die Weststromgarnison";
      ["name"] = "Westbrook Garrison Needs Help!";
      ["name_cn"] = "西泉要塞";
      ["objective"] = "Go to the Westbrook Garrison and speak with Deputy Rainer.";
      ["next"] = 11;
      ["faction"] = "Alliance";
      ["sort"] = "Elwynn Forest";
      ["prev"] = 76;
      ["prequests"] = {
         [1] = 76;
      };
      ["level"] = 10;
      ["name_es"] = "El Cuartel de Arroyoeste necesita ayuda";
      ["req"] = 6;
   };
   [240] = {
      ["name_ru"] = "Возвращение к Трясунчику";
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers la Tremblote";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Ruckkehr zu Bibbers";
      ["name_cn"] = "基特斯的美餐";
      ["name"] = "Return to Jitters";
      ["objective"] = "Return to Jitters with the Dusky Crab Cakes.";
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 93;
      ["prequests"] = {
         [1] = 93;
      };
      ["level"] = 20;
      ["name_es"] = "Regresa junto a Alterio";
      ["req"] = 17;
   };
   [243] = {
      ["name_ru"] = "Поход в пустыню";
      ["type"] = "Solo";
      ["name_fr"] = "Sur le terrain";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Auf ins Feld";
      ["name"] = "Into the Field";
      ["name_cn"] = "?入沙漠";
      ["objective"] = "Speak to Chief Engineer Bilgewhizzle in Gadgetzan about getting a power source for the testing kit.";
      ["next"] = 379;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 238;
      ["prequests"] = {
         [1] = 238;
      };
      ["level"] = 46;
      ["name_es"] = "In situ";
      ["req"] = 38;
   };
   [244] = {
      ["name_ru"] = "Вторжение гноллов";
      ["type"] = "Solo";
      ["objective"] = "Report to Deputy Feldon.";
      ["next"] = 246;
      ["name_fr"] = "Des gnolls encombrants";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "豺狼人的入侵";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Eindringende Gnolle";
      ["faction"] = "Alliance";
      ["name"] = "Encroaching Gnolls";
      ["level"] = 16;
      ["name_es"] = "Gnolls invasores";
      ["req"] = 11;
   };
   [245] = {
      ["name_ru"] = "Восьминогая угроза";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Pygmy Venom Web Spiders, and then report back to Watcher Dodds in Duskwood.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Duskwood";
      ["name_fr"] = "Les plaies a huit pattes";
      ["name_cn"] = "蜘蛛的威?";
      ["reward"] = {
         [1] = 3559;
      };
      ["name_de"] = "[DEPRECATED] Gefahr auf acht Beinen";
      ["faction"] = "Alliance";
      ["name"] = "Eight-Legged Menaces";
      ["level"] = 21;
      ["name_es"] = "Las amenazas de ocho patas";
      ["req"] = 17;
   };
   [246] = {
      ["name_ru"] = "Подсчет врагов";
      ["type"] = "Solo";
      ["name_fr"] = "L'appreciation du danger";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Einschatzung der Gefahr";
      ["name_cn"] = "??度?";
      ["name"] = "Assessing the Threat";
      ["objective"] = "Kill 10 Redridge Mongrels and 6 Redridge Poachers, then report back to Deputy Feldon in Lakeshire.";
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 244;
      ["prequests"] = {
         [1] = 244;
      };
      ["level"] = 17;
      ["name_es"] = "Evaluar la amenaza";
      ["req"] = 11;
   };
   [247] = {
      ["name_ru"] = "Завершение охоты";
      ["type"] = "Solo";
      ["name_fr"] = "La chasse achevee";
      ["repgain"] = {
         [81] = 350;
      };
      ["sort"] = "Ashenvale";
      ["name_cn"] = "完成狩?";
      ["objective"] = "";
      ["name"] = "The Hunt Completed";
      ["reward"] = {
         [1] = 16658;
      };
      ["name_de"] = "Die Jagd ist abgeschlossen";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2;
         [2] = 23;
         [3] = 24;
      };
      ["level"] = 30;
      ["name_es"] = "El fin de la Caza";
      ["req"] = 20;
   };
   [248] = {
      ["name_ru"] = "Пронизывающий взор";
      ["type"] = "Group";
      ["name_fr"] = "En regardant plus loin";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Weitere Beobachtungen";
      ["name_cn"] = "??";
      ["name"] = "Looking Further";
      ["objective"] = "Climb the intact watch tower beside Stonewatch Keep.$B$BFind a suitable container to place the Glyph of Azora.";
      ["faction"] = "Alliance";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 94;
      ["prequests"] = {
         [1] = 94;
      };
      ["level"] = 22;
      ["name_es"] = "Ver mas alla";
      ["req"] = 20;
   };
   [249] = {
      ["name_ru"] = "Моргант";
      ["type"] = "Group";
      ["objective"] = "Defeat Morganth.$B$BBring his Pendant of Shadow to Theocritus at the Tower of Azora in Elwynn Forest.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Morganth";
      ["reward"] = {
         [1] = 5274;
      };
      ["name_cn"] = "莫甘斯";
      ["name_fr"] = "Morganth";
      ["faction"] = "Alliance";
      ["name"] = "Morganth";
      ["sort"] = "Redridge Mountains";
      ["prev"] = 248;
      ["prequests"] = {
         [1] = 248;
      };
      ["level"] = 27;
      ["name_es"] = "Morganth";
      ["req"] = 20;
   };
   [250] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Eine dunkle Bedrohung";
      ["name_cn"] = "水?危机";
      ["objective"] = "Investigate the area near the eastern ramp of the Dam and bring Chief Engineer Hinderweir a clue that might reveal what the Dark Iron Dwarves are up to.";
      ["next"] = 199;
      ["sort"] = "Loch Modan";
      ["name"] = "A Dark Threat Looms";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 18;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [251] = {
      ["name_ru"] = "Перевод записки Аберкромби";
      ["type"] = "Solo";
      ["name_fr"] = "La traduction de la lettre d'Abercrombie";
      ["name_de"] = "Ubersetzung von Calvinius' Notiz";
      ["name_cn"] = "翻??伯克隆比的信";
      ["objective"] = "Bring the Letter to Ello to Sirra Von'Indi.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Translate Abercrombie's Note";
      ["prev"] = 160;
      ["prequests"] = {
         [1] = 160;
      };
      ["level"] = 30;
      ["name_es"] = "Traduce la nota de Abercrombie";
      ["req"] = 20;
   };
   [252] = {
      ["name_ru"] = "Перевод для Элло";
      ["type"] = "Solo";
      ["name_fr"] = "La traduction pour Ello";
      ["name_de"] = "Ubersetzung fur Ello";
      ["reward"] = {
         [1] = 3248;
      };
      ["name_cn"] = "翻?好的信件";
      ["objective"] = "Bring the Translated Letter to Lord Ello Ebonlocke";
      ["faction"] = "Alliance";
      ["name"] = "Translation to Ello";
      ["sort"] = "Duskwood";
      ["prev"] = 401;
      ["prequests"] = {
         [1] = 401;
      };
      ["level"] = 30;
      ["name_es"] = "Una traduccion para Ello";
      ["req"] = 20;
   };
   [253] = {
      ["name_ru"] = "Невеста Бальзамировщика";
      ["type"] = "Group";
      ["objective"] = "Find Eliza's grave.  Retrieve the Embalmer's Heart from her, then return to Ello Ebonlocke.";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 500;
      };
      ["name_de"] = "Braut des Einbalsamierers";
      ["reward"] = {
         [1] = 3560;
         [2] = 6223;
      };
      ["name_cn"] = "藏尸者的妻子";
      ["name_fr"] = "La fiancee de l'Embaumeur";
      ["faction"] = "Alliance";
      ["name"] = "Bride of the Embalmer";
      ["sort"] = "Duskwood";
      ["prev"] = 252;
      ["prequests"] = {
         [1] = 252;
      };
      ["level"] = 30;
      ["name_es"] = "La novia del embalsamador";
      ["req"] = 20;
   };
   [254] = {
      ["name_ru"] = "Копание земли";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Duskwood";
      ["name_cn"] = "掘墓";
      ["name_fr"] = "En creusant la terre";
      ["name_de"] = "Graben in der Erde";
      ["faction"] = "Alliance";
      ["name"] = "Digging Through the Dirt";
      ["level"] = 35;
      ["name_es"] = "Excavar la tierra";
      ["req"] = 20;
   };
   [255] = {
      ["name_ru"] = "Наемники";
      ["type"] = "Group";
      ["objective"] = "Magistrate Bluntnose of Thelsamar has hired you to kill 4 Mo'grosh Ogres, 4 Mo'grosh Brutes and 4 Mo'grosh Enforcers.";
      ["repgain"] = {
         [54] = 75;
         [47] = 350;
      };
      ["name_fr"] = "Mercenaires";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "雇?兵";
      ["name_de"] = "Soldner";
      ["faction"] = "Alliance";
      ["name"] = "Mercenaries";
      ["level"] = 19;
      ["name_es"] = "Mercenarios";
      ["req"] = 15;
   };
   [256] = {
      ["name_ru"] = "Разыскивается: Чок'сул";
      ["type"] = "Group";
      ["objective"] = "Kill Chok'sul and bring his head to Magistrate Bluntnose of Thelsamar.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "ON RECHERCHE?: Chok'sul";
      ["name_cn"] = "通?令：卓克??";
      ["reward"] = {
         [1] = 6189;
         [2] = 1449;
         [3] = 6191;
      };
      ["name_de"] = "GESUCHT: Chok'sul";
      ["faction"] = "Alliance";
      ["name"] = "WANTED: Chok'sul";
      ["level"] = 22;
      ["name_es"] = "SE BUSCA: Chok'sul";
      ["req"] = 17;
   };
   [257] = {
      ["name_ru"] = "Похвальба охотника";
      ["type"] = "Solo";
      ["objective"] = "Kill 6 Mountain Buzzards and return to Daryl the Youngling in the Farstrider Lodge within 15 minutes.";
      ["next"] = 258;
      ["name_fr"] = "La fanfaronnade d'un chasseur";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "自豪的?人";
      ["reward"] = {
         [1] = 2903;
         [2] = 2904;
      };
      ["name_de"] = "Das Prahlen eines Jagers";
      ["faction"] = "Alliance";
      ["name"] = "A Hunter's Boast";
      ["level"] = 16;
      ["name_es"] = "La fanfarronada de un cazador";
      ["req"] = 11;
   };
   [258] = {
      ["name_ru"] = "Вызов охотнику";
      ["type"] = "Solo";
      ["name_fr"] = "Le defi d'un chasseur";
      ["name_de"] = "Die Herausforderung eines Jagers";
      ["reward"] = {
         [1] = 859;
         [2] = 3572;
      };
      ["name_cn"] = "?人的挑?";
      ["objective"] = "Kill 5 Elder Mountain Boars and return to Daryl the Youngling in the Farstrider Lodge within 12 minutes.";
      ["faction"] = "Alliance";
      ["name"] = "A Hunter's Challenge";
      ["sort"] = "Loch Modan";
      ["prev"] = 257;
      ["prequests"] = {
         [1] = 257;
      };
      ["level"] = 17;
      ["name_es"] = "El reto de un cazador";
      ["req"] = 11;
   };
   [261] = {
      ["name_ru"] = "Путями Алого ордена";
      ["type"] = "Solo";
      ["objective"] = "Destroy 30 Undead Ravagers, then return to Brother Anton at Nijel's Point.";
      ["next"] = 1052;
      ["name_fr"] = "Sur le chemin ecarlate";
      ["sort"] = "Desolace";
      ["name_cn"] = "血色之路";
      ["series"] = 1;
      ["name_de"] = "Auf dem Scharlachroten Pfad";
      ["faction"] = "Alliance";
      ["name"] = "Down the Scarlet Path";
      ["level"] = 39;
      ["name_es"] = "El sendero Escarlata";
      ["req"] = 34;
   };
   [262] = {
      ["name_ru"] = "Таинственный незнакомец";
      ["type"] = "Solo";
      ["name_fr"] = "L'obscure silhouette";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Die Schattengestalt";
      ["name"] = "The Shadowy Figure";
      ["name_cn"] = "模糊的人影";
      ["objective"] = "Take the book you found at Sven's farm and show it to townsfolk in Darkshire.";
      ["next"] = 265;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 230;
      ["prequests"] = {
         [1] = 230;
      };
      ["level"] = 25;
      ["name_es"] = "La figura en las sombras";
      ["req"] = 20;
   };
   [263] = {
      ["name_ru"] = "Защита королевских земель";
      ["type"] = "Solo";
      ["objective"] = "Mountaineer Wallbang in the southern guard tower wants you to kill 10 Stonesplinter Shaman and 10 Stonesplinter Bonesnappers.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Verteidigung der Lander des Konigs";
      ["reward"] = {
         [1] = 2863;
      };
      ["name_cn"] = "保?国王的?土";
      ["name_fr"] = "A la defense des terres du roi";
      ["faction"] = "Alliance";
      ["name"] = "In Defense of the King's Lands";
      ["sort"] = "Loch Modan";
      ["prev"] = 237;
      ["prequests"] = {
         [1] = 237;
      };
      ["level"] = 15;
      ["name_es"] = "En defensa de las tierras del rey";
      ["req"] = 10;
   };
   [264] = {
      ["name_ru"] = "Покуда смерть не разлучит нас";
      ["type"] = "Solo";
      ["objective"] = " what about his children?! What about ME?! Night after night I sat patiently waiting for him... always second to his blasted duty!$B$BWell";
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "至死方休";
      ["name_fr"] = "Jusqu'a ce que la mort nous separe";
      ["name_de"] = "Bis dass der Tod uns scheidet";
      ["faction"] = "Horde";
      ["name"] = "Until Death Do Us Part";
      ["level"] = 15;
      ["name_es"] = "Hasta que la muerte nos separe";
      ["req"] = 12;
   };
   [265] = {
      ["name_ru"] = "Продолжение поисков незнакомца";
      ["type"] = "Solo";
      ["name_fr"] = "L'obscure recherche se poursuit";
      ["next"] = 266;
      ["name_de"] = "Die Schattensuche geht weiter";
      ["name_cn"] = "??搜?";
      ["objective"] = "See if other townsfolk have clues about the shadowy figure.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "The Shadowy Search Continues";
      ["prev"] = 262;
      ["prequests"] = {
         [1] = 262;
      };
      ["level"] = 25;
      ["name_es"] = "La busqueda de la figura continua";
      ["req"] = 20;
   };
   [266] = {
      ["name_ru"] = "Расспросы в таверне";
      ["type"] = "Solo";
      ["name_fr"] = "Une enquete a l'auberge";
      ["next"] = 453;
      ["name_de"] = "Nachforschungen im Gasthaus";
      ["name_cn"] = "??旅店";
      ["objective"] = "Search the inn for clues about the shadowy figure.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Inquire at the Inn";
      ["prev"] = 265;
      ["prequests"] = {
         [1] = 265;
      };
      ["level"] = 25;
      ["name_es"] = "Busqueda en la posada";
      ["req"] = 20;
   };
   [267] = {
      ["name_ru"] = "Троггская угроза";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Trogg Stone Teeth to Captain Rugelfuss in the southern guard tower.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "La menace trogg";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "穴居人的威?";
      ["name_de"] = "Die Bedrohung durch die Troggs";
      ["faction"] = "Alliance";
      ["name"] = "The Trogg Threat";
      ["level"] = 12;
      ["name_es"] = "La amenaza trogg";
      ["req"] = 10;
   };
   [268] = {
      ["name_ru"] = "Возвращение к Свену";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Sven";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Ruckkehr zu Sven";
      ["name"] = "Return to Sven";
      ["name_cn"] = "回?斯温";
      ["objective"] = "Return to Sven with Jitters' completed journal.";
      ["next"] = 323;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 453;
      ["prequests"] = {
         [1] = 453;
      };
      ["level"] = 25;
      ["name_es"] = "Entrega para Sven";
      ["req"] = 20;
   };
   [269] = {
      ["name_ru"] = "В поисках мудрости";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de la sagesse";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Auf der Suche nach Weisheit";
      ["name"] = "Seeking Wisdom";
      ["name_cn"] = "?求指引";
      ["objective"] = "Give Jitters' Completed Journal to Bishop Farthing in Stormwind.";
      ["next"] = 270;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 323;
      ["prequests"] = {
         [1] = 323;
      };
      ["level"] = 29;
      ["name_es"] = "En busca de sabiduria";
      ["req"] = 20;
   };
   [270] = {
      ["name_ru"] = "Обреченный флот";
      ["type"] = "Solo";
      ["name_fr"] = "La Flotte perdue";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Die Verlorene Flotte";
      ["name"] = "The Doomed Fleet";
      ["name_cn"] = "被?咒的??";
      ["objective"] = "Go to Menethil Harbor in the Wetlands, and speak with Glorin Steelbrow.";
      ["next"] = 321;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 269;
      ["prequests"] = {
         [1] = 269;
      };
      ["level"] = 29;
      ["name_es"] = "La flota maldita";
      ["req"] = 20;
   };
   [271] = {
      ["name_ru"] = "Месть Вайрины";
      ["type"] = "Group";
      ["name_fr"] = "La vengeance de Vyrin";
      ["next"] = 531;
      ["name_de"] = "Vyrins Rache";
      ["name"] = "Vyrin's Revenge";
      ["name_cn"] = "?林的??";
      ["objective"] = "Kill Ol' Sooty then show your handiwork to Daryl the Youngling at the Farstrider Lodge.";
      ["series"] = 1;
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 258;
      ["prequests"] = {
         [1] = 258;
      };
      ["level"] = 20;
      ["name_es"] = "La venganza de Vyrin";
      ["req"] = 15;
   };
   [272] = {
      ["name_ru"] = "Испытание Морского Льва";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve du lion de mer";
      ["next"] = 5061;
      ["name_de"] = "Prufung des Seelowen";
      ["objective"] = "Find the Half Pendant of Aquatic Agility and the Half Pendant of Aquatic Endurance.  Speak with the residents of Moonglade to learn clues as to where these items may be located.$B$BForm the Pendant of the Sea Lion from the two pendant halves.  You need to be in proximity of the Shrine of Remulos to do this.$B$BBring the joined pendant to Dendrite Starblaze in the village of Nighthaven, Moonglade.";
      ["name_cn"] = "海???";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Trial of the Sea Lion";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 29;
      ["prequests"] = {
         [1] = 29;
      };
      ["level"] = 16;
      ["name_es"] = "La prueba del leon marino";
      ["req"] = 16;
   };
   [273] = {
      ["name_ru"] = "Снабжение экспедиции";
      ["type"] = "Solo";
      ["name_fr"] = "Approvisionnement du site de fouilles";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Nachschub fur die Ausgrabungsstatte";
      ["name"] = "Resupplying the Excavation";
      ["name_cn"] = "?掘?的??品";
      ["objective"] = "Speak with Huldar.";
      ["next"] = 454;
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 302;
      ["prequests"] = {
         [1] = 302;
      };
      ["level"] = 15;
      ["name_es"] = "Aprovisionar la excavacion";
      ["req"] = 10;
   };
   [274] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "Ashlan Stonesmirk wants you to return to Chief Engineer Hinderweir and inform him of the new discovery.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["next"] = 278;
      ["name_de"] = "Eine dunkle Bedrohung";
      ["repgain"] = {
         [47] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 161;
      ["prequests"] = {
         [1] = 161;
      };
      ["series"] = 4;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [275] = {
      ["name_ru"] = "Нарывы на теле земли";
      ["type"] = "Solo";
      ["name_fr"] = "Fievre sur le pays";
      ["name_de"] = "Schwarendes Land";
      ["reward"] = {
         [1] = 3558;
         [2] = 1273;
         [3] = 2263;
      };
      ["name_cn"] = "大地上的?疱";
      ["objective"] = "Kill 8 Fen Creepers, then return to Rethiel the Greenwarden in the Wetlands.";
      ["faction"] = "Alliance";
      ["name"] = "Blisters on The Land";
      ["sort"] = "Wetlands";
      ["prev"] = 277;
      ["prequests"] = {
         [1] = 277;
      };
      ["level"] = 26;
      ["name_es"] = "Ampollas en la tierra";
      ["req"] = 20;
   };
   [276] = {
      ["name_ru"] = "Вытоптанные луга";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Mosshide Gnolls and 10 Mosshide Mongrels, then return to Rethiel the Greenwarden in the Wetlands.";
      ["next"] = 277;
      ["sort"] = "Wetlands";
      ["name_cn"] = "践踏之爪";
      ["name_fr"] = "Pietinements de pattes";
      ["name_de"] = "Stapfende Pfoten";
      ["faction"] = "Alliance";
      ["name"] = "Tramping Paws";
      ["level"] = 21;
      ["name_es"] = "Patas sucias";
      ["req"] = 20;
   };
   [277] = {
      ["name_ru"] = "Запрет на огонь";
      ["type"] = "Solo";
      ["name_fr"] = "Feu interdit";
      ["next"] = 275;
      ["name_de"] = "Feuer-Tabu";
      ["reward"] = {
         [1] = 4606;
      };
      ["name_cn"] = "火?管制";
      ["objective"] = "Bring Rethiel the Greenwarden 9 Crude Flints.";
      ["faction"] = "Alliance";
      ["name"] = "Fire Taboo";
      ["sort"] = "Wetlands";
      ["prev"] = 276;
      ["prequests"] = {
         [1] = 276;
      };
      ["level"] = 23;
      ["name_es"] = "No al fuego";
      ["req"] = 20;
   };
   [278] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "Chief Engineer Hinderweir wants you to gather Lurker Venom, a Mo'grosh Crystal, and a Crocolisk Tear.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 18;
      ["type"] = "Group";
      ["name_fr"] = "Une sombre menace se dessine";
      ["next"] = 280;
      ["name_de"] = "Eine dunkle Bedrohung";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 274;
      ["prequests"] = {
         [1] = 274;
      };
      ["series"] = 5;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [279] = {
      ["name_ru"] = "Угроза из глубин";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Bluegill Murlocs.$B$BSlay Gobbler and take his head.$B$BBring Gobbler's Head to Karl Boran in Menethil Harbor.";
      ["next"] = 281;
      ["name_fr"] = "Griffes des profondeurs";
      ["sort"] = "Wetlands";
      ["name_cn"] = "海中的?人";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Klauen aus der Tiefe";
      ["faction"] = "Alliance";
      ["name"] = "Claws from the Deep";
      ["level"] = 22;
      ["name_es"] = "Zarpas de las profundidades";
      ["req"] = 20;
   };
   [280] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "Chief Engineer Hinderweir wants you to swim down to the base of the dam, locate the powder keg and stir in the Disarming Mixture to prevent an explosion.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["next"] = 283;
      ["name_de"] = "Eine dunkle Bedrohung";
      ["repgain"] = {
         [47] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 278;
      ["prequests"] = {
         [1] = 278;
      };
      ["series"] = 6;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [281] = {
      ["name_ru"] = "Украденные товары";
      ["objective"] = "Search the crates and barrels at the coastal Murloc camps.";
      ["name_cn"] = "?回雕像";
      ["sort"] = "Wetlands";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "Recuperation de marchandises";
      ["next"] = 284;
      ["name_de"] = "Waren-Wiederbeschaffung";
      ["repgain"] = {
         [54] = 10;
         [469] = 10;
         [72] = 25;
      };
      ["reward"] = {
         [1] = 929;
      };
      ["name"] = "Reclaiming Goods";
      ["prev"] = 279;
      ["prequests"] = {
         [1] = 279;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Recuperacion de bienes";
      ["req"] = 20;
   };
   [282] = {
      ["name_ru"] = "Наблюдения Сенира";
      ["objective"] = "Speak with Mountaineer Thalos.";
      ["name_cn"] = "森内?的?察站";
      ["sort"] = "Coldridge Valley";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "Les observations de Senir";
      ["next"] = 420;
      ["name_de"] = "Senirs Beobachtungen";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Senir's Observations";
      ["prev"] = 218;
      ["prequests"] = {
         [1] = 218;
      };
      ["series"] = 1;
      ["name_es"] = "Las observaciones de Senir";
      ["req"] = 1;
   };
   [283] = {
      ["name_ru"] = "Прямая и черная угроза";
      ["objective"] = "The Disarming Mixture seemed to take effect.  Return to Chief Engineer Hinderweir to report the good news.";
      ["name_cn"] = "水?危机";
      ["sort"] = "Loch Modan";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Une sombre menace se dessine";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Eine dunkle Bedrohung";
      ["reward"] = {
         [1] = 2907;
         [2] = 2908;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Dark Threat Looms";
      ["prev"] = 280;
      ["prequests"] = {
         [1] = 280;
      };
      ["series"] = 7;
      ["name_es"] = "Se aproxima una oscura amenaza";
      ["req"] = 16;
   };
   [284] = {
      ["name_ru"] = "Поиски продолжаются";
      ["objective"] = "Search for the Menethil Statuette.";
      ["name_cn"] = "??搜?";
      ["sort"] = "Wetlands";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "La recherche continue";
      ["next"] = 285;
      ["name_de"] = "Die Suche geht weiter";
      ["repgain"] = {
         [72] = 25;
      };
      ["reward"] = {
         [1] = 422;
      };
      ["name"] = "The Search Continues";
      ["prev"] = 281;
      ["prequests"] = {
         [1] = 281;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La busqueda continua";
      ["req"] = 20;
   };
   [285] = {
      ["name_ru"] = "Поиски в поселениях мурлоков";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche d'autres taudis";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Suche in weiteren Hutten";
      ["name"] = "Search More Hovels";
      ["name_cn"] = "搜?雕像";
      ["objective"] = "Continue searching the Murloc hovels for the Menethil Statuette.";
      ["next"] = 286;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 284;
      ["prequests"] = {
         [1] = 284;
      };
      ["level"] = 25;
      ["name_es"] = "Inspecciona mas casuchas";
      ["req"] = 20;
   };
   [286] = {
      ["name_ru"] = "Возвращение статуэтки";
      ["type"] = "Solo";
      ["objective"] = "Bring Karl Boran the Menethil Statuette.";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Ruckgabe der Statuette";
      ["reward"] = {
         [1] = 2950;
         [2] = 2949;
      };
      ["name_cn"] = "??雕像";
      ["name_fr"] = "Rapporter la statuette";
      ["faction"] = "Alliance";
      ["name"] = "Return the Statuette";
      ["sort"] = "Wetlands";
      ["prev"] = 285;
      ["prequests"] = {
         [1] = 285;
      };
      ["level"] = 25;
      ["name_es"] = "Devuelve la Estatuilla";
      ["req"] = 20;
   };
   [287] = {
      ["name_ru"] = "Форт Мерзлогривов";
      ["objective"] = "Explore Frostmane Hold, and kill 5 Frostmane Headhunters for Senir Whitebeard in Kharanos.";
      ["name_cn"] = "霜?巨魔要塞";
      ["sort"] = "Dun Morogh";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "Le repaire des Crins-de-givre";
      ["next"] = 291;
      ["name_de"] = "Hohle der Frostmahnen";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["reward"] = {
         [1] = 3216;
         [2] = 2900;
      };
      ["name"] = "Frostmane Hold";
      ["prev"] = 420;
      ["prequests"] = {
         [1] = 420;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Poblado Peloescarcha";
      ["req"] = 7;
   };
   [288] = {
      ["name_ru"] = "Третья флотилия";
      ["type"] = "Solo";
      ["objective"] = "Buy First Mate Fitzsimmons a Flagon of Mead.";
      ["next"] = 289;
      ["sort"] = "Wetlands";
      ["name_cn"] = "第三??";
      ["name_fr"] = "La IIIe flotte";
      ["name_de"] = "Die Dritte Flotte";
      ["faction"] = "Alliance";
      ["name"] = "The Third Fleet";
      ["level"] = 27;
      ["name_es"] = "La Tercera Flota";
      ["req"] = 22;
   };
   [289] = {
      ["name_ru"] = "Проклятая команда";
      ["type"] = "Solo";
      ["name_fr"] = "L'equipage maudit";
      ["repgain"] = {
         [54] = 75;
         [72] = 150;
      };
      ["name_de"] = "Die verfluchte Crew";
      ["name"] = "The Cursed Crew";
      ["name_cn"] = "被?咒的船?";
      ["objective"] = "Kill 13 Cursed Sailors, 5 Cursed Marines and First Mate Snellig.  Bring Snellig's Snuffbox to First Mate Fitzsimmons in Menethil Harbor.";
      ["next"] = 290;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 288;
      ["prequests"] = {
         [1] = 288;
      };
      ["level"] = 29;
      ["name_es"] = "La tripulacion maldita";
      ["req"] = 22;
   };
   [290] = {
      ["name_ru"] = "Очищение";
      ["type"] = "Solo";
      ["name_fr"] = "Levee de la malediction";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Brechen des Fluchs";
      ["name"] = "Lifting the Curse";
      ["name_cn"] = "解除?咒";
      ["objective"] = "Get the Intrepid Strongbox Key from Captain Halyndor.$B$BUse the key to open the Intrepid's Locked Strongbox.";
      ["next"] = 292;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 289;
      ["prequests"] = {
         [1] = 289;
      };
      ["level"] = 30;
      ["name_es"] = "Purga de la maldicion";
      ["req"] = 22;
   };
   [291] = {
      ["name_ru"] = "Донесения";
      ["type"] = "Solo";
      ["name_fr"] = "Les rapports";
      ["repgain"] = {
         [54] = 75;
         [47] = 75;
      };
      ["name_de"] = "Die Berichte";
      ["name_cn"] = "森内?的?告";
      ["name"] = "The Reports";
      ["objective"] = "Deliver Senir's report to Senator Barin Redstone in Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 287;
      ["prequests"] = {
         [1] = 287;
      };
      ["level"] = 10;
      ["name_es"] = "Los informes";
      ["req"] = 1;
   };
   [292] = {
      ["name_ru"] = "Око Палета";
      ["type"] = "Solo";
      ["name_fr"] = "L'?il de Paleth";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Das Auge von Paleth";
      ["name"] = "The Eye of Paleth";
      ["name_cn"] = "?雷斯之眼";
      ["objective"] = "Bring the Cursed Eye of Paleth to Glorin Steelbrow.";
      ["next"] = 293;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 290;
      ["prequests"] = {
         [1] = 290;
      };
      ["level"] = 30;
      ["name_es"] = "El ojo de Paleth";
      ["req"] = 22;
   };
   [293] = {
      ["name_ru"] = "Проклятое Око";
      ["type"] = "Solo";
      ["objective"] = "Bring Archbishop Benedictus the Cursed Eye of Paleth.  Benedictus is in the Cathedral of Light, in the city of Stormwind.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Reinigung des Auges";
      ["reward"] = {
         [1] = 2943;
      };
      ["name_cn"] = "?化?雷斯之眼";
      ["name_fr"] = "Purifier l'?il";
      ["faction"] = "Alliance";
      ["name"] = "Cleansing the Eye";
      ["sort"] = "Wetlands";
      ["prev"] = 292;
      ["prequests"] = {
         [1] = 292;
      };
      ["level"] = 30;
      ["name_es"] = "Limpieza del ojo";
      ["req"] = 22;
   };
   [294] = {
      ["name_ru"] = "Месть Ормера";
      ["type"] = "Solo";
      ["name_fr"] = "La vengeance d'Ormer";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Ormers Rache";
      ["name_cn"] = "奥莫?的?仇";
      ["objective"] = "Ormer Ironbraid at the Whelgar Excavation Site wants you to kill 10 Mottled Screechers and 10 Mottled Raptors.";
      ["next"] = 295;
      ["sort"] = "Wetlands";
      ["name"] = "Ormer's Revenge";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 24;
      ["name_es"] = "La venganza de Ormer";
      ["req"] = 22;
   };
   [295] = {
      ["name_ru"] = "Месть Ормера";
      ["objective"] = "Ormer Ironbraid wants you to kill 10 Mottled Scytheclaw raptors and 10 Mottled Razormaw raptors then return to him at the Whelgar Excavation Site.";
      ["name_cn"] = "奥莫?的?仇";
      ["sort"] = "Wetlands";
      ["level"] = 27;
      ["type"] = "Solo";
      ["name_fr"] = "La vengeance d'Ormer";
      ["next"] = 296;
      ["name_de"] = "Ormers Rache";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Ormer's Revenge";
      ["prev"] = 294;
      ["prequests"] = {
         [1] = 294;
      };
      ["series"] = 2;
      ["name_es"] = "La venganza de Ormer";
      ["req"] = 22;
   };
   [296] = {
      ["name_ru"] = "Месть Ормера";
      ["objective"] = "Ormer Ironbraid at the Whelgar Excavation Site wants you to kill Sarltooth and return to him with one of his talons once the task is fulfilled.";
      ["name_cn"] = "奥莫?的?仇";
      ["sort"] = "Wetlands";
      ["level"] = 29;
      ["type"] = "Solo";
      ["name_fr"] = "La vengeance d'Ormer";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Ormers Rache";
      ["reward"] = {
         [1] = 3493;
         [2] = 3682;
         [3] = 3566;
         [4] = 5246;
      };
      ["faction"] = "Alliance";
      ["name"] = "Ormer's Revenge";
      ["prev"] = 295;
      ["prequests"] = {
         [1] = 295;
      };
      ["series"] = 3;
      ["name_es"] = "La venganza de Ormer";
      ["req"] = 22;
   };
   [297] = {
      ["name_ru"] = "Сбор идолов";
      ["type"] = "Solo";
      ["objective"] = "Bring Magmar Fellhew 8 Carved Stone Idols.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Reunir les idoles";
      ["name_cn"] = "收集石像";
      ["reward"] = {
         [1] = 5241;
         [2] = 6186;
         [3] = 3154;
      };
      ["name_de"] = "Gotzen sammeln";
      ["faction"] = "Alliance";
      ["name"] = "Gathering Idols";
      ["level"] = 18;
      ["name_es"] = "Recoger idolos";
      ["req"] = 13;
   };
   [298] = {
      ["name_ru"] = "Отчет о ходе раскопок";
      ["type"] = "Solo";
      ["objective"] = "Bring Ironband's Progress Report to Jern Hornhelm in Thelsamar.";
      ["next"] = 301;
      ["name_fr"] = "Compte rendu d'avancement des fouilles";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "?掘?度?告";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Bericht uber den Fortschritt der Ausgrabungen";
      ["faction"] = "Alliance";
      ["name"] = "Excavation Progress Report";
      ["level"] = 15;
      ["name_es"] = "Un informe sobre el avance de la excavacion";
      ["req"] = 10;
   };
   [299] = {
      ["name_ru"] = "Тайны прошлого";
      ["type"] = "Solo";
      ["objective"] = " Modr";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Wetlands";
      ["name_fr"] = "Decouverte du passe";
      ["name_cn"] = "???史";
      ["reward"] = {
         [1] = 2913;
      };
      ["name_de"] = "Enthullung der Vergangenheit";
      ["faction"] = "Alliance";
      ["name"] = "Uncovering the Past";
      ["level"] = 28;
      ["name_es"] = "Desvelando el pasado";
      ["req"] = 25;
   };
   [301] = {
      ["name_ru"] = "Отчет в Стальгорн";
      ["type"] = "Solo";
      ["name_fr"] = "Rapport a Forgefer";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Meldung in Eisenschmiede";
      ["name"] = "Report to Ironforge";
      ["name_cn"] = "向?炉堡?告";
      ["objective"] = "Take Ironband's Progress Report to Prospector Stormpike.";
      ["next"] = 302;
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 298;
      ["prequests"] = {
         [1] = 298;
      };
      ["level"] = 15;
      ["name_es"] = "Informe a Forjaz";
      ["req"] = 10;
   };
   [302] = {
      ["name_ru"] = "Порох для Сталекрута";
      ["type"] = "Solo";
      ["name_fr"] = "De l'explosif pour Baguefer";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Pulver fur Eisenband";
      ["name"] = "Powder to Ironband";
      ["name_cn"] = "??的火?";
      ["objective"] = "Speak with Jern Hornhelm in Thelsamar.";
      ["next"] = 273;
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 301;
      ["prequests"] = {
         [1] = 301;
      };
      ["level"] = 15;
      ["name_es"] = "Polvora para Vetaferro";
      ["req"] = 10;
   };
   [303] = {
      ["name_ru"] = "Война с Черным Железом";
      ["type"] = "Group";
      ["objective"] = "Motley Garmason at Dun Modr wants you to kill 10 Dark Iron Dwarves,  5 Dark Iron Tunnelers, 5 Dark Iron Saboteurs and 5 Dark Iron Demolitionists.";
      ["repgain"] = {
         [54] = 75;
         [47] = 250;
      };
      ["name_fr"] = "La guerre contre les Sombrefer";
      ["sort"] = "Wetlands";
      ["name_cn"] = "黑??争";
      ["name_de"] = "Der Dunkeleisenkrieg";
      ["faction"] = "Alliance";
      ["name"] = "The Dark Iron War";
      ["level"] = 30;
      ["name_es"] = "La guerra contra los Hierro Negro";
      ["req"] = 25;
   };
   [304] = {
      ["name_ru"] = "Мрачное поручение";
      ["type"] = "Group";
      ["objective"] = "Kill Balgaras the Foul and bring his ear to Longbraid the Grim outside of Dun Modr.";
      ["repgain"] = {
         [47] = 350;
      };
      ["sort"] = "Wetlands";
      ["name_fr"] = "Une tache sinistre";
      ["name_cn"] = "?巨的任?";
      ["reward"] = {
         [1] = 2916;
         [2] = 2917;
      };
      ["name_de"] = "Eine grausige Aufgabe";
      ["faction"] = "Alliance";
      ["name"] = "A Grim Task";
      ["level"] = 34;
      ["name_es"] = "Una mision hedionda";
      ["req"] = 26;
   };
   [305] = {
      ["name_ru"] = "Пропавшие ученые";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de l'equipe de fouilles";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Auf der Suche nach dem Ausgrabungstrupp";
      ["name_cn"] = "?找?掘?";
      ["objective"] = "Tarrel Rockweaver wants you to travel to the Excavation Site and contact Merrin Rockweaver.";
      ["next"] = 306;
      ["sort"] = "Wetlands";
      ["name"] = "In Search of The Excavation Team";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 24;
      ["name_es"] = "La busqueda del equipo de excavacion";
      ["req"] = 21;
   };
   [306] = {
      ["name_ru"] = "Пропавшие ученые";
      ["type"] = "Solo";
      ["objective"] = "Return to Tarrel Rockweaver with Merrin's note.";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Auf der Suche nach dem Ausgrabungstrupp";
      ["name"] = "In Search of The Excavation Team";
      ["name_cn"] = "?找?掘?";
      ["name_fr"] = "A la recherche de l'equipe de fouilles";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 305;
      ["prequests"] = {
         [1] = 305;
      };
      ["level"] = 24;
      ["name_es"] = "La busqueda del equipo de excavacion";
      ["req"] = 21;
   };
   [307] = {
      ["name_ru"] = "Грязные лапы";
      ["type"] = "Solo";
      ["objective"] = "Go to the Silver Stream Mine and collect 4 loads of Miners' Gear.$B$BReturn to Mountaineer Stormpike.";
      ["repgain"] = {
         [47] = 350;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Bas les pattes?!";
      ["name_cn"] = "??的爪子";
      ["reward"] = {
         [1] = 3166;
         [2] = 3161;
         [3] = 3160;
      };
      ["name_de"] = "Schmutzige Pfoten";
      ["faction"] = "Alliance";
      ["name"] = "Filthy Paws";
      ["level"] = 15;
      ["name_es"] = "Zarpas asquerosas";
      ["req"] = 9;
   };
   [308] = {
      ["name_ru"] = "Отвлечь Ярвена";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_de"] = "Jarvens Ablenkung";
      ["name_cn"] = "加文的?好";
      ["name_fr"] = "Distraire Jarven";
      ["name"] = "Distracting Jarven";
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 403;
      ["prequests"] = {
         [1] = 403;
      };
      ["level"] = 7;
      ["name_es"] = "Distraer a Jarven";
      ["req"] = 1;
   };
   [309] = {
      ["name_ru"] = "Охрана груза";
      ["type"] = "Solo";
      ["objective"] = "Ensure Miran and the shipment arrive at the excavation site, then inform Prospector Ironband.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Beschutzen der Fracht";
      ["reward"] = {
         [1] = 3217;
         [2] = 6188;
      };
      ["name_cn"] = "?送?物";
      ["name_fr"] = "Protection de la cargaison";
      ["faction"] = "Alliance";
      ["name"] = "Protecting the Shipment";
      ["sort"] = "Loch Modan";
      ["prev"] = 454;
      ["prequests"] = {
         [1] = 454;
      };
      ["level"] = 15;
      ["name_es"] = "Proteger el envio";
      ["req"] = 10;
   };
   [310] = {
      ["name_ru"] = "Злейшие соперники";
      ["type"] = "Solo";
      ["objective"] = "In the basement of the Thunderbrew Distillery in Kharanos, replace a barrel of Thunder Ale with a Barrel of Barleybrew Scalder.";
      ["next"] = 311;
      ["name_fr"] = "Bieres rivales";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "??相?";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_de"] = "Bittere Rivalen";
      ["faction"] = "Alliance";
      ["name"] = "Bitter Rivals";
      ["level"] = 6;
      ["name_es"] = "Rivales acerrimos";
      ["req"] = 2;
   };
   [311] = {
      ["name_ru"] = "Возвращение к Марлетте";
      ["type"] = "Solo";
      ["name_fr"] = "Retour chez Marleth";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Ruckkehr zu Marleth";
      ["name_cn"] = "向?莱斯回?";
      ["name"] = "Return to Marleth";
      ["objective"] = "Bring the barrel of Thunder Ale to Marleth Barleybrew at the Brewnall Village.";
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 310;
      ["prequests"] = {
         [1] = 310;
      };
      ["level"] = 7;
      ["name_es"] = "Regresa junto a Marleth";
      ["req"] = 2;
   };
   [312] = {
      ["name_ru"] = "Ограбление тайника Тундры Макгранна";
      ["type"] = "Solo";
      ["objective"] = "Retrieve Tundra MacGrann's dried meats from the stolen meat locker in Old Icebeard's cave.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "La reserve volee de Tundra MacGrann";
      ["name_cn"] = "?克格拉恩的干肉";
      ["reward"] = {
         [1] = 6177;
         [2] = 10550;
      };
      ["name_de"] = "Tundra MacGranns gestohlene Vorrate";
      ["faction"] = "Alliance";
      ["name"] = "Tundra MacGrann's Stolen Stash";
      ["level"] = 12;
      ["name_es"] = "La reserva robada de Tundra MacGrann";
      ["req"] = 7;
   };
   [313] = {
      ["name_ru"] = "Серая берлога";
      ["type"] = "Solo";
      ["objective"] = "Gather 8 Wendigo Manes and bring them to Pilot Stonegear.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_fr"] = "L'antre Gris";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "灰色洞穴";
      ["name_de"] = "Zum Zusehen verdammt";
      ["faction"] = "Alliance";
      ["name"] = "The Grizzled Den";
      ["level"] = 7;
      ["name_es"] = "Vigilando desde lejos";
      ["req"] = 4;
   };
   [314] = {
      ["name_ru"] = "Защита стада";
      ["type"] = "Group";
      ["objective"] = "Rudra Amberstill wants you to slay Vagash and bring his fang to her at the Ram ranch.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Protection du troupeau";
      ["name_cn"] = "保?牲畜";
      ["reward"] = {
         [1] = 10549;
         [2] = 2817;
         [3] = 3103;
      };
      ["name_de"] = "Die Herde beschutzen";
      ["faction"] = "Alliance";
      ["name"] = "Protecting the Herd";
      ["level"] = 12;
      ["name_es"] = "La proteccion del rebano";
      ["req"] = 6;
   };
   [315] = {
      ["name_ru"] = "Всем портерам портер";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Shimmerweeds to Rejold Barleybrew in the Brewnall Village.";
      ["next"] = 413;
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "La biere brune parfaite";
      ["name_cn"] = "完美烈酒";
      ["reward"] = {
         [1] = 2905;
         [2] = 2326;
      };
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Das perfekte Starkbier";
      ["faction"] = "Alliance";
      ["name"] = "The Perfect Stout";
      ["level"] = 9;
      ["name_es"] = "La cerveza perfecta";
      ["req"] = 5;
   };
   [317] = {
      ["name_ru"] = "Заготовка продовольствия";
      ["type"] = "Solo";
      ["objective"] = "Gather 4 Chunks of Boar Meat and 2 Thick Bear Furs, and deliver them to Pilot Bellowfiz at Steelgrill's Depot.";
      ["next"] = 318;
      ["name_fr"] = "Ravitailler le Crache-vapeur";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "??丁的??";
      ["repgain"] = {
         [54] = 350;
         [47] = 150;
      };
      ["name_de"] = "Vorrate fur Dampfstrahl";
      ["faction"] = "Alliance";
      ["name"] = "Stocking Jetsteam";
      ["level"] = 6;
      ["name_es"] = "Los suministros del reactor a vapor";
      ["req"] = 2;
   };
   [318] = {
      ["name_ru"] = "\"Вечное сияние\"";
      ["type"] = "Solo";
      ["name_fr"] = "L’eternol";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_de"] = "Immerschimmer";
      ["name"] = "Evershine";
      ["name_cn"] = "艾沃沙酒";
      ["objective"] = "Get a cask of Evershine from Rejold Barleybrew in Brewnall Village.";
      ["next"] = 319;
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 317;
      ["prequests"] = {
         [1] = 317;
      };
      ["level"] = 7;
      ["name_es"] = "La tajada";
      ["req"] = 2;
   };
   [319] = {
      ["name_ru"] = "Услуга за \"Вечное сияние\"";
      ["type"] = "Solo";
      ["name_fr"] = "Une faveur pour un tonneau d’eternol";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_de"] = "Ein Gefallen fur etwas Immerschimmer";
      ["name"] = "A Favor for Evershine";
      ["name_cn"] = "艾沃沙酒";
      ["objective"] = "Kill 6 Ice Claw Bears, 8 Elder Crag Boars, and 8 Snow Leopards, and then return to Rejold Barleybrew in Brewnall Village.";
      ["next"] = 320;
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 318;
      ["prequests"] = {
         [1] = 318;
      };
      ["level"] = 8;
      ["name_es"] = "Un favor a cambio de un barril de tajada";
      ["req"] = 2;
   };
   [320] = {
      ["name_ru"] = "Возвращение к Толстопузу";
      ["type"] = "Solo";
      ["objective"] = "Give the cask of Evershine to Pilot Bellowfiz at Steelgrill's Depot.";
      ["repgain"] = {
         [54] = 350;
         [47] = 350;
      };
      ["name_de"] = "Ruckkehr zu Bellfiz";
      ["reward"] = {
         [1] = 1011;
         [2] = 1010;
         [3] = 10547;
      };
      ["name_cn"] = "艾沃沙酒";
      ["name_fr"] = "Retour vers Claquesoufflet";
      ["faction"] = "Alliance";
      ["name"] = "Return to Bellowfiz";
      ["sort"] = "Dun Morogh";
      ["prev"] = 319;
      ["prequests"] = {
         [1] = 319;
      };
      ["level"] = 8;
      ["name_es"] = "Regresa junto a Bramiz";
      ["req"] = 2;
   };
   [321] = {
      ["name_ru"] = "Светлосталь";
      ["objective"] = "Search the wreckage of The Flying Osprey in the Wetlands.";
      ["name_cn"] = "光??";
      ["sort"] = "Duskwood";
      ["level"] = 29;
      ["type"] = "Solo";
      ["name_fr"] = "Le fer de sancteforge";
      ["next"] = 324;
      ["name_de"] = "Lichtgeschmiedetes Eisen";
      ["repgain"] = {
         [72] = 25;
      };
      ["reward"] = {
         [1] = 2702;
      };
      ["name"] = "Lightforge Iron";
      ["prev"] = 270;
      ["prequests"] = {
         [1] = 270;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Hierro Forjaluz";
      ["req"] = 20;
   };
   [322] = {
      ["name_ru"] = "Достойное оружие";
      ["type"] = "Solo";
      ["name_fr"] = "Beni soit ce bras";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Gesegnete Waffe";
      ["name"] = "Blessed Arm";
      ["name_cn"] = "格瑞曼德・艾?默";
      ["objective"] = "Take the Crate of Lightforge Ingots to Grimand Elmore in Stormwind.";
      ["next"] = 325;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 324;
      ["prequests"] = {
         [1] = 324;
      };
      ["level"] = 29;
      ["name_es"] = "Brazo bendito";
      ["req"] = 20;
   };
   [323] = {
      ["name_ru"] = "Доказательство силы";
      ["type"] = "Solo";
      ["name_fr"] = "Prouver votre valeur";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Bewahrungsprobe";
      ["name"] = "Proving Your Worth";
      ["name_cn"] = "?明?的?力";
      ["objective"] = "Kill 15 Skeletal Raiders, 3 Skeletal Healers and 3 Skeletal Warders, and then return to Sven.";
      ["next"] = 269;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 268;
      ["prequests"] = {
         [1] = 268;
      };
      ["level"] = 28;
      ["name_es"] = "Pon a prueba tu valor";
      ["req"] = 20;
   };
   [324] = {
      ["name_ru"] = "Утерянные слитки";
      ["type"] = "Solo";
      ["name_fr"] = "Les lingots perdus";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Die verlorenen Blocke";
      ["name"] = "The Lost Ingots";
      ["name_cn"] = "?失的??";
      ["objective"] = "Gather 5 Lightforge Ingots, then return to Glorin Steelbrow in the Wetlands.";
      ["next"] = 322;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 321;
      ["prequests"] = {
         [1] = 321;
      };
      ["level"] = 29;
      ["name_es"] = "Los lingotes perdidos";
      ["req"] = 20;
   };
   [325] = {
      ["name_ru"] = "Вооружен и особо опасен";
      ["type"] = "Solo";
      ["name_fr"] = "En armes et pret au combat";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Bewaffnet und bereit";
      ["name"] = "Armed and Ready";
      ["name_cn"] = "整装待?";
      ["objective"] = "Bring Morbent's Bane to Sven in Duskwood.";
      ["next"] = 55;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 322;
      ["prequests"] = {
         [1] = 322;
      };
      ["level"] = 29;
      ["name_es"] = "Armado y listo";
      ["req"] = 20;
   };
   [328] = {
      ["name_ru"] = "Спрятанный ключ";
      ["objective"] = " and the small brass key can open it";
      ["name_cn"] = "?藏的?匙";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "La cle cachee";
      ["next"] = 329;
      ["name_de"] = "Der versteckte Schlussel";
      ["repgain"] = {
         [72] = 75;
      };
      ["reward"] = {
         [1] = 4122;
      };
      ["name"] = "The Hidden Key";
      ["prev"] = 200;
      ["prequests"] = {
         [1] = 200;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La llave oculta";
      ["req"] = 30;
   };
   [329] = {
      ["name_ru"] = "Шпион найден!";
      ["type"] = "Solo";
      ["name_fr"] = "L'espion decouvert?!";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Der entlarvte Spion";
      ["name"] = "The Spy Revealed!";
      ["name_cn"] = "找出内鬼！";
      ["objective"] = "Take the Muddy Note to Lieutenant Doren at the Rebel Camp.";
      ["next"] = 330;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 328;
      ["prequests"] = {
         [1] = 328;
      };
      ["level"] = 37;
      ["name_es"] = "!Espia descubierto!";
      ["req"] = 30;
   };
   [330] = {
      ["name_ru"] = "Расписание дежурств";
      ["type"] = "Solo";
      ["name_fr"] = "Composition des patrouilles";
      ["next"] = 331;
      ["name_de"] = "Patrouillen-Plane";
      ["name_cn"] = "巡???表";
      ["objective"] = "Speak with Corporal Sethman.";
      ["sort"] = "Stranglethorn Valley";
      ["faction"] = "Alliance";
      ["name"] = "Patrol Schedules";
      ["prev"] = 329;
      ["prequests"] = {
         [1] = 329;
      };
      ["level"] = 37;
      ["name_es"] = "Horarios de patrulla";
      ["req"] = 30;
   };
   [331] = {
      ["name_ru"] = "Доклад Дорену";
      ["type"] = "Solo";
      ["objective"] = "Speak with Lieutenant Doren.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Meldung bei Doren";
      ["reward"] = {
         [1] = 4139;
         [2] = 4123;
      };
      ["name_cn"] = "向多??告";
      ["name_fr"] = "Rapport au lieutenant Doren";
      ["faction"] = "Alliance";
      ["name"] = "Report to Doren";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 330;
      ["prequests"] = {
         [1] = 330;
      };
      ["level"] = 37;
      ["name_es"] = "Informa a Doren";
      ["req"] = 30;
   };
   [332] = {
      ["name_ru"] = "Реклама винного магазина";
      ["type"] = "Solo";
      ["objective"] = "Go to the Gallina Winery, and bring Suzetta Gallina the Wine Ticket for a free bottle of wine.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Stormwind City";
      ["name_fr"] = "Publicite pour la cave a vins Gallina";
      ["name_cn"] = "酒店的广告";
      ["reward"] = {
         [1] = 2723;
      };
      ["name_de"] = "Weinladen-Werbung";
      ["faction"] = "Alliance";
      ["name"] = "Wine Shop Advert";
      ["level"] = 2;
      ["name_es"] = "Publicidad de la bodega";
      ["req"] = 1;
   };
   [333] = {
      ["name_ru"] = "Харлан нуждается в помощи";
      ["type"] = "Solo";
      ["objective"] = "Go to the Canal Tailor Shop and bring Rema Schneider the Cloth Request from Harlan Bagley.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_fr"] = "Harlan a besoin d'etre approvisionne";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "哈?需要供?";
      ["name_de"] = "Harlan braucht Nachschub";
      ["faction"] = "Alliance";
      ["name"] = "Harlan Needs a Resupply";
      ["level"] = 2;
      ["name_es"] = "Harlan necesita un nuevo suministro";
      ["req"] = 1;
   };
   [334] = {
      ["name_ru"] = "Посылка для Тармена";
      ["type"] = "Solo";
      ["objective"] = "Go to the Larson Clothiers in the Stormwind Mage Quarter, and give Thurman Schneider his Sewing Kit.";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_fr"] = "Un paquet pour Thurman";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "??曼的??包";
      ["name_de"] = "Eine Lieferung fur Thurman";
      ["faction"] = "Alliance";
      ["name"] = "Package for Thurman";
      ["level"] = 2;
      ["name_es"] = "Un paquete para Thurman";
      ["req"] = 1;
   };
   [335] = {
      ["name_ru"] = "Благородный напиток";
      ["type"] = "Solo";
      ["objective"] = " but I'll need your help. $B$BThere is a flower growing in the Garden of Stalvan on the outskirts of Darkshire.  This small white flower is known as the Tear of Tilloa.  I will also need a Musquash Root";
      ["next"] = 336;
      ["name_fr"] = "Une biere noble";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "名?";
      ["series"] = 1;
      ["name_de"] = "Ein nobles Brau";
      ["faction"] = "Alliance";
      ["name"] = "A Noble Brew";
      ["level"] = 30;
      ["name_es"] = "Una noble cerveza";
      ["req"] = 25;
   };
   [336] = {
      ["name_ru"] = "Благородный напиток";
      ["type"] = "Solo";
      ["name_fr"] = "Une biere noble";
      ["name_de"] = "Ein nobles Brau";
      ["name"] = "A Noble Brew";
      ["name_cn"] = "名?";
      ["objective"] = " running up a bill he never pays.  Well";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 335;
      ["prequests"] = {
         [1] = 335;
      };
      ["level"] = 30;
      ["name_es"] = "Una noble cerveza";
      ["req"] = 25;
   };
   [337] = {
      ["name_ru"] = "Старый учебник истории";
      ["type"] = "Solo";
      ["objective"] = " the seal of the Stormwind Library is clearly stamped on the book's first page.$B$BIt looks like someone checked out this book";
      ["next"] = 538;
      ["name_fr"] = "Un vieux livre d'histoire";
      ["sort"] = "Duskwood";
      ["name_cn"] = "一本破旧的?史?";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Ein altes Geschichtsbuch";
      ["faction"] = "Alliance";
      ["name"] = "An Old History Book";
      ["level"] = 25;
      ["name_es"] = "Un libro viejo de Historia";
      ["req"] = 20;
   };
   [338] = {
      ["name_ru"] = "Зеленые холмы Тернистой долины";
      ["type"] = "Solo";
      ["name_fr"] = "≪?Les vertes collines de Strangleronce?≫";
      ["name_de"] = "Die Grunen Hugel des Schlingendorntals";
      ["reward"] = {
         [1] = 17688;
         [2] = 8173;
         [3] = 3928;
      };
      ["name_cn"] = "?棘谷的青山";
      ["objective"] = "Collect the missing pages from The Green Hills of Stranglethorn manuscript.  Once all four chapters are complete, return them to Barnil.";
      ["faction"] = "Horde";
      ["name"] = "The Green Hills of Stranglethorn";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 583;
      ["prequests"] = {
         [1] = 583;
      };
      ["level"] = 40;
      ["name_es"] = "Las verdes colinas de Tuercespina";
      ["req"] = 30;
   };
   [339] = {
      ["name_ru"] = "Глава I";
      ["type"] = "Solo";
      ["objective"] = "Bring pages 1, 4, 6, and 8 of Nesingwary's The Green Hills of Stranglethorn to Barnil Stonepot in order to complete Chapter I.";
      ["name_fr"] = "Chapitre I";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?棘谷的青山 - 第一章";
      ["reward"] = {
         [1] = 2756;
      };
      ["name_de"] = "Kapitel I";
      ["faction"] = "Horde";
      ["name"] = "Chapter I";
      ["level"] = 40;
      ["name_es"] = "Capitulo I";
      ["req"] = 30;
   };
   [340] = {
      ["name_ru"] = "Глава II";
      ["type"] = "Solo";
      ["objective"] = "Bring pages 10, 11, 14 and 16 of Nesingwary's The Green Hills of Stranglethorn to Barnil Stonepot in order to complete Chapter II.";
      ["name_fr"] = "Chapitre II";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?棘谷的青山 - 第二章";
      ["reward"] = {
         [1] = 2757;
      };
      ["name_de"] = "Kapitel II";
      ["faction"] = "Horde";
      ["name"] = "Chapter II";
      ["level"] = 40;
      ["name_es"] = "Capitulo II";
      ["req"] = 30;
   };
   [341] = {
      ["name_ru"] = "Глава III";
      ["type"] = "Solo";
      ["objective"] = "Bring pages 18, 20, 21and 24 of Nesingwary's The Green Hills of Stranglethorn to Barnil Stonepot in order to complete Chapter III.";
      ["name_fr"] = "Chapitre III";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?棘谷的青山 - 第三章";
      ["reward"] = {
         [1] = 2758;
      };
      ["name_de"] = "Kapitel III";
      ["faction"] = "Horde";
      ["name"] = "Chapter III";
      ["level"] = 40;
      ["name_es"] = "Capitulo III";
      ["req"] = 30;
   };
   [342] = {
      ["name_ru"] = "Глава IV";
      ["type"] = "Solo";
      ["objective"] = "Bring pages 25, 26, and 27 of Nesingwary's The Green Hills of Stranglethorn to Barnil Stonepot in order to complete Chapter IV.";
      ["name_fr"] = "Chapitre IV";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?棘谷的青山 - 第四章";
      ["reward"] = {
         [1] = 2759;
      };
      ["name_de"] = "Kapitel IV";
      ["faction"] = "Horde";
      ["name"] = "Chapter IV";
      ["level"] = 40;
      ["name_es"] = "Capitulo IV";
      ["req"] = 30;
   };
   [343] = {
      ["name_ru"] = "Кстати, о стойкости духа";
      ["type"] = "Solo";
      ["objective"] = " within Stormwind Keep.  Can you retrieve it for me?  If so";
      ["next"] = 344;
      ["name_fr"] = "En parlant de fermete";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?于??的演?";
      ["repgain"] = {
         [0] = 72;
      };
      ["name_de"] = "Reden uber Kraft";
      ["faction"] = "Alliance";
      ["name"] = "Speaking of Fortitude";
      ["level"] = 24;
      ["name_es"] = "Hablando de entereza";
      ["req"] = 20;
   };
   [344] = {
      ["name_ru"] = "Брат Пакстон";
      ["type"] = "Solo";
      ["name_fr"] = "Frere Paxton";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Bruder Paxton";
      ["name"] = "Brother Paxton";
      ["name_cn"] = "?克斯?修士";
      ["objective"] = "Speak with Brother Paxton in the Northshire Abbey.";
      ["next"] = 345;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 343;
      ["prequests"] = {
         [1] = 343;
      };
      ["level"] = 24;
      ["name_es"] = "Hermano Paxton";
      ["req"] = 20;
   };
   [345] = {
      ["name_ru"] = "Запас чернил";
      ["type"] = "Solo";
      ["name_fr"] = "Provisions d'encre";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Tinten-Zutaten";
      ["name"] = "Ink Supplies";
      ["name_cn"] = "墨水短缺";
      ["objective"] = "Speak with Foreman Oslow in Lakeshire and ask him for Rethban Iron Ore.";
      ["next"] = 347;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 344;
      ["prequests"] = {
         [1] = 344;
      };
      ["level"] = 24;
      ["name_es"] = "Suministros de tinta";
      ["req"] = 20;
   };
   [346] = {
      ["name_ru"] = "Возвращение к Кристофу";
      ["type"] = "Solo";
      ["objective"] = "Return to Brother Kristoff in the Cathedral Square.  Give him the book The Stresses of Iron.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Ruckkehr zu Kristoff";
      ["reward"] = {
         [1] = 6095;
      };
      ["name_cn"] = "克里斯托弗的?";
      ["name_fr"] = "Retourner voir Frere Kristoff";
      ["faction"] = "Alliance";
      ["name"] = "Return to Kristoff";
      ["sort"] = "Stormwind City";
      ["prev"] = 347;
      ["prequests"] = {
         [1] = 347;
      };
      ["level"] = 24;
      ["name_es"] = "Regresa junto a Kristoff";
      ["req"] = 20;
   };
   [347] = {
      ["name_ru"] = "Ретбанская руда";
      ["type"] = "Solo";
      ["name_fr"] = "Minerai de rethban";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Rethbanerz";
      ["name"] = "Rethban Ore";
      ["name_cn"] = "瑞斯班?石";
      ["objective"] = "Gather 5 loads of Rethban Ore and bring it to Brother Paxton in the Northshire Library.";
      ["next"] = 346;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 345;
      ["prequests"] = {
         [1] = 345;
      };
      ["level"] = 24;
      ["name_es"] = "La mena de Rethban";
      ["req"] = 20;
   };
   [348] = {
      ["name_ru"] = "Лихорадка Тернистой долины";
      ["type"] = "Solo";
      ["objective"] = "Seek out Witch Doctor Unbagwa and have him summon Mokk the Savage. Bring the Heart of Mokk to Fin Fizracket.";
      ["repgain"] = {
         [21] = 500;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "La fievre de Strangleronce";
      ["name_cn"] = "?棘谷?疫";
      ["reward"] = {
         [1] = 4113;
      };
      ["name_de"] = "Schlingendornfieber";
      ["faction"] = "Horde";
      ["name"] = "Stranglethorn Fever";
      ["level"] = 45;
      ["name_es"] = "La fiebre de Tuercespina";
      ["req"] = 40;
   };
   [349] = {
      ["name_ru"] = "Лихорадка Тернистой долины";
      ["type"] = "Solo";
      ["objective"] = "Speak with Witch Doctor Unbagwa.";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?棘谷?疫";
      ["name_fr"] = "La fievre de Strangleronce";
      ["name_de"] = "Schlingendornfieber";
      ["faction"] = "Horde";
      ["name"] = "Stranglethorn Fever";
      ["level"] = 45;
      ["name_es"] = "La fiebre de Tuercespina";
      ["req"] = 32;
   };
   [350] = {
      ["name_ru"] = "Помощь старого друга";
      ["type"] = "Solo";
      ["name_fr"] = "Le point de vue d'un vieil ami";
      ["next"] = 2745;
      ["name_de"] = "Auf einen alten Freund verlassen";
      ["name_cn"] = "老朋友";
      ["objective"] = "Speak to Elling Trias in Stormwind.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "Look to an Old Friend";
      ["prev"] = 393;
      ["prequests"] = {
         [1] = 393;
      };
      ["level"] = 31;
      ["name_es"] = "Mira por un viejo amigo";
      ["req"] = 16;
   };
   [351] = {
      ["name_ru"] = "Найди КПХ-17/TN!";
      ["type"] = "Solo";
      ["objective"] = " and my homing robot has gone missing!  I will reward you for its recovery!  Please take this beacon to the robot.  Excellent";
      ["next"] = 648;
      ["name_fr"] = "Trouvez OOX-17/TN?!";
      ["sort"] = "Tanaris";
      ["name_cn"] = "?找OOX-17/TN！";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Findet OOX-17/TN!";
      ["faction"] = "Horde";
      ["name"] = "Find OOX-17/TN!";
      ["level"] = 48;
      ["name_es"] = "!Encontrar a OOX-17/TN!";
      ["req"] = 43;
   };
   [353] = {
      ["name_ru"] = "Посылка для Грозовой Вершины";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison pour Foudrepique";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Sturmlanzes Lieferung";
      ["name_cn"] = "雷矛的包裹";
      ["name"] = "Stormpike's Delivery";
      ["objective"] = "Deliver the Package for Stormpike to Mountaineer Stormpike in Loch Modan.";
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1097;
      ["prequests"] = {
         [1] = 1097;
      };
      ["level"] = 15;
      ["name_es"] = "Una entrega a Pico Tormenta";
      ["req"] = 9;
   };
   [354] = {
      ["name_ru"] = "Смерти в семье";
      ["type"] = "Solo";
      ["objective"] = "Bring Gregor's Remains, Nissa's Remains and Thurman's Remains to Coleman Farthing in Brill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Morts dans la Famille";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "阿加曼德家族";
      ["name_de"] = "Todesfalle in der Familie";
      ["faction"] = "Horde";
      ["name"] = "Deaths in the Family";
      ["level"] = 11;
      ["name_es"] = "Muertes en la familia";
      ["req"] = 7;
   };
   [355] = {
      ["name_ru"] = "Разговор с Севреном";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Sevren";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Sprecht mit Sevren";
      ["name"] = "Speak with Sevren";
      ["name_cn"] = "与塞弗?交?";
      ["objective"] = "Speak with Magistrate Sevren in Brill.";
      ["next"] = 408;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 354;
      ["prequests"] = {
         [1] = 354;
      };
      ["level"] = 10;
      ["name_es"] = "Habla con Sevren";
      ["req"] = 7;
   };
   [356] = {
      ["name_ru"] = "Патруль в арьергарде";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Bleeding Horrors and 8 Wandering Spirits, then report back to Linnea at her camp.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_fr"] = "Patrouille d'arriere-garde";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "巡?后方";
      ["name_de"] = "Patrouille zur Ruckendeckung";
      ["faction"] = "Horde";
      ["name"] = "Rear Guard Patrol";
      ["level"] = 11;
      ["name_es"] = "Patrulla de la retaguardia";
      ["req"] = 6;
   };
   [357] = {
      ["name_ru"] = "Личность лича";
      ["type"] = "Solo";
      ["name_fr"] = "Le nom de la Liche";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Die Identitat des Lichs";
      ["name"] = "The Lich's Identity";
      ["name_cn"] = "巫妖的身?";
      ["objective"] = "Bring the Lich's Spellbook to Bethor Iceshard in the Undercity.";
      ["next"] = 366;
      ["faction"] = "Horde";
      ["sort"] = "Undercity";
      ["prev"] = 405;
      ["prequests"] = {
         [1] = 405;
      };
      ["level"] = 8;
      ["name_es"] = "La identidad del exanime";
      ["req"] = 5;
   };
   [358] = {
      ["name_ru"] = "Грабители могил";
      ["type"] = "Solo";
      ["objective"] = "Kill Rot Hide Graverobbers and Rot Hide Mongrels.  $B$BBring 8 Embalming Ichors to Magistrate Sevren in Brill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Tirisfal Glades";
      ["name_fr"] = "Les Profanateurs";
      ["name_cn"] = "盗墓?";
      ["reward"] = {
         [1] = 6063;
         [2] = 3439;
      };
      ["name_de"] = "Grabrauber";
      ["faction"] = "Horde";
      ["name"] = "Graverobbers";
      ["level"] = 8;
      ["name_es"] = "Profanadores";
      ["req"] = 4;
   };
   [359] = {
      ["name_ru"] = "Обязанности Отрекшихся";
      ["type"] = "Solo";
      ["name_fr"] = "Mission des Reprouves";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Verlassenen-Pflichten";
      ["name"] = "Forsaken Duties";
      ["name_cn"] = "亡??兵的??";
      ["objective"] = "Speak with Deathguard Linnea.";
      ["next"] = 360;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 358;
      ["prequests"] = {
         [1] = 358;
      };
      ["level"] = 9;
      ["name_es"] = "Las obligaciones de los Renegados";
      ["req"] = 6;
   };
   [360] = {
      ["name_ru"] = "Возвращение к мировому судье";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir le Magistrat";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Ruckkehr zum Magistrat";
      ["name_cn"] = "向塞弗?回?";
      ["name"] = "Return to the Magistrate";
      ["objective"] = "Return to Magistrate Sevren in Brill.";
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 359;
      ["prequests"] = {
         [1] = 359;
      };
      ["level"] = 9;
      ["name_es"] = "Regresa junto al magistrado";
      ["req"] = 6;
   };
   [361] = {
      ["name_ru"] = "Недоставленное письмо";
      ["type"] = "Solo";
      ["objective"] = "Find Yvette Farthing, and deliver to her the letter from Thurman Agamand.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_fr"] = "Une lettre perdue";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "未寄出的信件";
      ["name_de"] = "Ein nie zugestellter Brief";
      ["faction"] = "Horde";
      ["name"] = "A Letter Undelivered";
      ["level"] = 7;
      ["name_es"] = "Una carta sin entregar";
      ["req"] = 4;
   };
   [362] = {
      ["name_ru"] = "Мельницы с привидениями";
      ["type"] = "Solo";
      ["objective"] = "Slay Devlin Agamand, and bring Devlin's Remains to Coleman Farthing in Brill.";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_fr"] = "Les moulins hantes";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "?鬼的磨坊";
      ["name_de"] = "Die Spukmuhlen";
      ["faction"] = "Horde";
      ["name"] = "The Haunted Mills";
      ["level"] = 10;
      ["name_es"] = "Los molinos fantasma";
      ["req"] = 7;
   };
   [363] = {
      ["name_ru"] = "Резкое пробуждение";
      ["type"] = "Solo";
      ["name_fr"] = "Reveil brutal";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_cn"] = "突然醒来";
      ["name_de"] = "Unsanftes Erwachen";
      ["objective"] = "Speak with Shadow Priest Sarvis.";
      ["next"] = 364;
      ["name"] = "Rude Awakening";
      ["sort"] = "Deathknell";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 1;
      ["name_es"] = "Desvelo brutal";
      ["req"] = 1;
   };
   [364] = {
      ["name_ru"] = "Безмозглые твари";
      ["type"] = "Solo";
      ["objective"] = "Shadow Priest Sarvis wants you to kill 8 Mindless Zombies and 8 Wretched Zombies.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Die Hirnlosen";
      ["reward"] = {
         [1] = 3275;
         [2] = 11847;
      };
      ["name_cn"] = "无?的僵尸";
      ["name_fr"] = "Les Dechus";
      ["faction"] = "Horde";
      ["name"] = "The Mindless Ones";
      ["sort"] = "Deathknell";
      ["prev"] = 363;
      ["prequests"] = {
         [1] = 363;
      };
      ["level"] = 2;
      ["name_es"] = "Los automatas";
      ["req"] = 1;
   };
   [365] = {
      ["name_ru"] = "Поля Горя";
      ["type"] = "Solo";
      ["name_fr"] = "Les champs du Chagrin";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Felder des Kummers";
      ["name_cn"] = "悲?之地";
      ["objective"] = "Steal 10 pumpkins from the farm to the west, just north of Deathknell and take them to Apothecary Johaan in Brill.";
      ["next"] = 407;
      ["sort"] = "Tirisfal Glades";
      ["name"] = "Fields of Grief";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 7;
      ["name_es"] = "Campos de pena";
      ["req"] = 4;
   };
   [366] = {
      ["name_ru"] = "Книга Гюнтера";
      ["type"] = "Solo";
      ["name_fr"] = "Ramener le livre";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Ruckgabe des Buches";
      ["name"] = "Return the Book";
      ["name_cn"] = "???籍";
      ["objective"] = "Return Gunther's Spellbook to him, on the island of Gunther's Retreat.";
      ["next"] = 409;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 357;
      ["prequests"] = {
         [1] = 357;
      };
      ["level"] = 8;
      ["name_es"] = "Devuelve el libro";
      ["req"] = 5;
   };
   [367] = {
      ["name_ru"] = "Новая чума";
      ["type"] = "Solo";
      ["name_fr"] = "Une Peste nouvelle";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Eine neue Seuche";
      ["name"] = "A New Plague";
      ["name_cn"] = "新的瘟疫";
      ["objective"] = "Apothecary Johaan in the town of Brill wants you to collect 5 Vials of Darkhound Blood.";
      ["next"] = 368;
      ["series"] = 1;
      ["sort"] = "Tirisfal Glades";
      ["reward"] = {
         [1] = 3382;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 6;
      ["name_es"] = "Una nueva Peste";
      ["req"] = 6;
   };
   [368] = {
      ["name_ru"] = "Новая чума";
      ["objective"] = "Apothecary Johaan of the town of Brill needs 5 Vile Fin Scales from Murlocs in Tirisfal Glades.";
      ["name_cn"] = "新的瘟疫";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "Une Peste nouvelle";
      ["next"] = 369;
      ["name_de"] = "Eine neue Seuche";
      ["repgain"] = {
         [68] = 250;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["reward"] = {
         [1] = 3434;
      };
      ["name"] = "A New Plague";
      ["prev"] = 367;
      ["prequests"] = {
         [1] = 367;
      };
      ["series"] = 2;
      ["name_es"] = "Una nueva Peste";
      ["req"] = 6;
   };
   [369] = {
      ["name_ru"] = "Новая чума";
      ["objective"] = "Apothecary Johaan in the town of Brill wants you to bring him 4 samples of venom from a Vicious Night Web Spider.";
      ["name_cn"] = "新的瘟疫";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 11;
      ["type"] = "Solo";
      ["name_fr"] = "Une Peste nouvelle";
      ["next"] = 492;
      ["name_de"] = "Eine neue Seuche";
      ["repgain"] = {
         [68] = 25;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["reward"] = {
         [1] = 3442;
      };
      ["name"] = "A New Plague";
      ["prev"] = 368;
      ["prequests"] = {
         [1] = 368;
      };
      ["series"] = 3;
      ["name_es"] = "Una nueva Peste";
      ["req"] = 6;
   };
   [370] = {
      ["name_ru"] = "Война с Алым орденом";
      ["objective"] = "Executor Zygand in Brill wants you to kill Captain Perrine, 3 Scarlet Zealots and 3 Scarlet Missionaries.";
      ["name_cn"] = "与血色十字?的?争";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "En guerre avec la Croisade ecarlate";
      ["next"] = 371;
      ["name_de"] = "Im Krieg mit dem Scharlachroten Kreuzzug";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "At War With The Scarlet Crusade";
      ["prev"] = 427;
      ["prequests"] = {
         [1] = 427;
      };
      ["series"] = 2;
      ["name_es"] = "En guerra con la Cruzada Escarlata";
      ["req"] = 5;
   };
   [371] = {
      ["name_ru"] = "Война с Алым орденом";
      ["objective"] = "Executor Zygand in Brill has commissioned you to slay Captain Vachon and 5 Scarlet Friars.";
      ["name_cn"] = "与血色十字?的?争";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "En guerre avec la Croisade ecarlate";
      ["next"] = 372;
      ["name_de"] = "Krieg mit dem Scharlachroten Kreuzzug";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "At War With The Scarlet Crusade";
      ["prev"] = 370;
      ["prequests"] = {
         [1] = 370;
      };
      ["series"] = 3;
      ["name_es"] = "En guerra con la Cruzada Escarlata";
      ["req"] = 5;
   };
   [372] = {
      ["name_ru"] = "Война с Алым орденом";
      ["objective"] = "Executor Zygand in the town of Brill wants you to assassinate Captain Melrache and his two bodyguards.";
      ["name_cn"] = "与血色十字?的?争";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 12;
      ["type"] = "Solo";
      ["name_fr"] = "En guerre avec la Croisade ecarlate";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Im Krieg mit dem Scharlachroten Kreuzzug";
      ["reward"] = {
         [1] = 3445;
         [2] = 3071;
      };
      ["faction"] = "Horde";
      ["name"] = "At War With The Scarlet Crusade";
      ["prev"] = 371;
      ["prequests"] = {
         [1] = 371;
      };
      ["series"] = 4;
      ["name_es"] = "En guerra con la Cruzada Escarlata";
      ["req"] = 5;
   };
   [373] = {
      ["name_ru"] = "Неотправленное письмо";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Letter to the City Architect to Baros Alexston in Stormwind.";
      ["next"] = 389;
      ["name_fr"] = "La lettre non envoyee";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "未寄出的信";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Der nie verschickte Brief";
      ["faction"] = "Alliance";
      ["name"] = "The Unsent Letter";
      ["level"] = 22;
      ["name_es"] = "La carta sin enviar";
      ["req"] = 16;
   };
   [374] = {
      ["name_ru"] = "Доказательство верности";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Scarlet Insignia Rings to Deathguard Burgess in Brill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Tirisfal Glades";
      ["name_fr"] = "Preuves de la mort";
      ["name_cn"] = "死亡?明";
      ["reward"] = {
         [1] = 3435;
         [2] = 3437;
         [3] = 12299;
      };
      ["name_de"] = "Todesbeweis";
      ["faction"] = "Horde";
      ["name"] = "Proof of Demise";
      ["level"] = 7;
      ["name_es"] = "Prueba de defuncion";
      ["req"] = 5;
   };
   [375] = {
      ["name_ru"] = "Смертельный холод";
      ["type"] = "Solo";
      ["objective"] = "Bring five Duskbat Pelts and some Coarse Thread to Gretchen Dedmar in Brill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Tirisfal Glades";
      ["name_fr"] = "Le frisson de la mort";
      ["name_cn"] = "死亡之寒";
      ["reward"] = {
         [1] = 3833;
         [2] = 5939;
      };
      ["name_de"] = "Die Kalte des Todes";
      ["faction"] = "Horde";
      ["name"] = "The Chill of Death";
      ["level"] = 8;
      ["name_es"] = "El frio de la muerte";
      ["req"] = 7;
   };
   [376] = {
      ["name_ru"] = "Проклятые";
      ["type"] = "Solo";
      ["objective"] = "Novice Elreth requires 6 Scavenger Paws and 6 Duskbat Wings.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Deathknell";
      ["name_fr"] = "Les Maudits";
      ["name_cn"] = "被?咒者";
      ["reward"] = {
         [1] = 6060;
         [2] = 2173;
      };
      ["name_de"] = "Die Verdammten";
      ["faction"] = "Horde";
      ["name"] = "The Damned";
      ["level"] = 2;
      ["name_es"] = "Los Malditos";
      ["req"] = 2;
   };
   [377] = {
      ["name_ru"] = "Преступление и наказание";
      ["type"] = "Dungeon";
      ["objective"] = "Councilman Millstipe of Darkshire wants you to bring him the hand of Dextren Ward.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "The Stockade";
      ["name_fr"] = "Crime et Chatiments";
      ["name_cn"] = "罪与?";
      ["reward"] = {
         [1] = 2033;
         [2] = 2906;
      };
      ["name_de"] = "Verbrechen und Strafe";
      ["faction"] = "Alliance";
      ["name"] = "Crime and Punishment";
      ["level"] = 26;
      ["name_es"] = "Crimen y castigo";
      ["req"] = 22;
   };
   [378] = {
      ["name_ru"] = "Успокоить Гневливого";
      ["type"] = "Dungeon";
      ["objective"] = "Motley Garmason wants Kam Deepfury's head brought to him at Dun Modr.";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Tief empfundener Zorn";
      ["reward"] = {
         [1] = 3562;
         [2] = 1264;
      };
      ["name_cn"] = "?姆・深怒";
      ["name_fr"] = "Fureur dans les Profondeurs";
      ["faction"] = "Alliance";
      ["name"] = "The Fury Runs Deep";
      ["sort"] = "The Stockade";
      ["prev"] = 303;
      ["prequests"] = {
         [1] = 303;
      };
      ["level"] = 27;
      ["name_es"] = "La furia mora en las profundidades";
      ["req"] = 22;
   };
   [379] = {
      ["name_ru"] = "Утолить жажду";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Wastewander Water Pouches to Chief Engineer Bilgewhizzle in Gadgetzan.";
      ["repgain"] = {
         [369] = 150;
         [68] = 150;
      };
      ["name_de"] = "Durstloscher";
      ["reward"] = {
         [1] = 8524;
      };
      ["name_cn"] = "口?的比格??";
      ["name_fr"] = "Etancher cette soif";
      ["faction"] = "Horde";
      ["name"] = "Slake That Thirst";
      ["sort"] = "Tanaris";
      ["prev"] = 243;
      ["prequests"] = {
         [1] = 243;
      };
      ["level"] = 46;
      ["name_es"] = "Aplacar esa sed";
      ["req"] = 38;
   };
   [380] = {
      ["name_ru"] = "Паучья низина";
      ["objective"] = "Executor Arren wants you to kill 10 Young Night Web Spiders and 8 Night Web Spiders.";
      ["name_cn"] = "夜行蜘蛛洞穴";
      ["sort"] = "Deathknell";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "Les grottes des Tisse-nuit";
      ["next"] = 381;
      ["name_de"] = "Nachtweber";
      ["repgain"] = {
         [68] = 250;
      };
      ["reward"] = {
         [1] = 3270;
         [2] = 3273;
         [3] = 3272;
      };
      ["name"] = "Night Web's Hollow";
      ["prev"] = 376;
      ["prequests"] = {
         [1] = 376;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Hoya Nocturacnidas";
      ["req"] = 2;
   };
   [381] = {
      ["name_ru"] = "Алый орден";
      ["objective"] = "Bring Executor Arren 12 Scarlet Armbands from Scarlet Converts and Scarlet Initiates.";
      ["name_cn"] = "血色十字?";
      ["sort"] = "Deathknell";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "La Croisade ecarlate";
      ["next"] = 382;
      ["name_de"] = "Der Scharlachrote Kreuzzug";
      ["repgain"] = {
         [68] = 250;
      };
      ["reward"] = {
         [1] = 3268;
         [2] = 159;
         [3] = 3269;
         [4] = 3267;
         [5] = 5779;
      };
      ["name"] = "The Scarlet Crusade";
      ["prev"] = 380;
      ["prequests"] = {
         [1] = 380;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La Cruzada Escarlata";
      ["req"] = 2;
   };
   [382] = {
      ["name_ru"] = "Красный гонец";
      ["objective"] = "Kill Meven Korgal, the messenger, at the Crusader camp, then return any information you find to Executor Arren.";
      ["name_cn"] = "十字?信使";
      ["sort"] = "Deathknell";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "Le messager rouge";
      ["next"] = 383;
      ["name_de"] = "Der Rote Bote";
      ["repgain"] = {
         [68] = 500;
      };
      ["reward"] = {
         [1] = 3277;
         [2] = 3276;
      };
      ["name"] = "The Red Messenger";
      ["prev"] = 381;
      ["prequests"] = {
         [1] = 381;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El mensajero rojo";
      ["req"] = 2;
   };
   [383] = {
      ["name_ru"] = "Важные разведданные";
      ["type"] = "Solo";
      ["name_fr"] = "Informations decisives";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Entscheidende Informationen";
      ["name_cn"] = "重要情?";
      ["name"] = "Vital Intelligence";
      ["objective"] = "Deliver the Scarlet Crusade Documents to Executor Zygand in Brill.";
      ["faction"] = "Horde";
      ["sort"] = "Deathknell";
      ["prev"] = 382;
      ["prequests"] = {
         [1] = 382;
      };
      ["level"] = 5;
      ["name_es"] = "Informacion decisiva";
      ["req"] = 2;
   };
   [384] = {
      ["name_ru"] = "Кабаньи ребрышки в пиве";
      ["type"] = "Solo";
      ["objective"] = "Ragnar Thunderbrew in Kharanos wants 6 Crag Boar Ribs and a mug of Rhapsody Malt.";
      ["repgain"] = {
         [54] = 250;
         [47] = 150;
      };
      ["sort"] = "Cooking";
      ["name_fr"] = "Cotes de sanglier a la biere";
      ["name_cn"] = "?酒?猪排";
      ["reward"] = {
         [1] = 2888;
         [2] = 2889;
      };
      ["name_de"] = "Eberrippchen in Biersauce";
      ["faction"] = "Alliance";
      ["name"] = "Beer Basted Boar Ribs";
      ["level"] = 7;
      ["name_es"] = "Costillas de jabali a la cerveza";
      ["req"] = 5;
   };
   [385] = {
      ["name_ru"] = "Охота на кроколисков";
      ["type"] = "Solo";
      ["objective"] = "Get 5 pieces of Crocolisk Meat and 6 Crocolisk Skins for Marek Ironheart at the Farstrider Lodge.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Chasse aux crocilisques";
      ["name_cn"] = "捕???";
      ["reward"] = {
         [1] = 3678;
         [2] = 2240;
      };
      ["name_de"] = "Krokiliskenjagd";
      ["faction"] = "Alliance";
      ["name"] = "Crocolisk Hunting";
      ["level"] = 15;
      ["name_es"] = "La caza de crocoliscos";
      ["req"] = 10;
   };
   [386] = {
      ["name_ru"] = "Что происходит?";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the head of Targorr the Dread to Guard Berton in Lakeshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "The Stockade";
      ["name_fr"] = "Ce qui se passait ailleurs…";
      ["name_cn"] = "伸?正?";
      ["reward"] = {
         [1] = 3400;
         [2] = 1317;
      };
      ["name_de"] = "Verbrechen lohnt sich nicht";
      ["faction"] = "Alliance";
      ["name"] = "What Comes Around...";
      ["level"] = 25;
      ["name_es"] = "Lo que sucede alrededor...";
      ["req"] = 22;
   };
   [387] = {
      ["name_ru"] = "Подавление бунта";
      ["type"] = "Dungeon";
      ["objective"] = "Warden Thelwater of Stormwind wants you to kill 10 Defias Prisoners, 8 Defias Convicts, and 8 Defias Insurgents in The Stockade.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_fr"] = "Ecraser la rebellion";
      ["sort"] = "The Stockade";
      ["name_cn"] = "??暴?";
      ["name_de"] = "Niederschlagung des Aufstandes";
      ["faction"] = "Alliance";
      ["name"] = "Quell The Uprising";
      ["level"] = 26;
      ["name_es"] = "Detener el motin";
      ["req"] = 22;
   };
   [388] = {
      ["name_ru"] = "Цвет крови";
      ["type"] = "Dungeon";
      ["objective"] = "Nikova Raskol of Stormwind wants you to collect 10 Red Wool Bandanas.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_fr"] = "La couleur du Sang";
      ["sort"] = "The Stockade";
      ["name_cn"] = "?血的?色";
      ["name_de"] = "Die Farbe von Blut";
      ["faction"] = "Alliance";
      ["name"] = "The Color of Blood";
      ["level"] = 26;
      ["name_es"] = "El color de la sangre";
      ["req"] = 22;
   };
   [389] = {
      ["name_ru"] = "Базиль Тредд";
      ["type"] = "Solo";
      ["name_fr"] = "Bazil Thredd";
      ["next"] = 391;
      ["name_de"] = "Bazil Thredd";
      ["name_cn"] = "巴吉?・特雷德";
      ["objective"] = "Speak with Warden Thelwater in the Stockade.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "Bazil Thredd";
      ["prev"] = 373;
      ["prequests"] = {
         [1] = 373;
      };
      ["level"] = 22;
      ["name_es"] = "Bazil Thredd";
      ["req"] = 16;
   };
   [391] = {
      ["name_ru"] = "Бунтовщики в тюрьме";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les Emeutes de la Prison";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Aufstand im Verlies";
      ["name"] = "The Stockade Riots";
      ["name_cn"] = "??暴?";
      ["objective"] = "Kill Bazil Thredd and bring his head back to Warden Thelwater at the Stockade.";
      ["next"] = 392;
      ["faction"] = "Alliance";
      ["sort"] = "The Stockade";
      ["prev"] = 389;
      ["prequests"] = {
         [1] = 389;
      };
      ["level"] = 29;
      ["name_es"] = "El motin de Las Mazmorras";
      ["req"] = 16;
   };
   [392] = {
      ["name_ru"] = "Таинственный посетитель";
      ["type"] = "Solo";
      ["name_fr"] = "Un curieux visiteur";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der seltsame Besucher";
      ["name"] = "The Curious Visitor";
      ["name_cn"] = "好奇的?客";
      ["objective"] = "Bring the Sealed Description of Thredd's Visitor to Baros Alexston in Stormwind.";
      ["next"] = 393;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 391;
      ["prequests"] = {
         [1] = 391;
      };
      ["level"] = 29;
      ["name_es"] = "Extrano visitante";
      ["req"] = 16;
   };
   [393] = {
      ["name_ru"] = "Тень прошлого";
      ["type"] = "Solo";
      ["name_fr"] = "Les Ombres du Passe";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Schatten der Vergangenheit";
      ["name"] = "Shadow of the Past";
      ["name_cn"] = "往日的?影";
      ["objective"] = "Bring the Sealed Description of Thredd's Visitor to Master Mathias Shaw in Stormwind.";
      ["next"] = 350;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 392;
      ["prequests"] = {
         [1] = 392;
      };
      ["level"] = 29;
      ["name_es"] = "Sombras del pasado";
      ["req"] = 16;
   };
   [394] = {
      ["name_ru"] = "Голова чудовища";
      ["type"] = "Solo";
      ["name_fr"] = "La tete de la bete";
      ["next"] = 395;
      ["name_de"] = "Der Kopf des Ganzen";
      ["name_cn"] = "禽?的首?";
      ["objective"] = "Speak to Mathias Shaw in Stormwind.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "The Head of the Beast";
      ["prev"] = 434;
      ["prequests"] = {
         [1] = 434;
      };
      ["level"] = 31;
      ["name_es"] = "La cabeza de la bestia";
      ["req"] = 16;
   };
   [395] = {
      ["name_ru"] = "Гибель братства";
      ["type"] = "Solo";
      ["name_fr"] = "La fin de la Confrerie";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Das Ende der Bruderschaft";
      ["name"] = "Brotherhood's End";
      ["name_cn"] = "兄弟会的?亡";
      ["objective"] = "Speak with Baros Alexston in Stormwind.";
      ["next"] = 396;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 394;
      ["prequests"] = {
         [1] = 394;
      };
      ["level"] = 31;
      ["name_es"] = "El fin de la Hermandad";
      ["req"] = 16;
   };
   [396] = {
      ["name_ru"] = "Аудиенция у короля";
      ["type"] = "Solo";
      ["objective"] = "Deliver Baros Alexston's report on the Defias Brotherhood to King Varian Wrynn in Stormwind Keep.";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Eine Audienz beim Konig";
      ["reward"] = {
         [1] = 2933;
      };
      ["name_cn"] = "??国王";
      ["name_fr"] = "Une audience avec le roi";
      ["faction"] = "Alliance";
      ["name"] = "An Audience with the King";
      ["sort"] = "Stormwind City";
      ["prev"] = 395;
      ["prequests"] = {
         [1] = 395;
      };
      ["level"] = 31;
      ["name_es"] = "Una audiencia con el Rey";
      ["req"] = 16;
   };
   [397] = {
      ["name_ru"] = "За достойную службу";
      ["type"] = "Solo";
      ["name_fr"] = "Vous nous avez bien servi";
      ["name_de"] = "Ihr habt uns gut gedient";
      ["sort"] = "Stormwind City";
      ["objective"] = "Speak with Zggi, the servant of Zardeth the Blackclaw, to claim your reward.";
      ["name_cn"] = "干得好";
      ["name"] = "You Have Served Us Well";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 3556;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 336;
      ["prequests"] = {
         [1] = 336;
      };
      ["level"] = 30;
      ["name_es"] = "Nos has hecho un gran servicio";
      ["req"] = 25;
   };
   [398] = {
      ["name_ru"] = "Разыскивается: Червеглаз";
      ["type"] = "Solo";
      ["objective"] = "Kill Maggot Eye and return to Executor Zygand in Brill with his paw for a reward.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Tirisfal Glades";
      ["name_fr"] = "On recherche?: ?il-de-ver";
      ["name_cn"] = "??：蛆眼";
      ["reward"] = {
         [1] = 5941;
         [2] = 3444;
      };
      ["name_de"] = "GESUCHT: Madenauge";
      ["faction"] = "Horde";
      ["name"] = "Wanted: Maggot Eye";
      ["level"] = 10;
      ["name_es"] = "Se busca: Ojo de cresa";
      ["req"] = 6;
   };
   [399] = {
      ["name_ru"] = "Скромные дары прошлого";
      ["type"] = "Solo";
      ["objective"] = "Go to Baros Alexston's house in Westfall and search for his compass, then return it to him in Cathedral Square of Stormwind.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "Debuts modestes";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "童年的??";
      ["name_de"] = "Ein bescheidener Anfang";
      ["faction"] = "Alliance";
      ["name"] = "Humble Beginnings";
      ["level"] = 15;
      ["name_es"] = "Principios humildes";
      ["req"] = 10;
   };
   [400] = {
      ["name_ru"] = "Инструменты для Сталежара";
      ["type"] = "Solo";
      ["objective"] = "Deliver Steelgrill's Tools to Beldin Steelgrill.";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_fr"] = "Des outils pour Grillacier";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "??丁的工具";
      ["name_de"] = "Werkzeuge fur Stahlrost";
      ["faction"] = "Alliance";
      ["name"] = "Tools for Steelgrill";
      ["level"] = 5;
      ["name_es"] = "Herramientas para Brasacerada";
      ["req"] = 2;
   };
   [401] = {
      ["name_ru"] = "Ожидание перевода";
      ["type"] = "Solo";
      ["name_fr"] = "Attendre la fin des travaux de Sirra";
      ["next"] = 252;
      ["name_de"] = "Wartet, bis Sirra fertig ist";
      ["name_cn"] = "等待希拉完工";
      ["objective"] = "Wait a moment, then speak with Sirra Von'Indi again.";
      ["sort"] = "Duskwood";
      ["faction"] = "Alliance";
      ["name"] = "Wait for Sirra to Finish";
      ["prev"] = 251;
      ["prequests"] = {
         [1] = 251;
      };
      ["level"] = 30;
      ["name_es"] = "Espera a que Sirra acabe";
      ["req"] = 20;
   };
   [403] = {
      ["name_ru"] = "Охраняемый бочонок Громоваров";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "戒?森?";
      ["name_fr"] = "La garde du tonneau de Tonnebiere";
      ["name_de"] = "Das bewachte Fass mit Donnerbier";
      ["faction"] = "Alliance";
      ["name"] = "Guarded Thunderbrew Barrel";
      ["level"] = 1;
      ["name_es"] = "El barril de Cebatruenos custodiado";
      ["req"] = 1;
   };
   [404] = {
      ["name_ru"] = "Грязная работа";
      ["type"] = "Solo";
      ["objective"] = "Bring 7 Putrid Claws to Deathguard Dillinger in Brill.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_fr"] = "Une tache putride";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "腐?的爪子";
      ["name_de"] = "Eine eitrige Aufgabe";
      ["faction"] = "Horde";
      ["name"] = "A Putrid Task";
      ["level"] = 6;
      ["name_es"] = "Una tarea putrida";
      ["req"] = 4;
   };
   [405] = {
      ["name_ru"] = "Блудный лич";
      ["type"] = "Solo";
      ["name_fr"] = "La Liche prodigue";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Der abtrunnige Lich";
      ["name"] = "The Prodigal Lich";
      ["name_cn"] = "流浪的巫妖";
      ["objective"] = "Present Sevren's Orders to Bethor Iceshard in the Undercity.";
      ["next"] = 357;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 358;
      ["prequests"] = {
         [1] = 358;
      };
      ["level"] = 8;
      ["name_es"] = "El exanime prodigo";
      ["req"] = 5;
   };
   [407] = {
      ["name_ru"] = "Поля Горя";
      ["type"] = "Solo";
      ["objective"] = "Take the Laced Pumpkin to the Captured Scarlet Zealot who is being held in the cellar of the Gallow's End Tavern.";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Felder des Kummers";
      ["name"] = "Fields of Grief";
      ["name_cn"] = "悲?之地";
      ["name_fr"] = "Les champs du Chagrin";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 365;
      ["prequests"] = {
         [1] = 365;
      };
      ["level"] = 7;
      ["name_es"] = "Campos de pena";
      ["req"] = 4;
   };
   [408] = {
      ["name_ru"] = "Семейный склеп";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Wailing Ancestors and 8 Rotting Ancestors.$B$BKill Captain Dargol, and bring his skull to Magistrate Sevren in Brill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Die Familiengruft";
      ["reward"] = {
         [1] = 3446;
         [2] = 3440;
      };
      ["name_cn"] = "家族墓穴";
      ["name_fr"] = "La Crypte Familiale";
      ["faction"] = "Horde";
      ["name"] = "The Family Crypt";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 355;
      ["prequests"] = {
         [1] = 355;
      };
      ["level"] = 13;
      ["name_es"] = "La Cripta de la Familia";
      ["req"] = 7;
   };
   [409] = {
      ["name_ru"] = "Доказательство преданности";
      ["type"] = "Solo";
      ["name_fr"] = "Prouver l'allegeance";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Treuebeweis";
      ["name"] = "Proving Allegiance";
      ["name_cn"] = "?明忠?";
      ["objective"] = "Obtain a Candle of Beckoning.$B$BSummon Lillith Nefara and kill her.$B$BReturn to Gunther on his island.";
      ["next"] = 411;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 366;
      ["prequests"] = {
         [1] = 366;
      };
      ["level"] = 12;
      ["name_es"] = "Prueba de lealtad";
      ["req"] = 5;
   };
   [410] = {
      ["name_ru"] = "Спящая тень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "潜伏的?影";
      ["name_fr"] = "L'Ombre dormante";
      ["name_de"] = "Der Schlummernde Schatten";
      ["faction"] = "Horde";
      ["name"] = "The Dormant Shade";
      ["level"] = 10;
      ["name_es"] = "Sombra durmiente";
      ["req"] = 5;
   };
   [411] = {
      ["name_ru"] = "Возвращение блудного лича";
      ["type"] = "Solo";
      ["objective"] = "Bring the Nether Gem to Bethor Iceshard in the Undercity.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Die Ruckkehr des abtrunnigen Lichs";
      ["reward"] = {
         [1] = 5940;
      };
      ["name_cn"] = "巫妖??";
      ["name_fr"] = "Le Retour de la Liche Prodigue";
      ["faction"] = "Horde";
      ["name"] = "The Prodigal Lich Returns";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 409;
      ["prequests"] = {
         [1] = 409;
      };
      ["level"] = 12;
      ["name_es"] = "El regreso del exanime prodigo";
      ["req"] = 5;
   };
   [412] = {
      ["name_ru"] = "Операция \"Перенаправление\"";
      ["type"] = "Solo";
      ["objective"] = "Bring Razzle Sprysprocket in Kharanos 8 Restabilization Cogs and 8 Gyromechanic Gears.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Operation Recombobulation";
      ["name_cn"] = "自??化装置";
      ["reward"] = {
         [1] = 3152;
         [2] = 3153;
      };
      ["name_de"] = "Operation Rekombobulationsgerat";
      ["faction"] = "Alliance";
      ["name"] = "Operation Recombobulation";
      ["level"] = 10;
      ["name_es"] = "Operacion Recombobulacion";
      ["req"] = 7;
   };
   [413] = {
      ["name_ru"] = "\"Мерцающий портер\"";
      ["type"] = "Solo";
      ["name_fr"] = "La Brune scintillante";
      ["repgain"] = {
         [54] = 75;
         [47] = 75;
      };
      ["name_de"] = "Schimmerstarkbier";
      ["name"] = "Shimmer Stout";
      ["name_cn"] = "微光酒";
      ["objective"] = "Take the Barrel of Shimmer Stout to Mountaineer Barleybrew.";
      ["next"] = 414;
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 315;
      ["prequests"] = {
         [1] = 315;
      };
      ["level"] = 10;
      ["name_es"] = "Cerveza negra Brillante";
      ["req"] = 8;
   };
   [414] = {
      ["name_ru"] = "Портер для Кэдрелла";
      ["type"] = "Solo";
      ["name_fr"] = "Une biere brune pour Kadrell";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_de"] = "Starkbier fur Kadrell";
      ["name_cn"] = "?德雷?的酒";
      ["name"] = "Stout to Kadrell";
      ["objective"] = "Take the Cask of Shimmer Stout to Mountaineer Kadrell.";
      ["faction"] = "Alliance";
      ["sort"] = "Dun Morogh";
      ["prev"] = 413;
      ["prequests"] = {
         [1] = 413;
      };
      ["level"] = 10;
      ["name_es"] = "Cerveza negra para Kadrell";
      ["req"] = 8;
   };
   [415] = {
      ["name_ru"] = "Новое пиво Регольда";
      ["objective"] = "Speak with Rejold Barleybrew.";
      ["name_cn"] = "雷杰德的新酒";
      ["sort"] = "Dun Morogh";
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "La nouvelle cuvee de Rejold";
      ["next"] = 413;
      ["name_de"] = "Rejolds neues Gebrau";
      ["repgain"] = {
         [54] = 10;
         [47] = 10;
      };
      ["reward"] = {
         [1] = 3087;
      };
      ["name"] = "Rejold's New Brew";
      ["prev"] = 315;
      ["prequests"] = {
         [1] = 315;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La nueva bebida de Rejold";
      ["req"] = 8;
   };
   [416] = {
      ["name_ru"] = "Ловля крыс";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Tunnel Rat Ears to Mountaineer Kadrell in Thelsamar.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Chasse au rat";
      ["name_cn"] = "狗?人的耳?";
      ["reward"] = {
         [1] = 3158;
         [2] = 860;
      };
      ["name_de"] = "Rattenfang";
      ["faction"] = "Alliance";
      ["name"] = "Rat Catching";
      ["level"] = 11;
      ["name_es"] = "Mata ratas";
      ["req"] = 10;
   };
   [417] = {
      ["name_ru"] = "Месть пилота";
      ["type"] = "Solo";
      ["objective"] = " but not before it mauled him savagely.$B$BJudging from the state of Hildelve's body";
      ["repgain"] = {
         [54] = 150;
         [0] = 47;
      };
      ["name_de"] = "Pilotenrache";
      ["reward"] = {
         [1] = 2218;
         [2] = 1009;
      };
      ["name_cn"] = "???的?仇";
      ["name_fr"] = "La revanche du pilote";
      ["faction"] = "Alliance";
      ["name"] = "A Pilot's Revenge";
      ["sort"] = "Dun Morogh";
      ["prev"] = 419;
      ["prequests"] = {
         [1] = 419;
      };
      ["level"] = 11;
      ["name_es"] = "Vengar al piloto";
      ["req"] = 8;
   };
   [418] = {
      ["name_ru"] = "Телcамарские кровяные колбаски";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 pieces of Bear Meat, 3 Boar Intestines, and 3 Spider Ichor to Vidra Hearthstove in Thelsamar.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Les boudins de Thelsamar";
      ["name_cn"] = "塞???血?";
      ["reward"] = {
         [1] = 3220;
         [2] = 3679;
      };
      ["name_de"] = "Blutwurst aus Thelsamar";
      ["faction"] = "Alliance";
      ["name"] = "Thelsamar Blood Sausages";
      ["level"] = 11;
      ["name_es"] = "Morcillas de Thelsamar";
      ["req"] = 7;
   };
   [419] = {
      ["name_ru"] = "Пропавший пилот";
      ["type"] = "Solo";
      ["objective"] = "Find Pilot Hildelve.";
      ["next"] = 417;
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Le pilote perdu";
      ["name_cn"] = "失踪的???";
      ["repgain"] = {
         [54] = 75;
         [47] = 75;
      };
      ["reward"] = {
         [1] = 3151;
      };
      ["name_de"] = "Der vermisste Pilot";
      ["faction"] = "Alliance";
      ["name"] = "The Lost Pilot";
      ["level"] = 10;
      ["name_es"] = "El piloto perdido";
      ["req"] = 8;
   };
   [420] = {
      ["name_ru"] = "Наблюдения Сенира";
      ["type"] = "Solo";
      ["objective"] = "Deliver Grelin's report to Senir Whitebeard in Kharanos.";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_de"] = "Senirs Beobachtungen";
      ["name"] = "Senir's Observations";
      ["name_cn"] = "森内?的?察站";
      ["name_fr"] = "Les observations de Senir";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Coldridge Valley";
      ["prev"] = 282;
      ["prequests"] = {
         [1] = 282;
      };
      ["level"] = 5;
      ["name_es"] = "Las observaciones de Senir";
      ["req"] = 1;
   };
   [421] = {
      ["name_ru"] = "Проявить себя";
      ["type"] = "Solo";
      ["objective"] = "Dalar Dawnweaver at the Sepulcher wants you to kill 5 Moonrage Whitescalps.";
      ["next"] = 422;
      ["name_fr"] = "Prouver votre valeur";
      ["sort"] = "Silverpine Forest";
      ["name_cn"] = "?明?的价?";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Wertbeweis";
      ["faction"] = "Horde";
      ["name"] = "Prove Your Worth";
      ["level"] = 10;
      ["name_es"] = "Demuestra tu valia";
      ["req"] = 9;
   };
   [422] = {
      ["name_ru"] = "Безрассудство Аругала";
      ["objective"] = "Retrieve the Remedy of Arugal for Dalar Dawnweaver at the Sepulcher.";
      ["name_cn"] = "阿?高的愚行";
      ["sort"] = "Silverpine Forest";
      ["level"] = 11;
      ["type"] = "Solo";
      ["name_fr"] = "La folie d'Arugal";
      ["next"] = 423;
      ["name_de"] = "Arugals Torheit";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Arugal's Folly";
      ["prev"] = 421;
      ["prequests"] = {
         [1] = 421;
      };
      ["series"] = 1;
      ["name_es"] = "La locura de Arugal";
      ["req"] = 9;
   };
   [423] = {
      ["name_ru"] = "Безрассудство Аругала";
      ["objective"] = "Bring 6 Glutton Shackles and 3 Darksoul Shackles to Dalar Dawnweaver at the Sepulcher.";
      ["name_cn"] = "阿?高的愚行";
      ["sort"] = "Silverpine Forest";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "La folie d'Arugal";
      ["next"] = 424;
      ["name_de"] = "Arugals Torheit";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Arugal's Folly";
      ["prev"] = 422;
      ["prequests"] = {
         [1] = 422;
      };
      ["series"] = 2;
      ["name_es"] = "La locura de Arugal";
      ["req"] = 9;
   };
   [424] = {
      ["name_ru"] = "Безрассудство Аругала";
      ["objective"] = "Kill Grimson the Pale and bring his head to Dalar Dawnweaver at the Sepulcher.";
      ["name_cn"] = "阿?高的愚行";
      ["sort"] = "Silverpine Forest";
      ["level"] = 15;
      ["type"] = "Solo";
      ["name_fr"] = "La folie d'Arugal";
      ["next"] = 99;
      ["name_de"] = "Arugals Torheit";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Arugal's Folly";
      ["prev"] = 423;
      ["prequests"] = {
         [1] = 423;
      };
      ["series"] = 3;
      ["name_es"] = "La locura de Arugal";
      ["req"] = 9;
   };
   [425] = {
      ["name_ru"] = "Ивар Нечистый";
      ["type"] = "Solo";
      ["objective"] = "Kill Ivar the Foul, and bring Ivar's Head to Rane Yorick at the Ivar Patch.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Ivar der Verfaulte";
      ["reward"] = {
         [1] = 3453;
         [2] = 3583;
      };
      ["name_cn"] = "邪?的伊瓦";
      ["name_fr"] = "Ivar l'Infect";
      ["faction"] = "Horde";
      ["name"] = "Ivar the Foul";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 430;
      ["prequests"] = {
         [1] = 430;
      };
      ["level"] = 12;
      ["name_es"] = "Ivar el Hediondo";
      ["req"] = 10;
   };
   [426] = {
      ["name_ru"] = "Нападение на мельницы";
      ["type"] = "Solo";
      ["objective"] = "Gather 5 Notched Ribs and 3 Blackened Skulls, then return to Deathguard Dillinger in Brill.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Die uberrannte Muhle";
      ["reward"] = {
         [1] = 3447;
         [2] = 3834;
      };
      ["name_cn"] = "磨坊告急";
      ["name_fr"] = "La chute des moulins";
      ["faction"] = "Horde";
      ["name"] = "The Mills Overrun";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 404;
      ["prequests"] = {
         [1] = 404;
      };
      ["level"] = 8;
      ["name_es"] = "La invasion de los molinos";
      ["req"] = 6;
   };
   [427] = {
      ["name_ru"] = "Война с Алым орденом";
      ["objective"] = "Executor Zygand of Brill wants you to kill 10 Scarlet Warriors.";
      ["name_cn"] = "与血色十字?的?争";
      ["sort"] = "Tirisfal Glades";
      ["level"] = 8;
      ["type"] = "Solo";
      ["name_fr"] = "En guerre avec la Croisade ecarlate";
      ["next"] = 370;
      ["name_de"] = "Im Krieg mit dem Scharlachroten Kreuzzug";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "At War With The Scarlet Crusade";
      ["prev"] = 383;
      ["prequests"] = {
         [1] = 383;
      };
      ["series"] = 1;
      ["name_es"] = "En guerra con la Cruzada Escarlata";
      ["req"] = 5;
   };
   [428] = {
      ["name_ru"] = "Пропавшие стражи смерти";
      ["type"] = "Solo";
      ["objective"] = "Find the Deathstalkers Quinn and Rane Yorick.";
      ["next"] = 429;
      ["name_fr"] = "Les necrotraqueurs egares";
      ["sort"] = "Silverpine Forest";
      ["name_cn"] = "失踪的亡?哨兵";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Die verlorenen Todespirscher";
      ["faction"] = "Horde";
      ["name"] = "Lost Deathstalkers";
      ["level"] = 12;
      ["name_es"] = "Los Mortacechadores desaparecidos";
      ["req"] = 10;
   };
   [429] = {
      ["name_ru"] = "Звериные сердца";
      ["objective"] = "Gather 6 discolored worg hearts and bring them to Apothecary Renferrel at the Sepulcher.";
      ["name_cn"] = "荒野之心";
      ["sort"] = "Silverpine Forest";
      ["level"] = 11;
      ["type"] = "Solo";
      ["name_fr"] = "C?urs sauvages";
      ["next"] = 430;
      ["name_de"] = "Wilde Herzen";
      ["repgain"] = {
         [68] = 75;
      };
      ["reward"] = {
         [1] = 4597;
         [2] = 4596;
      };
      ["name"] = "Wild Hearts";
      ["prev"] = 428;
      ["prequests"] = {
         [1] = 428;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Corazones salvajes";
      ["req"] = 10;
   };
   [430] = {
      ["name_ru"] = "Назад к Квинну";
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers Quinn";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Ruckkehr zu Quinn";
      ["name_cn"] = "回到奎恩身旁";
      ["name"] = "Return to Quinn";
      ["objective"] = "Bring Quinn's potion to Quinn Yorick at the Ivar Patch, north of the Sepulcher.";
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 429;
      ["prequests"] = {
         [1] = 429;
      };
      ["level"] = 11;
      ["name_es"] = "Regresa junto a Quinn";
      ["req"] = 10;
   };
   [431] = {
      ["name_ru"] = "Манящие свечи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tirisfal Glades";
      ["name_fr"] = "Bougies de signal";
      ["name_cn"] = "????";
      ["reward"] = {
         [1] = 3080;
      };
      ["name_de"] = "Kerze des Heranlockens";
      ["faction"] = "Horde";
      ["name"] = "Candles of Beckoning";
      ["level"] = 10;
      ["name_es"] = "Velas de senalizacion";
      ["req"] = 5;
   };
   [432] = {
      ["name_ru"] = "Проклятые трогги!";
      ["type"] = "Solo";
      ["objective"] = "Kill 6 Rockjaw Skullthumpers for Foreman Stonebrow at the Gol'Bolar quarry.";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_fr"] = "Ces satanes troggs !";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "?死的石?怪！";
      ["name_de"] = "Diese verfluchten Troggs!";
      ["faction"] = "Alliance";
      ["name"] = "Those Blasted Troggs!";
      ["level"] = 9;
      ["name_es"] = "!Malditos troggs!";
      ["req"] = 5;
   };
   [433] = {
      ["name_ru"] = "Слуга народа";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Rockjaw Bonesnappers for Senator Mehr Stonehallow at the Gol'Bolar quarry.";
      ["repgain"] = {
         [54] = 150;
         [47] = 150;
      };
      ["name_fr"] = "Le serviteur public";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "公?之仆";
      ["name_de"] = "Im Dienste des Volkes";
      ["faction"] = "Alliance";
      ["name"] = "The Public Servant";
      ["level"] = 11;
      ["name_es"] = "El servidor publico";
      ["req"] = 6;
   };
   [434] = {
      ["name_ru"] = "Нападение!";
      ["type"] = "Solo";
      ["name_fr"] = "L'attaque?!";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Der Angriff!";
      ["name"] = "The Attack!";
      ["name_cn"] = "伏?！";
      ["objective"] = "Remain in the garden until Lord Gregor Lescovar and Marzon the Silent Blade have had their conversation. Afterwards, kill them both before returning to Elling Trias in Stormwind.";
      ["next"] = 394;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 2746;
      ["prequests"] = {
         [1] = 2746;
      };
      ["level"] = 31;
      ["name_es"] = "El ataque";
      ["req"] = 16;
   };
   [435] = {
      ["name_ru"] = "Сопровождая Эрланда";
      ["type"] = "Solo";
      ["objective"] = "Escort Erland through the wolves, to Rane Yorick.";
      ["next"] = 449;
      ["sort"] = "Silverpine Forest";
      ["name_fr"] = "Une escorte pour Erland";
      ["name_cn"] = "?送埃?德";
      ["repgain"] = {
         [68] = 250;
      };
      ["reward"] = {
         [1] = 3455;
      };
      ["name_de"] = "Eskorte fur Erland";
      ["faction"] = "Horde";
      ["name"] = "Escorting Erland";
      ["level"] = 11;
      ["name_es"] = "Escolta a Erland";
      ["req"] = 10;
   };
   [436] = {
      ["name_ru"] = "Раскопки Сталекрута";
      ["type"] = "Solo";
      ["objective"] = "Speak with Explorer Fellhew.";
      ["next"] = 297;
      ["name_fr"] = "Les fouilles de Baguefer";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "???掘?";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Eisenbands Ausgrabungsstatte";
      ["faction"] = "Alliance";
      ["name"] = "Ironband's Excavation";
      ["level"] = 18;
      ["name_es"] = "La excavacion de Vetaferro";
      ["req"] = 13;
   };
   [437] = {
      ["name_ru"] = "Мертвое поле";
      ["type"] = "Solo";
      ["objective"] = "Kill rot hide gnolls at the Dead Fields.$B$BWhen Nightlash appears, kill her.$B$BBring the Essence of Nightlash to High Executor Hadrec at the Sepulcher.";
      ["next"] = 438;
      ["sort"] = "Silverpine Forest";
      ["name_fr"] = "Le Champ des morts";
      ["name_cn"] = "亡者??";
      ["repgain"] = {
         [68] = 250;
      };
      ["reward"] = {
         [1] = 3454;
      };
      ["name_de"] = "Das Todesfeld";
      ["faction"] = "Horde";
      ["name"] = "The Dead Fields";
      ["level"] = 14;
      ["name_es"] = "El Campo Muerto";
      ["req"] = 10;
   };
   [438] = {
      ["name_ru"] = "Старая переправа";
      ["type"] = "Solo";
      ["name_fr"] = "Le bac delabre";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Die verfallene Fahre";
      ["name"] = "The Decrepit Ferry";
      ["name_cn"] = "破旧渡口";
      ["objective"] = "Go to the Decrepit Ferry.$B$BSearch for the reason the Scourge are there.";
      ["next"] = 439;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 437;
      ["prequests"] = {
         [1] = 437;
      };
      ["level"] = 16;
      ["name_es"] = "El Viejo Embarcadero";
      ["req"] = 10;
   };
   [439] = {
      ["name_ru"] = "Необычная находка";
      ["type"] = "Solo";
      ["name_fr"] = "Un indice vers les Poils-putrides";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Auf den Spuren der Moderfelle";
      ["name"] = "Rot Hide Clues";
      ["name_cn"] = "?索";
      ["objective"] = "Bring Deliah's Ring to High Executor Hadrec at the Sepulcher.";
      ["next"] = 443;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 438;
      ["prequests"] = {
         [1] = 438;
      };
      ["level"] = 16;
      ["name_es"] = "Pistas de Putrepellejos";
      ["req"] = 10;
   };
   [440] = {
      ["name_ru"] = "Кольцо с гравировкой";
      ["type"] = "Solo";
      ["name_fr"] = "La bague ciselee";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Der gravierte Ring";
      ["name"] = "The Engraved Ring";
      ["name_cn"] = "黛??的戒指";
      ["objective"] = "Bring Deliah's Ring to Magistrate Sevren in Brill.";
      ["next"] = 441;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 439;
      ["prequests"] = {
         [1] = 439;
      };
      ["level"] = 16;
      ["name_es"] = "El anillo grabado";
      ["req"] = 10;
   };
   [441] = {
      ["name_ru"] = "Роли, который живет в Подгороде";
      ["type"] = "Solo";
      ["name_fr"] = "Raleigh et Fossoyeuse";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Raleigh und Unterstadt";
      ["name"] = "Raleigh and the Undercity";
      ["name_cn"] = "拉林夫与幽暗城";
      ["objective"] = "Bring Deliah's Ring to Raleigh.";
      ["next"] = 530;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 440;
      ["prequests"] = {
         [1] = 440;
      };
      ["level"] = 16;
      ["name_es"] = "Raleigh y Entranas";
      ["req"] = 10;
   };
   [442] = {
      ["name_ru"] = "Атака на остров Фенриса";
      ["type"] = "Group";
      ["objective"] = "Bring Thule's Head to High Executor Hadrec at the Sepulcher.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Sturm auf die Insel Fenris";
      ["reward"] = {
         [1] = 3461;
         [2] = 3462;
      };
      ["name_cn"] = "突?芬里斯?";
      ["name_fr"] = "L'attaque de l'ile de Fenris";
      ["faction"] = "Horde";
      ["name"] = "Assault on Fenris Isle";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 448;
      ["prequests"] = {
         [1] = 448;
      };
      ["level"] = 24;
      ["name_es"] = "Asalto a la Isla de Fenris";
      ["req"] = 10;
   };
   [443] = {
      ["name_ru"] = "Лимфа Гнилошкуров";
      ["type"] = "Solo";
      ["name_fr"] = "L'ichor de Poil-putride";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Moderfellsekret";
      ["name"] = "Rot Hide Ichor";
      ["name_cn"] = "腐皮豺狼人的?液";
      ["objective"] = "Bring 8 bottles of rot hide ichor to Apothecary Renferrel at the Sepulcher.";
      ["next"] = 444;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 438;
      ["prequests"] = {
         [1] = 438;
      };
      ["level"] = 17;
      ["name_es"] = "Icor de Putrepellejo";
      ["req"] = 10;
   };
   [444] = {
      ["name_ru"] = "Происхождение Гнилошкуров";
      ["type"] = "Solo";
      ["name_fr"] = "L'origine des Poils-putrides";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Die Ursprunge der Moderfelle";
      ["name_cn"] = "腐皮豺狼人的?生";
      ["name"] = "Rot Hide Origins";
      ["objective"] = "Bring the Sample Ichor to Bethor Iceshard in the Undercity.";
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 443;
      ["prequests"] = {
         [1] = 443;
      };
      ["level"] = 17;
      ["name_es"] = "El origen de los Putrepellejos";
      ["req"] = 10;
   };
   [445] = {
      ["name_ru"] = "Доставка в Серебряный бор";
      ["type"] = "Solo";
      ["objective"] = "Take Apothecary Johaan's findings to Apothecary Renferrel in Silverpine Forest.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_fr"] = "Livraison dans la foret des Pins argentes";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "??松森林送信";
      ["name_de"] = "Lieferung in den Silberwald";
      ["faction"] = "Horde";
      ["name"] = "Delivery to Silverpine Forest";
      ["level"] = 10;
      ["name_es"] = "Entrega a Bosque de Argenteos";
      ["req"] = 9;
   };
   [446] = {
      ["name_ru"] = "Тул Коготь Ворона";
      ["objective"] = "Bring Bethor's Scroll to Apothecary Renferrel at the Silverpine Sepulcher.";
      ["name_cn"] = "?勒・?爪";
      ["sort"] = "Silverpine Forest";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Thule Serres-de-corbeau";
      ["next"] = 448;
      ["name_de"] = "Thule Rabenklaue";
      ["repgain"] = {
         [68] = 25;
      };
      ["reward"] = {
         [1] = 3251;
      };
      ["name"] = "Thule Ravenclaw";
      ["prev"] = 444;
      ["prequests"] = {
         [1] = 444;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Thule Corvozarpa";
      ["req"] = 10;
   };
   [447] = {
      ["name_ru"] = "Рецептура смерти";
      ["type"] = "Solo";
      ["name_fr"] = "Une recette mortelle";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Rezept fur den Tod";
      ["name"] = "A Recipe For Death";
      ["name_cn"] = "致命的配方";
      ["objective"] = "Collect 6 Grizzled Bear Hearts and 6 samples of Skittering Blood and deliver them to Master Apothecary Faranell in the Undercity.";
      ["next"] = 450;
      ["series"] = 1;
      ["sort"] = "Silverpine Forest";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 3448;
      };
      ["level"] = 12;
      ["name_es"] = "Una formula mortal";
      ["req"] = 9;
   };
   [448] = {
      ["name_ru"] = "Доложиться Хадрику";
      ["objective"] = "Report to High Executor Hadrec at the Sepulcher.";
      ["name_cn"] = "?哈德瑞克的?告";
      ["sort"] = "Silverpine Forest";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Un rapport pour Hadrec";
      ["next"] = 442;
      ["name_de"] = "Meldung bei Hadrec";
      ["repgain"] = {
         [68] = 75;
      };
      ["reward"] = {
         [1] = 3240;
         [2] = 2313;
         [3] = 2863;
      };
      ["name"] = "Report to Hadrec";
      ["prev"] = 446;
      ["prequests"] = {
         [1] = 446;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Presentate ante Hadrec";
      ["req"] = 10;
   };
   [449] = {
      ["name_ru"] = "Отчет стражей смерти";
      ["type"] = "Solo";
      ["name_fr"] = "Le rapport des necrotraqueurs";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Der Bericht der Todespirscher";
      ["name"] = "The Deathstalkers' Report";
      ["name_cn"] = "亡?哨兵的?告";
      ["objective"] = "Bring the Deathstalker Report to High Executor Hadrec at the Sepulcher.";
      ["next"] = 3221;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 435;
      ["prequests"] = {
         [1] = 435;
      };
      ["level"] = 11;
      ["name_es"] = "El informe de los Mortacechadores";
      ["req"] = 10;
   };
   [450] = {
      ["name_ru"] = "Рецептура смерти";
      ["objective"] = "Retrieve Apothecary Berard's journal from Pyrewood Village and take it to Apothecary Renferrel at the Sepulcher.";
      ["name_cn"] = "致命的配方";
      ["sort"] = "Silverpine Forest";
      ["level"] = 15;
      ["type"] = "Group";
      ["name_fr"] = "Une recette mortelle";
      ["next"] = 451;
      ["name_de"] = "Rezept fur den Tod";
      ["repgain"] = {
         [68] = 350;
      };
      ["faction"] = "Horde";
      ["name"] = "A Recipe For Death";
      ["prev"] = 447;
      ["prequests"] = {
         [1] = 447;
      };
      ["series"] = 2;
      ["name_es"] = "Una formula mortal";
      ["req"] = 9;
   };
   [451] = {
      ["name_ru"] = "Рецептура смерти";
      ["objective"] = "Bring 6 samples of Lake Creeper Moss, 6 samples of Lake Skulker Moss and a Hardened Tumor to Master Apothecary Faranell in the Undercity.";
      ["name_cn"] = "致命的配方";
      ["sort"] = "Silverpine Forest";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "Une recette mortelle";
      ["repgain"] = {
         [68] = 500;
      };
      ["name_de"] = "Rezept fur den Tod";
      ["reward"] = {
         [1] = 3451;
         [2] = 2458;
         [3] = 3582;
         [4] = 2459;
      };
      ["faction"] = "Horde";
      ["name"] = "A Recipe For Death";
      ["prev"] = 450;
      ["prequests"] = {
         [1] = 450;
      };
      ["series"] = 3;
      ["name_es"] = "Una formula mortal";
      ["req"] = 9;
   };
   [452] = {
      ["name_ru"] = "Засада в деревне";
      ["type"] = "Group";
      ["objective"] = "Help Deathstalker Faerleia kill the Pyrewood Council.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Silverpine Forest";
      ["name_fr"] = "Embuscade a Bois-du-Bucher";
      ["name_cn"] = "焚木村中的伏?";
      ["reward"] = {
         [1] = 3450;
         [2] = 2818;
         [3] = 3449;
      };
      ["name_de"] = "Hinterhalt in Lohenscheit";
      ["faction"] = "Horde";
      ["name"] = "Pyrewood Ambush";
      ["level"] = 15;
      ["name_es"] = "La emboscada de Aldea Pirolena";
      ["req"] = 12;
   };
   [453] = {
      ["name_ru"] = "Поиски таинственного незнакомца";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de l'obscure silhouette";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Auf der Suche nach der Schattengestalt";
      ["name"] = "Finding the Shadowy Figure";
      ["name_cn"] = "搜????";
      ["objective"] = "Find the Shadowy Figure.  Your clues:$B$BHe is not native to Darkshire.$B$BHe is a nervous, jittery person.$B$BHe left Darkshire and headed west.";
      ["next"] = 268;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 266;
      ["prequests"] = {
         [1] = 266;
      };
      ["level"] = 25;
      ["name_es"] = "Encuentra la figura misteriosa";
      ["req"] = 20;
   };
   [454] = {
      ["name_ru"] = "После засады";
      ["type"] = "Solo";
      ["name_fr"] = "Apres l'embuscade";
      ["repgain"] = {
         [47] = 10;
      };
      ["name_de"] = "Nach dem Hinterhalt";
      ["name_cn"] = "??之后";
      ["name"] = "After the Ambush";
      ["objective"] = "Speak with Miran.";
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 273;
      ["prequests"] = {
         [1] = 273;
      };
      ["level"] = 15;
      ["name_es"] = "Tras la emboscada";
      ["req"] = 10;
   };
   [455] = {
      ["name_ru"] = "Альгазская битва";
      ["type"] = "Solo";
      ["name_fr"] = "Le defi d'Algaz";
      ["repgain"] = {
         [54] = 75;
         [47] = 150;
         [69] = 75;
      };
      ["name_de"] = "Der Algaz-Spiesrutenlauf";
      ["name_cn"] = "丹奥加?告急";
      ["name"] = "The Algaz Gauntlet";
      ["objective"] = "Traverse Dun Algaz.$B$BKill 8 Dragonmaw Scouts and 6 Dragonmaw Grunts.$B$BReport to Valstag Ironjaw in Menethil Harbor.";
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 468;
      ["prequests"] = {
         [1] = 468;
      };
      ["level"] = 21;
      ["name_es"] = "El asedio de Algaz";
      ["req"] = 19;
   };
   [456] = {
      ["name_ru"] = "Природное равновесие";
      ["type"] = "Solo";
      ["objective"] = "Kill 7 Young Nightsabers and 4 Young Thistle Boars and return to Conservator Ilthalaine.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Shadowglen";
      ["name_fr"] = "L'equilibre de la nature";
      ["name_cn"] = "自然的平衡";
      ["followup"] = 457;
      ["reward"] = {
         [1] = 5394;
         [2] = 11187;
      };
      ["name_de"] = "Das Gleichgewicht der Natur";
      ["faction"] = "Alliance";
      ["name"] = "The Balance of Nature";
      ["level"] = 2;
      ["name_es"] = "El equilibrio de la naturaleza";
      ["req"] = 1;
   };
   [457] = {
      ["name_ru"] = "Природное равновесие";
      ["type"] = "Solo";
      ["objective"] = "Conservator Ilthalaine needs you to kill 7 Mangy Nightsabers and 7 Thistle Boars.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Das Gesetz der Natur";
      ["reward"] = {
         [1] = 5405;
         [2] = 6058;
      };
      ["name_cn"] = "自然的平衡";
      ["name_fr"] = "L'Equilibre de la nature";
      ["faction"] = "Alliance";
      ["name"] = "The Balance of Nature";
      ["sort"] = "Shadowglen";
      ["prev"] = 456;
      ["prequests"] = {
         [1] = 456;
      };
      ["level"] = 3;
      ["name_es"] = "En deuda con la naturaleza";
      ["req"] = 1;
   };
   [458] = {
      ["name_ru"] = "Защитница леса";
      ["type"] = "Solo";
      ["name_fr"] = "La protectrice sylvestre";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Die Beschutzerin des Waldlandes";
      ["name_cn"] = "森林守?者";
      ["objective"] = "Seek out the dryad known as Tarindrella.";
      ["next"] = 459;
      ["sort"] = "Shadowglen";
      ["name"] = "The Woodland Protector";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 1;
      ["name_es"] = "La protectora de los bosques";
      ["req"] = 1;
   };
   [459] = {
      ["name_ru"] = "Защитница леса";
      ["objective"] = "Collect 8 Fel Moss and bring them to Tarindrella.";
      ["name_cn"] = "森林守?者";
      ["sort"] = "Shadowglen";
      ["level"] = 3;
      ["type"] = "Solo";
      ["name_fr"] = "La protectrice sylvestre";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Damonische Diebe";
      ["reward"] = {
         [1] = 5398;
         [2] = 961;
         [3] = 5399;
         [4] = 11190;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Woodland Protector";
      ["prev"] = 458;
      ["prequests"] = {
         [1] = 458;
      };
      ["series"] = 2;
      ["name_es"] = "Ladrones demoniacos";
      ["req"] = 1;
   };
   [460] = {
      ["name_ru"] = "В целости и сохранности";
      ["type"] = "Solo";
      ["objective"] = " but instead his spell gave me an unlife from which I cannot escape.  And after creating the cursed rot hide gnolls";
      ["next"] = 461;
      ["name_fr"] = "Reposer en… pieces";
      ["sort"] = "Silverpine Forest";
      ["name_cn"] = "支?破碎";
      ["repgain"] = {
         [0] = 68;
      };
      ["name_de"] = "In Stucken begraben";
      ["faction"] = "Horde";
      ["name"] = "Resting in Pieces";
      ["level"] = 17;
      ["name_es"] = "Descansar en piezas";
      ["req"] = 12;
   };
   [461] = {
      ["name_ru"] = "Замаскированный тайник";
      ["type"] = "Solo";
      ["name_fr"] = "L'alcove secrete";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Die versteckte Nische";
      ["name"] = "The Hidden Niche";
      ["name_cn"] = "密室";
      ["objective"] = "Take Alaric to the hidden alcove.";
      ["next"] = 491;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 460;
      ["prequests"] = {
         [1] = 460;
      };
      ["level"] = 18;
      ["name_es"] = "El nicho oculto";
      ["req"] = 12;
   };
   [463] = {
      ["name_ru"] = "Страж Природы";
      ["type"] = "Solo";
      ["objective"] = "Find the Greenwarden.";
      ["next"] = 276;
      ["sort"] = "Wetlands";
      ["name_cn"] = "?色守?者";
      ["name_fr"] = "Le Gouverneur vert";
      ["name_de"] = "Der Sumpfhuter";
      ["faction"] = "Alliance";
      ["name"] = "The Greenwarden";
      ["level"] = 21;
      ["name_es"] = "El Guardaverde";
      ["req"] = 20;
   };
   [464] = {
      ["name_ru"] = "Боевые знамена";
      ["type"] = "Solo";
      ["name_fr"] = "Bannieres de guerre";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Kriegsflaggen";
      ["name"] = "War Banners";
      ["name_cn"] = "?喉?旗";
      ["objective"] = "Bring 8 Dragonmaw War Banners to Captain Stoutfist.";
      ["next"] = 465;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 473;
      ["prequests"] = {
         [1] = 473;
      };
      ["level"] = 28;
      ["name_es"] = "Estandartes de batalla";
      ["req"] = 23;
   };
   [465] = {
      ["name_ru"] = "Гамбит Нек'роша";
      ["type"] = "Solo";
      ["name_fr"] = "La man?uvre de Nek'rosh";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Nek'roshs Schachzug";
      ["name"] = "Nek'rosh's Gambit";
      ["name_cn"] = "?克?什的??";
      ["objective"] = "Destroy the Dragonmaw catapults.";
      ["next"] = 474;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 464;
      ["prequests"] = {
         [1] = 464;
      };
      ["level"] = 31;
      ["name_es"] = "La estrategia de Nek'rosh";
      ["req"] = 23;
   };
   [466] = {
      ["name_ru"] = "Поиски огневита";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 loads of Incendicite Ore to Pilot Stonegear in Dun Morogh.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Auf der Suche nach Pyrophor";
      ["reward"] = {
         [1] = 3565;
      };
      ["name_cn"] = "火岩?石";
      ["name_fr"] = "A la recherche de l'incendicite";
      ["faction"] = "Alliance";
      ["name"] = "Search for Incendicite";
      ["sort"] = "Dun Morogh";
      ["prev"] = 467;
      ["prequests"] = {
         [1] = 467;
      };
      ["level"] = 22;
      ["name_es"] = "Busqueda de incendicita";
      ["req"] = 20;
   };
   [467] = {
      ["name_ru"] = "Найдите Камнекожца";
      ["type"] = "Solo";
      ["objective"] = "Speak with Pilot Stonegear.";
      ["next"] = 466;
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "迪恩・石?的梦想";
      ["name_fr"] = "La quete d'Engrepierre";
      ["name_de"] = "Steinsegels Suche";
      ["faction"] = "Alliance";
      ["name"] = "Stonegear's Search";
      ["level"] = 23;
      ["name_es"] = "La busqueda de los Roscapiedra";
      ["req"] = 20;
   };
   [468] = {
      ["name_ru"] = "Отчитайтесь перед горным пехотинцем Рокхаром";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mountaineer Rockgar.";
      ["next"] = 455;
      ["name_fr"] = "Un rapport pour le Montagnard Rochegar";
      ["sort"] = "Wetlands";
      ["name_cn"] = "向巡山人?克加?告";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Meldung bei Gebirgsjager Felsgar";
      ["faction"] = "Alliance";
      ["name"] = "Report to Mountaineer Rockgar";
      ["level"] = 21;
      ["name_es"] = "Presentate ante el montaraz Piedragar";
      ["req"] = 19;
   };
   [469] = {
      ["name_ru"] = "Ежедневная доставка";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Bundle of Crocolisk Skins to James Halloran, the tanner, in Menethil Harbor.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_fr"] = "Livraison quotidienne";
      ["sort"] = "Wetlands";
      ["name_cn"] = "日常供?";
      ["name_de"] = "Tagliche Lieferung";
      ["faction"] = "Alliance";
      ["name"] = "Daily Delivery";
      ["level"] = 21;
      ["name_es"] = "Entrega cotidiana";
      ["req"] = 18;
   };
   [470] = {
      ["name_ru"] = "Прожорливый слизнюк";
      ["type"] = "Solo";
      ["objective"] = "One of the oozes at Ironbeard's Tomb has Sida's bag, retrieve it and bring it back to her in Menethil Harbor.";
      ["repgain"] = {
         [47] = 350;
      };
      ["sort"] = "Wetlands";
      ["name_fr"] = "En creusant dans la vase";
      ["name_cn"] = "搜??泥怪";
      ["reward"] = {
         [1] = 3352;
      };
      ["name_de"] = "Stochern im Schlamm";
      ["faction"] = "Alliance";
      ["name"] = "Digging Through the Ooze";
      ["level"] = 24;
      ["name_es"] = "Abriendose paso entre los mocos";
      ["req"] = 19;
   };
   [471] = {
      ["name_ru"] = "Тяжкая судьба помощника";
      ["type"] = "Solo";
      ["objective"] = "Collect 6 Giant Crocolisk Skins and bring them to James Halloran in Menethil Harbor.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Lehrlingspflichten";
      ["reward"] = {
         [1] = 2545;
         [2] = 3681;
         [3] = 3561;
      };
      ["name_cn"] = "学徒的??";
      ["name_fr"] = "Les devoirs de l'apprenti";
      ["faction"] = "Alliance";
      ["name"] = "Apprentice's Duties";
      ["sort"] = "Wetlands";
      ["prev"] = 484;
      ["prequests"] = {
         [1] = 484;
      };
      ["level"] = 26;
      ["name_es"] = "Deberes de aprendiz";
      ["req"] = 18;
   };
   [472] = {
      ["name_ru"] = "Падение Дун Модра";
      ["type"] = "Solo";
      ["objective"] = "Search for Longbraid near the town of Dun Modr.";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_fr"] = "La chute de Dun Modr";
      ["sort"] = "Wetlands";
      ["name_cn"] = "丹莫德的陷落";
      ["name_de"] = "Der Fall von Dun Modr";
      ["faction"] = "Alliance";
      ["name"] = "Fall of Dun Modr";
      ["level"] = 25;
      ["name_es"] = "La caida de Dun Modr";
      ["req"] = 25;
   };
   [473] = {
      ["name_ru"] = "Доклад капитану Крепкому Кулаку";
      ["type"] = "Solo";
      ["objective"] = "Speak with Captain Stoutfist.";
      ["next"] = 464;
      ["name_fr"] = "Un rapport au capitaine Rudepoing";
      ["sort"] = "Wetlands";
      ["name_cn"] = "向斯托菲???告";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Meldung bei Hauptmann Starkfaust";
      ["faction"] = "Alliance";
      ["name"] = "Report to Captain Stoutfist";
      ["level"] = 28;
      ["name_es"] = "Presentate ante el capitan Punorrecio";
      ["req"] = 23;
   };
   [474] = {
      ["name_ru"] = "Убить Нек'роша";
      ["type"] = "Group";
      ["objective"] = "Kill Chieftain Nek'rosh$B$BBring Nek'rosh's Head to Captain Stoutfist.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Sieg uber Nek'rosh";
      ["reward"] = {
         [1] = 3209;
         [2] = 6194;
      };
      ["name_cn"] = "???克?什";
      ["name_fr"] = "Vaincre Nek'rosh";
      ["faction"] = "Alliance";
      ["name"] = "Defeat Nek'rosh";
      ["sort"] = "Wetlands";
      ["prev"] = 465;
      ["prequests"] = {
         [1] = 465;
      };
      ["level"] = 32;
      ["name_es"] = "Derrota a Nek'rosh";
      ["req"] = 23;
   };
   [475] = {
      ["name_ru"] = "Ветер тревоги";
      ["type"] = "Solo";
      ["objective"] = "Seek out Gaerolas Talvethren in Starbreeze Village.$B";
      ["next"] = 476;
      ["name_fr"] = "Une brise etrange";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "??之?";
      ["repgain"] = {
         [69] = 50;
      };
      ["name_de"] = "Ein beunruhigender Wind";
      ["faction"] = "Alliance";
      ["name"] = "A Troubling Breeze";
      ["level"] = 6;
      ["name_es"] = "Una brisa problematica";
      ["req"] = 4;
   };
   [476] = {
      ["name_ru"] = "Порча Кривой Сосны";
      ["type"] = "Solo";
      ["name_fr"] = "La corruption des Pins-tordus";
      ["repgain"] = {
         [69] = 100;
      };
      ["name_de"] = "Die Verderbnis der Knarzklauen";
      ["name"] = "Gnarlpine Corruption";
      ["name_cn"] = "瘤背熊怪的堕落";
      ["objective"] = "Return to Athridas Bearmantle in Dolanaar.";
      ["next"] = 483;
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 475;
      ["prequests"] = {
         [1] = 475;
      };
      ["level"] = 6;
      ["name_es"] = "Corrupcion en Tuercepinos";
      ["req"] = 4;
   };
   [477] = {
      ["name_ru"] = "Пересечение границ";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the contents of one of the Dalaran wizards' crates. You will find Pyrewood Village to the south.";
      ["next"] = 478;
      ["name_fr"] = "Frontieres";
      ["sort"] = "Silverpine Forest";
      ["name_cn"] = "越境";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Grenzubergange";
      ["faction"] = "Horde";
      ["name"] = "Border Crossings";
      ["level"] = 14;
      ["name_es"] = "Pasa la frontera";
      ["req"] = 10;
   };
   [478] = {
      ["name_ru"] = "Карты и руны";
      ["type"] = "Solo";
      ["name_fr"] = "Des cartes et des runes";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Karten und Runen";
      ["name"] = "Maps and Runes";
      ["name_cn"] = "地?与符?";
      ["objective"] = "Bring the strange pendant to Shadow Priest Allister at the Sepulcher.";
      ["next"] = 481;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 477;
      ["prequests"] = {
         [1] = 477;
      };
      ["level"] = 14;
      ["name_es"] = "Mapas y runas";
      ["req"] = 10;
   };
   [479] = {
      ["name_ru"] = "Расследование в Янтарной Мельнице";
      ["type"] = "Solo";
      ["name_fr"] = "Enquete a Moulin-de-l'Ambre";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Nachforschungen in Muhlenbern";
      ["name"] = "Ambermill Investigations";
      ["name_cn"] = "??安伯米?";
      ["objective"] = "Obtain 8 Dalaran Pendants for Shadow Priest Allister at the Sepulcher.";
      ["next"] = 480;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 482;
      ["prequests"] = {
         [1] = 482;
      };
      ["level"] = 16;
      ["name_es"] = "Las investigaciones de Molino Ambar";
      ["req"] = 10;
   };
   [480] = {
      ["name_ru"] = "Ткач";
      ["type"] = "Solo";
      ["objective"] = "Kill the Dalaran archmage, then retrieve his staff for Shadow Priest Allister at the Sepulcher.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Der Wirker";
      ["reward"] = {
         [1] = 3452;
         [2] = 3585;
      };
      ["name_cn"] = "法?的??";
      ["name_fr"] = "Le Tisserand";
      ["faction"] = "Horde";
      ["name"] = "The Weaver";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 479;
      ["prequests"] = {
         [1] = 479;
      };
      ["level"] = 22;
      ["name_es"] = "El Tejedor";
      ["req"] = 10;
   };
   [481] = {
      ["name_ru"] = "Анализ Далара";
      ["type"] = "Solo";
      ["name_fr"] = "L'analyse de Dalar";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Dalars Analyse";
      ["name"] = "Dalar's Analysis";
      ["name_cn"] = "?拉?的推理";
      ["objective"] = "Take the rune-inscribed pendant to Dalar Dawnweaver at the Sepulcher.";
      ["next"] = 482;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 478;
      ["prequests"] = {
         [1] = 478;
      };
      ["level"] = 14;
      ["name_es"] = "El analisis de Dalar";
      ["req"] = 10;
   };
   [482] = {
      ["name_ru"] = "Планы Даларана";
      ["type"] = "Solo";
      ["name_fr"] = "Les intentions de Dalaran";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Dalaran Absichten";
      ["name"] = "Dalaran's Intentions";
      ["name_cn"] = "?拉然的意?";
      ["objective"] = "Speak with Shadow Priest Allister at the Sepulcher.";
      ["next"] = 479;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 481;
      ["prequests"] = {
         [1] = 481;
      };
      ["level"] = 14;
      ["name_es"] = "Las intenciones de los Dalaran";
      ["req"] = 10;
   };
   [483] = {
      ["name_ru"] = "Реликвии Пробуждения";
      ["objective"] = "Retrieve the Relics of Wakening and bring them to Athridas Bearmantle in Dolanaar.";
      ["name_cn"] = "?醒?物";
      ["sort"] = "Teldrassil";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "Les Reliques d'eveil";
      ["next"] = 486;
      ["name_de"] = "Die Relikte des Erwachens";
      ["repgain"] = {
         [69] = 100;
      };
      ["reward"] = {
         [1] = 9599;
         [2] = 9603;
      };
      ["name"] = "The Relics of Wakening";
      ["prev"] = 476;
      ["prequests"] = {
         [1] = 476;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Las Reliquias del Despertar";
      ["req"] = 4;
   };
   [484] = {
      ["name_ru"] = "Шкуры молодых кроколисков";
      ["type"] = "Solo";
      ["objective"] = "Obtain 4 Young Crocolisk Skins for James Halloran in Menethil Harbor.";
      ["next"] = 471;
      ["name_fr"] = "Les peaux de jeune crocilisque";
      ["sort"] = "Wetlands";
      ["name_cn"] = "小??皮";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Haute junger Krokilisken";
      ["faction"] = "Alliance";
      ["name"] = "Young Crocolisk Skins";
      ["level"] = 22;
      ["name_es"] = "Piel de crocolisco joven";
      ["req"] = 18;
   };
   [485] = {
      ["name_ru"] = "Найти КПХ-9/HL!";
      ["type"] = "Solo";
      ["objective"] = " and my homing robot has crashed!  I will reward you for its recovery; please take this beacon to the robot!\"$B$B\"I now have computed the coordinates of the robot for you; it crashed at the head of the river near Skulk Rock!\"\"";
      ["next"] = 836;
      ["name_fr"] = "Trouvez OOX-09/HL !";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "找到OOX-09/HL！";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Sucht OOX-09/HL!";
      ["faction"] = "Horde";
      ["name"] = "Find OOX-09/HL!";
      ["level"] = 48;
      ["name_es"] = "!Encuentra a OOX-09/TI!";
      ["req"] = 43;
   };
   [486] = {
      ["name_ru"] = "Урсал Изверг";
      ["type"] = "Solo";
      ["objective"] = "Kill Ursal the Mauler and return to Athridas Bearmantle in Dolanaar.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Ursal der Raufer";
      ["reward"] = {
         [1] = 5459;
         [2] = 5587;
      };
      ["name_cn"] = "大槌???";
      ["name_fr"] = "Ursal le Marteleur";
      ["faction"] = "Alliance";
      ["name"] = "Ursal the Mauler";
      ["sort"] = "Teldrassil";
      ["prev"] = 483;
      ["prequests"] = {
         [1] = 483;
      };
      ["level"] = 12;
      ["name_es"] = "Ursal el Violento";
      ["req"] = 4;
   };
   [487] = {
      ["name_ru"] = "Дорога в Дарнас";
      ["type"] = "Solo";
      ["objective"] = "Slay 6 Gnarlpine Ambushers and return to Sentinel Amara Nightwalker outside of Dolanaar.";
      ["repgain"] = {
         [69] = 100;
      };
      ["name_fr"] = "La route de Darnassus";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "???斯之路";
      ["name_de"] = "Die Strase nach Darnassus";
      ["faction"] = "Alliance";
      ["name"] = "The Road to Darnassus";
      ["level"] = 8;
      ["name_es"] = "El camino a Darnassus";
      ["req"] = 5;
   };
   [488] = {
      ["name_ru"] = "Просьба Зенна";
      ["type"] = "Solo";
      ["objective"] = "Bring Zenn Foulhoof outside of Dolanaar 3 Nightsaber Fangs, 3 Strigid Owl Feathers and 3 swatches of Webwood Spider Silk.";
      ["name_fr"] = "Les commandements de Zenn";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "?恩的要求";
      ["reward"] = {
         [1] = 5457;
      };
      ["name_de"] = "Zenns Auftrage";
      ["faction"] = "Alliance";
      ["name"] = "Zenn's Bidding";
      ["level"] = 5;
      ["name_es"] = "Las apuestas de Zenn";
      ["req"] = 4;
   };
   [489] = {
      ["name_ru"] = "Искупление вины";
      ["type"] = "Solo";
      ["name_fr"] = "En quete de redemption?!";
      ["repgain"] = {
         [69] = 500;
      };
      ["name_de"] = "Sucht Befreiung!";
      ["name_cn"] = "?求救?！";
      ["name"] = "Seek Redemption!";
      ["objective"] = "Collect 3 Fel Cones and give them to Zenn Foulhoof outside of Dolanaar.";
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 488;
      ["prequests"] = {
         [1] = 488;
      };
      ["level"] = 7;
      ["name_es"] = "!Busqueda de redencion!";
      ["req"] = 4;
   };
   [491] = {
      ["name_ru"] = "Жезл для Бетора";
      ["type"] = "Solo";
      ["objective"] = "Take the Woven Wand to Bethor Iceshard in the Magic Quarter of the Undercity.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Zauberstab an Bethor";
      ["reward"] = {
         [1] = 3457;
         [2] = 3458;
         [3] = 3581;
      };
      ["name_cn"] = "?比索的魔杖";
      ["name_fr"] = "Une Baguette pour Bethor";
      ["faction"] = "Horde";
      ["name"] = "Wand to Bethor";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 461;
      ["prequests"] = {
         [1] = 461;
      };
      ["level"] = 18;
      ["name_es"] = "Una varita para Bethor";
      ["req"] = 12;
   };
   [492] = {
      ["name_ru"] = "Новая чума";
      ["type"] = "Solo";
      ["objective"] = "Bring Johaan's Special Drink to the Captured Mountaineer.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Eine neue Seuche";
      ["name"] = "A New Plague";
      ["name_cn"] = "新的瘟疫";
      ["name_fr"] = "Une Peste nouvelle";
      ["series"] = 4;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 369;
      ["prequests"] = {
         [1] = 369;
      };
      ["level"] = 11;
      ["name_es"] = "Una nueva Peste";
      ["req"] = 6;
   };
   [493] = {
      ["name_ru"] = "Путешествие в предгорья Хилсбрада";
      ["type"] = "Solo";
      ["objective"] = "Deliver Apothecary Renferrel's findings to Apothecary Lydon in the town of Tarren Mill in the Hillsbrad Foothills.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_fr"] = "Voyage jusqu’aux contreforts de Hautebrande";
      ["sort"] = "Silverpine Forest";
      ["name_cn"] = "前往希?斯布莱德丘陵";
      ["name_de"] = "Reise in das Vorgebirge des Hugellands";
      ["faction"] = "Horde";
      ["name"] = "Journey to Hillsbrad Foothills";
      ["level"] = 20;
      ["name_es"] = "Viaja a Laderas de Trabalomas";
      ["req"] = 19;
   };
   [494] = {
      ["name_ru"] = "Время нанести удар";
      ["type"] = "Solo";
      ["objective"] = " hurry!  Off you go to Tarren Mill";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_fr"] = "Prets a frapper";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "?攻的?机";
      ["name_de"] = "Zeit zum Zuschlagen";
      ["faction"] = "Horde";
      ["name"] = "Time To Strike";
      ["level"] = 20;
      ["name_es"] = "El momento de atacar";
      ["req"] = 19;
   };
   [495] = {
      ["name_ru"] = "Корона Воли";
      ["type"] = "Solo";
      ["objective"] = "Report to Melisara at Tarren Mill in the Hillsbrad Foothills.";
      ["next"] = 518;
      ["name_fr"] = "La couronne de volonte";
      ["sort"] = "Undercity";
      ["name_cn"] = "意志之冠";
      ["series"] = 1;
      ["name_de"] = "Die Krone des Willens";
      ["faction"] = "Horde";
      ["name"] = "The Crown of Will";
      ["level"] = 39;
      ["name_es"] = "Corona de Voluntad";
      ["req"] = 34;
   };
   [496] = {
      ["name_ru"] = "Эликсир Страдания";
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir de souffrance";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Elixier des Leidens";
      ["name_cn"] = "受???";
      ["objective"] = "Apothecary Lydon of Tarren Mill wants 10 Gray Bear Tongues and some Creeper Ichor.";
      ["next"] = 499;
      ["sort"] = "Hillsbrad Foothills";
      ["name"] = "Elixir of Suffering";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 22;
      ["name_es"] = "Elixir de sufrimiento";
      ["req"] = 19;
   };
   [498] = {
      ["name_ru"] = "Спасение";
      ["type"] = "Solo";
      ["objective"] = "Krusk in Tarren Mill needs you to free Drull and Tog'thar from Durnholde Keep.";
      ["next"] = 533;
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "Sauvetage";
      ["name_cn"] = "拯救行?";
      ["reward"] = {
         [1] = 3752;
         [2] = 3734;
         [3] = 3733;
      };
      ["repgain"] = {
         [530] = 150;
         [81] = 150;
         [76] = 350;
      };
      ["name_de"] = "Die Rettung";
      ["faction"] = "Horde";
      ["name"] = "The Rescue";
      ["level"] = 22;
      ["name_es"] = "El rescate";
      ["req"] = 17;
   };
   [499] = {
      ["name_ru"] = "Эликсир Страдания";
      ["type"] = "Solo";
      ["objective"] = "Give Umpi the Elixir of Suffering.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Elixier des Leidens";
      ["name"] = "Elixir of Suffering";
      ["name_cn"] = "受???";
      ["name_fr"] = "L'elixir de souffrance";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 496;
      ["prequests"] = {
         [1] = 496;
      };
      ["level"] = 22;
      ["name_es"] = "Elixir de sufrimiento";
      ["req"] = 19;
   };
   [500] = {
      ["name_ru"] = "Награда Раздробленного Хребта";
      ["type"] = "Solo";
      ["objective"] = "Gather 9 Dirty Knucklebones from Crushridge ogres in the Alterac Mountains.  Bring them to Marshal Redpath in Southshore.";
      ["next"] = 504;
      ["name_fr"] = "La prime Cassecrete";
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "破碎?食人魔";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "[DEPRECATED] Trummergratkopfgeld";
      ["faction"] = "Alliance";
      ["name"] = "Crushridge Bounty";
      ["level"] = 36;
      ["name_es"] = "La recompensa Aplastacresta";
      ["req"] = 30;
   };
   [501] = {
      ["name_ru"] = "Эликсир боли";
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir de douleur";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Elixier der Schmerzen";
      ["name"] = "Elixir of Pain";
      ["name_cn"] = "痛苦??";
      ["objective"] = "Bring 10 vials of Mountain Lion Blood to Apothecary Lydon in Tarren Mill.";
      ["next"] = 502;
      ["series"] = 1;
      ["sort"] = "Hillsbrad Foothills";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 2230;
         [2] = 3735;
         [3] = 3741;
         [4] = 6482;
      };
      ["level"] = 24;
      ["name_es"] = "Elixir de dolor";
      ["req"] = 21;
   };
   [502] = {
      ["name_ru"] = "Эликсир боли";
      ["type"] = "Solo";
      ["objective"] = "Feed the Elixir of Pain to Stanley.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Elixier der Schmerzen";
      ["name"] = "Elixir of Pain";
      ["name_cn"] = "痛苦??";
      ["name_fr"] = "L'elixir de douleur";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 501;
      ["prequests"] = {
         [1] = 501;
      };
      ["level"] = 24;
      ["name_es"] = "Elixir de dolor";
      ["req"] = 21;
   };
   [503] = {
      ["name_ru"] = "Гол'дир";
      ["type"] = "Solo";
      ["name_fr"] = "Gol'dir";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Gol'dir";
      ["name"] = "Gol'dir";
      ["name_cn"] = "高迪?";
      ["objective"] = "Free Gol'dir then return to Krusk in Tarren Mill.";
      ["next"] = 506;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 533;
      ["prequests"] = {
         [1] = 533;
      };
      ["level"] = 36;
      ["name_es"] = "Gol'dir";
      ["req"] = 29;
   };
   [504] = {
      ["name_ru"] = "Наемники клана Раздробленного Хребта";
      ["type"] = "Group";
      ["objective"] = "Slay 10 Crushridge Warmongers, then return to Marshal Redpath in Southshore.";
      ["repgain"] = {
         [54] = 150;
         [72] = 250;
      };
      ["name_de"] = "[DEPRECATED] Kriegstreiber der Trummergratoger";
      ["reward"] = {
         [1] = 5249;
         [2] = 3763;
      };
      ["name_cn"] = "破碎?好?者";
      ["name_fr"] = "Les Combattants Cassecrete";
      ["faction"] = "Alliance";
      ["name"] = "Crushridge Warmongers";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 500;
      ["prequests"] = {
         [1] = 500;
      };
      ["level"] = 40;
      ["name_es"] = "Belicistas Aplastacresta";
      ["req"] = 30;
   };
   [505] = {
      ["name_ru"] = "Убийцы из Синдиката";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Syndicate Footpads and 8 Syndicate Thieves, then return to Magistrate Henry Maleb in Southshore.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Alterac Mountains";
      ["name_fr"] = "Syndicat d'assassins";
      ["name_cn"] = "辛迪加刺客";
      ["reward"] = {
         [1] = 3758;
         [2] = 3759;
      };
      ["name_de"] = "[DEPRECATED] Auftragsmorder des Syndikats";
      ["faction"] = "Alliance";
      ["name"] = "Syndicate Assassins";
      ["level"] = 33;
      ["name_es"] = "Hermandad de asesinos";
      ["req"] = 26;
   };
   [506] = {
      ["name_ru"] = "Наследие Блэкмура";
      ["type"] = "Solo";
      ["name_fr"] = "L'heritage de Landenoire";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Schwarzmoors Vermachtnis";
      ["name"] = "Blackmoore's Legacy";
      ["name_cn"] = "布莱克摩?的余?";
      ["objective"] = "Return the information gathered by Gol'dir to Krusk in Tarren Mill.";
      ["next"] = 507;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 503;
      ["prequests"] = {
         [1] = 503;
      };
      ["level"] = 36;
      ["name_es"] = "El legado de Lodonegro";
      ["req"] = 29;
   };
   [507] = {
      ["name_ru"] = "Лорд Алиден Перенольд";
      ["type"] = "Solo";
      ["name_fr"] = "Seigneur Aliden Perenolde";
      ["next"] = 508;
      ["name_de"] = "Lord Aliden Perenolde";
      ["name_cn"] = "奥里登・匹瑞?德";
      ["objective"] = "Kill Lord Aliden Perenolde and ask his mistress, Elysa, about Taretha's pendant.";
      ["sort"] = "Hillsbrad Foothills";
      ["faction"] = "Horde";
      ["name"] = "Lord Aliden Perenolde";
      ["prev"] = 506;
      ["prequests"] = {
         [1] = 506;
      };
      ["level"] = 42;
      ["name_es"] = "Lord Aliden Perenolde";
      ["req"] = 29;
   };
   [508] = {
      ["name_ru"] = "Подарок Тареты";
      ["type"] = "Solo";
      ["objective"] = "Return Taretha's pendant to Krusk in Tarren Mill.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Tarethas Geschenk";
      ["reward"] = {
         [1] = 3764;
         [2] = 3765;
      };
      ["name_cn"] = "塔蕾莎的礼物";
      ["name_fr"] = "Le cadeau de Taretha";
      ["faction"] = "Horde";
      ["name"] = "Taretha's Gift";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 507;
      ["prequests"] = {
         [1] = 507;
      };
      ["level"] = 40;
      ["name_es"] = "Un regalo de Taretha";
      ["req"] = 29;
   };
   [509] = {
      ["name_ru"] = "Эликсир агонии";
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir d'agonie";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Elixier der Pein";
      ["name"] = "Elixir of Agony";
      ["name_cn"] = "苦楚??";
      ["objective"] = "Bring 6 Mudsnout Blossoms to Apothecary Lydon in Tarren Mill.";
      ["next"] = 513;
      ["series"] = 1;
      ["sort"] = "Hillsbrad Foothills";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 2459;
         [2] = 929;
      };
      ["level"] = 28;
      ["name_es"] = "Elixir de agonia";
      ["req"] = 24;
   };
   [510] = {
      ["name_ru"] = "Зловещие планы";
      ["type"] = "Solo";
      ["objective"] = "Bring the Foreboding Plans to Magistrate Maleb in Southshore.";
      ["next"] = 512;
      ["name_fr"] = "Documents d'annonce d'attaque";
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "??行???";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Furchteinflosende Plane";
      ["faction"] = "Alliance";
      ["name"] = "Foreboding Plans";
      ["level"] = 34;
      ["name_es"] = "Documentos de planificacion";
      ["req"] = 26;
   };
   [511] = {
      ["name_ru"] = "Зашифрованное письмо";
      ["type"] = "Solo";
      ["objective"] = "Bring the Encrypted Letter to Loremaster Dibbs in Southshore.";
      ["next"] = 514;
      ["name_fr"] = "Lettre codee";
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "密文信件";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Verschlusselter Brief";
      ["faction"] = "Alliance";
      ["name"] = "Encrypted Letter";
      ["level"] = 34;
      ["name_es"] = "Una carta cifrada";
      ["req"] = 30;
   };
   [512] = {
      ["name_ru"] = "Благородные смерти";
      ["type"] = "Solo";
      ["name_fr"] = "Nobles morts";
      ["repgain"] = {
         [469] = 250;
      };
      ["name_de"] = "Tod der Edlen";
      ["name_cn"] = "?族之死";
      ["name"] = "Noble Deaths";
      ["objective"] = "Bring 7 Alterac Signet Rings to Magistrate Maleb in Southshore.";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 510;
      ["prequests"] = {
         [1] = 510;
      };
      ["level"] = 36;
      ["name_es"] = "Nobles muertes";
      ["req"] = 26;
   };
   [513] = {
      ["name_ru"] = "Эликсир агонии";
      ["objective"] = "Take the Mudsnout Composite to Master Apothecary Faranell in the Undercity.";
      ["name_cn"] = "苦楚??";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir d'agonie";
      ["next"] = 515;
      ["name_de"] = "Elixier der Pein";
      ["repgain"] = {
         [68] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Elixir of Agony";
      ["prev"] = 509;
      ["prequests"] = {
         [1] = 509;
      };
      ["series"] = 2;
      ["name_es"] = "Elixir de agonia";
      ["req"] = 24;
   };
   [514] = {
      ["name_ru"] = "Письмо Грозовой Вершине";
      ["type"] = "Solo";
      ["name_fr"] = "Le maitre des lettres";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Brief an Sturmlanze";
      ["name"] = "Letter to Stormpike";
      ["name_cn"] = "?炉堡的??者";
      ["objective"] = "Take the Cleverly Encrypted Letter to Prospector Stormpike in Ironforge.";
      ["next"] = 525;
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 511;
      ["prequests"] = {
         [1] = 511;
      };
      ["level"] = 34;
      ["name_es"] = "Una carta para Pico Tormenta";
      ["req"] = 30;
   };
   [515] = {
      ["name_ru"] = "Эликсир агонии";
      ["objective"] = "Bring the Mudsnout Mixture, a Strong Troll's Blood Potion, 5 Daggerspine Scales and 5 Torn Fin Eyes to Apothecary Lydon in Tarren Mill.";
      ["name_cn"] = "苦楚??";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir d'agonie";
      ["next"] = 517;
      ["name_de"] = "Elixier der Pein";
      ["repgain"] = {
         [68] = 350;
      };
      ["reward"] = {
         [1] = 3749;
         [2] = 3747;
      };
      ["faction"] = "Horde";
      ["name"] = "Elixir of Agony";
      ["prev"] = 513;
      ["prequests"] = {
         [1] = 513;
      };
      ["series"] = 3;
      ["name_es"] = "Elixir de agonia";
      ["req"] = 24;
   };
   [516] = {
      ["name_ru"] = "Погибель Берена";
      ["type"] = "Solo";
      ["objective"] = "Locate Beren's Peril, then kill 6 Ravenclaw Drudgers and 6 Ravenclaw Guardians, then return to Shadow Priest Allister at the Sepulcher.";
      ["repgain"] = {
         [68] = 150;
      };
      ["sort"] = "Silverpine Forest";
      ["name_fr"] = "Le Peril de Beren";
      ["name_cn"] = "博?的?穴";
      ["reward"] = {
         [1] = 5252;
      };
      ["name_de"] = "Berens List";
      ["faction"] = "Horde";
      ["name"] = "Beren's Peril";
      ["level"] = 21;
      ["name_es"] = "El Desafio de Beren";
      ["req"] = 16;
   };
   [517] = {
      ["name_ru"] = "Эликсир агонии";
      ["objective"] = "Bring a keg of Shindigger Stout to Apothecary Lydon in Tarren Mill.";
      ["name_cn"] = "苦楚??";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 30;
      ["type"] = "Group";
      ["name_fr"] = "L'elixir d'agonie";
      ["next"] = 524;
      ["name_de"] = "Elixier der Pein";
      ["repgain"] = {
         [68] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Elixir of Agony";
      ["prev"] = 515;
      ["prequests"] = {
         [1] = 515;
      };
      ["series"] = 4;
      ["name_es"] = "Elixir de agonia";
      ["req"] = 24;
   };
   [518] = {
      ["name_ru"] = "Корона Воли";
      ["objective"] = "Kill 10 Crushridge Maulers for Melisara in Tarren Mill.";
      ["name_cn"] = "意志之冠";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 39;
      ["type"] = "Group";
      ["name_fr"] = "La couronne de volonte";
      ["next"] = 519;
      ["name_de"] = "Die Krone des Willens";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "The Crown of Will";
      ["prev"] = 495;
      ["prequests"] = {
         [1] = 495;
      };
      ["series"] = 2;
      ["name_es"] = "Corona de Voluntad";
      ["req"] = 34;
   };
   [519] = {
      ["name_ru"] = "Корона Воли";
      ["objective"] = "Kill Targ, Muckrake, and Glommus and bring their heads to Melisara in Tarren Mill.";
      ["name_cn"] = "意志之冠";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 41;
      ["type"] = "Group";
      ["name_fr"] = "La couronne de volonte";
      ["next"] = 520;
      ["name_de"] = "Die Krone des Willens";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "The Crown of Will";
      ["prev"] = 518;
      ["prequests"] = {
         [1] = 518;
      };
      ["series"] = 3;
      ["name_es"] = "Corona de Voluntad";
      ["req"] = 34;
   };
   [520] = {
      ["name_ru"] = "Корона Воли";
      ["objective"] = "Kill Mug'Thol, and return his head with the Crown of Will to Melisara in Tarren Mill.";
      ["name_cn"] = "意志之冠";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 43;
      ["type"] = "Group";
      ["name_fr"] = "La couronne de volonte";
      ["next"] = 521;
      ["name_de"] = "Die Krone des Willens";
      ["repgain"] = {
         [68] = 350;
      };
      ["faction"] = "Horde";
      ["name"] = "The Crown of Will";
      ["prev"] = 519;
      ["prequests"] = {
         [1] = 519;
      };
      ["series"] = 4;
      ["name_es"] = "Corona de Voluntad";
      ["req"] = 34;
   };
   [521] = {
      ["name_ru"] = "Корона Воли";
      ["objective"] = "Deliver the Crown of Will to Sharlindra in the Undercity.";
      ["name_cn"] = "意志之冠";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de volonte";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Die Krone des Willens";
      ["reward"] = {
         [1] = 4430;
      };
      ["faction"] = "Horde";
      ["name"] = "The Crown of Will";
      ["prev"] = 520;
      ["prequests"] = {
         [1] = 520;
      };
      ["series"] = 5;
      ["name_es"] = "Corona de Voluntad";
      ["req"] = 34;
   };
   [522] = {
      ["name_ru"] = "Контракт убийцы";
      ["type"] = "Solo";
      ["objective"] = "Bring the Assassin's Contract to Magistrate Maleb in Southshore.";
      ["next"] = 523;
      ["name_fr"] = "Contrat de l'assassin";
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "刺客的契?";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Auftragsmordervertrag";
      ["faction"] = "Alliance";
      ["name"] = "Assassin's Contract";
      ["level"] = 38;
      ["name_es"] = "Contrato de asesino";
      ["req"] = 30;
   };
   [523] = {
      ["name_ru"] = "Смерть барона";
      ["type"] = "Solo";
      ["name_fr"] = "La mort du baron Vardus";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Ableben des Barons";
      ["name_cn"] = "男爵之死";
      ["name"] = "Baron's Demise";
      ["objective"] = "Bring the Head of Baron Vardus to Magistrate Maleb in Southshore.";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 522;
      ["prequests"] = {
         [1] = 522;
      };
      ["level"] = 40;
      ["name_es"] = "Muerte al Baron";
      ["req"] = 30;
   };
   [524] = {
      ["name_ru"] = "Эликсир агонии";
      ["type"] = "Solo";
      ["objective"] = "Place the Tainted Keg on the rug for the captured farmers.";
      ["repgain"] = {
         [68] = 500;
      };
      ["name_de"] = "Elixier der Pein";
      ["name"] = "Elixir of Agony";
      ["name_cn"] = "苦楚??";
      ["name_fr"] = "L'elixir d'agonie";
      ["series"] = 5;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 517;
      ["prequests"] = {
         [1] = 517;
      };
      ["level"] = 30;
      ["name_es"] = "Elixir de agonia";
      ["req"] = 24;
   };
   [525] = {
      ["name_ru"] = "Все больше тайн";
      ["type"] = "Solo";
      ["name_fr"] = "D'autres mysteres";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Weitere Geheimnisse";
      ["name"] = "Further Mysteries";
      ["name_cn"] = "更大的??";
      ["objective"] = "Bring the Decrypted Letter to Magistrate Maleb in Southshore.";
      ["next"] = 537;
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 514;
      ["prequests"] = {
         [1] = 514;
      };
      ["level"] = 34;
      ["name_es"] = "Mas misterios";
      ["req"] = 30;
   };
   [526] = {
      ["name_ru"] = "Слитки светлостали";
      ["type"] = "Solo";
      ["name_fr"] = "Les lingots de sancteforge";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Lichtschmiedeblocke";
      ["name"] = "Lightforge Ingots";
      ["name_cn"] = "光???";
      ["objective"] = "Gather 5 lightforge ingots, then return to Glorin Steelbrow in the Wetlands.";
      ["next"] = 322;
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 324;
      ["prequests"] = {
         [1] = 324;
      };
      ["level"] = 29;
      ["name_es"] = "Lingotes Forjaluz";
      ["req"] = 20;
   };
   [527] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Kampf um das Hugelland";
      ["name_cn"] = "希?斯布莱德之?";
      ["objective"] = "Kill 6 Hillsbrad Farmhands, 6 Hillsbrad Farmers, Farmer Ray and Farmer Getz and report back to Darthalia in Tarren Mill.";
      ["next"] = 528;
      ["sort"] = "Hillsbrad Foothills";
      ["name"] = "Battle of Hillsbrad";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 24;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [528] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Kill 15 Hillsbrad Peasants and report back to Darthalia in Tarren Mill.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["next"] = 529;
      ["name_de"] = "Kampf um das Hugelland";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 527;
      ["prequests"] = {
         [1] = 527;
      };
      ["series"] = 2;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [529] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Kill Blacksmith Verringtan and 4 Hillsbrad Apprentice Blacksmiths.$B$BRetrieve a shipment of iron and report back to Darthalia in Tarren Mill.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["next"] = 532;
      ["name_de"] = "Kampf um das Hugelland";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 528;
      ["prequests"] = {
         [1] = 528;
      };
      ["series"] = 3;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [530] = {
      ["name_ru"] = "Месть мужа";
      ["type"] = "Solo";
      ["objective"] = "Kill Valdred Moray.$B$BBring his hands to Raleigh Andrean in the Undercity.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Rache eines Ehemanns";
      ["reward"] = {
         [1] = 3235;
      };
      ["name_cn"] = "丈夫的?仇";
      ["name_fr"] = "La vengeance d'un mari";
      ["faction"] = "Horde";
      ["name"] = "A Husband's Revenge";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 441;
      ["prequests"] = {
         [1] = 441;
      };
      ["level"] = 20;
      ["name_es"] = "La venganza de un esposo";
      ["req"] = 10;
   };
   [531] = {
      ["name_ru"] = "Месть Вайрины";
      ["type"] = "Group";
      ["objective"] = "Bring Ol' Sooty's head to Vyrin Swiftwind at the Farstrider Lodge.";
      ["name_de"] = "Vyrins Rache";
      ["name_fr"] = "La vengeance de Vyrin";
      ["reward"] = {
         [1] = 3574;
         [2] = 3573;
      };
      ["name_cn"] = "?林的??";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["name"] = "Vyrin's Revenge";
      ["sort"] = "Loch Modan";
      ["prev"] = 271;
      ["prequests"] = {
         [1] = 271;
      };
      ["level"] = 20;
      ["name_es"] = "La venganza de Vyrin";
      ["req"] = 15;
   };
   [532] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Kill Magistrate Burnside and 4 Hillsbrad Councilmen.  Destroy the Hillsbrad Proclamation.  Steal the Hillsbrad Town Registry.  Report back to Darthalia in Tarren Mill afterwards.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["next"] = 539;
      ["name_de"] = "Kampf um das Hugelland";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 529;
      ["prequests"] = {
         [1] = 529;
      };
      ["series"] = 4;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [533] = {
      ["name_ru"] = "Шпионская работа";
      ["type"] = "Solo";
      ["name_fr"] = "Infiltration";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Unterwanderung";
      ["name"] = "Infiltration";
      ["name_cn"] = "秘密潜入";
      ["objective"] = "Retrieve information about Gol'dir's whereabouts for Krusk in Tarren Mill.";
      ["next"] = 503;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 498;
      ["prequests"] = {
         [1] = 498;
      };
      ["level"] = 34;
      ["name_es"] = "Infiltracion";
      ["req"] = 29;
   };
   [535] = {
      ["name_ru"] = "Валлик";
      ["type"] = "Solo";
      ["objective"] = "Bring a mug of Southshore Stout to Valik in the Syndicate camp.";
      ["name_fr"] = "Valik";
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "仆从瓦里克";
      ["reward"] = {
         [1] = 3601;
      };
      ["name_de"] = "Valik";
      ["faction"] = "Horde";
      ["name"] = "Valik";
      ["level"] = 34;
      ["name_es"] = "Valik";
      ["req"] = 29;
   };
   [536] = {
      ["name_ru"] = "На побережье";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Torn Fin Tidehunters and 10 Torn Fin Oracles for Lieutenant Farren Orinelle in Southshore.";
      ["next"] = 559;
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "清理海岸";
      ["name_fr"] = "Le long de la cote";
      ["name_de"] = "Die Kuste entlang";
      ["faction"] = "Alliance";
      ["name"] = "Down the Coast";
      ["level"] = 30;
      ["name_es"] = "Al lo largo de la costa";
      ["req"] = 25;
   };
   [537] = {
      ["name_ru"] = "Темный совет";
      ["type"] = "Solo";
      ["name_fr"] = "Le conseil noir";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "[DEPRECATED] Der Dunkle Rat";
      ["name_cn"] = "黑暗?会";
      ["name"] = "Dark Council";
      ["objective"] = "Kill 4 Argus Shadow Mages.$B$BBring the Head of Nagaz to Magistrate Maleb in Southshore.";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 525;
      ["prequests"] = {
         [1] = 525;
      };
      ["level"] = 40;
      ["name_es"] = "Consejo oscuro";
      ["req"] = 30;
   };
   [538] = {
      ["name_ru"] = "Южнобережье";
      ["type"] = "Solo";
      ["name_fr"] = "Austrivage";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Suderstade";
      ["name"] = "Southshore";
      ["name_cn"] = "南海?";
      ["objective"] = "Speak with Loremaster Dibbs in Southshore.";
      ["next"] = 540;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 337;
      ["prequests"] = {
         [1] = 337;
      };
      ["level"] = 38;
      ["name_es"] = "Costasur";
      ["req"] = 20;
   };
   [539] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Kill Foreman Bonds and 10 Hillsbrad Miners and report back to Darthalia in Tarren Mill.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["next"] = 541;
      ["name_de"] = "Kampf um das Hugelland";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 532;
      ["prequests"] = {
         [1] = 532;
      };
      ["series"] = 5;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [540] = {
      ["name_ru"] = "Сохранение знаний";
      ["type"] = "Group";
      ["name_fr"] = "L'entretien des connaissances";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Wissen bewahren";
      ["name"] = "Preserving Knowledge";
      ["name_cn"] = "保全?籍";
      ["objective"] = "Bring 5 Recovered Tomes and the Worn Leather Book containing The Arm of Gri'lek to Loremaster Dibbs in Southshore.";
      ["next"] = 542;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 538;
      ["prequests"] = {
         [1] = 538;
      };
      ["level"] = 38;
      ["name_es"] = "Proteger el conocimiento";
      ["req"] = 20;
   };
   [541] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Travel to Dun Garok and kill 8 Mountaineers, 4 Riflemen, 2 Priests and Captain Ironhill and report back to Darthalia in Tarren Mill.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 30;
      ["type"] = "Group";
      ["name_fr"] = "La bataille de Hautebrande";
      ["next"] = 550;
      ["name_de"] = "Kampf um das Hugelland";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 539;
      ["prequests"] = {
         [1] = 539;
      };
      ["series"] = 6;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [542] = {
      ["name_ru"] = "Возвращение к Милтону";
      ["type"] = "Solo";
      ["name_fr"] = "Les livres de Milton";
      ["repgain"] = {
         [469] = 350;
      };
      ["name_de"] = "Ruckkehr zu Milton";
      ["name_cn"] = "向米??回?";
      ["name"] = "Return to Milton";
      ["objective"] = "Bring the Tomes of Alterac to Milton Sheaf in Stormwind.";
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 540;
      ["prequests"] = {
         [1] = 540;
      };
      ["level"] = 38;
      ["name_es"] = "Regresa junto a Milton";
      ["req"] = 20;
   };
   [543] = {
      ["name_ru"] = "Тиара Перенольда";
      ["type"] = "Group";
      ["objective"] = " and fitted with the finest of emeralds.$B$BWhen Alterac was destroyed the Tiara was lost";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_fr"] = "La tiare de Perenolde";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "匹瑞?德王冠";
      ["name_de"] = "Die Tiara von Perenolde";
      ["faction"] = "Alliance";
      ["name"] = "The Perenolde Tiara";
      ["level"] = 40;
      ["name_es"] = "La Tiara Perenolde";
      ["req"] = 30;
   };
   [544] = {
      ["name_ru"] = "Взлом тюрьмы";
      ["type"] = "Solo";
      ["objective"] = "Find the traitors and recover their artifacts, then return to Magus Voidglare in Tarren Mill.";
      ["next"] = 545;
      ["name_fr"] = "L'invasion de la prison";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "入室?窃";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Gefangniseinbruch";
      ["faction"] = "Horde";
      ["name"] = "Prison Break In";
      ["level"] = 34;
      ["name_es"] = "Colarse en la carcel";
      ["req"] = 30;
   };
   [545] = {
      ["name_ru"] = "Даларанские патрули";
      ["type"] = "Solo";
      ["name_fr"] = "Les patrouilles de Dalaran";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Patrouillen von Dalaran";
      ["name_cn"] = "?拉然巡??";
      ["name"] = "Dalaran Patrols";
      ["objective"] = "Kill 6 Dalaran Summoners and 12 Elemental Slaves, then return to Magus Voidglare in Tarren Mill.";
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 544;
      ["prequests"] = {
         [1] = 544;
      };
      ["level"] = 35;
      ["name_es"] = "Las patrullas de Dalaran";
      ["req"] = 30;
   };
   [546] = {
      ["name_ru"] = "Сувениры смерти";
      ["type"] = "Solo";
      ["objective"] = "Deathguard Samsa of Tarren Mill wants 30 Hillsbrad Human Skulls.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Andenken des Todes";
      ["reward"] = {
         [1] = 3739;
      };
      ["name_cn"] = "死亡的?念品";
      ["name_fr"] = "Souvenirs de morts";
      ["faction"] = "Horde";
      ["name"] = "Souvenirs of Death";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 527;
      ["prequests"] = {
         [1] = 527;
      };
      ["level"] = 25;
      ["name_es"] = "Recuerdos de muerte";
      ["req"] = 20;
   };
   [547] = {
      ["name_ru"] = "Меч Гумберта";
      ["type"] = "Group";
      ["objective"] = "Retrieve Deathguard Humbert's sword from Dun Garok and return it to him in Tarren Mill.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "L'epee d'Humbert";
      ["name_cn"] = "亨伯特的??";
      ["reward"] = {
         [1] = 3750;
         [2] = 3751;
      };
      ["name_de"] = "Humberts Schwert";
      ["faction"] = "Horde";
      ["name"] = "Humbert's Sword";
      ["level"] = 30;
      ["name_es"] = "La espada de Humbert";
      ["req"] = 26;
   };
   [549] = {
      ["name_ru"] = "РАЗЫСКИВАЮТСЯ: сторонники Синдиката";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Syndicate Rogues and 10 Syndicate Watchmen. Return to High Executor Darthalia in Tarren Mill for your reward.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "ON RECHERCHE?: Personnel du Syndicat";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "通?：辛迪加成?";
      ["name_de"] = "GESUCHT: Syndikatspersonal";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Syndicate Personnel";
      ["level"] = 22;
      ["name_es"] = "SE BUSCA: Personal de la Hermandad";
      ["req"] = 17;
   };
   [550] = {
      ["name_ru"] = "Битва за Хилсбрад";
      ["objective"] = "Take Darthalia's Sealed Commendation to Varimathras in the Undercity.";
      ["name_cn"] = "希?斯布莱德之?";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 32;
      ["type"] = "Solo";
      ["name_fr"] = "La bataille de Hautebrande";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Kampf um das Hugelland";
      ["reward"] = {
         [1] = 6282;
         [2] = 3760;
         [3] = 3761;
         [4] = 3822;
      };
      ["faction"] = "Horde";
      ["name"] = "Battle of Hillsbrad";
      ["prev"] = 541;
      ["prequests"] = {
         [1] = 541;
      };
      ["series"] = 7;
      ["name_es"] = "La batalla de Trabalomas";
      ["req"] = 19;
   };
   [551] = {
      ["name_ru"] = "Заколдованный пергамент";
      ["type"] = "Solo";
      ["objective"] = "Take the Ensorcelled Parchment to Loremaster Dibbs in Southshore.";
      ["next"] = 554;
      ["sort"] = "Alterac Mountains";
      ["name_cn"] = "附有魔法的羊皮?";
      ["name_fr"] = "Le Parchemin ensorcele";
      ["name_de"] = "Das Verhexte Pergament";
      ["faction"] = "Alliance";
      ["name"] = "The Ensorcelled Parchment";
      ["level"] = 40;
      ["name_es"] = "El papiro encantado";
      ["req"] = 30;
   };
   [552] = {
      ["name_ru"] = "Месть Гелькулара";
      ["type"] = "Solo";
      ["name_fr"] = "La vengeance d'Helcular";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Helculars Rache";
      ["name_cn"] = "赫??拉的?仇";
      ["objective"] = "Retrieve Helcular's Rod from the Yeti and bring it back to Novice Thaivand in Tarren Mill.";
      ["next"] = 553;
      ["sort"] = "Hillsbrad Foothills";
      ["name"] = "Helcular's Revenge";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 33;
      ["name_es"] = "La venganza de Helcular";
      ["req"] = 29;
   };
   [553] = {
      ["name_ru"] = "Месть Гелькулара";
      ["type"] = "Solo";
      ["objective"] = "Charge the Rod of Helcular with the powers of the Flame of Azel, Flame of Veraz and the Flame of Uzel.$B$BDrive the charged rod into Helcular's grave in Southshore.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Helculars Rache";
      ["name"] = "Helcular's Revenge";
      ["name_cn"] = "赫??拉的?仇";
      ["name_fr"] = "La vengeance d'Helcular";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 552;
      ["prequests"] = {
         [1] = 552;
      };
      ["level"] = 33;
      ["name_es"] = "La venganza de Helcular";
      ["req"] = 29;
   };
   [554] = {
      ["name_ru"] = "Расшифровщик Грозовая Вершина";
      ["type"] = "Solo";
      ["name_fr"] = "Foudrepique decode";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Sturmlanzes Entschlusselung";
      ["name_cn"] = "解?高手";
      ["name"] = "Stormpike's Deciphering";
      ["objective"] = "Take the Ensorcelled Parchment to Prospector Stormpike in Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Mountains";
      ["prev"] = 551;
      ["prequests"] = {
         [1] = 551;
      };
      ["level"] = 40;
      ["name_es"] = "La descodificacion de Pico Tormenta";
      ["req"] = 28;
   };
   [555] = {
      ["name_ru"] = "Нежный черепаховый суп";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 pieces of Turtle Meat and some Soothing Spices to Chef Jessen in Southshore.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "Bisque de tortue apaisante";
      ["name_cn"] = "海??";
      ["reward"] = {
         [1] = 3737;
         [2] = 3729;
      };
      ["name_de"] = "Milde Schildkrotensuppe";
      ["faction"] = "Alliance";
      ["name"] = "Soothing Turtle Bisque";
      ["level"] = 31;
      ["name_es"] = "Sopa de tortuga reconfortante";
      ["req"] = 28;
   };
   [556] = {
      ["name_ru"] = "Каменные талисманы";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Worn Stone Tokens to Keeper Bel'varil in Tarren Mill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Les Runes gravees";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "石雕";
      ["name_de"] = "Steinmarken";
      ["faction"] = "Horde";
      ["name"] = "Stone Tokens";
      ["level"] = 32;
      ["name_es"] = "Muestras de piedra";
      ["req"] = 30;
   };
   [557] = {
      ["name_ru"] = "Сковывающие браслеты";
      ["type"] = "Solo";
      ["name_fr"] = "Les Bracelets de liaison";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Armschienen der Bindung";
      ["name_cn"] = "地??腕";
      ["name"] = "Bracers of Binding";
      ["objective"] = "Bring 4 Bracers of Earth Binding to Keeper Bel'varil in Tarren Mill.";
      ["faction"] = "Horde";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 556;
      ["prequests"] = {
         [1] = 556;
      };
      ["level"] = 34;
      ["name_es"] = "Brazales de vinculo";
      ["req"] = 30;
   };
   [558] = {
      ["name_ru"] = "Автограф Джайны";
      ["type"] = "Solo";
      ["objective"] = "Travel to Theramore to see about getting Lady Jaina Proudmoore's autograph for your ward.";
      ["sort"] = "Children's Week";
      ["name_cn"] = "珍娜的?名";
      ["name_fr"] = "L'autographe de Jaina";
      ["followup"] = 171;
      ["name_de"] = "Jainas Autogramm";
      ["faction"] = "Horde";
      ["name"] = "Jaina's Autograph";
      ["level"] = 60;
      ["name_es"] = "El autografo de Jaina";
      ["req"] = 10;
   };
   [559] = {
      ["name_ru"] = "Доказательство Фаррена";
      ["type"] = "Solo";
      ["name_fr"] = "La preuve de Farren";
      ["next"] = 560;
      ["name_de"] = "Farrens Beweis";
      ["name"] = "Farren's Proof";
      ["name_cn"] = "法?林的?据";
      ["objective"] = "Collect 10 Murloc Heads from the murlocs on the Western Strand for Lieutenant Farren Orinelle in Southshore.";
      ["series"] = 1;
      ["faction"] = "Alliance";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 536;
      ["prequests"] = {
         [1] = 536;
      };
      ["level"] = 32;
      ["name_es"] = "La prueba de Farren";
      ["req"] = 25;
   };
   [560] = {
      ["name_ru"] = "Доказательство Фаррена";
      ["objective"] = "Deliver the sack of murloc heads to Marshall Redpath in Southshore.";
      ["name_cn"] = "法?林的?据";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 32;
      ["type"] = "Solo";
      ["name_fr"] = "La preuve de Farren";
      ["next"] = 561;
      ["name_de"] = "Farrens Beweis";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "Farren's Proof";
      ["prev"] = 559;
      ["prequests"] = {
         [1] = 559;
      };
      ["series"] = 2;
      ["name_es"] = "La prueba de Farren";
      ["req"] = 25;
   };
   [561] = {
      ["name_ru"] = "Доказательство Фаррена";
      ["type"] = "Solo";
      ["name_fr"] = "La preuve de Farren";
      ["next"] = 562;
      ["name_de"] = "Farrens Beweis";
      ["name"] = "Farren's Proof";
      ["name_cn"] = "法?林的?据";
      ["objective"] = "Speak with Lieutenant Farren Orinelle in Southshore.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 560;
      ["prequests"] = {
         [1] = 560;
      };
      ["level"] = 32;
      ["name_es"] = "La prueba de Farren";
      ["req"] = 25;
   };
   [562] = {
      ["name_ru"] = "Эй, Штормград!";
      ["type"] = "Solo";
      ["name_fr"] = "Hurlevent me voila";
      ["next"] = 563;
      ["name_de"] = "Sturmwind Ho!";
      ["reward"] = {
         [1] = 3755;
      };
      ["name_cn"] = "升官之道";
      ["objective"] = "Kill 10 Daggerspine Shorehunters and 10 Daggerspine Sirens for Lieutenant Farren Orinelle in Southshore.";
      ["faction"] = "Alliance";
      ["name"] = "Stormwind Ho!";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 561;
      ["prequests"] = {
         [1] = 561;
      };
      ["level"] = 32;
      ["name_es"] = "Cambio de destino";
      ["req"] = 25;
   };
   [563] = {
      ["name_ru"] = "Новое назначение";
      ["type"] = "Solo";
      ["name_fr"] = "Nouvelle affectation";
      ["name_de"] = "Versetzungen";
      ["name_cn"] = "人事??";
      ["objective"] = "Deliver Farren's report to Major Samuelson in Stormwind Keep.";
      ["sort"] = "Hillsbrad Foothills";
      ["faction"] = "Alliance";
      ["name"] = "Reassignment";
      ["prev"] = 562;
      ["prequests"] = {
         [1] = 562;
      };
      ["level"] = 32;
      ["name_es"] = "Nueva asignacion";
      ["req"] = 25;
   };
   [564] = {
      ["name_ru"] = "Серьезная угроза";
      ["type"] = "Solo";
      ["objective"] = "Darren Malvew of Southshore wants you to kill 8 Mountain Lions and 10 Hulking Mountain Lions.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "Un probleme tres couteux";
      ["name_cn"] = "?失惨重";
      ["reward"] = {
         [1] = 3753;
         [2] = 3736;
         [3] = 3754;
         [4] = 3728;
      };
      ["name_de"] = "Teure Bedrohung";
      ["faction"] = "Alliance";
      ["name"] = "Costly Menace";
      ["level"] = 34;
      ["name_es"] = "Una amenaza costosa";
      ["req"] = 30;
   };
   [565] = {
      ["name_ru"] = "Плащ из меха йети";
      ["type"] = "Solo";
      ["objective"] = " there is no finer cloak!\"  Yes";
      ["repgain"] = {
         [0] = 72;
      };
      ["name_fr"] = "La cape en fourrure de yeti de Bartolo";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "巴??的雪人毛皮披?";
      ["name_de"] = "Bartolos Yetifellumhang";
      ["faction"] = "Alliance";
      ["name"] = "Bartolo's Yeti Fur Cloak";
      ["level"] = 34;
      ["name_es"] = "Capa de piel de yeti de Bartolo";
      ["req"] = 29;
   };
   [566] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: Барон Вардус";
      ["type"] = "Solo";
      ["objective"] = "Kill Baron Vardus and deliver his head to High Executor Darthalia in Tarren Mill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "ON RECHERCHE?: baron Vardus";
      ["name_cn"] = "通?：瓦杜斯男爵";
      ["reward"] = {
         [1] = 2231;
      };
      ["name_de"] = "GESUCHT: Baron Vardus";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Baron Vardus";
      ["level"] = 40;
      ["name_es"] = "SE BUSCA: Baron Vardus";
      ["req"] = 35;
   };
   [567] = {
      ["name_ru"] = "Вооружены и очень опасны!";
      ["type"] = "Solo";
      ["objective"] = "High Executor Darthalia of Tarren Mill is offering a bounty on Clerk Horrace Whitesteed, Citizen Wilkes, Miner Hackett and Farmer Kalaba.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Hillsbrad Foothills";
      ["name_fr"] = "Dangereux?!";
      ["name_cn"] = "危?！";
      ["reward"] = {
         [1] = 3742;
         [2] = 3732;
         [3] = 3743;
         [4] = 5250;
      };
      ["name_de"] = "Gefahrlich!";
      ["faction"] = "Horde";
      ["name"] = "Dangerous!";
      ["level"] = 28;
      ["name_es"] = "!Peligrosos!";
      ["req"] = 19;
   };
   [568] = {
      ["name_ru"] = "Защита Гром'гола";
      ["type"] = "Solo";
      ["name_fr"] = "La defense de Grom'gol";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Die Verteidigung von Grom'gol";
      ["name_cn"] = "格?姆高保??";
      ["objective"] = "Commander Aggro'gosh of the Grom'gol base camp wants you to kill 15 Lashtail Raptors.";
      ["next"] = 569;
      ["sort"] = "Stranglethorn Valley";
      ["name"] = "The Defense of Grom'gol";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 36;
      ["name_es"] = "La defensa de Grom'gol";
      ["req"] = 33;
   };
   [569] = {
      ["name_ru"] = "Защита Гром'гола";
      ["objective"] = "Commander Aggro'gosh of the Grom'gol base camp wants you to kill 10 Ogre Brutes and 5 Ogre Witch Doctors.";
      ["name_cn"] = "格?姆高保??";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "La defense de Grom'gol";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Die Verteidigung von Grom'gol";
      ["reward"] = {
         [1] = 4115;
      };
      ["faction"] = "Horde";
      ["name"] = "The Defense of Grom'gol";
      ["prev"] = 568;
      ["prequests"] = {
         [1] = 568;
      };
      ["series"] = 2;
      ["name_es"] = "La defensa de Grom'gol";
      ["req"] = 33;
   };
   [570] = {
      ["name_ru"] = "Чары Мок'тардина";
      ["type"] = "Solo";
      ["name_fr"] = "Enchantement de Mok'thardin";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Mok'Thardins Verzauberung";
      ["name_cn"] = "摩克??丁的魔法";
      ["objective"] = "Far Seer Mok'thardin at the Grom'gol base camp wants 8 Shadowmaw Claws and a Pristine Tigress Fang.";
      ["next"] = 572;
      ["sort"] = "Stranglethorn Valley";
      ["name"] = "Mok'thardin's Enchantment";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 38;
      ["name_es"] = "El encantamiento de Mok'thardin";
      ["req"] = 33;
   };
   [571] = {
      ["name_ru"] = "Чары Мок'тардина";
      ["objective"] = "Bring an Aged Gorilla Sinew to Far Seer Mok'thardin in Grom'gol.";
      ["name_cn"] = "摩克??丁的魔法";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "Enchantement de Mok'thardin";
      ["next"] = 573;
      ["name_de"] = "Mok'Thardins Verzauberung";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Mok'thardin's Enchantment";
      ["prev"] = 572;
      ["prequests"] = {
         [1] = 572;
      };
      ["series"] = 3;
      ["name_es"] = "El encantamiento de Mok'thardin";
      ["req"] = 33;
   };
   [572] = {
      ["name_ru"] = "Чары Мок'тардина";
      ["objective"] = "Bring 10 Jungle Stalker Feathers to Far Seer Mok'thardin at the Grom'gol base camp.";
      ["name_cn"] = "摩克??丁的魔法";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "Enchantement de Mok'thardin";
      ["next"] = 571;
      ["name_de"] = "Mok'Thardins Verzauberung";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Mok'thardin's Enchantment";
      ["prev"] = 570;
      ["prequests"] = {
         [1] = 570;
      };
      ["series"] = 2;
      ["name_es"] = "El encantamiento de Mok'thardin";
      ["req"] = 33;
   };
   [573] = {
      ["name_ru"] = "Чары Мок'тардина";
      ["objective"] = "Far Seer Mok'thardin of Grom'gol needs Holy Spring Water.  He also wants you to kill 10 Naga Explorers.";
      ["name_cn"] = "摩克??丁的魔法";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 44;
      ["type"] = "Solo";
      ["name_fr"] = "Enchantement de Mok'thardin";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Mok'Thardins Verzauberung";
      ["reward"] = {
         [1] = 4112;
      };
      ["faction"] = "Horde";
      ["name"] = "Mok'thardin's Enchantment";
      ["prev"] = 571;
      ["prequests"] = {
         [1] = 571;
      };
      ["series"] = 4;
      ["name_es"] = "El encantamiento de Mok'thardin";
      ["req"] = 33;
   };
   [574] = {
      ["name_ru"] = "Особые войска";
      ["type"] = "Solo";
      ["name_fr"] = "Forces speciales";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Spezialtruppe";
      ["name_cn"] = "特?部?";
      ["objective"] = "Kill 10 Kurzen Commandoes and 6 Kurzen Headshrinkers.$B$BReport to Lieutenant Doren at the Rebel Camp.";
      ["next"] = 202;
      ["sort"] = "Stranglethorn Valley";
      ["name"] = "Special Forces";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 203;
         [2] = 204;
      };
      ["level"] = 38;
      ["name_es"] = "Fuerzas especiales";
      ["req"] = 30;
   };
   [575] = {
      ["name_ru"] = "Спрос и предложение";
      ["type"] = "Solo";
      ["objective"] = " a connoisseur's choice!$B$BI've just received an order from Director Riddlevox of the Tinkers' Union for a dozen of his favorite Excelsior-line boots. Our best sellers";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_fr"] = "L'offre et la demande";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "供与求";
      ["name_de"] = "Angebot und Nachfrage";
      ["faction"] = "Horde";
      ["name"] = "Supply and Demand";
      ["level"] = 31;
      ["name_es"] = "La oferta y la demanda";
      ["req"] = 26;
   };
   [576] = {
      ["name_ru"] = "Смотри в оба";
      ["type"] = "Solo";
      ["objective"] = "Dizzy One-Eye in Booty Bay wants you to retrieve his eye from the Bloodsail Buccaneers.";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Ein Auge offen halten";
      ["reward"] = {
         [1] = 4114;
      };
      ["name_cn"] = "海盗的眼睛";
      ["name_fr"] = "Gardez un ?il dehors";
      ["faction"] = "Horde";
      ["name"] = "Keep An Eye Out";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 595;
      ["prequests"] = {
         [1] = 595;
      };
      ["level"] = 42;
      ["name_es"] = "!Ojo!";
      ["req"] = 37;
   };
   [577] = {
      ["name_ru"] = "Добыча шкур";
      ["type"] = "Solo";
      ["name_fr"] = "Un peu d'assemblage est necessaire";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Etwas Zusammenbau benotigt";
      ["name"] = "Some Assembly Required";
      ["name_cn"] = "收集??皮";
      ["objective"] = " Drizzlik?\" No doubt the question on your lips";
      ["next"] = 628;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 575;
      ["prequests"] = {
         [1] = 575;
      };
      ["level"] = 36;
      ["name_es"] = "Hay que ensamblar";
      ["req"] = 31;
   };
   [578] = {
      ["name_ru"] = "Камень приливов";
      ["type"] = "Solo";
      ["name_fr"] = "La Pierre des marees";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Der Stein der Gezeiten";
      ["name"] = "The Stone of the Tides";
      ["name_cn"] = "海潮之石";
      ["objective"] = "Find the haunted island for Baron Revilgaz in Booty Bay.";
      ["next"] = 601;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 616;
      ["prequests"] = {
         [1] = 616;
      };
      ["level"] = 37;
      ["name_es"] = "La piedra de las mareas";
      ["req"] = 32;
   };
   [579] = {
      ["name_ru"] = "Библиотека Штормграда";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_fr"] = "La Bibliotheque de Hurlevent";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "暴?城???";
      ["reward"] = {
         [1] = 2154;
         [2] = 3899;
      };
      ["name_de"] = "Bibliothek von Sturmwind";
      ["faction"] = "Alliance";
      ["name"] = "Stormwind Library";
      ["level"] = 1;
      ["name_es"] = "La biblioteca de Ventormenta";
      ["req"] = 1;
   };
   [580] = {
      ["name_ru"] = "Потерянный грог Алкача Виски";
      ["type"] = "Solo";
      ["objective"] = "Whiskey Slim in Booty Bay wants you to bring him the bottles of Pupellyverbos Port he lost.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "La bibine perdue de Whiskey Slim";
      ["name_cn"] = "威士忌斯利姆的酒";
      ["reward"] = {
         [1] = 17048;
      };
      ["name_de"] = "Klein Whiskeys verlorener Grog";
      ["faction"] = "Horde";
      ["name"] = "Whiskey Slim's Lost Grog";
      ["level"] = 50;
      ["name_es"] = "El grog de Whiskey el Delgado";
      ["req"] = 40;
   };
   [581] = {
      ["name_ru"] = "Поиски Йеннику";
      ["type"] = "Solo";
      ["objective"] = "Bring 9 Bloodscalp Tusks to Nimboya at the Grom'gol Base Camp.";
      ["next"] = 582;
      ["name_fr"] = "La chasse pour Yenniku";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "耶尼?的下落";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Die Suche nach Yenniku";
      ["faction"] = "Horde";
      ["name"] = "Hunt for Yenniku";
      ["level"] = 34;
      ["name_es"] = "Caza para Yenniku";
      ["req"] = 30;
   };
   [582] = {
      ["name_ru"] = "Охота за головами";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Shrunken Heads to Nimboya at the Grom'gol Base Camp.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Kopfjagerei";
      ["reward"] = {
         [1] = 4133;
         [2] = 4132;
      };
      ["name_cn"] = "??行?";
      ["name_fr"] = "La chasse aux tetes";
      ["faction"] = "Horde";
      ["name"] = "Headhunting";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 581;
      ["prequests"] = {
         [1] = 581;
      };
      ["level"] = 37;
      ["name_es"] = "Caza cabezas";
      ["req"] = 30;
   };
   [583] = {
      ["name_ru"] = "Добро пожаловать в джунгли";
      ["type"] = "Solo";
      ["objective"] = "Speak with Hemet Nesingwary";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?迎来到?林";
      ["name_fr"] = "Bienvenue dans la jungle";
      ["name_de"] = "Willkommen im Dschungel";
      ["faction"] = "Horde";
      ["name"] = "Welcome to the Jungle";
      ["level"] = 30;
      ["name_es"] = "Bienvenido a la jungla";
      ["req"] = 28;
   };
   [584] = {
      ["name_ru"] = "Головы племени Кровавого Скальпа";
      ["type"] = "Solo";
      ["name_fr"] = "Les tetes du clan Scalp-rouge";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Kopfe des Blutskalpklans";
      ["name_cn"] = "血?之?";
      ["name"] = "Bloodscalp Clan Heads";
      ["objective"] = "Bring Gan'zulah's Head and Nezzliok's Head to the bubbling cauldron at the Grom'gol Base Camp.";
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 582;
      ["prequests"] = {
         [1] = 582;
      };
      ["level"] = 41;
      ["name_es"] = "Las cabezas de los Sangrapellejo";
      ["req"] = 30;
   };
   [585] = {
      ["name_ru"] = "Разговор с Неззилоком";
      ["type"] = "Solo";
      ["name_fr"] = "En parlant avec Nezzliok";
      ["repgain"] = {
         [530] = 150;
      };
      ["name_de"] = "Mit Nezzliok sprechen";
      ["followup"] = 588;
      ["name_cn"] = "奈?里奥克";
      ["objective"] = "Bring a Balia'mah Trophy, a Ziata'jai Trophy and a Zul'Mamwe Trophy to the Bubbling Cauldron at the Grom'gol Base Camp.";
      ["faction"] = "Horde";
      ["name"] = "Speaking with Nezzliok";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 584;
      ["prequests"] = {
         [1] = 584;
      };
      ["level"] = 40;
      ["name_es"] = "Hablando con Nezzliok";
      ["req"] = 30;
   };
   [586] = {
      ["name_ru"] = "Разговор с Ган'зулахом";
      ["type"] = "Solo";
      ["name_fr"] = "En parlant avec Gan'zulah";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Mit Gan'zulah sprechen";
      ["followup"] = 588;
      ["name_cn"] = "甘祖拉恩";
      ["objective"] = "Kill 8 Skullsplitter Hunters, 6 Skullsplitter Headhunters, and 4 Skullsplitter Berserkers.$B$BBring the Broken Armor of Ana'thek to the Bubbling Cauldron at the Grom'gol Base Camp.";
      ["faction"] = "Horde";
      ["name"] = "Speaking with Gan'zulah";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 584;
      ["prequests"] = {
         [1] = 584;
      };
      ["level"] = 46;
      ["name_es"] = "Hablando con Gan'zulah";
      ["req"] = 30;
   };
   [587] = {
      ["name_ru"] = "Понюшка табака";
      ["type"] = "Solo";
      ["name_fr"] = "Faire un tabac";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Auf dem Schnupftabak";
      ["name_cn"] = "鼻烟";
      ["name"] = "Up to Snuff";
      ["objective"] = "Deeg in Booty Bay wants you to bring him 15 shares of Snuff.";
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 595;
      ["prequests"] = {
         [1] = 595;
      };
      ["level"] = 41;
      ["name_es"] = "Tabaco rape";
      ["req"] = 37;
   };
   [588] = {
      ["name_ru"] = "Судьба Йеннику";
      ["type"] = "Solo";
      ["name_fr"] = "Le sort de Yenniku";
      ["repgain"] = {
         [530] = 25;
      };
      ["name_de"] = "Yennikus Schicksal";
      ["name_cn"] = "耶尼?的命?";
      ["objective"] = "Speak with Kin'weelay.";
      ["next"] = 589;
      ["sort"] = "Stranglethorn Valley";
      ["name"] = "The Fate of Yenniku";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 585;
         [2] = 586;
      };
      ["level"] = 45;
      ["name_es"] = "El destino de Yenniku";
      ["req"] = 30;
   };
   [589] = {
      ["name_ru"] = "Поющие кристаллы";
      ["type"] = "Solo";
      ["name_fr"] = "Les Eclats vibrants";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Die singenden Kristalle";
      ["name"] = "The Singing Crystals";
      ["name_cn"] = "歌唱水晶";
      ["objective"] = "Bring 3 Pulsing Blue Shards to Kin'weelay at the Grom'gol Base Camp.";
      ["next"] = 591;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 588;
      ["prequests"] = {
         [1] = 588;
      };
      ["level"] = 45;
      ["name_es"] = "Los cristales canto";
      ["req"] = 30;
   };
   [590] = {
      ["name_ru"] = "Выгодная сделка";
      ["type"] = "Solo";
      ["name_fr"] = "Un marche de voleur";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Ein Schurkenhandel";
      ["name_cn"] = "潜行者的交易";
      ["name"] = "A Rogue's Deal";
      ["objective"] = "Defeat Calvin Montague in Deathknell.";
      ["faction"] = "Horde";
      ["sort"] = "Deathknell";
      ["prev"] = 8;
      ["prequests"] = {
         [1] = 8;
      };
      ["level"] = 5;
      ["name_es"] = "Un trato de picaro";
      ["req"] = 1;
   };
   [591] = {
      ["name_ru"] = "Око разума";
      ["type"] = "Group";
      ["name_fr"] = "La Vue de l'Esprit";
      ["repgain"] = {
         [530] = 350;
      };
      ["name_de"] = "Das Gedankenauge";
      ["name_cn"] = "心?之眼";
      ["name"] = "The Mind's Eye";
      ["objective"] = "Bring the Mind's Eye to Kin'weelay at the Grom'gol Base Camp.";
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 589;
      ["prequests"] = {
         [1] = 589;
      };
      ["level"] = 46;
      ["name_es"] = "El Ojo de la mente";
      ["req"] = 30;
   };
   [592] = {
      ["name_ru"] = "Спасение Йеннику";
      ["type"] = "Solo";
      ["objective"] = "Bring the Filled Soul Gem to Nimboya.";
      ["repgain"] = {
         [530] = 350;
      };
      ["name_de"] = "Yennikus Rettung";
      ["reward"] = {
         [1] = 4134;
         [2] = 6723;
      };
      ["name_cn"] = "拯救耶尼?";
      ["name_fr"] = "Il faut sauver Yenniku";
      ["faction"] = "Horde";
      ["name"] = "Saving Yenniku";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 591;
      ["prequests"] = {
         [1] = 591;
      };
      ["level"] = 46;
      ["name_es"] = "Salvar a Yenniku";
      ["req"] = 30;
   };
   [593] = {
      ["name_ru"] = "Наполнение самоцвета Души";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Une ame pour la gemme";
      ["name_cn"] = "?魂宝石";
      ["reward"] = {
         [1] = 3913;
      };
      ["name_de"] = "Den Seelenedelstein fullen";
      ["faction"] = "Horde";
      ["name"] = "Filling the Soul Gem";
      ["level"] = 46;
      ["name_es"] = "Gema de alma";
      ["req"] = 1;
   };
   [594] = {
      ["name_ru"] = "Послание в бутылке";
      ["type"] = "Solo";
      ["objective"] = "Find the author of the message in a bottle.";
      ["next"] = 630;
      ["name_fr"] = "Message dans une bouteille";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "瓶中信";
      ["series"] = 1;
      ["name_de"] = "Flaschenpost";
      ["faction"] = "Horde";
      ["name"] = "Message in a Bottle";
      ["level"] = 45;
      ["name_es"] = "Mensaje en una botella";
      ["req"] = 45;
   };
   [595] = {
      ["name_ru"] = "Пираты Кровавого паруса";
      ["type"] = "Solo";
      ["name_fr"] = "Les boucaniers de la Voile sanglante";
      ["repgain"] = {
         [21] = 150;
      };
      ["name_de"] = "Die Blutsegelbukaniere";
      ["name_cn"] = "血帆海盗";
      ["objective"] = "First Mate Crazz wants you to check the cove north of Booty Bay.";
      ["next"] = 597;
      ["sort"] = "Stranglethorn Valley";
      ["name"] = "The Bloodsail Buccaneers";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 41;
      ["name_es"] = "Bucaneros Velasangre";
      ["req"] = 37;
   };
   [596] = {
      ["name_ru"] = "Ожерелье кровавых костей";
      ["type"] = "Solo";
      ["objective"] = "Bring 25 Bloody Bone Necklaces to Kin'weelay at the Grom'gol Base Camp.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Les Colliers d'os ensanglantes";
      ["name_cn"] = "染血的白骨??";
      ["reward"] = {
         [1] = 4135;
      };
      ["name_de"] = "Blutige Knochenhalskette";
      ["faction"] = "Horde";
      ["name"] = "Bloody Bone Necklaces";
      ["level"] = 37;
      ["name_es"] = "Collares de huesos sangrientos";
      ["req"] = 30;
   };
   [597] = {
      ["name_ru"] = "Пираты Кровавого паруса";
      ["objective"] = " kill them.\"\"";
      ["name_cn"] = "血帆海盗";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "Les boucaniers de la Voile sanglante";
      ["next"] = 599;
      ["name_de"] = "Die Blutsegelbukaniere";
      ["repgain"] = {
         [21] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "The Bloodsail Buccaneers";
      ["prev"] = 595;
      ["prequests"] = {
         [1] = 595;
      };
      ["series"] = 2;
      ["name_es"] = "Bucaneros Velasangre";
      ["req"] = 37;
   };
   [598] = {
      ["name_ru"] = "Ожерелье расколотых костей";
      ["type"] = "Solo";
      ["objective"] = "Bring 25 Split Bone Necklaces to Kin'weelay at the Grom'gol Base camp.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Spaltknochenhalskette";
      ["reward"] = {
         [1] = 4137;
         [2] = 4136;
      };
      ["name_cn"] = "裂骨??";
      ["name_fr"] = "Collier d'os brises";
      ["faction"] = "Horde";
      ["name"] = "Split Bone Necklace";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 596;
      ["prequests"] = {
         [1] = 596;
      };
      ["level"] = 42;
      ["name_es"] = "Collar de hueso partido";
      ["req"] = 30;
   };
   [599] = {
      ["name_ru"] = "Пираты Кровавого паруса";
      ["objective"] = "Report the planned Bloodsail attack to Fleet Master Seahorn.";
      ["name_cn"] = "血帆海盗";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "Les boucaniers de la Voile sanglante";
      ["next"] = 604;
      ["name_de"] = "Die Blutsegelbukaniere";
      ["repgain"] = {
         [21] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "The Bloodsail Buccaneers";
      ["prev"] = 597;
      ["prequests"] = {
         [1] = 597;
      };
      ["series"] = 3;
      ["name_es"] = "Bucaneros Velasangre";
      ["req"] = 37;
   };
   [600] = {
      ["name_ru"] = "Рудник Торговой Компании";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Singing Blue Crystals to Crank Fizzlebub in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Venture Company-Bergbau";
      ["reward"] = {
         [1] = 5253;
         [2] = 4128;
      };
      ["name_cn"] = "??投?公司";
      ["name_fr"] = "La mauvaise mine de la KapitalRisk";
      ["faction"] = "Horde";
      ["name"] = "Venture Company Mining";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 605;
      ["prequests"] = {
         [1] = 605;
      };
      ["level"] = 41;
      ["name_es"] = "La mineria de Ventura y Cia.";
      ["req"] = 30;
   };
   [601] = {
      ["name_ru"] = "Элементали воды";
      ["type"] = "Solo";
      ["name_fr"] = "Les elementaires d'eau";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Wasserelementare";
      ["name"] = "Water Elementals";
      ["name_cn"] = "水元素";
      ["objective"] = "Acquire 6 Water Elemental Bracers for Baron Revilgaz in Booty Bay.";
      ["next"] = 602;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 578;
      ["prequests"] = {
         [1] = 578;
      };
      ["level"] = 37;
      ["name_es"] = "Elementales de agua";
      ["req"] = 32;
   };
   [602] = {
      ["name_ru"] = "Магический анализ";
      ["type"] = "Solo";
      ["name_fr"] = "L'analyse magique";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Magische Analyse";
      ["name_cn"] = "魔法分析";
      ["name"] = "Magical Analysis";
      ["objective"] = "Bring the water elemental bracers to Archmage Ansirem Runeweaver in Dalaran.";
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 601;
      ["prequests"] = {
         [1] = 601;
      };
      ["level"] = 37;
      ["name_es"] = "Analisis magico";
      ["req"] = 32;
   };
   [603] = {
      ["name_ru"] = "Ключ Ансарема";
      ["type"] = "Solo";
      ["name_fr"] = "La Cle d'Ansirem";
      ["repgain"] = {
         [21] = 75;
      };
      ["name_de"] = "Ansirems Schlussel";
      ["name"] = "Ansirem's Key";
      ["name_cn"] = "安斯雷姆的?匙";
      ["objective"] = "Talk to Catelyn in Booty Bay.";
      ["next"] = 610;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 602;
      ["prequests"] = {
         [1] = 602;
      };
      ["level"] = 37;
      ["name_es"] = "Llave de Ansirem";
      ["req"] = 32;
   };
   [604] = {
      ["name_ru"] = "Пираты Кровавого Паруса";
      ["objective"] = "Fleet Master Seahorn in Booty Bay wants you to kill 10 Bloodsail Swashbucklers and bring back the Bloodsail Charts and the Bloodsail Orders.";
      ["name_cn"] = "血帆海盗";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Les boucaniers de la Voile sanglante";
      ["next"] = 608;
      ["name_de"] = "Die Blutsegelbukaniere";
      ["repgain"] = {
         [21] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "The Bloodsail Buccaneers";
      ["prev"] = 599;
      ["prequests"] = {
         [1] = 599;
      };
      ["series"] = 4;
      ["name_es"] = "Bucaneros Velasangre";
      ["req"] = 37;
   };
   [605] = {
      ["name_ru"] = "Осколки Поющих кристаллов";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Singing Crystal Shards to Crank Fizzlebub.";
      ["next"] = 600;
      ["name_fr"] = "Les eclats bleus chantants";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "歌唱水晶碎片";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Singende blaue Splitter";
      ["faction"] = "Horde";
      ["name"] = "Singing Blue Shards";
      ["level"] = 35;
      ["name_es"] = "Fragmentos de cristales canto azules";
      ["req"] = 30;
   };
   [606] = {
      ["name_ru"] = "Напугать Трусишку";
      ["type"] = "Solo";
      ["objective"] = " we'll have to scare him.$B$BGo out of town and hunt Elder Mistvale Gorillas.  Find a nice selection of giblets";
      ["next"] = 607;
      ["name_fr"] = "Effrayer Philippe le Chancelant";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "??病鬼";
      ["repgain"] = {
         [21] = 25;
      };
      ["name_de"] = "Zitterhand Angst einjagen";
      ["faction"] = "Horde";
      ["name"] = "Scaring Shaky";
      ["level"] = 41;
      ["name_es"] = "Asusta al Tremulo";
      ["req"] = 30;
   };
   [607] = {
      ["name_ru"] = "Возвращение к Маккинли";
      ["type"] = "Solo";
      ["name_fr"] = "De retour chez MacKinley";
      ["repgain"] = {
         [21] = 150;
      };
      ["name_de"] = "Ruckkehr zu MacKinley";
      ["name"] = "Return to MacKinley";
      ["name_cn"] = "向?克基雷回?";
      ["objective"] = "Bring Shaky's Payment to Sea Wolf\" MacKinley.\"";
      ["next"] = 609;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 606;
      ["prequests"] = {
         [1] = 606;
      };
      ["level"] = 41;
      ["name_es"] = "Regresa junto a MacKinley";
      ["req"] = 30;
   };
   [608] = {
      ["name_ru"] = "Пираты Кровавого Паруса";
      ["objective"] = "Fleet-Master Seahorn in Booty Bay wants you to kill Captain Stillwater, Captain Keelhaul and Fleet Master Firallon.";
      ["name_cn"] = "血帆海盗";
      ["sort"] = "Stranglethorn Valley";
      ["level"] = 45;
      ["type"] = "Solo";
      ["name_fr"] = "Les boucaniers de la Voile sanglante";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Die Blutsegelbukaniere";
      ["reward"] = {
         [1] = 4138;
      };
      ["faction"] = "Horde";
      ["name"] = "The Bloodsail Buccaneers";
      ["prev"] = 604;
      ["prequests"] = {
         [1] = 604;
      };
      ["series"] = 5;
      ["name_es"] = "Bucaneros Velasangre";
      ["req"] = 37;
   };
   [609] = {
      ["name_ru"] = "Должники вуду";
      ["type"] = "Solo";
      ["name_fr"] = "Gages vaudou";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Voodooschulden";
      ["name"] = "Voodoo Dues";
      ["name_cn"] = "??行?";
      ["objective"] = " Jon-Jon the Crow";
      ["next"] = 613;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 607;
      ["prequests"] = {
         [1] = 607;
      };
      ["level"] = 44;
      ["name_es"] = "El vudu debido";
      ["req"] = 30;
   };
   [610] = {
      ["name_ru"] = "\"Красавчик\" Дункан";
      ["type"] = "Solo";
      ["name_fr"] = "Duncan ≪?le Beau garcon?≫";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Schonling Duncan";
      ["name"] = "Pretty Boy\" Duncan\"";
      ["name_cn"] = "?小?子?肯";
      ["objective"] = " one of the Bloodsail Buccaneers. Put something 'tween his shoulders and I'm sure he'll give it up.\"";
      ["next"] = 611;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 603;
      ["prequests"] = {
         [1] = 603;
      };
      ["level"] = 39;
      ["name_es"] = "El Guapo\" Duncan";
      ["req"] = 32;
   };
   [611] = {
      ["name_ru"] = "Проклятье приливов";
      ["type"] = "Group";
      ["objective"] = "Destroy the Altar of the Tides with Catelyn's Blade, kill Gazban and bring the Stone of the Tides and Catelyn's Blade back to Baron Revilgaz.";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Der Fluch der Gezeiten";
      ["reward"] = {
         [1] = 4120;
      };
      ["name_cn"] = "海潮的?咒";
      ["name_fr"] = "La malediction des marees";
      ["faction"] = "Alliance";
      ["name"] = "The Curse of the Tides";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 610;
      ["prequests"] = {
         [1] = 610;
      };
      ["level"] = 40;
      ["name_es"] = "La maldicion de las mareas";
      ["req"] = 32;
   };
   [613] = {
      ["name_ru"] = "Вскрыть ногу Моури";
      ["type"] = "Group";
      ["objective"] = "Bring Maury's Key to Sea Wolf\" Mackinley in Booty Bay.\"";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Maurys Fus aufbrechen";
      ["reward"] = {
         [1] = 4129;
      };
      ["name_cn"] = "?雷的腿";
      ["name_fr"] = "Le pied-bot de Maury";
      ["faction"] = "Horde";
      ["name"] = "Cracking Maury's Foot";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 609;
      ["prequests"] = {
         [1] = 609;
      };
      ["level"] = 44;
      ["name_es"] = "Abrir la pata de Maury";
      ["req"] = 30;
   };
   [614] = {
      ["name_ru"] = "Сундук капитана";
      ["type"] = "Group";
      ["objective"] = "Bring Smotts' Chest to Hecklebury Smotts in Booty Bay.";
      ["name_fr"] = "Le coffre du capitaine";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "船?的箱子 (精英)";
      ["reward"] = {
         [1] = 11469;
      };
      ["name_de"] = "Die Truhe des Kapitans";
      ["faction"] = "Alliance";
      ["name"] = "The Captain's Chest";
      ["level"] = 51;
      ["name_es"] = "El cofre del Capitan";
      ["req"] = 35;
   };
   [615] = {
      ["name_ru"] = "Капитанская сабля";
      ["type"] = "Solo";
      ["name_fr"] = "Le sabre du capitaine Smott";
      ["next"] = 8554;
      ["name_de"] = "Der Entersabel des Kapitans";
      ["name_cn"] = "船?的弯刀";
      ["objective"] = "Speak with Sprogger.";
      ["sort"] = "Stranglethorn Valley";
      ["faction"] = "Horde";
      ["name"] = "The Captain's Cutlass";
      ["prev"] = 8552;
      ["prequests"] = {
         [1] = 8552;
      };
      ["level"] = 51;
      ["name_es"] = "El alfanje del Capitan";
      ["req"] = 35;
   };
   [616] = {
      ["name_ru"] = "Остров духов";
      ["type"] = "Solo";
      ["objective"] = "Speak with Baron Revilgaz in Booty Bay.";
      ["next"] = 578;
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "幽??";
      ["name_fr"] = "L'ile hantee";
      ["name_de"] = "Die Spukinsel";
      ["faction"] = "Alliance";
      ["name"] = "The Haunted Isle";
      ["level"] = 37;
      ["name_es"] = "La isla fantasma";
      ["req"] = 32;
   };
   [617] = {
      ["name_ru"] = "Вязанка акириса";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Bundles of Akiris Reed to Privateer Bloads in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "De derriere les fagots";
      ["name_cn"] = "一?海蛇草";
      ["reward"] = {
         [1] = 4117;
      };
      ["name_de"] = "Bundelweise Akiris";
      ["faction"] = "Horde";
      ["name"] = "Akiris by the Bundle";
      ["level"] = 43;
      ["name_es"] = "Tallos de juncos akiris";
      ["req"] = 38;
   };
   [618] = {
      ["name_ru"] = "Бой с Неголашем";
      ["type"] = "Group";
      ["objective"] = "Bring 10 Barbecued Buzzard Wings and 5 bottles of Junglevine Wine to Captain Smotts' Lifeboat.$B$BKill Negolash, and bring Smotts' Cutlass to Captain Smotts in Stranglethorn.";
      ["repgain"] = {
         [21] = 500;
      };
      ["name_de"] = "Negolash entgegentreten";
      ["reward"] = {
         [1] = 4130;
      };
      ["name_cn"] = "挑?奈古拉什";
      ["name_fr"] = "Face a Negolash";
      ["faction"] = "Horde";
      ["name"] = "Facing Negolash";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 615;
      ["prequests"] = {
         [1] = 615;
      };
      ["level"] = 50;
      ["name_es"] = "Enfrentate a Negolash";
      ["req"] = 40;
   };
   [619] = {
      ["name_ru"] = "Приманка для Неголаша";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "引?奈古拉什";
      ["name_fr"] = "Allecher Negolash";
      ["name_de"] = "Negolash anlocken";
      ["faction"] = "Horde";
      ["name"] = "Enticing Negolash";
      ["level"] = 52;
      ["name_es"] = "La tentacion de Negolash";
      ["req"] = 1;
   };
   [621] = {
      ["name_ru"] = "Тайна Занзила";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 samples of Zanzil's Mixture to Crank Fizzlebub in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Le secret de Zanzil";
      ["name_cn"] = "?吉?的秘密";
      ["followup"] = 1119;
      ["reward"] = {
         [1] = 4131;
      };
      ["name_de"] = "Zanzils Geheimnis";
      ["faction"] = "Horde";
      ["name"] = "Zanzil's Secret";
      ["level"] = 44;
      ["name_es"] = "El secreto de Zanzil";
      ["req"] = 35;
   };
   [622] = {
      ["name_ru"] = "Возвращение к капралу Калебу";
      ["type"] = "Solo";
      ["objective"] = "Bring Krazek's Fixed Pot to Corporal Kaleb at the Rebel Camp.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Kehrt zu Korporal Kaleb zuruck";
      ["reward"] = {
         [1] = 4124;
      };
      ["name_cn"] = "向?雷布下士回?";
      ["name_fr"] = "La cocotte du caporal Kaleb";
      ["faction"] = "Alliance";
      ["name"] = "Return to Corporal Kaleb";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 627;
      ["prequests"] = {
         [1] = 627;
      };
      ["level"] = 37;
      ["name_es"] = "Regresa junto al cabo Kaleb";
      ["req"] = 32;
   };
   [623] = {
      ["name_ru"] = "Вязанка акириса";
      ["type"] = "Solo";
      ["name_fr"] = "De derriere les fagots";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Bundelweise Akiris";
      ["name_cn"] = "一?海蛇草";
      ["name"] = "Akiris by the Bundle";
      ["objective"] = "Bring a Bundle of Akiris Reeds to Privateer Groy in Theramore.";
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 617;
      ["prequests"] = {
         [1] = 617;
      };
      ["level"] = 43;
      ["name_es"] = "Tallos de juncos akiris";
      ["req"] = 38;
   };
   [624] = {
      ["name_ru"] = "Загадка Кортелло";
      ["type"] = "Solo";
      ["objective"] = "Solve the riddle!";
      ["next"] = 625;
      ["name_fr"] = "Devinette de Cortello";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "科泰?的??";
      ["series"] = 1;
      ["name_de"] = "Cortellos Ratsel";
      ["faction"] = "Horde";
      ["name"] = "Cortello's Riddle";
      ["level"] = 43;
      ["name_es"] = "El enigma de Cortello";
      ["req"] = 35;
   };
   [625] = {
      ["name_ru"] = "Загадка Кортелло";
      ["type"] = "Solo";
      ["name_fr"] = "Devinette de Cortello";
      ["next"] = 626;
      ["name_de"] = "Cortellos Ratsel";
      ["name"] = "Cortello's Riddle";
      ["name_cn"] = "科泰?的??";
      ["objective"] = "Solve the riddle!";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 624;
      ["prequests"] = {
         [1] = 624;
      };
      ["level"] = 43;
      ["name_es"] = "El enigma de Cortello";
      ["req"] = 35;
   };
   [626] = {
      ["name_ru"] = "Загадка Кортелло";
      ["type"] = "Solo";
      ["objective"] = "Solve the riddle!";
      ["name_de"] = "Cortellos Ratsel";
      ["name_fr"] = "Devinette de Cortello";
      ["reward"] = {
         [1] = 11324;
      };
      ["name_cn"] = "科泰?的??";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["name"] = "Cortello's Riddle";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 625;
      ["prequests"] = {
         [1] = 625;
      };
      ["level"] = 51;
      ["name_es"] = "El enigma de Cortello";
      ["req"] = 35;
   };
   [627] = {
      ["name_ru"] = "Просьба Кразека";
      ["type"] = "Solo";
      ["name_fr"] = "Un service pour Krazek";
      ["repgain"] = {
         [21] = 150;
      };
      ["name_de"] = "Gefallen fur Krazek";
      ["name"] = "Favor for Krazek";
      ["name_cn"] = "克拉?克的要求";
      ["objective"] = "Bring 4 loads of Lesser Bloodstone Ore to Krazek in Booty Bay.";
      ["next"] = 622;
      ["faction"] = "Alliance";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 210;
      ["prequests"] = {
         [1] = 210;
      };
      ["level"] = 37;
      ["name_es"] = "Un favor a Krazek";
      ["req"] = 32;
   };
   [628] = {
      ["name_ru"] = "Эксельзиор";
      ["type"] = "Group";
      ["objective"] = "Bring an Elder Crocolisk Skin to Drizzlik in Booty Bay.";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Exzelsior";
      ["reward"] = {
         [1] = 4109;
      };
      ["name_cn"] = "?花皮靴";
      ["name_fr"] = "L’Excelsior de chez Drizzlik";
      ["faction"] = "Horde";
      ["name"] = "Excelsior";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 577;
      ["prequests"] = {
         [1] = 577;
      };
      ["level"] = 38;
      ["name_es"] = "Borcegui";
      ["req"] = 31;
   };
   [629] = {
      ["name_ru"] = "Коварный риф";
      ["type"] = "Group";
      ["objective"] = "Bring a Tablet Shard to Kin'weelay at the Grom'gol Base Camp.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Le Recif infame";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "暗礁海";
      ["name_de"] = "Das Finstere Riff";
      ["faction"] = "Horde";
      ["name"] = "The Vile Reef";
      ["level"] = 37;
      ["name_es"] = "El Arrecife Mortal";
      ["req"] = 30;
   };
   [630] = {
      ["name_ru"] = "Послание в бутылке";
      ["type"] = "Group";
      ["objective"] = "Slay King Mukla and return to Princess Poobah with the Key to free her.";
      ["name_de"] = "Flaschenpost";
      ["name_fr"] = "Message dans une bouteille";
      ["reward"] = {
         [1] = 4118;
      };
      ["name_cn"] = "瓶中信";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "Message in a Bottle";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 594;
      ["prequests"] = {
         [1] = 594;
      };
      ["level"] = 51;
      ["name_es"] = "Mensaje en una botella";
      ["req"] = 45;
   };
   [631] = {
      ["name_ru"] = "Мост Тандола";
      ["type"] = "Group";
      ["name_fr"] = "Le viaduc de Thandol";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Der Thandolubergang";
      ["name_cn"] = "?多?大?";
      ["objective"] = "Rhag Garmason wants you to locate Ol' Rustlocke.";
      ["next"] = 632;
      ["sort"] = "Wetlands";
      ["name"] = "The Thandol Span";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 31;
      ["name_es"] = "El Puente Thandol";
      ["req"] = 28;
   };
   [632] = {
      ["name_ru"] = "Мост Тандола";
      ["objective"] = "Report back to Rhag Garmason and show him the parchment you found on Rustlocke's corpse.";
      ["name_cn"] = "?多?大?";
      ["sort"] = "Wetlands";
      ["level"] = 31;
      ["type"] = "Solo";
      ["name_fr"] = "Le viaduc de Thandol";
      ["next"] = 633;
      ["name_de"] = "Der Thandolubergang";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Thandol Span";
      ["prev"] = 631;
      ["prequests"] = {
         [1] = 631;
      };
      ["series"] = 2;
      ["name_es"] = "El Puente Thandol";
      ["req"] = 28;
   };
   [633] = {
      ["name_ru"] = "Мост Тандола";
      ["objective"] = "Destroy the cache of explosives.";
      ["name_cn"] = "?多?大?";
      ["sort"] = "Wetlands";
      ["level"] = 31;
      ["type"] = "Solo";
      ["name_fr"] = "Le viaduc de Thandol";
      ["next"] = 634;
      ["name_de"] = "Der Thandolubergang";
      ["repgain"] = {
         [47] = 150;
      };
      ["reward"] = {
         [1] = 4504;
         [2] = 4505;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Thandol Span";
      ["prev"] = 632;
      ["prequests"] = {
         [1] = 632;
      };
      ["series"] = 3;
      ["name_es"] = "El Puente Thandol";
      ["req"] = 28;
   };
   [634] = {
      ["name_ru"] = "Просьба о помощи";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel a l'Alliance";
      ["name_de"] = "Hilfegesuch an die Allianz";
      ["name_cn"] = "?求援助";
      ["objective"] = "Seek out Captain Nials at Refuge Pointe.";
      ["sort"] = "Wetlands";
      ["faction"] = "Alliance";
      ["name"] = "Plea To The Alliance";
      ["prev"] = 633;
      ["prequests"] = {
         [1] = 633;
      };
      ["level"] = 31;
      ["name_es"] = "Peticion a la Alianza";
      ["req"] = 28;
   };
   [635] = {
      ["name_ru"] = "Горный кристалл";
      ["type"] = "Solo";
      ["objective"] = "Find the crystal from your vision.";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "山中的水晶";
      ["name_fr"] = "Le cristal dans les montagnes";
      ["name_de"] = "Kristall in den Bergen";
      ["faction"] = "Horde";
      ["name"] = "Crystal in the Mountains";
      ["level"] = 35;
      ["name_es"] = "Cristal en las montanas";
      ["req"] = 30;
   };
   [636] = {
      ["name_ru"] = "Легенды Земли";
      ["type"] = "Solo";
      ["objective"] = "Find the Shards of Myzrael.";
      ["name_cn"] = "大地公主的??";
      ["sort"] = "Arathi Highlands";
      ["name_de"] = "Legenden der Erde <NYI>";
      ["faction"] = "Horde";
      ["name"] = "Legends of the Earth";
      ["level"] = 35;
      ["name_es"] = "Leyendas de la tierra <NYI>";
      ["req"] = 30;
   };
   [637] = {
      ["name_ru"] = "Письмо Салли Балу";
      ["type"] = "Solo";
      ["objective"] = "Deliver Sully Balloo's Letter to Sara Balloo.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "Lettre de Sully Balloo";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?利・巴?的信";
      ["name_de"] = "Sully Balloos Brief";
      ["faction"] = "Alliance";
      ["name"] = "Sully Balloo's Letter";
      ["level"] = 30;
      ["name_es"] = "La carta de Sully Balloo";
      ["req"] = 25;
   };
   [638] = {
      ["name_ru"] = "Троллебой";
      ["type"] = "Solo";
      ["objective"] = "Travel to Hammerfall in the Arathi Highlands and speak with Zengu.";
      ["next"] = 639;
      ["name_fr"] = "Trollemort";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "巨魔之?";
      ["repgain"] = {
         [530] = 25;
      };
      ["name_de"] = "Trollbann";
      ["faction"] = "Horde";
      ["name"] = "Trollbane";
      ["level"] = 37;
      ["name_es"] = "Aterratrols";
      ["req"] = 32;
   };
   [639] = {
      ["name_ru"] = "Печать Cтрома";
      ["type"] = "Group";
      ["name_fr"] = "Le cachet de Strom";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Siegelzeichen von Strom";
      ["name"] = "Sigil of Strom";
      ["name_cn"] = "激流堡符印";
      ["objective"] = "Get the Sigil of Strom for Zengu in Hammerfall.";
      ["next"] = 640;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 638;
      ["prequests"] = {
         [1] = 638;
      };
      ["level"] = 37;
      ["name_es"] = "El sigilo de Strom";
      ["req"] = 32;
   };
   [640] = {
      ["name_ru"] = "Сломанная печать";
      ["type"] = "Group";
      ["name_fr"] = "Le Glyphe qui fut brise";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Das zerbrochene Siegel";
      ["name_cn"] = "破碎的符印";
      ["name"] = "The Broken Sigil";
      ["objective"] = "Retrieve the 5 Sigil Fragments from the defenders in Stromgarde, and bring them to Tor'gan in Hammerfall.";
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 639;
      ["prequests"] = {
         [1] = 639;
      };
      ["level"] = 40;
      ["name_es"] = "El sigilo roto";
      ["req"] = 32;
   };
   [641] = {
      ["name_ru"] = "Печать Торадина";
      ["type"] = "Solo";
      ["name_fr"] = "Glyphe de Thoradin";
      ["repgain"] = {
         [530] = 25;
      };
      ["name_de"] = "Siegelzeichen des Thoradin";
      ["name"] = "Sigil of Thoradin";
      ["name_cn"] = "索拉丁符印";
      ["objective"] = "Bring the restored Sigil of Thoradin to Zengu in Hammerfall.";
      ["next"] = 643;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 640;
      ["prequests"] = {
         [1] = 640;
      };
      ["level"] = 40;
      ["name_es"] = "El sigilo de Thoradin";
      ["req"] = 32;
   };
   [642] = {
      ["name_ru"] = "Пойманная принцесса";
      ["type"] = "Solo";
      ["objective"] = "Gather 12 Motes of Myzrael, then bring them to the Iridescent Shards in Drywhisker Gorge.";
      ["next"] = 651;
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "被困的公主";
      ["name_fr"] = "La princesse emprisonnee";
      ["name_de"] = "Die gefangene Prinzessin";
      ["faction"] = "Horde";
      ["name"] = "The Princess Trapped";
      ["level"] = 37;
      ["name_es"] = "La princesa encerrada";
      ["req"] = 30;
   };
   [643] = {
      ["name_ru"] = "Печать Аратора";
      ["type"] = "Group";
      ["name_fr"] = "Glyphe d'Arathor";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Siegelzeichen von Arathor";
      ["name"] = "Sigil of Arathor";
      ["name_cn"] = "阿拉索符印";
      ["objective"] = "Retrieve the Sigil of Arathor and return it to Zengu in Hammerfall.";
      ["next"] = 644;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 641;
      ["prequests"] = {
         [1] = 641;
      };
      ["level"] = 41;
      ["name_es"] = "El sigilo de Arathor";
      ["req"] = 32;
   };
   [644] = {
      ["name_ru"] = "Печать Троллебоя";
      ["type"] = "Group";
      ["name_fr"] = "Glyphe de Trollemort";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Siegelzeichen von Trollbann";
      ["name"] = "Sigil of Trollbane";
      ["name_cn"] = "托??恩符印";
      ["objective"] = "Kill Prince Galen Trollbane and bring the Sigil of Trollbane to Zengu in Hammerfall.";
      ["next"] = 645;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 643;
      ["prequests"] = {
         [1] = 643;
      };
      ["level"] = 42;
      ["name_es"] = "El sigilo de Aterratrols";
      ["req"] = 32;
   };
   [645] = {
      ["name_ru"] = "Трол'калар";
      ["objective"] = "Retrieve Trol'kalar from Trollbane's tomb in Stromgarde.";
      ["name_cn"] = "托?拉?";
      ["sort"] = "Arathi Highlands";
      ["level"] = 42;
      ["type"] = "Group";
      ["name_fr"] = "Trol'kalar";
      ["next"] = 646;
      ["name_de"] = "Trol'kalar";
      ["repgain"] = {
         [530] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Trol'kalar";
      ["prev"] = 644;
      ["prequests"] = {
         [1] = 644;
      };
      ["series"] = 1;
      ["name_es"] = "Trol'kalar";
      ["req"] = 32;
   };
   [646] = {
      ["name_ru"] = "Трол'калар";
      ["objective"] = "Deliver Trol'kalar to Zengu in Hammerfall.";
      ["name_cn"] = "托?拉?";
      ["sort"] = "Arathi Highlands";
      ["level"] = 42;
      ["type"] = "Group";
      ["name_fr"] = "Trol'kalar";
      ["repgain"] = {
         [530] = 350;
      };
      ["name_de"] = "Trol'kalar";
      ["reward"] = {
         [1] = 4508;
         [2] = 4507;
      };
      ["faction"] = "Horde";
      ["name"] = "Trol'kalar";
      ["prev"] = 645;
      ["prequests"] = {
         [1] = 645;
      };
      ["series"] = 2;
      ["name_es"] = "Trol'kalar";
      ["req"] = 32;
   };
   [647] = {
      ["name_ru"] = "Самогон Маккрила";
      ["type"] = "Solo";
      ["objective"] = "Take MacKreel's Moonshine to Brewmeister Bilger in Southshore.";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_fr"] = "Le tord-boyaux de MacKreel";
      ["sort"] = "Wetlands";
      ["name_cn"] = "?克里?的月光酒";
      ["name_de"] = "MacKreels Fusel";
      ["faction"] = "Alliance";
      ["name"] = "MacKreel's Moonshine";
      ["level"] = 30;
      ["name_es"] = "Licor de luna de Mackreel";
      ["req"] = 28;
   };
   [648] = {
      ["name_ru"] = "Спасти КПХ-17/TN!";
      ["objective"] = " safe place so it can begin a lengthy take-off procedure.  It has built-in cloaking";
      ["name_cn"] = "拯救OOX-17/TN！";
      ["sort"] = "Tanaris";
      ["level"] = 48;
      ["type"] = "Solo";
      ["name_fr"] = "A la rescousse de OOX-17/TN?!";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Rettet OOX-17/TN!";
      ["followup"] = 3721;
      ["faction"] = "Horde";
      ["name"] = "Rescue OOX-17/TN!";
      ["prev"] = 351;
      ["prequests"] = {
         [1] = 351;
      };
      ["reward"] = {
         [1] = 1;
         [2] = 1;
      };
      ["name_es"] = "!Rescatar a OOX-17/TN!";
      ["req"] = 43;
   };
   [649] = {
      ["name_ru"] = "За медовухой";
      ["type"] = "Solo";
      ["objective"] = "Talk to Malton Droffers in Orgrimmar.";
      ["next"] = 650;
      ["name_fr"] = "La recuperation de Houle";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?找蜜酒";
      ["series"] = 1;
      ["name_de"] = "Bergung der Welle";
      ["faction"] = "Horde";
      ["name"] = "Ripple Recovery";
      ["level"] = 48;
      ["name_es"] = "Recupera el calimocho";
      ["req"] = 42;
   };
   [650] = {
      ["name_ru"] = "За медовухой";
      ["objective"] = "Talk to Gilveradin Sunchaser; his camp is located in the Hinterlands.";
      ["name_cn"] = "?找蜜酒";
      ["sort"] = "Orgrimmar";
      ["level"] = 48;
      ["type"] = "Solo";
      ["name_fr"] = "La recuperation de Houle";
      ["next"] = 77;
      ["name_de"] = "Bergung der Welle";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Ripple Recovery";
      ["prev"] = 649;
      ["prequests"] = {
         [1] = 649;
      };
      ["series"] = 2;
      ["name_es"] = "Recupera el calimocho";
      ["req"] = 42;
   };
   [651] = {
      ["name_ru"] = "Связывающие камни";
      ["type"] = "Solo";
      ["name_fr"] = "Les pierres de lien";
      ["next"] = 652;
      ["name_de"] = "Steine der Bindung";
      ["name_cn"] = "禁?之石";
      ["objective"] = "Gather the Burning Key, the Cresting Key and the Thundering Key from the Stone of West Binding, the Stone of East Binding and the Stone of Outer Binding.$B$BBring them to the Stone of Inner Binding.";
      ["sort"] = "Arathi Highlands";
      ["faction"] = "Horde";
      ["name"] = "Stones of Binding";
      ["prev"] = 642;
      ["prequests"] = {
         [1] = 642;
      };
      ["level"] = 38;
      ["name_es"] = "Piedras de Vinculo";
      ["req"] = 30;
   };
   [652] = {
      ["name_ru"] = "Разбить краеугольный камень";
      ["type"] = "Group";
      ["name_fr"] = "La Pierre cruciale";
      ["name_de"] = "Den Hauptstein zerbrechen";
      ["name_cn"] = "打??匙之石";
      ["objective"] = "Find and kill Fozruk.  Bring the Rod of Order to the Keystone in the Arathi Highlands.";
      ["sort"] = "Arathi Highlands";
      ["faction"] = "Horde";
      ["name"] = "Breaking the Keystone";
      ["prev"] = 651;
      ["prequests"] = {
         [1] = 651;
      };
      ["level"] = 42;
      ["name_es"] = "Desbloquear la piedra angular";
      ["req"] = 30;
   };
   [653] = {
      ["name_ru"] = "Союзники Мизраэль";
      ["type"] = "Solo";
      ["name_fr"] = "Les allies de Myzrael";
      ["next"] = 687;
      ["name_de"] = "Myzraels Verbundete";
      ["objective"] = "Speak with Gerrig Bonegrip in the Forlorn Cavern of Ironforge.";
      ["name_cn"] = "密斯莱?的盟友";
      ["sort"] = "Arathi Highlands";
      ["faction"] = "Alliance";
      ["name"] = "Myzrael's Allies";
      ["followup"] = 687;
      ["prev"] = 652;
      ["prequests"] = {
         [1] = 652;
      };
      ["level"] = 40;
      ["name_es"] = "Aliados de Myzrael";
      ["req"] = 30;
   };
   [654] = {
      ["name_ru"] = "Полевые испытания в Танарисе";
      ["type"] = "Solo";
      ["name_fr"] = "Les echantillons du desert de Tanaris";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Tanaris-Feldproben";
      ["name"] = "Tanaris Field Sampling";
      ["name_cn"] = "塔?利斯的?本";
      ["objective"] = "Acquire acceptable samples for 8 basilisks, 8 hyenas, and 8 scorpions.  Bring the testing kit back to Chief Engineer Bilgewhizzle in Gadgetzan before the power source runs out.";
      ["next"] = 864;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 379;
      ["prequests"] = {
         [1] = 379;
      };
      ["level"] = 46;
      ["name_es"] = "Recogida de muestras en Tanaris";
      ["req"] = 38;
   };
   [655] = {
      ["name_ru"] = "Павший Молот";
      ["type"] = "Solo";
      ["objective"] = "Speak with Tor'gan in Hammerfall.";
      ["next"] = 672;
      ["name_fr"] = "Trepas-d'Orgrim";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "落??";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Hammerfall";
      ["faction"] = "Horde";
      ["name"] = "Hammerfall";
      ["level"] = 34;
      ["name_es"] = "Sentencia";
      ["req"] = 29;
   };
   [656] = {
      ["name_ru"] = "Призыв принцессы";
      ["type"] = "Group";
      ["name_fr"] = "L'invocation de la Princesse";
      ["name_de"] = "Beschworen der Prinzessin";
      ["reward"] = {
         [1] = 4743;
      };
      ["name_cn"] = "召?大地公主";
      ["objective"] = "Go to the Shards of Myzrael, summon her and defeat her.$B$BGather her Eldritch Shackles and bind them to the Shards of Myzrael.";
      ["faction"] = "Horde";
      ["name"] = "Summoning the Princess";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 692;
      ["prequests"] = {
         [1] = 692;
      };
      ["level"] = 50;
      ["name_es"] = "Invocar a la princesa";
      ["req"] = 30;
   };
   [657] = {
      ["name_ru"] = "Новая чума зарождается?";
      ["type"] = "Solo";
      ["name_fr"] = "Les indices d'une Peste nouvelle??";
      ["name_de"] = "Hinweise auf eine neue Seuche?";
      ["name"] = "Hints of a New Plague?";
      ["name_cn"] = "新的瘟疫？";
      ["objective"] = "Speak to Kinelory.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 658;
      ["prequests"] = {
         [1] = 658;
      };
      ["level"] = 36;
      ["name_es"] = "Sospechas de una nueva Peste";
      ["req"] = 30;
   };
   [658] = {
      ["name_ru"] = "Новая чума зарождается?";
      ["objective"] = "Find the Forsaken Courier and bring back her Sealed Folder to Quae near the Go'Shek Farm.";
      ["name_cn"] = "新的瘟疫？";
      ["sort"] = "Hillsbrad Foothills";
      ["level"] = 36;
      ["type"] = "Solo";
      ["name_fr"] = "Les indices d'une Peste nouvelle??";
      ["next"] = 657;
      ["name_de"] = "Hinweise auf eine neue Seuche?";
      ["repgain"] = {
         [72] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Hints of a New Plague?";
      ["prev"] = 659;
      ["prequests"] = {
         [1] = 659;
      };
      ["series"] = 2;
      ["name_es"] = "Sospechas de una nueva Peste";
      ["req"] = 30;
   };
   [659] = {
      ["name_ru"] = "Новая чума зарождается?";
      ["type"] = "Solo";
      ["name_fr"] = "Les indices d'une Peste nouvelle??";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Hinweise auf eine neue Seuche?";
      ["name_cn"] = "新的瘟疫？";
      ["objective"] = "Find Quae and Kinelory near the Go'Shek Farm in the Arathi Highlands.";
      ["next"] = 658;
      ["sort"] = "Hillsbrad Foothills";
      ["name"] = "Hints of a New Plague?";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 33;
      ["name_es"] = "Sospechas de una nueva Peste";
      ["req"] = 30;
   };
   [660] = {
      ["name_ru"] = "Новая чума зарождается?";
      ["type"] = "Solo";
      ["name_fr"] = "Les indices d'une Peste nouvelle??";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Hinweise auf eine neue Seuche?";
      ["name"] = "Hints of a New Plague?";
      ["name_cn"] = "新的瘟疫？";
      ["objective"] = "Protect Kinelory until she returns to Quae.";
      ["next"] = 661;
      ["faction"] = "Alliance";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 657;
      ["prequests"] = {
         [1] = 657;
      };
      ["level"] = 37;
      ["name_es"] = "Sospechas de una nueva Peste";
      ["req"] = 30;
   };
   [661] = {
      ["name_ru"] = "Новая чума зарождается?";
      ["type"] = "Solo";
      ["objective"] = "Find Phin Odelic in Southshore.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Hinweise auf eine neue Seuche?";
      ["reward"] = {
         [1] = 15455;
         [2] = 15456;
      };
      ["name_cn"] = "新的瘟疫？";
      ["name_fr"] = "Les indices d'une Peste nouvelle??";
      ["faction"] = "Alliance";
      ["name"] = "Hints of a New Plague?";
      ["sort"] = "Hillsbrad Foothills";
      ["prev"] = 660;
      ["prequests"] = {
         [1] = 660;
      };
      ["level"] = 37;
      ["name_es"] = "Sospechas de una nueva Peste";
      ["req"] = 30;
   };
   [662] = {
      ["name_ru"] = "Поиски на глубине";
      ["type"] = "Solo";
      ["objective"] = "First Mate Nilzlix wants you to retrieve the Charts and Logs from the Maiden's Folly and the Spirit of Silverpine.";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Tiefsee-Bergung";
      ["reward"] = {
         [1] = 4511;
      };
      ["name_cn"] = "深海打?";
      ["name_fr"] = "Sauvetage en haute mer";
      ["faction"] = "Horde";
      ["name"] = "Deep Sea Salvage";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 663;
      ["prequests"] = {
         [1] = 663;
      };
      ["level"] = 40;
      ["name_es"] = "Rescate en alta mar";
      ["req"] = 35;
   };
   [663] = {
      ["name_ru"] = "Эй, там!";
      ["type"] = "Solo";
      ["objective"] = "Talk to Captain O'Breen in Faldir's Cove.";
      ["repgain"] = {
         [21] = 25;
      };
      ["name_fr"] = "Terre?!";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "法迪?海湾";
      ["name_de"] = "Land in Sicht!";
      ["faction"] = "Horde";
      ["name"] = "Land Ho!";
      ["level"] = 35;
      ["name_es"] = "!Tierra a vista!";
      ["req"] = 35;
   };
   [664] = {
      ["name_ru"] = "Затонувшие печали";
      ["type"] = "Solo";
      ["objective"] = "Captain Steelgut in Faldir's Cove wants you to kill 10 Daggerspine Raiders and 3 Daggerspine Sorceresses.";
      ["repgain"] = {
         [21] = 250;
      };
      ["sort"] = "Arathi Highlands";
      ["name_fr"] = "Chagrin noye";
      ["name_cn"] = "船?的?仇";
      ["reward"] = {
         [1] = 4509;
      };
      ["name_de"] = "Ertrunkene Trauer";
      ["faction"] = "Horde";
      ["name"] = "Drowned Sorrows";
      ["level"] = 40;
      ["name_es"] = "Ahogar las penas";
      ["req"] = 35;
   };
   [665] = {
      ["name_ru"] = "Утонувшее сокровище";
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor englouti";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Versunkener Schatz";
      ["name_cn"] = "水下宝藏";
      ["objective"] = "Escort Professor Phizzlethorpe to the cave and back.";
      ["next"] = 666;
      ["sort"] = "Arathi Highlands";
      ["name"] = "Sunken Treasure";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 40;
      ["name_es"] = "El tesoro sumergido";
      ["req"] = 35;
   };
   [666] = {
      ["name_ru"] = "Утонувшее сокровище";
      ["objective"] = "Doctor Draxlegauge in Faldir's Cove wants you to collect 10 Elven Gems and return the Goggles of Gem Hunting once you are done.";
      ["name_cn"] = "水下宝藏";
      ["sort"] = "Arathi Highlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor englouti";
      ["next"] = 668;
      ["name_de"] = "Versunkene Schatze";
      ["repgain"] = {
         [21] = 350;
      };
      ["reward"] = {
         [1] = 4547;
         [2] = 4548;
      };
      ["faction"] = "Horde";
      ["name"] = "Sunken Treasure";
      ["prev"] = 665;
      ["prequests"] = {
         [1] = 665;
      };
      ["series"] = 2;
      ["name_es"] = "El tesoro sumergido";
      ["req"] = 35;
   };
   [667] = {
      ["name_ru"] = "Смерть со дна морского";
      ["type"] = "Solo";
      ["objective"] = "Protect Shakes O'Breen during the attack.";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Tod von unten";
      ["reward"] = {
         [1] = 4550;
         [2] = 4549;
      };
      ["name_cn"] = "水下伏兵";
      ["name_fr"] = "La mort venue d'en bas";
      ["faction"] = "Horde";
      ["name"] = "Death From Below";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 670;
      ["prequests"] = {
         [1] = 670;
      };
      ["level"] = 44;
      ["name_es"] = "Muerte desde abajo";
      ["req"] = 35;
   };
   [668] = {
      ["name_ru"] = "Утонувшее сокровище";
      ["objective"] = "Take the Elven Gems to Captain O'Breen.";
      ["name_cn"] = "水下宝藏";
      ["sort"] = "Arathi Highlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor englouti";
      ["next"] = 669;
      ["name_de"] = "Versunkener Schatz";
      ["repgain"] = {
         [21] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Sunken Treasure";
      ["prev"] = 666;
      ["prequests"] = {
         [1] = 666;
      };
      ["series"] = 3;
      ["name_es"] = "El tesoro sumergido";
      ["req"] = 35;
   };
   [669] = {
      ["name_ru"] = "Утонувшее сокровище";
      ["objective"] = "Take the Sample Elven Gem to Fleet Master Seahorn in Booty Bay.";
      ["name_cn"] = "水下宝藏";
      ["sort"] = "Arathi Highlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Le tresor englouti";
      ["next"] = 670;
      ["name_de"] = "Versunkener Schatz";
      ["repgain"] = {
         [21] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Sunken Treasure";
      ["prev"] = 668;
      ["prequests"] = {
         [1] = 668;
      };
      ["series"] = 4;
      ["name_es"] = "El tesoro sumergido";
      ["req"] = 35;
   };
   [670] = {
      ["name_ru"] = "Утонувшее сокровище";
      ["type"] = "Solo";
      ["objective"] = "Deliver Seahorn's Letter to Shakes O'Breen in Arathi Highlands.";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Versunkener Schatz";
      ["name"] = "Sunken Treasure";
      ["name_cn"] = "水下宝藏";
      ["name_fr"] = "Le tresor englouti";
      ["series"] = 5;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 669;
      ["prequests"] = {
         [1] = 669;
      };
      ["level"] = 40;
      ["name_es"] = "El tesoro sumergido";
      ["req"] = 35;
   };
   [671] = {
      ["name_ru"] = "Зловещая магия";
      ["type"] = "Solo";
      ["objective"] = "Get 10 Bloodstone Amulets for Tor'gan in Hammerfall.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Magies immondes";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "邪?的魔法";
      ["name_de"] = "Elende Magien";
      ["faction"] = "Horde";
      ["name"] = "Foul Magics";
      ["level"] = 33;
      ["name_es"] = "Magia demoniaca";
      ["req"] = 30;
   };
   [672] = {
      ["name_ru"] = "Вызов духов";
      ["objective"] = "Acquire 10 Highland Raptor Eyes from Highland Striders and Highland Thrashers for Tor'gan in Hammerfall.";
      ["name_cn"] = "振?精神";
      ["sort"] = "Arathi Highlands";
      ["level"] = 34;
      ["type"] = "Solo";
      ["name_fr"] = "L'eveil de l'esprit";
      ["next"] = 674;
      ["name_de"] = "Stimmungsaufheller";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Raising Spirits";
      ["prev"] = 655;
      ["prequests"] = {
         [1] = 655;
      };
      ["series"] = 1;
      ["name_es"] = "El despertar de los espiritus";
      ["req"] = 29;
   };
   [673] = {
      ["name_ru"] = "Зловещая магия";
      ["type"] = "Group";
      ["objective"] = "Retrieve Marez Cowl's Bloodstone Orb and bring it to Tor'gan in Hammerfall.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Elende Magien";
      ["reward"] = {
         [1] = 4543;
         [2] = 4545;
      };
      ["name_cn"] = "邪?的魔法";
      ["name_fr"] = "Magies immondes";
      ["faction"] = "Horde";
      ["name"] = "Foul Magics";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 671;
      ["prequests"] = {
         [1] = 671;
      };
      ["level"] = 40;
      ["name_es"] = "Magia demoniaca";
      ["req"] = 35;
   };
   [674] = {
      ["name_ru"] = "Вызов духов";
      ["objective"] = "Give the Raptor Talon Amulet to Gor'mul.";
      ["name_cn"] = "振?精神";
      ["sort"] = "Arathi Highlands";
      ["level"] = 34;
      ["type"] = "Solo";
      ["name_fr"] = "L'eveil de l'esprit";
      ["next"] = 675;
      ["name_de"] = "Mut machen";
      ["repgain"] = {
         [76] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Raising Spirits";
      ["prev"] = 672;
      ["prequests"] = {
         [1] = 672;
      };
      ["series"] = 2;
      ["name_es"] = "El despertar de los espiritus";
      ["req"] = 29;
   };
   [675] = {
      ["name_ru"] = "Вызов духов";
      ["objective"] = "Speak with Tor'gan.";
      ["name_cn"] = "振?精神";
      ["sort"] = "Arathi Highlands";
      ["level"] = 34;
      ["type"] = "Solo";
      ["name_fr"] = "L'eveil de l'esprit";
      ["next"] = 701;
      ["name_de"] = "Mut machen";
      ["repgain"] = {
         [76] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Raising Spirits";
      ["prev"] = 674;
      ["prequests"] = {
         [1] = 674;
      };
      ["series"] = 3;
      ["name_es"] = "El despertar de los espiritus";
      ["req"] = 29;
   };
   [676] = {
      ["name_ru"] = "Да падет молот";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Boulderfist Ogres and 10 Boulderfist Enforcers, then find Drum Fel in the Hammerfall outpost in Arathi Highlands.";
      ["next"] = 677;
      ["name_fr"] = "Menace sur le Trepas-d'Orgrim";
      ["sort"] = "Hillsbrad Foothills";
      ["name_cn"] = "落?之?";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Der Hammer kann fallen";
      ["faction"] = "Horde";
      ["name"] = "The Hammer May Fall";
      ["level"] = 32;
      ["name_es"] = "La Sentencia";
      ["req"] = 30;
   };
   [677] = {
      ["name_ru"] = "К оружию!";
      ["objective"] = "Slay 10 Witherbark Axe Throwers, 10 Headhunters and 8 Witch Doctors, and return to Drum Fel in the Hammerfall outpost.";
      ["name_cn"] = "短兵相接";
      ["sort"] = "Arathi Highlands";
      ["level"] = 32;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du combat";
      ["next"] = 678;
      ["name_de"] = "Zu den Waffen";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Call to Arms";
      ["prev"] = 676;
      ["prequests"] = {
         [1] = 676;
      };
      ["series"] = 1;
      ["name_es"] = "Un llamamiento a las armas";
      ["req"] = 30;
   };
   [678] = {
      ["name_ru"] = "К оружию!";
      ["objective"] = "Kill 10 Boulderfist Brutes and 4 Boulderfist Magi, and return to Drum Fel in the Hammerfall outpost.";
      ["name_cn"] = "短兵相接";
      ["sort"] = "Arathi Highlands";
      ["level"] = 38;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du combat";
      ["next"] = 679;
      ["name_de"] = "Zu den Waffen";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Call to Arms";
      ["prev"] = 677;
      ["prequests"] = {
         [1] = 677;
      };
      ["series"] = 2;
      ["name_es"] = "Un llamamiento a las armas";
      ["req"] = 30;
   };
   [679] = {
      ["name_ru"] = "К оружию!";
      ["objective"] = "Kill 7 Boulderfist Shaman and 3 Boulderfist Lords and return to Drum Fel in the Hammerfall outpost.";
      ["name_cn"] = "短兵相接";
      ["sort"] = "Arathi Highlands";
      ["level"] = 40;
      ["type"] = "Group";
      ["name_fr"] = "L'appel du combat";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Zu den Waffen";
      ["reward"] = {
         [1] = 9520;
         [2] = 9521;
      };
      ["faction"] = "Horde";
      ["name"] = "Call to Arms";
      ["prev"] = 678;
      ["prequests"] = {
         [1] = 678;
      };
      ["series"] = 3;
      ["name_es"] = "Un llamamiento a las armas";
      ["req"] = 30;
   };
   [680] = {
      ["name_ru"] = "Настоящая угроза";
      ["type"] = "Group";
      ["objective"] = "Slay Or'Kalar and bring his Head to Korin Fel in the Hammerfall outpost.";
      ["repgain"] = {
         [76] = 350;
      };
      ["sort"] = "Arathi Highlands";
      ["name_fr"] = "La reelle menace";
      ["name_cn"] = "真正的威?";
      ["reward"] = {
         [1] = 4976;
         [2] = 4977;
      };
      ["name_de"] = "Die echte Bedrohung";
      ["faction"] = "Horde";
      ["name"] = "The Real Threat";
      ["level"] = 40;
      ["name_es"] = "Una autentica amenaza";
      ["req"] = 30;
   };
   [681] = {
      ["name_ru"] = "Северное поместье";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Syndicate Highwaymen and 6 Syndicate Mercenaries.$B$BReturn to Captain Nials at Refuge Pointe.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "Le manoir de Nordclos";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "?斯弗德??";
      ["name_de"] = "Nordhof";
      ["faction"] = "Alliance";
      ["name"] = "Northfold Manor";
      ["level"] = 31;
      ["name_es"] = "Mansion Redilnorte";
      ["req"] = 30;
   };
   [682] = {
      ["name_ru"] = "Знаки Стромгарда";
      ["type"] = "Group";
      ["objective"] = "Bring 7 Stromgarde Badges to Captain Nials at Refuge Pointe.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Abzeichen von Stromgarde";
      ["reward"] = {
         [1] = 4741;
      };
      ["name_cn"] = "激流堡徽章";
      ["name_fr"] = "Les insignes de Stromgarde";
      ["faction"] = "Alliance";
      ["name"] = "Stromgarde Badges";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 681;
      ["prequests"] = {
         [1] = 681;
      };
      ["level"] = 37;
      ["name_es"] = "Distintivos de Stromgarde";
      ["req"] = 30;
   };
   [683] = {
      ["name_ru"] = "Просьба Сары Балу";
      ["type"] = "Solo";
      ["name_fr"] = "Requete de Sara Balloo";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Sara Balloos Hilfegesuch";
      ["name_cn"] = "?拉・巴?的?求";
      ["name"] = "Sara Balloo's Plea";
      ["objective"] = "Take Sara Balloo's note to King Magni Bronzebeard of Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 637;
      ["prequests"] = {
         [1] = 637;
      };
      ["level"] = 30;
      ["name_es"] = "La peticion de Sara Balloo";
      ["req"] = 25;
   };
   [684] = {
      ["name_ru"] = "Разыскивается: Марез Клобук";
      ["type"] = "Group";
      ["objective"] = "Bring Marez's head to Captain Nials at Refuge Pointe.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Arathi Highlands";
      ["name_fr"] = "On recherche?: Marez Capuche";
      ["name_cn"] = "通?：?雷?・考?";
      ["reward"] = {
         [1] = 4744;
      };
      ["name_de"] = "GESUCHT: Marez Schattenkutte";
      ["faction"] = "Alliance";
      ["name"] = "Wanted!  Marez Cowl";
      ["level"] = 39;
      ["name_es"] = "Se busca: Marez Cogulla";
      ["req"] = 30;
   };
   [685] = {
      ["name_ru"] = "Разыскивается: Отто и лорд Соколиный Шлем";
      ["type"] = "Group";
      ["objective"] = "Bring Otto's Head and Falconcrest's Head to Captain Nials at Refuge Pointe.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Arathi Highlands";
      ["name_fr"] = "On recherche?: Otto et Lepervier";
      ["name_cn"] = "通?：奥?和法?雷斯特";
      ["reward"] = {
         [1] = 5247;
         [2] = 4745;
      };
      ["name_de"] = "GESUCHT: Falkenstein und Otto";
      ["faction"] = "Alliance";
      ["name"] = "Wanted!  Otto and Falconcrest";
      ["level"] = 40;
      ["name_es"] = "Se busca: Otto y Lord Falconcrest";
      ["req"] = 30;
   };
   [686] = {
      ["name_ru"] = "Королевские почести";
      ["objective"] = "King Magni Bronzebeard wants you to speak with Grand Mason Marblesten.";
      ["name_cn"] = "国王的礼物";
      ["sort"] = "Ironforge";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Hommage royal";
      ["next"] = 689;
      ["name_de"] = "Ehrerbietung von einem Konig";
      ["repgain"] = {
         [47] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "A King's Tribute";
      ["prev"] = 683;
      ["prequests"] = {
         [1] = 683;
      };
      ["series"] = 1;
      ["name_es"] = "Un homenaje real";
      ["req"] = 25;
   };
   [687] = {
      ["name_ru"] = "Тельдарин Заблудший";
      ["type"] = "Solo";
      ["objective"] = "Find Theldurin the Lost.";
      ["next"] = 692;
      ["name_fr"] = "Theldurin l’Egare";
      ["sort"] = "Arathi Highlands";
      ["name_cn"] = "迷失者塞?杜林";
      ["name"] = "Theldurin the Lost";
      ["name_de"] = "Theldurin der Verirrte";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 653;
         [2] = 688;
      };
      ["level"] = 40;
      ["name_es"] = "Theldurin el Perdido";
      ["req"] = 30;
   };
   [688] = {
      ["name_ru"] = "Союзники Мизраэли";
      ["type"] = "Solo";
      ["name_fr"] = "Les allies de Myzrael";
      ["next"] = 687;
      ["name_de"] = "Myzraels Verbundete";
      ["objective"] = "Speak with Zaruk in Hammerfall.";
      ["name_cn"] = "密斯莱?的盟友";
      ["sort"] = "Arathi Highlands";
      ["faction"] = "Horde";
      ["name"] = "Myzrael's Allies";
      ["followup"] = 687;
      ["prev"] = 652;
      ["prequests"] = {
         [1] = 652;
      };
      ["level"] = 40;
      ["name_es"] = "Aliados de Myzrael";
      ["req"] = 30;
   };
   [689] = {
      ["name_ru"] = "Королевские почести";
      ["type"] = "Solo";
      ["objective"] = "Grand Mason Marblesten of Ironforge wants 5 pieces of Alterac Granite.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Ehrerbietung von einem Konig";
      ["name"] = "A King's Tribute";
      ["name_cn"] = "国王的礼物";
      ["name_fr"] = "Hommage royal";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 686;
      ["prequests"] = {
         [1] = 686;
      };
      ["level"] = 31;
      ["name_es"] = "Un homenaje real";
      ["req"] = 25;
   };
   [690] = {
      ["name_ru"] = "Просьба Малина";
      ["type"] = "Solo";
      ["objective"] = "Find Skuerto at Refuge Pointe in the Arathi Highlands.";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_fr"] = "La demande de Malin";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?林的要求";
      ["name_de"] = "Malins Gesuch";
      ["faction"] = "Alliance";
      ["name"] = "Malin's Request";
      ["level"] = 32;
      ["name_es"] = "Una peticion de Malin";
      ["req"] = 30;
   };
   [691] = {
      ["name_ru"] = "На вес золота";
      ["type"] = "Solo";
      ["name_fr"] = "Valoir son poids en or";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Sein Gewicht in Gold";
      ["name_cn"] = "?明?力";
      ["name"] = "Worth Its Weight in Gold";
      ["objective"] = "Find 10 Witherbark Tusks, 4 Witherbark Medicine Pouches and a Shadow Hunter Knife for Apprentice Kryten at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 690;
      ["prequests"] = {
         [1] = 690;
      };
      ["level"] = 36;
      ["name_es"] = "Valer su peso en oro";
      ["req"] = 30;
   };
   [692] = {
      ["name_ru"] = "Утраченные фрагменты";
      ["type"] = "Solo";
      ["name_fr"] = "Les fragments perdus";
      ["name_de"] = "Die verlorenen Fragmente";
      ["name_cn"] = "?失的卷?碎片";
      ["objective"] = "Bring the Torn Scroll Fragment, the Crumpled Scroll Fragment and the Singed Scroll Fragment to Theldurin the Lost.";
      ["sort"] = "Badlands";
      ["faction"] = "Horde";
      ["name"] = "The Lost Fragments";
      ["prev"] = 687;
      ["prequests"] = {
         [1] = 687;
      };
      ["level"] = 41;
      ["name_es"] = "Los trozos perdidos";
      ["req"] = 30;
   };
   [693] = {
      ["name_ru"] = "Оружие получше кулаков";
      ["type"] = "Solo";
      ["name_fr"] = "La baguette au poing";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Zauberstab gegen Faust";
      ["name_cn"] = "特雷莱恩的符咒魔杖";
      ["name"] = "Wand over Fist";
      ["objective"] = "Find Trelane's Wand of Invocation and return it to Skuerto at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 691;
      ["prequests"] = {
         [1] = 691;
      };
      ["level"] = 39;
      ["name_es"] = "Empunar la varita";
      ["req"] = 30;
   };
   [694] = {
      ["name_ru"] = "Оборона Трелана";
      ["type"] = "Group";
      ["name_fr"] = "Les defenses de Trelane";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Trelanes Verteidigung";
      ["name"] = "Trelane's Defenses";
      ["name_cn"] = "特雷莱恩的防御";
      ["objective"] = "Find an Azure Agate and bring it to Apprentice Kryten at Refuge Pointe.";
      ["next"] = 695;
      ["faction"] = "Alliance";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 693;
      ["prequests"] = {
         [1] = 693;
      };
      ["level"] = 39;
      ["name_es"] = "Las defensas de Trelane";
      ["req"] = 30;
   };
   [695] = {
      ["name_ru"] = "Чары ученика";
      ["type"] = "Group";
      ["name_fr"] = "Enchantement d'Apprenti";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Des Lehrlings Verzauberung";
      ["name"] = "An Apprentice's Enchantment";
      ["name_cn"] = "学徒的魔法";
      ["objective"] = "Speak to Skuerto.";
      ["next"] = 696;
      ["faction"] = "Alliance";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 694;
      ["prequests"] = {
         [1] = 694;
      };
      ["level"] = 39;
      ["name_es"] = "Un encantamiento de aprendiz";
      ["req"] = 30;
   };
   [696] = {
      ["name_ru"] = "Атака на башню";
      ["type"] = "Group";
      ["name_fr"] = "Attaque sur la tour";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Angriff auf den Turm";
      ["name"] = "Attack on the Tower";
      ["name_cn"] = "?攻高塔";
      ["objective"] = "Find Trelane's Phylactery, Trelane's Orb, and Trelane's Ember Agate, and return them to Skuerto at Refuge Pointe.";
      ["next"] = 697;
      ["faction"] = "Alliance";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 695;
      ["prequests"] = {
         [1] = 695;
      };
      ["level"] = 39;
      ["name_es"] = "Ataque a la torre";
      ["req"] = 30;
   };
   [697] = {
      ["name_ru"] = "Просьба Малина";
      ["type"] = "Group";
      ["objective"] = "Take the Sealed Letter to Archmage Malin in the Mage Quarter of Stormwind.";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Malins Gesuch";
      ["reward"] = {
         [1] = 4975;
         [2] = 15104;
      };
      ["name_cn"] = "?林的要求";
      ["name_fr"] = "La demande de Malin";
      ["faction"] = "Alliance";
      ["name"] = "Malin's Request";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 696;
      ["prequests"] = {
         [1] = 696;
      };
      ["level"] = 39;
      ["name_es"] = "Una peticion de Malin";
      ["req"] = 30;
   };
   [698] = {
      ["name_ru"] = "Нехватка ресурсов";
      ["type"] = "Solo";
      ["name_fr"] = "Petit bonus du soir";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Mangelnde Reserven";
      ["name_cn"] = "缺乏??";
      ["objective"] = "Bring 8 Unprepared Sawtooth Flanks to Tok'Kar in Swamp of Sorrows.";
      ["next"] = 699;
      ["sort"] = "Swamp of Sorrows";
      ["name"] = "Lack of Surplus";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 40;
      ["name_es"] = "Falta de suministros";
      ["req"] = 35;
   };
   [699] = {
      ["name_ru"] = "Нехватка ресурсов";
      ["objective"] = "Bring 6 Sawtooth Snapper Claws to Tok'Kar in the Swamp of Sorrows.";
      ["name_cn"] = "缺乏??";
      ["sort"] = "Swamp of Sorrows";
      ["level"] = 42;
      ["type"] = "Solo";
      ["name_fr"] = "Petit bonus du soir";
      ["next"] = 1422;
      ["name_de"] = "Mangelnde Reserven";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Lack of Surplus";
      ["prev"] = 698;
      ["prequests"] = {
         [1] = 698;
      };
      ["series"] = 2;
      ["name_es"] = "Falta de suministros";
      ["req"] = 35;
   };
   [700] = {
      ["name_ru"] = "Королевские почести";
      ["type"] = "Solo";
      ["objective"] = "Report to King Magni Bronzebeard.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Ehrerbietung von einem Konig";
      ["reward"] = {
         [1] = 4535;
      };
      ["name_cn"] = "国王的礼物";
      ["name_fr"] = "Hommage royal";
      ["faction"] = "Alliance";
      ["name"] = "A King's Tribute";
      ["sort"] = "Ironforge";
      ["prev"] = 689;
      ["prequests"] = {
         [1] = 689;
      };
      ["level"] = 31;
      ["name_es"] = "Un homenaje real";
      ["req"] = 25;
   };
   [701] = {
      ["name_ru"] = "Коварство ящера";
      ["objective"] = "Acquire 12 Raptor Hearts from Highland Fleshstalkers for Tor'gan.";
      ["name_cn"] = "迅猛?的狡?";
      ["sort"] = "Arathi Highlands";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "La ruse du raptor";
      ["next"] = 702;
      ["name_de"] = "Arglist des Raptors";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Guile of the Raptor";
      ["prev"] = 675;
      ["prequests"] = {
         [1] = 675;
      };
      ["series"] = 1;
      ["name_es"] = "La astucia del raptor";
      ["req"] = 29;
   };
   [702] = {
      ["name_ru"] = "Коварство ящера";
      ["type"] = "Solo";
      ["objective"] = "Give Tor'gan's Orb to Gor'mul.";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Arglist des Raptors";
      ["name"] = "Guile of the Raptor";
      ["name_cn"] = "迅猛?的狡?";
      ["name_fr"] = "La ruse du raptor";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 701;
      ["prequests"] = {
         [1] = 701;
      };
      ["level"] = 37;
      ["name_es"] = "La astucia del raptor";
      ["req"] = 29;
   };
   [703] = {
      ["name_ru"] = "Жареные крылышки канюка";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Buzzard Wings to Rigglefuzz.";
      ["repgain"] = {
         [21] = 150;
      };
      ["sort"] = "Badlands";
      ["name_fr"] = "Ailes de busard grillees";
      ["name_cn"] = "????翅膀";
      ["reward"] = {
         [1] = 4457;
         [2] = 4609;
      };
      ["name_de"] = "Gegrillte Bussardflugel";
      ["faction"] = "Horde";
      ["name"] = "Barbecued Buzzard Wings";
      ["level"] = 40;
      ["name_es"] = "Alas de aguila ratonera a la parrilla";
      ["req"] = 33;
   };
   [704] = {
      ["name_ru"] = "Судьба Эгмонда";
      ["type"] = "Solo";
      ["objective"] = " just as did the idols I found here.$B$BI need you to get those urns for our studies.  Go to the Uldaman site";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Agmonds Schicksal";
      ["reward"] = {
         [1] = 4980;
      };
      ["name_cn"] = "阿戈莫德的命?";
      ["name_fr"] = "Le destin d'Agmond";
      ["faction"] = "Alliance";
      ["name"] = "Agmond's Fate";
      ["sort"] = "Uldaman";
      ["prev"] = 739;
      ["prequests"] = {
         [1] = 739;
      };
      ["level"] = 38;
      ["name_es"] = "El sino de Agmond";
      ["req"] = 30;
   };
   [705] = {
      ["name_ru"] = "В поисках жемчуга";
      ["type"] = "Group";
      ["objective"] = "Bring 9 Blue Pearls to Rigglefuzz in the Badlands.";
      ["repgain"] = {
         [21] = 350;
      };
      ["sort"] = "Badlands";
      ["name_fr"] = "Peche aux perles";
      ["name_cn"] = "潜水采珍珠";
      ["reward"] = {
         [1] = 4086;
         [2] = 4852;
         [3] = 5248;
      };
      ["name_de"] = "Perlentauchen";
      ["faction"] = "Horde";
      ["name"] = "Pearl Diving";
      ["level"] = 37;
      ["name_es"] = "La pesca de perlas";
      ["req"] = 30;
   };
   [706] = {
      ["name_ru"] = "Чары яркого пламени";
      ["type"] = "Group";
      ["objective"] = "Acquire a Black Drake's Heart for Sigrun Ironhew.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Badlands";
      ["name_fr"] = "Enchantements d'eclats flamboyants";
      ["name_cn"] = "黑?之火";
      ["reward"] = {
         [1] = 5421;
      };
      ["name_de"] = "Feuerverzauberungen";
      ["faction"] = "Alliance";
      ["name"] = "Fiery Blaze Enchantments";
      ["level"] = 45;
      ["name_es"] = "Encantamientos Llamarada ignea";
      ["req"] = 40;
   };
   [707] = {
      ["name_ru"] = "Вы нужны Сталекруту!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Prospector Ironband at Ironband's Excavation Site in Loch Modan.";
      ["next"] = 738;
      ["name_fr"] = "Baguefer a besoin de vous?!";
      ["sort"] = "Ironforge";
      ["name_cn"] = "???掘?需要?！";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Eisenband sucht Euch!";
      ["faction"] = "Alliance";
      ["name"] = "Ironband Wants You!";
      ["level"] = 37;
      ["name_es"] = "!Vetaferro te necesita!";
      ["req"] = 30;
   };
   [708] = {
      ["name_ru"] = "Черный ящик";
      ["type"] = "Solo";
      ["objective"] = "Take the Corroded Black Box to the Hall of Arms in Ironforge.";
      ["sort"] = "Badlands";
      ["name_cn"] = "黑盒子";
      ["name_fr"] = "La boite noire";
      ["name_de"] = "Der Flugschreiber";
      ["faction"] = "Alliance";
      ["name"] = "The Black Box";
      ["level"] = 40;
      ["name_es"] = "La caja negra";
      ["req"] = 30;
   };
   [709] = {
      ["name_ru"] = "Лекарство от судьбы";
      ["type"] = "Solo";
      ["objective"] = "Bring the Tablet of Ryun'eh to Theldurin the Lost.";
      ["name_fr"] = "La solution a la malediction";
      ["sort"] = "Uldaman";
      ["name_cn"] = "化解??";
      ["reward"] = {
         [1] = 4746;
      };
      ["name_de"] = "Losung der Verdammnis";
      ["faction"] = "Horde";
      ["name"] = "Solution to Doom";
      ["level"] = 40;
      ["name_es"] = "La solucion a la maldicion";
      ["req"] = 30;
   };
   [710] = {
      ["name_ru"] = "Изучение стихий: Камень";
      ["type"] = "Solo";
      ["objective"] = "Find 10 Small Stone Shards and bring them to Lotwil Veriatus in the Badlands.";
      ["next"] = 711;
      ["name_fr"] = "Etude des elements?: la roche";
      ["sort"] = "Badlands";
      ["name_cn"] = "研究石元素";
      ["series"] = 1;
      ["name_de"] = "Element-Studie: Fels";
      ["faction"] = "Horde";
      ["name"] = "Study of the Elements: Rock";
      ["level"] = 37;
      ["name_es"] = "Estudio de los elementos: roca";
      ["req"] = 35;
   };
   [711] = {
      ["name_ru"] = "Изучение стихий: Камень";
      ["type"] = "Solo";
      ["name_fr"] = "Etude des elements?: la roche";
      ["next"] = 712;
      ["name_de"] = "Element-Studie: Fels";
      ["name"] = "Study of the Elements: Rock";
      ["name_cn"] = "研究石元素";
      ["objective"] = "Bring 3 Large Stone Slabs to Lotwil Veriatus in the Badlands.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Badlands";
      ["prev"] = 710;
      ["prequests"] = {
         [1] = 710;
      };
      ["level"] = 39;
      ["name_es"] = "Estudio de los elementos: roca";
      ["req"] = 35;
   };
   [712] = {
      ["name_ru"] = "Изучение стихий: Камень";
      ["type"] = "Solo";
      ["name_fr"] = "Etude des elements?: la roche";
      ["name_de"] = "Element-Studie: Fels";
      ["objective"] = "Bring 5 Bracers of Rock Binding to Lotwil Veriatus in the Badlands.";
      ["followup"] = 734;
      ["name_cn"] = "研究石元素";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["name"] = "Study of the Elements: Rock";
      ["sort"] = "Badlands";
      ["prev"] = 711;
      ["prequests"] = {
         [1] = 711;
      };
      ["level"] = 42;
      ["name_es"] = "Estudio de los elementos: roca";
      ["req"] = 35;
   };
   [713] = {
      ["name_ru"] = "Охлаждение горячих голов";
      ["type"] = "Solo";
      ["objective"] = "Find Frost Oil and bring it to Lotwil Veriatus in Badlands.";
      ["next"] = 714;
      ["sort"] = "Badlands";
      ["name_cn"] = "至?重要的冷却?";
      ["name_fr"] = "La tete froide l'emporte toujours";
      ["name_de"] = "Kuhlaufsatze setzen sich durch";
      ["faction"] = "Horde";
      ["name"] = "Coolant Heads Prevail";
      ["level"] = 37;
      ["name_es"] = "Mantener la cabeza fria";
      ["req"] = 35;
   };
   [714] = {
      ["name_ru"] = "Гиро... чего?";
      ["type"] = "Solo";
      ["name_fr"] = "Un gyro... quoi ?";
      ["name_de"] = "Gyro... Was?";
      ["objective"] = "Bring a Gyrochronatom to Lotwil Veriatus in the Badlands.";
      ["name_cn"] = "?条式什?什??";
      ["sort"] = "Badlands";
      ["faction"] = "Horde";
      ["name"] = "Gyro... What?";
      ["followup"] = 734;
      ["prev"] = 713;
      ["prequests"] = {
         [1] = 713;
      };
      ["level"] = 37;
      ["name_es"] = "Un giro... ?Que?";
      ["req"] = 35;
   };
   [715] = {
      ["name_ru"] = "Жидкий камень";
      ["type"] = "Solo";
      ["name_fr"] = "Pierre liquide";
      ["name_de"] = "Flussigstein";
      ["reward"] = {
         [1] = 4624;
         [2] = 4623;
      };
      ["name_cn"] = "?希恩的?水";
      ["objective"] = "Bring a Healing Potion and a Lesser Invisibility Potion to Lucien Tosselwrench in the Badlands.";
      ["faction"] = "Horde";
      ["name"] = "Liquid Stone";
      ["sort"] = "Badlands";
      ["prev"] = 714;
      ["prequests"] = {
         [1] = 714;
      };
      ["level"] = 37;
      ["name_es"] = "Piedra liquida";
      ["req"] = 35;
   };
   [716] = {
      ["name_ru"] = "Камень ? лучшая одежка!";
      ["type"] = "Solo";
      ["name_fr"] = "Mieux est la pierre que le tissu";
      ["name_de"] = "Stein ist besser als Stoff";
      ["reward"] = {
         [1] = 4979;
      };
      ["name_cn"] = "有?无患";
      ["objective"] = "Bring some Patterned Bronze Bracers to Lucien Tosselwrench in the Badlands.";
      ["faction"] = "Horde";
      ["name"] = "Stone Is Better than Cloth";
      ["sort"] = "Badlands";
      ["prev"] = 712;
      ["prequests"] = {
         [1] = 712;
      };
      ["level"] = 42;
      ["name_es"] = "Es mejor la piedra que la tela";
      ["req"] = 35;
   };
   [717] = {
      ["name_ru"] = "Дрожь земли";
      ["objective"] = "Use the Sign of the Earth to activate the Pillars of Amethyst, Opal, and Diamond and obtain the Runestones.$B$BPlace the runestones in the Seal of the Earth to free Blacklash and Hematus.$B$BSlay them and return Blacklash's Bindings, the Chains of Hematus, and the Sign of the Earth to Garek.";
      ["name_cn"] = "大地的震?";
      ["sort"] = "Badlands";
      ["level"] = 50;
      ["type"] = "Group";
      ["name_fr"] = "Tremblement de terre";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Erdbeben";
      ["reward"] = {
         [1] = 11193;
         [2] = 11194;
         [3] = 11195;
         [4] = 11196;
      };
      ["faction"] = "Alliance";
      ["name"] = "Tremors of the Earth";
      ["prev"] = 732;
      ["prequests"] = {
         [1] = 732;
      };
      ["series"] = 2;
      ["name_es"] = "Terremotos";
      ["req"] = 40;
   };
   [718] = {
      ["name_ru"] = "Миражи";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Supply Crate for Sigrun Ironhew.";
      ["next"] = 733;
      ["name_fr"] = "Mirages";
      ["sort"] = "Badlands";
      ["name_cn"] = "????";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Illusionen";
      ["faction"] = "Alliance";
      ["name"] = "Mirages";
      ["level"] = 38;
      ["name_es"] = "Espejismos";
      ["req"] = 35;
   };
   [719] = {
      ["name_ru"] = "Дворф и его инструменты";
      ["type"] = "Solo";
      ["objective"] = "Find Ryedol's Lucky Pick and return it to Prospector Ryedol south of Hammertoe's Dig Site.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Badlands";
      ["name_fr"] = "Un nain et ses outils";
      ["name_cn"] = "矮人的工具";
      ["reward"] = {
         [1] = 4978;
      };
      ["name_de"] = "Ein Zwerg und sein Werkzeug";
      ["faction"] = "Alliance";
      ["name"] = "A Dwarf and His Tools";
      ["level"] = 35;
      ["name_es"] = "Un enano y sus herramientas";
      ["req"] = 35;
   };
   [720] = {
      ["name_ru"] = "Предвестник надежды";
      ["type"] = "Solo";
      ["name_fr"] = "Un signe d'espoir";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Ein Hoffnungsschimmer";
      ["name_cn"] = "一?希望";
      ["objective"] = " $BThey're taking me to Uldaman. Send help.$B-Hammertoe\"\"";
      ["next"] = 721;
      ["sort"] = "Badlands";
      ["name"] = "A Sign of Hope";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 35;
      ["name_es"] = "Un signo de esperanza";
      ["req"] = 35;
   };
   [721] = {
      ["name_ru"] = "Предвестник надежды";
      ["objective"] = "Find Hammertoe Grez in Uldaman.";
      ["name_cn"] = "一?希望";
      ["sort"] = "Uldaman";
      ["level"] = 35;
      ["type"] = "Dungeon";
      ["name_fr"] = "Un signe d'espoir";
      ["next"] = 722;
      ["name_de"] = "Ein Hoffnungsschimmer";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "A Sign of Hope";
      ["prev"] = 720;
      ["prequests"] = {
         [1] = 720;
      };
      ["series"] = 2;
      ["name_es"] = "Un signo de esperanza";
      ["req"] = 35;
   };
   [722] = {
      ["name_ru"] = "Амулет тайн";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'amulette des secrets";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Amulett der Geheimnisse";
      ["name"] = "Amulet of Secrets";
      ["name_cn"] = "?趾的?符";
      ["objective"] = "Find Hammertoe's Amulet and return it to him in Uldaman.";
      ["next"] = 723;
      ["faction"] = "Alliance";
      ["sort"] = "Uldaman";
      ["prev"] = 721;
      ["prequests"] = {
         [1] = 721;
      };
      ["level"] = 40;
      ["name_es"] = "El amuleto de los secretos";
      ["req"] = 35;
   };
   [723] = {
      ["name_ru"] = "Клятва верности";
      ["objective"] = "Take Hammertoe's Amulet to Prospector Ryedol in the Badlands.";
      ["name_cn"] = "?趾的?愿";
      ["sort"] = "Badlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Esperance en la foi";
      ["next"] = 724;
      ["name_de"] = "Ein Funken Hoffnung";
      ["repgain"] = {
         [47] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Prospect of Faith";
      ["prev"] = 722;
      ["prequests"] = {
         [1] = 722;
      };
      ["series"] = 1;
      ["name_es"] = "Tener fe en el porvenir";
      ["req"] = 35;
   };
   [724] = {
      ["name_ru"] = "Клятва верности";
      ["type"] = "Solo";
      ["objective"] = "Take Hammertoe's Amulet to Historian Karnik in Ironforge.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Ein Funken Hoffnung";
      ["name"] = "Prospect of Faith";
      ["name_cn"] = "?趾的?愿";
      ["name_fr"] = "Esperance en la foi";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Badlands";
      ["prev"] = 723;
      ["prequests"] = {
         [1] = 723;
      };
      ["level"] = 40;
      ["name_es"] = "Tener fe en el porvenir";
      ["req"] = 35;
   };
   [725] = {
      ["name_ru"] = "Слухи об угрозе";
      ["objective"] = "Find Advisor Belgrum and give him his note.";
      ["name_cn"] = "亡者的警告";
      ["sort"] = "Badlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Avertir de la menace";
      ["next"] = 726;
      ["name_de"] = "Kunde uber die Bedrohung breitet sich aus";
      ["repgain"] = {
         [47] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "Passing Word of a Threat";
      ["prev"] = 724;
      ["prequests"] = {
         [1] = 724;
      };
      ["series"] = 1;
      ["name_es"] = "Advertir de la amenaza";
      ["req"] = 35;
   };
   [726] = {
      ["name_ru"] = "Слухи об угрозе";
      ["objective"] = "Speak to Historian Karnik.";
      ["name_cn"] = "亡者的警告";
      ["sort"] = "Badlands";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Avertir de la menace";
      ["next"] = 762;
      ["name_de"] = "Kunde uber die Bedrohung breitet sich aus";
      ["repgain"] = {
         [47] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Passing Word of a Threat";
      ["prev"] = 725;
      ["prequests"] = {
         [1] = 725;
      };
      ["series"] = 2;
      ["name_es"] = "Advertir de la amenaza";
      ["req"] = 35;
   };
   [727] = {
      ["name_ru"] = "В Стальгорн за книгой Йагина";
      ["type"] = "Solo";
      ["name_fr"] = "L'Abrege de Yagyin a Forgefer";
      ["next"] = 735;
      ["name_de"] = "Auf nach Eisenschmiede zu 'Yagyins Zusammenstellung'";
      ["name_cn"] = "?赴?炉堡";
      ["objective"] = "Give the Sigil of the Hammer to Gerrig Bonegrip in the Forlorn Cavern of Ironforge.";
      ["sort"] = "Badlands";
      ["faction"] = "Alliance";
      ["name"] = "To Ironforge for Yagyin's Digest";
      ["prev"] = 709;
      ["prequests"] = {
         [1] = 709;
      };
      ["level"] = 40;
      ["name_es"] = "Ir a Forjaz a buscar el \"Compendio\" de Yagyin";
      ["req"] = 30;
   };
   [728] = {
      ["name_ru"] = "В Подгород за книгой Йагина";
      ["type"] = "Solo";
      ["name_fr"] = "L'Abrege de Yagyin a Fossoyeuse";
      ["next"] = 736;
      ["name_de"] = "Auf nach Unterstadt zu 'Yagyins Zusammenstellung'";
      ["name_cn"] = "?赴幽暗城";
      ["objective"] = "Bring the Sigil of the Hammer to Keeper Bel'dugur in the Undercity.";
      ["sort"] = "Badlands";
      ["faction"] = "Horde";
      ["name"] = "To the Undercity for Yagyin's Digest";
      ["prev"] = 709;
      ["prequests"] = {
         [1] = 709;
      };
      ["level"] = 40;
      ["name_es"] = "Ir a Entranas a buscar el \"Compendio\" de Yagyin";
      ["req"] = 30;
   };
   [729] = {
      ["name_ru"] = "Рассеянный геолог";
      ["type"] = "Solo";
      ["objective"] = "Travel south and check on Prospector Remtravel.";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_fr"] = "Les absences du prospecteur";
      ["sort"] = "Darkshore";
      ["name_cn"] = "健忘的勘察?";
      ["name_de"] = "Der geistesabwesende Ausgrabungsleiter";
      ["faction"] = "Alliance";
      ["name"] = "The Absent Minded Prospector";
      ["level"] = 20;
      ["name_es"] = "El prospector despistado";
      ["req"] = 15;
   };
   [730] = {
      ["name_ru"] = "Неприятности на Темных берегах?";
      ["type"] = "Solo";
      ["objective"] = "Travel to Auberdine and look for signs of the dwarven excavation team.";
      ["next"] = 729;
      ["name_fr"] = "Des problemes a Sombrivage ?";
      ["sort"] = "Darnassus";
      ["name_cn"] = "黑海岸的麻?事";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Arger in Dunkelkuste?";
      ["faction"] = "Alliance";
      ["name"] = "Trouble In Darkshore?";
      ["level"] = 14;
      ["name_es"] = "?Problemas en Costa Oscura?";
      ["req"] = 14;
   };
   [731] = {
      ["name_ru"] = "Рассеянный геолог";
      ["type"] = "Group";
      ["name_fr"] = "Les absences du prospecteur";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Der geistesabwesende Ausgrabungsleiter";
      ["name"] = "The Absent Minded Prospector";
      ["name_cn"] = "健忘的勘察?";
      ["objective"] = "Protect Prospector Remtravel as he searches for the mysterious fossil, then return to Archaeologist Hollee in Auberdine.";
      ["next"] = 741;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 729;
      ["prequests"] = {
         [1] = 729;
      };
      ["level"] = 20;
      ["name_es"] = "El prospector despistado";
      ["req"] = 15;
   };
   [732] = {
      ["name_ru"] = "Дрожь земли";
      ["objective"] = "Retrieve the Sign of the Earth for Garek.";
      ["name_cn"] = "大地的震?";
      ["sort"] = "Badlands";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Tremblement de terre";
      ["next"] = 717;
      ["name_de"] = "Erdbeben";
      ["repgain"] = {
         [72] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Tremors of the Earth";
      ["prev"] = 718;
      ["prequests"] = {
         [1] = 718;
      };
      ["series"] = 1;
      ["name_es"] = "Terremotos";
      ["req"] = 40;
   };
   [733] = {
      ["name_ru"] = "Помогите кто чем может!";
      ["type"] = "Solo";
      ["objective"] = "Get 7 pieces of Scrap Metal for Sigrun.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Schnorrerei";
      ["reward"] = {
         [1] = 4652;
         [2] = 4653;
      };
      ["name_cn"] = "搜集行?";
      ["name_fr"] = "Demandes variees";
      ["faction"] = "Alliance";
      ["name"] = "Scrounging";
      ["sort"] = "Badlands";
      ["prev"] = 718;
      ["prequests"] = {
         [1] = 718;
      };
      ["level"] = 40;
      ["name_es"] = "!A gorronear!";
      ["req"] = 35;
   };
   [734] = {
      ["name_ru"] = "Сложная задача";
      ["type"] = "Solo";
      ["name_fr"] = "Grandes difficultes";
      ["next"] = 777;
      ["name_de"] = "Das wird schwierig";
      ["name_cn"] = "不祥的感?";
      ["objective"] = "Speak to Lucien Tosselwrench in the Badlands.";
      ["sort"] = "Badlands";
      ["series"] = 1;
      ["name"] = "This Is Going to Be Hard";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 712;
         [2] = 714;
      };
      ["level"] = 42;
      ["name_es"] = "Lo tienes crudo";
      ["req"] = 35;
   };
   [735] = {
      ["name_ru"] = "Звезда, Рука и Сердце";
      ["type"] = "Group";
      ["name_fr"] = "L'etoile, la main et le c?ur";
      ["next"] = 737;
      ["name_de"] = "Der Stern, die Hand und das Herz";
      ["objective"] = "Return the items on the Bonegrip's Note to Gerrig Bonegrip in Ironforge.";
      ["name_cn"] = "星，手，心";
      ["sort"] = "Badlands";
      ["faction"] = "Alliance";
      ["name"] = "The Star, the Hand and the Heart";
      ["followup"] = 737;
      ["prev"] = 727;
      ["prequests"] = {
         [1] = 727;
      };
      ["level"] = 44;
      ["name_es"] = "La Estrella, la Mano y el Corazon";
      ["req"] = 30;
   };
   [736] = {
      ["name_ru"] = "Звезда, Рука и Сердце";
      ["type"] = "Group";
      ["name_fr"] = "L'etoile, la main et le c?ur";
      ["next"] = 737;
      ["name_de"] = "Der Stern, die Hand und das Herz";
      ["objective"] = "Bring the items on Bel'dugur's Note to Keeper Bel'dugur in the Undercity.";
      ["name_cn"] = "星，手，心";
      ["sort"] = "Undercity";
      ["faction"] = "Horde";
      ["name"] = "The Star, the Hand and the Heart";
      ["followup"] = 737;
      ["prev"] = 728;
      ["prequests"] = {
         [1] = 728;
      };
      ["level"] = 44;
      ["name_es"] = "La Estrella, la Mano y el Corazon";
      ["req"] = 30;
   };
   [737] = {
      ["name_ru"] = "Запретное знание";
      ["type"] = "Solo";
      ["name_fr"] = "Le savoir perdu";
      ["name_de"] = "Verbotenes Wissen";
      ["name_cn"] = "禁断的知?";
      ["objective"] = "Bring Yagyin's Digest to Theldurin.";
      ["sort"] = "Badlands";
      ["reward"] = {
         [1] = 4984;
      };
      ["name"] = "Forbidden Knowledge";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 735;
         [2] = 736;
      };
      ["level"] = 40;
      ["name_es"] = "El saber prohibido";
      ["req"] = 30;
   };
   [738] = {
      ["name_ru"] = "Найти Эгмонда";
      ["objective"] = " I haven't heard from him in weeks.  I need you to find Agmond so I can get his report.$B$BLast I heard Agmond was at the southernmost dig site in the Badlands--a tiny operation past the Angor Fortress.  I'd start your search for him there.\"";
      ["name_cn"] = "?找阿戈莫德";
      ["sort"] = "Badlands";
      ["level"] = 38;
      ["type"] = "Solo";
      ["name_fr"] = "Trouver Agmond";
      ["next"] = 739;
      ["name_de"] = "Sucht Agmond";
      ["repgain"] = {
         [47] = 75;
      };
      ["reward"] = {
         [1] = 4982;
         [2] = 1529;
         [3] = 2776;
      };
      ["name"] = "Find Agmond";
      ["prev"] = 707;
      ["prequests"] = {
         [1] = 707;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Encontrar a Agmond";
      ["req"] = 30;
   };
   [739] = {
      ["name_ru"] = "Мурдалок";
      ["objective"] = "Slay Agmond's killer, Murdaloc.$B$BSlay 12 Stonevault Bonesnappers.$B$BReport to Prospector Ironband in Loch Modan.";
      ["name_cn"] = "莫?洛克";
      ["sort"] = "Badlands";
      ["level"] = 42;
      ["type"] = "Solo";
      ["name_fr"] = "Murdaloc";
      ["next"] = 704;
      ["name_de"] = "Murdaloc";
      ["repgain"] = {
         [47] = 250;
      };
      ["reward"] = {
         [1] = 4983;
      };
      ["name"] = "Murdaloc";
      ["prev"] = 738;
      ["prequests"] = {
         [1] = 738;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Murdaloc";
      ["req"] = 30;
   };
   [741] = {
      ["name_ru"] = "Рассеянный геолог";
      ["objective"] = "Take the mysterious fossil to Chief Archaeologist Greywhisker in Darnassus.";
      ["name_cn"] = "健忘的勘察?";
      ["sort"] = "Darkshore";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Les absences du prospecteur";
      ["next"] = 942;
      ["name_de"] = "Der geistesabwesende Ausgrabungsleiter";
      ["repgain"] = {
         [47] = 150;
      };
      ["reward"] = {
         [1] = 5629;
         [2] = 5630;
         [3] = 11936;
      };
      ["name"] = "The Absent Minded Prospector";
      ["prev"] = 731;
      ["prequests"] = {
         [1] = 731;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "El prospector despistado";
      ["req"] = 15;
   };
   [742] = {
      ["name_ru"] = "Большая охота";
      ["type"] = "Solo";
      ["objective"] = "Speak with Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "灰谷狩?";
      ["name_fr"] = "La Chasse d'Orneval";
      ["followup"] = 6383;
      ["name_de"] = "Die Jagd im Eschental";
      ["faction"] = "Horde";
      ["name"] = "The Ashenvale Hunt";
      ["level"] = 20;
      ["name_es"] = "La Caza de Vallefresno";
      ["req"] = 20;
   };
   [743] = {
      ["name_ru"] = "Соседство со стаей Неистовства Ветра";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Windfury Talons to Ruul Eagletalon in Bloodhoof Village.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Le danger des Furies-des-vents";
      ["sort"] = "Mulgore";
      ["name_cn"] = "?怒?身人";
      ["name_de"] = "Windfuriengefahr";
      ["faction"] = "Horde";
      ["name"] = "Dangers of the Windfury";
      ["level"] = 8;
      ["name_es"] = "Las Viento Furioso son un peligro";
      ["req"] = 5;
   };
   [744] = {
      ["name_ru"] = "Подготовка к церемонии";
      ["type"] = "Solo";
      ["objective"] = "Collect 6 Azure Feathers and 6 Bronze Feathers, and bring them to Eyahn Eagletalon in Thunder Bluff.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Preparation a la ceremonie";
      ["name_cn"] = "准?典礼";
      ["reward"] = {
         [1] = 4968;
         [2] = 4967;
      };
      ["name_de"] = "Vorbereitungen auf die Zeremonie";
      ["faction"] = "Horde";
      ["name"] = "Preparation for Ceremony";
      ["level"] = 11;
      ["name_es"] = "Preparacion para la ceremonia";
      ["req"] = 7;
   };
   [745] = {
      ["name_ru"] = "Недобрые соседи";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Palemane Tanners, 8 Palemane Skinners, and 5 Palemane Poachers, then return to Baine Bloodhoof in Bloodhoof Village.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Mulgore";
      ["name_fr"] = "Partager la terre";
      ["name_cn"] = "土地之争";
      ["reward"] = {
         [1] = 4960;
      };
      ["name_de"] = "Gemeinsame Nutzung des Landes";
      ["faction"] = "Horde";
      ["name"] = "Sharing the Land";
      ["level"] = 6;
      ["name_es"] = "Compartir la tierra";
      ["req"] = 1;
   };
   [746] = {
      ["name_ru"] = "Дворфийские делишки";
      ["type"] = "Solo";
      ["objective"] = "Collect 5 Prospector's Picks.$B$BAt a forge, smash the Prospector's Picks to create Broken Tools.$B$BBring 5 Broken Tools to Baine Bloodhoof in Bloodhoof Village.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Mulgore";
      ["name_fr"] = "Les fouilles des nains";
      ["name_cn"] = "矮人的?掘?";
      ["reward"] = {
         [1] = 4969;
         [2] = 4970;
      };
      ["name_de"] = "Zwergenbuddelei";
      ["faction"] = "Horde";
      ["name"] = "Dwarven Digging";
      ["level"] = 8;
      ["name_es"] = "Una excavacion de los enanos";
      ["req"] = 6;
   };
   [747] = {
      ["name_ru"] = "Охота начинается";
      ["type"] = "Solo";
      ["objective"] = "Grull Hawkwind in Camp Narache wants you to bring him 7 Plainstrider Feathers and 7 pieces of Plainstrider Meat.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Red Cloud Mesa";
      ["name_fr"] = "La chasse commence";
      ["name_cn"] = "?始狩?";
      ["reward"] = {
         [1] = 4954;
         [2] = 4910;
      };
      ["name_de"] = "Die Jagd beginnt";
      ["faction"] = "Horde";
      ["name"] = "The Hunt Begins";
      ["level"] = 2;
      ["name_es"] = "Empieza la caza";
      ["req"] = 1;
   };
   [748] = {
      ["name_ru"] = "Отравленная вода";
      ["type"] = "Solo";
      ["name_fr"] = "Eau empoisonnee";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_cn"] = "毒水";
      ["name_de"] = "Vergiftetes Wasser";
      ["objective"] = "Bring 6 Prairie Wolf Paws and 4 Plainstrider Talons to Mull Thunderhorn in Bloodhoof.";
      ["name"] = "Poison Water";
      ["sort"] = "Mulgore";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 5;
      ["name_es"] = "Pozos envenenados";
      ["req"] = 4;
   };
   [749] = {
      ["name_ru"] = "Разграбленный караван";
      ["type"] = "Solo";
      ["name_fr"] = "La Caravane devastee";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Die Uberfallene Karawane";
      ["name_cn"] = "被破坏的??";
      ["objective"] = "Morin Cloudstalker wants you to examine the contents of a supply crate at the Ravaged Caravan.";
      ["next"] = 751;
      ["sort"] = "Mulgore";
      ["name"] = "The Ravaged Caravan";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 8;
      ["name_es"] = "La Caravana Devastada";
      ["req"] = 5;
   };
   [750] = {
      ["name_ru"] = "Охота продолжается";
      ["objective"] = "Grull Hawkwind in Camp Narache wants you to bring him 10 Mountain Cougar Pelts.";
      ["name_cn"] = "??狩?";
      ["sort"] = "Red Cloud Mesa";
      ["level"] = 3;
      ["type"] = "Solo";
      ["name_fr"] = "La chasse continue";
      ["next"] = 780;
      ["name_de"] = "Die Jagd geht weiter";
      ["repgain"] = {
         [81] = 250;
      };
      ["reward"] = {
         [1] = 4908;
         [2] = 4913;
      };
      ["name"] = "The Hunt Continues";
      ["prev"] = 747;
      ["prequests"] = {
         [1] = 747;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La caza sigue";
      ["req"] = 1;
   };
   [751] = {
      ["name_ru"] = "Разграбленный караван";
      ["type"] = "Solo";
      ["objective"] = "Return the Venture Co. Documents to Morin Cloudstalker near Bloodhoof Village.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Die Uberfallene Karawane";
      ["name"] = "The Ravaged Caravan";
      ["name_cn"] = "被破坏的??";
      ["name_fr"] = "La Caravane devastee";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Mulgore";
      ["prev"] = 749;
      ["prequests"] = {
         [1] = 749;
      };
      ["level"] = 8;
      ["name_es"] = "La Caravana Devastada";
      ["req"] = 5;
   };
   [752] = {
      ["name_ru"] = "Скромная просьба";
      ["type"] = "Solo";
      ["name_fr"] = "Une humble contribution";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Eine bescheidene Bitte";
      ["name_cn"] = "一件?事";
      ["objective"] = "Chief Hawkwind wants you to search for his mother near the water well to the southeast of Camp Narache.";
      ["next"] = 753;
      ["sort"] = "Red Cloud Mesa";
      ["name"] = "A Humble Task";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 2;
      ["name_es"] = "Una humilde contribucion";
      ["req"] = 1;
   };
   [753] = {
      ["name_ru"] = "Скромная просьба";
      ["objective"] = "Take a Water Pitcher from the water well.$B$BReturn the pitcher to Chief Hawkwind in Camp Narache which is northwest from the water well.";
      ["name_cn"] = "一件?事";
      ["sort"] = "Red Cloud Mesa";
      ["level"] = 3;
      ["type"] = "Solo";
      ["name_fr"] = "Une humble contribution";
      ["next"] = 755;
      ["name_de"] = "Eine bescheidene Bitte";
      ["repgain"] = {
         [81] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "A Humble Task";
      ["prev"] = 752;
      ["prequests"] = {
         [1] = 752;
      };
      ["series"] = 2;
      ["name_es"] = "Una humilde contribucion";
      ["req"] = 1;
   };
   [754] = {
      ["name_ru"] = "Очищение колодца Заиндевевшего Копыта";
      ["type"] = "Solo";
      ["name_fr"] = "Purification de Sabot-d'hiver";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Winterhufsauberung";
      ["name_cn"] = "?化冰蹄之井";
      ["objective"] = "Use the Winterhoof Cleansing Totem at the Winterhoof Water Well, then return to Mull Thunderhorn.";
      ["sort"] = "Mulgore";
      ["name"] = "Winterhoof Cleansing";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 748;
      ["prequests"] = {
         [1] = 748;
      };
      ["level"] = 6;
      ["name_es"] = "La purificacion de Pezuna Invernal";
      ["req"] = 4;
   };
   [755] = {
      ["name_ru"] = "Обряды Матери-Земли";
      ["type"] = "Solo";
      ["name_fr"] = "Les Rites de la Terre-mere";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Riten der Erdenmutter";
      ["name"] = "Rites of the Earthmother";
      ["name_cn"] = "大地之母?祭";
      ["objective"] = "Travel to Seer Graytongue who lives in the hills directly south of Camp Narache.";
      ["next"] = 757;
      ["faction"] = "Horde";
      ["sort"] = "Red Cloud Mesa";
      ["prev"] = 753;
      ["prequests"] = {
         [1] = 753;
      };
      ["level"] = 3;
      ["name_es"] = "Los ritos de la Madre Tierra";
      ["req"] = 1;
   };
   [756] = {
      ["name_ru"] = "Тотем Громового Рога";
      ["type"] = "Solo";
      ["name_fr"] = "Le Totem de Corne-tonnerre";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Totem der Donnerhorner";
      ["name_cn"] = "雷角??";
      ["objective"] = "Bring 6 Stalker Claws and 6 Cougar Claws to Mull Thunderhorn.";
      ["sort"] = "Mulgore";
      ["name"] = "Thunderhorn Totem";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 754;
      ["prequests"] = {
         [1] = 754;
      };
      ["level"] = 7;
      ["name_es"] = "El totem de Tronacuerno";
      ["req"] = 4;
   };
   [757] = {
      ["name_ru"] = "Обряд Силы";
      ["objective"] = "Kill Bristlebacks in Brambleblade Ravine and bring 12 Bristleback Belts to Chief Hawkwind in Camp Narache.";
      ["name_cn"] = "力量?祭";
      ["sort"] = "Red Cloud Mesa";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "Le Rite de force";
      ["next"] = 763;
      ["name_de"] = "Ritus der Kraft";
      ["repgain"] = {
         [81] = 350;
      };
      ["reward"] = {
         [1] = 1382;
         [2] = 1383;
         [3] = 2137;
         [4] = 5776;
         [5] = 5777;
      };
      ["name"] = "Rite of Strength";
      ["prev"] = 755;
      ["prequests"] = {
         [1] = 755;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Rito de la fuerza";
      ["req"] = 1;
   };
   [758] = {
      ["name_ru"] = "Очищение колодца Громового Рога";
      ["type"] = "Solo";
      ["name_fr"] = "Purification de Corne-tonnerre";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Donnerhornsauberung";
      ["races"] = {
         [1] = "Tauren";
      };
      ["name_cn"] = "?化雷角之井";
      ["objective"] = "Use the Thunderhorn Cleansing Totem at the Thunderhorn Water Well, then return to Mull.";
      ["name"] = "Thunderhorn Cleansing";
      ["reward"] = {
         [1] = 4963;
      };
      ["sort"] = "Mulgore";
      ["prev"] = 756;
      ["prequests"] = {
         [1] = 756;
      };
      ["level"] = 8;
      ["name_es"] = "La purificacion de Tronacuerno";
      ["req"] = 4;
   };
   [759] = {
      ["name_ru"] = "Тотем Буйногривых";
      ["type"] = "Solo";
      ["name_fr"] = "Le Totem de Crin-sauvage";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Totem der Wildmahnen";
      ["name_cn"] = "蛮???";
      ["objective"] = "Bring 8 Prairie Alpha Teeth to Mull Thunderhorn in Bloodhoof Village.";
      ["sort"] = "Mulgore";
      ["name"] = "Wildmane Totem";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 758;
      ["prequests"] = {
         [1] = 758;
      };
      ["level"] = 10;
      ["name_es"] = "El totem Ferocrin";
      ["req"] = 4;
   };
   [760] = {
      ["name_ru"] = "Очищение колодца Буйногривых";
      ["type"] = "Solo";
      ["name_fr"] = "Purification de Crin-sauvage";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Wildmahnensauberung";
      ["races"] = {
         [1] = "Tauren";
      };
      ["name_cn"] = "?化蛮?之井";
      ["objective"] = "Use the Wildmane Cleansing Totem at the Wildmane Water Well, then return to Mull Thunderhorn.";
      ["name"] = "Wildmane Cleansing";
      ["reward"] = {
         [1] = 3443;
         [2] = 4961;
      };
      ["sort"] = "Mulgore";
      ["prev"] = 759;
      ["prequests"] = {
         [1] = 759;
      };
      ["level"] = 10;
      ["name_es"] = "La purificacion de Ferocrin";
      ["req"] = 4;
   };
   [761] = {
      ["name_ru"] = "Охота на перепелятников";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Trophy Swoop Quills to Harken Windtotem in Bloodhoof Village.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_fr"] = "Chasse aux Rapaces";
      ["sort"] = "Mulgore";
      ["name_cn"] = "?捕猛?";
      ["name_de"] = "Sturzfliegerjagd";
      ["faction"] = "Horde";
      ["name"] = "Swoop Hunting";
      ["level"] = 6;
      ["name_es"] = "La caza de los aguilones";
      ["req"] = 4;
   };
   [762] = {
      ["name_ru"] = "Посланник зла";
      ["objective"] = "Kill Ambassador Infernus in Angor Fortress and bring proof of his death to Advisor Belgrum in Ironforge.";
      ["name_cn"] = "邪?的使者";
      ["sort"] = "Badlands";
      ["level"] = 44;
      ["type"] = "Group";
      ["name_fr"] = "Un ambassadeur du mal";
      ["next"] = 1139;
      ["name_de"] = "Ein Botschafter des Bosen";
      ["repgain"] = {
         [47] = 350;
      };
      ["reward"] = {
         [1] = 4987;
      };
      ["name"] = "An Ambassador of Evil";
      ["prev"] = 726;
      ["prequests"] = {
         [1] = 726;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Un embajador del mal";
      ["req"] = 35;
   };
   [763] = {
      ["name_ru"] = "Обряды Матери-Земли";
      ["type"] = "Solo";
      ["name_fr"] = "Les Rites de la Terre-mere";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Riten der Erdenmutter";
      ["name_cn"] = "大地之母?祭";
      ["name"] = "Rites of the Earthmother";
      ["objective"] = "Take the Totem of Hawkwind to Baine Bloodhoof in Bloodhoof Village. Follow the road out of Camp Narache.";
      ["faction"] = "Horde";
      ["sort"] = "Red Cloud Mesa";
      ["prev"] = 757;
      ["prequests"] = {
         [1] = 757;
      };
      ["level"] = 5;
      ["name_es"] = "Los ritos de la Madre Tierra";
      ["req"] = 1;
   };
   [764] = {
      ["name_ru"] = "Торговая Компания";
      ["type"] = "Solo";
      ["name_fr"] = "La KapitalRisk";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Die Venture Company";
      ["name_cn"] = "??投?公司";
      ["name"] = "The Venture Co.";
      ["objective"] = "Kill 14 Venture Co. Workers and 6 Venture Co. Supervisors for Morin Cloudstalker at Bloodhoof Village.";
      ["faction"] = "Horde";
      ["sort"] = "Mulgore";
      ["prev"] = 751;
      ["prequests"] = {
         [1] = 751;
      };
      ["level"] = 10;
      ["name_es"] = "Los Ventura y Cia.";
      ["req"] = 5;
   };
   [765] = {
      ["name_ru"] = "Бригадир Шумовик";
      ["type"] = "Solo";
      ["objective"] = "Kill Supervisor Fizsprocket and return his clipboard to Morin Cloudstalker at Bloodhoof Village.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Vorsteher Zischelspross";
      ["reward"] = {
         [1] = 4974;
         [2] = 4964;
      };
      ["name_cn"] = "菲?普?克主管";
      ["name_fr"] = "Superviseur Vibrouage";
      ["faction"] = "Horde";
      ["name"] = "Supervisor Fizsprocket";
      ["sort"] = "Mulgore";
      ["prev"] = 751;
      ["prequests"] = {
         [1] = 751;
      };
      ["level"] = 12;
      ["name_es"] = "Supervisor Saltatuercas";
      ["req"] = 5;
   };
   [766] = {
      ["name_ru"] = "Маззранач";
      ["type"] = "Solo";
      ["objective"] = "Bring a Prairie Wolf Heart, Flatland Cougar Femur, Plainstrider Scale and Swoop Gizzard to Maur Raincaller at Bloodhoof Village.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Mulgore";
      ["name_fr"] = "Mazzranache";
      ["name_cn"] = "??拉?其";
      ["reward"] = {
         [1] = 4972;
         [2] = 4973;
      };
      ["name_de"] = "Mazzranach";
      ["faction"] = "Horde";
      ["name"] = "Mazzranache";
      ["level"] = 8;
      ["name_es"] = "Mazzranache";
      ["req"] = 5;
   };
   [767] = {
      ["name_ru"] = "Обряд прозрения";
      ["objective"] = "Speak with Zarlman Two-Moons in Bloodhoof Village.";
      ["name_cn"] = "幻象?祭";
      ["sort"] = "Mulgore";
      ["level"] = 6;
      ["type"] = "Solo";
      ["name_fr"] = "Le Rite de vision";
      ["next"] = 771;
      ["name_de"] = "Ritus der Vision";
      ["repgain"] = {
         [81] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Rite of Vision";
      ["prev"] = 763;
      ["prequests"] = {
         [1] = 763;
      };
      ["series"] = 1;
      ["name_es"] = "Rito de la Vision";
      ["req"] = 3;
   };
   [768] = {
      ["name_ru"] = "Добывание шкур";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 pieces of Light Leather to Veren Tallstrider in Thunder Bluff.";
      ["repgain"] = {
         [81] = 350;
      };
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "La chasse aux peaux";
      ["name_cn"] = "收集皮革";
      ["reward"] = {
         [1] = 5936;
         [2] = 4962;
      };
      ["name_de"] = "Leder sammeln";
      ["faction"] = "Horde";
      ["name"] = "Gathering Leather";
      ["level"] = 8;
      ["name_es"] = "Recolecta cuero";
      ["req"] = 4;
   };
   [769] = {
      ["name_ru"] = "Сумка из шкуры кодо";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Light Leather and 4 Coarse Thread to Veren Tallstrider in Thunder Bluff.";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Kodobalgtasche";
      ["reward"] = {
         [1] = 5083;
      };
      ["name_cn"] = "科多?皮包";
      ["name_fr"] = "Sac en peau de kodo";
      ["faction"] = "Horde";
      ["name"] = "Kodo Hide Bag";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 768;
      ["prequests"] = {
         [1] = 768;
      };
      ["level"] = 10;
      ["name_es"] = "Bolsa de pellejo de kodo";
      ["req"] = 4;
   };
   [770] = {
      ["name_ru"] = "Поцарапанный демоном плащ";
      ["type"] = "Solo";
      ["objective"] = "Find someone who knows of Ghost Howl.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Mulgore";
      ["name_fr"] = "La Cape de demon balafree";
      ["name_cn"] = "?魔之?";
      ["reward"] = {
         [1] = 4971;
         [2] = 3079;
      };
      ["name_de"] = "Der Damonennarbenumhang";
      ["faction"] = "Horde";
      ["name"] = "The Demon Scarred Cloak";
      ["level"] = 12;
      ["name_es"] = "La capa del demonio marcado";
      ["req"] = 6;
   };
   [771] = {
      ["name_ru"] = "Обряд прозрения";
      ["objective"] = "Collect 2 Well Stones and 2 Ambercorn and bring them back to Zarlman Two-Moons in Bloodhoof Village.";
      ["name_cn"] = "幻象?祭";
      ["sort"] = "Mulgore";
      ["level"] = 7;
      ["type"] = "Solo";
      ["name_fr"] = "Le Rite de vision";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ritus der Vision";
      ["followup"] = 772;
      ["faction"] = "Horde";
      ["name"] = "Rite of Vision";
      ["prev"] = 767;
      ["prequests"] = {
         [1] = 767;
      };
      ["series"] = 2;
      ["name_es"] = "Rito de la Vision";
      ["req"] = 3;
   };
   [772] = {
      ["name_ru"] = "Обряд прозрения";
      ["objective"] = "Consume the Water of the Seers in front of the tribal fire in Bloodhoof Village and follow the vision once it appears.";
      ["name_cn"] = "幻象?祭";
      ["sort"] = "Mulgore";
      ["level"] = 7;
      ["type"] = "Solo";
      ["name_fr"] = "Le Rite de vision";
      ["next"] = 773;
      ["name_de"] = "Ritus der Vision";
      ["repgain"] = {
         [81] = 150;
      };
      ["reward"] = {
         [1] = 4906;
         [2] = 4958;
      };
      ["name"] = "Rite of Vision";
      ["prev"] = 771;
      ["prequests"] = {
         [1] = 771;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Rito de la Vision";
      ["req"] = 3;
   };
   [773] = {
      ["name_ru"] = "Обряд мудрости";
      ["type"] = "Solo";
      ["name_fr"] = "Le Rite de sagesse";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ritus der Weisheit";
      ["name"] = "Rite of Wisdom";
      ["name_cn"] = "智慧?祭";
      ["objective"] = "Travel to Red Rocks east of Thunder Bluff and speak with the Ancestral Spirit.";
      ["next"] = 775;
      ["faction"] = "Horde";
      ["sort"] = "Mulgore";
      ["prev"] = 772;
      ["prequests"] = {
         [1] = 772;
      };
      ["level"] = 10;
      ["name_es"] = "Rito de la Sabiduria";
      ["req"] = 3;
   };
   [775] = {
      ["name_ru"] = "Путешествие в Громовой Утес";
      ["type"] = "Solo";
      ["name_fr"] = "Voyage aux Pitons du Tonnerre";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Reise nach Donnerfels";
      ["name"] = "Journey into Thunder Bluff";
      ["name_cn"] = "雷霆崖之旅";
      ["objective"] = "Speak with Cairne Bloodhoof in Thunder Bluff.";
      ["next"] = 776;
      ["faction"] = "Horde";
      ["sort"] = "Mulgore";
      ["prev"] = 773;
      ["prequests"] = {
         [1] = 773;
      };
      ["level"] = 10;
      ["name_es"] = "Viaje a Cima del Trueno";
      ["req"] = 3;
   };
   [776] = {
      ["name_ru"] = "Обряды Матери-Земли";
      ["type"] = "Solo";
      ["objective"] = "Cairne Bloodhoof in Thunder Bluff wants you to bring him the Horn of Arra'chea.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Riten der Erdenmutter";
      ["reward"] = {
         [1] = 4909;
      };
      ["name_cn"] = "大地之母?祭";
      ["name_fr"] = "Les Rites de la Terre-mere";
      ["faction"] = "Horde";
      ["name"] = "Rites of the Earthmother";
      ["sort"] = "Mulgore";
      ["prev"] = 775;
      ["prequests"] = {
         [1] = 775;
      };
      ["level"] = 14;
      ["name_es"] = "Los ritos de la Madre Tierra";
      ["req"] = 3;
   };
   [777] = {
      ["name_ru"] = "Сложная задача";
      ["type"] = "Solo";
      ["name_fr"] = "Grandes difficultes";
      ["next"] = 778;
      ["name_de"] = "Das wird schwierig";
      ["name"] = "This Is Going to Be Hard";
      ["name_cn"] = "不祥的感?";
      ["objective"] = "Bring Cog #5 to Lotwil Veriatus.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Badlands";
      ["prev"] = 734;
      ["prequests"] = {
         [1] = 734;
      };
      ["level"] = 42;
      ["name_es"] = "Lo tienes crudo";
      ["req"] = 35;
   };
   [778] = {
      ["name_ru"] = "Сложная задача";
      ["type"] = "Solo";
      ["objective"] = "Defeat the Fam'retor Guardian and bring Lotwil's Shackles of Elemental Binding back to Lotwil Veriatus.";
      ["name_de"] = "Das wird schwierig";
      ["name_fr"] = "Ca promet d'etre dur";
      ["reward"] = {
         [1] = 2820;
      };
      ["name_cn"] = "不祥的感?";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["name"] = "This Is Going to Be Hard";
      ["sort"] = "Badlands";
      ["prev"] = 777;
      ["prequests"] = {
         [1] = 777;
      };
      ["level"] = 45;
      ["name_es"] = "Lo tienes crudo";
      ["req"] = 35;
   };
   [779] = {
      ["name_ru"] = "Печать земли";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Badlands";
      ["name_cn"] = "大地封印";
      ["name_fr"] = "Sceau de la Terre";
      ["name_de"] = "Siegel der Erde";
      ["faction"] = "Horde";
      ["name"] = "Seal of the Earth";
      ["level"] = 50;
      ["name_es"] = "El Sello de la Tierra";
      ["req"] = 40;
   };
   [780] = {
      ["name_ru"] = "Боевые вепри";
      ["type"] = "Solo";
      ["objective"] = "Grull Hawkwind in Camp Narache wants you to kill Battleboars and bring back 8 Battleboar Snouts and 8 Battleboar Flanks.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Die Kampfeber";
      ["reward"] = {
         [1] = 6059;
         [2] = 4540;
      };
      ["name_cn"] = "斗猪";
      ["name_fr"] = "Les sangliers de guerre apprivoises";
      ["faction"] = "Horde";
      ["name"] = "The Battleboars";
      ["sort"] = "Red Cloud Mesa";
      ["prev"] = 750;
      ["prequests"] = {
         [1] = 750;
      };
      ["level"] = 4;
      ["name_es"] = "Los jabaguerreros";
      ["req"] = 1;
   };
   [781] = {
      ["name_ru"] = "Нападение на Лагерь Нараче";
      ["type"] = "Solo";
      ["objective"] = "Bring the Bristleback Attack Plans to Chief Hawkwind in Camp Narache.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Red Cloud Mesa";
      ["name_fr"] = "L'attaque du camp Narache";
      ["name_cn"] = "?拉其?地的危机";
      ["reward"] = {
         [1] = 4911;
      };
      ["name_de"] = "Angriff auf Camp Narache";
      ["faction"] = "Horde";
      ["name"] = "Attack on Camp Narache";
      ["level"] = 4;
      ["name_es"] = "Ataque al Campamento Narache";
      ["req"] = 1;
   };
   [782] = {
      ["name_ru"] = "Разорванные союзы";
      ["type"] = "Solo";
      ["name_fr"] = "Alliances rompues";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Zerbrochene Allianzen";
      ["name_cn"] = "破碎的?盟";
      ["objective"] = "Kill Boss Tho'grun and bring the Sign of the Earth to Gorn in Kargath.";
      ["next"] = 793;
      ["sort"] = "Badlands";
      ["name"] = "Broken Alliances";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 43;
      ["name_es"] = "Alianzas rotas";
      ["req"] = 40;
   };
   [783] = {
      ["name_ru"] = "Внутренняя угроза";
      ["type"] = "Solo";
      ["objective"] = "Speak with Marshal McBride.";
      ["next"] = 7;
      ["name_fr"] = "Menace interieure";
      ["sort"] = "Northshire Valley";
      ["name_cn"] = "身?的危机";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Die Bedrohung von innen";
      ["faction"] = "Alliance";
      ["name"] = "A Threat Within";
      ["level"] = 1;
      ["name_es"] = "Una amenaza del interior";
      ["req"] = 1;
   };
   [784] = {
      ["name_ru"] = "Бей предателей!";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Kul Tiras Sailors, 8 Kul Tiras Marines and Lieutenant Benedict and return to Gar'Thok in Razor Hill.";
      ["next"] = 825;
      ["name_fr"] = "Vaincre les traitres";
      ["sort"] = "Durotar";
      ["name_cn"] = "背信弃?的人?";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Vernichtet die Verrater";
      ["faction"] = "Horde";
      ["name"] = "Vanquish the Betrayers";
      ["level"] = 7;
      ["name_es"] = "Vencer a los traidores";
      ["req"] = 3;
   };
   [786] = {
      ["name_ru"] = "Предотвращение агрессии племени Колкар";
      ["type"] = "Solo";
      ["objective"] = "Lar Prowltusk outside of Sen'jin Village wants you to destroy the 3 sets of Attack Plans held within Kolkar Crag.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Dejouer l'agression des Kolkar";
      ["name_cn"] = "科??半人?的?攻";
      ["reward"] = {
         [1] = 4933;
         [2] = 6062;
      };
      ["name_de"] = "Vereitelung der Kolkaraggression";
      ["faction"] = "Horde";
      ["name"] = "Thwarting Kolkar Aggression";
      ["level"] = 8;
      ["name_es"] = "Frustrar los planes kolkar";
      ["req"] = 5;
   };
   [787] = {
      ["name_ru"] = "Новая Орда";
      ["type"] = "Solo";
      ["objective"] = "Report to Gornek in the Den.";
      ["next"] = 788;
      ["sort"] = "Valley of Trials";
      ["name_cn"] = "新的部落";
      ["name_fr"] = "La nouvelle Horde";
      ["name_de"] = "Die neue Horde";
      ["faction"] = "Horde";
      ["name"] = "The New Horde";
      ["level"] = 1;
      ["name_es"] = "La nueva Horda";
      ["req"] = 1;
   };
   [788] = {
      ["name_ru"] = "Кабаньи клыки";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Mottled Boars then return to Gornek at the Den.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Valley of Trials";
      ["name_fr"] = "La dent tranchante";
      ["name_cn"] = "小?身手";
      ["reward"] = {
         [1] = 4915;
         [2] = 4914;
      };
      ["name_de"] = "Erste Erfahrungen";
      ["faction"] = "Horde";
      ["name"] = "Cutting Teeth";
      ["level"] = 2;
      ["name_es"] = "Dientes afilados";
      ["req"] = 1;
   };
   [789] = {
      ["name_ru"] = "Жала скорпидов";
      ["type"] = "Solo";
      ["objective"] = "Get 10 Scorpid Worker Tails for Gornek in the Den.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Stich des Skorpiden";
      ["reward"] = {
         [1] = 4919;
         [2] = 4920;
      };
      ["name_cn"] = "工蝎的尾巴";
      ["name_fr"] = "L'aiguillon du scorpide";
      ["faction"] = "Horde";
      ["name"] = "Sting of the Scorpid";
      ["sort"] = "Valley of Trials";
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 3;
      ["name_es"] = "Aguijon de escorpido";
      ["req"] = 1;
   };
   [790] = {
      ["name_ru"] = "Саркот";
      ["type"] = "Solo";
      ["name_fr"] = "Sarkoth";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Sarkoth";
      ["name_cn"] = "?科斯";
      ["objective"] = "Kill Sarkoth and bring his claw back to Hana'zua.";
      ["next"] = 804;
      ["sort"] = "Valley of Trials";
      ["name"] = "Sarkoth";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 5;
      ["name_es"] = "Sarkoth";
      ["req"] = 1;
   };
   [791] = {
      ["name_ru"] = "Больше сумок ? больше добычи!";
      ["type"] = "Solo";
      ["objective"] = "Furl Scornbrow in the Razor Hill watchtower wants 8 Canvas Scraps.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Assumer ses responsabilites";
      ["name_cn"] = "新的背包";
      ["reward"] = {
         [1] = 11845;
      };
      ["name_de"] = "Akzeptiert Euer Schicksal";
      ["faction"] = "Horde";
      ["name"] = "Carry Your Weight";
      ["level"] = 7;
      ["name_es"] = "Asume tu responsabilidad";
      ["req"] = 4;
   };
   [792] = {
      ["name_ru"] = "Злобные фамильяры";
      ["objective"] = "Kill 12 Vile Familiars.$B$BReturn to Zureetha Fargaze outside the Den.";
      ["name_cn"] = "邪?劣魔";
      ["followup"] = 794;
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "Les vils quasits";
      ["next"] = 794;
      ["name_de"] = "Uble Familiare";
      ["classes"] = {
         [1] = "Druid";
         [2] = "Shaman";
         [3] = "Warrior";
         [4] = "Rogue";
         [5] = "Mage";
         [6] = "Hunter";
         [7] = "Priest";
      };
      ["repgain"] = {
         [530] = 350;
         [76] = 350;
      };
      ["name"] = "Vile Familiars";
      ["faction"] = "Horde";
      ["sort"] = "Valley of Trials";
      ["reward"] = {
         [1] = 4924;
         [2] = 4925;
         [3] = 4923;
         [4] = 5778;
      };
      ["name_es"] = "Familiares viles";
      ["req"] = 2;
   };
   [793] = {
      ["name_ru"] = "Разорванные союзы";
      ["objective"] = "Use the Sign of the Earth to activate the Pillars of Diamond, Opal, and Amethyst and obtain the Runestones.$B$BPlace the runestones in the Seal of the Earth to free Blacklash and Hematus.$B$BSlay them and return Blacklash's Bindings, the Chains of Hematus, and the Sign of the Earth to Gorn.";
      ["name_cn"] = "破碎的?盟";
      ["sort"] = "Badlands";
      ["level"] = 50;
      ["type"] = "Group";
      ["name_fr"] = "Alliances rompues";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Zerbrochene Allianzen";
      ["reward"] = {
         [1] = 11193;
         [2] = 11194;
         [3] = 11195;
         [4] = 11196;
      };
      ["faction"] = "Horde";
      ["name"] = "Broken Alliances";
      ["prev"] = 782;
      ["prequests"] = {
         [1] = 782;
      };
      ["series"] = 2;
      ["name_es"] = "Alianzas rotas";
      ["req"] = 40;
   };
   [794] = {
      ["name_ru"] = "Медальон Пылающего Клинка";
      ["type"] = "Solo";
      ["name_fr"] = "Le medaillon de la Lame ardente";
      ["repgain"] = {
         [530] = 500;
         [76] = 500;
      };
      ["name_de"] = "Medaillon der Brennenden Klinge";
      ["reward"] = {
         [1] = 4921;
         [2] = 118;
         [3] = 4922;
         [4] = 6713;
      };
      ["name_cn"] = "火刃?章";
      ["objective"] = "Bring the Burning Blade Medallion to Zureetha Fargaze, outside The Den.";
      ["next"] = 805;
      ["name"] = "Burning Blade Medallion";
      ["sort"] = "Valley of Trials";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 792;
         [2] = 1499;
      };
      ["level"] = 5;
      ["name_es"] = "El medallon del Filo Ardiente";
      ["req"] = 1;
   };
   [795] = {
      ["name_ru"] = "Печать Земли";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Badlands";
      ["name_cn"] = "大地封印";
      ["name_fr"] = "Sceau de la Terre";
      ["name_de"] = "Siegel der Erde";
      ["faction"] = "Horde";
      ["name"] = "Seal of the Earth";
      ["level"] = 55;
      ["name_es"] = "El Sello de la Tierra";
      ["req"] = 40;
   };
   [804] = {
      ["name_ru"] = "Саркот";
      ["objective"] = "Bring the news of Hana'zua's plight to Gornek at the Den.";
      ["name_cn"] = "?科斯";
      ["sort"] = "Valley of Trials";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "Sarkoth";
      ["repgain"] = {
         [530] = 25;
         [76] = 25;
      };
      ["name_de"] = "Sarkoth";
      ["reward"] = {
         [1] = 4916;
         [2] = 4917;
      };
      ["faction"] = "Horde";
      ["name"] = "Sarkoth";
      ["prev"] = 790;
      ["prequests"] = {
         [1] = 790;
      };
      ["series"] = 2;
      ["name_es"] = "Sarkoth";
      ["req"] = 1;
   };
   [805] = {
      ["name_ru"] = "Деревня Сен'джин";
      ["type"] = "Solo";
      ["name_fr"] = "Faire un rapport au Village de Sen'jin";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_de"] = "Bericht erstatten in Sen'jin";
      ["name_cn"] = "去森金村?到";
      ["name"] = "Report to Sen'jin Village";
      ["objective"] = "Speak with Master Gadrin in Sen'jin Village.";
      ["faction"] = "Horde";
      ["sort"] = "Valley of Trials";
      ["prev"] = 794;
      ["prequests"] = {
         [1] = 794;
      };
      ["level"] = 5;
      ["name_es"] = "Presentate en el Poblado Sen'jin";
      ["req"] = 1;
   };
   [806] = {
      ["name_ru"] = "Сгущаются черные тучи";
      ["type"] = "Solo";
      ["objective"] = "Bring Fizzle's Claw to Orgnil Soulscar in Razor Hill.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Dunkle Sturme";
      ["reward"] = {
         [1] = 4942;
      };
      ["name_cn"] = "黑暗?暴";
      ["name_fr"] = "De sombres orages";
      ["faction"] = "Horde";
      ["name"] = "Dark Storms";
      ["sort"] = "Durotar";
      ["prev"] = 823;
      ["prequests"] = {
         [1] = 823;
      };
      ["level"] = 12;
      ["name_es"] = "Oscuras tormentas";
      ["req"] = 4;
   };
   [808] = {
      ["name_ru"] = "Череп Миншины";
      ["type"] = "Solo";
      ["objective"] = "Retrieve Minshina's skull from the circle of power on the Echo Isles.$B$BBring it to Master Gadrin in Sen'jin Village.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Crane de Minshina";
      ["name_cn"] = "明希?的?骨";
      ["reward"] = {
         [1] = 4945;
      };
      ["name_de"] = "Minshinas Schadel";
      ["faction"] = "Horde";
      ["name"] = "Minshina's Skull";
      ["level"] = 9;
      ["name_es"] = "La calavera de Minshina";
      ["req"] = 4;
   };
   [809] = {
      ["name_ru"] = "Ак'Зелот";
      ["type"] = "Solo";
      ["name_fr"] = "Ak'Zeloth";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_de"] = "Ak'Zeloth";
      ["name"] = "Ak'Zeloth";
      ["name_cn"] = "雅克塞?斯";
      ["objective"] = "Speak with Ak'Zeloth in the Barrens.";
      ["next"] = 924;
      ["faction"] = "Horde";
      ["sort"] = "Durotar";
      ["prev"] = 829;
      ["prequests"] = {
         [1] = 829;
      };
      ["level"] = 13;
      ["name_es"] = "Ak'Zeloth";
      ["req"] = 4;
   };
   [812] = {
      ["name_ru"] = "Нужда в исцелении";
      ["type"] = "Solo";
      ["objective"] = "Find Kor'ghan in Orgrimmar and get the Venomtail Antidote. Then bring the antidote to Rhinag near the northwestern border of Durotar.";
      ["repgain"] = {
         [530] = 350;
         [76] = 350;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Besoin d'un remede";
      ["name_cn"] = "救命如救火";
      ["reward"] = {
         [1] = 4937;
         [2] = 4929;
      };
      ["name_de"] = "Heilmittel benotigt";
      ["faction"] = "Horde";
      ["name"] = "Need for a Cure";
      ["level"] = 9;
      ["name_es"] = "Se necesita un remedio";
      ["req"] = 7;
   };
   [813] = {
      ["name_ru"] = "Поиски противоядия";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Venomtail Poison Sacs to Kor'ghan in Orgrimmar.";
      ["name_fr"] = "La recherche de l'antidote";
      ["sort"] = "Durotar";
      ["name_cn"] = "?找解毒?";
      ["reward"] = {
         [1] = 4904;
      };
      ["name_de"] = "Suche nach dem Gegengift";
      ["faction"] = "Horde";
      ["name"] = "Finding the Antidote";
      ["level"] = 9;
      ["name_es"] = "En busca del antidoto";
      ["req"] = 7;
   };
   [815] = {
      ["name_ru"] = "Хорошенький омлет";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Taillasher Eggs to Cook Torka in Razor Hill.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Des ?ufs pour l'omelette";
      ["name_cn"] = "恐?蛋大餐";
      ["reward"] = {
         [1] = 4540;
         [2] = 117;
      };
      ["name_de"] = "Zerbrecht ein paar Eier";
      ["faction"] = "Horde";
      ["name"] = "Break a Few Eggs";
      ["level"] = 8;
      ["name_es"] = "Romper huevos";
      ["req"] = 6;
   };
   [816] = {
      ["name_ru"] = "Пропавший, но не забытый";
      ["type"] = "Solo";
      ["objective"] = "Bring a sign of Kron's fate to Misha Tor'kren at the farmstead northwest of Razor Hill.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "L'egare";
      ["name_cn"] = "?失的孩子";
      ["reward"] = {
         [1] = 4944;
      };
      ["name_de"] = "Verloren, aber nicht vergessen";
      ["faction"] = "Horde";
      ["name"] = "Lost But Not Forgotten";
      ["level"] = 11;
      ["name_es"] = "Perdido, pero no olvidado";
      ["req"] = 8;
   };
   [817] = {
      ["name_ru"] = "Полезная добыча";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Durotar Tiger Furs to Vel'rin Fang in Sen'jin Village.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_fr"] = "Proie necessaire";
      ["sort"] = "Durotar";
      ["name_cn"] = "生活所需的虎皮";
      ["name_de"] = "Praktische Beute";
      ["faction"] = "Horde";
      ["name"] = "Practical Prey";
      ["level"] = 8;
      ["name_es"] = "Presa practica";
      ["req"] = 5;
   };
   [818] = {
      ["name_ru"] = "Растворитель";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Intact Makrura Eyes and 8 vials of Crawler Mucus to Master Vornal in Sen'jin Village.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Un esprit parfaitement eduque";
      ["name_cn"] = "沃??大?";
      ["reward"] = {
         [1] = 4941;
      };
      ["name_de"] = "Ein geistvolles Getrank";
      ["faction"] = "Horde";
      ["name"] = "A Solvent Spirit";
      ["level"] = 7;
      ["name_es"] = "Un espiritu responsable";
      ["req"] = 5;
   };
   [819] = {
      ["name_ru"] = "Пустой бочонок Чена";
      ["type"] = "Solo";
      ["name_fr"] = "Tonneau vide de Chen";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Chens leeres Fasschen";
      ["name_cn"] = "老?的空酒桶";
      ["objective"] = "Find someone who knows about Chen's Empty Keg.";
      ["next"] = 821;
      ["sort"] = "The Barrens";
      ["name"] = "Chen's Empty Keg";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 15;
      ["name_es"] = "El barril vacio de Chen";
      ["req"] = 11;
   };
   [821] = {
      ["name_ru"] = "Пустой бочонок Чена";
      ["objective"] = "Bring 5 Savannah Lion Tusks, 5 Plainstrider Kidneys, and 1 Thunder Lizard Horn to Brewmaster Drohn in Ratchet.";
      ["name_cn"] = "老?的空酒桶";
      ["sort"] = "The Barrens";
      ["level"] = 15;
      ["type"] = "Solo";
      ["name_fr"] = "Tonneau vide de Chen";
      ["next"] = 822;
      ["name_de"] = "Chens leeres Fasschen";
      ["repgain"] = {
         [76] = 350;
      };
      ["reward"] = {
         [1] = 4952;
      };
      ["faction"] = "Horde";
      ["name"] = "Chen's Empty Keg";
      ["prev"] = 819;
      ["prequests"] = {
         [1] = 819;
      };
      ["series"] = 2;
      ["name_es"] = "El barril vacio de Chen";
      ["req"] = 11;
   };
   [822] = {
      ["name_ru"] = "Пустой бочонок Чена";
      ["objective"] = "Bring 5 Lightning Glands, 1 Thunderhawk Saliva Gland and 1 Kodo Liver to Brewmaster Drohn in Ratchet.";
      ["name_cn"] = "老?的空酒桶";
      ["sort"] = "The Barrens";
      ["level"] = 24;
      ["type"] = "Solo";
      ["name_fr"] = "Tonneau vide de Chen";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Chens leeres Fasschen";
      ["reward"] = {
         [1] = 4953;
      };
      ["faction"] = "Horde";
      ["name"] = "Chen's Empty Keg";
      ["prev"] = 821;
      ["prequests"] = {
         [1] = 821;
      };
      ["series"] = 3;
      ["name_es"] = "El barril vacio de Chen";
      ["req"] = 11;
   };
   [823] = {
      ["name_ru"] = "Явиться к Оргнилу";
      ["type"] = "Solo";
      ["objective"] = "Speak with Orgnil Soulscar in Razor Hill.";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_fr"] = "Un rapport a Orgnil";
      ["sort"] = "Durotar";
      ["name_cn"] = "向奥戈尼??告";
      ["name_de"] = "Bericht an Orgnil";
      ["faction"] = "Horde";
      ["name"] = "Report to Orgnil";
      ["level"] = 7;
      ["name_es"] = "Informa a Orgnil";
      ["req"] = 4;
   };
   [824] = {
      ["name_ru"] = "Дже'неу из Служителей Земли";
      ["type"] = "Solo";
      ["objective"] = "Bring the Befouled Water Globe to Je'neu Sancrea at Zoram'gar Outpost, Ashenvale.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Je'neu vom Irdenen Ring";
      ["reward"] = {
         [1] = 16659;
         [2] = 16660;
         [3] = 16661;
      };
      ["name_cn"] = "大地之?的耶努?克雷";
      ["name_fr"] = "Je'neu du Cercle terrestre";
      ["faction"] = "Horde";
      ["name"] = "Je'neu of the Earthen Ring";
      ["sort"] = "Ashenvale";
      ["prev"] = 1918;
      ["prequests"] = {
         [1] = 1918;
      };
      ["level"] = 27;
      ["name_es"] = "Je'neu del Anillo de la Tierra";
      ["req"] = 23;
   };
   [825] = {
      ["name_ru"] = "Обломки кораблекрушения";
      ["type"] = "Solo";
      ["objective"] = "Gar'Thok of Razor Hill wants you to retrieve 3 Gnomish Tools from the wreckage off the coast.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Aus den Wrackteilen geborgen...";
      ["reward"] = {
         [1] = 4936;
         [2] = 4928;
         [3] = 4935;
      };
      ["name_cn"] = "海底?船";
      ["name_fr"] = "Des epaves";
      ["faction"] = "Horde";
      ["name"] = "From The Wreckage....";
      ["sort"] = "Durotar";
      ["prev"] = 784;
      ["prequests"] = {
         [1] = 784;
      };
      ["level"] = 8;
      ["name_es"] = "Los restos del naufragio...";
      ["req"] = 3;
   };
   [826] = {
      ["name_ru"] = "Залазан";
      ["type"] = "Solo";
      ["objective"] = "Defeat Zalazane.$B$BKill 8 Voodoo Trolls and 8 Hexed Trolls.$B$BBring Zalazane's Head to Gadrin.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Zalazane";
      ["name_cn"] = "扎拉?恩";
      ["reward"] = {
         [1] = 4946;
         [2] = 4940;
      };
      ["name_de"] = "Zalazane";
      ["faction"] = "Horde";
      ["name"] = "Zalazane";
      ["level"] = 10;
      ["name_es"] = "Zalazane";
      ["req"] = 4;
   };
   [827] = {
      ["name_ru"] = "Скала Черепа";
      ["type"] = "Solo";
      ["objective"] = "Gather Searing Collars from the cultists in Skull Rock.$B$BBring them to Margoz at his camp.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Die Knochenhohle";
      ["reward"] = {
         [1] = 4947;
         [2] = 4939;
         [3] = 4948;
      };
      ["name_cn"] = "??石";
      ["name_fr"] = "Rocher du crane";
      ["faction"] = "Horde";
      ["name"] = "Skull Rock";
      ["sort"] = "Durotar";
      ["prev"] = 828;
      ["prequests"] = {
         [1] = 828;
      };
      ["level"] = 12;
      ["name_es"] = "Roca del Craneo";
      ["req"] = 4;
   };
   [828] = {
      ["name_ru"] = "Маргоз";
      ["type"] = "Solo";
      ["name_fr"] = "Margoz";
      ["repgain"] = {
         [530] = 10;
         [76] = 10;
      };
      ["name_de"] = "Margoz";
      ["name"] = "Margoz";
      ["name_cn"] = "?高?";
      ["objective"] = "Speak with Margoz.";
      ["next"] = 827;
      ["faction"] = "Horde";
      ["sort"] = "Durotar";
      ["prev"] = 806;
      ["prequests"] = {
         [1] = 806;
      };
      ["level"] = 12;
      ["name_es"] = "Margoz";
      ["req"] = 4;
   };
   [829] = {
      ["name_ru"] = "Ниру Огненный Клинок";
      ["type"] = "Solo";
      ["name_fr"] = "Neeru Lamefeu";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_de"] = "Neeru Feuerklinge";
      ["name"] = "Neeru Fireblade";
      ["name_cn"] = "尼??・火刃";
      ["objective"] = "Bring an Example Collar to Neeru Fireblade in Orgrimmar.";
      ["next"] = 809;
      ["faction"] = "Horde";
      ["sort"] = "Durotar";
      ["prev"] = 827;
      ["prequests"] = {
         [1] = 827;
      };
      ["level"] = 12;
      ["name_es"] = "Neeru Hojafuego";
      ["req"] = 4;
   };
   [830] = {
      ["name_ru"] = "Приказы адмирала";
      ["type"] = "Solo";
      ["name_fr"] = "Les ordres de l'amiral";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Die Befehle des Admirals";
      ["name_cn"] = "将?的命令";
      ["objective"] = "Take Admiral Proudmoore's Orders to Gar'Thok in Razor Hill.";
      ["next"] = 831;
      ["sort"] = "Durotar";
      ["name"] = "The Admiral's Orders";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 7;
      ["name_es"] = "Las ordenes del almirante";
      ["req"] = 1;
   };
   [831] = {
      ["name_ru"] = "Приказы адмирала";
      ["type"] = "Solo";
      ["objective"] = "Deliver Admiral Proudmoore's Orders to Nazgrel in Thrall's chamber in Orgrimmar.";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Die Befehle des Admirals";
      ["name"] = "The Admiral's Orders";
      ["name_cn"] = "将?的命令";
      ["name_fr"] = "Les ordres de l'amiral";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Durotar";
      ["prev"] = 830;
      ["prequests"] = {
         [1] = 830;
      };
      ["level"] = 7;
      ["name_es"] = "Las ordenes del almirante";
      ["req"] = 1;
   };
   [832] = {
      ["name_ru"] = "Пылающие тени";
      ["type"] = "Solo";
      ["objective"] = "Take this eye to Neeru Fireblade.";
      ["repgain"] = {
         [530] = 150;
         [76] = 150;
      };
      ["name_fr"] = "Ombres ardentes";
      ["sort"] = "Durotar";
      ["name_cn"] = "燃影之眼";
      ["name_de"] = "Brennende Schatten";
      ["faction"] = "Horde";
      ["name"] = "Burning Shadows";
      ["level"] = 12;
      ["name_es"] = "Sombras Ardientes";
      ["req"] = 4;
   };
   [833] = {
      ["name_ru"] = "Священное погребение";
      ["type"] = "Solo";
      ["objective"] = "Lorekeeper Raintotem wants you to kill 8 Bristleback Interlopers at Red Rocks.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Cimetiere sacre";
      ["sort"] = "Mulgore";
      ["name_cn"] = "神?的墓地";
      ["name_de"] = "Eine heilige Bestattung";
      ["faction"] = "Horde";
      ["name"] = "A Sacred Burial";
      ["level"] = 10;
      ["name_es"] = "Cementerio sagrado";
      ["req"] = 7;
   };
   [834] = {
      ["name_ru"] = "Ветра пустыни";
      ["type"] = "Solo";
      ["objective"] = "Retrieve 5 Sacks of Supplies and return them to Rezlak near Orgrimmar.";
      ["next"] = 835;
      ["name_fr"] = "Des vents dans le desert";
      ["sort"] = "Durotar";
      ["name_cn"] = "沙漠之?";
      ["repgain"] = {
         [530] = 250;
         [470] = 250;
         [76] = 250;
      };
      ["name_de"] = "Wind in der Wuste";
      ["faction"] = "Horde";
      ["name"] = "Winds in the Desert";
      ["level"] = 9;
      ["name_es"] = "Las arpias Viento Seco";
      ["req"] = 7;
   };
   [835] = {
      ["name_ru"] = "Обеспечение безопасного сообщения";
      ["type"] = "Solo";
      ["name_fr"] = "Des lignes securisees";
      ["name_de"] = "Sicherung der Linien";
      ["reward"] = {
         [1] = 4938;
         [2] = 12;
         [3] = 8;
      };
      ["name_cn"] = "保?商路";
      ["objective"] = " and that's if you want something done well";
      ["faction"] = "Horde";
      ["name"] = "Securing the Lines";
      ["sort"] = "Durotar";
      ["prev"] = 834;
      ["prequests"] = {
         [1] = 834;
      };
      ["level"] = 11;
      ["name_es"] = "Asegurar las rutas";
      ["req"] = 7;
   };
   [836] = {
      ["name_ru"] = "Спасти КПХ-9/HL!";
      ["objective"] = " safe place so it can begin a lengthy take-off procedure.  It has built-in cloaking";
      ["name_cn"] = "拯救OOX-09/HL！";
      ["sort"] = "The Hinterlands";
      ["level"] = 48;
      ["type"] = "Solo";
      ["name_fr"] = "A la rescousse de OOX-09/HL?!";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Rettet OOX-09/HL!";
      ["followup"] = 3721;
      ["faction"] = "Horde";
      ["name"] = "Rescue OOX-09/HL!";
      ["prev"] = 485;
      ["prequests"] = {
         [1] = 485;
      };
      ["reward"] = {
         [1] = 1;
         [2] = 1;
      };
      ["name_es"] = "!Rescata a OOX-09/TI!";
      ["req"] = 43;
   };
   [837] = {
      ["name_ru"] = "Вторжение";
      ["type"] = "Solo";
      ["objective"] = "Kill 4 Razormane Quilboars, 4 Razormane Scouts, 4 Razormane Dustrunners and 4 Razormane Battleguards for Gar'Thok at Razor Hill.";
      ["repgain"] = {
         [530] = 150;
         [76] = 150;
      };
      ["name_fr"] = "Empietement";
      ["sort"] = "Durotar";
      ["name_cn"] = "野猪人的?犯";
      ["name_de"] = "Ubergriff";
      ["faction"] = "Horde";
      ["name"] = "Encroachment";
      ["level"] = 10;
      ["name_es"] = "Invasion";
      ["req"] = 6;
   };
   [838] = {
      ["name_ru"] = "Некроситет";
      ["type"] = "Solo";
      ["name_fr"] = "Scholomance";
      ["next"] = 964;
      ["name_de"] = "Scholomance";
      ["name_cn"] = "通?学院";
      ["objective"] = "Speak with Apothecary Dithers at the Bulwark, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Scholomance";
      ["prev"] = 5098;
      ["prequests"] = {
         [1] = 5098;
      };
      ["level"] = 55;
      ["name_es"] = "Scholomance";
      ["req"] = 55;
   };
   [840] = {
      ["name_ru"] = "Новобранец Орды";
      ["type"] = "Solo";
      ["objective"] = "Follow the western road from Razor Hill to the Barrens over a bridge.$B$BStop at the orc outpost across the bridge.$B$BGive Kargal Battlescar at the Barrens outpost your recruitment letter.";
      ["next"] = 842;
      ["name_fr"] = "Sous les drapeaux de la Horde";
      ["sort"] = "Durotar";
      ["name_cn"] = "部落的新兵";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_de"] = "Freiwilliger der Horde";
      ["faction"] = "Horde";
      ["name"] = "Conscript of the Horde";
      ["level"] = 12;
      ["name_es"] = "Nuevo recluta de la Horda";
      ["req"] = 10;
   };
   [841] = {
      ["name_ru"] = "Еще один источник энергии?";
      ["type"] = "Solo";
      ["name_fr"] = "Une autre Source d'energie??";
      ["name_de"] = "Eine weitere Kraftquelle?";
      ["reward"] = {
         [1] = 8524;
      };
      ["name_cn"] = "?一个能量源？";
      ["objective"] = "Bring 10 Wastewander Water Pouches to Chief Engineer Bilgewhizzle in Gadgetzan in exchange for another power source.";
      ["faction"] = "Horde";
      ["name"] = "Another Power Source?";
      ["sort"] = "Tanaris";
      ["prev"] = 379;
      ["prequests"] = {
         [1] = 379;
      };
      ["level"] = 46;
      ["name_es"] = "?Otra fuente de alimentacion?";
      ["req"] = 38;
   };
   [842] = {
      ["name_ru"] = "Рекрутский набор Перекрестка";
      ["type"] = "Solo";
      ["name_fr"] = "Conscription a la Croisee";
      ["repgain"] = {
         [530] = 250;
         [76] = 250;
      };
      ["name_de"] = "Wegekreuzwehrpflicht";
      ["name_cn"] = "十字路口征兵";
      ["name"] = "Crossroads Conscription";
      ["objective"] = "Follow the western road from Kargal's Far Watch Outpost.$B$BAt the T intersection, turn left and follow the road south. $B$BFind Sergra Darkthorn at the crossing of roads within the Crossroads.";
      ["faction"] = "Horde";
      ["sort"] = "Durotar";
      ["prev"] = 840;
      ["prequests"] = {
         [1] = 840;
      };
      ["level"] = 12;
      ["name_es"] = "Servicio militar en El Cruce";
      ["req"] = 10;
   };
   [843] = {
      ["name_ru"] = "Ответный удар Ганна";
      ["type"] = "Solo";
      ["objective"] = "Gann Stonespire wants you to kill 15 Bael'dun Excavators and 5 Bael'dun Foremen.$B$BBring Khazgorm's Journal to Gann Stonespire.";
      ["next"] = 846;
      ["name_fr"] = "La reconquete de Gann";
      ["sort"] = "The Barrens";
      ["name_cn"] = "加恩的??";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ganns Rekultivierung";
      ["faction"] = "Horde";
      ["name"] = "Gann's Reclamation";
      ["level"] = 23;
      ["name_es"] = "La reclamacion de Gann";
      ["req"] = 17;
   };
   [844] = {
      ["name_ru"] = "Равнинные долгоноги";
      ["type"] = "Solo";
      ["objective"] = "Collect 7 Plainstrider Beaks and return them to Sergra Darkthorn in the Crossroads.";
      ["next"] = 845;
      ["name_fr"] = "La menace des trotteurs des plaines";
      ["sort"] = "The Barrens";
      ["name_cn"] = "平原?行?的威?";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Ebenenschreiterbedrohung";
      ["faction"] = "Horde";
      ["name"] = "Plainstrider Menace";
      ["level"] = 12;
      ["name_es"] = "La amenaza de los zancudos de llanura";
      ["req"] = 10;
   };
   [845] = {
      ["name_ru"] = "Жевры";
      ["type"] = "Solo";
      ["name_fr"] = "Les zhevras";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Die Zhevras";
      ["name"] = "The Zhevra";
      ["name_cn"] = "斑?的威?";
      ["objective"] = "Slay Zhevra Runners to collect 4 Zhevra Hooves for Sergra Darkthorn in the Crossroads.";
      ["next"] = 903;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 844;
      ["prequests"] = {
         [1] = 844;
      };
      ["level"] = 13;
      ["name_es"] = "La zhebra";
      ["req"] = 10;
   };
   [846] = {
      ["name_ru"] = "Месть Ганна";
      ["objective"] = "Gann Stonespire wants you to bring him 6 vials of Nitroglycerin, 6 bundles of Wood Pulp, and 6 samples of Sodium Nitrate.";
      ["name_cn"] = "加恩的??";
      ["sort"] = "The Barrens";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "La revanche de Gann";
      ["next"] = 849;
      ["name_de"] = "Ganns Rache";
      ["repgain"] = {
         [81] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Revenge of Gann";
      ["prev"] = 843;
      ["prequests"] = {
         [1] = 843;
      };
      ["series"] = 1;
      ["name_es"] = "La venganza de Gann";
      ["req"] = 17;
   };
   [847] = {
      ["name_ru"] = "Коварство ящера";
      ["type"] = "Solo";
      ["objective"] = "Speak with Tor'gan.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Arglist des Raptors";
      ["reward"] = {
         [1] = 4546;
      };
      ["name_cn"] = "迅猛?的狡?";
      ["name_fr"] = "La ruse du raptor";
      ["faction"] = "Horde";
      ["name"] = "Guile of the Raptor";
      ["sort"] = "Arathi Highlands";
      ["prev"] = 702;
      ["prequests"] = {
         [1] = 702;
      };
      ["level"] = 37;
      ["name_es"] = "La astucia del raptor";
      ["req"] = 29;
   };
   [848] = {
      ["name_ru"] = "Споры грибов";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Fungal Spores to Apothecary Helbrim at the Crossroads.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Spores fongiques";
      ["sort"] = "The Barrens";
      ["name_cn"] = "菌??子";
      ["name_de"] = "Pilzsporen";
      ["faction"] = "Horde";
      ["name"] = "Fungal Spores";
      ["level"] = 15;
      ["name_es"] = "Esporas de hongos";
      ["req"] = 10;
   };
   [849] = {
      ["name_ru"] = "Месть Ганна";
      ["objective"] = "Destroy the flying machine at Bael Modan and return to Gann Stonespire.";
      ["name_cn"] = "加恩的??";
      ["sort"] = "The Barrens";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "La revanche de Gann";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ganns Rache";
      ["reward"] = {
         [1] = 5313;
      };
      ["faction"] = "Horde";
      ["name"] = "Revenge of Gann";
      ["prev"] = 846;
      ["prequests"] = {
         [1] = 846;
      };
      ["series"] = 2;
      ["name_es"] = "La venganza de Gann";
      ["req"] = 17;
   };
   [850] = {
      ["name_ru"] = "Главари племени Колкар";
      ["type"] = "Solo";
      ["objective"] = "Bring Barak's Head to Regthar Deathgate, west of the Crossroads.";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_fr"] = "Les chefs des Kolkar";
      ["sort"] = "The Barrens";
      ["name_cn"] = "科??首?";
      ["name_de"] = "Anfuhrer der Kolkar";
      ["faction"] = "Horde";
      ["name"] = "Kolkar Leaders";
      ["level"] = 16;
      ["name_es"] = "Los jefes Kolkar";
      ["req"] = 11;
   };
   [851] = {
      ["name_ru"] = "Верог Дервиш";
      ["type"] = "Solo";
      ["name_fr"] = "Verog le Derviche";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Verog der Derwisch";
      ["name"] = "Verog the Dervish";
      ["name_cn"] = "狂?的??戈";
      ["objective"] = "Bring Verog's Head to Regthar Deathgate, west of the Crossroads.";
      ["next"] = 852;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 850;
      ["prequests"] = {
         [1] = 850;
      };
      ["level"] = 18;
      ["name_es"] = "Verog el Derviche";
      ["req"] = 11;
   };
   [852] = {
      ["name_ru"] = "Хэрзул Кровавая Отметина";
      ["type"] = "Solo";
      ["objective"] = "Bring Hezrul's Head to Regthar Deathgate, west of the Crossroads.";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Hezrul Blutmal";
      ["reward"] = {
         [1] = 5351;
      };
      ["name_cn"] = "赫???・血印";
      ["name_fr"] = "Hezrul Marque-de-sang";
      ["faction"] = "Horde";
      ["name"] = "Hezrul Bloodmark";
      ["sort"] = "The Barrens";
      ["prev"] = 851;
      ["prequests"] = {
         [1] = 851;
      };
      ["level"] = 19;
      ["name_es"] = "Hezrul Marcasangre";
      ["req"] = 11;
   };
   [853] = {
      ["name_ru"] = "Аптекарь Зама";
      ["type"] = "Solo";
      ["objective"] = "Bring the Rendered Spores to Apothecary Zamah in Thunder Bluff, before the time limit is up.";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Apothekerin Zamah";
      ["reward"] = {
         [1] = 2458;
         [2] = 5340;
         [3] = 2457;
         [4] = 2456;
         [5] = 2459;
      };
      ["name_cn"] = "???扎?";
      ["name_fr"] = "L'apothicaire Zamah";
      ["faction"] = "Horde";
      ["name"] = "Apothecary Zamah";
      ["sort"] = "The Barrens";
      ["prev"] = 848;
      ["prequests"] = {
         [1] = 848;
      };
      ["level"] = 15;
      ["name_es"] = "Boticaria Zamah";
      ["req"] = 10;
   };
   [854] = {
      ["name_ru"] = "Путешествие в Перекресток";
      ["type"] = "Solo";
      ["name_fr"] = "Un voyage a la Croisee";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_cn"] = "十字路口之旅";
      ["name_de"] = "Reise zum Wegekreuz";
      ["objective"] = "Speak with Thork at the Crossroads in the Barrens.";
      ["name"] = "Journey to the Crossroads";
      ["sort"] = "Mulgore";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 12;
      ["name_es"] = "Viaja a El Cruce";
      ["req"] = 9;
   };
   [855] = {
      ["name_ru"] = "Наручи кентавров";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Centaur Bracers to Regthar Deathgate, west of the Crossroads.";
      ["repgain"] = {
         [76] = 350;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Les bracelets de centaures";
      ["name_cn"] = "半人??腕";
      ["reward"] = {
         [1] = 5346;
         [2] = 5344;
         [3] = 5345;
      };
      ["name_de"] = "Zentaurenarmschienen";
      ["faction"] = "Horde";
      ["name"] = "Centaur Bracers";
      ["level"] = 14;
      ["name_es"] = "Los brazales centauro";
      ["req"] = 9;
   };
   [857] = {
      ["name_ru"] = "Слеза Лун";
      ["type"] = "Solo";
      ["objective"] = "Feegly the Exiled wants you to retrieve for him the Tear of the Moons.";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?月之泪";
      ["name_fr"] = "La larme des lunes";
      ["name_de"] = "Die Trane der Monde";
      ["faction"] = "Horde";
      ["name"] = "The Tear of the Moons";
      ["level"] = 30;
      ["name_es"] = "La Lagrima de las Lunas";
      ["req"] = 22;
   };
   [858] = {
      ["name_ru"] = "Зажигание";
      ["type"] = "Solo";
      ["objective"] = "Get the Ignition Key and bring it to Wizzlecrank.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_fr"] = "Contact";
      ["sort"] = "The Barrens";
      ["name_cn"] = "打火?匙";
      ["name_de"] = "Zundung";
      ["faction"] = "Horde";
      ["name"] = "Ignition";
      ["level"] = 18;
      ["name_es"] = "La llave de contacto";
      ["req"] = 13;
   };
   [860] = {
      ["name_ru"] = "Сергра Черный Шип";
      ["type"] = "Solo";
      ["name_fr"] = "Sergra Sombreronce";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Sergra Dunkeldorn";
      ["name"] = "Sergra Darkthorn";
      ["name_cn"] = "瑟格拉・黑棘";
      ["objective"] = "Speak with Sergra Darkthorn at the Crossroads.";
      ["next"] = 844;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 861;
      ["prequests"] = {
         [1] = 861;
      };
      ["level"] = 10;
      ["name_es"] = "Sergra Espinoscura";
      ["req"] = 10;
   };
   [861] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Flatland Prowler Claws to Melor Stonehoof in Thunder Bluff.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Le chemin du chasseur";
      ["sort"] = "Mulgore";
      ["name_cn"] = "?人之道";
      ["name_de"] = "Der Weg der Jager";
      ["faction"] = "Horde";
      ["name"] = "The Hunter's Way";
      ["level"] = 10;
      ["name_es"] = "Los habitos del cazador";
      ["req"] = 10;
   };
   [862] = {
      ["name_ru"] = "Похлебка из пещерной крысы";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Dig Rats to Grub east of the Crossroads.";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Cooking";
      ["name_fr"] = "Brouet de rat";
      ["name_cn"] = "掘地鼠?肉";
      ["reward"] = {
         [1] = 5487;
         [2] = 5478;
         [3] = 10919;
      };
      ["name_de"] = "Grubenratteneintopf";
      ["faction"] = "Horde";
      ["name"] = "Dig Rat Stew";
      ["level"] = 23;
      ["name_es"] = "Estofado de ratas de madriguera";
      ["req"] = 15;
   };
   [863] = {
      ["name_ru"] = "Бегство";
      ["type"] = "Solo";
      ["objective"] = "Protect Wizzlecrank and the stolen goblin shredder on the way to Sputtervalve in Ratchet.";
      ["repgain"] = {
         [470] = 350;
      };
      ["name_de"] = "Die Flucht";
      ["reward"] = {
         [1] = 5326;
         [2] = 5327;
      };
      ["name_cn"] = "逃?";
      ["name_fr"] = "La fuite";
      ["faction"] = "Horde";
      ["name"] = "The Escape";
      ["sort"] = "The Barrens";
      ["prev"] = 858;
      ["prequests"] = {
         [1] = 858;
      };
      ["level"] = 18;
      ["name_es"] = "La fuga";
      ["req"] = 13;
   };
   [864] = {
      ["name_ru"] = "Возвращение к аптекарю Зинг";
      ["type"] = "Solo";
      ["objective"] = " the power source is safely removed and the data is preserved.  Well";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Kehrt zu Apothekerin Zinge zuruck";
      ["reward"] = {
         [1] = 9634;
         [2] = 9635;
         [3] = 11502;
      };
      ["name_cn"] = "向???金格回?";
      ["name_fr"] = "De retour vers l'apothicaire Zinge";
      ["faction"] = "Horde";
      ["name"] = "Return to Apothecary Zinge";
      ["sort"] = "Undercity";
      ["prev"] = 654;
      ["prequests"] = {
         [1] = 654;
      };
      ["level"] = 46;
      ["name_es"] = "Regresa junto a la boticaria Zinge";
      ["req"] = 38;
   };
   [865] = {
      ["name_ru"] = "Рога ящера";
      ["type"] = "Solo";
      ["objective"] = " and in the northern Barrens near the border of Ashenvale Forest.\"";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Les cornes de raptors";
      ["name_cn"] = "迅猛?角";
      ["reward"] = {
         [1] = 5342;
         [2] = 5343;
      };
      ["name_de"] = "Es muss im Horn stecken";
      ["faction"] = "Horde";
      ["name"] = "Raptor Horns";
      ["level"] = 18;
      ["name_es"] = "El secreto esta en el cuerno";
      ["req"] = 13;
   };
   [866] = {
      ["name_ru"] = "Образцы корней";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Root Samples to Mebok Mizzyrix in Ratchet.";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "Herbalism";
      ["name_fr"] = "Les echantillons de racines";
      ["name_cn"] = "根??本";
      ["reward"] = {
         [1] = 5341;
      };
      ["name_de"] = "Wurzelproben";
      ["faction"] = "Horde";
      ["name"] = "Root Samples";
      ["level"] = 16;
      ["name_es"] = "Recoge muestras de raices";
      ["req"] = 9;
   };
   [867] = {
      ["name_ru"] = "Гарпии-налетчики";
      ["type"] = "Solo";
      ["objective"] = "Collect 8 Witchwing talons.$B$BReturn them to Darsok Swiftdagger at the Crossroads.";
      ["next"] = 875;
      ["name_fr"] = "Les harpies pillardes";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?身?盗";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Rauberische Harpyien";
      ["faction"] = "Horde";
      ["name"] = "Harpy Raiders";
      ["level"] = 15;
      ["name_es"] = "Arpias saqueadoras";
      ["req"] = 12;
   };
   [868] = {
      ["name_ru"] = "Охота за яйцами";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Silithid Eggs and the Digging Claw to Korran at the Crossroads.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "La chasse aux ?ufs";
      ["name_cn"] = "蝎卵";
      ["reward"] = {
         [1] = 6503;
         [2] = 6502;
      };
      ["name_de"] = "Eierjagd";
      ["faction"] = "Horde";
      ["name"] = "Egg Hunt";
      ["level"] = 22;
      ["name_es"] = "!A cazar huevos!";
      ["req"] = 17;
   };
   [869] = {
      ["name_ru"] = "Ящеры-воры";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Raptor Heads to Gazrog at the Crossroads.";
      ["next"] = 3281;
      ["name_fr"] = "Les raptors voleurs";
      ["sort"] = "The Barrens";
      ["name_cn"] = "??的迅猛?";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Wie man einen Dieb aufspurt";
      ["faction"] = "Horde";
      ["name"] = "Raptor Thieves";
      ["level"] = 13;
      ["name_es"] = "El rastro del ladron";
      ["req"] = 9;
   };
   [870] = {
      ["name_ru"] = "Забытые пруды";
      ["type"] = "Solo";
      ["objective"] = "Report back to Tonga Runetotem with your findings.";
      ["next"] = 877;
      ["name_fr"] = "Les Bassins oublies";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?忘之池";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Die Vergessenen Teiche";
      ["faction"] = "Horde";
      ["name"] = "The Forgotten Pools";
      ["level"] = 13;
      ["name_es"] = "Las Charcas del Olvido";
      ["req"] = 10;
   };
   [871] = {
      ["name_ru"] = "Прекратить набеги";
      ["type"] = "Solo";
      ["objective"] = "Of the Razormane tribe, kill 8 Water Seekers, 8 Thornweavers and 3 Hunters, and then return to Thork in the Crossroads.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Stopper les attaques des hurans";
      ["sort"] = "The Barrens";
      ["name_cn"] = "野猪人的??";
      ["followup"] = 872;
      ["name_de"] = "Die Verteidigung der Fernwacht";
      ["faction"] = "Horde";
      ["name"] = "Disrupt the Attacks";
      ["level"] = 12;
      ["name_es"] = "Defender la Avanzada del Puente";
      ["req"] = 9;
   };
   [872] = {
      ["name_ru"] = "Конец бесчинствам";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Razormane Geomancers, 8 Razormane Defenders, and Kreenig Snarlsnout.$B$BThen bring Kreenig Snarlsnout's Tusk to Thork at the Crossroads.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Der Angriff der Fernwacht";
      ["reward"] = {
         [1] = 5275;
         [2] = 5328;
      };
      ["name_cn"] = "野猪人的?目";
      ["name_fr"] = "La perturbation cesse";
      ["faction"] = "Horde";
      ["name"] = "The Disruption Ends";
      ["sort"] = "The Barrens";
      ["prev"] = 871;
      ["prequests"] = {
         [1] = 871;
      };
      ["level"] = 15;
      ["name_es"] = "La ofensiva de Avanzada del Puente";
      ["req"] = 9;
   };
   [873] = {
      ["name_ru"] = "Иша Авак";
      ["type"] = "Solo";
      ["objective"] = "Bring the Heart of Isha Awak to Mahren Skyseer.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Isha Awak";
      ["reward"] = {
         [1] = 5356;
         [2] = 5355;
         [3] = 5357;
      };
      ["name_cn"] = "依沙瓦克";
      ["name_fr"] = "Isha Awak";
      ["faction"] = "Horde";
      ["name"] = "Isha Awak";
      ["sort"] = "The Barrens";
      ["prev"] = 874;
      ["prequests"] = {
         [1] = 874;
      };
      ["level"] = 27;
      ["name_es"] = "Isha Awak";
      ["req"] = 10;
   };
   [874] = {
      ["name_ru"] = "Марен Небесная Провидица";
      ["type"] = "Solo";
      ["name_fr"] = "Mahren ?il-des-cieux";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_de"] = "Mahren Himmelsdeuter";
      ["name"] = "Mahren Skyseer";
      ["name_cn"] = "??・星眼";
      ["objective"] = "Speak with Mahren Skyseer.";
      ["next"] = 873;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 913;
      ["prequests"] = {
         [1] = 913;
      };
      ["level"] = 27;
      ["name_es"] = "Mahren Vidente del Cielo";
      ["req"] = 9;
   };
   [875] = {
      ["name_ru"] = "Лейтенанты гарпий";
      ["type"] = "Solo";
      ["name_fr"] = "Lieutenants harpies";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Offiziere der Harpyien";
      ["name"] = "Harpy Lieutenants";
      ["name_cn"] = "?身人首?";
      ["objective"] = "Collect 6 Harpy Lieutenant Rings from Witchwing Slayers and return them to Darsok Swiftdagger at the Crossroads.";
      ["next"] = 876;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 867;
      ["prequests"] = {
         [1] = 867;
      };
      ["level"] = 16;
      ["name_es"] = "Las tenientes arpias";
      ["req"] = 12;
   };
   [876] = {
      ["name_ru"] = "Серена Кровавое Перо";
      ["type"] = "Solo";
      ["objective"] = "Slay Serena Bloodfeather and return her head to Darsok Swiftdagger at the Crossroads.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Serena Blutfeder";
      ["reward"] = {
         [1] = 5321;
         [2] = 5279;
         [3] = 5318;
      };
      ["name_cn"] = "塞瑞娜・血羽";
      ["name_fr"] = "Serena Plumesang";
      ["faction"] = "Horde";
      ["name"] = "Serena Bloodfeather";
      ["sort"] = "The Barrens";
      ["prev"] = 875;
      ["prequests"] = {
         [1] = 875;
      };
      ["level"] = 20;
      ["name_es"] = "Serena Sangrepluma";
      ["req"] = 12;
   };
   [877] = {
      ["name_ru"] = "Застывший оазис";
      ["type"] = "Solo";
      ["name_fr"] = "L'oasis stagnante";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Die Brackige Oase";
      ["name"] = "The Stagnant Oasis";
      ["name_cn"] = "死水?洲";
      ["objective"] = "Return to Tonga at The Crossroads, after investigating the Stagnant Oasis.";
      ["next"] = 880;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 870;
      ["prequests"] = {
         [1] = 870;
      };
      ["level"] = 16;
      ["name_es"] = "El Oasis Estancado";
      ["req"] = 10;
   };
   [878] = {
      ["name_ru"] = "Воюющие племена";
      ["type"] = "Solo";
      ["objective"] = "Kill 6 Bristleback Water Seekers, 12 Bristleback Thornweavers and 12 Bristleback Geomancers and return to Mangletooth at Camp Taurajo in the Barrens.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Tribus en guerre";
      ["sort"] = "The Barrens";
      ["name_cn"] = "野猪人的内?";
      ["name_de"] = "Stamme im Krieg";
      ["faction"] = "Horde";
      ["name"] = "Tribes at War";
      ["level"] = 21;
      ["name_es"] = "Tribus en guerra";
      ["req"] = 14;
   };
   [879] = {
      ["name_ru"] = "Предатель в наших рядах";
      ["objective"] = "Kill Nak, Kuz, and Lok Orcbane and bring their skulls to Mangletooth at Camp Taurajo in the Barrens.";
      ["name_cn"] = "内奸";
      ["sort"] = "The Barrens";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "Une trahison de l'interieur";
      ["next"] = 906;
      ["name_de"] = "Verrater in den eigenen Reihen";
      ["repgain"] = {
         [76] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Betrayal from Within";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["series"] = 1;
      ["name_es"] = "Traidores";
      ["req"] = 17;
   };
   [880] = {
      ["name_ru"] = "Измененные существа";
      ["type"] = "Solo";
      ["name_fr"] = "Source de vie";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Veranderte Wesen";
      ["name_cn"] = "??的生物";
      ["name"] = "Altered Beings";
      ["objective"] = "Bring 8 Altered Snapjaw Shells to Tonga Runetotem at the Crossroads.";
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 877;
      ["prequests"] = {
         [1] = 877;
      };
      ["level"] = 16;
      ["name_es"] = "Seres alterados";
      ["req"] = 10;
   };
   [881] = {
      ["name_ru"] = "Ичияки";
      ["type"] = "Solo";
      ["name_fr"] = "Echeyakee";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Echeyakee";
      ["name"] = "Echeyakee";
      ["name_cn"] = "埃其?基";
      ["objective"] = "Bring Echeyakee's Hide to Sergra Darkthorn at the Crossroads.";
      ["next"] = 905;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 903;
      ["prequests"] = {
         [1] = 903;
      };
      ["level"] = 16;
      ["name_es"] = "Echeyakee";
      ["req"] = 10;
   };
   [882] = {
      ["name_ru"] = "Ишамухал";
      ["type"] = "Solo";
      ["name_fr"] = "Ishamuhale";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Ishamuhale";
      ["name"] = "Ishamuhale";
      ["name_cn"] = "伊沙姆哈?";
      ["objective"] = "Bring Ishamuhale's Fang to Jorn at Camp Taurajo.";
      ["next"] = 907;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 3261;
      ["prequests"] = {
         [1] = 3261;
      };
      ["level"] = 19;
      ["name_es"] = "Ishamuhale";
      ["req"] = 10;
   };
   [883] = {
      ["name_ru"] = "Лакота'мани";
      ["type"] = "Solo";
      ["objective"] = "Bring the Hoof of Lakota'mani to Jorn at Camp Taurajo.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Lakota'mani";
      ["sort"] = "The Barrens";
      ["name_cn"] = "拉克塔曼尼";
      ["name_de"] = "Lakota'mani";
      ["faction"] = "Horde";
      ["name"] = "Lakota'mani";
      ["level"] = 22;
      ["name_es"] = "Lakota'mani";
      ["req"] = 10;
   };
   [884] = {
      ["name_ru"] = "Оватанка";
      ["type"] = "Solo";
      ["objective"] = "Bring Owatanka's Tailspike to Jorn at Camp Taurajo.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Owatanka";
      ["sort"] = "The Barrens";
      ["name_cn"] = "奥瓦坦?";
      ["name_de"] = "Owatanka";
      ["faction"] = "Horde";
      ["name"] = "Owatanka";
      ["level"] = 24;
      ["name_es"] = "Owatanka";
      ["req"] = 10;
   };
   [885] = {
      ["name_ru"] = "Ваште Пауни";
      ["type"] = "Solo";
      ["objective"] = "Bring Washte Pawne's Feather to Jorn Skyseer at Camp Taurajo.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Washte Pawne";
      ["sort"] = "The Barrens";
      ["name_cn"] = "瓦希塔?恩";
      ["name_de"] = "Washte Pawne";
      ["faction"] = "Horde";
      ["name"] = "Washte Pawne";
      ["level"] = 25;
      ["name_es"] = "Washte Pawne";
      ["req"] = 10;
   };
   [886] = {
      ["name_ru"] = "Оазисы Степей";
      ["type"] = "Solo";
      ["objective"] = "Speak with Tonga Runetotem at the Crossroads.";
      ["next"] = 870;
      ["name_fr"] = "Les oasis des Tarides";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?瘠之地的?洲";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Die Oasen des Brachlandes";
      ["faction"] = "Horde";
      ["name"] = "The Barrens Oases";
      ["level"] = 10;
      ["name_es"] = "El oasis de Los Baldios";
      ["req"] = 10;
   };
   [887] = {
      ["name_ru"] = "Флибустьеры Южных морей";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Southsea Brigands and 6 Southsea Cannoneers for Gazlowe in Ratchet.";
      ["next"] = 890;
      ["name_fr"] = "Les flibustiers des mers du Sud";
      ["sort"] = "The Barrens";
      ["name_cn"] = "南海海盗";
      ["repgain"] = {
         [470] = 150;
      };
      ["name_de"] = "Sudmeerfreibeuter";
      ["faction"] = "Horde";
      ["name"] = "Southsea Freebooters";
      ["level"] = 14;
      ["name_es"] = "Los filibusteros de los Mares del Sur";
      ["req"] = 9;
   };
   [888] = {
      ["name_ru"] = "Украденное добро";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Shipment of Boots and Telescopic Lens for Gazlowe in Ratchet.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Gestohlene Beute";
      ["reward"] = {
         [1] = 5337;
         [2] = 5320;
      };
      ["name_cn"] = "被窃的?物";
      ["name_fr"] = "Course a la lentille";
      ["faction"] = "Horde";
      ["name"] = "Stolen Booty";
      ["sort"] = "The Barrens";
      ["prev"] = 892;
      ["prequests"] = {
         [1] = 892;
      };
      ["level"] = 16;
      ["name_es"] = "El botin robado";
      ["req"] = 9;
   };
   [889] = {
      ["name_ru"] = "Дух Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "L'esprit du vent";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?之魂";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Spirit of the Wind";
      ["name_de"] = "Geist des Windes";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "El espiritu del viento";
      ["req"] = 14;
   };
   [890] = {
      ["name_ru"] = "Пропавший груз";
      ["objective"] = "Bring Gazlowe's Ledger to Wharfmaster Dizzywig.";
      ["name_cn"] = "?失的?物";
      ["sort"] = "The Barrens";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "La livraison perdue";
      ["next"] = 892;
      ["name_de"] = "Die verloren gegangene Lieferung";
      ["repgain"] = {
         [470] = 10;
      };
      ["faction"] = "Horde";
      ["name"] = "The Missing Shipment";
      ["prev"] = 887;
      ["prequests"] = {
         [1] = 887;
      };
      ["series"] = 1;
      ["name_es"] = "El envio perdido";
      ["req"] = 9;
   };
   [891] = {
      ["name_ru"] = "Пушки крепости Северной Стражи";
      ["type"] = "Solo";
      ["objective"] = "Captain Thalo'thas Brightsun of Ratchet wants you to collect 10 Theramore Medals and slay Captain Fairmount, Cannoneer Whessan and Cannoneer Smythe.";
      ["repgain"] = {
         [470] = 250;
         [530] = 75;
         [81] = 75;
         [76] = 75;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Sous le feu de l'ennemi";
      ["name_cn"] = "北方城堡的火炮";
      ["reward"] = {
         [1] = 5309;
         [2] = 5310;
      };
      ["name_de"] = "Die Rache des Kapitans";
      ["faction"] = "Horde";
      ["name"] = "The Guns of Northwatch";
      ["level"] = 20;
      ["name_es"] = "La venganza de un capitan";
      ["req"] = 13;
   };
   [892] = {
      ["name_ru"] = "Пропавший груз";
      ["objective"] = "Return Gazlowe's Ledger to Gazlowe in Ratchet.";
      ["name_cn"] = "?失的?物";
      ["sort"] = "The Barrens";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "La livraison perdue";
      ["next"] = 888;
      ["name_de"] = "Die verloren gegangene Lieferung";
      ["repgain"] = {
         [470] = 10;
      };
      ["faction"] = "Horde";
      ["name"] = "The Missing Shipment";
      ["prev"] = 890;
      ["prequests"] = {
         [1] = 890;
      };
      ["series"] = 2;
      ["name_es"] = "El envio perdido";
      ["req"] = 9;
   };
   [893] = {
      ["name_ru"] = "Предпочитаемое оружие";
      ["type"] = "Solo";
      ["objective"] = "Bring a Razormane Backstabber, a Charred Razormane Wand and a Razormane War Shield to Tatternack Steelforge at Camp Taurajo in the Barrens.";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Des armes de choix";
      ["name_cn"] = "野猪人的武器";
      ["reward"] = {
         [1] = 5322;
         [2] = 5323;
      };
      ["name_de"] = "Ausgewahlte Waffen";
      ["faction"] = "Horde";
      ["name"] = "Weapons of Choice";
      ["level"] = 24;
      ["name_es"] = "Una seleccion de armas";
      ["req"] = 17;
   };
   [894] = {
      ["name_ru"] = "Самофланж";
      ["type"] = "Solo";
      ["name_fr"] = "Samophlange";
      ["repgain"] = {
         [470] = 150;
      };
      ["name_de"] = "Samophlang";
      ["name_cn"] = "什?什?平衡器";
      ["objective"] = " whatever it is";
      ["next"] = 900;
      ["sort"] = "The Barrens";
      ["name"] = "Samophlange";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 14;
      ["name_es"] = "El churumbele";
      ["req"] = 10;
   };
   [895] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: Барон Дольноберег";
      ["type"] = "Solo";
      ["objective"] = "Bring the head of Baron Longshore to Gazlowe in Ratchet.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_fr"] = "ON RECHERCHE?: baron de Longrivage";
      ["sort"] = "The Barrens";
      ["name_cn"] = "通?：巴隆・朗??";
      ["name_de"] = "GESUCHT: Kapt'n Garvey";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Baron Longshore";
      ["level"] = 16;
      ["name_es"] = "SE BUSCA: Capitan Garvey";
      ["req"] = 11;
   };
   [896] = {
      ["name_ru"] = "Удача шахтера";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Cats Eye Emerald from one of the Venture Co. Overseers or Enforcers for Wharfmaster Dizzywig at Ratchet.";
      ["repgain"] = {
         [470] = 350;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "La bonne fortune d'un mineur pauvre";
      ["name_cn"] = "?工的宝?";
      ["reward"] = {
         [1] = 5335;
      };
      ["name_de"] = "Des Minenarbeiters Vermogen";
      ["faction"] = "Horde";
      ["name"] = "Miner's Fortune";
      ["level"] = 18;
      ["name_es"] = "La fortuna de un minero";
      ["req"] = 13;
   };
   [897] = {
      ["name_ru"] = "Жнец";
      ["type"] = "Solo";
      ["objective"] = "Bring the Harvester's Head to Jorn Skyseer.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_fr"] = "Le Moissonneur";
      ["sort"] = "The Barrens";
      ["name_cn"] = "收割者";
      ["name_de"] = "Der Ernter";
      ["faction"] = "Horde";
      ["name"] = "The Harvester";
      ["level"] = 24;
      ["name_es"] = "El Cosechador";
      ["req"] = 10;
   };
   [898] = {
      ["name_ru"] = "Свобода!";
      ["type"] = "Solo";
      ["objective"] = "Safely escort Gilthares Firebough back to Captain Brightsun in Ratchet.";
      ["repgain"] = {
         [470] = 350;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Hors du fort";
      ["name_cn"] = "逃??牢";
      ["reward"] = {
         [1] = 5311;
         [2] = 5312;
      };
      ["name_de"] = "Aus der Gefangenschaft befreit";
      ["faction"] = "Horde";
      ["name"] = "Free From the Hold";
      ["level"] = 20;
      ["name_es"] = "Escapar del fuerte";
      ["req"] = 13;
   };
   [899] = {
      ["name_ru"] = "Огонь ненависти";
      ["type"] = "Solo";
      ["objective"] = "Bring 60 Bristleback Quilboar Tusks to Mankrik at the Crossroads.";
      ["repgain"] = {
         [76] = 350;
      };
      ["sort"] = "The Barrens";
      ["name_fr"] = "Consume par la haine";
      ["name_cn"] = "?仇的怒火";
      ["reward"] = {
         [1] = 5314;
         [2] = 6477;
      };
      ["name_de"] = "Von Hass zerfressen";
      ["faction"] = "Horde";
      ["name"] = "Consumed by Hatred";
      ["level"] = 20;
      ["name_es"] = "Consumido por el odio";
      ["req"] = 14;
   };
   [900] = {
      ["name_ru"] = "Самофланж";
      ["objective"] = "Close off the Fuel Control Valve, the Regulator Valve and the Main Control Valve then use the control console again.";
      ["name_cn"] = "什?什?平衡器";
      ["sort"] = "The Barrens";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Samophlange";
      ["next"] = 901;
      ["name_de"] = "Samophlang";
      ["repgain"] = {
         [470] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Samophlange";
      ["prev"] = 894;
      ["prequests"] = {
         [1] = 894;
      };
      ["series"] = 2;
      ["name_es"] = "El churumbele";
      ["req"] = 10;
   };
   [901] = {
      ["name_ru"] = "Самофланж";
      ["objective"] = "Get the Console Key from Tinkerer Sniggles to use on the control console.";
      ["name_cn"] = "什?什?平衡器";
      ["sort"] = "The Barrens";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Samophlange";
      ["next"] = 902;
      ["name_de"] = "Samophlang";
      ["repgain"] = {
         [470] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Samophlange";
      ["prev"] = 900;
      ["prequests"] = {
         [1] = 900;
      };
      ["series"] = 3;
      ["name_es"] = "El churumbele";
      ["req"] = 10;
   };
   [902] = {
      ["name_ru"] = "Самофланж";
      ["objective"] = "Return the Samophlange to Sputtervalve in Ratchet.";
      ["name_cn"] = "什?什?平衡器";
      ["sort"] = "The Barrens";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Samophlange";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Samophlang";
      ["reward"] = {
         [1] = 5324;
         [2] = 5325;
      };
      ["faction"] = "Horde";
      ["name"] = "Samophlange";
      ["prev"] = 901;
      ["prequests"] = {
         [1] = 901;
      };
      ["series"] = 4;
      ["name_es"] = "El churumbele";
      ["req"] = 10;
   };
   [903] = {
      ["name_ru"] = "Хищники Степей";
      ["type"] = "Solo";
      ["name_fr"] = "Les rodeurs des Tarides";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Jagt die Jagerin";
      ["name"] = "Prowlers of the Barrens";
      ["name_cn"] = "草原上的徘徊者";
      ["objective"] = "Collect 7 Prowler Claws from Savannah Prowlers for Sergra Darkthorn in the Crossroads.";
      ["next"] = 881;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 845;
      ["prequests"] = {
         [1] = 845;
      };
      ["level"] = 15;
      ["name_es"] = "Cazar a las cazadoras";
      ["req"] = 10;
   };
   [905] = {
      ["name_ru"] = "Разъяренные смертехваты";
      ["type"] = "Solo";
      ["name_fr"] = "Les Faucheurs furieux";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "In die Hohle des Raptors";
      ["name"] = "The Angry Scytheclaws";
      ["name_cn"] = "狂暴的?爪?";
      ["objective"] = "Kill Sunscale raptors and collect their feathers. Use the feathers on the 3 Scytheclaw nests. Return to Sergra Darkthorn in the Crossroads.";
      ["next"] = 3261;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 881;
      ["prequests"] = {
         [1] = 881;
      };
      ["level"] = 17;
      ["name_es"] = "En la guarida del raptor";
      ["req"] = 10;
   };
   [906] = {
      ["name_ru"] = "Предатель в наших рядах";
      ["objective"] = "Bring Lok's Skull to Thork at the Crossroads in the Barrens.";
      ["name_cn"] = "内奸";
      ["sort"] = "The Barrens";
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "Une trahison de l'interieur";
      ["repgain"] = {
         [76] = 500;
      };
      ["name_de"] = "Verrater in den eigenen Reihen";
      ["reward"] = {
         [1] = 5316;
         [2] = 5317;
      };
      ["faction"] = "Horde";
      ["name"] = "Betrayal from Within";
      ["prev"] = 879;
      ["prequests"] = {
         [1] = 879;
      };
      ["series"] = 2;
      ["name_es"] = "Traidores";
      ["req"] = 17;
   };
   [907] = {
      ["name_ru"] = "Разъяренные рокочущие ящерицы";
      ["type"] = "Solo";
      ["name_fr"] = "Les lezards-tonnerre enrages";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Wutende Donnerechsen";
      ["name"] = "Enraged Thunder Lizards";
      ["name_cn"] = "被激怒的雷霆蜥蜴";
      ["objective"] = "Bring 3 Thunder Lizard Blood to Jorn Skyseer at Camp Taurajo.";
      ["next"] = 913;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 882;
      ["prequests"] = {
         [1] = 882;
      };
      ["level"] = 18;
      ["name_es"] = "Los truenagartos iracundos";
      ["req"] = 10;
   };
   [910] = {
      ["name_ru"] = "В порту";
      ["type"] = "Solo";
      ["name_fr"] = "Un tour sur les quais";
      ["name_de"] = "Unten an den Docks";
      ["name_cn"] = "降帆靠港";
      ["objective"] = "Take your ward to the docks of Ratchet in the Barrens.";
      ["sort"] = "Children's Week";
      ["faction"] = "Horde";
      ["name"] = "Down at the Docks";
      ["prev"] = 172;
      ["prequests"] = {
         [1] = 172;
      };
      ["level"] = 60;
      ["name_es"] = "Un paseo por los embarcaderos";
      ["req"] = 10;
   };
   [911] = {
      ["name_ru"] = "Врата пограничья";
      ["type"] = "Solo";
      ["name_fr"] = "L'acces vers la frontiere";
      ["name_de"] = "Das Tor zur Grenze";
      ["name_cn"] = "前?之?";
      ["objective"] = "Take your ward to the Mor'shan Rampart in the northern part of the Barrens, just before entering Ashenvale.";
      ["sort"] = "Children's Week";
      ["faction"] = "Horde";
      ["name"] = "Gateway to the Frontier";
      ["prev"] = 172;
      ["prequests"] = {
         [1] = 172;
      };
      ["level"] = 60;
      ["name_es"] = "El acceso a la frontera";
      ["req"] = 10;
   };
   [913] = {
      ["name_ru"] = "Крик грозового змея";
      ["objective"] = "Find and slay a Thunderhawk, return its wings to Jorn Skyseer at Camp Taurajo.";
      ["name_cn"] = "雷?的嘶?";
      ["sort"] = "The Barrens";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Le cri du faucon-tonnerre";
      ["next"] = 874;
      ["name_de"] = "Der Ruf des Donnerfalken";
      ["repgain"] = {
         [81] = 350;
      };
      ["reward"] = {
         [1] = 5302;
         [2] = 5299;
         [3] = 5306;
      };
      ["name"] = "Cry of the Thunderhawk";
      ["prev"] = 907;
      ["prequests"] = {
         [1] = 907;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El chillido del halcon trueno";
      ["req"] = 10;
   };
   [914] = {
      ["name_ru"] = "Повелители Змей";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Gems of Cobrahn, Anacondra, Pythas and Serpentis to Nara Wildmane in Thunder Bluff.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Anfuhrer der Giftzahne";
      ["reward"] = {
         [1] = 6505;
         [2] = 6504;
      };
      ["name_cn"] = "尖牙德?伊";
      ["name_fr"] = "Les druides du Croc";
      ["faction"] = "Horde";
      ["name"] = "Leaders of the Fang";
      ["sort"] = "Wailing Caverns";
      ["prev"] = 1490;
      ["prequests"] = {
         [1] = 1490;
      };
      ["level"] = 22;
      ["name_es"] = "Lideres del Colmillo";
      ["req"] = 11;
   };
   [915] = {
      ["name_ru"] = "Женщинам ? цветы, детям ? ...";
      ["type"] = "Solo";
      ["objective"] = "Get some Strawberry Ice Cream for your ward.  The lad seems to prefer Tigule and Foror's brand ice cream.";
      ["name_fr"] = "Je veux une glaaaaace?!";
      ["sort"] = "Children's Week";
      ["name_cn"] = "草莓冰激凌";
      ["name"] = "You Scream, I Scream...";
      ["name_de"] = "Lecker Eis";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1800;
      };
      ["level"] = 60;
      ["name_es"] = "!Quiero un heladooooo!";
      ["req"] = 10;
   };
   [916] = {
      ["name_ru"] = "Яд чащобного паука";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Webwood Venom Sacs to Gilshalan Windwalker at Aldrassil.";
      ["next"] = 917;
      ["sort"] = "Shadowglen";
      ["name_fr"] = "Le venin des Tissebois";
      ["name_cn"] = "?林蜘蛛的毒?";
      ["reward"] = {
         [1] = 10544;
         [2] = 5392;
         [3] = 5393;
         [4] = 5586;
      };
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Verderbnis der Waldweber";
      ["faction"] = "Alliance";
      ["name"] = "Webwood Venom";
      ["level"] = 4;
      ["name_es"] = "Corrupcion Tejemadera";
      ["req"] = 3;
   };
   [917] = {
      ["name_ru"] = "Яйцо чащобного паука";
      ["objective"] = "Bring a Webwood Egg to Gilshalan in Aldrassil.";
      ["name_cn"] = "?林蜘蛛的卵";
      ["sort"] = "Shadowglen";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "L'?uf d'araignee Tissebois";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Waldweberei";
      ["followup"] = 920;
      ["faction"] = "Alliance";
      ["name"] = "Webwood Egg";
      ["prev"] = 916;
      ["prequests"] = {
         [1] = 916;
      };
      ["reward"] = {
         [1] = 5395;
         [2] = 4907;
         [3] = 11189;
      };
      ["name_es"] = "Huevo de Tejemadera";
      ["req"] = 1;
   };
   [918] = {
      ["name_ru"] = "Саженцы древесника";
      ["objective"] = "Bring 8 Timberling Seeds to Denelan at Lake Al'Ameth.";
      ["name_cn"] = "林精的?子";
      ["sort"] = "Teldrassil";
      ["level"] = 7;
      ["type"] = "Solo";
      ["name_fr"] = "Les graines de sylvain";
      ["next"] = 922;
      ["name_de"] = "Baumlingssamenkorner";
      ["repgain"] = {
         [69] = 250;
      };
      ["reward"] = {
         [1] = 4604;
      };
      ["name"] = "Timberling Seeds";
      ["prev"] = 997;
      ["prequests"] = {
         [1] = 997;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Semillas de Brezomadera";
      ["req"] = 4;
   };
   [919] = {
      ["name_ru"] = "Ростки древесника";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Timberling Sprouts to Denalan at Lake Al'Ameth.";
      ["repgain"] = {
         [69] = 350;
      };
      ["sort"] = "Teldrassil";
      ["name_fr"] = "Les pousses de sylvain";
      ["name_cn"] = "林精的新芽";
      ["reward"] = {
         [1] = 5606;
         [2] = 6061;
      };
      ["name_de"] = "Baumlingssprosse";
      ["faction"] = "Alliance";
      ["name"] = "Timberling Sprouts";
      ["level"] = 7;
      ["name_es"] = "Brotes de Brezomadera";
      ["req"] = 4;
   };
   [920] = {
      ["name_ru"] = "Зов Тенарона";
      ["type"] = "Solo";
      ["name_fr"] = "Les appels de Tenaron";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Tenarons Einladung";
      ["name"] = "Tenaron's Summons";
      ["name_cn"] = "特?隆的召?";
      ["objective"] = "Speak with Tenaron Stormgrip atop Aldrassil in Shadowglen.";
      ["next"] = 921;
      ["faction"] = "Alliance";
      ["sort"] = "Shadowglen";
      ["prev"] = 917;
      ["prequests"] = {
         [1] = 917;
      };
      ["level"] = 5;
      ["name_es"] = "Las invocaciones de Tenaron";
      ["req"] = 1;
   };
   [921] = {
      ["name_ru"] = "Венец Земли";
      ["objective"] = "Fill the Crystal Phial and bring it back to Tenaron Stormgrip atop Aldrassil.";
      ["name_cn"] = "大地之冠";
      ["sort"] = "Shadowglen";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["next"] = 928;
      ["name_de"] = "Teldrassil: Krone von Azeroth";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 920;
      ["prequests"] = {
         [1] = 920;
      };
      ["series"] = 1;
      ["name_es"] = "Teldrassil: La corona de Azeroth";
      ["req"] = 1;
   };
   [922] = {
      ["name_ru"] = "Релиан Зеленый Костер";
      ["type"] = "Solo";
      ["name_fr"] = "Rellian Vertecime";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Rellian Grunwipfel";
      ["name"] = "Rellian Greenspyre";
      ["name_cn"] = "雷利?・??";
      ["objective"] = "Bring a Timberling Seed to Rellian Greenspyre in Darnassus.";
      ["next"] = 923;
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 918;
      ["prequests"] = {
         [1] = 918;
      };
      ["level"] = 7;
      ["name_es"] = "Rellian Verdeguja";
      ["req"] = 4;
   };
   [923] = {
      ["name_ru"] = "Опухоли";
      ["objective"] = "Bring 5 Mossy Tumors to Rellian Greenspyre in Darnassus.";
      ["name_cn"] = "青苔之瘤";
      ["sort"] = "Teldrassil";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "Tumeurs";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Moosartige Tumore";
      ["followup"] = 2498;
      ["faction"] = "Alliance";
      ["name"] = "Tumors";
      ["prev"] = 922;
      ["prequests"] = {
         [1] = 922;
      };
      ["reward"] = {
         [1] = 5605;
      };
      ["name_es"] = "Tumores musgosos";
      ["req"] = 4;
   };
   [924] = {
      ["name_ru"] = "Демоново семя";
      ["type"] = "Solo";
      ["objective"] = "Grab a Flawed Power Stone.  Bring it to the Altar of Fire before the stone expires, then return to Ak'Zeloth.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Die Damonensaat";
      ["reward"] = {
         [1] = 5420;
      };
      ["name_cn"] = "?魔之?";
      ["name_fr"] = "La Graine demoniaque";
      ["faction"] = "Horde";
      ["name"] = "The Demon Seed";
      ["sort"] = "Durotar";
      ["prev"] = 809;
      ["prequests"] = {
         [1] = 809;
      };
      ["level"] = 14;
      ["name_es"] = "La Semilla del Demonio";
      ["req"] = 9;
   };
   [925] = {
      ["name_ru"] = "Отпечаток копыта Кэрна";
      ["type"] = "Solo";
      ["objective"] = "Travel to Thunder Bluff to see about getting Cairne Bloodhoof's hoofprint for your ward.";
      ["sort"] = "Children's Week";
      ["name_cn"] = "?恩的蹄印";
      ["name_fr"] = "L'empreinte de Cairne";
      ["followup"] = 5502;
      ["name_de"] = "Cairnes Hufabdruck";
      ["faction"] = "Horde";
      ["name"] = "Cairne's Hoofprint";
      ["level"] = 60;
      ["name_es"] = "Marca de la pezuna de Cairne";
      ["req"] = 10;
   };
   [926] = {
      ["name_ru"] = "Треснувший камень силы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Durotar";
      ["name_fr"] = "Pierre de puissance imparfaite";
      ["name_cn"] = "有瑕疵的能量石";
      ["reward"] = {
         [1] = 4986;
      };
      ["name_de"] = "Fehlerhafter Kraftstein";
      ["faction"] = "Horde";
      ["name"] = "Flawed Power Stone";
      ["level"] = 14;
      ["name_es"] = "La piedra de energia con imperfecciones";
      ["req"] = 1;
   };
   [927] = {
      ["name_ru"] = "Сердце, поросшее мхом";
      ["type"] = "Solo";
      ["objective"] = "Bring the Moss-twined Heart to Denalan at Lake Al'Ameth.";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_fr"] = "Le c?ur moussu";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "布?苔?的心?";
      ["name_de"] = "Das moosumschlungene Herz";
      ["faction"] = "Alliance";
      ["name"] = "The Moss-twined Heart";
      ["level"] = 12;
      ["name_es"] = "El corazon musgoso";
      ["req"] = 5;
   };
   [928] = {
      ["name_ru"] = "Венец Земли";
      ["objective"] = "Bring the Partially Filled Vessel to Corithras Moonrage in Dolanaar.";
      ["name_cn"] = "大地之冠";
      ["sort"] = "Shadowglen";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["next"] = 929;
      ["name_de"] = "Teldrassil: Gebt das Wissen weiter";
      ["repgain"] = {
         [69] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 921;
      ["prequests"] = {
         [1] = 921;
      };
      ["series"] = 2;
      ["name_es"] = "Teldrassil: La transmision del conocimiento";
      ["req"] = 1;
   };
   [929] = {
      ["name_ru"] = "Венец Земли";
      ["objective"] = "Fill the Jade Phial and bring it back to Corithras Moonrage in Dolanaar.";
      ["name_cn"] = "大地之冠";
      ["sort"] = "Teldrassil";
      ["level"] = 5;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["next"] = 933;
      ["name_de"] = "Teldrassil: Die Verweigerung der Aspekte";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 928;
      ["prequests"] = {
         [1] = 928;
      };
      ["series"] = 3;
      ["name_es"] = "Teldrassil: La negativa de los Aspectos";
      ["req"] = 1;
   };
   [930] = {
      ["name_ru"] = "Светящийся плод";
      ["type"] = "Solo";
      ["objective"] = "Bring the glowing fruit to Denalan at Lake Al'Ameth.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Le fruit luminescent";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "?光的水果";
      ["name_de"] = "Die leuchtende Frucht";
      ["faction"] = "Alliance";
      ["name"] = "The Glowing Fruit";
      ["level"] = 10;
      ["name_es"] = "El fruto resplandeciente";
      ["req"] = 4;
   };
   [931] = {
      ["name_ru"] = "Мерцающий росток";
      ["type"] = "Solo";
      ["objective"] = "Bring a Shimmering Frond to Denalan at Lake Al'Ameth";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Les racines chatoyantes";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "?光的?叶";
      ["name_de"] = "Der schimmernde Wedel";
      ["faction"] = "Alliance";
      ["name"] = "The Shimmering Frond";
      ["level"] = 10;
      ["name_es"] = "Fronda fulgurante";
      ["req"] = 4;
   };
   [932] = {
      ["name_ru"] = "Извращенная ненависть";
      ["type"] = "Solo";
      ["objective"] = "Kill Lord Melenas and bring his head to Tallonkai Swiftroot in Dolanaar.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Teldrassil";
      ["name_fr"] = "Haine folle";
      ["name_cn"] = "?曲的仇恨";
      ["reward"] = {
         [1] = 5419;
         [2] = 2571;
      };
      ["name_de"] = "Krankhafter Hass";
      ["faction"] = "Alliance";
      ["name"] = "Twisted Hatred";
      ["level"] = 7;
      ["name_es"] = "Odio enraizado";
      ["req"] = 4;
   };
   [933] = {
      ["name_ru"] = "Венец Земли";
      ["objective"] = "Fill the Tourmaline Phial and bring it back to Corithras Moonrage in Dolanaar.";
      ["name_cn"] = "大地之冠";
      ["sort"] = "Teldrassil";
      ["level"] = 9;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["next"] = 7383;
      ["name_de"] = "Teldrassil: Der Anbruch des Tages";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 929;
      ["prequests"] = {
         [1] = 929;
      };
      ["series"] = 4;
      ["name_es"] = "Teldrassil: El alba del manana";
      ["req"] = 1;
   };
   [934] = {
      ["name_ru"] = "Венец Земли";
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Krone der Erde";
      ["name"] = "Crown of the Earth";
      ["name_cn"] = "大地之冠";
      ["objective"] = "Fill the Amethyst Phial and bring it back to Corithras Moonrage in Dolanaar.";
      ["next"] = 935;
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 933;
      ["prequests"] = {
         [1] = 933;
      };
      ["level"] = 11;
      ["name_es"] = "La corona de la Tierra";
      ["req"] = 1;
   };
   [935] = {
      ["name_ru"] = "Венец Земли";
      ["objective"] = "Bring the Filled Vessel to Arch Druid Fandral Staghelm in Darnassus.";
      ["name_cn"] = "大地之冠";
      ["sort"] = "Teldrassil";
      ["level"] = 11;
      ["type"] = "Solo";
      ["name_fr"] = "La couronne de la Terre";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Die Wasser von Teldrassil";
      ["reward"] = {
         [1] = 5596;
         [2] = 5595;
      };
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 7383;
      ["prequests"] = {
         [1] = 7383;
      };
      ["series"] = 6;
      ["name_es"] = "Las aguas de Teldrassil";
      ["req"] = 1;
   };
   [936] = {
      ["name_ru"] = "Помощь верховному друиду Руническому Тотему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem in Thunder Bluff.";
      ["next"] = 3761;
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "L'aide a l'archidruide Totem-runique";
      ["name_de"] = "Erzdruide Runentotem helfen";
      ["faction"] = "Horde";
      ["name"] = "Assisting Arch Druid Runetotem";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Totem de Runa";
      ["req"] = 47;
   };
   [937] = {
      ["name_ru"] = "Зачарованная поляна";
      ["type"] = "Solo";
      ["objective"] = "Acquire 6 Bloodfeather Belts and bring them to Sentinel Arynia Cloudsbreak in the Oracle Glade.";
      ["repgain"] = {
         [69] = 75;
      };
      ["sort"] = "Teldrassil";
      ["name_fr"] = "La clairiere enchantee";
      ["name_cn"] = "神?林地";
      ["followup"] = 940;
      ["reward"] = {
         [1] = 5592;
         [2] = 5591;
      };
      ["name_de"] = "Die verzauberte Lichtung";
      ["faction"] = "Alliance";
      ["name"] = "The Enchanted Glade";
      ["level"] = 11;
      ["name_es"] = "El claro encantado";
      ["req"] = 6;
   };
   [938] = {
      ["name_ru"] = "Туманна";
      ["type"] = "Solo";
      ["objective"] = "Escort Mist to Sentinel Arynia Cloudsbreak at the moon well near the Oracle Tree.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Teldrassil";
      ["name_fr"] = "Brume";
      ["name_cn"] = "密斯特";
      ["reward"] = {
         [1] = 5590;
         [2] = 5593;
         [3] = 5618;
      };
      ["name_de"] = "Nebel";
      ["faction"] = "Alliance";
      ["name"] = "Mist";
      ["level"] = 12;
      ["name_es"] = "Niebla";
      ["req"] = 7;
   };
   [939] = {
      ["name_ru"] = "Флейта Ксаварика";
      ["type"] = "Solo";
      ["objective"] = "Bring the Flute of Xavaric and 5 Jadefire Felbind samples to Eridan Bluewind in southern Felwood.";
      ["next"] = 4441;
      ["sort"] = "Felwood";
      ["name_cn"] = "?瓦里克?笛";
      ["name_fr"] = "Flute de Xavaric";
      ["name_de"] = "[DEPRECATED] Flote des Xavaric";
      ["faction"] = "Alliance";
      ["name"] = "Flute of Xavaric";
      ["level"] = 54;
      ["name_es"] = "La Flauta de Xavaric";
      ["req"] = 49;
   };
   [940] = {
      ["name_ru"] = "Тельдрассил";
      ["type"] = "Solo";
      ["name_fr"] = "Teldrassil";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Teldrassil";
      ["name"] = "Teldrassil";
      ["name_cn"] = "泰?希?";
      ["objective"] = "Deliver the Oracle Tree's report to Arch Druid Fandral Staghelm in Darnassus.";
      ["next"] = 952;
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 937;
      ["prequests"] = {
         [1] = 937;
      };
      ["level"] = 11;
      ["name_es"] = "Teldrassil";
      ["req"] = 6;
   };
   [941] = {
      ["name_ru"] = "Сердце-семя";
      ["type"] = "Solo";
      ["objective"] = "Plant the Tainted Heart in Denalan's Planter.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Das Einpflanzen des Herzens";
      ["reward"] = {
         [1] = 5218;
      };
      ["name_cn"] = "培?心?";
      ["name_fr"] = "Une belle plante";
      ["faction"] = "Alliance";
      ["name"] = "Planting the Heart";
      ["sort"] = "Teldrassil";
      ["prev"] = 927;
      ["prequests"] = {
         [1] = 927;
      };
      ["level"] = 12;
      ["name_es"] = "Plantar el corazon";
      ["req"] = 9;
   };
   [942] = {
      ["name_ru"] = "Рассеянный геолог";
      ["type"] = "Solo";
      ["name_fr"] = "Les absences du Prospecteur";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Der geistesabwesende Ausgrabungsleiter";
      ["name"] = "The Absent Minded Prospector";
      ["name_cn"] = "健忘的勘察?";
      ["objective"] = "Take the mysterious fossil to Archaeologist Flagongut in Menethil Harbor.";
      ["next"] = 943;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 741;
      ["prequests"] = {
         [1] = 741;
      };
      ["level"] = 20;
      ["name_es"] = "El prospector despistado";
      ["req"] = 15;
   };
   [943] = {
      ["name_ru"] = "Рассеянный геолог";
      ["type"] = "Solo";
      ["objective"] = "Archaeologist Flagongut in Menethil Harbor wants you to bring him the Stone of Relu and Flagongut's Fossil.";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Der geistesabwesende Ausgrabungsleiter";
      ["reward"] = {
         [1] = 5627;
         [2] = 5626;
      };
      ["name_cn"] = "健忘的勘察?";
      ["name_fr"] = "Les absences du Prospecteur";
      ["faction"] = "Alliance";
      ["name"] = "The Absent Minded Prospector";
      ["sort"] = "Darkshore";
      ["prev"] = 942;
      ["prequests"] = {
         [1] = 942;
      };
      ["level"] = 24;
      ["name_es"] = "El prospector despistado";
      ["req"] = 15;
   };
   [944] = {
      ["name_ru"] = "Меч Властителя";
      ["type"] = "Solo";
      ["name_fr"] = "Le Glaive du Maitre";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Die Meistergleve";
      ["name"] = "The Master's Glaive";
      ["name_cn"] = "主宰之?";
      ["objective"] = "Gather information, then use the Phial of Scrying to create a Scrying Bowl.  Use the bowl to speak with Onu.";
      ["next"] = 949;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 948;
      ["prequests"] = {
         [1] = 948;
      };
      ["level"] = 17;
      ["name_es"] = "La Espada del Maestro";
      ["req"] = 12;
   };
   [945] = {
      ["name_ru"] = "Спасение Терилун";
      ["type"] = "Solo";
      ["objective"] = "Help Therylune escape, then tell Therysil at the Shrine of Aessina that her sister is safe.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "L'evasion de Therylune";
      ["sort"] = "Darkshore";
      ["name_cn"] = "?送瑟瑞露尼";
      ["name_de"] = "Therylunes Flucht";
      ["faction"] = "Alliance";
      ["name"] = "Therylune's Escape";
      ["level"] = 18;
      ["name_es"] = "La fuga de Therylune";
      ["req"] = 10;
   };
   [947] = {
      ["name_ru"] = "Пещерные грибы";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Scaber Stalks and 1 Death Cap to Barithras Moonshade in Auberdine.";
      ["next"] = 948;
      ["sort"] = "Darkshore";
      ["name_fr"] = "La caverne aux champignons";
      ["name_cn"] = "洞中的?菇";
      ["repgain"] = {
         [69] = 250;
      };
      ["reward"] = {
         [1] = 5610;
         [2] = 4605;
      };
      ["name_de"] = "Hohlenpilze";
      ["faction"] = "Alliance";
      ["name"] = "Cave Mushrooms";
      ["level"] = 17;
      ["name_es"] = "La cueva de las setas";
      ["req"] = 12;
   };
   [948] = {
      ["name_ru"] = "Ону";
      ["type"] = "Solo";
      ["name_fr"] = "Onu";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Onu";
      ["name"] = "Onu";
      ["name_cn"] = "安努";
      ["objective"] = "Speak with Onu at the Grove of the Ancients.";
      ["next"] = 944;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 947;
      ["prequests"] = {
         [1] = 947;
      };
      ["level"] = 17;
      ["name_es"] = "Onus";
      ["req"] = 12;
   };
   [949] = {
      ["name_ru"] = "Лагерь Сумеречного Молота";
      ["type"] = "Solo";
      ["name_fr"] = "Le camp du Marteau du crepuscule";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Das Lager des Schattenhammers";
      ["name"] = "The Twilight Camp";
      ["name_cn"] = "暮光之?的?地";
      ["objective"] = "Find a clue in the Twilight's Hammer camp at the Master's Glaive.";
      ["next"] = 950;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 944;
      ["prequests"] = {
         [1] = 944;
      };
      ["level"] = 17;
      ["name_es"] = "El campamento del Martillo Crepuscular";
      ["req"] = 12;
   };
   [950] = {
      ["name_ru"] = "Возвращение к Ону";
      ["type"] = "Solo";
      ["name_fr"] = "La page qui rend fou";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Ruckkehr zu Onu";
      ["name_cn"] = "向安努回?";
      ["name"] = "Return to Onu";
      ["objective"] = "Bring Onu the recovered Insane Scribbles.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 949;
      ["prequests"] = {
         [1] = 949;
      };
      ["level"] = 17;
      ["name_es"] = "Regresa junto a Onus";
      ["req"] = 12;
   };
   [951] = {
      ["name_ru"] = "Реликвии Матистры";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Mathystra Relics to Onu at the Grove of the Ancients.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Relikte von Mathystra";
      ["reward"] = {
         [1] = 5757;
         [2] = 5615;
      };
      ["name_cn"] = "?塞斯特拉?物";
      ["name_fr"] = "Les Reliques de Mathystra";
      ["faction"] = "Alliance";
      ["name"] = "Mathystra Relics";
      ["sort"] = "Darkshore";
      ["prev"] = 950;
      ["prequests"] = {
         [1] = 950;
      };
      ["level"] = 20;
      ["name_es"] = "Las reliquias de Mathystra";
      ["req"] = 12;
   };
   [952] = {
      ["name_ru"] = "Роща Древних";
      ["type"] = "Solo";
      ["name_fr"] = "Bosquet des Anciens";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Hain der Uralten";
      ["name_cn"] = "古?之林";
      ["name"] = "Grove of the Ancients";
      ["objective"] = "Deliver Fandral's message to Onu in the Grove of the Ancients in Darkshore, south of Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darnassus";
      ["prev"] = 940;
      ["prequests"] = {
         [1] = 940;
      };
      ["level"] = 11;
      ["name_es"] = "El Paramo de los Ancianos";
      ["req"] = 6;
   };
   [953] = {
      ["name_ru"] = "Падение Амет'Арана";
      ["type"] = "Solo";
      ["objective"] = "Study the tablets which tell of Ameth'Aran and of its fall, then return to Sentinel Tysha Moonblade in Darkshore.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "La chute d'Ameth'Aran";
      ["sort"] = "Darkshore";
      ["name_cn"] = "?米??的??";
      ["name_de"] = "Der Untergang von Ameth'Aran";
      ["faction"] = "Alliance";
      ["name"] = "The Fall of Ameth'Aran";
      ["level"] = 12;
      ["name_es"] = "La caida de Ameth'Aran";
      ["req"] = 9;
   };
   [954] = {
      ["name_ru"] = "Башал'Аран";
      ["type"] = "Solo";
      ["name_fr"] = "Bashal'Aran";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Bashal'Aran";
      ["name_cn"] = "巴莎?";
      ["objective"] = "Find the source of the strange blue aura in the ruins of Bashal'Aran.";
      ["next"] = 955;
      ["sort"] = "Darkshore";
      ["name"] = "Bashal'Aran";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 12;
      ["name_es"] = "Bashal'Aran";
      ["req"] = 7;
   };
   [955] = {
      ["name_ru"] = "Башал'Аран";
      ["objective"] = "Acquire 8 Grell Earrings for Asterion in Bashal'Aran.";
      ["name_cn"] = "巴莎?";
      ["sort"] = "Darkshore";
      ["level"] = 12;
      ["type"] = "Solo";
      ["name_fr"] = "Bashal'Aran";
      ["next"] = 956;
      ["name_de"] = "Bashal'Aran";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Bashal'Aran";
      ["prev"] = 954;
      ["prequests"] = {
         [1] = 954;
      };
      ["series"] = 2;
      ["name_es"] = "Bashal'Aran";
      ["req"] = 7;
   };
   [956] = {
      ["name_ru"] = "Башал'Аран";
      ["objective"] = "Obtain the Ancient Moonstone Seal and bring it to Asterion in Bashal'Aran.";
      ["name_cn"] = "巴莎?";
      ["sort"] = "Darkshore";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Bashal'Aran";
      ["next"] = 957;
      ["name_de"] = "Bashal'Aran";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Bashal'Aran";
      ["prev"] = 955;
      ["prequests"] = {
         [1] = 955;
      };
      ["series"] = 3;
      ["name_es"] = "Bashal'Aran";
      ["req"] = 7;
   };
   [957] = {
      ["name_ru"] = "Башал'Аран";
      ["objective"] = "Destroy the Ancient Moonstone Seal at the ancient flame in Ameth'Aran, then return to Asterion in Bashal'Aran.";
      ["name_cn"] = "巴莎?";
      ["sort"] = "Darkshore";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Bashal'Aran";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Bashal'Aran";
      ["reward"] = {
         [1] = 7229;
         [2] = 5617;
         [3] = 5604;
      };
      ["faction"] = "Alliance";
      ["name"] = "Bashal'Aran";
      ["prev"] = 956;
      ["prequests"] = {
         [1] = 956;
      };
      ["series"] = 4;
      ["name_es"] = "Bashal'Aran";
      ["req"] = 7;
   };
   [958] = {
      ["name_ru"] = "Инструменты высокорожденных";
      ["type"] = "Solo";
      ["objective"] = "Retrieve 7 Highborne Relics for Thundris Windweaver in Auberdine.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "Les outils des Bien-nes";
      ["name_cn"] = "上?精?的工具";
      ["reward"] = {
         [1] = 5612;
      };
      ["name_de"] = "Werkzeuge der Hochgeborenen";
      ["faction"] = "Alliance";
      ["name"] = "Tools of the Highborne";
      ["level"] = 12;
      ["name_es"] = "Las herramientas de los Altonato";
      ["req"] = 9;
   };
   [959] = {
      ["name_ru"] = "Неприятности в порту";
      ["type"] = "Solo";
      ["objective"] = "Crane Operator Bigglefuzz in Ratchet wants you to retrieve the bottle of 99-Year-Old Port from Mad Magglish who is hiding in the Wailing Caverns.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_fr"] = "Fuite de porto aux docks";
      ["sort"] = "Wailing Caverns";
      ["name_cn"] = "港口的麻?";
      ["name_de"] = "Arger auf den Docks";
      ["faction"] = "Horde";
      ["name"] = "Trouble at the Docks";
      ["level"] = 18;
      ["name_es"] = "!A por la botella!";
      ["req"] = 14;
   };
   [961] = {
      ["name_ru"] = "Размышление Ону";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkshore";
      ["name_fr"] = "Onu reflechit";
      ["name_cn"] = "正在冥想的安努";
      ["reward"] = {
         [1] = 5251;
      };
      ["name_de"] = "Onu meditiert";
      ["faction"] = "Alliance";
      ["name"] = "Onu is meditating";
      ["level"] = 1;
      ["name_es"] = "Onus lo esta meditando";
      ["req"] = 1;
   };
   [962] = {
      ["name_ru"] = "Змеецвет";
      ["type"] = "Solo";
      ["objective"] = "Apothecary Zamah in Thunder Bluff wants you to collect 10 Serpentbloom.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Wailing Caverns";
      ["name_fr"] = "Fleur de serpent";
      ["name_cn"] = "毒蛇花";
      ["reward"] = {
         [1] = 10919;
      };
      ["name_de"] = "Schlangenflaum";
      ["faction"] = "Horde";
      ["name"] = "Serpentbloom";
      ["level"] = 18;
      ["name_es"] = "Reptilia";
      ["req"] = 14;
   };
   [963] = {
      ["name_ru"] = "Во имя вечной любви";
      ["type"] = "Solo";
      ["objective"] = "Free the spirit of Anaya Dawnrunner and bring her pendant back to Cerellean Whiteclaw in Auberdine.";
      ["repgain"] = {
         [69] = 150;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "Un amour eternel";
      ["name_cn"] = "永志不渝";
      ["reward"] = {
         [1] = 5611;
      };
      ["name_de"] = "In ewiger Liebe";
      ["faction"] = "Alliance";
      ["name"] = "For Love Eternal";
      ["level"] = 16;
      ["name_es"] = "Un amor eterno";
      ["req"] = 11;
   };
   [964] = {
      ["name_ru"] = "Фрагменты скелетов";
      ["type"] = "Solo";
      ["name_fr"] = "Fragments de squelette";
      ["next"] = 5514;
      ["name_de"] = "Skelettfragmente";
      ["name_cn"] = "骸骨碎片";
      ["objective"] = "Bring 15 Skeletal Fragments to Apothecary Dithers at the Bulwark, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Skeletal Fragments";
      ["prev"] = 838;
      ["prequests"] = {
         [1] = 838;
      };
      ["level"] = 57;
      ["name_es"] = "Trozos esqueleticos";
      ["req"] = 55;
   };
   [965] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["name_cn"] = "奥?拉克斯之塔";
      ["objective"] = "Find Balthule Shadowstrike near the Tower of Althalaxx in Darkshore.";
      ["next"] = 966;
      ["sort"] = "Darkshore";
      ["name"] = "The Tower of Althalaxx";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 18;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [966] = {
      ["name_ru"] = "Башня Алталакса";
      ["objective"] = "Collect 4 Worn Parchments for Balthule Shadowstrike near the Tower of Althalaxx.";
      ["name_cn"] = "奥?拉克斯之塔";
      ["sort"] = "Darkshore";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["next"] = 967;
      ["name_de"] = "Der Turm von Althalaxx";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Tower of Althalaxx";
      ["prev"] = 965;
      ["prequests"] = {
         [1] = 965;
      };
      ["series"] = 2;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [967] = {
      ["name_ru"] = "Башня Алталакса";
      ["objective"] = "Deliver Balthule's letter to Delgren the Purifier in Ashenvale Forest.";
      ["name_cn"] = "奥?拉克斯之塔";
      ["sort"] = "Darkshore";
      ["level"] = 18;
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["next"] = 970;
      ["name_de"] = "Der Turm von Althalaxx";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Tower of Althalaxx";
      ["prev"] = 966;
      ["prequests"] = {
         [1] = 966;
      };
      ["series"] = 3;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [968] = {
      ["name_ru"] = "\"Подземные Силы\"";
      ["type"] = "Solo";
      ["objective"] = " The Forlorn Cavern";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_fr"] = "Les puissances d'en bas";
      ["sort"] = "Darkshore";
      ["name_cn"] = "深渊之神";
      ["name_de"] = "Die Macht in der Tiefe";
      ["faction"] = "Alliance";
      ["name"] = "The Powers Below";
      ["level"] = 20;
      ["name_es"] = "Los Poderes Subyacentes";
      ["req"] = 10;
   };
   [969] = {
      ["name_ru"] = "Да пребудет с тобой удача!";
      ["type"] = "Group";
      ["objective"] = "Collect 4 Frostmaul Shards for Witch Doctor Mau'ari in Everlook.";
      ["next"] = 975;
      ["sort"] = "Winterspring";
      ["name_cn"] = "祝?好?";
      ["name_fr"] = "Que la chance soit avec vous";
      ["name_de"] = "Das Gluck sei mit Euch";
      ["faction"] = "Horde";
      ["name"] = "Luck Be With You";
      ["level"] = 60;
      ["name_es"] = "Que la suerte sea contigo";
      ["req"] = 55;
   };
   [970] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["objective"] = "Collect a Glowing Soul Gem and return it to Delgren the Purifier at Maestra's Post.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["name"] = "The Tower of Althalaxx";
      ["name_cn"] = "奥?拉克斯之塔";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["series"] = 4;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 967;
      ["prequests"] = {
         [1] = 967;
      };
      ["level"] = 21;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [971] = {
      ["name_ru"] = "Знание в пучине";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Lorgalis Manuscript to Gerrig Bonegrip in the Forlorn Cavern in Ironforge.";
      ["repgain"] = {
         [47] = 75;
      };
      ["sort"] = "Blackfathom Deeps";
      ["name_fr"] = "La connaissance des profondeurs";
      ["name_cn"] = "深渊中的知?";
      ["reward"] = {
         [1] = 6743;
      };
      ["name_de"] = "Wissen in der Tiefe";
      ["faction"] = "Alliance";
      ["name"] = "Knowledge in the Deeps";
      ["level"] = 23;
      ["name_es"] = "Conocimiento en las Cavernas";
      ["req"] = 10;
   };
   [972] = {
      ["name_ru"] = "Сапта воды";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Shaman";
      ["name_fr"] = "Le sapta d'eau";
      ["name_cn"] = "水之?契";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 6637;
      };
      ["name_de"] = "Wassersapta";
      ["faction"] = "Horde";
      ["name"] = "Water Sapta";
      ["level"] = 20;
      ["name_es"] = "La sapta de agua";
      ["req"] = 20;
   };
   [973] = {
      ["name_ru"] = "Башня Алталакса";
      ["objective"] = "Bring Ilkrud Magthrull's Tome to Delgren the Purifier at Maestra's Post.";
      ["name_cn"] = "奥?拉克斯之塔";
      ["sort"] = "Darkshore";
      ["level"] = 24;
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["next"] = 1140;
      ["name_de"] = "Der Turm von Althalaxx";
      ["repgain"] = {
         [69] = 250;
      };
      ["reward"] = {
         [1] = 5622;
         [2] = 5613;
      };
      ["name"] = "The Tower of Althalaxx";
      ["prev"] = 970;
      ["prequests"] = {
         [1] = 970;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [974] = {
      ["name_ru"] = "Найти источник";
      ["type"] = "Solo";
      ["objective"] = "Krakle in Un'Goro Crater wants you to find the hottest area of Fire Plume Ridge.$B$BWhenever you find a hot spot, right click the thermometer to check the temperature. Keep looking until you find the hottest one.";
      ["next"] = 980;
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "究根?底";
      ["name_fr"] = "A la recherche de la source";
      ["name_de"] = "Die Quelle finden";
      ["faction"] = "Horde";
      ["name"] = "Finding the Source";
      ["level"] = 55;
      ["name_es"] = "Busca la fuente";
      ["req"] = 51;
   };
   [975] = {
      ["name_ru"] = "Сокровище Мау'ари";
      ["type"] = "Solo";
      ["name_fr"] = "Cache de Mau'ari";
      ["name_de"] = "Behalter von Mau'ari";
      ["reward"] = {
         [1] = 12384;
      };
      ["name_cn"] = "?艾里的容器";
      ["objective"] = "Speak to Witch Doctor Mau'ari again in a moment to receive the lucky charm.";
      ["faction"] = "Horde";
      ["name"] = "Cache of Mau'ari";
      ["sort"] = "Winterspring";
      ["prev"] = 969;
      ["prequests"] = {
         [1] = 969;
      };
      ["level"] = 60;
      ["name_es"] = "Alijo de Mau'ari";
      ["req"] = 55;
   };
   [976] = {
      ["name_ru"] = "Поставка для Аубердина";
      ["type"] = "Solo";
      ["objective"] = "Speak with Delgren the Purifier at Maestra's Post after seeing Feero safely through Ashenvale Forest.";
      ["repgain"] = {
         [69] = 500;
      };
      ["name_de"] = "Nachschub fur Auberdine";
      ["reward"] = {
         [1] = 5323;
         [2] = 6721;
      };
      ["name_cn"] = "奥伯丁的??品";
      ["name_fr"] = "De l’approvisionnement pour Auberdine";
      ["faction"] = "Alliance";
      ["name"] = "Supplies to Auberdine";
      ["sort"] = "Ashenvale";
      ["prev"] = 973;
      ["prequests"] = {
         [1] = 973;
      };
      ["level"] = 24;
      ["name_es"] = "Suministros a Auberdine";
      ["req"] = 19;
   };
   [977] = {
      ["name_ru"] = "Йети где-то рядом...";
      ["objective"] = "Collect 2 Pristine Yeti Horns for Umi Rumplesnicker in Everlook.";
      ["name_cn"] = "雪怪??！";
      ["sort"] = "Winterspring";
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Yeti?? Y es-tu??";
      ["next"] = 5163;
      ["name_de"] = "Sind wir endlich da, Yeti?";
      ["repgain"] = {
         [577] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Are We There, Yeti?";
      ["prev"] = 3783;
      ["prequests"] = {
         [1] = 3783;
      };
      ["series"] = 2;
      ["name_es"] = "Yeti... ?ya hemos llegado?";
      ["req"] = 52;
   };
   [978] = {
      ["name_ru"] = "Осененные луной дикие совухи";
      ["type"] = "Solo";
      ["name_fr"] = "Les Indomptables lunaires";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Mondbestrahltes Wildekin";
      ["name"] = "Moontouched Wildkin";
      ["name_cn"] = "月光羽毛";
      ["objective"] = "Collect 10 Moontouched Feathers from Winterspring, then return to Erelas Ambersky in Rut'theran Village.";
      ["next"] = 979;
      ["faction"] = "Alliance";
      ["sort"] = "Rut'theran Village";
      ["prev"] = 3661;
      ["prequests"] = {
         [1] = 3661;
      };
      ["level"] = 55;
      ["name_es"] = "Lechucico Lunadon";
      ["req"] = 52;
   };
   [979] = {
      ["name_ru"] = "В поисках Раншаллы";
      ["type"] = "Solo";
      ["name_fr"] = "Trouver Ranshalla";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Ranshalla suchen";
      ["name_cn"] = "?莎?拉";
      ["name"] = "Find Ranshalla";
      ["objective"] = "Find Ranshalla in eastern Winterspring.";
      ["faction"] = "Alliance";
      ["sort"] = "Rut'theran Village";
      ["prev"] = 978;
      ["prequests"] = {
         [1] = 978;
      };
      ["level"] = 57;
      ["name_es"] = "Encuentra a Ranshalla";
      ["req"] = 52;
   };
   [980] = {
      ["name_ru"] = "Новые источники";
      ["type"] = "Solo";
      ["name_fr"] = "Les nouvelles sources";
      ["next"] = 4842;
      ["name_de"] = "Die neuen Quellen";
      ["name_cn"] = "新的泉水";
      ["objective"] = "Travel to Winterspring and speak with Donova Snowden.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The New Springs";
      ["prev"] = 974;
      ["prequests"] = {
         [1] = 974;
      };
      ["level"] = 55;
      ["name_es"] = "Nuevos manantiales";
      ["req"] = 51;
   };
   [981] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["objective"] = "Talk to Delgren the Purifier at Maestra's Post.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["reward"] = {
         [1] = 10043;
         [2] = 5614;
      };
      ["name_cn"] = "奥?拉克斯之塔";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["faction"] = "Alliance";
      ["name"] = "The Tower of Althalaxx";
      ["sort"] = "Darkshore";
      ["prev"] = 1143;
      ["prequests"] = {
         [1] = 1143;
      };
      ["level"] = 31;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [982] = {
      ["name_ru"] = "Безбрежное море, глубокий океан";
      ["type"] = "Solo";
      ["objective"] = "Recover the Silver Dawning's Lockbox and the Mist Veil's Lockbox for Gorbold Steelhand in Auberdine.  Both items should be found aboard the wreckage of the ships to the north of the village.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "Ocean profond, mer immense";
      ["name_cn"] = "深不可?的海洋";
      ["reward"] = {
         [1] = 15401;
         [2] = 15402;
      };
      ["name_de"] = "Tiefer Ozean, weites Meer";
      ["faction"] = "Alliance";
      ["name"] = "Deep Ocean, Vast Sea";
      ["level"] = 17;
      ["name_es"] = "Profundo oceano, mar inmenso";
      ["req"] = 13;
   };
   [983] = {
      ["name_ru"] = "Жужжалка 827";
      ["type"] = "Solo";
      ["objective"] = "Collect 6 Crawler Legs and place them in Buzzbox 827.";
      ["next"] = 1001;
      ["name_fr"] = "Bigobox?827";
      ["sort"] = "Darkshore";
      ["name_cn"] = "?声盒827号";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Drohnkiste 827";
      ["faction"] = "Alliance";
      ["name"] = "Buzzbox 827";
      ["level"] = 10;
      ["name_es"] = "La caja mecanica 827";
      ["req"] = 7;
   };
   [984] = {
      ["name_ru"] = "Насколько велика угроза?";
      ["type"] = "Solo";
      ["name_fr"] = "Quelle est l'ampleur de la menace??";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Wie gros ist die Bedrohung?";
      ["name_cn"] = "熊怪的威?";
      ["objective"] = "Find a corrupt furbolg camp in Darkshore and return to Terenthis in Auberdine.";
      ["next"] = 985;
      ["sort"] = "Darkshore";
      ["name"] = "How Big a Threat?";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 14;
      ["name_es"] = "La extension de la amenaza";
      ["req"] = 10;
   };
   [985] = {
      ["name_ru"] = "Насколько велика угроза?";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Blackwood Pathfinders and 5 Windtalkers and return to Terenthis in Auberdine.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Wie gros ist die Bedrohung?";
      ["name"] = "How Big a Threat?";
      ["name_cn"] = "熊怪的威?";
      ["name_fr"] = "Quelle est l'ampleur de la menace??";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 984;
      ["prequests"] = {
         [1] = 984;
      };
      ["level"] = 14;
      ["name_es"] = "La extension de la amenaza";
      ["req"] = 10;
   };
   [986] = {
      ["name_ru"] = "Пропавший хозяин";
      ["type"] = "Solo";
      ["name_fr"] = "Un maitre perdu";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Ein verirrter Meister";
      ["name_cn"] = "失踪的主人";
      ["name"] = "A Lost Master";
      ["objective"] = "Find 5 Fine Moonstalker Pelts and return them to Terenthis in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 985;
      ["prequests"] = {
         [1] = 985;
      };
      ["level"] = 20;
      ["name_es"] = "El maestro perdido";
      ["req"] = 10;
   };
   [990] = {
      ["name_ru"] = "Путь в Ясеневый лес";
      ["type"] = "Solo";
      ["name_fr"] = "Voyage vers Orneval";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_cn"] = "灰谷之旅";
      ["name_de"] = "Marsch ins Eschental";
      ["objective"] = "Find Raene Wolfrunner in Ashenvale.";
      ["sort"] = "Ashenvale";
      ["name"] = "Trek to Ashenvale";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 994;
         [2] = 995;
      };
      ["level"] = 19;
      ["name_es"] = "El camino de Vallefresno";
      ["req"] = 15;
   };
   [991] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Findet Teronis";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Find Teronis in Ashenvale.";
      ["next"] = 1023;
      ["sort"] = "Ashenvale";
      ["name"] = "Raene's Cleansing";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 19;
      ["name_es"] = "Encontrar a Teronis";
      ["req"] = 18;
   };
   [992] = {
      ["name_ru"] = "Исследование воды";
      ["type"] = "Solo";
      ["objective"] = "Use the untapped dowsing widget near the pool of water by Sandsorrow Watch.  Once you have collected the sample, return the tapped dowsing widget to Senior Surveyor Fizzledowser in Gadgetzan.";
      ["next"] = 82;
      ["name_fr"] = "Etude des eaux de Gadgetzan";
      ["sort"] = "Tanaris";
      ["name_cn"] = "加基森水?公司";
      ["repgain"] = {
         [369] = 150;
      };
      ["name_de"] = "Gadgetzan Wassersondierung";
      ["faction"] = "Horde";
      ["name"] = "Gadgetzan Water Survey";
      ["level"] = 46;
      ["name_es"] = "Un estudio de agua de Gadgetzan";
      ["req"] = 38;
   };
   [993] = {
      ["name_ru"] = "Пропавший хозяин";
      ["type"] = "Solo";
      ["name_fr"] = "Un maitre perdu";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Ein verirrter Meister";
      ["name_cn"] = "?失的主人";
      ["name"] = "A Lost Master";
      ["objective"] = "Find Volcor in Darkshore and give him the Enchanted Moonstalker Cloak.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 986;
      ["prequests"] = {
         [1] = 986;
      };
      ["level"] = 20;
      ["name_es"] = "El maestro perdido";
      ["req"] = 10;
   };
   [994] = {
      ["name_ru"] = "Спасение с помощью силы";
      ["objective"] = "Protect Volcor until you reach the road, then speak to Terenthis in Auberdine.";
      ["name_cn"] = "?出重?";
      ["sort"] = "Darkshore";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "Evasion par la force";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Flucht durch Gewalt";
      ["followup"] = 990;
      ["faction"] = "Alliance";
      ["name"] = "Escape Through Force";
      ["prev"] = 993;
      ["prequests"] = {
         [1] = 993;
      };
      ["reward"] = {
         [1] = 5609;
      };
      ["name_es"] = "Escaparse por la fuerza";
      ["req"] = 10;
   };
   [995] = {
      ["name_ru"] = "Спасение с помощью скрытности";
      ["objective"] = "Escape the Furbolg cave and meet Terenthis in Auberdine.";
      ["name_cn"] = "??溜走";
      ["sort"] = "Darkshore";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Evasion par la ruse";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Flucht durch Verstohlenheit";
      ["followup"] = 990;
      ["faction"] = "Alliance";
      ["name"] = "Escape Through Stealth";
      ["prev"] = 993;
      ["prequests"] = {
         [1] = 993;
      };
      ["reward"] = {
         [1] = 6659;
      };
      ["name_es"] = "Escaparse furtivamente";
      ["req"] = 10;
   };
   [996] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [997] = {
      ["name_ru"] = "Земля Деналана";
      ["type"] = "Solo";
      ["objective"] = "Bring the package of Rare Earth to Denalan at Lake Al'Ameth.";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_fr"] = "La terre de Denalan";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "德??的泥土";
      ["name_de"] = "Denalans Erde";
      ["faction"] = "Alliance";
      ["name"] = "Denalan's Earth";
      ["level"] = 5;
      ["name_es"] = "Las tierras de Denalan";
      ["req"] = 4;
   };
   [998] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [1000] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem on the Elder Rise of Thunder Bluff about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 1123;
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "新的?疆";
      ["name_fr"] = "La nouvelle frontiere";
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Horde";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1001] = {
      ["name_ru"] = "Жужжалка 411";
      ["type"] = "Solo";
      ["name_fr"] = "Bigobox?411";
      ["repgain"] = {
         [0] = 54;
      };
      ["name_de"] = "Drohnkiste 411";
      ["name"] = "Buzzbox 411";
      ["name_cn"] = "?声盒411号";
      ["objective"] = " on the beach$B$BSo";
      ["next"] = 1002;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 983;
      ["prequests"] = {
         [1] = 983;
      };
      ["level"] = 12;
      ["name_es"] = "La caja mecanica 411";
      ["req"] = 7;
   };
   [1002] = {
      ["name_ru"] = "Жужжалка 323";
      ["type"] = "Solo";
      ["name_fr"] = "Bigobox?323";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Drohnkiste 323";
      ["name"] = "Buzzbox 323";
      ["name_cn"] = "?声盒323号";
      ["objective"] = " ish on the road sho ya shouldn't have trouble finding it near the bridge.\"$B$BWizbang mumbles something incoherent before you hear a loud gulping sound.$B$B\"Thish one needs Moonstalker Fangs... 6 of 'em.\"\"";
      ["next"] = 1003;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 1001;
      ["prequests"] = {
         [1] = 1001;
      };
      ["level"] = 14;
      ["name_es"] = "La caja mecanica 323";
      ["req"] = 7;
   };
   [1003] = {
      ["name_ru"] = "Жужжалка 525";
      ["type"] = "Solo";
      ["name_fr"] = "Bigobox?525";
      ["repgain"] = {
         [2082] = 5;
         [0] = 1;
      };
      ["name_de"] = "Drohnkiste 525";
      ["name_cn"] = "?声盒525号";
      ["name"] = "Buzzbox 525";
      ["objective"] = " Buzzbox 525 takes grizzled scalps from thoshe grizzled thistle bears. Boy thash a mouthful. Grizzshled... Hehehe...\"$B$BYou hear more gulping sounds as the machine cuts out. Then";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 1002;
      ["prequests"] = {
         [1] = 1002;
      };
      ["level"] = 16;
      ["name_es"] = "La caja mecanica 525";
      ["req"] = 7;
   };
   [1004] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem on the Elder Rise of Thunder Bluff about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 1123;
      ["sort"] = "Undercity";
      ["name_cn"] = "新的?疆";
      ["name_fr"] = "La nouvelle frontiere";
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Horde";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1007] = {
      ["name_ru"] = "Древняя статуэтка";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ancient Statuette to Talen, in his camp near the Zoram Strand.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_fr"] = "L'ancienne statuette";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "?古雕像";
      ["name_de"] = "Die antiken Statuetten";
      ["faction"] = "Alliance";
      ["name"] = "The Ancient Statuette";
      ["level"] = 20;
      ["name_es"] = "Las antiguas estatuillas";
      ["req"] = 19;
   };
   [1008] = {
      ["name_ru"] = "Зорамское взморье";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Wrathtail Heads to Shindrell Swiftfire in Astranaar.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "La greve de Zoram";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "佐拉姆海岸";
      ["name_de"] = "Der Zoramstrand";
      ["faction"] = "Alliance";
      ["name"] = "The Zoram Strand";
      ["level"] = 19;
      ["name_es"] = "La Ensenada de Zoram";
      ["req"] = 14;
   };
   [1009] = {
      ["name_ru"] = "Руузель";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ring of Zoram to Talen near the Zoram Strand.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Ruuzel";
      ["reward"] = {
         [1] = 5812;
      };
      ["name_cn"] = "???";
      ["name_fr"] = "Ruuzel";
      ["faction"] = "Alliance";
      ["name"] = "Ruuzel";
      ["sort"] = "Ashenvale";
      ["prev"] = 1007;
      ["prequests"] = {
         [1] = 1007;
      };
      ["level"] = 25;
      ["name_es"] = "Ruuzel";
      ["req"] = 20;
   };
   [1010] = {
      ["name_ru"] = "Батранов волос";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Bathran's Hair to Orendil Broadleaf in Ashenvale.";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_fr"] = "Les Cheveux de Bathran";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "巴斯?的??";
      ["name_de"] = "Bathranshaar";
      ["faction"] = "Alliance";
      ["name"] = "Bathran's Hair";
      ["level"] = 20;
      ["name_es"] = "Cabello de Bathran";
      ["req"] = 20;
   };
   [1011] = {
      ["name_ru"] = "Чума Отрекшихся";
      ["type"] = "Solo";
      ["name_fr"] = "Les maladies des Reprouves";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Verlassenenkrankheit";
      ["name_cn"] = "被?忘者的病菌";
      ["name"] = "Forsaken Diseases";
      ["objective"] = "Bring a Bottle of Disease to Kayneth Stillwind in Forest Song.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 4581;
      ["prequests"] = {
         [1] = 4581;
      };
      ["level"] = 29;
      ["name_es"] = "Los males de los Renegados";
      ["req"] = 24;
   };
   [1012] = {
      ["name_ru"] = "Безумные друиды";
      ["type"] = "Solo";
      ["objective"] = "Kill the druids: Taneel Darkwood, Uthil Mooncall, Mavoris Cloudsbreak; then return to Kayneth Stillwind in Forest Song.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Irrsinnige Druiden";
      ["reward"] = {
         [1] = 5813;
      };
      ["name_cn"] = "?狂的德?伊";
      ["name_fr"] = "Les druides fous";
      ["faction"] = "Alliance";
      ["name"] = "Insane Druids";
      ["sort"] = "Ashenvale";
      ["prev"] = 1011;
      ["prequests"] = {
         [1] = 1011;
      };
      ["level"] = 32;
      ["name_es"] = "Druidas dementes";
      ["req"] = 24;
   };
   [1013] = {
      ["name_ru"] = "Книга Ура";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Book of Ur to Keeper Bel'dugur at the Apothecarium in the Undercity.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Shadowfang Keep";
      ["name_fr"] = "Le Livre d'Ur";
      ["name_cn"] = "??之?";
      ["reward"] = {
         [1] = 6335;
         [2] = 4534;
      };
      ["name_de"] = "Das Buch von Ur";
      ["faction"] = "Horde";
      ["name"] = "The Book of Ur";
      ["level"] = 26;
      ["name_es"] = "El Libro de Ur";
      ["req"] = 16;
   };
   [1014] = {
      ["name_ru"] = "Смерть Аругалу!";
      ["type"] = "Dungeon";
      ["objective"] = "Kill Arugal and bring his head to Dalar Dawnweaver at the Sepulcher.";
      ["repgain"] = {
         [68] = 500;
      };
      ["sort"] = "Shadowfang Keep";
      ["name_fr"] = "Arugal doit mourir";
      ["name_cn"] = "除掉阿?高";
      ["reward"] = {
         [1] = 6414;
      };
      ["name_de"] = "Arugal muss sterben";
      ["faction"] = "Horde";
      ["name"] = "Arugal Must Die";
      ["level"] = 27;
      ["name_es"] = "Arugal debe morir";
      ["req"] = 18;
   };
   [1015] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm at the Cenarion Enclave of Darnassus about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 6761;
      ["name_fr"] = "La nouvelle frontiere";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "新的?疆";
      ["series"] = 1;
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Alliance";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1016] = {
      ["name_ru"] = "Браслеты элементалей";
      ["type"] = "Solo";
      ["objective"] = "Collect 5 Intact Elemental Bracers and use the Divining Scroll on them. Afterwards, bring the Divined Scroll to Sentinel Velene Starstrike at the Silverwind Refuge.";
      ["next"] = 1017;
      ["name_fr"] = "Les bracelets d'elementaire";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "元素?腕";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Die Ruckeroberung des Mystralsees";
      ["faction"] = "Alliance";
      ["name"] = "Elemental Bracers";
      ["level"] = 24;
      ["name_es"] = "Retomar el Lago Mystral";
      ["req"] = 20;
   };
   [1017] = {
      ["name_ru"] = "Маг-призыватель";
      ["type"] = "Solo";
      ["objective"] = "Slay Sarilus Foulborne and bring his head to Sentinel Velene Starstrike in Silverwind Refuge.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Magier-Beschworer";
      ["reward"] = {
         [1] = 5816;
      };
      ["name_cn"] = "召?者";
      ["name_fr"] = "Mage invocateur";
      ["faction"] = "Alliance";
      ["name"] = "Mage Summoner";
      ["sort"] = "Ashenvale";
      ["prev"] = 1016;
      ["prequests"] = {
         [1] = 1016;
      };
      ["level"] = 25;
      ["name_es"] = "Mago invocador";
      ["req"] = 20;
   };
   [1018] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem on the Elder Rise of Thunder Bluff about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 1123;
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "新的?疆";
      ["name_fr"] = "La nouvelle frontiere";
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Horde";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1019] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm at the Cenarion Enclave of Darnassus about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 6761;
      ["sort"] = "Ironforge";
      ["name_cn"] = "新的?疆";
      ["name_fr"] = "La nouvelle frontiere";
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Alliance";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1020] = {
      ["name_ru"] = "Лекарство Орендила";
      ["type"] = "Solo";
      ["name_fr"] = "Jouvence d'Orendil";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Orendils Heilmittel";
      ["name_cn"] = "奥雷迪?的??";
      ["name"] = "Orendil's Cure";
      ["objective"] = "Bring Orendil's Cure to Pelturas Whitemoon in Astranaar.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1010;
      ["prequests"] = {
         [1] = 1010;
      };
      ["level"] = 20;
      ["name_es"] = "Cura de Orendil";
      ["req"] = 20;
   };
   [1021] = {
      ["name_ru"] = "Сатиры коварны! Дриады в опасности!";
      ["type"] = "Solo";
      ["objective"] = "Find Anilia in Xavian.";
      ["next"] = 1031;
      ["name_fr"] = "Vil satyre?! Dryades en danger?!";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "身陷危?的?妖！";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Elende Satyrn! Die Dryaden sind in Gefahr!";
      ["faction"] = "Alliance";
      ["name"] = "Vile Satyr! Dryads in Danger!";
      ["level"] = 32;
      ["name_es"] = "!Vil satiro! !Driades en peligro!";
      ["req"] = 26;
   };
   [1022] = {
      ["name_ru"] = "Воющая Долина";
      ["type"] = "Solo";
      ["objective"] = "Go to the Howling Vale and study the Tome of Mel'Thandris, then return to Sentinel Melyria Frostshadow at Forest Song.";
      ["next"] = 1037;
      ["name_fr"] = "Le Val hurlant";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "狼?谷";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Das Heulende Tal";
      ["faction"] = "Alliance";
      ["name"] = "The Howling Vale";
      ["level"] = 30;
      ["name_es"] = "La Vega del Aullido";
      ["req"] = 25;
   };
   [1023] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["objective"] = "Find the Glowing Gem and return to Raene Wolfrunner in Astranaar with Teronis' Journal.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Der verlorene Stein";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 991;
      ["prequests"] = {
         [1] = 991;
      };
      ["level"] = 21;
      ["name_es"] = "La gema perdida";
      ["req"] = 18;
   };
   [1024] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Dryadenlieferung";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Find Shael'dryn at the moonwell to the northeast.";
      ["next"] = 1026;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1023;
      ["prequests"] = {
         [1] = 1023;
      };
      ["level"] = 21;
      ["name_es"] = "La entrega a la driade";
      ["req"] = 18;
   };
   [7172] = {
      ["name_ru"] = "Око Командования";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Das Auge der Fuhrung";
      ["name_fr"] = "L'?il du commandement";
      ["name_cn"] = "命令之眼";
      ["name"] = "The Eye of Command";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17904;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7171;
      ["prequests"] = {
         [1] = 7171;
      };
      ["level"] = 60;
      ["name_es"] = "El ojo del orden";
      ["req"] = 51;
   };
   [7364] = {
      ["name_ru"] = "Награда Гномрегана";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing tauren players in Alterac Valley.$B$BKill a tauren and return to Dirk Swindle at Dun'Baldar with a  Tauren Hoof.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?莫瑞根大通?！";
      ["name_fr"] = "Au service de Gnomeregan";
      ["name_de"] = "Gnomeregan Kopfgeld";
      ["faction"] = "Alliance";
      ["name"] = "Gnomeregan Bounty";
      ["level"] = 60;
      ["name_es"] = "La recompensa de Gnomeregan";
      ["req"] = 51;
   };
   [7428] = {
      ["name_ru"] = "Разыскивается: БОЛЬШЕ ОРКОВ!";
      ["type"] = "PvP";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "通?：更多?人！";
      ["name"] = "Wanted: MORE ORCS!";
      ["name_de"] = "GESUCHT: MEHR ORCS!";
      ["prev"] = 7402;
      ["prequests"] = {
         [1] = 7402;
      };
      ["level"] = 60;
      ["name_es"] = "Se buscan: !MAS ORCOS!";
      ["req"] = 55;
   };
   [7492] = {
      ["name_ru"] = "Лагерь Мохаче";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Talo Thornhoof at Camp Mojache in Feralas.";
      ["next"] = 7489;
      ["sort"] = "Dire Maul";
      ["name_cn"] = "莫沙??地";
      ["name_fr"] = "Camp Mojache";
      ["name_de"] = "Camp Mojache";
      ["faction"] = "Horde";
      ["name"] = "Camp Mojache";
      ["level"] = 57;
      ["name_es"] = "Campamento Mojache";
      ["req"] = 54;
   };
   [7508] = {
      ["name_ru"] = "Ковка Кель'Серрара";
      ["type"] = "Dungeon";
      ["name_fr"] = "Forger Quel'Serrar";
      ["next"] = 7509;
      ["name_de"] = "Das Schmieden von Quel'Serrar";
      ["name"] = "The Forging of Quel'Serrar";
      ["name_cn"] = "?造奎?塞拉";
      ["objective"] = "Give the Dull and Flat Elven Blade to Lorekeeper Lydros.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Dire Maul";
      ["prev"] = 7507;
      ["prequests"] = {
         [1] = 7507;
      };
      ["level"] = 60;
      ["name_es"] = "Forjar Quel'Serrar";
      ["req"] = 60;
   };
   [7604] = {
      ["name_ru"] = "Заключение договора";
      ["type"] = "Dungeon";
      ["objective"] = "Turn the Thorium Brotherhood Contract in to Lokhtos Darkbargainer if you would like to receive the plans for Sulfuron.";
      ["repgain"] = {
         [59] = 1000;
      };
      ["sort"] = "Blackrock Depths";
      ["name_fr"] = "Un contrat contraignant";
      ["name_cn"] = "瑟?兄弟会契?";
      ["reward"] = {
         [1] = 18592;
      };
      ["name_de"] = "Ein verbindlicher Vertrag";
      ["faction"] = "Horde";
      ["name"] = "A Binding Contract";
      ["level"] = 60;
      ["name_es"] = "Un contrato vinculante";
      ["req"] = 60;
   };
   [7636] = {
      ["name_ru"] = "Ветвь ходячего Древа";
      ["type"] = "Solo";
      ["name_fr"] = "Le baton des Anciens";
      ["name_de"] = "Holzstab der Uralten";
      ["objective"] = "You must find and destroy these four demonic corrupters:$B$BSimone the Seductress.$B$BKlinfran the Crazed.$B$BSolenor the Slayer.$B$BArtorius the Doombringer.$B$BDestroy these creatures and return to Vartrus the Ancient in Felwood with their heads.$B$BRefer to the Petrified Bark in your inventory for clues as to their whereabouts.$B$BYou MUST complete this task by yourself.";
      ["reward"] = {
         [1] = 18707;
      };
      ["name_cn"] = "古?的手杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Stave of the Ancients";
      ["sort"] = "Hunter";
      ["prev"] = 7632;
      ["prequests"] = {
         [1] = 7632;
      };
      ["level"] = 60;
      ["name_es"] = "El baculo de los Ancestros";
      ["req"] = 60;
   };
   [7652] = {
      ["name_ru"] = "Выгодная сделка";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 250;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Une affaire en thorium";
      ["name_cn"] = "君王板甲的???";
      ["name_de"] = "Ein Sonderangebot";
      ["faction"] = "Horde";
      ["name"] = "A Blue Light Bargain";
      ["level"] = 60;
      ["name_es"] = "Una ganga azulada";
      ["req"] = 50;
   };
   [7732] = {
      ["name_ru"] = "Донесение об улье Зукк'аш";
      ["type"] = "Solo";
      ["name_fr"] = "Le rapport sur les Zukk'ash";
      ["repgain"] = {
         [76] = 75;
         [68] = 75;
         [81] = 75;
         [530] = 75;
      };
      ["name_de"] = "Bericht uber die Zukk'ash";
      ["name_cn"] = "祖?什?告";
      ["reward"] = {
         [1] = 19038;
         [2] = 19037;
      };
      ["objective"] = "Deliver the Camp Mojache Zukk'ash Report to Zilzibin Drumlore.  He resides in the Drag of Orgrimmar.";
      ["name"] = "Zukk'ash Report";
      ["sort"] = "Feralas";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7730;
         [2] = 7731;
      };
      ["level"] = 48;
      ["name_es"] = "El informe Zukk'ash";
      ["req"] = 39;
   };
   [7796] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [72] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 7795;
      ["prequests"] = {
         [1] = 7795;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [7812] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 7811;
      ["prequests"] = {
         [1] = 7811;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [7828] = {
      ["name_ru"] = "Охота на бродяг";
      ["type"] = "Solo";
      ["objective"] = "Huntsman Markhor at Revantusk Village in the Hinterlands wants you to kill 10 Silvermane Stalkers and 10 Silvermane Howlers. Return to him once the task is complete.$B$BMarkhor mentioned that the wolves hide in the wilds of the Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "??捕?者";
      ["name_fr"] = "Traquer les traqueurs";
      ["name_de"] = "Die Pirsch auf die Pirscher";
      ["faction"] = "Horde";
      ["name"] = "Stalking the Stalkers";
      ["level"] = 48;
      ["name_es"] = "Acechar a los acechadores";
      ["req"] = 44;
   };
   [7844] = {
      ["name_ru"] = "Собратья-каннибалы";
      ["type"] = "Solo";
      ["objective"] = "Mystic Yayo'jin at Revantusk Village in the Hinterlands wants you to kill 15 Vilebranch Scalpers and 10 Vilebranch Soothsayers. Return to her when this task is complete.$B$BYayo'jin indicated that these trolls could be found near the Shaol'watha and Agol'watha temples in the north by northeastern region of the Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "野蛮的?戚";
      ["name_fr"] = "Les cousins cannibales";
      ["name_de"] = "Kannibalistische Vettern";
      ["faction"] = "Horde";
      ["name"] = "Cannibalistic Cousins";
      ["level"] = 48;
      ["name_es"] = "Unos primos canibales";
      ["req"] = 44;
   };
   [7876] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_fr"] = "Ecrasez les usurpateurs d'Aile-argent";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 55;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 50;
   };
   [7892] = {
      ["name_ru"] = "Большая черная палица";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Grande masse noire";
      ["name_cn"] = "巨型黑色?";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Groser schwarzer Streitkolben";
      ["faction"] = "Horde";
      ["name"] = "Big Black Mace";
      ["level"] = 60;
      ["name_es"] = "Maza negra grande";
      ["req"] = 30;
   };
   [7924] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["name_fr"] = "Marque d'honneur";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["objective"] = "You obtained a Warsong Mark of Honor for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["name_de"] = "Ehrenabzeichen";
      ["prev"] = 7874;
      ["prequests"] = {
         [1] = 7874;
      };
      ["level"] = 35;
      ["name_es"] = "Marca de Honor";
      ["req"] = 30;
   };
   [7940] = {
      ["name_ru"] = "1200 билетов ? сфера Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "1200 bons - Orbe de la Sombrelune";
      ["name_cn"] = "1200??券 - 暗月宝珠";
      ["reward"] = {
         [1] = 19426;
      };
      ["name_de"] = "1200 Lose - Kugel des Dunkelmonds";
      ["faction"] = "Horde";
      ["name"] = "1200 Tickets - Orb of the Darkmoon";
      ["level"] = 60;
      ["name_es"] = "1200 vales: orbe de la Luna Negra";
      ["req"] = 55;
   };
   [8052] = {
      ["name_ru"] = "Всевидящее Око Зулдазара";
      ["objective"] = "";
      ["name_cn"] = "祖??全?之眼";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "L'Oeil omnivoyant de Zuldazar";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Das allsehende Auge von Zuldazar";
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "The All-Seeing Eye of Zuldazar";
      ["prev"] = 8051;
      ["prequests"] = {
         [1] = 8051;
      };
      ["reward"] = {
         [1] = 19594;
      };
      ["name_es"] = "El Ojo que todo lo ve de Zuldazar";
      ["req"] = 60;
   };
   [8068] = {
      ["name_ru"] = "Знаки Силы: оплечье мастера иллюзий";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Shawl.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: le mantelet d’illusionniste";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：幻???肩";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 19845;
      };
      ["name_de"] = "Symbole der Macht: Der Mantel des Illusionisten";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Illusionist's Mantle";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Manto de ilusionista";
      ["req"] = 60;
   };
   [8116] = {
      ["name_ru"] = "Ожерелье видений Вудресса";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Vision de Voodress";
      ["name_cn"] = "巫毒幻象";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19606;
      };
      ["name_de"] = "Vision von Voodress";
      ["faction"] = "Horde";
      ["name"] = "Vision of Voodress";
      ["level"] = 60;
      ["name_es"] = "Vision de Voodress";
      ["req"] = 60;
   };
   [8148] = {
      ["name_ru"] = "Ярость Водоворота";
      ["objective"] = "";
      ["name_cn"] = "??之怒";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le courroux du maelstrom";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Mahlstroms Zorn";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "The Maelstrom's Wrath";
      ["prev"] = 8147;
      ["prequests"] = {
         [1] = 8147;
      };
      ["reward"] = {
         [1] = 19621;
      };
      ["name_es"] = "Colera de La Voragine";
      ["req"] = 60;
   };
   [8164] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["faction"] = "Horde";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8161;
      ["prequests"] = {
         [1] = 8161;
      };
      ["level"] = 35;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 30;
   };
   [4101] = {
      ["name_ru"] = "Очищение Оскверненного леса";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Blood Amber to Arathandris Silversky in Felwood.";
      ["sort"] = "Felwood";
      ["name_cn"] = "?化?伍德";
      ["name_fr"] = "Purifiez Gangrebois";
      ["name_de"] = "Den Teufelswald saubern";
      ["faction"] = "Alliance";
      ["name"] = "Cleansing Felwood";
      ["level"] = 55;
      ["name_es"] = "Limpiar Frondavil";
      ["req"] = 48;
   };
   [8232] = {
      ["name_ru"] = "Зеленый дракон";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le drake vert";
      ["name_de"] = "Der grune Drache";
      ["objective"] = "Bring the Tooth of Morphaz to Ogtinc in Azshara.  Ogtinc resides atop the cliffs northeast the Ruins of Eldarath.";
      ["reward"] = {
         [1] = 20083;
         [2] = 19991;
         [3] = 19992;
      };
      ["name_cn"] = "神?中的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "The Green Drake";
      ["sort"] = "Hunter";
      ["prev"] = 8231;
      ["prequests"] = {
         [1] = 8231;
      };
      ["level"] = 52;
      ["name_es"] = "El draco verde";
      ["req"] = 50;
   };
   [8264] = {
      ["name_ru"] = "Стандартный полевой комплект Осквернителей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [510] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Le paquetage ordinaire de profanateur";
      ["name_cn"] = "?染者?准医?包";
      ["reward"] = {
         [1] = 20230;
      };
      ["name_de"] = "Standarduberlebenspaket der Entweihten";
      ["faction"] = "Horde";
      ["name"] = "Defiler's Standard Care Package";
      ["level"] = 44;
      ["name_es"] = "Botiquin normal de Rapinador";
      ["req"] = 35;
   };
   [8296] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [889] = 75;
      };
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["name_de"] = "Ehrenabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["level"] = 15;
      ["name_es"] = "Marca de Honor";
      ["req"] = 10;
   };
   [4181] = {
      ["name_ru"] = "Гоблинское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Goblin Engineering, take the Manual of Engineering Disciplines to Nixx Sprocketspring in Gadgetzan.";
      ["sort"] = "Engineering";
      ["name_cn"] = "地精工程学";
      ["name_fr"] = "Ingenierie des gobelins";
      ["followup"] = 3638;
      ["name_de"] = "Gobliningenieurskunst";
      ["faction"] = "Alliance";
      ["name"] = "Goblin Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria goblin";
      ["req"] = 30;
   };
   [8392] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 50;
      };
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["prev"] = 8394;
      ["prequests"] = {
         [1] = 8394;
      };
      ["level"] = 49;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 40;
   };
   [8424] = {
      ["name_ru"] = "Война против Приверженцев Тени";
      ["type"] = "Solo";
      ["name_fr"] = "La guerre contre les liges d'ombre";
      ["next"] = 8425;
      ["name_de"] = "Krieg den Schattenanbetern";
      ["objective"] = "Slaughter the Shadowsworn in the Blasted Lands and return to the Fallen Hero of the Horde.";
      ["name_cn"] = "魔誓者之?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "War on the Shadowsworn";
      ["prev"] = 8423;
      ["prequests"] = {
         [1] = 8423;
      };
      ["level"] = 52;
      ["name_es"] = "La guerra contra los Sombra Jurada";
      ["req"] = 50;
   };
   [4245] = {
      ["name_ru"] = "В поисках Чи-Та 3";
      ["type"] = "Solo";
      ["name_fr"] = "A la poursuite d'A-mi 01";
      ["name_de"] = "Chasing A-Me 01";
      ["name_cn"] = "找回A-Me 01";
      ["objective"] = " you prepare to see what happens when you flip the switch back to the \"On\" position.$B$BThis is your last chance... are you sure this is what you want to do?\"";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Chasing A-Me 01";
      ["prev"] = 4244;
      ["prequests"] = {
         [1] = 4244;
      };
      ["level"] = 53;
      ["name_es"] = "Buscando a Memo 01";
      ["req"] = 48;
   };
   [4261] = {
      ["name_ru"] = "Древний дух";
      ["type"] = "Solo";
      ["objective"] = "Escort Arei to safety, then speak with Kayneth Stillwind in Forest Song, in eastern Ashenvale.";
      ["repgain"] = {
         [47] = 150;
         [69] = 350;
      };
      ["name_de"] = "Alter Geist";
      ["reward"] = {
         [1] = 11873;
         [2] = 11874;
      };
      ["name_cn"] = "?古之?";
      ["name_fr"] = "Esprit d'un ancien";
      ["faction"] = "Alliance";
      ["name"] = "Ancient Spirit";
      ["sort"] = "Felwood";
      ["prev"] = 4442;
      ["prequests"] = {
         [1] = 4442;
      };
      ["level"] = 56;
      ["name_es"] = "El espiritu de un Ancestro";
      ["req"] = 49;
   };
   [2139] = {
      ["name_ru"] = "Надежда Тарнариуна";
      ["type"] = "Solo";
      ["objective"] = "Find and kill the Den Mother.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Tharnariuns Hoffnung";
      ["reward"] = {
         [1] = 7738;
         [2] = 7739;
      };
      ["name_cn"] = "??瑞恩的希望";
      ["name_fr"] = "Espoir de Tharnariun";
      ["faction"] = "Alliance";
      ["name"] = "Tharnariun's Hope";
      ["sort"] = "Darkshore";
      ["prev"] = 2138;
      ["prequests"] = {
         [1] = 2138;
      };
      ["level"] = 18;
      ["name_es"] = "La esperanza de Tharnariun";
      ["req"] = 10;
   };
   [8584] = {
      ["name_ru"] = "Никогда не расспрашивай меня о моем бизнесе!";
      ["type"] = "Solo";
      ["name_fr"] = "On ne parle jamais de mon boulot";
      ["next"] = 8585;
      ["name_de"] = "Fragt mich nie nach meinen Angelegenheiten";
      ["name_cn"] = "少管?事";
      ["objective"] = "Narain Soothfancy in Tanaris wants you to speak with Dirge Quikcleave in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Never Ask Me About My Business";
      ["prev"] = 8576;
      ["prequests"] = {
         [1] = 8576;
      };
      ["level"] = 60;
      ["name_es"] = "!Nunca me preguntes por mi negocio!";
      ["req"] = 60;
   };
   [8616] = {
      ["name_ru"] = "Орде все еще не хватает запеченного лосося!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Baked Salmon to Chief Sharpclaw at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr gebackenen Lachs!";
      ["name_fr"] = "La Horde a besoin de plus de pains de saumon !";
      ["name_cn"] = "部落需要更多???！";
      ["name"] = "The Horde Needs More Baked Salmon!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8615;
      ["prequests"] = {
         [1] = 8615;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas salmon asado!";
      ["req"] = 1;
   };
   [8648] = {
      ["name_ru"] = "Предок Черносерд";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Sombre-noyau";
      ["name_cn"] = "暗??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Dunkelherz";
      ["faction"] = "Horde";
      ["name"] = "Darkcore the Elder";
      ["level"] = 60;
      ["name_es"] = "Cuoreoscuro el Ancestro";
      ["req"] = 1;
   };
   [4341] = {
      ["name_ru"] = "Каран Могучий Молот";
      ["type"] = "Dungeon";
      ["name_fr"] = "Kharan Force-martel";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Kharan Hammermacht";
      ["name_cn"] = "??・巨?";
      ["name"] = "Kharan Mighthammer";
      ["objective"] = "Travel to Blackrock Depths and find Kharan Mighthammer.$B$BThe King mentioned that Kharan was being held prisoner there - perhaps you should try looking for a prison.";
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 3701;
      ["prequests"] = {
         [1] = 3701;
      };
      ["level"] = 59;
      ["name_es"] = "Kharan Martillo Poderoso";
      ["req"] = 50;
   };
   [8712] = {
      ["name_ru"] = "Коса Незримого пути";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Spiked Hilt, 2 Azure Idols, 5 Silver Scarabs and 5 Bone Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La faux du sentier invisible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?秘通途之?";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21401;
      };
      ["name_de"] = "Sense des unsichtbaren Pfads";
      ["faction"] = "Horde";
      ["name"] = "Scythe of the Unseen Path";
      ["level"] = 60;
      ["name_es"] = "La guadana de la senda oculta";
      ["req"] = 60;
   };
   [8744] = {
      ["name_ru"] = "Тщательно завернутый подарок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un cadeau soigneusement emballe";
      ["name_cn"] = "精心包裹的礼物";
      ["reward"] = {
         [1] = 21191;
      };
      ["name_de"] = "Ein sorgfaltig verpacktes Geschenk";
      ["faction"] = "Horde";
      ["name"] = "A Carefully Wrapped Present";
      ["level"] = 1;
      ["name_es"] = "Un presente envuelto con cuidado";
      ["req"] = 1;
   };
   [8776] = {
      ["name_ru"] = "Цель: поработители из Улья Регал";
      ["type"] = "Group";
      ["objective"] = "Kill 30 Hive'Regal Slavemakers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing X in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les esclavagistes de la Ruche'Regal";
      ["name_cn"] = "目?：雷戈制奴者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Sklavenjager des Regalschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Regal Slavemakers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los esclavizadores Colmen'Regal";
      ["req"] = 60;
   };
   [8808] = {
      ["name_ru"] = "Поставки формы";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Mooncloth, 2 Bolts of Runecloth and 1 Ironweb Spider Silk to Windcaller Proudhorn at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing VIII in order to complete this quest.";
      ["name_fr"] = "La question des uniformes";
      ["sort"] = "Silithus";
      ["name_cn"] = "制服供?";
      ["reward"] = {
         [1] = 20800;
         [2] = 21266;
      };
      ["name_de"] = "Uniformnachschub";
      ["faction"] = "Horde";
      ["name"] = "Uniform Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros para uniformes";
      ["req"] = 60;
   };
   [8840] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8816;
      ["prequests"] = {
         [1] = 8816;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8872] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger at the Cenarion Enclave in Darnassus.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Alliance";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [8904] = {
      ["name_ru"] = "Опасная любовь";
      ["type"] = "Solo";
      ["objective"] = "Get a Guardian's Moldy Card and bring it to Fenstad Argyle in the Undercity.";
      ["next"] = 8979;
      ["name_cn"] = "危?的?情";
      ["sort"] = "Hallow's End";
      ["name_de"] = "Gefahrliche Liebschaft";
      ["faction"] = "Horde";
      ["name"] = "Dangerous Love";
      ["level"] = 0;
      ["name_es"] = "Amor peligroso";
      ["req"] = 1;
   };
   [8936] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Dreadmist Belt and a set of Dreadmist Wraps to Deliana in Ironforge.";
      ["name_cn"] = "小小的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22070;
         [2] = 22077;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8968] = {
      ["name_ru"] = "Левая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau gauche de l'amulette du seigneur Valthalak";
      ["next"] = 8970;
      ["name_de"] = "Das linke Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth Jarien and Sothos and slay them. Return to Bodley inside Blackrock Mountain with the Left Piece of Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦?拉克?符的左半?";
      ["sort"] = "Stratholme";
      ["faction"] = "Horde";
      ["name"] = "The Left Piece of Lord Valthalak's Amulet";
      ["followup"] = 8970;
      ["prev"] = 8964;
      ["prequests"] = {
         [1] = 8964;
      };
      ["level"] = 60;
      ["name_es"] = "La parte izquierda del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [4501] = {
      ["name_ru"] = "Опасайся терродактилей";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Pterrordax and 15 Frenzied Pterrordax, then speak to Spraggle Frock at Marshal's Refuge.";
      ["name_fr"] = "Attention aux pterreurdactyles";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "当心翼手?";
      ["reward"] = {
         [1] = 11918;
         [2] = 11919;
      };
      ["name_de"] = "Vorsicht, Pterrordax!";
      ["faction"] = "Horde";
      ["name"] = "Beware of Pterrordax";
      ["level"] = 55;
      ["name_es"] = "Cuidado con los pterrordactilos";
      ["req"] = 49;
   };
   [2259] = {
      ["name_ru"] = "Эрион Шепот Тени";
      ["type"] = "Solo";
      ["name_fr"] = "Erion Murmombre";
      ["next"] = 2260;
      ["name_de"] = "Erion Schattenflusterer";
      ["objective"] = "Contact Erion Shadewhisper in Darnassus.$B";
      ["name_cn"] = "艾瑞安・影?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Erion Shadewhisper";
      ["prev"] = 2241;
      ["prequests"] = {
         [1] = 2241;
      };
      ["level"] = 16;
      ["name_es"] = "Erion Sombrusurro";
      ["req"] = 16;
   };
   [9096] = {
      ["name_ru"] = "Поножи ледяного огня";
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres de givrefeu";
      ["name_de"] = "Frostfeuergamaschen";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make Frostfire Leggings if you bring her the following: 1 Desecrated Leggings, 20 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22497;
      };
      ["name_cn"] = "霜火?腿";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Frostfire Leggings";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Los leotardos de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9128] = {
      ["name_ru"] = "Уравнение стихий";
      ["type"] = "Solo";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands wants 30 Core of Elements.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "L'equation elementaire";
      ["name_cn"] = "元素交易";
      ["reward"] = {
         [1] = 22523;
      };
      ["name_de"] = "Die Elementargleichung";
      ["faction"] = "Horde";
      ["name"] = "The Elemental Equation";
      ["level"] = 60;
      ["name_es"] = "La ecuacion elemental";
      ["req"] = 55;
   };
   [4581] = {
      ["name_ru"] = "Кайнет Штиль";
      ["type"] = "Solo";
      ["objective"] = "Take Shindrell's Note to Kayneth Stillwind in Forest Song.";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_fr"] = "Kayneth Mortebrise";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "?尼斯・静?";
      ["name_de"] = "Kayneth Stillwind";
      ["faction"] = "Alliance";
      ["name"] = "Kayneth Stillwind";
      ["level"] = 29;
      ["name_es"] = "Kayneth Ventoleve";
      ["req"] = 24;
   };
   [2299] = {
      ["name_ru"] = "К Хальфдану!";
      ["type"] = "Solo";
      ["name_fr"] = "Cap sur Hulfdan !";
      ["next"] = 2298;
      ["name_de"] = "Auf Hulfdan!";
      ["objective"] = "Travel to Ironforge and speak with Hulfdan Blackbeard.";
      ["name_cn"] = "去找霍夫丹！";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "To Hulfdan!";
      ["prev"] = 2218;
      ["prequests"] = {
         [1] = 2218;
      };
      ["level"] = 16;
      ["name_es"] = "!Ve a hablar con Hulfdan!";
      ["req"] = 16;
   };
   [9224] = {
      ["name_ru"] = "Легендарное снаряжение ? Уважаемый Рассветом";
      ["type"] = "Solo";
      ["objective"] = "For 75 Insignias of the Dawn and 75 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille epiques - Honore aupres de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "史??的作?装? - ?色黎明尊敬";
      ["reward"] = {
         [1] = 22657;
         [2] = 22667;
         [3] = 22668;
         [4] = 22659;
         [5] = 22678;
         [6] = 22656;
      };
      ["name_de"] = "Epische Kampfausrustung - Wohlwollen der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Epic Armaments of Battle - Honored Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento epico de batalla: honorable con El Alba";
      ["req"] = 55;
   };
   [9320] = {
      ["name_ru"] = "Гигантский флакон с зельем маны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_fr"] = "Potion de mana majeure";
      ["name_cn"] = "?效法力?水";
      ["reward"] = {
         [1] = 13444;
      };
      ["name_de"] = "Erstklassiger Manatrank";
      ["faction"] = "Horde";
      ["name"] = "Major Mana Potion";
      ["level"] = 60;
      ["name_es"] = "Superpocion de mana";
      ["req"] = 55;
   };
   [2339] = {
      ["name_ru"] = "Найти самоцветы и источник энергии";
      ["type"] = "Dungeon";
      ["name_fr"] = "Trouver les gemmes et la source d'energie";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Findet die Edelsteine und die Kraftquelle";
      ["name_cn"] = "?找宝?";
      ["name"] = "Find the Gems and Power Source";
      ["objective"] = "Recover all three gems and a power source for the necklace from Uldaman, and then bring them to Jarkal Mossmeld in Kargath.  Jarkal believes a power source might be found on the strongest construct present in Uldaman.$B$BFrom the journal, you know...$B* The ruby has been stashed in a barricaded Shadowforge area.$B* The topaz has been hidden in an urn in one of the Trogg areas, near some Alliance dwarves.$B* The sapphire has been claimed by Grimlok, the trogg leader.";
      ["faction"] = "Horde";
      ["sort"] = "Uldaman";
      ["prev"] = 2338;
      ["prequests"] = {
         [1] = 2338;
      };
      ["level"] = 44;
      ["name_es"] = "Encuentra las gemas y la fuente de alimentacion";
      ["req"] = 37;
   };
   [9416] = {
      ["name_ru"] = "Генерал Кирика";
      ["type"] = "Solo";
      ["objective"] = "Speak with General Kirika at the Horde encampment near Hive'Regal.";
      ["next"] = 9422;
      ["sort"] = "Silithus";
      ["name_cn"] = "向吉里?将??到";
      ["name_fr"] = "Se presenter au general Kirika";
      ["name_de"] = "Meldung bei General Kirika";
      ["faction"] = "Horde";
      ["name"] = "Report to General Kirika";
      ["level"] = 60;
      ["name_es"] = "Presentate ante el general Kirika";
      ["req"] = 53;
   };
   [4725] = {
      ["name_ru"] = "Останки морской черепахи";
      ["type"] = "Solo";
      ["name_fr"] = "La tortue de mer echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meeresschildkrote";
      ["name_cn"] = "?浅的海?";
      ["name"] = "Beached Sea Turtle";
      ["objective"] = "Take the Strangely Marked Box to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 15;
      ["name_es"] = "Tortuga marina varada";
      ["req"] = 12;
   };
   [4741] = {
      ["name_ru"] = "Одичавшие стражи";
      ["objective"] = "Trull Failbane in Felwood wants you to hunt 13 Moontouched Owlbeasts.";
      ["name_cn"] = "冬泉谷的??";
      ["sort"] = "Felwood";
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Les gardiens sauvages";
      ["next"] = 4721;
      ["name_de"] = "Wilde Wachter";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Wild Guardians";
      ["prev"] = 4521;
      ["prequests"] = {
         [1] = 4521;
      };
      ["series"] = 2;
      ["name_es"] = "Guardianes salvajes";
      ["req"] = 52;
   };
   [2379] = {
      ["name_ru"] = "Зандо'зан";
      ["type"] = "Solo";
      ["objective"] = "Speak with Zando'zan at the Cleft of Shadow.";
      ["next"] = 2382;
      ["name_fr"] = "Zando'zan";
      ["sort"] = "Rogue";
      ["name_cn"] = "?杜沙";
      ["name"] = "Zando'zan";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name_de"] = "Zando'zan";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2380;
         [2] = 2378;
      };
      ["level"] = 16;
      ["name_es"] = "Zando'zan";
      ["req"] = 16;
   };
   [4805] = {
      ["name_ru"] = "Э'ко йети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Eisdistelyetis";
      ["name_fr"] = "L'E'ko des Chardon de Glace";
      ["name_cn"] = "冰草魂精";
      ["name"] = "Ice Thistle E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12459;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko de los Cardo Nevado";
      ["req"] = 55;
   };
   [4821] = {
      ["name_ru"] = "Странное яйцо";
      ["type"] = "Solo";
      ["objective"] = "Return the Alien Egg to Hagar Lightninghoof in Freewind Post.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "L'?uf etrange";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "?型卵";
      ["name_de"] = "Fremdartiges Ei";
      ["faction"] = "Horde";
      ["name"] = "Alien Egg";
      ["level"] = 26;
      ["name_es"] = "Un huevo extrano";
      ["req"] = 24;
   };
   [4901] = {
      ["name_ru"] = "Стражи алтаря";
      ["type"] = "Solo";
      ["name_fr"] = "Les gardiens de l'autel";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Wachter des Altars";
      ["name_cn"] = "祭?守?者";
      ["name"] = "Guardians of the Altar";
      ["objective"] = "Protect Ranshalla while she attempts to reactivate the Altar of Elune. Report your findings to Erelas Ambersky in Rut'theran Village.";
      ["faction"] = "Alliance";
      ["sort"] = "Winterspring";
      ["prev"] = 979;
      ["prequests"] = {
         [1] = 979;
      };
      ["level"] = 59;
      ["name_es"] = "Guardianes del altar";
      ["req"] = 52;
   };
   [2459] = {
      ["name_ru"] = "Фероситас Пожиратель Снов";
      ["type"] = "Solo";
      ["name_fr"] = "Ferocitas le Mangeur de reves";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Ferocitas der Traumfresser";
      ["name_cn"] = "噬梦者菲?斯塔";
      ["name"] = "Ferocitas the Dream Eater";
      ["objective"] = "Tallonkai Swiftroot in Dolanaar wants you to kill 7 Gnarlpine Mystics and find the Missing Jewel.";
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 2438;
      ["prequests"] = {
         [1] = 2438;
      };
      ["level"] = 8;
      ["name_es"] = "Ferocitas el Comesuenos";
      ["req"] = 1;
   };
   [4965] = {
      ["name_ru"] = "Знание шара Орахила";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1799;
      ["sort"] = "Warlock";
      ["name_cn"] = "奥拉赫宝珠";
      ["name_fr"] = "Connaissance de l'Orbe d'Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Wissen der Kugel von Orahil";
      ["faction"] = "Alliance";
      ["name"] = "Knowledge of the Orb of Orahil";
      ["level"] = 35;
      ["name_es"] = "El conocimiento del orbe de Orahil";
      ["req"] = 35;
   };
   [4981] = {
      ["name_ru"] = "Агент Блестяшка";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Spire and find out what happened to Bijou.";
      ["next"] = 4982;
      ["name_fr"] = "Agent Bijou";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "狡猾的比修";
      ["repgain"] = {
         [21] = 250;
      };
      ["name_de"] = "Agentin Bijou";
      ["faction"] = "Horde";
      ["name"] = "Operative Bijou";
      ["level"] = 59;
      ["name_es"] = "La espia Bijou";
      ["req"] = 55;
   };
   [2499] = {
      ["name_ru"] = "Дубохмур";
      ["type"] = "Group";
      ["objective"] = "Denalan at Lake Al'Ameth wants you to collect the Gargantuan Tumor from Oakenscowl.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Grimmeiche";
      ["reward"] = {
         [1] = 5458;
         [2] = 5589;
      };
      ["name_cn"] = "奥肯斯古?";
      ["name_fr"] = "Froncechene";
      ["faction"] = "Alliance";
      ["name"] = "Oakenscowl";
      ["sort"] = "Teldrassil";
      ["prev"] = 2498;
      ["prequests"] = {
         [1] = 2498;
      };
      ["level"] = 9;
      ["name_es"] = "Robleguello";
      ["req"] = 4;
   };
   [5045] = {
      ["name_ru"] = "Высокий дух";
      ["type"] = "Solo";
      ["name_fr"] = "L'essor de l'esprit";
      ["sort"] = "The Barrens";
      ["name_cn"] = "高?的士气";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Rising Spirit";
      ["name_de"] = "Steigerung des Geistes";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "Fortaleza de espiritu";
      ["req"] = 14;
   };
   [5061] = {
      ["name_ru"] = "Водный облик";
      ["objective"] = "Return to Darnassus and show Mathrengyl Bearwalker the Pendant of the Sea Lion.";
      ["name_cn"] = "水栖形?";
      ["sort"] = "Druid";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Forme aquatique";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Wassergestalt";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Aquatic Form";
      ["prev"] = 272;
      ["prequests"] = {
         [1] = 272;
      };
      ["reward"] = {
         [1] = 16608;
      };
      ["name_es"] = "Forma acuatica";
      ["req"] = 16;
   };
   [5093] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out High Executor Derrington.  His base camp is located at the Bulwark, east of Tirisfal Glade and the Undercity.";
      ["next"] = 5096;
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["followup"] = 5096;
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Horde";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [5125] = {
      ["name_ru"] = "Слова Аурия";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Aurius' Abrechnung";
      ["name_fr"] = "La retribution d'Aurius";
      ["name_cn"] = "奥里克斯的清算";
      ["name"] = "Aurius' Reckoning";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17044;
         [2] = 17045;
      };
      ["sort"] = "Stratholme";
      ["prev"] = 5122;
      ["prequests"] = {
         [1] = 5122;
      };
      ["level"] = 60;
      ["name_es"] = "La estimacion de Aurius";
      ["req"] = 55;
   };
   [5141] = {
      ["name_ru"] = "Кожевничество: чешуя дракона";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Tough Scorpid Breastplates, 2 Tough Scorpid Gloves, and 10 Worn Dragonscales to Peter Galen in Azshara.$B$BCompleting this quest will give you access to the Dragonscale Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Elemental Leatherworking and Tribal Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "??制皮";
      ["name_fr"] = "Travail du cuir de dragon";
      ["name_de"] = "Drachenlederverarbeitung";
      ["faction"] = "Alliance";
      ["name"] = "Dragonscale Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria dragontina";
      ["req"] = 40;
   };
   [5157] = {
      ["name_ru"] = "Собрать оскверненную воду";
      ["type"] = "Solo";
      ["name_fr"] = "Recueillir de l'eau souillee";
      ["next"] = 5158;
      ["name_de"] = "Verderbtes Wasser sammeln";
      ["name_cn"] = "收集堕落之水";
      ["objective"] = "Take the Empty Canteen to the Moon Well in the center of Jaedenar and fill it before returning to Greta Mosshoof in Felwood.";
      ["sort"] = "Felwood";
      ["faction"] = "Horde";
      ["name"] = "Collection of the Corrupt Water";
      ["prev"] = 5155;
      ["prequests"] = {
         [1] = 5155;
      };
      ["level"] = 52;
      ["name_es"] = "Una muestra de agua corrupta";
      ["req"] = 48;
   };
   [2603] = {
      ["name_ru"] = "Стойкость стервятника";
      ["type"] = "Solo";
      ["objective"] = "Bring ten Vulture Gizzards and two Snickerfang Jowls to Bloodmage Lynnore.$B";
      ["name_fr"] = "La vigueur du vautour";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "??的活力";
      ["reward"] = {
         [1] = 8424;
      };
      ["name_de"] = "Lebensenergie des Geiers";
      ["faction"] = "Horde";
      ["name"] = "Vulture's Vigor";
      ["level"] = 50;
      ["name_es"] = "El vigor del buitre";
      ["req"] = 45;
   };
   [5221] = {
      ["name_ru"] = "Котел Слез Далсона";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["name_de"] = "Der Kessel von Dalsons Tranenfeld";
      ["name_cn"] = "??松之泪的瘟疫之?";
      ["name_fr"] = "Le chaudron des Larmes de Dalson";
      ["name"] = "Dalson's Tears Cauldron";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5237;
      ["prequests"] = {
         [1] = 5237;
      };
      ["level"] = 55;
      ["name_es"] = "La caldera del Llanto de Dalson";
      ["req"] = 50;
   };
   [5237] = {
      ["name_ru"] = "Задание выполнено!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 500;
         [529] = 500;
      };
      ["name_de"] = "Mission erfullt!";
      ["name_fr"] = "Mission accomplie?!";
      ["name_cn"] = "任?完成！";
      ["faction"] = "Horde";
      ["name"] = "Mission Accomplished!";
      ["reward"] = {
         [1] = 15801;
         [2] = 15799;
         [3] = 15800;
      };
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5236;
      ["prequests"] = {
         [1] = 5236;
      };
      ["level"] = 58;
      ["name_es"] = "!Mision cumplida!";
      ["req"] = 50;
   };
   [5253] = {
      ["name_ru"] = "Кристалл Зин-Малора";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Crystal of Zin-Malor to Arch Druid Fandral Staghelm in Darnassus.";
      ["repgain"] = {
         [69] = 250;
         [54] = 250;
         [72] = 250;
         [47] = 250;
      };
      ["name_de"] = "Der Kristall von Zin-Malor";
      ["reward"] = {
         [1] = 15791;
         [2] = 15792;
         [3] = 15795;
      };
      ["name_cn"] = "辛?洛水晶";
      ["name_fr"] = "Le Cristal de Zin-Malor";
      ["faction"] = "Alliance";
      ["name"] = "The Crystal of Zin-Malor";
      ["sort"] = "Winterspring";
      ["prev"] = 5252;
      ["prequests"] = {
         [1] = 5252;
      };
      ["level"] = 58;
      ["name_es"] = "El cristal de Zin-Malor";
      ["req"] = 53;
   };
   [5301] = {
      ["name_ru"] = "Искусство изготовления брони";
      ["type"] = "Solo";
      ["objective"] = "To become an armorsmith, you must make the following items and return them to Okothos: 4 Ornate Mithril Helms, 2 Ornate Mithril Boots, 1 Ornate Mithril Breastplate.";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "?造?甲的??";
      ["name_fr"] = "L'art de l'armurier";
      ["name_de"] = "Die Kunst des Rustungsschmiedes";
      ["faction"] = "Horde";
      ["name"] = "The Art of the Armorsmith";
      ["level"] = 40;
      ["name_es"] = "El arte del forjador de armaduras";
      ["req"] = 40;
   };
   [5381] = {
      ["name_ru"] = "Рука Ируксоса";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Demon Box from Thunder Axe Fortress, and return it, along with the Demon Pick to Taiga Wisemane in Shadowprey Village.$B";
      ["next"] = 5581;
      ["name_fr"] = "La Main d'Iruxos";
      ["sort"] = "Desolace";
      ["name_cn"] = "埃?索斯之手";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Hand von Iruxos";
      ["faction"] = "Horde";
      ["name"] = "Hand of Iruxos";
      ["level"] = 38;
      ["name_es"] = "La Mano de Iruxos";
      ["req"] = 32;
   };
   [5461] = {
      ["name_ru"] = "Рас Ледяной Шепот ? человек";
      ["type"] = "Group";
      ["name_fr"] = "L'humain, Ras Murmegivre";
      ["next"] = 5462;
      ["name_de"] = "Der Mensch Ras Frostraunen";
      ["name_cn"] = "莱斯・霜?";
      ["objective"] = "Travel to the Arathi Highlands, to the ruins of Stromgarde. Search Stromgarde for a Keepsake of Remembrance. If you find such an item, return with it to Magistrate Marduke.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "The Human, Ras Frostwhisper";
      ["prev"] = 5384;
      ["prequests"] = {
         [1] = 5384;
      };
      ["level"] = 60;
      ["name_es"] = "El humano, Ras Murmuhielo";
      ["req"] = 57;
   };
   [2747] = {
      ["name_ru"] = "Необычное яйцо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 10;
         [69] = 10;
      };
      ["name_de"] = "Ein ausergewohnliches Ei";
      ["name_fr"] = "Un ?uf extraordinaire";
      ["name_cn"] = "特?的蛋";
      ["faction"] = "Horde";
      ["name"] = "An Extraordinary Egg";
      ["reward"] = {
         [1] = 9541;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 2741;
      ["prequests"] = {
         [1] = 2741;
      };
      ["level"] = 60;
      ["name_es"] = "Un huevo muy especial";
      ["req"] = 42;
   };
   [2755] = {
      ["name_ru"] = "Радости Омоша";
      ["type"] = "Solo";
      ["name_fr"] = "Les joies des Omosh";
      ["name_de"] = "Freude der Omoshs";
      ["reward"] = {
         [1] = 7982;
      };
      ["name_cn"] = "沃姆什的喜悦";
      ["objective"] = "Watch and learn the Omosh Dance of Joy.";
      ["faction"] = "Horde";
      ["name"] = "Joys of Omosh";
      ["sort"] = "Blacksmithing";
      ["prev"] = 2754;
      ["prequests"] = {
         [1] = 2754;
      };
      ["level"] = 36;
      ["name_es"] = "Las alegrias de los Omosh";
      ["req"] = 32;
   };
   [2763] = {
      ["name_ru"] = "Могущество камней";
      ["type"] = "Solo";
      ["name_fr"] = "L'art de l'impregnation";
      ["name_de"] = "Die Kunst der Magieerfullung";
      ["objective"] = "Bring forty Mithril Bars and four Citrines to Galvan the Ancient in Stranglethorn.";
      ["followup"] = 2765;
      ["name_cn"] = "灌魔工?";
      ["faction"] = "Horde";
      ["name"] = "The Art of the Imbue";
      ["reward"] = {
         [1] = 7985;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "El arte de imbuir";
      ["req"] = 40;
   };
   [5541] = {
      ["name_ru"] = "Боеприпасы для Громострела";
      ["type"] = "Solo";
      ["objective"] = "Bring Rumbleshot's Ammo to Hegnar Rumbleshot in Dun Morogh.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_fr"] = "Munitions pour Grondetrait";
      ["sort"] = "Dun Morogh";
      ["name_cn"] = "海格?的??";
      ["name_de"] = "Munition fur Schlingerschuss";
      ["faction"] = "Alliance";
      ["name"] = "Ammo for Rumbleshot";
      ["level"] = 6;
      ["name_es"] = "Municiones para Estruendo";
      ["req"] = 5;
   };
   [5621] = {
      ["name_ru"] = "Облачение Луны";
      ["type"] = "Solo";
      ["name_fr"] = "Vetements de la lune";
      ["name_de"] = "Gewander des Mondes";
      ["sort"] = "Priest";
      ["objective"] = "Find Sentinel Shaya and heal her wounds using Lesser Heal (Rank 2). Afterwards, grant her Power Word: Fortitude and then return to Laurna Morninglight in Dolanaar.";
      ["name_cn"] = "月光之衣";
      ["name"] = "Garments of the Moon";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 16604;
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 5622;
      ["prequests"] = {
         [1] = 5622;
      };
      ["level"] = 4;
      ["name_es"] = "Prendas de la luna";
      ["req"] = 5;
   };
   [5637] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["sort"] = "Priest";
      ["name_cn"] = "?望祷言";
      ["name_fr"] = "Priere du desespoir";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [2843] = {
      ["name_ru"] = "Поехалиии!";
      ["type"] = "Dungeon";
      ["name_fr"] = "Gnomer-paaarti?!";
      ["name_de"] = "Gnomer-weeeeg!";
      ["reward"] = {
         [1] = 9173;
      };
      ["name_cn"] = "出?！?莫瑞根！";
      ["objective"] = "Wait for Scooty to calibrate the Goblin Transponder.";
      ["faction"] = "Horde";
      ["name"] = "Gnomer-gooooone!";
      ["sort"] = "Gnomeregan";
      ["prev"] = 2842;
      ["prequests"] = {
         [1] = 2842;
      };
      ["level"] = 35;
      ["name_es"] = "!Gnomer-yaaaaa!";
      ["req"] = 20;
   };
   [2851] = {
      ["name_ru"] = "Дикарские кожаные сапоги";
      ["type"] = "Solo";
      ["name_fr"] = "Les bottes en cuir fauve";
      ["name_de"] = "Wildlederstiefel";
      ["objective"] = "Bring 2 Nightscape Pants, 2 Nightscape Boots, and 2 Wildvines to Pratt McGrubben in Feathermoon Stronghold.";
      ["followup"] = 2853;
      ["name_cn"] = "蛮皮?靴";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Boots";
      ["reward"] = {
         [1] = 8406;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 45;
      ["name_es"] = "Botas de cuero salvaje";
      ["req"] = 30;
   };
   [2859] = {
      ["name_ru"] = "Дикарские кожаные поножи";
      ["type"] = "Solo";
      ["name_fr"] = "Les jambieres en cuir fauve";
      ["name_de"] = "Wildledergamaschen";
      ["objective"] = "Bring 2 Turtle Scale Helms, 2 Turtle Scale Bracers, and 2 Wildvines to Jangdor Swiftstrider in Camp Mojache.";
      ["followup"] = 2860;
      ["name_cn"] = "蛮皮?腿";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Leggings";
      ["reward"] = {
         [1] = 8407;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2854;
      ["prequests"] = {
         [1] = 2854;
      };
      ["level"] = 45;
      ["name_es"] = "Leotardos de cuero salvaje";
      ["req"] = 30;
   };
   [2867] = {
      ["name_ru"] = "Возвращение в Крепость Оперенной Луны";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner au bastion de Pennelune";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Kehrt zur Mondfederfeste zuruck";
      ["name_cn"] = "返回羽月要塞";
      ["name"] = "Return to Feathermoon Stronghold";
      ["objective"] = "Return to Shandris Feathermoon in the Feathermoon Stronghold and report your findings.";
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2866;
      ["prequests"] = {
         [1] = 2866;
      };
      ["level"] = 43;
      ["name_es"] = "Regresa al Bastion Plumaluna";
      ["req"] = 40;
   };
   [2875] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: Андре Огнебородый";
      ["type"] = "Solo";
      ["objective"] = "Bring Andre's Head to Security Chief Bilgewhizzle in Steamwheedle Port.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "ON RECHERCHE?: Andre Barbe-en-feu";
      ["sort"] = "Tanaris";
      ["name_cn"] = "通?：安德雷・??比德";
      ["name_de"] = "GESUCHT: Andre Feuerbart";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Andre Firebeard";
      ["level"] = 45;
      ["name_es"] = "SE BUSCA: Andre Barbafuego";
      ["req"] = 40;
   };
   [5781] = {
      ["name_ru"] = "Символ ушедших дней";
      ["type"] = "Solo";
      ["name_fr"] = "Aux memoires perdues";
      ["next"] = 5845;
      ["name_de"] = "Von vergessenen Erinnerungen";
      ["name_cn"] = "?忘的??";
      ["objective"] = "Travel to the Undercroft - at the southernmost section of the Eastern Plaguelands - and recover Taelan's Hammer. Return to Tirion Fordring upon completion of your objective.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Of Forgotten Memories";
      ["prev"] = 5742;
      ["prequests"] = {
         [1] = 5742;
      };
      ["level"] = 57;
      ["name_es"] = "De recuerdos olvidados";
      ["req"] = 52;
   };
   [5845] = {
      ["name_ru"] = "Символ утраченной чести";
      ["type"] = "Solo";
      ["name_fr"] = "De l'honneur perdu";
      ["next"] = 5846;
      ["name_de"] = "Von verlorener Ehre";
      ["name_cn"] = "失落的?耀";
      ["objective"] = "Travel to Northdale, in the northeastern region of the Eastern Plaguelands, and recover the Symbol of Lost Honor. Return to Tirion Fordring upon completion of your objective.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Of Lost Honor";
      ["prev"] = 5781;
      ["prequests"] = {
         [1] = 5781;
      };
      ["level"] = 58;
      ["name_es"] = "Del honor perdido";
      ["req"] = 52;
   };
   [5861] = {
      ["name_ru"] = "Найти Миранду";
      ["type"] = "Solo";
      ["name_fr"] = "Trouver Myranda";
      ["next"] = 5862;
      ["name_de"] = "Myranda suchen";
      ["name_cn"] = "?找麦??";
      ["objective"] = "Travel to Uther's Tomb, located in the southern Plaguelands. Show Myranda the Hag Tirion's Gift.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Find Myranda";
      ["prev"] = 5848;
      ["prequests"] = {
         [1] = 5848;
      };
      ["level"] = 60;
      ["name_es"] = "Encuentra a Myranda";
      ["req"] = 52;
   };
   [2939] = {
      ["name_ru"] = "В поисках знаний";
      ["type"] = "Solo";
      ["objective"] = "Talk to Daryn Lightwind in Rut'theran Village.";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_fr"] = "En savoir plus";
      ["sort"] = "Feralas";
      ["name_cn"] = "?找知?";
      ["name_de"] = "Auf der Suche nach Wissen";
      ["faction"] = "Alliance";
      ["name"] = "In Search of Knowledge";
      ["level"] = 47;
      ["name_es"] = "La busqueda del conocimiento";
      ["req"] = 42;
   };
   [5893] = {
      ["name_ru"] = "Припасы Ледяного Зуба";
      ["type"] = "PvP";
      ["objective"] = "Bring 10 Coldtooth Supplies to the Horde Quatermaster in Frostwolf Keep.";
      ["repgain"] = {
         [76] = 25;
         [729] = 2;
      };
      ["name_fr"] = "Fournitures de Froide-dent";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "冷??洞的??";
      ["name_de"] = "Vorrate der Eisbeisermine";
      ["faction"] = "Horde";
      ["name"] = "Coldtooth Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros de Dentefrio";
      ["req"] = 51;
   };
   [2963] = {
      ["name_ru"] = "Ульдумские чудеса";
      ["type"] = "Solo";
      ["name_fr"] = "Prodiges d'Uldum";
      ["repgain"] = {
         [47] = 10;
      };
      ["name_de"] = "Omen von Uldum";
      ["name"] = "Portents of Uldum";
      ["name_cn"] = "奥丹姆的?索";
      ["objective"] = "Speak with Historian Karnik in the Hall of Explorers within Ironforge.";
      ["next"] = 2946;
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 2439;
      ["prequests"] = {
         [1] = 2439;
      };
      ["level"] = 50;
      ["name_es"] = "Presagios de Uldum";
      ["req"] = 45;
   };
   [5941] = {
      ["name_ru"] = "Возвращение к Хроми";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Chromie";
      ["next"] = 5721;
      ["name_de"] = "Ruckkehr zu Chromie";
      ["name_cn"] = "返回克?米身?";
      ["objective"] = "Take the Bundle of Relics to Chromie in Andorhal.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Return to Chromie";
      ["prev"] = 5206;
      ["prequests"] = {
         [1] = 5206;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Cromi";
      ["req"] = 50;
   };
   [2979] = {
      ["name_ru"] = "Темный обряд";
      ["type"] = "Solo";
      ["name_fr"] = "Sombre ceremonie";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Dunkle Zeremonie";
      ["name"] = "Dark Ceremony";
      ["name_cn"] = "黑暗?式";
      ["objective"] = "Rok Orhan in Camp Mojache wants you to find a Gordunni Orb.";
      ["next"] = 3002;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 2978;
      ["prequests"] = {
         [1] = 2978;
      };
      ["level"] = 46;
      ["name_es"] = "Una ceremonia oscura";
      ["req"] = 38;
   };
   [2987] = {
      ["name_ru"] = "Кобальт Гордунни";
      ["type"] = "Solo";
      ["objective"] = "Orwin Gizzmick in Camp Mojache wants 12 samples of Gordunni Cobalt.";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "Cobalt Gordunni";
      ["name_cn"] = "戈杜尼??石";
      ["reward"] = {
         [1] = 9658;
         [2] = 9660;
      };
      ["name_de"] = "Gordunnikobalt";
      ["faction"] = "Horde";
      ["name"] = "Gordunni Cobalt";
      ["level"] = 43;
      ["name_es"] = "El cobalto Gordunni";
      ["req"] = 38;
   };
   [2995] = {
      ["name_ru"] = "Линии связи";
      ["type"] = "Solo";
      ["objective"] = "Oran Snakewrithe in Undercity wants you to travel to the Hinterlands and burn the Highvale Records, Highvale Report, and Highvale Notes.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Lignes de communication";
      ["sort"] = "Undercity";
      ["name_cn"] = "??中心";
      ["name_de"] = "Nachrichtenwege";
      ["faction"] = "Horde";
      ["name"] = "Lines of Communication";
      ["level"] = 47;
      ["name_es"] = "Lineas de comunicacion";
      ["req"] = 42;
   };
   [6021] = {
      ["name_ru"] = "Зельдарр Изгой";
      ["type"] = "Solo";
      ["objective"] = "Bring Zaeldarr's Head to Caretaker Alen at Light's Hope Chapel.";
      ["repgain"] = {
         [529] = 150;
      };
      ["name_fr"] = "Zaeldarr le Banni";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "流亡者塞??";
      ["name_de"] = "Zaeldarr der Ausgestosene";
      ["faction"] = "Horde";
      ["name"] = "Zaeldarr the Outcast";
      ["level"] = 55;
      ["name_es"] = "Zaeldarr el Marginado";
      ["req"] = 50;
   };
   [6069] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Thotar at Razor Hill.";
      ["next"] = 6062;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6085] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame an Ice Claw Bear. Practice your skills, then return the Taming Rod to Grif Wildheart in Kharanos.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6086;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6084;
      ["prequests"] = {
         [1] = 6084;
      };
      ["series"] = 3;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6101] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Nightsaber Stalker. Practice your skills, then return the Taming Rod to Dazalar in Dolanaar.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6102;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6063;
      ["prequests"] = {
         [1] = 6063;
      };
      ["series"] = 2;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6133] = {
      ["name_ru"] = "Охота на cледопытов";
      ["type"] = "Solo";
      ["objective"] = "Travel to the northern borders of the Eastern Plaguelands and recover the Quel'Thalas Registry. The item is somewhere in the Quel'Lithien lodge.$B$BYou must also slay 8 Rangers, 8 Pathstriders, and 8 Woodsmen.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "游侠之王的命令";
      ["name_fr"] = "L'ordre du seigneur forestier";
      ["name_de"] = "Das Ersuchen des Waldlauferlords";
      ["faction"] = "Horde";
      ["name"] = "The Ranger Lord's Behest";
      ["level"] = 60;
      ["name_es"] = "La orden del Senor forestal";
      ["req"] = 54;
   };
   [8201] = {
      ["name_ru"] = "Коллекция голов";
      ["type"] = "Raid";
      ["objective"] = "String 5 Channeler's Heads, then return the Collection of Troll Heads to Exzhal on Yojamba Isle.";
      ["repgain"] = {
         [270] = 500;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Une collection de tetes";
      ["name_cn"] = "祭司的??";
      ["reward"] = {
         [1] = 20213;
         [2] = 20215;
         [3] = 20216;
         [4] = 20217;
      };
      ["name_de"] = "Die Schadelsammlung";
      ["faction"] = "Horde";
      ["name"] = "A Collection of Heads";
      ["level"] = 60;
      ["name_es"] = "Una coleccion de cabezas";
      ["req"] = 58;
   };
   [3083] = {
      ["name_ru"] = "Табличка с письменами";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette codee";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Verschlusselte Schrifttafel";
      ["objective"] = "Read the Encrypted Tablet and speak to Rwag in the Valley of Trials.";
      ["name_cn"] = "密文石板";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Tablilla encriptada";
      ["req"] = 1;
   };
   [3091] = {
      ["name_ru"] = "Простая записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note simple";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Einfache Notiz";
      ["objective"] = "Read the Simple Note and speak to Harutt Thunderhorn in Camp Narache.";
      ["name_cn"] = "?易便?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Note";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 747;
      ["prequests"] = {
         [1] = 747;
      };
      ["level"] = 1;
      ["name_es"] = "La nota simple";
      ["req"] = 1;
   };
   [3099] = {
      ["name_ru"] = "Нечистый свиток";
      ["type"] = "Solo";
      ["name_fr"] = "Rouleau contamine";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Besudelte Rolle";
      ["objective"] = "Read the Tainted Scroll and speak to Maximillion in Deathknell.";
      ["name_cn"] = "被?染的卷?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Tainted Scroll";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 1;
      ["name_es"] = "Un pergamino corrupto";
      ["req"] = 1;
   };
   [3107] = {
      ["name_ru"] = "Священная руна";
      ["type"] = "Solo";
      ["name_fr"] = "Rune consacree";
      ["repgain"] = {
         [47] = 50;
      };
      ["name_de"] = "Geweihte Rune";
      ["objective"] = "Read the Consecrated Rune and speak to Bromos Grummner in Coldridge Valley.";
      ["name_cn"] = "神?符文";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Consecrated Rune";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa consagrada";
      ["req"] = 1;
   };
   [8361] = {
      ["name_ru"] = "Связь с Бездной";
      ["type"] = "Group";
      ["objective"] = "Bor Wildmane at Cenarion Hold in Silithus wants you to destroy an Abyssal Templar and bring him an Abyssal Crest as proof of the deed.";
      ["repgain"] = {
         [609] = 100;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Des contacts abyssaux";
      ["name_cn"] = "深渊??";
      ["reward"] = {
         [1] = 20603;
      };
      ["name_de"] = "Abyssische Kontakte";
      ["faction"] = "Horde";
      ["name"] = "Abyssal Contacts";
      ["level"] = 60;
      ["name_es"] = "Contactos Abisales";
      ["req"] = 60;
   };
   [3123] = {
      ["name_ru"] = "Испытание сосуда";
      ["type"] = "Solo";
      ["name_fr"] = "Test du recipient";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Das Gefas wird getestet";
      ["name"] = "Testing the Vessel";
      ["name_cn"] = "??容器";
      ["objective"] = "Travel to the Hinterlands, and locate the Wildkin. Kill 10, and use the Muisek Vessel to shrink and capture the fallen Wildkin.$B$BBring 10 Wildkin Muiseks and the Muisek Vessel to Witch Doctor Uzer'i in Feralas.";
      ["next"] = 3124;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 3122;
      ["prequests"] = {
         [1] = 3122;
      };
      ["level"] = 47;
      ["name_es"] = "Probar la vasija";
      ["req"] = 40;
   };
   [8425] = {
      ["name_ru"] = "Вудуистские перья";
      ["type"] = "Dungeon";
      ["name_fr"] = "Plumes vaudou";
      ["name_de"] = "Voodoofedern";
      ["objective"] = "Bring the Voodoo Feathers from the trolls in the Sunken Temple to the Fallen Hero of the Horde.";
      ["reward"] = {
         [1] = 20521;
         [2] = 20130;
         [3] = 20517;
      };
      ["name_cn"] = "巫毒羽毛";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Voodoo Feathers";
      ["sort"] = "Warrior";
      ["prev"] = 8424;
      ["prequests"] = {
         [1] = 8424;
      };
      ["level"] = 52;
      ["name_es"] = "Plumas Vudu";
      ["req"] = 50;
   };
   [8521] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает шелковых бинтов!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de bandages en soie?!";
      ["name_de"] = "Die Allianz braucht mehr Seidenverbande!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21511;
      };
      ["name_cn"] = "?盟需要更多????！";
      ["objective"] = "Bring 20 silk bandages to Nurse Stonefield at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Silk Bandages!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8520;
      ["prequests"] = {
         [1] = 8520;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas vendas de seda!";
      ["req"] = 1;
   };
   [8553] = {
      ["name_ru"] = "Капитанская сабля";
      ["type"] = "Solo";
      ["name_fr"] = "Le sabre du capitaine Smotts";
      ["next"] = 8554;
      ["name_de"] = "Der Entersabel des Kapitans";
      ["name_cn"] = "船?的弯刀";
      ["objective"] = "Speak with Sprogger.";
      ["sort"] = "Stranglethorn Valley";
      ["faction"] = "Horde";
      ["name"] = "The Captain's Cutlass";
      ["prev"] = 8552;
      ["prequests"] = {
         [1] = 8552;
      };
      ["level"] = 50;
      ["name_es"] = "El alfanje del Capitan";
      ["req"] = 40;
   };
   [8585] = {
      ["name_ru"] = "Остров Ужаса!";
      ["type"] = "Raid";
      ["name_fr"] = "L'ile de l'effroi?!";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Die Insel des Schreckens!";
      ["name"] = "The Isle of Dread!";
      ["name_cn"] = "恐怖之?！";
      ["objective"] = "Recover Lakmaeran's Carcass and 20 Chimaerok Tenderloins for Dirge Quikcleave in Tanaris.";
      ["next"] = 8586;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8584;
      ["prequests"] = {
         [1] = 8584;
      };
      ["level"] = 60;
      ["name_es"] = "La Isla del Terror";
      ["req"] = 60;
   };
   [8649] = {
      ["name_ru"] = "Предок Штормоскал";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Front-de-tempete";
      ["name_cn"] = "雷眉?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Sturmbraue";
      ["faction"] = "Horde";
      ["name"] = "Stormbrow the Elder";
      ["level"] = 60;
      ["name_es"] = "Tormenceno el Ancestro";
      ["req"] = 1;
   };
   [8681] = {
      ["name_ru"] = "Предок Громовой Рог";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Corne-tonnerre";
      ["name_cn"] = "雷角?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Donnerhorn";
      ["faction"] = "Horde";
      ["name"] = "Thunderhorn the Elder";
      ["level"] = 60;
      ["name_es"] = "Tronacuerno el Ancestro";
      ["req"] = 1;
   };
   [8713] = {
      ["name_ru"] = "Предок Песнь Звезд";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Chantetoile";
      ["name_cn"] = "星歌?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Sternensang";
      ["faction"] = "Horde";
      ["name"] = "Starsong the Elder";
      ["level"] = 60;
      ["name_es"] = "Cantoestelar el Ancestro";
      ["req"] = 1;
   };
   [6421] = {
      ["name_ru"] = "Ущелье Камнепадов";
      ["type"] = "Solo";
      ["objective"] = "Explore deep into the cave at Boulderslide Ravine and bring back 10 Resonite Crystals for Mor'rogal at Sun Rock Retreat to investigate.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Le ravin des Eboulis";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "?岩峡谷";
      ["name_de"] = "Steinschlagklamm";
      ["faction"] = "Horde";
      ["name"] = "Boulderslide Ravine";
      ["level"] = 18;
      ["name_es"] = "Barranco del Alud";
      ["req"] = 14;
   };
   [8777] = {
      ["name_ru"] = "Цель: землерои из Улья Регал";
      ["type"] = "Group";
      ["objective"] = "Kill 30 Hive'Regal Burrowers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing XI in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les fouisseuses de la Ruche'Regal";
      ["name_cn"] = "目?：雷戈掘洞者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Einbuddler des Regalschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Regal Burrowers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los perforadores Colmen'Regal";
      ["req"] = 60;
   };
   [8809] = {
      ["name_ru"] = "Необычные материалы";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Enchanted Thorium Bars and 2 Enchanted Leather to Vargus at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing IX in order to complete this quest.";
      ["name_fr"] = "Des materiaux extraordinaires";
      ["sort"] = "Silithus";
      ["name_cn"] = "特殊的材料";
      ["reward"] = {
         [1] = 20800;
         [2] = 21266;
      };
      ["name_de"] = "Besondere Materialien";
      ["faction"] = "Horde";
      ["name"] = "Extraordinary Materials";
      ["level"] = 60;
      ["name_es"] = "Materiales encantados";
      ["req"] = 60;
   };
   [8841] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8824;
      ["prequests"] = {
         [1] = 8824;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8873] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger in the Valley of Wisdom in Orgrimmar.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Horde";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [8905] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Wildheart Bracers to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22108;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8937] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Belt of Valor and a set of Gauntlets of Valor to Deliana in Ironforge.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 21994;
         [2] = 21998;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8969] = {
      ["name_ru"] = "Левая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau gauche de l'amulette du seigneur Valthalak";
      ["next"] = 8970;
      ["name_de"] = "Das linke Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Kormok and slay him. Return to Bodley inside Blackrock Mountain with the Left Piece of Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦塔拉克?品的左瓣";
      ["sort"] = "Scholomance";
      ["faction"] = "Horde";
      ["name"] = "The Left Piece of Lord Valthalak's Amulet";
      ["followup"] = 8970;
      ["prev"] = 8965;
      ["prequests"] = {
         [1] = 8965;
      };
      ["level"] = 60;
      ["name_es"] = "La parte izquierda del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [9001] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Magister's Crown and Magister's Robes.";
      ["reward"] = {
         [1] = 22065;
         [2] = 22069;
      };
      ["name_cn"] = "??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [6565] = {
      ["name_ru"] = "Верность Древним богам";
      ["objective"] = "Kill Lorgus Jett in Blackfathom Deeps and then return to Je'neu Sancrea in Ashenvale.";
      ["name_cn"] = "上古之神的仆从";
      ["sort"] = "Blackfathom Deeps";
      ["level"] = 26;
      ["type"] = "Dungeon";
      ["name_fr"] = "Allegeance aux Dieux tres anciens";
      ["repgain"] = {
         [530] = 350;
      };
      ["name_de"] = "Treue zu den Alten Gottern";
      ["reward"] = {
         [1] = 17694;
         [2] = 17695;
      };
      ["faction"] = "Horde";
      ["name"] = "Allegiance to the Old Gods";
      ["prev"] = 6564;
      ["prequests"] = {
         [1] = 6564;
      };
      ["series"] = 2;
      ["name_es"] = "Lealtad a los dioses antiguos";
      ["req"] = 17;
   };
   [6581] = {
      ["name_ru"] = "Пилы Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Lames du clan Chanteguerre";
      ["name_cn"] = "?歌?条";
      ["reward"] = {
         [1] = 16742;
      };
      ["name_de"] = "Sageblatter des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "Warsong Saw Blades";
      ["level"] = 27;
      ["name_es"] = "Espadas dentadas Grito de Guerra";
      ["req"] = 22;
   };
   [9097] = {
      ["name_ru"] = "Венец ледяного огня";
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe de givrefeu";
      ["name_de"] = "Frostfeuerreif";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make a Frostfire Circlet if you bring her the following: 1 Desecrated Circlet, 15 Wartorn Cloth Scraps, 3 Mooncloth and 3 Nexus Crystals.";
      ["reward"] = {
         [1] = 22498;
      };
      ["name_cn"] = "霜火??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Frostfire Circlet";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El aro de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9129] = {
      ["name_ru"] = "Средоточие стихий";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Kern der Elemente";
      ["name_fr"] = "Le noyau des elements";
      ["name_cn"] = "元素之核";
      ["faction"] = "Horde";
      ["name"] = "Core of Elements";
      ["reward"] = {
         [1] = 22523;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9128;
      ["prequests"] = {
         [1] = 9128;
      };
      ["level"] = 60;
      ["name_es"] = "Nucleo de elementos";
      ["req"] = 55;
   };
   [6629] = {
      ["name_ru"] = "Убить Грундига Темное Облако";
      ["type"] = "Solo";
      ["name_fr"] = "Tuer Grundig Noir-nuage";
      ["name_de"] = "Totet Grundig Finsterwolke";
      ["name_cn"] = "?死格?迪格・暗云";
      ["objective"] = "Kill Grundig Darkcloud and 6 Grimtotem Brutes, and return to Makaba Flathoof near the southeastern edge of Stonetalon.$B";
      ["sort"] = "Stonetalon Mountains";
      ["faction"] = "Horde";
      ["name"] = "Kill Grundig Darkcloud";
      ["prev"] = 6548;
      ["prequests"] = {
         [1] = 6548;
      };
      ["level"] = 18;
      ["name_es"] = "Mata a Grundig Nube Negra";
      ["req"] = 12;
   };
   [6645] = {
      ["name_ru"] = "Покровительство братства, кожа Недр";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 150;
      };
      ["sort"] = "Molten Core";
      ["name_fr"] = "Faveur aupres de la Confrerie, Cuir du Magma";
      ["name_cn"] = "兄弟会的好感 - 熔火犬皮";
      ["name_de"] = "Gunst der Bruderschaft, Kernleder";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Brotherhood, Core Leather";
      ["level"] = 60;
      ["name_es"] = "El favor de la Hermandad, cuero del nucleo";
      ["req"] = 60;
   };
   [9225] = {
      ["name_ru"] = "Легендарное боевое снаряжение ? Чтимый Рассветом";
      ["type"] = "Solo";
      ["objective"] = "For 45 Insignias of the Dawn and 45 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille epiques - Revere aupres de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "史??的作?装? - ?色黎明崇敬";
      ["reward"] = {
         [1] = 22657;
         [2] = 22667;
         [3] = 22668;
         [4] = 22659;
         [5] = 22678;
         [6] = 22656;
      };
      ["name_de"] = "Epische Kampfausrustung - Respekt der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Epic Armaments of Battle - Revered Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento epico de batalla: venerado con El Alba";
      ["req"] = 55;
   };
   [9257] = {
      ["name_ru"] = "Атиеш, большой посох Стража";
      ["type"] = "Dungeon";
      ["objective"] = "Anachronos at the Caverns of Time in Tanaris wants you to take Atiesh, Greatstaff of the Guardian to Stratholme and use it on Consecrated Earth. Defeat the entity that is exorcised from the staff and return to him.";
      ["repgain"] = {
         [910] = 500;
         [529] = 500;
      };
      ["name_de"] = "Atiesh, Hohestab des Wachters";
      ["sort"] = "Legendary";
      ["name_cn"] = "埃提耶什，守?者的??之杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22631;
      };
      ["name"] = "Atiesh, Greatstaff of the Guardian";
      ["prev"] = 9251;
      ["prequests"] = {
         [1] = 9251;
      };
      ["level"] = 60;
      ["name_es"] = "Atiesh, el gran baculo del guardian";
      ["req"] = 60;
   };
   [3363] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的?歌花";
      ["name_fr"] = "La fleur-de-chant corrompue";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [6741] = {
      ["name_ru"] = "Больше добычи!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 1;
      };
      ["name_de"] = "Mehr Beute!";
      ["name_cn"] = "取之于?";
      ["name_fr"] = "Plus de butin?!";
      ["name"] = "More Booty!";
      ["faction"] = "Horde";
      ["sort"] = "Alterac Valley";
      ["prev"] = 7224;
      ["prequests"] = {
         [1] = 7224;
      };
      ["level"] = 60;
      ["name_es"] = "!Mas botines!";
      ["req"] = 51;
   };
   [3379] = {
      ["name_ru"] = "Мастер Тени";
      ["type"] = "Solo";
      ["objective"] = "Kill the group of Shadow Silk Poachers that wander the Searing Gorge. Nilith has reason to believe that there are five of them that need to be exterminated. Return to Nilith in the Searing Gorge when this task is complete.$B";
      ["next"] = 3385;
      ["name_fr"] = "Les tisseuses d'ombre";
      ["sort"] = "Tailoring";
      ["name_cn"] = "暗影蛛?";
      ["reward"] = {
         [1] = 10461;
      };
      ["name_de"] = "Schattenweber";
      ["faction"] = "Horde";
      ["name"] = "Shadoweaver";
      ["level"] = 50;
      ["name_es"] = "Las tejedoras de sombra";
      ["req"] = 46;
   };
   [6805] = {
      ["name_ru"] = "Буря в пустыне";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Dust Stormers and 15 Desert Rumblers and then return to Duke Hydraxis in Azshara.";
      ["sort"] = "Azshara";
      ["name_cn"] = "雷暴和磐石";
      ["name_fr"] = "Tempetes";
      ["followup"] = 6821;
      ["name_de"] = "Sturmer und Rumpler";
      ["faction"] = "Horde";
      ["name"] = "Stormers and Rumblers";
      ["level"] = 57;
      ["name_es"] = "Sirocosos y reptarenas";
      ["req"] = 55;
   };
   [6821] = {
      ["name_ru"] = "Око Углевзора";
      ["type"] = "Raid";
      ["objective"] = "Bring the Eye of the Emberseer to Duke Hydraxis in Azshara.";
      ["next"] = 6822;
      ["name_fr"] = "?il du Prophete ardent";
      ["sort"] = "Azshara";
      ["name_cn"] = "艾博希?之眼";
      ["name"] = "Eye of the Emberseer";
      ["name_de"] = "Auge des Glutsehers";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 6805;
         [2] = 6804;
      };
      ["level"] = 60;
      ["name_es"] = "Ojo del Brasadivino";
      ["req"] = 56;
   };
   [3443] = {
      ["name_ru"] = "Древко факела";
      ["type"] = "Solo";
      ["name_fr"] = "Forger le manche";
      ["next"] = 3452;
      ["name_de"] = "Das Schmieden des Schafts";
      ["name_cn"] = "?造火炬杆";
      ["objective"] = "Bring 8 Thorium Plated Daggers to Kalaran Windblade.";
      ["sort"] = "Searing Gorge";
      ["faction"] = "Horde";
      ["name"] = "Forging the Shaft";
      ["prev"] = 3442;
      ["prequests"] = {
         [1] = 3442;
      };
      ["level"] = 48;
      ["name_es"] = "Forjar el mango";
      ["req"] = 40;
   };
   [6901] = {
      ["name_ru"] = "В атаку!";
      ["type"] = "PvP";
      ["objective"] = "";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?始攻?!";
      ["name_fr"] = "Lancez l'attaque !";
      ["name_de"] = "Startet den Angriff!";
      ["faction"] = "Horde";
      ["name"] = "Launch the Attack!";
      ["level"] = 60;
      ["name_es"] = "Lanzar el ataque";
      ["req"] = 1;
   };
   [3483] = {
      ["name_ru"] = "Сигнал \"Взять на борт!\"";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Signal zum Abholen";
      ["name_fr"] = "Signal de la recuperation";
      ["name_cn"] = "信号?射器";
      ["name"] = "Signal for Pickup";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 10444;
      };
      ["sort"] = "Ironforge";
      ["prev"] = 3451;
      ["prequests"] = {
         [1] = 3451;
      };
      ["level"] = 52;
      ["name_es"] = "Una senal para el envio";
      ["req"] = 45;
   };
   [6981] = {
      ["name_ru"] = "Светящийся осколок";
      ["type"] = "Solo";
      ["objective"] = "Travel to Ratchet to find someone that can tell you more about the glowing shard.$B$BThen, deliver the shard as you are directed.";
      ["sort"] = "Wailing Caverns";
      ["name_cn"] = "?光的碎片";
      ["name_fr"] = "L'Eclat luminescent";
      ["name_de"] = "Der leuchtende Splitter";
      ["faction"] = "Horde";
      ["name"] = "The Glowing Shard";
      ["level"] = 26;
      ["name_es"] = "El fragmento resplandeciente";
      ["req"] = 15;
   };
   [3507] = {
      ["name_ru"] = "Предательница";
      ["objective"] = "Speak to Belgrom Rockmaul in Orgrimmar.";
      ["name_cn"] = "叛徒";
      ["sort"] = "Orgrimmar";
      ["level"] = 56;
      ["type"] = "Solo";
      ["name_fr"] = "Trahison";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Verraten";
      ["reward"] = {
         [1] = 10709;
         [2] = 11120;
      };
      ["faction"] = "Horde";
      ["name"] = "Betrayed";
      ["prev"] = 3506;
      ["prequests"] = {
         [1] = 3506;
      };
      ["series"] = 4;
      ["name_es"] = "Traicion";
      ["req"] = 44;
   };
   [7029] = {
      ["name_ru"] = "Скверна Злоязыкого";
      ["type"] = "Dungeon";
      ["objective"] = "Fill the Coated Cerulean Vial at the orange crystal pool in Maraudon.$B$BUse the Filled Cerulean Vial on the Vylestem Vines to force the corrupted Noxxious Scion to emerge.$B$BHeal 8 plants by killing these Noxxious Scion, then return to Vark Battlescar in Shadowprey Village.";
      ["name_fr"] = "La corruption de Vylelangue";
      ["sort"] = "Maraudon";
      ["name_cn"] = "?利塔恩的?染";
      ["reward"] = {
         [1] = 17768;
         [2] = 17778;
         [3] = 17770;
      };
      ["name_de"] = "Schlangenzunges Verderbnis";
      ["faction"] = "Horde";
      ["name"] = "Vyletongue Corruption";
      ["level"] = 47;
      ["name_es"] = "La corrupcion de Lenguavil";
      ["req"] = 41;
   };
   [7045] = {
      ["name_ru"] = "Благодарность от \"Пастбищ Дымного Леса\"!";
      ["type"] = "Solo";
      ["name_fr"] = "Un grand merci des Gourmandises Fumebois?!";
      ["name_de"] = "Ein Dankeschon von Kokelwalder!";
      ["reward"] = {
         [1] = 17726;
      };
      ["name_cn"] = "烟林牧?的感?";
      ["objective"] = "Speak with Greatfather Winter in Ironforge.";
      ["faction"] = "Alliance";
      ["name"] = "A Smokywood Pastures Thank You!";
      ["sort"] = "Hallow's End";
      ["prev"] = 7043;
      ["prequests"] = {
         [1] = 7043;
      };
      ["level"] = 60;
      ["name_es"] = "Un agradecimiento de Pastos de Bosquehumeante";
      ["req"] = 30;
   };
   [7061] = {
      ["name_ru"] = "Праздник Зимнего Покрова";
      ["type"] = "Solo";
      ["name_fr"] = "La fete du Voile d'hiver";
      ["repgain"] = {
         [81] = 500;
      };
      ["name_de"] = "Das Winterhauchfest";
      ["name_cn"] = "冬幕?";
      ["name"] = "The Feast of Winter Veil";
      ["objective"] = "Feel free to read the book, The Feast of Winter Veil\"";
      ["faction"] = "Horde";
      ["sort"] = "Hallow's End";
      ["prev"] = 6964;
      ["prequests"] = {
         [1] = 6964;
      };
      ["level"] = 60;
      ["name_es"] = "El festin del Festival de Invierno";
      ["req"] = 10;
   };
   [3563] = {
      ["name_ru"] = "Плата Джес'римона Джедиге";
      ["type"] = "Solo";
      ["name_fr"] = "Le paiement de Jes'rimon a Jediga";
      ["name_de"] = "Jes'rimons Bezahlung fur Jediga";
      ["name_cn"] = "杰斯雷蒙的?酬";
      ["objective"] = "Deliver Jes'rimon's Note to Jediga in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Jes'rimon's Payment to Jediga";
      ["prev"] = 3541;
      ["prequests"] = {
         [1] = 3541;
      };
      ["level"] = 52;
      ["name_es"] = "El pago de Jes'rimon a Jediga";
      ["req"] = 45;
   };
   [7141] = {
      ["name_ru"] = "Битва за Альтерак";
      ["type"] = "PvP";
      ["name_fr"] = "La bataille d'Alterac";
      ["repgain"] = {
         [47] = 500;
         [730] = 500;
      };
      ["name_cn"] = "奥特?克的?斗";
      ["name_de"] = "Die Schlacht um Alterac";
      ["objective"] = "Enter Alterac Valley, defeat the Horde general Drek'thar, and then return to Prospector Stonehewer in the Alterac Mountains.";
      ["sort"] = "Alterac Valley";
      ["name"] = "The Battle of Alterac";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 7221;
      };
      ["level"] = 60;
      ["name_es"] = "La batalla de Alterac";
      ["req"] = 51;
   };
   [7221] = {
      ["name_ru"] = "Разговор с геологом Камнетеркой";
      ["type"] = "PvP";
      ["objective"] = "Speak with Prospector Stonehewer in the Dun Baldar garrison.";
      ["next"] = 7141;
      ["name_cn"] = "勘??塔雷・石?";
      ["sort"] = "Alterac Valley";
      ["followup"] = 7141;
      ["name_de"] = "Sprecht mit Ausgrabungsleiter Steinhauer";
      ["faction"] = "Alliance";
      ["name"] = "Speak with Prospector Stonehewer";
      ["level"] = 60;
      ["name_es"] = "Habla con la prospectora Tallapiedra";
      ["req"] = 51;
   };
   [3627] = {
      ["name_ru"] = "Воссоединить расколотый амулет";
      ["type"] = "Group";
      ["name_fr"] = "Reunir les morceaux de l'amulette brisee";
      ["next"] = 3628;
      ["name_de"] = "Das zerbrochene Amulett vereinen";
      ["name_cn"] = "收集破碎的?符";
      ["objective"] = "Slay Grol the Destroyer, Lady Sevine, and Archmage Allistarj. From their corpses take the Amulet of Grol, the Amulet of Sevine, and the Amulet of Allistarj.$B$BRemember to USE your Enchanted Azsharite Fel Weaponry to weaken the triad. They cannot be killed otherwise - but use them wisely...$B";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "Uniting the Shattered Amulet";
      ["prev"] = 3626;
      ["prequests"] = {
         [1] = 3626;
      };
      ["level"] = 60;
      ["name_es"] = "Juntar pedazos del amuleto";
      ["req"] = 45;
   };
   [3635] = {
      ["name_ru"] = "Гномское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Gnome Engineering, take the Manual of Engineering Disciplines to Oglethorpe Obnoticus in Booty Bay.";
      ["sort"] = "Engineering";
      ["name_cn"] = "侏儒工程学";
      ["name_fr"] = "Ingenierie des gnomes";
      ["followup"] = 3642;
      ["name_de"] = "Gnomeningenieurskunst";
      ["faction"] = "Horde";
      ["name"] = "Gnome Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria gnomica";
      ["req"] = 30;
   };
   [3643] = {
      ["name_ru"] = "Покажи свою работу";
      ["type"] = "Solo";
      ["name_fr"] = "Montrez votre travail";
      ["name_de"] = "Zeigt Eure Arbeit";
      ["reward"] = {
         [1] = 10790;
      };
      ["name_cn"] = "工作成果";
      ["objective"] = "Bring 6 Mithril Tubes, an Accurate Scope, and a 2 Advanced Target Dummies to Oglethorpe Obnoticus in Booty Bay.";
      ["faction"] = "Horde";
      ["name"] = "Show Your Work";
      ["sort"] = "Engineering";
      ["prev"] = 3642;
      ["prequests"] = {
         [1] = 3642;
      };
      ["level"] = 47;
      ["name_es"] = "Muestra tu trabajo";
      ["req"] = 30;
   };
   [7301] = {
      ["name_ru"] = "Свергнутые властители небес";
      ["type"] = "PvP";
      ["objective"] = "Travel to Frostwolf territory and search for Wing Commander Slidore, Wing Commander Vipore, and Wing Commander Ichman. Return to Commander Duffy should you complete your mission.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "Les ailes brisees";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "被捕的空?指?官";
      ["name_de"] = "Gefallene Himmelssturmer";
      ["faction"] = "Alliance";
      ["name"] = "Fallen Sky Lords";
      ["level"] = 60;
      ["name_es"] = "Senores del Cielo caidos";
      ["req"] = 51;
   };
   [7365] = {
      ["name_ru"] = "Реквием Оленьего Шлема";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing troll players in Alterac Valley.$B$BKill a troll and return to Athramanis at Dun'Baldar with Darkspear Troll Mojo.";
      ["name_cn"] = "鹿?的挽歌";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Hirschhaupts Requiem";
      ["faction"] = "Alliance";
      ["name"] = "Staghelm's Requiem";
      ["level"] = 60;
      ["name_es"] = "Requiem de Corzocelada";
      ["req"] = 51;
   };
   [7381] = {
      ["name_ru"] = "Возвращение Коррака";
      ["type"] = "Raid";
      ["objective"] = "Should Korrak the Bloodrager make a return to the Field of Strife, seek him out and destroy him.$B$BReturn the Skull of Korrak to Warmaster Laggrond in the Hillsbrad Foothills.";
      ["name_fr"] = "Le retour de Korrak";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "科?拉克?来";
      ["reward"] = {
         [1] = 18149;
      };
      ["name_de"] = "Korraks Ruckkehr";
      ["faction"] = "Horde";
      ["name"] = "The Return of Korrak";
      ["level"] = 60;
      ["name_es"] = "El regreso de Korrak";
      ["req"] = 51;
   };
   [7429] = {
      ["name_ru"] = "Освободите Нотта!";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [169] = 350;
      };
      ["name_de"] = "Befreit Knot!";
      ["name_cn"] = "逃出生天！";
      ["name_fr"] = "Liberez Noue?!";
      ["name"] = "Free Knot!";
      ["faction"] = "Horde";
      ["sort"] = "Dire Maul";
      ["prev"] = 5525;
      ["prequests"] = {
         [1] = 5525;
      };
      ["level"] = 60;
      ["name_es"] = "!Libera a Knot!";
      ["req"] = 57;
   };
   [7461] = {
      ["name_ru"] = "Древнее безумие";
      ["type"] = "Dungeon";
      ["objective"] = "You must destroy the guardians surrounding the 5 Pylons that power the Prison of Immol'thar. Once the Pylons have powered down, the force field surrounding Immol'thar will have dissipated.$B$BEnter the Prison of Immol'thar and eradicate the foul demon that stands at its heart. Finally, confront Prince Tortheldrin in Athenaeum.$B$BReturn to the Shen'dralar Ancient in the courtyard should you complete this quest.";
      ["next"] = 7877;
      ["sort"] = "Dire Maul";
      ["name_cn"] = "伊莫塔?的?狂";
      ["name_fr"] = "Folie interieure";
      ["name_de"] = "Der innere Wahnsinn";
      ["faction"] = "Horde";
      ["name"] = "The Madness Within";
      ["level"] = 60;
      ["name_es"] = "Locura interior";
      ["req"] = 56;
   };
   [7493] = {
      ["name_ru"] = "Все еще только начинается!";
      ["type"] = "Solo";
      ["name_fr"] = "Le voyage commence a peine";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "一切才???始";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "The Journey Has Just Begun";
      ["name_de"] = "Die Reise beginnt erst";
      ["prev"] = 7491;
      ["prequests"] = {
         [1] = 7491;
      };
      ["level"] = 60;
      ["name_es"] = "El viaje acaba de empezar";
      ["req"] = 60;
   };
   [7509] = {
      ["name_ru"] = "Ковка Кель'Серрара";
      ["objective"] = "You must get Onyxia to breathe fire on the Unfired Ancient Blade. Once this is done, pick up the now Heated Ancient Blade. Be warned, a Heated Ancient Blade will not remain heated forever - time is of the essence.$B$BThe last step before returning to me is to slay the beast and drive the Heated Ancient Blade into her corpse.$B$BDo this and Quel'Serrar will be yours.";
      ["name_cn"] = "?造奎?塞拉";
      ["sort"] = "Onyxia's Lair";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Forger Quel'Serrar";
      ["repgain"] = {
         [809] = 200;
      };
      ["name_de"] = "Das Schmieden von Quel'Serrar";
      ["reward"] = {
         [1] = 18348;
      };
      ["faction"] = "Horde";
      ["name"] = "The Forging of Quel'Serrar";
      ["prev"] = 7508;
      ["prequests"] = {
         [1] = 7508;
      };
      ["series"] = 2;
      ["name_es"] = "Forjar Quel'Serrar";
      ["req"] = 60;
   };
   [3763] = {
      ["name_ru"] = "Помощь верховному друиду Оленьему Шлему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm in Darnassus.";
      ["next"] = 3764;
      ["sort"] = "Darnassus";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "L'aide a l'archidruide Forteramure";
      ["name_de"] = "Erzdruide Hirschhaupt helfen";
      ["faction"] = "Alliance";
      ["name"] = "Assisting Arch Druid Staghelm";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Corzocelada";
      ["req"] = 47;
   };
   [7541] = {
      ["name_ru"] = "Служба Орде";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Dienst an der Horde";
      ["name_fr"] = "Un service pour la Horde";
      ["name_cn"] = "?部落效力";
      ["faction"] = "Horde";
      ["name"] = "Service to the Horde";
      ["reward"] = {
         [1] = 18585;
         [2] = 18586;
      };
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1262;
      ["prequests"] = {
         [1] = 1262;
      };
      ["level"] = 45;
      ["name_es"] = "Un servicio para la Horda";
      ["req"] = 30;
   };
   [3787] = {
      ["name_ru"] = "Просьба друида";
      ["type"] = "Solo";
      ["name_fr"] = "La requete de Gentecime";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Lebenshands Bitte";
      ["name"] = "Jonespyre's Request";
      ["name_cn"] = "奎恩提斯的?求";
      ["objective"] = "Speak with Quintis Jonespyre in Feathermoon Stronghold.";
      ["next"] = 3791;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 3785;
      ["prequests"] = {
         [1] = 3785;
      };
      ["level"] = 50;
      ["name_es"] = "La peticion de Jonguja";
      ["req"] = 47;
   };
   [3803] = {
      ["name_ru"] = "Рассветница для Дарнаса";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 50;
      };
      ["name_de"] = "Morgenkorn nach Darnassus";
      ["name_fr"] = "De la fibre d'aurore pour Darnassus";
      ["name_cn"] = "???斯的晨光麦";
      ["faction"] = "Alliance";
      ["name"] = "Morrowgrain to Darnassus";
      ["reward"] = {
         [1] = 11887;
      };
      ["sort"] = "Darnassus";
      ["prev"] = 3785;
      ["prequests"] = {
         [1] = 3785;
      };
      ["level"] = 55;
      ["name_es"] = "Managrana para Darnassus";
      ["req"] = 47;
   };
   [7621] = {
      ["name_ru"] = "Предупреждение";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Priest";
      ["name_cn"] = "警示";
      ["name_fr"] = "Un avertissement";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name_de"] = "Eine Warnung";
      ["faction"] = "Horde";
      ["name"] = "A Warning";
      ["level"] = 60;
      ["name_es"] = "Un aviso";
      ["req"] = 60;
   };
   [7637] = {
      ["name_ru"] = "Жертва необходима";
      ["objective"] = "Travel to Ironforge and get High Priest Rohan's Exorcism Censer.  You will need to make a donation of 150 gold in order to secure it.";
      ["name_cn"] = "?牲精神";
      ["followup"] = 7639;
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "L'accent sur le sacrifice";
      ["next"] = 7639;
      ["name_de"] = "Ein Opfer darbieten";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["repgain"] = {
         [47] = 350;
         [69] = 150;
      };
      ["name"] = "Emphasis on Sacrifice";
      ["sort"] = "Paladin";
      ["prequests"] = {
         [1] = 7638;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name_es"] = "Enfasis en el sacrificio";
      ["req"] = 60;
   };
   [7653] = {
      ["name_ru"] = "Императорский латный пояс";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["name_de"] = "Imperialer Plattengurtel";
      ["name_fr"] = "La ceinture imperiale en plaques";
      ["name_cn"] = "君王板甲腰?";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Belt";
      ["reward"] = {
         [1] = 12688;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Cinturon de placas imperiales";
      ["req"] = 50;
   };
   [3843] = {
      ["name_ru"] = "Новый член семьи";
      ["type"] = "Solo";
      ["name_fr"] = "Un tout nouveau membre dans la famille";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Das neueste Mitglied der Familie";
      ["name"] = "The Newest Member of the Family";
      ["name_cn"] = "新的生命";
      ["objective"] = "Take your Fragile Sprite Darter Egg to the Hinterlands and speak to Agnar Beastamer, but hurry, you only have 1 hour to find him before the hatchling within the egg dies.";
      ["next"] = 4297;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 3842;
      ["prequests"] = {
         [1] = 3842;
      };
      ["level"] = 47;
      ["name_es"] = "Un nuevo miembro en la familia";
      ["req"] = 38;
   };
   [7701] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: надзиратель Мальториус";
      ["type"] = "Group";
      ["objective"] = "Deep within the Slag Pit of the Cauldron, in the Searing Gorge, you will find the traitorous Dark Iron dwarf named Overseer Maltorius.$B$BSlay Overseer Maltorius and take his head. Return the head to Lookout Captain Lolo Longstriker in the Searing Gorge for your reward.";
      ["repgain"] = {
         [59] = 100;
      };
      ["sort"] = "Searing Gorge";
      ["name_fr"] = "ON RECHERCHE?: Surveillant Maltorius";
      ["name_cn"] = "??：工??托留斯";
      ["reward"] = {
         [1] = 19128;
         [2] = 19127;
      };
      ["name_de"] = "GESUCHT: Vorarbeiter Maltorius";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Overseer Maltorius";
      ["level"] = 50;
      ["name_es"] = "SE BUSCA: Sobrestante Maltorius";
      ["req"] = 45;
   };
   [7733] = {
      ["name_ru"] = "Борьба за качество";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Rage Scar Yeti Hides to Pratt McGrubben at Feathermoon Stronghold, Feralas.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Beste Qualitat";
      ["reward"] = {
         [1] = 19041;
      };
      ["name_cn"] = "更高的品?";
      ["name_fr"] = "Qualite amelioree";
      ["faction"] = "Alliance";
      ["name"] = "Improved Quality";
      ["sort"] = "Feralas";
      ["prev"] = 2821;
      ["prequests"] = {
         [1] = 2821;
      };
      ["level"] = 48;
      ["name_es"] = "Calidad mejorada";
      ["req"] = 40;
   };
   [3883] = {
      ["name_ru"] = "Экология чужих";
      ["type"] = "Solo";
      ["objective"] = "Use the Scraping Vial to collect a Hive Wall Sample from one of the Gorishi hive hatcheries in Un'Goro Crater.  Look for the chambers with the hanging larval spawns.$B$BBring the Hive Wall Sample to Hol'anyee Marshal in Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "?型的生?";
      ["name_fr"] = "Ecologie etrangere";
      ["name_de"] = "Eine fremdartige Okologie";
      ["faction"] = "Horde";
      ["name"] = "Alien Ecology";
      ["level"] = 52;
      ["name_es"] = "Ecologia alienigena";
      ["req"] = 48;
   };
   [7781] = {
      ["name_ru"] = "Владыка Черной горы";
      ["type"] = "Solo";
      ["name_fr"] = "Le seigneur de Rochenoire";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 250;
      };
      ["name_de"] = "Der Herrscher des Schwarzfels";
      ["name_cn"] = "黑石之王";
      ["objective"] = "Return the Head of Nefarian to Highlord Bolvar Fordragon in Stormwind.";
      ["next"] = 7782;
      ["sort"] = "Stormwind City";
      ["name"] = "The Lord of Blackrock";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 60;
      ["name_es"] = "Senor de Roca Negra";
      ["req"] = 60;
   };
   [7813] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 150;
      };
      ["sort"] = "Undercity";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7818;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [7829] = {
      ["name_ru"] = "Охота на дикарей";
      ["type"] = "Solo";
      ["objective"] = "Huntsman Markhor at Revantusk Village in the Hinterlands wants you to kill 20 Savage Owlbeasts. Return to him once the task is complete.$B$BMarkhor mentioned that the Savage Owlbeasts occupy the wilds of the Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "野蛮的??";
      ["name_fr"] = "Chasser les sauvages";
      ["name_de"] = "Jagt die Wilden";
      ["faction"] = "Horde";
      ["name"] = "Hunt the Savages";
      ["level"] = 48;
      ["name_es"] = "Cazar a los salvajes";
      ["req"] = 44;
   };
   [7845] = {
      ["name_ru"] = "Похищен старейшина Сломанный Клык!";
      ["type"] = "Group";
      ["objective"] = "Primal Torntusk at Revantusk Village in the Hinterlands wants you to rescue her mate, Elder Torntusk, from Jintha'alor.$B$BYou have been told that he is being held prisoner atop Jintha'alor, the Vilebranch capital city located in the southern region of the Hinterlands.";
      ["next"] = 7846;
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "被?架的断??者！";
      ["name_fr"] = "L’ancien Brocherompue a ete enleve?!";
      ["name_de"] = "Die Entfuhrung des Altesten Stumpfhauer";
      ["faction"] = "Horde";
      ["name"] = "Kidnapped Elder Torntusk!";
      ["level"] = 51;
      ["name_es"] = "El secuestro del anciano Colmillopartido";
      ["req"] = 46;
   };
   [7861] = {
      ["name_ru"] = "Разыскивается: коварная жрица Ведьмиса и ее прислужники";
      ["type"] = "Group";
      ["objective"] = "You have been ordered to slay Vile Priestess Hexx and 10 Vilebranch Aman'zasi Guards. See Primal Torntusk at Revantusk Village in the Hinterlands once this task is complete.$B$BVile Priestess Hexx and the Aman'zasi Guards can be found atop Jintha'alor in the Hinterlands.";
      ["name_fr"] = "On recherche?: La vile pretresse Maleficia et ses sbires";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "通?：邪?祭司海克斯和?的爪牙";
      ["reward"] = {
         [1] = 19159;
         [2] = 19121;
      };
      ["name_de"] = "GESUCHT: Uble Priesterin Hexx und ihre Diener";
      ["faction"] = "Horde";
      ["name"] = "Wanted: Vile Priestess Hexx and Her Minions";
      ["level"] = 51;
      ["name_es"] = "Se busca: sacerdotisa vil Hexx y sus esbirros";
      ["req"] = 46;
   };
   [7877] = {
      ["name_ru"] = "Сокровище Шен'дралар";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le tresor des Shen'dralar";
      ["name_de"] = "Der Schatz der Shen'dralar";
      ["reward"] = {
         [1] = 18420;
         [2] = 18421;
         [3] = 18424;
      };
      ["name_cn"] = "辛德拉的宝藏";
      ["objective"] = "Return to the Athenaeum and find the Treasure of the Shen'dralar. Claim your reward!";
      ["faction"] = "Horde";
      ["name"] = "The Treasure of the Shen'dralar";
      ["sort"] = "Dire Maul";
      ["prev"] = 7461;
      ["prequests"] = {
         [1] = 7461;
      };
      ["level"] = 60;
      ["name_es"] = "El tesoro de los Shen'dralar";
      ["req"] = 56;
   };
   [7893] = {
      ["name_ru"] = "Ритуалы Силы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Rituels de force";
      ["name_cn"] = "力量?式";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Rituale der Starke";
      ["faction"] = "Horde";
      ["name"] = "Rituals of Strength";
      ["level"] = 60;
      ["name_es"] = "Ritual de fuerza";
      ["req"] = 40;
   };
   [7925] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["name_fr"] = "Marque d'honneur";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["objective"] = "You obtained a Warsong Mark of Honor for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["name_de"] = "Ehrenabzeichen";
      ["prev"] = 7789;
      ["prequests"] = {
         [1] = 7789;
      };
      ["level"] = 25;
      ["name_es"] = "Marca de Honor";
      ["req"] = 20;
   };
   [7941] = {
      ["name_ru"] = "Еще накладки на доспехи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Plus de renforts d’armure";
      ["name_cn"] = "更多的?甲片";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mehr Rustungssets";
      ["faction"] = "Horde";
      ["name"] = "More Armor Kits";
      ["level"] = 60;
      ["name_es"] = "Mas refuerzos para armadura";
      ["req"] = 40;
   };
   [4003] = {
      ["name_ru"] = "Спасение принцессы";
      ["type"] = "Dungeon";
      ["name_fr"] = "Un sauvetage royal";
      ["next"] = 4004;
      ["name_de"] = "Die konigliche Rettung";
      ["name_cn"] = "拯救公主";
      ["objective"] = "Slay Emperor Dagran Thaurissan and free Princess Moira Bronzebeard from his evil spell. $B";
      ["sort"] = "Blackrock Depths";
      ["faction"] = "Horde";
      ["name"] = "The Royal Rescue";
      ["prev"] = 4002;
      ["prequests"] = {
         [1] = 4002;
      };
      ["level"] = 59;
      ["name_es"] = "El rescate real";
      ["req"] = 48;
   };
   [8053] = {
      ["name_ru"] = "Знаки Силы: боевые наручи вольнодумца";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker Primal Hakkari Bindings.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les garde-bras de libre-penseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：思考者?臂";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19827;
      };
      ["name_de"] = "Symbole der Macht: Die Armschutzer des Freidenkers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Freethinker's Armguards";
      ["level"] = 61;
      ["name_es"] = "Dechados de Poder: los Guardabrazos de librepensador";
      ["req"] = 60;
   };
   [8069] = {
      ["name_ru"] = "Знаки Силы: одеяние мастера иллюзий";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Kossack.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la robe d’illusionniste";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：幻???袍";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 20034;
      };
      ["name_de"] = "Symbole der Macht: Die Roben des Illusionisten";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Illusionist's Robes";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: la Toga de ilusionista";
      ["req"] = 60;
   };
   [8101] = {
      ["name_ru"] = "Камешек Каджаро";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le caillou de Kajaro";
      ["name_cn"] = "???之石";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 19598;
      };
      ["name_de"] = "Der Stein des Kajaro";
      ["faction"] = "Horde";
      ["name"] = "The Pebble of Kajaro";
      ["level"] = 60;
      ["name_es"] = "El guijarro de Kajaro";
      ["req"] = 60;
   };
   [8117] = {
      ["name_ru"] = "Ожерелье видений Вудресса";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Vision von Voodress";
      ["name_fr"] = "Vision de Voodress";
      ["name"] = "Vision of Voodress";
      ["name_cn"] = "巫毒幻象";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19607;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8116;
      ["prequests"] = {
         [1] = 8116;
      };
      ["level"] = 60;
      ["name_es"] = "Vision de Voodress";
      ["req"] = 60;
   };
   [8149] = {
      ["name_ru"] = "Почести герою";
      ["type"] = "Solo";
      ["objective"] = "Travel to Uther's Tomb in Western Plaguelands and use Uther's Tribute at his statue, and then return to Wagner Hammerstrike outside Ironforge before the Harvest Festival is over.";
      ["repgain"] = {
         [69] = 250;
         [54] = 250;
         [72] = 250;
         [47] = 250;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "En l'honneur d'un heros";
      ["name_cn"] = "??英雄";
      ["reward"] = {
         [1] = 20009;
      };
      ["name_de"] = "Die Ehrung eines Helden";
      ["faction"] = "Horde";
      ["name"] = "Honoring a Hero";
      ["level"] = 60;
      ["name_es"] = "En honor a un heroe";
      ["req"] = 30;
   };
   [4083] = {
      ["name_ru"] = "Призрачный кубок";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "鬼魂之杯";
      ["name_fr"] = "Le Calice spectral";
      ["name_de"] = "Der spektrale Kelch";
      ["faction"] = "Horde";
      ["name"] = "The Spectral Chalice";
      ["level"] = 55;
      ["name_es"] = "El caliz espectral";
      ["req"] = 40;
   };
   [8181] = {
      ["name_ru"] = "Сопротивление Йе'кинье";
      ["type"] = "Raid";
      ["name_fr"] = "La confrontation avec Yeh'kinya";
      ["name_de"] = "Konfrontiert Yeh'kinya";
      ["reward"] = {
         [1] = 20218;
         [2] = 20219;
      };
      ["name_cn"] = "面?叶基?";
      ["objective"] = "Speak with Yeh'kinya.";
      ["faction"] = "Horde";
      ["name"] = "Confront Yeh'kinya";
      ["sort"] = "Zul'Gurub";
      ["prev"] = 4788;
      ["prequests"] = {
         [1] = 4788;
      };
      ["level"] = 58;
      ["name_es"] = "La confrontacion con Yeh'kinya";
      ["req"] = 40;
   };
   [4102] = {
      ["name_ru"] = "Очищение Оскверненного леса";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Blood Amber to Maybess Riverbreeze in Felwood.";
      ["sort"] = "Felwood";
      ["name_cn"] = "?化?伍德";
      ["name_fr"] = "Purifiez Gangrebois";
      ["name_de"] = "Den Teufelswald saubern";
      ["faction"] = "Horde";
      ["name"] = "Cleansing Felwood";
      ["level"] = 55;
      ["name_es"] = "Limpiar Frondavil";
      ["req"] = 48;
   };
   [8234] = {
      ["name_ru"] = "Запечатанная лазурная сумка";
      ["objective"] = "Retrieve the Sealed Azure Bag from the Timbermaw Shaman in Azshara.  Then take the bag to Archmage Xylem, also found in Azshara.";
      ["name_cn"] = "密封的?袋子";
      ["sort"] = "Rogue";
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Sac azur scelle";
      ["next"] = 8235;
      ["name_de"] = "Die versiegelte azurblaue Tasche";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["repgain"] = {
         [349] = 250;
      };
      ["name"] = "Sealed Azure Bag";
      ["prev"] = 8233;
      ["prequests"] = {
         [1] = 8233;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Bolsa azur sellada";
      ["req"] = 50;
   };
   [4134] = {
      ["name_ru"] = "Украденный рецепт Громоваров";
      ["type"] = "Dungeon";
      ["name_fr"] = "La recette perdue de Tonnebiere";
      ["name_de"] = "Verlorenes Donnerbraurezept";
      ["reward"] = {
         [1] = 11964;
         [2] = 3928;
         [3] = 12000;
         [4] = 6149;
      };
      ["name_cn"] = "?失的雷酒秘方";
      ["objective"] = "Bring the Lost Thunderbrew Recipe to Vivian Lagrave in Kargath.";
      ["faction"] = "Horde";
      ["name"] = "Lost Thunderbrew Recipe";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4133;
      ["prequests"] = {
         [1] = 4133;
      };
      ["level"] = 55;
      ["name_es"] = "La receta de Cebatruenos perdida";
      ["req"] = 50;
   };
   [1038] = {
      ["name_ru"] = "Эффекты Велинды";
      ["type"] = "Solo";
      ["name_fr"] = "Les effets personnels de Velinde";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Velindes Besitztumer";
      ["name"] = "Velinde's Effects";
      ["name_cn"] = "?琳德的日?";
      ["objective"] = "Search through Velinde's chest for her journal, then return it along with the key to Thyn'tel Bladeweaver in Darnassus.";
      ["next"] = 1039;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1037;
      ["prequests"] = {
         [1] = 1037;
      };
      ["level"] = 30;
      ["name_es"] = "Las pertenencias de Velinde";
      ["req"] = 25;
   };
   [1042] = {
      ["name_ru"] = "Семья Карвин";
      ["type"] = "Solo";
      ["name_fr"] = "La famille Carevin";
      ["next"] = 1043;
      ["name_de"] = "Die Familie Treuwein";
      ["name_cn"] = "??文家族";
      ["objective"] = "Speak with Jonathan Carevin in Darkshire.";
      ["sort"] = "Ashenvale";
      ["faction"] = "Alliance";
      ["name"] = "The Carevin Family";
      ["prev"] = 1041;
      ["prequests"] = {
         [1] = 1041;
      };
      ["level"] = 30;
      ["name_es"] = "La familia Carevin";
      ["req"] = 25;
   };
   [4182] = {
      ["name_ru"] = "Драконья угроза";
      ["type"] = "Group";
      ["objective"] = "Slay 15 Black Broodlings, 10 Black Dragonspawn, 4 Black Wyrmkin and 1 Black Drake. Return to Helendis Riverhorn when the task is complete.";
      ["next"] = 4183;
      ["name_fr"] = "La menace des draconiens";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "黑?的威?";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Drachkin-Bedrohung";
      ["faction"] = "Alliance";
      ["name"] = "Dragonkin Menace";
      ["level"] = 54;
      ["name_es"] = "La amenaza de los dragonantes";
      ["req"] = 48;
   };
   [1050] = {
      ["name_ru"] = "\"Мифология Титанов\"";
      ["type"] = "Dungeon";
      ["objective"] = "Retrieve Mythology of the Titans from the Monastery and bring it to Librarian Mae Paledust in Ironforge.";
      ["repgain"] = {
         [47] = 350;
      };
      ["sort"] = "Scarlet Monastery";
      ["name_fr"] = "Mythologie des Titans";
      ["name_cn"] = "泰坦神?";
      ["reward"] = {
         [1] = 7746;
      };
      ["name_de"] = "Mythologie der Titanen";
      ["faction"] = "Alliance";
      ["name"] = "Mythology of the Titans";
      ["level"] = 38;
      ["name_es"] = "Mitologia de los titanes";
      ["req"] = 28;
   };
   [8426] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 29;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 20;
   };
   [1058] = {
      ["name_ru"] = "Лесная магия Джин'Зила";
      ["type"] = "Solo";
      ["objective"] = "Witch Doctor Jin'Zil at Malaka'jin wants 5 portions of Stonetalon Sap, 5 Twilight Whiskers, 30 Courser Eyes and a Fey Dragon Scale.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "Stonetalon Mountains";
      ["name_fr"] = "Magie de la foret de Jin'Zil";
      ["name_cn"] = "金吉?的森林魔法";
      ["reward"] = {
         [1] = 6664;
         [2] = 6665;
      };
      ["name_de"] = "Jin'Zils Waldmagie";
      ["faction"] = "Horde";
      ["name"] = "Jin'Zil's Forest Magic";
      ["level"] = 26;
      ["name_es"] = "Magia del bosque de Jin'Zil";
      ["req"] = 20;
   };
   [1062] = {
      ["name_ru"] = "Вторжение гоблинов";
      ["type"] = "Solo";
      ["objective"] = "Kill 15 Venture Co. Loggers, then return to Seereth Stonebreak on the border of Stonetalon and the Barrens.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Les invasions gobelines";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "地精侵略者";
      ["name_de"] = "Goblineindringlinge";
      ["faction"] = "Horde";
      ["name"] = "Goblin Invaders";
      ["level"] = 19;
      ["name_es"] = "Los invasores goblin";
      ["req"] = 13;
   };
   [1066] = {
      ["name_ru"] = "Невинная кровь";
      ["type"] = "Solo";
      ["name_fr"] = "Le sang des innocents";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Das Blut Unschuldiger";
      ["name_cn"] = "无辜者之血";
      ["name"] = "Blood of Innocents";
      ["objective"] = "Bring 5 Vials of Innocent Blood to Apothecary Lydon in Tarren Mill.";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1065;
      ["prequests"] = {
         [1] = 1065;
      };
      ["level"] = 23;
      ["name_es"] = "Sangre inocente";
      ["req"] = 13;
   };
   [1070] = {
      ["name_ru"] = "На страже в Когтистых горах";
      ["type"] = "Solo";
      ["objective"] = "Find Kaela Shadowspear overlooking the valley entering Windshear Crag in the Stonetalon Mountains.";
      ["next"] = 1085;
      ["name_fr"] = "De garde dans les Serres-Rocheuses";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "守?石爪山";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Wache halten im Steinkrallengebirge";
      ["faction"] = "Alliance";
      ["name"] = "On Guard in Stonetalon";
      ["level"] = 21;
      ["name_es"] = "Estar de guardia en Espolon";
      ["req"] = 17;
   };
   [8586] = {
      ["name_ru"] = "Зажигательные химеровые отбивные Могиля";
      ["objective"] = "Dirge Quikcleave in Gadgetzan wants you to bring him 20 Goblin Rocket Fuel and 20 Deeprock Salt.";
      ["name_cn"] = "迪?格的超美味奇美拉肉片";
      ["sort"] = "Tanaris";
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Pyro-cotelettes de chimaerok a la Dirge";
      ["next"] = 8587;
      ["name_de"] = "Dirges abgefahrene Chimaerokkoteletts";
      ["repgain"] = {
         [910] = 500;
      };
      ["reward"] = {
         [1] = 21025;
         [2] = 21023;
      };
      ["name"] = "Dirge's Kickin' Chimaerok Chops";
      ["prev"] = 8585;
      ["prequests"] = {
         [1] = 8585;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Fabulosas chuletillas de quimerok de Dirge";
      ["req"] = 60;
   };
   [1078] = {
      ["name_ru"] = "Поиск для Маурена";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Crystalized Scales to Collin Mauren in Stormwind.";
      ["repgain"] = {
         [54] = 250;
         [72] = 250;
      };
      ["sort"] = "Stonetalon Mountains";
      ["name_fr"] = "Des retrouvailles pour Mauren";
      ["name_cn"] = "完????";
      ["reward"] = {
         [1] = 6677;
      };
      ["name_de"] = "Suche fur Mauren";
      ["faction"] = "Alliance";
      ["name"] = "Retrieval for Mauren";
      ["level"] = 26;
      ["name_es"] = "Escamas cristalizadas para Mauren";
      ["req"] = 17;
   };
   [8650] = {
      ["name_ru"] = "Предок Снежнокрон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Couronne-de-neige";
      ["name_cn"] = "雪冠?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Schneekrone";
      ["faction"] = "Horde";
      ["name"] = "Snowcrown the Elder";
      ["level"] = 60;
      ["name_es"] = "Corona Nevada el Ancestro";
      ["req"] = 1;
   };
   [4342] = {
      ["name_ru"] = "Рассказ Карана";
      ["type"] = "Dungeon";
      ["objective"] = "Listen as Kharan Mighthammer tells his story.";
      ["next"] = 4361;
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "??的故事";
      ["name_fr"] = "Legende de Kharan";
      ["name_de"] = "Kharans Geschichte";
      ["faction"] = "Alliance";
      ["name"] = "Kharan's Tale";
      ["level"] = 59;
      ["name_es"] = "El relato de Kharan";
      ["req"] = 50;
   };
   [8714] = {
      ["name_ru"] = "Предок Лунная Заря";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Heurtelune";
      ["name_cn"] = "月??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Mondstreich";
      ["faction"] = "Horde";
      ["name"] = "Moonstrike the Elder";
      ["level"] = 60;
      ["name_es"] = "Lunaplena el Ancestro";
      ["req"] = 1;
   };
   [1094] = {
      ["name_ru"] = "Дальнейшие указания";
      ["objective"] = "Deliver the Sealed Envelope to Sputtervalve in the Barrens.";
      ["name_cn"] = "新的指示";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 21;
      ["type"] = "Solo";
      ["name_fr"] = "D'autres instructions";
      ["next"] = 1095;
      ["name_de"] = "Weitere Instruktionen";
      ["repgain"] = {
         [470] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Further Instructions";
      ["prev"] = 1093;
      ["prequests"] = {
         [1] = 1093;
      };
      ["series"] = 1;
      ["name_es"] = "Mas instrucciones";
      ["req"] = 16;
   };
   [8778] = {
      ["name_ru"] = "Взрывчатка для дружины Стальгорна";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Oils of Immolation, 5 Goblin Rocket Fuel and 10 Dense Blasting Powder to Arcanist Nozzlespring near Hive'Zora in Silithus.  You must also bring Logistics Task Briefing IV in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "La brigade de Forgefer a besoin d'explosifs?!";
      ["name_cn"] = "?炉堡??需要爆炸品！";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Die Eisenschmiedebrigade braucht Sprengstoff!";
      ["faction"] = "Alliance";
      ["name"] = "The Ironforge Brigade Needs Explosives!";
      ["level"] = 60;
      ["name_es"] = "!La Brigada de Forjaz necesita explosivos!";
      ["req"] = 60;
   };
   [1102] = {
      ["name_ru"] = "Отмщение грядет!";
      ["type"] = "Dungeon";
      ["objective"] = "Bring Razorflank's Heart to Auld Stonespire in Thunder Bluff.";
      ["repgain"] = {
         [81] = 500;
      };
      ["sort"] = "Razorfen Kraul";
      ["name_fr"] = "Un destin funeste";
      ["name_cn"] = "奥?德的??";
      ["reward"] = {
         [1] = 4197;
         [2] = 6742;
         [3] = 6725;
      };
      ["name_de"] = "Ein schreckliches Schicksal";
      ["faction"] = "Horde";
      ["name"] = "A Vengeful Fate";
      ["level"] = 34;
      ["name_es"] = "Un destino vengador";
      ["req"] = 29;
   };
   [1106] = {
      ["name_ru"] = "Мартек Изгой";
      ["type"] = "Solo";
      ["objective"] = "Bring Fizzle's Letter to Martek the Exiled in the Badlands.";
      ["next"] = 1108;
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "流放者?特克";
      ["name_fr"] = "Martek l'Exile";
      ["name_de"] = "Martek der Verbannte";
      ["faction"] = "Horde";
      ["name"] = "Martek the Exiled";
      ["level"] = 35;
      ["name_es"] = "Martek el Exiliado";
      ["req"] = 26;
   };
   [1110] = {
      ["name_ru"] = "Обломки болидов";
      ["type"] = "Solo";
      ["objective"] = "Bring 30 Rocket Car Parts to Kravel Koalbeard in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "火箭?零件";
      ["name_fr"] = "Pieces de chariot explosif";
      ["name_de"] = "Raketenwagenteile";
      ["faction"] = "Horde";
      ["name"] = "Rocket Car Parts";
      ["level"] = 31;
      ["name_es"] = "Las piezas de coche cohete";
      ["req"] = 28;
   };
   [1114] = {
      ["name_ru"] = "Заказ гномов";
      ["type"] = "Solo";
      ["name_fr"] = "Une livraison pour les gnomes";
      ["name_de"] = "Lieferung fur die Gnome";
      ["name_cn"] = "侏儒的?物";
      ["objective"] = "Bring the Delicate Car Parts to Fizzle Brassbolts in Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Delivery to the Gnomes";
      ["prev"] = 1112;
      ["prequests"] = {
         [1] = 1112;
      };
      ["level"] = 36;
      ["name_es"] = "Un envio para los gnomos";
      ["req"] = 30;
   };
   [8938] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Beaststalker's Belt and a set of Beaststalker's Gloves to Mokvar in Orgrimmar.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22010;
         [2] = 22015;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [4486] = {
      ["name_ru"] = "Фолиант благородства";
      ["type"] = "Solo";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_de"] = "Der Foliant des Adels";
      ["sort"] = "Paladin";
      ["name_cn"] = "高?之?";
      ["name_fr"] = "Le Tome de noblesse";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "The Tome of Nobility";
      ["level"] = 40;
      ["name_es"] = "Escrito sobre nobleza";
      ["req"] = 40;
   };
   [4502] = {
      ["name_ru"] = "Вулканическая активность";
      ["type"] = "Solo";
      ["objective"] = "Collect 9 samples of Un'Goro Ash from the fire elementals around the volcano in Un'Goro Crater, and return them to Liv Rizzlefix in Ratchet.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_fr"] = "Activite volcanique";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "火山的活?";
      ["name_de"] = "Vulkanische Aktivitat";
      ["faction"] = "Horde";
      ["name"] = "Volcanic Activity";
      ["level"] = 55;
      ["name_es"] = "Actividad volcanica";
      ["req"] = 49;
   };
   [1130] = {
      ["name_ru"] = "Весть от Мелора";
      ["type"] = "Solo";
      ["objective"] = "Speak with Melor Stonehoof in Thunder Bluff.";
      ["next"] = 1131;
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "梅洛的?注";
      ["name_fr"] = "Melor envoie un message";
      ["name_de"] = "Melor schickt Kunde";
      ["faction"] = "Horde";
      ["name"] = "Melor Sends Word";
      ["level"] = 30;
      ["name_es"] = "Melor manda saludos";
      ["req"] = 20;
   };
   [1134] = {
      ["name_ru"] = "Величавые виверны Каменного Когтя";
      ["type"] = "Solo";
      ["name_fr"] = "Les Ailes-fieres des Serres-Rocheuses";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Prachtschwingen des Steinkrallengebirges";
      ["name_cn"] = "石爪山的双足??";
      ["name"] = "Pridewings of Stonetalon";
      ["objective"] = "Bring 12 Pridewing Venom Sacs to Shindrell Swiftfire in Astranaar.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1008;
      ["prequests"] = {
         [1] = 1008;
      };
      ["level"] = 21;
      ["name_es"] = "Alaorgullo del Espolon";
      ["req"] = 18;
   };
   [9098] = {
      ["name_ru"] = "Наплечные пластины ледяного огня";
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-epaules de givrefeu";
      ["name_de"] = "Frostfeuerschulterpolster";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make Frostfire Shoulderpads if you bring her the following: 1 Desecrated Shoulderpads, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.$B";
      ["reward"] = {
         [1] = 22499;
      };
      ["name_cn"] = "霜火肩?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Frostfire Shoulderpads";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las hombreras de Fuego de Escarcha";
      ["req"] = 60;
   };
   [1142] = {
      ["name_ru"] = "Последнее желание";
      ["type"] = "Dungeon";
      ["objective"] = "Find and return Treshala's Pendant to Treshala Fallowbrook in Darnassus.";
      ["repgain"] = {
         [69] = 350;
      };
      ["sort"] = "Razorfen Kraul";
      ["name_fr"] = "Le declin et la mort";
      ["name_cn"] = "???言";
      ["reward"] = {
         [1] = 6751;
         [2] = 6752;
      };
      ["name_de"] = "Die Sterblichkeit schwindet";
      ["faction"] = "Alliance";
      ["name"] = "Mortality Wanes";
      ["level"] = 30;
      ["name_es"] = "Decaida mortal";
      ["req"] = 25;
   };
   [1146] = {
      ["name_ru"] = "Рой растет";
      ["objective"] = "Deliver Belgrom's Sealed Note to Moktar Krin in Thousand Needles.";
      ["name_cn"] = "?狂的虫群";
      ["sort"] = "Orgrimmar";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "L'essaim s'agrandit";
      ["next"] = 1147;
      ["name_de"] = "Der Schwarm wachst";
      ["repgain"] = {
         [76] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "The Swarm Grows";
      ["prev"] = 1145;
      ["prequests"] = {
         [1] = 1145;
      };
      ["series"] = 2;
      ["name_es"] = "El enjambre crece";
      ["req"] = 29;
   };
   [9194] = {
      ["name_ru"] = "Задание мастера: одеяние из рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "Deliver 8 Runecloth Robes and the Craftsman's Writ - Runecloth Robe - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Robes en etoffe runique";
      ["name_cn"] = "工匠文? - 符文布袍";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Runenstoffrobe";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Runecloth Robe";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: toga de pano runico";
      ["req"] = 55;
   };
   [9226] = {
      ["name_ru"] = "Превосходное боевое снаряжениее ? Чтимый Рассветом";
      ["type"] = "Solo";
      ["objective"] = "For 7 Insignias of the Dawn and 7 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.$B";
      ["name_fr"] = "Armes de bataille excellentes - Revere aupres de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "精良的作?装? - ?色黎明崇敬";
      ["reward"] = {
         [1] = 22681;
         [2] = 22680;
         [3] = 22688;
         [4] = 22679;
         [5] = 22690;
         [6] = 22689;
      };
      ["name_de"] = "Uberragende Kampfausrustung - Respekt der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Superior Armaments of Battle - Revered Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento superior de batalla: venerado con El Alba";
      ["req"] = 55;
   };
   [9322] = {
      ["name_ru"] = "Костры Калимдора";
      ["type"] = "Solo";
      ["objective"] = "Visit the Midsummer camps located in Azshara, Silithus, Un'Goro Crater, and Winterspring, then return to the Festival Flamekeeper.";
      ["name_fr"] = "Feux sauvages en Kalimdor";
      ["sort"] = "Midsummer";
      ["name_cn"] = "?利姆多的野火";
      ["reward"] = {
         [1] = 23379;
         [2] = 23247;
      };
      ["name_de"] = "Gluhende Feuer in Kalimdor";
      ["faction"] = "Horde";
      ["name"] = "Wild Fires in Kalimdor";
      ["level"] = 60;
      ["name_es"] = "Los fuegos salvajes de Kalimdor";
      ["req"] = 50;
   };
   [1170] = {
      ["name_ru"] = "Выводок Ониксии";
      ["type"] = "Solo";
      ["name_fr"] = "La portee d'Onyxia";
      ["next"] = 1171;
      ["name_de"] = "Die Brut von Onyxia";
      ["name"] = "The Brood of Onyxia";
      ["name_cn"] = "奥?克希?的血脉";
      ["objective"] = "Speak with Overlord Mok'Morokk in Brackenwall Village.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1169;
      ["prequests"] = {
         [1] = 1169;
      };
      ["level"] = 43;
      ["name_es"] = "El linaje de Onyxia";
      ["req"] = 38;
   };
   [9386] = {
      ["name_ru"] = "Свет в темных местах";
      ["type"] = "Solo";
      ["objective"] = "Find and touch the bonfires located within Blackrock Spire, Dire Maul, Scholomance, and Stratholme, then speak with the Festival Flamekeeper.";
      ["name_fr"] = "Une Lumiere au sein des ombres";
      ["sort"] = "Midsummer";
      ["name_cn"] = "黑暗中的光明";
      ["reward"] = {
         [1] = 23083;
         [2] = 23247;
      };
      ["name_de"] = "Licht im Dunkeln";
      ["faction"] = "Horde";
      ["name"] = "A Light in Dark Places";
      ["level"] = 60;
      ["name_es"] = "Una luz en la oscuridad";
      ["req"] = 50;
   };
   [1178] = {
      ["name_ru"] = "Гоблинская поддержка";
      ["objective"] = "Speak to Gazlowe in Ratchet.";
      ["name_cn"] = "地精?助商";
      ["sort"] = "Thousand Needles";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Mecenat gobelin";
      ["next"] = 1180;
      ["name_de"] = "Goblinsponsoring";
      ["repgain"] = {
         [470] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Goblin Sponsorship";
      ["prev"] = 1176;
      ["prequests"] = {
         [1] = 1176;
      };
      ["series"] = 1;
      ["name_es"] = "Patrocinio goblin";
      ["req"] = 29;
   };
   [1182] = {
      ["name_ru"] = "Гоблинская поддержка";
      ["objective"] = "Bring the Fuel Regulator Blueprints to Baron Revilgaz in Booty Bay.";
      ["name_cn"] = "地精?助商";
      ["sort"] = "Thousand Needles";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Mecenat gobelin";
      ["next"] = 1183;
      ["name_de"] = "Goblinsponsoring";
      ["repgain"] = {
         [21] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Goblin Sponsorship";
      ["prev"] = 1181;
      ["prequests"] = {
         [1] = 1181;
      };
      ["series"] = 4;
      ["name_es"] = "Patrocinio goblin";
      ["req"] = 29;
   };
   [1186] = {
      ["name_ru"] = "Восемнадцатый пилот";
      ["type"] = "Solo";
      ["name_fr"] = "Le dix-huitieme pilote";
      ["next"] = 1187;
      ["name_de"] = "Der achtzehnte Rennfahrer";
      ["name_cn"] = "第十八个???";
      ["objective"] = "Speak with Razzeric on the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "The Eighteenth Pilot";
      ["prev"] = 1183;
      ["prequests"] = {
         [1] = 1183;
      };
      ["level"] = 37;
      ["name_es"] = "El piloto no18";
      ["req"] = 29;
   };
   [1190] = {
      ["name_ru"] = "Только вперед";
      ["type"] = "Solo";
      ["name_fr"] = "Rester dans la course";
      ["repgain"] = {
         [470] = 75;
      };
      ["name_de"] = "Tempo halten";
      ["name"] = "Keeping Pace";
      ["name_cn"] = "跟上?奏";
      ["objective"] = "Have Zamek create a diversion, then steal Rizzle's plans for Pozzik on the Shimmering Flats.";
      ["next"] = 1194;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1137;
      ["prequests"] = {
         [1] = 1137;
      };
      ["level"] = 41;
      ["name_es"] = "Mantener la velocidad";
      ["req"] = 29;
   };
   [1194] = {
      ["name_ru"] = "Чертежи Риззла";
      ["type"] = "Solo";
      ["name_fr"] = "Les schemas de Tropp";
      ["repgain"] = {
         [470] = 75;
      };
      ["name_de"] = "Rizzels Bauplane";
      ["name_cn"] = "瑞??的?表";
      ["name"] = "Rizzle's Schematics";
      ["objective"] = "Bring the Sample of Indurium Ore to Pozzik on the Shimmering Flats.";
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1190;
      ["prequests"] = {
         [1] = 1190;
      };
      ["level"] = 41;
      ["name_es"] = "Los esquemas de Rizzle";
      ["req"] = 29;
   };
   [1198] = {
      ["name_ru"] = "В поисках Талрида";
      ["type"] = "Dungeon";
      ["objective"] = "Seek out Argent Guard Thaelrid in Blackfathom Deeps.";
      ["next"] = 1200;
      ["name_fr"] = "A la recherche de Thaelrid";
      ["sort"] = "Blackfathom Deeps";
      ["name_cn"] = "?找塞?瑞德";
      ["repgain"] = {
         [69] = 350;
         [529] = 350;
      };
      ["name_de"] = "Auf der Suche nach Thaelrid";
      ["faction"] = "Alliance";
      ["name"] = "In Search of Thaelrid";
      ["level"] = 24;
      ["name_es"] = "Buscando a Thaelrid";
      ["req"] = 18;
   };
   [4806] = {
      ["name_ru"] = "Э'ко великанов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Frosthagelriesen";
      ["name_fr"] = "L'E'ko de Cognegivre";
      ["name_cn"] = "霜槌魂精";
      ["name"] = "Frostmaul E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12460;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko de los Machacahielo";
      ["req"] = 55;
   };
   [4822] = {
      ["name_ru"] = "Женщинам ? цветы, детям ? ...";
      ["type"] = "Solo";
      ["objective"] = "Get some Strawberry Ice Cream for your ward.  The lad seems to prefer Tigule and Foror's brand ice cream.";
      ["name_fr"] = "Je veux une glaaaaace?!";
      ["sort"] = "Children's Week";
      ["name_cn"] = "草莓冰激凌*";
      ["name"] = "You Scream, I Scream...";
      ["name_de"] = "Lecker Eis";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 1687;
      };
      ["level"] = 60;
      ["name_es"] = "!Quiero un heladooooo!";
      ["req"] = 10;
   };
   [1218] = {
      ["name_ru"] = "Ароматные специи";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Soothing Spices to Swamp Eye\" Jarl in Dustwallow Marsh.\"";
      ["next"] = 1206;
      ["name_fr"] = "Les cuisses de grenouille des marais";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "沼?蛙的腿";
      ["followup"] = 1206;
      ["reward"] = {
         [1] = 6807;
      };
      ["name_de"] = "Marschenfroschschenkel";
      ["faction"] = "Horde";
      ["name"] = "Soothing Spices";
      ["level"] = 35;
      ["name_es"] = "Ancas de rana de marisma";
      ["req"] = 30;
   };
   [1222] = {
      ["name_ru"] = "Побег Вонючки";
      ["type"] = "Escort";
      ["objective"] = "Escort Stinky\" Ignatz";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Dustwallow Marsh";
      ["name_fr"] = "Sauvetage du Puant";
      ["name_cn"] = "伊格??的逃亡";
      ["followup"] = 1271;
      ["reward"] = {
         [1] = 3825;
      };
      ["name_de"] = "Stinkis Flucht";
      ["faction"] = "Alliance";
      ["name"] = "Stinky's Escape";
      ["level"] = 37;
      ["name_es"] = "La fuga de Apestoso";
      ["req"] = 30;
   };
   [4902] = {
      ["name_ru"] = "Питомцы Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm in Darnassus.";
      ["repgain"] = {
         [69] = 250;
         [54] = 250;
         [72] = 250;
         [47] = 250;
      };
      ["name_de"] = "Wildekin von Elune";
      ["reward"] = {
         [1] = 16622;
         [2] = 16623;
      };
      ["name_cn"] = "艾露恩的??";
      ["name_fr"] = "Les Indomptables d'Elune";
      ["faction"] = "Alliance";
      ["name"] = "Wildkin of Elune";
      ["sort"] = "Winterspring";
      ["prev"] = 4901;
      ["prequests"] = {
         [1] = 4901;
      };
      ["level"] = 57;
      ["name_es"] = "Lechucico salvaje de Elune";
      ["req"] = 52;
   };
   [1238] = {
      ["name_ru"] = "Потерянный рапорт";
      ["type"] = "Solo";
      ["objective"] = "Bring the Spy's Report to Nazeer Bloodpike in Brackenwall Village.";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_fr"] = "Le rapport perdu";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?失的?告";
      ["name_de"] = "Der verlorene Bericht";
      ["faction"] = "Horde";
      ["name"] = "The Lost Report";
      ["level"] = 35;
      ["name_es"] = "El informe perdido";
      ["req"] = 30;
   };
   [4966] = {
      ["name_ru"] = "Защитить Канати Серое Облако";
      ["type"] = "Solo";
      ["objective"] = "Protect Kanati Greycloud from the centaur attack.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Kanati Grauwolke schutzen";
      ["reward"] = {
         [1] = 15461;
         [2] = 15462;
         [3] = 15463;
      };
      ["name_cn"] = "保???提・灰云";
      ["name_fr"] = "Proteger Kanati Nuage-gris";
      ["faction"] = "Horde";
      ["name"] = "Protect Kanati Greycloud";
      ["sort"] = "Thousand Needles";
      ["prev"] = 4881;
      ["prequests"] = {
         [1] = 4881;
      };
      ["level"] = 28;
      ["name_es"] = "Defensa de Kanati Nube Gris";
      ["req"] = 23;
   };
   [4982] = {
      ["name_ru"] = "Вещи Блестяшки";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les effets de Bijou";
      ["next"] = 4983;
      ["name_de"] = "Bijous Habseligkeiten";
      ["name_cn"] = "比修的装置";
      ["objective"] = "Find Bijou's Belongings and return them to her. You recall her mentioning that she stashed them on the bottom floor of the city.$B";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "Bijou's Belongings";
      ["prev"] = 4981;
      ["prequests"] = {
         [1] = 4981;
      };
      ["level"] = 59;
      ["name_es"] = "Las pertenencias de Bijou";
      ["req"] = 55;
   };
   [1250] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Speak to Mikhail in the Wetlands.";
      ["next"] = 1264;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1249;
      ["prequests"] = {
         [1] = 1249;
      };
      ["level"] = 33;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1258] = {
      ["name_ru"] = "... с крабами";
      ["objective"] = "Bring 12 Pristine Crawler Legs to Morgan Stern in Theramore.";
      ["name_cn"] = "?有?蟹！";
      ["sort"] = "Dustwallow Marsh";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "... Et des bestioles";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "...und Kafer";
      ["followup"] = 1271;
      ["faction"] = "Alliance";
      ["name"] = "... and Bugs";
      ["prev"] = 1204;
      ["prequests"] = {
         [1] = 1204;
      };
      ["reward"] = {
         [1] = 6801;
      };
      ["name_es"] = "...con tropezones";
      ["req"] = 33;
   };
   [1262] = {
      ["name_ru"] = "Сообщение для Зора";
      ["type"] = "Solo";
      ["name_fr"] = "Rapport a Zor";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Bei Zor melden";
      ["name_cn"] = "向佐??告";
      ["name"] = "Report to Zor";
      ["objective"] = "Bring the Jeweled Pendant to Zor Lonetree in Orgrimmar.";
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1261;
      ["prequests"] = {
         [1] = 1261;
      };
      ["level"] = 40;
      ["name_es"] = "Informa a Zor";
      ["req"] = 30;
   };
   [1266] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Find Private Hendel in Dustwallow Marsh.";
      ["next"] = 1324;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1265;
      ["prequests"] = {
         [1] = 1265;
      };
      ["level"] = 36;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1270] = {
      ["name_ru"] = "Побег Вонючки";
      ["type"] = "Escort";
      ["objective"] = "Escort Stinky\" Ignatz";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "Dustwallow Marsh";
      ["name_fr"] = "Sauvetage du Puant";
      ["name_cn"] = "伊格??的逃亡";
      ["reward"] = {
         [1] = 3825;
      };
      ["name_de"] = "Stinkis Flucht";
      ["faction"] = "Horde";
      ["name"] = "Stinky's Escape";
      ["level"] = 37;
      ["name_es"] = "La fuga de Apestoso";
      ["req"] = 30;
   };
   [5094] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out High Executor Derrington.  His base camp is located at the Bulwark, east of Tirisfal Glade and the Undercity.";
      ["next"] = 5096;
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["followup"] = 5096;
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Horde";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [1282] = {
      ["name_ru"] = "Зовут его Улыбка Джим";
      ["type"] = "Solo";
      ["objective"] = "Speak with Captain Garran Vimes on the top floor of Foothold Citadel.";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "微笑的吉姆";
      ["name_fr"] = "Ils l'appellent Jim le Souriant";
      ["name_de"] = "Sie nennen ihn den lachelnden Jim";
      ["faction"] = "Alliance";
      ["name"] = "They Call Him Smiling Jim";
      ["level"] = 35;
      ["name_es"] = "Le llaman Jim Sonrisas";
      ["req"] = 30;
   };
   [1286] = {
      ["name_ru"] = "Дезертиры";
      ["type"] = "Solo";
      ["name_fr"] = "Les deserteurs";
      ["next"] = 1287;
      ["name_de"] = "Die Deserteure";
      ["name"] = "The Deserters";
      ["name_cn"] = "背叛者";
      ["objective"] = "Get information about Reethe from Balos Jacken and the deserters in Dustwallow Marsh.";
      ["series"] = 1;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1285;
      ["prequests"] = {
         [1] = 1285;
      };
      ["level"] = 38;
      ["name_es"] = "Los desertores";
      ["req"] = 30;
   };
   [5158] = {
      ["name_ru"] = "В поисках духовной помощи";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de soutien spirituel";
      ["name_de"] = "Spirituelle Hilfe suchen";
      ["name_cn"] = "水之魂的?助";
      ["objective"] = "Take the Corrupt Moon Well Water to Islen Waterseer in the Barrens.";
      ["sort"] = "Felwood";
      ["faction"] = "Horde";
      ["name"] = "Seeking Spiritual Aid";
      ["prev"] = 5157;
      ["prequests"] = {
         [1] = 5157;
      };
      ["level"] = 52;
      ["name_es"] = "Buscando ayuda espiritual";
      ["req"] = 48;
   };
   [5206] = {
      ["name_ru"] = "Мародеры Дарроушира";
      ["type"] = "Solo";
      ["name_fr"] = "Les maraudeurs de Comte-de-Darrow";
      ["repgain"] = {
         [529] = 100;
      };
      ["name_de"] = "Marodeure von Darroheim";
      ["name_cn"] = "?隆郡的掠?者";
      ["objective"] = "Bring 5 Resonating Skulls and the Mystic Crystal to Carlin Redpath in Eastern Plaguelands.";
      ["next"] = 5941;
      ["sort"] = "Eastern Plaguelands";
      ["name"] = "Marauders of Darrowshire";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 5181;
         [2] = 5168;
      };
      ["level"] = 60;
      ["name_es"] = "Los merodeadores de Villa Darrow";
      ["req"] = 50;
   };
   [5222] = {
      ["name_ru"] = "Цель: Удел Страданий";
      ["objective"] = "Go to the Writhing Haunt in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Writhing Haunt Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：?哭鬼屋";
      ["sort"] = "Western Plaguelands";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: le Repaire putride";
      ["next"] = 5223;
      ["name_de"] = "Ziel: Das Trostlose Feld";
      ["repgain"] = {
         [469] = 250;
         [529] = 250;
      };
      ["followup"] = 5223;
      ["name"] = "Target: Writhing Haunt";
      ["prev"] = 5220;
      ["prequests"] = {
         [1] = 5220;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Objetivo: El Tormento";
      ["req"] = 50;
   };
   [5238] = {
      ["name_ru"] = "Задание выполнено!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [469] = 500;
         [529] = 500;
      };
      ["name_de"] = "Mission erfullt!";
      ["name_fr"] = "Mission accomplie?!";
      ["name_cn"] = "任?完成！";
      ["faction"] = "Alliance";
      ["name"] = "Mission Accomplished!";
      ["reward"] = {
         [1] = 15801;
         [2] = 15799;
         [3] = 15800;
      };
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5226;
      ["prequests"] = {
         [1] = 5226;
      };
      ["level"] = 58;
      ["name_es"] = "!Mision cumplida!";
      ["req"] = 50;
   };
   [1318] = {
      ["name_ru"] = "Неоконченное дело Гордоков";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Gauntlet of Gordok Might and return it to Captain Kromcrush in Dire Maul.$B$BAccording to Kromcrush, the old timey story\" says that Tortheldrin - a \"creepy\" elf who called himself a prince - stole it from one of the Gordok kings.\"";
      ["name_fr"] = "Affaires inachevees chez les Gordok";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "戈多克食人魔的事?";
      ["reward"] = {
         [1] = 18366;
         [2] = 18367;
         [3] = 18368;
         [4] = 18369;
      };
      ["name_de"] = "Die offene Rechnung der Gordok";
      ["faction"] = "Horde";
      ["name"] = "Unfinished Gordok Business";
      ["level"] = 60;
      ["name_es"] = "Asunto Gordok sin finiquitar";
      ["req"] = 56;
   };
   [1322] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["next"] = 1323;
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name"] = "The Black Shield";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Acquire 5 Acidic Venom Sacs for Do'gol in Brackenwall Village.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1321;
      ["prequests"] = {
         [1] = 1321;
      };
      ["level"] = 37;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [5302] = {
      ["name_ru"] = "Путь оружейника";
      ["type"] = "Solo";
      ["objective"] = "To become a Weaponsmith, you must make the following items and return them to Borgosh: 4 Moonsteel Broadswords, 4 Massive Iron Axes, 2 Heavy Mithril Axes, and 2 Big Black Maces.$B";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "武器?造?之道";
      ["name_fr"] = "La voie du Forgeron d'armes";
      ["name_de"] = "Der Weg des Waffenschmieds...";
      ["faction"] = "Horde";
      ["name"] = "The Way of the Weaponsmith";
      ["level"] = 40;
      ["name_es"] = "El arte del forjador de armas";
      ["req"] = 40;
   };
   [1338] = {
      ["name_ru"] = "Заказ Грозовой Вершины";
      ["type"] = "Solo";
      ["objective"] = "Bring Stormpike's Request to Furen Longbeard in Stormwind.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "La mission de Foudrepique";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "??・雷矛的??";
      ["name_de"] = "Sturmlanzes Bestellung";
      ["faction"] = "Alliance";
      ["name"] = "Stormpike's Order";
      ["level"] = 14;
      ["name_es"] = "Un pedido de Pico Tormenta";
      ["req"] = 9;
   };
   [5382] = {
      ["name_ru"] = "Доктор Теолен Крастинов ? Мясник";
      ["type"] = "Dungeon";
      ["objective"] = "Find Doctor Theolen Krastinov inside the Scholomance. Destroy him, then burn the Remains of Eva Sarkhoff and the Remains of Lucien Sarkhoff. Return to Eva Sarkhoff when the task is complete.$B";
      ["next"] = 5515;
      ["sort"] = "Scholomance";
      ["name_cn"] = "瑟?林・?斯迪?夫教授";
      ["name_fr"] = "Docteur Theolen Krastinov, le boucher";
      ["name_de"] = "Doktor Theolen Krastinov, der Schlachter";
      ["faction"] = "Horde";
      ["name"] = "Doctor Theolen Krastinov, the Butcher";
      ["level"] = 60;
      ["name_es"] = "Doctor Theolen Krastinov, el Carnicero";
      ["req"] = 55;
   };
   [1358] = {
      ["name_ru"] = "Образец для Хелбрима";
      ["type"] = "Solo";
      ["objective"] = "Bring the Wolf Heart Sample to Apothecary Helbrim in the Barrens.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Probe fur Helbrim";
      ["reward"] = {
         [1] = 10637;
         [2] = 10638;
      };
      ["name_cn"] = "?赫布瑞姆的?本";
      ["name_fr"] = "Un echantillon pour Helbrim";
      ["faction"] = "Horde";
      ["name"] = "Sample for Helbrim";
      ["sort"] = "Undercity";
      ["prev"] = 1359;
      ["prequests"] = {
         [1] = 1359;
      };
      ["level"] = 15;
      ["name_es"] = "Muestra para Helbrim";
      ["req"] = 10;
   };
   [1362] = {
      ["name_ru"] = "Кентавры Пустошей";
      ["type"] = "Solo";
      ["objective"] = "Speak with Felgur Twocuts at Ghost Walker Post in Desolace.";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_fr"] = "Les Kolkar de Desolace";
      ["sort"] = "Desolace";
      ["name_cn"] = "凄凉之地的科??部族";
      ["name_de"] = "Die Kolkar von Desolace";
      ["faction"] = "Horde";
      ["name"] = "The Kolkar of Desolace";
      ["level"] = 32;
      ["name_es"] = "Los Kolkar de Desolace";
      ["req"] = 30;
   };
   [1366] = {
      ["name_ru"] = "Награда за кентавров";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Centaur Ears to Felgur Twocuts in Desolace.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Zentaurenkopfgeld";
      ["reward"] = {
         [1] = 6780;
         [2] = 6784;
      };
      ["name_cn"] = "??半人?";
      ["name_fr"] = "La prime aux centaures";
      ["faction"] = "Horde";
      ["name"] = "Centaur Bounty";
      ["sort"] = "Desolace";
      ["prev"] = 1365;
      ["prequests"] = {
         [1] = 1365;
      };
      ["level"] = 31;
      ["name_es"] = "Coleccion de orejas";
      ["req"] = 30;
   };
   [1370] = {
      ["name_ru"] = "Похищение припасов";
      ["type"] = "Solo";
      ["name_fr"] = "Voleur de viande";
      ["next"] = 1373;
      ["name_de"] = "Diebstahl von Vorraten";
      ["name_cn"] = "?取物?";
      ["objective"] = "Bring 6 bags of Crudely Dried Meat to Uthek the Wise in the Gelkis Village.";
      ["sort"] = "Desolace";
      ["reward"] = {
         [1] = 3463;
         [2] = 3464;
         [3] = 3465;
      };
      ["name"] = "Stealing Supplies";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1368;
         [2] = 1384;
      };
      ["level"] = 35;
      ["name_es"] = "!A robar provisiones!";
      ["req"] = 30;
   };
   [1374] = {
      ["name_ru"] = "Вождь Джен";
      ["type"] = "Solo";
      ["name_fr"] = "Khan Jehn";
      ["next"] = 1380;
      ["name_de"] = "Khan Jehn";
      ["name_cn"] = "杰恩可汗";
      ["objective"] = "Bring the Khan Jehn's Head to Uthek the Wise in the Gelkis Village in Desolace.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "Khan Jehn";
      ["prev"] = 1373;
      ["prequests"] = {
         [1] = 1373;
      };
      ["level"] = 37;
      ["name_es"] = "Khan Jehn";
      ["req"] = 30;
   };
   [5510] = {
      ["name_ru"] = "Камни приспешников Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Pierres du Fleau des serviteurs";
      ["name_cn"] = "爪牙的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Dieners";
      ["faction"] = "Horde";
      ["name"] = "Minion's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del esbirro";
      ["req"] = 50;
   };
   [5526] = {
      ["name_ru"] = "Осколки сквернита";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Felvine in Dire Maul and acquire a shard from it.  Chances are you'll only be able to procure one with the demise of Alzzin the Wildshaper.  Use the Reliquary of Purity to securely seal the shard inside, and return it to Rabine Saturna in Nighthaven, Moonglade.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_de"] = "Die Splitter der Teufelsranke";
      ["reward"] = {
         [1] = 18535;
         [2] = 18536;
      };
      ["name_cn"] = "魔藤碎片";
      ["name_fr"] = "Fragment de la Gangrevigne";
      ["faction"] = "Horde";
      ["name"] = "Shards of the Felvine";
      ["sort"] = "Moonglade";
      ["prev"] = 5527;
      ["prequests"] = {
         [1] = 5527;
      };
      ["level"] = 60;
      ["name_es"] = "Fragmentos de gangrevid";
      ["req"] = 56;
   };
   [5542] = {
      ["name_ru"] = "Псы-демоны";
      ["type"] = "Solo";
      ["objective"] = "Slay 20 Plaguehound Runts, 5 Plaguehounds and 5 Frenzied Plaguehounds. Return to Tirion Fordring when the task is complete.";
      ["next"] = 5742;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?魔之犬";
      ["name_fr"] = "Chiens-demons";
      ["followup"] = 5742;
      ["name_de"] = "Damonenhunde";
      ["faction"] = "Horde";
      ["name"] = "Demon Dogs";
      ["level"] = 56;
      ["name_es"] = "Perros demoniacos";
      ["req"] = 52;
   };
   [1394] = {
      ["name_ru"] = "Финальное испытание";
      ["type"] = "Solo";
      ["objective"] = "Speak to Dorn Plainstalker in Thousand Needles.";
      ["repgain"] = {
         [76] = 500;
         [68] = 500;
         [81] = 500;
         [530] = 500;
      };
      ["name_de"] = "Letzte Uberfahrt";
      ["reward"] = {
         [1] = 6804;
         [2] = 6806;
      };
      ["name_cn"] = "通???";
      ["name_fr"] = "Le dernier voyage";
      ["faction"] = "Horde";
      ["name"] = "Final Passage";
      ["sort"] = "Thousand Needles";
      ["prev"] = 6628;
      ["prequests"] = {
         [1] = 6628;
      };
      ["level"] = 36;
      ["name_es"] = "La recta final";
      ["req"] = 25;
   };
   [1398] = {
      ["name_ru"] = "Плавник";
      ["type"] = "Solo";
      ["name_fr"] = "Bois flotte";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Treibholz";
      ["name"] = "Driftwood";
      ["name_cn"] = "晒干的流木";
      ["objective"] = "Bring 8 pieces of Sundried Driftwood to Watcher Biggs in the Swamp of Sorrows.";
      ["next"] = 1425;
      ["faction"] = "Alliance";
      ["sort"] = "Swamp of Sorrows";
      ["prev"] = 1421;
      ["prequests"] = {
         [1] = 1421;
      };
      ["level"] = 42;
      ["name_es"] = "Madera a la deriva";
      ["req"] = 30;
   };
   [5622] = {
      ["name_ru"] = "Во имя Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Laurna Morninglight in Teldrassil.";
      ["next"] = 5621;
      ["name_de"] = "Elune geneigt";
      ["sort"] = "Priest";
      ["name_cn"] = "月神的恩?";
      ["name_fr"] = "Au service d'Elune";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "In Favor of Elune";
      ["level"] = 4;
      ["name_es"] = "Los caminos de Elune";
      ["req"] = 5;
   };
   [5638] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["sort"] = "Priest";
      ["name_cn"] = "?望祷言*";
      ["name_fr"] = "Priere du desespoir";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [5654] = {
      ["name_ru"] = "Обессиливающий сглаз";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Verhexung der Schwache";
      ["name_cn"] = "虚弱妖?";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Hex of Weakness";
      ["level"] = 10;
      ["name_es"] = "Maleficio de Debilidad";
      ["req"] = 10;
   };
   [1418] = {
      ["name_ru"] = "Ника Алый Шрам";
      ["type"] = "Solo";
      ["objective"] = "Speak with Neeka Bloodscar.";
      ["next"] = 1420;
      ["name_fr"] = "Neeka Balafre-sanglante";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "尼?・血痕";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Neeka Blutnarbe";
      ["faction"] = "Horde";
      ["name"] = "Neeka Bloodscar";
      ["level"] = 35;
      ["name_es"] = "Neeka Marca de Sangre";
      ["req"] = 30;
   };
   [1422] = {
      ["name_ru"] = "Угроза с моря";
      ["type"] = "Solo";
      ["name_fr"] = "Le danger venu des flots";
      ["next"] = 1426;
      ["name_de"] = "Gefahr aus dem Meer";
      ["name"] = "Threat From the Sea";
      ["name_cn"] = "海中的威?";
      ["objective"] = "Speak to Katar in the Swamp of Sorrows.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Swamp of Sorrows";
      ["prev"] = 699;
      ["prequests"] = {
         [1] = 699;
      };
      ["level"] = 45;
      ["name_es"] = "La amenaza maritima";
      ["req"] = 35;
   };
   [1426] = {
      ["name_ru"] = "Угроза с моря";
      ["objective"] = "Kill 10 Marsh Murlocs, 10 Marsh Inkspewer, and 10 Marsh Flesheater, then return to Katar in the Swamp of Sorrows.";
      ["name_cn"] = "海中的威?";
      ["sort"] = "Swamp of Sorrows";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Le danger venu des flots";
      ["next"] = 1427;
      ["name_de"] = "Gefahr aus dem Meer";
      ["repgain"] = {
         [76] = 350;
      };
      ["faction"] = "Horde";
      ["name"] = "Threat From the Sea";
      ["prev"] = 1422;
      ["prequests"] = {
         [1] = 1422;
      };
      ["series"] = 2;
      ["name_es"] = "La amenaza maritima";
      ["req"] = 35;
   };
   [1430] = {
      ["name_ru"] = "Свежее мясо";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Monstrous Crawler Legs to Dar in the Swamp of Sorrows.";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Swamp of Sorrows";
      ["name_fr"] = "Viande fraiche";
      ["name_cn"] = "新?的?蟹腿";
      ["reward"] = {
         [1] = 9681;
         [2] = 9682;
      };
      ["name_de"] = "Frischfleisch";
      ["faction"] = "Horde";
      ["name"] = "Fresh Meat";
      ["level"] = 44;
      ["name_es"] = "Carne fresca";
      ["req"] = 35;
   };
   [1434] = {
      ["name_ru"] = "Опоганенные сатиры";
      ["type"] = "Solo";
      ["objective"] = "Slay 7 Hatefury Rogues, 7 Hatefury Felsworn, 7 Hatefury Betrayers, and 7 Hatefury Hellcallers, and return to Takata Steelblade in Desolace.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Souille par les satyres";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?特的威?";
      ["name_de"] = "Beschmutzt durch Satyrn";
      ["faction"] = "Horde";
      ["name"] = "Befouled by Satyr";
      ["level"] = 33;
      ["name_es"] = "La contaminacion del satiro";
      ["req"] = 25;
   };
   [1438] = {
      ["name_ru"] = "Расследование Валарриэля";
      ["objective"] = "Find Dalinda Malem in Desolace.";
      ["name_cn"] = "瓦拉里?的搜?";
      ["sort"] = "Desolace";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "La recherche de Vahlarriel";
      ["next"] = 1439;
      ["name_de"] = "Vahlarriels Suche";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Vahlarriel's Search";
      ["prev"] = 1465;
      ["prequests"] = {
         [1] = 1465;
      };
      ["series"] = 3;
      ["name_es"] = "Buscando para Vahlarriel";
      ["req"] = 30;
   };
   [1442] = {
      ["name_ru"] = "Поиск самоцвета Кора";
      ["type"] = "Dungeon";
      ["name_fr"] = "A la recherche de la gemme de Kor";
      ["name_de"] = "Suche nach dem Koredelstein";
      ["sort"] = "Paladin";
      ["objective"] = "Bring a Kor Gem to Thundris Windweaver in Darkshore.";
      ["name_cn"] = "?找科?宝石";
      ["name"] = "Seeking the Kor Gem";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 7083;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 1653;
      ["prequests"] = {
         [1] = 1653;
      };
      ["level"] = 22;
      ["name_es"] = "La busqueda de la gema Kor";
      ["req"] = 20;
   };
   [1446] = {
      ["name_ru"] = "Джаммал'ан Пророк";
      ["type"] = "Dungeon";
      ["objective"] = "The Atal'ai Exile in The Hinterlands wants the Head of Jammal'an.";
      ["name_fr"] = "Jammal'an le Prophete";
      ["sort"] = "Sunken Temple";
      ["name_cn"] = "?言者迦??";
      ["reward"] = {
         [1] = 11123;
         [2] = 11124;
      };
      ["name_de"] = "Jammal'an der Prophet";
      ["faction"] = "Horde";
      ["name"] = "Jammal'an the Prophet";
      ["level"] = 53;
      ["name_es"] = "Jammal'an el Profeta";
      ["req"] = 38;
   };
   [1450] = {
      ["name_ru"] = "Укротитель грифонов Разящий Коготь";
      ["type"] = "Solo";
      ["name_fr"] = "Le maitre des griffons Hachegriffe";
      ["next"] = 1451;
      ["name_de"] = "Greifenmeister Krallenaxt";
      ["name_cn"] = "??管理?";
      ["objective"] = "Speak with Gryphon Master Talonaxe inside the Aerie Peak Aviary.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Alliance";
      ["name"] = "Gryphon Master Talonaxe";
      ["prev"] = 1449;
      ["prequests"] = {
         [1] = 1449;
      };
      ["level"] = 43;
      ["name_es"] = "Maestro de grifos Garracha";
      ["req"] = 38;
   };
   [1454] = {
      ["name_ru"] = "Пожитки Карнитола";
      ["objective"] = "Find Karnitol's Chest in Desolace.";
      ["name_cn"] = "?尼托的海?";
      ["sort"] = "Desolace";
      ["level"] = 39;
      ["type"] = "Solo";
      ["name_fr"] = "L'epave de Karnitol";
      ["next"] = 1455;
      ["name_de"] = "Karnitols Schiffbruch";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Karnitol Shipwreck";
      ["prev"] = 1453;
      ["prequests"] = {
         [1] = 1453;
      };
      ["series"] = 1;
      ["name_es"] = "El naufragio de Karnitol";
      ["req"] = 30;
   };
   [1458] = {
      ["name_ru"] = "Реагенты для Поисковой корпорации";
      ["objective"] = "Bring 10 Hatefury Claws, and 10 Hatefury Horns to Kreldig Ungor in Desolace.";
      ["name_cn"] = "?物公司的委托";
      ["sort"] = "Desolace";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "Des reactifs pour Recuperateurs SA";
      ["next"] = 1459;
      ["name_de"] = "Reagenzien fur die Wiederholer AG";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Reagents for Reclaimers Inc.";
      ["prev"] = 1453;
      ["prequests"] = {
         [1] = 1453;
      };
      ["series"] = 1;
      ["name_es"] = "Componentes para Recuperadores S.A.";
      ["req"] = 30;
   };
   [1462] = {
      ["name_ru"] = "Сапта земли";
      ["type"] = "Solo";
      ["objective"] = "Speak to Seer Ravenfeather for another Earth Sapta.";
      ["name_fr"] = "Le sapta de terre";
      ["sort"] = "Shaman";
      ["name_cn"] = "大地?契";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 6635;
      };
      ["name_de"] = "Erdsapta";
      ["faction"] = "Horde";
      ["name"] = "Earth Sapta";
      ["level"] = 4;
      ["name_es"] = "Sapta de tierra";
      ["req"] = 4;
   };
   [1466] = {
      ["name_ru"] = "Реагенты для Поисковой корпорации";
      ["objective"] = "Bring 10 Felhound Brains, 10 Nether Wings, and 10 vials of Doomwarder Blood to Kreldig Ungor in Desolace.";
      ["name_cn"] = "?物公司的委托";
      ["sort"] = "Desolace";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Des reactifs pour Recuperateurs SA";
      ["next"] = 1467;
      ["name_de"] = "Reagenzien fur die Wiederholer AG";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Reagents for Reclaimers Inc.";
      ["prev"] = 1459;
      ["prequests"] = {
         [1] = 1459;
      };
      ["series"] = 3;
      ["name_es"] = "Componentes para Recuperadores S.A.";
      ["req"] = 30;
   };
   [1470] = {
      ["name_ru"] = "Приоткрывая завесу";
      ["type"] = "Solo";
      ["objective"] = "Bring Venya Marthand 3 Rattlecage Skulls.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Lever le voile";
      ["sort"] = "Warlock";
      ["name_cn"] = "控制小鬼";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Der zerrissene Schleier";
      ["faction"] = "Horde";
      ["name"] = "Piercing the Veil";
      ["level"] = 3;
      ["name_es"] = "Descubrir el misterio";
      ["req"] = 1;
   };
   [1474] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Pure Hearts, summon and subdue a succubus, then return the Pure Hearts to Carendin Halgar in the Magic Quarter of the Undercity.";
      ["reward"] = {
         [1] = 22243;
      };
      ["name_cn"] = "誓?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Binding";
      ["sort"] = "Warlock";
      ["prev"] = 1476;
      ["prequests"] = {
         [1] = 1476;
      };
      ["level"] = 20;
      ["name_es"] = "El vinculo";
      ["req"] = 20;
   };
   [1478] = {
      ["name_ru"] = "Призыв Халгара";
      ["type"] = "Solo";
      ["objective"] = "Speak with Carendin Halgar in the Undercity.";
      ["next"] = 1473;
      ["sort"] = "Warlock";
      ["name_cn"] = "哈加?的召?";
      ["name_fr"] = "Les invocations de Halgar";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 1473;
      ["name_de"] = "Halgars Beschworung";
      ["faction"] = "Horde";
      ["name"] = "Halgar's Summons";
      ["level"] = 10;
      ["name_es"] = "Las invocaciones de Halgar";
      ["req"] = 10;
   };
   [5926] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Turak Runetotem on the Elder Rise of Thunder Bluff.";
      ["next"] = 5922;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "??召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [5942] = {
      ["name_ru"] = "Спрятанные сокровища";
      ["type"] = "Solo";
      ["objective"] = "Bring Joseph's Key to Joseph's Chest.";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Versteckte Schatze";
      ["reward"] = {
         [1] = 15855;
         [2] = 15856;
         [3] = 15857;
      };
      ["name_cn"] = "?藏的宝藏";
      ["name_fr"] = "Tresors caches";
      ["faction"] = "Horde";
      ["name"] = "Hidden Treasures";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5721;
      ["prequests"] = {
         [1] = 5721;
      };
      ["level"] = 60;
      ["name_es"] = "Tesoros ocultos";
      ["req"] = 50;
   };
   [1490] = {
      ["name_ru"] = "Нара Буйногривая";
      ["type"] = "Solo";
      ["name_fr"] = "Nara Crin-sauvage";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Nara Wildmahne";
      ["name"] = "Nara Wildmane";
      ["name_cn"] = "?拉・蛮?";
      ["objective"] = "Speak with Nara Wildmane.";
      ["next"] = 914;
      ["faction"] = "Horde";
      ["sort"] = "Wailing Caverns";
      ["prev"] = 1489;
      ["prequests"] = {
         [1] = 1489;
      };
      ["level"] = 16;
      ["name_es"] = "Nara Ferocrin";
      ["req"] = 12;
   };
   [1498] = {
      ["name_ru"] = "Путь защиты";
      ["type"] = "Solo";
      ["name_fr"] = "La voie de la defense";
      ["next"] = 1502;
      ["name_de"] = "Weg der Verteidigung";
      ["objective"] = "Bring 5 Singed Scales to Uzzek at Far Watch Post in the Barrens.";
      ["name_cn"] = "防御之道";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Path of Defense";
      ["prev"] = 1505;
      ["prequests"] = {
         [1] = 1505;
      };
      ["level"] = 10;
      ["name_es"] = "Camino de defensa";
      ["req"] = 10;
   };
   [1502] = {
      ["name_ru"] = "Тун'грим Огневзор";
      ["type"] = "Solo";
      ["name_fr"] = "Thun'grim Mirefeu";
      ["next"] = 1503;
      ["name_de"] = "Thun'grim Brandblick";
      ["objective"] = "Speak with Thun'grim Firegaze in the Barrens.";
      ["name_cn"] = "索恩格瑞姆・火眼";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Thun'grim Firegaze";
      ["prev"] = 1498;
      ["prequests"] = {
         [1] = 1498;
      };
      ["level"] = 10;
      ["name_es"] = "Thun'grim Vistafuego";
      ["req"] = 10;
   };
   [1506] = {
      ["name_ru"] = "Призыв от Ган'рула";
      ["type"] = "Solo";
      ["objective"] = "Speak with Gan'rul Bloodeye in Orgrimmar.";
      ["next"] = 1501;
      ["sort"] = "Warlock";
      ["name_cn"] = "甘??的召?";
      ["name_fr"] = "Les invocations de Gan'rul";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 1501;
      ["name_de"] = "Gan'ruls Beschworung";
      ["faction"] = "Horde";
      ["name"] = "Gan'rul's Summons";
      ["level"] = 10;
      ["name_es"] = "Las invocaciones de Gan'rul";
      ["req"] = 10;
   };
   [1510] = {
      ["name_ru"] = "Вести о Догране";
      ["objective"] = "Speak with Ken'zigla at the Malaka'jin.";
      ["name_cn"] = "多格?的消息";
      ["sort"] = "Warlock";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Des nouvelles de Dogran";
      ["next"] = 1511;
      ["name_de"] = "Neuigkeiten von Dogran";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "News of Dogran";
      ["prev"] = 1509;
      ["prequests"] = {
         [1] = 1509;
      };
      ["series"] = 2;
      ["name_es"] = "Noticias de Dogran";
      ["req"] = 20;
   };
   [1514] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [6070] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Thotar at Razor Hill.";
      ["next"] = 6062;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6086] = {
      ["name_ru"] = "Обучение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Entrainer la bete";
      ["name_de"] = "Die Ausbildung des Tiers";
      ["objective"] = "Speak with Belia Thundergranite in Ironforge.";
      ["name_cn"] = "??野?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Training the Beast";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 6085;
      ["prequests"] = {
         [1] = 6085;
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6102] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Strigid Screecher. Practice your skills, then return the Taming Rod to Dazalar in Dolanaar.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6103;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6101;
      ["prequests"] = {
         [1] = 6101;
      };
      ["series"] = 3;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [1530] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 1535;
      ["name_de"] = "Ruf des Wassers";
      ["objective"] = "Find Brine in Southern Barrens.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["series"] = 1;
      ["name"] = "Call of Water";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1528;
         [2] = 2985;
         [3] = 1529;
         [4] = 2986;
      };
      ["level"] = 22;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [6134] = {
      ["name_ru"] = "Сбор эктоплазмы";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Ghost-o-plasms and the Crate of Ghost Magnets to Hornizz Brimbuzzle in Desolace.";
      ["name_fr"] = "Chasse a l'ectoplasme";
      ["sort"] = "Desolace";
      ["name_cn"] = "幽???";
      ["reward"] = {
         [1] = 15864;
         [2] = 15865;
      };
      ["name_de"] = "Geisterplasmasuche";
      ["faction"] = "Horde";
      ["name"] = "Ghost-o-plasm Round Up";
      ["level"] = 39;
      ["name_es"] = "La caza de ectoplasmas";
      ["req"] = 34;
   };
   [8235] = {
      ["name_ru"] = "Зашифрованные фрагменты";
      ["objective"] = "Bring 10 Encoded Fragments to Archmage Xylem in Azshara.";
      ["name_cn"] = "密文碎片";
      ["sort"] = "Rogue";
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Les fragments codes";
      ["next"] = 8236;
      ["name_de"] = "Verschlusselte Fragmente";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["repgain"] = {
         [349] = 250;
      };
      ["name"] = "Encoded Fragments";
      ["prev"] = 8234;
      ["prequests"] = {
         [1] = 8234;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los trozos codificados";
      ["req"] = 50;
   };
   [8267] = {
      ["name_ru"] = "Ленты жертвоприношения";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ribbons of Sacrifice to Captain Shatterskull so that the Outriders may reward you for acting on our behalf.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "奉献??";
      ["name_fr"] = "Les rubans de sacrifice";
      ["name_de"] = "Aufopferungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ribbons of Sacrifice";
      ["level"] = 60;
      ["name_es"] = "Galon de sacrificio";
      ["req"] = 40;
   };
   [8299] = {
      ["name_ru"] = "Перекрыть линии поставок Аратора";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "切断阿拉索???";
      ["name_fr"] = "Couper les voies de ravitaillement d'Arathor";
      ["name_de"] = "Zerschlagt die Versorgungslinien Arathors";
      ["faction"] = "Horde";
      ["name"] = "Cut Arathor Supply Lines";
      ["level"] = 60;
      ["name_es"] = "Cortale el suministro a la Liga de Arathor";
      ["req"] = 60;
   };
   [8331] = {
      ["name_ru"] = "Аурель Золотой Лист";
      ["type"] = "Group";
      ["objective"] = "Speak with Aurel Goldleaf in Cenarion Hold.";
      ["next"] = 8332;
      ["name_fr"] = "Aurel Feuilledor";
      ["sort"] = "Silithus";
      ["name_cn"] = "奥莉?・金叶";
      ["repgain"] = {
         [609] = 25;
      };
      ["name_de"] = "Aurel Goldblatt";
      ["faction"] = "Horde";
      ["name"] = "Aurel Goldleaf";
      ["level"] = 60;
      ["name_es"] = "Aurel Hojaurea";
      ["req"] = 60;
   };
   [8363] = {
      ["name_ru"] = "Перстни Бездны";
      ["type"] = "Group";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Abyssische Siegel";
      ["name_fr"] = "Les chevalieres abyssales";
      ["name_cn"] = "深渊徽?";
      ["faction"] = "Horde";
      ["name"] = "Abyssal Signets";
      ["reward"] = {
         [1] = 20601;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8348;
      ["prequests"] = {
         [1] = 8348;
      };
      ["level"] = 60;
      ["name_es"] = "Sellos abisales";
      ["req"] = 60;
   };
   [8395] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 100;
      };
      ["name_fr"] = "La revendication du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["level"] = 59;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 50;
   };
   [8427] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 39;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 30;
   };
   [1578] = {
      ["name_ru"] = "Помощь фронту";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Copper Axes and 6 Copper Chain Belts to Thorvald in the southern guard tower of Loch Modan.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Reequiper le front";
      ["name_cn"] = "前?的??";
      ["reward"] = {
         [1] = 3609;
      };
      ["name_de"] = "Nachschub fur die Front";
      ["faction"] = "Alliance";
      ["name"] = "Supplying the Front";
      ["level"] = 12;
      ["name_es"] = "Abastecer al frente";
      ["req"] = 1;
   };
   [1582] = {
      ["name_ru"] = "Жилет лунного сияния";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Embossed Leather Gloves, 5 Embossed Leather Boots and 5 Embossed Leather Cloaks to Lotherias in Darnassus.";
      ["repgain"] = {
         [609] = 25;
      };
      ["sort"] = "Leatherworking";
      ["name_fr"] = "Le gilet Lueur-de-lune";
      ["name_cn"] = "月光外衣";
      ["reward"] = {
         [1] = 6710;
      };
      ["name_de"] = "Mondscheinweste";
      ["faction"] = "Alliance";
      ["name"] = "Moonglow Vest";
      ["level"] = 18;
      ["name_es"] = "El jubon resplandor lunar";
      ["req"] = 8;
   };
   [6342] = {
      ["name_ru"] = "Полет в Аубердин";
      ["type"] = "Solo";
      ["name_fr"] = "Vol vers Auberdine";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Ein unerwartetes Geschenk";
      ["objective"] = "Ride a hippogryph to Auberdine from the hippogryph master Vesprystus, then bring Nessa's Collection to Laird.";
      ["name_cn"] = "?往奥伯丁";
      ["next"] = 6343;
      ["sort"] = "Darkshore";
      ["name"] = "Flight to Auberdine";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 6341;
      ["prequests"] = {
         [1] = 6341;
      };
      ["level"] = 10;
      ["name_es"] = "Un regalo inesperado";
      ["req"] = 10;
   };
   [8619] = {
      ["name_ru"] = "Предок Утренний Туман";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Gouffre-du-matin";
      ["name_cn"] = "黎明?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Schwermut";
      ["faction"] = "Horde";
      ["name"] = "Morndeep the Elder";
      ["level"] = 60;
      ["name_es"] = "Alborhondo el Ancestro";
      ["req"] = 1;
   };
   [8651] = {
      ["name_ru"] = "Предок Сталекрут";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Baguefer";
      ["name_cn"] = "???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Eisenband";
      ["faction"] = "Horde";
      ["name"] = "Ironband the Elder";
      ["level"] = 60;
      ["name_es"] = "Vetaferro el Ancestro";
      ["req"] = 1;
   };
   [8683] = {
      ["name_ru"] = "Предок Рассветная Странница";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Aube-glorieuse";
      ["name_cn"] = "晨行?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Morgenwandler";
      ["faction"] = "Horde";
      ["name"] = "Dawnstrider the Elder";
      ["level"] = 60;
      ["name_es"] = "Caminalba el Ancestro";
      ["req"] = 1;
   };
   [8715] = {
      ["name_ru"] = "Предок Остролист";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Feuillelame";
      ["name_cn"] = "?叶?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Messerblatt";
      ["faction"] = "Horde";
      ["name"] = "Bladeleaf the Elder";
      ["level"] = 60;
      ["name_es"] = "Filohoja el Ancestro";
      ["req"] = 1;
   };
   [8747] = {
      ["name_ru"] = "Путь защитника";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "La voie du Protecteur";
      ["name_cn"] = "保?者之路";
      ["reward"] = {
         [1] = 21196;
      };
      ["name_de"] = "Der Pfad des Beschutzers";
      ["faction"] = "Horde";
      ["name"] = "The Path of the Protector";
      ["level"] = 60;
      ["name_es"] = "El camino del protector";
      ["req"] = 60;
   };
   [8779] = {
      ["name_ru"] = "Материалы для гадания";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Large Brilliant Shard, 1 Large Radiant Shard and 1 Huge Emerald to Geologist Larksbane at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing V in order to complete this quest.";
      ["name_fr"] = "Le materiel de divination";
      ["sort"] = "Silithus";
      ["name_cn"] = "研究材料";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Magische Materialien";
      ["faction"] = "Alliance";
      ["name"] = "Scrying Materials";
      ["level"] = 60;
      ["name_es"] = "Materiales de vision";
      ["req"] = 60;
   };
   [8811] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8843] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8825;
      ["prequests"] = {
         [1] = 8825;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8875] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger at the Elder Rise in Thunder Bluff.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Horde";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [6502] = {
      ["name_ru"] = "Амулет Пламени дракона";
      ["type"] = "Raid";
      ["name_fr"] = "Amulette drakefeu";
      ["name_de"] = "Drachenfeueramulett";
      ["reward"] = {
         [1] = 16309;
      };
      ["name_cn"] = "?火?符";
      ["objective"] = "You must retrieve the Blood of the Black Dragon Champion from General Drakkisath. Drakkisath can be found in his throne room behind the Halls of Ascension in Blackrock Spire.";
      ["faction"] = "Alliance";
      ["name"] = "Drakefire Amulet";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 6501;
      ["prequests"] = {
         [1] = 6501;
      };
      ["level"] = 60;
      ["name_es"] = "Amuleto Pirodraco";
      ["req"] = 50;
   };
   [8939] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Magister's Belt and a set of Magister's Gloves to Mokvar in Orgrimmar.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22062;
         [2] = 22066;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [1638] = {
      ["name_ru"] = "Обучение воина";
      ["type"] = "Solo";
      ["objective"] = "Speak with Harry Burlguard.";
      ["next"] = 1639;
      ["sort"] = "Warrior";
      ["name_cn"] = "?士的??";
      ["name_fr"] = "L'entrainement du guerrier";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Die Ausbildung eines Kriegers";
      ["faction"] = "Alliance";
      ["name"] = "A Warrior's Training";
      ["level"] = 10;
      ["name_es"] = "Instruccion de guerrero";
      ["req"] = 10;
   };
   [6566] = {
      ["name_ru"] = "Что принес ветер";
      ["type"] = "Solo";
      ["name_fr"] = "Ce que le vent apporte";
      ["next"] = 6567;
      ["name_de"] = "Was der Wind erzahlt";
      ["name_cn"] = "?吹来的消息";
      ["objective"] = "Listen to Thrall.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "What the Wind Carries";
      ["prev"] = 4974;
      ["prequests"] = {
         [1] = 4974;
      };
      ["level"] = 60;
      ["name_es"] = "Lo que trae el viento";
      ["req"] = 55;
   };
   [6582] = {
      ["name_ru"] = "Черепа: Провидец";
      ["type"] = "Raid";
      ["name_fr"] = "L'epreuve des cranes, Clairvoyant";
      ["name_de"] = "Die Prufung der Schadel, Seher";
      ["objective"] = "You must find the blue dragonflight drake champion, Scryer, and slay him. Pry his skull from his corpse and return it to Emberstrife.$B$BYou know that Scryer can be found in Winterspring.";
      ["name_cn"] = "?骨??，斯克利?";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "The Test of Skulls, Scryer";
      ["followup"] = 6585;
      ["prev"] = 6570;
      ["prequests"] = {
         [1] = 6570;
      };
      ["level"] = 60;
      ["name_es"] = "La prueba de los craneos, Aruspice";
      ["req"] = 55;
   };
   [9099] = {
      ["name_ru"] = "Сандалии ледяного огня";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make Frostfire Sandals if you bring her the following: 1 Desecrated Sandals, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.";
      ["name_cn"] = "霜火便鞋";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les sandales de givrefeu";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Frostfeuersandalen";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22500;
      };
      ["name"] = "Frostfire Sandals";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los botines de Fuego de Escarcha";
      ["req"] = 60;
   };
   [1654] = {
      ["name_ru"] = "Испытание доблести";
      ["objective"] = "Using Jordan's Weapon Notes, find some Whitestone Oak Lumber, Bailor's Refined Ore Shipment, Jordan's Smithing Hammer, and a Kor Gem, and return them to Jordan Stilwell in Ironforge.";
      ["name_cn"] = "正???";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 22;
      ["type"] = "Dungeon";
      ["name_fr"] = "Le test de droiture";
      ["next"] = 1806;
      ["name_de"] = "Die Prufung der Rechtschaffenheit";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Test of Righteousness";
      ["prev"] = 1653;
      ["prequests"] = {
         [1] = 1653;
      };
      ["series"] = 2;
      ["name_es"] = "La prueba de rectitud";
      ["req"] = 20;
   };
   [1658] = {
      ["name_ru"] = "Испортить праздник Плетеного Человечка";
      ["type"] = "PvP";
      ["objective"] = "Locate the Forsaken's Wickerman Festival in Tirisfal Glade.  Return to Sergeant Hartman in Southshore once you've done so.";
      ["repgain"] = {
         [72] = 150;
         [54] = 150;
         [69] = 150;
         [47] = 150;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un intrus a la Fete de l'homme d'osier";
      ["name_cn"] = "稻草人的?日";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_de"] = "Bespitzelt das Fest des Weidenmanns";
      ["faction"] = "Alliance";
      ["name"] = "Crashing the Wickerman Festival (PvP)";
      ["level"] = 60;
      ["name_es"] = "Arruinar el Festival del Hombre de Mimbre";
      ["req"] = 25;
   };
   [9195] = {
      ["name_ru"] = "Задание мастера: гоблинская мина";
      ["type"] = "Solo";
      ["objective"] = "Deliver 20 Goblin Sapper Charges and the Craftsman's Writ - Goblin Sapper Charge - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Charges de sapeur gobelin";
      ["name_cn"] = "工匠文? - 地精工兵炸?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Goblinpioniersprengladung";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Goblin Sapper Charge";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: carga de zapador goblin";
      ["req"] = 55;
   };
   [1666] = {
      ["name_ru"] = "Маршал Хаггард";
      ["objective"] = "Speak with Marshal Haggard.";
      ["name_cn"] = "治安官哈迦德";
      ["sort"] = "Warrior";
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Le marechal Haggard";
      ["next"] = 1667;
      ["name_de"] = "Marschall Haggard";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["repgain"] = {
         [72] = 1;
      };
      ["name"] = "Marshal Haggard";
      ["prev"] = 1665;
      ["prequests"] = {
         [1] = 1665;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "El mariscal Haggard";
      ["req"] = 10;
   };
   [9259] = {
      ["name_ru"] = "Предатель Кровавого Паруса";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [21] = 500;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "Un traitre envers la Voile sanglante";
      ["name_cn"] = "血帆海盗的叛徒";
      ["name_de"] = "Verrat am Blutsegel";
      ["faction"] = "Horde";
      ["name"] = "Traitor to the Bloodsail";
      ["level"] = 60;
      ["name_es"] = "Un traidor de Velasangre";
      ["req"] = 30;
   };
   [9323] = {
      ["name_ru"] = "Костры Восточных королевств";
      ["type"] = "Solo";
      ["objective"] = "Visit the Fire Festival camps located in Blasted Lands, Eastern Plaguelands, the Hinterlands and Searing Gorge, then speak with the Festival Flamekeeper.";
      ["name_fr"] = "Feux sauvages dans les Royaumes de l'est";
      ["sort"] = "Midsummer";
      ["name_cn"] = "?部王国的野火";
      ["reward"] = {
         [1] = 23324;
         [2] = 23247;
      };
      ["name_de"] = "Gluhende Feuer in den Ostlichen Konigreichen";
      ["faction"] = "Horde";
      ["name"] = "Wild Fires in the Eastern Kingdoms";
      ["level"] = 60;
      ["name_es"] = "Los fuegos salvajes de los Reinos del Este";
      ["req"] = 50;
   };
   [1682] = {
      ["name_ru"] = "Оружие из серой стали";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Waffen aus grauem Eisen";
      ["name_fr"] = "Armes en fer gris";
      ["name"] = "Grey Iron Weapons";
      ["name_cn"] = "灰?武器";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6978;
         [2] = 6982;
         [3] = 6981;
         [4] = 6984;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1681;
      ["prequests"] = {
         [1] = 1681;
      };
      ["level"] = 10;
      ["name_es"] = "Armas de hierro gris";
      ["req"] = 10;
   };
   [1686] = {
      ["name_ru"] = "Тень Элуры";
      ["type"] = "Solo";
      ["name_fr"] = "L'Ombre d'Elura";
      ["next"] = 1692;
      ["name_de"] = "Eluras Schemen";
      ["objective"] = "Bring 8 loads of Elunite Ore and the Medallion of Elura to Elanaria in Darnassus.";
      ["name_cn"] = "艾?拉的?影";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "The Shade of Elura";
      ["prev"] = 1683;
      ["prequests"] = {
         [1] = 1683;
      };
      ["level"] = 10;
      ["name_es"] = "La sombra de Elura";
      ["req"] = 10;
   };
   [9419] = {
      ["name_ru"] = "Истощение пустыни";
      ["type"] = "PvP";
      ["objective"] = "Find and deliver Silithyst to the Silithyst Extractor, then speak with Marshal Bluewall at the Alliance encampment near Hive'Zora.";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Durchkammen der Wuste";
      ["reward"] = {
         [1] = 13446;
         [2] = 13444;
      };
      ["name_cn"] = "横?沙漠";
      ["name_fr"] = "Passer le desert au peigne fin";
      ["faction"] = "Alliance";
      ["name"] = "Scouring the Desert";
      ["sort"] = "Silithus";
      ["prev"] = 9415;
      ["prequests"] = {
         [1] = 9415;
      };
      ["level"] = 60;
      ["name_es"] = "Peinando el desierto";
      ["req"] = 55;
   };
   [1698] = {
      ["name_ru"] = "Йорус Ячменовар";
      ["type"] = "Solo";
      ["objective"] = "Speak with Yorus Barleybrew.";
      ["next"] = 1699;
      ["sort"] = "Warrior";
      ["name_cn"] = "犹?斯・麦酒";
      ["name_fr"] = "Yorus Brasselorge";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Yorus Gerstenbrau";
      ["faction"] = "Alliance";
      ["name"] = "Yorus Barleybrew";
      ["level"] = 20;
      ["name_es"] = "Yorus Cebadiz";
      ["req"] = 20;
   };
   [1702] = {
      ["name_ru"] = "Щитник";
      ["objective"] = "Bring the Cask of Scalder to Furen Longbeard.";
      ["name_cn"] = "?盾?";
      ["sort"] = "Warrior";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "Fabricant de bouclier";
      ["next"] = 1701;
      ["name_de"] = "Der Schildschmied";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6970;
      };
      ["name"] = "The Shieldsmith";
      ["prev"] = 1699;
      ["prequests"] = {
         [1] = 1699;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "El forjador de escudos";
      ["req"] = 20;
   };
   [6822] = {
      ["name_ru"] = "Огненные Недра";
      ["type"] = "Raid";
      ["name_fr"] = "Le C?ur du Magma";
      ["next"] = 6823;
      ["name_de"] = "Der Geschmolzene Kern";
      ["name_cn"] = "熔火之心";
      ["objective"] = "Kill 1 Fire Lord, 1 Molten Giant, 1 Ancient Core Hound and 1 Lava Surger, then return to Duke Hydraxis in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "The Molten Core";
      ["prev"] = 6821;
      ["prequests"] = {
         [1] = 6821;
      };
      ["level"] = 60;
      ["name_es"] = "El Nucleo de Magma";
      ["req"] = 57;
   };
   [1710] = {
      ["name_ru"] = "Высохшая скорлупа";
      ["type"] = "Solo";
      ["name_fr"] = "Coquilles dessechees au soleil";
      ["name_de"] = "Sonnenverbrannte Schalen";
      ["objective"] = "Bring 20 Sunscorched Shells to Mathiel in Darnassus.";
      ["name_cn"] = "晒焦的蛋?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Sunscorched Shells";
      ["prev"] = 1703;
      ["prequests"] = {
         [1] = 1703;
      };
      ["level"] = 30;
      ["name_es"] = "Cascaras asoladas";
      ["req"] = 20;
   };
   [1714] = {
      ["name_ru"] = "Субстанция Изгнанников";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Warrior";
      ["name_fr"] = "Essence d'exil";
      ["name_cn"] = "流放精?";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6851;
      };
      ["name_de"] = "Essenz der Verbannung";
      ["faction"] = "Horde";
      ["name"] = "Essence of the Exile";
      ["level"] = 37;
      ["name_es"] = "Esencia del exilio";
      ["req"] = 30;
   };
   [1718] = {
      ["name_ru"] = "Островитянин";
      ["type"] = "Solo";
      ["objective"] = "Speak with Klannoc Macleod.";
      ["next"] = 1719;
      ["sort"] = "Warrior";
      ["name_cn"] = "?民";
      ["name_fr"] = "L'ile mortelle";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Der Inselbewohner";
      ["faction"] = "Horde";
      ["name"] = "The Islander";
      ["level"] = 30;
      ["name_es"] = "El isleno";
      ["req"] = 30;
   };
   [1738] = {
      ["name_ru"] = "Сердцедрево";
      ["type"] = "Solo";
      ["name_fr"] = "Le c?ur du bois";
      ["next"] = 1739;
      ["name_de"] = "Herzholz";
      ["objective"] = "Retrieve the Heartswood from Ashenvale and bring it to Gakin the Darkbinder in the Mage Quarter of Stormwind.";
      ["name_cn"] = "同心?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Heartswood";
      ["prev"] = 1716;
      ["prequests"] = {
         [1] = 1716;
      };
      ["level"] = 20;
      ["name_es"] = "Duramen";
      ["req"] = 20;
   };
   [6982] = {
      ["name_ru"] = "Припасы Ледяного Зуба";
      ["type"] = "PvP";
      ["objective"] = "Bring 10 Coldtooth Supplies to the Alliance Quartermaster in Dun Baldar.";
      ["repgain"] = {
         [47] = 25;
         [730] = 2;
      };
      ["name_fr"] = "Fournitures de Froide-dent";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "冷??洞的??";
      ["name_de"] = "Vorrate der Eisbeisermine";
      ["faction"] = "Alliance";
      ["name"] = "Coldtooth Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros de Dentefrio";
      ["req"] = 51;
   };
   [1758] = {
      ["name_ru"] = "Фолиант заговора";
      ["objective"] = "Speak with Krom Stoutarm in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Warlock";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Tome de la Cabale";
      ["next"] = 1802;
      ["name_de"] = "Foliant der Kabale";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Tome of the Cabal";
      ["prev"] = 1798;
      ["prequests"] = {
         [1] = 1798;
      };
      ["series"] = 1;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [7046] = {
      ["name_ru"] = "Скипетр Келебраса";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le sceptre de Celebras";
      ["name_de"] = "Das Szepter von Celebras";
      ["reward"] = {
         [1] = 17191;
      };
      ["name_cn"] = "塞雷布拉斯?杖";
      ["objective"] = "Assist Celebras the Redeemed while he creates the Scepter of Celebras.$B$BSpeak with him when the ritual is complete.";
      ["faction"] = "Horde";
      ["name"] = "The Scepter of Celebras";
      ["sort"] = "Maraudon";
      ["prev"] = 7044;
      ["prequests"] = {
         [1] = 7044;
      };
      ["level"] = 49;
      ["name_es"] = "El cetro de Celebras";
      ["req"] = 41;
   };
   [7062] = {
      ["name_ru"] = "Повод для праздника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Historian Karnik at the Explorer's League in Ironforge about the Feast of Winter Veil.";
      ["next"] = 7063;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬幕?的意?";
      ["name_fr"] = "L'esprit de cette fete";
      ["name_de"] = "Der Anlass fur die Feiertage";
      ["faction"] = "Alliance";
      ["name"] = "The Reason for the Season";
      ["level"] = 60;
      ["name_es"] = "El espiritu de esta fiesta";
      ["req"] = 10;
   };
   [1778] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1779;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1648;
      ["prequests"] = {
         [1] = 1648;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1782] = {
      ["name_ru"] = "Доспехи Фьюрена";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Furens Rustung";
      ["name_fr"] = "L'armure de Furen";
      ["name"] = "Furen's Armor";
      ["name_cn"] = "弗?的?甲";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6972;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1701;
      ["prequests"] = {
         [1] = 1701;
      };
      ["level"] = 28;
      ["name_es"] = "La armadura de Furen";
      ["req"] = 20;
   };
   [7142] = {
      ["name_ru"] = "Битва за Альтерак";
      ["type"] = "PvP";
      ["objective"] = "Enter Alterac Valley and defeat the dwarven general, Vanndar Stormpike.  Then, return to Voggah Deathgrip in the Alterac Mountains.";
      ["name_fr"] = "La bataille pour Alterac";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?奥特?克而?";
      ["name"] = "The Battle for Alterac";
      ["name_de"] = "Die Schlacht ums Alteractal";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7222;
      };
      ["level"] = 60;
      ["name_es"] = "La batalla por Alterac";
      ["req"] = 51;
   };
   [1790] = {
      ["name_ru"] = "Знак Жизни";
      ["type"] = "Solo";
      ["name_fr"] = "Le Symbole de vie";
      ["sort"] = "Paladin";
      ["name_cn"] = "生命符?";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Das Symbol des Lebens";
      ["name"] = "The Symbol of Life";
      ["reward"] = {
         [1] = 6866;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["level"] = 12;
      ["name_es"] = "El Simbolo de la Vida";
      ["req"] = 12;
   };
   [1794] = {
      ["name_ru"] = "Фолиант Отваги";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["sort"] = "Paladin";
      ["name_cn"] = "勇气之?";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["name"] = "The Tome of Valor";
      ["reward"] = {
         [1] = 6776;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 20;
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [1798] = {
      ["name_ru"] = "В поисках Страхада";
      ["type"] = "Solo";
      ["objective"] = "Speak with Strahad Farsan in the Barrens.";
      ["next"] = 1758;
      ["sort"] = "Warlock";
      ["name_cn"] = "?找斯坦哈德";
      ["name_fr"] = "A la recherche de Strahad";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Die Suche nach Strahad";
      ["faction"] = "Alliance";
      ["name"] = "Seeking Strahad";
      ["level"] = 30;
      ["name_es"] = "Buscando a Strahad";
      ["req"] = 30;
   };
   [1802] = {
      ["name_ru"] = "Фолиант заговора";
      ["objective"] = "Retrieve the Moldy Tome and Tattered Manuscript for Krom Stoutarm in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Warlock";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Tome de la Cabale";
      ["next"] = 1804;
      ["name_de"] = "Foliant der Kabale";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Tome of the Cabal";
      ["prev"] = 1758;
      ["prequests"] = {
         [1] = 1758;
      };
      ["series"] = 2;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [1806] = {
      ["name_ru"] = "Испытание доблести";
      ["objective"] = "Wait for Jordan Stilwell to finish forging a weapon for you.";
      ["name_cn"] = "正???";
      ["sort"] = "Paladin";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "Le test de droiture";
      ["name_de"] = "Die Prufung der Rechtschaffenheit";
      ["reward"] = {
         [1] = 6953;
      };
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "The Test of Righteousness";
      ["prev"] = 1654;
      ["prequests"] = {
         [1] = 1654;
      };
      ["series"] = 3;
      ["name_es"] = "La prueba de rectitud";
      ["req"] = 20;
   };
   [1818] = {
      ["name_ru"] = "Разговор с Диллинджером";
      ["type"] = "Solo";
      ["objective"] = "Speak with Deathguard Dillinger in Brill.";
      ["next"] = 1819;
      ["sort"] = "Warrior";
      ["name_cn"] = "迪林格?";
      ["name_fr"] = "Parler a Dillinger";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Gesprach mit Dillinger";
      ["faction"] = "Horde";
      ["name"] = "Speak with Dillinger";
      ["level"] = 10;
      ["name_es"] = "Habla con Dillinger";
      ["req"] = 10;
   };
   [1822] = {
      ["name_ru"] = "Фамильное оружие";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Erbstuckwaffe";
      ["name_fr"] = "Une arme en heritage";
      ["name"] = "Heirloom Weapon";
      ["name_cn"] = "祖?武器";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7115;
         [2] = 7117;
         [3] = 7116;
         [4] = 7118;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1821;
      ["prequests"] = {
         [1] = 1821;
      };
      ["level"] = 11;
      ["name_es"] = "Arma reliquia";
      ["req"] = 10;
   };
   [7302] = {
      ["name_ru"] = "Свергнутые властители небес";
      ["type"] = "PvP";
      ["objective"] = "Find out what became of Wing Commander Guse, Wing Commander Jeztor, and Wing Commander Mulverick. Return to Commander Mulfort should you complete your mission.";
      ["repgain"] = {
         [76] = 250;
         [729] = 250;
      };
      ["name_fr"] = "Les ailes brisees";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "被捕的空?指?官";
      ["name_de"] = "Gefallene Himmelssturmer";
      ["faction"] = "Horde";
      ["name"] = "Fallen Sky Lords";
      ["level"] = 60;
      ["name_es"] = "Senores del Cielo caidos";
      ["req"] = 51;
   };
   [1838] = {
      ["name_ru"] = "Доспехи Жестокости";
      ["type"] = "Solo";
      ["name_fr"] = "Armure de brutalite";
      ["name_de"] = "Brutale Rustung";
      ["objective"] = "Bring to Thun'grim Firegaze 15 Smoky Iron Ingots, 10 Powdered Azurite, 10 Iron Bars and a Vial of Phlogiston.";
      ["name_cn"] = "野蛮?甲";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Brutal Armor";
      ["prev"] = 1825;
      ["prequests"] = {
         [1] = 1825;
      };
      ["level"] = 30;
      ["name_es"] = "Armadura brutal";
      ["req"] = 20;
   };
   [7366] = {
      ["name_ru"] = "Милосердие архиепископа";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing Forsaken players in Alterac Valley.$B$BKill a Forsaken and return to Commander Karl Philips (who wanders between the lumber mill and the mine) with a Forsaken Heart.";
      ["name_cn"] = "大主教的仁慈";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Die Gnade des Erzbischofs";
      ["faction"] = "Alliance";
      ["name"] = "The Archbishop's Mercy";
      ["level"] = 60;
      ["name_es"] = "La misericordia del arzobispo";
      ["req"] = 51;
   };
   [7382] = {
      ["name_ru"] = "Коррак Бессмертный";
      ["type"] = "Raid";
      ["objective"] = "Should Korrak the Bloodrager make a return to the Field of Strife, seek him out and destroy him.$B$BReturn the Skull of Korrak to Lieutenant Haggerdin in the Hillsbrad Foothills.$B";
      ["name_fr"] = "Korrak l'Indestructible";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "永生的科?拉克";
      ["reward"] = {
         [1] = 18150;
      };
      ["name_de"] = "Korrak der Unsterbliche";
      ["faction"] = "Alliance";
      ["name"] = "Korrak the Everliving";
      ["level"] = 60;
      ["name_es"] = "Korrak el Eterno";
      ["req"] = 51;
   };
   [1858] = {
      ["name_ru"] = "Изувеченная Длань";
      ["objective"] = "Steal Tazan's key, then use it to open his Satchel and deliver its contents to Therzok in the Cleft of Shadow in Orgrimmar.";
      ["name_cn"] = "碎手氏族";
      ["sort"] = "Rogue";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "La Main brisee";
      ["name_de"] = "Die Zerschmetterte Hand";
      ["reward"] = {
         [1] = 7298;
      };
      ["classes"] = {
         [1] = "Rogue";
      };
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["name"] = "The Shattered Hand";
      ["prev"] = 1963;
      ["prequests"] = {
         [1] = 1963;
      };
      ["series"] = 2;
      ["name_es"] = "Mano Destrozada";
      ["req"] = 10;
   };
   [7462] = {
      ["name_ru"] = "Сокровище Шен'дралар";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le tresor des Shen'dralar";
      ["name_de"] = "Der Schatz der Shen'dralar";
      ["reward"] = {
         [1] = 18420;
         [2] = 18421;
         [3] = 18424;
      };
      ["name_cn"] = "辛德拉的宝藏";
      ["objective"] = "Return to the Athenaeum and find the Treasure of the Shen'dralar. Claim your reward!";
      ["faction"] = "Alliance";
      ["name"] = "The Treasure of the Shen'dralar";
      ["sort"] = "Dire Maul";
      ["prev"] = 7461;
      ["prequests"] = {
         [1] = 7461;
      };
      ["level"] = 60;
      ["name_es"] = "El tesoro de los Shen'dralar";
      ["req"] = 56;
   };
   [7494] = {
      ["name_ru"] = "Крепость Оперенной Луны";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Latronicus Moonspear at the Feathermoon Stronghold in Feralas.";
      ["next"] = 7488;
      ["sort"] = "Dire Maul";
      ["name_cn"] = "羽月要塞";
      ["name_fr"] = "Le bastion de Pennelune";
      ["name_de"] = "Die Mondfederfeste";
      ["faction"] = "Alliance";
      ["name"] = "Feathermoon Stronghold";
      ["level"] = 57;
      ["name_es"] = "Bastion Plumaluna";
      ["req"] = 54;
   };
   [1878] = {
      ["name_ru"] = "Награда за воду";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [369] = 10;
      };
      ["name_de"] = "Wasserbeutelkopfgeld";
      ["name_fr"] = "Prime de la poche a eau";
      ["name_cn"] = "收集水袋";
      ["faction"] = "Horde";
      ["name"] = "Water Pouch Bounty";
      ["reward"] = {
         [1] = 8484;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 1707;
      ["prequests"] = {
         [1] = 1707;
      };
      ["level"] = 44;
      ["name_es"] = "Cazador de faltriqueras de agua";
      ["req"] = 40;
   };
   [1882] = {
      ["name_ru"] = "Усадьба Балнира";
      ["type"] = "Solo";
      ["name_fr"] = "La ferme des Balnir";
      ["name_de"] = "Balnirs Bauernhof";
      ["sort"] = "Mage";
      ["objective"] = "Bring Balnir Snapdragons to Anastasia Hartwell in the Mage Quarter of the Undercity.";
      ["name_cn"] = "巴尼???";
      ["name"] = "The Balnir Farmstead";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7507;
         [2] = 9514;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1881;
      ["prequests"] = {
         [1] = 1881;
      };
      ["level"] = 10;
      ["name_es"] = "La Hacienda Balnir";
      ["req"] = 10;
   };
   [1886] = {
      ["name_ru"] = "Стражи смерти";
      ["objective"] = "Get Astor's Letter of Introduction and return it to Mennet Carkad in the Rogues' Quarter.";
      ["name_cn"] = "亡?哨兵";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Les necrotraqueurs";
      ["next"] = 1898;
      ["name_de"] = "Die Todespirscher";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["sort"] = "Rogue";
      ["name"] = "The Deathstalkers";
      ["prev"] = 1885;
      ["prequests"] = {
         [1] = 1885;
      };
      ["series"] = 1;
      ["name_es"] = "Los mortacechadores";
      ["req"] = 10;
   };
   [1898] = {
      ["name_ru"] = "Стражи смерти";
      ["objective"] = "Speak with Andron Gant in the Undercity.";
      ["name_cn"] = "亡?哨兵";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Les necrotraqueurs";
      ["next"] = 1899;
      ["name_de"] = "Die Todespirscher";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["sort"] = "Rogue";
      ["name"] = "The Deathstalkers";
      ["prev"] = 1886;
      ["prequests"] = {
         [1] = 1886;
      };
      ["series"] = 2;
      ["name_es"] = "Los mortacechadores";
      ["req"] = 10;
   };
   [7622] = {
      ["name_ru"] = "Баланс Света и Тени";
      ["type"] = "Solo";
      ["objective"] = "Save 50 Peasants before 15 are slain. Speak with Eris Havenfire should you accomplish this task.$B$BYou may view the Death Post to view how many Peasants have been slain.";
      ["name_fr"] = "L’equilibre de la Lumiere et de l’Ombre";
      ["sort"] = "Priest";
      ["name_cn"] = "光与影的平衡";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 18659;
      };
      ["name_de"] = "Die Waage von Licht und Schatten";
      ["faction"] = "Horde";
      ["name"] = "The Balance of Light and Shadow";
      ["level"] = 60;
      ["name_es"] = "Equilibrio de Luz y Sombras";
      ["req"] = 60;
   };
   [7638] = {
      ["name_ru"] = "Лорд Грейсон Тенелом";
      ["type"] = "Solo";
      ["objective"] = "Speak with Lord Grayson Shadowbreaker in Stormwind's Cathedral District.";
      ["name_de"] = "Lord Grayson Schattenbruch";
      ["sort"] = "Paladin";
      ["name_cn"] = "格雷森・沙?布瑞克公爵";
      ["name_fr"] = "Le seigneur Grayson Shadowbreaker";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["followup"] = 7637;
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Lord Grayson Shadowbreaker";
      ["level"] = 60;
      ["name_es"] = "Lord Grisillo Quiebrasombras";
      ["req"] = 60;
   };
   [7654] = {
      ["name_ru"] = "Императорские латные сапоги";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["name_de"] = "Imperiale Plattenstiefel";
      ["name_fr"] = "Les bottes imperiales en plaques";
      ["name_cn"] = "君王板甲?靴";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Boots";
      ["reward"] = {
         [1] = 12700;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Botas de placas imperiales";
      ["req"] = 50;
   };
   [1918] = {
      ["name_ru"] = "Оскверненная стихия";
      ["type"] = "Solo";
      ["objective"] = "Bring the Befouled Water Globe to Mastok Wrilehiss at Splintertree Post, Ashenvale.";
      ["next"] = 824;
      ["name_fr"] = "Les elements souilles";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "被?染的水元素";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Das beschmutzte Element";
      ["faction"] = "Horde";
      ["name"] = "The Befouled Element";
      ["level"] = 27;
      ["name_es"] = "El elemento contaminado";
      ["req"] = 23;
   };
   [7734] = {
      ["name_ru"] = "Борьба за качество";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Rage Scar Yeti Hides to Jangdor Swiftstrider at Camp Mojache, Feralas.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Beste Qualitat";
      ["reward"] = {
         [1] = 19042;
      };
      ["name_cn"] = "更高的品?";
      ["name_fr"] = "Qualite amelioree";
      ["faction"] = "Horde";
      ["name"] = "Improved Quality";
      ["sort"] = "Feralas";
      ["prev"] = 2822;
      ["prequests"] = {
         [1] = 2822;
      };
      ["level"] = 48;
      ["name_es"] = "Calidad mejorada";
      ["req"] = 40;
   };
   [1938] = {
      ["name_ru"] = "Трактат Ура по темной магии";
      ["type"] = "Solo";
      ["name_fr"] = "Traite d'Ur sur la Magie des Ombres";
      ["next"] = 1940;
      ["name_de"] = "Urs Abhandlung uber Schattenmagie";
      ["objective"] = "Bring Ur's Treatise on Shadow Magic to High Sorcerer Andromath in Stormwind.";
      ["name_cn"] = "??的暗影魔法研究?文";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Ur's Treatise on Shadow Magic";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1939;
      ["prequests"] = {
         [1] = 1939;
      };
      ["level"] = 28;
      ["name_es"] = "Tratado de Ur sobre la Magia de las Sombras";
      ["req"] = 26;
   };
   [1942] = {
      ["name_ru"] = "Одеяние волшебного плетения";
      ["type"] = "Solo";
      ["objective"] = "";
      ["races"] = {
         [1] = "Human";
      };
      ["name_fr"] = "L'Habit du noeud astral";
      ["name"] = "Astral Knot Garment";
      ["name_cn"] = "星?之衣";
      ["name_de"] = "Astralknotengewand";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7511;
         [2] = 9516;
      };
      ["sort"] = "Mage";
      ["prev"] = 1940;
      ["prequests"] = {
         [1] = 1940;
      };
      ["level"] = 26;
      ["name_es"] = "Prendas de nudo astral";
      ["req"] = 26;
   };
   [1946] = {
      ["name_ru"] = "Одеяние из кружева Пустоты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["races"] = {
         [1] = "Undead";
      };
      ["name_fr"] = "L'Habit du neant";
      ["name"] = "Nether-lace Garment";
      ["name_cn"] = "虚??袍";
      ["name_de"] = "Netherspitzengewand";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7512;
         [2] = 9515;
      };
      ["sort"] = "Mage";
      ["prev"] = 1945;
      ["prequests"] = {
         [1] = 1945;
      };
      ["level"] = 26;
      ["name_es"] = "Prendas de encaje Abisal";
      ["req"] = 26;
   };
   [7798] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 150;
      };
      ["sort"] = "Darnassus";
      ["name_cn"] = "捐献??";
      ["followup"] = 7800;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7814] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 150;
      };
      ["sort"] = "Undercity";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7818;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7830] = {
      ["name_ru"] = "Отмщение за погибших";
      ["type"] = "Solo";
      ["objective"] = "Huntsman Markhor at Revantusk Village in the Hinterlands wants you to kill a Razorbeak Skylord and retrieve its Skylord Plume. Return to him once the task is complete.$B$BMarkhor mentioned that the Razorbeak Skylord are a rare breed that tend to occupy the wilds of the Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "死者的?仇";
      ["name_fr"] = "Venger les victimes";
      ["name_de"] = "Die Gefallenen rachen";
      ["faction"] = "Horde";
      ["name"] = "Avenging the Fallen";
      ["level"] = 48;
      ["name_es"] = "Vengar a los Caidos";
      ["req"] = 44;
   };
   [7846] = {
      ["name_ru"] = "Отыскать ключ!";
      ["type"] = "Group";
      ["name_fr"] = "Recuperez la cle?!";
      ["next"] = 7847;
      ["name_de"] = "Erlangt den Schlussel!";
      ["name_cn"] = "找回?匙！";
      ["objective"] = "Elder Torntusk at Jintha'alor wants you to kill Hitah'ya the Keeper to get the Shackle Key to his bindings. Return to Elder Torntusk when you have recovered the key.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Horde";
      ["name"] = "Recover the Key!";
      ["prev"] = 7845;
      ["prequests"] = {
         [1] = 7845;
      };
      ["level"] = 51;
      ["name_es"] = "!Recupera la llave!";
      ["req"] = 46;
   };
   [7862] = {
      ["name_ru"] = "Требуется: капитан стражи в деревню Сломанного Клыка";
      ["type"] = "Group";
      ["objective"] = "You have been tasked with the decimation of 20 Vilebranch Berserkers, 20 Vilebranch Shadow Hunters, 20 Vilebranch Blood Drinkers, and 20 Vilebranch Soul Eaters.$B$BShould you complete this task, return to Primal Torntusk at Revantusk Village in the Hinterlands.";
      ["name_fr"] = "Offre d’emploi?: capitaine de la garde du village des Vengebroches";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "?位空缺：??村?兵??";
      ["reward"] = {
         [1] = 19120;
      };
      ["name_de"] = "Offener Posten: Wachbefehlshaber der Bruchhauer";
      ["faction"] = "Horde";
      ["name"] = "Job Opening: Guard Captain of Revantusk Village";
      ["level"] = 51;
      ["name_es"] = "Oferta de empleo: capitan de la guardia de Poblado Sanadiente";
      ["req"] = 46;
   };
   [7894] = {
      ["name_ru"] = "Медный регулятор";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Modulateurs de cuivre";
      ["name_cn"] = "????器";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Kupfermodulator";
      ["faction"] = "Horde";
      ["name"] = "Copper Modulator";
      ["level"] = 60;
      ["name_es"] = "Modulador de cobre";
      ["req"] = 1;
   };
   [1978] = {
      ["name_ru"] = "Стражи смерти";
      ["objective"] = "Deliver Andron's Ledger to Varimathras in the Hall of the Dark Lady in the Undercity.";
      ["name_cn"] = "亡?哨兵";
      ["sort"] = "Rogue";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Les necrotraqueurs";
      ["name_de"] = "Die Todespirscher";
      ["reward"] = {
         [1] = 7298;
      };
      ["classes"] = {
         [1] = "Rogue";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "The Deathstalkers";
      ["prev"] = 1899;
      ["prequests"] = {
         [1] = 1899;
      };
      ["series"] = 4;
      ["name_es"] = "Los mortacechadores";
      ["req"] = 10;
   };
   [7926] = {
      ["name_ru"] = "Ярмарка Новолуния";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Free Ticket Voucher to Gelvas Grimgate, located inside the Darkmoon Faire carnival.";
      ["repgain"] = {
         [909] = 50;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "La foire de Sombrelune";
      ["name_cn"] = "暗月???";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Der Dunkelmond-Jahrmarkt";
      ["faction"] = "Horde";
      ["name"] = "The Darkmoon Faire";
      ["level"] = 60;
      ["name_es"] = "La Feria de la Luna Negra";
      ["req"] = 6;
   };
   [7942] = {
      ["name_ru"] = "Обмен: ториевые устройства";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Plus de rouages en thorium";
      ["name_cn"] = "更多的瑟?零件";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mehr Thoriumapparate";
      ["faction"] = "Horde";
      ["name"] = "More Thorium Widgets";
      ["level"] = 60;
      ["name_es"] = "Mas trastos de torio";
      ["req"] = 40;
   };
   [1998] = {
      ["name_ru"] = "Фенвик Татрос";
      ["type"] = "Solo";
      ["objective"] = "Kill Fenwick Thatros and bring his head back to Mennet Carkad in the Rogues' Quarter of the Undercity.";
      ["next"] = 1999;
      ["name_de"] = "Fenwick Thatros";
      ["sort"] = "Rogue";
      ["name_cn"] = "芬?克・?托斯";
      ["name_fr"] = "Fenwick Thatros";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Fenwick Thatros";
      ["level"] = 16;
      ["name_es"] = "Fenwick Thatros";
      ["req"] = 16;
   };
   [8054] = {
      ["name_ru"] = "Знаки силы: пояс вольнодумца";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker a Primal Hakkari Shawl.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la ceinture de libre-penseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：思考者腰?";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19826;
      };
      ["name_de"] = "Symbole der Macht: Der Gurtel des Freidenkers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Freethinker's Belt";
      ["level"] = 61;
      ["name_es"] = "Dechados de Poder: el Cinturon de librepensador";
      ["req"] = 60;
   };
   [8070] = {
      ["name_ru"] = "Знаки Силы: пояс исповедника";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Sash.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: le cordon de confesseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?悔者腰?";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19842;
      };
      ["name_de"] = "Symbole der Macht: Die Bindungen des Glaubenshuters";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Confessor's Bindings";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: las Ataduras de confesor";
      ["req"] = 60;
   };
   [8102] = {
      ["name_ru"] = "Камешек Каджаро";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Der Stein des Kajaro";
      ["name_fr"] = "Le caillou de Kajaro";
      ["name"] = "The Pebble of Kajaro";
      ["name_cn"] = "???之石";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 19599;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8101;
      ["prequests"] = {
         [1] = 8101;
      };
      ["level"] = 60;
      ["name_es"] = "El guijarro de Kajaro";
      ["req"] = 60;
   };
   [8118] = {
      ["name_ru"] = "Ожерелье видений Вудресса";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Vision von Voodress";
      ["name_fr"] = "Vision de Voodress";
      ["name"] = "Vision of Voodress";
      ["name_cn"] = "巫毒幻象";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19608;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8117;
      ["prequests"] = {
         [1] = 8117;
      };
      ["level"] = 60;
      ["name_es"] = "Vision de Voodress";
      ["req"] = 60;
   };
   [2038] = {
      ["name_ru"] = "Пропавшее снаряжение Бинглза";
      ["type"] = "Solo";
      ["objective"] = "Find and return Bingles' supplies:$B$BBingles' Wrench, Bingles' Screwdriver, Bingles' Hammer, and Bingles' Blastencapper.";
      ["repgain"] = {
         [54] = 250;
      };
      ["sort"] = "Loch Modan";
      ["name_fr"] = "Les fournitures perdues de Bingles";
      ["name_cn"] = "?格斯的??品";
      ["reward"] = {
         [1] = 12522;
      };
      ["name_de"] = "Bingles' verschwundene Werkzeuge";
      ["faction"] = "Alliance";
      ["name"] = "Bingles' Missing Supplies";
      ["level"] = 15;
      ["name_es"] = "Suministros de Bingles";
      ["req"] = 12;
   };
   [8166] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the mine, the lumber mill, the blacksmith and the farm, then return to Field Marshal Oslight in Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Alliance";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 45;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 40;
   };
   [8182] = {
      ["name_ru"] = "Длань Растахана";
      ["type"] = "Raid";
      ["name_fr"] = "La Main de Rastakhan";
      ["name_de"] = "Die Hand von Rastakhan";
      ["name_cn"] = "拉斯塔哈之手";
      ["objective"] = "Speak with Molthor in Stranglethorn.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "The Hand of Rastakhan";
      ["prev"] = 8181;
      ["prequests"] = {
         [1] = 8181;
      };
      ["level"] = 58;
      ["name_es"] = "La mano de Rastakhan";
      ["req"] = 40;
   };
   [4103] = {
      ["name_ru"] = "Лекарство из охотничьих трофеев";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Jagd";
      ["name_fr"] = "Du baume en chassant";
      ["name_cn"] = "狩???膏";
      ["name"] = "Salve via Hunting";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4101;
      ["prequests"] = {
         [1] = 4101;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por caza";
      ["req"] = 48;
   };
   [4119] = {
      ["name_ru"] = "Оскверненный ночной дракон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的夜?草";
      ["name_fr"] = "Dragon nocturne corrompu";
      ["name_de"] = "Verderbter Nachtdrache";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Night Dragon";
      ["level"] = 55;
      ["name_es"] = "Dragon nocturno corrupto";
      ["req"] = 48;
   };
   [4135] = {
      ["name_ru"] = "Гудящая Бездна";
      ["type"] = "Solo";
      ["name_fr"] = "Le Gouffre grouillant";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Die Gewundene Tiefe";
      ["name"] = "The Writhing Deep";
      ["name_cn"] = "痛苦深渊";
      ["objective"] = "Now that Raschal's last known whereabouts have been discovered, continue your search for him or his remains in the Writhing Deep.  According to the note, it is located to the south of the Woodpaw gnoll camps.";
      ["next"] = 4265;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 4131;
      ["prequests"] = {
         [1] = 4131;
      };
      ["level"] = 46;
      ["name_es"] = "Las Galerias Retorcidas";
      ["req"] = 40;
   };
   [8300] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "More Resource Crates";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["faction"] = "Horde";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8299;
      ["prequests"] = {
         [1] = 8299;
      };
      ["level"] = 60;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 60;
   };
   [8332] = {
      ["name_ru"] = "Герцоги Совета";
      ["objective"] = "Bring 1 Large Brilliant Shard and 3 Abyssal Crests to Aurel Goldleaf in Cenarion Hold.";
      ["name_cn"] = "?会公爵";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Group";
      ["name_fr"] = "Les ducs du Conseil";
      ["next"] = 8349;
      ["name_de"] = "Fursten des Rates";
      ["repgain"] = {
         [609] = 75;
      };
      ["reward"] = {
         [1] = 20422;
      };
      ["name"] = "Dukes of the Council";
      ["prev"] = 8331;
      ["prequests"] = {
         [1] = 8331;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los Duques del Consejo";
      ["req"] = 60;
   };
   [8364] = {
      ["name_ru"] = "Скипетры Бездны";
      ["type"] = "Raid";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 500;
      };
      ["name_de"] = "Abyssische Szepter";
      ["name_fr"] = "Les sceptres abyssaux";
      ["name_cn"] = "深渊?杖";
      ["faction"] = "Horde";
      ["name"] = "Abyssal Scepters";
      ["reward"] = {
         [1] = 20602;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8352;
      ["prequests"] = {
         [1] = 8352;
      };
      ["level"] = 60;
      ["name_es"] = "Cetros Abisales";
      ["req"] = 60;
   };
   [8396] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 100;
      };
      ["name_fr"] = "La revendication du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?争的?力";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["level"] = 60;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 60;
   };
   [8428] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 49;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 40;
   };
   [8460] = {
      ["name_ru"] = "Союзник Древобрюхов";
      ["type"] = "Solo";
      ["objective"] = "Grazle wants you to prove yourself by killing 6 Deadwood Warriors, 6 Deadwood Pathfinders, and 6 Deadwood Gardeners.  Return to him in southern Felwood near the Emerald Sanctuary when you are done.";
      ["repgain"] = {
         [576] = 350;
      };
      ["sort"] = "Felwood";
      ["name_fr"] = "Allie des Grumegueules";
      ["name_cn"] = "木喉熊怪的盟友";
      ["reward"] = {
         [1] = 21311;
         [2] = 21312;
      };
      ["name_de"] = "Verbundeter der Holzschlundfeste";
      ["faction"] = "Horde";
      ["name"] = "Timbermaw Ally";
      ["level"] = 48;
      ["name_es"] = "Aliado Fauces de Madera";
      ["req"] = 45;
   };
   [8492] = {
      ["name_ru"] = "Альянсу не хватает медных слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Copper Bars to Sergeant Stonebrow at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de barres de cuivre !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要??！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_de"] = "Die Allianz braucht Kupferbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Copper Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita lingotes de cobre!";
      ["req"] = 50;
   };
   [4263] = {
      ["name_ru"] = "Опалитель!";
      ["type"] = "Dungeon";
      ["objective"] = "Find Lord Incendius in Blackrock Depths and destroy him!";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Incendius!";
      ["reward"] = {
         [1] = 12113;
         [2] = 12114;
         [3] = 12112;
         [4] = 12115;
      };
      ["name_cn"] = "伊森迪奥斯！";
      ["name_fr"] = "Incendius?!";
      ["faction"] = "Alliance";
      ["name"] = "Incendius!";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4262;
      ["prequests"] = {
         [1] = 4262;
      };
      ["level"] = 56;
      ["name_es"] = "!Incendius!";
      ["req"] = 48;
   };
   [8556] = {
      ["name_ru"] = "Перстень неумолимой силы";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Magisterial Ring, 2 Lambent Idols, 5 Bronze Scarabs and 5 Ivory Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Chevaliere de force inflexible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?定力量之戒";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21393;
      };
      ["name_de"] = "Siegel der unnachgiebigen Starke";
      ["faction"] = "Horde";
      ["name"] = "Signet of Unyielding Strength";
      ["level"] = 60;
      ["name_es"] = "El sello de fuerza implacable";
      ["req"] = 60;
   };
   [8588] = {
      ["name_ru"] = "Орде не хватает толстой кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Heavy Leather to Skinner Jamani at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de cuir lourd?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要重皮!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21511;
      };
      ["name_de"] = "Die Horde braucht schweres Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Heavy Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita cuero pesado!";
      ["req"] = 53;
   };
   [8620] = {
      ["name_ru"] = "Единственный способ";
      ["type"] = "Raid";
      ["objective"] = " use this magical binding to put them back together and return to me.\"";
      ["repgain"] = {
         [910] = 150;
      };
      ["name_de"] = "Der einzige Weg";
      ["reward"] = {
         [1] = 21517;
      };
      ["name_cn"] = "唯一的方案";
      ["name_fr"] = "Le seul remede";
      ["faction"] = "Horde";
      ["name"] = "The Only Prescription";
      ["sort"] = "Tanaris";
      ["prev"] = 8606;
      ["prequests"] = {
         [1] = 8606;
      };
      ["level"] = 60;
      ["name_es"] = "La unica receta";
      ["req"] = 60;
   };
   [8652] = {
      ["name_ru"] = "Предок Могильный Холм";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Ne-au-tombeau";
      ["name_cn"] = "灰石?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Grufthauch";
      ["faction"] = "Horde";
      ["name"] = "Graveborn the Elder";
      ["level"] = 60;
      ["name_es"] = "Sapulnato el Ancestro";
      ["req"] = 1;
   };
   [4343] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [8716] = {
      ["name_ru"] = "Предок Звездный Луг";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Reflet-d'etoile";
      ["name_cn"] = "星林?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Sternenau";
      ["faction"] = "Horde";
      ["name"] = "Starglade the Elder";
      ["level"] = 60;
      ["name_es"] = "Claroestelar el Ancestro";
      ["req"] = 1;
   };
   [8748] = {
      ["name_ru"] = "Путь защитника";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Beschutzers";
      ["name_fr"] = "La voie du Protecteur";
      ["name_cn"] = "保?者之路";
      ["name"] = "The Path of the Protector";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21197;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8747;
      ["prequests"] = {
         [1] = 8747;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del protector";
      ["req"] = 60;
   };
   [8780] = {
      ["name_ru"] = "Комплекты брони";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Rugged Armor Kits and 8 Heavy Armor Kits to Janela Stouthammer at the Ironforge Brigade Outpost near Hive'Zora in Silithus.  You must also bring Logistics Task Briefing VII in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Des renforts d'armure pour le champ de bataille";
      ["name_cn"] = "??上的?甲片";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Rustungssets fur den Feldeinsatz";
      ["faction"] = "Alliance";
      ["name"] = "Armor Kits for the Field";
      ["level"] = 60;
      ["name_es"] = "Refuerzos para armadura para el campo de batalla";
      ["req"] = 60;
   };
   [8812] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8844] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8818;
      ["prequests"] = {
         [1] = 8818;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8876] = {
      ["name_ru"] = "Маленькие ракеты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les petites cometes";
      ["name_cn"] = "小型烟花";
      ["reward"] = {
         [1] = 21740;
         [2] = 21640;
      };
      ["name_de"] = "Kleine Raketen";
      ["faction"] = "Horde";
      ["name"] = "Small Rockets";
      ["level"] = 60;
      ["name_es"] = "Cohetes pequenos";
      ["req"] = 25;
   };
   [8908] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Lightforge Bracers to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 22088;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8940] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Devout Belt and a set of Devout Gloves to Mokvar in Orgrimmar.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22078;
         [2] = 22081;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [4487] = {
      ["name_ru"] = "Призывание коня Скверны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in Ratchet.";
      ["next"] = 4490;
      ["sort"] = "Warlock";
      ["name_cn"] = "召?地???";
      ["name_fr"] = "Invoquer un Palefroi corrompu";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Teufelsross beschworen";
      ["faction"] = "Alliance";
      ["name"] = "Summon Felsteed";
      ["level"] = 40;
      ["name_es"] = "Invoca un corcel vil";
      ["req"] = 40;
   };
   [9004] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Shadowcraft Cap and Shadowcraft Tunic.";
      ["reward"] = {
         [1] = 22005;
         [2] = 22009;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9036] = {
      ["name_ru"] = "Ножные латы неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make Dreadnaught Legplates if you bring him the following items: 1 Desecrated Legplates, 20 Wartorn Plate Scraps, 4 Arcanite Bars and 3 Cured Rugged Hides.";
      ["name_cn"] = "无畏腿?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Cuissards de cuirassier";
      ["repgain"] = {
         [529] = 100;
      };
      ["name_de"] = "Beinplatten des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22417;
      };
      ["name"] = "Dreadnaught Legplates";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los quijotes acorator";
      ["req"] = 60;
   };
   [9068] = {
      ["name_ru"] = "Мундир Землекрушителя";
      ["type"] = "Raid";
      ["name_fr"] = "La tunique de Brise-terre";
      ["name_de"] = "Tunika des Erdspalters";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make an Earthshatter Tunic if you bring him the following: 1 Desecrated Tunic, 25 Wartorn Chain Scraps, 4 Arcanite Bars and 3 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22464;
      };
      ["name_cn"] = "碎地者外套";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Earthshatter Tunic";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La guerrera Rompeterra";
      ["req"] = 60;
   };
   [9100] = {
      ["name_ru"] = "Перчатки ледяного огня";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make Frostfire Gloves if you bring her the following: 1 Desecrated Gloves, 8 Wartorn Cloth Scraps and 4 Mooncloth.";
      ["name_cn"] = "霜火手套";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les gants de givrefeu";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Frostfeuerhandschuhe";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22501;
      };
      ["name"] = "Frostfire Gloves";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guantes de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9132] = {
      ["name_ru"] = "Лом черного железа";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Dunkeleisenfragmente";
      ["name_fr"] = "Des morceaux de sombrefer";
      ["name_cn"] = "黑?碎片";
      ["faction"] = "Horde";
      ["name"] = "Dark Iron Scraps";
      ["reward"] = {
         [1] = 22523;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9131;
      ["prequests"] = {
         [1] = 9131;
      };
      ["level"] = 60;
      ["name_es"] = "Fragmentos de hierro negro";
      ["req"] = 55;
   };
   [9196] = {
      ["name_ru"] = "Задание мастера: ториевая граната";
      ["type"] = "Solo";
      ["objective"] = "Deliver 20 Thorium Grenades and the Craftsman's Writ - Thorium Grenade - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Grenades en thorium";
      ["name_cn"] = "工匠文? - 瑟?手榴?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Thoriumgranate";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Thorium Grenade";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: granada de torio";
      ["req"] = 55;
   };
   [9228] = {
      ["name_ru"] = "Легендарное боевое снаряжение ? Восторг Рассвета";
      ["type"] = "Solo";
      ["objective"] = "For 27 Insignias of the Dawn and 27 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille epiques - Exalte aupres de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "史??的作?装? - ?色黎明崇拜";
      ["reward"] = {
         [1] = 22657;
         [2] = 22667;
         [3] = 22668;
         [4] = 22659;
         [5] = 22678;
         [6] = 22656;
      };
      ["name_de"] = "Epische Kampfausrustung - Ehrfurcht der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Epic Armaments of Battle - Exalted Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento epico de batalla: exaltado con El Alba";
      ["req"] = 55;
   };
   [9260] = {
      ["name_ru"] = "Что делает Плеть в Штормграде?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside Stormwind and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "??暴?城的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Sturmwind";
      ["faction"] = "Alliance";
      ["name"] = "Investigate the Scourge of Stormwind";
      ["level"] = 6;
      ["name_es"] = "Investigar la Plaga de Ventormenta";
      ["req"] = 1;
   };
   [9292] = {
      ["name_ru"] = "Треснувший некротический кристалл";
      ["type"] = "Solo";
      ["objective"] = "Bring the Cracked Necrotic Crystal to Lieutenant Orrin outside the gates of Stormwind.";
      ["name_fr"] = "Cristal necrotique lezarde";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "破碎的死?水晶";
      ["reward"] = {
         [1] = 23123;
         [2] = 23122;
      };
      ["name_de"] = "Gesprungener nekrotischer Kristall";
      ["faction"] = "Alliance";
      ["name"] = "Cracked Necrotic Crystal";
      ["level"] = 60;
      ["name_es"] = "Cristal necrotico rajado";
      ["req"] = 60;
   };
   [9324] = {
      ["name_ru"] = "Похищение пламени Оргриммара";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of Orgrimmar to the Festival Loremaster.";
      ["name_fr"] = "Voler la flamme d'Orgrimmar";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取奥格瑞?的烈?";
      ["followup"] = 9365;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Orgrimmar";
      ["faction"] = "Alliance";
      ["name"] = "Stealing Orgrimmar's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Orgrimmar";
      ["req"] = 50;
   };
   [2340] = {
      ["name_ru"] = "Принести самоцветы";
      ["type"] = "Dungeon";
      ["name_fr"] = "Livrer les Gemmes";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Ablieferung der Edelsteine";
      ["name"] = "Deliver the Gems";
      ["name_cn"] = "交付宝石";
      ["objective"] = "Deliver the Necklace and Gem Salvage to Dran Droffers in Orgrimmar.";
      ["next"] = 2341;
      ["faction"] = "Horde";
      ["sort"] = "Uldaman";
      ["prev"] = 2339;
      ["prequests"] = {
         [1] = 2339;
      };
      ["level"] = 44;
      ["name_es"] = "Entregar las gemas";
      ["req"] = 37;
   };
   [9388] = {
      ["name_ru"] = "Мерцающие огни Калимдора";
      ["type"] = "Solo";
      ["objective"] = "Visit the bonfires within Ashenvale, the Barrens, Darkshore, and Stonetalon Mountains, then speak with the Festival Flamekeeper.";
      ["sort"] = "Midsummer";
      ["name_cn"] = "?利姆多的火?";
      ["reward"] = {
         [1] = 23435;
         [2] = 23327;
         [3] = 23326;
         [4] = 23211;
      };
      ["name_de"] = "Lodernde Flammen in Kalimdor";
      ["faction"] = "Horde";
      ["name"] = "Flickering Flames in Kalimdor";
      ["level"] = 25;
      ["name_es"] = "La oscilacion de las llamas de Kalimdor";
      ["req"] = 1;
   };
   [4727] = {
      ["name_ru"] = "Останки морской черепахи";
      ["type"] = "Solo";
      ["name_fr"] = "La tortue de mer echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meeresschildkrote";
      ["name_cn"] = "?浅的海?";
      ["name"] = "Beached Sea Turtle";
      ["objective"] = "Take the Sea Turtle Remains to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 15;
      ["name_es"] = "Tortuga marina varada";
      ["req"] = 12;
   };
   [4743] = {
      ["name_ru"] = "Печать Вознесения";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to the Wyrmbog in Dustwallow Marsh. Find the ancient drake, Emberstrife and beat him without mercy until his will is broken.$B$BIt is at that moment which you must place the Unforged Seal of Ascension before the great beast. You must then be quick to use the Orb of Draconic Energy on his weakened form and claim dominion over his mental faculties. Control the beast and force the Flames of the Black Dragonflight upon the Unforged Seal of Ascension!";
      ["name_de"] = "Siegel des Aufstiegs";
      ["name_fr"] = "Le sceau d'ascension";
      ["reward"] = {
         [1] = 12344;
      };
      ["name_cn"] = "晋升印章";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "Seal of Ascension";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4742;
      ["prequests"] = {
         [1] = 4742;
      };
      ["level"] = 60;
      ["name_es"] = "El sello de ascension";
      ["req"] = 57;
   };
   [2380] = {
      ["name_ru"] = "В Оргриммар!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Shenthul at the Cleft of Shadow in Orgrimmar.";
      ["next"] = 2379;
      ["sort"] = "Rogue";
      ["name_cn"] = "向奥格瑞???！";
      ["name_fr"] = "Cap sur Orgrimmar !";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["followup"] = 2379;
      ["name_de"] = "Nach Orgrimmar!";
      ["faction"] = "Horde";
      ["name"] = "To Orgrimmar!";
      ["level"] = 16;
      ["name_es"] = "Ve a Orgrimmar";
      ["req"] = 16;
   };
   [4807] = {
      ["name_ru"] = "Э'ко диких совухов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Wildekin";
      ["name_fr"] = "L'E'ko des Indomptables";
      ["name_cn"] = "??魂精";
      ["name"] = "Wildkin E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12458;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko de lechucico salvaje";
      ["req"] = 55;
   };
   [4903] = {
      ["name_ru"] = "Приказ полководца";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Highlord Omokk, War Master Voone, and Overlord Wyrmthalak. Recover Important Blackrock Documents. Return to Warlord Goretooth in Kargath when the mission has been accomplished.";
      ["next"] = 4941;
      ["name_fr"] = "Ordre du chef de guerre";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "高?斯的命令";
      ["reward"] = {
         [1] = 13958;
         [2] = 13959;
         [3] = 13961;
         [4] = 13962;
         [5] = 13963;
      };
      ["name_de"] = "Befehl des Kriegsherrn";
      ["faction"] = "Horde";
      ["name"] = "Warlord's Command";
      ["level"] = 60;
      ["name_es"] = "La orden del Senor de la Guerra";
      ["req"] = 55;
   };
   [2460] = {
      ["name_ru"] = "Приветствие Изувеченной Длани";
      ["type"] = "Solo";
      ["objective"] = "Perform the Shattered Salute on Shenthul.";
      ["next"] = 2458;
      ["sort"] = "Rogue";
      ["name_cn"] = "碎手?礼";
      ["name_fr"] = "Le Salut brise";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name_de"] = "Der Grus der Zerschmetterten Hand";
      ["faction"] = "Horde";
      ["name"] = "The Shattered Salute";
      ["level"] = 20;
      ["name_es"] = "El saludo de los Mano Destrozada";
      ["req"] = 20;
   };
   [4967] = {
      ["name_ru"] = "Знание шара Орахила";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1799;
      ["sort"] = "Warlock";
      ["name_cn"] = "奥拉赫宝珠";
      ["name_fr"] = "Connaissance de l'Orbe d'Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Wissen der Kugel von Orahil";
      ["faction"] = "Alliance";
      ["name"] = "Knowledge of the Orb of Orahil";
      ["level"] = 35;
      ["name_es"] = "El conocimiento del orbe de Orahil";
      ["req"] = 35;
   };
   [4983] = {
      ["name_ru"] = "По данным разведки";
      ["type"] = "Dungeon";
      ["objective"] = "Take Bijou's Reconnaissance Report back to Grandmaster Lexlort in Kargath.$B";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Bijous Aufklarungsbericht";
      ["reward"] = {
         [1] = 15858;
         [2] = 15859;
      };
      ["name_cn"] = "比修的?察?告";
      ["name_fr"] = "Rapport de reconnaissance de Bijou";
      ["faction"] = "Horde";
      ["name"] = "Bijou's Reconnaissance Report";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4982;
      ["prequests"] = {
         [1] = 4982;
      };
      ["level"] = 59;
      ["name_es"] = "El informe de reconocimiento de Bijou";
      ["req"] = 55;
   };
   [2500] = {
      ["name_ru"] = "Пробежка по Бесплодным землям";
      ["type"] = "Solo";
      ["objective"] = "Acquire the reagents Ghak Healtouch needs from the Badlands, then return to him in Thelsamar.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "Les reactifs des Terres ingrates";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "荒?之地的材料";
      ["name_de"] = "Reagenziensuche im Odland";
      ["faction"] = "Alliance";
      ["name"] = "Badlands Reagent Run";
      ["level"] = 39;
      ["name_es"] = "Componentes de Tierras Inhospitas";
      ["req"] = 36;
   };
   [5047] = {
      ["name_ru"] = "Айс Вентурон, к вашим услугам!";
      ["type"] = "Dungeon";
      ["objective"] = "Talk to Malyfous Darkhammer in Everlook.";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "芬克・恩霍?，??效?！";
      ["name_fr"] = "Finkle Einhorn, a votre service?!";
      ["name_de"] = "Finkle Einhorn, zu Euren Diensten!";
      ["faction"] = "Horde";
      ["name"] = "Finkle Einhorn, At Your Service!";
      ["level"] = 60;
      ["name_es"] = "!Finkle Einhorn, a tu servicio!";
      ["req"] = 55;
   };
   [5063] = {
      ["name_ru"] = "Шапка Алого Ученого";
      ["type"] = "Group";
      ["name_fr"] = "La coiffe du savant ecarlate";
      ["name_de"] = "Kappe des Scharlachroten Wissenden";
      ["reward"] = {
         [1] = 12752;
      };
      ["name_cn"] = "血色学者之帽";
      ["objective"] = "In order to create the Cap of the Scarlet Savant, you will be required to bring the following items back to Malyfous Darkhammer: 1 Pristine Hide of the Beast; 5 Frayed Abomination Stitchings; 8 Arcane Crystals; 5 Enchanted Scarlet Thread. $B$BYou will also be required to pay 50 gold pieces for the crafting of the item.";
      ["faction"] = "Horde";
      ["name"] = "Cap of the Scarlet Savant";
      ["sort"] = "Winterspring";
      ["prev"] = 5047;
      ["prequests"] = {
         [1] = 5047;
      };
      ["level"] = 60;
      ["name_es"] = "Almete del Sabio Escarlata";
      ["req"] = 57;
   };
   [5095] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out High Executor Derrington.  His base camp is located at the Bulwark, east of Tirisfal Glades and the Undercity.";
      ["next"] = 5096;
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["followup"] = 5096;
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Horde";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [5127] = {
      ["name_ru"] = "Демонова кузня";
      ["type"] = "Dungeon";
      ["name_fr"] = "La forge demoniaque";
      ["name_de"] = "Die Damonenschmiede";
      ["reward"] = {
         [1] = 12696;
         [2] = 9224;
         [3] = 12849;
      };
      ["name_cn"] = "?魔熔炉";
      ["objective"] = "Travel to Blackrock Spire and find Goraluk Anvilcrack. Slay him and then use the Blood Stained Pike upon his corpse. After his soul has been siphoned, the pike will be Soul Stained.$B$BYou must also find the Unforged Rune Covered Breastplate.$B$BReturn both the Soul Stained Pike and the Unforged Rune Covered Breastplate to Lorax in Winterspring.";
      ["faction"] = "Horde";
      ["name"] = "The Demon Forge";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 5126;
      ["prequests"] = {
         [1] = 5126;
      };
      ["level"] = 60;
      ["name_es"] = "La forja demoniaca";
      ["req"] = 55;
   };
   [5143] = {
      ["name_ru"] = "Кожевничество: традиции предков";
      ["type"] = "Solo";
      ["objective"] = "Bring a Wild Leather Vest and a Wild Leather Helmet to Caryssia Moonhunter in Feralas.$B$BCompleting this quest will give you access to the Tribal Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Dragonscale Leatherworking and Elemental Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "部族制皮";
      ["name_fr"] = "Travail du cuir tribal";
      ["name_de"] = "Stammeslederverarbeitung";
      ["faction"] = "Alliance";
      ["name"] = "Tribal Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria tribal";
      ["req"] = 40;
   };
   [5159] = {
      ["name_ru"] = "Чистая вода возвращается в Оскверненный лес";
      ["type"] = "Solo";
      ["name_fr"] = "L'eau purifiee retourne a Gangrebois";
      ["next"] = 5165;
      ["name_de"] = "Gesaubertes Wasser wird zum Teufelswald gebracht";
      ["name_cn"] = "?化?的水";
      ["objective"] = "Take the Purified Moon Well Water to Greta Mosshoof in Felwood.";
      ["sort"] = "Felwood";
      ["faction"] = "Horde";
      ["name"] = "Cleansed Water Returns to Felwood";
      ["prev"] = 5158;
      ["prequests"] = {
         [1] = 5158;
      };
      ["level"] = 54;
      ["name_es"] = "El agua purificada vuelve a Frondavil";
      ["req"] = 48;
   };
   [2604] = {
      ["name_ru"] = "Духовное господство";
      ["type"] = "Solo";
      ["name_fr"] = "Domination spirituelle";
      ["name_de"] = "Geistige Beherrschung";
      ["reward"] = {
         [1] = 8424;
      };
      ["name_cn"] = "精神矍?";
      ["objective"] = "Bring ten Vulture Gizzards and two Snickerfang Jowls to Bloodmage Lynnore.$B";
      ["faction"] = "Horde";
      ["name"] = "Spiritual Domination";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2603;
      ["prequests"] = {
         [1] = 2603;
      };
      ["level"] = 50;
      ["name_es"] = "Dominacion espiritual";
      ["req"] = 45;
   };
   [5223] = {
      ["name_ru"] = "Возвращение в лагерь Промозглого Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au camp du Noroit";
      ["repgain"] = {
         [469] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Zugwindlager";
      ["name"] = "Return to Chillwind Camp";
      ["name_cn"] = "返回冰??";
      ["objective"] = "Bring the Filled Writhing Haunt Bottle to High Priestess MacDonnell at Chillwind Camp, Western Plaguelands.";
      ["next"] = 5225;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5222;
      ["prequests"] = {
         [1] = 5222;
      };
      ["level"] = 55;
      ["name_es"] = "Regresa al Campamento del Orvallo";
      ["req"] = 50;
   };
   [5463] = {
      ["name_ru"] = "Дар Менетила";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le cadeau de Menethil";
      ["next"] = 5464;
      ["name_de"] = "Menethils Geschenk";
      ["name"] = "Menethil's Gift";
      ["name_cn"] = "米奈希?的礼物";
      ["objective"] = "Travel to Stratholme and find Menethil's Gift. Place the Keepsake of Remembrance upon the unholy ground. ";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Stratholme";
      ["prev"] = 5462;
      ["prequests"] = {
         [1] = 5462;
      };
      ["level"] = 60;
      ["name_es"] = "El Obsequio de Menethil";
      ["req"] = 57;
   };
   [2748] = {
      ["name_ru"] = "Хорошее яйцо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [530] = 10;
         [69] = 10;
      };
      ["name_de"] = "Ein gutes Ei";
      ["name_fr"] = "Un ?uf de premier choix";
      ["name_cn"] = "?良的蛋";
      ["faction"] = "Horde";
      ["name"] = "A Fine Egg";
      ["reward"] = {
         [1] = 9540;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 2741;
      ["prequests"] = {
         [1] = 2741;
      };
      ["level"] = 60;
      ["name_es"] = "Un huevo de primera";
      ["req"] = 42;
   };
   [2756] = {
      ["name_ru"] = "Старые обычаи";
      ["type"] = "Solo";
      ["objective"] = "Bring four Steel Breastplates and four Steel Plate Helms to Aturk the Anvil in Orgrimmar.$B";
      ["next"] = 2757;
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "古老的技?";
      ["name_fr"] = "Les vieilles voies";
      ["name_de"] = "Die alten Traditionen";
      ["faction"] = "Horde";
      ["name"] = "The Old Ways";
      ["level"] = 40;
      ["name_es"] = "Los viejos habitos";
      ["req"] = 40;
   };
   [2764] = {
      ["name_ru"] = "Лучший ученик Гальвана";
      ["type"] = "Solo";
      ["name_fr"] = "Le meilleur disciple de Galvan";
      ["name_de"] = "Galvans bester Schuler";
      ["name_cn"] = "加?文的得意?生";
      ["objective"] = "Speak with Trenton Lighthammer in Gadgetzan.";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Horde";
      ["name"] = "Galvan's Finest Pupil";
      ["prev"] = 2761;
      ["prequests"] = {
         [1] = 2761;
      };
      ["level"] = 45;
      ["name_es"] = "El mejor alumno de Galvan";
      ["req"] = 40;
   };
   [5543] = {
      ["name_ru"] = "Окровавленные небеса";
      ["type"] = "Solo";
      ["objective"] = "Slay 30 Plaguebats and return to Tirion Fordring.";
      ["next"] = 5742;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "血染的天空";
      ["name_fr"] = "Ciel couleur de sang";
      ["followup"] = 5742;
      ["name_de"] = "Blutgefarbter Himmel";
      ["faction"] = "Horde";
      ["name"] = "Blood Tinged Skies";
      ["level"] = 56;
      ["name_es"] = "Cielos sangrientos";
      ["req"] = 52;
   };
   [5623] = {
      ["name_ru"] = "Во имя Света";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Josetta in Elwynn Forest.";
      ["next"] = 5624;
      ["name_de"] = "Dem Licht geneigt";
      ["sort"] = "Priest";
      ["name_cn"] = "?光的恩?";
      ["name_fr"] = "Au service de la Lumiere";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "In Favor of the Light";
      ["level"] = 4;
      ["name_es"] = "Al servicio de la Luz";
      ["req"] = 5;
   };
   [5639] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["sort"] = "Priest";
      ["name_cn"] = "?望祷言*";
      ["name_fr"] = "Priere du desespoir";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [5655] = {
      ["name_ru"] = "Обессиливающий сглаз";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Verhexung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱妖?*";
      ["name_fr"] = "Le malefice de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Hex of Weakness";
      ["level"] = 10;
      ["name_es"] = "Maleficio de Debilidad";
      ["req"] = 10;
   };
   [2844] = {
      ["name_ru"] = "Великан-опекун";
      ["type"] = "Solo";
      ["objective"] = "Locate the lost night elf girl.";
      ["next"] = 2845;
      ["sort"] = "Feralas";
      ["name_cn"] = "大保姆";
      ["name_fr"] = "Le garde geant";
      ["name_de"] = "Der Riesenwachter";
      ["faction"] = "Alliance";
      ["name"] = "The Giant Guardian";
      ["level"] = 49;
      ["name_es"] = "El guardian gigante";
      ["req"] = 44;
   };
   [2852] = {
      ["name_ru"] = "Дикарские кожаные поножи";
      ["type"] = "Solo";
      ["name_fr"] = "Les jambieres en cuir fauve";
      ["name_de"] = "Wildledergamaschen";
      ["objective"] = "Bring 2 Turtle Scale Helms, 2 Turtle Scale Bracers, and 2 Wildvines to Pratt McGrubben in Feathermoon Stronghold.";
      ["followup"] = 2853;
      ["name_cn"] = "蛮皮?腿";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Leggings";
      ["reward"] = {
         [1] = 8407;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 45;
      ["name_es"] = "Leotardos de cuero salvaje";
      ["req"] = 30;
   };
   [2860] = {
      ["name_ru"] = "Мастер школы Дикаря";
      ["type"] = "Solo";
      ["name_fr"] = "Maitre du cuir fauve";
      ["name_de"] = "Meister des Wildleders";
      ["name_cn"] = "蛮皮?甲大?";
      ["objective"] = "Give Jangdor's Letter to Una, the master leatherworker of Thunder Bluff.";
      ["sort"] = "Leatherworking";
      ["reward"] = {
         [1] = 8408;
      };
      ["name"] = "Master of the Wild Leather";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2859;
         [2] = 2855;
         [3] = 2856;
         [4] = 2857;
         [5] = 2858;
      };
      ["level"] = 45;
      ["name_es"] = "Maestro de cuero salvaje";
      ["req"] = 30;
   };
   [2876] = {
      ["name_ru"] = "Расписание кораблей";
      ["type"] = "Solo";
      ["objective"] = "Report the Ship Schedules to an authority in Steamwheedle Port.";
      ["repgain"] = {
         [369] = 350;
      };
      ["name_fr"] = "Horaires des bateaux";
      ["sort"] = "Tanaris";
      ["name_cn"] = "船??刻表";
      ["name_de"] = "Schiffzeitplane";
      ["faction"] = "Horde";
      ["name"] = "Ship Schedules";
      ["level"] = 45;
      ["name_es"] = "El registro nautico";
      ["req"] = 40;
   };
   [5847] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue !";
      ["name_cn"] = "?迎!*";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Deathknell Gift Voucher to Claire Willower in Deathknell.";
      ["sort"] = "Deathknell";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [5863] = {
      ["name_ru"] = "Поселение Песчаного Молота";
      ["type"] = "Solo";
      ["objective"] = "Andi Lynn in Gadgetzan wants you to destroy the Dunemaul Compound by killing 10 Dunemaul Brutes, 10 Dunemaul Enforcers, and Gor'marok the Ravager.";
      ["repgain"] = {
         [369] = 250;
      };
      ["sort"] = "Tanaris";
      ["name_fr"] = "La base des Cognedunes";
      ["name_cn"] = "砂槌食人魔";
      ["reward"] = {
         [1] = 16738;
         [2] = 16739;
      };
      ["name_de"] = "Das Truppenlager der Dunenbrecher";
      ["faction"] = "Horde";
      ["name"] = "The Dunemaul Compound";
      ["level"] = 49;
      ["name_es"] = "La Base Machacaduna";
      ["req"] = 44;
   };
   [2940] = {
      ["name_ru"] = "\"Фералас: История\"";
      ["type"] = "Solo";
      ["name_fr"] = "Feralas?: une histoire";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Feralas: Ein historischer Abriss";
      ["name"] = "Feralas: A History";
      ["name_cn"] = "菲拉斯的?史";
      ["objective"] = "Ask Daryn Lightwind if you may borrow her book.";
      ["next"] = 2941;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2939;
      ["prequests"] = {
         [1] = 2939;
      };
      ["level"] = 47;
      ["name_es"] = "Feralas: una historia";
      ["req"] = 42;
   };
   [2948] = {
      ["name_ru"] = "Гномское усовершенствование";
      ["type"] = "Solo";
      ["objective"] = "Bring the Brilliant Gold Ring, a Silver Bar, a Moss Agate, and 30 silver coins to Talvash del Kissel in Ironforge.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Gnomenverbesserungen";
      ["reward"] = {
         [1] = 9538;
      };
      ["name_cn"] = "侏儒的手?";
      ["name_fr"] = "Amelioration gnomique";
      ["faction"] = "Alliance";
      ["name"] = "Gnome Improvement";
      ["sort"] = "Ironforge";
      ["prev"] = 2947;
      ["prequests"] = {
         [1] = 2947;
      };
      ["level"] = 35;
      ["name_es"] = "Mejora gnomica";
      ["req"] = 28;
   };
   [5927] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Turak Runetotem on the Elder Rise of Thunder Bluff.";
      ["next"] = 5922;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "回?召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [2972] = {
      ["name_ru"] = "Небольшое возмездие";
      ["type"] = "Solo";
      ["objective"] = "Take Jer'kai's Signet Ring to High Priestess Tyrande Whisperwind in Darnassus.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Gerechtigkeit uben";
      ["reward"] = {
         [1] = 10705;
         [2] = 10706;
      };
      ["name_cn"] = "菲拉斯的正?";
      ["name_fr"] = "Justice de chatiment";
      ["faction"] = "Alliance";
      ["name"] = "Doling Justice";
      ["sort"] = "Feralas";
      ["prev"] = 2970;
      ["prequests"] = {
         [1] = 2970;
      };
      ["level"] = 47;
      ["name_es"] = "La justicia del castigo";
      ["req"] = 38;
   };
   [2980] = {
      ["name_ru"] = "Огры Фераласа";
      ["type"] = "Solo";
      ["objective"] = "Rok Orhan in Camp Mojache wants you to kill 10 Gordunni Shaman, 10 Gordunni Warlocks, and 5 Gordunni Maulers.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Die Oger von Feralas";
      ["name"] = "The Ogres of Feralas";
      ["name_cn"] = "菲拉斯的食人魔";
      ["name_fr"] = "Les ogres de Feralas";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 2975;
      ["prequests"] = {
         [1] = 2975;
      };
      ["level"] = 44;
      ["name_es"] = "Los ogros de Feralas";
      ["req"] = 38;
   };
   [2988] = {
      ["name_ru"] = "Тролльи клетки";
      ["type"] = "Solo";
      ["objective"] = "Check the cages at the two Witherbark villages, then return to Gryphon  Master Talonaxe.";
      ["next"] = 2989;
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "枯木巨魔的牢?";
      ["name_fr"] = "Les cages Fanecorce";
      ["name_de"] = "Kafige der Bleichborken";
      ["faction"] = "Alliance";
      ["name"] = "Witherbark Cages";
      ["level"] = 45;
      ["name_es"] = "Las jaulas de Secacorteza";
      ["req"] = 40;
   };
   [2996] = {
      ["name_ru"] = "В поисках Страхада";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in Ratchet.";
      ["sort"] = "Warlock";
      ["name_cn"] = "?找斯坦哈德";
      ["name_fr"] = "A la recherche de Strahad";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Die Suche nach Strahad";
      ["faction"] = "Horde";
      ["name"] = "Seeking Strahad";
      ["level"] = 30;
      ["name_es"] = "Buscando a Strahad";
      ["req"] = 30;
   };
   [6023] = {
      ["name_ru"] = "Неоконченное дело";
      ["type"] = "Solo";
      ["name_fr"] = "Un travail inacheve";
      ["next"] = 6025;
      ["name_de"] = "Offene Rechnungen";
      ["name"] = "Unfinished Business";
      ["name_cn"] = "未完的任?";
      ["objective"] = "Kill Huntsman Radley and Cavalier Durgen before returning to Kirsta Deepshadow in Western Plaguelands.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 6004;
      ["prequests"] = {
         [1] = 6004;
      };
      ["level"] = 57;
      ["name_es"] = "Negocios inconclusos";
      ["req"] = 50;
   };
   [6071] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dazalar in Dolanaar.";
      ["next"] = 6063;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6087] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Prairie Stalker. Practice your skills, then return the Taming Rod to Yaw Sharpmane in Bloodhoof Village.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6088;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6061;
      ["prequests"] = {
         [1] = 6061;
      };
      ["series"] = 2;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6103] = {
      ["name_ru"] = "Обучение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Entrainer la bete";
      ["name_de"] = "Die Ausbildung des Tiers";
      ["objective"] = "Speak to Jocaste in the Cenarion Enclave, in Darnassus.";
      ["name_cn"] = "??野?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Training the Beast";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 6102;
      ["prequests"] = {
         [1] = 6102;
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6135] = {
      ["name_ru"] = "Проклятый Тенекрыл";
      ["type"] = "Group";
      ["objective"] = "Find Duskwing and slay him. From the corpse, recover a Patch of Duskwing's Fur and return it to Nathanos Blightcaller.$B$BIt is said that Duskwing roams the countryside to the north of Marris Stead.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Dammerschwinge, oh, wie ich Euch hasse...";
      ["reward"] = {
         [1] = 16994;
         [2] = 16995;
      };
      ["name_cn"] = "暗翼蝠";
      ["name_fr"] = "Crepuscaile, oh comme je te hais?!";
      ["faction"] = "Horde";
      ["name"] = "Duskwing, Oh How I Hate Thee...";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6133;
      ["prequests"] = {
         [1] = 6133;
      };
      ["level"] = 60;
      ["name_es"] = "Alaocaso, como te odio...";
      ["req"] = 56;
   };
   [3084] = {
      ["name_ru"] = "Руническая табличка";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette runique";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Mit Runen beschriftete Schrifttafel";
      ["objective"] = "Speak to Shikrik in the Valley of Trials.";
      ["name_cn"] = "符文石板";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Rune-Inscribed Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "La tablilla con runas grabadas";
      ["req"] = 1;
   };
   [8269] = {
      ["name_ru"] = "Ленты жертвоприношения";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ribbons of Sacrifice to Sentinel Farsong so that the Sentinels may reward you for acting on our behalf.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "奉献??";
      ["name_fr"] = "Les rubans de sacrifice";
      ["name_de"] = "Aufopferungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ribbons of Sacrifice";
      ["level"] = 60;
      ["name_es"] = "Galon de sacrificio";
      ["req"] = 40;
   };
   [8301] = {
      ["name_ru"] = "Путь праведника";
      ["type"] = "Group";
      ["objective"] = "Collect 200 Silithid Carapace Fragments and return to Baristolth.";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Der Pfad des Gerechten";
      ["reward"] = {
         [1] = 20403;
      };
      ["name_cn"] = "正?之路";
      ["name_fr"] = "Le Chemin des Justes";
      ["faction"] = "Horde";
      ["name"] = "The Path of the Righteous";
      ["sort"] = "Silithus";
      ["prev"] = 8288;
      ["prequests"] = {
         [1] = 8288;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del honrado";
      ["req"] = 60;
   };
   [8333] = {
      ["name_ru"] = "Статусный медальон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Das Standesmedaillon";
      ["name_fr"] = "Le medaillon de statut";
      ["name_cn"] = "身??章";
      ["name"] = "Medallion of Station";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 20422;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8332;
      ["prequests"] = {
         [1] = 8332;
      };
      ["level"] = 60;
      ["name_es"] = "Medallon de estatus";
      ["req"] = 60;
   };
   [3116] = {
      ["name_ru"] = "Простой знак";
      ["type"] = "Solo";
      ["name_fr"] = "Sceau simple";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Einfaches Siegelzeichen";
      ["objective"] = "Read the Simple Sigil and speak to Alyissia in Shadowglen.";
      ["name_cn"] = "?易符?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Sigil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 457;
      ["prequests"] = {
         [1] = 457;
      };
      ["level"] = 1;
      ["name_es"] = "El sigilo simple";
      ["req"] = 1;
   };
   [8397] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 50;
      };
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["prev"] = 8395;
      ["prequests"] = {
         [1] = 8395;
      };
      ["level"] = 59;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 50;
   };
   [8429] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 59;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 50;
   };
   [8461] = {
      ["name_ru"] = "Северные фурболги Мертвого Леса";
      ["type"] = "Solo";
      ["objective"] = "Nafien would like you to kill 6 Deadwood Den Watchers, 6 Deadwood Avengers, and 6 Deadwood Shamans.  Return to him in northern Felwood near the entrance to Timbermaw Hold.";
      ["repgain"] = {
         [576] = 150;
      };
      ["sort"] = "Timbermaw Hold";
      ["name_fr"] = "Les Mort-bois du nord";
      ["name_cn"] = "北方的死木熊怪";
      ["reward"] = {
         [1] = 21316;
         [2] = 21317;
      };
      ["name_de"] = "Totenwaldfelle des Nordens";
      ["faction"] = "Horde";
      ["name"] = "Deadwood of the North";
      ["level"] = 55;
      ["name_es"] = "Los Muertobosque del Norte";
      ["req"] = 45;
   };
   [8493] = {
      ["name_ru"] = "Альянсу все еще не хватает медных слитков!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de barres de cuivre !";
      ["name_de"] = "Die Allianz braucht mehr Kupferbarren!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_cn"] = "?盟需要更多??！";
      ["objective"] = "Bring 20 copper bars to Sergeant Stonebrow at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Copper Bars!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8492;
      ["prequests"] = {
         [1] = 8492;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas lingotes de cobre!";
      ["req"] = 1;
   };
   [8525] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает радужного тунца!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de thon arc-en-ciel?!";
      ["name_de"] = "Die Allianz braucht mehr Regenbogenflossenthunfisch!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_cn"] = "?盟需要更多彩??！";
      ["objective"] = "Bring 20 rainbow fin albacore to Slicky Gastronome at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Rainbow Fin Albacore!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8524;
      ["prequests"] = {
         [1] = 8524;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas atun blanco arco iris!";
      ["req"] = 1;
   };
   [8557] = {
      ["name_ru"] = "Пелерина неумолимой силы";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Martial Drape, 2 Onyx Idols, 5 Silver Scarabs and 5 Bone Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Drape de force inflexible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?定力量披?";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21394;
      };
      ["name_de"] = "Tuch der unnachgiebigen Starke";
      ["faction"] = "Horde";
      ["name"] = "Drape of Unyielding Strength";
      ["level"] = 60;
      ["name_es"] = "El manton de fuerza implacable";
      ["req"] = 60;
   };
   [6343] = {
      ["name_ru"] = "Возвращение к Нессе";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner a Nessa";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Ruckkehr zu Nyoma";
      ["name_cn"] = "?回泰?希?";
      ["objective"] = "Bring Laird's Response to Nessa Shadowsong.";
      ["sort"] = "Darkshore";
      ["name"] = "Return to Nessa";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 6342;
      ["prequests"] = {
         [1] = 6342;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa junto con Nyoma";
      ["req"] = 10;
   };
   [8621] = {
      ["name_ru"] = "Прочные ботинки Зовущего бурю";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of the Sage, 5 Bronze Scarabs and 5 Clay Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "?暴召?者的足甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes d'implorateur de tempete";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Fusschutzer des Sturmrufers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21373;
      };
      ["name"] = "Stormcaller's Footguards";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardapies de clamatormentas";
      ["req"] = 60;
   };
   [8653] = {
      ["name_ru"] = "Предок Златокладезь";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Puits-dore";
      ["name_cn"] = "金井?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Goldbrunn";
      ["faction"] = "Horde";
      ["name"] = "Goldwell the Elder";
      ["level"] = 60;
      ["name_es"] = "Pozo de Oro el Ancestro";
      ["req"] = 1;
   };
   [6391] = {
      ["name_ru"] = "Полет в Стальгорн";
      ["type"] = "Solo";
      ["name_fr"] = "Voyage vers Forgefer";
      ["repgain"] = {
         [54] = 75;
         [47] = 75;
      };
      ["name_de"] = "Flug nach Eisenschmiede";
      ["objective"] = "Buy a gryphon to Ironforge from the gryphon master Thorgrum Borrelson, then bring Brock's List to Golnir Bouldertoe in Ironforge.";
      ["name_cn"] = "?往?炉堡";
      ["next"] = 6388;
      ["sort"] = "Loch Modan";
      ["name"] = "Ride to Ironforge";
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["prev"] = 6387;
      ["prequests"] = {
         [1] = 6387;
      };
      ["level"] = 10;
      ["name_es"] = "Vuela a Forjaz";
      ["req"] = 10;
   };
   [8717] = {
      ["name_ru"] = "Предок Лунный Страж";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Gardelune";
      ["name_cn"] = "月光?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Mondwacht";
      ["faction"] = "Horde";
      ["name"] = "Moonwarden the Elder";
      ["level"] = 60;
      ["name_es"] = "Guardaluna el Ancestro";
      ["req"] = 1;
   };
   [8749] = {
      ["name_ru"] = "Путь защитника";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Beschutzers";
      ["name_fr"] = "La voie du Protecteur";
      ["name_cn"] = "保?者之路";
      ["name"] = "The Path of the Protector";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21198;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8748;
      ["prequests"] = {
         [1] = 8748;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del protector";
      ["req"] = 60;
   };
   [8781] = {
      ["name_ru"] = "Нехватка оружия";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Moonsteel Broadswords to Janela Stouthammer at the Ironforge Brigade Outpost outside of Hive'Zora.  You must also bring Logistics Task Briefing VI in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Des armes pour le champ de bataille";
      ["name_cn"] = "??上的武器";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Waffen fur den Feldeinsatz";
      ["faction"] = "Alliance";
      ["name"] = "Arms for the Field";
      ["level"] = 60;
      ["name_es"] = "Armas para el campo de batalla";
      ["req"] = 60;
   };
   [8813] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8845] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8826;
      ["prequests"] = {
         [1] = 8826;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8877] = {
      ["name_ru"] = "Пусковая установка для фейерверков";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Le lanceur de fusees";
      ["name_cn"] = "烟花?射器";
      ["reward"] = {
         [1] = 21738;
         [2] = 21640;
      };
      ["name_de"] = "Zunder fur Feuerwerk";
      ["faction"] = "Horde";
      ["name"] = "Firework Launcher";
      ["level"] = 60;
      ["name_es"] = "Lanzador de fuegos artificiales";
      ["req"] = 45;
   };
   [6503] = {
      ["name_ru"] = "Вестницы Ясеневого леса";
      ["type"] = "Solo";
      ["objective"] = "Kill 9 Ashenvale Outrunners, then return to Kuray'bin at Splintertree Outpost.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Les estafettes d'Orneval";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "灰谷先?者";
      ["name_de"] = "Die Kundschafter des Eschentals";
      ["faction"] = "Horde";
      ["name"] = "Ashenvale Outrunners";
      ["level"] = 24;
      ["name_es"] = "Avanzada de Vallefresno";
      ["req"] = 19;
   };
   [8941] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Shadowcraft Belt and a set of Shadowcraft Gloves to Mokvar in Orgrimmar.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22006;
         [2] = 22002;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [9005] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Dreadmist Mask and Dreadmist Robe.";
      ["reward"] = {
         [1] = 22074;
         [2] = 22075;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [6567] = {
      ["name_ru"] = "Защитник Орды";
      ["type"] = "Solo";
      ["name_fr"] = "Le Champion de la Horde";
      ["next"] = 6568;
      ["name_de"] = "Der Champion der Horde";
      ["name_cn"] = "部落的勇士";
      ["objective"] = "Seek out Rexxar. The Warchief has instructed you as to his whereabouts. Search the paths of Desolace, between the Stonetalon Mountains and Feralas.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "The Champion of the Horde";
      ["prev"] = 6566;
      ["prequests"] = {
         [1] = 6566;
      };
      ["level"] = 60;
      ["name_es"] = "El Campeon de la Horda";
      ["req"] = 55;
   };
   [9069] = {
      ["name_ru"] = "Набедренники Землекрушителя";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make Earthshatter Legguards if you bring him the following: 1 Desecrated Legguards, 20 Wartorn Chain Scraps, 3 Arcanite Bars and 5 Cured Rugged Hides.";
      ["name_cn"] = "碎地者?腿";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le kilt de Brise-terre";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Beinschutzer des Erdspalters";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22465;
      };
      ["name"] = "Earthshatter Legguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las musleras Rompeterra";
      ["req"] = 60;
   };
   [9101] = {
      ["name_ru"] = "Пояс ледяного огня";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make a Frostfire Belt if you bring her the following: 1 Desecrated Belt, 8 Wartorn Cloth Scraps, 2 Arcane Crystals and 2 Mooncloth.";
      ["name_cn"] = "霜火腰?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La ceinture de givrefeu";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Frostfeuergurtel";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22502;
      };
      ["name"] = "Frostfire Belt";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El cinturon de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9165] = {
      ["name_ru"] = "Подорожная";
      ["type"] = "Solo";
      ["objective"] = "Deliver the signed Writ of Safe Passage to Dispatch Commander Metz at Light's Hope Chapel in the Eastern Plaguelands.";
      ["name_fr"] = "Le sauf-conduit";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "安全之路令状";
      ["reward"] = {
         [1] = 22523;
         [2] = 22524;
      };
      ["name_de"] = "Verfugung des freien Geleits";
      ["faction"] = "Horde";
      ["name"] = "Writ of Safe Passage";
      ["level"] = 60;
      ["name_es"] = "La libranza de salvoconducto";
      ["req"] = 55;
   };
   [9197] = {
      ["name_ru"] = "Задание мастера: боевой цыпленок гномов";
      ["type"] = "Solo";
      ["objective"] = "Deliver 4 Gnomish Battle Chickens and the Craftsman's Writ - Gnomish Battle Chicken - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Coqs de combat gnome";
      ["name_cn"] = "工匠令状 - 地精作?小?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Gnomenkampfhuhn";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Gnomish Battle Chicken";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: gallo de batalla gnomico";
      ["req"] = 55;
   };
   [9229] = {
      ["name_ru"] = "Кольцо Судьбы Рамаладни";
      ["type"] = "Raid";
      ["objective"] = "Enter Naxxramas and uncover the Fate of Ramaladni.";
      ["next"] = 9230;
      ["sort"] = "Naxxramas";
      ["name_cn"] = "拉??迪的命?";
      ["name_fr"] = "Le destin de Ramaladni";
      ["name_de"] = "Ramaladnis Schicksal";
      ["faction"] = "Horde";
      ["name"] = "The Fate of Ramaladni";
      ["level"] = 60;
      ["name_es"] = "El destino de Ramaladni";
      ["req"] = 60;
   };
   [9261] = {
      ["name_ru"] = "Что делает Плеть в Стальгорне?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside Ironforge and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "???炉堡的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Eisenschmiede";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Scourge of Ironforge";
      ["level"] = 10;
      ["name_es"] = "Investigar la Plaga de Forjaz";
      ["req"] = 1;
   };
   [9325] = {
      ["name_ru"] = "Похищение пламени Громового Утеса";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of Thunder Bluff to the Festival Loremaster.";
      ["name_fr"] = "Voler la flamme des Pitons du Tonnerre";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取雷霆崖的烈?";
      ["followup"] = 9365;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Donnerfels";
      ["faction"] = "Alliance";
      ["name"] = "Stealing Thunder Bluff's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Cima del Trueno";
      ["req"] = 50;
   };
   [3364] = {
      ["name_ru"] = "Жгучая бражка";
      ["type"] = "Solo";
      ["objective"] = " so get going.  Anvilmar is to the northeast";
      ["repgain"] = {
         [54] = 75;
         [0] = 47;
      };
      ["name_fr"] = "Une livraison de the brulant";
      ["sort"] = "Coldridge Valley";
      ["name_cn"] = "?酒快?";
      ["name_de"] = "Lieferung des kochend heisen Morgengebraus";
      ["faction"] = "Alliance";
      ["name"] = "Scalding Mornbrew Delivery";
      ["level"] = 5;
      ["name_es"] = "Entrega una infusion de albaza hirviendo";
      ["req"] = 4;
   };
   [3372] = {
      ["name_ru"] = "Отпусти их";
      ["type"] = "Group";
      ["name_fr"] = "La liberation";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Erlost sie";
      ["name_cn"] = "?放他?";
      ["name"] = "Release Them";
      ["objective"] = "Find the Mysterious Artifact being guarded by the Twilight's Hammer Idolaters in the northwest quadrant of the Searing Gorge and bring it to the Altar of Suntara in the Slag Pit.$B";
      ["faction"] = "Alliance";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3371;
      ["prequests"] = {
         [1] = 3371;
      };
      ["level"] = 52;
      ["name_es"] = "Liberalos";
      ["req"] = 40;
   };
   [3380] = {
      ["name_ru"] = "Затонувший храм";
      ["type"] = "Dungeon";
      ["objective"] = "Find Marvon Rivetseeker in Tanaris.";
      ["next"] = 3444;
      ["sort"] = "Sunken Temple";
      ["name_cn"] = "?没的神?";
      ["name_fr"] = "Le Temple englouti";
      ["followup"] = 3444;
      ["name_de"] = "Der Versunkene Tempel";
      ["faction"] = "Horde";
      ["name"] = "The Sunken Temple";
      ["level"] = 51;
      ["name_es"] = "El Templo Sumergido";
      ["req"] = 46;
   };
   [6823] = {
      ["name_ru"] = "Агент Гидраксиса";
      ["type"] = "Solo";
      ["name_fr"] = "Agent de Hydraxis";
      ["next"] = 6824;
      ["name_de"] = "Agent von Hydraxis";
      ["name_cn"] = "海?克西斯的使者";
      ["objective"] = "Earn an Honored faction with the Hydraxian Waterlords, then talk to Duke Hydraxis in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Agent of Hydraxis";
      ["prev"] = 6822;
      ["prequests"] = {
         [1] = 6822;
      };
      ["level"] = 60;
      ["name_es"] = "Agente de Hydraxis";
      ["req"] = 60;
   };
   [3444] = {
      ["name_ru"] = "Круглый камень";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Stone Circle from Marvon Rivetseeker's workshop in Ratchet.";
      ["name_fr"] = "Le Cercle de pierres";
      ["sort"] = "Tanaris";
      ["name_cn"] = "石?";
      ["name"] = "The Stone Circle";
      ["name_de"] = "Der runde Stein";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 3380;
         [2] = 3445;
      };
      ["level"] = 51;
      ["name_es"] = "El Circulo de Piedras";
      ["req"] = 46;
   };
   [3452] = {
      ["name_ru"] = "Защита пламени";
      ["type"] = "Group";
      ["name_fr"] = "L'enveloppe de la flamme";
      ["next"] = 3453;
      ["name_de"] = "Die Ummantelung der Flamme";
      ["name_cn"] = "烈?之盒";
      ["objective"] = "Find and return a Symbol of Ragnaros to Kalaran Windblade.";
      ["sort"] = "Searing Gorge";
      ["faction"] = "Horde";
      ["name"] = "The Flame's Casing";
      ["prev"] = 3443;
      ["prequests"] = {
         [1] = 3443;
      };
      ["level"] = 50;
      ["name_es"] = "El soporte para la llama";
      ["req"] = 40;
   };
   [6983] = {
      ["name_ru"] = "Прохладное чувство юмора";
      ["type"] = "Group";
      ["name_fr"] = "La mechancete vous habite...";
      ["next"] = 6984;
      ["name_de"] = "So was Gemeines...";
      ["name_cn"] = "天寒地?";
      ["objective"] = " $N.  Be c-c-careful though!  He is t-t-the one who turned me into this s-s-snowy mess!$B$BYou're g-g-gonna need some help in f-f-facing him.  I've seen him w-w-wander all around where the y-y-yeti are; he's s-s-surely here s-s-somewhere!  F-f-find the treats $N";
      ["sort"] = "Hallow's End";
      ["faction"] = "Horde";
      ["name"] = "You're a Mean One...";
      ["prev"] = 6963;
      ["prequests"] = {
         [1] = 6963;
      };
      ["level"] = 35;
      ["name_es"] = "!Que ruin!";
      ["req"] = 30;
   };
   [3508] = {
      ["name_ru"] = "Минуя охрану";
      ["type"] = "Solo";
      ["name_fr"] = "Briser l'Amulette";
      ["next"] = 3509;
      ["name_de"] = "Den Zauberschutz brechen";
      ["name_cn"] = "破坏?界";
      ["objective"] = "Wait for Loramus to complete the enlightenment spell.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Breaking the Ward";
      ["prev"] = 3141;
      ["prequests"] = {
         [1] = 3141;
      };
      ["level"] = 58;
      ["name_es"] = "Romper el amuleto";
      ["req"] = 45;
   };
   [3524] = {
      ["name_ru"] = "Останки на берегу";
      ["type"] = "Solo";
      ["name_fr"] = "Echouage";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "An Land gespult";
      ["name_cn"] = "?浅的巨?";
      ["objective"] = "Recover Sea Creature Bones from the beached sea creature just south of Auberdine, and then return with it to Gwennyth Bly'Leggonde in Auberdine.";
      ["next"] = 4681;
      ["sort"] = "Darkshore";
      ["name"] = "Washed Ashore";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 13;
      ["name_es"] = "Varado";
      ["req"] = 11;
   };
   [7063] = {
      ["name_ru"] = "Праздник Зимнего Покрова";
      ["type"] = "Solo";
      ["name_fr"] = "La fete du Voile d'hiver";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Das Winterhauchfest";
      ["name_cn"] = "冬幕?";
      ["name"] = "The Feast of Winter Veil";
      ["objective"] = "Feel free to read the book, The Feast of Winter Veil\"";
      ["faction"] = "Alliance";
      ["sort"] = "Hallow's End";
      ["prev"] = 7062;
      ["prequests"] = {
         [1] = 7062;
      };
      ["level"] = 60;
      ["name_es"] = "El festin del Festival de Invierno";
      ["req"] = 10;
   };
   [3564] = {
      ["name_ru"] = "Плата Андрона Джедиге";
      ["type"] = "Solo";
      ["name_fr"] = "Le paiement d'Andron a Jediga";
      ["name_de"] = "Androns Bezahlung fur Jediga";
      ["name_cn"] = "安德隆的?酬";
      ["objective"] = "Deliver Andron's Note to Jediga in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Andron's Payment to Jediga";
      ["prev"] = 3542;
      ["prequests"] = {
         [1] = 3542;
      };
      ["level"] = 52;
      ["name_es"] = "El pago de Andron a Jediga";
      ["req"] = 45;
   };
   [7223] = {
      ["name_ru"] = "Обломки брони";
      ["type"] = "PvP";
      ["objective"] = "Bring 20 Armor Scraps to Murgot Deepforge in Dun Baldar.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "Morceaux d'armures";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?甲碎片";
      ["name_de"] = "Rustungsfetzen";
      ["faction"] = "Alliance";
      ["name"] = "Armor Scraps";
      ["level"] = 60;
      ["name_es"] = "Los restos de armadura";
      ["req"] = 51;
   };
   [3628] = {
      ["name_ru"] = "Ты ? Рах'лих, демон!";
      ["type"] = "Group";
      ["name_fr"] = "Vous etes Rakh'likh, demon";
      ["name_de"] = "Ihr seid Rakh'likh, Damon";
      ["reward"] = {
         [1] = 10778;
         [2] = 10779;
         [3] = 10959;
      };
      ["name_cn"] = "?魔拉瑟莱克";
      ["objective"] = "Destroy Razelikh the Defiler and return the Severed Horn of the Defiler to the Fallen Hero of the Horde. You will also need to return the Ward of the Defiler so that the Fallen Hero can destroy it, preventing it from ever falling into the wrong hands.$B";
      ["faction"] = "Horde";
      ["name"] = "You Are Rakh'likh, Demon";
      ["sort"] = "Blasted Lands";
      ["prev"] = 3627;
      ["prequests"] = {
         [1] = 3627;
      };
      ["level"] = 60;
      ["name_es"] = "Eres Rakh'likh, demonio";
      ["req"] = 45;
   };
   [3636] = {
      ["name_ru"] = "Нести свет";
      ["type"] = "Dungeon";
      ["objective"] = "Archbishop Bendictus wants you to slay Amnennar the Coldbringer in Razorfen Downs.";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Razorfen Downs";
      ["name_fr"] = "Apportez la Lumiere";
      ["name_cn"] = "与?光同在";
      ["reward"] = {
         [1] = 10823;
         [2] = 10824;
      };
      ["name_de"] = "Das Licht bringen";
      ["faction"] = "Alliance";
      ["name"] = "Bring the Light";
      ["level"] = 42;
      ["name_es"] = "Trae la Luz";
      ["req"] = 39;
   };
   [3644] = {
      ["name_ru"] = "Продление членского билета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Mitgliedskarten-Erneuerung";
      ["name_fr"] = "Le renouvellement de la Carte de membre";
      ["name_cn"] = "会????";
      ["name"] = "Membership Card Renewal";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 10791;
      };
      ["sort"] = "Engineering";
      ["prev"] = 3639;
      ["prequests"] = {
         [1] = 3639;
      };
      ["level"] = 47;
      ["name_es"] = "Renovacion de la tarjeta de miembro";
      ["req"] = 30;
   };
   [7367] = {
      ["name_ru"] = "Обезвредить угрозу";
      ["type"] = "PvP";
      ["objective"] = "Find the Frostwolf Explosives Expert and kill him. Return to the Stormpike Explosives Expert when the task is complete.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "爆破?家";
      ["name_fr"] = "Desarmer les mines";
      ["name_de"] = "Die Gefahr bannen";
      ["faction"] = "Alliance";
      ["name"] = "Defusing the Threat";
      ["level"] = 60;
      ["name_es"] = "Acabar con la amenaza";
      ["req"] = 51;
   };
   [7383] = {
      ["name_ru"] = "Венец Земли";
      ["type"] = "Solo";
      ["objective"] = "Fill the Amethyst Phial and bring it back to Corithras Moonrage in Dolanaar.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Teldrassil: Die Burde der Kaldorei";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "泰?希?：?多雷的?担";
      ["next"] = 935;
      ["series"] = 5;
      ["faction"] = "Alliance";
      ["name"] = "Crown of the Earth";
      ["prev"] = 933;
      ["prequests"] = {
         [1] = 933;
      };
      ["level"] = 11;
      ["name_es"] = "Teldrassil: La carga de los Kaldorei";
      ["req"] = 1;
   };
   [7463] = {
      ["name_ru"] = "Магический напиток";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to the Warpwood Quarter of Dire Maul and slay the water elemental, Hydrospawn. Return to Lorekeeper Lydros in the Athenaeum with the Hydrospawn Essence.";
      ["repgain"] = {
         [809] = 200;
      };
      ["name_fr"] = "Rafraichissement arcanique";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "久?的法?";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Arkane Erfrischung";
      ["faction"] = "Horde";
      ["name"] = "Arcane Refreshment";
      ["level"] = 60;
      ["name_es"] = "El refresco arcano";
      ["req"] = 60;
   };
   [7495] = {
      ["name_ru"] = "Славная победа Альянса";
      ["type"] = "Solo";
      ["objective"] = "Take the Head of Onyxia to Highlord Bolvar Fordragon in Stormwind.";
      ["next"] = 7496;
      ["name_fr"] = "Victoire pour l'Alliance?!";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?盟的?利";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Sieg fur die Allianz";
      ["faction"] = "Alliance";
      ["name"] = "Victory for the Alliance";
      ["level"] = 60;
      ["name_es"] = "Victoria para la Alianza";
      ["req"] = 50;
   };
   [3764] = {
      ["name_ru"] = "Почва Ун'Горо";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Un'Goro Soil samples to Jenal at the Cenarion Enclave in Darnassus.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "La terre d'Un'Goro";
      ["sort"] = "Darnassus";
      ["name_cn"] = "安戈洛的泥土";
      ["name_de"] = "Erde von Un'Goro";
      ["faction"] = "Alliance";
      ["name"] = "Un'Goro Soil";
      ["level"] = 50;
      ["name_es"] = "Tierra de Un'Goro";
      ["req"] = 47;
   };
   [3788] = {
      ["name_ru"] = "Просьба друида";
      ["type"] = "Solo";
      ["name_fr"] = "La requete de Gentecime";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Lebenshands Bitte";
      ["name"] = "Jonespyre's Request";
      ["name_cn"] = "奎恩提斯的?求";
      ["objective"] = "Speak with Quintis Jonespyre in Feathermoon Stronghold.";
      ["next"] = 3791;
      ["faction"] = "Alliance";
      ["sort"] = "Feathermoon Stronghold";
      ["prev"] = 3785;
      ["prequests"] = {
         [1] = 3785;
      };
      ["level"] = 50;
      ["name_es"] = "La peticion de Jonguja";
      ["req"] = 47;
   };
   [3804] = {
      ["name_ru"] = "Рассветница для Громового Утеса";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 50;
      };
      ["name_de"] = "Morgenkorn nach Donnerfels";
      ["name_fr"] = "Des Fibres d'aurore pour les Pitons du Tonnerre";
      ["name_cn"] = "雷霆崖的晨光麦";
      ["faction"] = "Horde";
      ["name"] = "Morrowgrain to Thunder Bluff";
      ["reward"] = {
         [1] = 11887;
      };
      ["sort"] = "Thunder Bluff";
      ["prev"] = 3786;
      ["prequests"] = {
         [1] = 3786;
      };
      ["level"] = 55;
      ["name_es"] = "Managrana para Cima del Trueno";
      ["req"] = 47;
   };
   [7623] = {
      ["name_ru"] = "Лорд Гиблопуст";
      ["type"] = "Solo";
      ["objective"] = "Purchase Shadowy Potions from Gorzeeki in the Burning Steppes.$B$BUse the potions to travel through Jaedenar, and speak with Lord Banehollow.";
      ["next"] = 7624;
      ["sort"] = "Warlock";
      ["name_cn"] = "魔王?恩霍勒";
      ["name_fr"] = "Le seigneur Creuseplaie";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Lord Schattenfluch";
      ["faction"] = "Horde";
      ["name"] = "Lord Banehollow";
      ["level"] = 58;
      ["name_es"] = "Lord Pesadilla";
      ["req"] = 60;
   };
   [7639] = {
      ["name_ru"] = "Демонстрация истинного правосудия";
      ["objective"] = "Return the Exorcism Censer to Lord Grayson Shadowbreaker in the Cathedral District of Stormwind.";
      ["name_cn"] = "??士的?判";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Des preuves de jugement";
      ["repgain"] = {
         [72] = 75;
         [69] = 25;
         [47] = 25;
      };
      ["name_de"] = "Lass Gerechtigkeit walten";
      ["next"] = 7640;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "To Show Due Judgment";
      ["prev"] = 7637;
      ["prequests"] = {
         [1] = 7637;
      };
      ["followup"] = 7640;
      ["name_es"] = "Mostrarse juicioso";
      ["req"] = 60;
   };
   [7655] = {
      ["name_ru"] = "Императорские латные наручи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 150;
      };
      ["name_de"] = "Imperiale Plattenarmschienen";
      ["name_fr"] = "Les brassards imperiaux en plaques";
      ["name_cn"] = "君王板甲?腕";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Bracer";
      ["reward"] = {
         [1] = 12690;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Brazales de placas imperiales";
      ["req"] = 50;
   };
   [7671] = {
      ["name_ru"] = "Новый ледопард";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darnassus";
      ["name_fr"] = "Un nouveau sabre-de-givre";
      ["name_cn"] = "更?霜刃豹";
      ["reward"] = {
         [1] = 18902;
         [2] = 18766;
         [3] = 18767;
      };
      ["name_de"] = "Ersatz fur Euren Frostsabler";
      ["faction"] = "Alliance";
      ["name"] = "Frostsaber Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de sable de hielo";
      ["req"] = 60;
   };
   [3844] = {
      ["name_ru"] = "Тайна, покрытая мраком";
      ["type"] = "Solo";
      ["objective"] = "Look around in the pond for a clue about who this wrecked raft may belong to.";
      ["next"] = 3845;
      ["name_fr"] = "C'est un secret pour tout le monde";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "无人知?的秘密";
      ["series"] = 1;
      ["name_de"] = "Es ist fur jeden ein Geheimnis";
      ["faction"] = "Horde";
      ["name"] = "It's a Secret to Everybody";
      ["level"] = 52;
      ["name_es"] = "Un secreto bien guardado";
      ["req"] = 47;
   };
   [7703] = {
      ["name_ru"] = "Неоконченное дело Гордоков";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Gauntlet of Gordok Might and return it to Captain Kromcrush in Dire Maul.$B$BAccording to Kromcrush, the old timey story\" says that Tortheldrin - a \"creepy\" elf who called himself a prince - stole it from one of the Gordok kings.\"";
      ["name_fr"] = "Affaires inachevees chez les Gordok";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "戈多克食人魔的事?";
      ["reward"] = {
         [1] = 18366;
         [2] = 18367;
         [3] = 18368;
         [4] = 18369;
      };
      ["name_de"] = "Die offene Rechnung der Gordok";
      ["faction"] = "Horde";
      ["name"] = "Unfinished Gordok Business";
      ["level"] = 60;
      ["name_es"] = "Asunto Gordok sin finiquitar";
      ["req"] = 56;
   };
   [7735] = {
      ["name_ru"] = "Безупречная шкура йети";
      ["type"] = "Solo";
      ["objective"] = "Bring the Pristine Yeti Hide to Pratt McGrubben at the Feathermoon Stronghold, Feralas.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Une peau de yeti en parfait etat";
      ["sort"] = "Feralas";
      ["name_cn"] = "原始雪人毛皮";
      ["name_de"] = "Makelloser Yetibalg";
      ["faction"] = "Alliance";
      ["name"] = "Pristine Yeti Hide";
      ["level"] = 48;
      ["name_es"] = "Pellejo de yeti pristino";
      ["req"] = 40;
   };
   [3884] = {
      ["name_ru"] = "Дневник Вилидена";
      ["type"] = "Solo";
      ["objective"] = "Return the journal to Williden Marshal somewhere in Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "威利德的日?";
      ["name_fr"] = "Le journal de Williden";
      ["name_de"] = "Willidens Tagebuch";
      ["faction"] = "Horde";
      ["name"] = "Williden's Journal";
      ["level"] = 50;
      ["name_es"] = "Diario de Williden";
      ["req"] = 48;
   };
   [7783] = {
      ["name_ru"] = "Владыка Черной горы";
      ["type"] = "Solo";
      ["name_fr"] = "Le seigneur de Rochenoire";
      ["repgain"] = {
         [68] = 200;
      };
      ["name_de"] = "Der Herrscher des Schwarzfels";
      ["name_cn"] = "黑石之王";
      ["objective"] = "Return the Head of Nefarian to Thrall in Orgrimmar.";
      ["next"] = 7784;
      ["sort"] = "Orgrimmar";
      ["name"] = "The Lord of Blackrock";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 60;
      ["name_es"] = "Senor de Roca Negra";
      ["req"] = 60;
   };
   [7799] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 150;
      };
      ["sort"] = "Darnassus";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7800;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [3908] = {
      ["name_ru"] = "Тайна, покрытая мраком";
      ["type"] = "Solo";
      ["name_fr"] = "C'est un secret pour tout le monde";
      ["next"] = 3909;
      ["name_de"] = "Es ist fur jeden ein Geheimnis";
      ["name"] = "It's a Secret to Everybody";
      ["name_cn"] = "无人知?的秘密";
      ["objective"] = "Take Linken's Sword to Donova Snowden in Winterspring.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 3845;
      ["prequests"] = {
         [1] = 3845;
      };
      ["level"] = 52;
      ["name_es"] = "Un secreto bien guardado";
      ["req"] = 47;
   };
   [7831] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7824;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [3924] = {
      ["name_ru"] = "Руководство по самофланжу";
      ["type"] = "Solo";
      ["objective"] = "Bring the Samophlange Manual to Rilli Greasygob in Orgrimmar.";
      ["repgain"] = {
         [470] = 350;
         [530] = 150;
         [81] = 150;
         [76] = 150;
      };
      ["name_de"] = "Samophlanghandbuch";
      ["reward"] = {
         [1] = 11855;
         [2] = 11854;
      };
      ["name_cn"] = "主?式??平衡器?明?";
      ["name_fr"] = "Manuel du Samophlange";
      ["faction"] = "Horde";
      ["name"] = "Samophlange Manual";
      ["sort"] = "The Barrens";
      ["prev"] = 3923;
      ["prequests"] = {
         [1] = 3923;
      };
      ["level"] = 19;
      ["name_es"] = "El manual del churumbele";
      ["req"] = 10;
   };
   [7863] = {
      ["name_ru"] = "Припасы часовых";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [890] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage de base de Sentinelle";
      ["name_cn"] = "哨兵基??理包";
      ["reward"] = {
         [1] = 19150;
      };
      ["name_de"] = "Basisuberlebenspaket der Schildwache";
      ["faction"] = "Alliance";
      ["name"] = "Sentinel Basic Care Package";
      ["level"] = 34;
      ["name_es"] = "Botiquin basico de centinela";
      ["req"] = 25;
   };
   [7895] = {
      ["name_ru"] = "Трещащий бронзовый механизм";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Bidules bourdonnants en bronze";
      ["name_cn"] = "高速青???";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Surrendes bronzenes Dingsda";
      ["faction"] = "Horde";
      ["name"] = "Whirring Bronze Gizmo";
      ["level"] = 60;
      ["name_es"] = "Cacharros zumbones de bronce";
      ["req"] = 10;
   };
   [7927] = {
      ["name_ru"] = "Колода карт Новолуния: Порталы";
      ["type"] = "Solo";
      ["objective"] = " so you will have to wait until they are here next.\"";
      ["repgain"] = {
         [909] = 350;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Suite de Portails de Sombrelune";
      ["name_cn"] = "暗月入口套牌";
      ["reward"] = {
         [1] = 19290;
      };
      ["name_de"] = "Portalkartenset des Dunkelmond-Jahrmarkts";
      ["faction"] = "Horde";
      ["name"] = "Darkmoon Portals Deck";
      ["level"] = 55;
      ["name_es"] = "La baraja de Portales de la Luna Negra";
      ["req"] = 1;
   };
   [7943] = {
      ["name_ru"] = "Обмен: глаза летучих мышей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Plus d’yeux de chauve-souris";
      ["name_cn"] = "更多蝙蝠眼";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mehr Fledermausaugen";
      ["faction"] = "Horde";
      ["name"] = "More Bat Eyes";
      ["level"] = 60;
      ["name_es"] = "Mas ojos de murcielago vil";
      ["req"] = 40;
   };
   [4004] = {
      ["name_ru"] = "Спасенная принцесса";
      ["type"] = "Dungeon";
      ["objective"] = "Return to Thrall!$B";
      ["repgain"] = {
         [76] = 500;
         [68] = 500;
         [81] = 500;
         [530] = 500;
      };
      ["name_de"] = "Ist die Prinzessin gerettet?";
      ["reward"] = {
         [1] = 12544;
         [2] = 12545;
      };
      ["name_cn"] = "拯救公主？";
      ["name_fr"] = "La Princesse sauvee??";
      ["faction"] = "Horde";
      ["name"] = "The Princess Saved?";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4003;
      ["prequests"] = {
         [1] = 4003;
      };
      ["level"] = 60;
      ["name_es"] = "?Princesa salvada?";
      ["req"] = 48;
   };
   [8055] = {
      ["name_ru"] = "Знаки Силы: кираса вольнодумца";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker a Primal Hakkari Tabard.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la cuirasse de libre-penseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：思考者胸甲";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19825;
      };
      ["name_de"] = "Symbole der Macht: Die Brustplatte des Freidenkers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Freethinker's Breastplate";
      ["level"] = 61;
      ["name_es"] = "Dechados de Poder: la coraza de librepensador";
      ["req"] = 60;
   };
   [8071] = {
      ["name_ru"] = "Знаки Силы: оплечье исповедника";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Aegis.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: le mantelet de confesseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?悔者?肩";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19841;
      };
      ["name_de"] = "Symbole der Macht: Der Mantel des Glaubenshuters";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Confessor's Mantle";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Manto de confesor";
      ["req"] = 60;
   };
   [8103] = {
      ["name_ru"] = "Камешек Каджаро";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Der Stein des Kajaro";
      ["name_fr"] = "Le caillou de Kajaro";
      ["name"] = "The Pebble of Kajaro";
      ["name_cn"] = "???之石";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 19600;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8102;
      ["prequests"] = {
         [1] = 8102;
      };
      ["level"] = 60;
      ["name_es"] = "El guijarro de Kajaro";
      ["req"] = 60;
   };
   [8119] = {
      ["name_ru"] = "Незамутненное ожерелье видений Вудресса";
      ["objective"] = "";
      ["name_cn"] = "完美巫毒幻象";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La vision limpide de Voodress";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Die unversehrte Vision von Voodress";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "The Unmarred Vision of Voodress";
      ["prev"] = 8118;
      ["prequests"] = {
         [1] = 8118;
      };
      ["reward"] = {
         [1] = 19609;
      };
      ["name_es"] = "Vision inmaculada de Voodress";
      ["req"] = 60;
   };
   [8151] = {
      ["name_ru"] = "Талисман охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ogtinc in Azshara.";
      ["next"] = 8153;
      ["sort"] = "Hunter";
      ["name_cn"] = "?人的?符";
      ["name_fr"] = "Le charme du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name_de"] = "Der Talisman des Jagers";
      ["faction"] = "Horde";
      ["name"] = "The Hunter's Charm";
      ["level"] = 52;
      ["name_es"] = "El talisman del cazador";
      ["req"] = 50;
   };
   [4084] = {
      ["name_ru"] = "Серебряное сердце";
      ["type"] = "Solo";
      ["name_fr"] = "Coeur d'argent";
      ["next"] = 4005;
      ["name_de"] = "Silberherz";
      ["name_cn"] = "?爪?心";
      ["objective"] = "Collect 11 Silvery Claws and 1 Irontree Heart for Eridan Bluewind in Felwood.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Silver Heart";
      ["prev"] = 3942;
      ["prequests"] = {
         [1] = 3942;
      };
      ["level"] = 55;
      ["name_es"] = "Corazon de plata";
      ["req"] = 47;
   };
   [8183] = {
      ["name_ru"] = "Сердце Хаккара";
      ["type"] = "Solo";
      ["objective"] = "Bring the Heart of Hakkar to Molthor on Yojamba Isle.";
      ["repgain"] = {
         [270] = 500;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le c?ur d'Hakkar";
      ["name_cn"] = "哈?之心";
      ["reward"] = {
         [1] = 19948;
         [2] = 19950;
         [3] = 19949;
      };
      ["name_de"] = "Das Herz von Hakkar";
      ["faction"] = "Horde";
      ["name"] = "The Heart of Hakkar";
      ["level"] = 60;
      ["name_es"] = "El corazon de Hakkar";
      ["req"] = 58;
   };
   [4104] = {
      ["name_ru"] = "Лекарство из минералов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Bergbau";
      ["name_fr"] = "Du baume par la pioche";
      ["name_cn"] = "采???膏";
      ["name"] = "Salve via Mining";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4101;
      ["prequests"] = {
         [1] = 4101;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por mineria";
      ["req"] = 48;
   };
   [4120] = {
      ["name_ru"] = "Сила порчи";
      ["type"] = "Solo";
      ["objective"] = "Talo Thornhoof at Camp Mojache in Feralas wants you to kill 12 Angerclaw Grizzlies and 12 Felpaw Ravagers in Felwood.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "La force de la corruption";
      ["sort"] = "Feralas";
      ["name_cn"] = "堕落的力量";
      ["name_de"] = "Die Kraft der Verderbnis";
      ["faction"] = "Horde";
      ["name"] = "The Strength of Corruption";
      ["level"] = 52;
      ["name_es"] = "La fuerza de la corrupcion";
      ["req"] = 47;
   };
   [4136] = {
      ["name_ru"] = "Риббли Крутипроб";
      ["type"] = "Dungeon";
      ["name_fr"] = "Ribbly Fermevanne";
      ["name_de"] = "Ribbly Schraubstutz";
      ["reward"] = {
         [1] = 11865;
         [2] = 11963;
         [3] = 12049;
      };
      ["name_cn"] = "雷布里・斯?比格特";
      ["objective"] = "Bring Ribbly's Head to Yuka Screwspigot in the Burning Steppes.";
      ["faction"] = "Horde";
      ["name"] = "Ribbly Screwspigot";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4324;
      ["prequests"] = {
         [1] = 4324;
      };
      ["level"] = 53;
      ["name_es"] = "Ribbly Llavenrosca";
      ["req"] = 48;
   };
   [8302] = {
      ["name_ru"] = "Рука праведника";
      ["type"] = "Group";
      ["objective"] = "Collect 200 Silithid Carapace Fragments and return to Baristolth.";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Die Hand der Gerechtigkeit";
      ["reward"] = {
         [1] = 20403;
      };
      ["name_cn"] = "正?之手";
      ["name_fr"] = "La Main des Justes";
      ["faction"] = "Horde";
      ["name"] = "The Hand of the Righteous";
      ["sort"] = "Silithus";
      ["prev"] = 8301;
      ["prequests"] = {
         [1] = 8301;
      };
      ["level"] = 60;
      ["name_es"] = "La mano del honrado";
      ["req"] = 60;
   };
   [8366] = {
      ["name_ru"] = "Покажи этим пиратам";
      ["type"] = "Solo";
      ["objective"] = "Security Chief Bilgewhizzle of Steamwheedle Port in Tanaris wants you to kill 10 Southsea Pirates, 10 Southsea Freebooters, 10 Southsea Dock Workers and 10 Southsea Swashbucklers.";
      ["repgain"] = {
         [369] = 250;
      };
      ["sort"] = "Tanaris";
      ["name_fr"] = "Le racket des mers du Sud";
      ["name_cn"] = "南海?仇";
      ["reward"] = {
         [1] = 20640;
         [2] = 20641;
      };
      ["name_de"] = "Gaunerei und Erpressung im Sudmeer";
      ["faction"] = "Horde";
      ["name"] = "Southsea Shakedown";
      ["level"] = 45;
      ["name_es"] = "Mamporros en los Mares del Sur";
      ["req"] = 40;
   };
   [8398] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 50;
      };
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["prev"] = 8396;
      ["prequests"] = {
         [1] = 8396;
      };
      ["level"] = 60;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 60;
   };
   [8430] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 60;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 60;
   };
   [8462] = {
      ["name_ru"] = "Беседа с Нафиэном";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Nafien";
      ["repgain"] = {
         [576] = 25;
      };
      ["name_de"] = "Sprecht mit Nafien";
      ["name_cn"] = "与?菲恩交?";
      ["name"] = "Speak to Nafien";
      ["objective"] = "Travel north along the main road in Felwood and speak with the furbolg named Nafien.  He stands guard outside the entrance to Timbermaw Hold.";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 8460;
      ["prequests"] = {
         [1] = 8460;
      };
      ["level"] = 55;
      ["name_es"] = "Habla con Nafien";
      ["req"] = 45;
   };
   [8494] = {
      ["name_ru"] = "Альянсу не хватает железных слитков!";
      ["type"] = "Solo";
      ["objective"] = " the Alliance has been gearing up for a war in Ahn'Qiraj and is in need of iron bars... a whole mess of 'em. Bring them to me in stacks of twenty. We can count on you";
      ["name_fr"] = "L'Alliance a besoin de barres de fer !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要??！";
      ["reward"] = {
         [1] = 21436;
      };
      ["name_de"] = "Die Allianz braucht Eisenbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Iron Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita barras de hierro!";
      ["req"] = 40;
   };
   [4264] = {
      ["name_ru"] = "Измятая записка";
      ["type"] = "Dungeon";
      ["name_fr"] = "Une note chiffonnee";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Eine zusammengeknullte Notiz";
      ["name"] = "A Crumpled Up Note";
      ["name_cn"] = "弄?的便?";
      ["objective"] = "You may have just stumbled on to something that Marshal Windsor would be interested in seeing. There may be hope, after all.";
      ["next"] = 4282;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4242;
      ["prequests"] = {
         [1] = 4242;
      };
      ["level"] = 58;
      ["name_es"] = "Una nota arrugada";
      ["req"] = 50;
   };
   [8558] = {
      ["name_ru"] = "Серп неумолимой силы";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Spiked Hilt, 2  Alabaster Idols, 5 Crystal Scarabs and 5 Stone Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La faucille de force inflexible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?定力量之?";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21392;
      };
      ["name_de"] = "Sichel der unnachgiebigen Starke";
      ["faction"] = "Horde";
      ["name"] = "Sickle of Unyielding Strength";
      ["level"] = 60;
      ["name_es"] = "La hoz de fuerza implacable";
      ["req"] = 60;
   };
   [4296] = {
      ["name_ru"] = "Табличка Семерых";
      ["type"] = "Solo";
      ["objective"] = "Bring the Tablet Transcript to Maxwort Uberglint in the Burning Steppes.";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "七?石板";
      ["name_fr"] = "Tablette des Sept";
      ["name_de"] = "Schrifttafel der Sieben";
      ["faction"] = "Horde";
      ["name"] = "Tablet of the Seven";
      ["level"] = 50;
      ["name_es"] = "La tablilla de los Siete";
      ["req"] = 50;
   };
   [8622] = {
      ["name_ru"] = "Хауберк Зовущего бурю";
      ["objective"] = "Bring the Carapace of the Old God, 2 Idols of the Sage, 5 Silver Scarabs and 5 Bone Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?暴召?者的?甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le haubert d'implorateur de tempete";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Halsberge des Sturmrufers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21374;
      };
      ["name"] = "Stormcaller's Hauberk";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El camisote de clamatormentas";
      ["req"] = 60;
   };
   [8654] = {
      ["name_ru"] = "Предок Первокамень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Prime-pierre";
      ["name_cn"] = "?石?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Urstein";
      ["faction"] = "Horde";
      ["name"] = "Primestone the Elder";
      ["level"] = 60;
      ["name_es"] = "Primapiedra el Ancestro";
      ["req"] = 1;
   };
   [8686] = {
      ["name_ru"] = "Предок Высокогор";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Haute-montagne";
      ["name_cn"] = "高山?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Hohenberg";
      ["faction"] = "Horde";
      ["name"] = "High Mountain the Elder";
      ["level"] = 60;
      ["name_es"] = "Altomonte el Ancestro";
      ["req"] = 1;
   };
   [8718] = {
      ["name_ru"] = "Предок Быстрый Клинок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Lamevive";
      ["name_cn"] = "迅刀?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Klingentanz";
      ["faction"] = "Horde";
      ["name"] = "Bladeswift the Elder";
      ["level"] = 60;
      ["name_es"] = "Filoveloz el Ancestro";
      ["req"] = 1;
   };
   [8750] = {
      ["name_ru"] = "Путь защитника";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Beschutzers";
      ["name_fr"] = "La voie du Protecteur";
      ["name_cn"] = "保?者之路";
      ["name"] = "The Path of the Protector";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21199;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8749;
      ["prequests"] = {
         [1] = 8749;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del protector";
      ["req"] = 60;
   };
   [8782] = {
      ["name_ru"] = "Поставки формы";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Mooncloth, 2 Bolts of Runecloth and 1 Ironweb Spider Silk to Windcaller Proudhorn at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing VIII in order to complete this quest.";
      ["name_fr"] = "La question des uniformes";
      ["sort"] = "Silithus";
      ["name_cn"] = "制服供?";
      ["reward"] = {
         [1] = 20800;
         [2] = 21132;
      };
      ["name_de"] = "Uniformnachschub";
      ["faction"] = "Alliance";
      ["name"] = "Uniform Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros para uniformes";
      ["req"] = 60;
   };
   [8814] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8846] = {
      ["name_ru"] = "Пять жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Cinq chevalieres pour des fournitures militaires";
      ["name_cn"] = "五枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21509;
      };
      ["name_de"] = "Funf Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Alliance";
      ["name"] = "Five Signets for War Supplies";
      ["level"] = 19;
      ["name_es"] = "Cinco sellos para los suministros belicos";
      ["req"] = 10;
   };
   [8878] = {
      ["name_ru"] = "Праздничные выкройки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Des recettes de fete";
      ["name_cn"] = "?日的???";
      ["reward"] = {
         [1] = 21722;
         [2] = 21640;
         [3] = 21723;
      };
      ["name_de"] = "Festtagsrezepte";
      ["faction"] = "Horde";
      ["name"] = "Festive Recipes";
      ["level"] = 60;
      ["name_es"] = "Patrones para las fiestas";
      ["req"] = 50;
   };
   [8910] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Shadowcraft Bracers to Deliana in Ironforge.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22004;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8942] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Cord of Elements and a set of Gauntlets of Elements to Mokvar in Orgrimmar.$B";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22098;
         [2] = 22099;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [4488] = {
      ["name_ru"] = "Призывание коня Скверны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in Ratchet.";
      ["next"] = 4490;
      ["name_cn"] = "召?地???";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Teufelsross beschworen";
      ["faction"] = "Alliance";
      ["name"] = "Summon Felsteed";
      ["level"] = 40;
      ["name_es"] = "Invoca un corcel vil";
      ["req"] = 40;
   };
   [4504] = {
      ["name_ru"] = "Суперлипучка";
      ["type"] = "Solo";
      ["objective"] = "Collect 12 samples of Super Sticky Tar for Tran'rek in Gadgetzan.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "Ultra collant";
      ["sort"] = "Tanaris";
      ["name_cn"] = "?度粘稠的?青";
      ["name_de"] = "Superkleber";
      ["faction"] = "Horde";
      ["name"] = "Super Sticky";
      ["level"] = 54;
      ["name_es"] = "Superpegajoso";
      ["req"] = 48;
   };
   [9038] = {
      ["name_ru"] = "Наплечье неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make Dreadnaught Pauldrons if you bring him the following items: 1 Desecrated Pauldrons, 12 Wartorn Plate Scraps, 2 Arcanite Bars and 3 Cured Rugged Hides.";
      ["name_cn"] = "无畏肩?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Espauliers de cuirassier";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_de"] = "Schulterstucke des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22419;
      };
      ["name"] = "Dreadnaught Pauldrons";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los espaldares acorator";
      ["req"] = 60;
   };
   [9070] = {
      ["name_ru"] = "Головной убор Землекрушителя";
      ["type"] = "Raid";
      ["name_fr"] = "Le couvre-chef de Brise-terre";
      ["name_de"] = "Kopfstuck des Erdspalters";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make an Earthshatter Headpiece if you bring him the following: 1 Desecrated Headpiece, 15 Wartorn Chain Scraps, 4 Arcanite Bars and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22466;
      };
      ["name_cn"] = "碎地者??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Earthshatter Headpiece";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La celada Rompeterra";
      ["req"] = 60;
   };
   [9102] = {
      ["name_ru"] = "Наручники ледяного огня";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make Frostfire Bindings if you bring her the following: 1 Desecrated Bindings, 6 Wartorn Cloth Scraps, 1 Arcane Crystal and 1 Nexus Crystal.";
      ["name_cn"] = "霜火腕?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les manchettes de givrefeu";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Frostfeuerbindungen";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22503;
      };
      ["name"] = "Frostfire Bindings";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las ataduras de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9198] = {
      ["name_ru"] = "Задание мастера: ториевая труба";
      ["type"] = "Solo";
      ["objective"] = "Deliver 14 Thorium Tubes and the Craftsman's Writ - Thorium Tube - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Tubes en thorium";
      ["name_cn"] = "工匠令状 - 瑟?管";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Thoriumrohre";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Thorium Tube";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: tubo de torio";
      ["req"] = 55;
   };
   [9230] = {
      ["name_ru"] = "Ледяная хватка Рамаладни";
      ["type"] = "Raid";
      ["name_fr"] = "L'etreinte de glace de Ramaladni";
      ["name_de"] = "Ramaladnis eisiger Griff";
      ["reward"] = {
         [1] = 22707;
      };
      ["name_cn"] = "拉??迪的寒冰之握";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands wants you to bring him 1 Frozen Rune, 1 Blue Sapphire and 1 Arcanite Bar.$B";
      ["faction"] = "Horde";
      ["name"] = "Ramaladni's Icy Grasp";
      ["sort"] = "Naxxramas";
      ["prev"] = 9229;
      ["prequests"] = {
         [1] = 9229;
      };
      ["level"] = 60;
      ["name_es"] = "La garra helada de Ramaladni";
      ["req"] = 60;
   };
   [9262] = {
      ["name_ru"] = "Что делает Плеть в Дарнасе?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside Darnassus and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "?????斯的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Darnassus";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Scourge of Darnassus";
      ["level"] = 10;
      ["name_es"] = "Investigar la Plaga de Darnassus";
      ["req"] = 1;
   };
   [9326] = {
      ["name_ru"] = "Похищение пламени Подгорода";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of the Undercity to the Festival Loremaster.";
      ["name_fr"] = "Voler la flamme de Fossoyeuse";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取幽暗城的烈?";
      ["followup"] = 9365;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Unterstadt";
      ["faction"] = "Alliance";
      ["name"] = "Stealing the Undercity's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Entranas";
      ["req"] = 50;
   };
   [9422] = {
      ["name_ru"] = "Истощение пустыни";
      ["type"] = "PvP";
      ["objective"] = "Find and deliver Silithyst to the Silithyst Extractor then speak with General Kirika at the Horde encampment near Hive'Regal.";
      ["repgain"] = {
         [609] = 250;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Passer le desert au peigne fin";
      ["name_cn"] = "横?沙漠";
      ["reward"] = {
         [1] = 13446;
         [2] = 13444;
      };
      ["name_de"] = "Durchkammen der Wuste";
      ["faction"] = "Horde";
      ["name"] = "Scouring the Desert";
      ["level"] = 60;
      ["name_es"] = "Peinando el desierto";
      ["req"] = 55;
   };
   [4728] = {
      ["name_ru"] = "Останки морской твари";
      ["type"] = "Solo";
      ["name_fr"] = "La creature marine echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meereskreatur";
      ["name_cn"] = "?浅的海洋生物";
      ["name"] = "Beached Sea Creature";
      ["objective"] = "Take the Sea Creature Bones to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 14;
      ["name_es"] = "Criatura marina varada";
      ["req"] = 12;
   };
   [4808] = {
      ["name_ru"] = "Фелнок Сталлист";
      ["type"] = "Solo";
      ["name_fr"] = "Felnok Ressordacier";
      ["repgain"] = {
         [577] = 75;
      };
      ["name_de"] = "Felnok Stahlfeder";
      ["name"] = "Felnok Steelspring";
      ["name_cn"] = "菲?克";
      ["objective"] = "Give Tinkee's Letter to Felnok Steelspring.";
      ["next"] = 4809;
      ["faction"] = "Horde";
      ["sort"] = "Burning Steppes";
      ["prev"] = 4726;
      ["prequests"] = {
         [1] = 4726;
      };
      ["level"] = 54;
      ["name_es"] = "Felnok Acerovera";
      ["req"] = 50;
   };
   [4904] = {
      ["name_ru"] = "Долгожданная свобода";
      ["type"] = "Solo";
      ["objective"] = "Escort Lakota Windsong from the Darkcloud Pinnacle, and then talk to Thalia Amberhide at Freewind Post.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Thousand Needles";
      ["name_fr"] = "Libre, enfin?!";
      ["name_cn"] = "??自由";
      ["reward"] = {
         [1] = 15469;
         [2] = 15468;
      };
      ["name_de"] = "Endlich frei";
      ["faction"] = "Horde";
      ["name"] = "Free at Last";
      ["level"] = 29;
      ["name_es"] = "Al fin libre";
      ["req"] = 25;
   };
   [4968] = {
      ["name_ru"] = "Знание шара Орахила";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1799;
      ["sort"] = "Warlock";
      ["name_cn"] = "奥拉赫宝珠";
      ["name_fr"] = "Connaissance de l'Orbe d'Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Wissen der Kugel von Orahil";
      ["faction"] = "Horde";
      ["name"] = "Knowledge of the Orb of Orahil";
      ["level"] = 35;
      ["name_es"] = "El conocimiento del orbe de Orahil";
      ["req"] = 35;
   };
   [4984] = {
      ["name_ru"] = "Страдания природы";
      ["type"] = "Solo";
      ["name_fr"] = "La faune et la flore souffrent aussi";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Die Tierwelt leidet auch";
      ["name_cn"] = "大自然的苦楚";
      ["objective"] = "Destroy 8 Diseased Wolves, and then return to Mulgris Deepriver at the Writhing Haunt, Western Plaguelands.$B$B";
      ["next"] = 4985;
      ["sort"] = "Western Plaguelands";
      ["name"] = "The Wildlife Suffers Too";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 54;
      ["name_es"] = "La naturaleza tambien sufre";
      ["req"] = 51;
   };
   [5048] = {
      ["name_ru"] = "Добросердечная Эмма";
      ["objective"] = "Find Ol' Emma in Stormwind and see if she is in fact Emma Felstone.  If she is, then perhaps she'd like the package Janice Felstone made for her.";
      ["name_cn"] = "善良的艾?";
      ["sort"] = "Stormwind City";
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Emma la bonne pate";
      ["next"] = 5050;
      ["name_de"] = "Emma die Nette";
      ["repgain"] = {
         [72] = 250;
      };
      ["followup"] = 5050;
      ["name"] = "Good Natured Emma";
      ["prev"] = 5022;
      ["prequests"] = {
         [1] = 5022;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "El buen caracter de Emma";
      ["req"] = 50;
   };
   [5064] = {
      ["name_ru"] = "Наблюдение за Зловещим Тотемом";
      ["type"] = "Solo";
      ["objective"] = "Locate and retrieve the three Secret Notes in Darkcloud Pinnacle.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Grimmtotemspionage";
      ["reward"] = {
         [1] = 15457;
         [2] = 15458;
         [3] = 15459;
      };
      ["name_cn"] = "恐怖??的密信";
      ["name_fr"] = "Espionner le Totem-sinistre";
      ["faction"] = "Horde";
      ["name"] = "Grimtotem Spying";
      ["sort"] = "Thousand Needles";
      ["prev"] = 4841;
      ["prequests"] = {
         [1] = 4841;
      };
      ["level"] = 28;
      ["name_es"] = "Espiando a los Totem Siniestro";
      ["req"] = 24;
   };
   [5096] = {
      ["name_ru"] = "Вылазка в стан Алого Ордена";
      ["type"] = "Solo";
      ["name_fr"] = "Diversions ecarlates";
      ["repgain"] = {
         [530] = 75;
         [68] = 250;
         [81] = 75;
         [76] = 75;
      };
      ["name_cn"] = "??血色十字?";
      ["name_de"] = "Scharlachrote Ablenkung";
      ["objective"] = "Proceed to the Scarlet Crusade's base camp between Felstone Field and Dalson's Tears and destroy their command tent.$B$BPlace the Scourge banner at the camp, and then return to High Executor Derrington at the Bulwark, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["name"] = "Scarlet Diversions";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 5093;
         [2] = 5094;
         [3] = 5095;
      };
      ["level"] = 53;
      ["name_es"] = "Distraccion Escarlata";
      ["req"] = 50;
   };
   [5128] = {
      ["name_ru"] = "Слова верховного вождя";
      ["type"] = "Solo";
      ["name_fr"] = "Paroles du Grand Chef";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Worte des Oberhauptlings";
      ["name_cn"] = "熊怪酋?的?";
      ["name"] = "Words of the High Chief";
      ["objective"] = "Take the Crudely-written Log to Kelek Skykeeper in southern Felwood.";
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5123;
      ["prequests"] = {
         [1] = 5123;
      };
      ["level"] = 59;
      ["name_es"] = "Las palabras del Gran Jefe";
      ["req"] = 52;
   };
   [5144] = {
      ["name_ru"] = "Кожевничество: сила стихий";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Heart of Fire, 2 Globe of Water, 2 Core of Earth, and 2 Breath of Wind to Sarah Tanner in Searing Gorge.$B$BCompleting this quest will give you access to the Elemental Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Dragonscale Leatherworking and Tribal Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "元素制皮";
      ["name_fr"] = "Travail du cuir elementaire";
      ["name_de"] = "Elementarlederverarbeitung";
      ["faction"] = "Alliance";
      ["name"] = "Elemental Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria elemental";
      ["req"] = 40;
   };
   [5160] = {
      ["name_ru"] = "Матрона-защитница";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Winterspring and find Haleh. Give her Awbee's scale.";
      ["next"] = 5161;
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "??者";
      ["name_fr"] = "Le Protectorat de la matrone";
      ["name_de"] = "Die oberste Beschutzerin";
      ["faction"] = "Horde";
      ["name"] = "The Matron Protectorate";
      ["level"] = 60;
      ["name_es"] = "El Protectorado de la matrona";
      ["req"] = 57;
   };
   [5224] = {
      ["name_ru"] = "Котел Удела Страданий";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["name_de"] = "Der Kessel des Trostlosen Felds";
      ["name_cn"] = "?哭鬼屋的瘟疫之?";
      ["name_fr"] = "Le chaudron du Repaire putride";
      ["name"] = "Writhing Haunt Cauldron";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5237;
      ["prequests"] = {
         [1] = 5237;
      };
      ["level"] = 55;
      ["name_es"] = "La caldera de El Tormento";
      ["req"] = 50;
   };
   [5384] = {
      ["name_ru"] = "Киртонос Глашатай";
      ["type"] = "Dungeon";
      ["name_fr"] = "Kirtonos le heraut";
      ["name_de"] = "Kirtonos der Herold";
      ["reward"] = {
         [1] = 15805;
         [2] = 13544;
         [3] = 15806;
      };
      ["name_cn"] = "?令官基???斯";
      ["objective"] = "Return to the Scholomance with the Blood of Innocents. Find the porch and place the Blood of Innocents in the brazier. Kirtonos will come to feast upon your soul.$B$BFight valiantly, do not give an inch! Destroy Kirtonos and return to Eva Sarkhoff.$B";
      ["faction"] = "Horde";
      ["name"] = "Kirtonos the Herald";
      ["sort"] = "Scholomance";
      ["prev"] = 5515;
      ["prequests"] = {
         [1] = 5515;
      };
      ["level"] = 60;
      ["name_es"] = "Kirtonos el Heraldo";
      ["req"] = 55;
   };
   [5464] = {
      ["name_ru"] = "Дар Менетила";
      ["objective"] = "Take the Soulbound Keepsake to Leonid Barthalomew in Eastern Plaguelands.";
      ["name_cn"] = "米奈希?的礼物";
      ["sort"] = "Eastern Plaguelands";
      ["level"] = 60;
      ["type"] = "Group";
      ["name_fr"] = "Le cadeau de Menethil";
      ["next"] = 5465;
      ["name_de"] = "Menethils Geschenk";
      ["repgain"] = {
         [529] = 100;
      };
      ["faction"] = "Horde";
      ["name"] = "Menethil's Gift";
      ["prev"] = 5463;
      ["prequests"] = {
         [1] = 5463;
      };
      ["series"] = 2;
      ["name_es"] = "El Obsequio de Menethil";
      ["req"] = 57;
   };
   [5528] = {
      ["name_ru"] = "Лучшее пойло Гордока";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["sort"] = "Dire Maul";
      ["name_fr"] = "La degustation gordok";
      ["name_cn"] = "戈多克好酒";
      ["reward"] = {
         [1] = 18269;
         [2] = 18284;
      };
      ["name_de"] = "Der Gordokgeschmackstest";
      ["faction"] = "Horde";
      ["name"] = "The Gordok Taste Test";
      ["level"] = 60;
      ["name_es"] = "La cata de los Gordok";
      ["req"] = 57;
   };
   [5544] = {
      ["name_ru"] = "Мясо личинок-трупоедов";
      ["type"] = "Solo";
      ["objective"] = "Seek out the Carrion Grubs and Devourers of the region. Slay them and harvest their meat. Return to Tirion Fordring when you have gathered 15 Slabs of Carrion Worm Meat.$B";
      ["next"] = 5742;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "腐肉虫";
      ["name_fr"] = "Larve putride";
      ["followup"] = 5742;
      ["name_de"] = "Aassammlung";
      ["faction"] = "Horde";
      ["name"] = "Carrion Grubbage";
      ["level"] = 56;
      ["name_es"] = "Gusanos carroneros";
      ["req"] = 52;
   };
   [5624] = {
      ["name_ru"] = "Облачение Света";
      ["type"] = "Solo";
      ["name_fr"] = "Vetements de la Lumiere";
      ["name_de"] = "Gewander des Lichts";
      ["sort"] = "Priest";
      ["objective"] = "Find Guard Roberts and heal his wounds using Lesser Heal (Rank 2). Afterwards, grant him Power Word: Fortitude and then return to Priestess Josetta in Goldshire.";
      ["name_cn"] = "?光之衣";
      ["name"] = "Garments of the Light";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 16605;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 5623;
      ["prequests"] = {
         [1] = 5623;
      };
      ["level"] = 4;
      ["name_es"] = "Las prendas de la Luz";
      ["req"] = 5;
   };
   [5656] = {
      ["name_ru"] = "Обессиливающий сглаз";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Verhexung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱妖?";
      ["name_fr"] = "Le malefice de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Hex of Weakness";
      ["level"] = 10;
      ["name_es"] = "Maleficio de Debilidad";
      ["req"] = 10;
   };
   [5672] = {
      ["name_ru"] = "Благодать Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["name_de"] = "Elunes Anmut";
      ["name_cn"] = "艾露恩的?福";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Elune's Grace";
      ["level"] = 20;
      ["name_es"] = "La Gracia de Elune";
      ["req"] = 20;
   };
   [5848] = {
      ["name_ru"] = "Символ семейной любви";
      ["type"] = "Dungeon";
      ["name_fr"] = "De l'amour et de la famille";
      ["next"] = 5861;
      ["name_de"] = "Von Liebe und Familie";
      ["name"] = "Of Love and Family";
      ["name_cn"] = "?与家庭";
      ["objective"] = "Travel to Stratholme, in the northern part of the Plaguelands. It is in the Scarlet Bastion that you will find the painting 'Of Love and Family,' hidden behind another painting depicting the twin moons of our world.$B$BReturn the painting to Tirion Fordring.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Stratholme";
      ["prev"] = 5846;
      ["prequests"] = {
         [1] = 5846;
      };
      ["level"] = 60;
      ["name_es"] = "Del amor y la familia";
      ["req"] = 52;
   };
   [5928] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Turak Runetotem on the Elder Rise of Thunder Bluff.";
      ["next"] = 5922;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "??召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [5944] = {
      ["name_ru"] = "Во сне";
      ["type"] = "Group";
      ["name_fr"] = "En reve";
      ["name_de"] = "In den Traumen";
      ["reward"] = {
         [1] = 15411;
         [2] = 15413;
         [3] = 15418;
         [4] = 15421;
         [5] = 16058;
      };
      ["name_cn"] = "在梦中";
      ["objective"] = "Escort Taelan Fordring out of Hearthglen.";
      ["faction"] = "Horde";
      ["name"] = "In Dreams";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5862;
      ["prequests"] = {
         [1] = 5862;
      };
      ["level"] = 60;
      ["name_es"] = "En suenos";
      ["req"] = 52;
   };
   [6024] = {
      ["name_ru"] = "Мольба Хамейи";
      ["type"] = "Solo";
      ["objective"] = "Kill Infiltrator Hameya.  Use his key on the Mound of Dirt behind the Undercroft.";
      ["name_fr"] = "L'appel d'Hameya";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "哈米?的?求";
      ["reward"] = {
         [1] = 15814;
         [2] = 15815;
      };
      ["name_de"] = "Hameyas Bitte";
      ["faction"] = "Horde";
      ["name"] = "Hameya's Plea";
      ["level"] = 60;
      ["name_es"] = "La suplica de Hameya";
      ["req"] = 54;
   };
   [6072] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dazalar in Dolanaar.";
      ["next"] = 6063;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6088] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Swoop. Practice your skills, then return the Taming Rod to Yaw Sharpmane in Bloodhoof Village.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6089;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6087;
      ["prequests"] = {
         [1] = 6087;
      };
      ["series"] = 3;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6136] = {
      ["name_ru"] = "Огромный червь";
      ["type"] = "Group";
      ["objective"] = "Find Borelgore in the northern wastes of Eastern Plaguelands and destroy him. Return to Nathanos Blightcaller when the mission is complete.";
      ["name_fr"] = "Le corpulent";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "肥大的食腐虫";
      ["reward"] = {
         [1] = 17002;
         [2] = 17003;
         [3] = 17004;
      };
      ["name_de"] = "Der Korpulente";
      ["faction"] = "Horde";
      ["name"] = "The Corpulent One";
      ["level"] = 60;
      ["name_es"] = "El corpulento";
      ["req"] = 56;
   };
   [8239] = {
      ["name_ru"] = "Монеты племен: Песчаная Буря, Дробители Черепов и Кровавый Скальп";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [270] = 25;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Pieces Furie-des-sables, Casse-crane et Scalp-rouge";
      ["name_cn"] = "沙怒、碎?和血?硬?";
      ["reward"] = {
         [1] = 19858;
      };
      ["name_de"] = "Munzen der Sandwuter, Schadelspalter und Blutskalpe";
      ["faction"] = "Horde";
      ["name"] = "Sandfury, Skullsplitter, and Bloodscalp Coins";
      ["level"] = 60;
      ["name_es"] = "Las monedas Furiarena, Machacacraneos y Sangrapellejo";
      ["req"] = 58;
   };
   [8271] = {
      ["name_ru"] = "Герой Грозовой Вершины";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 10;
      };
      ["name_de"] = "Held der Sturmlanzen";
      ["name_fr"] = "Heros des Foudrepiques";
      ["name_cn"] = "雷矛英雄";
      ["faction"] = "Horde";
      ["name"] = "Hero of the Stormpike";
      ["reward"] = {
         [1] = 19107;
         [2] = 19106;
         [3] = 19108;
         [4] = 20648;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7141;
      ["prequests"] = {
         [1] = 7141;
      };
      ["level"] = 60;
      ["name_es"] = "Heroe Pico Tormenta";
      ["req"] = 51;
   };
   [8303] = {
      ["name_ru"] = "Анахронос";
      ["type"] = "Solo";
      ["name_fr"] = "Anachronos";
      ["repgain"] = {
         [910] = 200;
      };
      ["name_de"] = "Anachronos";
      ["name"] = "Anachronos";
      ["name_cn"] = "安?克?斯";
      ["objective"] = "Seek out Anachronos at the Caverns of Time in Tanaris.";
      ["next"] = 8305;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8301;
      ["prequests"] = {
         [1] = 8301;
      };
      ["level"] = 60;
      ["name_es"] = "Anacronos";
      ["req"] = 60;
   };
   [8367] = {
      ["name_ru"] = "Великая честь";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor, 3 Arathi Basin Marks of Honor and 3 Warsong Gulch Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 150;
         [729] = 200;
         [889] = 150;
      };
      ["name_fr"] = "Pour un grand honneur";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "无上的?耀";
      ["name_de"] = "Grose Ehre";
      ["faction"] = "Horde";
      ["name"] = "For Great Honor";
      ["level"] = 60;
      ["name_es"] = "Cuestion de honor";
      ["req"] = 51;
   };
   [8399] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 29;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 20;
   };
   [8431] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8426;
      ["prequests"] = {
         [1] = 8426;
      };
      ["level"] = 29;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 20;
   };
   [8495] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает железных слитков!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de barres de fer !";
      ["name_de"] = "Die Allianz braucht mehr Eisenbarren!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21511;
      };
      ["name_cn"] = "?盟需要更多??！";
      ["objective"] = "Bring 20 iron bars to Corporal Carnes at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Iron Bars!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8494;
      ["prequests"] = {
         [1] = 8494;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas barras de hierro!";
      ["req"] = 1;
   };
   [8527] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает жареного мяса ящера!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de roti de raptor?!";
      ["name_de"] = "Die Allianz braucht mehr gerostete Raptoren!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21511;
      };
      ["name_cn"] = "?盟需要更多?迅猛?肉！";
      ["objective"] = "Bring 20 roast raptor to Sarah Sadwhistle at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Roast Raptor!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8526;
      ["prequests"] = {
         [1] = 8526;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas raptor asado!";
      ["req"] = 1;
   };
   [8559] = {
      ["name_ru"] = "Наголенники Завоевателя";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of War, 5 Ivory Scarabs and 5 Gold Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "征服者的?甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les greves du Conquerant";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schienbeinschutzer des Eroberers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21333;
      };
      ["name"] = "Conqueror's Greaves";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las grebas de conquistador";
      ["req"] = 60;
   };
   [8591] = {
      ["name_ru"] = "Орде все еще не хватает плотной кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Leather to Sergeant Umala at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr dickes Leder!";
      ["name_fr"] = "La Horde a besoin de plus de cuir epais !";
      ["name_cn"] = "部落需要更多厚皮！";
      ["name"] = "The Horde Needs More Thick Leather!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8590;
      ["prequests"] = {
         [1] = 8590;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas cuero grueso!";
      ["req"] = 1;
   };
   [8623] = {
      ["name_ru"] = "Диадема Зовущего бурю";
      ["objective"] = "Bring Vek'lor's Diadem, 2 Idols of Rebirth, 5 Stone Scarabs and 5 Crystal Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?暴召?者的王冠";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe d'implorateur de tempete";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Diadem des Sturmrufers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21372;
      };
      ["name"] = "Stormcaller's Diadem";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La diadema de clamatormentas";
      ["req"] = 60;
   };
   [8655] = {
      ["name_ru"] = "Наголенники Мстителя";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of the Sage, 5 Bronze Scarabs and 5 Clay Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "?仇者的?甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les greves du Vengeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schienbeinschutzer des Rachers";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21388;
      };
      ["name"] = "Avenger's Greaves";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Las grebas del Vengador";
      ["req"] = 60;
   };
   [6392] = {
      ["name_ru"] = "Возвращение к Броку";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner vers Brock";
      ["repgain"] = {
         [54] = 350;
         [47] = 350;
      };
      ["name_de"] = "Ruckkehr zu Gremlock";
      ["name_cn"] = "向布洛克回?";
      ["objective"] = "Buy a gryphon to Thelsamar from the gryphon master Gryth Thurden, then bring the Honorary Picks to Brock Stoneseeker in Thelsamar.";
      ["sort"] = "Loch Modan";
      ["name"] = "Return to Brock";
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["prev"] = 6388;
      ["prequests"] = {
         [1] = 6388;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa junto a Gremlock";
      ["req"] = 10;
   };
   [8719] = {
      ["name_ru"] = "Предок Песнь Клинка";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Lamechant";
      ["name_cn"] = "刃歌?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Klingensang";
      ["faction"] = "Horde";
      ["name"] = "Bladesing the Elder";
      ["level"] = 60;
      ["name_es"] = "Cantofilo el Ancestro";
      ["req"] = 1;
   };
   [8751] = {
      ["name_ru"] = "Защитник Калимдора";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 100;
      };
      ["name_de"] = "Der Beschutzer von Kalimdor";
      ["name_fr"] = "Le Protecteur de Kalimdor";
      ["name_cn"] = "?利姆多的保?者";
      ["faction"] = "Horde";
      ["name"] = "The Protector of Kalimdor";
      ["reward"] = {
         [1] = 21200;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8750;
      ["prequests"] = {
         [1] = 8750;
      };
      ["level"] = 60;
      ["name_es"] = "El protector de Kalimdor";
      ["req"] = 60;
   };
   [8783] = {
      ["name_ru"] = "Необычные материалы";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Enchanted Thorium Bars and 2 Enchanted Leather to Vargus at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing IX in order to complete this quest.";
      ["name_fr"] = "Des materiaux extraordinaires";
      ["sort"] = "Silithus";
      ["name_cn"] = "特殊的材料";
      ["reward"] = {
         [1] = 20800;
         [2] = 21132;
      };
      ["name_de"] = "Besondere Materialien";
      ["faction"] = "Alliance";
      ["name"] = "Extraordinary Materials";
      ["level"] = 60;
      ["name_es"] = "Materiales encantados";
      ["req"] = 60;
   };
   [8815] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8847] = {
      ["name_ru"] = "Десять жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Dix chevalieres pour des fournitures militaires";
      ["name_cn"] = "十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21510;
      };
      ["name_de"] = "Zehn Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Alliance";
      ["name"] = "Ten Signets for War Supplies";
      ["level"] = 29;
      ["name_es"] = "Diez sellos para los suministros belicos";
      ["req"] = 20;
   };
   [8879] = {
      ["name_ru"] = "Большие ракеты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les grandes cometes";
      ["name_cn"] = "大型烟花";
      ["reward"] = {
         [1] = 21742;
         [2] = 21640;
      };
      ["name_de"] = "Grose Raketen";
      ["faction"] = "Horde";
      ["name"] = "Large Rockets";
      ["level"] = 60;
      ["name_es"] = "Cohetes grandes";
      ["req"] = 35;
   };
   [8911] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Dreadmist Bracers to Deliana in Ironforge.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "??的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 22071;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8943] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Dreadmist Belt and a set of Dreadmist Wraps to Mokvar in Orgrimmar.$B";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22070;
         [2] = 22077;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [9007] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Wildheart Cowl and Wildheart Vest.";
      ["reward"] = {
         [1] = 22109;
         [2] = 22113;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9039] = {
      ["name_ru"] = "Башмаки неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make Dreadnaught Sabatons if you bring him the following items: 1 Desecrated Sabatons, 12 Wartorn Plate Scraps, 2 Arcanite Bars and 3 Cured Rugged Hides.$B";
      ["name_cn"] = "无畏?靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Solerets de cuirassier";
      ["repgain"] = {
         [890] = 250;
         [730] = 250;
         [509] = 250;
      };
      ["name_de"] = "Sabatons des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22420;
      };
      ["name"] = "Dreadnaught Sabatons";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los escarpes acorator";
      ["req"] = 60;
   };
   [9071] = {
      ["name_ru"] = "Наплеч Землекрушителя";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make Earthshatter Spaulders if you bring him the following: 1 Desecrated Spaulders, 12 Wartorn Chain Scraps, 2 Arcanite Bars and 2 Mooncloth.";
      ["name_cn"] = "碎地者肩甲";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres de Brise-terre";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Schiftung des Erdspalters";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22467;
      };
      ["name"] = "Earthshatter Spaulders";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las bufas Rompeterra";
      ["req"] = 60;
   };
   [9103] = {
      ["name_ru"] = "Одеяние Проклятого Сердца";
      ["type"] = "Raid";
      ["name_fr"] = "La robe de pestecoeur";
      ["name_de"] = "Robe des verseuchten Herzens";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make a Plagueheart Robe if you bring him the following: 1 Desecrated Robe, 25 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22504;
      };
      ["name_cn"] = "瘟疫之心?袍";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Plagueheart Robe";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La toga corazon de la peste";
      ["req"] = 60;
   };
   [9263] = {
      ["name_ru"] = "Что делает Плеть в Оргриммаре?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside Orgrimmar and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "??奥格瑞?的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Scourge of Orgrimmar";
      ["level"] = 10;
      ["name_es"] = "Investigar la Plaga en Orgrimmar";
      ["req"] = 1;
   };
   [9295] = {
      ["name_ru"] = "Письмо с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Torn Letter to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "被撕碎的信";
      ["name_fr"] = "Une lettre du front";
      ["name_de"] = "Brief von der Front";
      ["faction"] = "Horde";
      ["name"] = "Letter from the Front";
      ["level"] = 60;
      ["name_es"] = "Una carta del frente";
      ["req"] = 55;
   };
   [6824] = {
      ["name_ru"] = "Руки врага";
      ["type"] = "Raid";
      ["name_fr"] = "Les mains de l'ennemi";
      ["name_de"] = "Hande des Feindes";
      ["name_cn"] = "?人之手";
      ["objective"] = "Bring the Hands of Lucifron, Sulfuron, Gehennas and Shazzrah to Duke Hydraxis in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Hands of the Enemy";
      ["prev"] = 6823;
      ["prequests"] = {
         [1] = 6823;
      };
      ["level"] = 60;
      ["name_es"] = "Las manos de los enemigos";
      ["req"] = 60;
   };
   [6984] = {
      ["name_ru"] = "Благодарность от \"Пастбищ Дымного Леса\"!";
      ["type"] = "Solo";
      ["name_fr"] = "Un grand merci des Gourmandises Fumebois?!";
      ["name_de"] = "Ein Dankeschon von Kokelwalder!";
      ["reward"] = {
         [1] = 17726;
      };
      ["name_cn"] = "烟林牧?的感?";
      ["objective"] = "Speak with Great-father Winter in Orgrimmar.";
      ["faction"] = "Horde";
      ["name"] = "A Smokywood Pastures Thank You!";
      ["sort"] = "Hallow's End";
      ["prev"] = 6983;
      ["prequests"] = {
         [1] = 6983;
      };
      ["level"] = 60;
      ["name_es"] = "Un agradecimiento de Pastos de Bosquehumeante";
      ["req"] = 30;
   };
   [7064] = {
      ["name_ru"] = "Яблочко от яблоньки...";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Princess Theradras and return to Selendra near Shadowprey Village in Desolace.";
      ["repgain"] = {
         [609] = 150;
      };
      ["sort"] = "Maraudon";
      ["name_fr"] = "Corruption de la terre et de la graine";
      ["name_cn"] = "大地的?染";
      ["reward"] = {
         [1] = 17705;
         [2] = 17743;
         [3] = 17753;
      };
      ["name_de"] = "Verderbnis von Erde und Samenkorn";
      ["faction"] = "Horde";
      ["name"] = "Corruption of Earth and Seed";
      ["level"] = 51;
      ["name_es"] = "Corrupcion de la tierra y de la semilla";
      ["req"] = 45;
   };
   [7224] = {
      ["name_ru"] = "Вражеский трофей";
      ["type"] = "PvP";
      ["objective"] = "Bring 20 Armor Scraps to Smith Regzar in Frostwolf Village.";
      ["repgain"] = {
         [76] = 250;
         [729] = 1;
      };
      ["name_fr"] = "Pris a l'ennemi";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?人的物?";
      ["name_de"] = "Beutezug im Feindesland";
      ["faction"] = "Horde";
      ["name"] = "Enemy Booty";
      ["level"] = 60;
      ["name_es"] = "Botin enemigo";
      ["req"] = 51;
   };
   [7368] = {
      ["name_ru"] = "Обезвредить угрозу";
      ["type"] = "PvP";
      ["objective"] = "Find the Stormpike Explosives Expert and kill him. Return to the Frostwolf Explosives Expert when the task is complete.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "爆破?家";
      ["name_fr"] = "Desarmer les mines";
      ["name_de"] = "Die Gefahr bannen";
      ["faction"] = "Horde";
      ["name"] = "Defusing the Threat";
      ["level"] = 60;
      ["name_es"] = "Acabar con la amenaza";
      ["req"] = 51;
   };
   [7496] = {
      ["name_ru"] = "Праздник добрых времен";
      ["type"] = "Solo";
      ["objective"] = "Seek out Major Mattingly in the Valley of Heroes.";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Gute Zeiten feiern";
      ["reward"] = {
         [1] = 18406;
         [2] = 18403;
         [3] = 18404;
      };
      ["name_cn"] = "英雄?典";
      ["name_fr"] = "Celebrer le triomphe";
      ["faction"] = "Alliance";
      ["name"] = "Celebrating Good Times";
      ["sort"] = "Stormwind City";
      ["prev"] = 7495;
      ["prequests"] = {
         [1] = 7495;
      };
      ["level"] = 60;
      ["name_es"] = "Celebrar los buenos momentos";
      ["req"] = 60;
   };
   [7624] = {
      ["name_ru"] = "Улатек Предатель";
      ["objective"] = "Confront Ulathek, then bring The Traitor's Heart to Lord Banehollow in Jaedenar.";
      ["name_cn"] = "背叛者?拉泰克";
      ["followup"] = 7625;
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Ulathek le traitre";
      ["next"] = 7625;
      ["name_de"] = "Ulathek der Verrater";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["sort"] = "Warlock";
      ["name"] = "Ulathek the Traitor";
      ["prev"] = 7623;
      ["prequests"] = {
         [1] = 7623;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Ulathek el Traidor";
      ["req"] = 60;
   };
   [7640] = {
      ["name_ru"] = "Изгнание призраков из Долины Ужаса";
      ["objective"] = "Use the Exorcism Censer to drive out the spirits that torment Terrordale.  When you have slain 25 Terrordale Spirits, return to Lord Grayson Shadowbreaker in the Cathedral District of Stormwind.";
      ["name_cn"] = "恐惧谷的?魂";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Exorciser Val-Terreur";
      ["repgain"] = {
         [69] = 75;
         [72] = 250;
         [47] = 75;
      };
      ["name_de"] = "Der Exorzismus des Schreckenstals";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Exorcising Terrordale";
      ["prev"] = 7639;
      ["prequests"] = {
         [1] = 7639;
      };
      ["followup"] = 7641;
      ["name_es"] = "Exorcismo en Valle del Terror";
      ["req"] = 60;
   };
   [7656] = {
      ["name_ru"] = "Имперское зерцало";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["name_de"] = "Imperiale Plattenrustung";
      ["name_fr"] = "La pansiere imperiale";
      ["name_cn"] = "君王板甲?胸";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Chest";
      ["reward"] = {
         [1] = 12705;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Peto de placas imperiales";
      ["req"] = 50;
   };
   [7672] = {
      ["name_ru"] = "Новый ночной саблезуб";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darnassus";
      ["name_fr"] = "Remplacement de sabre-de-nuit";
      ["name_cn"] = "更?夜刃豹";
      ["reward"] = {
         [1] = 18902;
         [2] = 18766;
         [3] = 18767;
      };
      ["name_de"] = "Austausch Eures Nachtsablers";
      ["faction"] = "Alliance";
      ["name"] = "Nightsaber Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de sable de la noche";
      ["req"] = 60;
   };
   [7704] = {
      ["name_ru"] = "Размер имеет значение";
      ["type"] = "Solo";
      ["objective"] = "Take Chambermaid Pillaclencher's Pillow to Evonice Sootsmoker in the Searing Gorge.";
      ["repgain"] = {
         [59] = 250;
      };
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "看看它的个?！";
      ["reward"] = {
         [1] = 18951;
      };
      ["name_de"] = "Wie gros das ist!";
      ["faction"] = "Horde";
      ["name"] = "Look at the Size of It!";
      ["level"] = 50;
      ["name_es"] = "!Mira el tamano de esto!";
      ["req"] = 45;
   };
   [7736] = {
      ["name_ru"] = "Пополнение запасов огненного плавня ? королевская кровь";
      ["type"] = "Solo";
      ["objective"] = "Deliver 2 Incendosaur Scales, 4 Kingsblood and one Coal to Master Smith Burninate.";
      ["repgain"] = {
         [59] = 25;
      };
      ["name_de"] = "Nachschub an feurigem Fluxus: Konigsblut";
      ["name_cn"] = "??助熔?的??：皇血草";
      ["name_fr"] = "Reapprovisionnement en flux embrase (Sang-royal)";
      ["name"] = "Restoring Fiery Flux Supplies via Kingsblood";
      ["faction"] = "Horde";
      ["sort"] = "Searing Gorge";
      ["prev"] = 7722;
      ["prequests"] = {
         [1] = 7722;
      };
      ["level"] = 60;
      ["name_es"] = "Fabricar flujo igneo con sangrerregia";
      ["req"] = 45;
   };
   [7784] = {
      ["name_ru"] = "Владыка Черной горы";
      ["objective"] = "Speak with High Overlord Saurfang in Orgrimmar. He stands waiting for you in the Valley of Strength.";
      ["name_cn"] = "黑石之王";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Le seigneur de Rochenoire";
      ["repgain"] = {
         [68] = 200;
      };
      ["name_de"] = "Der Herrscher des Schwarzfels";
      ["reward"] = {
         [1] = 19383;
         [2] = 19366;
         [3] = 19384;
      };
      ["faction"] = "Horde";
      ["name"] = "The Lord of Blackrock";
      ["prev"] = 7783;
      ["prequests"] = {
         [1] = 7783;
      };
      ["series"] = 2;
      ["name_es"] = "Senor de Roca Negra";
      ["req"] = 60;
   };
   [7800] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Darnassus";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 7798;
         [2] = 7799;
         [3] = 7792;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [7816] = {
      ["name_ru"] = "Гаммерита!";
      ["type"] = "Group";
      ["name_fr"] = "Gammerita, l'ami?!";
      ["name_de"] = "Gammerita, Alter!";
      ["name_cn"] = "加莫里塔！";
      ["objective"] = "Katoom the Angler at Revantusk Village in the Hinterlands wants you to kill Gammerita and retrieve Katoom's Best Lure from her corpse.$B$BKatoom mentioned that Gammerita hangs out on the coast with the other turtles.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Horde";
      ["name"] = "Gammerita, Mon!";
      ["prev"] = 7815;
      ["prequests"] = {
         [1] = 7815;
      };
      ["level"] = 48;
      ["name_es"] = "!Gammerita, colega!";
      ["req"] = 44;
   };
   [7832] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 7824;
      ["prequests"] = {
         [1] = 7824;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [7848] = {
      ["name_ru"] = "Сродство с недрами";
      ["type"] = "Dungeon";
      ["objective"] = "Venture to the Molten Core entry portal in Blackrock Depths and recover a Core Fragment. Return to Lothos Riftwaker in Blackrock Mountain when you have recovered the Core Fragment.";
      ["sort"] = "Molten Core";
      ["name_cn"] = "熔火之心的?送?";
      ["name_fr"] = "Harmonisation avec le C?ur du Magma";
      ["name_de"] = "Abstimmung mit dem Kern";
      ["faction"] = "Horde";
      ["name"] = "Attunement to the Core";
      ["level"] = 60;
      ["name_es"] = "Armonizacion con el Nucleo";
      ["req"] = 55;
   };
   [7864] = {
      ["name_ru"] = "Стандартные припасы часового";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [890] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage ordinaire de Sentinelle";
      ["name_cn"] = "哨兵?准?理包";
      ["reward"] = {
         [1] = 19151;
      };
      ["name_de"] = "Standarduberlebenspaket der Schildwache";
      ["faction"] = "Alliance";
      ["name"] = "Sentinel Standard Care Package";
      ["level"] = 44;
      ["name_es"] = "Botiquin normal de centinela";
      ["req"] = 35;
   };
   [7896] = {
      ["name_ru"] = "Зеленые ракеты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Feux d'artifice vert";
      ["name_cn"] = "?色烟火";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Grunes Feuerwerk";
      ["faction"] = "Horde";
      ["name"] = "Green Fireworks";
      ["level"] = 60;
      ["name_es"] = "Fuegos artificiales verdes";
      ["req"] = 20;
   };
   [7928] = {
      ["name_ru"] = "Колода карт Новолуния: Полководцы";
      ["type"] = "Solo";
      ["objective"] = " so you will have to wait until they are here next.\"";
      ["repgain"] = {
         [909] = 150;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Suite de Seigneurs de guerre de Sombrelune";
      ["name_cn"] = "暗月督?套牌";
      ["reward"] = {
         [1] = 19287;
      };
      ["name_de"] = "Kriegsfurstenkartenset des Dunkelmond-Jahrmarkts";
      ["faction"] = "Horde";
      ["name"] = "Darkmoon Warlords Deck";
      ["level"] = 55;
      ["name_es"] = "La baraja de Senores de la Guerra de la Luna Negra";
      ["req"] = 1;
   };
   [7944] = {
      ["name_ru"] = "Ты найдешь свою удачу...";
      ["type"] = "Solo";
      ["objective"] = " you see an image of a cave to the southwest of the Crossroads in the Barrens.  Focusing closer in on the image";
      ["repgain"] = {
         [909] = 75;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Une surprise vous attend...";
      ["name_cn"] = "?富在等着?……";
      ["reward"] = {
         [1] = 19425;
      };
      ["name_de"] = "Euer Schicksal erwartet Euch...";
      ["faction"] = "Horde";
      ["name"] = "Your Fortune Awaits You...";
      ["level"] = 60;
      ["name_es"] = "La Fortuna te espera...";
      ["req"] = 10;
   };
   [8056] = {
      ["name_ru"] = "Знаки Силы: наручи авгура";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Armsplint.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BMaywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance : les brassards d'augure";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?言者?腕";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19830;
      };
      ["name_de"] = "Symbole der Macht: Die Armschienen des Weissagers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Augur's Bracers";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazales de augur";
      ["req"] = 60;
   };
   [8072] = {
      ["name_ru"] = "Знаки Силы: оплечье безумца";
      ["type"] = "Raid";
      ["objective"] = " but also with the blinding speed of his twin daggers.  Madcaps today cherish their mantle as a sign of their place in the tribe.$B$BBring to me the Paragons of Power I seek";
      ["name_fr"] = "Parangons de puissance?: le mantelet d'insense";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：狂妄者?肩";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19835;
      };
      ["name_de"] = "Symbole der Macht: Der Mantel des Wildfangs";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Madcap's Mantle";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Manto de sinconcierto";
      ["req"] = 60;
   };
   [8104] = {
      ["name_ru"] = "Самоцвет Каджаро";
      ["objective"] = "";
      ["name_cn"] = "???的珠宝";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le joyau de Kajaro";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Das Juwel von Kajaro";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "The Jewel of Kajaro";
      ["prev"] = 8103;
      ["prequests"] = {
         [1] = 8103;
      };
      ["reward"] = {
         [1] = 19601;
      };
      ["name_es"] = "La Joya de Kajaro";
      ["req"] = 60;
   };
   [8120] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the Arathi Basin mine, lumber mill, blacksmith and stable, and then return to Deathmaster Dwire in Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Horde";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 55;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 50;
   };
   [8168] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the mine, the lumber mill, the blacksmith and the farm, then return to Field Marshal Oslight in Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Alliance";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 25;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8184] = {
      ["name_ru"] = "Явление Силы";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 250;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La presence de la puissance";
      ["name_cn"] = "力量的?明";
      ["reward"] = {
         [1] = 19782;
      };
      ["name_de"] = "Prasenz der Macht";
      ["faction"] = "Horde";
      ["name"] = "Presence of Might";
      ["level"] = 60;
      ["name_es"] = "Presencia de poderio";
      ["req"] = 58;
   };
   [4105] = {
      ["name_ru"] = "Лекарство из оскверненных трав";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Sammlung";
      ["name_fr"] = "Du baume contre une recolte";
      ["name_cn"] = "采集??膏";
      ["name"] = "Salve via Gathering";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4101;
      ["prequests"] = {
         [1] = 4101;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por recoleccion";
      ["req"] = 48;
   };
   [8240] = {
      ["name_ru"] = "Драгоценности для Занзы";
      ["type"] = "Solo";
      ["objective"] = "Destroy any one of the Hakkari Bijous found in Zul'Gurub at the Altar of Zanza on Yojamba Isle.  When done, speak with Vinchaxa nearby.";
      ["repgain"] = {
         [270] = 350;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Un Bijou pour Zanza";
      ["name_cn"] = "?扎的宝石";
      ["reward"] = {
         [1] = 19858;
      };
      ["name_de"] = "Ein Schmuckstuck fur Zanza";
      ["faction"] = "Horde";
      ["name"] = "A Bijou for Zanza";
      ["level"] = 60;
      ["name_es"] = "Una presea para Zanza";
      ["req"] = 58;
   };
   [8272] = {
      ["name_ru"] = "Герой Северного Волка";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 10;
      };
      ["name_de"] = "Held der Frostwolfe";
      ["name_fr"] = "Heros des Loups-de-givre";
      ["name_cn"] = "霜狼英雄";
      ["faction"] = "Horde";
      ["name"] = "Hero of the Frostwolf";
      ["reward"] = {
         [1] = 19107;
         [2] = 19106;
         [3] = 19108;
         [4] = 20648;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7142;
      ["prequests"] = {
         [1] = 7142;
      };
      ["level"] = 60;
      ["name_es"] = "Heroe de Lobo Gelido";
      ["req"] = 51;
   };
   [8304] = {
      ["name_ru"] = "Дражайшая Наталия";
      ["type"] = "Group";
      ["objective"] = "Commander Mar'alith at Cenarion Hold in Silithus wants you to question the inhabitants of Bronzebeard's Encampment. You will find Bronzebeard's Encampment south of Cenarion Hold.$B$BOnce you have gathered the requested information, return to Commander Mar'alith.";
      ["next"] = 8306;
      ["name_fr"] = "Chere Natalia";
      ["sort"] = "Silithus";
      ["name_cn"] = "??的?塔莉?";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Liebste Natalia";
      ["faction"] = "Horde";
      ["name"] = "Dearest Natalia";
      ["level"] = 60;
      ["name_es"] = "Queridisima Natalia";
      ["req"] = 60;
   };
   [8368] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 100;
      };
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "峡谷中的?斗";
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Battle of Warsong Gulch";
      ["level"] = 19;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 10;
   };
   [8400] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 39;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 30;
   };
   [8432] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8427;
      ["prequests"] = {
         [1] = 8427;
      };
      ["level"] = 39;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 30;
   };
   [8464] = {
      ["name_ru"] = "Боевые действия в деревне Зимней Спячки";
      ["type"] = "Solo";
      ["objective"] = "Salfa wants you to kill 8 Winterfall Shaman, 8 Winterfall Den Watchers, and 8 Winterfall Ursa.  Salfa is located just outside the entrance to Timbermaw Hold in Winterspring.";
      ["repgain"] = {
         [576] = 350;
      };
      ["sort"] = "Timbermaw Hold";
      ["name_fr"] = "Les Tombe-hiver s'agitent";
      ["name_cn"] = "冬泉熊怪的活?";
      ["reward"] = {
         [1] = 21318;
         [2] = 21319;
         [3] = 21320;
         [4] = 21322;
      };
      ["name_de"] = "Aktivitat der Winterfelle";
      ["faction"] = "Horde";
      ["name"] = "Winterfall Activity";
      ["level"] = 58;
      ["name_es"] = "Actividad de los Nevada";
      ["req"] = 45;
   };
   [8496] = {
      ["name_ru"] = "Запас бинтов";
      ["type"] = "Solo";
      ["objective"] = "Bring 30 Heavy Runecloth Bandages, 30 Heavy Silk Bandages and 30 Heavy Mageweave Bandages to Windcaller Proudhorn at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing X in order to complete this quest.";
      ["name_fr"] = "Des bandages pour la campagne";
      ["sort"] = "Silithus";
      ["name_cn"] = "??上的??";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Verbande fur den Feldeinsatz";
      ["faction"] = "Alliance";
      ["name"] = "Bandages for the Field";
      ["level"] = 60;
      ["name_es"] = "Vendas para el campo de batalla";
      ["req"] = 60;
   };
   [4265] = {
      ["name_ru"] = "Освобожденный из улья";
      ["type"] = "Solo";
      ["name_fr"] = "L'evasion de la ruche";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Flucht aus dem Schwarmbau";
      ["name"] = "Freed from the Hive";
      ["name_cn"] = "逃?虫?";
      ["objective"] = " friend!  I... I'm Raschal";
      ["next"] = 4266;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 4135;
      ["prequests"] = {
         [1] = 4135;
      };
      ["level"] = 46;
      ["name_es"] = "Liberado de la colmena";
      ["req"] = 40;
   };
   [8560] = {
      ["name_ru"] = "Набедренники Завоевателя";
      ["objective"] = "Bring Ouro's Intact Hide, 2 Idols of Death, 5 Bronze Scarabs and 5 Ivory Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "征服者的腿?";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-jambes du Conquerant";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Beinschutzer des Eroberers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21332;
      };
      ["name"] = "Conqueror's Legguards";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las musleras de conquistador";
      ["req"] = 60;
   };
   [4297] = {
      ["name_ru"] = "Покормить малыша";
      ["type"] = "Solo";
      ["name_fr"] = "Nourriture pour bebe";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Essen fur das Baby";
      ["name"] = "Food for Baby";
      ["name_cn"] = "小精?的食物";
      ["objective"] = "Bring 5 Silvermane Stalker Flanks to Agnar Beastamer in Hinterlands.";
      ["next"] = 4298;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 3843;
      ["prequests"] = {
         [1] = 3843;
      };
      ["level"] = 47;
      ["name_es"] = "Comida para el bebe";
      ["req"] = 38;
   };
   [8624] = {
      ["name_ru"] = "Поножи Зовущего Бурю";
      ["objective"] = "Bring the Skin of the Great Sandworm, 2 Idols of Strife, 5 Bronze Scarabs and 5 Ivory Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?暴召?者的?腿";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres d'implorateur de tempete";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Gamaschen des Sturmrufers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21375;
      };
      ["name"] = "Stormcaller's Leggings";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los leotardos de clamatormentas";
      ["req"] = 60;
   };
   [8656] = {
      ["name_ru"] = "Хауберк Бойца";
      ["objective"] = "Bring the the Carapace of the Old God, 2 Idols of Life, 5 Gold Scarabs and 5 Clay Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "攻?者的?甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le haubert du Frappeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Halsberge des Hetzers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21370;
      };
      ["name"] = "Striker's Hauberk";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El camisote de asediador";
      ["req"] = 60;
   };
   [8688] = {
      ["name_ru"] = "Предок Вестник Ветров";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Tracevent";
      ["name_cn"] = "?路?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Windflucht";
      ["faction"] = "Horde";
      ["name"] = "Windrun the Elder";
      ["level"] = 60;
      ["name_es"] = "Fuerteviento el Ancestro";
      ["req"] = 1;
   };
   [8720] = {
      ["name_ru"] = "Предок Небесный Отблеск";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Luireciel";
      ["name_cn"] = "夜光?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Himmelsglanz";
      ["faction"] = "Horde";
      ["name"] = "Skygleam the Elder";
      ["level"] = 60;
      ["name_es"] = "Relucielo el Ancestro";
      ["req"] = 1;
   };
   [8752] = {
      ["name_ru"] = "Путь победителя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "La voie du Conquerant";
      ["name_cn"] = "征服者之路";
      ["reward"] = {
         [1] = 21201;
      };
      ["name_de"] = "Der Pfad des Eroberers";
      ["faction"] = "Horde";
      ["name"] = "The Path of the Conqueror";
      ["level"] = 60;
      ["name_es"] = "El camino del conquistador";
      ["req"] = 60;
   };
   [8784] = {
      ["name_ru"] = "Секреты Кираи";
      ["type"] = "Solo";
      ["objective"] = "Take the Ancient Qiraji Artifact to the dragons hiding near the entrance of the temple.$B";
      ["repgain"] = {
         [910] = 1000;
      };
      ["name_fr"] = "Les secrets des Qiraji";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "其拉的秘密";
      ["name_de"] = "Geheimnisse der Qiraji";
      ["faction"] = "Horde";
      ["name"] = "Secrets of the Qiraji";
      ["level"] = 60;
      ["name_es"] = "Los secretos de los qiraji";
      ["req"] = 60;
   };
   [8816] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8848] = {
      ["name_ru"] = "Пятнадцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Quinze chevalieres pour des fournitures militaires";
      ["name_cn"] = "十五枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21511;
      };
      ["name_de"] = "Funfzehn Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Alliance";
      ["name"] = "Fifteen Signets for War Supplies";
      ["level"] = 39;
      ["name_es"] = "Quince sellos para los suministros belicos";
      ["req"] = 30;
   };
   [4441] = {
      ["name_ru"] = "Древа в узах скверны";
      ["type"] = "Solo";
      ["name_fr"] = "Anciens corrompus";
      ["name_de"] = "[DEPRECATED] Gebundene Urtume";
      ["name_cn"] = "被禁?的古?";
      ["objective"] = "Travel to Darnassus and use Eridan's Vial to collect a Vial of Blessed Water from the Temple of the Moon. Return to Eridan with the filled vial.";
      ["sort"] = "Felwood";
      ["faction"] = "Alliance";
      ["name"] = "Felbound Ancients";
      ["prev"] = 939;
      ["prequests"] = {
         [1] = 939;
      };
      ["level"] = 54;
      ["name_es"] = "Los Ancestros corrompidos";
      ["req"] = 49;
   };
   [8912] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Bracers of Valor to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21996;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8944] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Belt of Valor and a set of Gauntlets of Valor to Mokvar in Orgrimmar.$B";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 21994;
         [2] = 21998;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [4489] = {
      ["name_ru"] = "Призывание коня Скверны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in Ratchet.";
      ["next"] = 4490;
      ["name_cn"] = "召?地???";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Teufelsross beschworen";
      ["faction"] = "Horde";
      ["name"] = "Summon Felsteed";
      ["level"] = 40;
      ["name_es"] = "Invoca un corcel vil";
      ["req"] = 40;
   };
   [9008] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Beaststalker's Cap and Beaststalker's Tunic.";
      ["reward"] = {
         [1] = 22013;
         [2] = 22060;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9040] = {
      ["name_ru"] = "Рукавицы неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make Dreadnaught Gauntlets if you bring him the following items: 1 Desecrated Gauntlets, 8 Wartorn Plate Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides.";
      ["name_cn"] = "无畏?手";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Gantelets de cuirassier";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stulpen des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22421;
      };
      ["name"] = "Dreadnaught Gauntlets";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guanteletes acorator";
      ["req"] = 60;
   };
   [9072] = {
      ["name_ru"] = "Сапоги Землекрушителя";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make Earthshatter Boots if you bring him the following: 1 Desecrated Boots, 12 Wartorn Chain Scraps, 1 Arcanite Bar and 3 Nexus Crystals.";
      ["name_cn"] = "碎地者?靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de Brise-terre";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stiefel des Erdspalters";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22468;
      };
      ["name"] = "Earthshatter Boots";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas Rompeterra";
      ["req"] = 60;
   };
   [9104] = {
      ["name_ru"] = "Поножи Проклятого Сердца";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make Plagueheart Leggings if you bring him the following: 1 Desecrated Leggings, 20 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["name_cn"] = "瘟疫之心?腿";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres de pestecoeur";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gamaschen des verseuchten Herzens";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 22505;
      };
      ["name"] = "Plagueheart Leggings";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los leotardos corazon de la peste";
      ["req"] = 60;
   };
   [9136] = {
      ["name_ru"] = "Дикая флора";
      ["type"] = "Solo";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands wants 30 Savage Fronds.";
      ["repgain"] = {
         [529] = 200;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "La flore sauvage";
      ["name_cn"] = "蛮荒之叶";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Wildpflanzen";
      ["faction"] = "Horde";
      ["name"] = "Savage Flora";
      ["level"] = 60;
      ["name_es"] = "Flora salvaje";
      ["req"] = 55;
   };
   [4601] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = " followed by some text:$B$B\"Grime and residue ruining your sparklies?  The Sparklematic 5200 puts the shine back in shine-tastic!  Insert the item you wish to clean and deposit three silver coins in the coin slot.  Give the Sparklematic 5200 a moment for operation";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "超?清?器5200型！";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_de"] = "Der Funkelmat 5200!";
      ["faction"] = "Horde";
      ["name"] = "The Sparklematic 5200!";
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [9232] = {
      ["name_ru"] = "Не разгуляешься...";
      ["type"] = "Raid";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants you to bring him 2 Frozen Runes, 2 Essence of Water, 2 Blue Sapphires and 30 gold pieces.";
      ["name_fr"] = "C'est tout ce que j'ai a mon repertoire...";
      ["sort"] = "Naxxramas";
      ["name_cn"] = "我只会唱?一首歌……";
      ["reward"] = {
         [1] = 22700;
         [2] = 22699;
         [3] = 22702;
         [4] = 22701;
      };
      ["name_de"] = "Das Einzige, das ich kann...";
      ["faction"] = "Horde";
      ["name"] = "The Only Song I Know...";
      ["level"] = 60;
      ["name_es"] = "La unica cancion que conozco";
      ["req"] = 60;
   };
   [9264] = {
      ["name_ru"] = "Что делает Плеть в Громовом Утесе?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside Thunder Bluff and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "??雷霆崖的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Donnerfels";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Scourge of Thunder Bluff";
      ["level"] = 10;
      ["name_es"] = "Investigar la Plaga en Cima del Trueno";
      ["req"] = 1;
   };
   [2341] = {
      ["name_ru"] = "Пропавшее ожерелье, этап 3";
      ["type"] = "Dungeon";
      ["objective"] = "Visit Jarkal Mossmeld in Kargath to see if he was successful.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Wiederbeschaffung der Halskette, Teil 3";
      ["reward"] = {
         [1] = 7888;
      };
      ["name_cn"] = "??任?的?? (地下城)";
      ["name_fr"] = "Reparer le collier, troisieme prise";
      ["faction"] = "Horde";
      ["name"] = "Necklace Recovery, Take 3";
      ["sort"] = "Uldaman";
      ["prev"] = 2340;
      ["prequests"] = {
         [1] = 2340;
      };
      ["level"] = 44;
      ["name_es"] = "La recuperacion del collar, 3a parte";
      ["req"] = 40;
   };
   [4729] = {
      ["name_ru"] = "Редкие звери Киблера";
      ["type"] = "Dungeon";
      ["objective"] = " Kibler.\" The answer is simple: Take this here beast cage and find me some worg pups. For that";
      ["name_fr"] = "Les animaux exotiques de Kibler";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "基布雷?的特殊?物";
      ["reward"] = {
         [1] = 12264;
      };
      ["name_de"] = "Kiblers Exotische Tiere";
      ["faction"] = "Horde";
      ["name"] = "Kibler's Exotic Pets";
      ["level"] = 59;
      ["name_es"] = "Las mascotas exoticas de Kibler";
      ["req"] = 55;
   };
   [4761] = {
      ["name_ru"] = "Тандрис Ветропряд";
      ["type"] = "Solo";
      ["name_fr"] = "Thundris Tissevent";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Thundris Windwirker";
      ["name"] = "Thundris Windweaver";
      ["name_cn"] = "桑迪斯・??";
      ["objective"] = "Speak with Thundris Windweaver in Auberdine.";
      ["next"] = 4762;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 984;
      ["prequests"] = {
         [1] = 984;
      };
      ["level"] = 15;
      ["name_es"] = "Thundris Tejevientos";
      ["req"] = 11;
   };
   [4809] = {
      ["name_ru"] = "Рога хладнокрылов";
      ["type"] = "Solo";
      ["name_fr"] = "Cornes de Noroit";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Horner der Eiswindschimaren";
      ["name"] = "Chillwind Horns";
      ["name_cn"] = "冰?奇美拉角";
      ["objective"] = "Bring 8 Uncracked Chillwind Horns to Felnok Steelspring.";
      ["next"] = 4810;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 4808;
      ["prequests"] = {
         [1] = 4808;
      };
      ["level"] = 54;
      ["name_es"] = "Cuernos de Orvallo";
      ["req"] = 50;
   };
   [4841] = {
      ["name_ru"] = "Упокоение кентавров";
      ["type"] = "Solo";
      ["name_fr"] = "Pacifier les centaures";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Befriedung der Zentauren";
      ["name"] = "Pacify the Centaur";
      ["name_cn"] = "清除半人?";
      ["objective"] = "Kill 12 Galak Scouts, 10 Galak Wranglers, and 6 Galak Windchasers, and then return to Cliffwatcher Longhorn in Freewind Post.";
      ["next"] = 5064;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 4542;
      ["prequests"] = {
         [1] = 4542;
      };
      ["level"] = 25;
      ["name_es"] = "Apaciguar al centauro";
      ["req"] = 23;
   };
   [4921] = {
      ["name_ru"] = "Пропавшая без вести";
      ["type"] = "Solo";
      ["objective"] = "Find Mankrik's wife and then return to him in the Crossroads.";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_fr"] = "Disparition au combat";
      ["sort"] = "The Barrens";
      ["name_cn"] = "在?斗中失踪";
      ["name_de"] = "In der Schlacht vermisst";
      ["faction"] = "Horde";
      ["name"] = "Lost in Battle";
      ["level"] = 20;
      ["name_es"] = "Perdida en la batalla";
      ["req"] = 14;
   };
   [4969] = {
      ["name_ru"] = "Знание шара Орахила";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1799;
      ["sort"] = "Warlock";
      ["name_cn"] = "奥拉赫宝珠";
      ["name_fr"] = "Connaissance de l'Orbe d'Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Wissen der Kugel von Orahil";
      ["faction"] = "Horde";
      ["name"] = "Knowledge of the Orb of Orahil";
      ["level"] = 35;
      ["name_es"] = "El conocimiento del orbe de Orahil";
      ["req"] = 35;
   };
   [4985] = {
      ["name_ru"] = "Страдания природы";
      ["type"] = "Solo";
      ["objective"] = "Destroy 8 Diseased Grizzlies, and then return to Mulgris Deepriver at the Writhing Haunt, Western Plaguelands.";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Die Tierwelt leidet auch";
      ["name"] = "The Wildlife Suffers Too";
      ["name_cn"] = "大自然的苦楚";
      ["name_fr"] = "La faune et la flore souffrent aussi";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 4984;
      ["prequests"] = {
         [1] = 4984;
      };
      ["level"] = 56;
      ["name_es"] = "La naturaleza tambien sufre";
      ["req"] = 51;
   };
   [2501] = {
      ["name_ru"] = "Пробежка по Бесплодным землям-2";
      ["type"] = "Group";
      ["name_fr"] = "Les reactifs des Terres ingrates II";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Reagenziensuche im Odland II";
      ["name_cn"] = "荒?之地的材料 II";
      ["name"] = "Badlands Reagent Run II";
      ["objective"] = "Use the empty thaumaturgy vessels on scorched guardian dragons found in the Badlands.  Once you have them filled, bring them to Ghak Healtouch in Thelsamar.";
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 2500;
      ["prequests"] = {
         [1] = 2500;
      };
      ["level"] = 44;
      ["name_es"] = "Componentes de Tierras Inhospitas II";
      ["req"] = 40;
   };
   [5049] = {
      ["name_ru"] = "Грусть Иеремии";
      ["objective"] = "Find Jeremiah Payson in the Undercity and see if he is in fact Jeremiah Felstone.  If he is, then perhaps he'd like the package Janice Felstone made for him.";
      ["name_cn"] = "杰雷米?的??";
      ["sort"] = "Undercity";
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Le blues de Jeremiah";
      ["next"] = 5050;
      ["name_de"] = "Der Jammer des Jeremiah";
      ["repgain"] = {
         [68] = 250;
      };
      ["followup"] = 5050;
      ["name"] = "The Jeremiah Blues";
      ["prev"] = 5023;
      ["prequests"] = {
         [1] = 5023;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La depre de Jeremiah";
      ["req"] = 50;
   };
   [5065] = {
      ["name_ru"] = "Утраченные таблички Мошару";
      ["type"] = "Group";
      ["name_fr"] = "Les tablettes perdues de Mosh'aru";
      ["next"] = 4788;
      ["name_de"] = "Die verlorenen Schrifttafeln von Mosh'aru";
      ["name_cn"] = "失落的摩沙?石板";
      ["objective"] = "Bring the Third and Fourth Mosh'aru Tablets to Prospector Ironboot in Tanaris.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "The Lost Tablets of Mosh'aru";
      ["prev"] = 3528;
      ["prequests"] = {
         [1] = 3528;
      };
      ["level"] = 58;
      ["name_es"] = "Las tablillas perdidas Mosh'aru";
      ["req"] = 40;
   };
   [2541] = {
      ["name_ru"] = "Спящий друид";
      ["type"] = "Solo";
      ["objective"] = "Bring a Shaman Voodoo Charm to Oben Rageclaw in the Ban'ethil Barrow Den.";
      ["next"] = 2561;
      ["name_fr"] = "Le druide dormant";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "?睡的德?伊";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der schlafende Druide";
      ["faction"] = "Alliance";
      ["name"] = "The Sleeping Druid";
      ["level"] = 8;
      ["name_es"] = "El druida durmiente";
      ["req"] = 3;
   };
   [5097] = {
      ["name_ru"] = "Сторожевые башни";
      ["type"] = "Solo";
      ["name_fr"] = "Tout au long des tours de guet";
      ["repgain"] = {
         [469] = 250;
      };
      ["name_de"] = "Turm um Turm";
      ["name_cn"] = "??哨塔";
      ["name"] = "All Along the Watchtowers";
      ["objective"] = "Using the Beacon Torch, mark each tower in Andorhal; you will need to stand in the doorway of the tower to successfully mark it.$B$BOnce all four towers are marked, return the Beacon Torch to Commander Ashlam Valorfist in Chillwind Camp, Western Plaguelands.";
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5092;
      ["prequests"] = {
         [1] = 5092;
      };
      ["level"] = 56;
      ["name_es"] = "Todas las atalayas";
      ["req"] = 50;
   };
   [5145] = {
      ["name_ru"] = "Кожевничество: чешуя дракона";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Tough Scorpid Breastplates, 2 Tough Scorpid Gloves, and 10 Worn Dragonscales to Thorkaf Dragoneye in the Badlands.$B$BCompleting this quest will give you access to the Dragonscale Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Elemental Leatherworking and Tribal Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "??制皮";
      ["name_fr"] = "Travail du cuir de dragon";
      ["name_de"] = "Drachenlederverarbeitung";
      ["faction"] = "Horde";
      ["name"] = "Dragonscale Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria dragontina";
      ["req"] = 40;
   };
   [2581] = {
      ["name_ru"] = "Челюсти гиены-хохотуна";
      ["type"] = "Solo";
      ["objective"] = "Bring three Snickerfang Jowls, two Blasted Boar Lungs, and one Scorpok Pincer to Bloodmage Drazial.";
      ["name_fr"] = "Joues de Raillecroc";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "弯牙土狼的?骨";
      ["reward"] = {
         [1] = 8410;
      };
      ["name_de"] = "Kicherfangunterkiefer";
      ["faction"] = "Horde";
      ["name"] = "Snickerfang Jowls";
      ["level"] = 50;
      ["name_es"] = "Papadas de hiena risitas";
      ["req"] = 45;
   };
   [2605] = {
      ["name_ru"] = "Жаждущий гоблин";
      ["type"] = "Solo";
      ["objective"] = "Collect a Laden Dew Gland and bring it to Marin Noggenfogger in Gadgetzan.";
      ["next"] = 2606;
      ["name_fr"] = "Le gobelin assoiffe";
      ["sort"] = "Tanaris";
      ["name_cn"] = "口?的地精";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_de"] = "Der durstige Goblin";
      ["faction"] = "Horde";
      ["name"] = "The Thirsty Goblin";
      ["level"] = 49;
      ["name_es"] = "El goblin sediento";
      ["req"] = 44;
   };
   [5225] = {
      ["name_ru"] = "Цель: пустошь Гаррона";
      ["objective"] = "Go to Gahrron's Withering in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Gahrron's Withering Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：盖?恩??";
      ["sort"] = "Western Plaguelands";
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: la Fletrissure de Gahrron";
      ["next"] = 5226;
      ["name_de"] = "Ziel: Gahrrons Trauerfeld";
      ["repgain"] = {
         [469] = 250;
         [529] = 250;
      };
      ["followup"] = 5227;
      ["name"] = "Target: Gahrron's Withering";
      ["prev"] = 5223;
      ["prequests"] = {
         [1] = 5223;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Objetivo: Gangrena de Gahrron";
      ["req"] = 50;
   };
   [2621] = {
      ["name_ru"] = "Опозоренный";
      ["type"] = "Solo";
      ["name_fr"] = "Le deshonore";
      ["next"] = 2622;
      ["name_de"] = "Der Entehrte";
      ["name_cn"] = "悔恨的?士";
      ["objective"] = "Speak to Dispatch Commander Ruag in Stonard.";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "The Disgraced One";
      ["prev"] = 2784;
      ["prequests"] = {
         [1] = 2784;
      };
      ["level"] = 50;
      ["name_es"] = "El deshonrado";
      ["req"] = 45;
   };
   [5305] = {
      ["name_ru"] = "Секрет безмятежности";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme and kill the Crimson Hammersmith. Recover the Crimson Hammersmith's Apron and return to Lilith.$B";
      ["name_fr"] = "Douce serenite";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "甜美的平静";
      ["reward"] = {
         [1] = 12824;
      };
      ["name_de"] = "Suse Beschaulichkeit";
      ["faction"] = "Horde";
      ["name"] = "Sweet Serenity";
      ["level"] = 60;
      ["name_es"] = "Dulce serenidad";
      ["req"] = 50;
   };
   [2661] = {
      ["name_ru"] = "Посылка для Синя";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison pour Marin";
      ["repgain"] = {
         [369] = 25;
      };
      ["name_de"] = "Lieferung fur Marin";
      ["name"] = "Delivery for Marin";
      ["name_cn"] = "??林的粉末";
      ["objective"] = "Sprinkle wants to you take the Violet Powder to Marin Noggenfogger in Gadgetzan.";
      ["next"] = 2662;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 2641;
      ["prequests"] = {
         [1] = 2641;
      };
      ["level"] = 49;
      ["name_es"] = "Un envio para Marin";
      ["req"] = 44;
   };
   [5385] = {
      ["name_ru"] = "Останки Трея Светогорна";
      ["type"] = "Solo";
      ["name_fr"] = "Les restes de Trey Sancteforge";
      ["name_de"] = "Die Uberreste von Trey Lichtschmied";
      ["reward"] = {
         [1] = 15706;
         [2] = 15705;
      };
      ["name_cn"] = "特雷・莱弗治的残骸";
      ["objective"] = "Return the Remains of Trey Lightforge to Jessir Moonbow in Felwood.";
      ["faction"] = "Horde";
      ["name"] = "The Remains of Trey Lightforge";
      ["sort"] = "Felwood";
      ["prev"] = 5204;
      ["prequests"] = {
         [1] = 5204;
      };
      ["level"] = 57;
      ["name_es"] = "Los restos de Trey Forjaluz";
      ["req"] = 49;
   };
   [2701] = {
      ["name_ru"] = "Герои древних времен";
      ["type"] = "Solo";
      ["objective"] = "Open the chest and claim your reward.";
      ["name_de"] = "Helden der Vergangenheit";
      ["name_fr"] = "Les heros des Anciens";
      ["reward"] = {
         [1] = 10659;
      };
      ["name_cn"] = "古代英雄";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "Heroes of Old";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2702;
      ["prequests"] = {
         [1] = 2702;
      };
      ["level"] = 57;
      ["name_es"] = "Los heroes de los antiguos";
      ["req"] = 45;
   };
   [5465] = {
      ["name_ru"] = "Книга Души";
      ["type"] = "Group";
      ["name_fr"] = "Souvenir lie";
      ["next"] = 5466;
      ["name_de"] = "Seelengebundenes Andenken";
      ["name_cn"] = "禁??魂的?物";
      ["objective"] = "Return to Magistrate Marduke in Caer Darrow. Show him the Soulbound Keepsake.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Soulbound Keepsake";
      ["prev"] = 5464;
      ["prequests"] = {
         [1] = 5464;
      };
      ["level"] = 60;
      ["name_es"] = "El Libro de Memorias del Alma";
      ["req"] = 57;
   };
   [2741] = {
      ["name_ru"] = "Супер Яйц-О-Матик";
      ["type"] = "Solo";
      ["objective"] = " ";
      ["sort"] = "Tanaris";
      ["name_fr"] = "Le Super-Oeuf-O-Matic";
      ["name_cn"] = "超??蛋器";
      ["reward"] = {
         [1] = 8647;
      };
      ["name_de"] = "Der Super-Ei-o-Mat";
      ["faction"] = "Horde";
      ["name"] = "The Super Egg-O-Matic";
      ["level"] = 60;
      ["name_es"] = "El Superhuevomatico";
      ["req"] = 42;
   };
   [2749] = {
      ["name_ru"] = "Обычное яйцо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 10;
         [69] = 10;
      };
      ["name_de"] = "Ein gewohnliches Ei";
      ["name_fr"] = "Un ?uf ordinaire";
      ["name_cn"] = "普通的蛋";
      ["faction"] = "Horde";
      ["name"] = "An Ordinary Egg";
      ["reward"] = {
         [1] = 9539;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 2741;
      ["prequests"] = {
         [1] = 2741;
      };
      ["level"] = 60;
      ["name_es"] = "Un huevo normal";
      ["req"] = 42;
   };
   [5513] = {
      ["name_ru"] = "Оплечья Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Argent Dawn Valor Tokens to Quartermaster Breechlock at Light's Hope Chapel, Eastern Plaguelands.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "黎明?肩";
      ["name_fr"] = "Les mantelets de l'aube";
      ["name_de"] = "Mantel der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Mantles of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Mantos del Alba";
      ["req"] = 55;
   };
   [2765] = {
      ["name_ru"] = "Кузнец-умелец!";
      ["type"] = "Solo";
      ["name_fr"] = "Maitre Forgeron?!";
      ["name_de"] = "Schmiedkunstexperte!";
      ["name_cn"] = "?造?家！";
      ["objective"] = "Claim your reward from Galvan the Ancient!";
      ["sort"] = "Blacksmithing";
      ["reward"] = {
         [1] = 8703;
      };
      ["name"] = "Expert Blacksmith!";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2763;
         [2] = 2761;
         [3] = 2762;
      };
      ["level"] = 45;
      ["name_es"] = "!Experto herrero!";
      ["req"] = 40;
   };
   [2773] = {
      ["name_ru"] = "Мифриловый парень";
      ["type"] = "Solo";
      ["name_fr"] = "Le gars du mithril";
      ["name_de"] = "Mithril-Kid";
      ["objective"] = "Bring two Heavy Mithril Breastplates and one Ornate Mithril Gloves to Trenton Lighthammer.";
      ["name_cn"] = "秘?小子";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Horde";
      ["name"] = "The Mithril Kid";
      ["followup"] = 3321;
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "El chico de mitril";
      ["req"] = 40;
   };
   [2781] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: Калиф Жало Скорпида";
      ["type"] = "Solo";
      ["objective"] = "Bring the head of Caliph Scorpidsting to Chief Engineer Bilgewhizzle in Gadgetzan.";
      ["repgain"] = {
         [369] = 350;
      };
      ["name_fr"] = "ON RECHERCHE?: Caliph Dard-de-scorpide";
      ["sort"] = "Tanaris";
      ["name_cn"] = "通?：?利夫・斯科比斯汀";
      ["name_de"] = "GESUCHT: Kalif Skorpidstich";
      ["faction"] = "Horde";
      ["name"] = "WANTED: Caliph Scorpidsting";
      ["level"] = 46;
      ["name_es"] = "SE BUSCA: Califa Escorpijon";
      ["req"] = 39;
   };
   [5625] = {
      ["name_ru"] = "Облачение Света";
      ["type"] = "Solo";
      ["name_fr"] = "Vetements de la Lumiere";
      ["name_de"] = "Gewander des Lichts";
      ["sort"] = "Priest";
      ["objective"] = "Find Mountaineer Dolf and heal his wounds using Lesser Heal (Rank 2). Afterwards, grant him Power Word: Fortitude and then return to Maxan Anvol in Kharanos.";
      ["name_cn"] = "?光之衣";
      ["name"] = "Garments of the Light";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 16605;
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 5626;
      ["prequests"] = {
         [1] = 5626;
      };
      ["level"] = 4;
      ["name_es"] = "Las prendas de la Luz";
      ["req"] = 5;
   };
   [2821] = {
      ["name_ru"] = "Знак качества";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Yeti Hides to Pratt McGrubben in Feathermoon Stronghold.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "La marque de la qualite";
      ["name_cn"] = "?量的保?";
      ["reward"] = {
         [1] = 9630;
         [2] = 9631;
      };
      ["name_de"] = "Das Zeichen der Qualitat";
      ["faction"] = "Alliance";
      ["name"] = "The Mark of Quality";
      ["level"] = 46;
      ["name_es"] = "La marca de la calidad";
      ["req"] = 40;
   };
   [5657] = {
      ["name_ru"] = "Обессиливающий сглаз";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Verhexung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱妖?";
      ["name_fr"] = "Le malefice de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Hex of Weakness";
      ["level"] = 10;
      ["name_es"] = "Maleficio de Debilidad";
      ["req"] = 10;
   };
   [5673] = {
      ["name_ru"] = "Благодать Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["name_de"] = "Elunes Anmut";
      ["sort"] = "Priest";
      ["name_cn"] = "艾露恩的?福";
      ["name_fr"] = "Grace d'Elune";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Elune's Grace";
      ["level"] = 20;
      ["name_es"] = "La Gracia de Elune";
      ["req"] = 20;
   };
   [2845] = {
      ["name_ru"] = "Шая-бродяжница";
      ["type"] = "Solo";
      ["name_fr"] = "Shay l'egaree";
      ["name_de"] = "Streunende Shay";
      ["reward"] = {
         [1] = 9656;
         [2] = 9657;
      };
      ["name_cn"] = "迷路的沙恩";
      ["objective"] = "Pick up Shay's Bell from the chest.$B$BEscort Shay Leafrunner to Rockbiter's camp.";
      ["faction"] = "Alliance";
      ["name"] = "Wandering Shay";
      ["sort"] = "Feralas";
      ["prev"] = 2844;
      ["prequests"] = {
         [1] = 2844;
      };
      ["level"] = 49;
      ["name_es"] = "Las andanzas de Shay";
      ["req"] = 44;
   };
   [2853] = {
      ["name_ru"] = "Мастер школы Дикаря";
      ["type"] = "Solo";
      ["name_fr"] = "Maitre du cuir fauve";
      ["name_de"] = "Meister des Wildleders";
      ["name_cn"] = "蛮皮?甲大?";
      ["objective"] = "Give Pratt's Letter to Telonis, the master leatherworker of Darnassus.";
      ["sort"] = "Leatherworking";
      ["reward"] = {
         [1] = 8408;
      };
      ["name"] = "Master of the Wild Leather";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 2851;
         [2] = 2852;
         [3] = 2848;
         [4] = 2849;
         [5] = 2850;
      };
      ["level"] = 45;
      ["name_es"] = "Maestro de cuero salvaje";
      ["req"] = 30;
   };
   [5721] = {
      ["name_ru"] = "Битва при Дарроушире";
      ["type"] = "Raid";
      ["name_fr"] = "La bataille de Comte-de-Darrow";
      ["next"] = 5942;
      ["name_de"] = "Die Schlacht um Darroheim";
      ["reward"] = {
         [1] = 15723;
      };
      ["name_cn"] = "?隆郡的?斗";
      ["objective"] = "Place the Relic Bundle at the Darrowshire town square.$B$BPrevent Davil Lightfire's death until the death of Horgus.$B$BPrevent Captain Redpath's death until Redpath the Corrupted appears.$B$BDefeat Redpath the Corrupted.$B$BSpeak with the spirit of Joseph Redpath when he appears at the town square, then speak with Pamela at her home.";
      ["faction"] = "Horde";
      ["name"] = "The Battle of Darrowshire";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5941;
      ["prequests"] = {
         [1] = 5941;
      };
      ["level"] = 60;
      ["name_es"] = "La Batalla de Villa Darrow";
      ["req"] = 55;
   };
   [2869] = {
      ["name_ru"] = "Борьба с Гребнем Ненависти";
      ["objective"] = "Bring 10 Hatecrest Naga Scales to Latronicus Moonspear in Feathermoon Stronghold.";
      ["name_cn"] = "憎世?迦之?";
      ["sort"] = "Feralas";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Contre les Hainecrete";
      ["next"] = 2870;
      ["name_de"] = "Gegen die Hasskamme";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Against the Hatecrest";
      ["prev"] = 3130;
      ["prequests"] = {
         [1] = 3130;
      };
      ["series"] = 2;
      ["name_es"] = "En contra de los Crestafuria";
      ["req"] = 40;
   };
   [2877] = {
      ["name_ru"] = "Зачистка Осклизлой скалы";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Green Sludges and 10 Jade Oozes, and then report back to Fraggar Thundermantle in Aerie Peak.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "清理?匿石";
      ["name_fr"] = "Nettoyer le rocher de l'Affut";
      ["name_de"] = "Den Lauerfels aufraumen";
      ["faction"] = "Alliance";
      ["name"] = "Skulk Rock Clean-up";
      ["level"] = 48;
      ["name_es"] = "La limpieza de Roca Oculta";
      ["req"] = 40;
   };
   [5801] = {
      ["name_ru"] = "Кузня Пламенного хребта";
      ["type"] = "Solo";
      ["name_fr"] = "Forgee dans la Fournaise";
      ["next"] = 5803;
      ["name_de"] = "Feuersaulen geschmiedet";
      ["name_cn"] = "火羽山";
      ["objective"] = "Take the Skeleton Key Mold and 2 Thorium Bars to the top of Fire Plume Ridge in Un'Goro Crater.  Use the Skeleton Key Mold by the lava lake to forge the Unfinished Skeleton Key.$B$BBring the Unfinished Skeleton Key to Alchemist Arbington at Chillwind Point, Western Plaguelands.";
      ["sort"] = "Tanaris";
      ["faction"] = "Alliance";
      ["name"] = "Fire Plume Forged";
      ["prev"] = 5538;
      ["prequests"] = {
         [1] = 5538;
      };
      ["level"] = 57;
      ["name_es"] = "La forja del Penacho en Llamas";
      ["req"] = 55;
   };
   [2925] = {
      ["name_ru"] = "Базовые элементы Клацморта";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Klockmort Spannerspan in Ironforge.";
      ["next"] = 2924;
      ["name_fr"] = "Les cerveaux mecaniques de Plethorloge";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "?助科?莫特";
      ["repgain"] = {
         [54] = 25;
      };
      ["name_de"] = "Klockmorts Grundlagen";
      ["faction"] = "Alliance";
      ["name"] = "Klockmort's Essentials";
      ["level"] = 30;
      ["name_es"] = "Klockmort Palmalicate";
      ["req"] = 24;
   };
   [2933] = {
      ["name_ru"] = "Бутыли с ядом";
      ["type"] = "Solo";
      ["objective"] = "Bring a Venom Bottle to an apothecary in Tarren Mill.";
      ["next"] = 2934;
      ["name_fr"] = "Bouteilles de venin";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "毒液瓶";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Giftflaschen";
      ["faction"] = "Horde";
      ["name"] = "Venom Bottles";
      ["level"] = 43;
      ["name_es"] = "Botellas de veneno";
      ["req"] = 40;
   };
   [2941] = {
      ["name_ru"] = "В обмен на книгу";
      ["type"] = "Solo";
      ["name_fr"] = "Le pret";
      ["next"] = 2944;
      ["name_de"] = "Der Borger";
      ["name_cn"] = "海?照片";
      ["objective"] = " I think...\"";
      ["sort"] = "Feralas";
      ["faction"] = "Alliance";
      ["name"] = "The Borrower";
      ["prev"] = 2940;
      ["prequests"] = {
         [1] = 2940;
      };
      ["level"] = 48;
      ["name_es"] = "El prestamo";
      ["req"] = 42;
   };
   [2949] = {
      ["name_ru"] = "Возвращение кольца";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le retour de l'anneau";
      ["next"] = 2950;
      ["name_de"] = "Die Ruckkehr des Rings";
      ["name_cn"] = "戒指?来";
      ["objective"] = " or perhaps the initials of the ring's crafter.  Keep the ring... or find \"NOG\" - decisions";
      ["sort"] = "Gnomeregan";
      ["faction"] = "Horde";
      ["name"] = "Return of the Ring";
      ["prev"] = 2945;
      ["prequests"] = {
         [1] = 2945;
      };
      ["level"] = 34;
      ["name_es"] = "La devolucion del anillo";
      ["req"] = 28;
   };
   [2965] = {
      ["name_ru"] = "Ульдумские чудеса";
      ["type"] = "Solo";
      ["name_fr"] = "Prodiges d'Uldum";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Omen von Uldum";
      ["name"] = "Portents of Uldum";
      ["name_cn"] = "奥丹姆的?索";
      ["objective"] = "Speak with Nara Wildmane on the Elder Rise in Thunder Bluff.";
      ["next"] = 2966;
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 2440;
      ["prequests"] = {
         [1] = 2440;
      };
      ["level"] = 50;
      ["name_es"] = "Presagios de Uldum";
      ["req"] = 45;
   };
   [2973] = {
      ["name_ru"] = "Новый сверкающий плащ";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Iridescent Sprite Darter Wings to Krueg Skullsplitter in Camp Mojache.";
      ["next"] = 2974;
      ["name_fr"] = "Une nouvelle cape";
      ["sort"] = "Feralas";
      ["name_cn"] = "新斗篷的光?";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Schimmer fur einen neuen Umhang";
      ["faction"] = "Horde";
      ["name"] = "A New Cloak's Sheen";
      ["level"] = 45;
      ["name_es"] = "El lustre de una nueva capa";
      ["req"] = 38;
   };
   [5961] = {
      ["name_ru"] = "Защитник королевы банши";
      ["type"] = "Solo";
      ["objective"] = "Speak with Nathanos Blightcaller in the Eastern Plaguelands. He is said to have taken up residence at the Marris Stead.$B";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_fr"] = "Le champion de la reine banshee";
      ["sort"] = "Undercity";
      ["name_cn"] = "女妖之王的勇士";
      ["name_de"] = "Der Champion der Bansheekonigin";
      ["faction"] = "Horde";
      ["name"] = "The Champion of the Banshee Queen";
      ["level"] = 56;
      ["name_es"] = "Campeon de la Reina alma en pena";
      ["req"] = 54;
   };
   [2989] = {
      ["name_ru"] = "Алтарь Зула";
      ["type"] = "Solo";
      ["name_fr"] = "L'autel de Zul";
      ["next"] = 2990;
      ["name_de"] = "Der Altar von Zul";
      ["name_cn"] = "祖?祭?";
      ["objective"] = "Check the top of the Altar of Zul, then return to Gryphon Master Talonaxe.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Alliance";
      ["name"] = "The Altar of Zul";
      ["prev"] = 2988;
      ["prequests"] = {
         [1] = 2988;
      };
      ["level"] = 48;
      ["name_es"] = "El Altar de Zul";
      ["req"] = 40;
   };
   [2997] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge.";
      ["next"] = 1645;
      ["name_de"] = "Foliant der Offenbarung";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["name_fr"] = "Le Tome de divinite";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "Tome of Divinity";
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [6025] = {
      ["name_ru"] = "Неоконченное дело";
      ["type"] = "Group";
      ["name_fr"] = "Un travail inacheve";
      ["name_de"] = "Offene Rechnungen";
      ["name"] = "Unfinished Business";
      ["name_cn"] = "未完的任?";
      ["objective"] = "Enter Hearthglen and find a high vantage point from which you can see the town and gauge the Scarlet Crusade's forces, then return to Kirsta Deepshadow in Western Plaguelands.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 6023;
      ["prequests"] = {
         [1] = 6023;
      };
      ["level"] = 58;
      ["name_es"] = "Negocios inconclusos";
      ["req"] = 50;
   };
   [6041] = {
      ["name_ru"] = "Дымок над водою";
      ["type"] = "Group";
      ["name_fr"] = "Quand Smokey chante, je deviens violent";
      ["name_de"] = "When Smokey Sings, I Get Violent";
      ["reward"] = {
         [1] = 16992;
         [2] = 5951;
         [3] = 16993;
         [4] = 17523;
      };
      ["name_cn"] = "烟鬼的炸?";
      ["objective"] = "Travel to Plaguewood, northwest of Light's Hope. Destroy 8 Scourge Structures by using Smokey's Special Compound at the Mark of Detonation planted inside each building. Smokey has had the Ziggurats and Slaughterhouses marked.$B$BOnce you plant the bomb, leave the building and marvel at your handiwork.$B$BBy the way, Smokey's Special Compound is rather... unstable.";
      ["faction"] = "Horde";
      ["name"] = "When Smokey Sings, I Get Violent";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6026;
      ["prequests"] = {
         [1] = 6026;
      };
      ["level"] = 58;
      ["name_es"] = "Cuando Smokey canta, me pongo violento";
      ["req"] = 54;
   };
   [6073] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dazalar in Dolanaar.";
      ["next"] = 6063;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6089] = {
      ["name_ru"] = "Обучение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Entrainer la bete";
      ["name_de"] = "Die Ausbildung des Tiers";
      ["objective"] = "Speak with Holt Thunderhorn on Hunter Rise in Thunder Bluff.";
      ["name_cn"] = "??野?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Training the Beast";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 6088;
      ["prequests"] = {
         [1] = 6088;
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6121] = {
      ["name_ru"] = "Новый урок";
      ["type"] = "Solo";
      ["objective"] = "Travel to Moonglade and speak with Dendrite Starblaze in the village of Nighthaven.";
      ["next"] = 6122;
      ["name_de"] = "Neue Lektionen";
      ["sort"] = "Druid";
      ["name_cn"] = "新的?程";
      ["name_fr"] = "Nouvelles lecons";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Lessons Anew";
      ["level"] = 14;
      ["name_es"] = "Nuevas lecciones";
      ["req"] = 14;
   };
   [8241] = {
      ["name_ru"] = "Пополнение запасов огненного плавня ? железо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 25;
      };
      ["name_de"] = "Nachschub an feurigem Fluxus: Eisen";
      ["name_cn"] = "??助熔?的??：??";
      ["name_fr"] = "Reapprovisionnement en flux embrase (Fer)";
      ["name"] = "Restoring Fiery Flux Supplies via Iron";
      ["faction"] = "Horde";
      ["sort"] = "Searing Gorge";
      ["prev"] = 7722;
      ["prequests"] = {
         [1] = 7722;
      };
      ["level"] = 60;
      ["name_es"] = "Fabricar flujo igneo con hierro";
      ["req"] = 45;
   };
   [8273] = {
      ["name_ru"] = "Благодарность Оран";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Orans Dankbarkeit";
      ["name_fr"] = "La gratitude d'Oran";
      ["name_cn"] = "奥?的感?";
      ["faction"] = "Horde";
      ["name"] = "Oran's Gratitude";
      ["reward"] = {
         [1] = 20643;
         [2] = 20642;
      };
      ["sort"] = "The Hinterlands";
      ["prev"] = 2782;
      ["prequests"] = {
         [1] = 2782;
      };
      ["level"] = 47;
      ["name_es"] = "La gratitud Oran";
      ["req"] = 42;
   };
   [3101] = {
      ["name_ru"] = "Благословенное письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre consacree";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Geweihter Brief";
      ["objective"] = "Read the Consecrated Letter and speak to Brother Sammuel in Northshire Abbey.";
      ["name_cn"] = "??信件";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Consecrated Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta consagrada";
      ["req"] = 1;
   };
   [3109] = {
      ["name_ru"] = "Зашифрованная руна";
      ["type"] = "Solo";
      ["name_fr"] = "Rune codee";
      ["repgain"] = {
         [47] = 50;
      };
      ["name_de"] = "Verschlusselte Rune";
      ["objective"] = "Read the Encrypted Rune and speak to Solm Hargrin in Coldridge Valley.";
      ["name_cn"] = "密文符文";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Rune";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa codificada";
      ["req"] = 1;
   };
   [8369] = {
      ["name_ru"] = "Вторжение в Альтеракскую долину";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [729] = 150;
      };
      ["name_fr"] = "Les envahisseurs de la vallee d'Alterac";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "奥特?克的入侵者";
      ["name_de"] = "Die Invasoren des Alteractals";
      ["faction"] = "Horde";
      ["name"] = "Invaders of Alterac Valley";
      ["level"] = 60;
      ["name_es"] = "Invasores del Valle de Alterac";
      ["req"] = 51;
   };
   [3125] = {
      ["name_ru"] = "Уменьшенный лесной дракончик";
      ["type"] = "Solo";
      ["name_fr"] = "Dragon feerique miniaturise";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Muisek von Feendrachen";
      ["name"] = "Faerie Dragon Muisek";
      ["name_cn"] = "精???魂精?";
      ["objective"] = "Kill 8 Sprite Darters or Sprite Dragons. Use the Muisek Vessel to shrink and capture the fallen Faerie Dragons.";
      ["next"] = 3126;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 3124;
      ["prequests"] = {
         [1] = 3124;
      };
      ["level"] = 45;
      ["name_es"] = "Muisek de dragon feerico";
      ["req"] = 40;
   };
   [8433] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8428;
      ["prequests"] = {
         [1] = 8428;
      };
      ["level"] = 49;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 40;
   };
   [6281] = {
      ["name_ru"] = "Продолжение пути в Штормград";
      ["type"] = "Solo";
      ["name_fr"] = "Continuer vers Hurlevent";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Weiter nach Sturmwind";
      ["objective"] = "Buy a gryphon ride from the gryphon master Thor, then bring Lewis' Note to Osric Strang, in the shop Limited Immunity, in the Old Town of Stormwind.";
      ["name_cn"] = "赶赴暴?城";
      ["next"] = 6261;
      ["sort"] = "Westfall";
      ["name"] = "Continue to Stormwind";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 6181;
      ["prequests"] = {
         [1] = 6181;
      };
      ["level"] = 10;
      ["name_es"] = "Prosigue hasta Ventormenta";
      ["req"] = 10;
   };
   [8497] = {
      ["name_ru"] = "Неприкосновенный запас";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Globes of Water, 4 Powerful Anti-Venom and 4 Smoked Desert Dumplings to Calandrath at the inn in Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing I in order to complete this quest.";
      ["name_fr"] = "Survivre dans le desert";
      ["sort"] = "Silithus";
      ["name_cn"] = "沙漠生存包";
      ["reward"] = {
         [1] = 20800;
         [2] = 21132;
      };
      ["name_de"] = "Wustenuberlebenspaket";
      ["faction"] = "Alliance";
      ["name"] = "Desert Survival Kits";
      ["level"] = 60;
      ["name_es"] = "Material de supervivencia en el desierto";
      ["req"] = 60;
   };
   [8529] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает пятнистого желтохвоста!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de jaune-queue tachete?!";
      ["name_de"] = "Die Allianz braucht mehr Tupfelgelbschwanze!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_cn"] = "?盟需要更多斑点黄尾?！";
      ["objective"] = "Bring 20 spotted yellowtail to Huntress Swiftriver at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Spotted Yellowtail!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8528;
      ["prequests"] = {
         [1] = 8528;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas serviolas moteadas!";
      ["req"] = 1;
   };
   [8561] = {
      ["name_ru"] = "Корона Завоевателя";
      ["objective"] = "Bring Vek'nilash's Circlet, 2 Idols of the Sun, 5 Stone Scarabs and 5 Crystal Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "征服者的皇冠";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La couronne du Conquerant";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Krone des Eroberers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21329;
      };
      ["name"] = "Conqueror's Crown";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La corona de conquistador";
      ["req"] = 60;
   };
   [8593] = {
      ["name_ru"] = "Брюки Оракула";
      ["objective"] = "Bring Ouro's Intact Hide, 2 Idols of Life, 5 Gold Scarabs and 5 Clay Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神?者的??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les chausses de l'Oracle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Beinkleider des Orakels";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21352;
      };
      ["name"] = "Trousers of the Oracle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las calzas del Oraculo";
      ["req"] = 60;
   };
   [8625] = {
      ["name_ru"] = "Наплечные пластины таинства";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Death, 5 Stone Scarabs and 5 Bronze Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神秘肩?";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-epaules de l'enigme";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schulterpolster des Mysteriums";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21345;
      };
      ["name"] = "Enigma Shoulderpads";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las hombreras enigma";
      ["req"] = 60;
   };
   [8657] = {
      ["name_ru"] = "Диадема бойца";
      ["objective"] = "Bring Vek'lor's Diadem, 2 Idols of Strife, 5 Bronze Scarabs and 5 Ivory Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "攻?者的王冠";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe du Frappeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Diadem des Hetzers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21366;
      };
      ["name"] = "Striker's Diadem";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La diadema de asediador";
      ["req"] = 60;
   };
   [8689] = {
      ["name_ru"] = "Накидка Бесконечной мудрости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Martial Drape, 2 Jasper Idols, 5 Gold Scarabs and 5 Clay Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le voile de sagesse infinie";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "无尽智慧披?";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21412;
      };
      ["name_de"] = "Schleier der unendlichen Weisheit";
      ["faction"] = "Horde";
      ["name"] = "Shroud of Infinite Wisdom";
      ["level"] = 60;
      ["name_es"] = "El embozo de sabiduria infinita";
      ["req"] = 60;
   };
   [8721] = {
      ["name_ru"] = "Предок Звездная Пряжа";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Tissetoile";
      ["name_cn"] = "星??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Sternenweber";
      ["faction"] = "Horde";
      ["name"] = "Starweave the Elder";
      ["level"] = 60;
      ["name_es"] = "Tejestrellas el Ancestro";
      ["req"] = 1;
   };
   [8753] = {
      ["name_ru"] = "Путь победителя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Eroberers";
      ["name_fr"] = "La voie du Conquerant";
      ["name_cn"] = "征服者之路";
      ["name"] = "The Path of the Conqueror";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21202;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8752;
      ["prequests"] = {
         [1] = 8752;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del conquistador";
      ["req"] = 60;
   };
   [6441] = {
      ["name_ru"] = "Рога сатира";
      ["type"] = "Solo";
      ["objective"] = "Collect 16 Satyr Horns for Pixel in Splintertree Post.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_fr"] = "Cornes de satyre";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "?特之角";
      ["name_de"] = "Satyrhorner";
      ["faction"] = "Horde";
      ["name"] = "Satyr Horns";
      ["level"] = 26;
      ["name_es"] = "Los cuernos de satiro";
      ["req"] = 21;
   };
   [8817] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8849] = {
      ["name_ru"] = "Двадцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Vingt chevalieres pour des fournitures militaires";
      ["name_cn"] = "二十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21512;
      };
      ["name_de"] = "Zwanzig Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Alliance";
      ["name"] = "Twenty Signets for War Supplies";
      ["level"] = 49;
      ["name_es"] = "Veinte sellos para los suministros belicos";
      ["req"] = 40;
   };
   [8881] = {
      ["name_ru"] = "Большие связки фейерверков";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les chapelets de grandes cometes";
      ["name_cn"] = "大型烟花束";
      ["reward"] = {
         [1] = 21743;
         [2] = 21640;
      };
      ["name_de"] = "Grose Raketenbundel";
      ["faction"] = "Horde";
      ["name"] = "Large Cluster Rockets";
      ["level"] = 60;
      ["name_es"] = "Tracas de cohetes grandes";
      ["req"] = 55;
   };
   [8913] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Wildheart Bracers to Mokvar in Orgrimmar.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22108;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8945] = {
      ["name_ru"] = "Просьба мертвеца";
      ["type"] = "Dungeon";
      ["name_fr"] = "La supplique du mort";
      ["repgain"] = {
         [529] = 500;
      };
      ["name_de"] = "Die letzte Bitte eines toten Mannes";
      ["reward"] = {
         [1] = 22137;
      };
      ["name_cn"] = "死人的?求";
      ["objective"] = "Go into Stratholme and rescue Ysida Harmon from Baron Rivendare.";
      ["next"] = 8946;
      ["name"] = "Dead Man's Plea";
      ["sort"] = "Stratholme";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8929;
         [2] = 8930;
      };
      ["level"] = 60;
      ["name_es"] = "La suplica de un muerto";
      ["req"] = 58;
   };
   [8977] = {
      ["name_ru"] = "Возвращение к Делиане";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Deliana";
      ["name_de"] = "Ruckkehr zu Deliana";
      ["name_cn"] = "向德莉?娜回?";
      ["objective"] = "Bring the Extra-Dimensional Ghost Revealer  to Deliana in Ironforge.";
      ["sort"] = "Ironforge";
      ["faction"] = "Alliance";
      ["name"] = "Return to Deliana";
      ["prev"] = 8928;
      ["prequests"] = {
         [1] = 8928;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Deliana";
      ["req"] = 58;
   };
   [9009] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Devout Crown and Devout Robe.";
      ["reward"] = {
         [1] = 22080;
         [2] = 22083;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9041] = {
      ["name_ru"] = "Воинский пояс неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make a Dreadnaught Waistguard if you bring him the following items: 1 Desecrated Waistguard, 8 Wartorn Plate Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides.";
      ["name_cn"] = "无畏腰?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Sangle de cuirassier";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Taillenschutz des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22422;
      };
      ["name"] = "Dreadnaught Waistguard";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardarrenes acorator";
      ["req"] = 60;
   };
   [9073] = {
      ["name_ru"] = "Боевые рукавицы Землекрушителя";
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-mains de Brise-terre";
      ["name_de"] = "Handschutzer des Erdspalters";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make Earthshatter Handguards if you bring him the following: 1 Desecrated Handguards, 8 Wartorn Chain Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22469;
      };
      ["name_cn"] = "碎地者?手";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Earthshatter Handguards";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las manoplas Rompeterra";
      ["req"] = 60;
   };
   [3301] = {
      ["name_ru"] = "Муура Рунический Тотем";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mura Runetotem in the Sepulcher.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Mura Runentotem";
      ["reward"] = {
         [1] = 10820;
         [2] = 10821;
      };
      ["name_cn"] = "茉拉・符文??";
      ["name_fr"] = "Mura Totem-runique";
      ["faction"] = "Horde";
      ["name"] = "Mura Runetotem";
      ["sort"] = "The Barrens";
      ["prev"] = 880;
      ["prequests"] = {
         [1] = 880;
      };
      ["level"] = 15;
      ["name_es"] = "Mura Totem de Runa";
      ["req"] = 10;
   };
   [9137] = {
      ["name_ru"] = "Дикие ростки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Wildwedel";
      ["name_fr"] = "Des palmes sauvages";
      ["name_cn"] = "蛮荒之叶";
      ["faction"] = "Horde";
      ["name"] = "Savage Fronds";
      ["reward"] = {
         [1] = 22523;
         [2] = 22524;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9136;
      ["prequests"] = {
         [1] = 9136;
      };
      ["level"] = 60;
      ["name_es"] = "Hojas salvajes";
      ["req"] = 55;
   };
   [9201] = {
      ["name_ru"] = "Задание мастера: сильное зелье защиты от тайной магии";
      ["type"] = "Solo";
      ["objective"] = "Deliver 15 Greater Arcane Protection Potions and the Craftsman's Writ - Greater Arcane Protection Potion - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.$B";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Potions de protection contr";
      ["name_cn"] = "工匠文? - ?效奥?防??水";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Groser Arkanschutztrank";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Greater Arcane Protection Potion";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pocion de Proteccion contra lo Arcano superior";
      ["req"] = 55;
   };
   [9233] = {
      ["name_ru"] = "Руководство Омариона";
      ["type"] = "Raid";
      ["objective"] = "Take Omarion's Handbook to Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands.$B";
      ["sort"] = "Naxxramas";
      ["name_cn"] = "奥?里恩的手册";
      ["name_fr"] = "Le recueil d'Omarion";
      ["name_de"] = "Omarions Leitfaden";
      ["faction"] = "Horde";
      ["name"] = "Omarion's Handbook";
      ["level"] = 60;
      ["name_es"] = "Vademecum de Omarion";
      ["req"] = 60;
   };
   [9265] = {
      ["name_ru"] = "Что делает Плеть в Подгороде?";
      ["type"] = "Solo";
      ["objective"] = "Collect three Dim Necrotic Stones from the Scourge outside the Undercity and investigate the glowing runic circles near their encampment.";
      ["name_cn"] = "??幽暗城的天?入侵";
      ["sort"] = "Scourge Invasion";
      ["name_de"] = "Erforscht die Geisel von Unterstadt";
      ["faction"] = "Horde";
      ["name"] = "Investigate the Scourge of the Undercity";
      ["level"] = 8;
      ["name_es"] = "Investigar la Plaga en Entranas";
      ["req"] = 1;
   };
   [3365] = {
      ["name_ru"] = "Возвращение кружки";
      ["type"] = "Solo";
      ["name_fr"] = "Rapporter la Tasse";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_de"] = "Den Becher zuruckbringen";
      ["name_cn"] = "??酒杯";
      ["name"] = "Bring Back the Mug";
      ["objective"] = "Return Nori's Mug to Nori Pridedrift.";
      ["faction"] = "Alliance";
      ["sort"] = "Coldridge Valley";
      ["prev"] = 3364;
      ["prequests"] = {
         [1] = 3364;
      };
      ["level"] = 5;
      ["name_es"] = "Devuelve la jarra";
      ["req"] = 4;
   };
   [3373] = {
      ["name_ru"] = "Сущность Эраникуса";
      ["type"] = "Dungeon";
      ["objective"] = " heed this plea.  I am Eranikus of the Green Dragonflight";
      ["repgain"] = {
         [0] = 1;
      };
      ["name_fr"] = "L'Essence d'Eranikus";
      ["sort"] = "Sunken Temple";
      ["name_cn"] = "伊?尼?斯精?";
      ["name_de"] = "Die Essenz des Eranikus";
      ["faction"] = "Horde";
      ["name"] = "The Essence of Eranikus";
      ["level"] = 55;
      ["name_es"] = "La esencia de Eranikus";
      ["req"] = 48;
   };
   [6761] = {
      ["name_ru"] = "Новое пограничье";
      ["objective"] = "Speak with Mathrengyl Bearwalker at the Cenarion Enclave of Darnassus.";
      ["name_cn"] = "新的?疆";
      ["sort"] = "Darnassus";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "La nouvelle frontiere";
      ["next"] = 6762;
      ["name_de"] = "Die neue Grenze";
      ["repgain"] = {
         [69] = 10;
      };
      ["faction"] = "Alliance";
      ["name"] = "The New Frontier";
      ["prev"] = 1015;
      ["prequests"] = {
         [1] = 1015;
      };
      ["series"] = 2;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [6825] = {
      ["name_ru"] = "Небо зовет ? флот Смуггла";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 1;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille de Guse";
      ["name_cn"] = "天空的召? - 古斯的部?";
      ["name_de"] = "Ruf der Lufte - Guses Luftflotte";
      ["faction"] = "Horde";
      ["name"] = "Call of Air - Guse's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: flota de Guse";
      ["req"] = 51;
   };
   [3421] = {
      ["name_ru"] = "Возвращение";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Azshara";
      ["name_cn"] = "回程";
      ["name_fr"] = "Le voyage de retour";
      ["name_de"] = "Ruckreise";
      ["faction"] = "Horde";
      ["name"] = "Return Trip";
      ["level"] = 55;
      ["name_es"] = "El viaje de vuelta";
      ["req"] = 45;
   };
   [3445] = {
      ["name_ru"] = "Затонувший храм";
      ["type"] = "Solo";
      ["objective"] = "Find Marvon Rivetseeker in Tanaris.";
      ["next"] = 3444;
      ["sort"] = "Feralas";
      ["name_cn"] = "?没的神?";
      ["name_fr"] = "Le Temple englouti";
      ["followup"] = 3444;
      ["name_de"] = "Der Versunkene Tempel";
      ["faction"] = "Alliance";
      ["name"] = "The Sunken Temple";
      ["level"] = 51;
      ["name_es"] = "El Templo Sumergido";
      ["req"] = 46;
   };
   [3453] = {
      ["name_ru"] = "Факел воздаяния";
      ["type"] = "Solo";
      ["name_fr"] = "La Torche de vindicte";
      ["next"] = 3454;
      ["name_de"] = "Die Fackel der Vergeltung";
      ["name"] = "The Torch of Retribution";
      ["name_cn"] = "?戒火炬";
      ["objective"] = "Wait for Kalaran Windblade to complete the Torch of Retribution.$B";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3452;
      ["prequests"] = {
         [1] = 3452;
      };
      ["level"] = 50;
      ["name_es"] = "La antorcha de reprension";
      ["req"] = 40;
   };
   [6921] = {
      ["name_ru"] = "Среди руин";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Fathom Core to Je'neu Sancrea at Zoram'gar Outpost, Ashenvale.";
      ["repgain"] = {
         [530] = 500;
      };
      ["name_fr"] = "Parmi les ruines";
      ["sort"] = "Blackfathom Deeps";
      ["name_cn"] = "?墟之?";
      ["name_de"] = "Inmitten der Ruinen";
      ["faction"] = "Horde";
      ["name"] = "Amongst the Ruins";
      ["level"] = 27;
      ["name_es"] = "Entre ruinas";
      ["req"] = 21;
   };
   [6985] = {
      ["name_ru"] = "Припасы Железного рудника";
      ["type"] = "PvP";
      ["objective"] = "Bring 10 Irondeep Supplies to the Horde Quartermaster in Frostwolf Keep.";
      ["repgain"] = {
         [76] = 25;
         [729] = 2;
      };
      ["name_fr"] = "Fournitures de Gouffrefer";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "深??洞的??";
      ["name_de"] = "Vorrate der Eisenschachtmine";
      ["faction"] = "Horde";
      ["name"] = "Irondeep Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros de Ferrohondo";
      ["req"] = 51;
   };
   [7001] = {
      ["name_ru"] = "Пустые стойла";
      ["type"] = "Solo";
      ["objective"] = "Locate a Frostwolf in Alterac Valley. Use the Frostwolf Muzzle when you are near the Frostwolf to 'tame' the beast. Once tamed, the Frostwolf will follow you back to the Frostwolf Stable Master. Speak with the Frostwolf Stable Master to earn credit for the capture.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?充坐?";
      ["name_fr"] = "Ecuries vides";
      ["name_de"] = "Verwaiste Stalle";
      ["faction"] = "Horde";
      ["name"] = "Empty Stables";
      ["level"] = 60;
      ["name_es"] = "Establos vacios";
      ["req"] = 51;
   };
   [3509] = {
      ["name_ru"] = "Имя Зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Le nom de la bete";
      ["next"] = 3510;
      ["name_de"] = "Der Name der Bestie";
      ["name"] = "The Name of the Beast";
      ["name_cn"] = "?魔之名";
      ["objective"] = "Speak with Lord Arkkoroc in Azshara. Begin your search at the waters edge to find the Temple of Arkkoran.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Azshara";
      ["prev"] = 3508;
      ["prequests"] = {
         [1] = 3508;
      };
      ["level"] = 58;
      ["name_es"] = "El nombre de la bestia";
      ["req"] = 45;
   };
   [3517] = {
      ["name_ru"] = "Тайненькое знаньице";
      ["type"] = "Solo";
      ["objective"] = "Find the Tablet of Beth'Amara, the Tablet of Jin'yael, the Tablet of Markri, and the Tablet of Sael'hai before returning to Jediga in Azshara.";
      ["sort"] = "Azshara";
      ["name_cn"] = "?窃知?";
      ["name_fr"] = "L'art du vol";
      ["name_de"] = "Wissen stehlen";
      ["faction"] = "Horde";
      ["name"] = "Stealing Knowledge";
      ["level"] = 52;
      ["name_es"] = "El robo de conocimientos";
      ["req"] = 45;
   };
   [3525] = {
      ["name_ru"] = "Уничтожить идола";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'extinction de l'idole";
      ["name_de"] = "Ausschalten des Gotzen";
      ["reward"] = {
         [1] = 10710;
      };
      ["name_cn"] = "封印神像";
      ["objective"] = "Escort Belnistrasz to the Quilboar's idol in Razorfen Downs.$B$BProtect Belnistrasz while he performs the ritual to shut down the idol.";
      ["faction"] = "Horde";
      ["name"] = "Extinguishing the Idol";
      ["sort"] = "Razorfen Downs";
      ["prev"] = 3523;
      ["prequests"] = {
         [1] = 3523;
      };
      ["level"] = 37;
      ["name_es"] = "Extinguir el idolo";
      ["req"] = 32;
   };
   [7065] = {
      ["name_ru"] = "Яблочко от яблоньки...";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Princess Theradras and return to Keeper Marandis at Nijel's Point in Desolace.";
      ["repgain"] = {
         [609] = 150;
      };
      ["sort"] = "Maraudon";
      ["name_fr"] = "Corruption de la terre et de la Graine";
      ["name_cn"] = "大地的?染";
      ["reward"] = {
         [1] = 17705;
         [2] = 17743;
         [3] = 17753;
      };
      ["name_de"] = "Verderbnis von Erde und Samenkorn";
      ["faction"] = "Alliance";
      ["name"] = "Corruption of Earth and Seed";
      ["level"] = 51;
      ["name_es"] = "Corrupcion de la tierra y de la semilla";
      ["req"] = 45;
   };
   [7081] = {
      ["name_ru"] = "Кладбища Альтеракской долины";
      ["type"] = "PvP";
      ["objective"] = "Assault a graveyard, then return to Sergeant Durgen Stormpike in the Alterac Mountains.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "Les cimetieres de la vallee d'Alterac";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "奥特?克山谷的墓地";
      ["name_de"] = "Die Friedhofe im Alteractal";
      ["faction"] = "Alliance";
      ["name"] = "Alterac Valley Graveyards";
      ["level"] = 60;
      ["name_es"] = "Los cementerios del Valle de Alterac";
      ["req"] = 51;
   };
   [3565] = {
      ["name_ru"] = "Плата Ксилема Джедиге";
      ["type"] = "Solo";
      ["name_fr"] = "Le paiement de Xylem a Jediga";
      ["name_de"] = "Xylems Bezahlung fur Jediga";
      ["name_cn"] = "克希雷姆的?酬";
      ["objective"] = "Deliver Xylem's Note to Jediga in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Xylem's Payment to Jediga";
      ["prev"] = 3561;
      ["prequests"] = {
         [1] = 3561;
      };
      ["level"] = 52;
      ["name_es"] = "El pago de Xylem a Jediga";
      ["req"] = 45;
   };
   [7161] = {
      ["name_ru"] = "Испытательные земли";
      ["type"] = "Solo";
      ["objective"] = "Travel to the Wildpaw cavern located southeast of the main base in Alterac Valley and find the Frostwolf Banner. Return the Frostwolf Banner to Warmaster Laggrond. ";
      ["repgain"] = {
         [76] = 250;
         [729] = 250;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Montrer sa valeur";
      ["name_cn"] = "???";
      ["reward"] = {
         [1] = 17690;
         [2] = 19483;
      };
      ["name_de"] = "Flaggenjagd";
      ["faction"] = "Horde";
      ["name"] = "Proving Grounds";
      ["level"] = 60;
      ["name_es"] = "Terreno de Pruebas";
      ["req"] = 51;
   };
   [7241] = {
      ["name_ru"] = "Защита клана Северного Волка";
      ["type"] = "PvP";
      ["objective"] = "Venture to Alterac Valley, located in the Alterac Mountains. Find and speak with Warmaster Laggrond - who stands outside the tunnel entrance - to begin your career as a soldier of Frostwolf. You will find Alterac Valley north of Tarren Mill at the base of the Alterac Mountains.";
      ["repgain"] = {
         [76] = 250;
         [729] = 250;
      };
      ["name_fr"] = "La defense des Loups-de-givre";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "保?霜狼氏族";
      ["name_de"] = "Die Verteidigung der Frostwolfe";
      ["faction"] = "Horde";
      ["name"] = "In Defense of Frostwolf";
      ["level"] = 60;
      ["name_es"] = "En defensa de Lobo Gelido";
      ["req"] = 51;
   };
   [3629] = {
      ["name_ru"] = "Гоблинское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Goblin Engineering, take the Manual of Engineering Disciplines to Nixx Sprocketspring in Gadgetzan.";
      ["sort"] = "Engineering";
      ["name_cn"] = "地精工程学";
      ["name_fr"] = "Ingenierie des gobelins";
      ["followup"] = 3638;
      ["name_de"] = "Gobliningenieurskunst";
      ["faction"] = "Alliance";
      ["name"] = "Goblin Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria goblin";
      ["req"] = 30;
   };
   [3637] = {
      ["name_ru"] = "Гномское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Gnome Engineering, take the Manual of Engineering Disciplines to Oglethorpe Obnoticus in Booty Bay.";
      ["sort"] = "Engineering";
      ["name_cn"] = "侏儒工程学";
      ["name_fr"] = "Ingenierie des gnomes";
      ["followup"] = 3642;
      ["name_de"] = "Gnomeningenieurskunst";
      ["faction"] = "Horde";
      ["name"] = "Gnome Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria gnomica";
      ["req"] = 30;
   };
   [3645] = {
      ["name_ru"] = "Продление членского билета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Mitgliedskarten-Erneuerung";
      ["name_fr"] = "Le renouvellement de la Carte de membre";
      ["name_cn"] = "会????";
      ["name"] = "Membership Card Renewal";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 10790;
      };
      ["sort"] = "Engineering";
      ["prev"] = 3641;
      ["prequests"] = {
         [1] = 3641;
      };
      ["level"] = 47;
      ["name_es"] = "Renovacion de la tarjeta de miembro";
      ["req"] = 30;
   };
   [7321] = {
      ["name_ru"] = "Нежный черепаховый суп";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 pieces of Turtle Meat and some Soothing Spices to Christoph Jeffcoat in Tarren Mill.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Cooking";
      ["name_fr"] = "Bisque de tortue apaisante";
      ["name_cn"] = "海??";
      ["reward"] = {
         [1] = 3737;
         [2] = 3729;
      };
      ["name_de"] = "Milde Schildkrotensuppe";
      ["faction"] = "Horde";
      ["name"] = "Soothing Turtle Bisque";
      ["level"] = 31;
      ["name_es"] = "Sopa de tortuga reconfortante";
      ["req"] = 28;
   };
   [7385] = {
      ["name_ru"] = "Галлон крови";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["repgain"] = {
         [76] = 75;
         [729] = 5;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Quelques litres de sang";
      ["name_cn"] = "?盟之血";
      ["name_de"] = "Eine Gallone Blut";
      ["faction"] = "Horde";
      ["name"] = "A Gallon of Blood";
      ["level"] = 60;
      ["name_es"] = "Un galon de sangre";
      ["req"] = 51;
   };
   [3701] = {
      ["name_ru"] = "Дымящиеся руины Тауриссана";
      ["objective"] = "Venture to the Ruins of Thaurissan in the Burning Steppes and recover information from the Thaurissan Relics. Return to Royal Historian Archesonus when you have recovered the information.";
      ["name_cn"] = "索瑞森?墟";
      ["sort"] = "Ironforge";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Les ruines fumantes de Thaurissan";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Die glimmenden Ruinen von Thaurissan";
      ["reward"] = {
         [1] = 12102;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Smoldering Ruins of Thaurissan";
      ["prev"] = 3702;
      ["prequests"] = {
         [1] = 3702;
      };
      ["series"] = 2;
      ["name_es"] = "Las humeantes Ruinas de Thaurissan";
      ["req"] = 50;
   };
   [7481] = {
      ["name_ru"] = "Эльфийские легенды";
      ["type"] = "Dungeon";
      ["objective"] = "Search Dire Maul for Kariel Winthalus. Report back to Sage Korolusk at Camp Mojache with whatever information that you may find.";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "精?的??";
      ["name_fr"] = "Legendes elfiques";
      ["name_de"] = "Elfische Legenden";
      ["faction"] = "Horde";
      ["name"] = "Elven Legends";
      ["level"] = 60;
      ["name_es"] = "Leyendas elficas";
      ["req"] = 54;
   };
   [7497] = {
      ["name_ru"] = "Все еще только начинается!";
      ["type"] = "Solo";
      ["name_fr"] = "Le voyage commence a peine";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "一切才???始";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "The Journey Has Just Begun";
      ["name_de"] = "Die Reise beginnt erst";
      ["prev"] = 7496;
      ["prequests"] = {
         [1] = 7496;
      };
      ["level"] = 60;
      ["name_es"] = "El viaje acaba de empezar";
      ["req"] = 60;
   };
   [3765] = {
      ["name_ru"] = "Проблема за морем";
      ["type"] = "Solo";
      ["objective"] = "Travel to Gershala Nightwhisper in Auberdine.";
      ["next"] = 1275;
      ["name_fr"] = "La depravation au loin";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "遥?的旅途";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Verderbnis in der Fremde";
      ["faction"] = "Alliance";
      ["name"] = "The Corruption Abroad";
      ["level"] = 24;
      ["name_es"] = "Lejana corrupcion";
      ["req"] = 18;
   };
   [3781] = {
      ["name_ru"] = "Изучение рассветницы";
      ["objective"] = "Take the Arch Druid's Seed Voucher to Mathrengyl Bearwalker in the Cenarion Enclave of Darnassus.";
      ["name_cn"] = "晨光麦研究";
      ["sort"] = "Darnassus";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "Recherches sur la fibre d'aurore";
      ["next"] = 3785;
      ["name_de"] = "Morgenkornforschung";
      ["repgain"] = {
         [69] = 10;
      };
      ["reward"] = {
         [1] = 11022;
      };
      ["faction"] = "Alliance";
      ["name"] = "Morrowgrain Research";
      ["prev"] = 3764;
      ["prequests"] = {
         [1] = 3764;
      };
      ["series"] = 1;
      ["name_es"] = "Investigar la managrana";
      ["req"] = 47;
   };
   [3789] = {
      ["name_ru"] = "Помощь верховному друиду Оленьему Шлему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm in Darnassus.";
      ["next"] = 3764;
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "Assister l'archidruide Forteramure";
      ["name_de"] = "Erzdruide Hirschhaupt helfen";
      ["faction"] = "Alliance";
      ["name"] = "Assisting Arch Druid Staghelm";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Corzocelada";
      ["req"] = 47;
   };
   [7625] = {
      ["name_ru"] = "Зоротианская звездная пыль";
      ["type"] = "Solo";
      ["name_fr"] = "Poussiere d'etoile xorothienne";
      ["name_de"] = "Xorothianischer Sternenstaub";
      ["sort"] = "Warlock";
      ["objective"] = "Purchase Xorothian Stardust from Ur'dan.  Bring it to Gorzeeki Wildeyes in the Burning Steppes.";
      ["name_cn"] = "克索?斯星?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Xorothian Stardust";
      ["followup"] = 7629;
      ["prev"] = 7624;
      ["prequests"] = {
         [1] = 7624;
      };
      ["level"] = 60;
      ["name_es"] = "Polvo estelar xorothiano";
      ["req"] = 60;
   };
   [3821] = {
      ["name_ru"] = "Скала Молота Ужаса";
      ["type"] = "Solo";
      ["objective"] = "Venture forth to the Burning Steppes and find out what became of Sha'ni Proudtusk.";
      ["next"] = 3822;
      ["name_fr"] = "Le Rocher des Cognepeurs";
      ["sort"] = "Badlands";
      ["name_cn"] = "巨槌石";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Schreckensfels";
      ["faction"] = "Horde";
      ["name"] = "Dreadmaul Rock";
      ["level"] = 52;
      ["name_es"] = "Roca Machacamiedo";
      ["req"] = 48;
   };
   [7657] = {
      ["name_ru"] = "Императорский латный шлем";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["name_de"] = "Imperialer Plattenhelm";
      ["name_fr"] = "Le heaume imperial en plaques";
      ["name_cn"] = "君王?甲??";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Helm";
      ["reward"] = {
         [1] = 12701;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Yelmo de placas imperiales";
      ["req"] = 50;
   };
   [7673] = {
      ["name_ru"] = "Замена снежного барана";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Echange de belier de givre";
      ["name_cn"] = "更?霜山羊";
      ["reward"] = {
         [1] = 18786;
         [2] = 18787;
         [3] = 18785;
      };
      ["name_de"] = "Austausch Eures Frostwidders";
      ["faction"] = "Alliance";
      ["name"] = "Frost Ram Exchange";
      ["level"] = 1;
      ["name_es"] = "Intercambio de carnero de escarcha";
      ["req"] = 60;
   };
   [3845] = {
      ["name_ru"] = "Тайна, покрытая мраком";
      ["type"] = "Solo";
      ["name_fr"] = "C'est un secret pour tout le monde";
      ["next"] = 3908;
      ["name_de"] = "Es ist fur jeden ein Geheimnis";
      ["name"] = "It's a Secret to Everybody";
      ["name_cn"] = "无人知?的秘密";
      ["objective"] = "Examine the items inside the pack and bring them to their owner.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 3844;
      ["prequests"] = {
         [1] = 3844;
      };
      ["level"] = 52;
      ["name_es"] = "Un secreto bien guardado";
      ["req"] = 47;
   };
   [3861] = {
      ["name_ru"] = "Куд-кудаааа!";
      ["type"] = "Solo";
      ["objective"] = " but you are not sure what it is. Could it be... S-A-L-D-E-A-N? Before you can ask";
      ["sort"] = "Children's Week";
      ["name_cn"] = "???！";
      ["name_fr"] = "COT-COT-CODEC?!";
      ["name_de"] = "GLUCK!";
      ["faction"] = "Alliance";
      ["name"] = "CLUCK!";
      ["level"] = 1;
      ["name_es"] = "!CLOQUEA!";
      ["req"] = 1;
   };
   [7737] = {
      ["name_ru"] = "Завоевать еще большую благосклонность";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 25;
      };
      ["name_de"] = "Noch mehr Anerkennung erlangen";
      ["name_cn"] = "?得信任";
      ["name_fr"] = "Se faire accepter";
      ["name"] = "Gaining Acceptance";
      ["faction"] = "Horde";
      ["sort"] = "Searing Gorge";
      ["prev"] = 7722;
      ["prequests"] = {
         [1] = 7722;
      };
      ["level"] = 60;
      ["name_es"] = "Conseguir mas aceptacion";
      ["req"] = 45;
   };
   [7785] = {
      ["name_ru"] = "Сосуд Возрождения";
      ["type"] = "Solo";
      ["objective"] = "Examine the Vessel of Rebirth and return it to Highlord Demitrian.";
      ["next"] = 7786;
      ["sort"] = "Legendary";
      ["name_cn"] = "?生之瓶";
      ["name_fr"] = "Examiner le Calice";
      ["name_de"] = "Untersuchung des Gefases";
      ["faction"] = "Horde";
      ["name"] = "Examine the Vessel";
      ["level"] = 60;
      ["name_es"] = "Examina la vasija";
      ["req"] = 60;
   };
   [3901] = {
      ["name_ru"] = "Игрушки-погремушки";
      ["type"] = "Solo";
      ["objective"] = "Kill 12 Rattlecage Skeletons, and then return to Shadow Priest Sarvis in Deathknell when you are done.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Klappernde Skelette";
      ["reward"] = {
         [1] = 3274;
         [2] = 11851;
         [3] = 11852;
      };
      ["name_cn"] = "断骨??";
      ["name_fr"] = "Faites cliqueter les thorax?!";
      ["faction"] = "Horde";
      ["name"] = "Rattling the Rattlecages";
      ["sort"] = "Deathknell";
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 3;
      ["name_es"] = "Sacudir esqueletos";
      ["req"] = 1;
   };
   [7817] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 150;
      };
      ["sort"] = "Undercity";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7818;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [7833] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [530] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7836;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [7849] = {
      ["name_ru"] = "Воссоединение останков";
      ["type"] = "Group";
      ["objective"] = "Huntsman Markhor at Revantusk Village in the Hinterlands wants you to recover his twin brother's remains. Find and return Huntsman Malkhor's Skull and Huntsman Malkhor's Bones to Huntsman Markhor.$B$BMarkhor mentioned that his brother's remains were fed to the oozes and wolves of the Vilebranch. He also mentioned that there is a refuse pit filled with oozes in Jintha'alor as well as a wolf den. Both of these places are near the top of the temple.";
      ["name_fr"] = "L’angoisse de la separation";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "分?的痛苦";
      ["reward"] = {
         [1] = 19117;
         [2] = 19116;
      };
      ["name_de"] = "Die getrennten Bruder";
      ["faction"] = "Horde";
      ["name"] = "Separation Anxiety";
      ["level"] = 50;
      ["name_es"] = "Una separacion angustiosa";
      ["req"] = 46;
   };
   [7865] = {
      ["name_ru"] = "Улусшенные припасы часового";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [890] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage ameliore de Sentinelle";
      ["name_cn"] = "哨兵高??理包";
      ["reward"] = {
         [1] = 19152;
      };
      ["name_de"] = "Verbessertes Uberlebenspaket der Schildwache";
      ["faction"] = "Alliance";
      ["name"] = "Sentinel Advanced Care Package";
      ["level"] = 60;
      ["name_es"] = "Botiquin avanzado de centinela";
      ["req"] = 45;
   };
   [7881] = {
      ["name_ru"] = "Тисненые кожаные сапоги";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Des bottes pour les forains";
      ["name_cn"] = "狂???靴";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Jahrmarktsstiefel";
      ["faction"] = "Horde";
      ["name"] = "Carnival Boots";
      ["level"] = 60;
      ["name_es"] = "Las botas de los feriantes";
      ["req"] = 1;
   };
   [7897] = {
      ["name_ru"] = "Автоматические ремонтные наборы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Trousses de reparation mecanique";
      ["name_cn"] = "机械修理包";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mechanische Repariersets";
      ["faction"] = "Horde";
      ["name"] = "Mechanical Repair Kits";
      ["level"] = 60;
      ["name_es"] = "Juegos de herramientas mecanicas de reparacion";
      ["req"] = 30;
   };
   [7929] = {
      ["name_ru"] = "Колода карт Новолуния: Элементали";
      ["type"] = "Solo";
      ["objective"] = " so you will have to wait until they are here next.\"";
      ["repgain"] = {
         [909] = 350;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Suite d'Elementaires de Sombrelune";
      ["name_cn"] = "暗月元素套牌";
      ["reward"] = {
         [1] = 19289;
      };
      ["name_de"] = "Elementarkartenset des Dunkelmond-Jahrmarkts";
      ["faction"] = "Horde";
      ["name"] = "Darkmoon Elementals Deck";
      ["level"] = 55;
      ["name_es"] = "La baraja de Elementales de la Luna Negra";
      ["req"] = 1;
   };
   [7945] = {
      ["name_ru"] = "Ты найдешь свою удачу...";
      ["type"] = "Solo";
      ["objective"] = " you see an image of the Palemane Rock of Mulgore.  Focusing closer in on the image";
      ["repgain"] = {
         [909] = 50;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Une surprise vous attend...";
      ["name_cn"] = "?富在等着?……";
      ["reward"] = {
         [1] = 19425;
      };
      ["name_de"] = "Euer Schicksal erwartet Euch...";
      ["faction"] = "Horde";
      ["name"] = "Your Fortune Awaits You...";
      ["level"] = 60;
      ["name_es"] = "La Fortuna te espera...";
      ["req"] = 10;
   };
   [3981] = {
      ["name_ru"] = "Командир Гор'шак";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le commandant Gor'shak";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Kommandant Gor'shak";
      ["name"] = "Commander Gor'shak";
      ["name_cn"] = "指?官哥沙克";
      ["objective"] = "Find Commander Gor'shak in Blackrock Depths.$B$BYou recall that the crudely drawn picture of the orc included bars drawn over the portrait. Perhaps you should search for a prison of some sort.";
      ["next"] = 3982;
      ["faction"] = "Horde";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 3906;
      ["prequests"] = {
         [1] = 3906;
      };
      ["level"] = 52;
      ["name_es"] = "Comandante Gor'shak";
      ["req"] = 48;
   };
   [4005] = {
      ["name_ru"] = "Аквамонтос";
      ["type"] = "Solo";
      ["name_fr"] = "Aquementas";
      ["next"] = 3961;
      ["name_de"] = "Aquementas";
      ["name_cn"] = "?奎?塔斯";
      ["objective"] = "Take the Book of Aquor, the Silvery Claws, and the Irontree Heart to Tanaris.$B$BUse the Book of Aquor to summon Aquementas.$B$BAfter you have the completed totem, take it to J.D. Collie in Marshal's Refuge.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Aquementas";
      ["prev"] = 4084;
      ["prequests"] = {
         [1] = 4084;
      };
      ["level"] = 54;
      ["name_es"] = "Aquamentas";
      ["req"] = 47;
   };
   [8041] = {
      ["name_ru"] = "Сила горы Мугамба";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La force du mont Mugamba";
      ["name_cn"] = "穆?巴之力";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19574;
      };
      ["name_de"] = "Starke des Bergs Mugamba";
      ["faction"] = "Horde";
      ["name"] = "Strength of Mount Mugamba";
      ["level"] = 60;
      ["name_es"] = "La fuerza del Monte Mugamba";
      ["req"] = 60;
   };
   [8057] = {
      ["name_ru"] = "Знаки Силы: наручи гаруспика";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Stanchion.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BMaywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les brassards d'haruspice";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：占卜??腕";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19840;
      };
      ["name_de"] = "Symbole der Macht: Die Haruspexarmschienen";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Haruspex's Bracers";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los brazales de haruspex";
      ["req"] = 60;
   };
   [8073] = {
      ["name_ru"] = "Знаки Силы: мундир безумца";
      ["type"] = "Raid";
      ["objective"] = "Bring Falthir the Sightless a Primal Hakkari Aegis.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BFalthir the Sightless is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la tunique d'insense";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：狂妄者外套";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19834;
      };
      ["name_de"] = "Symbole der Macht: Die Tunika des Wildfangs";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Madcap's Tunic";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: la guerrera de sinconcierto";
      ["req"] = 60;
   };
   [8105] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the mine, the lumber mill, the blacksmith and the farm, then return to Field Marshal Oslight in Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Alliance";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 55;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 50;
   };
   [8121] = {
      ["name_ru"] = "Захват четырех баз";
      ["type"] = "PvP";
      ["objective"] = "Hold four bases at the same time in Arathi Basin, and then return to Deathmaster Dwire in Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?取四座基地";
      ["name_fr"] = "Prendre quatre bases";
      ["name_de"] = "Erobert vier Stutzpunkte";
      ["faction"] = "Horde";
      ["name"] = "Take Four Bases";
      ["level"] = 60;
      ["name_es"] = "Toma el control de cuatro bases";
      ["req"] = 60;
   };
   [8153] = {
      ["name_ru"] = "Рога и копыта";
      ["type"] = "Solo";
      ["name_fr"] = "La ramure de coursier";
      ["next"] = 8231;
      ["name_de"] = "Gehornte Renner";
      ["objective"] = "Bring a pair of Perfect Courser Antlers to Ogtinc in Azshara.  Ogtinc resides atop the cliffs northeast of the Ruins of Eldarath.";
      ["name_cn"] = "苔蹄快?者的鹿角";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "Courser Antlers";
      ["prev"] = 8151;
      ["prequests"] = {
         [1] = 8151;
      };
      ["level"] = 52;
      ["name_es"] = "Cornamenta de trotador";
      ["req"] = 50;
   };
   [8169] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the Arathi Basin mine, lumber mill, blacksmith and stable, and then return to Deathmaster Dwire in Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Horde";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 45;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 40;
   };
   [8185] = {
      ["name_ru"] = "Печать синкретиста";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 250;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le signe du syncretiste";
      ["name_cn"] = "?和的徽?";
      ["reward"] = {
         [1] = 19783;
      };
      ["name_de"] = "Siegelzeichen des Synkretisten";
      ["faction"] = "Alliance";
      ["name"] = "Syncretist's Sigil";
      ["level"] = 60;
      ["name_es"] = "Sigilo de Sincretista";
      ["req"] = 58;
   };
   [4106] = {
      ["name_ru"] = "Лекарство из оскверненных шкур";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Kurschnerei";
      ["name_fr"] = "Du baume contre des peaux";
      ["name_cn"] = "剥皮??膏";
      ["name"] = "Salve via Skinning";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4101;
      ["prequests"] = {
         [1] = 4101;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desuello";
      ["req"] = 48;
   };
   [4122] = {
      ["name_ru"] = "Грарк Лоркруб";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to the Burning Steppes and find Grark Lorkrub. You recall Lexlort mentioning that he was last seen in a massive Blackrock fortress.$B$BWhen you find Grark Lorkrub, use the Thorium Shackles to bind him and then lead him back through Blackrock Mountain to the Searing Gorge. Lexlort will have his men waiting on the other side to take Grark into custody.$B";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "格拉克・洛克?布";
      ["name_fr"] = "Grark Lorkrub";
      ["name_de"] = "Grark Lorkrub";
      ["faction"] = "Horde";
      ["name"] = "Grark Lorkrub";
      ["level"] = 58;
      ["name_es"] = "Grark Lorkrub";
      ["req"] = 52;
   };
   [1035] = {
      ["name_ru"] = "Зеркало Небес";
      ["type"] = "Solo";
      ["objective"] = "Retrieve a Fallen Moonstone from the Shadethicket Oracle, then bring it to Pelturas in Astranaar.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Der Himmelssturzsee";
      ["reward"] = {
         [1] = 5814;
         [2] = 6722;
         [3] = 17047;
      };
      ["name_cn"] = "?星湖";
      ["name_fr"] = "Le lac Tombeciel";
      ["faction"] = "Alliance";
      ["name"] = "Fallen Sky Lake";
      ["sort"] = "Ashenvale";
      ["prev"] = 1034;
      ["prequests"] = {
         [1] = 1034;
      };
      ["level"] = 30;
      ["name_es"] = "Lago Cielo Estrellado";
      ["req"] = 20;
   };
   [1039] = {
      ["name_ru"] = "Порт в Степях";
      ["type"] = "Solo";
      ["name_fr"] = "Le port des Tarides";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Der Brachlandhafen";
      ["name"] = "The Barrens Port";
      ["name_cn"] = "?瘠之地的港口";
      ["objective"] = "Speak with Wharfmaster Dizzywig in Ratchet.";
      ["next"] = 1040;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1038;
      ["prequests"] = {
         [1] = 1038;
      };
      ["level"] = 30;
      ["name_es"] = "El puerto de Los Baldios";
      ["req"] = 25;
   };
   [1043] = {
      ["name_ru"] = "Коса Элуны";
      ["type"] = "Solo";
      ["name_fr"] = "La Faux d'Elune";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die Sichel von Elune";
      ["name"] = "The Scythe of Elune";
      ["name_cn"] = "月神的?刀";
      ["objective"] = "Look for signs of the Scythe of Elune then return to Jonathan Carevin in Darkshire.";
      ["next"] = 1044;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1042;
      ["prequests"] = {
         [1] = 1042;
      };
      ["level"] = 30;
      ["name_es"] = "La Guadana de Elune";
      ["req"] = 25;
   };
   [1047] = {
      ["name_ru"] = "Новое пограничье";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm at the Cenarion Enclave of Darnassus about the Cenarion Circle's call to explore the frontiers of Kalimdor.";
      ["next"] = 6761;
      ["sort"] = "Darnassus";
      ["name_cn"] = "新的?疆";
      ["name_fr"] = "La nouvelle frontiere";
      ["name_de"] = "Die neue Grenze";
      ["faction"] = "Alliance";
      ["name"] = "The New Frontier";
      ["level"] = 55;
      ["name_es"] = "La nueva frontera";
      ["req"] = 54;
   };
   [1051] = {
      ["name_ru"] = "Месть Воррела";
      ["type"] = "Group";
      ["objective"] = "Return Vorrel Sengutz's wedding ring to Monika Sengutz in Tarren Mill.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Scarlet Monastery";
      ["name_fr"] = "La vengeance de Vorrel";
      ["name_cn"] = "沃瑞?的?仇";
      ["reward"] = {
         [1] = 7750;
         [2] = 7751;
         [3] = 4643;
      };
      ["name_de"] = "Vorrels Rache";
      ["faction"] = "Horde";
      ["name"] = "Vorrel's Revenge";
      ["level"] = 33;
      ["name_es"] = "La venganza de Vorrel";
      ["req"] = 25;
   };
   [8434] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8429;
      ["prequests"] = {
         [1] = 8429;
      };
      ["level"] = 59;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 50;
   };
   [1059] = {
      ["name_ru"] = "Возвращение Обугленной долины";
      ["objective"] = "Travel to Falfindel Waywarder on the border of Thousand Needles and Feralas.";
      ["name_cn"] = "?回焦炭谷";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 27;
      ["type"] = "Solo";
      ["name_fr"] = "A la reconquete du Val calcine";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Die Ruckeroberung des Verbrannten Tals";
      ["reward"] = {
         [1] = 6675;
         [2] = 6676;
      };
      ["faction"] = "Alliance";
      ["name"] = "Reclaiming the Charred Vale";
      ["prev"] = 1057;
      ["prequests"] = {
         [1] = 1057;
      };
      ["series"] = 2;
      ["name_es"] = "La reconquista de La Vega Carbonizada";
      ["req"] = 20;
   };
   [1063] = {
      ["name_ru"] = "Мудрая старуха";
      ["type"] = "Solo";
      ["name_fr"] = "L'Ancienne";
      ["name_de"] = "Die Altestengreisin";
      ["name_cn"] = "?者";
      ["objective"] = "Speak with Magatha in Thunder Bluff.";
      ["sort"] = "Stonetalon Mountains";
      ["faction"] = "Horde";
      ["name"] = "The Elder Crone";
      ["prev"] = 1062;
      ["prequests"] = {
         [1] = 1062;
      };
      ["level"] = 18;
      ["name_es"] = "La bruja anciana";
      ["req"] = 13;
   };
   [4266] = {
      ["name_ru"] = "Благодарность за отвагу";
      ["objective"] = "Speak with Shandris Feathermoon in Feathermoon Stronghold.";
      ["name_cn"] = "羽月将?的?迎";
      ["sort"] = "Feralas";
      ["level"] = 46;
      ["type"] = "Solo";
      ["name_fr"] = "Accueil d'un heros";
      ["next"] = 4267;
      ["name_de"] = "Der Empfang eines Helden";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 500;
      };
      ["reward"] = {
         [1] = 11856;
         [2] = 11857;
      };
      ["name"] = "A Hero's Welcome";
      ["prev"] = 4265;
      ["prequests"] = {
         [1] = 4265;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La bienvenida de un heroe";
      ["req"] = 40;
   };
   [4282] = {
      ["name_ru"] = "Проблеск надежды";
      ["type"] = "Dungeon";
      ["name_fr"] = "Un espoir en lambeaux";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Ein Funken Hoffnung";
      ["name_cn"] = "一?希望";
      ["name"] = "A Shred of Hope";
      ["objective"] = "Return Marshal Windsor's Lost Information.$B$BMarshal Windsor believes that the information is being held by Golem Lord Argelmach and General Angerforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4264;
      ["prequests"] = {
         [1] = 4264;
      };
      ["level"] = 58;
      ["name_es"] = "Una brizna de esperanza";
      ["req"] = 50;
   };
   [4298] = {
      ["name_ru"] = "У вас появился малыш!";
      ["type"] = "Solo";
      ["objective"] = "Speak to Agnar Beastamer in the Hinterlands.";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Elternfreuden";
      ["reward"] = {
         [1] = 11474;
      };
      ["name_cn"] = "?人父母";
      ["name_fr"] = "L'amour d'un parent";
      ["faction"] = "Alliance";
      ["name"] = "Becoming a Parent";
      ["sort"] = "Feralas";
      ["prev"] = 4297;
      ["prequests"] = {
         [1] = 4297;
      };
      ["level"] = 48;
      ["name_es"] = "El amor parental";
      ["req"] = 37;
   };
   [8626] = {
      ["name_ru"] = "Прочные ботинки бойца";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of Life, 5 Stone Scarabs and 5 Bone Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "攻?者的足甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-tibias du Frappeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Fusschutzer des Hetzers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21365;
      };
      ["name"] = "Striker's Footguards";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardapies de asediador";
      ["req"] = 60;
   };
   [1083] = {
      ["name_ru"] = "Разъяренные духи";
      ["type"] = "Solo";
      ["name_fr"] = "Esprits enrages";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Wutende Geister";
      ["followup"] = 1082;
      ["name_cn"] = "怒?";
      ["objective"] = "Bring 8 Smoldering Embers from any of the fire elementals in the Charred Vale to Kaela Shadowspear in Stonetalon.";
      ["faction"] = "Alliance";
      ["name"] = "Enraged Spirits";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1091;
      ["prequests"] = {
         [1] = 1091;
      };
      ["level"] = 26;
      ["name_es"] = "Los espiritus iracundos";
      ["req"] = 20;
   };
   [1087] = {
      ["name_ru"] = "Наследие Кенария";
      ["type"] = "Solo";
      ["objective"] = "Kill 4 Sons of Cenarius, 4 Daughters of Cenarius and 4 Cenarion Botanists for Braelyn Firehand near Sun Rock Retreat.";
      ["next"] = 1088;
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "塞?留斯的??";
      ["name_fr"] = "L'heritage de Cenarius";
      ["name_de"] = "Cenarius' Vermachtnis";
      ["faction"] = "Horde";
      ["name"] = "Cenarius' Legacy";
      ["level"] = 25;
      ["name_es"] = "El legado de Cenarius";
      ["req"] = 20;
   };
   [8722] = {
      ["name_ru"] = "Предок Луговой Ручей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Courresteppe";
      ["name_cn"] = "幽林?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Auenflucht";
      ["faction"] = "Horde";
      ["name"] = "Meadowrun the Elder";
      ["level"] = 60;
      ["name_es"] = "Correpradera el Ancestro";
      ["req"] = 1;
   };
   [1095] = {
      ["name_ru"] = "Дальнейшие указания";
      ["objective"] = "Bring the new orders to Ziz Fizziks in the Stonetalon Mountains.";
      ["name_cn"] = "新的指示";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 27;
      ["type"] = "Solo";
      ["name_fr"] = "D'autres instructions";
      ["next"] = 1096;
      ["name_de"] = "Weitere Instruktionen";
      ["repgain"] = {
         [470] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Further Instructions";
      ["prev"] = 1094;
      ["prequests"] = {
         [1] = 1094;
      };
      ["series"] = 2;
      ["name_es"] = "Mas instrucciones";
      ["req"] = 16;
   };
   [8786] = {
      ["name_ru"] = "Нехватка оружия";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Massive Iron Axes to Merok Longstride at the Orgrimmar Legion camp outside of Hive'Regal.  You must also bring Logistics Task Briefing VI in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Des armes pour le champ de bataille";
      ["name_cn"] = "??上的武器";
      ["reward"] = {
         [1] = 20800;
         [2] = 21386;
      };
      ["name_de"] = "Waffen fur den Feldeinsatz";
      ["faction"] = "Horde";
      ["name"] = "Arms for the Field";
      ["level"] = 60;
      ["name_es"] = "Armas para el campo de batalla";
      ["req"] = 60;
   };
   [1103] = {
      ["name_ru"] = "Зов воды";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["name_de"] = "Ruf des Wassers";
      ["objective"] = "Bring a Water Sapta to Tiev Mordune in Silverpine Forest if you failed to speak to the Minor Manifestation of Water.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 100;
      ["prequests"] = {
         [1] = 100;
      };
      ["level"] = 23;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [8850] = {
      ["name_ru"] = "Тридцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Trente chevalieres pour des fournitures militaires";
      ["name_cn"] = "三十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21513;
      };
      ["name_de"] = "Dreisig Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Alliance";
      ["name"] = "Thirty Signets for War Supplies";
      ["level"] = 60;
      ["name_es"] = "Treinta sellos para los suministros belicos";
      ["req"] = 50;
   };
   [4442] = {
      ["name_ru"] = "Очищение явлено!";
      ["type"] = "Solo";
      ["name_fr"] = "Purifie?!";
      ["name_de"] = "Gelautert!";
      ["reward"] = {
         [1] = 11445;
      };
      ["name_cn"] = "?化！";
      ["objective"] = "Speak to Eridan again in a moment.";
      ["faction"] = "Alliance";
      ["name"] = "Purified!";
      ["sort"] = "Felwood";
      ["prev"] = 4441;
      ["prequests"] = {
         [1] = 4441;
      };
      ["level"] = 54;
      ["name_es"] = "!Purificada!";
      ["req"] = 49;
   };
   [1115] = {
      ["name_ru"] = "Сплетник";
      ["type"] = "Solo";
      ["name_fr"] = "Le marchand de rumeurs";
      ["next"] = 1116;
      ["name_de"] = "Der Geruchteverbreiter";
      ["name_cn"] = "?手的??";
      ["objective"] = "Talk to Krazek in Booty Bay.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "The Rumormonger";
      ["prev"] = 1114;
      ["prequests"] = {
         [1] = 1114;
      };
      ["level"] = 36;
      ["name_es"] = "Rumores";
      ["req"] = 30;
   };
   [8946] = {
      ["name_ru"] = "Доказательство жизни";
      ["type"] = "Solo";
      ["name_fr"] = "Une preuve de vie";
      ["next"] = 8947;
      ["name_de"] = "Lebensbeweis";
      ["name_cn"] = "生命的?据";
      ["objective"] = "Bring Ysida's Locket to Anthion Harmon in Eastern Plaguelands.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Proof of Life";
      ["prev"] = 8945;
      ["prequests"] = {
         [1] = 8945;
      };
      ["level"] = 60;
      ["name_es"] = "Prueba de vida";
      ["req"] = 58;
   };
   [8978] = {
      ["name_ru"] = "Возвращение к Моквару";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Mokvar";
      ["name_de"] = "Ruckkehr zu Mokvar";
      ["name_cn"] = "回到莫克瓦那里";
      ["objective"] = "Return to Mokvar in Orgrimmar with the Extra-Dimensional Ghost Revealer.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "Return to Mokvar";
      ["prev"] = 8928;
      ["prequests"] = {
         [1] = 8928;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Mokvar";
      ["req"] = 58;
   };
   [4506] = {
      ["name_ru"] = "Зараженные саблезубы";
      ["type"] = "Solo";
      ["name_fr"] = "Sabres corrompus";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Verderbte Sabler";
      ["name_cn"] = "被腐?的猫";
      ["name"] = "Corrupted Sabers";
      ["objective"] = "Take Winna's kitten to the corrupted moonwell, release it, then bring it back to Winna.$B$BOnce you have returned to Winna, click on the cat to release it to Winna.";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 4505;
      ["prequests"] = {
         [1] = 4505;
      };
      ["level"] = 54;
      ["name_es"] = "Dientes de sable corruptos";
      ["req"] = 49;
   };
   [1131] = {
      ["name_ru"] = "Сталезуб";
      ["type"] = "Solo";
      ["name_fr"] = "Broie-l'acier";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Stahlbiss";
      ["name_cn"] = "??土狼";
      ["name"] = "Steelsnap";
      ["objective"] = "Bring Steelsnap's Rib to Melor Stonehoof in Thunder Bluff.";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1130;
      ["prequests"] = {
         [1] = 1130;
      };
      ["level"] = 30;
      ["name_es"] = "Metaleador";
      ["req"] = 20;
   };
   [1135] = {
      ["name_ru"] = "Яд из Скального гнездовья";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Highperch Venom Sacs to Fiora Longears in Theramore.";
      ["name_fr"] = "Le venin de Haut-perchoir";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "??双足??的毒?";
      ["reward"] = {
         [1] = 6719;
      };
      ["name_de"] = "Steilhanggift";
      ["faction"] = "Alliance";
      ["name"] = "Highperch Venom";
      ["level"] = 30;
      ["name_es"] = "Glandulas de veneno de Nido Alto";
      ["req"] = 25;
   };
   [1139] = {
      ["name_ru"] = "Утерянные таблички Воли";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Tablet of Will, and return them to Advisor Belgrum in Ironforge.";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Die verlorene Tafel des Willens";
      ["reward"] = {
         [1] = 6723;
      };
      ["name_cn"] = "意志石板";
      ["name_fr"] = "La tablette de volonte";
      ["faction"] = "Alliance";
      ["name"] = "The Lost Tablets of Will";
      ["sort"] = "Uldaman";
      ["prev"] = 762;
      ["prequests"] = {
         [1] = 762;
      };
      ["level"] = 45;
      ["name_es"] = "Las tablillas perdidas de Voluntad";
      ["req"] = 35;
   };
   [1143] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["name"] = "The Tower of Althalaxx";
      ["name_cn"] = "奥?拉克斯之塔";
      ["objective"] = "Kill Athrikus Narassin and bring his head to Balthule Shadowstrike near the Tower of Althalaxx.";
      ["next"] = 981;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 1167;
      ["prequests"] = {
         [1] = 1167;
      };
      ["level"] = 31;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [1147] = {
      ["name_ru"] = "Рой растет";
      ["type"] = "Solo";
      ["objective"] = "Kill 5 Silithid Searchers, 5 Silithid Hive Drones, and 5 Silithid Invaders and return to Moktar Krin in Thousand Needles.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Der Schwarm wachst";
      ["name"] = "The Swarm Grows";
      ["name_cn"] = "?狂的虫群";
      ["name_fr"] = "L'essaim s'agrandit";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1146;
      ["prequests"] = {
         [1] = 1146;
      };
      ["level"] = 35;
      ["name_es"] = "El enjambre crece";
      ["req"] = 29;
   };
   [9202] = {
      ["name_ru"] = "Задание мастера: огромный флакон с лечебным зельем";
      ["type"] = "Solo";
      ["objective"] = "Deliver 20 Major Healing Potions and the Craftsman's Writ - Major Healing Potion - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Potions de soins majeures";
      ["name_cn"] = "工匠文? - 特效治??水";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Erheblicher Heiltrank";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Major Healing Potion";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pocion de sanacion sublime";
      ["req"] = 55;
   };
   [9234] = {
      ["name_ru"] = "Рукавицы ледяной погибели";
      ["type"] = "Raid";
      ["name_fr"] = "Les gantelets plaie-de-glace";
      ["name_de"] = "Eisfluchstulpen";
      ["reward"] = {
         [1] = 22670;
      };
      ["name_cn"] = "冰克?手";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 5 Frozen Runes, 12 Thorium Bars, 2 Arcanite Bars, 2 Essences of Water and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Icebane Gauntlets";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los guanteletes Deliriohelado";
      ["req"] = 60;
   };
   [1159] = {
      ["name_ru"] = "Испытание знаний";
      ["objective"] = "Find Parqual Fintallas in Undercity.";
      ["name_cn"] = "知???";
      ["sort"] = "Thousand Needles";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 1160;
      ["name_de"] = "Test der Lehre";
      ["repgain"] = {
         [68] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Test of Lore";
      ["prev"] = 6627;
      ["prequests"] = {
         [1] = 6627;
      };
      ["series"] = 4;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [9330] = {
      ["name_ru"] = "Похищение пламени Штормграда";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of Stormwind to the Festival Talespinner.";
      ["name_fr"] = "Voler la flamme de Hurlevent";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取暴?城的烈?";
      ["followup"] = 9339;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Sturmwind";
      ["faction"] = "Horde";
      ["name"] = "Stealing Stormwind's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Ventormenta";
      ["req"] = 50;
   };
   [1171] = {
      ["name_ru"] = "Выводок Ониксии";
      ["type"] = "Solo";
      ["name_fr"] = "La portee d'Onyxia";
      ["next"] = 1172;
      ["name_de"] = "Die Brut von Onyxia";
      ["name"] = "The Brood of Onyxia";
      ["name_cn"] = "奥?克希?的血脉";
      ["objective"] = "Speak with Draz'Zilb in Brackenwall Village.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1170;
      ["prequests"] = {
         [1] = 1170;
      };
      ["level"] = 43;
      ["name_es"] = "El linaje de Onyxia";
      ["req"] = 38;
   };
   [1175] = {
      ["name_ru"] = "Помехи на трассе";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Saltstone Basilisks, 10 Saltstone Crystalhides and 6 Saltstone Gazers for Trackmaster Zherin on the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "安全?患";
      ["name_fr"] = "Les cahots de la piste";
      ["name_de"] = "Eine Strasenunebenheit";
      ["faction"] = "Horde";
      ["name"] = "A Bump in the Road";
      ["level"] = 33;
      ["name_es"] = "Un bache en la carretera";
      ["req"] = 28;
   };
   [1179] = {
      ["name_ru"] = "Братья Медноштиф";
      ["type"] = "Solo";
      ["objective"] = "Bring the crate of crash helmets to Wizzle Brassbolts in the Shimmering Flats.";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_fr"] = "Les freres Zeboulon";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "防撞??";
      ["name_de"] = "Die Bruder Kupferbolz";
      ["faction"] = "Alliance";
      ["name"] = "The Brassbolts Brothers";
      ["level"] = 30;
      ["name_es"] = "Los hermanos Pernolaton";
      ["req"] = 28;
   };
   [4730] = {
      ["name_ru"] = "Останки морской твари";
      ["type"] = "Solo";
      ["name_fr"] = "La creature marine echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meereskreatur";
      ["name_cn"] = "?浅的海洋生物";
      ["name"] = "Beached Sea Creature";
      ["objective"] = "Take the Sea Creature Bones to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 16;
      ["name_es"] = "Criatura marina varada";
      ["req"] = 12;
   };
   [1187] = {
      ["name_ru"] = "Доработка Раззерика";
      ["type"] = "Solo";
      ["name_fr"] = "Les trucs de Razzeric";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Razzerics Basteln";
      ["name"] = "Razzeric's Tweaking";
      ["name_cn"] = "拉?瑞克的?整";
      ["objective"] = "Retrieve the Seaforium Booster for Razzeric in the Shimmering Flats.";
      ["next"] = 1188;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1186;
      ["prequests"] = {
         [1] = 1186;
      };
      ["level"] = 41;
      ["name_es"] = "Los ajustes de Razzeric";
      ["req"] = 29;
   };
   [1191] = {
      ["name_ru"] = "Помеха Замека";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "扎米克的困?";
      ["name_fr"] = "La diversion de Zamek";
      ["name_de"] = "Zameks Ablenkungsmanover";
      ["faction"] = "Horde";
      ["name"] = "Zamek's Distraction";
      ["level"] = 41;
      ["name_es"] = "La distraccion de Zamek";
      ["req"] = 29;
   };
   [1195] = {
      ["name_ru"] = "Священное пламя";
      ["type"] = "Solo";
      ["name_fr"] = "La flamme sacree";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Die heilige Flamme";
      ["name_cn"] = "神?之火";
      ["objective"] = "Return a Filled Etched Phial to Zangen Stonehoof in Thunder Bluff.";
      ["next"] = 1196;
      ["sort"] = "Thunder Bluff";
      ["name"] = "The Sacred Flame";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 25;
      ["name_es"] = "La llama sacra";
      ["req"] = 20;
   };
   [1199] = {
      ["name_ru"] = "Наступление сумерек";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 10 Twilight Pendants to Argent Guard Manados in Darnassus.";
      ["repgain"] = {
         [69] = 350;
         [529] = 150;
      };
      ["sort"] = "Blackfathom Deeps";
      ["name_fr"] = "Le crepuscule descend";
      ["name_cn"] = "暮光之?的末日";
      ["reward"] = {
         [1] = 6998;
         [2] = 7000;
      };
      ["name_de"] = "Die Stunde der Finsternis";
      ["faction"] = "Alliance";
      ["name"] = "Twilight Falls";
      ["level"] = 25;
      ["name_es"] = "Cascada Crepuscular";
      ["req"] = 20;
   };
   [4810] = {
      ["name_ru"] = "Возвращение к Тинки";
      ["type"] = "Solo";
      ["objective"] = "Bring Felnok's Package to Tinkee Steamboil in the Burning Steppes.";
      ["repgain"] = {
         [169] = 75;
      };
      ["name_de"] = "Ruckkehr zu Tinkee";
      ["reward"] = {
         [1] = 15862;
         [2] = 15863;
      };
      ["name_cn"] = "返回丁奇身?";
      ["name_fr"] = "Retourner voir Brikolette";
      ["faction"] = "Horde";
      ["name"] = "Return to Tinkee";
      ["sort"] = "Winterspring";
      ["prev"] = 4809;
      ["prequests"] = {
         [1] = 4809;
      };
      ["level"] = 54;
      ["name_es"] = "Regresa junto a Tinkee";
      ["req"] = 50;
   };
   [4842] = {
      ["name_ru"] = "Выяснение причин";
      ["type"] = "Solo";
      ["objective"] = "Follow Donova Snowden's instructions, then report back.";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Sonderbare Quellen";
      ["reward"] = {
         [1] = 15789;
      };
      ["name_cn"] = "奇怪的源?";
      ["name_fr"] = "Sources etranges";
      ["faction"] = "Horde";
      ["name"] = "Strange Sources";
      ["sort"] = "Winterspring";
      ["prev"] = 980;
      ["prequests"] = {
         [1] = 980;
      };
      ["level"] = 56;
      ["name_es"] = "Fuentes extranas";
      ["req"] = 51;
   };
   [1219] = {
      ["name_ru"] = "Орочье донесение";
      ["type"] = "Solo";
      ["objective"] = "Bring the Spy's Report to a Theramore Lieutenant.";
      ["next"] = 1220;
      ["name_fr"] = "Le rapport orc";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?人的?告";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Der Orcbericht";
      ["faction"] = "Alliance";
      ["name"] = "The Orc Report";
      ["level"] = 35;
      ["name_es"] = "El informe orco";
      ["req"] = 30;
   };
   [4906] = {
      ["name_ru"] = "Снова порча!";
      ["type"] = "Solo";
      ["name_fr"] = "Plus de corruption";
      ["name_de"] = "[DEPRECATED] Weitere Verderbnis";
      ["reward"] = {
         [1] = 11875;
      };
      ["name_cn"] = "更深重的堕落";
      ["objective"] = "Eridan Bluewind in Felwood wants you to kill 8 Jadefire Hellcallers, 8 Jadefire Betrayers, 8 Jadefire Tricksters, and Xavaric. Return to Eridan when the task is completed.";
      ["faction"] = "Alliance";
      ["name"] = "Further Corruption";
      ["sort"] = "Felwood";
      ["prev"] = 4421;
      ["prequests"] = {
         [1] = 4421;
      };
      ["level"] = 54;
      ["name_es"] = "Mas corrupcion";
      ["req"] = 49;
   };
   [1239] = {
      ["name_ru"] = "Отрубленная Голова";
      ["type"] = "Solo";
      ["name_fr"] = "La tete coupee";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Der abgetrennte Kopf";
      ["name"] = "The Severed Head";
      ["name_cn"] = "被?下的??";
      ["objective"] = "Bring the Defiant Orc Head to Nazeer Bloodpike in Brackenwall Village.";
      ["next"] = 1240;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1238;
      ["prequests"] = {
         [1] = 1238;
      };
      ["level"] = 35;
      ["name_es"] = "La cabeza cercenada";
      ["req"] = 30;
   };
   [1243] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1244;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Give the Sealed Note to Watcher Backus in Duskwood.";
      ["series"] = 4;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1242;
      ["prequests"] = {
         [1] = 1242;
      };
      ["level"] = 28;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [4986] = {
      ["name_ru"] = "Покрытая письменами дубовая ветвь";
      ["type"] = "Solo";
      ["objective"] = "Based on the magic enchanted within the Glyphed Oaken Branch, its delivery to the Cenarion Circle in Darnassus is the next step the tauren druid sought.  Seek one of the druids there for assistance.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Glyphenverzierter Eichenast";
      ["reward"] = {
         [1] = 15804;
      };
      ["name_cn"] = "雕文橡木枝";
      ["name_fr"] = "La branche de chene glyphee";
      ["faction"] = "Alliance";
      ["name"] = "Glyphed Oaken Branch";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 4985;
      ["prequests"] = {
         [1] = 4985;
      };
      ["level"] = 56;
      ["name_es"] = "Rama de roble con inscripciones";
      ["req"] = 51;
   };
   [5002] = {
      ["name_ru"] = "Донесение Максвелла";
      ["type"] = "Dungeon";
      ["name_fr"] = "Message a Maxwell";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Nachricht an Maxwell";
      ["name"] = "Message to Maxwell";
      ["name_cn"] = "?麦克斯??的消息";
      ["objective"] = "Travel to the Burning Steppes and give Bijou's Information to Marshal Maxwell.";
      ["next"] = 5081;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 5001;
      ["prequests"] = {
         [1] = 5001;
      };
      ["level"] = 59;
      ["name_es"] = "Un mensaje para Maxwell";
      ["req"] = 55;
   };
   [1259] = {
      ["name_ru"] = "Лейтенант Павал Рит";
      ["type"] = "Solo";
      ["name_fr"] = "Le lieutenant Paval Reethe";
      ["next"] = 1285;
      ["name_de"] = "Leutnant Paval Reethe";
      ["name"] = "Lieutenant Paval Reethe";
      ["name_cn"] = "?瓦?・雷瑟上尉";
      ["objective"] = "Find out more about Reethe from Adjutant Tesoran in Theramore.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1252;
      ["prequests"] = {
         [1] = 1252;
      };
      ["level"] = 40;
      ["name_es"] = "Teniente Paval Reethe";
      ["req"] = 30;
   };
   [5050] = {
      ["name_ru"] = "Оберег удачи";
      ["type"] = "Solo";
      ["objective"] = "Return to Janice Felstone in Western Plaguelands her Good Luck Half-Charm.";
      ["next"] = 5051;
      ["name_fr"] = "Charme porte-bonheur";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "好??符";
      ["name"] = "Good Luck Charm";
      ["name_de"] = "Glucksbringer";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 5048;
         [2] = 5049;
      };
      ["level"] = 52;
      ["name_es"] = "Talisman de buena suerte";
      ["req"] = 50;
   };
   [5066] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out Commander Ashlam Valorfist.  His base camp is located at Chillwind Camp, north of the Alterac Mountains.";
      ["next"] = 5092;
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["followup"] = 5092;
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Alliance";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [5082] = {
      ["name_ru"] = "Угроза со стороны Зимней Спячки";
      ["type"] = "Solo";
      ["name_fr"] = "La menace des Tombe-hiver";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Bedrohung durch die Winterfelle";
      ["name_cn"] = "冬泉熊怪的威?";
      ["name"] = "Threat of the Winterfall";
      ["objective"] = "Donova Snowden in Winterspring wants you to kill 8 Winterfall Pathfinders, 8 Winterfall Den Watchers, and 8 Winterfall Totemics.";
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 6603;
      ["prequests"] = {
         [1] = 6603;
      };
      ["level"] = 56;
      ["name_es"] = "La amenaza de los Nevada";
      ["req"] = 52;
   };
   [5098] = {
      ["name_ru"] = "Сторожевые башни";
      ["type"] = "Group";
      ["name_fr"] = "Tout au long des tours de guet";
      ["repgain"] = {
         [67] = 250;
      };
      ["name_de"] = "Turm um Turm";
      ["name_cn"] = "??哨塔";
      ["name"] = "All Along the Watchtowers";
      ["objective"] = "Using the Beacon Torch, mark each tower in Andorhal; you will need to stand in the doorway of the tower to successfully mark it.$B$BOnce all four towers are marked, return the Beacon Torch to High Executor Derrington at the Bulwark, Western Plaguelands.";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5096;
      ["prequests"] = {
         [1] = 5096;
      };
      ["level"] = 56;
      ["name_es"] = "Todas las atalayas";
      ["req"] = 50;
   };
   [1287] = {
      ["name_ru"] = "Дезертиры";
      ["type"] = "Solo";
      ["name_fr"] = "Les deserteurs";
      ["name_de"] = "Die Deserteure";
      ["name"] = "The Deserters";
      ["name_cn"] = "背叛者";
      ["objective"] = "Speak with Captain Garran Vimes in Theramore about Reethe.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1286;
      ["prequests"] = {
         [1] = 1286;
      };
      ["level"] = 38;
      ["name_es"] = "Los desertores";
      ["req"] = 30;
   };
   [5162] = {
      ["name_ru"] = "Гнев синих драконов";
      ["type"] = "Group";
      ["name_fr"] = "La colere du vol bleu";
      ["next"] = 5164;
      ["name_de"] = "Der Zorn des blauen Drachenschwarms";
      ["name"] = "Wrath of the Blue Flight";
      ["name_cn"] = "??之怒";
      ["objective"] = "Speak with Jeziba in the Plaguelands. He resides in Andorhal.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5161;
      ["prequests"] = {
         [1] = 5161;
      };
      ["level"] = 60;
      ["name_es"] = "La colera del Vuelo Azul";
      ["req"] = 57;
   };
   [5210] = {
      ["name_ru"] = "Брат Карлин";
      ["type"] = "Solo";
      ["name_fr"] = "Frere Carlin";
      ["repgain"] = {
         [529] = 75;
      };
      ["name_de"] = "Bruder Carlin";
      ["name"] = "Brother Carlin";
      ["name_cn"] = "?林・雷德?斯";
      ["objective"] = "Bring the Extended Annals of Darrowshire to Carlin Redpath in Eastern Plaguelands.";
      ["next"] = 5181;
      ["faction"] = "Horde";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5154;
      ["prequests"] = {
         [1] = 5154;
      };
      ["level"] = 56;
      ["name_es"] = "Carlin, el hermano de Joseph";
      ["req"] = 50;
   };
   [5226] = {
      ["name_ru"] = "Возвращение в лагерь Промозглого Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au camp du Noroit";
      ["repgain"] = {
         [469] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Zugwindlager";
      ["name_cn"] = "返回冰??";
      ["name"] = "Return to Chillwind Point";
      ["objective"] = "Bring the Filled Gahrron's Withering Bottle to High Priestess MacDonnell at Chillwind Camp, Western Plaguelands.";
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5225;
      ["prequests"] = {
         [1] = 5225;
      };
      ["level"] = 58;
      ["name_es"] = "Regresa al Campamento del Orvallo";
      ["req"] = 50;
   };
   [5242] = {
      ["name_ru"] = "Окончательный удар";
      ["type"] = "Solo";
      ["name_fr"] = "Un coup final";
      ["name_de"] = "Der endgultige Schlag";
      ["reward"] = {
         [1] = 15707;
         [2] = 15708;
         [3] = 15709;
      };
      ["name_cn"] = "最?一?";
      ["objective"] = "Kill Moora and Salia, and bring Shadow Lord Fel'dan's Head to Greta Mosshoof in Felwood.";
      ["faction"] = "Horde";
      ["name"] = "A Final Blow";
      ["sort"] = "Felwood";
      ["prev"] = 5165;
      ["prequests"] = {
         [1] = 5165;
      };
      ["level"] = 58;
      ["name_es"] = "Un golpe final";
      ["req"] = 48;
   };
   [1319] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["next"] = 1320;
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name"] = "The Black Shield";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Show the Blackened Iron Shield to Caz Twosprocket in Theramore.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1253;
      ["prequests"] = {
         [1] = 1253;
      };
      ["level"] = 35;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [1323] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name"] = "The Black Shield";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Talk with Krog in Brackenwall Village.";
      ["series"] = 4;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1322;
      ["prequests"] = {
         [1] = 1322;
      };
      ["level"] = 37;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [5306] = {
      ["name_ru"] = "Змеекамень Пленяющей Духов";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Spire and slay Shadow Hunter Vosh'gajin. Recover Vosh'gajin's Snakestone and return to Kilram.";
      ["name_fr"] = "Pierre du serpent de la chasseresse des ombres";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "沃什加斯的蛇石";
      ["reward"] = {
         [1] = 12821;
      };
      ["name_de"] = "Schlangenstein der Schattenjagerin";
      ["faction"] = "Horde";
      ["name"] = "Snakestone of the Shadow Huntress";
      ["level"] = 60;
      ["name_es"] = "Piedra culebra de la cazadora de las Sombras";
      ["req"] = 50;
   };
   [1339] = {
      ["name_ru"] = "Задание Грозовой Вершины";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mountaineer Stormpike.";
      ["next"] = 1338;
      ["name_fr"] = "La mission du Montagnard Foudrepique";
      ["sort"] = "Loch Modan";
      ["name_cn"] = "巡山人??・雷矛的任?";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Gebirgsjager Sturmlanzes Aufgabe";
      ["faction"] = "Alliance";
      ["name"] = "Mountaineer Stormpike's Task";
      ["level"] = 15;
      ["name_es"] = "La tarea del montaraz Pico Tormenta";
      ["req"] = 9;
   };
   [5386] = {
      ["name_ru"] = "Дорога рыбка к обеду";
      ["type"] = "Solo";
      ["objective"] = "Talk to Jinar'Zillen at Shadowprey Village, and then bring Nataka Longhorn 2 Bloodbelly fish.";
      ["repgain"] = {
         [81] = 150;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "La prise du jour";
      ["name_cn"] = "食?度日";
      ["reward"] = {
         [1] = 3858;
         [2] = 4304;
         [3] = 4338;
      };
      ["name_de"] = "Der Fang des Tages";
      ["faction"] = "Horde";
      ["name"] = "Catch of the Day";
      ["level"] = 37;
      ["name_es"] = "La pesca del dia";
      ["req"] = 32;
   };
   [5402] = {
      ["name_ru"] = "Камни приспешников плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des serviteurs";
      ["name_cn"] = "爪牙的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Dieners";
      ["faction"] = "Alliance";
      ["name"] = "Minion's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del esbirro";
      ["req"] = 50;
   };
   [1359] = {
      ["name_ru"] = "Посылка для Зинг";
      ["type"] = "Solo";
      ["name_fr"] = "Une livraison pour Zinge";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Zinges Lieferung";
      ["name"] = "Zinge's Delivery";
      ["name_cn"] = "?金格的?物";
      ["objective"] = "Bring the Wolf Heart Samples to Apothecary Zinge in the Undercity.";
      ["next"] = 1358;
      ["faction"] = "Horde";
      ["sort"] = "Undercity";
      ["prev"] = 3221;
      ["prequests"] = {
         [1] = 3221;
      };
      ["level"] = 15;
      ["name_es"] = "Una entrega de Zinge";
      ["req"] = 10;
   };
   [1363] = {
      ["name_ru"] = "Задание Мазена";
      ["type"] = "Solo";
      ["objective"] = "Speak with Acolyte Dellis in Stormwind.";
      ["next"] = 1364;
      ["name_fr"] = "Les ordres de Mazen";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "?森的?求";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Mazens Befehl";
      ["faction"] = "Alliance";
      ["name"] = "Mazen's Behest";
      ["level"] = 41;
      ["name_es"] = "La orden de Mazen";
      ["req"] = 37;
   };
   [1367] = {
      ["name_ru"] = "Союз с племенем Маграм";
      ["type"] = "Solo";
      ["objective"] = "Gain a Friendly reputation with the Magram, then speak with Warug.";
      ["next"] = 1369;
      ["name_fr"] = "L'alliance avec les Magram";
      ["sort"] = "Desolace";
      ["name_cn"] = "?格拉姆部族";
      ["followup"] = 1369;
      ["repgain"] = {
         [93] = 250;
      };
      ["name_de"] = "Allianz mit den Magram";
      ["faction"] = "Horde";
      ["name"] = "Magram Alliance";
      ["level"] = 33;
      ["name_es"] = "La alianza con los Magram";
      ["req"] = 30;
   };
   [5482] = {
      ["name_ru"] = "Погибельник";
      ["type"] = "Solo";
      ["name_fr"] = "Herbe malefique";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Verdammniskraut";
      ["name_cn"] = "末日草";
      ["name"] = "Doom Weed";
      ["objective"] = "Collect 10 Doom Weed and deliver them back to Junior Apothecary Holland.$B";
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 5481;
      ["prequests"] = {
         [1] = 5481;
      };
      ["level"] = 6;
      ["name_es"] = "Apocaliseas";
      ["req"] = 5;
   };
   [1375] = {
      ["name_ru"] = "Вождь Шак";
      ["type"] = "Solo";
      ["name_fr"] = "Khan Shaka";
      ["next"] = 1381;
      ["name_de"] = "Khan Shaka";
      ["name_cn"] = "沙?可汗";
      ["objective"] = "Maintain your reputation with the Magram, and bring the Head of Khan Shaka to Warug in the Magram Village in Desolace.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "Khan Shaka";
      ["prev"] = 1371;
      ["prequests"] = {
         [1] = 1371;
      };
      ["level"] = 37;
      ["name_es"] = "Khan Shaka";
      ["req"] = 30;
   };
   [5514] = {
      ["name_ru"] = "Форма денег стоит";
      ["type"] = "Solo";
      ["name_fr"] = "A la peche au moule…";
      ["next"] = 5802;
      ["name_de"] = "Sold reimt sich auf...";
      ["name_cn"] = "昂?的模具";
      ["objective"] = "Bring the Imbued Skeletal Fragments and 15 gold coins to Krinkle Goodsteel in Gadgetzan.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Mold Rhymes With...";
      ["prev"] = 964;
      ["prequests"] = {
         [1] = 964;
      };
      ["level"] = 57;
      ["name_es"] = "Molde rima con... ?oro?";
      ["req"] = 55;
   };
   [1383] = {
      ["name_ru"] = "Правда и только правда";
      ["objective"] = "Apothecary Faustin at Beggar's Haunt needs 5 Shadow Panther Hearts, Mire Lord Fungus and a Deep Strider Tumor.";
      ["name_cn"] = "真言?水";
      ["sort"] = "Duskwood";
      ["level"] = 42;
      ["type"] = "Group";
      ["name_fr"] = "La verite, rien que la verite";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Nichts als die Wahrheit";
      ["reward"] = {
         [1] = 6832;
         [2] = 11265;
      };
      ["faction"] = "Horde";
      ["name"] = "Nothing But The Truth";
      ["prev"] = 1372;
      ["prequests"] = {
         [1] = 1372;
      };
      ["series"] = 2;
      ["name_es"] = "El suero de la verdad";
      ["req"] = 37;
   };
   [1387] = {
      ["name_ru"] = "Награда за кентавров";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Centaur Ears to Corporal Melkins at Nijel's Point in Desolace.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "La prime aux centaures";
      ["name_cn"] = "??半人?";
      ["reward"] = {
         [1] = 6790;
      };
      ["name_de"] = "Zentaurenkopfgeld";
      ["faction"] = "Alliance";
      ["name"] = "Centaur Bounty";
      ["level"] = 31;
      ["name_es"] = "Coleccion de orejas";
      ["req"] = 30;
   };
   [1391] = {
      ["name_ru"] = "Правда и только правда";
      ["type"] = "Solo";
      ["name_fr"] = "La verite, rien que la verite";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Nichts als die Wahrheit";
      ["name_cn"] = "真言?水";
      ["name"] = "Nothing But The Truth";
      ["objective"] = "Take Zraedus's Brew to Infiltrator Marksen in Stonard.";
      ["faction"] = "Horde";
      ["sort"] = "Duskwood";
      ["prev"] = 1388;
      ["prequests"] = {
         [1] = 1388;
      };
      ["level"] = 42;
      ["name_es"] = "El suero de la verdad";
      ["req"] = 37;
   };
   [1395] = {
      ["name_ru"] = "Поставки для Стражей Пустоты";
      ["type"] = "Solo";
      ["name_fr"] = "Fournitures pour Rempart-du-Neant";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Vorrate fur Nethergarde";
      ["name_cn"] = "守望堡的物?";
      ["name"] = "Supplies for Nethergarde";
      ["objective"] = "Bring the Crate of Powerstones to Quartermaster Lungertz, before the powerstones expire.";
      ["faction"] = "Alliance";
      ["sort"] = "Duskwood";
      ["prev"] = 1477;
      ["prequests"] = {
         [1] = 1477;
      };
      ["level"] = 45;
      ["name_es"] = "Suministros para Nethergarde";
      ["req"] = 40;
   };
   [5626] = {
      ["name_ru"] = "Во имя Света";
      ["type"] = "Solo";
      ["objective"] = "Speak to Maxan Anvol in Dun Morogh.";
      ["next"] = 5625;
      ["name_de"] = "Dem Licht geneigt";
      ["sort"] = "Priest";
      ["name_cn"] = "?光的恩?";
      ["name_fr"] = "Au service de la Lumiere";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "In Favor of the Light";
      ["level"] = 4;
      ["name_es"] = "Al servicio de la Luz";
      ["req"] = 5;
   };
   [5642] = {
      ["name_ru"] = "Страж Тьмы";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Schattenwache";
      ["sort"] = "Priest";
      ["name_cn"] = "暗影守?";
      ["name_fr"] = "Garde des tenebres";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Shadowguard";
      ["level"] = 20;
      ["name_es"] = "Guardia de las Sombras";
      ["req"] = 20;
   };
   [5658] = {
      ["name_ru"] = "Прикосновение слабости";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["sort"] = "Priest";
      ["name_fr"] = "Toucher de faiblesse";
      ["name_cn"] = "虚弱之触";
      ["name_de"] = "Beruhrung der Schwache";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Touch of Weakness";
      ["level"] = 10;
      ["name_es"] = "Toque de debilidad";
      ["req"] = 10;
   };
   [1419] = {
      ["name_ru"] = "Койоты-воры";
      ["type"] = "Solo";
      ["objective"] = "Bring 30 Coyote Jawbones to Neeka Bloodscar in Kargath.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Les coyotes voleurs";
      ["sort"] = "Badlands";
      ["name_cn"] = "捕?山狗";
      ["name_de"] = "Kojoten-Diebe";
      ["faction"] = "Horde";
      ["name"] = "Coyote Thieves";
      ["level"] = 40;
      ["name_es"] = "Ladrones coyote";
      ["req"] = 30;
   };
   [1423] = {
      ["name_ru"] = "Потерянные припасы";
      ["type"] = "Solo";
      ["objective"] = "Bring the Lost Supplies to Quartermaster Lungertz.";
      ["repgain"] = {
         [72] = 25;
      };
      ["sort"] = "Swamp of Sorrows";
      ["name_fr"] = "Les marchandises perdues";
      ["name_cn"] = "?失的??品";
      ["reward"] = {
         [1] = 6827;
      };
      ["name_de"] = "Die verlorenen Vorrate";
      ["faction"] = "Alliance";
      ["name"] = "The Lost Supplies";
      ["level"] = 40;
      ["name_es"] = "Los suministros perdidos";
      ["req"] = 30;
   };
   [1427] = {
      ["name_ru"] = "Угроза с моря";
      ["objective"] = "Speak with Tok'Kar in the Swamp of Sorrows.";
      ["name_cn"] = "海中的威?";
      ["sort"] = "Swamp of Sorrows";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Le danger venu des flots";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Gefahr aus dem Meer";
      ["reward"] = {
         [1] = 9680;
         [2] = 9678;
         [3] = 9679;
      };
      ["faction"] = "Horde";
      ["name"] = "Threat From the Sea";
      ["prev"] = 1426;
      ["prequests"] = {
         [1] = 1426;
      };
      ["series"] = 3;
      ["name_es"] = "La amenaza maritima";
      ["req"] = 35;
   };
   [1431] = {
      ["name_ru"] = "Отношения с Альянсом";
      ["type"] = "Solo";
      ["name_fr"] = "Les relations de l'Alliance";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Allianzbeziehungen";
      ["name_cn"] = "?盟?系";
      ["objective"] = "Speak to Keldran in Orgrimmar.";
      ["next"] = 1432;
      ["sort"] = "Orgrimmar";
      ["name"] = "Alliance Relations";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 30;
      ["name_es"] = "Las relaciones de la Alianza";
      ["req"] = 30;
   };
   [1435] = {
      ["name_ru"] = "Сжигание душ";
      ["type"] = "Solo";
      ["name_fr"] = "Esprits consumes";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Brennender Geist";
      ["name_cn"] = "?魂的燃?";
      ["name"] = "The Burning of Spirits";
      ["objective"] = "Return the Burning Gem and 15 Infused Burning Gems to Maurin Bonesplitter in Desolace.";
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 1433;
      ["prequests"] = {
         [1] = 1433;
      };
      ["level"] = 33;
      ["name_es"] = "Los espiritus ardientes";
      ["req"] = 25;
   };
   [1439] = {
      ["name_ru"] = "Поиски Тираниса";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de Tyranis";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Suche nach Tyranis";
      ["name_cn"] = "?找泰拉尼斯";
      ["name"] = "Search for Tyranis";
      ["objective"] = "Find Tyranis Malem in Desolace.";
      ["faction"] = "Alliance";
      ["sort"] = "Desolace";
      ["prev"] = 1438;
      ["prequests"] = {
         [1] = 1438;
      };
      ["level"] = 33;
      ["name_es"] = "Buscando a Tyranis";
      ["req"] = 30;
   };
   [1447] = {
      ["name_ru"] = "Пропавший дипломат";
      ["objective"] = "Defeat Dashel Stonefist in Stormwind.";
      ["name_cn"] = "失踪的使?";
      ["sort"] = "Stormwind City";
      ["level"] = 31;
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1247;
      ["name_de"] = "Der vermisste Diplomat";
      ["repgain"] = {
         [72] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Missing Diplomat";
      ["prev"] = 1246;
      ["prequests"] = {
         [1] = 1246;
      };
      ["series"] = 8;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1451] = {
      ["name_ru"] = "Рапсод Землекоп";
      ["type"] = "Solo";
      ["name_fr"] = "Rhapsody Croquejarret";
      ["next"] = 1452;
      ["name_de"] = "Rhapsodie Kniegraber";
      ["name_cn"] = "拉普索迪・??";
      ["objective"] = "Seek out Rhapsody Shindigger in The Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Alliance";
      ["name"] = "Rhapsody Shindigger";
      ["prev"] = 1450;
      ["prequests"] = {
         [1] = 1450;
      };
      ["level"] = 43;
      ["name_es"] = "Rapsodio Machacacanillas";
      ["req"] = 38;
   };
   [1455] = {
      ["name_ru"] = "Пожитки Карнитола";
      ["objective"] = "Return to Kreldig Ungor in Desolace.";
      ["name_cn"] = "?尼托的海?";
      ["sort"] = "Desolace";
      ["level"] = 39;
      ["type"] = "Solo";
      ["name_fr"] = "L'epave de Karnitol";
      ["next"] = 1456;
      ["name_de"] = "Karnitols Schiffbruch";
      ["repgain"] = {
         [47] = 75;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Karnitol Shipwreck";
      ["prev"] = 1454;
      ["prequests"] = {
         [1] = 1454;
      };
      ["series"] = 2;
      ["name_es"] = "El naufragio de Karnitol";
      ["req"] = 30;
   };
   [1459] = {
      ["name_ru"] = "Реагенты для Поисковой корпорации";
      ["objective"] = "Bring 7 vials of Scorpashi Venom and 3 Aged Kodo Hides to Kreldig Ungor in Desolace.";
      ["name_cn"] = "?物公司的委托";
      ["sort"] = "Desolace";
      ["level"] = 35;
      ["type"] = "Solo";
      ["name_fr"] = "Des reactifs pour Recuperateurs SA";
      ["next"] = 1466;
      ["name_de"] = "Reagenzien fur die Wiederholer AG";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Reagents for Reclaimers Inc.";
      ["prev"] = 1458;
      ["prequests"] = {
         [1] = 1458;
      };
      ["series"] = 2;
      ["name_es"] = "Componentes para Recuperadores S.A.";
      ["req"] = 30;
   };
   [1463] = {
      ["name_ru"] = "Сапта земли";
      ["type"] = "Solo";
      ["objective"] = "Speak to Canaga Earthcaller for another Earth Sapta.";
      ["name_fr"] = "Le sapta de terre";
      ["sort"] = "Shaman";
      ["name_cn"] = "大地?契";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 6635;
      };
      ["name_de"] = "Erdsapta";
      ["faction"] = "Horde";
      ["name"] = "Earth Sapta";
      ["level"] = 4;
      ["name_es"] = "Sapta de tierra";
      ["req"] = 4;
   };
   [1467] = {
      ["name_ru"] = "Реагенты для Поисковой корпорации";
      ["objective"] = "Bring Leftwitch's Package back to Roetten Stonehammer in Ironforge.";
      ["name_cn"] = "?物公司的委托";
      ["sort"] = "Desolace";
      ["level"] = 40;
      ["type"] = "Solo";
      ["name_fr"] = "Des reactifs pour Recuperateurs SA";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Reagenzien fur die Wiederholer AG";
      ["reward"] = {
         [1] = 6793;
         [2] = 6794;
      };
      ["faction"] = "Alliance";
      ["name"] = "Reagents for Reclaimers Inc.";
      ["prev"] = 1466;
      ["prequests"] = {
         [1] = 1466;
      };
      ["series"] = 4;
      ["name_es"] = "Componentes para Recuperadores S.A.";
      ["req"] = 30;
   };
   [5882] = {
      ["name_ru"] = "Лекарство из охотничьих трофеев";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Jagd";
      ["name_fr"] = "Du baume en chassant";
      ["name_cn"] = "狩???膏";
      ["name"] = "Salve via Hunting";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4102;
      ["prequests"] = {
         [1] = 4102;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por caza";
      ["req"] = 48;
   };
   [1475] = {
      ["name_ru"] = "В Храме Атал'Хаккара";
      ["type"] = "Dungeon";
      ["objective"] = "Gather 10 Atal'ai Tablets for Brohann Caskbelly in Stormwind.";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Im Tempel von Atal'Hakkar";
      ["reward"] = {
         [1] = 1490;
      };
      ["name_cn"] = "?入阿塔哈?神?";
      ["name_fr"] = "Dans le temple d'Atal'Hakkar";
      ["faction"] = "Alliance";
      ["name"] = "Into The Temple of Atal'Hakkar";
      ["sort"] = "Sunken Temple";
      ["prev"] = 1469;
      ["prequests"] = {
         [1] = 1469;
      };
      ["level"] = 50;
      ["name_es"] = "En El Templo de Atal'Hakkar";
      ["req"] = 41;
   };
   [1479] = {
      ["name_ru"] = "Купина Вечности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Rameau des Eternels";
      ["repgain"] = {
         [469] = 75;
      };
      ["name_de"] = "Der Baum der Ewigen";
      ["name_cn"] = "永恒之?";
      ["name"] = "The Bough of the Eternals";
      ["objective"] = "Take the orphan to the bank of Darnassus.  The bank itself is hollowed out of a tree known as the Bough of the Eternals.";
      ["faction"] = "Alliance";
      ["sort"] = "Children's Week";
      ["prev"] = 1468;
      ["prequests"] = {
         [1] = 1468;
      };
      ["level"] = 60;
      ["name_es"] = "La Rama de los Eternos";
      ["req"] = 10;
   };
   [1483] = {
      ["name_ru"] = "Зиз Физзикс";
      ["type"] = "Solo";
      ["objective"] = "Speak with Ziz Fizziks in Windshear Crag.";
      ["next"] = 1093;
      ["name_fr"] = "Ziz Fizzik";
      ["sort"] = "The Barrens";
      ["name_cn"] = "菲?克斯";
      ["repgain"] = {
         [470] = 25;
      };
      ["name_de"] = "Ziz Fizziks";
      ["faction"] = "Horde";
      ["name"] = "Ziz Fizziks";
      ["level"] = 21;
      ["name_es"] = "Ziz Fizziks";
      ["req"] = 16;
   };
   [1487] = {
      ["name_ru"] = "Искоренение Скверны";
      ["type"] = "Dungeon";
      ["objective"] = "Ebru in the Wailing Caverns wants you to kill 7 Deviate Ravagers, 7 Deviate Vipers, 7 Deviate Shamblers and 7 Deviate Dreadfangs.";
      ["name_fr"] = "L'eradication des deviants";
      ["sort"] = "Wailing Caverns";
      ["name_cn"] = "清除??者";
      ["reward"] = {
         [1] = 6476;
         [2] = 8071;
         [3] = 6481;
      };
      ["name_de"] = "Ausrottung der Deviat";
      ["faction"] = "Horde";
      ["name"] = "Deviate Eradication";
      ["level"] = 21;
      ["name_es"] = "Erradicacion de descarriados";
      ["req"] = 15;
   };
   [1491] = {
      ["name_ru"] = "Умный напиток";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les potions d'intelligence";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Klugheitstranke";
      ["name_cn"] = "智慧?料";
      ["name"] = "Smart Drinks";
      ["objective"] = "Bring 6 portions of Wailing Essence to Mebok Mizzyrix in Ratchet.";
      ["faction"] = "Horde";
      ["sort"] = "Wailing Caverns";
      ["prev"] = 865;
      ["prequests"] = {
         [1] = 865;
      };
      ["level"] = 18;
      ["name_es"] = "Bebidas de inteligencia";
      ["req"] = 13;
   };
   [1499] = {
      ["name_ru"] = "Злобные фамильяры";
      ["objective"] = "Speak with Zureetha Fargaze.";
      ["name_cn"] = "邪?劣魔";
      ["followup"] = 794;
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "Les vils quasits";
      ["next"] = 794;
      ["name_de"] = "Uble Familiare";
      ["sort"] = "Warlock";
      ["repgain"] = {
         [530] = 10;
         [76] = 10;
      };
      ["reward"] = {
         [1] = 4925;
         [2] = 5778;
      };
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Vile Familiars";
      ["prev"] = 1485;
      ["prequests"] = {
         [1] = 1485;
      };
      ["series"] = 2;
      ["name_es"] = "Familiares viles";
      ["req"] = 1;
   };
   [1503] = {
      ["name_ru"] = "Стальные слитки";
      ["type"] = "Solo";
      ["name_fr"] = "Acier forge";
      ["name_de"] = "Geschmiedeter Stahl";
      ["objective"] = "Bring the Forged Steel Bars to Thun'grim Firegaze in the Barrens.";
      ["reward"] = {
         [1] = 7326;
         [2] = 7328;
         [3] = 7327;
         [4] = 7329;
      };
      ["name_cn"] = "?造好的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Forged Steel";
      ["sort"] = "Warrior";
      ["prev"] = 1502;
      ["prequests"] = {
         [1] = 1502;
      };
      ["level"] = 10;
      ["name_es"] = "Acero fundido";
      ["req"] = 10;
   };
   [6026] = {
      ["name_ru"] = "Работу пополам";
      ["type"] = "Solo";
      ["objective"] = "Smokey LaRue wants you to get 2 Thorium Bars, 1 Golden Rod, 8 Hi-Explosive Bombs, and 8 Unstable Triggers.$B$BYou will have to find a blacksmith and an engineer for these items.";
      ["next"] = 6041;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?子大?口";
      ["name_fr"] = "Voila qui est beaucoup demander";
      ["name_de"] = "Das ist viel verlangt";
      ["faction"] = "Horde";
      ["name"] = "That's Asking A Lot";
      ["level"] = 58;
      ["name_es"] = "Eso pide mucho";
      ["req"] = 54;
   };
   [6042] = {
      ["name_ru"] = "Мелочи нежизни";
      ["type"] = "Solo";
      ["objective"] = "Slay 20 Noxious Plaguebats and 10 Monstrous Plaguebats. Return to Nathanos Blightcaller when you are finished.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Les petits soucis de la non-vie";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "??的蝙蝠";
      ["name_de"] = "Die kleinen Argernisse des Un-Lebens";
      ["faction"] = "Horde";
      ["name"] = "Un-Life's Little Annoyances";
      ["level"] = 58;
      ["name_es"] = "Los pequenos problemas de la no-vida";
      ["req"] = 54;
   };
   [1515] = {
      ["name_ru"] = "Догран в плену";
      ["type"] = "Solo";
      ["name_fr"] = "La captivite de Dogran";
      ["next"] = 1512;
      ["name_de"] = "Dograns Gefangenschaft";
      ["objective"] = "Bring Ken'zigla's Draught to Dogran in the Barrens.";
      ["name_cn"] = "多格?之囚";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Dogran's Captivity";
      ["prev"] = 1511;
      ["prequests"] = {
         [1] = 1511;
      };
      ["level"] = 20;
      ["name_es"] = "El cautiverio de Dogran";
      ["req"] = 20;
   };
   [1519] = {
      ["name_ru"] = "Зов Земли";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de la terre";
      ["next"] = 1520;
      ["name_de"] = "Ruf der Erde";
      ["name_cn"] = "大地的召?";
      ["objective"] = "Bring 2 applications of Ritual Salve to Seer Ravenfeather in Camp Narache.";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["sort"] = "Shaman";
      ["name"] = "Call of Earth";
      ["series"] = 1;
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 4;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [1523] = {
      ["name_ru"] = "Зов Огня";
      ["type"] = "Solo";
      ["objective"] = "Find Kranal Fiss in the Barrens.";
      ["next"] = 1524;
      ["sort"] = "Shaman";
      ["name_cn"] = "火?的召?";
      ["name_fr"] = "L'appel du feu";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1524;
      ["name_de"] = "Ruf des Feuers";
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["level"] = 10;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [1527] = {
      ["name_ru"] = "Зов Огня";
      ["objective"] = "Bring the Torch of Eternal Flame to Kranal Fiss in the Barrens.";
      ["name_cn"] = "火?的召?";
      ["sort"] = "Shaman";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du feu";
      ["name_de"] = "Ruf des Feuers";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 5176;
      };
      ["name"] = "Call of Fire";
      ["prev"] = 1526;
      ["prequests"] = {
         [1] = 1526;
      };
      ["series"] = 4;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [1531] = {
      ["name_ru"] = "Зов Воздуха";
      ["type"] = "Solo";
      ["objective"] = "Find Prate Cloudseer in Thousand Needles.";
      ["name_fr"] = "L'appel de l'air";
      ["sort"] = "Shaman";
      ["name_cn"] = "空气的召?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 5178;
      };
      ["name_de"] = "Ruf der Luft";
      ["faction"] = "Horde";
      ["name"] = "Call of Air";
      ["level"] = 30;
      ["name_es"] = "La llamada del aire";
      ["req"] = 30;
   };
   [1535] = {
      ["name_ru"] = "Зов Воды";
      ["objective"] = "Fill the Empty Brown Waterskin at the watering hole below Brine's hut and return it to her in the Barrens.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 1536;
      ["name_de"] = "Ruf des Wassers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 1530;
      ["prequests"] = {
         [1] = 1530;
      };
      ["series"] = 2;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [8243] = {
      ["name_ru"] = "Напиток могущества Занзы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [270] = 50;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Puissants breuvages de Zanza";
      ["name_cn"] = "?扎的?料";
      ["reward"] = {
         [1] = 20080;
         [2] = 20079;
         [3] = 20081;
      };
      ["name_de"] = "Zanzas wirksame Tranke";
      ["faction"] = "Horde";
      ["name"] = "Zanza's Potent Potables";
      ["level"] = 60;
      ["name_es"] = "Los mejunjes potentes de Zanza";
      ["req"] = 58;
   };
   [6186] = {
      ["name_ru"] = "Пришествие Гнили";
      ["type"] = "Group";
      ["name_fr"] = "La venue du Fletrisseur";
      ["next"] = 6187;
      ["name_de"] = "Der Pestrufer kommt";
      ["name_cn"] = "凋零者";
      ["objective"] = "Return to Stormwind and inform Highlord Bolvar Fordragon of the fate of Nathanos Marris.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "The Blightcaller Cometh";
      ["prev"] = 6185;
      ["prequests"] = {
         [1] = 6185;
      };
      ["level"] = 60;
      ["name_es"] = "El regreso de Clamanublo";
      ["req"] = 56;
   };
   [8307] = {
      ["name_ru"] = "Блюдо из червей";
      ["type"] = "Solo";
      ["objective"] = "Look for information about cooking Sandworm Meat at the Twilight's Hammer camp west of Cenarion Hold.";
      ["next"] = 8313;
      ["name_fr"] = "Recette du desert";
      ["sort"] = "Cooking";
      ["name_cn"] = "沙漠食?";
      ["repgain"] = {
         [609] = 10;
      };
      ["name_de"] = "Wustenrezept";
      ["faction"] = "Horde";
      ["name"] = "Desert Recipe";
      ["level"] = 57;
      ["name_es"] = "Receta del desierto";
      ["req"] = 54;
   };
   [1559] = {
      ["name_ru"] = "Секрет изготовления световой бомбы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Engineering";
      ["name_fr"] = "La recette de la bombe eclairante";
      ["name_cn"] = "?光?的制法";
      ["reward"] = {
         [1] = 6672;
      };
      ["name_de"] = "Blitzbombenanleitung";
      ["faction"] = "Horde";
      ["name"] = "Flash Bomb Recipe";
      ["level"] = 37;
      ["name_es"] = "Receta de bomba cegadora";
      ["req"] = 30;
   };
   [8403] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "自然屏障";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 60;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 60;
   };
   [8435] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8430;
      ["prequests"] = {
         [1] = 8430;
      };
      ["level"] = 60;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 60;
   };
   [8467] = {
      ["name_ru"] = "Перья для Нафиэна";
      ["type"] = "Solo";
      ["objective"] = "Some of the Deadwood furbolgs wear a distinctive headdress that may be used as a means of proof in thinning their numbers. Bring me a feather from any headdresses you acquire; for every set of five you bring me, you will earn recognition amongst the Timbermaw.";
      ["repgain"] = {
         [576] = 75;
      };
      ["name_de"] = "Federn fur Nafien";
      ["name_cn"] = "??菲恩的羽毛";
      ["name_fr"] = "Des plumes pour Nafien";
      ["name"] = "Feathers for Nafien";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 8461;
      ["prequests"] = {
         [1] = 8461;
      };
      ["level"] = 55;
      ["name_es"] = "Plumas para Nafien";
      ["req"] = 45;
   };
   [8499] = {
      ["name_ru"] = "Альянсу не хватает ториевых слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Thorium Bars to Dame Twinbraid at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de barres de thorium?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要瑟??！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_de"] = "Die Allianz braucht Thoriumbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Thorium Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita barras de torio!";
      ["req"] = 48;
   };
   [1579] = {
      ["name_ru"] = "Суперразъемы";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Gaffer Jacks to Wizbang Cranktoggle in Auberdine.";
      ["next"] = 1580;
      ["name_fr"] = "Rouages electriques";
      ["sort"] = "Fishing";
      ["name_cn"] = "小??";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Klemmmuffen";
      ["faction"] = "Alliance";
      ["name"] = "Gaffer Jacks";
      ["level"] = 12;
      ["name_es"] = "Mecanismos electricos";
      ["req"] = 10;
   };
   [8595] = {
      ["name_ru"] = "Поборники правого дела из числа смертных";
      ["type"] = "Raid";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 500;
         [609] = 100;
      };
      ["name_de"] = "Sterbliche Helden";
      ["name_cn"] = "凡人中的勇士";
      ["name_fr"] = "Champions mortels";
      ["name"] = "Mortal Champions";
      ["faction"] = "Horde";
      ["sort"] = "Ahn'Qiraj";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["level"] = 60;
      ["name_es"] = "Campeones mortales";
      ["req"] = 60;
   };
   [8627] = {
      ["name_ru"] = "Кираса Мстителя";
      ["objective"] = "Bring the the Carapace of the Old God, 2 Idols of the Sage, 5 Silver Scarabs and 5 Bone Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?仇者的胸甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La cuirasse du Vengeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Brustplatte des Rachers";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21389;
      };
      ["name"] = "Avenger's Breastplate";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La coraza del Vengador";
      ["req"] = 60;
   };
   [8659] = {
      ["name_ru"] = "Наплечье Бойца";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of War, 5 Crystal Scarabs and 5 Ivory Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "攻?者的?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les espauliers du Frappeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schulterstucke des Hetzers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21367;
      };
      ["name"] = "Striker's Pauldrons";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los espaldares de asediador";
      ["req"] = 60;
   };
   [8691] = {
      ["name_ru"] = "Пелерина Погребенных тайн";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Martial Drape, 2 Alabaster Idols, 5 Stone Scarabs and 5 Crystal Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le drape des secrets scelles";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "魔法秘密披?";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21415;
      };
      ["name_de"] = "Tuch der behuteten Geheimnisse";
      ["faction"] = "Horde";
      ["name"] = "Drape of Vaulted Secrets";
      ["level"] = 60;
      ["name_es"] = "El manton de secretos oscuros";
      ["req"] = 60;
   };
   [8723] = {
      ["name_ru"] = "Предок Ночной Ветер";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Ventenuit";
      ["name_cn"] = "夜??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Nachtwind";
      ["faction"] = "Horde";
      ["name"] = "Nightwind the Elder";
      ["level"] = 60;
      ["name_es"] = "Nochebrisa el Ancestro";
      ["req"] = 1;
   };
   [8755] = {
      ["name_ru"] = "Путь победителя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Eroberers";
      ["name_fr"] = "La voie du Conquerant";
      ["name_cn"] = "征服者之路";
      ["name"] = "The Path of the Conqueror";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21204;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8754;
      ["prequests"] = {
         [1] = 8754;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del conquistador";
      ["req"] = 60;
   };
   [6442] = {
      ["name_ru"] = "Наги на Зорамском взморье";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Wrathtail Heads to Marukai along the Zoram Strand.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Des nagas sur la greve de Zoram";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "佐拉姆海岸的?迦";
      ["name_de"] = "Die Naga am Zoramstrand";
      ["faction"] = "Horde";
      ["name"] = "Naga at the Zoram Strand";
      ["level"] = 19;
      ["name_es"] = "Nagas en la Ensenada de Zoram";
      ["req"] = 14;
   };
   [8819] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8851] = {
      ["name_ru"] = "Пять жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Cinq chevalieres pour des fournitures militaires";
      ["name_cn"] = "五部落?誉徽章";
      ["reward"] = {
         [1] = 21509;
      };
      ["name_de"] = "Funf Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Horde";
      ["name"] = "Five Signets for War Supplies";
      ["level"] = 19;
      ["name_es"] = "Cinco sellos para los suministros belicos";
      ["req"] = 10;
   };
   [8883] = {
      ["name_ru"] = "Валадар Звездная Песня";
      ["type"] = "Solo";
      ["name_fr"] = "Valadar Chantetoile";
      ["name_de"] = "Valadar Sternensang";
      ["name_cn"] = "瓦拉??・星歌";
      ["objective"] = "Use your Lunar Festival Invitation in the moonlight to travel to Moonglade. Speak with Valadar Starsong in Nighthaven when you arrive.";
      ["sort"] = "Lunar Festival";
      ["faction"] = "Horde";
      ["name"] = "Valadar Starsong";
      ["prev"] = 8867;
      ["prequests"] = {
         [1] = 8867;
      };
      ["level"] = 60;
      ["name_es"] = "Valadar Cantoestelar";
      ["req"] = 1;
   };
   [8915] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Magister's Bindings to Mokvar in Orgrimmar.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22063;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [6522] = {
      ["name_ru"] = "Нечестивый союз";
      ["type"] = "Dungeon";
      ["objective"] = "Take the Small Scroll to Varimathras in the Undercity.";
      ["next"] = 6521;
      ["name_fr"] = "Une alliance impie";
      ["sort"] = "Razorfen Downs";
      ["name_cn"] = "邪?的盟友";
      ["series"] = 1;
      ["name_de"] = "Eine unheilige Allianz";
      ["faction"] = "Horde";
      ["name"] = "An Unholy Alliance";
      ["level"] = 36;
      ["name_es"] = "Una alianza impia";
      ["req"] = 28;
   };
   [8979] = {
      ["name_ru"] = "Подозрения Фенстада";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Cologne Bottle and 1 Perfume Bottle to Apothecary Zinge in the Undercity's Apothecarium.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "芬斯塔的?感";
      ["name_fr"] = "L'intuition de Fenstad";
      ["name_de"] = "Fenstads Visionen";
      ["faction"] = "Horde";
      ["name"] = "Fenstad's Hunch";
      ["level"] = 70;
      ["name_es"] = "El presentimiento de Fenstad";
      ["req"] = 58;
   };
   [1639] = {
      ["name_ru"] = "Бартлби Пьянь";
      ["type"] = "Solo";
      ["name_fr"] = "Bartleby le poivrot";
      ["next"] = 1640;
      ["name_de"] = "Bartleby der Trunkenbold";
      ["objective"] = "Speak with Bartleby.";
      ["name_cn"] = "醉鬼巴特莱比";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Bartleby the Drunk";
      ["prev"] = 1638;
      ["prequests"] = {
         [1] = 1638;
      };
      ["level"] = 10;
      ["name_es"] = "Bartleby, el borracho";
      ["req"] = 10;
   };
   [9043] = {
      ["name_ru"] = "Мундир Искупления";
      ["type"] = "Raid";
      ["name_fr"] = "La tunique de redemption";
      ["name_de"] = "Tunika der Erlosung";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make a Redemption Tunic if you bring him the following: 1 Desecrated Tunic, 25 Wartorn Plate Scraps, 4 Arcanite Bars and 3 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22425;
      };
      ["name_cn"] = "救?外套";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Redemption Tunic";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La guerrera de redencion";
      ["req"] = 60;
   };
   [1647] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1648;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Search the outer ring of Ironforge for John Turner.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1646;
      ["prequests"] = {
         [1] = 1646;
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [6602] = {
      ["name_ru"] = "Кровь могучего черного дракона";
      ["type"] = "Raid";
      ["name_fr"] = "Le sang du champion des dragons noirs";
      ["name_de"] = "Blut des schwarzen Grosdrachenhelden";
      ["reward"] = {
         [1] = 16309;
      };
      ["name_cn"] = "黑?勇士之血";
      ["objective"] = "Travel to Blackrock Spire and slay General Drakkisath. Gather his blood and return it to Rexxar.";
      ["faction"] = "Horde";
      ["name"] = "Blood of the Black Dragon Champion";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 6601;
      ["prequests"] = {
         [1] = 6601;
      };
      ["level"] = 60;
      ["name_es"] = "La sangre de dragon Negro Campeon";
      ["req"] = 55;
   };
   [1655] = {
      ["name_ru"] = "Партия руды Балора";
      ["type"] = "Group";
      ["name_fr"] = "Cargaison de minerai de Bailor";
      ["name_de"] = "Bailors Erzlieferung";
      ["name_cn"] = "白洛?的?石";
      ["objective"] = "Bring Jordan's Ore Shipment to Bailor Stonehand in Loch Modan.";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Bailor's Ore Shipment";
      ["reward"] = {
         [1] = 6993;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 22;
      ["name_es"] = "Envio de mena de Bailor";
      ["req"] = 20;
   };
   [9203] = {
      ["name_ru"] = "Задание мастера: настой оцепенения";
      ["type"] = "Solo";
      ["objective"] = "Deliver 1 Flask of Petrification and the Craftsman's Writ - Flask of Petrification - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Flacon de petrification";
      ["name_cn"] = "工匠文? - 化石合?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Trank der Versteinerung";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Flask of Petrification";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pocion de petrificacion";
      ["req"] = 55;
   };
   [9235] = {
      ["name_ru"] = "Наручи ледяной погибели";
      ["type"] = "Raid";
      ["name_fr"] = "Les brassards plaie-de-glace";
      ["name_de"] = "Eisflucharmschienen";
      ["reward"] = {
         [1] = 22671;
      };
      ["name_cn"] = "破冰?腕";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 4 Frozen Runes, 12 Thorium Bars, 2 Arcanite Bars, 2 Essence of Water and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Icebane Bracers";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los brazales Deliriohelado";
      ["req"] = 60;
   };
   [9267] = {
      ["name_ru"] = "Исцеление старых ран";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [470] = 500;
      };
      ["name_fr"] = "Soigner de vieilles blessures";
      ["sort"] = "The Barrens";
      ["name_cn"] = "修?旧?";
      ["name_de"] = "Heilen alter Wunden";
      ["faction"] = "Horde";
      ["name"] = "Mending Old Wounds";
      ["level"] = 60;
      ["name_es"] = "Curar viejas heridas";
      ["req"] = 15;
   };
   [9299] = {
      ["name_ru"] = "Записка с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Careworn Note to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "前?的便条";
      ["name_fr"] = "Une note du front";
      ["name_de"] = "Notiz von der Front";
      ["faction"] = "Horde";
      ["name"] = "Note from the Front";
      ["level"] = 60;
      ["name_es"] = "Una nota del frente";
      ["req"] = 55;
   };
   [9331] = {
      ["name_ru"] = "Похищение пламени Стальгорна";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of Ironforge to the Festival Talespinner.";
      ["name_fr"] = "Voler la flamme de Forgefer";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取?炉堡的烈?";
      ["followup"] = 9339;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Eisenschmiede";
      ["faction"] = "Horde";
      ["name"] = "Stealing Ironforge's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Forjaz";
      ["req"] = 50;
   };
   [1683] = {
      ["name_ru"] = "Ворлус Подлое Копыто";
      ["type"] = "Solo";
      ["name_fr"] = "Vorlus Vilsabot";
      ["name_de"] = "Vorlus Elendshuf";
      ["objective"] = "Bring the Horn of Vorlus to Elanaria in Darnassus.";
      ["name_cn"] = "沃?斯・邪蹄";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Vorlus Vilehoof";
      ["prev"] = 1684;
      ["prequests"] = {
         [1] = 1684;
      };
      ["level"] = 10;
      ["name_es"] = "Vorlus Pezunavil";
      ["req"] = 10;
   };
   [1687] = {
      ["name_ru"] = "Маяк с привидениями";
      ["type"] = "Solo";
      ["name_fr"] = "Le phare hante";
      ["repgain"] = {
         [469] = 75;
      };
      ["name_de"] = "Der gruselige Leuchtturm";
      ["followup"] = 4822;
      ["name_cn"] = "幽?灯塔";
      ["objective"] = "Take the orphan to see the lighthouse off the coast of Westfall.$B";
      ["faction"] = "Alliance";
      ["name"] = "Spooky Lighthouse";
      ["sort"] = "Children's Week";
      ["prev"] = 1468;
      ["prequests"] = {
         [1] = 1468;
      };
      ["level"] = 60;
      ["name_es"] = "El faro fantasma";
      ["req"] = 10;
   };
   [1691] = {
      ["name_ru"] = "Еще одна расправа над Скитальцами Пустыни";
      ["type"] = "Solo";
      ["name_fr"] = "Continuer a chatier les Bat-le-desert";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_de"] = "Noch mehr Wustenlaufergerechtigkeit";
      ["name_cn"] = "?土的公正";
      ["name"] = "More Wastewander Justice";
      ["objective"] = "Take down 10 Wastewander Shadow Mages, 8 Wastewander Rogues, and 6 Wastewander Assassins for Chief Engineer Bilgewhizzle in Gadgetzan.$B";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 1690;
      ["prequests"] = {
         [1] = 1690;
      };
      ["level"] = 44;
      ["name_es"] = "Mas justicia para los Vagayermos";
      ["req"] = 40;
   };
   [1699] = {
      ["name_ru"] = "Ретбанский вызов";
      ["type"] = "Solo";
      ["name_fr"] = "Le defi de Rethban";
      ["name_de"] = "Der Rethbanspiesrutenlauf";
      ["objective"] = "Enter the Rethban Caverns, reach the first fork, and return to Yorus Barleybrew within the time allowed.$B$BYou must not die and release your spirit.";
      ["name_cn"] = "往返瑞斯班洞穴";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "The Rethban Gauntlet";
      ["prev"] = 1698;
      ["prequests"] = {
         [1] = 1698;
      };
      ["level"] = 22;
      ["name_es"] = "El guantelete de Rethban";
      ["req"] = 20;
   };
   [1703] = {
      ["name_ru"] = "Матиль";
      ["type"] = "Solo";
      ["name_fr"] = "Mathiel";
      ["next"] = 1710;
      ["name_de"] = "Mathiel";
      ["objective"] = "Bring Furen's Notes to Mathiel.";
      ["name_cn"] = "?希?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Mathiel";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 1701;
      ["prequests"] = {
         [1] = 1701;
      };
      ["level"] = 28;
      ["name_es"] = "Mathiel";
      ["req"] = 20;
   };
   [6826] = {
      ["name_ru"] = "Небо зовет ? флот Мааши";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 2;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille de Jeztor";
      ["name_cn"] = "天空的召? - 杰斯托的部?";
      ["name_de"] = "Ruf der Lufte - Jeztors Luftflotte";
      ["faction"] = "Horde";
      ["name"] = "Call of Air - Jeztor's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: flota de Jeztor";
      ["req"] = 51;
   };
   [1711] = {
      ["name_ru"] = "Доспехи Матиля";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Mathiels Rustung";
      ["name_fr"] = "L'armure de Mathiel";
      ["name"] = "Mathiel's Armor";
      ["name_cn"] = "?希?的?甲";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6973;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1710;
      ["prequests"] = {
         [1] = 1710;
      };
      ["level"] = 30;
      ["name_es"] = "La armadura de Mathiel";
      ["req"] = 20;
   };
   [1715] = {
      ["name_ru"] = "Таверна \"Забитый ягненок\"";
      ["type"] = "Solo";
      ["objective"] = "Report to Gakin the Darkbinder in the Mage Quarter of Stormwind.";
      ["sort"] = "Warlock";
      ["name_cn"] = "已宰的羔羊";
      ["name_fr"] = "L'Agneau assassine";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Zum Geschlachteten Lamm";
      ["faction"] = "Alliance";
      ["name"] = "The Slaughtered Lamb";
      ["level"] = 10;
      ["name_es"] = "El Cordero Degollado";
      ["req"] = 10;
   };
   [1719] = {
      ["name_ru"] = "Побоище";
      ["type"] = "Solo";
      ["name_fr"] = "La Dispute";
      ["name_de"] = "Der Ringkampf";
      ["objective"] = "Kill Big Will, then speak to Klannoc Macleod on Fray Island.";
      ["name_cn"] = "格斗考?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "The Affray";
      ["prev"] = 1718;
      ["prequests"] = {
         [1] = 1718;
      };
      ["level"] = 30;
      ["name_es"] = "La Reyerta";
      ["req"] = 30;
   };
   [6922] = {
      ["name_ru"] = "Барон Акванис";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Strange Water Globe to Je'neu Sancrea at Zoram'gar Outpost, Ashenvale.";
      ["repgain"] = {
         [530] = 350;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Baron Aquanis";
      ["name_cn"] = "阿奎尼斯男爵";
      ["reward"] = {
         [1] = 16886;
         [2] = 16887;
      };
      ["name_de"] = "Baron Aquanis";
      ["faction"] = "Horde";
      ["name"] = "Baron Aquanis";
      ["level"] = 30;
      ["name_es"] = "Baron Aquanis";
      ["req"] = 21;
   };
   [1739] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Heartswood Core, summon and subdue a succubus, then return the Heartswood Core to Gakin the Darkbinder in the Slaughtered Lamb.";
      ["reward"] = {
         [1] = 22243;
      };
      ["name_cn"] = "誓?";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Binding";
      ["sort"] = "Warlock";
      ["prev"] = 1738;
      ["prequests"] = {
         [1] = 1738;
      };
      ["level"] = 20;
      ["name_es"] = "El vinculo";
      ["req"] = 20;
   };
   [7002] = {
      ["name_ru"] = "Упряжь из бараньей кожи";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["repgain"] = {
         [76] = 10;
         [729] = 2;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Harnais en cuir de belier";
      ["name_cn"] = "羊皮坐具";
      ["name_de"] = "Widderledernes Zaumzeug";
      ["faction"] = "Horde";
      ["name"] = "Ram Hide Harnesses";
      ["level"] = 60;
      ["name_es"] = "Arneses de pellejo de carnero";
      ["req"] = 51;
   };
   [7066] = {
      ["name_ru"] = "Семя Жизни";
      ["type"] = "Dungeon";
      ["objective"] = "Seek out Remulos in Moonglade and give him the Seed of Life.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_fr"] = "La graine de la vie";
      ["sort"] = "Maraudon";
      ["name_cn"] = "生命之?";
      ["name_de"] = "Samenkorn des Lebens";
      ["faction"] = "Horde";
      ["name"] = "Seed of Life";
      ["level"] = 51;
      ["name_es"] = "La semilla de vida";
      ["req"] = 45;
   };
   [7082] = {
      ["name_ru"] = "Кладбища долины Альтерака";
      ["type"] = "PvP";
      ["objective"] = "Assault a graveyard, then return to Corporal Teeka Bloodsnarl in the Alterac Mountains.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "奥特?克山谷的墓地";
      ["name_fr"] = "Les cimetieres d'Alterac";
      ["name_de"] = "Die Friedhofe von Alterac";
      ["faction"] = "Horde";
      ["name"] = "The Graveyards of Alterac";
      ["level"] = 60;
      ["name_es"] = "Los cementerios de Alterac";
      ["req"] = 51;
   };
   [1779] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1783;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Take the Symbol of Life and speak to Muiredon Battleforge in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1778;
      ["prequests"] = {
         [1] = 1778;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1783] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1784;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Take the Symbol of Life and resurrect Narm Faulk in Dun Morogh.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1779;
      ["prequests"] = {
         [1] = 1779;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1787] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1788;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Retrieve a Defias Script from the Defias Rogue Wizards in Elwynn, and return to Gazin Tenorm in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1786;
      ["prequests"] = {
         [1] = 1786;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [7162] = {
      ["name_ru"] = "Испытательные земли";
      ["type"] = "Solo";
      ["objective"] = "Travel to the Icewing Caverns located southwest of Dun Baldar in Alterac Valley and recover the Stormpike Banner. Return the Stormpike Banner to Lieutenant Haggerdin in the Alterac Mountains.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Montrer sa valeur";
      ["name_cn"] = "???";
      ["reward"] = {
         [1] = 17691;
         [2] = 19484;
      };
      ["name_de"] = "Flaggenjagd";
      ["faction"] = "Horde";
      ["name"] = "Proving Grounds";
      ["level"] = 60;
      ["name_es"] = "Terreno de Pruebas";
      ["req"] = 51;
   };
   [1795] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Tome of the Cabal, summon and subdue a felhunter, then return the Tome of the Cabal to Strahad Farsan in Ratchet.";
      ["reward"] = {
         [1] = 22244;
      };
      ["name_cn"] = "誓?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Binding";
      ["sort"] = "Warlock";
      ["prev"] = 1805;
      ["prequests"] = {
         [1] = 1805;
         [2] = 1804;
      };
      ["level"] = 30;
      ["name_es"] = "El vinculo";
      ["req"] = 30;
   };
   [1799] = {
      ["name_ru"] = "Части шара Орахила";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara's acolytes inside the tower above Ratchet and choose one of their paths to follow.$B$BAfterwards, bring an Infernal Orb to Tabetha in Dustwallow Marsh.";
      ["next"] = 4961;
      ["sort"] = "Warlock";
      ["name_cn"] = "宝珠碎片";
      ["name_fr"] = "Fragments de l'Orbe d'Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Fragmente der Kugel von Orahil";
      ["faction"] = "Horde";
      ["name"] = "Fragments of the Orb of Orahil";
      ["level"] = 40;
      ["name_es"] = "Los trozos del orbe de Orahil";
      ["req"] = 35;
   };
   [1803] = {
      ["name_ru"] = "Фолиант заговора";
      ["objective"] = "Retrieve the Moldy Tome and Tattered Manuscript for Jorah Annison in the Undercity.";
      ["name_cn"] = "??之?";
      ["sort"] = "Warlock";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Tome de la Cabale";
      ["next"] = 1805;
      ["name_de"] = "Foliant der Kabale";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Tome of the Cabal";
      ["prev"] = 1801;
      ["prequests"] = {
         [1] = 1801;
      };
      ["series"] = 2;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [1819] = {
      ["name_ru"] = "Улаг Колун";
      ["type"] = "Solo";
      ["name_fr"] = "Ulag le Fendeur";
      ["next"] = 1820;
      ["name_de"] = "Ulag der Spalter";
      ["objective"] = "Kill Ulag the Cleaver, then speak with Deathguard Dillinger.";
      ["name_cn"] = "切割者奥拉格";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Ulag the Cleaver";
      ["prev"] = 1818;
      ["prequests"] = {
         [1] = 1818;
      };
      ["level"] = 10;
      ["name_es"] = "Ulag el Cuchilla";
      ["req"] = 10;
   };
   [1823] = {
      ["name_ru"] = "Разговор с Ругой";
      ["type"] = "Solo";
      ["objective"] = "Speak with Ruga Ragetotem.";
      ["next"] = 1824;
      ["sort"] = "Warrior";
      ["name_cn"] = "和?迦交?";
      ["name_fr"] = "Parler a Ruga";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Gesprach mit Ruga";
      ["faction"] = "Horde";
      ["name"] = "Speak with Ruga";
      ["level"] = 20;
      ["name_es"] = "Habla con Ruga";
      ["req"] = 20;
   };
   [1839] = {
      ["name_ru"] = "Ула'елек и рукавицы Жестокости";
      ["type"] = "Solo";
      ["name_fr"] = "Ula'elek et les Gantelets de brutalite";
      ["next"] = 1842;
      ["name_de"] = "Ula'elek und die brutalen Stulpen";
      ["objective"] = "Speak with Ula'elek in Durotar.";
      ["name_cn"] = "尤拉莱克和野蛮?手";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Ula'elek and the Brutal Gauntlets";
      ["prev"] = 1838;
      ["prequests"] = {
         [1] = 1838;
      };
      ["level"] = 30;
      ["name_es"] = "Ula'elek y los guanteletes brutales";
      ["req"] = 20;
   };
   [1843] = {
      ["name_ru"] = "Рукавицы Жестокости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Brutale Stulpen";
      ["name_fr"] = "Gantelets de brutalite";
      ["name"] = "Brutal Gauntlets";
      ["name_cn"] = "野蛮?手";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7129;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1842;
      ["prequests"] = {
         [1] = 1842;
      };
      ["level"] = 30;
      ["name_es"] = "Guanteletes brutales";
      ["req"] = 20;
   };
   [7386] = {
      ["name_ru"] = "Гроздь кристаллов";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["repgain"] = {
         [47] = 75;
         [730] = 5;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Grappes de cristaux";
      ["name_cn"] = "水晶簇";
      ["name_de"] = "Haufenweise Kristalle";
      ["faction"] = "Alliance";
      ["name"] = "Crystal Cluster";
      ["level"] = 60;
      ["name_es"] = "Recogida de cristal";
      ["req"] = 51;
   };
   [7402] = {
      ["name_ru"] = "Разыскиваются: ОРКИ!";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing Orc players in Alterac Valley.$B$BKill an Orc and take their Orc Tooth back to Corporal Noreg Stormpike at Dun Baldar.";
      ["name_cn"] = "通?：?人！";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "GESUCHT: ORCS!";
      ["faction"] = "Horde";
      ["name"] = "Wanted: ORCS!";
      ["level"] = 60;
      ["name_es"] = "Se buscan: !ORCOS!";
      ["req"] = 51;
   };
   [1859] = {
      ["name_ru"] = "Терзок";
      ["type"] = "Solo";
      ["objective"] = "Speak with Therzok in the Cleft of Shadow in Orgrimmar.";
      ["next"] = 1963;
      ["name_de"] = "Therzok";
      ["sort"] = "Rogue";
      ["name_cn"] = "瑟祖克";
      ["name_fr"] = "Therzok";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["races"] = {
         [1] = "Orc";
      };
      ["name"] = "Therzok";
      ["level"] = 10;
      ["name_es"] = "Therzok";
      ["req"] = 10;
   };
   [7482] = {
      ["name_ru"] = "Эльфийские легенды";
      ["type"] = "Dungeon";
      ["objective"] = "Search Dire Maul for Kariel Winthalus. Report back to Scholar Runethorn at Feathermoon with whatever information that you may find.";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "精?的??";
      ["name_fr"] = "Legendes elfiques";
      ["name_de"] = "Elfische Legenden";
      ["faction"] = "Alliance";
      ["name"] = "Elven Legends";
      ["level"] = 60;
      ["name_es"] = "Leyendas elficas";
      ["req"] = 54;
   };
   [7498] = {
      ["name_ru"] = "Гарона: Исследование уловок и предательства";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Garona : une etude en discretion et en trahison";
      ["name_cn"] = "迦?娜：潜行与??研究";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 18465;
      };
      ["name_de"] = "Garona: Eine Studie uber Heimlichkeit und Verrat";
      ["faction"] = "Horde";
      ["name"] = "Garona: A Study on Stealth and Treachery";
      ["level"] = 60;
      ["name_es"] = "Garona: Un Estudio sobre el Sigilo y la Traicion";
      ["req"] = 54;
   };
   [1879] = {
      ["name_ru"] = "Поговорите с Бинк";
      ["type"] = "Solo";
      ["objective"] = "Speak with Bink in Ironforge.";
      ["next"] = 1880;
      ["name_de"] = "Gesprach mit Bink";
      ["sort"] = "Mage";
      ["name_cn"] = "和彬克交?";
      ["name_fr"] = "Parler a Bink";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Speak with Bink";
      ["level"] = 10;
      ["name_es"] = "Habla con Bink";
      ["req"] = 10;
   };
   [1883] = {
      ["name_ru"] = "Разговор с Ун'Тувой";
      ["type"] = "Solo";
      ["objective"] = "Speak with Un'thuwa.";
      ["next"] = 1884;
      ["name_de"] = "Gesprach mit Un'thuwa";
      ["sort"] = "Mage";
      ["name_cn"] = "安?瓦";
      ["name_fr"] = "Parler a Un'thuwa";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Speak with Un'thuwa";
      ["level"] = 10;
      ["name_es"] = "Habla con Un'thuwa";
      ["req"] = 10;
   };
   [7562] = {
      ["name_ru"] = "Мор'зул Вестник Крови";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mor'zul Bloodbringer in the Burning Steppes.";
      ["next"] = 7563;
      ["sort"] = "Warlock";
      ["name_cn"] = "莫??・召血者";
      ["name_fr"] = "Mor'zul Porte-sang";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 7563;
      ["name_de"] = "Mor'zul Blutbringer";
      ["faction"] = "Horde";
      ["name"] = "Mor'zul Bloodbringer";
      ["level"] = 58;
      ["name_es"] = "Mor'zul Sangredoble";
      ["req"] = 60;
   };
   [1899] = {
      ["name_ru"] = "Стражи смерти";
      ["objective"] = "Bring Andron's Ledger to Mennet Carkad in the Rogues' Quarter of Undercity.";
      ["name_cn"] = "亡?哨兵";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "Les necrotraqueurs";
      ["next"] = 1978;
      ["name_de"] = "Die Todespirscher";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["sort"] = "Rogue";
      ["name"] = "The Deathstalkers";
      ["prev"] = 1898;
      ["prequests"] = {
         [1] = 1898;
      };
      ["series"] = 3;
      ["name_es"] = "Los mortacechadores";
      ["req"] = 10;
   };
   [7626] = {
      ["name_ru"] = "Колокол Детмуры";
      ["type"] = "Solo";
      ["name_fr"] = "La Cloche de Dethmoora";
      ["name_de"] = "Die Glocke von Dethmoora";
      ["sort"] = "Warlock";
      ["objective"] = "Bring 10 Elixirs of Shadow Power to Gorzeeki Wildeyes in the Burning Steppes.";
      ["name_cn"] = "?斯莫拉之?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Bell of Dethmoora";
      ["followup"] = 7630;
      ["prev"] = 7564;
      ["prequests"] = {
         [1] = 7564;
      };
      ["level"] = 60;
      ["name_es"] = "La Campana de Dethmoora";
      ["req"] = 60;
   };
   [7642] = {
      ["name_ru"] = "Сбор необходимого";
      ["objective"] = "Bring 40 Runecloth, 6 Arcanite Bars, 10 Arthas' Tears, 5 Stratholme Holy Water vials, and 150 gold to Grimand Elmore in the Dwarven District of Stormwind.";
      ["name_cn"] = "收集材料";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une ribambelle d'objets";
      ["repgain"] = {
         [69] = 75;
         [469] = 75;
         [47] = 250;
      };
      ["name_de"] = "Funf Dinge";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Collection of Goods";
      ["prev"] = 7641;
      ["prequests"] = {
         [1] = 7641;
      };
      ["followup"] = 7643;
      ["name_es"] = "Recopilacion de articulos";
      ["req"] = 60;
   };
   [7658] = {
      ["name_ru"] = "Императорские латные поножи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["name_de"] = "Imperiale Plattengamaschen";
      ["name_fr"] = "Les jambieres imperiales en plaques";
      ["name_cn"] = "君王?甲?腿";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Leggings";
      ["reward"] = {
         [1] = 12715;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Leotardos de placas imperiales";
      ["req"] = 50;
   };
   [7674] = {
      ["name_ru"] = "Замена черного барана";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Echange de belier noir";
      ["name_cn"] = "更?黑山羊";
      ["reward"] = {
         [1] = 18786;
         [2] = 18787;
         [3] = 18785;
      };
      ["name_de"] = "Austausch Eures schwarzen Widders";
      ["faction"] = "Alliance";
      ["name"] = "Black Ram Exchange";
      ["level"] = 1;
      ["name_es"] = "Intercambio de carnero negro";
      ["req"] = 60;
   };
   [7722] = {
      ["name_ru"] = "Какой еще плавень?";
      ["type"] = "Solo";
      ["objective"] = "Somewhere in the Slag Pit of the Cauldron you will find the Secret Plans: Fiery Flux that Overseer Maltorius stole. Find those plans and return them to Master Smith Burninate in the Searing Gorge.$B";
      ["repgain"] = {
         [59] = 100;
      };
      ["name_fr"] = "Le Flux embrase";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "?密配方！";
      ["name_de"] = "Was zum Fluxus?!";
      ["faction"] = "Horde";
      ["name"] = "What the Flux?";
      ["level"] = 50;
      ["name_es"] = "?Que pasa con el flujo?";
      ["req"] = 45;
   };
   [7738] = {
      ["name_ru"] = "Безупречная шкура йети";
      ["type"] = "Solo";
      ["objective"] = "Bring the Perfect Yeti Hide to Jangdor Swiftstrider at Camp Mojache, Feralas.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Une peau de yeti parfaite";
      ["sort"] = "Feralas";
      ["name_cn"] = "完美的雪人毛皮";
      ["name_de"] = "Perfekter Yetibalg";
      ["faction"] = "Horde";
      ["name"] = "Perfect Yeti Hide";
      ["level"] = 48;
      ["name_es"] = "Pellejo de yeti perfecto";
      ["req"] = 40;
   };
   [1939] = {
      ["name_ru"] = "Верховный колдун Андромат";
      ["type"] = "Solo";
      ["objective"] = "Speak with High Sorcerer Andromath.";
      ["next"] = 1938;
      ["name_de"] = "Zaubermeister Andromath";
      ["sort"] = "Mage";
      ["name_cn"] = "高?巫?安多?斯";
      ["name_fr"] = "Grand sorcier Andromath";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "High Sorcerer Andromath";
      ["level"] = 26;
      ["name_es"] = "Sumo Hechicero Andromath";
      ["req"] = 26;
   };
   [1943] = {
      ["name_ru"] = "Разговор с Дейно";
      ["type"] = "Solo";
      ["objective"] = "Speak with Deino.";
      ["next"] = 1944;
      ["name_de"] = "Gesprach mit Deino";
      ["sort"] = "Mage";
      ["name_cn"] = "巨魔法?迪?";
      ["name_fr"] = "Parler a Deino";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Speak with Deino";
      ["level"] = 26;
      ["name_es"] = "Habla con Deino";
      ["req"] = 26;
   };
   [7786] = {
      ["name_ru"] = "Громораан Искатель Ветра";
      ["type"] = "Raid";
      ["name_fr"] = "Tonneraan le Cherchevent";
      ["name_de"] = "Donneraan der Windsucher";
      ["name_cn"] = "逐?者桑德?";
      ["objective"] = "To free Thunderaan the Windseeker from his prison, you must present the right and left halves of the Bindings of the Windseeker, 10 bars of Elementium, and the Essence of the Firelord to Highlord Demitrian in Silithus.";
      ["sort"] = "Legendary";
      ["faction"] = "Horde";
      ["name"] = "Thunderaan the Windseeker";
      ["prev"] = 7785;
      ["prequests"] = {
         [1] = 7785;
      };
      ["level"] = 60;
      ["name_es"] = "Thunderaan el Hijo del Viento";
      ["req"] = 60;
   };
   [7802] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7805;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [1955] = {
      ["name_ru"] = "Поединок с демоном";
      ["type"] = "Group";
      ["name_fr"] = "L'Exorcisme";
      ["next"] = 1956;
      ["name_de"] = "Die Austreibung";
      ["objective"] = "Kill the Demon of the Orb, then speak with Tabetha.";
      ["name_cn"] = "?除魔鬼";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "The Exorcism";
      ["prev"] = 1954;
      ["prequests"] = {
         [1] = 1954;
      };
      ["level"] = 40;
      ["name_es"] = "El exorcismo";
      ["req"] = 35;
   };
   [7834] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [530] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7836;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [1963] = {
      ["name_ru"] = "Изувеченная Длань";
      ["objective"] = "Kill Tazan and bring his Satchel to Therzok in the Cleft of Shadow in Orgrimmar.";
      ["name_cn"] = "碎手氏族";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "La Main brisee";
      ["next"] = 1858;
      ["name_de"] = "Die Zerschmetterte Hand";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["sort"] = "Rogue";
      ["name"] = "The Shattered Hand";
      ["prev"] = 1859;
      ["prequests"] = {
         [1] = 1859;
      };
      ["series"] = 1;
      ["name_es"] = "Mano Destrozada";
      ["req"] = 10;
   };
   [7866] = {
      ["name_ru"] = "Припасы Всадников";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [889] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage de base de Voltigeur";
      ["name_cn"] = "斥候基??理包";
      ["reward"] = {
         [1] = 19154;
      };
      ["name_de"] = "Basisuberlebenspaket der Vorhut";
      ["faction"] = "Horde";
      ["name"] = "Outrider Basic Care Package";
      ["level"] = 34;
      ["name_es"] = "Botiquin basico de escolta";
      ["req"] = 25;
   };
   [7882] = {
      ["name_ru"] = "Кожаные куртки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Des tuniques pour les forains";
      ["name_cn"] = "狂??外套";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Jahrmarktswamser";
      ["faction"] = "Horde";
      ["name"] = "Carnival Jerkins";
      ["level"] = 60;
      ["name_es"] = "Los chalecos de los feriantes";
      ["req"] = 10;
   };
   [7898] = {
      ["name_ru"] = "Ториевое устройство";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Les rouages en thorium";
      ["name_cn"] = "瑟?零件";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Thoriumapparat";
      ["faction"] = "Horde";
      ["name"] = "Thorium Widget";
      ["level"] = 60;
      ["name_es"] = "Trastos de torio";
      ["req"] = 40;
   };
   [7930] = {
      ["name_ru"] = "5 купонов ? цветок Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "5 bons - Fleur de Sombrelune";
      ["name_cn"] = "5??券 - 暗月花束";
      ["reward"] = {
         [1] = 19295;
      };
      ["name_de"] = "5 Lose - Dunkelmond-Blume";
      ["faction"] = "Horde";
      ["name"] = "5 Tickets - Darkmoon Flower";
      ["level"] = 60;
      ["name_es"] = "5 vales: flor de la Luna Negra";
      ["req"] = 6;
   };
   [7946] = {
      ["name_ru"] = "Потомство Жабжаб";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Le rejeton de Jubjub";
      ["name_cn"] = "加布加布";
      ["reward"] = {
         [1] = 19462;
      };
      ["name_de"] = "Jubjubs Nachwuchs";
      ["faction"] = "Horde";
      ["name"] = "Spawn of Jubjub";
      ["level"] = 1;
      ["name_es"] = "Huevo de Jubjub";
      ["req"] = 1;
   };
   [1999] = {
      ["name_ru"] = "Предметы торговли";
      ["type"] = "Solo";
      ["name_fr"] = "Les outils du metier";
      ["name_de"] = "Werkzeuge des Handwerks";
      ["objective"] = "Find the Dalaran Status Report and return it to Mennet Carkad in the Rogues' Quarter of the Undercity.";
      ["name_cn"] = "交易工具";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Tools of the Trade";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1998;
      ["prequests"] = {
         [1] = 1998;
      };
      ["level"] = 20;
      ["name_es"] = "Herramientas de comercio";
      ["req"] = 16;
   };
   [8042] = {
      ["name_ru"] = "Сила горы Мугамба";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Starke des Bergs Mugamba";
      ["name_fr"] = "La force du mont Mugamba";
      ["name"] = "Strength of Mount Mugamba";
      ["name_cn"] = "穆?巴之力";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19575;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8041;
      ["prequests"] = {
         [1] = 8041;
      };
      ["level"] = 60;
      ["name_es"] = "La fuerza del Monte Mugamba";
      ["req"] = 60;
   };
   [8058] = {
      ["name_ru"] = "Знаки Силы: боевые наручи воздаятеля";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker a Primal Hakkari Armsplint.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les garde-bras de redresseur de torts";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：??者?臂";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19824;
      };
      ["name_de"] = "Symbole der Macht: Die Armschutzer des Vollstreckers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Vindicator's Armguards";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Guardabrazos de vindicador";
      ["req"] = 60;
   };
   [8074] = {
      ["name_ru"] = "Знаки Силы: пояс авгура";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Girdle.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BMaywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance : la ceinture d'augure";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?言者腰?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19829;
      };
      ["name_de"] = "Symbole der Macht: Der Gurtel des Weissagers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Augur's Belt";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Cinturon de augur";
      ["req"] = 60;
   };
   [8106] = {
      ["name_ru"] = "Ожерелье Кезанского порока";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La souillure de Kezan";
      ["name_cn"] = "科?的??";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 19602;
      };
      ["name_de"] = "Kezans Schmach";
      ["faction"] = "Horde";
      ["name"] = "Kezan's Taint";
      ["level"] = 60;
      ["name_es"] = "Ocaso de Kezan";
      ["req"] = 60;
   };
   [8122] = {
      ["name_ru"] = "Занять пять баз";
      ["type"] = "PvP";
      ["objective"] = "Hold five bases in Arathi Basin at the same time, then return to Deathmaster Dwire in Hammerfall.";
      ["name_fr"] = "Prendre cinq bases";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?取五座基地";
      ["reward"] = {
         [1] = 20131;
      };
      ["name_de"] = "Erobert funf Stutzpunkte";
      ["faction"] = "Horde";
      ["name"] = "Take Five Bases";
      ["level"] = 60;
      ["name_es"] = "Toma el control de cinco bases";
      ["req"] = 60;
   };
   [8154] = {
      ["name_ru"] = "Ресурсы Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地的?源!";
      ["name_fr"] = "Les ressources du bassin d'Arathi";
      ["name_de"] = "Die Ressourcen des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Arathi Basin Resources!";
      ["level"] = 45;
      ["name_es"] = "Los recursos de la Cuenca de Arathi";
      ["req"] = 40;
   };
   [8170] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the Arathi Basin mine, lumber mill, blacksmith and stable, and then return to Deathmaster Dwire in Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Horde";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 35;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 30;
   };
   [8186] = {
      ["name_ru"] = "Объятия смерти";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La caresse de la mort";
      ["name_cn"] = "死亡的?抱";
      ["reward"] = {
         [1] = 19784;
      };
      ["name_de"] = "Umarmung des Todes";
      ["faction"] = "Horde";
      ["name"] = "Death's Embrace";
      ["level"] = 60;
      ["name_es"] = "Abrazo de la Muerte";
      ["req"] = 58;
   };
   [4107] = {
      ["name_ru"] = "Лекарство из распыленных предметов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Entzauberung";
      ["name_fr"] = "Du baume contre des desenchantements";
      ["name_cn"] = "分解??膏";
      ["name"] = "Salve via Disenchanting";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4101;
      ["prequests"] = {
         [1] = 4101;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desencantamiento";
      ["req"] = 48;
   };
   [4123] = {
      ["name_ru"] = "Сердце горы";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Heart of the Mountain to Maxwort Uberglint in the Burning Steppes.";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "山脉之心";
      ["name_fr"] = "Le Coeur de la montagne";
      ["name_de"] = "Das Herz des Berges";
      ["faction"] = "Horde";
      ["name"] = "The Heart of the Mountain";
      ["level"] = 55;
      ["name_es"] = "El corazon de la montana";
      ["req"] = 50;
   };
   [8276] = {
      ["name_ru"] = "Отвоевание Силитуса";
      ["type"] = "Solo";
      ["objective"] = "Talk to Windcaller Proudhorn at Cenarion Hold in Silithus.";
      ["next"] = 8280;
      ["name_fr"] = "La reconquete de Silithus";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?回希利?斯";
      ["repgain"] = {
         [609] = 10;
      };
      ["name_de"] = "Die Ruckeroberung von Silithus";
      ["faction"] = "Horde";
      ["name"] = "Taking Back Silithus";
      ["level"] = 55;
      ["name_es"] = "La reconquista de Silithus";
      ["req"] = 54;
   };
   [8308] = {
      ["name_ru"] = "Потерянное письмо Бранна Бронзоборода";
      ["type"] = "Group";
      ["objective"] = "Take Brann Bronzebeard's Letter to Bronzebeard's Encampment in southern Silithus.";
      ["repgain"] = {
         [609] = 250;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "La lettre perdue de Brann Barbe-de-bronze";
      ["name_cn"] = "布莱恩・??的信";
      ["reward"] = {
         [1] = 20723;
      };
      ["name_de"] = "Der verlorene Brief von Brann Bronzebart";
      ["faction"] = "Horde";
      ["name"] = "Brann Bronzebeard's Lost Letter";
      ["level"] = 60;
      ["name_es"] = "La carta perdida de Brann Barbabronce";
      ["req"] = 58;
   };
   [8372] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 19;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 10;
   };
   [8404] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["sort"] = "Warsong Gulch";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["prev"] = 8399;
      ["prequests"] = {
         [1] = 8399;
      };
      ["level"] = 29;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 20;
   };
   [8436] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
      };
      ["name_fr"] = "La conquete du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?源??";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["level"] = 39;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 30;
   };
   [2118] = {
      ["name_ru"] = "Зачумленные земли";
      ["type"] = "Solo";
      ["objective"] = "Capture a living Rabid Thistle Bear and bring it back to Tharnariun.$B$BShould you fail to capture a Rabid Thistle Bear and lose your trap, return to Tharnariun Treetender and request another trap.";
      ["next"] = 2138;
      ["name_fr"] = "Terres malades";
      ["sort"] = "Darkshore";
      ["name_cn"] = "瘟疫蔓延";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Verseuchtes Land";
      ["faction"] = "Alliance";
      ["name"] = "Plagued Lands";
      ["level"] = 14;
      ["name_es"] = "Tierras apestadas";
      ["req"] = 10;
   };
   [8500] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает ториевых слитков!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de barres de thorium !";
      ["name_de"] = "Die Allianz braucht mehr Thoriumbarren!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_cn"] = "?盟需要更多瑟??！";
      ["objective"] = "Bring 20 thorium bars to Dame Twinbraid at the airfield in Dun Morogh.";
      ["faction"] = "Alliance";
      ["name"] = "The Alliance Needs More Thorium Bars!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8499;
      ["prequests"] = {
         [1] = 8499;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas barras de torio!";
      ["req"] = 1;
   };
   [8532] = {
      ["name_ru"] = "Орде не хватает медных слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Copper Bars to Miner Cromwell at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de barres de cuivre !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要??！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21509;
      };
      ["name_de"] = "Die Horde braucht Kupferbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Copper Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita lingotes de cobre!";
      ["req"] = 54;
   };
   [4283] = {
      ["name_ru"] = "ПЯТЬДЕСЯТ! АГА!";
      ["type"] = "Solo";
      ["objective"] = "Oralius wants 50 Blackrock Medallions. Chances are high that these medallions can be found on the orcs in the Burning Steppes.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "CINQUANTE?! OUI?!";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "五十个！";
      ["name_de"] = "FUNFZIG! Jawoll!";
      ["faction"] = "Alliance";
      ["name"] = "FIFTY! YEP!";
      ["level"] = 56;
      ["name_es"] = "!CINCUENTA! !SI!";
      ["req"] = 50;
   };
   [8596] = {
      ["name_ru"] = "Обмотки Оракула";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of Death, 5 Bronze Scarabs and 5 Gold Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "神?者的裹足";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottillons de l'Oracle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Fuslappen des Orakels";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21349;
      };
      ["name"] = "Footwraps of the Oracle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los borceguies del Oraculo";
      ["req"] = 60;
   };
   [8628] = {
      ["name_ru"] = "Корона Мстителя";
      ["objective"] = "Bring Vek'lor's Diadem, 2 Idols of Rebirth, 5 Stone Scarabs and 5 Crystal Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?仇者的王冠";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La couronne du Vengeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Krone des Rachers";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21387;
      };
      ["name"] = "Avenger's Crown";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La corona del Vengador";
      ["req"] = 60;
   };
   [8660] = {
      ["name_ru"] = "Обмотки Призывателя рока";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Night, 5 Clay Scarabs and 5 Ivory Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "厄?召?者的裹足";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottines d'implorateur funeste";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Fuslappen des Verdammnisrufers";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21338;
      };
      ["name"] = "Doomcaller's Footwraps";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Borceguies de clamacondenas";
      ["req"] = 60;
   };
   [8692] = {
      ["name_ru"] = "Плащ Бесконечной жизни";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Regal Drape, 2 Vermillion Idols, 5 Silver Scarabs and 5 Bone Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La cape de vie interminable";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "不?生命披?";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21409;
      };
      ["name_de"] = "Umhang des endlosen Lebens";
      ["faction"] = "Horde";
      ["name"] = "Cloak of Unending Life";
      ["level"] = 60;
      ["name_es"] = "Capa de vida inagotable";
      ["req"] = 60;
   };
   [4363] = {
      ["name_ru"] = "Королевский сюрприз";
      ["type"] = "Dungeon";
      ["name_fr"] = "La surprise de la Princesse";
      ["name_de"] = "Die Uberraschung der Prinzessin";
      ["reward"] = {
         [1] = 12548;
         [2] = 12543;
      };
      ["name_cn"] = "?出?人的公主";
      ["objective"] = "Return to Ironforge and speak with King Magni Bronzebeard.";
      ["faction"] = "Alliance";
      ["name"] = "The Princess's Surprise";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4362;
      ["prequests"] = {
         [1] = 4362;
      };
      ["level"] = 59;
      ["name_es"] = "La sorpresa de la princesa";
      ["req"] = 50;
   };
   [8756] = {
      ["name_ru"] = "Победитель киражей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Der Eroberer der Qiraji";
      ["name_fr"] = "Le conquerant qiraji";
      ["name_cn"] = "其拉虫人的征服者";
      ["faction"] = "Horde";
      ["name"] = "The Qiraji Conqueror";
      ["reward"] = {
         [1] = 21205;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8755;
      ["prequests"] = {
         [1] = 8755;
      };
      ["level"] = 60;
      ["name_es"] = "El conquistador qiraji";
      ["req"] = 60;
   };
   [8788] = {
      ["name_ru"] = "Слегка помятый подарок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un cadeau secoue doucement";
      ["name_cn"] = "???晃?的礼品";
      ["classes"] = {
         [1] = "Druid";
         [2] = "Mage";
         [3] = "Priest";
         [4] = "Warlock";
      };
      ["reward"] = {
         [1] = 21271;
      };
      ["name_de"] = "Ein leicht geschutteltes Geschenk";
      ["faction"] = "Horde";
      ["name"] = "A Gently Shaken Gift";
      ["level"] = 1;
      ["name_es"] = "Un obsequio ligeramente agitado";
      ["req"] = 1;
   };
   [8820] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8852] = {
      ["name_ru"] = "Десять жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Dix chevalieres pour des fournitures militaires";
      ["name_cn"] = "十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21510;
      };
      ["name_de"] = "Zehn Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Horde";
      ["name"] = "Ten Signets for War Supplies";
      ["level"] = 29;
      ["name_es"] = "Diez sellos para los suministros belicos";
      ["req"] = 20;
   };
   [4443] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [8916] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Devout Bracers to Mokvar in Orgrimmar.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "??的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22079;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [2238] = {
      ["name_ru"] = "Простая уловка";
      ["type"] = "Solo";
      ["name_fr"] = "Simple subterfuge";
      ["next"] = 2239;
      ["name_de"] = "Einfache List";
      ["objective"] = "Find Onin MacHammar by Gnomeregan.";
      ["name_cn"] = "国王的?宝";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Simple Subterfugin'";
      ["prev"] = 2218;
      ["prequests"] = {
         [1] = 2218;
      };
      ["level"] = 10;
      ["name_es"] = "Un simple subterfugio";
      ["req"] = 10;
   };
   [8980] = {
      ["name_ru"] = "Мнение Зинг";
      ["type"] = "Solo";
      ["objective"] = "Return to Fenstad Argyle outside the bank in the Undercity.";
      ["next"] = 8982;
      ["name_fr"] = "L'evaluation de Zinge";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "金格的?估";
      ["reward"] = {
         [1] = 21812;
         [2] = 22218;
      };
      ["name_de"] = "Zinges Einschatzung";
      ["faction"] = "Horde";
      ["name"] = "Zinge's Assessment";
      ["level"] = 0;
      ["name_es"] = "La evaluacion de Zinge";
      ["req"] = 58;
   };
   [9012] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Dreadmist Mask and Dreadmist Robe.";
      ["reward"] = {
         [1] = 22074;
         [2] = 22075;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9044] = {
      ["name_ru"] = "Набедренники Искупления";
      ["type"] = "Raid";
      ["name_fr"] = "Les cuissards de redemption";
      ["name_de"] = "Beinschutzer der Erlosung";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make a pair of Redemption Legguards if you bring him the following: 1 Desecrated Legguards, 20 Wartorn Plate Scraps, 4 Arcanite Bars and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22427;
      };
      ["name_cn"] = "救?腿甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Redemption Legguards";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las musleras de redencion";
      ["req"] = 60;
   };
   [2278] = {
      ["name_ru"] = "Платиновые диски";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with stone watcher and learn what ancient lore it keeps.  Once you have learned what lore it has to offer, activate the Discs of Norgannon.";
      ["sort"] = "Uldaman";
      ["name_cn"] = "白金??";
      ["name_fr"] = "Les Disques de platine";
      ["name_de"] = "Die Platinscheiben";
      ["faction"] = "Horde";
      ["name"] = "The Platinum Discs";
      ["level"] = 47;
      ["name_es"] = "Los discos de platino";
      ["req"] = 40;
   };
   [4603] = {
      ["name_ru"] = "Работа для Чистера";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Funkelmatastisch";
      ["name_fr"] = "Le Brille-o-Matic decape encore";
      ["name_cn"] = "再次使用超?清?器";
      ["name"] = "More Sparklematic Action";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 4605;
      ["prequests"] = {
         [1] = 4605;
      };
      ["level"] = 30;
      ["name_es"] = "El Destellamatic en accion";
      ["req"] = 25;
   };
   [9236] = {
      ["name_ru"] = "Кираса ледяной погибели";
      ["type"] = "Raid";
      ["name_fr"] = "La cuirasse plaie-de-glace";
      ["name_de"] = "Eisfluchbrustplatte";
      ["reward"] = {
         [1] = 22669;
      };
      ["name_cn"] = "破冰胸甲";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 8 Frozen Runes, 16 Thorium Bars, 2 Arcanite Bars, 4 Essence of Water and 300 gold. You will also need to be of Exalted reputation with the Argent Dawn.$B";
      ["faction"] = "Horde";
      ["name"] = "Icebane Breastplate";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "La coraza Deliriohelado";
      ["req"] = 60;
   };
   [9268] = {
      ["name_ru"] = "Морской бой";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [21] = 250;
         [369] = 500;
         [577] = 250;
         [470] = 250;
      };
      ["sort"] = "Tanaris";
      ["name_fr"] = "Combat naval";
      ["name_cn"] = "海上之?";
      ["name_de"] = "Krieg zur See";
      ["faction"] = "Horde";
      ["name"] = "War at Sea";
      ["level"] = 60;
      ["name_es"] = "Guerra en el mar";
      ["req"] = 40;
   };
   [9300] = {
      ["name_ru"] = "Страничка с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Ragged Page to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "破旧的信";
      ["name_fr"] = "Une page du front";
      ["name_de"] = "Nachricht von der Front";
      ["faction"] = "Horde";
      ["name"] = "Page from the Front";
      ["level"] = 60;
      ["name_es"] = "Una pagina del frente";
      ["req"] = 55;
   };
   [9332] = {
      ["name_ru"] = "Похищение пламени Дарнаса";
      ["type"] = "Solo";
      ["objective"] = "Return the Flame of Darnassus to the Festival Talespinner.";
      ["name_fr"] = "Voler la flamme de Darnassus";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗取???斯的烈?";
      ["followup"] = 9339;
      ["reward"] = {
         [1] = 23435;
         [2] = 23247;
         [3] = 23327;
         [4] = 23326;
         [5] = 23211;
      };
      ["name_de"] = "Raubt die Flamme von Darnassus";
      ["faction"] = "Horde";
      ["name"] = "Stealing Darnassus's Flame";
      ["level"] = 60;
      ["name_es"] = "Robar la llama de Darnassus";
      ["req"] = 50;
   };
   [9364] = {
      ["name_ru"] = "Частицы магии";
      ["type"] = "Solo";
      ["name_fr"] = "Magie morcelee";
      ["name_de"] = "Gespaltene Magie";
      ["objective"] = "Polymorph the Spitelash of Azshara and kill the clones that appear several seconds later.  When you have slain 50 Polymorph Clones, return to Archmage Xylem in Azshara.";
      ["name_cn"] = "魔法的碎片";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Fragmented Magic";
      ["prev"] = 9362;
      ["prequests"] = {
         [1] = 9362;
      };
      ["level"] = 60;
      ["name_es"] = "Magia fragmentada";
      ["req"] = 60;
   };
   [2358] = {
      ["name_ru"] = "Рога Нез'ры";
      ["type"] = "Solo";
      ["objective"] = "Return the Horns of Nez'ra to Arantir's Shadow in Lakeshire.";
      ["name_fr"] = "Cornes de Nez'ra";
      ["sort"] = "Rogue";
      ["name_cn"] = "奈?拉之角*";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 7676;
      };
      ["name_de"] = "Horner von Nez'ra";
      ["faction"] = "Horde";
      ["name"] = "Horns of Nez'ra";
      ["level"] = 22;
      ["name_es"] = "Cuernos de Nez'ra";
      ["req"] = 16;
   };
   [4731] = {
      ["name_ru"] = "Останки морской черепахи";
      ["type"] = "Solo";
      ["name_fr"] = "La tortue de mer echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meeresschildkrote";
      ["name_cn"] = "?浅的海?";
      ["name"] = "Beached Sea Turtle";
      ["objective"] = "Take the Strangely Marked Box to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 19;
      ["name_es"] = "Tortuga marina varada";
      ["req"] = 13;
   };
   [4763] = {
      ["name_ru"] = "Порабощенные фурболги Чернолесья";
      ["type"] = "Solo";
      ["objective"] = "Fill the Empty Cleansing Bowl at the Auberdine Moonwell.$B$BGather a sample of fruit, nut, and grain from the northern Blackwood furbolg camps.$B$BMix the bowl and place it near the bonfire closest to the Cliffspring River at the northern camp, thus summoning the satyr corruptor.$B$BTake the Talisman of Corruption and bring it to Thundris Windweaver in Auberdine.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Die verderbten Schwarzfelle";
      ["reward"] = {
         [1] = 15204;
         [2] = 15202;
         [3] = 15203;
      };
      ["name_cn"] = "黑木熊怪的堕落";
      ["name_fr"] = "La corruption des Noirbois";
      ["faction"] = "Alliance";
      ["name"] = "The Blackwood Corrupted";
      ["sort"] = "Darkshore";
      ["prev"] = 4762;
      ["prequests"] = {
         [1] = 4762;
      };
      ["level"] = 18;
      ["name_es"] = "La corrupcion de los Bosque Negro";
      ["req"] = 15;
   };
   [2398] = {
      ["name_ru"] = "Потерянные дворфы";
      ["type"] = "Dungeon";
      ["objective"] = "Find Baelog in Uldaman.";
      ["next"] = 2240;
      ["sort"] = "Uldaman";
      ["name_cn"] = "失踪的矮人";
      ["name_fr"] = "Les nains perdus";
      ["name_de"] = "Die verschollenen Zwerge";
      ["faction"] = "Alliance";
      ["name"] = "The Lost Dwarves";
      ["level"] = 40;
      ["name_es"] = "Los enanos desaparecidos";
      ["req"] = 35;
   };
   [4811] = {
      ["name_ru"] = "Красный кристалл";
      ["type"] = "Solo";
      ["objective"] = "Travel east of Auberdine and look for a large, red crystal along Darkshore's eastern mountain range.  Report back what you find to Sentinel Glynda Nal'Shea in Auberdine.";
      ["next"] = 4812;
      ["name_fr"] = "Le cristal rouge";
      ["sort"] = "Darkshore";
      ["name_cn"] = "?色水晶";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Der rote Kristall";
      ["faction"] = "Alliance";
      ["name"] = "The Red Crystal";
      ["level"] = 14;
      ["name_es"] = "El cristal rojo";
      ["req"] = 12;
   };
   [2438] = {
      ["name_ru"] = "Изумрудный ловец снов";
      ["type"] = "Solo";
      ["objective"] = "Bring the Emerald Dreamcatcher to Tallonkai Swiftroot in Dolanaar.";
      ["next"] = 2459;
      ["name_fr"] = "Le Captureve d'emeraude";
      ["sort"] = "Teldrassil";
      ["name_cn"] = "翡翠?梦符";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Der smaragdgrune Traumfanger";
      ["faction"] = "Alliance";
      ["name"] = "The Emerald Dreamcatcher";
      ["level"] = 6;
      ["name_es"] = "El atrapasuenos esmeralda";
      ["req"] = 1;
   };
   [4907] = {
      ["name_ru"] = "Тинки Кипеллер";
      ["type"] = "Raid";
      ["name_fr"] = "Brikolette Toutevapeur";
      ["next"] = 4734;
      ["name_de"] = "Tinkee Kesseldampf";
      ["name_cn"] = "丁奇・斯迪波?";
      ["objective"] = "Speak with Tinkee Steamboil.";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "Tinkee Steamboil";
      ["prev"] = 4810;
      ["prequests"] = {
         [1] = 4810;
      };
      ["level"] = 60;
      ["name_es"] = "Tinkee Vaporio";
      ["req"] = 57;
   };
   [2478] = {
      ["name_ru"] = "Миссия: выполнима, но с трудом";
      ["objective"] = "Steal Silixiz's Tower Key from Foreman Silixiz, then kill two Mutated Venture Co. Drones, two Venture Co. Patrollers, and two Venture Co. Lookouts.$B$BAssassinate Grand Foreman Gallywix and take his head, then pick the lock on Gallywix's lockbox and steal the Cache of Zanzil's Altered Mixture. Take the Cache and Gallywix's Head back to Shenthul in Orgrimmar for further instruction.$B";
      ["name_cn"] = "基本不可能的任?";
      ["sort"] = "Rogue";
      ["level"] = 24;
      ["type"] = "Group";
      ["name_fr"] = "Mission?: Possible mais non probable";
      ["next"] = 2479;
      ["name_de"] = "Mission: moglich, aber nicht sehr wahrscheinlich";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 18160;
      };
      ["name"] = "Mission: Possible But Not Probable";
      ["prev"] = 2458;
      ["prequests"] = {
         [1] = 2458;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Mision: Posible, pero no probable";
      ["req"] = 20;
   };
   [4971] = {
      ["name_ru"] = "Вопрос времени";
      ["type"] = "Solo";
      ["objective"] = "Use the Temporal Displacer near one of Andorhal's silos and uncover Temporal Parasites.$B$BSlay 10 Temporal Parasites, and then return the Temporal Displacer to Chromie in the Andorhal Inn, Western Plaguelands.";
      ["name_fr"] = "Une question de temps";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "????";
      ["reward"] = {
         [1] = 15812;
         [2] = 15813;
      };
      ["name_de"] = "Eine Frage der Zeit";
      ["faction"] = "Horde";
      ["name"] = "A Matter of Time";
      ["level"] = 56;
      ["name_es"] = "Una cuestion de tiempo";
      ["req"] = 53;
   };
   [4987] = {
      ["name_ru"] = "Покрытая письменами дубовая ветвь";
      ["type"] = "Solo";
      ["objective"] = "Based on the magic enchanted within the Glyphed Oaken Branch, its delivery to the Cenarion Circle in Thunder Bluff is the next step the tauren druid sought.  Seek one of the druids there for assistance.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Glyphenverzierter Eichenast";
      ["reward"] = {
         [1] = 15804;
      };
      ["name_cn"] = "雕文橡木枝";
      ["name_fr"] = "La branche de chene a glyphes";
      ["faction"] = "Horde";
      ["name"] = "Glyphed Oaken Branch";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 4985;
      ["prequests"] = {
         [1] = 4985;
      };
      ["level"] = 56;
      ["name_es"] = "Rama de roble con inscripciones";
      ["req"] = 51;
   };
   [2518] = {
      ["name_ru"] = "Слезы Луны";
      ["type"] = "Solo";
      ["objective"] = "Priestess A'moora in the Temple of the Moon at Darnassus wants you to bring her Lady Sathrah's Silvery Spinnerets.";
      ["next"] = 2520;
      ["name_fr"] = "Les larmes de la Lune";
      ["sort"] = "Darnassus";
      ["name_cn"] = "月神的泪水";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Tranen des Mondes";
      ["faction"] = "Alliance";
      ["name"] = "Tears of the Moon";
      ["level"] = 12;
      ["name_es"] = "Las lagrimas de la Luna";
      ["req"] = 5;
   };
   [5051] = {
      ["name_ru"] = "Вторая половина";
      ["type"] = "Solo";
      ["name_fr"] = "Deux moities deviennent Une";
      ["name_de"] = "Zwei Halften vereint";
      ["name_cn"] = "?半合一";
      ["objective"] = " John.  Bring me your charm";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Two Halves Become One";
      ["prev"] = 5050;
      ["prequests"] = {
         [1] = 5050;
      };
      ["level"] = 54;
      ["name_es"] = "Dos mitades hacen una";
      ["req"] = 50;
   };
   [5067] = {
      ["name_ru"] = "Поножи Тайны";
      ["type"] = "Group";
      ["name_fr"] = "Jambieres d'Arcana";
      ["name_de"] = "Gamaschen von Arcana";
      ["reward"] = {
         [1] = 12756;
      };
      ["name_cn"] = "阿???腿";
      ["objective"] = "In order to create the Leggings of Arcana, you will be required to bring the following items back to Malyfous Darkhammer: 1 Pristine Hide of the Beast; 5 Frayed Abomination Stitchings; 5 Arcanite Bars; 5 Frostwhisper's Embalming Fluid.$B$BYou will also be required to pay 50 gold pieces for the crafting of the item.";
      ["faction"] = "Horde";
      ["name"] = "Leggings of Arcana";
      ["sort"] = "Winterspring";
      ["prev"] = 5047;
      ["prequests"] = {
         [1] = 5047;
      };
      ["level"] = 50;
      ["name_es"] = "Leotardos de Arcana";
      ["req"] = 57;
   };
   [5083] = {
      ["name_ru"] = "Огненная вода племени Зимней Спячки";
      ["type"] = "Solo";
      ["objective"] = "Bring the Empty Firewater Flask to Donova Snowden in Winterspring.";
      ["next"] = 5084;
      ["name_fr"] = "L'eau-de-feu de Tombe-hiver";
      ["sort"] = "Winterspring";
      ["name_cn"] = "冬泉火酒";
      ["repgain"] = {
         [577] = 75;
      };
      ["name_de"] = "Feuerwasser der Winterfelle";
      ["faction"] = "Horde";
      ["name"] = "Winterfall Firewater";
      ["level"] = 56;
      ["name_es"] = "Aguardiente Nevada";
      ["req"] = 52;
   };
   [5147] = {
      ["name_ru"] = "Разыскивается: Арнак Зловещий Тотем";
      ["type"] = "Solo";
      ["objective"] = "Slay Arnak Grimtotem and bring proof of your deed to Cliffwatcher Longhorn in Freewind Post.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Thousand Needles";
      ["name_fr"] = "On recherche?: Arnak Totem-sinistre";
      ["name_cn"] = "通?：阿?克・恐怖??";
      ["reward"] = {
         [1] = 15471;
         [2] = 15470;
      };
      ["name_de"] = "GESUCHT: Arnak Grimmtotem";
      ["faction"] = "Horde";
      ["name"] = "Wanted - Arnak Grimtotem";
      ["level"] = 29;
      ["name_es"] = "Se busca: Arnak Totem Siniestro";
      ["req"] = 25;
   };
   [2582] = {
      ["name_ru"] = "Вековая ярость";
      ["type"] = "Solo";
      ["name_fr"] = "La colere des ages";
      ["name_de"] = "Wut der Zeiten";
      ["reward"] = {
         [1] = 8410;
      };
      ["name_cn"] = "?古之怒";
      ["objective"] = "Bring three Snickerfang Jowls, two Blasted Boar Lungs, and one Scorpok Pincer to Bloodmage Drazial.";
      ["faction"] = "Horde";
      ["name"] = "Rage of Ages";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2581;
      ["prequests"] = {
         [1] = 2581;
      };
      ["level"] = 50;
      ["name_es"] = "Ira de las Eras";
      ["req"] = 45;
   };
   [2606] = {
      ["name_ru"] = "Хороший вкус";
      ["type"] = "Solo";
      ["name_fr"] = "De bon gout";
      ["next"] = 2641;
      ["name_de"] = "Dem guten Geschmacke";
      ["name_cn"] = "好味道";
      ["objective"] = "Marin Noggenfogger wants you to speak with Sprinkle in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "In Good Taste";
      ["prev"] = 2605;
      ["prequests"] = {
         [1] = 2605;
      };
      ["level"] = 49;
      ["name_es"] = "Un buen sabor";
      ["req"] = 44;
   };
   [5227] = {
      ["name_ru"] = "Котел пустоши Гаррона";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["name_de"] = "Der Kessel von Gahrrons Trauerfeld";
      ["name_cn"] = "盖?恩??的瘟疫之?";
      ["name_fr"] = "Le chaudron de la Fletrissure de Gahrron";
      ["name"] = "Gahrron's Withering Cauldron";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5237;
      ["prequests"] = {
         [1] = 5237;
         [2] = 5225;
         [3] = 5235;
      };
      ["level"] = 58;
      ["name_es"] = "La caldera de la Gangrena de Gahrron";
      ["req"] = 50;
   };
   [2622] = {
      ["name_ru"] = "Пропавшие приказы";
      ["type"] = "Solo";
      ["name_fr"] = "Les ordres disparus";
      ["next"] = 2623;
      ["name_de"] = "Die fehlenden Befehle";
      ["name_cn"] = "?失的命令";
      ["objective"] = "Speak to Bengor.";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "The Missing Orders";
      ["prev"] = 2621;
      ["prequests"] = {
         [1] = 2621;
      };
      ["level"] = 50;
      ["name_es"] = "Las ordenes perdidas";
      ["req"] = 45;
   };
   [5307] = {
      ["name_ru"] = "Скверна";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Black Guard Swordsmith in Stratholme and destroy him. Recover the Insignia of the Black Guard and return to Seril Scourgebane.";
      ["name_fr"] = "Corruption";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "腐?";
      ["reward"] = {
         [1] = 12825;
      };
      ["name_de"] = "Verderbnis";
      ["faction"] = "Horde";
      ["name"] = "Corruption";
      ["level"] = 60;
      ["name_es"] = "Corrupcion";
      ["req"] = 50;
   };
   [2662] = {
      ["name_ru"] = "Эликсир Гогельмогеля";
      ["type"] = "Solo";
      ["name_fr"] = "Elixir Brouillecaboche";
      ["name_de"] = "Noggenfoggers Elixier";
      ["reward"] = {
         [1] = 8529;
      };
      ["name_cn"] = "?格弗格??";
      ["objective"] = "Marin Noggenfogger wants you to speak to him again after he creates his elixir.";
      ["faction"] = "Horde";
      ["name"] = "Noggenfogger Elixir";
      ["sort"] = "Tanaris";
      ["prev"] = 2661;
      ["prequests"] = {
         [1] = 2661;
      };
      ["level"] = 49;
      ["name_es"] = "El elixir de Tragonublo";
      ["req"] = 44;
   };
   [2702] = {
      ["name_ru"] = "Герои древних времен";
      ["type"] = "Solo";
      ["name_fr"] = "Les heros des Anciens";
      ["next"] = 2701;
      ["name_de"] = "Helden der Vergangenheit";
      ["name"] = "Heroes of Old";
      ["name_cn"] = "古代英雄";
      ["objective"] = "Speak to Corporal Thund Splithoof.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2681;
      ["prequests"] = {
         [1] = 2681;
      };
      ["level"] = 57;
      ["name_es"] = "Los heroes de los antiguos";
      ["req"] = 45;
   };
   [2742] = {
      ["name_ru"] = "Рин'джи в ловушке";
      ["type"] = "Solo";
      ["objective"] = "Escort Rin'ji out of the Quel'Danil Lodge, then find his hidden secret at the Overlook Cliffs to the east.";
      ["next"] = 2782;
      ["name_fr"] = "Rin'ji est pris au piege?!";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "林吉被困住了！";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Rin'ji steckt in der Falle!";
      ["faction"] = "Horde";
      ["name"] = "Rin'ji is Trapped!";
      ["level"] = 47;
      ["name_es"] = "!Capturaron a Rin'ji!";
      ["req"] = 42;
   };
   [2750] = {
      ["name_ru"] = "Плохое яйцо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 10;
         [69] = 10;
      };
      ["name_de"] = "Ein schlechtes Ei";
      ["name_cn"] = "坏掉的蛋";
      ["name_fr"] = "Un mauvais ?uf";
      ["name"] = "A Bad Egg";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 2741;
      ["prequests"] = {
         [1] = 2741;
      };
      ["level"] = 47;
      ["name_es"] = "Un huevo pasado";
      ["req"] = 42;
   };
   [5515] = {
      ["name_ru"] = "Мешок ужасов Крастинова";
      ["type"] = "Dungeon";
      ["name_fr"] = "Sac des horreurs de Krastinov";
      ["next"] = 5384;
      ["name_de"] = "Krastinovs Tasche der Schrecken";
      ["name_cn"] = "?斯迪?夫的恐惧之袋";
      ["objective"] = "Locate Jandice Barov in the Scholomance and destroy her. From her corpse recover Krastinov's Bag of Horrors. Return the bag to Eva Sarkhoff.";
      ["sort"] = "Scholomance";
      ["faction"] = "Horde";
      ["name"] = "Krastinov's Bag of Horrors";
      ["prev"] = 5382;
      ["prequests"] = {
         [1] = 5382;
      };
      ["level"] = 60;
      ["name_es"] = "Bolsa de los horrores de Krastinov";
      ["req"] = 55;
   };
   [5531] = {
      ["name_ru"] = "Бетина Биггльцинк";
      ["type"] = "Dungeon";
      ["name_fr"] = "Betina Bigglezink";
      ["next"] = 4771;
      ["name_de"] = "Betina Moppelzink";
      ["name_cn"] = "?蒂娜・比格辛克";
      ["objective"] = "Bring the Frozen Eggs to Betina Bigglezink.";
      ["sort"] = "Scholomance";
      ["faction"] = "Horde";
      ["name"] = "Betina Bigglezink";
      ["prev"] = 5522;
      ["prequests"] = {
         [1] = 5522;
      };
      ["level"] = 60;
      ["name_es"] = "Betina Bigglezink";
      ["req"] = 57;
   };
   [2782] = {
      ["name_ru"] = "Секрет Рин'джи";
      ["type"] = "Solo";
      ["name_fr"] = "Secret de Rin'ji";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Rin'jis Geheimnis";
      ["name_cn"] = "林吉的秘密";
      ["name"] = "Rin'ji's Secret";
      ["objective"] = "Oran Snakewrithe, a well known scholar on matters concerning the Witherbark trolls, may be able to decipher the tablet. She is known to reside within the Magic Quarter of the Undercity.";
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2742;
      ["prequests"] = {
         [1] = 2742;
      };
      ["level"] = 47;
      ["name_es"] = "El secreto de Rin'ji";
      ["req"] = 42;
   };
   [5627] = {
      ["name_ru"] = "Звезды Элуны";
      ["type"] = "Solo";
      ["name_fr"] = "Etoiles d'Elune";
      ["sort"] = "Priest";
      ["name_cn"] = "艾露恩之星*";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name_de"] = "Sterne von Elune";
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Stars of Elune";
      ["prequests"] = {
         [1] = 5628;
         [2] = 5629;
         [3] = 5630;
         [4] = 5631;
         [5] = 5632;
         [6] = 5633;
      };
      ["level"] = 10;
      ["name_es"] = "Estrellas de Elune";
      ["req"] = 10;
   };
   [5643] = {
      ["name_ru"] = "Страж Тьмы";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Schattenwache";
      ["sort"] = "Priest";
      ["name_cn"] = "暗影守?";
      ["name_fr"] = "Garde de l'ombre";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Shadowguard";
      ["level"] = 20;
      ["name_es"] = "Guardia de las Sombras";
      ["req"] = 20;
   };
   [5675] = {
      ["name_ru"] = "Благодать Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["name_de"] = "Elunes Anmut";
      ["sort"] = "Priest";
      ["name_cn"] = "艾露恩的?福";
      ["name_fr"] = "Grace d'Elune";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Elune's Grace";
      ["level"] = 20;
      ["name_es"] = "La Gracia de Elune";
      ["req"] = 20;
   };
   [2846] = {
      ["name_ru"] = "Тиара Глубин";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Tiara of the Deep to Tabetha in Dustwallow Marsh.";
      ["name_fr"] = "La tiare des abysses";
      ["sort"] = "Zul'Farrak";
      ["name_cn"] = "深渊皇冠";
      ["reward"] = {
         [1] = 9527;
         [2] = 9531;
      };
      ["name_de"] = "Tiara der Tiefen";
      ["faction"] = "Horde";
      ["name"] = "Tiara of the Deep";
      ["level"] = 46;
      ["name_es"] = "Tiara de las profundidades";
      ["req"] = 40;
   };
   [2854] = {
      ["name_ru"] = "Дикарские кожаные доспехи";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Leather to Jangdor Swiftstrider in Camp Mojache.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "蛮皮?甲";
      ["name_fr"] = "L'armure en cuir fauve";
      ["name_de"] = "Wildlederrustung";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Armor";
      ["level"] = 45;
      ["name_es"] = "Armadura de cuero salvaje";
      ["req"] = 30;
   };
   [5723] = {
      ["name_ru"] = "Испытание силы врага";
      ["type"] = "Dungeon";
      ["objective"] = "Search Orgrimmar for Ragefire Chasm, then kill 8 Ragefire Troggs and 8 Ragefire Shaman before returning to Rahauro in Thunder Bluff.";
      ["repgain"] = {
         [81] = 500;
      };
      ["name_fr"] = "Tester la force de l'ennemi";
      ["sort"] = "Ragefire Chasm";
      ["name_cn"] = "?探?人";
      ["name_de"] = "Die Kraft des Feindes wird auf die Probe gestellt";
      ["faction"] = "Horde";
      ["name"] = "Testing an Enemy's Strength";
      ["level"] = 15;
      ["name_es"] = "Midiendo fuerzas con el enemigo";
      ["req"] = 9;
   };
   [2870] = {
      ["name_ru"] = "Борьба с лордом Шалзару";
      ["type"] = "Solo";
      ["name_fr"] = "Contre le seigneur Shalzaru";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Gegen Lord Shalzaru";
      ["name"] = "Against Lord Shalzaru";
      ["name_cn"] = "??沙?扎?";
      ["objective"] = "Eliminate Lord Shalzaru, and then bring the Mysterious Relic he uncovered to Latronicus Moonspear in Feathermoon Stronghold.";
      ["next"] = 2871;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2869;
      ["prequests"] = {
         [1] = 2869;
      };
      ["level"] = 45;
      ["name_es"] = "En contra de Lord Shalzaru";
      ["req"] = 40;
   };
   [2878] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [5803] = {
      ["name_ru"] = "Скарабей Аража";
      ["type"] = "Group";
      ["name_fr"] = "Le Scarabee d'Araj";
      ["name_de"] = "Arajs Skarabaus";
      ["name_cn"] = "阿拉基的?甲虫";
      ["objective"] = "Destroy Araj the Summoner and bring Araj's Scarab to Alchemist Arbington at Chillwind Point, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "Araj's Scarab";
      ["prev"] = 5801;
      ["prequests"] = {
         [1] = 5801;
      };
      ["level"] = 60;
      ["name_es"] = "El escarabeo de Araj";
      ["req"] = 55;
   };
   [2926] = {
      ["name_ru"] = "Новая формула";
      ["type"] = "Dungeon";
      ["name_fr"] = "Gnogaine";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Gnogaine";
      ["name"] = "Gnogaine";
      ["name_cn"] = "?恩";
      ["objective"] = "Use the Empty Leaden Collection Phial on Irradiated Invaders or Irradiated Pillagers to collect radioactive fallout. Once it is full, take it back to Ozzie Togglevolt in Kharanos.";
      ["next"] = 2962;
      ["faction"] = "Alliance";
      ["sort"] = "Gnomeregan";
      ["prev"] = 2927;
      ["prequests"] = {
         [1] = 2927;
      };
      ["level"] = 27;
      ["name_es"] = "Gnogaine";
      ["req"] = 20;
   };
   [2934] = {
      ["name_ru"] = "Неповрежденная ядовитая железа";
      ["type"] = "Solo";
      ["name_fr"] = "Glande a venin intacte";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Unbeschadigter Giftbeutel";
      ["name"] = "Undamaged Venom Sac";
      ["name_cn"] = "完好无?的毒?";
      ["objective"] = "Bring an Undamaged Venom Sac to Apothecary Lydon in Tarren Mill.";
      ["next"] = 2935;
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2933;
      ["prequests"] = {
         [1] = 2933;
      };
      ["level"] = 45;
      ["name_es"] = "Glandula de veneno intacta";
      ["req"] = 40;
   };
   [5883] = {
      ["name_ru"] = "Лекарство из минералов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Bergbau";
      ["name_fr"] = "Du baume par la pioche";
      ["name_cn"] = "采???膏";
      ["name"] = "Salve via Mining";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4102;
      ["prequests"] = {
         [1] = 4102;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por mineria";
      ["req"] = 48;
   };
   [2950] = {
      ["name_ru"] = "Переделка кольца";
      ["type"] = "Solo";
      ["objective"] = "Bring the Brilliant Gold Ring, a Silver Bar, a Moss Agate, and 30 silver coins to Nogg in Orgrimmar.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Noggs Ringerneuerung";
      ["reward"] = {
         [1] = 9588;
      };
      ["name_cn"] = "?格的手?";
      ["name_fr"] = "Nogg ameliore l'anneau";
      ["faction"] = "Horde";
      ["name"] = "Nogg's Ring Redo";
      ["sort"] = "Orgrimmar";
      ["prev"] = 2949;
      ["prequests"] = {
         [1] = 2949;
      };
      ["level"] = 35;
      ["name_es"] = "Nogg mejora el anillo";
      ["req"] = 28;
   };
   [5931] = {
      ["name_ru"] = "Возвращение в Дарнас";
      ["objective"] = "Return to Darnassus and speak with Mathrengyl Bearwalker in the Cenarion Enclave.";
      ["name_cn"] = "返回???斯";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Retour a Darnassus";
      ["next"] = 6001;
      ["name_de"] = "Zuruck nach Darnassus";
      ["classes"] = {
         [1] = "Druid";
      };
      ["sort"] = "Druid";
      ["name"] = "Back to Darnassus";
      ["prev"] = 5929;
      ["prequests"] = {
         [1] = 5929;
      };
      ["followup"] = 6001;
      ["name_es"] = "El regreso a Darnassus";
      ["req"] = 10;
   };
   [2974] = {
      ["name_ru"] = "Зловещее открытие";
      ["objective"] = "Bring 20 Grimtotem Horns to Krueg Skullsplitter in Camp Mojache.";
      ["name_cn"] = "可怕的??";
      ["sort"] = "Feralas";
      ["level"] = 45;
      ["type"] = "Solo";
      ["name_fr"] = "Une decouverte sinistre";
      ["next"] = 2976;
      ["name_de"] = "Eine grausige Entdeckung";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "A Grim Discovery";
      ["prev"] = 2973;
      ["prequests"] = {
         [1] = 2973;
      };
      ["series"] = 1;
      ["name_es"] = "Un descubrimiento siniestro";
      ["req"] = 38;
   };
   [2982] = {
      ["name_ru"] = "Высокогорные дебри";
      ["type"] = "Solo";
      ["objective"] = "Angelas Moonbreeze wants you to kill 8 Gordunni Warlocks, 8 Gordunni Shaman, and 8 Gordunni Brutes.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Les Plateaux sauvages";
      ["sort"] = "Feralas";
      ["name_cn"] = "高原荒野";
      ["name_de"] = "Die Obere Wildnis";
      ["faction"] = "Alliance";
      ["name"] = "The High Wilderness";
      ["level"] = 44;
      ["name_es"] = "Las Altas Tierras Salvajes";
      ["req"] = 39;
   };
   [2990] = {
      ["name_ru"] = "Тадиус Мрачная Тень";
      ["type"] = "Solo";
      ["name_fr"] = "Thadius Sinissombre";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Thadius Grimmschatten";
      ["name"] = "Thadius Grimshade";
      ["name_cn"] = "?迪斯・格希德";
      ["objective"] = "Bring Sharpbeak's Feather to Thadius Grimshade in the Blasted Lands.";
      ["next"] = 2991;
      ["faction"] = "Alliance";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2989;
      ["prequests"] = {
         [1] = 2989;
      };
      ["level"] = 47;
      ["name_es"] = "Thadius Sombramacabra";
      ["req"] = 40;
   };
   [2998] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["next"] = 1641;
      ["name_de"] = "Foliant der Offenbarung";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["name_fr"] = "Le Tome de divinite";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Tome of Divinity";
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [6027] = {
      ["name_ru"] = "Книга Древних";
      ["type"] = "Solo";
      ["objective"] = "Get the Book of the Ancients and return it to Azore Aldamort at the tower in Ethel Rethor.$B";
      ["repgain"] = {
         [529] = 350;
      };
      ["name_de"] = "Buch der Uralten";
      ["reward"] = {
         [1] = 16791;
         [2] = 16793;
      };
      ["name_cn"] = "上古之?";
      ["name_fr"] = "Le Livre des Anciens";
      ["faction"] = "Horde";
      ["name"] = "Book of the Ancients";
      ["sort"] = "Desolace";
      ["prev"] = 5741;
      ["prequests"] = {
         [1] = 5741;
      };
      ["level"] = 38;
      ["name_es"] = "El Libro de los Ancestros";
      ["req"] = 30;
   };
   [3022] = {
      ["name_ru"] = "Не кантовать!";
      ["type"] = "Solo";
      ["objective"] = "Bring the Carefully-packed Crate to Erelas Ambersky in Rut'theran Village.";
      ["sort"] = "Tanaris";
      ["name_cn"] = "小心?送";
      ["name_fr"] = "A manipuler avec soin";
      ["name_de"] = "Vorsichtig behandeln";
      ["faction"] = "Alliance";
      ["name"] = "Handle With Care";
      ["level"] = 47;
      ["name_es"] = "Un envio fragil";
      ["req"] = 42;
   };
   [6075] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Grif Wildheart in Kharanos.";
      ["next"] = 6064;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6123] = {
      ["name_ru"] = "Сбор лекарственных ингредиентов";
      ["objective"] = "Bring 5 Earthroot and 12 Lunar Funguses to Alanndarian Nightsong in Auberdine so she may make a curative salve.";
      ["name_cn"] = "收集解?";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Rassembler les ingredients du remede";
      ["next"] = 6124;
      ["name_de"] = "Das Heilmittel sammeln";
      ["classes"] = {
         [1] = "Druid";
      };
      ["repgain"] = {
         [609] = 150;
      };
      ["name"] = "Gathering the Cure";
      ["prev"] = 6122;
      ["prequests"] = {
         [1] = 6122;
      };
      ["sort"] = "Druid";
      ["name_es"] = "Reunir los ingredientes del remedio";
      ["req"] = 14;
   };
   [3086] = {
      ["name_ru"] = "Табличка с тайными знаками";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette glyphee";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Glyphenschrifttafel";
      ["objective"] = "Read the Glyphic Tablet and speak with Mai'ah near the entrance to the Den in the Valley of Trials.";
      ["name_cn"] = "雕文石板";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Glyphic Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Tablilla glifica";
      ["req"] = 1;
   };
   [3094] = {
      ["name_ru"] = "Зеленая записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note verdoyante";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Tiefgrune Notiz";
      ["objective"] = "Read the Verdant Note and speak to Gart Mistrunner in Camp Narache.";
      ["name_cn"] = "?色便?";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Verdant Note";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 747;
      ["prequests"] = {
         [1] = 747;
      };
      ["level"] = 1;
      ["name_es"] = "La nota verdeante";
      ["req"] = 1;
   };
   [3102] = {
      ["name_ru"] = "Зашифрованное письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre codee";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Verschlusselter Brief";
      ["objective"] = "Read the Encrypted Letter and speak to Jorik Kerridan in the stable behind Northshire Abbey.";
      ["name_cn"] = "密文信件";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta cifrada";
      ["req"] = 1;
   };
   [8341] = {
      ["name_ru"] = "Лорды Совета";
      ["type"] = "Group";
      ["name_fr"] = "Les seigneurs du conseil";
      ["next"] = 8351;
      ["name_de"] = "Lords des Rates";
      ["reward"] = {
         [1] = 20451;
      };
      ["name_cn"] = "?会?主";
      ["objective"] = "Bring 5 Large Brilliant Shards and 3 Abyssal Signets to Aurel Goldleaf in Cenarion Hold.";
      ["faction"] = "Horde";
      ["name"] = "Lords of the Council";
      ["sort"] = "Silithus";
      ["prev"] = 8343;
      ["prequests"] = {
         [1] = 8343;
      };
      ["level"] = 60;
      ["name_es"] = "Senores del Consejo";
      ["req"] = 60;
   };
   [8373] = {
      ["name_ru"] = "Сила сосен";
      ["type"] = "PvP";
      ["objective"] = "Use a Stink Bomb Cleaner to remove any Forsaken Stink Bomb that's been dropped on Southshore.  Return to Sergeant Hartman in Southshore when you're done.";
      ["name_fr"] = "La puissance du pin";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "松木的力量";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_de"] = "Die Kraft der Pinie";
      ["faction"] = "Alliance";
      ["name"] = "The Power of Pine";
      ["level"] = 60;
      ["name_es"] = "El poder del pino";
      ["req"] = 25;
   };
   [8405] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["sort"] = "Warsong Gulch";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["prev"] = 8400;
      ["prequests"] = {
         [1] = 8400;
      };
      ["level"] = 39;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 30;
   };
   [8437] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
      };
      ["name_fr"] = "La conquete du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?源??";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["level"] = 49;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 40;
   };
   [6283] = {
      ["name_ru"] = "Предводительница стаи Кровавой Ярости";
      ["type"] = "Group";
      ["objective"] = "Maggran at Sun Rock Retreat wishes you to slay Bloodfury Ripper and bring her remains as proof of your deed.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Blutfuriengeschlecht";
      ["reward"] = {
         [1] = 16990;
         [2] = 16987;
      };
      ["name_cn"] = "血怒一族";
      ["name_fr"] = "La lignee Rougefurie";
      ["faction"] = "Horde";
      ["name"] = "Bloodfury Bloodline";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 6282;
      ["prequests"] = {
         [1] = 6282;
      };
      ["level"] = 26;
      ["name_es"] = "El linaje Furia Sangrienta";
      ["req"] = 18;
   };
   [8501] = {
      ["name_ru"] = "Цель: острожалы из улья Аши";
      ["type"] = "Group";
      ["objective"] = "Kill 30 Hive'Ashi Stingers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing XII in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les aiguillonneurs de la Ruche'Ashi";
      ["name_cn"] = "目?：?什毒蝎";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Stecher des Ashischwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Ashi Stingers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los aguijoneros Colmen'Ashi";
      ["req"] = 60;
   };
   [8533] = {
      ["name_ru"] = "Орде по-прежнему не хватает медных слитков!";
      ["type"] = "Solo";
      ["name_fr"] = "La Horde a besoin de plus de barres de cuivre !";
      ["name_de"] = "Die Horde braucht mehr Kupferbarren!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21509;
      };
      ["name_cn"] = "部落需要更多??！";
      ["objective"] = "Bring 20 copper bars to Miner Cromwell in Durotar.";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs More Copper Bars!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8532;
      ["prequests"] = {
         [1] = 8532;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas lingotes de cobre!";
      ["req"] = 1;
   };
   [8565] = {
      ["name_ru"] = "Былые победы в Арати";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "往日的?利：阿拉希盆地";
      ["reward"] = {
         [1] = 20559;
      };
      ["name_de"] = "Vergangene Siege im Arathibecken";
      ["faction"] = "Alliance";
      ["name"] = "Past Victories in Arathi";
      ["level"] = 1;
      ["name_es"] = "Victorias del pasado en Arathi";
      ["req"] = 1;
   };
   [8597] = {
      ["name_ru"] = "\"Драконий язык для чайников\"";
      ["type"] = "Solo";
      ["name_fr"] = "Le draconique pour les nuls";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "Drachisch fur Dummies";
      ["name"] = "Draconic for Dummies";
      ["name_cn"] = "???瓜教程";
      ["objective"] = "Find Narain Soothfancy's book, buried on an island in the South Seas.";
      ["next"] = 8598;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8576;
      ["prequests"] = {
         [1] = 8576;
      };
      ["level"] = 60;
      ["name_es"] = "Draconico para torpes";
      ["req"] = 60;
   };
   [6363] = {
      ["name_ru"] = "Укротитель ветрокрылов Тал";
      ["type"] = "Solo";
      ["name_fr"] = "Tal, le maitre des coursiers du vent";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_de"] = "Tal der Windreitermeister";
      ["objective"] = "Bring Ahanu's Leather Goods to Tal in Thunder Bluff.";
      ["name_cn"] = "双足??管理?塔?";
      ["next"] = 6364;
      ["sort"] = "The Barrens";
      ["name"] = "Tal the Wind Rider Master";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 6362;
      ["prequests"] = {
         [1] = 6362;
      };
      ["level"] = 10;
      ["name_es"] = "Tal, maestro de jinetes del viento";
      ["req"] = 10;
   };
   [8661] = {
      ["name_ru"] = "Одеяния Призывателя рока";
      ["objective"] = "Bring the the Husk of the Old God, 2 Idols of Night, 5 Stone Scarabs and 5 Crystal Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "厄?召?者的?袍";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La robe d'implorateur funeste";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Roben des Verdammnisrufers";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21334;
      };
      ["name"] = "Doomcaller's Robes";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las togas clamacondenas";
      ["req"] = 60;
   };
   [6395] = {
      ["name_ru"] = "Последнее желание Марлы";
      ["type"] = "Solo";
      ["name_fr"] = "La derniere volonte de Marla";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Marlas letzter Wunsch";
      ["name_cn"] = "?拉的?愿";
      ["name"] = "Marla's Last Wish";
      ["objective"] = "Bring Samuel Fipps' Remains to Marla's Grave, then return to Novice Elreth.";
      ["faction"] = "Horde";
      ["sort"] = "Deathknell";
      ["prev"] = 376;
      ["prequests"] = {
         [1] = 376;
      };
      ["level"] = 5;
      ["name_es"] = "El ultimo deseo de Marla";
      ["req"] = 3;
   };
   [8725] = {
      ["name_ru"] = "Предок Речная Песня";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Chantelonde";
      ["name_cn"] = "水歌?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Flussweise";
      ["faction"] = "Horde";
      ["name"] = "Riversong the Elder";
      ["level"] = 60;
      ["name_es"] = "Riosona el Ancestro";
      ["req"] = 1;
   };
   [8757] = {
      ["name_ru"] = "Путь заклинателя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "La voie de l'Invocateur";
      ["name_cn"] = "祈求者之路";
      ["reward"] = {
         [1] = 21206;
      };
      ["name_de"] = "Der Pfad des Herbeirufers";
      ["faction"] = "Horde";
      ["name"] = "The Path of the Invoker";
      ["level"] = 60;
      ["name_es"] = "El camino del convocador";
      ["req"] = 60;
   };
   [8789] = {
      ["name_ru"] = "Киражское императорское оружие";
      ["type"] = "Raid";
      ["objective"] = "Arygos in the Temple of Ahn'Qiraj will create Elementium Infused Armaments for you should you bring him Imperial Qiraji Armaments and 3 Elementium Ore.";
      ["name_fr"] = "Les armes imperiales qiraji";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "其拉帝王武器";
      ["reward"] = {
         [1] = 21242;
         [2] = 21272;
         [3] = 21244;
         [4] = 21269;
      };
      ["name_de"] = "Imperiale Qirajiwaffen";
      ["faction"] = "Horde";
      ["name"] = "Imperial Qiraji Armaments";
      ["level"] = 60;
      ["name_es"] = "Armamentos imperiales qiraji";
      ["req"] = 60;
   };
   [8821] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8853] = {
      ["name_ru"] = "Пятнадцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Quinze chevalieres pour des fournitures militaires";
      ["name_cn"] = "十五枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21511;
      };
      ["name_de"] = "Funfzehn Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Horde";
      ["name"] = "Fifteen Signets for War Supplies";
      ["level"] = 39;
      ["name_es"] = "Quince sellos para los suministros belicos";
      ["req"] = 30;
   };
   [8917] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Shadowcraft Bracers to Mokvar in Orgrimmar.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22004;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8949] = {
      ["name_ru"] = "Кровная месть Фарлина";
      ["type"] = "Dungeon";
      ["name_fr"] = "La vendetta de Falrin";
      ["next"] = 8950;
      ["name_de"] = "Falrins Rachefeldzug";
      ["reward"] = {
         [1] = 22150;
         [2] = 22149;
      };
      ["name_cn"] = "法?林的?仇";
      ["objective"] = "Collect 25 Ogre Warbeads from Ogres inside Dire Maul or Blackrock Spire and return to Falrin Treeshaper inside the Athenaeum in Dire Maul.";
      ["faction"] = "Horde";
      ["name"] = "Falrin's Vendetta";
      ["sort"] = "Dire Maul";
      ["prev"] = 8948;
      ["prequests"] = {
         [1] = 8948;
      };
      ["level"] = 60;
      ["name_es"] = "La vendetta de Falrin";
      ["req"] = 58;
   };
   [8981] = {
      ["name_ru"] = "Подношение даров";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Faire des cadeaux";
      ["name_cn"] = "?送礼品";
      ["reward"] = {
         [1] = 22218;
         [2] = 21812;
         [3] = 22200;
      };
      ["name_de"] = "Geschenkubergabe";
      ["faction"] = "Horde";
      ["name"] = "Gift Giving";
      ["level"] = 0;
      ["name_es"] = "Ofrecer regalos";
      ["req"] = 60;
   };
   [9013] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Helm of Valor and Breastplate of Valor.";
      ["reward"] = {
         [1] = 21999;
         [2] = 21997;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9045] = {
      ["name_ru"] = "Головной убор Искупления";
      ["type"] = "Raid";
      ["name_fr"] = "Le couvre-chef de redemption";
      ["name_de"] = "Kopfstuck der Erlosung";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make a Redemption Headpiece if you bring him the following: 1 Desecrated Headpiece, 15 Wartorn Plate Scraps, 5 Arcanite Bars and 2 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22428;
      };
      ["name_cn"] = "救???";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Redemption Headpiece";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La celada de redencion";
      ["req"] = 60;
   };
   [9077] = {
      ["name_ru"] = "Кираса костяной косы";
      ["type"] = "Raid";
      ["name_fr"] = "La cuirasse de la faucheuse d'os";
      ["name_de"] = "Brustplatte der Knochensense";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make a Bonescythe Breastplate if you bring him the following: 1 Desecrated Breastplate, 25 Wartorn Leather Scraps, 2 Arcanite Bars and 6 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22476;
      };
      ["name_cn"] = "骨?胸甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Bonescythe Breastplate";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La coraza Segahuesos";
      ["req"] = 60;
   };
   [6603] = {
      ["name_ru"] = "Сложности в Зимних ключах!";
      ["type"] = "Solo";
      ["objective"] = "Find Donova Snowden near the hot springs in Winterspring.";
      ["next"] = 5082;
      ["sort"] = "Winterspring";
      ["name_cn"] = "冬泉谷的麻?！";
      ["name_fr"] = "Troubles au Berceau-de-l'Hiver";
      ["name_de"] = "Probleme in Winterquell!";
      ["faction"] = "Horde";
      ["name"] = "Trouble in Winterspring!";
      ["level"] = 56;
      ["name_es"] = "Problemas en Cuna del Invierno";
      ["req"] = 52;
   };
   [9141] = {
      ["name_ru"] = "Не все так просто";
      ["type"] = "Solo";
      ["objective"] = "Dispatch Commander Metz at Light's Hope Chapel in the Eastern Plaguelands wants an Argent Dawn Valor Token.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "On m'appelle \"Le Coq\"";
      ["name_cn"] = "梅?的文?";
      ["reward"] = {
         [1] = 22568;
      };
      ["name_de"] = "Sie nennen mich \"den Schleifer\"";
      ["faction"] = "Horde";
      ["name"] = "They Call Me The Rooster\"\"";
      ["level"] = 60;
      ["name_es"] = "Me llaman \"El Gallo\"";
      ["req"] = 55;
   };
   [9205] = {
      ["name_ru"] = "Задание мастера: пластинчатая бронерыба";
      ["type"] = "Solo";
      ["objective"] = "Deliver 30 Plated Armorfish and the Craftsman's Writ - Plated Armorfish - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Poissons cuirasses";
      ["name_cn"] = "工匠文? - 板??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Panzerfisch";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Plated Armorfish";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pez coraza de placas";
      ["req"] = 55;
   };
   [9237] = {
      ["name_ru"] = "Ледовый плащ";
      ["type"] = "Raid";
      ["name_fr"] = "La cape glaciaire";
      ["name_de"] = "Gletscherumhang";
      ["reward"] = {
         [1] = 22658;
      };
      ["name_cn"] = "冰川披?";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 5 Frozen Runes, 4 Bolts of Runecloth, 2 Essences of Water, 4 Ironweb Spider Silks and 200 gold. You must also be of Exalted reputation with the Argent Dawn.";
      ["faction"] = "Horde";
      ["name"] = "Glacial Cloak";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "La capa glacial";
      ["req"] = 60;
   };
   [9269] = {
      ["name_ru"] = "Атиеш, большой посох Стража";
      ["type"] = "Dungeon";
      ["name_fr"] = "Atiesh, le grand baton du Gardien";
      ["name_de"] = "Atiesh, Hohestab des Wachters";
      ["objective"] = "Anachronos at the Caverns of Time in Tanaris wants you to take Atiesh, Greatstaff of the Guardian to Stratholme and use it on Consecrated Earth. Defeat the entity that is exorcised from the staff and return to him.";
      ["reward"] = {
         [1] = 22632;
      };
      ["name_cn"] = "埃提耶什，守?者的??之杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Atiesh, Greatstaff of the Guardian";
      ["sort"] = "Legendary";
      ["prev"] = 9251;
      ["prequests"] = {
         [1] = 9251;
      };
      ["level"] = 60;
      ["name_es"] = "Atiesh, el gran baculo del guardian";
      ["req"] = 60;
   };
   [9301] = {
      ["name_ru"] = "Конверт с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Bloodstained Envelope to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "浸血的信封";
      ["name_fr"] = "Une enveloppe du front";
      ["name_de"] = "Umschlag von der Front";
      ["faction"] = "Horde";
      ["name"] = "Envelope from the Front";
      ["level"] = 60;
      ["name_es"] = "Un sobre del frente";
      ["req"] = 55;
   };
   [9333] = {
      ["name_ru"] = "Перчатки Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?色黎明手套";
      ["reward"] = {
         [1] = 23084;
         [2] = 23081;
         [3] = 23082;
         [4] = 23078;
      };
      ["name_de"] = "Handschuhe der Argentumdammerung";
      ["faction"] = "Horde";
      ["name"] = "Argent Dawn Gloves";
      ["level"] = 60;
      ["name_es"] = "Guantes de El Alba Argenta";
      ["req"] = 55;
   };
   [9365] = {
      ["name_ru"] = "Награда вора";
      ["type"] = "Solo";
      ["name_fr"] = "La recompense d'un voleur";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗?的?励";
      ["objective"] = "";
      ["name"] = "A Thief's Reward";
      ["reward"] = {
         [1] = 23323;
      };
      ["name_de"] = "Der Lohn des Diebes";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 9324;
         [2] = 9325;
         [3] = 9326;
      };
      ["level"] = 60;
      ["name_es"] = "Una recompensa de ladron";
      ["req"] = 50;
   };
   [3374] = {
      ["name_ru"] = "Сущность Эраникуса";
      ["type"] = "Solo";
      ["name_fr"] = "L'Essence d'Eranikus";
      ["name_de"] = "Die Essenz des Eranikus";
      ["name_cn"] = "伊?尼?斯精?";
      ["objective"] = " you agree to aid my cause and the cause of Ysera's Dragonflight in redeeming the corrupted soul of Eranikus.  The first sacrifice";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "The Essence of Eranikus";
      ["prev"] = 3373;
      ["prequests"] = {
         [1] = 3373;
      };
      ["level"] = 55;
      ["name_es"] = "La esencia de Eranikus";
      ["req"] = 48;
   };
   [3382] = {
      ["name_ru"] = "На абордаж!";
      ["type"] = "Solo";
      ["objective"] = "Defend Captain Vanessa Beltis, her crew and the Horizon Scout's passengers against the naga attack. Captain Vanessa Beltis must survive.";
      ["sort"] = "Azshara";
      ["name_cn"] = "危?中的船?";
      ["name_fr"] = "Un equipage sous le feu ennemi";
      ["name_de"] = "Eine Mannschaft in Bedrangnis";
      ["faction"] = "Horde";
      ["name"] = "A Crew Under Fire";
      ["level"] = 57;
      ["name_es"] = "Un equipo bajo el fuego enemigo";
      ["req"] = 48;
   };
   [6827] = {
      ["name_ru"] = "Небо зовет ? флот Маэстра";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 5;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille de Mulverick";
      ["name_cn"] = "天空的召? - 穆?里克的部?";
      ["name_de"] = "Ruf der Lufte - Mulvericks Luftflotte";
      ["faction"] = "Horde";
      ["name"] = "Call of Air - Mulverick's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: flota de Mulverick";
      ["req"] = 51;
   };
   [3446] = {
      ["name_ru"] = "Во глубине болот";
      ["type"] = "Dungeon";
      ["name_fr"] = "Dans les profondeurs";
      ["name_de"] = "In die Tiefen";
      ["name_cn"] = "深入神?";
      ["objective"] = "Find the Altar of Hakkar in the Sunken Temple in Swamp of Sorrows.";
      ["sort"] = "Sunken Temple";
      ["faction"] = "Horde";
      ["name"] = "Into the Depths";
      ["prev"] = 3444;
      ["prequests"] = {
         [1] = 3444;
      };
      ["level"] = 51;
      ["name_es"] = "En las profundidades";
      ["req"] = 46;
   };
   [3454] = {
      ["name_ru"] = "Факел воздаяния";
      ["type"] = "Solo";
      ["objective"] = "Take the Torch of Retribution.";
      ["name_de"] = "Die Fackel der Vergeltung";
      ["name_fr"] = "La Torche de vindicte";
      ["reward"] = {
         [1] = 10515;
      };
      ["name_cn"] = "?戒火炬";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "The Torch of Retribution";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3453;
      ["prequests"] = {
         [1] = 3453;
      };
      ["level"] = 50;
      ["name_es"] = "La antorcha de reprension";
      ["req"] = 40;
   };
   [3462] = {
      ["name_ru"] = "Оруженосец Малтрейк";
      ["type"] = "Solo";
      ["name_fr"] = "L'ecuyer Maltrake";
      ["next"] = 3463;
      ["name_de"] = "Knappe Malzdarr";
      ["name_cn"] = "侍??特拉克";
      ["objective"] = "Speak with Squire Maltrake.";
      ["sort"] = "Searing Gorge";
      ["faction"] = "Horde";
      ["name"] = "Squire Maltrake";
      ["prev"] = 3454;
      ["prequests"] = {
         [1] = 3454;
      };
      ["level"] = 50;
      ["name_es"] = "Escudero Maltrake";
      ["req"] = 40;
   };
   [3502] = {
      ["name_ru"] = "Дренейский хлам...";
      ["type"] = "Solo";
      ["name_fr"] = "Au rebut pour les draenei";
      ["name_de"] = "Des einen Draeneis Plunder...";
      ["reward"] = {
         [1] = 12122;
      };
      ["name_cn"] = "德莱尼的??…";
      ["objective"] = "Bring Kum'isha Imperfect Draenethyst Fragments. Any form of monster in the Blasted Lands could be carrying a fragment.$B";
      ["faction"] = "Horde";
      ["name"] = "One Draenei's Junk...";
      ["sort"] = "Blasted Lands";
      ["prev"] = 3501;
      ["prequests"] = {
         [1] = 3501;
      };
      ["level"] = 55;
      ["name_es"] = "Un trasto de Draenei...";
      ["req"] = 45;
   };
   [3510] = {
      ["name_ru"] = "Имя Зверя";
      ["type"] = "Group";
      ["name_fr"] = "Le nom de la bete";
      ["next"] = 3511;
      ["name_de"] = "Der Name der Bestie";
      ["name"] = "The Name of the Beast";
      ["name_cn"] = "?魔之名";
      ["objective"] = "Slay Hetaera and bring back Hetaera's Bloodied Head, Hetaera's Beaten Head, and Hetaera's Bruised Head to Lord Arkkoroc.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Azshara";
      ["prev"] = 3509;
      ["prequests"] = {
         [1] = 3509;
      };
      ["level"] = 58;
      ["name_es"] = "El nombre de la bestia";
      ["req"] = 45;
   };
   [3518] = {
      ["name_ru"] = "Доставка Магате";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison a Magatha";
      ["next"] = 3562;
      ["name_de"] = "Lieferung an Magatha";
      ["name_cn"] = "?加?的石版";
      ["objective"] = "Bring the Tablet of Beth'Amara to Magatha in Thunder Bluff.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Delivery to Magatha";
      ["prev"] = 3517;
      ["prequests"] = {
         [1] = 3517;
      };
      ["level"] = 52;
      ["name_es"] = "Entrega a Magatha";
      ["req"] = 45;
   };
   [3526] = {
      ["name_ru"] = "Гоблинское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Goblin Engineering, take the Manual of Engineering Disciplines to Nixx Sprocketspring in Gadgetzan.";
      ["sort"] = "Engineering";
      ["name_cn"] = "地精工程学";
      ["name_fr"] = "Ingenierie des gobelins";
      ["followup"] = 3638;
      ["name_de"] = "Gobliningenieurskunst";
      ["faction"] = "Horde";
      ["name"] = "Goblin Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria goblin";
      ["req"] = 30;
   };
   [7067] = {
      ["name_ru"] = "Инструкции кентавра-парии";
      ["type"] = "Dungeon";
      ["objective"] = "Read the Pariah's Instructions. Afterwards, obtain the Amulet of Union from Maraudon and return it to the Centaur Pariah in southern Desolace.";
      ["name_fr"] = "Les instructions du paria";
      ["sort"] = "Maraudon";
      ["name_cn"] = "?民的指引";
      ["reward"] = {
         [1] = 17774;
      };
      ["name_de"] = "Die Anweisungen des Pariahs";
      ["faction"] = "Horde";
      ["name"] = "The Pariah's Instructions";
      ["level"] = 48;
      ["name_es"] = "Las instrucciones del Paria";
      ["req"] = 39;
   };
   [3542] = {
      ["name_ru"] = "Доставка Андрону Ганту";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison a Andron Gant";
      ["next"] = 3564;
      ["name_de"] = "Lieferung an Andron Gant";
      ["name_cn"] = "安德隆・甘特的石版";
      ["objective"] = "Bring the Tablet of Markri to Andron Gant in Undercity.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Delivery to Andron Gant";
      ["prev"] = 3517;
      ["prequests"] = {
         [1] = 3517;
      };
      ["level"] = 52;
      ["name_es"] = "Entrega a Andron Gant";
      ["req"] = 45;
   };
   [3566] = {
      ["name_ru"] = "Восстань, Обсидион!";
      ["type"] = "Group";
      ["objective"] = "Slay Lathoric the Black and Obsidion, and return to Thorius in Ironforge with the Head of Lathoric the Black and the Heart of Obsidion. ";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Erhebt Euch, Obsidion!";
      ["reward"] = {
         [1] = 10740;
         [2] = 10741;
         [3] = 10739;
      };
      ["name_cn"] = "奥比斯?";
      ["name_fr"] = "Debout, Obsidion?!";
      ["faction"] = "Alliance";
      ["name"] = "Rise, Obsidion!";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3372;
      ["prequests"] = {
         [1] = 3372;
      };
      ["level"] = 52;
      ["name_es"] = "!Arriba, Obsidion!";
      ["req"] = 45;
   };
   [7163] = {
      ["name_ru"] = "Награда найдет героя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Aufstieg und Anerkennung";
      ["name_fr"] = "Ascension et reconnaissance";
      ["name_cn"] = "?露?角";
      ["name"] = "Rise and Be Recognized";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17905;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7161;
      ["prequests"] = {
         [1] = 7161;
      };
      ["level"] = 60;
      ["name_es"] = "Ascender y darse a conocer";
      ["req"] = 51;
   };
   [3630] = {
      ["name_ru"] = "Гномское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Gnome Engineering, take the Manual of Engineering Disciplines to Tinkmaster Overspark in Ironforge.";
      ["sort"] = "Engineering";
      ["name_cn"] = "侏儒工程学";
      ["name_fr"] = "Ingenierie des gnomes";
      ["followup"] = 3640;
      ["name_de"] = "Gnomeningenieurskunst";
      ["faction"] = "Alliance";
      ["name"] = "Gnome Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria gnomica";
      ["req"] = 30;
   };
   [3638] = {
      ["name_ru"] = "Договор о неразглашении";
      ["type"] = "Solo";
      ["objective"] = "If you agree to become a Goblin Engineer, then right-click on the Pledge of Secrecy and speak once more with Nixx Sprocketspring in Gadgetzan.";
      ["next"] = 3639;
      ["name_fr"] = "Le V?u du secret";
      ["sort"] = "Engineering";
      ["name_cn"] = "保密??";
      ["name"] = "The Pledge of Secrecy";
      ["name_de"] = "Der Schwur der Geheimhaltung";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 4181;
         [2] = 3629;
         [3] = 3526;
         [4] = 3633;
      };
      ["level"] = 47;
      ["name_es"] = "La promesa del secreto";
      ["req"] = 30;
   };
   [3646] = {
      ["name_ru"] = "Продление членского билета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Mitgliedskarten-Erneuerung";
      ["name_fr"] = "Le renouvellement de la Carte de membre";
      ["name_cn"] = "会????";
      ["name"] = "Membership Card Renewal";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 10791;
      };
      ["sort"] = "Engineering";
      ["prev"] = 3639;
      ["prequests"] = {
         [1] = 3639;
      };
      ["level"] = 47;
      ["name_es"] = "Renovacion de la tarjeta de miembro";
      ["req"] = 30;
   };
   [3702] = {
      ["name_ru"] = "Дымящиеся руины Тауриссана";
      ["type"] = "Solo";
      ["name_fr"] = "Les ruines fumantes de Thaurissan";
      ["repgain"] = {
         [47] = 10;
      };
      ["name_de"] = "Die glimmenden Ruinen von Thaurissan";
      ["name_cn"] = "索瑞森?墟";
      ["objective"] = "Listen to Royal Historian Archesonus recant the history of Thaurissan.";
      ["next"] = 3701;
      ["sort"] = "Ironforge";
      ["name"] = "The Smoldering Ruins of Thaurissan";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 54;
      ["name_es"] = "Las humeantes Ruinas de Thaurissan";
      ["req"] = 50;
   };
   [7483] = {
      ["name_ru"] = "Манускрипт Скорости";
      ["type"] = "Dungeon";
      ["objective"] = "Bring a Libram of Rapidity, 1 Pristine Black Diamond, 2 Large Brilliant Shards, and 2 Blood of Heroes to Lorekeeper Lydros in Dire Maul to receive an Arcanum of Rapidity.";
      ["name_fr"] = "Libram de Rapidite";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "急速?典";
      ["reward"] = {
         [1] = 18329;
      };
      ["name_de"] = "Buchband der Schnelligkeit";
      ["faction"] = "Horde";
      ["name"] = "Libram of Rapidity";
      ["level"] = 60;
      ["name_es"] = "El tratado sobre rapidez";
      ["req"] = 58;
   };
   [7499] = {
      ["name_ru"] = "Кодекс Обороны";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Le codex de defense";
      ["name_cn"] = "防御宝典";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 18466;
      };
      ["name_de"] = "Kodex der Verteidigung";
      ["faction"] = "Horde";
      ["name"] = "Codex of Defense";
      ["level"] = 60;
      ["name_es"] = "Codice de Defensa";
      ["req"] = 54;
   };
   [7563] = {
      ["name_ru"] = "Ярость крови";
      ["objective"] = "Bring 30 bottles of Raging Beast's Blood to Mor'zul Bloodbringer in the Burning Steppes.";
      ["name_cn"] = "血之狂暴";
      ["followup"] = 7564;
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Rage de sang";
      ["next"] = 7564;
      ["name_de"] = "Kochendes Blut";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["sort"] = "Warlock";
      ["name"] = "Rage of Blood";
      ["prev"] = 7562;
      ["prequests"] = {
         [1] = 7562;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La ira de sangre";
      ["req"] = 60;
   };
   [3790] = {
      ["name_ru"] = "Помощь верховному друиду Оленьему Шлему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Fandral Staghelm in Darnassus.";
      ["next"] = 3764;
      ["sort"] = "Ironforge";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "Assister l'archidruide Forteramure";
      ["name_de"] = "Erzdruide Hirschhaupt helfen";
      ["faction"] = "Alliance";
      ["name"] = "Assisting Arch Druid Staghelm";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Corzocelada";
      ["req"] = 47;
   };
   [7627] = {
      ["name_ru"] = "Колесо Черного Похода";
      ["type"] = "Solo";
      ["name_fr"] = "La Roue de la Marche noire";
      ["name_de"] = "Das Rad des Schwarzen Marsches";
      ["sort"] = "Warlock";
      ["objective"] = "Bring 6 Large Brilliant Shards and 25 Dark Iron Ore to Gorzeeki in the Burning Steppes.";
      ["name_cn"] = "黑暗??之?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Wheel of the Black March";
      ["followup"] = 7630;
      ["prev"] = 7564;
      ["prequests"] = {
         [1] = 7564;
      };
      ["level"] = 60;
      ["name_es"] = "Rueda de la Marcha Negra";
      ["req"] = 60;
   };
   [7643] = {
      ["name_ru"] = "Дух древнего коня";
      ["objective"] = "Acquire special horse feed used for feeding a spirit horse.  Merideth Carlson in Southshore apparently is the source for such food.$B$BTravel to the Dire Maul dungeon in Feralas and slay Tendris Warpwood.  Doing so will free the Ancient Equine Spirit.  Feed it the special horse feed, thereby soothing the spirit.  Finally, give it the Arcanite Barding so it may bless it.";
      ["name_cn"] = "上古??之魂";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "L'ancien esprit equin";
      ["next"] = 7644;
      ["name_de"] = "Der uralte Pferdegeist";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Ancient Equine Spirit";
      ["prev"] = 7642;
      ["prequests"] = {
         [1] = 7642;
      };
      ["followup"] = 7644;
      ["name_es"] = "El antiguo espiritu equino";
      ["req"] = 60;
   };
   [7659] = {
      ["name_ru"] = "Императорские латные наплечники";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 150;
      };
      ["name_de"] = "Imperiale Plattenschultern";
      ["name_fr"] = "Les epaulieres imperiales en plaques";
      ["name_cn"] = "君王板甲?肩";
      ["faction"] = "Horde";
      ["name"] = "Imperial Plate Shoulders";
      ["reward"] = {
         [1] = 12687;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 7652;
      ["prequests"] = {
         [1] = 7652;
      };
      ["level"] = 60;
      ["name_es"] = "Sobrehombros de placas imperiales";
      ["req"] = 50;
   };
   [7675] = {
      ["name_ru"] = "Замена синего механодолгонога";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Remplacement de mecanotrotteur bleu clair";
      ["name_cn"] = "更?冰?色机械?行?";
      ["reward"] = {
         [1] = 18772;
         [2] = 18773;
         [3] = 18774;
      };
      ["name_de"] = "Eisblauer Roboschreiter-Austausch";
      ["faction"] = "Alliance";
      ["name"] = "Icy Blue Mechanostrider Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de mecazancudo azul hielo";
      ["req"] = 60;
   };
   [7723] = {
      ["name_ru"] = "Отекшие пальцы";
      ["type"] = "Solo";
      ["objective"] = "Hansel Heavyhands wants you to kill 20 Heavy War Golems.$B$BThe Heavy War Golems wander the areas surrounding the Cauldron in the Searing Gorge. When you've killed enough, return to Hansel in Searing Gorge.";
      ["repgain"] = {
         [59] = 100;
      };
      ["sort"] = "Searing Gorge";
      ["name_fr"] = "Maudits gros doigts";
      ["name_cn"] = "?死的手指?！";
      ["reward"] = {
         [1] = 19126;
      };
      ["name_de"] = "Verdammt seien diese fetten Finger";
      ["faction"] = "Horde";
      ["name"] = "Curse These Fat Fingers";
      ["level"] = 49;
      ["name_es"] = "!Malditos dedos gordos!";
      ["req"] = 45;
   };
   [7787] = {
      ["name_ru"] = "Громовая ярость";
      ["type"] = "Solo";
      ["name_fr"] = "Eveille-toi, Lame-tonnerre !";
      ["name_de"] = "Donnerzorn erwache!";
      ["reward"] = {
         [1] = 19019;
      };
      ["name_cn"] = "?醒?,雷霆之怒";
      ["objective"] = "Present the Dormant Wind Kissed Blade to Highlord Demitrian.";
      ["faction"] = "Horde";
      ["name"] = "Rise, Thunderfury!";
      ["sort"] = "Legendary";
      ["prev"] = 7786;
      ["prequests"] = {
         [1] = 7786;
      };
      ["level"] = 60;
      ["name_es"] = "!Arriba, Trueno Furioso!";
      ["req"] = 60;
   };
   [7803] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7805;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7819] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Horde";
      ["sort"] = "Undercity";
      ["prev"] = 7818;
      ["prequests"] = {
         [1] = 7818;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [7835] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [530] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7836;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [7867] = {
      ["name_ru"] = "Стандартные припасы Всадников";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [889] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage ordinaire de Voltigeur";
      ["name_cn"] = "斥候?准?理包";
      ["reward"] = {
         [1] = 19155;
      };
      ["name_de"] = "Standarduberlebenspaket der Vorhut";
      ["faction"] = "Horde";
      ["name"] = "Outrider Standard Care Package";
      ["level"] = 44;
      ["name_es"] = "Botiquin normal de escolta";
      ["req"] = 35;
   };
   [7883] = {
      ["name_ru"] = "Гном-гигант!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Le gnome le plus grand du monde !";
      ["name_cn"] = "世界上最大的侏儒！";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Der groste Gnom der Welt!";
      ["faction"] = "Horde";
      ["name"] = "The World's Largest Gnome!";
      ["level"] = 60;
      ["name_es"] = "!El gnomo mas grande del mundo!";
      ["req"] = 20;
   };
   [7899] = {
      ["name_ru"] = "Маленькие мохнатые лапки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Petites pattes en fourrure";
      ["name_cn"] = "毛茸茸的小爪子";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Kleine pelzige Tatzen";
      ["faction"] = "Horde";
      ["name"] = "Small Furry Paws";
      ["level"] = 60;
      ["name_es"] = "Patitas peludas";
      ["req"] = 1;
   };
   [7931] = {
      ["name_ru"] = "5 купонов ? поощрительный приз Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "5 bons - Lot de Sombrelune (mineur)";
      ["name_cn"] = "5??券 - 小?品";
      ["reward"] = {
         [1] = 19298;
      };
      ["name_de"] = "5 Lose - Kleiner Dunkelmond-Preis";
      ["faction"] = "Horde";
      ["name"] = "5 Tickets - Minor Darkmoon Prize";
      ["level"] = 60;
      ["name_es"] = "5 vales: Lote menor de la Luna Negra";
      ["req"] = 15;
   };
   [3982] = {
      ["name_ru"] = "Что происходит?";
      ["objective"] = "Defend Gor'shak.";
      ["name_cn"] = "出了什?事？";
      ["sort"] = "Blackrock Depths";
      ["level"] = 54;
      ["type"] = "Dungeon";
      ["name_fr"] = "Que se passe-t-il??";
      ["next"] = 4001;
      ["name_de"] = "Was ist los?";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "What Is Going On?";
      ["prev"] = 3981;
      ["prequests"] = {
         [1] = 3981;
      };
      ["series"] = 1;
      ["name_es"] = "?Que pasa?";
      ["req"] = 48;
   };
   [8043] = {
      ["name_ru"] = "Сила горы Мугамба";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Starke des Bergs Mugamba";
      ["name_fr"] = "La force du mont Mugamba";
      ["name"] = "Strength of Mount Mugamba";
      ["name_cn"] = "穆?巴之力";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19576;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8042;
      ["prequests"] = {
         [1] = 8042;
      };
      ["level"] = 60;
      ["name_es"] = "La fuerza del Monte Mugamba";
      ["req"] = 60;
   };
   [8059] = {
      ["name_ru"] = "Знаки Силы: напульсники бесноватого";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Stanchion.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les couvre-bras de demoniaque";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?魔?裹?";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 19848;
      };
      ["name_de"] = "Symbole der Macht: Die Handlappen des Besessenen";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Demoniac's Wraps";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazaletes de endemoniado";
      ["req"] = 60;
   };
   [8075] = {
      ["name_ru"] = "Знаки Силы: хауберк авгура";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Tabard.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BMaywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance : le haubert d'augure";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?言者外套";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 19828;
      };
      ["name_de"] = "Symbole der Macht: Die Halsberge des Weissagers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Augur's Hauberk";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Camisote de augur";
      ["req"] = 60;
   };
   [8107] = {
      ["name_ru"] = "Ожерелье Кезанского порока";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Kezans Schmach";
      ["name_fr"] = "La souillure de Kezan";
      ["name"] = "Kezan's Taint";
      ["name_cn"] = "科?的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 19603;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8106;
      ["prequests"] = {
         [1] = 8106;
      };
      ["level"] = 60;
      ["name_es"] = "Ocaso de Kezan";
      ["req"] = 60;
   };
   [8123] = {
      ["name_ru"] = "Перекрыть линии поставок Аратора";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "切断阿拉索???";
      ["name_fr"] = "Couper les voies de ravitaillement d'Arathor";
      ["name_de"] = "Zerschlagt die Versorgungslinien Arathors";
      ["faction"] = "Horde";
      ["name"] = "Cut Arathor Supply Lines";
      ["level"] = 55;
      ["name_es"] = "Cortale el suministro a la Liga de Arathor";
      ["req"] = 50;
   };
   [8155] = {
      ["name_ru"] = "Ресурсы Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地的?源!";
      ["name_fr"] = "Les ressources du bassin d'Arathi";
      ["name_de"] = "Die Ressourcen des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Arathi Basin Resources!";
      ["level"] = 25;
      ["name_es"] = "Los recursos de la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8171] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the Arathi Basin mine, lumber mill, blacksmith and stable, and then return to Deathmaster Dwire in Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Horde";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 25;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8187] = {
      ["name_ru"] = "Зов Сокола";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "L'appel de l'epervier";
      ["name_cn"] = "??的召?";
      ["reward"] = {
         [1] = 19785;
      };
      ["name_de"] = "Ruf des Falken";
      ["faction"] = "Horde";
      ["name"] = "Falcon's Call";
      ["level"] = 60;
      ["name_es"] = "Llamada del falcon";
      ["req"] = 58;
   };
   [4108] = {
      ["name_ru"] = "Лекарство из охотничьих трофеев";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Jagd";
      ["name_fr"] = "Du baume en chassant";
      ["name_cn"] = "狩???膏";
      ["name"] = "Salve via Hunting";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4103;
      ["prequests"] = {
         [1] = 4103;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por caza";
      ["req"] = 48;
   };
   [4124] = {
      ["name_ru"] = "Пропавший курьер";
      ["type"] = "Solo";
      ["objective"] = "Speak with Ginro Hearthkindle in Feathermoon Stronghold.";
      ["next"] = 4125;
      ["name_fr"] = "Le messager disparu";
      ["sort"] = "Feralas";
      ["name_cn"] = "失踪的信使";
      ["series"] = 1;
      ["name_de"] = "Der vermisste Kurier";
      ["faction"] = "Alliance";
      ["name"] = "The Missing Courier";
      ["level"] = 43;
      ["name_es"] = "El mensajero desaparecido";
      ["req"] = 40;
   };
   [8278] = {
      ["name_ru"] = "Последняя надежда Ноггла";
      ["type"] = "Solo";
      ["objective"] = "Beetix Ficklespragg at Cenarion Hold in Silithus wants you to gather 3 Stonelash Pincer Stingers, 3 Stonelash Flayer Stingers and 3 Rock Stalker Fangs.";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Noggles letzte Hoffnung";
      ["reward"] = {
         [1] = 13446;
         [2] = 13444;
      };
      ["name_cn"] = "?格的最后一?希望";
      ["name_fr"] = "Le dernier espoir de Noggle";
      ["faction"] = "Horde";
      ["name"] = "Noggle's Last Hope";
      ["sort"] = "Silithus";
      ["prev"] = 8277;
      ["prequests"] = {
         [1] = 8277;
      };
      ["level"] = 57;
      ["name_es"] = "La ultima esperanza de Noggle";
      ["req"] = 54;
   };
   [8310] = {
      ["name_ru"] = "Расшифровка";
      ["type"] = "Group";
      ["name_fr"] = "Dechiffrer le code";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Knackt den Kode";
      ["followup"] = 8314;
      ["name_cn"] = "破?密?";
      ["objective"] = "Frankal Stonebridge at Bronzebeard's Encampment in Silithus wants you to recover a Hive'Zora Silithid Brain, Hive'Ashi Silithid Brain, and a Hive'Regal Silithid Brain. Return to Frankal when you have completed this task.";
      ["faction"] = "Horde";
      ["name"] = "Breaking the Code";
      ["sort"] = "Silithus";
      ["prev"] = 8304;
      ["prequests"] = {
         [1] = 8304;
      };
      ["level"] = 60;
      ["name_es"] = "Descifrar el codigo";
      ["req"] = 58;
   };
   [8342] = {
      ["name_ru"] = "Кольцо Власти служителя культа Сумеречного Молота";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Zwielichtherrschaftsring";
      ["name_fr"] = "L'anneau d'autorite du crepuscule";
      ["name_cn"] = "暮光?族之戒";
      ["name"] = "Twilight Ring of Lordship";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 20451;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8341;
      ["prequests"] = {
         [1] = 8341;
      };
      ["level"] = 60;
      ["name_es"] = "Anillo de nobleza Crepuscular";
      ["req"] = 60;
   };
   [8374] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 100;
      };
      ["name_fr"] = "La revendication du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?争的?力";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["level"] = 29;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8406] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["sort"] = "Warsong Gulch";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["prev"] = 8401;
      ["prequests"] = {
         [1] = 8401;
      };
      ["level"] = 49;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 40;
   };
   [8438] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
      };
      ["name_fr"] = "La conquete du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["level"] = 59;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 50;
   };
   [8470] = {
      ["name_ru"] = "Ритуальный тотем Мертвого Леса";
      ["type"] = "Solo";
      ["objective"] = "Take the Deadwood Ritual Totem inside Timbermaw Hold and see if one of the furbolgs there will find a use for the item.  The Timbermaw will not speak with you unless you are of Neutral reputation or greater with them.";
      ["repgain"] = {
         [576] = 150;
      };
      ["sort"] = "Felwood";
      ["name_fr"] = "Le totem rituel des Mort-bois";
      ["name_cn"] = "木喉熊怪的盟友";
      ["reward"] = {
         [1] = 13446;
         [2] = 13444;
      };
      ["name_de"] = "Ritualtotem der Totenwaldfelle";
      ["faction"] = "Horde";
      ["name"] = "Deadwood Ritual Totem";
      ["level"] = 55;
      ["name_es"] = "El totem de ritual Muertobosque";
      ["req"] = 45;
   };
   [8502] = {
      ["name_ru"] = "Цель: рабочие из улья Аши";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Ashi Workers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing III in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les ouvrieres de la Ruche'Ashi";
      ["name_cn"] = "目?：?什工蝎";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Arbeiter des Ashischwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Ashi Workers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los trabajadores Colmen'Ashi";
      ["req"] = 60;
   };
   [8534] = {
      ["name_ru"] = "Донесение разведчика из Улья Зора";
      ["type"] = "Group";
      ["objective"] = "Contact Cenarion Scout Azenel inside Hive'Zora and return the Hive'Zora Scout Report to Windcaller Proudhorn at Cenarion Hold.  You must also bring Tactical Task Briefing VI in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Rapport de reconnaissance de la Ruche'Zora";
      ["name_cn"] = "灰?公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 21133;
      };
      ["name_de"] = "Spaherbericht des Zoraschwarms";
      ["faction"] = "Horde";
      ["name"] = "Hive'Zora Scout Report";
      ["level"] = 60;
      ["name_es"] = "Informe de exploracion de Colmen'Zora";
      ["req"] = 60;
   };
   [8566] = {
      ["name_ru"] = "Былые победы в Арати";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "往日的?利：阿拉希盆地";
      ["reward"] = {
         [1] = 20559;
      };
      ["name_de"] = "Vergangene Siege im Arathibecken";
      ["faction"] = "Horde";
      ["name"] = "Past Victories in Arathi";
      ["level"] = 1;
      ["name_es"] = "Victorias del pasado en Arathi";
      ["req"] = 1;
   };
   [8598] = {
      ["name_ru"] = "вЫкУП";
      ["type"] = "Solo";
      ["name_fr"] = "rANcOn?!";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "lOsEGeLd";
      ["name"] = "rAnS0m";
      ["name_cn"] = "敲?";
      ["objective"] = "Return the Ransom Letter to Narain Soothfancy in Tanaris.$B";
      ["next"] = 8606;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8597;
      ["prequests"] = {
         [1] = 8597;
      };
      ["level"] = 60;
      ["name_es"] = "ReScaTe";
      ["req"] = 60;
   };
   [8630] = {
      ["name_ru"] = "Наплечье Мстителя";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Life, 5 Crystal Scarabs and 5 Gold Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?仇者的?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les espauliers du Vengeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schulterstucke des Rachers";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21391;
      };
      ["name"] = "Avenger's Pauldrons";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Los espaldares del Vengador";
      ["req"] = 60;
   };
   [8662] = {
      ["name_ru"] = "Венец Призывателя рока";
      ["objective"] = "Bring Vek'nilash's Circlet, 2 Idols of Death, 5 Silver Scarabs and 5 Bone Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "厄?召?者的??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe d'implorateur funeste";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Reif des Verdammnisrufers";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21337;
      };
      ["name"] = "Doomcaller's Circlet";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El aro de clamacondenas";
      ["req"] = 60;
   };
   [8694] = {
      ["name_ru"] = "Накидка Неназванных имен";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Regal Drape, 2 Amber Idols, 5 Ivory Scarabs and 5 Bronze Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le voile des noms inexprimes";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "禁断邪?披?";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21418;
      };
      ["name_de"] = "Schleier der ungesagten Namen";
      ["faction"] = "Horde";
      ["name"] = "Shroud of Unspoken Names";
      ["level"] = 60;
      ["name_es"] = "El embozo de los nombres prohibidos";
      ["req"] = 60;
   };
   [8726] = {
      ["name_ru"] = "Предок Сияющее Копье";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Brillelance";
      ["name_cn"] = "金矛?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Prunkspeer";
      ["faction"] = "Horde";
      ["name"] = "Brightspear the Elder";
      ["level"] = 60;
      ["name_es"] = "Lanza Reluciente el ancestro";
      ["req"] = 1;
   };
   [8758] = {
      ["name_ru"] = "Путь заклинателя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Herbeirufers";
      ["name_fr"] = "La voie de l'Invocateur";
      ["name_cn"] = "祈求者之路";
      ["name"] = "The Path of the Invoker";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21207;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8757;
      ["prequests"] = {
         [1] = 8757;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del convocador";
      ["req"] = 60;
   };
   [8790] = {
      ["name_ru"] = "Киражские императорские регалии";
      ["type"] = "Raid";
      ["objective"] = "Merithra of the Dream in the Temple of Ahn'Qiraj will create Elementium Infused Armaments for you should you bring her Imperial Qiraji Regalia and 3 Elementium Ore.$B";
      ["name_fr"] = "L'equipement imperial qiraji";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "其拉帝王徽?";
      ["reward"] = {
         [1] = 21273;
         [2] = 21275;
         [3] = 21268;
      };
      ["name_de"] = "Imperiale Qirajiinsignien";
      ["faction"] = "Horde";
      ["name"] = "Imperial Qiraji Regalia";
      ["level"] = 60;
      ["name_es"] = "Atavio imperial qiraji";
      ["req"] = 60;
   };
   [8822] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8854] = {
      ["name_ru"] = "Двадцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Vingt chevalieres pour des fournitures militaires";
      ["name_cn"] = "二十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21512;
      };
      ["name_de"] = "Zwanzig Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Horde";
      ["name"] = "Twenty Signets for War Supplies";
      ["level"] = 49;
      ["name_es"] = "Veinte sellos para los suministros belicos";
      ["req"] = 40;
   };
   [4444] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [8918] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Bindings of Elements to Mokvar in Orgrimmar.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22095;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8950] = {
      ["name_ru"] = "Чары подстрекателя";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'enchantement du provocateur";
      ["name_de"] = "Die Verzauberung des Aufhetzers";
      ["name_cn"] = "旗?上的附魔";
      ["objective"] = "Bring the following to Falrin Treeshaper inside Dire Maul: 1 Jeering Spectre's Essence, 4 Dark Runes and 8 Large Brilliant Shards.";
      ["sort"] = "Dire Maul";
      ["faction"] = "Horde";
      ["name"] = "The Instigator's Enchantment";
      ["prev"] = 8949;
      ["prequests"] = {
         [1] = 8949;
      };
      ["level"] = 60;
      ["name_es"] = "El encantamiento del provocador";
      ["req"] = 58;
   };
   [8982] = {
      ["name_ru"] = "Поиск источника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Innkeeper Norman in the Undercity.";
      ["next"] = 8983;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "追??源";
      ["name_fr"] = "Remonter a la source";
      ["name_de"] = "Verfolgung der Spur";
      ["faction"] = "Horde";
      ["name"] = "Tracing the Source";
      ["level"] = 70;
      ["name_es"] = "Rastrear la fuente";
      ["req"] = 58;
   };
   [9014] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Magister's Crown and Magister's Robes.";
      ["reward"] = {
         [1] = 22065;
         [2] = 22069;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [9046] = {
      ["name_ru"] = "Наплеч Искупления";
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres de redemption";
      ["name_de"] = "Schiftung der Erlosung";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make a pair of Redemption Spaulders if you bring him the following: 1 Desecrated Spaulders, 12 Wartorn Plate Scraps, 2 Arcanite Bars and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22429;
      };
      ["name_cn"] = "救?肩?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Redemption Spaulders";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las bufas de redencion";
      ["req"] = 60;
   };
   [9078] = {
      ["name_ru"] = "Ножные латы костяной косы";
      ["type"] = "Raid";
      ["name_fr"] = "Les cuissards de la faucheuse d'os";
      ["name_de"] = "Beinplatten der Knochensense";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make Bonescythe Legplates if you bring him the following: 1 Desecrated Legplates, 20 Wartorn Leather Scraps, 1 Arcanite Bar, 8 Cured Rugged Hides and 100 gold pieces.";
      ["reward"] = {
         [1] = 22477;
      };
      ["name_cn"] = "骨?腿?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Bonescythe Legplates";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Los quijotes Segahuesos";
      ["req"] = 60;
   };
   [9110] = {
      ["name_ru"] = "Наручники Проклятого Сердца";
      ["type"] = "Raid";
      ["name_fr"] = "Les manchettes de pestecoeur";
      ["name_de"] = "Bindungen des verseuchten Herzens";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make Plagueheart Bindings if you bring him the following: 1 Desecrated Bindings, 6 Wartorn Cloth Scraps, 1 Arcane Crystal and 1 Nexus Crystal.";
      ["reward"] = {
         [1] = 22511;
      };
      ["name_cn"] = "瘟疫之心腕?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Plagueheart Bindings";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las ataduras corazon de la peste";
      ["req"] = 60;
   };
   [9142] = {
      ["name_ru"] = "Задание мастера";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Handwerksverfugung";
      ["name_fr"] = "Commission d'artisan";
      ["name_cn"] = "工匠文?";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ";
      ["reward"] = {
         [1] = 22568;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9141;
      ["prequests"] = {
         [1] = 9141;
      };
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano";
      ["req"] = 55;
   };
   [9206] = {
      ["name_ru"] = "Задание мастера: молниевый угорь";
      ["type"] = "Solo";
      ["objective"] = "Deliver 30 Lightning Eel and the Craftsman's Writ - Lightning Eel - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Anguilles electriques";
      ["name_cn"] = "工匠文? - ??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Zitteraal";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Lightning Eel";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: anguila relampago";
      ["req"] = 55;
   };
   [9238] = {
      ["name_ru"] = "Ледовые накулачники";
      ["type"] = "Raid";
      ["name_fr"] = "Les poignets glaciaires";
      ["name_de"] = "Gletscherhandschutz";
      ["reward"] = {
         [1] = 22655;
      };
      ["name_cn"] = "冰川?腕";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 4 Frozen Runes, 2 Bolts of Runecloth, 2 Essences of Water, 2 Ironweb Spider Silks and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Glacial Wrists";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Las munequeras glaciales";
      ["req"] = 60;
   };
   [9270] = {
      ["name_ru"] = "Атиеш, большой посох Стража";
      ["type"] = "Dungeon";
      ["name_fr"] = "Atiesh, le grand baton du Gardien";
      ["name_de"] = "Atiesh, Hohestab des Wachters";
      ["objective"] = "Anachronos at the Caverns of Time in Tanaris wants you to take Atiesh, Greatstaff of the Guardian to Stratholme and use it on Consecrated Earth. Defeat the entity that is exorcised from the staff and return to him.";
      ["reward"] = {
         [1] = 22589;
      };
      ["name_cn"] = "埃提耶什，守?者的??之杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Atiesh, Greatstaff of the Guardian";
      ["sort"] = "Legendary";
      ["prev"] = 9251;
      ["prequests"] = {
         [1] = 9251;
      };
      ["level"] = 60;
      ["name_es"] = "Atiesh, el gran baculo del guardian";
      ["req"] = 60;
   };
   [9302] = {
      ["name_ru"] = "Послание с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Crumpled Missive to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "被弄?的信";
      ["name_fr"] = "Une missive du front";
      ["name_de"] = "Schreiben von der Front";
      ["faction"] = "Horde";
      ["name"] = "Missive from the Front";
      ["level"] = 60;
      ["name_es"] = "Una misiva del frente";
      ["req"] = 55;
   };
   [9334] = {
      ["name_ru"] = "Благословенное волшебное масло";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "神?巫?之油";
      ["reward"] = {
         [1] = 23123;
      };
      ["name_de"] = "Gesegnetes Zauberol";
      ["faction"] = "Horde";
      ["name"] = "Blessed Wizard Oil";
      ["level"] = 0;
      ["name_es"] = "Aceite de zahori bendito";
      ["req"] = 50;
   };
   [4732] = {
      ["name_ru"] = "Останки морской черепахи";
      ["type"] = "Solo";
      ["name_fr"] = "La tortue de mer echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meeresschildkrote";
      ["name_cn"] = "?浅的海?";
      ["name"] = "Beached Sea Turtle";
      ["objective"] = "Take the Sea Turtle Remains to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 19;
      ["name_es"] = "Tortuga marina varada";
      ["req"] = 13;
   };
   [4764] = {
      ["name_ru"] = "Пряжка Роковой оснастки";
      ["type"] = "Raid";
      ["name_fr"] = "Le fermoir de Freteruine";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Doomriggers Schnalle";
      ["name"] = "Doomrigger's Clasp";
      ["name_cn"] = "末日扣?";
      ["objective"] = "Bring Doomrigger's Clasp to Mayara Brightwing in the Burning Steppes.";
      ["next"] = 4765;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4766;
      ["prequests"] = {
         [1] = 4766;
      };
      ["level"] = 60;
      ["name_es"] = "El Broche de Equipasino";
      ["req"] = 57;
   };
   [4812] = {
      ["name_ru"] = "Пока струится вода...";
      ["type"] = "Solo";
      ["name_fr"] = "Comme l'eau tombe en cascade";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Wenn das Wasser fliest";
      ["name"] = "As Water Cascades";
      ["name_cn"] = "清洗水晶";
      ["objective"] = "Fill the Empty Water Tube at the Auberdine moonwell, and then investigate the red crystal along Darkshore's eastern mountain wall.";
      ["next"] = 4813;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4811;
      ["prequests"] = {
         [1] = 4811;
      };
      ["level"] = 14;
      ["name_es"] = "Agua en cascada";
      ["req"] = 12;
   };
   [4972] = {
      ["name_ru"] = "Отсчет времени";
      ["type"] = "Solo";
      ["name_fr"] = "Arret du temps";
      ["name_de"] = "Tempus fugit";
      ["reward"] = {
         [1] = 12650;
      };
      ["name_cn"] = "找回??";
      ["objective"] = "Locate 5 Andorhal Watches, found in lockboxes amongst the rubble of the city.  Return with them to Chromie in the Andorhal Inn, Western Plaguelands.";
      ["faction"] = "Horde";
      ["name"] = "Counting Out Time";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 4971;
      ["prequests"] = {
         [1] = 4971;
      };
      ["level"] = 56;
      ["name_es"] = "Contar el tiempo";
      ["req"] = 53;
   };
   [5052] = {
      ["name_ru"] = "Кровавые осколки Агамаггана";
      ["type"] = "Solo";
      ["name_fr"] = "Joyaux de sang d'Agammagan";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Blutsplitter von Agamaggan";
      ["name_cn"] = "阿迦?甘的血岩碎片";
      ["name"] = "Blood Shards of Agamaggan";
      ["objective"] = "Bring a Blood Shard to Mangletooth in Camp Taurajo in the Barrens.$B$BCollect more Blood Shards if you want him to bless you with Agamaggan's power.";
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 878;
      ["prequests"] = {
         [1] = 878;
      };
      ["level"] = 21;
      ["name_es"] = "Esquirlas de sangre de Agamaggan";
      ["req"] = 14;
   };
   [5068] = {
      ["name_ru"] = "Кираса кровавой жажды";
      ["type"] = "Group";
      ["name_fr"] = "La cuirasse carnassiere";
      ["name_de"] = "Brustplatte des Blutdurstes";
      ["reward"] = {
         [1] = 12757;
      };
      ["name_cn"] = "嗜血胸甲";
      ["objective"] = "In order to create the Breastplate of Bloodthirst, you will be required to bring the following items back to Malyfous Darkhammer: 1 Pristine Hide of the Beast; 10 Frayed Abomination Stitchings; 5 Arcanite Bars; 5 Skin of Shadow.$B$BYou will also be required to pay 50 gold pieces for the crafting of the item.";
      ["faction"] = "Horde";
      ["name"] = "Breastplate of Bloodthirst";
      ["sort"] = "Winterspring";
      ["prev"] = 5047;
      ["prequests"] = {
         [1] = 5047;
      };
      ["level"] = 60;
      ["name_es"] = "Coraza Sed de Sangre";
      ["req"] = 57;
   };
   [5084] = {
      ["name_ru"] = "Поддавшиеся порче";
      ["type"] = "Solo";
      ["name_fr"] = "Corrompu";
      ["repgain"] = {
         [577] = 150;
      };
      ["name_de"] = "Der Verderbnis erliegen";
      ["name"] = "Falling to Corruption";
      ["name_cn"] = "堕落熊怪";
      ["objective"] = "Search the Deadwood furbolg camp in northern Felwood for a clue.";
      ["next"] = 5085;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5083;
      ["prequests"] = {
         [1] = 5083;
      };
      ["level"] = 56;
      ["name_es"] = "Sucumbir a la corrupcion";
      ["req"] = 52;
   };
   [5148] = {
      ["name_ru"] = "Кожевничество: традиции предков";
      ["type"] = "Solo";
      ["objective"] = "Bring a Wild Leather Vest and a Wild Leather Helmet to Se'Jib in Stranglethorn Vale.$B$BCompleting this quest will give you access to the Tribal Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Dragonscale Leatherworking and Elemental Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "部族制皮";
      ["name_fr"] = "Travail du cuir tribal";
      ["name_de"] = "Stammeslederverarbeitung";
      ["faction"] = "Horde";
      ["name"] = "Tribal Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria tribal";
      ["req"] = 40;
   };
   [5164] = {
      ["name_ru"] = "Перечень Заблудших";
      ["type"] = "Group";
      ["name_fr"] = "Guide de l'Indocile";
      ["name_de"] = "Verzeichnis der Abtrunnigen";
      ["name_cn"] = "游?者目?";
      ["objective"] = "Read from the Catalogue of the Wayward.$B";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Catalogue of the Wayward";
      ["prev"] = 5162;
      ["prequests"] = {
         [1] = 5162;
      };
      ["level"] = 60;
      ["name_es"] = "Catalogo del Discolo";
      ["req"] = 57;
   };
   [5212] = {
      ["name_ru"] = "Плоть не лжет";
      ["type"] = "Dungeon";
      ["objective"] = "Recover 10 Plagued Flesh Samples from Stratholme and return them to Betina Bigglezink. You suspect that any creature in Stratholme would have said flesh sample.";
      ["next"] = 5213;
      ["name_fr"] = "La chair ne ment pas";
      ["sort"] = "Stratholme";
      ["name_cn"] = "血肉不会撒?";
      ["repgain"] = {
         [529] = 100;
      };
      ["name_de"] = "Das Fleisch lugt nicht";
      ["faction"] = "Horde";
      ["name"] = "The Flesh Does Not Lie";
      ["level"] = 60;
      ["name_es"] = "La carne no miente";
      ["req"] = 55;
   };
   [5228] = {
      ["name_ru"] = "Котлы Плети";
      ["type"] = "Solo";
      ["name_fr"] = "Les chaudrons du Fleau";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Die Geiselkessel";
      ["name"] = "The Scourge Cauldrons";
      ["name_cn"] = "瘟疫之?";
      ["objective"] = "Speak with Shadow Priestess Vandis at the Bulwark, Western Plaguelands.";
      ["next"] = 5229;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5096;
      ["prequests"] = {
         [1] = 5096;
      };
      ["level"] = 53;
      ["name_es"] = "Las calderas de la Plaga";
      ["req"] = 50;
   };
   [5244] = {
      ["name_ru"] = "Руины Кел'Терила";
      ["type"] = "Solo";
      ["objective"] = "Speak with Jaron Stoneshaper in Starfall Village.";
      ["next"] = 5245;
      ["name_fr"] = "Les ruines de Kel'Theril";
      ["sort"] = "Winterspring";
      ["name_cn"] = "?斯利??墟";
      ["repgain"] = {
         [47] = 10;
      };
      ["name_de"] = "Die Ruinen von Kel'Theril";
      ["faction"] = "Alliance";
      ["name"] = "The Ruins of Kel'Theril";
      ["level"] = 56;
      ["name_es"] = "Las Ruinas de Kel'Theril";
      ["req"] = 53;
   };
   [5404] = {
      ["name_ru"] = "Камни осквернителей Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des corrupteurs";
      ["name_cn"] = "堕落者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Verderbers";
      ["faction"] = "Alliance";
      ["name"] = "Corruptor's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del corruptor";
      ["req"] = 50;
   };
   [5628] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5644] = {
      ["name_ru"] = "Всепожирающая чума";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Verschlingende Seuche";
      ["name_cn"] = "噬?瘟疫";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Devouring Plague";
      ["level"] = 20;
      ["name_es"] = "Peste devoradora";
      ["req"] = 20;
   };
   [5660] = {
      ["name_ru"] = "Прикосновение слабости";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Beruhrung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱之触";
      ["name_fr"] = "Toucher de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Touch of Weakness";
      ["level"] = 10;
      ["name_es"] = "Toque de debilidad";
      ["req"] = 10;
   };
   [5676] = {
      ["name_ru"] = "Волшебное искажение";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Arkane Ruckkopplung";
      ["name_cn"] = "奥?回?者*";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Arcane Feedback";
      ["level"] = 20;
      ["name_es"] = "La reaccion Arcana";
      ["req"] = 20;
   };
   [5724] = {
      ["name_ru"] = "Возвращение потерянной сумки";
      ["type"] = "Dungeon";
      ["objective"] = "Take the Grimtotem Satchel to Rahauro in Thunder Bluff.";
      ["repgain"] = {
         [81] = 500;
      };
      ["name_de"] = "Wiederbeschaffung des verloren gegangenen Ranzens";
      ["reward"] = {
         [1] = 15452;
         [2] = 15453;
      };
      ["name_cn"] = "??背包";
      ["name_fr"] = "Rapporter la sacoche perdue";
      ["faction"] = "Horde";
      ["name"] = "Returning the Lost Satchel";
      ["sort"] = "Ragefire Chasm";
      ["prev"] = 5722;
      ["prequests"] = {
         [1] = 5722;
      };
      ["level"] = 16;
      ["name_es"] = "La vuelta de la cartera perdida";
      ["req"] = 9;
   };
   [5804] = {
      ["name_ru"] = "Скарабей Аража";
      ["type"] = "Group";
      ["name_fr"] = "Le Scarabee d'Araj";
      ["name_de"] = "Arajs Skarabaus";
      ["name_cn"] = "阿拉基的?甲虫";
      ["objective"] = "Destroy Araj the Summoner and bring Araj's Scarab to Apothecary Dithers at the Bulwark, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Araj's Scarab";
      ["prev"] = 5802;
      ["prequests"] = {
         [1] = 5802;
      };
      ["level"] = 60;
      ["name_es"] = "El escarabeo de Araj";
      ["req"] = 55;
   };
   [5884] = {
      ["name_ru"] = "Лекарство из оскверненных трав";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Sammlung";
      ["name_fr"] = "Du baume contre une recolte";
      ["name_cn"] = "采集??膏";
      ["name"] = "Salve via Gathering";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4102;
      ["prequests"] = {
         [1] = 4102;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por recoleccion";
      ["req"] = 48;
   };
   [5932] = {
      ["name_ru"] = "Возвращение в Громовой Утес";
      ["objective"] = "Return to Thunder Bluff and speak with Turak Runetotem on the Elder Rise.";
      ["name_cn"] = "返回雷霆崖";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers les Pitons du Tonnerre";
      ["next"] = 6002;
      ["name_de"] = "Zuruck nach Donnerfels";
      ["classes"] = {
         [1] = "Druid";
      };
      ["sort"] = "Druid";
      ["name"] = "Back to Thunder Bluff";
      ["prev"] = 5930;
      ["prequests"] = {
         [1] = 5930;
      };
      ["followup"] = 6002;
      ["name_es"] = "Vuelve a Cima del Trueno";
      ["req"] = 10;
   };
   [6028] = {
      ["name_ru"] = "Донесение из Круговзора";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Everlook Report to Argent Officer Pureheart at Chillwind Camp, Western Plaguelands.";
      ["repgain"] = {
         [529] = 75;
         [0] = 577;
      };
      ["name_fr"] = "Le rapport de Long-guet";
      ["sort"] = "Winterspring";
      ["name_cn"] = "永望??告";
      ["name_de"] = "Der Bericht der Ewigen Warte";
      ["faction"] = "Alliance";
      ["name"] = "The Everlook Report";
      ["level"] = 52;
      ["name_es"] = "El informe Vista Eterna";
      ["req"] = 50;
   };
   [6076] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Grif Wildheart in Kharanos.";
      ["next"] = 6064;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6124] = {
      ["name_ru"] = "Исцеление больных";
      ["objective"] = "Use the Curative Animal Salve on 10 Sickly Deer that are located throughout Darkshore; doing so should cure them.  Sickly Deer have been reported starting south of the Cliffspring River to the north of Auberdine and extending all the way into southern Darkshore where the edge of Ashenvale begins.";
      ["name_cn"] = "消除疾病";
      ["sort"] = "Druid";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Soigner la maladie";
      ["next"] = 6125;
      ["name_de"] = "Heilung der Kranken";
      ["repgain"] = {
         [609] = 150;
      };
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Curing the Sick";
      ["prev"] = 6123;
      ["prequests"] = {
         [1] = 6123;
      };
      ["reward"] = {
         [1] = 15866;
      };
      ["name_es"] = "Curar la dolencia";
      ["req"] = 14;
   };
   [8279] = {
      ["name_ru"] = "Сумеречный словарь";
      ["type"] = "Solo";
      ["name_fr"] = "Le Lexique du crepuscule";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Das Zwielichtlexikon";
      ["name"] = "The Twilight Lexicon";
      ["name_cn"] = "暮光?典";
      ["objective"] = "Bring the three chapters of the Twilight Lexicon to Hermit Ortell in Silithus.  ";
      ["next"] = 8287;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8285;
      ["prequests"] = {
         [1] = 8285;
      };
      ["level"] = 60;
      ["name_es"] = "El Lexicon Crepuscular";
      ["req"] = 54;
   };
   [8311] = {
      ["name_ru"] = "Тыквовинские вкусности для Джеспера!";
      ["type"] = "Solo";
      ["objective"] = "Speak with the innkeepers of Stormwind, Ironforge, and Darnassus, as well as Talvash del Kissel in Ironforge.  Perform the tricks they ask of you in exchange for the treats they offer.$B$BReturn to Jesper at the Stormwind Orphanage with a Darnassus Marzipan, Gnomeregan Gumdrop, Stormwind Nougat, and Ironforge Mint.";
      ["repgain"] = {
         [69] = 150;
         [54] = 150;
         [72] = 150;
         [47] = 150;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Des bonbons de la Sanssaint pour Jesper?!";
      ["name_cn"] = "耶斯??的万??糖果！";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_de"] = "Schlotternachtssusigkeiten fur Jesper!";
      ["faction"] = "Alliance";
      ["name"] = "Hallow's End Treats for Jesper!";
      ["level"] = 60;
      ["name_es"] = "Golosinas de Halloween para Jesper";
      ["req"] = 10;
   };
   [8343] = {
      ["name_ru"] = "Открытие Золотого Листа";
      ["type"] = "Solo";
      ["objective"] = "Speak with Aurel Goldleaf in Cenarion Hold.";
      ["next"] = 8341;
      ["sort"] = "Silithus";
      ["name_cn"] = "金叶的??";
      ["name_fr"] = "La decouverte de Feuilledor";
      ["name_de"] = "Goldblatts Entdeckung";
      ["faction"] = "Horde";
      ["name"] = "Goldleaf's Discovery";
      ["level"] = 60;
      ["name_es"] = "El descubrimiento de Hojaurea";
      ["req"] = 60;
   };
   [8375] = {
      ["name_ru"] = "Помни Альтеракскую долину!";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [730] = 150;
      };
      ["name_fr"] = "Souvenez-vous de la vallee d'Alterac?!";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "??奥特?克！";
      ["name_de"] = "Vergesst das Alteractal nicht!";
      ["faction"] = "Alliance";
      ["name"] = "Remember Alterac Valley!";
      ["level"] = 60;
      ["name_es"] = "!Recuerda el Valle de Alterac!";
      ["req"] = 51;
   };
   [8407] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["name_cn"] = "?歌峡谷之?";
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["name"] = "Fight for Warsong Gulch";
      ["faction"] = "Alliance";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8402;
      ["prequests"] = {
         [1] = 8402;
      };
      ["level"] = 59;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 50;
   };
   [8439] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
      };
      ["name_fr"] = "La conquete du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?源??";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["level"] = 60;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 60;
   };
   [8471] = {
      ["name_ru"] = "Ритуальный тотем Зимней Спячки";
      ["type"] = "Solo";
      ["objective"] = "Take the Winterfall Ritual Totem inside Timbermaw Hold and see if one of the furbolgs there will find a use for the item.  The Timbermaw will not speak with you unless you are of Neutral reputation or greater with them.";
      ["repgain"] = {
         [576] = 150;
      };
      ["sort"] = "Winterspring";
      ["name_fr"] = "Le totem rituel des Tombe-hiver";
      ["name_cn"] = "木喉熊怪的盟友";
      ["reward"] = {
         [1] = 13446;
         [2] = 13444;
      };
      ["name_de"] = "Ritualtotem der Winterfelle";
      ["faction"] = "Horde";
      ["name"] = "Winterfall Ritual Totem";
      ["level"] = 56;
      ["name_es"] = "Totem de ritual Nevada";
      ["req"] = 50;
   };
   [8503] = {
      ["name_ru"] = "Альянсу не хватает удавника!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Stranglekelp to Private Draxlegauge at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin d'etouffante?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要?棘藻！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21510;
      };
      ["name_de"] = "Die Allianz braucht Wurgetang!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Stranglekelp!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita algas estranguladoras!";
      ["req"] = 37;
   };
   [8535] = {
      ["name_ru"] = "Седой храмовник";
      ["type"] = "Group";
      ["objective"] = "Summon and slay a Hoary Templar and report back to Bor Wildmane in Cenarion Hold.  You must also bring Tactical Task Briefing IV in order to complete this quest.";
      ["name_fr"] = "Le templier chenu";
      ["sort"] = "Silithus";
      ["name_cn"] = "深渊公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 20809;
      };
      ["name_de"] = "Weisgrauer Templer";
      ["faction"] = "Horde";
      ["name"] = "Hoary Templar";
      ["level"] = 60;
      ["name_es"] = "Templario vetusto";
      ["req"] = 60;
   };
   [8567] = {
      ["name_ru"] = "Былые победы в Ущелье Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "往日的?利：?歌峡谷";
      ["reward"] = {
         [1] = 20558;
      };
      ["name_de"] = "Vergangene Siege in der Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Past Victories in Warsong Gulch";
      ["level"] = 1;
      ["name_es"] = "Victorias del pasado en la Garganta Grito de Guerra";
      ["req"] = 1;
   };
   [8599] = {
      ["name_ru"] = "Любовная песнь для Нарайна";
      ["type"] = "Solo";
      ["objective"] = "Take Meridith's Love Letter to Narain Soothfancy in Tanaris.";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_fr"] = "Une chanson d'amour pour Narain";
      ["sort"] = "Tanaris";
      ["name_cn"] = "唱??瑞安的情歌";
      ["name_de"] = "Liebesbrief fur Narain";
      ["faction"] = "Horde";
      ["name"] = "Love Song for Narain";
      ["level"] = 60;
      ["name_es"] = "Una cancion de amor para Narain";
      ["req"] = 60;
   };
   [8631] = {
      ["name_ru"] = "Поножи Таинства";
      ["objective"] = "Bring Ouro's Intact Hide, 2 Idols of the Sage, 5 Silver Scarabs and 5 Bone Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神秘?腿";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres de l'enigme";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Gamaschen des Mysteriums";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21346;
      };
      ["name"] = "Enigma Leggings";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los leotardos enigma";
      ["req"] = 60;
   };
   [8663] = {
      ["name_ru"] = "Брюки Призывателя Рока";
      ["objective"] = "Bring the Skin of the Great Sandworm, 2 Idols of Rebirth, 5 Gold Scarabs and 5 Clay Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "厄?召?者的??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les chausses d'implorateur funeste";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Beinkleider des Verdammnisrufers";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21336;
      };
      ["name"] = "Doomcaller's Trousers";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las calzas clamacondenas";
      ["req"] = 60;
   };
   [8695] = {
      ["name_ru"] = "Накидка Вечной справедливости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Regal Drape, 2 Obsidian Idols, 5 Gold Scarabs and 5 Clay Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La cape de justice eternelle";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "永恒公正斗篷";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21397;
      };
      ["name_de"] = "Cape der ewigen Gerechtigkeit";
      ["faction"] = "Alliance";
      ["name"] = "Cape of Eternal Justice";
      ["level"] = 60;
      ["name_es"] = "El manteo de Justicia eterna";
      ["req"] = 60;
   };
   [8727] = {
      ["name_ru"] = "Предок Тихий Шепот";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Murmeloin";
      ["name_cn"] = "???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Fernwisper";
      ["faction"] = "Horde";
      ["name"] = "Farwhisper the Elder";
      ["level"] = 60;
      ["name_es"] = "Levesusurro el Ancestro";
      ["req"] = 1;
   };
   [8759] = {
      ["name_ru"] = "Путь заклинателя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Herbeirufers";
      ["name_fr"] = "La voie de l'Invocateur";
      ["name_cn"] = "祈求者之路";
      ["name"] = "The Path of the Invoker";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21208;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8758;
      ["prequests"] = {
         [1] = 8758;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del convocador";
      ["req"] = 60;
   };
   [8791] = {
      ["name_ru"] = "Повергнутый Оссириан";
      ["type"] = "Raid";
      ["objective"] = "Deliver the Head of Ossirian the Unscarred to Commander Mar'alith at Cenarion Hold in Silithus.$B";
      ["repgain"] = {
         [910] = 500;
         [609] = 350;
      };
      ["sort"] = "Ruins of Ahn'Qiraj";
      ["name_fr"] = "La chute d'Ossirian";
      ["name_cn"] = "奥斯里安之死";
      ["reward"] = {
         [1] = 21504;
         [2] = 21507;
         [3] = 21505;
         [4] = 21506;
      };
      ["name_de"] = "Der Untergang von Ossirian";
      ["faction"] = "Horde";
      ["name"] = "The Fall of Ossirian";
      ["level"] = 60;
      ["name_es"] = "La caida de Osirio";
      ["req"] = 60;
   };
   [8823] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8855] = {
      ["name_ru"] = "Тридцать жетонов в обмен на припасы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_fr"] = "Trente chevalieres pour des fournitures militaires";
      ["name_cn"] = "三十枚?誉徽章?取物?";
      ["reward"] = {
         [1] = 21513;
      };
      ["name_de"] = "Dreisig Abzeichen gegen Kriegsmaterial tauschen";
      ["faction"] = "Horde";
      ["name"] = "Thirty Signets for War Supplies";
      ["level"] = 60;
      ["name_es"] = "Treinta sellos para los suministros belicos";
      ["req"] = 50;
   };
   [8919] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Dreadmist Bracers to Mokvar in Orgrimmar.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 22071;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8951] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Wildheart Boots, a Wildheart Kilt and Wildheart Spaulders.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22107;
         [2] = 22111;
         [3] = 22112;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [8983] = {
      ["name_ru"] = "Поиск источника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mara Rennick at the tailor's shop in the Undercity's Mage Quarter.";
      ["next"] = 8984;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "追??源";
      ["name_fr"] = "Remonter a la source";
      ["name_de"] = "Verfolgung der Spur";
      ["faction"] = "Horde";
      ["name"] = "Tracing the Source";
      ["level"] = 70;
      ["name_es"] = "Rastrear la fuente";
      ["req"] = 43;
   };
   [9015] = {
      ["name_ru"] = "Вызов";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le defi";
      ["name_de"] = "Die Herausforderung";
      ["name_cn"] = "挑?";
      ["objective"] = "Travel to the Ring of the Law in Blackrock Depths and place the Banner of Provocation in its center as you are sentenced by High Justice Grimstone.  Slay Theldren and his gladiators and return to Anthion Harmon in the Eastern Plaguelands with the first piece of Lord Valthalak's amulet.";
      ["sort"] = "Blackrock Depths";
      ["faction"] = "Horde";
      ["name"] = "The Challenge";
      ["prev"] = 8950;
      ["prequests"] = {
         [1] = 8950;
      };
      ["level"] = 60;
      ["name_es"] = "El reto";
      ["req"] = 58;
   };
   [9047] = {
      ["name_ru"] = "Сапоги Искупления";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make Redemption Boots if you bring him the following: 1 Desecrated Boots, 12 Wartorn Plate Scraps, 2 Arcanite Bars and 3 Cured Rugged Hides.";
      ["name_cn"] = "救??靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de redemption";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stiefel der Erlosung";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 22430;
      };
      ["name"] = "Redemption Boots";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas de redencion";
      ["req"] = 60;
   };
   [9079] = {
      ["name_ru"] = "Полный шлем костяной косы";
      ["type"] = "Raid";
      ["name_fr"] = "Le casque de la faucheuse d'os";
      ["name_de"] = "Helm der Knochensense";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make a Bonescythe Helmet if you bring him the following: 1 Desecrated Helmet, 15 Wartorn Leather Scraps, 8 Cured Rugged Hides, 1 Nexus Crystal and 75 gold pieces.$B";
      ["reward"] = {
         [1] = 22478;
      };
      ["name_cn"] = "骨???";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Bonescythe Helmet";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El casco Segahuesos";
      ["req"] = 60;
   };
   [6604] = {
      ["name_ru"] = "Разъяренные дикие совухи";
      ["type"] = "Solo";
      ["objective"] = "Speak with Jaron Stoneshaper at Starfall Village.";
      ["next"] = 4861;
      ["sort"] = "Winterspring";
      ["name_cn"] = "被激怒的??";
      ["name_fr"] = "Les Indomptables enrages";
      ["name_de"] = "Wutende Wildekin";
      ["faction"] = "Alliance";
      ["name"] = "Enraged Wildkin";
      ["level"] = 59;
      ["name_es"] = "Lechucico salvaje iracundo";
      ["req"] = 53;
   };
   [9239] = {
      ["name_ru"] = "Ледовые перчатки";
      ["type"] = "Raid";
      ["name_fr"] = "Les gants glaciaires";
      ["name_de"] = "Gletscherhandschuhe";
      ["reward"] = {
         [1] = 22654;
      };
      ["name_cn"] = "冰川?手";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 5 Frozen Runes, 4 Bolts of Runecloth, 4 Essences of Water, 2 Ironweb Spider Silks and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Glacial Gloves";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los guantes glaciales";
      ["req"] = 60;
   };
   [9271] = {
      ["name_ru"] = "Атиеш, большой посох Стража";
      ["type"] = "Dungeon";
      ["name_fr"] = "Atiesh, le grand baton du Gardien";
      ["name_de"] = "Atiesh, Hohestab des Wachters";
      ["objective"] = "Anachronos at the Caverns of Time in Tanaris wants you to take Atiesh, Greatstaff of the Guardian to Stratholme and use it on Consecrated Earth. Defeat the entity that is exorcised from the staff and return to him.";
      ["reward"] = {
         [1] = 22630;
      };
      ["name_cn"] = "埃提耶什，守?者的??之杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Atiesh, Greatstaff of the Guardian";
      ["sort"] = "Legendary";
      ["prev"] = 9251;
      ["prequests"] = {
         [1] = 9251;
      };
      ["level"] = 60;
      ["name_es"] = "Atiesh, el gran baculo del guardian";
      ["req"] = 60;
   };
   [9335] = {
      ["name_ru"] = "Освященное точило";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "神?磨刀石";
      ["reward"] = {
         [1] = 23122;
      };
      ["name_de"] = "Geweihte Wetzsteine";
      ["faction"] = "Horde";
      ["name"] = "Consecrated Sharpening Stones";
      ["level"] = 0;
      ["name_es"] = "Piedras de afilar consagradas";
      ["req"] = 50;
   };
   [9367] = {
      ["name_ru"] = "Праздник Огня";
      ["type"] = "Solo";
      ["objective"] = "Touch the bonfires within Stormwind, Ironforge, and Darnassus, then speak to a Festival Loremaster within the capital cities.";
      ["sort"] = "Midsummer";
      ["name_cn"] = "火?的?日";
      ["reward"] = {
         [1] = 23247;
         [2] = 23246;
      };
      ["name_de"] = "Das Fest des Feuers";
      ["faction"] = "Alliance";
      ["name"] = "The Festival of Fire";
      ["level"] = 60;
      ["name_es"] = "El Festival del Fuego";
      ["req"] = 1;
   };
   [6844] = {
      ["name_ru"] = "Умбер, архивариус";
      ["type"] = "Solo";
      ["name_fr"] = "Umber, Archiviste";
      ["repgain"] = {
         [609] = 50;
      };
      ["name_de"] = "Umber, Archivar";
      ["name"] = "Umber, Archivist";
      ["name_cn"] = "档案管理?阿姆伯?";
      ["objective"] = "Take the Encrusted Silithid Object to Umber - the Cenarion Circle's archivist - in the village of Nighthaven, Moonglade.";
      ["next"] = 6845;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 1126;
      ["prequests"] = {
         [1] = 1126;
      };
      ["level"] = 57;
      ["name_es"] = "Umber, el archivista";
      ["req"] = 54;
   };
   [7068] = {
      ["name_ru"] = "Фрагменты осколка сумрака";
      ["type"] = "Dungeon";
      ["objective"] = "Collect 10 Shadowshard Fragments from Maraudon and return them to Uthel'nay in Orgrimmar.";
      ["repgain"] = {
         [530] = 350;
      };
      ["sort"] = "Maraudon";
      ["name_fr"] = "Fragments d'Ombreclat";
      ["name_cn"] = "暗影残片";
      ["reward"] = {
         [1] = 17772;
         [2] = 17773;
      };
      ["name_de"] = "Schattensplitter";
      ["faction"] = "Horde";
      ["name"] = "Shadowshard Fragments";
      ["level"] = 42;
      ["name_es"] = "Trozos Oscuros";
      ["req"] = 38;
   };
   [7164] = {
      ["name_ru"] = "Уважение клана";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 250;
         [729] = 250;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Honore au sein du clan";
      ["name_cn"] = "氏族的尊敬";
      ["reward"] = {
         [1] = 17906;
      };
      ["name_de"] = "Ehre innerhalb des Klans";
      ["faction"] = "Horde";
      ["name"] = "Honored Amongst the Clan";
      ["level"] = 60;
      ["name_es"] = "Honorable con el clan";
      ["req"] = 51;
   };
   [7484] = {
      ["name_ru"] = "Манускрипт Средоточия";
      ["type"] = "Dungeon";
      ["objective"] = "Bring a Libram of Focus, 1 Pristine Black Diamond, 4 Large Brilliant Shards, and 2 Skin of Shadow to Lorekeeper Lydros in Dire Maul to receive an Arcanum of Focus.";
      ["repgain"] = {
         [809] = 200;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Libram de focalisation";
      ["name_cn"] = "?注?典";
      ["reward"] = {
         [1] = 18330;
      };
      ["name_de"] = "Buchband des Fokus";
      ["faction"] = "Horde";
      ["name"] = "Libram of Focus";
      ["level"] = 60;
      ["name_es"] = "El tratado sobre enfoque";
      ["req"] = 58;
   };
   [7500] = {
      ["name_ru"] = "Поваренная книга чародея";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Les recettes de l'arcaniste";
      ["name_cn"] = "奥法?的食?";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 18468;
      };
      ["name_de"] = "Das Arkanistenkochbuch";
      ["faction"] = "Horde";
      ["name"] = "The Arcanist's Cookbook";
      ["level"] = 60;
      ["name_es"] = "El libro de cocina del Arcanista";
      ["req"] = 54;
   };
   [7564] = {
      ["name_ru"] = "Дикоглаз";
      ["type"] = "Solo";
      ["name_fr"] = "Gorzeeki Fouregard";
      ["name_de"] = "Wildaug";
      ["sort"] = "Warlock";
      ["objective"] = "Bring the Case of Blood to Gorzeeki Wildeyes in the Burning Steppes.";
      ["name_cn"] = "戈瑟奇・邪眼";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Wildeyes";
      ["followup"] = 7629;
      ["prev"] = 7563;
      ["prequests"] = {
         [1] = 7563;
      };
      ["level"] = 58;
      ["name_es"] = "Ojovago";
      ["req"] = 60;
   };
   [7628] = {
      ["name_ru"] = "Свеча Судного дня";
      ["type"] = "Solo";
      ["name_fr"] = "La Chandelle de l'apocalypse";
      ["name_de"] = "Die Altarkerze des Jungsten Gerichts";
      ["sort"] = "Warlock";
      ["objective"] = "Bring 35 Black Dragonscales to Gorzeeki Wildeyes in the Burning Steppes.";
      ["name_cn"] = "末日??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Doomsday Candle";
      ["followup"] = 7630;
      ["prev"] = 7564;
      ["prequests"] = {
         [1] = 7564;
      };
      ["level"] = 60;
      ["name_es"] = "La Vela del Apocalipsis";
      ["req"] = 60;
   };
   [7644] = {
      ["name_ru"] = "Благословенный арканитовый чепрак";
      ["objective"] = "Return with the Blessed Arcanite Barding to Lord Grayson Shadowbreaker in the Cathedral District of Stormwind.";
      ["name_cn"] = "被祝福的奥金??";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Le caparacon en arcanite beni";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Gesegnetes Arkanitpferdegeschirr";
      ["next"] = 7646;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Blessed Arcanite Barding";
      ["prev"] = 7643;
      ["prequests"] = {
         [1] = 7643;
      };
      ["followup"] = 7646;
      ["name_es"] = "La gualdrapa de arcanita bendita";
      ["req"] = 60;
   };
   [7660] = {
      ["name_ru"] = "Обмен волками ? полярный волк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Echange de loup arctique";
      ["name_cn"] = "更?冰狼";
      ["reward"] = {
         [1] = 18796;
         [2] = 18798;
         [3] = 18797;
      };
      ["name_de"] = "Wolfstausch - arktischer Wolf";
      ["faction"] = "Horde";
      ["name"] = "Wolf Swapping - Arctic Wolf";
      ["level"] = 1;
      ["name_es"] = "Intercambio de lobos: lobo artico";
      ["req"] = 60;
   };
   [7676] = {
      ["name_ru"] = "Замена белого механодолгонога";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Remplacement de mecanotrotteur blanc";
      ["name_cn"] = "更?白色机械?行?";
      ["reward"] = {
         [1] = 18772;
         [2] = 18773;
         [3] = 18774;
      };
      ["name_de"] = "Ersatz fur Euren weisen Roboschreiter";
      ["faction"] = "Alliance";
      ["name"] = "White Mechanostrider Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de mecazancudo blanco";
      ["req"] = 60;
   };
   [7724] = {
      ["name_ru"] = "Огненная угроза";
      ["type"] = "Solo";
      ["objective"] = "Hansel Heavyhands wants you to kill 20 Greater Lava Spiders in the Searing Gorge. You can find Greater Lava Spiders in the plateaus and lava pools of the Searing Gorge.$B$BReturn to Hansel Heavyhands in the Searing Gorge when you have killed enough Greater Lava Spiders.";
      ["repgain"] = {
         [59] = 100;
      };
      ["sort"] = "Searing Gorge";
      ["name_fr"] = "Une menace incandescente";
      ["name_cn"] = "熔岩蜘蛛的威?！";
      ["reward"] = {
         [1] = 19125;
      };
      ["name_de"] = "Feurige Bedrohung!";
      ["faction"] = "Horde";
      ["name"] = "Fiery Menace!";
      ["level"] = 49;
      ["name_es"] = "Amenaza abrasadora";
      ["req"] = 45;
   };
   [7788] = {
      ["name_ru"] = "Долой захватчиков!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者！ (PvP)";
      ["name_fr"] = "Triomphez des envahisseurs !";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Alliance";
      ["name"] = "Vanquish the Invaders!";
      ["level"] = 25;
      ["name_es"] = "!Expulsa al invasor!";
      ["req"] = 20;
   };
   [7804] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7805;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [7820] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 150;
      };
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7823;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [7836] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [530] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Orgrimmar";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7833;
         [2] = 7834;
         [3] = 7835;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [7868] = {
      ["name_ru"] = "Улучшенные припасы Всадников";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [889] = 10;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Paquetage ameliore de Voltigeur";
      ["name_cn"] = "斥候高??理包";
      ["reward"] = {
         [1] = 19153;
      };
      ["name_de"] = "Verbessertes Uberlebenspaket der Vorhut";
      ["faction"] = "Horde";
      ["name"] = "Outrider Advanced Care Package";
      ["level"] = 60;
      ["name_es"] = "Botiquin avanzado de escolta";
      ["req"] = 45;
   };
   [7884] = {
      ["name_ru"] = "Мальчик-кроколиск и бородатый мурлок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "L'enfant crocilisque et le murloc barbu";
      ["name_cn"] = "??小子和有胡子的?人";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Der Krokilisken-Junge und der bartige Murloc";
      ["faction"] = "Horde";
      ["name"] = "Crocolisk Boy and the Bearded Murloc";
      ["level"] = 60;
      ["name_es"] = "El chico crocolisco y el murloc barbudo";
      ["req"] = 30;
   };
   [7900] = {
      ["name_ru"] = "Разорванные шкуры";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Peaux d'ours dechirees";
      ["name_cn"] = "破?的熊皮";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Zerrissene Barenpelze";
      ["faction"] = "Horde";
      ["name"] = "Torn Bear Pelts";
      ["level"] = 60;
      ["name_es"] = "Pieles de oso";
      ["req"] = 10;
   };
   [7932] = {
      ["name_ru"] = "12 купонов ? малый приз Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "12 bons - Lot de Sombrelune (inferieur)";
      ["name_cn"] = "12?彩票 - 二等暗月?";
      ["reward"] = {
         [1] = 19297;
      };
      ["name_de"] = "12 Lose - Geringer Dunkelmond-Preis";
      ["faction"] = "Horde";
      ["name"] = "12 Tickets - Lesser Darkmoon Prize";
      ["level"] = 60;
      ["name_es"] = "12 vales: lote inferior de la Luna Negra";
      ["req"] = 30;
   };
   [8044] = {
      ["name_ru"] = "Ярость Мугамбы";
      ["objective"] = "";
      ["name_cn"] = "穆?巴的怒火";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La rage de Mugamba";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Die Wut Mugambas";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "The Rage of Mount Mugamba";
      ["prev"] = 8043;
      ["prequests"] = {
         [1] = 8043;
      };
      ["reward"] = {
         [1] = 19577;
      };
      ["name_es"] = "La Ira de Mugamba";
      ["req"] = 60;
   };
   [8060] = {
      ["name_ru"] = "Знаки Силы: напульсники мастера иллюзий";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing Primal Hakkari Bindings.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les couvre-bras d’illusionniste";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：幻??裹布";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 19846;
      };
      ["name_de"] = "Symbole der Macht: Die Handlappen des Illusionisten";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Illusionist's Wraps";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazaletes de ilusionista";
      ["req"] = 60;
   };
   [8076] = {
      ["name_ru"] = "Знаки Силы: оплечье бесноватого";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Sash.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: le mantelet de demoniaque";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?魔??肩";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 19849;
      };
      ["name_de"] = "Symbole der Macht: Der Mantel des Besessenen";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Demoniac's Mantle";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Manto de endemoniado";
      ["req"] = 60;
   };
   [8108] = {
      ["name_ru"] = "Ожерелье Кезанского порока";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Kezans Schmach";
      ["name_fr"] = "La souillure de Kezan";
      ["name"] = "Kezan's Taint";
      ["name_cn"] = "科?的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 19604;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8107;
      ["prequests"] = {
         [1] = 8107;
      };
      ["level"] = 60;
      ["name_es"] = "Ocaso de Kezan";
      ["req"] = 60;
   };
   [8124] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["faction"] = "Horde";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8123;
      ["prequests"] = {
         [1] = 8123;
      };
      ["level"] = 55;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 50;
   };
   [8156] = {
      ["name_ru"] = "Ресурсы Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地的?源!";
      ["name_fr"] = "Les ressources du bassin d'Arathi";
      ["name_de"] = "Die Ressourcen des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Arathi Basin Resources!";
      ["level"] = 35;
      ["name_es"] = "Los recursos de la Cuenca de Arathi";
      ["req"] = 30;
   };
   [8188] = {
      ["name_ru"] = "Неусыпные узы вуду";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "L'etreinte vigilante du vaudouisan";
      ["name_cn"] = "巫毒的警?";
      ["reward"] = {
         [1] = 19786;
      };
      ["name_de"] = "Vodouisants wachsame Umarmung";
      ["faction"] = "Horde";
      ["name"] = "Vodouisant's Vigilant Embrace";
      ["level"] = 60;
      ["name_es"] = "Abrazo del vigilante de Vodouisant";
      ["req"] = 58;
   };
   [4109] = {
      ["name_ru"] = "Лекарство из минералов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Bergbau";
      ["name_fr"] = "Du baume par la pioche";
      ["name_cn"] = "采???膏";
      ["name"] = "Salve via Mining";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4104;
      ["prequests"] = {
         [1] = 4104;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por mineria";
      ["req"] = 48;
   };
   [4125] = {
      ["name_ru"] = "Пропавший курьер";
      ["objective"] = "Locate the courier's boat somewhere along the coast of Feralas.";
      ["name_cn"] = "失踪的信使";
      ["sort"] = "Feralas";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Le messager disparu";
      ["next"] = 4127;
      ["name_de"] = "Der vermisste Kurier";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Missing Courier";
      ["prev"] = 4124;
      ["prequests"] = {
         [1] = 4124;
      };
      ["series"] = 2;
      ["name_es"] = "El mensajero desaparecido";
      ["req"] = 40;
   };
   [4141] = {
      ["name_ru"] = "Муиджин и Ларион";
      ["type"] = "Solo";
      ["objective"] = "Collect 15 Bloodpetals and return to Muigin.";
      ["next"] = 4142;
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "穆?金和拉瑞安";
      ["name_fr"] = "Muigin et Larion";
      ["name_de"] = "Muigin und Larion";
      ["faction"] = "Alliance";
      ["name"] = "Muigin and Larion";
      ["level"] = 52;
      ["name_es"] = "Muigin y Larion";
      ["req"] = 47;
   };
   [8312] = {
      ["name_ru"] = "Тыквовинские вкусности для Крохи!";
      ["type"] = "Solo";
      ["objective"] = "Speak with the innkeepers of Orgrimmar, Undercity, and Thunder Bluff, as well as Kali Remik in Sen'jin Village.  Perform the tricks they ask of you in exchange for the treats they offer.$B$BReturn to Spoops at the Orgrimmar Orphanage with a Thunder Bluff Marzipan, Darkspear Gumdrop, Orgrimmar Nougat, and Undercity Mint.";
      ["repgain"] = {
         [76] = 150;
         [68] = 150;
         [81] = 150;
         [530] = 150;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Des bonbons de la Sanssaint pour Spoops?!";
      ["name_cn"] = "斯波普斯的万??糖果！";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_de"] = "Schlotternachtssusigkeiten fur Spuks!";
      ["faction"] = "Horde";
      ["name"] = "Hallow's End Treats for Spoops!";
      ["level"] = 60;
      ["name_es"] = "Golosinas de Halloween para Pupas";
      ["req"] = 10;
   };
   [8376] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??之?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["faction"] = "Alliance";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20700;
         [2] = 20711;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [8408] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["sort"] = "Warsong Gulch";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["prev"] = 8403;
      ["prequests"] = {
         [1] = 8403;
      };
      ["level"] = 60;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 60;
   };
   [4221] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [8504] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает удавника!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus d'etouffante?!";
      ["name_de"] = "Die Allianz braucht mehr Wurgetang!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21510;
      };
      ["name_cn"] = "?盟需要更多?棘藻！";
      ["objective"] = "Bring 20 stranglekelp to Private Draxlegauge at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Stranglekelp!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8503;
      ["prequests"] = {
         [1] = 8503;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas algas estranguladoras!";
      ["req"] = 1;
   };
   [8536] = {
      ["name_ru"] = "Земельник-храмовник";
      ["type"] = "Group";
      ["objective"] = "Summon and slay an Earthen Templar and report back to Bor Wildmane in Cenarion Hold.  You must also bring Tactical Task Briefing III in order to complete this quest.";
      ["name_fr"] = "Le templier terrestre";
      ["sort"] = "Silithus";
      ["name_cn"] = "碎石公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 21133;
      };
      ["name_de"] = "Irdener Templer";
      ["faction"] = "Horde";
      ["name"] = "Earthen Templar";
      ["level"] = 60;
      ["name_es"] = "Templario de tierra";
      ["req"] = 60;
   };
   [8568] = {
      ["name_ru"] = "Былые победы в Ущелье Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "往日的?利：?歌峡谷";
      ["reward"] = {
         [1] = 20558;
      };
      ["name_de"] = "Vergangene Siege in der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Past Victories in Warsong Gulch";
      ["level"] = 1;
      ["name_es"] = "Victorias del pasado en la Garganta Grito de Guerra";
      ["req"] = 1;
   };
   [4301] = {
      ["name_ru"] = "Могучая Уча";
      ["type"] = "Solo";
      ["name_fr"] = "Le puissant U'cha";
      ["name_de"] = "Der machtige U'cha";
      ["reward"] = {
         [1] = 11906;
         [2] = 11907;
      };
      ["name_cn"] = "?大的尤??";
      ["objective"] = "Bring U'cha's Pelt to Torwa Pathfinder at the entrance of Un'Goro Crater.";
      ["faction"] = "Horde";
      ["name"] = "The Mighty U'cha";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4289;
      ["prequests"] = {
         [1] = 4289;
      };
      ["level"] = 55;
      ["name_es"] = "El poderoso U'cha";
      ["req"] = 50;
   };
   [8632] = {
      ["name_ru"] = "Венец Таинства";
      ["objective"] = "Bring Vek'nilash's Circlet, 2 Idols of Night, 5 Bronze Scarabs and 5 Ivory Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神秘??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe de l'enigme";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Reif des Mysteriums";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21347;
      };
      ["name"] = "Enigma Circlet";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El aro enigma";
      ["req"] = 60;
   };
   [8664] = {
      ["name_ru"] = "Оплечье Призывателя Рока";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of the Sage, 5 Bronze Scarabs and 5 Bone Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "厄?召?者的?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le mantelet d'implorateur funeste";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Mantel des Verdammnisrufers";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21335;
      };
      ["name"] = "Doomcaller's Mantle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El manto de clamacondenas";
      ["req"] = 60;
   };
   [8696] = {
      ["name_ru"] = "Плащ Незримого пути";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Regal Drape, 2 Lambent Idols, 5 Stone Scarabs and 5 Crystal Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La cape du sentier invisible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?秘通途披?";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21403;
      };
      ["name_de"] = "Umhang des unsichtbaren Pfads";
      ["faction"] = "Horde";
      ["name"] = "Cloak of the Unseen Path";
      ["level"] = 60;
      ["name_es"] = "La capa de la senda oculta";
      ["req"] = 60;
   };
   [8728] = {
      ["name_ru"] = "Хорошая новость и плохая новость";
      ["type"] = "Solo";
      ["name_fr"] = "La bonne nouvelle et la mauvaise nouvelle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Die gute und die schlechte Nachricht";
      ["name"] = "The Good News and The Bad News";
      ["name_cn"] = "好消息和坏消息";
      ["objective"] = "Narain Soothfancy in Tanaris wants you to bring him 20 Arcanite Bars, 10 Elementium Ore, 10 Azerothian Diamonds, and 10 Blue Sapphires.";
      ["next"] = 8729;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8620;
      ["prequests"] = {
         [1] = 8620;
      };
      ["level"] = 60;
      ["name_es"] = "Buenas y malas noticias";
      ["req"] = 60;
   };
   [8760] = {
      ["name_ru"] = "Путь заклинателя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Herbeirufers";
      ["name_fr"] = "La voie de l'Invocateur";
      ["name_cn"] = "祈求者之路";
      ["name"] = "The Path of the Invoker";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21209;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8759;
      ["prequests"] = {
         [1] = 8759;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del convocador";
      ["req"] = 60;
   };
   [2199] = {
      ["name_ru"] = "Мудрость за деньги";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le Prix de la Connaissance";
      ["repgain"] = {
         [54] = 150;
      };
      ["name_de"] = "Lehren haben ihren Preis";
      ["name"] = "Lore for a Price";
      ["name_cn"] = "昂?的知?";
      ["objective"] = "Bring five silver bars to Talvash del Kissel in Ironforge.";
      ["next"] = 2200;
      ["faction"] = "Alliance";
      ["sort"] = "Uldaman";
      ["prev"] = 2198;
      ["prequests"] = {
         [1] = 2198;
      };
      ["level"] = 41;
      ["name_es"] = "Esa informacion tiene un precio";
      ["req"] = 37;
   };
   [8824] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8856] = {
      ["name_ru"] = "Неприкосновенный запас";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Globes of Water, 4 Powerful Anti-Venom and 4 Baked Salmon to Calandrath at the inn in Cenarion Hold in Silithus.";
      ["repgain"] = {
         [609] = 75;
      };
      ["sort"] = "Silithus";
      ["name_cn"] = "沙漠生存包";
      ["reward"] = {
         [1] = 20800;
         [2] = 20805;
      };
      ["name_de"] = "Wustenuberlebenspaket";
      ["faction"] = "Horde";
      ["name"] = "Desert Survival Kits";
      ["level"] = 0;
      ["name_es"] = "Material de supervivencia en el desierto";
      ["req"] = 60;
   };
   [4445] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [8920] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Bracers of Valor to Mokvar in Orgrimmar.$B";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21996;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [2239] = {
      ["name_ru"] = "Донесение Онина";
      ["type"] = "Solo";
      ["name_fr"] = "Rapport d'Onin";
      ["name_de"] = "Onins Bericht";
      ["objective"] = "Take Onin's Report back to Hulfdan in Ironforge.";
      ["reward"] = {
         [1] = 7298;
      };
      ["name_cn"] = "奥?的?告";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Onin's Report";
      ["sort"] = "Rogue";
      ["prev"] = 2238;
      ["prequests"] = {
         [1] = 2238;
      };
      ["level"] = 10;
      ["name_es"] = "El informe de Onin";
      ["req"] = 10;
   };
   [8984] = {
      ["name_ru"] = "Источник обнаружен";
      ["type"] = "Solo";
      ["name_fr"] = "La source est decouverte?!";
      ["name_de"] = "Luftung des Geheimnisses";
      ["name_cn"] = "水落石出";
      ["objective"] = "Find Apothecary Staffron Lerent in the Hillsbrad Foothills past Ravenholdt Manor.";
      ["sort"] = "Hallow's End";
      ["faction"] = "Horde";
      ["name"] = "The Source Revealed";
      ["prev"] = 8983;
      ["prequests"] = {
         [1] = 8983;
      };
      ["level"] = 70;
      ["name_es"] = "El descubrimiento de la fuente";
      ["req"] = 58;
   };
   [9016] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Wildheart Boots, a Wildheart Kilt and Wildheart Spaulders.$B";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22107;
         [2] = 22111;
         [3] = 22112;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [9048] = {
      ["name_ru"] = "Боевые рукавицы Искупления";
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-mains de redemption";
      ["name_de"] = "Handschutzer der Erlosung";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make Redemption Handguards if you bring him the following: 1 Desecrated Handguards, 8 Wartorn Plate Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22426;
      };
      ["name_cn"] = "救??手";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Redemption Handguards";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las manoplas de redencion";
      ["req"] = 60;
   };
   [9080] = {
      ["name_ru"] = "Наплечье костяной косы";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make Bonescythe Pauldrons if you bring him the following: 1 Desecrated Pauldrons, 12 Wartorn Leather Scraps, 5 Cured Rugged Hides, 1 Nexus Crystal and 50 gold pieces. ";
      ["name_cn"] = "骨?肩?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les espauliers de la faucheuse d'os";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Schulterstucke der Knochensense";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22479;
      };
      ["name"] = "Bonescythe Pauldrons";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los espaldares Segahuesos";
      ["req"] = 60;
   };
   [2279] = {
      ["name_ru"] = "Платиновые Диски";
      ["objective"] = "Take the miniature version of the Discs of Norgannon to the Explorers' League in Ironforge.";
      ["name_cn"] = "白金??";
      ["sort"] = "Uldaman";
      ["level"] = 47;
      ["type"] = "Solo";
      ["name_fr"] = "Les Disques de platine";
      ["next"] = 2439;
      ["name_de"] = "Die Platinscheiben";
      ["repgain"] = {
         [47] = 350;
      };
      ["followup"] = 2439;
      ["name"] = "The Platinum Discs";
      ["prev"] = 2278;
      ["prequests"] = {
         [1] = 2278;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Los discos de platino";
      ["req"] = 40;
   };
   [4605] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Der Funkelmat 5200!";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_cn"] = "超?清?器5200型！";
      ["name"] = "The Sparklematic 5200!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 4601;
      ["prequests"] = {
         [1] = 4601;
      };
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [9240] = {
      ["name_ru"] = "Ледовый жилет";
      ["type"] = "Raid";
      ["name_fr"] = "Le gilet glaciaire";
      ["name_de"] = "Gletscherweste";
      ["reward"] = {
         [1] = 22652;
      };
      ["name_cn"] = "冰川外衣";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 8 Frozen Runes, 8 Bolts of Runecloth, 6 Essences of Water, 4 Ironweb Spider Silks and 300 gold. You must also be of Exalted reputation with the Argent Dawn.";
      ["faction"] = "Horde";
      ["name"] = "Glacial Vest";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "El jubon glacial";
      ["req"] = 60;
   };
   [9272] = {
      ["name_ru"] = "Костюм пирата";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [87] = 10;
      };
      ["sort"] = "Stranglethorn Valley";
      ["name_fr"] = "L'habit fait le boucanier";
      ["name_cn"] = "?宜的服装";
      ["reward"] = {
         [1] = 22746;
      };
      ["name_de"] = "Kleider machen Seebaren";
      ["faction"] = "Horde";
      ["name"] = "Dressing the Part";
      ["level"] = 55;
      ["name_es"] = "Vistete como tal";
      ["req"] = 49;
   };
   [9304] = {
      ["name_ru"] = "Документ с фронта";
      ["type"] = "Solo";
      ["objective"] = "Take the Smudged Document to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "前?的文件";
      ["name_fr"] = "Un document du front";
      ["name_de"] = "Dokument von der Front";
      ["faction"] = "Horde";
      ["name"] = "Document from the Front";
      ["level"] = 60;
      ["name_es"] = "Un documento del frente";
      ["req"] = 55;
   };
   [9336] = {
      ["name_ru"] = "Гигантский флакон с лечебным зельем";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "超?治??水";
      ["reward"] = {
         [1] = 13446;
      };
      ["name_de"] = "Erstklassiger Heiltrank";
      ["faction"] = "Horde";
      ["name"] = "Major Healing Potion";
      ["level"] = 0;
      ["name_es"] = "Superpocion de sanacion";
      ["req"] = 50;
   };
   [9368] = {
      ["name_ru"] = "Праздник Огня";
      ["type"] = "Solo";
      ["objective"] = "Touch the bonfires within Orgrimmar, Thunder Bluff, and the Undercity, then speak to a Festival Talespinner within the capital cities.";
      ["name_fr"] = "La fete du Feu";
      ["sort"] = "Midsummer";
      ["name_cn"] = "火?的?日";
      ["reward"] = {
         [1] = 23247;
         [2] = 23246;
      };
      ["name_de"] = "Das Fest des Feuers";
      ["faction"] = "Horde";
      ["name"] = "The Festival of Fire";
      ["level"] = 60;
      ["name_es"] = "El Festival del Fuego";
      ["req"] = 1;
   };
   [4701] = {
      ["name_ru"] = "Устранение опасности";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Spire and destroy the source of the worg menace. As you left Helendis, he shouted a name: Halycon. It is what the orcs refer to in regards to the worg.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Blackrock Spire";
      ["name_fr"] = "Abattez-la";
      ["name_cn"] = "座狼之源";
      ["reward"] = {
         [1] = 15824;
         [2] = 15825;
         [3] = 15827;
      };
      ["name_de"] = "Stellt sie ab";
      ["faction"] = "Alliance";
      ["name"] = "Put Her Down";
      ["level"] = 59;
      ["name_es"] = "Acaba con el origen de la amenaza";
      ["req"] = 55;
   };
   [2359] = {
      ["name_ru"] = "Башня Клейвена";
      ["objective"] = "Steal the Defias Tower Key, break into the Defias Tower and uncover the contents of the Duskwood Chest. Take whatever information you find back to Mathias Shaw in Stormwind. Read Kearnen's Journal to gain insight about the tower.$B";
      ["name_cn"] = "克拉文之塔";
      ["sort"] = "Rogue";
      ["level"] = 24;
      ["type"] = "Group";
      ["name_fr"] = "La Tour de Klaven";
      ["next"] = 2607;
      ["name_de"] = "Klavens Turm";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 18160;
      };
      ["name"] = "Klaven's Tower";
      ["prev"] = 2360;
      ["prequests"] = {
         [1] = 2360;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La torre de Klaven";
      ["req"] = 20;
   };
   [4733] = {
      ["name_ru"] = "Останки морской твари";
      ["type"] = "Solo";
      ["name_fr"] = "La creature marine echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meereskreatur";
      ["name_cn"] = "?浅的海洋生物";
      ["name"] = "Beached Sea Creature";
      ["objective"] = "Take the Sea Creature Bones to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 19;
      ["name_es"] = "Criatura marina varada";
      ["req"] = 13;
   };
   [2383] = {
      ["name_ru"] = "Записка на пергаменте";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin simple";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Einfaches Pergament";
      ["objective"] = "Read the Simple Parchment and speak to Frang in the Valley of Trials.";
      ["name_cn"] = "?易羊皮?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Parchment";
      ["races"] = {
         [1] = "Orc";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Papiro simple";
      ["req"] = 1;
   };
   [4781] = {
      ["name_ru"] = "Материалы для зачарованного золотого кровавого одеяния";
      ["objective"] = "Bring a Gold Bar to Xizk Goodstitch in Stranglethorn Vale.";
      ["name_cn"] = "魔化金?血袍";
      ["sort"] = "Warlock";
      ["level"] = 34;
      ["type"] = "Solo";
      ["name_fr"] = "Les composants de la robe sanglante doree enchantee";
      ["next"] = 4782;
      ["name_de"] = "Komponenten fur die verzauberte Goldblutrobe";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Components for the Enchanted Gold Bloodrobe";
      ["prev"] = 1796;
      ["prequests"] = {
         [1] = 1796;
      };
      ["series"] = 2;
      ["name_es"] = "Los componentes para la toga de sangre dorada encantada";
      ["req"] = 31;
   };
   [2399] = {
      ["name_ru"] = "Росток папоротника";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Die spriesenden Wedel";
      ["name_fr"] = "Les racines ont pousse";
      ["name_cn"] = "?芽的?叶";
      ["faction"] = "Alliance";
      ["name"] = "The Sprouted Fronds";
      ["reward"] = {
         [1] = 5205;
      };
      ["sort"] = "Teldrassil";
      ["prev"] = 931;
      ["prequests"] = {
         [1] = 931;
      };
      ["level"] = 10;
      ["name_es"] = "Flora en brote";
      ["req"] = 4;
   };
   [4813] = {
      ["name_ru"] = "Скрытые фрагменты";
      ["type"] = "Solo";
      ["objective"] = "Report back what you have found to Sentinel Glynda Nal'Shea in Auberdine.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Die Fragmente im Inneren";
      ["reward"] = {
         [1] = 15335;
         [2] = 15396;
         [3] = 15397;
      };
      ["name_cn"] = "水晶中的碎骨";
      ["name_fr"] = "Les fragments a l'interieur";
      ["faction"] = "Alliance";
      ["name"] = "The Fragments Within";
      ["sort"] = "Darkshore";
      ["prev"] = 4812;
      ["prequests"] = {
         [1] = 4812;
      };
      ["level"] = 14;
      ["name_es"] = "Los trozos del interior";
      ["req"] = 12;
   };
   [4861] = {
      ["name_ru"] = "Разъяренные дикие совухи";
      ["type"] = "Solo";
      ["objective"] = "Locate Jaron Stoneshaper's wrecked camp and supplies in southern Winterspring.";
      ["next"] = 4863;
      ["name_fr"] = "Les Indomptables enrages";
      ["sort"] = "Winterspring";
      ["name_cn"] = "被激怒的??";
      ["series"] = 1;
      ["name_de"] = "Wutende Wildekin";
      ["faction"] = "Alliance";
      ["name"] = "Enraged Wildkin";
      ["level"] = 59;
      ["name_es"] = "Lechucico salvaje iracundo";
      ["req"] = 53;
   };
   [2439] = {
      ["name_ru"] = "Платиновые диски";
      ["type"] = "Solo";
      ["name_fr"] = "Les Disques de platine";
      ["name_de"] = "Die Platinscheiben";
      ["reward"] = {
         [1] = 3928;
         [2] = 9587;
         [3] = 6149;
      };
      ["name_cn"] = "白金??";
      ["objective"] = "Take your reward voucher to Dinita Stonemantle in the Vault of Ironforge.";
      ["faction"] = "Alliance";
      ["name"] = "The Platinum Discs";
      ["sort"] = "Ironforge";
      ["prev"] = 2279;
      ["prequests"] = {
         [1] = 2279;
         [2] = 2280;
      };
      ["level"] = 47;
      ["name_es"] = "Los discos de platino";
      ["req"] = 40;
   };
   [4941] = {
      ["name_ru"] = "Мудрость Эйтригга";
      ["type"] = "Solo";
      ["name_fr"] = "Sagesse d'Eitrigg";
      ["next"] = 4974;
      ["name_de"] = "Etriggs Weisheit";
      ["name_cn"] = "伊崔格的智慧";
      ["objective"] = "Speak with Eitrigg in Orgrimmar. When you have discussed matters with Eitrigg, seek council from Thrall.$B$BYou recall having seen Eitrigg in Thrall's chamber.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "Eitrigg's Wisdom";
      ["prev"] = 4903;
      ["prequests"] = {
         [1] = 4903;
      };
      ["level"] = 60;
      ["name_es"] = "La sabiduria de Eitrigg";
      ["req"] = 55;
   };
   [2479] = {
      ["name_ru"] = "Помощь Хинотта";
      ["objective"] = "Travel to Tarren Mill in Hillsbrad Foothills and deliver the Sample of Zanzil's Mixture to Serge Hinott.$B$BTo get to Tarren Mill, take the Zeppelin to the Undercity and follow the road south through Silverpine and towards Hillsbrad. Follow the signs!$B$B";
      ["name_cn"] = "希?特的?助";
      ["sort"] = "Rogue";
      ["level"] = 26;
      ["type"] = "Solo";
      ["name_fr"] = "L'aide d'Hinott";
      ["next"] = 2480;
      ["name_de"] = "Hinotts Hilfe";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Hinott's Assistance";
      ["prev"] = 2478;
      ["prequests"] = {
         [1] = 2478;
      };
      ["series"] = 1;
      ["name_es"] = "La ayuda de Hinott";
      ["req"] = 20;
   };
   [4973] = {
      ["name_ru"] = "Отсчет времени";
      ["type"] = "Solo";
      ["name_fr"] = "Arret du temps";
      ["name_de"] = "Tempus fugit";
      ["reward"] = {
         [1] = 12650;
      };
      ["name_cn"] = "找回??";
      ["objective"] = "Locate 5 Andorhal Watches amongst the rubble of the city, and return with them to Chromie in the Andorhal Inn, Western Plaguelands.";
      ["faction"] = "Horde";
      ["name"] = "Counting Out Time";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 4972;
      ["prequests"] = {
         [1] = 4972;
      };
      ["level"] = 56;
      ["name_es"] = "Contar el tiempo";
      ["req"] = 53;
   };
   [5021] = {
      ["name_ru"] = "Лучше поздно, чем никогда";
      ["type"] = "Solo";
      ["objective"] = " and she is only vaguely aware of you.$B$B\"Are you here to deliver my package?  Please";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "?到?比不到好";
      ["name_fr"] = "Mieux vaut tard que jamais";
      ["name_de"] = "Besser spat als nie";
      ["faction"] = "Horde";
      ["name"] = "Better Late Than Never";
      ["level"] = 52;
      ["name_es"] = "Mas vale tarde que nunca";
      ["req"] = 50;
   };
   [2519] = {
      ["name_ru"] = "Храм Луны";
      ["type"] = "Solo";
      ["objective"] = "Sister Aquinne wants you to speak with Priestess A'moora in the Temple of the Moon.";
      ["next"] = 2518;
      ["name_fr"] = "Le Temple de la Lune";
      ["sort"] = "Darnassus";
      ["name_cn"] = "月神殿";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Der Tempel des Mondes";
      ["faction"] = "Alliance";
      ["name"] = "The Temple of the Moon";
      ["level"] = 10;
      ["name_es"] = "El templo de la Luna";
      ["req"] = 5;
   };
   [1067] = {
      ["name_ru"] = "Возвращение в Громовой Утес";
      ["type"] = "Solo";
      ["name_fr"] = "Le retour aux Pitons du Tonnerre";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_de"] = "Ruckkehr nach Donnerfels";
      ["name_cn"] = "返回雷霆崖";
      ["name"] = "Return to Thunder Bluff";
      ["objective"] = "Bring Lydon's Toxin to Apothecary Zamah in Thunder Bluff.";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1066;
      ["prequests"] = {
         [1] = 1066;
      };
      ["level"] = 23;
      ["name_es"] = "Regresa a Cima del Trueno";
      ["req"] = 13;
   };
   [5085] = {
      ["name_ru"] = "Таинственная слизь";
      ["type"] = "Solo";
      ["name_fr"] = "Gelee mystere";
      ["repgain"] = {
         [577] = 150;
      };
      ["name_de"] = "Geheimnisvoller Glibber";
      ["name"] = "Mystery Goo";
      ["name_cn"] = "神秘的粘液";
      ["objective"] = "Report back to Donova Snowden with your findings.";
      ["next"] = 5086;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5084;
      ["prequests"] = {
         [1] = 5084;
      };
      ["level"] = 56;
      ["name_es"] = "Baba misteriosa";
      ["req"] = 52;
   };
   [3112] = {
      ["name_ru"] = "Записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note de service simple";
      ["repgain"] = {
         [54] = 75;
         [47] = 100;
      };
      ["name_de"] = "Einfaches Memorandum";
      ["objective"] = "Read the Simple Memorandum and speak to Thran Khorman in Coldridge Valley.";
      ["name_cn"] = "?易?忘?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Memorandum";
      ["races"] = {
         [1] = "Gnome";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Memorandum simple";
      ["req"] = 1;
   };
   [1707] = {
      ["name_ru"] = "Награда за воду";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Wastewander Water Pouches to Spigot Operator Luglunket in Gadgetzan.";
      ["repgain"] = {
         [369] = 150;
      };
      ["sort"] = "Tanaris";
      ["name_fr"] = "Prime de la poche a eau";
      ["name_cn"] = "收集水袋";
      ["reward"] = {
         [1] = 8484;
      };
      ["name_de"] = "Wasserbeutelkopfgeld";
      ["faction"] = "Horde";
      ["name"] = "Water Pouch Bounty";
      ["level"] = 44;
      ["name_es"] = "Cazador de faltriqueras de agua";
      ["req"] = 40;
   };
   [8707] = {
      ["name_ru"] = "Клинок Погребенных тайн";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ornate Hilt, 2  Obsidian Idols, 5 Silver Scarabs and 5 Bone Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La lame des secrets scelles";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "魔法秘密之刃";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21413;
      };
      ["name_de"] = "Klinge der behuteten Geheimnisse";
      ["faction"] = "Horde";
      ["name"] = "Blade of Vaulted Secrets";
      ["level"] = 60;
      ["name_es"] = "La hoja de secretos oscuros";
      ["req"] = 60;
   };
   [5149] = {
      ["name_ru"] = "Кукла Памелы";
      ["type"] = "Solo";
      ["objective"] = "Find Pamela's doll.";
      ["name_fr"] = "La poupee de Pamela";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?米拉的洋娃娃";
      ["name"] = "Pamela's Doll";
      ["name_de"] = "Pamelas Puppe";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 5142;
         [2] = 5601;
      };
      ["level"] = 55;
      ["name_es"] = "La muneca de Pamela";
      ["req"] = 50;
   };
   [2583] = {
      ["name_ru"] = "Жизненная сила вепря";
      ["type"] = "Solo";
      ["objective"] = "Bring three Blasted Boar Lungs, two Scorpok Pincers, and one Basilisk Brain to Bloodmage Drazial.$B";
      ["name_fr"] = "La vitalite du sanglier";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "野猪的活力";
      ["reward"] = {
         [1] = 8411;
      };
      ["name_de"] = "Lebenskraft des Ebers";
      ["faction"] = "Horde";
      ["name"] = "A Boar's Vitality";
      ["level"] = 50;
      ["name_es"] = "La vitalidad del jabali";
      ["req"] = 45;
   };
   [5181] = {
      ["name_ru"] = "Негодяи Дарроушира";
      ["type"] = "Solo";
      ["name_fr"] = "Les vilains de Comte-de-Darrow";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_de"] = "Bosewichte von Darroheim";
      ["followup"] = 5206;
      ["name_cn"] = "?隆郡的?魔";
      ["objective"] = "Bring the Skull of Horgus and the Shattered Sword of Marduk to Carlin Redpath at Light's Hope Chapel.";
      ["faction"] = "Horde";
      ["name"] = "Villains of Darrowshire";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5210;
      ["prequests"] = {
         [1] = 5210;
      };
      ["level"] = 57;
      ["name_es"] = "Los villanos de Villa Darrow";
      ["req"] = 50;
   };
   [2158] = {
      ["name_ru"] = "Отдых и покой";
      ["type"] = "Solo";
      ["objective"] = "Speak with Innkeeper Farley at the Lion's Pride Inn.";
      ["repgain"] = {
         [72] = 25;
      };
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Repos et detente";
      ["name_cn"] = "休息和放松";
      ["reward"] = {
         [1] = 4656;
         [2] = 159;
      };
      ["name_de"] = "Ruhe und Entspannung";
      ["faction"] = "Alliance";
      ["name"] = "Rest and Relaxation";
      ["level"] = 5;
      ["name_es"] = "Descanso y relajacion";
      ["req"] = 1;
   };
   [5213] = {
      ["name_ru"] = "Вирус чумы";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme and search the ziggurats. Find and return new Scourge Data to Betina Bigglezink.$B";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_de"] = "Der aktive Wirkstoff";
      ["reward"] = {
         [1] = 13209;
         [2] = 19812;
      };
      ["name_cn"] = "活?的探子";
      ["name_fr"] = "L'agent actif";
      ["faction"] = "Horde";
      ["name"] = "The Active Agent";
      ["sort"] = "Stratholme";
      ["prev"] = 5212;
      ["prequests"] = {
         [1] = 5212;
      };
      ["level"] = 60;
      ["name_es"] = "El agente activo";
      ["req"] = 55;
   };
   [5229] = {
      ["name_ru"] = "Цель: поле Джанис";
      ["objective"] = "Go to Felstone Field in Western Plaguelands to locate and defeat the Cauldron Lord present there.  It may have a key that will allow access to the cauldron.  You must have the Empty Felstone Field Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：??斯通??";
      ["sort"] = "Western Plaguelands";
      ["level"] = 53;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: le Champ de Gangrepierre";
      ["next"] = 5230;
      ["name_de"] = "Ziel: Teufelssteinfeld";
      ["repgain"] = {
         [67] = 250;
         [529] = 250;
      };
      ["followup"] = 5218;
      ["name"] = "Target: Felstone Field";
      ["prev"] = 5228;
      ["prequests"] = {
         [1] = 5228;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Objetivo: Campo de Piedramacula";
      ["req"] = 50;
   };
   [5245] = {
      ["name_ru"] = "Беспокойные духи Кел'Терила";
      ["type"] = "Solo";
      ["name_fr"] = "Les esprits troubles de Kel'Theril";
      ["repgain"] = {
         [69] = 25;
         [54] = 25;
         [72] = 25;
         [47] = 25;
      };
      ["name_de"] = "[DEPRECATED] Die gequalten Seelen von Kel'Theril";
      ["name"] = "Troubled Spirits of Kel'Theril";
      ["name_cn"] = "?斯利?的怨?";
      ["objective"] = "Use Jaron's Pick to find the four Highborne Relic Fragments. Bring them to Aurora Skycaller in Eastern Plaguelands.";
      ["next"] = 5246;
      ["faction"] = "Alliance";
      ["sort"] = "Winterspring";
      ["prev"] = 5244;
      ["prequests"] = {
         [1] = 5244;
      };
      ["level"] = 56;
      ["name_es"] = "Espiritus condenados de Kel'Theril";
      ["req"] = 53;
   };
   [5261] = {
      ["name_ru"] = "Иган Меховщик";
      ["type"] = "Solo";
      ["name_fr"] = "Eagan Tannepeau";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Eagan Pelzschneider";
      ["name"] = "Eagan Peltskinner";
      ["name_cn"] = "伊根・派特斯金?";
      ["objective"] = "Speak with Eagan Peltskinner.";
      ["next"] = 33;
      ["faction"] = "Alliance";
      ["sort"] = "Northshire Valley";
      ["prev"] = 783;
      ["prequests"] = {
         [1] = 783;
      };
      ["level"] = 2;
      ["name_es"] = "Eagan Desollapelambres";
      ["req"] = 1;
   };
   [2342] = {
      ["name_ru"] = "Возвращенные сокровища";
      ["type"] = "Solo";
      ["objective"] = "Get Patrick Garrett's family treasure from their family chest in the South Common Hall of Uldaman, and bring it to him in the Undercity.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Des Tresors a recouvrer";
      ["sort"] = "Uldaman";
      ["name_cn"] = "?找宝物";
      ["name_de"] = "Wiederbeschaffte Schatze";
      ["faction"] = "Horde";
      ["name"] = "Reclaimed Treasures";
      ["level"] = 43;
      ["name_es"] = "Los tesoros reclamados";
      ["req"] = 33;
   };
   [2753] = {
      ["name_ru"] = "Тяжелая поступь";
      ["type"] = "Solo";
      ["name_fr"] = "Pietines";
      ["name_de"] = "In den Boden getrampelt";
      ["reward"] = {
         [1] = 7981;
      };
      ["name_cn"] = "?在脚下";
      ["objective"] = "Bring four Green Iron Helms, four Green Iron Bracers, and two Green Iron Leggings to Orokk Omosh in Orgrimmar.";
      ["faction"] = "Horde";
      ["name"] = "Trampled Under Foot";
      ["sort"] = "Blacksmithing";
      ["prev"] = 2752;
      ["prequests"] = {
         [1] = 2752;
      };
      ["level"] = 36;
      ["name_es"] = "!Aplastalos!";
      ["req"] = 32;
   };
   [1090] = {
      ["name_ru"] = "Приказы Геренцо";
      ["type"] = "Solo";
      ["name_fr"] = "Les ordres de Gerenzo";
      ["repgain"] = {
         [470] = 350;
      };
      ["name_de"] = "Gerenzos Befehle";
      ["name_cn"] = "格雷?的要求";
      ["objective"] = "Get the mysterious ore from Piznik after he finishes mining it.";
      ["next"] = 1092;
      ["sort"] = "Stonetalon Mountains";
      ["name"] = "Gerenzo's Orders";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 22;
      ["name_es"] = "Ordenes de Gerenzo";
      ["req"] = 17;
   };
   [1193] = {
      ["name_ru"] = "Сломанная западня";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "破碎的陷?";
      ["name_fr"] = "Un piege casse";
      ["name_de"] = "Eine beschadigte Falle";
      ["faction"] = "Horde";
      ["name"] = "A Broken Trap";
      ["level"] = 60;
      ["name_es"] = "Una trampa rota";
      ["req"] = 56;
   };
   [5341] = {
      ["name_ru"] = "Сокровище Баровых";
      ["type"] = "Dungeon";
      ["objective"] = "Venture to the Scholomance and recover the Barov family fortune. Four deeds make up this fortune: The Deed to Caer Darrow; The Deed to Brill; The Deed to Tarren Mill; and The Deed to Southshore. Return to Alexi Barov when you have completed this task.";
      ["next"] = 5342;
      ["sort"] = "Scholomance";
      ["name_cn"] = "巴?夫家族的宝藏";
      ["name_fr"] = "Fortune de la famille Barov";
      ["name_de"] = "Das Familienvermogen der Barovs";
      ["faction"] = "Horde";
      ["name"] = "Barov Family Fortune";
      ["level"] = 60;
      ["name_es"] = "La fortuna de la familia Barov";
      ["req"] = 52;
   };
   [6611] = {
      ["name_ru"] = "Ступай в Прибамбасск!";
      ["type"] = "Solo";
      ["objective"] = "Travel to Gadgetzan in the Tanaris desert and speak with Dirge Quikcleave about advancing your cooking career.";
      ["next"] = 6610;
      ["sort"] = "Cooking";
      ["name_cn"] = "加基森之旅！";
      ["name_fr"] = "Vers Gadgetzan vous allez?!";
      ["name_de"] = "Ab mit Euch nach Gadgetzan!";
      ["faction"] = "Horde";
      ["name"] = "To Gadgetzan You Go!";
      ["level"] = 45;
      ["name_es"] = "Ve a Gadgetzan";
      ["req"] = 35;
   };
   [4127] = {
      ["name_ru"] = "Разбитая лодка";
      ["type"] = "Solo";
      ["name_fr"] = "Debris de bateau";
      ["next"] = 4129;
      ["name_de"] = "Havarie";
      ["name_cn"] = "船只的残骸";
      ["objective"] = "Return to Feathermoon Stronghold and show Ginro Hearthkindle the Discarded Knife you have found.";
      ["sort"] = "Feralas";
      ["faction"] = "Alliance";
      ["name"] = "Boat Wreckage";
      ["prev"] = 4125;
      ["prequests"] = {
         [1] = 4125;
      };
      ["level"] = 44;
      ["name_es"] = "Los restos del bote";
      ["req"] = 40;
   };
   [1518] = {
      ["name_ru"] = "Зов Земли";
      ["objective"] = "Bring the Rough Quartz to Canaga Earthcaller in the Valley of Trials.";
      ["name_cn"] = "大地的召?";
      ["sort"] = "Shaman";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de la terre";
      ["name_de"] = "Ruf der Erde";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 5175;
      };
      ["name"] = "Call of Earth";
      ["prev"] = 1517;
      ["prequests"] = {
         [1] = 1517;
      };
      ["series"] = 3;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [5405] = {
      ["name_ru"] = "Жетон Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Brevet de l'Aube d'argent";
      ["name_cn"] = "?色黎明委任徽章";
      ["reward"] = {
         [1] = 12846;
      };
      ["name_de"] = "Anstecknadel der Argentumdammerung";
      ["faction"] = "Horde";
      ["name"] = "Argent Dawn Commission";
      ["level"] = 55;
      ["name_es"] = "Comision de El Alba Argenta";
      ["req"] = 50;
   };
   [5421] = {
      ["name_ru"] = "Рыбка в ведерке";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Desolace";
      ["name_fr"] = "Poisson dans un seau";
      ["name_cn"] = "坐享其成";
      ["reward"] = {
         [1] = 13546;
      };
      ["name_de"] = "Fisch im Eimer";
      ["faction"] = "Horde";
      ["name"] = "Fish in a Bucket";
      ["level"] = 1;
      ["name_es"] = "Pescado en un balde";
      ["req"] = 25;
   };
   [1027] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Sich tot stellen";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Find the final piece of Dartol's Rod and return to Shael'dryn at the moonwell.";
      ["next"] = 1028;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1026;
      ["prequests"] = {
         [1] = 1026;
      };
      ["level"] = 28;
      ["name_es"] = "Hacerse el muerto";
      ["req"] = 18;
   };
   [3511] = {
      ["name_ru"] = "Имя Зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Le nom de la bete";
      ["next"] = 3602;
      ["name_de"] = "Der Name der Bestie";
      ["name"] = "The Name of the Beast";
      ["name_cn"] = "?魔之名";
      ["objective"] = "Take the temper back to Loramus Thalipedes.$B";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Azshara";
      ["prev"] = 3510;
      ["prequests"] = {
         [1] = 3510;
      };
      ["level"] = 58;
      ["name_es"] = "El nombre de la bestia";
      ["req"] = 45;
   };
   [8594] = {
      ["name_ru"] = "Оплечье Оракула";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of Rebirth, 5 Silver Scarabs and 5 Ivory Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神?者的?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le mantelet de l'Oracle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Mantel des Orakels";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21350;
      };
      ["name"] = "Mantle of the Oracle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El manto del Oraculo";
      ["req"] = 60;
   };
   [2743] = {
      ["name_ru"] = "Покров Тьмы";
      ["type"] = "Solo";
      ["name_fr"] = "Le couvert de l'obscurite";
      ["next"] = 2744;
      ["name_de"] = "Der Mantel der Dunkelheit";
      ["name_cn"] = "黑暗?罩";
      ["objective"] = "Return to the Fallen Hero of the Horde with your findings.";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "The Cover of Darkness";
      ["prev"] = 2721;
      ["prequests"] = {
         [1] = 2721;
      };
      ["level"] = 60;
      ["name_es"] = "La cubierta de la Oscuridad";
      ["req"] = 45;
   };
   [5501] = {
      ["name_ru"] = "Собиратель костей";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Kodo Bones from the Kodo Graveyard to Bibbly F'utzbuckle at Kormek's Hut.";
      ["repgain"] = {
         [470] = 150;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "Collectionneur d'os";
      ["name_cn"] = "集骨者";
      ["reward"] = {
         [1] = 15690;
      };
      ["name_de"] = "Knochenjager";
      ["faction"] = "Horde";
      ["name"] = "Bone Collector";
      ["level"] = 39;
      ["name_es"] = "Recoleccion de kodos";
      ["req"] = 33;
   };
   [5517] = {
      ["name_ru"] = "Многоцветное оплечье Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 25 Argent Dawn Valor Tokens to Quartermaster Breechlock at Light's Hope Chapel, Eastern Plaguelands.";
      ["name_fr"] = "Le mantelet de l'aube Chromatique";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "多彩黎明?肩";
      ["reward"] = {
         [1] = 18182;
      };
      ["name_de"] = "Der Chromatische Mantel der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Chromatic Mantle of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Manto del Alba cromatico";
      ["req"] = 55;
   };
   [5533] = {
      ["name_ru"] = "Некроситет";
      ["type"] = "Solo";
      ["name_fr"] = "Scholomance";
      ["next"] = 5537;
      ["name_de"] = "Scholomance";
      ["name_cn"] = "通?学院";
      ["objective"] = "Speak with Alchemist Arbington at Chillwind Point, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "Scholomance";
      ["prev"] = 5097;
      ["prequests"] = {
         [1] = 5097;
      };
      ["level"] = 55;
      ["name_es"] = "Scholomance";
      ["req"] = 55;
   };
   [3161] = {
      ["name_ru"] = "Газ'рилльское украшение";
      ["type"] = "Solo";
      ["objective"] = " after the hydra god.$B$BI did find some myself";
      ["repgain"] = {
         [369] = 250;
      };
      ["sort"] = "Tanaris";
      ["name_fr"] = "La gahz'ridienne";
      ["name_cn"] = "加?瑞迪安";
      ["reward"] = {
         [1] = 10827;
         [2] = 10826;
      };
      ["name_de"] = "Gahz'ridian";
      ["faction"] = "Horde";
      ["name"] = "Gahz'ridian";
      ["level"] = 48;
      ["name_es"] = "Gahz'rilo";
      ["req"] = 43;
   };
   [2783] = {
      ["name_ru"] = "Незначительные разногласия";
      ["type"] = "Solo";
      ["objective"] = "Speak with the Fallen Hero of the Horde at the border of the Blasted Lands and the swamp.";
      ["next"] = 2801;
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "争?";
      ["name_fr"] = "Querelles mesquines";
      ["followup"] = 2801;
      ["name_de"] = "Kleinliches Gezank";
      ["faction"] = "Alliance";
      ["name"] = "Petty Squabbles";
      ["level"] = 57;
      ["name_es"] = "Peleas mezquinas";
      ["req"] = 50;
   };
   [5581] = {
      ["name_ru"] = "Порталы Легиона";
      ["type"] = "Solo";
      ["objective"] = "Banish 6 Portals at Mannoroc Coven and return to Taiga Wisemane at Shadowprey Village.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Portale der Legion";
      ["reward"] = {
         [1] = 16794;
         [2] = 16873;
      };
      ["name_cn"] = "燃???的?送?";
      ["name_fr"] = "Les portails de la Legion";
      ["faction"] = "Horde";
      ["name"] = "Portals of the Legion";
      ["sort"] = "Desolace";
      ["prev"] = 5381;
      ["prequests"] = {
         [1] = 5381;
      };
      ["level"] = 38;
      ["name_es"] = "Los portales de la Legion";
      ["req"] = 32;
   };
   [3113] = {
      ["name_ru"] = "Зашифрованная записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note de service codee";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Verschlusseltes Memorandum";
      ["objective"] = "Read the Encrypted Memorandum and speak to Solm Hargrin in Coldridge Valley.";
      ["name_cn"] = "密文?忘?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Memorandum";
      ["races"] = {
         [1] = "Gnome";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Memorandum encriptado";
      ["req"] = 1;
   };
   [2861] = {
      ["name_ru"] = "Миссия Табеты";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Tabetha in Dustwallow Marsh.";
      ["next"] = 2846;
      ["sort"] = "Zul'Farrak";
      ["name_cn"] = "塔??的任?";
      ["name_fr"] = "La mission de Tabetha";
      ["name_de"] = "Tabethas Aufgabe";
      ["faction"] = "Horde";
      ["name"] = "Tabetha's Task";
      ["level"] = 46;
      ["name_es"] = "La tarea de Tabetha";
      ["req"] = 40;
   };
   [5629] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5645] = {
      ["name_ru"] = "Бесстрашие";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priest Rohan in Ironforge.";
      ["name_de"] = "Furchtlos";
      ["sort"] = "Priest";
      ["name_cn"] = "毫无畏惧";
      ["name_fr"] = "Un manque de peur";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "A Lack of Fear";
      ["level"] = 20;
      ["name_es"] = "Sin miedo";
      ["req"] = 20;
   };
   [5661] = {
      ["name_ru"] = "Прикосновение слабости";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Beruhrung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱之触";
      ["name_fr"] = "Toucher de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Touch of Weakness";
      ["level"] = 10;
      ["name_es"] = "Toque de debilidad";
      ["req"] = 10;
   };
   [5677] = {
      ["name_ru"] = "Волшебное искажение";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Arkane Ruckkopplung";
      ["sort"] = "Priest";
      ["name_cn"] = "奥?回?者";
      ["name_fr"] = "Retour d'information de l'Arcane";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Arcane Feedback";
      ["level"] = 20;
      ["name_es"] = "La reaccion Arcana";
      ["req"] = 20;
   };
   [2847] = {
      ["name_ru"] = "Дикарские кожаные доспехи";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Leather to Pratt McGrubben in Feathermoon Stronghold.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "蛮皮?甲";
      ["name_fr"] = "L'armure en cuir fauve";
      ["name_de"] = "Wildlederrustung";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Armor";
      ["level"] = 45;
      ["name_es"] = "Armadura de cuero salvaje";
      ["req"] = 30;
   };
   [2855] = {
      ["name_ru"] = "Дикарские кожаные наплечники";
      ["type"] = "Solo";
      ["name_fr"] = "Les epaulieres en cuir fauve";
      ["name_de"] = "Wildlederschultern";
      ["objective"] = "Bring 6 Thick Armor Kits and a Wildvine to Jangdor Swiftstrider in Camp Mojache.";
      ["followup"] = 2860;
      ["name_cn"] = "蛮皮?肩";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Shoulders";
      ["reward"] = {
         [1] = 8403;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2854;
      ["prequests"] = {
         [1] = 2854;
      };
      ["level"] = 45;
      ["name_es"] = "Sobrehombros de cuero salvaje";
      ["req"] = 30;
   };
   [2863] = {
      ["name_ru"] = "Истребление вожаков";
      ["type"] = "Solo";
      ["name_fr"] = "Frappe sur les Alphas";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Schlag gegen die Alphas";
      ["name"] = "Alpha Strike";
      ["name_cn"] = "突然??";
      ["objective"] = "Kill 5 Woodpaw Alphas and return to Hadoken Swiftstrider within one hour.";
      ["next"] = 2902;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 2862;
      ["prequests"] = {
         [1] = 2862;
      };
      ["level"] = 43;
      ["name_es"] = "Ataca a los Alfas";
      ["req"] = 39;
   };
   [5741] = {
      ["name_ru"] = "Скипетр Света";
      ["type"] = "Solo";
      ["objective"] = "Get the Sceptre of Light and then return it to Azore Aldamort at the tower in Ethel Rethor.$B";
      ["next"] = 6027;
      ["name_fr"] = "Sceptre de lumiere";
      ["sort"] = "Desolace";
      ["name_cn"] = "?光?杖";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_de"] = "Szepter des Lichts";
      ["faction"] = "Horde";
      ["name"] = "Sceptre of Light";
      ["level"] = 33;
      ["name_es"] = "El Cetro de Luz";
      ["req"] = 30;
   };
   [2879] = {
      ["name_ru"] = "Посох равноденствия";
      ["objective"] = "Energize Troyas' Stave and find the Equinex Monolith.";
      ["name_cn"] = "艾奎尼克斯法杖";
      ["sort"] = "Feralas";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "Le Baton d'Equinex";
      ["next"] = 2942;
      ["name_de"] = "Der Stock von Equinex";
      ["repgain"] = {
         [69] = 250;
      };
      ["reward"] = {
         [1] = 9307;
      };
      ["name"] = "The Stave of Equinex";
      ["prev"] = 2943;
      ["prequests"] = {
         [1] = 2943;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "El baculo de Equinex";
      ["req"] = 42;
   };
   [7721] = {
      ["name_ru"] = "Энергия для уменьшения";
      ["type"] = "Solo";
      ["objective"] = "Collect 10 Water Elemental Cores from the Sea Elementals and Sea Sprays along the Forgotten Coast of Feralas, and bring them back to Zorbin Fandazzle who is near the dock there.";
      ["repgain"] = {
         [21] = 350;
         [369] = 350;
         [577] = 350;
         [470] = 350;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "Du carburant pour la zappette";
      ["name_cn"] = "??器的?力";
      ["reward"] = {
         [1] = 19039;
      };
      ["name_de"] = "Treibstoff furs Schrumpfen";
      ["faction"] = "Horde";
      ["name"] = "Fuel for the Zapping";
      ["level"] = 48;
      ["name_es"] = "Combustible para el Ultra-reductor";
      ["req"] = 45;
   };
   [1167] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["name"] = "The Tower of Althalaxx";
      ["name_cn"] = "奥?拉克斯之塔";
      ["objective"] = "Speak with Balthule Shadowstrike near the Tower of Althalaxx.";
      ["next"] = 1143;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 1140;
      ["prequests"] = {
         [1] = 1140;
      };
      ["level"] = 28;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [5805] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue?!";
      ["name_cn"] = "?迎!";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Northshire Gift Voucher to Merissa Stilwell.";
      ["sort"] = "Northshire Abbey";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [5821] = {
      ["name_ru"] = "Наемный телохранитель";
      ["type"] = "Solo";
      ["objective"] = "Escort the Gizelton Caravan past the Kolkar Centaur village. Talk with Smeed at Scrabblescrew's Camp for your reward.";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "On engage?: gardes du corps";
      ["name_cn"] = "雇?保?";
      ["reward"] = {
         [1] = 15689;
      };
      ["name_de"] = "Leibwache zu mieten";
      ["faction"] = "Horde";
      ["name"] = "Bodyguard for Hire ";
      ["level"] = 35;
      ["name_es"] = "Guardaespaldas de alquiler";
      ["req"] = 30;
   };
   [2218] = {
      ["name_ru"] = "Путь к спасению";
      ["type"] = "Solo";
      ["objective"] = "Speak with Hulfdan Blackbeard in Ironforge.";
      ["next"] = 2238;
      ["sort"] = "Rogue";
      ["name_cn"] = "救?之路";
      ["name_fr"] = "La voie du salut";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name_de"] = "Strase der Rettung";
      ["faction"] = "Alliance";
      ["name"] = "Road to Salvation";
      ["level"] = 10;
      ["name_es"] = "El camino hacia la salvacion";
      ["req"] = 10;
   };
   [2927] = {
      ["name_ru"] = "На другой день";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Ozzie Togglevolt in Kharanos.";
      ["next"] = 2926;
      ["name_fr"] = "Le jour d'apres";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "??之后";
      ["repgain"] = {
         [54] = 10;
      };
      ["name_de"] = "Der Tag danach";
      ["faction"] = "Alliance";
      ["name"] = "The Day After";
      ["level"] = 27;
      ["name_es"] = "Al dia siguiente";
      ["req"] = 20;
   };
   [2935] = {
      ["name_ru"] = "Разговор с мастером Гадрином";
      ["type"] = "Group";
      ["name_fr"] = "Consulter Maitre Gadrin";
      ["repgain"] = {
         [530] = 150;
      };
      ["name_de"] = "Konsultiert Meister Gadrin";
      ["name"] = "Consult Master Gadrin";
      ["name_cn"] = "?教加德林大?";
      ["objective"] = "Speak with Master Gadrin in Sen'jin Village.";
      ["next"] = 2936;
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2934;
      ["prequests"] = {
         [1] = 2934;
      };
      ["level"] = 45;
      ["name_es"] = "Consulta al maestro Gadrin";
      ["req"] = 40;
   };
   [2943] = {
      ["name_ru"] = "Возвращение к Троясу";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Troyas";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Ruckkehr zu Troyas";
      ["name_cn"] = "向特洛?斯回?";
      ["name"] = "Return to Troyas";
      ["objective"] = "Deliver the book to Troyas Moonbreeze in Feathermoon Stronghold.";
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2944;
      ["prequests"] = {
         [1] = 2944;
      };
      ["level"] = 48;
      ["name_es"] = "Regresa junto a Troyas";
      ["req"] = 42;
   };
   [2951] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = " followed by some text:$B$B\"Grime and residue ruining your sparklies?  The Sparklematic 5200 puts the shine back in shine-tastic!  Insert the item you wish to clean and deposit three silver coins in the coin slot.  Give the Sparklematic 5200 a moment for operation";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "超?清?器5200型！";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_de"] = "Der Funkelmat 5200!";
      ["faction"] = "Horde";
      ["name"] = "The Sparklematic 5200!";
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [4492] = {
      ["name_ru"] = "Потерялся!";
      ["type"] = "Solo";
      ["objective"] = "Find Ringo at Fire Plume Ridge.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "走?了！";
      ["name_fr"] = "Perdu?!";
      ["name_de"] = "Verloren!";
      ["faction"] = "Horde";
      ["name"] = "Lost!";
      ["level"] = 55;
      ["name_es"] = "!Perdido!";
      ["req"] = 50;
   };
   [2967] = {
      ["name_ru"] = "Возвращение в Громовой Утес";
      ["type"] = "Group";
      ["name_fr"] = "Le retour aux Pitons du Tonnerre";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Ruckkehr nach Donnerfels";
      ["name"] = "Return to Thunder Bluff";
      ["name_cn"] = "返回雷霆崖";
      ["objective"] = "Speak with Nara Wildmane in Thunder Bluff.";
      ["next"] = 2968;
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 2954;
      ["prequests"] = {
         [1] = 2954;
      };
      ["level"] = 50;
      ["name_es"] = "Regresa a Cima del Trueno";
      ["req"] = 45;
   };
   [2975] = {
      ["name_ru"] = "Огры Фераласа";
      ["type"] = "Solo";
      ["name_fr"] = "Les ogres de Feralas";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Die Oger von Feralas";
      ["name_cn"] = "菲拉斯的食人魔";
      ["objective"] = "Rok Orhan in Camp Mojache wants you to kill 10 Gordunni Ogres, 10 Gordunni Ogre-Magi, and 5 Gordunni Brutes.";
      ["next"] = 2980;
      ["sort"] = "Feralas";
      ["name"] = "The Ogres of Feralas";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 43;
      ["name_es"] = "Los ogros de Feralas";
      ["req"] = 38;
   };
   [2983] = {
      ["name_ru"] = "Зов Огня";
      ["type"] = "Solo";
      ["objective"] = "Find Kranal Fiss in the Barrens.";
      ["next"] = 1524;
      ["sort"] = "Shaman";
      ["name_cn"] = "火?的召?";
      ["name_fr"] = "L'appel du feu";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1524;
      ["name_de"] = "Ruf des Feuers";
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["level"] = 10;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [5981] = {
      ["name_ru"] = "Истребление великанов";
      ["type"] = "Group";
      ["objective"] = "Rivern Frostwind wants you to kill 4 Frostmaul Giants and 4 Frostmaul Preservers.";
      ["repgain"] = {
         [589] = 75;
      };
      ["name_fr"] = "Geants dechaines";
      ["sort"] = "Winterspring";
      ["name_cn"] = "狂暴的巨人";
      ["name_de"] = "Tobende Riesen";
      ["faction"] = "Alliance";
      ["name"] = "Rampaging Giants";
      ["level"] = 60;
      ["name_es"] = "Gigantes arrasadores";
      ["req"] = 58;
   };
   [2999] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge";
      ["next"] = 1645;
      ["name_de"] = "Foliant der Offenbarung";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["name_fr"] = "Le Tome de divinite";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "Tome of Divinity";
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [3661] = {
      ["name_ru"] = "Любимцы Элуны?";
      ["type"] = "Solo";
      ["objective"] = "Collect 15 Wildkin Feathers from the Hinterlands for Erelas Ambersky in Rut'theran Village.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Dans les faveurs d'Elune??";
      ["sort"] = "Rut'theran Village";
      ["name_cn"] = "月神之?？";
      ["name_de"] = "Elunes Lieblinge?";
      ["faction"] = "Alliance";
      ["name"] = "Favored of Elune?";
      ["level"] = 47;
      ["name_es"] = "?Creados por Elune?";
      ["req"] = 42;
   };
   [6029] = {
      ["name_ru"] = "Донесение из Круговзора";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Everlook Report to Argent Officer Garush at the Bulwark, Western Plaguelands.";
      ["repgain"] = {
         [529] = 75;
         [0] = 577;
      };
      ["name_fr"] = "Le rapport de Long-guet";
      ["sort"] = "Winterspring";
      ["name_cn"] = "永望??告";
      ["name_de"] = "Der Bericht der Ewigen Warte";
      ["faction"] = "Horde";
      ["name"] = "The Everlook Report";
      ["level"] = 52;
      ["name_es"] = "El informe Vista Eterna";
      ["req"] = 50;
   };
   [3942] = {
      ["name_ru"] = "Память Линкена";
      ["type"] = "Solo";
      ["name_fr"] = "Les souvenirs de Linken";
      ["next"] = 4084;
      ["name_de"] = "Linkens Andenken";
      ["name_cn"] = "林克的??";
      ["objective"] = "Find Eridan Bluewind in southern Felwood.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Linken's Memory";
      ["prev"] = 3941;
      ["prequests"] = {
         [1] = 3941;
      };
      ["level"] = 54;
      ["name_es"] = "Recuerdos de Linken";
      ["req"] = 47;
   };
   [6061] = {
      ["name_ru"] = "Приручение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6087;
      ["name_de"] = "Die Zahmung der Bestie";
      ["name_cn"] = "?服野?";
      ["objective"] = "Use the Taming Rod to tame an Adult Plainstrider. Practice your skills, then return the Taming Rod to Yaw Sharpmane in Bloodhoof Village.";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["series"] = 1;
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [8693] = {
      ["name_ru"] = "Плащ сокрытых теней";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Martial Drape, 2 Azure Idols, 5 Bronze Scarabs and 5 Ivory Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La cape des ombres voilees";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?罩?影披?";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21406;
      };
      ["name_de"] = "Umhang der Schattenschleier";
      ["faction"] = "Horde";
      ["name"] = "Cloak of Veiled Shadows";
      ["level"] = 60;
      ["name_es"] = "La capa de las sombras ocultas";
      ["req"] = 60;
   };
   [7027] = {
      ["name_ru"] = "Пустые стойла";
      ["type"] = "Solo";
      ["objective"] = "Locate an Alterac Ram in Alterac Valley. Use the Stormpike Training Collar when you are near the Alterac Ram to 'tame' the beast. Once tamed, the Alterac Ram will follow you back to the Stable Master. Speak with the Stable Master to earn credit for the capture.$B";
      ["repgain"] = {
         [47] = 10;
         [730] = 10;
      };
      ["name_fr"] = "Ecuries vides";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?充坐?";
      ["name_de"] = "Verwaiste Stalle";
      ["faction"] = "Alliance";
      ["name"] = "Empty Stables";
      ["level"] = 60;
      ["name_es"] = "Establos vacios";
      ["req"] = 51;
   };
   [1956] = {
      ["name_ru"] = "Сила Ульдамана";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'energie d'Uldaman";
      ["next"] = 1957;
      ["name_de"] = "Kraft in Uldaman";
      ["objective"] = "Retrieve an Obsidian Power Source and bring it to Tabetha in Dustwallow Marsh.";
      ["name_cn"] = "奥?曼的能量源";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Power in Uldaman";
      ["prev"] = 1955;
      ["prequests"] = {
         [1] = 1955;
      };
      ["level"] = 40;
      ["name_es"] = "Poder en Uldaman";
      ["req"] = 35;
   };
   [6125] = {
      ["name_ru"] = "Власть над ядом";
      ["type"] = "Solo";
      ["name_fr"] = "Pouvoir contre le poison";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Macht uber Gift";
      ["objective"] = "Return to Mathrengyl Bearwalker in the Cenarion Enclave, Darnassus.";
      ["name_cn"] = "解毒之?";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Power over Poison";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 6124;
      ["prequests"] = {
         [1] = 6124;
      };
      ["level"] = 14;
      ["name_es"] = "Poder contra el veneno";
      ["req"] = 14;
   };
   [6141] = {
      ["name_ru"] = "Брат Антон";
      ["type"] = "Solo";
      ["objective"] = "Speak with Brother Anton in Desolace.";
      ["next"] = 261;
      ["sort"] = "Desolace";
      ["name_cn"] = "安?修士";
      ["name_fr"] = "Frere Anton";
      ["name_de"] = "Bruder Anton";
      ["faction"] = "Alliance";
      ["name"] = "Brother Anton";
      ["level"] = 39;
      ["name_es"] = "Hermano Anton";
      ["req"] = 34;
   };
   [1952] = {
      ["name_ru"] = "Магический жезл";
      ["type"] = "Solo";
      ["name_fr"] = "La baguette du mage";
      ["name_de"] = "Der Zauberstab des Magiers";
      ["objective"] = "Speak with Tabetha after her ritual.";
      ["reward"] = {
         [1] = 7514;
         [2] = 11263;
         [3] = 7513;
      };
      ["name_cn"] = "法?的魔杖";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Mage's Wand";
      ["sort"] = "Mage";
      ["prev"] = 1951;
      ["prequests"] = {
         [1] = 1951;
      };
      ["level"] = 40;
      ["name_es"] = "Varitas de mago";
      ["req"] = 30;
   };
   [3087] = {
      ["name_ru"] = "Пергамент с письменами";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin grave";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Geatztes Pergament";
      ["objective"] = "Read the Etched Parchment and speak to Jen'shan in the Valley of Trials.";
      ["name_cn"] = "??羊皮?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Etched Parchment";
      ["races"] = {
         [1] = "Orc";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Papiro con grabados";
      ["req"] = 1;
   };
   [3095] = {
      ["name_ru"] = "Простой свиток";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin simple";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Einfache Rolle";
      ["objective"] = "Read the Simple Scroll and speak to Dannal Stern in Deathknell.";
      ["name_cn"] = "?易卷?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Scroll";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 1;
      ["name_es"] = "Un pergamino simple";
      ["req"] = 1;
   };
   [3103] = {
      ["name_ru"] = "Святое письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre benie";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Geheiligter Brief";
      ["objective"] = "Read the Hallowed Letter and speak to Priestess Anetta in Northshire Abbey.";
      ["name_cn"] = "神?信件";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Hallowed Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta sacralizada";
      ["req"] = 1;
   };
   [4126] = {
      ["name_ru"] = "Харли Чернопых";
      ["type"] = "Dungeon";
      ["name_fr"] = "Hurley Soufflenoir";
      ["name_de"] = "Hurley Pestatem";
      ["reward"] = {
         [1] = 11964;
         [2] = 12003;
         [3] = 12000;
      };
      ["name_cn"] = "霍?雷・黑?";
      ["objective"] = "Bring the Lost Thunderbrew Recipe to Ragnar Thunderbrew in Kharanos.";
      ["faction"] = "Alliance";
      ["name"] = "Hurley Blackbreath";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4128;
      ["prequests"] = {
         [1] = 4128;
      };
      ["level"] = 55;
      ["name_es"] = "Hurley Negralito";
      ["req"] = 50;
   };
   [3119] = {
      ["name_ru"] = "Благословенный знак";
      ["type"] = "Solo";
      ["name_fr"] = "Sceau beni";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Geheiligtes Siegelzeichen";
      ["objective"] = "Read the Hallowed Sigil and speak to Shanda in Aldrassil.";
      ["name_cn"] = "神?符?";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Hallowed Sigil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 456;
      ["prequests"] = {
         [1] = 456;
      };
      ["level"] = 1;
      ["name_es"] = "Sigilo sacralizado";
      ["req"] = 1;
   };
   [8409] = {
      ["name_ru"] = "Поломанные бочки";
      ["type"] = "PvP";
      ["objective"] = "Return to Darkcaller Yanka at the Wickerman Festival in Tirisfal Glade.";
      ["repgain"] = {
         [76] = 150;
         [68] = 150;
         [81] = 150;
         [530] = 150;
      };
      ["name_de"] = "Verdorbenes Bier";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_cn"] = "?臭的?蛋";
      ["name_fr"] = "Des tonneaux gates";
      ["faction"] = "Horde";
      ["name"] = "Ruined Kegs";
      ["sort"] = "Hallow's End";
      ["prev"] = 8322;
      ["prequests"] = {
         [1] = 8322;
      };
      ["level"] = 60;
      ["name_es"] = "Los barriles danados";
      ["req"] = 25;
   };
   [8441] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 50;
      };
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["prev"] = 8437;
      ["prequests"] = {
         [1] = 8437;
      };
      ["level"] = 49;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 40;
   };
   [6285] = {
      ["name_ru"] = "Возвращение к Льюису";
      ["type"] = "Solo";
      ["name_fr"] = "Aller voir Lewis";
      ["repgain"] = {
         [72] = 350;
      };
      ["name_de"] = "Zuruck zu Lewis";
      ["name_cn"] = "返回西部荒野";
      ["objective"] = "Buy a gryphon ride to Sentinel Hill from the gryphon master Dungar Longdrink, then take Osric's Crate to Lewis at Sentinel Hill.";
      ["sort"] = "Westfall";
      ["name"] = "Return to Lewis";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 6261;
      ["prequests"] = {
         [1] = 6261;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa junto a Lewis";
      ["req"] = 10;
   };
   [8505] = {
      ["name_ru"] = "Альянсу не хватает лилового лотоса!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Purple Lotus to Master Nightsong at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de lotus pourpre !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要紫?花！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_de"] = "Die Allianz braucht lila Lotus!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Purple Lotus!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita lotos cardenos!";
      ["req"] = 37;
   };
   [8537] = {
      ["name_ru"] = "Багровый храмовник";
      ["type"] = "Group";
      ["objective"] = "Summon and slay a Crimson Templar and report back to Bor Wildmane in Cenarion Hold.  You must also bring Tactical Task Briefing II in order to complete this quest.";
      ["name_fr"] = "Le templier cramoisi";
      ["sort"] = "Silithus";
      ["name_cn"] = "微?公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 20809;
      };
      ["name_de"] = "Purpurroter Templer";
      ["faction"] = "Horde";
      ["name"] = "Crimson Templar";
      ["level"] = 60;
      ["name_es"] = "Templario Carmesi";
      ["req"] = 60;
   };
   [8569] = {
      ["name_ru"] = "Былые сражения в Ущелье Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "往日的?献：?歌峡谷";
      ["reward"] = {
         [1] = 20558;
      };
      ["name_de"] = "Vergangene Bemuhungen in der Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Past Efforts in Warsong Gulch";
      ["level"] = 1;
      ["name_es"] = "Esfuerzos del pasado en la Garganta Grito de Guerra";
      ["req"] = 1;
   };
   [8601] = {
      ["name_ru"] = "Орде все еще не хватает грубой кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Rugged Leather to Doctor Serratus at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr unverwustliches Leder!";
      ["name_fr"] = "La Horde a besoin de plus de cuir robuste?!";
      ["name_cn"] = "部落需要更多硬甲皮！";
      ["name"] = "The Horde Needs More Rugged Leather!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8600;
      ["prequests"] = {
         [1] = 8600;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas pieles de cuero basto!";
      ["req"] = 1;
   };
   [8633] = {
      ["name_ru"] = "Одеяния Таинства";
      ["objective"] = "Bring the Husk of the Old God, 2 Idols of the Sun, 5 Gold Scarabs and 5 Clay Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神秘?袍";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La robe de l'enigme";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Roben des Mysteriums";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21343;
      };
      ["name"] = "Enigma Robes";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Togas Enigma";
      ["req"] = 60;
   };
   [8665] = {
      ["name_ru"] = "Сапоги сотворения";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Rebirth, 5 Stone Scarabs and 5 Silver Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "起源?靴";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de la genese";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Stiefel der Genesis";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21355;
      };
      ["name"] = "Genesis Boots";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas genesis";
      ["req"] = 60;
   };
   [8697] = {
      ["name_ru"] = "Кольцо Бесконечной мудрости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ceremonial Ring, 2 Obsidian Idols, 5 Silver Scarabs and 5 Bone Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L' anneau de sagesse infinie";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "无尽智慧之戒";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21411;
      };
      ["name_de"] = "Ring der unendlichen Weisheit";
      ["faction"] = "Horde";
      ["name"] = "Ring of Infinite Wisdom";
      ["level"] = 60;
      ["name_es"] = "El anillo de sabiduria infinita";
      ["req"] = 60;
   };
   [8729] = {
      ["name_ru"] = "Гнев Нептулона";
      ["objective"] = "Use the Arcanite Buoy at the Swirling Maelstrom at the Bay of Storms in Azshara.";
      ["name_cn"] = "奈普?洛斯的?怒";
      ["sort"] = "Azshara";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le courroux de Neptulon";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Der Zorn von Neptulon";
      ["followup"] = 8742;
      ["faction"] = "Horde";
      ["name"] = "The Wrath of Neptulon";
      ["prev"] = 8728;
      ["prequests"] = {
         [1] = 8728;
      };
      ["reward"] = {
         [1] = 21526;
         [2] = 21527;
      };
      ["name_es"] = "La colera de Neptulon";
      ["req"] = 60;
   };
   [8761] = {
      ["name_ru"] = "Великий заклинатель";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 100;
      };
      ["name_de"] = "Der grose Herbeirufer";
      ["name_fr"] = "Le Grand Invocateur";
      ["name_cn"] = "虔?的祈求者";
      ["faction"] = "Horde";
      ["name"] = "The Grand Invoker";
      ["reward"] = {
         [1] = 21210;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8760;
      ["prequests"] = {
         [1] = 8760;
      };
      ["level"] = 60;
      ["name_es"] = "El gran convocador";
      ["req"] = 60;
   };
   [8793] = {
      ["name_ru"] = "Орде нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Warlord Gorchuk in Orgrimmar's Valley of Spirits.";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要?的?助！";
      ["name_fr"] = "La Horde a besoin de votre aide?!";
      ["name_de"] = "Die Horde braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Horda te necesita!";
      ["req"] = 10;
   };
   [8825] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8857] = {
      ["name_ru"] = "Тайны колосса ? Аши";
      ["type"] = "Solo";
      ["objective"] = "Take the Colossus of Ashi's Husk to Oglethorpe Obnoticus in Booty Bay.$B";
      ["repgain"] = {
         [21] = 1000;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Les secrets du Colosse - Ashi";
      ["name_cn"] = "?什巨像的秘密";
      ["reward"] = {
         [1] = 21528;
      };
      ["name_de"] = "Geheimnisse des Kolosses - Ashi";
      ["faction"] = "Horde";
      ["name"] = "Secrets of the Colossus - Ashi";
      ["level"] = 60;
      ["name_es"] = "Los secretos de los Colosos: Ashi";
      ["req"] = 51;
   };
   [4284] = {
      ["name_ru"] = "Кристаллы силы";
      ["type"] = "Solo";
      ["objective"] = "Collect 7 Power Crystals of each color: red, blue, yellow, and green. Bring them to J.D. Collie at Marshal's Refuge.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "能量水晶";
      ["name_fr"] = "Cristaux de puissance";
      ["name_de"] = "Machtkristalle";
      ["faction"] = "Horde";
      ["name"] = "Crystals of Power";
      ["level"] = 53;
      ["name_es"] = "Cristales de poder";
      ["req"] = 47;
   };
   [8921] = {
      ["name_ru"] = "Эктоплазматический дистиллятор";
      ["type"] = "Solo";
      ["name_fr"] = "L'alambic ectoplasmique";
      ["next"] = 8924;
      ["name_de"] = "Der Ektoplasmadestillierer";
      ["name_cn"] = "??提?器";
      ["objective"] = "Return to Mux Manascrambler in Gadgetzan with 1 Delicate Arcanite Converter, 4 Greater Eternal Essence, 10 Stonescale Oil, 25 Volcanic Ash and 40 gold.";
      ["sort"] = "Tanaris";
      ["reward"] = {
         [1] = 22320;
      };
      ["name"] = "The Ectoplasmic Distiller";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8922;
         [2] = 8923;
      };
      ["level"] = 60;
      ["name_es"] = "El destilador ectoplasmico";
      ["req"] = 58;
   };
   [8953] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Magister's Boots, Magister's Leggings and Magister's Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22064;
         [2] = 22067;
         [3] = 22068;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [6541] = {
      ["name_ru"] = "Донесение Кадраку";
      ["type"] = "Solo";
      ["objective"] = "Report to Kadrak at the watch tower in northern Barrens.";
      ["next"] = 6543;
      ["sort"] = "The Barrens";
      ["name_cn"] = "向?德拉克?到";
      ["name_fr"] = "Rapport a Kadrak";
      ["name_de"] = "Meldung bei Kadrak";
      ["faction"] = "Horde";
      ["name"] = "Report to Kadrak";
      ["level"] = 19;
      ["name_es"] = "Presentate ante Kadrak";
      ["req"] = 17;
   };
   [9017] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Beaststalker's Boots, Beaststalker's Pants and Beaststalker's Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22061;
         [2] = 22017;
         [3] = 22016;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [9049] = {
      ["name_ru"] = "Ремень Искупления";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make a Redemption Girdle if you bring him the following: 1 Desecrated Girdle, 8 Wartorn Plate Scraps, 1 Arcanite Bar and 3 Nexus Crystals.";
      ["name_cn"] = "救?束?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le ceinturon de redemption";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gurt der Erlosung";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 22431;
      };
      ["name"] = "Redemption Girdle";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La faja de redencion";
      ["req"] = 60;
   };
   [9081] = {
      ["name_ru"] = "Башмаки костяной косы";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make Bonescythe Sabatons if you bring him the following: 1 Desecrated Sabatons, 12 Wartorn Leather Scraps, 3 Cured Rugged Hides, 2 Nexus Crystals and 25 gold pieces. ";
      ["name_cn"] = "骨??靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les solerets de la fauchese d'os";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Sabatons der Knochensense";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22480;
      };
      ["name"] = "Bonescythe Sabatons";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los escarpes Segahuesos";
      ["req"] = 60;
   };
   [6605] = {
      ["name_ru"] = "Странная дамочка";
      ["type"] = "Solo";
      ["objective"] = "Speak with Winna Hazzard in Felwood.";
      ["next"] = 4505;
      ["name_fr"] = "Une etrange personne";
      ["sort"] = "Winterspring";
      ["name_cn"] = "奇怪的家?";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Eine seltsame Person";
      ["faction"] = "Horde";
      ["name"] = "A Strange One";
      ["level"] = 54;
      ["name_es"] = "Algo extrano";
      ["req"] = 49;
   };
   [6621] = {
      ["name_ru"] = "Король Гиблой Чащи";
      ["type"] = "Group";
      ["name_fr"] = "Le roi des Vile-sylve";
      ["name_de"] = "Konig der Faulnisklauen";
      ["reward"] = {
         [1] = 17005;
         [2] = 17006;
      };
      ["name_cn"] = "?林熊怪之王";
      ["objective"] = "Place Karang's Banner on the Foulweald Totem Mound.  Do not let the furbolgs destroy the banner.  Defeat Chief Murgut and bring Murgut's Totem to Karang Amakkar at Zoram'gar.";
      ["faction"] = "Horde";
      ["name"] = "King of the Foulweald";
      ["sort"] = "Ashenvale";
      ["prev"] = 216;
      ["prequests"] = {
         [1] = 216;
      };
      ["level"] = 26;
      ["name_es"] = "El rey de los Maderiza";
      ["req"] = 21;
   };
   [2942] = {
      ["name_ru"] = "Завтрашний камень";
      ["type"] = "Solo";
      ["objective"] = "Return the Sparkling Stone and the Stave of Equinex to Troyas Moonbreeze in Feathermoon Stronghold. ";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Morgenstein";
      ["reward"] = {
         [1] = 9654;
         [2] = 9655;
      };
      ["name_cn"] = "晨光石";
      ["name_fr"] = "La Pierre du matin";
      ["faction"] = "Alliance";
      ["name"] = "The Morrow Stone";
      ["sort"] = "Feralas";
      ["prev"] = 2879;
      ["prequests"] = {
         [1] = 2879;
      };
      ["level"] = 50;
      ["name_es"] = "La Piedra del manana";
      ["req"] = 42;
   };
   [9209] = {
      ["name_ru"] = "Защита Джунглей ? Магический знак стремительности";
      ["type"] = "Raid";
      ["objective"] = "Zanza the Restless in Zul'Gurub wants an Arcanum of Rapidity.";
      ["repgain"] = {
         [270] = 200;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La Garde sauvage - Arcanum de rapidite";
      ["name_cn"] = "野性戒? - 急速秘?";
      ["reward"] = {
         [1] = 22635;
      };
      ["name_de"] = "Der Greuelwachter - Arkanum der Schnelligkeit";
      ["faction"] = "Horde";
      ["name"] = "The Savage Guard - Arcanum of Rapidity";
      ["level"] = 60;
      ["name_es"] = "La guardia salvaje: arcanum de rapidez";
      ["req"] = 60;
   };
   [9241] = {
      ["name_ru"] = "Снежные наручи";
      ["type"] = "Raid";
      ["name_fr"] = "Les brassards polaires";
      ["name_de"] = "Polararmschienen";
      ["reward"] = {
         [1] = 22663;
      };
      ["name_cn"] = "北??腕";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 4 Frozen Runes, 12 Enchanted Leather, 3 Essence of Water, 3 Cured Rugged Hides and 200 gold. $B";
      ["faction"] = "Horde";
      ["name"] = "Polar Bracers";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los brazales polares";
      ["req"] = 60;
   };
   [4324] = {
      ["name_ru"] = "Юка Крутипроб";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Yuka Screwspigot in the Burning Steppes.";
      ["next"] = 4136;
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "尤?・斯?比格特";
      ["name_fr"] = "Yuka Fermevanne";
      ["name_de"] = "Yuka Schraubstutz";
      ["faction"] = "Horde";
      ["name"] = "Yuka Screwspigot";
      ["level"] = 53;
      ["name_es"] = "Yuka Llavenrosca";
      ["req"] = 48;
   };
   [6701] = {
      ["name_ru"] = "Эмблемы Синдиката";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [349] = 100;
      };
      ["name_de"] = "Syndikatsembleme";
      ["name_fr"] = "Emblemes du Syndicat";
      ["name_cn"] = "辛迪加徽章";
      ["name"] = "Syndicate Emblems";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["sort"] = "Rogue";
      ["prev"] = 6681;
      ["prequests"] = {
         [1] = 6681;
      };
      ["level"] = 60;
      ["name_es"] = "Emblemas de la Hermandad";
      ["req"] = 24;
   };
   [9337] = {
      ["name_ru"] = "Гигантский флакон с зельем маны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "超?法力?水";
      ["reward"] = {
         [1] = 13444;
      };
      ["name_de"] = "Erstklassiger Manatrank";
      ["faction"] = "Horde";
      ["name"] = "Major Mana Potion";
      ["level"] = 0;
      ["name_es"] = "Superpocion de mana";
      ["req"] = 50;
   };
   [3367] = {
      ["name_ru"] = "Камни Сунтары";
      ["type"] = "Solo";
      ["name_fr"] = "Les pierres de Suntara";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Suntarasteine";
      ["name_cn"] = "?塔拉之石";
      ["objective"] = "Help Dorius get back to Ironforge.$B";
      ["next"] = 3368;
      ["sort"] = "Searing Gorge";
      ["name"] = "Suntara Stones";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 48;
      ["name_es"] = "Piedras de Suntara";
      ["req"] = 40;
   };
   [3375] = {
      ["name_ru"] = "Запасной фиал";
      ["type"] = "Solo";
      ["objective"] = "Bring a Mana Potion, Coal, and Sweet Nectar to Talvash del Kissel in Ironforge to get a replacement for Talvash's Phial of Scrying.";
      ["sort"] = "Uldaman";
      ["name_cn"] = "占卜之瓶";
      ["name_fr"] = "La fiole de remplacement";
      ["name_de"] = "Ersatzphiole";
      ["faction"] = "Alliance";
      ["name"] = "Replacement Phial";
      ["level"] = 42;
      ["name_es"] = "Otra ampolla";
      ["req"] = 37;
   };
   [4361] = {
      ["name_ru"] = "Недобрые вести";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le porteur des mauvaises nouvelles";
      ["repgain"] = {
         [47] = 20;
      };
      ["name_de"] = "Der Uberbringer schlechter Botschaften...";
      ["name"] = "The Bearer of Bad News";
      ["name_cn"] = "糟?的消息";
      ["objective"] = "Return to Ironforge and deliver the bad news to King Magni Bronzebeard.";
      ["next"] = 4362;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4341;
      ["prequests"] = {
         [1] = 4341;
      };
      ["level"] = 59;
      ["name_es"] = "Portador de malas noticias";
      ["req"] = 50;
   };
   [6781] = {
      ["name_ru"] = "Больше обломков брони";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 1;
      };
      ["name_de"] = "Mehr Rustungsfetzen";
      ["name_cn"] = "?甲碎片";
      ["name_fr"] = "Plus de morceaux d'armure?!";
      ["name"] = "More Armor Scraps";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Valley";
      ["prev"] = 7223;
      ["prequests"] = {
         [1] = 7223;
      };
      ["level"] = 60;
      ["name_es"] = "Mas restos de armadura";
      ["req"] = 51;
   };
   [8675] = {
      ["name_ru"] = "Предок Небесная Охотница";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Chasse-le-ciel";
      ["name_cn"] = "逐星?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Himmelsjager";
      ["faction"] = "Horde";
      ["name"] = "Skychaser the Elder";
      ["level"] = 60;
      ["name_es"] = "Cazacielo el Ancestro";
      ["req"] = 1;
   };
   [4461] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [4508] = {
      ["name_ru"] = "Затишье перед бурей";
      ["objective"] = "Bring Pestlezugg's Un'Goro Report to Gracina Spiritmight in Darnassus.";
      ["name_cn"] = "?危不惧";
      ["sort"] = "Tanaris";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Le calme avant la tempete";
      ["next"] = 4510;
      ["name_de"] = "Die Ruhe vor dem Sturm";
      ["repgain"] = {
         [69] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "Calm Before the Storm";
      ["prev"] = 4507;
      ["prequests"] = {
         [1] = 4507;
      };
      ["series"] = 1;
      ["name_es"] = "La calma que precede a la tormenta";
      ["req"] = 50;
   };
   [6845] = {
      ["name_ru"] = "Раскрытие древних секретов";
      ["type"] = "Solo";
      ["objective"] = "Speak with Rabine Saturna in the village of Nighthaven, Moonglade.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_de"] = "Enthullung von Geheimnissen der Vergangenheit";
      ["reward"] = {
         [1] = 18400;
         [2] = 18402;
      };
      ["name_cn"] = "???去的秘密";
      ["name_fr"] = "Les secrets du passe";
      ["faction"] = "Horde";
      ["name"] = "Uncovering Past Secrets";
      ["sort"] = "Moonglade";
      ["prev"] = 6844;
      ["prequests"] = {
         [1] = 6844;
      };
      ["level"] = 57;
      ["name_es"] = "Desvelar los secretos del pasado";
      ["req"] = 54;
   };
   [6861] = {
      ["name_ru"] = "Портативный крошшер Зинфиззлекса";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["name_fr"] = "Le Dechiqueteur portable de Zinfizzlex";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "斯菲莱克斯的便携式伐木机";
      ["reward"] = {
         [1] = 17384;
      };
      ["name_de"] = "Zinnzischelix's tragbare Schreddereinheit";
      ["faction"] = "Horde";
      ["name"] = "Zinfizzlex's Portable Shredder Unit";
      ["level"] = 60;
      ["name_es"] = "La unidad trituradora portatil de Zinfizzlex";
      ["req"] = 51;
   };
   [5518] = {
      ["name_ru"] = "Броня огров Гордока";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 4 Bolts of Runecloth, 8 Rugged Leather, 2 Rune Threads, and Ogre Tannin to Knot Thimblejack.  He is currently chained inside the Gordok wing of Dire Maul.";
      ["repgain"] = {
         [21] = 250;
         [369] = 250;
         [577] = 250;
         [470] = 250;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "La tenue d'ogre gordok";
      ["name_cn"] = "戈多克食人魔装";
      ["reward"] = {
         [1] = 18258;
      };
      ["name_de"] = "Der Ogeranzug der Gordok";
      ["faction"] = "Horde";
      ["name"] = "The Gordok Ogre Suit";
      ["level"] = 60;
      ["name_es"] = "El disfraz de ogro Gordok";
      ["req"] = 56;
   };
   [3447] = {
      ["name_ru"] = "Тайна камня";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le secret du cercle";
      ["name_de"] = "Das Geheimnis des Kreises";
      ["reward"] = {
         [1] = 10773;
      };
      ["name_cn"] = "雕像群的秘密";
      ["objective"] = "Travel into the Sunken Temple and discover the secret hidden in the circle of statues.";
      ["faction"] = "Horde";
      ["name"] = "Secret of the Circle";
      ["sort"] = "Sunken Temple";
      ["prev"] = 3444;
      ["prequests"] = {
         [1] = 3444;
      };
      ["level"] = 51;
      ["name_es"] = "El secreto del circulo";
      ["req"] = 46;
   };
   [1107] = {
      ["name_ru"] = "Средство против трения";
      ["type"] = "Group";
      ["name_fr"] = "Les nageoires incrustees";
      ["name_de"] = "Verkrustete Schwanzflossen";
      ["name_cn"] = "?硬的尾?";
      ["objective"] = "Bring 10 Encrusted Tail Fins to Wizzle Brassbolts in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Encrusted Tail Fins";
      ["prev"] = 1105;
      ["prequests"] = {
         [1] = 1105;
      };
      ["level"] = 35;
      ["name_es"] = "Aletas dorsales taraceadas";
      ["req"] = 28;
   };
   [3463] = {
      ["name_ru"] = "Задай им жару!";
      ["type"] = "Group";
      ["name_fr"] = "Allumer le feu?!";
      ["name_de"] = "Setzt sie in Brand!";
      ["reward"] = {
         [1] = 10742;
         [2] = 10743;
         [3] = 10744;
      };
      ["name_cn"] = "?掉它?！";
      ["objective"] = "Set the North, South, East, and West Sentry Towers on fire by using the Torch of Retribution inside each of the buildings. $B";
      ["faction"] = "Horde";
      ["name"] = "Set Them Ablaze!";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3462;
      ["prequests"] = {
         [1] = 3462;
      };
      ["level"] = 52;
      ["name_es"] = "!Prendeles fuego!";
      ["req"] = 40;
   };
   [6941] = {
      ["name_ru"] = "Небо зовет ? флот Змейера";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 2;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille de Vipore";
      ["name_cn"] = "天空的召? - ?波里的空?";
      ["name_de"] = "Ruf der Lufte - Vipores Luftflotte";
      ["faction"] = "Alliance";
      ["name"] = "Call of Air - Vipore's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: la flota de Vipore";
      ["req"] = 51;
   };
   [1522] = {
      ["name_ru"] = "Зов Огня";
      ["type"] = "Solo";
      ["objective"] = "Find Kranal Fiss in the Barrens.";
      ["next"] = 1524;
      ["sort"] = "Shaman";
      ["name_cn"] = "火?的召?";
      ["name_fr"] = "L'appel du feu";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1524;
      ["name_de"] = "Ruf des Feuers";
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["level"] = 10;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [4726] = {
      ["name_ru"] = "Сущность детеныша дракона";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Broodling Essence and the Draco-Incarcinatrix 900 to Tinkee Steamboil at the Flame Crest in the Burning Steppes.";
      ["next"] = 4808;
      ["name_fr"] = "L'essence de rejeton";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "??精?";
      ["repgain"] = {
         [21] = 250;
         [369] = 250;
         [577] = 250;
         [470] = 250;
      };
      ["name_de"] = "Brutlingessenz";
      ["faction"] = "Horde";
      ["name"] = "Broodling Essence";
      ["level"] = 52;
      ["name_es"] = "Esencia de cria";
      ["req"] = 50;
   };
   [9107] = {
      ["name_ru"] = "Сандалии Проклятого Сердца";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make Plagueheart Sandals if you bring him the following: 1 Desecrated Sandals, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.";
      ["name_cn"] = "瘟疫之心便鞋";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les sandales de pestecoeur";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Sandalen des verseuchten Herzens";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 22508;
      };
      ["name"] = "Plagueheart Sandals";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los botines corazon de peste";
      ["req"] = 60;
   };
   [3503] = {
      ["name_ru"] = "Встреча с господином";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Azshara";
      ["name_cn"] = "?到主人";
      ["name_fr"] = "Reunion avec le Maitre";
      ["name_de"] = "Treffen mit dem Meister";
      ["faction"] = "Horde";
      ["name"] = "Meeting with the Master";
      ["level"] = 55;
      ["name_es"] = "Encuentro con el maestro";
      ["req"] = 45;
   };
   [7021] = {
      ["name_ru"] = "Здравствуй, Дедушка Зима!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter; he is located near the Smokywood Pastures vendor area in Orgrimmar.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天??来了！";
      ["name_fr"] = "Grand-pere Hiver est ici?!";
      ["name_de"] = "Altvater Winter ist hier!";
      ["faction"] = "Horde";
      ["name"] = "Great-father Winter is Here!";
      ["level"] = 60;
      ["name_es"] = "!El Gran Padre Invierno esta aqui!";
      ["req"] = 10;
   };
   [3519] = {
      ["name_ru"] = "Друг в беде";
      ["type"] = "Solo";
      ["name_fr"] = "Un ami dans le besoin";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Ein Freund in der Not";
      ["name"] = "A Friend in Need";
      ["name_cn"] = "需要?助的朋友";
      ["objective"] = "Speak to Dirania Silvershine in Shadowglen.";
      ["next"] = 3521;
      ["faction"] = "Alliance";
      ["sort"] = "Shadowglen";
      ["prev"] = 4495;
      ["prequests"] = {
         [1] = 4495;
      };
      ["level"] = 4;
      ["name_es"] = "Un amigo en apuros";
      ["req"] = 2;
   };
   [3527] = {
      ["name_ru"] = "Пророчество Мошару";
      ["type"] = "Dungeon";
      ["name_fr"] = "La prophetie de Mosh'aru";
      ["next"] = 4787;
      ["name_de"] = "Die Prophezeiung von Mosh'aru";
      ["name_cn"] = "摩沙?的?言";
      ["objective"] = "Bring the First and Second Mosh'aru Tablets to Yeh'kinya in Tanaris.";
      ["sort"] = "Zul'Farrak";
      ["faction"] = "Horde";
      ["name"] = "The Prophecy of Mosh'aru";
      ["prev"] = 3520;
      ["prequests"] = {
         [1] = 3520;
      };
      ["level"] = 47;
      ["name_es"] = "La profecia de Mosh'aru";
      ["req"] = 40;
   };
   [9058] = {
      ["name_ru"] = "Сапоги расхитителя гробниц";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make Cryptstalker Boots if you bring him the following: 1 Desecrated Boots, 12 Wartorn Chain Scraps, 1 Arcanite Bar and 3 Nexus Crystals.";
      ["name_cn"] = "地穴追?者?靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de traqueur des cryptes";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stiefel des Gruftpirschers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22440;
      };
      ["name"] = "Cryptstalker Boots";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas de acechacriptas";
      ["req"] = 60;
   };
   [3501] = {
      ["name_ru"] = "Счет идет на большие числа";
      ["type"] = "Solo";
      ["objective"] = "Bring Kum'isha Imperfect Draenethyst Fragments and be rewarded for each one you turn in.$B";
      ["next"] = 3502;
      ["name_fr"] = "Tout se compte en grandes quantites";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "多多益善";
      ["reward"] = {
         [1] = 12122;
      };
      ["name_de"] = "Viel hilft viel";
      ["faction"] = "Horde";
      ["name"] = "Everything Counts In Large Amounts";
      ["level"] = 55;
      ["name_es"] = "Todo cuenta en grandes cantidades";
      ["req"] = 45;
   };
   [7101] = {
      ["name_ru"] = "Башни и бункеры";
      ["type"] = "PvP";
      ["objective"] = "Capture an enemy tower, then return to Corporal Teeka Bloodsnarl in the Alterac Mountains.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "哨塔和?堡";
      ["name_fr"] = "Tours et fortins";
      ["name_de"] = "Turme und Bunker";
      ["faction"] = "Horde";
      ["name"] = "Towers and Bunkers";
      ["level"] = 60;
      ["name_es"] = "Las torres y los bunkeres";
      ["req"] = 51;
   };
   [2758] = {
      ["name_ru"] = "Происхождение кузнечного искусства";
      ["type"] = "Solo";
      ["objective"] = "Bring six Golden Scale Bracers to Hank the Hammer in Stormwind.";
      ["next"] = 2759;
      ["name_fr"] = "Les origines de la forge";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "?造的本源";
      ["reward"] = {
         [1] = 9367;
      };
      ["name_de"] = "Die Herkunft der Schmiedekunst";
      ["faction"] = "Alliance";
      ["name"] = "The Origins of Smithing";
      ["level"] = 40;
      ["name_es"] = "El origen de la herreria";
      ["req"] = 40;
   };
   [3567] = {
      ["name_ru"] = "Умный в гору не пойдет...";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Feralas";
      ["name_cn"] = "登高";
      ["name_fr"] = "Au sommet";
      ["name_de"] = "An die Spitze";
      ["faction"] = "Horde";
      ["name"] = "To the Top";
      ["level"] = 25;
      ["name_es"] = "A la cima";
      ["req"] = 25;
   };
   [4381] = {
      ["name_ru"] = "Кристалл восстановления";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallflicker";
      ["name_fr"] = "Cristal de restauration";
      ["name_cn"] = "恢?水晶";
      ["name"] = "Crystal Restore";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11562;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "El cristal de restauracion";
      ["req"] = 47;
   };
   [7165] = {
      ["name_ru"] = "Заслуженное почтение";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Montee en grade";
      ["name_cn"] = "?得尊敬";
      ["reward"] = {
         [1] = 17907;
      };
      ["name_de"] = "Verdiente Ehrerbietung";
      ["faction"] = "Horde";
      ["name"] = "Earned Reverence";
      ["level"] = 60;
      ["name_es"] = "Ganarse una reverencia";
      ["req"] = 51;
   };
   [7181] = {
      ["name_ru"] = "Легенда о Корраке";
      ["type"] = "Raid";
      ["objective"] = "According to legend, the leader of the mighty Winterax trolls appears at will to wreak havoc on the denizens of Alterac Valley.$B$BShould Korrak make himself known, destroy him and return to Warmaster Laggrond.";
      ["name_fr"] = "La legende de Korrak";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "科?拉克的??";
      ["reward"] = {
         [1] = 19107;
         [2] = 18149;
         [3] = 19106;
         [4] = 19108;
      };
      ["name_de"] = "Die Legende von Korrak";
      ["faction"] = "Horde";
      ["name"] = "The Legend of Korrak";
      ["level"] = 60;
      ["name_es"] = "La leyenda de Korrak";
      ["req"] = 51;
   };
   [7818] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [68] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Undercity";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7813;
         [2] = 7814;
         [3] = 7817;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [5862] = {
      ["name_ru"] = "Уловка против Алого Ордена";
      ["type"] = "Group";
      ["name_fr"] = "Le subterfuge ecarlate";
      ["name_de"] = "Scharlachrote Tauschung";
      ["name_cn"] = "血色幻象";
      ["objective"] = "Speak to Myranda to gain the Scarlet Illusion. Travel to Hearthglen while under the Scarlet Illusion and deliver Tirion's Gift to Highlord Taelan Fordring.$B$BHearthglen is to the north, Taelan should be inside of Mardenholde Keep.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Scarlet Subterfuge";
      ["prev"] = 5861;
      ["prequests"] = {
         [1] = 5861;
      };
      ["level"] = 60;
      ["name_es"] = "El subterfugio Escarlata";
      ["req"] = 52;
   };
   [8818] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["name_fr"] = "Une chevaliere de merite";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [2584] = {
      ["name_ru"] = "Дух вепря";
      ["type"] = "Solo";
      ["name_fr"] = "L'esprit du sanglier";
      ["name_de"] = "Geist des Ebers";
      ["reward"] = {
         [1] = 8411;
      };
      ["name_cn"] = "野猪之魂";
      ["objective"] = "Bring three Blasted Boar Lungs, two Scorpok Pincers, and one Basilisk Brain to Bloodmage Drazial.$B";
      ["faction"] = "Horde";
      ["name"] = "Spirit of the Boar";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2583;
      ["prequests"] = {
         [1] = 2583;
      };
      ["level"] = 50;
      ["name_es"] = "El espiritu del jabali";
      ["req"] = 45;
   };
   [7261] = {
      ["name_ru"] = "Королевское право";
      ["type"] = "PvP";
      ["objective"] = "Travel to Alterac Valley in the Hillsbrad Foothills. Outside of the entrance tunnel, find and speak with Lieutenant Haggerdin.$B$BFor the glory of Bronzebeard!";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "L'imperatif souverain";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "国王的命令";
      ["name_de"] = "Die hoheitliche Anordnung";
      ["faction"] = "Alliance";
      ["name"] = "The Sovereign Imperative";
      ["level"] = 60;
      ["name_es"] = "El imperativo soberano";
      ["req"] = 51;
   };
   [3639] = {
      ["name_ru"] = "Покажи свою работу";
      ["type"] = "Solo";
      ["name_fr"] = "Montrez votre travail";
      ["name_de"] = "Zeigt Eure Arbeit";
      ["reward"] = {
         [1] = 10791;
      };
      ["name_cn"] = "工作成果";
      ["objective"] = "Bring 20 Big Iron Bombs, 20 Solid Dynamite, and 5 Explosive Sheep to Nixx Sprocketspring in Gadgetzan.";
      ["faction"] = "Horde";
      ["name"] = "Show Your Work";
      ["sort"] = "Engineering";
      ["prev"] = 3638;
      ["prequests"] = {
         [1] = 3638;
      };
      ["level"] = 47;
      ["name_es"] = "Muestra tu trabajo";
      ["req"] = 30;
   };
   [3647] = {
      ["name_ru"] = "Продление членского билета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Mitgliedskarten-Erneuerung";
      ["name_fr"] = "Le renouvellement de la Carte de membre";
      ["name_cn"] = "会????";
      ["name"] = "Membership Card Renewal";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 10790;
      };
      ["sort"] = "Engineering";
      ["prev"] = 3643;
      ["prequests"] = {
         [1] = 3643;
      };
      ["level"] = 47;
      ["name_es"] = "Renovacion de la tarjeta de miembro";
      ["req"] = 30;
   };
   [1118] = {
      ["name_ru"] = "Назад в Пиратскую бухту";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a Baie-du-Butin";
      ["name_de"] = "Zuruck nach Beutebucht";
      ["objective"] = "Bring Kravel's Scheme to Crank Fizzlebub in Booty Bay.";
      ["name_cn"] = "返回藏宝海湾";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Back to Booty Bay";
      ["followup"] = 1119;
      ["prev"] = 1117;
      ["prequests"] = {
         [1] = 1117;
      };
      ["level"] = 43;
      ["name_es"] = "De vuelta a Bahia del Botin";
      ["req"] = 35;
   };
   [6571] = {
      ["name_ru"] = "Поставка для Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "Collect the Warsong Supplies: Warsong Saw Blades, Logging Rope, Warsong Oil, and the Warsong Axe Shipment for Locke Okarr in Splintertree Post.";
      ["repgain"] = {
         [76] = 350;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Fournitures Chanteguerre";
      ["name_cn"] = "?歌氏族的??品";
      ["reward"] = {
         [1] = 16975;
         [2] = 16977;
         [3] = 16978;
      };
      ["name_de"] = "Nachschub des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "Warsong Supplies";
      ["level"] = 27;
      ["name_es"] = "Suministros Grito de Guerra";
      ["req"] = 22;
   };
   [7341] = {
      ["name_ru"] = "Честная сделка";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un marche honnete";
      ["name_cn"] = "公平交易";
      ["reward"] = {
         [1] = 18042;
      };
      ["name_de"] = "Ein gerechter Handel";
      ["faction"] = "Horde";
      ["name"] = "A Fair Trade";
      ["level"] = 60;
      ["name_es"] = "Un trato justo";
      ["req"] = 52;
   };
   [9227] = {
      ["name_ru"] = "Превосходное боевое снаряжениее ? Восторг Рассвета";
      ["type"] = "Solo";
      ["objective"] = "For 6 Insignias of the Dawn and 6 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille excellentes - Exalte aupres de";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "精良的作?装? - ?色黎明崇拜";
      ["reward"] = {
         [1] = 22681;
         [2] = 22680;
         [3] = 22688;
         [4] = 22679;
         [5] = 22690;
         [6] = 22689;
      };
      ["name_de"] = "Uberragende Kampfausrustung - Ehrfurcht der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Superior Armaments of Battle - Exalted Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento superior de batalla: exaltado con El Alba";
      ["req"] = 55;
   };
   [2283] = {
      ["name_ru"] = "Пропавшее ожерелье";
      ["type"] = "Dungeon";
      ["objective"] = "Look for a valuable necklace within the Uldaman dig site and bring it back to Dran Droffers in Orgrimmar.  The necklace may be damaged.";
      ["next"] = 2284;
      ["name_fr"] = "Reparer le Collier";
      ["sort"] = "Uldaman";
      ["name_cn"] = "搜???";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Wiederbeschaffung der Halskette";
      ["faction"] = "Horde";
      ["name"] = "Necklace Recovery";
      ["level"] = 41;
      ["name_es"] = "La recuperacion del collar";
      ["req"] = 37;
   };
   [8539] = {
      ["name_ru"] = "Цель: сестры-убийцы из Улья Зора";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Zora Hive Sisters and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing V in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les s?urs de Ruche'Zora";
      ["name_cn"] = "目?：佐拉雌蝎";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Schwestern des Zoraschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Zora Hive Sisters";
      ["level"] = 60;
      ["name_es"] = "Objetivo: las hermanas de la colmena de Colmen'Zora";
      ["req"] = 60;
   };
   [9378] = {
      ["name_ru"] = "DND FLAG Цитадель ужаса ? Наксрамас";
      ["type"] = "Solo";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will grant you Arcane Cloaking at no cost. You must be Exalted with the Argent Dawn.";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "恐怖之城，?克??斯";
      ["name_de"] = "Die Zitadelle des Schreckens - Naxxramas";
      ["faction"] = "Horde";
      ["name"] = "DND FLAG The Dread Citadel - Naxxramas";
      ["level"] = 60;
      ["name_es"] = "DND FLAG La ciudadela del terror: Naxxramas";
      ["req"] = 60;
   };
   [7421] = {
      ["name_ru"] = "Защита Черного Копья";
      ["type"] = "PvP";
      ["objective"] = "";
      ["name_cn"] = "暗矛的防御";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Verteidigung der Dunkelspeere";
      ["faction"] = "Horde";
      ["name"] = "Darkspear Defense";
      ["level"] = 60;
      ["name_es"] = "Defensa de los Lanza Negra";
      ["req"] = 55;
   };
   [6181] = {
      ["name_ru"] = "Срочное сообщение";
      ["type"] = "Solo";
      ["name_fr"] = "Un message rapide";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_cn"] = "快?消息";
      ["name_de"] = "Eine eilige Nachricht";
      ["objective"] = "Bring Lewis' Note to Thor the gryphon master.";
      ["next"] = 6281;
      ["name"] = "A Swift Message";
      ["sort"] = "Westfall";
      ["races"] = {
         [1] = "Human";
      };
      ["level"] = 10;
      ["name_es"] = "Mensajero a toda prisa";
      ["req"] = 10;
   };
   [1271] = {
      ["name_ru"] = "Праздник в \"Синем отшельнике\"";
      ["type"] = "Solo";
      ["name_fr"] = "Fete au Solitaire Bleu";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "盛筵";
      ["objective"] = "";
      ["name"] = "Feast at the Blue Recluse";
      ["reward"] = {
         [1] = 5951;
      };
      ["name_de"] = "Festmahl im Blauen Eremiten";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 1222;
         [2] = 1258;
      };
      ["level"] = 37;
      ["name_es"] = "!Una fiesta en tu honor!";
      ["req"] = 30;
   };
   [5525] = {
      ["name_ru"] = "Освободите Нотта!";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [169] = 350;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Liberez Noue?!";
      ["name_cn"] = "逃出生天！";
      ["name_de"] = "Befreit Knot!";
      ["faction"] = "Horde";
      ["name"] = "Free Knot!";
      ["level"] = 60;
      ["name_es"] = "!Libera a Knot!";
      ["req"] = 57;
   };
   [7485] = {
      ["name_ru"] = "Манускрипт Защиты";
      ["type"] = "Dungeon";
      ["objective"] = "Bring a Libram of Protection, 1 Pristine Black Diamond, 2 Large Brilliant Shards, and 1 Frayed Abomination Stitching to Lorekeeper Lydros in Dire Maul to receive an Arcanum of Protection.";
      ["repgain"] = {
         [809] = 200;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Libram de Protection";
      ["name_cn"] = "防??典";
      ["reward"] = {
         [1] = 18331;
      };
      ["name_de"] = "Buchband des Schutzes";
      ["faction"] = "Horde";
      ["name"] = "Libram of Protection";
      ["level"] = 60;
      ["name_es"] = "El tratado sobre proteccion";
      ["req"] = 58;
   };
   [7501] = {
      ["name_ru"] = "Свет и как его раскачать";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "La lumiere et comment l'alterer";
      ["name_cn"] = "?光之力";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 18472;
      };
      ["name_de"] = "Vom Licht und wie man es schwingt";
      ["faction"] = "Horde";
      ["name"] = "The Light and How To Swing It";
      ["level"] = 60;
      ["name_es"] = "La Luz y como alterarla";
      ["req"] = 54;
   };
   [2318] = {
      ["name_ru"] = "Трудности перевода";
      ["objective"] = "Find someone who can translate the paladin's journal.  The closest location that might have someone is Kargath, in the Badlands.";
      ["name_cn"] = "翻?日?";
      ["sort"] = "Uldaman";
      ["level"] = 42;
      ["type"] = "Dungeon";
      ["name_fr"] = "La Traduction du Journal";
      ["next"] = 2338;
      ["name_de"] = "Ubersetzung des Tagebuchs";
      ["repgain"] = {
         [530] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Translating the Journal";
      ["prev"] = 2284;
      ["prequests"] = {
         [1] = 2284;
      };
      ["series"] = 1;
      ["name_es"] = "La traduccion del diario";
      ["req"] = 37;
   };
   [1486] = {
      ["name_ru"] = "Шкуры загадочных существ";
      ["type"] = "Dungeon";
      ["objective"] = "Nalpak in the Wailing Caverns wants 20 Deviate Hides.";
      ["name_fr"] = "Les peaux de deviants";
      ["sort"] = "Wailing Caverns";
      ["name_cn"] = "??皮革";
      ["reward"] = {
         [1] = 6480;
         [2] = 918;
      };
      ["name_de"] = "Deviatbalge";
      ["faction"] = "Horde";
      ["name"] = "Deviate Hides";
      ["level"] = 17;
      ["name_es"] = "Pellejos descarriados";
      ["req"] = 13;
   };
   [8590] = {
      ["name_ru"] = "Орде не хватает плотной кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Leather to Sergeant Umala at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de cuir epais !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要厚皮!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["name_de"] = "Die Horde braucht dickes Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Thick Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita cuero grueso!";
      ["req"] = 54;
   };
   [3783] = {
      ["name_ru"] = "Йети где-то рядом...";
      ["type"] = "Solo";
      ["name_fr"] = "Yeti?? Y es-tu??";
      ["repgain"] = {
         [577] = 150;
      };
      ["name_de"] = "Sind wir endlich da, Yeti?";
      ["name_cn"] = "雪怪??！";
      ["objective"] = "Collect 10 Thick Yeti Furs for Umi Rumplesnicker in Everlook.";
      ["next"] = 977;
      ["sort"] = "Winterspring";
      ["name"] = "Are We There, Yeti?";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 56;
      ["name_es"] = "Yeti... ?ya hemos llegado?";
      ["req"] = 52;
   };
   [3791] = {
      ["name_ru"] = "Тайна рассветницы";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Morrowgrain to Quintis Jonespyre in Feathermoon Stronghold.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Feathermoon Stronghold";
      ["name_fr"] = "Le Mystere des Fibres d'aurore";
      ["name_cn"] = "晨光麦的秘密";
      ["reward"] = {
         [1] = 11888;
         [2] = 11889;
      };
      ["name_de"] = "Das Geheimnis des Morgenkorns";
      ["faction"] = "Alliance";
      ["name"] = "The Mystery of Morrowgrain";
      ["level"] = 50;
      ["name_es"] = "El misterio de managrana";
      ["req"] = 47;
   };
   [4300] = {
      ["name_ru"] = "Костяные клинки";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 White Ravasaur Claws to Jes'rimon in Orgrimmar.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Les armes aux lames d'os";
      ["name_cn"] = "骨刃武器";
      ["reward"] = {
         [1] = 11862;
         [2] = 11863;
         [3] = 11864;
      };
      ["name_de"] = "Knochenklingenwaffen";
      ["faction"] = "Horde";
      ["name"] = "Bone-Bladed Weapons";
      ["level"] = 52;
      ["name_es"] = "Armas con filo de hueso";
      ["req"] = 48;
   };
   [1202] = {
      ["name_ru"] = "Доки Терамора";
      ["type"] = "Solo";
      ["name_fr"] = "Les docks de Theramore";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Die Docks von Theramore";
      ["name_cn"] = "塞拉摩??";
      ["name"] = "The Theramore Docks";
      ["objective"] = "Bring the Captain's Documents to Nazeer Bloodpike in Brackenwall Village.";
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1201;
      ["prequests"] = {
         [1] = 1201;
      };
      ["level"] = 35;
      ["name_es"] = "El puerto de Theramore";
      ["req"] = 30;
   };
   [7629] = {
      ["name_ru"] = "Доставка беса";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Imp in a Jar to the alchemy lab in the Scholomance.  After the parchment is created, return the jar to Gorzeeki Wildeyes.";
      ["name_fr"] = "Livraison de diablotin";
      ["sort"] = "Warlock";
      ["name_cn"] = "瓶中的小鬼";
      ["name"] = "Imp Delivery";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 7631;
      ["name_de"] = "Wichtellieferung";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7625;
         [2] = 7564;
      };
      ["level"] = 60;
      ["name_es"] = "Entrega de diablillo";
      ["req"] = 60;
   };
   [3823] = {
      ["name_ru"] = "Угасание Огненного Чрева";
      ["type"] = "Solo";
      ["objective"] = "Slay 15 Firegut Ogre-Mages, 7 Firegut Ogres, and 7 Firegut Ogre Brutes, and return to Oralius when you are finished.";
      ["next"] = 3824;
      ["name_fr"] = "Exterminer les Brulentrailles";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "消?火腹食人魔";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Die Feuermagenoger ausloschen";
      ["faction"] = "Alliance";
      ["name"] = "Extinguish the Firegut";
      ["level"] = 52;
      ["name_es"] = "El exterminio de los Pirontrana";
      ["req"] = 48;
   };
   [7661] = {
      ["name_ru"] = "Обмен волками ? рыжий волк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Echange de loup rouge";
      ["name_cn"] = "更?赤狼";
      ["reward"] = {
         [1] = 18796;
         [2] = 18798;
         [3] = 18797;
      };
      ["name_de"] = "Wolfstausch - Roter Wolf";
      ["faction"] = "Horde";
      ["name"] = "Wolf Swapping - Red Wolf";
      ["level"] = 1;
      ["name_es"] = "Intercambio de lobos: lobo rojo";
      ["req"] = 60;
   };
   [7677] = {
      ["name_ru"] = "Белый жеребец";
      ["type"] = "Solo";
      ["objective"] = "If you bring me your white stallion, I'll trade you for one from the new herd. The new horse will be just as fast as your old one, but have a different look to it. You can look at the swift steeds here to see what it will look like.$B$BMUST PAY 500 Gold too....";
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Echange d'etalon blanc";
      ["name_cn"] = "更?白?";
      ["reward"] = {
         [1] = 18777;
         [2] = 18776;
         [3] = 18778;
      };
      ["name_de"] = "Austausch Eures Schimmels";
      ["faction"] = "Alliance";
      ["name"] = "White Stallion Exchange";
      ["level"] = 1;
      ["name_es"] = "Intercambio de semental blanco";
      ["req"] = 60;
   };
   [2300] = {
      ["name_ru"] = "ШРУ";
      ["type"] = "Solo";
      ["name_fr"] = "SI:7";
      ["next"] = 2281;
      ["name_de"] = "Der SI:7";
      ["objective"] = "Travel to Stormwind and seek out Renzik The Shiv.\"$B\"";
      ["name_cn"] = "?情七?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "SI:7";
      ["prev"] = 2205;
      ["prequests"] = {
         [1] = 2205;
      };
      ["level"] = 16;
      ["name_es"] = "IV:7";
      ["req"] = 16;
   };
   [1653] = {
      ["name_ru"] = "Испытание доблести";
      ["objective"] = "Speak to Jordan Stilwell in Ironforge";
      ["name_cn"] = "正???";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 21;
      ["type"] = "Dungeon";
      ["name_fr"] = "Le test de droiture";
      ["next"] = 1654;
      ["name_de"] = "Die Prufung der Rechtschaffenheit";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Test of Righteousness";
      ["prev"] = 1652;
      ["prequests"] = {
         [1] = 1652;
      };
      ["series"] = 1;
      ["name_es"] = "La prueba de rectitud";
      ["req"] = 20;
   };
   [7725] = {
      ["name_ru"] = "Еще раз ослабим великанов";
      ["type"] = "Solo";
      ["name_fr"] = "Le retour des geants retrecis";
      ["repgain"] = {
         [21] = 25;
         [369] = 25;
         [577] = 25;
         [470] = 25;
      };
      ["name_de"] = "Und wieder unter den geschrumpften Riesen";
      ["name_cn"] = "更多被?小的巨人！";
      ["name"] = "Again With the Zapped Giants";
      ["objective"] = "Use Zorbin's Ultra-Shrinker to zap any kind of giant found in Feralas into a more manageable form.  Bring 10 Miniaturization Residues found on the zapped versions of these giants to Zorbin Fandazzle at the docks of the Forgotten Coast, Feralas.";
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 7003;
      ["prequests"] = {
         [1] = 7003;
      };
      ["level"] = 55;
      ["name_es"] = "Encoge mas gigantes";
      ["req"] = 45;
   };
   [8993] = {
      ["name_ru"] = "Подношение даров";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?送礼品";
      ["reward"] = {
         [1] = 22218;
         [2] = 21812;
         [3] = 22200;
      };
      ["name_de"] = "Geschenkubergabe";
      ["faction"] = "Alliance";
      ["name"] = "Gift Giving";
      ["level"] = 0;
      ["name_es"] = "Ofrecer regalos";
      ["req"] = 1;
   };
   [2865] = {
      ["name_ru"] = "Панцири скарабеев";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les carapaces de scarabees";
      ["repgain"] = {
         [369] = 500;
      };
      ["name_de"] = "Skarabauspanzerschalen";
      ["name_cn"] = "?甲虫的?";
      ["name"] = "Scarab Shells";
      ["objective"] = "Bring 5 Uncracked Scarab Shells to Tran'rek in Gadgetzan.";
      ["faction"] = "Horde";
      ["sort"] = "Zul'Farrak";
      ["prev"] = 2864;
      ["prequests"] = {
         [1] = 2864;
      };
      ["level"] = 45;
      ["name_es"] = "Caparazones de escarabajo";
      ["req"] = 40;
   };
   [1122] = {
      ["name_ru"] = "Возвращение к Пуззыриксу";
      ["type"] = "Solo";
      ["objective"] = "Bring the Fool's Stout report to Crank Fizzlebub in Booty Bay.";
      ["name_fr"] = "Retourner voir Bullevente";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "向菲?巴布?告";
      ["name"] = "Report Back to Fizzlebub";
      ["name_de"] = "Meldet Euch bei Zischelbub";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1121;
         [2] = 1120;
      };
      ["level"] = 44;
      ["name_es"] = "Volver a informar a Pinchabujas";
      ["req"] = 35;
   };
   [7789] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_fr"] = "Ecrasez les usurpateurs d'Aile-argent";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 25;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 20;
   };
   [7805] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Ironforge";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 7802;
         [2] = 7803;
         [3] = 7804;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [7821] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 150;
      };
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7823;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7837] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [530] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 7836;
      ["prequests"] = {
         [1] = 7836;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [1031] = {
      ["name_ru"] = "Ветвь Кенария";
      ["type"] = "Solo";
      ["objective"] = "Kill Geltharis and return the Branch of Cenarius to Illiyana at Forest Song.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Zweig des Cenarius";
      ["reward"] = {
         [1] = 5820;
         [2] = 11229;
      };
      ["name_cn"] = "塞?留斯的?枝";
      ["name_fr"] = "La branche de Cenarius";
      ["faction"] = "Alliance";
      ["name"] = "The Branch of Cenarius";
      ["sort"] = "Ashenvale";
      ["prev"] = 1021;
      ["prequests"] = {
         [1] = 1021;
      };
      ["level"] = 32;
      ["name_es"] = "La Rama de Cenarius";
      ["req"] = 26;
   };
   [2282] = {
      ["name_ru"] = "Лесопилка Альтера";
      ["type"] = "Solo";
      ["name_fr"] = "La scierie d'Alther";
      ["name_de"] = "Althers Muhle";
      ["objective"] = "Open Lucius's Lockbox, recover the Token of Thievery and return it to Lucius in Lakeshire.";
      ["reward"] = {
         [1] = 7907;
      };
      ["name_cn"] = "奥瑟?伐木?";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Alther's Mill";
      ["sort"] = "Rogue";
      ["prev"] = 2281;
      ["prequests"] = {
         [1] = 2281;
      };
      ["level"] = 20;
      ["name_es"] = "Molino de Alther";
      ["req"] = 16;
   };
   [7885] = {
      ["name_ru"] = "Накладки на доспехи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Renforts d'armure";
      ["name_cn"] = "?甲片";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Rustungssets";
      ["faction"] = "Horde";
      ["name"] = "Armor Kits";
      ["level"] = 60;
      ["name_es"] = "Refuerzos para armadura";
      ["req"] = 40;
   };
   [7901] = {
      ["name_ru"] = "Мягкие, пушистые хвосты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Queues fournies soyeuses";
      ["name_cn"] = "柔?的狼尾";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Weiche buschige Schwanze";
      ["faction"] = "Horde";
      ["name"] = "Soft Bushy Tails";
      ["level"] = 60;
      ["name_es"] = "Colas peludas blandas";
      ["req"] = 20;
   };
   [2242] = {
      ["name_ru"] = "Зов судьбы";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du destin";
      ["name_de"] = "Das Schicksal ruft";
      ["objective"] = "Find Sethir the Ancient and bring back any clues that you may discover to Syurna.$B";
      ["reward"] = {
         [1] = 7298;
      };
      ["name_cn"] = "命?的召?";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Destiny Calls";
      ["sort"] = "Rogue";
      ["prev"] = 2241;
      ["prequests"] = {
         [1] = 2241;
      };
      ["level"] = 10;
      ["name_es"] = "La llamada del destino";
      ["req"] = 10;
   };
   [7933] = {
      ["name_ru"] = "40 купонов ? большой приз Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "40 bons - Lot de Sombrelune (superieur)";
      ["name_cn"] = "40??券 - 高??品";
      ["reward"] = {
         [1] = 19296;
      };
      ["name_de"] = "40 Lose - Groser Dunkelmond-Preis";
      ["faction"] = "Horde";
      ["name"] = "40 Tickets - Greater Darkmoon Prize";
      ["level"] = 60;
      ["name_es"] = "40 vales: lote superior de la Luna Negra";
      ["req"] = 45;
   };
   [1089] = {
      ["name_ru"] = "Логово";
      ["type"] = "Group";
      ["name_fr"] = "L'Antre";
      ["name_de"] = "Der Bau";
      ["reward"] = {
         [1] = 6669;
         [2] = 6670;
         [3] = 6671;
      };
      ["name_cn"] = "大?穴";
      ["objective"] = "Travel to the Den on Stonetalon Peak. Using the Gatekeeper's Key, obtain the druids' hidden items. Use these items to open the Talon Den Hoard. ";
      ["faction"] = "Horde";
      ["name"] = "The Den";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1088;
      ["prequests"] = {
         [1] = 1088;
      };
      ["level"] = 29;
      ["name_es"] = "El Cubil";
      ["req"] = 20;
   };
   [3089] = {
      ["name_ru"] = "Рунический пергамент";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin runique";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Mit Runen beschriftetes Pergament";
      ["objective"] = "Read the Rune-Inscribed Parchment and speak to Shikrik in the Valley of Trials.";
      ["name_cn"] = "符文羊皮?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Rune-Inscribed Parchment";
      ["races"] = {
         [1] = "Orc";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "El papiro con runas grabadas";
      ["req"] = 1;
   };
   [7981] = {
      ["name_ru"] = "1200 билетов ? амулет Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "1200 bons - Amulette de la Sombrelune";
      ["name_cn"] = "1200?彩票 - 暗月?符";
      ["reward"] = {
         [1] = 19491;
      };
      ["name_de"] = "1200 Lose - Amulett des Dunkelmonds";
      ["faction"] = "Horde";
      ["name"] = "1200 Tickets - Amulet of the Darkmoon";
      ["level"] = 60;
      ["name_es"] = "1200 vales: amuleto de la Luna Negra";
      ["req"] = 55;
   };
   [6074] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Grif Wildheart in Kharanos.";
      ["next"] = 6064;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [1690] = {
      ["name_ru"] = "Расправа над Скитальцами Пустыни";
      ["type"] = "Solo";
      ["objective"] = "Take down 10 Wastewander Bandits and Thieves east of Gadgetzan, then report back to Chief Engineer Bilgewhizzle.";
      ["next"] = 1691;
      ["name_fr"] = "Chatier les Bat-le-desert";
      ["sort"] = "Tanaris";
      ["name_cn"] = "?土的公正";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_de"] = "Wustenlaufergerechtigkeit";
      ["faction"] = "Horde";
      ["name"] = "Wastewander Justice";
      ["level"] = 43;
      ["name_es"] = "Justicia para los Vagayermos";
      ["req"] = 40;
   };
   [2200] = {
      ["name_ru"] = "Назад в Ульдаман";
      ["type"] = "Dungeon";
      ["name_fr"] = "Retour a Uldaman";
      ["repgain"] = {
         [54] = 150;
      };
      ["name_de"] = "Ruckkehr nach Uldaman";
      ["name"] = "Back to Uldaman";
      ["name_cn"] = "回到奥?曼";
      ["objective"] = "Search for clues as to the current disposition of Talvash's necklace within Uldaman.  The slain paladin he mentioned was the person who had it last.";
      ["next"] = 2201;
      ["faction"] = "Alliance";
      ["sort"] = "Uldaman";
      ["prev"] = 2199;
      ["prequests"] = {
         [1] = 2199;
      };
      ["level"] = 42;
      ["name_es"] = "El regreso a Uldaman";
      ["req"] = 37;
   };
   [4023] = {
      ["name_ru"] = "Вкус пламени";
      ["type"] = "Group";
      ["objective"] = "Show Cyrus Therepentous proof of your worth.$B$BYou have a feeling that Cyrus already knows that you are unworthy.";
      ["next"] = 4024;
      ["name_fr"] = "Un gout de flammes";
      ["sort"] = "Burning Steppes";
      ["name_cn"] = "烈?精?";
      ["series"] = 1;
      ["name_de"] = "Eine Kostprobe der Flamme";
      ["faction"] = "Horde";
      ["name"] = "A Taste of Flame";
      ["level"] = 54;
      ["name_es"] = "Un sabor a llamarada";
      ["req"] = 52;
   };
   [8061] = {
      ["name_ru"] = "Знаки Силы: напульсники исповедника";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Stanchion.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance : les couvre-bras de confesseur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?悔者裹布";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19843;
      };
      ["name_de"] = "Symbole der Macht: Die Handlappen des Glaubenshuters";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Confessor's Wraps";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazaletes de confesor";
      ["req"] = 60;
   };
   [8077] = {
      ["name_ru"] = "Знаки Силы: одеяние бесноватого";
      ["type"] = "Raid";
      ["objective"] = "Bring Al'tabim the All-Seeing a Primal Hakkari Kossack.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BAl'tabim the All-Seeing is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la robe de demoniaque";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：?魔??袍";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 20033;
      };
      ["name_de"] = "Symbole der Macht: Die Roben des Besessenen";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Demoniac's Robes";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: la Toga de endemoniado";
      ["req"] = 60;
   };
   [5889] = {
      ["name_ru"] = "Лекарство из оскверненных трав";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Sammlung";
      ["name_fr"] = "Du baume contre une recolte";
      ["name_cn"] = "采集??膏";
      ["name"] = "Salve via Gathering";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 5884;
      ["prequests"] = {
         [1] = 5884;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por recoleccion";
      ["req"] = 48;
   };
   [8109] = {
      ["name_ru"] = "Ожерелье вечного Кезанского порока";
      ["objective"] = "";
      ["name_cn"] = "科?的?力??";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La souillure irresistible de Kezan";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Kezans unaufhaltsame Schmach";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Kezan's Unstoppable Taint";
      ["prev"] = 8108;
      ["prequests"] = {
         [1] = 8108;
      };
      ["reward"] = {
         [1] = 19605;
      };
      ["name_es"] = "Mancha imparable de Kezan";
      ["req"] = 60;
   };
   [4063] = {
      ["name_ru"] = "Восстание машин";
      ["type"] = "Dungeon";
      ["objective"] = "Find and slay Golem Lord Argelmach. Return his head to Lotwil. You will also need to collect 10 Intact Elemental Cores from the Ragereaver Golems and Warbringer Constructs protecting Argelmach. You know this because you are psychic. ";
      ["name_de"] = "Aufstieg der Maschinen";
      ["name_fr"] = "La revolte des machines";
      ["reward"] = {
         [1] = 12109;
         [2] = 12110;
         [3] = 12108;
         [4] = 12111;
      };
      ["name_cn"] = "机器的崛起";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["name"] = "The Rise of the Machines";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4062;
      ["prequests"] = {
         [1] = 4062;
      };
      ["level"] = 58;
      ["name_es"] = "La revuelta de las maquinas";
      ["req"] = 52;
   };
   [8141] = {
      ["name_ru"] = "Зандаларский талисман Тени";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le talisman d'ombre zandalarien";
      ["name_cn"] = "??拉暗影??";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19614;
      };
      ["name_de"] = "Zandalarischattentalisman";
      ["faction"] = "Horde";
      ["name"] = "Zandalrian Shadow Talisman";
      ["level"] = 60;
      ["name_es"] = "Dije Zandalar de las Sombras";
      ["req"] = 60;
   };
   [8157] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8154;
      ["prequests"] = {
         [1] = 8154;
      };
      ["level"] = 45;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 40;
   };
   [5846] = {
      ["name_ru"] = "Символ семейной любви";
      ["type"] = "Solo";
      ["name_fr"] = "L'amour et la famille";
      ["next"] = 5848;
      ["name_de"] = "Von Liebe und Familie";
      ["name"] = "Of Love and Family";
      ["name_cn"] = "?与家庭";
      ["objective"] = "Travel to island of Caer Darrow, in the south-central region of the Plaguelands, and look for any clues as to the whereabouts of the painting.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5845;
      ["prequests"] = {
         [1] = 5845;
      };
      ["level"] = 58;
      ["name_es"] = "Del amor y la familia";
      ["req"] = 52;
   };
   [8189] = {
      ["name_ru"] = "Явление прозрения";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La presence de la vision";
      ["name_cn"] = "魔法的?域";
      ["reward"] = {
         [1] = 19787;
      };
      ["name_de"] = "Allgegenwartige Sicht";
      ["faction"] = "Horde";
      ["name"] = "Presence of Sight";
      ["level"] = 60;
      ["name_es"] = "Presencia de vista";
      ["req"] = 58;
   };
   [1028] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["objective"] = "Find the hidden shrine and re-enchant Dartol's Rod.";
      ["name_cn"] = "莱恩的?化";
      ["sort"] = "Ashenvale";
      ["level"] = 28;
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["next"] = 1055;
      ["name_de"] = "Raenes Sauberung";
      ["repgain"] = {
         [69] = 150;
      };
      ["reward"] = {
         [1] = 5462;
      };
      ["name"] = "Raene's Cleansing";
      ["prev"] = 1027;
      ["prequests"] = {
         [1] = 1027;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La limpieza de Raene";
      ["req"] = 18;
   };
   [1032] = {
      ["name_ru"] = "Убийство сатиров!";
      ["type"] = "Solo";
      ["name_fr"] = "Mort aux satyres?!";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Satyrn schlachten!";
      ["name_cn"] = "???特！";
      ["name"] = "Satyr Slaying!";
      ["objective"] = "Bring 16 Satyr Horns to Illiyana in Forest Song.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1031;
      ["prequests"] = {
         [1] = 1031;
      };
      ["level"] = 32;
      ["name_es"] = "!Muerte a los satiros!";
      ["req"] = 26;
   };
   [1036] = {
      ["name_ru"] = "Суши весла, сухопутная крыса";
      ["type"] = "Solo";
      ["objective"] = "Speak with Fleet Master Firallon aboard the Crimson Vale off the coast of Stranglethorn Vale.";
      ["next"] = 4621;
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?，水手！";
      ["name_fr"] = "En avant toute, jeune mariole !";
      ["name_de"] = "Hierher, Taugenichts";
      ["faction"] = "Horde";
      ["name"] = "Avast Ye, Scallywag";
      ["level"] = 60;
      ["name_es"] = "!Adelante, pillin!";
      ["req"] = 55;
   };
   [8314] = {
      ["name_ru"] = "Разгадка тайны";
      ["type"] = "Group";
      ["objective"] = "Rutgar Glyphshaper at Bronzebeard's Encampment wants you to deliver the Glyphed Crystal Prism to Geologist Larksbane at the Cenarion Hold in Silithus.";
      ["next"] = 8315;
      ["name_fr"] = "Devoiler le mystere";
      ["sort"] = "Silithus";
      ["name_cn"] = "??秘密";
      ["name"] = "Unraveling the Mystery";
      ["name_de"] = "Des Ratsels Losung";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8310;
         [2] = 8309;
      };
      ["level"] = 60;
      ["name_es"] = "Desentranar el misterio";
      ["req"] = 58;
   };
   [1044] = {
      ["name_ru"] = "Полученные ответы";
      ["type"] = "Solo";
      ["objective"] = "Return to Thyn'tel Bladeweaver in Darnassus.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Beantwortete Fragen";
      ["reward"] = {
         [1] = 5817;
         [2] = 5818;
      };
      ["name_cn"] = "??的答案";
      ["name_fr"] = "Reponses aux questions";
      ["faction"] = "Alliance";
      ["name"] = "Answered Questions";
      ["sort"] = "Ashenvale";
      ["prev"] = 1043;
      ["prequests"] = {
         [1] = 1043;
      };
      ["level"] = 30;
      ["name_es"] = "La respuesta a las preguntas";
      ["req"] = 25;
   };
   [8378] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??之?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20703;
         [2] = 20715;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [1052] = {
      ["name_ru"] = "Путями Алого ордена";
      ["type"] = "Solo";
      ["objective"] = "Take Brother Anton's Letter of Commendation to Raleigh the Devout in Southshore.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Auf dem Scharlachroten Pfad";
      ["name"] = "Down the Scarlet Path";
      ["name_cn"] = "血色之路";
      ["name_fr"] = "Sur le chemin ecarlate";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Desolace";
      ["prev"] = 261;
      ["prequests"] = {
         [1] = 261;
      };
      ["level"] = 40;
      ["name_es"] = "El sendero Escarlata";
      ["req"] = 34;
   };
   [4222] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [1060] = {
      ["name_ru"] = "Письмо Джин'Зилу";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre a Jin'Zil";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Brief an Jin'Zil";
      ["name_cn"] = "写?金吉?的信";
      ["name"] = "Letter to Jin'Zil";
      ["objective"] = "Deliver Darsok's letter to Jin'Zil within his cave in Malaka'Jin, in Stonetalon.";
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 876;
      ["prequests"] = {
         [1] = 876;
      };
      ["level"] = 20;
      ["name_es"] = "Una carta para Jin'Zil";
      ["req"] = 15;
   };
   [1064] = {
      ["name_ru"] = "Помощь Отрекшихся";
      ["type"] = "Solo";
      ["name_fr"] = "L'aide des Reprouves";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_de"] = "Die Hilfe der Verlassenen";
      ["name"] = "Forsaken Aid";
      ["name_cn"] = "被?忘者的援助";
      ["objective"] = "Speak with Apothecary Zamah in the Pools of Vision in Thunder Bluff.";
      ["next"] = 1065;
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1063;
      ["prequests"] = {
         [1] = 1063;
      };
      ["level"] = 18;
      ["name_es"] = "La ayuda de los Renegados";
      ["req"] = 13;
   };
   [8538] = {
      ["name_ru"] = "Четыре герцога";
      ["type"] = "Group";
      ["objective"] = "Find a way to summon and slay the Duke of Cynders, the Duke of Fathoms, the Duke of Zephyrs and the Duke of Shards and report back to Commander Mar'alith in Cenarion Hold.  You must also bring Tactical Task Briefing V in order to complete this quest.";
      ["name_fr"] = "Les quatre ducs";
      ["sort"] = "Silithus";
      ["name_cn"] = "?殿?士";
      ["reward"] = {
         [1] = 21508;
      };
      ["name_de"] = "Die vier Fursten";
      ["faction"] = "Horde";
      ["name"] = "The Four Dukes";
      ["level"] = 60;
      ["name_es"] = "Los cuatro Duques";
      ["req"] = 60;
   };
   [8570] = {
      ["name_ru"] = "Былые сражения в Ущелье Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "往日的?献：?歌峡谷";
      ["reward"] = {
         [1] = 20558;
      };
      ["name_de"] = "Vergangene Bemuhungen in der Kriegshymnenschlucht";
      ["faction"] = "Horde";
      ["name"] = "Past Efforts in Warsong Gulch";
      ["level"] = 1;
      ["name_es"] = "Esfuerzos del pasado en la Garganta Grito de Guerra";
      ["req"] = 1;
   };
   [8602] = {
      ["name_ru"] = "Наплечье Зовущего бурю";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Life, 5 Gold Scarabs and 5 Crystal Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?暴召?者的肩甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les espauliers de l'implorateur des tempetes";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schulterstucke des Sturmrufers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21376;
      };
      ["name"] = "Stormcaller's Pauldrons";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los espaldares de clamatormentas";
      ["req"] = 60;
   };
   [1080] = {
      ["name_ru"] = "Секретная операция ? Бета";
      ["type"] = "Solo";
      ["name_fr"] = "Operations secretes ? Plan B";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_de"] = "Geheimoperation Beta";
      ["followup"] = 1091;
      ["name_cn"] = "?秘行?：B";
      ["objective"] = "Retrieve the Venture Co. Letters from Windshear Mine at the east end of Windshear Crag.";
      ["faction"] = "Alliance";
      ["name"] = "Covert Ops - Beta";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1077;
      ["prequests"] = {
         [1] = 1077;
         [2] = 1074;
      };
      ["level"] = 22;
      ["name_es"] = "Operaciones secretas: plan B";
      ["req"] = 17;
   };
   [8666] = {
      ["name_ru"] = "Жилет сотворения";
      ["objective"] = "Bring the the Husk of the Old God, 2 Idols of Rebirth, 5 Bronze Scarabs and 5 Ivory Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "起源外套";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le gilet de la genese";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Weste der Genesis";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21357;
      };
      ["name"] = "Genesis Vest";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El jubon genesis";
      ["req"] = 60;
   };
   [1088] = {
      ["name_ru"] = "Ордан";
      ["type"] = "Solo";
      ["name_fr"] = "Ordanus";
      ["next"] = 1089;
      ["name_de"] = "Ordanus";
      ["name_cn"] = "奥?努斯";
      ["objective"] = "Bring Ordanus' head to Braelyn Firehand near Sun Rock Retreat.";
      ["sort"] = "Stonetalon Mountains";
      ["faction"] = "Horde";
      ["name"] = "Ordanus";
      ["prev"] = 1087;
      ["prequests"] = {
         [1] = 1087;
      };
      ["level"] = 29;
      ["name_es"] = "Ordanus";
      ["req"] = 20;
   };
   [8730] = {
      ["name_ru"] = "Нефариус, пораженный порчей";
      ["objective"] = "Slay Nefarian and recover the Red Scepter Shard. Return the Red Scepter Shard to Anachronos at the Caverns of Time in Tanaris. You have 5 hours to complete this task.";
      ["name_cn"] = "奈法里奥斯的腐?";
      ["sort"] = "Blackwing Lair";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La corruption de Nefarius";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Nefarius' Verderbnis";
      ["followup"] = 8742;
      ["faction"] = "Horde";
      ["name"] = "Nefarius's Corruption";
      ["prev"] = 8555;
      ["prequests"] = {
         [1] = 8555;
      };
      ["reward"] = {
         [1] = 21530;
         [2] = 21529;
      };
      ["name_es"] = "La corrupcion de Nefarius";
      ["req"] = 60;
   };
   [4382] = {
      ["name_ru"] = "Кристалл силы духа";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallkraft";
      ["name_fr"] = "Cristal de concentration";
      ["name_cn"] = "精神水晶";
      ["name"] = "Crystal Force";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11563;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "La fuerza de cristal";
      ["req"] = 47;
   };
   [8794] = {
      ["name_ru"] = "Орде нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Warlord Gorchuk in Orgrimmar's Valley of Spirits.";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要?的?助！";
      ["name_fr"] = "La Horde a besoin de votre aide?!";
      ["name_de"] = "Die Horde braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Horda te necesita!";
      ["req"] = 10;
   };
   [1104] = {
      ["name_ru"] = "Яд Соляных равнин";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Salty Scorpid Venoms to Fizzle Brassbolts in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "含?的蝎毒";
      ["name_fr"] = "Le venin acide des salines";
      ["name_de"] = "Salziges Gift";
      ["faction"] = "Horde";
      ["name"] = "Salt Flat Venom";
      ["level"] = 30;
      ["name_es"] = "Veneno de El Desierto de Sal";
      ["req"] = 28;
   };
   [8858] = {
      ["name_ru"] = "Тайны колосса ? Регал";
      ["type"] = "Solo";
      ["objective"] = "Take the Colossus of Regal's Husk to Overseer Oilfist in Searing Gorge.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Les secrets du Colosse - Regal";
      ["name_cn"] = "巨像的秘密 - 雷戈";
      ["reward"] = {
         [1] = 21528;
      };
      ["name_de"] = "Geheimnisse des Kolosses - Regal";
      ["faction"] = "Horde";
      ["name"] = "Secrets of the Colossus - Regal";
      ["level"] = 60;
      ["name_es"] = "Los secretos de los Colosos: Regal";
      ["req"] = 51;
   };
   [1112] = {
      ["name_ru"] = "Детали для Крейвела";
      ["type"] = "Solo";
      ["name_fr"] = "Les pieces detachees de Kravel";
      ["name_de"] = "Teile fur Kravel";
      ["name_cn"] = "?克拉??的零件";
      ["objective"] = "Bring Kravel's Parts to Kravel Koalbeard in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Parts for Kravel";
      ["prev"] = 1111;
      ["prequests"] = {
         [1] = 1111;
      };
      ["level"] = 36;
      ["name_es"] = "Las piezas de Kravel";
      ["req"] = 30;
   };
   [8922] = {
      ["name_ru"] = "Сверхъестественное устройство";
      ["type"] = "Solo";
      ["objective"] = "Bring the Sealed Blood Container to Mux Manascrambler inside Gadgetzan in Tanaris.";
      ["next"] = 8921;
      ["name_fr"] = "Un objet surnaturel";
      ["sort"] = "Tanaris";
      ["name_cn"] = "超自然的??";
      ["name"] = "A Supernatural Device";
      ["followup"] = 8921;
      ["name_de"] = "Ein ubernaturlicher Apparat";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 8905;
         [2] = 8908;
         [3] = 8910;
         [4] = 8911;
         [5] = 8912;
         [6] = 8906;
         [7] = 8909;
         [8] = 8907;
      };
      ["level"] = 60;
      ["name_es"] = "Un artefacto sobrenatural";
      ["req"] = 58;
   };
   [8954] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Lightforge Boots, Lightforge Legplates and Lightforge Spaulders.";
      ["name_cn"] = "告?安泰恩";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22087;
         [2] = 22092;
         [3] = 22093;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [8986] = {
      ["name_ru"] = "Еще одна важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "D'autres composants importants";
      ["next"] = 8989;
      ["name_de"] = "Mehr Komponenten von groser Wichtigkeit";
      ["reward"] = {
         [1] = 22192;
         [2] = 22193;
      };
      ["name_cn"] = "更多重要的材料";
      ["objective"] = "Acquire Druidical Remains and return them to Bodley inside Blackrock Mountain.";
      ["faction"] = "Horde";
      ["name"] = "More Components of Importance";
      ["sort"] = "Blackrock Mountain";
      ["prev"] = 8970;
      ["prequests"] = {
         [1] = 8970;
         [2] = 8965;
      };
      ["level"] = 60;
      ["name_es"] = "Mas componentes importantes";
      ["req"] = 58;
   };
   [9018] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Magister's Boots, Magister's Leggings and Magister's Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22064;
         [2] = 22067;
         [3] = 22068;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [1132] = {
      ["name_ru"] = "Фиора Длинноушка";
      ["type"] = "Solo";
      ["objective"] = "Speak with Fiora Longears on the docks at Theramore in Dustwallow Marsh.";
      ["next"] = 1133;
      ["sort"] = "Wetlands";
      ["name_cn"] = "菲欧拉・?耳";
      ["name_fr"] = "Fiora Grandes-oreilles";
      ["name_de"] = "Fiora Langohr";
      ["faction"] = "Alliance";
      ["name"] = "Fiora Longears";
      ["level"] = 20;
      ["name_es"] = "Fiora Orejona";
      ["req"] = 18;
   };
   [9082] = {
      ["name_ru"] = "Рукавицы костяной косы";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make Bonescythe Gauntlets if you bring him the following: 1 Desecrated Gauntlets, 8 Wartorn Leather Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides. ";
      ["name_cn"] = "骨??手";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les gantelets de la faucheuse d'os";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stulpen der Knochensense";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22481;
      };
      ["name"] = "Bonescythe Gauntlets";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guanteletes Segahuesos";
      ["req"] = 60;
   };
   [1140] = {
      ["name_ru"] = "Башня Алталакса";
      ["type"] = "Solo";
      ["name_fr"] = "La Tour d'Althalaxx";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Turm von Althalaxx";
      ["name"] = "The Tower of Althalaxx";
      ["name_cn"] = "奥?拉克斯之塔";
      ["objective"] = "Free the trapped Highborne souls in Night Run and Satyrnaar, then return to Delgren the Purifier at Maestra's Post.";
      ["next"] = 1167;
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 973;
      ["prequests"] = {
         [1] = 973;
      };
      ["level"] = 28;
      ["name_es"] = "La Torre de Althalaxx";
      ["req"] = 13;
   };
   [1144] = {
      ["name_ru"] = "Импортер Вилликс";
      ["type"] = "Dungeon";
      ["objective"] = "Escort Willix the Importer out of Razorfen Kraul.";
      ["repgain"] = {
         [470] = 350;
      };
      ["sort"] = "Razorfen Kraul";
      ["name_fr"] = "Willix l’Importateur";
      ["name_cn"] = "?口商威利克斯";
      ["reward"] = {
         [1] = 6748;
         [2] = 6750;
         [3] = 6749;
      };
      ["name_de"] = "Willix der Importeur";
      ["faction"] = "Horde";
      ["name"] = "Willix the Importer";
      ["level"] = 30;
      ["name_es"] = "Willix el Importador";
      ["req"] = 23;
   };
   [9178] = {
      ["name_ru"] = "Задание мастера: массивное грузило";
      ["type"] = "Solo";
      ["objective"] = "Deliver 120 Dense Weightstones and the Craftsman's Writ - Dense Weightstone - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Pierres de lest denses";
      ["name_cn"] = "工匠文? - 致密平衡石";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Verdichteter Gewichtsstein";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Dense Weightstone";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: contrapeso denso";
      ["req"] = 55;
   };
   [4606] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Der Funkelmat 5200!";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_cn"] = "超?清?器5200型！";
      ["name"] = "The Sparklematic 5200!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 4602;
      ["prequests"] = {
         [1] = 4602;
      };
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [9242] = {
      ["name_ru"] = "Снежные перчатки";
      ["type"] = "Raid";
      ["name_fr"] = "Les gants polaires";
      ["name_de"] = "Polarhandschuhe";
      ["reward"] = {
         [1] = 22662;
      };
      ["name_cn"] = "北?手套";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 5 Frozen Runes, 12 Enchanted Leather, 3 Essence of Water, 3 Cured Rugged Hides and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Polar Gloves";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los guantes polares";
      ["req"] = 60;
   };
   [1160] = {
      ["name_ru"] = "Испытание знаний";
      ["objective"] = "Find The Beginnings of the Undead Threat, and return it to Parqual Fintallas in Undercity.";
      ["name_cn"] = "知???";
      ["sort"] = "Scarlet Monastery";
      ["level"] = 36;
      ["type"] = "Dungeon";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 6628;
      ["name_de"] = "Test der Lehre";
      ["repgain"] = {
         [68] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Test of Lore";
      ["prev"] = 1159;
      ["prequests"] = {
         [1] = 1159;
      };
      ["series"] = 5;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [1164] = {
      ["name_ru"] = "Ограбить воров";
      ["type"] = "Solo";
      ["objective"] = "Bring Kenata, Fardel, and Marcel Dabyrie's Heads to Genavie Callow in Undercity.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Undercity";
      ["name_fr"] = "Le voleur vole";
      ["name_cn"] = "科娜塔一家";
      ["reward"] = {
         [1] = 4443;
         [2] = 2032;
      };
      ["name_de"] = "Von Dieben stehlen";
      ["faction"] = "Horde";
      ["name"] = "To Steal From Thieves";
      ["level"] = 36;
      ["name_es"] = "Robar a un ladron...";
      ["req"] = 27;
   };
   [9338] = {
      ["name_ru"] = "Верность Кругу Кенария";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 500;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Allegeance au Cercle cenarien";
      ["name_cn"] = "塞?里奥?会的盟友";
      ["name_de"] = "Treue zum Zirkel des Cenarius";
      ["faction"] = "Horde";
      ["name"] = "Allegiance to Cenarion Circle";
      ["level"] = 60;
      ["name_es"] = "Lealtad al Circulo Cenarion";
      ["req"] = 60;
   };
   [1172] = {
      ["name_ru"] = "Выводок Ониксии";
      ["type"] = "Group";
      ["objective"] = "Draz'Zilb in Brackenwall Village wants you to destroy 5 Eggs of Onyxia.";
      ["name_de"] = "[DEPRECATED] Die Brut von Onyxia";
      ["name_fr"] = "La portee d'Onyxia";
      ["reward"] = {
         [1] = 10700;
         [2] = 10701;
      };
      ["name_cn"] = "奥?克希?的血脉";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["name"] = "The Brood of Onyxia";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1171;
      ["prequests"] = {
         [1] = 1171;
      };
      ["level"] = 45;
      ["name_es"] = "El linaje de Onyxia";
      ["req"] = 38;
   };
   [1176] = {
      ["name_ru"] = "Уменьшение веса";
      ["type"] = "Solo";
      ["objective"] = "Get 10 Hollow Vulture Bones for Pozzik in the Shimmering Flats.";
      ["next"] = 1178;
      ["name_fr"] = "Allegement de la structure";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "???重";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Gewicht reduzieren";
      ["faction"] = "Horde";
      ["name"] = "Load Lightening";
      ["level"] = 30;
      ["name_es"] = "Menos peso";
      ["req"] = 29;
   };
   [1180] = {
      ["name_ru"] = "Гоблинская поддержка";
      ["objective"] = "Speak with Wharfmaster Lozgil in Booty Bay.";
      ["name_cn"] = "地精?助商";
      ["sort"] = "Thousand Needles";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Mecenat gobelin";
      ["next"] = 1181;
      ["name_de"] = "Goblinsponsoring";
      ["repgain"] = {
         [470] = 25;
         [21] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Goblin Sponsorship";
      ["prev"] = 1178;
      ["prequests"] = {
         [1] = 1178;
      };
      ["series"] = 2;
      ["name_es"] = "Patrocinio goblin";
      ["req"] = 29;
   };
   [4734] = {
      ["name_ru"] = "Заморозка яйца";
      ["type"] = "Raid";
      ["name_fr"] = "Un oeuf congele";
      ["name_de"] = "Ei-Frosten";
      ["reward"] = {
         [1] = 12144;
      };
      ["name_cn"] = "冷??蛋";
      ["objective"] = "Use the Eggscilloscope Prototype on an egg in the Rookery.";
      ["faction"] = "Horde";
      ["name"] = "Egg Freezing";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4907;
      ["prequests"] = {
         [1] = 4907;
      };
      ["level"] = 60;
      ["name_es"] = "Un huevo congelado";
      ["req"] = 57;
   };
   [1188] = {
      ["name_ru"] = "Безопасность превыше всего";
      ["objective"] = "Bring the Seaforium Booster to Shreev in Gadgetzan.";
      ["name_cn"] = "安全第一";
      ["sort"] = "Thousand Needles";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "La securite d'abord";
      ["next"] = 1189;
      ["name_de"] = "Sicherheit zuerst";
      ["repgain"] = {
         [369] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "Safety First";
      ["prev"] = 1187;
      ["prequests"] = {
         [1] = 1187;
      };
      ["series"] = 1;
      ["name_es"] = "La seguridad primero";
      ["req"] = 29;
   };
   [1192] = {
      ["name_ru"] = "Индарилиевая руда";
      ["type"] = "Solo";
      ["name_fr"] = "Minerai d'indurium";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "精??石";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Indurium Ore";
      ["name_de"] = "Induriumerz";
      ["prev"] = 1194;
      ["prequests"] = {
         [1] = 1194;
      };
      ["level"] = 42;
      ["name_es"] = "Mena de indurio";
      ["req"] = 29;
   };
   [4782] = {
      ["name_ru"] = "Материалы для зачарованного золотого кровавого одеяния";
      ["objective"] = "Return to Menara Voidrender in the Barrens.";
      ["name_cn"] = "魔化金?血袍";
      ["sort"] = "Warlock";
      ["level"] = 34;
      ["type"] = "Solo";
      ["name_fr"] = "Les composants de la robe sanglante doree enchantee";
      ["next"] = 4783;
      ["name_de"] = "Komponenten fur die verzauberte Goldblutrobe";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Components for the Enchanted Gold Bloodrobe";
      ["prev"] = 4781;
      ["prequests"] = {
         [1] = 4781;
      };
      ["series"] = 3;
      ["name_es"] = "Los componentes para la toga de sangre dorada encantada";
      ["req"] = 31;
   };
   [1200] = {
      ["name_ru"] = "Злодейство в Непроглядной Пучине";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the head of Twilight Lord Kelris to Dawnwatcher Selgorm in Darnassus.";
      ["repgain"] = {
         [69] = 500;
         [529] = 500;
      };
      ["name_de"] = "Schurkerei in der Tiefschwarzen Grotte";
      ["reward"] = {
         [1] = 7001;
         [2] = 7002;
      };
      ["name_cn"] = "黑暗深渊中的?魔";
      ["name_fr"] = "L'infamie de Brassenoire";
      ["faction"] = "Alliance";
      ["name"] = "Blackfathom Villainy";
      ["sort"] = "Blackfathom Deeps";
      ["prev"] = 1198;
      ["prequests"] = {
         [1] = 1198;
      };
      ["level"] = 27;
      ["name_es"] = "La vileza de Brazanegra";
      ["req"] = 18;
   };
   [1204] = {
      ["name_ru"] = "Суп из глинистой черепахи с крабами";
      ["type"] = "Solo";
      ["name_fr"] = "Soupe de Rochefange aux insectes";
      ["repgain"] = {
         [0] = 72;
      };
      ["name_de"] = "Schlammpanzersuppe mit Kafern";
      ["name"] = "Mudrock Soup and Bugs";
      ["name_cn"] = "泥石?蟹?";
      ["objective"] = " and... well";
      ["next"] = 1258;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1260;
      ["prequests"] = {
         [1] = 1260;
      };
      ["level"] = 38;
      ["name_es"] = "Sopa de Fangorroca con tropezones";
      ["req"] = 33;
   };
   [9200] = {
      ["name_ru"] = "Задание мастера: огромный флакон с зельем маны";
      ["type"] = "Solo";
      ["objective"] = "Deliver 10 Major Mana Potions and the Craftsman's Writ - Major Mana Potion - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Potions de mana majeures";
      ["name_cn"] = "工匠文? - 特效法力?水";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Erheblicher Manatrank";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Major Mana Potion";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pocion de mana sublime";
      ["req"] = 55;
   };
   [5929] = {
      ["name_ru"] = "Дух Великого Медведя";
      ["objective"] = "Seek out the Great Bear Spirit in northwestern Moonglade and learn what it has to share with you about the nature of the bear.  When finished, return to Dendrite Starblaze in Nighthaven, Moonglade.";
      ["name_cn"] = "巨熊之?";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "L'esprit du Grand ours";
      ["repgain"] = {
         [609] = 50;
      };
      ["name_de"] = "Groser Barengeist";
      ["next"] = 5931;
      ["classes"] = {
         [1] = "Druid";
      };
      ["sort"] = "Druid";
      ["name"] = "Great Bear Spirit";
      ["prev"] = 5921;
      ["prequests"] = {
         [1] = 5921;
      };
      ["followup"] = 5931;
      ["name_es"] = "Espiritu del gran oso";
      ["req"] = 10;
   };
   [4862] = {
      ["name_ru"] = "Товар на любителя";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Spire and collect 15 Spire Spider Eggs for Kibler.$B$BBy the sound of it, these eggs could be found near spiders.$B";
      ["name_fr"] = "Mauvais";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "蜘蛛卵";
      ["reward"] = {
         [1] = 12529;
      };
      ["name_de"] = "Be-Oh-Es-Eh";
      ["faction"] = "Horde";
      ["name"] = "En-Ay-Es-Tee-Why";
      ["level"] = 59;
      ["name_es"] = "Bestia amaestrada";
      ["req"] = 55;
   };
   [1220] = {
      ["name_ru"] = "Капитан Ваймс";
      ["type"] = "Solo";
      ["name_fr"] = "Le capitaine Vimaire";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Hauptmann Mumm";
      ["name_cn"] = "?米斯??";
      ["name"] = "Captain Vimes";
      ["objective"] = "Bring the Spy's Report to Captain Garran Vimes.";
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1219;
      ["prequests"] = {
         [1] = 1219;
      };
      ["level"] = 35;
      ["name_es"] = "Capitan Vimes";
      ["req"] = 30;
   };
   [1136] = {
      ["name_ru"] = "Ледочрев";
      ["type"] = "Solo";
      ["objective"] = "Bring Frostmaw's Mane to Melor Stonehoof in Thunder Bluff.";
      ["repgain"] = {
         [81] = 500;
      };
      ["name_de"] = "[DEPRECATED] Frostrachen";
      ["reward"] = {
         [1] = 6720;
      };
      ["name_cn"] = "霜喉雪人";
      ["name_fr"] = "Gueule-glacee";
      ["faction"] = "Horde";
      ["name"] = "Frostmaw";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1131;
      ["prequests"] = {
         [1] = 1131;
      };
      ["level"] = 37;
      ["name_es"] = "Faucehielo";
      ["req"] = 26;
   };
   [2752] = {
      ["name_ru"] = "За железными наплечниками";
      ["type"] = "Solo";
      ["name_fr"] = "Epaulettes en fer";
      ["name_de"] = "Uber Eisenschulterstucke";
      ["reward"] = {
         [1] = 7978;
      };
      ["name_cn"] = "?肩?";
      ["objective"] = "Bring four Bronze Battleaxes and four Bronze Warhammers to Orokk Omosh in Orgrimmar.";
      ["faction"] = "Horde";
      ["name"] = "On Iron Pauldrons";
      ["sort"] = "Blacksmithing";
      ["prev"] = 2751;
      ["prequests"] = {
         [1] = 2751;
      };
      ["level"] = 32;
      ["name_es"] = "Espaldares de hierro";
      ["req"] = 32;
   };
   [8293] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["name_fr"] = "La marque d'honneur";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["objective"] = "You obtained a Warsong Mark of Honor for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["name_de"] = "Ehrenabzeichen";
      ["prev"] = 8294;
      ["prequests"] = {
         [1] = 8294;
      };
      ["level"] = 60;
      ["name_es"] = "Marca de Honor";
      ["req"] = 60;
   };
   [3118] = {
      ["name_ru"] = "Зашифрованный знак";
      ["type"] = "Solo";
      ["name_fr"] = "Sceau code";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Verschlusseltes Siegelzeichen";
      ["objective"] = "Read the Encrypted Sigil and speak to Frahun Shadewhisper in Shadowglen.";
      ["name_cn"] = "密文符?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Sigil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 457;
      ["prequests"] = {
         [1] = 457;
      };
      ["level"] = 1;
      ["name_es"] = "El sigilo cifrado";
      ["req"] = 1;
   };
   [1240] = {
      ["name_ru"] = "Тролль-знахарь";
      ["type"] = "Solo";
      ["name_fr"] = "Le Sorcier-docteur troll";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Der Trollhexendoktor";
      ["name_cn"] = "巨魔巫医";
      ["name"] = "The Troll Witchdoctor";
      ["objective"] = "Take the Defiant Orc Head to Kin'weelay in the Grom'gol Base Camp in Stranglethorn Vale.";
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1239;
      ["prequests"] = {
         [1] = 1239;
      };
      ["level"] = 35;
      ["name_es"] = "El trol medico brujo";
      ["req"] = 30;
   };
   [4974] = {
      ["name_ru"] = "За Орду!";
      ["type"] = "Raid";
      ["objective"] = "Travel to Blackrock Spire and slay Warchief Rend Blackhand. Take his head and return to Orgrimmar.";
      ["repgain"] = {
         [76] = 500;
         [68] = 500;
         [81] = 500;
         [530] = 500;
      };
      ["name_de"] = "Fur die Horde!";
      ["reward"] = {
         [1] = 13966;
         [2] = 13968;
         [3] = 13965;
      };
      ["name_cn"] = "?部落而?！";
      ["name_fr"] = "Pour la Horde?!";
      ["faction"] = "Horde";
      ["name"] = "For The Horde!";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4941;
      ["prequests"] = {
         [1] = 4941;
      };
      ["level"] = 60;
      ["name_es"] = "!Por la Horda!";
      ["req"] = 55;
   };
   [1248] = {
      ["name_ru"] = "Пропавший дипломат";
      ["objective"] = "Speak to Mikhail in the Wetlands.";
      ["name_cn"] = "失踪的使?";
      ["sort"] = "Stormwind City";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1249;
      ["name_de"] = "Der vermisste Diplomat";
      ["repgain"] = {
         [72] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Missing Diplomat";
      ["prev"] = 1247;
      ["prequests"] = {
         [1] = 1247;
      };
      ["series"] = 10;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1252] = {
      ["name_ru"] = "Лейтенант Павал Рит";
      ["type"] = "Solo";
      ["objective"] = "Bring Reethe's Badge to Captain Garran Vimes in Theramore.";
      ["next"] = 1259;
      ["name_fr"] = "Lieutenant Paval Reethe";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?瓦?・雷瑟上尉";
      ["series"] = 1;
      ["name_de"] = "Leutnant Paval Reethe";
      ["faction"] = "Alliance";
      ["name"] = "Lieutenant Paval Reethe";
      ["level"] = 40;
      ["name_es"] = "Teniente Paval Reethe";
      ["req"] = 30;
   };
   [5022] = {
      ["name_ru"] = "Лучше поздно, чем никогда";
      ["type"] = "Solo";
      ["name_fr"] = "Mieux vaut tard que jamais";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Besser spat als nie";
      ["name"] = "Better Late Than Never";
      ["name_cn"] = "?到?比不到好";
      ["objective"] = "Check with the Royal Factors of Stormwind to learn the whereabouts of an Emma Felstone.  There is usually a census officer located in City Hall.";
      ["next"] = 5048;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5021;
      ["prequests"] = {
         [1] = 5021;
      };
      ["level"] = 52;
      ["name_es"] = "Mas vale tarde que nunca";
      ["req"] = 50;
   };
   [1260] = {
      ["name_ru"] = "Морган Штерн";
      ["type"] = "Solo";
      ["objective"] = " a city on the edge of the Dustwallow Marsh.  He's there gathering recipes from the locals";
      ["next"] = 1204;
      ["name_fr"] = "Morgan Stern";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "摩根・斯特恩";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Morgan Stern";
      ["faction"] = "Alliance";
      ["name"] = "Morgan Stern";
      ["level"] = 38;
      ["name_es"] = "Morgan Stern";
      ["req"] = 33;
   };
   [5054] = {
      ["name_ru"] = "Урсиус из щербозубов";
      ["type"] = "Group";
      ["objective"] = "Storm Shadowhoof at Everlook in Winterspring wants you to kill Ursius.";
      ["next"] = 5055;
      ["name_fr"] = "Ursius des Crocs aceres";
      ["sort"] = "Winterspring";
      ["name_cn"] = "碎?熊尤西?斯";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Ursius von den Splitterzahnbaren";
      ["faction"] = "Horde";
      ["name"] = "Ursius of the Shardtooth";
      ["level"] = 56;
      ["name_es"] = "Ursius de los Dentoesquirla";
      ["req"] = 53;
   };
   [1268] = {
      ["name_ru"] = "Подозрительные следы копыт";
      ["type"] = "Solo";
      ["objective"] = "Report about the suspicious prints at the Shady Rest Inn to Krog in Brackenwall Village.";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "可疑的蹄印";
      ["name_fr"] = "Des empreintes de sabots suspectes";
      ["name_de"] = "Verdachtige Hufabdrucke";
      ["faction"] = "Horde";
      ["name"] = "Suspicious Hoofprints";
      ["level"] = 35;
      ["name_es"] = "Huellas de pezunas sospechosas";
      ["req"] = 30;
   };
   [5086] = {
      ["name_ru"] = "Ядовитый Ужас";
      ["type"] = "Solo";
      ["name_fr"] = "Horreurs toxiques";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "[DEPRECATED] Toxinschrecken";
      ["name"] = "Toxic Horrors";
      ["name_cn"] = "?毒之水";
      ["objective"] = "Collect 3 Toxic Horror Droplets for Donova Snowden in Winterspring.";
      ["next"] = 5087;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5085;
      ["prequests"] = {
         [1] = 5085;
      };
      ["level"] = 56;
      ["name_es"] = "Horrores toxicos";
      ["req"] = 52;
   };
   [5102] = {
      ["name_ru"] = "Кончина генерала Драккисата";
      ["type"] = "Raid";
      ["objective"] = "Travel to Blackrock Spire and destroy General Drakkisath. Return to Marshal Maxwell when the job is done.$B";
      ["repgain"] = {
         [469] = 500;
      };
      ["name_de"] = "General Drakkisaths Niedergang";
      ["reward"] = {
         [1] = 13966;
         [2] = 13968;
         [3] = 13965;
      };
      ["name_cn"] = "?基?斯将?之死";
      ["name_fr"] = "La reddition du general Drakkisath";
      ["faction"] = "Alliance";
      ["name"] = "General Drakkisath's Demise";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 5089;
      ["prequests"] = {
         [1] = 5089;
      };
      ["level"] = 60;
      ["name_es"] = "Muerte al general Drakkisath";
      ["req"] = 55;
   };
   [3100] = {
      ["name_ru"] = "Обычное письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre simple";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Einfacher Brief";
      ["objective"] = "Read the Simple Letter and speak to Llane Beshere in Northshire Abbey.";
      ["name_cn"] = "?要的信件";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta simple";
      ["req"] = 1;
   };
   [1284] = {
      ["name_ru"] = "Подозрительные следы копыт";
      ["type"] = "Solo";
      ["objective"] = "Report about the suspicious prints at the Shady Rest Inn to Captain Garran Vimes in Theramore.";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "可疑的蹄印";
      ["name_fr"] = "Des empreintes de sabots suspectes";
      ["name_de"] = "Verdachtige Hufabdrucke";
      ["faction"] = "Alliance";
      ["name"] = "Suspicious Hoofprints";
      ["level"] = 35;
      ["name_es"] = "Huellas de pezunas sospechosas";
      ["req"] = 30;
   };
   [5150] = {
      ["name_ru"] = "Даданга проголодалась!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Un'Goro Crater";
      ["name_fr"] = "Dadanga a faim?!";
      ["name_cn"] = "?丹加?了！";
      ["reward"] = {
         [1] = 15699;
      };
      ["name_de"] = "Dadanga ist hungrig!";
      ["faction"] = "Horde";
      ["name"] = "Dadanga is Hungry!";
      ["level"] = 55;
      ["name_es"] = "!Dadanga tiene hambre!";
      ["req"] = 47;
   };
   [5166] = {
      ["name_ru"] = "Кираса хроматических полетов";
      ["type"] = "Group";
      ["name_fr"] = "La cuirasse du vol chromatique";
      ["name_de"] = "Brustplatte des chromatischen Drachenschwarms";
      ["reward"] = {
         [1] = 12895;
      };
      ["name_cn"] = "多彩巨?胸甲";
      ["objective"] = "To forge the Breastplate of the Chromatic Flight, you will be required to bring the following items to Jeziba the 'Sculptor':$B$B1 Chromatic Carapace.$B$B10 Brilliant Chromatic Scales.$B$B10 Blood of Heroes.$B$B10 Frayed Abomination Stitchings.";
      ["faction"] = "Horde";
      ["name"] = "Breastplate of the Chromatic Flight";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5164;
      ["prequests"] = {
         [1] = 5164;
      };
      ["level"] = 60;
      ["name_es"] = "Coraza del Vuelo Cromatico";
      ["req"] = 57;
   };
   [8906] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Beaststalker's Bindings to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22011;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [1100] = {
      ["name_ru"] = "Дневник Хмурня";
      ["type"] = "Group";
      ["objective"] = "Read Henrig Lonebrow's Journal.";
      ["next"] = 1101;
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "亨里格的日?";
      ["name_fr"] = "Journal de Lonebrow";
      ["name_de"] = "Einbraues Tagebuch";
      ["faction"] = "Alliance";
      ["name"] = "Lonebrow's Journal";
      ["level"] = 34;
      ["name_es"] = "El diario de Soliceja";
      ["req"] = 29;
   };
   [5214] = {
      ["name_ru"] = "Великий Фрас Сиаби";
      ["type"] = "Dungeon";
      ["objective"] = "Find Fras Siabi's smoke shop in Stratholme and recover a box of Siabi's Premium Tobacco. Return to Smokey LaRue when the job is done.$B";
      ["name_fr"] = "Le grand Fras Siabi";
      ["sort"] = "Stratholme";
      ["name_cn"] = "弗拉斯・希?比";
      ["reward"] = {
         [1] = 13171;
      };
      ["name_de"] = "Der grose Fras Siabi";
      ["faction"] = "Horde";
      ["name"] = "The Great Fras Siabi";
      ["level"] = 60;
      ["name_es"] = "El gran Fras Siabi";
      ["req"] = 55;
   };
   [5230] = {
      ["name_ru"] = "Возвращение в Бастион";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a la Barricade";
      ["repgain"] = {
         [67] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Bollwerk";
      ["name"] = "Return to the Bulwark";
      ["name_cn"] = "返回亡?壁?";
      ["objective"] = "Bring the Filled Felstone Field Bottle to Shadow Priestess Vandis at the Bulwark, Western Plaguelands.";
      ["next"] = 5231;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5229;
      ["prequests"] = {
         [1] = 5229;
      };
      ["level"] = 53;
      ["name_es"] = "Regresa a El Baluarte";
      ["req"] = 50;
   };
   [5246] = {
      ["name_ru"] = "Фрагменты прошлого";
      ["objective"] = "Find the Sacred Highborne Writings in the Temple of Zin-Malor in Azshara, and bring them to Aurora Skycaller near the Northpass Tower in Eastern Plaguelands.";
      ["name_cn"] = "?史的残片";
      ["sort"] = "Eastern Plaguelands";
      ["level"] = 56;
      ["type"] = "Solo";
      ["name_fr"] = "Fragments du passe";
      ["next"] = 5247;
      ["name_de"] = "Fragmente der Vergangenheit";
      ["repgain"] = {
         [69] = 25;
         [54] = 25;
         [72] = 25;
         [47] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "Fragments of the Past";
      ["prev"] = 5245;
      ["prequests"] = {
         [1] = 5245;
      };
      ["series"] = 1;
      ["name_es"] = "Trozos del pasado";
      ["req"] = 53;
   };
   [5262] = {
      ["name_ru"] = "Ошеломляющая истина";
      ["type"] = "Dungeon";
      ["name_fr"] = "La verite vient du ciel";
      ["repgain"] = {
         [529] = 150;
      };
      ["name_de"] = "Die Wahrheit zeigt sich mit Macht";
      ["name"] = "The Truth Comes Crashing Down";
      ["name_cn"] = "可怕的真相";
      ["objective"] = "Take the Head of Balnazzar to Duke Nicholas Zverenhoff in the Eastern Plaguelands.";
      ["next"] = 5263;
      ["faction"] = "Horde";
      ["sort"] = "Stratholme";
      ["prev"] = 5251;
      ["prequests"] = {
         [1] = 5251;
      };
      ["level"] = 60;
      ["name_es"] = "La verdad cae del cielo";
      ["req"] = 55;
   };
   [1320] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name"] = "The Black Shield";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Speak with Captain Garran Vimes in Theramore.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1319;
      ["prequests"] = {
         [1] = 1319;
      };
      ["level"] = 35;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [1324] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Defeat Private Hendel in Dustwallow Marsh.";
      ["next"] = 1267;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1266;
      ["prequests"] = {
         [1] = 1266;
      };
      ["level"] = 38;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [6163] = {
      ["name_ru"] = "Рамштайн";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme and slay Ramstein the Gorger. Take his head as a souvenir for Nathanos.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Ramstein";
      ["reward"] = {
         [1] = 18022;
         [2] = 17001;
      };
      ["name_cn"] = "?咽者拉姆斯登";
      ["name_fr"] = "Ramstein";
      ["faction"] = "Horde";
      ["name"] = "Ramstein";
      ["sort"] = "Stratholme";
      ["prev"] = 6135;
      ["prequests"] = {
         [1] = 6135;
      };
      ["level"] = 60;
      ["name_es"] = "Ramstein";
      ["req"] = 56;
   };
   [6261] = {
      ["name_ru"] = "Дунгар Долгопив";
      ["type"] = "Solo";
      ["name_fr"] = "Dungar Grangodet";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Dungar Trinkfest";
      ["objective"] = "Bring Osric's Crate to Dungar Longdrink the gryphon master.";
      ["name_cn"] = "杜加?・朗德瑞克";
      ["next"] = 6285;
      ["sort"] = "Westfall";
      ["name"] = "Dungar Longdrink";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 6281;
      ["prequests"] = {
         [1] = 6281;
      };
      ["level"] = 10;
      ["name_es"] = "Dungar Tragolargo";
      ["req"] = 10;
   };
   [5342] = {
      ["name_ru"] = "Последний из Баровых";
      ["type"] = "Group";
      ["name_fr"] = "Le dernier Barov";
      ["name_de"] = "Der letzte Barov";
      ["reward"] = {
         [1] = 14022;
      };
      ["name_cn"] = "巴?夫的?承人";
      ["objective"] = "Travel to Chillwind Camp - Alliance territory - and assassinate Weldon Barov. Take his head and return to Alexi Barov.$B$BBe warned, Weldon will probably be well protected by Alliance scum.";
      ["faction"] = "Horde";
      ["name"] = "The Last Barov";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5341;
      ["prequests"] = {
         [1] = 5341;
      };
      ["level"] = 60;
      ["name_es"] = "El ultimo de los Barov";
      ["req"] = 52;
   };
   [2771] = {
      ["name_ru"] = "Голова на плечах";
      ["type"] = "Solo";
      ["name_fr"] = "Une tete bien faite sur les epaules";
      ["name_de"] = "Ein schlauer Kopf auf den Schultern";
      ["objective"] = "Bring two Mithril Coifs and one Ornate Mithril Shoulder to Trenton Lighthammer.";
      ["name_cn"] = "罩帽和?肩";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Horde";
      ["name"] = "A Good Head On Your Shoulders";
      ["followup"] = 3321;
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "La cabeza sobre los hombros";
      ["req"] = 40;
   };
   [6282] = {
      ["name_ru"] = "Угроза со стороны гарпий";
      ["type"] = "Solo";
      ["objective"] = "Maggran Earthbinder in Sun Rock Retreat wants you to slay 7 Bloodfury Harpies, 7 Bloodfury Ambushers, 7 Bloodfury Slayers and 7 Bloodfury Roguefeathers.";
      ["next"] = 6283;
      ["name_fr"] = "La menace des harpies";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "?身人的威?";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Harpyien drohen";
      ["faction"] = "Horde";
      ["name"] = "Harpies Threaten";
      ["level"] = 26;
      ["name_es"] = "La amenaza de las arpias";
      ["req"] = 18;
   };
   [8393] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 100;
      };
      ["name_fr"] = "La revendication du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?争的?力";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["level"] = 39;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 30;
   };
   [5406] = {
      ["name_ru"] = "Камни осквернителей Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des corrupteurs";
      ["name_cn"] = "堕落者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Verderbers";
      ["faction"] = "Horde";
      ["name"] = "Corruptor's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del corruptor";
      ["req"] = 50;
   };
   [6301] = {
      ["name_ru"] = "Цикл возрождения";
      ["type"] = "Solo";
      ["objective"] = "Tammra Windfield at Sun Rock Retreat wants you to gather 10 Gaea Seeds.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Cycle de la renaissance";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "生生不息";
      ["name_de"] = "Zyklus der Wiedergeburt";
      ["faction"] = "Horde";
      ["name"] = "Cycle of Rebirth";
      ["level"] = 23;
      ["name_es"] = "El ciclo del renacimiento";
      ["req"] = 17;
   };
   [1360] = {
      ["name_ru"] = "Возвращенные сокровища";
      ["type"] = "Solo";
      ["objective"] = "Get Krom Stoutarm's treasured possession from his chest in the North Common Hall of Uldaman, and bring it to him in Ironforge.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_fr"] = "Des Tresors a recouvrer";
      ["sort"] = "Uldaman";
      ["name_cn"] = "失而?得";
      ["name_de"] = "Wiederbeschaffte Schatze";
      ["faction"] = "Alliance";
      ["name"] = "Reclaimed Treasures";
      ["level"] = 43;
      ["name_es"] = "Los tesoros reclamados";
      ["req"] = 33;
   };
   [1364] = {
      ["name_ru"] = "Задание Мазена";
      ["type"] = "Solo";
      ["objective"] = "Retrieve Khadgar's Essays on Dimensional Convergence and deliver them to Watcher Mahar Ba in Nethergarde Keep.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Stormwind City";
      ["name_fr"] = "Les ordres de Mazen";
      ["name_cn"] = "?森的?求";
      ["reward"] = {
         [1] = 10747;
         [2] = 10748;
      };
      ["name_de"] = "Mazens Befehl";
      ["faction"] = "Alliance";
      ["name"] = "Mazen's Behest";
      ["level"] = 41;
      ["name_es"] = "La orden de Mazen";
      ["req"] = 37;
   };
   [1368] = {
      ["name_ru"] = "Союз с племенем Гелкис";
      ["type"] = "Solo";
      ["objective"] = "Gain a Friendly reputation with the Gelkis, then speak with Uthek the Wise.";
      ["next"] = 1370;
      ["name_fr"] = "L'alliance avec les Gelkis";
      ["sort"] = "Desolace";
      ["name_cn"] = "吉?吉斯部族";
      ["followup"] = 1370;
      ["repgain"] = {
         [92] = 250;
      };
      ["name_de"] = "Allianz mit den Gelkis";
      ["faction"] = "Horde";
      ["name"] = "Gelkis Alliance";
      ["level"] = 33;
      ["name_es"] = "La alianza con los Gelkis";
      ["req"] = 30;
   };
   [1372] = {
      ["name_ru"] = "Правда и только правда";
      ["type"] = "Solo";
      ["name_fr"] = "La verite, rien que la verite";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Nichts als die Wahrheit";
      ["name_cn"] = "真言?水";
      ["objective"] = "Speak with Apothecary Faustin at Beggar's Haunt.";
      ["next"] = 1383;
      ["sort"] = "Duskwood";
      ["name"] = "Nothing But The Truth";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 42;
      ["name_es"] = "El suero de la verdad";
      ["req"] = 37;
   };
   [5502] = {
      ["name_ru"] = "Опекун Орды";
      ["type"] = "Solo";
      ["name_fr"] = "Un surveillant de la Horde";
      ["name_de"] = "Tageseltern der Horde";
      ["name_cn"] = "部落孤儿的看?者";
      ["objective"] = "Return your ward to the Orgrimmar orphanage by handing in the Orcish Orphan Whistle to Orphan Matron Battlewail in the Valley of Honor.";
      ["sort"] = "Children's Week";
      ["reward"] = {
         [1] = 23007;
         [2] = 23015;
         [3] = 23002;
         [4] = 23022;
      };
      ["name"] = "A Warden of the Horde";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 925;
      };
      ["level"] = 60;
      ["name_es"] = "Alcaide de la Horda";
      ["req"] = 10;
   };
   [1380] = {
      ["name_ru"] = "Вождь Храта";
      ["type"] = "Group";
      ["name_fr"] = "Khan Hratha";
      ["name_de"] = "Khan Hratha";
      ["reward"] = {
         [1] = 6773;
         [2] = 6774;
      };
      ["name_cn"] = "赫??可汗";
      ["objective"] = "Maintain your reputation with the Gelkis, and bring the Maraudine Key Fragment to Uthek the Wise in the Gelkis Village.";
      ["faction"] = "Horde";
      ["name"] = "Khan Hratha";
      ["sort"] = "Desolace";
      ["prev"] = 1374;
      ["prequests"] = {
         [1] = 1374;
      };
      ["level"] = 42;
      ["name_es"] = "Khan Hratha";
      ["req"] = 30;
   };
   [5534] = {
      ["name_ru"] = "\"Пропавшее\"оборудование Ким'джаеля";
      ["type"] = "Solo";
      ["name_fr"] = "L'equipement \"manquant\" de Kim'jael";
      ["repgain"] = {
         [21] = 350;
      };
      ["name_de"] = "Kim'jaels 'fehlende' Ausrustung";
      ["name_cn"] = "基姆加?“?失”的装?";
      ["name"] = "Kim'jael's Missing\" Equipment\"";
      ["objective"] = " then hit the Ruins of Eldarath and find me some rune that them Blood elves were lookin' for. The naga apparently have it in their possession.\"";
      ["faction"] = "Horde";
      ["sort"] = "Azshara";
      ["prev"] = 3601;
      ["prequests"] = {
         [1] = 3601;
      };
      ["level"] = 53;
      ["name_es"] = "El equipamiento \"perdido\" de Kim'jael";
      ["req"] = 47;
   };
   [1388] = {
      ["name_ru"] = "Правда и только правда";
      ["type"] = "Solo";
      ["name_fr"] = "La verite, rien que la verite";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Nichts als die Wahrheit";
      ["name"] = "Nothing But The Truth";
      ["name_cn"] = "真言?水";
      ["objective"] = "Give Faustin's Truth Serum to Deathstalker Zraedus at Beggar's Haunt.";
      ["next"] = 1391;
      ["faction"] = "Horde";
      ["sort"] = "Duskwood";
      ["prev"] = 1383;
      ["prequests"] = {
         [1] = 1383;
      };
      ["level"] = 42;
      ["name_es"] = "El suero de la verdad";
      ["req"] = 37;
   };
   [1392] = {
      ["name_ru"] = "Нобору Дубина";
      ["type"] = "Solo";
      ["objective"] = "Bring Noboru's Cudgel to the leader of The Harborage in the Swamp of Sorrows.";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "木棒?博?";
      ["name_fr"] = "Noboru le Gourdin";
      ["name_de"] = "Noboru der Knuppel";
      ["faction"] = "Horde";
      ["name"] = "Noboru the Cudgel";
      ["level"] = 39;
      ["name_es"] = "Noboru el Garrote";
      ["req"] = 29;
   };
   [5582] = {
      ["name_ru"] = "Здоровая чешуя дракона";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'ecaille de dragon luisante";
      ["repgain"] = {
         [529] = 75;
      };
      ["name_de"] = "Gesunde Grosdrachenschuppe";
      ["name_cn"] = "健康的??";
      ["name"] = "Healthy Dragon Scale";
      ["objective"] = "Bring the Healthy Dragon Scale to Betina Bigglezink at the Light's Hope Chapel in Eastern Plaguelands.";
      ["faction"] = "Horde";
      ["sort"] = "Scholomance";
      ["prev"] = 5529;
      ["prequests"] = {
         [1] = 5529;
      };
      ["level"] = 58;
      ["name_es"] = "Escama de dragon sana";
      ["req"] = 55;
   };
   [6393] = {
      ["name_ru"] = "Война элементалей";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Incendrites to Tsunaman at Sun Rock Retreat.";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "元素?争";
      ["name_fr"] = "Guerre elementaire";
      ["name_de"] = "Krieg der Elementare";
      ["faction"] = "Horde";
      ["name"] = "Elemental War";
      ["level"] = 25;
      ["name_es"] = "Guerra elemental";
      ["req"] = 19;
   };
   [6323] = {
      ["name_ru"] = "Полет в Подгород";
      ["type"] = "Solo";
      ["name_fr"] = "Voyage vers Fossoyeuse";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Flug nach Unterstadt";
      ["objective"] = "Buy a bat ride to the Undercity from the bat master Karos Razok, then take Podrig's Order to Gordon Wendham in the Undercity.";
      ["name_cn"] = "?往幽暗城";
      ["next"] = 6322;
      ["sort"] = "Silverpine Forest";
      ["name"] = "Ride to the Undercity";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 6321;
      ["prequests"] = {
         [1] = 6321;
      };
      ["level"] = 10;
      ["name_es"] = "Vuela a Entranas";
      ["req"] = 10;
   };
   [5630] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家*";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5646] = {
      ["name_ru"] = "Всепожирающая чума";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Verschlingende Seuche";
      ["sort"] = "Priest";
      ["name_cn"] = "噬?瘟疫";
      ["name_fr"] = "Peste devorante";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Devouring Plague";
      ["level"] = 20;
      ["name_es"] = "Peste devoradora";
      ["req"] = 20;
   };
   [5662] = {
      ["name_ru"] = "Прикосновение слабости";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Beruhrung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱之触";
      ["name_fr"] = "Toucher de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Touch of Weakness";
      ["level"] = 10;
      ["name_es"] = "Toque de debilidad";
      ["req"] = 10;
   };
   [1420] = {
      ["name_ru"] = "Донесение Хелгруму";
      ["type"] = "Solo";
      ["objective"] = "Bring Neeka's Report to Helgrum the Swift in Stonard.";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_fr"] = "Le rapport a Helgrum";
      ["sort"] = "Badlands";
      ["name_cn"] = "向赫格拉姆?到";
      ["name_de"] = "Bericht fur Helgrum";
      ["faction"] = "Horde";
      ["name"] = "Report to Helgrum";
      ["level"] = 40;
      ["name_es"] = "Un informe para Helgrum";
      ["req"] = 30;
   };
   [1424] = {
      ["name_ru"] = "Озеро Слез";
      ["type"] = "Group";
      ["objective"] = "Fel'zerul in Stonard wants you to gather 10 Atal'ai Artifacts.";
      ["next"] = 1429;
      ["name_fr"] = "Le bassin des larmes";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "泪水之池";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "[DEPRECATED] Tranenteich";
      ["faction"] = "Horde";
      ["name"] = "Pool of Tears";
      ["level"] = 43;
      ["name_es"] = "Charca de Lagrimas";
      ["req"] = 38;
   };
   [1428] = {
      ["name_ru"] = "Продолжающаяся угроза";
      ["type"] = "Solo";
      ["name_fr"] = "Le danger permanent";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Fortwahrende Gefahr";
      ["name_cn"] = "海中的威?";
      ["name"] = "Continued Threat";
      ["objective"] = "Kill 10 Marsh Inkspewers, 10 Marsh Flesheaters, and 10 Marsh Oracles, then return to Katar in the Swamp of Sorrows.";
      ["faction"] = "Horde";
      ["sort"] = "Swamp of Sorrows";
      ["prev"] = 1426;
      ["prequests"] = {
         [1] = 1426;
      };
      ["level"] = 45;
      ["name_es"] = "La amenaza continua";
      ["req"] = 35;
   };
   [1432] = {
      ["name_ru"] = "Отношения с Альянсом";
      ["type"] = "Solo";
      ["objective"] = "Speak to Takata Steelblade in Desolace.";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Allianzbeziehungen";
      ["name"] = "Alliance Relations";
      ["name_cn"] = "?盟?系";
      ["name_fr"] = "Les relations de l'Alliance";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 1431;
      ["prequests"] = {
         [1] = 1431;
      };
      ["level"] = 30;
      ["name_es"] = "Las relaciones de la Alianza";
      ["req"] = 30;
   };
   [5742] = {
      ["name_ru"] = "Искупление";
      ["type"] = "Solo";
      ["objective"] = "Listen to what Tirion Fordring has to say.";
      ["next"] = 5781;
      ["name_fr"] = "Redemption";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "救?";
      ["name"] = "Redemption";
      ["name_de"] = "Erlosung";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 5542;
         [2] = 5543;
         [3] = 5544;
      };
      ["level"] = 56;
      ["name_es"] = "Redencion";
      ["req"] = 52;
   };
   [1440] = {
      ["name_ru"] = "Возвращение к Валарриэлю";
      ["type"] = "Solo";
      ["objective"] = "Escort Dalinda Malem from Thunder Axe Fortress and then return to Vahlarriel Demonslayer in Desolace.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Ruckkehr zu Vahlarriel";
      ["reward"] = {
         [1] = 9687;
         [2] = 9698;
         [3] = 9699;
         [4] = 11884;
      };
      ["name_cn"] = "回?瓦拉里?";
      ["name_fr"] = "Le retour vers Vahlarriel";
      ["faction"] = "Alliance";
      ["name"] = "Return to Vahlarriel";
      ["sort"] = "Desolace";
      ["prev"] = 1439;
      ["prequests"] = {
         [1] = 1439;
      };
      ["level"] = 33;
      ["name_es"] = "Regresa junto a Vahlarriel";
      ["req"] = 30;
   };
   [1444] = {
      ["name_ru"] = "Возвращение к Фел'зерулу";
      ["type"] = "Solo";
      ["name_fr"] = "De retour vers Fel’Zerul";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Ruckkehr zu Fel'Zerul";
      ["name"] = "Return to Fel'Zerul";
      ["name_cn"] = "向?????命";
      ["objective"] = "Return to Fel'Zerul in Stonard.";
      ["next"] = 1445;
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 1429;
      ["prequests"] = {
         [1] = 1429;
      };
      ["level"] = 44;
      ["name_es"] = "Regresa junto a Fel'Zerul";
      ["req"] = 38;
   };
   [1448] = {
      ["name_ru"] = "В поисках Храма";
      ["type"] = "Group";
      ["objective"] = "Brohann Caskbelly in Stormwind wants you to search for the Temple of Atal'Hakkar.";
      ["next"] = 1449;
      ["name_fr"] = "A la recherche du temple";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "??神?";
      ["repgain"] = {
         [47] = 250;
         [72] = 75;
      };
      ["name_de"] = "Auf der Suche nach dem Tempel";
      ["faction"] = "Alliance";
      ["name"] = "In Search of The Temple";
      ["level"] = 43;
      ["name_es"] = "En busqueda del templo";
      ["req"] = 38;
   };
   [1452] = {
      ["name_ru"] = "Калимдорский коктейль";
      ["type"] = "Solo";
      ["name_fr"] = "Le Kocktail Kalimdor de Rhapsody";
      ["name_de"] = "Rhapsodies Kalimdor-Cocktail";
      ["name_cn"] = "拉普索迪的?利姆多?尾酒";
      ["objective"] = "Rhapsody Shindigger in The Hinterlands wants you to bring him 3 Roc Gizzards, 3 Groddoc Livers and 3 Ironfur Livers.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Alliance";
      ["name"] = "Rhapsody's Kalimdor Kocktail";
      ["prev"] = 1451;
      ["prequests"] = {
         [1] = 1451;
      };
      ["level"] = 43;
      ["name_es"] = "El cubata de Kalimdor de Rapsodio";
      ["req"] = 38;
   };
   [1456] = {
      ["name_ru"] = "Пожитки Карнитола";
      ["objective"] = "Find Karnitol's Satchel and return it to Kreldig Ungor in Desolace.";
      ["name_cn"] = "?尼托的海?";
      ["sort"] = "Desolace";
      ["level"] = 39;
      ["type"] = "Solo";
      ["name_fr"] = "L'epave de Karnitol";
      ["next"] = 1457;
      ["name_de"] = "Karnitols Schiffbruch";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Karnitol Shipwreck";
      ["prev"] = 1455;
      ["prequests"] = {
         [1] = 1455;
      };
      ["series"] = 3;
      ["name_es"] = "El naufragio de Karnitol";
      ["req"] = 30;
   };
   [6324] = {
      ["name_ru"] = "Обратно к Подригу";
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers Podrig";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Ruckkehr zu Morris";
      ["name_cn"] = "向博迪瑞格回?";
      ["objective"] = "Buy a bat ride to the Sepulcher from the bat master Michael Garrett, then bring Gordon's Crate to Deathguard Podrig in the Sepulcher.";
      ["sort"] = "Silverpine Forest";
      ["name"] = "Return to Podrig";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 6322;
      ["prequests"] = {
         [1] = 6322;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa junto a Morris";
      ["req"] = 10;
   };
   [1464] = {
      ["name_ru"] = "Сапта огня";
      ["type"] = "Solo";
      ["objective"] = "Speak to Telf Joolam for another Fire Sapta.";
      ["name_fr"] = "Le sapta de feu";
      ["sort"] = "Shaman";
      ["name_cn"] = "火??契";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 6636;
      };
      ["name_de"] = "Feuersapta";
      ["faction"] = "Horde";
      ["name"] = "Fire Sapta";
      ["level"] = 13;
      ["name_es"] = "La sapta de fuego";
      ["req"] = 10;
   };
   [1468] = {
      ["name_ru"] = "Детская неделя";
      ["type"] = "Solo";
      ["objective"] = "Use the Human Orphan Whistle to talk with the child you will be looking after during Children's Week.";
      ["repgain"] = {
         [69] = 10;
         [54] = 10;
         [72] = 10;
         [47] = 10;
      };
      ["name_fr"] = "La Semaine des enfants";
      ["sort"] = "Children's Week";
      ["name_cn"] = "儿童周";
      ["name_de"] = "Die Kinderwoche";
      ["faction"] = "Alliance";
      ["name"] = "Children's Week";
      ["level"] = 60;
      ["name_es"] = "Semana de los Ninos";
      ["req"] = 10;
   };
   [5886] = {
      ["name_ru"] = "Лекарство из распыленных предметов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Entzauberung";
      ["name_fr"] = "Du baume contre des desenchantements";
      ["name_cn"] = "分解??膏";
      ["name"] = "Salve via Disenchanting";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4102;
      ["prequests"] = {
         [1] = 4102;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desencantamiento";
      ["req"] = 48;
   };
   [5902] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["next"] = 6390;
      ["name_de"] = "Eine Plage komme uber Euch";
      ["name"] = "A Plague Upon Thee";
      ["name_cn"] = "瘟疫与?";
      ["objective"] = "Find someplace suitable in the center of the Northridge Lumber Mill in Western Plaguelands to place the Barrel of Plagueland Termites.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Tirisfal Glades";
      ["prev"] = 5901;
      ["prequests"] = {
         [1] = 5901;
      };
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [1480] = {
      ["name_ru"] = "Осквернитель душ";
      ["type"] = "Solo";
      ["name_fr"] = "Le corrupteur";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Der Verderber";
      ["name_cn"] = "堕落者";
      ["objective"] = "Bring the Flayed Demon Skin to Maurin Bonesplitter in Desolace.";
      ["next"] = 1481;
      ["sort"] = "Desolace";
      ["name"] = "The Corrupter";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 33;
      ["name_es"] = "El corruptor";
      ["req"] = 25;
   };
   [1484] = {
      ["name_ru"] = "Осквернитель душ";
      ["type"] = "Solo";
      ["name_fr"] = "Le corrupteur";
      ["name_de"] = "Der Verderber";
      ["name_cn"] = "堕落者";
      ["objective"] = "Speak to Takata Steelblade in Desolace.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "The Corrupter";
      ["prev"] = 1482;
      ["prequests"] = {
         [1] = 1482;
      };
      ["level"] = 35;
      ["name_es"] = "El corruptor";
      ["req"] = 25;
   };
   [1488] = {
      ["name_ru"] = "Осквернитель душ";
      ["type"] = "Group";
      ["name_fr"] = "Le corrupteur";
      ["name_de"] = "Der Verderber";
      ["reward"] = {
         [1] = 6746;
         [2] = 6747;
      };
      ["name_cn"] = "堕落者";
      ["objective"] = "Slay Lord Azrethoc and Jugkar Grim'rod and return to Takata Steelblade in Desolace.";
      ["faction"] = "Horde";
      ["name"] = "The Corrupter";
      ["sort"] = "Desolace";
      ["prev"] = 1484;
      ["prequests"] = {
         [1] = 1484;
      };
      ["level"] = 40;
      ["name_es"] = "El corruptor";
      ["req"] = 25;
   };
   [1492] = {
      ["name_ru"] = "Управляющий пристанью Головокружилкинс";
      ["type"] = "Solo";
      ["objective"] = "Bring the Secure Crate to Wharfmaster Dizzywig in Ratchet.";
      ["repgain"] = {
         [470] = 75;
      };
      ["name_fr"] = "Maitre des quais Tournoupette";
      ["sort"] = "The Barrens";
      ["name_cn"] = "??管理?迪??格";
      ["name_de"] = "Werftmeister Flunkerblick";
      ["faction"] = "Horde";
      ["name"] = "Wharfmaster Dizzywig";
      ["level"] = 11;
      ["name_es"] = "Maestro de muelles Vertipeluca";
      ["req"] = 9;
   };
   [6390] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["name_de"] = "Eine Plage komme uber Euch";
      ["name"] = "A Plague Upon Thee";
      ["name_cn"] = "瘟疫与?";
      ["objective"] = "Release the Plagueland Termites in the Northridge Lumber Mill, then return with the Barrel of Plagueland Termites to Mickey Levine at the Bulwark in Tirisfal Glades.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5902;
      ["prequests"] = {
         [1] = 5902;
      };
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [6394] = {
      ["name_ru"] = "Кирка Тазз'рила";
      ["type"] = "Solo";
      ["name_fr"] = "La pioche de Thazz'ril";
      ["repgain"] = {
         [530] = 350;
         [76] = 350;
      };
      ["name_de"] = "Thazz'rils Hacke";
      ["name_cn"] = "塔?利?的?";
      ["name"] = "Thazz'ril's Pick";
      ["objective"] = "Bring Thazz'ril's Pick to Foreman Thazz'ril.";
      ["faction"] = "Horde";
      ["sort"] = "Valley of Trials";
      ["prev"] = 5441;
      ["prequests"] = {
         [1] = 5441;
      };
      ["level"] = 4;
      ["name_es"] = "Pico de Thazz'ril";
      ["req"] = 3;
   };
   [1504] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Glyphs of Summoning, summon and subdue a voidwalker, then return the Glyphs of Summoning to Gan'rul Bloodeye in Orgrimmar.";
      ["name_cn"] = "誓?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "The Binding";
      ["prev"] = 1501;
      ["prequests"] = {
         [1] = 1501;
      };
      ["level"] = 11;
      ["name_es"] = "El vinculo";
      ["req"] = 10;
   };
   [6030] = {
      ["name_ru"] = "Герцог Николас Зверенхофф";
      ["type"] = "Solo";
      ["objective"] = "Deliver the book, Studies in Spirit Speaking\"";
      ["repgain"] = {
         [0] = 577;
      };
      ["name_fr"] = "Le duc Nicholas Zverenhoff";
      ["sort"] = "Winterspring";
      ["name_cn"] = "尼古拉斯・瑟?霍夫公爵";
      ["name_de"] = "Furst Nicholas Zverenhoff";
      ["faction"] = "Horde";
      ["name"] = "Duke Nicholas Zverenhoff";
      ["level"] = 52;
      ["name_es"] = "El duque Nicolas Zverenhoff";
      ["req"] = 50;
   };
   [1512] = {
      ["name_ru"] = "Дар любви";
      ["type"] = "Solo";
      ["name_fr"] = "Le cadeau de l'amour";
      ["next"] = 1513;
      ["name_de"] = "Die Liebesgabe";
      ["objective"] = "Bring the Dirt-caked Pendant to Gan'rul Bloodeye in Orgrimmar.";
      ["name_cn"] = "?的礼物";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Love's Gift";
      ["prev"] = 1515;
      ["prequests"] = {
         [1] = 1515;
      };
      ["level"] = 20;
      ["name_es"] = "Un regalo de amor";
      ["req"] = 20;
   };
   [6062] = {
      ["name_ru"] = "Приручение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6083;
      ["name_de"] = "Die Zahmung der Bestie";
      ["name_cn"] = "?服野?";
      ["objective"] = "Use the Taming Rod to tame a Dire Mottled Boar. Practice your skills, then return the Taming Rod to Thotar in Razor Hill.";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["series"] = 1;
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [1520] = {
      ["name_ru"] = "Зов Земли";
      ["objective"] = "Find Kodo Rock and drink the Earth Sapta.";
      ["name_cn"] = "大地的召?";
      ["sort"] = "Shaman";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de la terre";
      ["next"] = 1521;
      ["name_de"] = "Ruf der Erde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Earth";
      ["prev"] = 1519;
      ["prequests"] = {
         [1] = 1519;
      };
      ["series"] = 2;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [1524] = {
      ["name_ru"] = "Зов Огня";
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du feu";
      ["next"] = 1525;
      ["name_de"] = "Ruf des Feuers";
      ["objective"] = "Bring the Torch of the Dormant Flame to Telf Joolam in Durotar.";
      ["name_cn"] = "火?的召?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["series"] = 1;
      ["name"] = "Call of Fire";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1523;
         [2] = 2983;
         [3] = 1522;
         [4] = 2984;
      };
      ["level"] = 11;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [1528] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["objective"] = "Find Islen Waterseer in the Barrens.";
      ["next"] = 1530;
      ["sort"] = "Shaman";
      ["name_cn"] = "水之召?";
      ["name_fr"] = "L'appel de l'eau";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1530;
      ["name_de"] = "Ruf des Wassers";
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["level"] = 20;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [6126] = {
      ["name_ru"] = "Новый урок";
      ["type"] = "Solo";
      ["objective"] = "Travel to Moonglade and speak with Dendrite Starblaze in the village of Nighthaven.";
      ["next"] = 6127;
      ["name_de"] = "Neue Lektionen";
      ["sort"] = "Druid";
      ["name_cn"] = "新的?程";
      ["name_fr"] = "Nouvelles lecons";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Lessons Anew";
      ["level"] = 14;
      ["name_es"] = "Nuevas lecciones";
      ["req"] = 14;
   };
   [6142] = {
      ["name_ru"] = "Наживка из моллюска";
      ["type"] = "Solo";
      ["objective"] = "Find 10 pieces of Soft-shelled Clam Meat and bring it back to Mai'Lahii at Shadowprey Village.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "Des praires comme appat";
      ["name_cn"] = "蚌肉??";
      ["reward"] = {
         [1] = 15585;
         [2] = 15587;
         [3] = 15588;
      };
      ["name_de"] = "Muschelkoder";
      ["faction"] = "Horde";
      ["name"] = "Clam Bait";
      ["level"] = 35;
      ["name_es"] = "Almejas";
      ["req"] = 31;
   };
   [6401] = {
      ["name_ru"] = "Кайя жива!";
      ["type"] = "Solo";
      ["name_fr"] = "Kaya est en vie";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Kaya lebt";
      ["name_cn"] = "?雅?活着";
      ["name"] = "Kaya's Alive";
      ["objective"] = "Tell Tammra Windfield in Sun Rock Retreat the good news.$B";
      ["faction"] = "Horde";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 6523;
      ["prequests"] = {
         [1] = 6523;
      };
      ["level"] = 18;
      ["name_es"] = "Kaya esta viva";
      ["req"] = 12;
   };
   [8251] = {
      ["name_ru"] = "Волшебная пыль";
      ["type"] = "Solo";
      ["name_fr"] = "La poussiere magique";
      ["next"] = 8252;
      ["name_de"] = "Magischer Staub";
      ["objective"] = "Bring 10 Glittering Dust to Archmage Xylem.";
      ["name_cn"] = "魔法的?埃";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Magic Dust";
      ["prev"] = 8250;
      ["prequests"] = {
         [1] = 8250;
      };
      ["level"] = 52;
      ["name_es"] = "El polvo magico";
      ["req"] = 50;
   };
   [8283] = {
      ["name_ru"] = "РОЗЫСК: Смертехват, гроза пустыни";
      ["type"] = "Group";
      ["objective"] = "Bring Deathclasp's Pincer to Vish Kozus, Captain of the Guard.";
      ["repgain"] = {
         [609] = 250;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "On recherche?: Poigne-de-mort, Terreur des sables";
      ["name_cn"] = "通?：死亡弯?";
      ["reward"] = {
         [1] = 20646;
         [2] = 20647;
      };
      ["name_de"] = "GESUCHT: Totenstachel, Terror der Wuste";
      ["faction"] = "Horde";
      ["name"] = "Wanted - Deathclasp, Terror of the Sands";
      ["level"] = 59;
      ["name_es"] = "Se busca: Pinzamorten el Terror de las arenas";
      ["req"] = 54;
   };
   [8315] = {
      ["name_ru"] = "Зов";
      ["type"] = "Group";
      ["name_fr"] = "L'appel";
      ["repgain"] = {
         [609] = 200;
      };
      ["name_de"] = "Die Anrufung";
      ["name_cn"] = "召?";
      ["name"] = "The Calling";
      ["objective"] = "Geologist Larksbane at Cenarion Hold in Silithus wants you to recover the Crystal Unlocking Mechanism from the Qiraji Emissary.$B$BYou have been instructed to take the Glyphs of Calling to the Bones of Grakkarond, south of Cenarion Hold, and draw them in the sand. Should the Qiraji Emissary appear, slay it and recover the Crystal Unlocking Mechanism. Return to Geologist Larksbane if you succeed.$B$BAssemble an army for this task, $N!";
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8314;
      ["prequests"] = {
         [1] = 8314;
      };
      ["level"] = 60;
      ["name_es"] = "La llamada";
      ["req"] = 58;
   };
   [5146] = {
      ["name_ru"] = "Кожевничество: сила стихий";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Heart of Fire, 2 Globe of Water, 2 Core of Earth, and 2 Breath of Wind to Brumn Winterhoof in the Arathi Mountains.$B$BCompleting this quest will give you access to the Elemental Leatherworking arts.$B$BThe completion of this quest will prevent you from learning Dragonscale Leatherworking and Tribal Leatherworking; be sure this is the path you wish to follow before doing so.";
      ["sort"] = "Leatherworking";
      ["name_cn"] = "元素制皮";
      ["name_fr"] = "Travail du cuir elementaire";
      ["name_de"] = "Elementarlederverarbeitung";
      ["faction"] = "Horde";
      ["name"] = "Elemental Leatherworking";
      ["level"] = 55;
      ["name_es"] = "Peleteria elemental";
      ["req"] = 40;
   };
   [1560] = {
      ["name_ru"] = "Задание Туги";
      ["type"] = "Solo";
      ["objective"] = "Show Tooga the way back to his wife, Torta.";
      ["name_fr"] = "La quete de Tooga";
      ["sort"] = "Tanaris";
      ["name_cn"] = "?加的任?";
      ["reward"] = {
         [1] = 9638;
         [2] = 9642;
      };
      ["name_de"] = "Toogas Bitte";
      ["faction"] = "Horde";
      ["name"] = "Tooga's Quest";
      ["level"] = 50;
      ["name_es"] = "La mision de Tooga";
      ["req"] = 40;
   };
   [8411] = {
      ["name_ru"] = "Покорение Стихий";
      ["type"] = "Solo";
      ["objective"] = "Bring the elements earth, air, fire and water to Bath'rah the Windwatcher.";
      ["next"] = 8412;
      ["name_cn"] = "控制元素";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name_de"] = "Die Beherrschung der Elemente";
      ["faction"] = "Horde";
      ["name"] = "Mastering the Elements";
      ["level"] = 50;
      ["name_es"] = "Dominar los elementos";
      ["req"] = 50;
   };
   [8443] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 50;
      };
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["prev"] = 8439;
      ["prequests"] = {
         [1] = 8439;
      };
      ["level"] = 60;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 60;
   };
   [6561] = {
      ["name_ru"] = "Злодейство в Непроглядной Пучине";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the head of Twilight Lord Kelris to Bashana Runetotem in Thunder Bluff.";
      ["repgain"] = {
         [81] = 500;
         [529] = 200;
      };
      ["sort"] = "Blackfathom Deeps";
      ["name_fr"] = "L'infamie de Brassenoire";
      ["name_cn"] = "黑暗深渊中的邪?";
      ["reward"] = {
         [1] = 7001;
         [2] = 7002;
      };
      ["name_de"] = "Schurkerei in der Tiefschwarzen Grotte";
      ["faction"] = "Horde";
      ["name"] = "Blackfathom Villainy";
      ["level"] = 27;
      ["name_es"] = "La vileza de Brazanegra";
      ["req"] = 18;
   };
   [8507] = {
      ["name_ru"] = "Рутинное задание";
      ["type"] = "Group";
      ["objective"] = "Report for duty at the Ironforge Brigade post near Hive'Zora.  Prepare your Unsigned Field Duty Papers and obtain Signed Field Duty Papers from Captain Blackanvil and return to Windcaller Kaldon at Cenarion Hold in Silithus.$B$BNote: Healing or casting beneficial spells on a member of the Ironforge Brigade will flag you for PvP.";
      ["repgain"] = {
         [609] = 25;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Votre affectation";
      ["name_cn"] = "?地任?";
      ["reward"] = {
         [1] = 20808;
         [2] = 21132;
         [3] = 20809;
      };
      ["name_de"] = "Felddienst";
      ["faction"] = "Alliance";
      ["name"] = "Field Duty";
      ["level"] = 60;
      ["name_es"] = "Servicio de campo";
      ["req"] = 60;
   };
   [1580] = {
      ["name_ru"] = "Электропеллеры";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Electropellers to Wizbang Cranktoggle in Auberdine.";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Elektropeller";
      ["reward"] = {
         [1] = 6811;
      };
      ["name_cn"] = "??器";
      ["name_fr"] = "Peche aux Electropellers";
      ["faction"] = "Alliance";
      ["name"] = "Electropellers";
      ["sort"] = "Fishing";
      ["prev"] = 1579;
      ["prequests"] = {
         [1] = 1579;
      };
      ["level"] = 12;
      ["name_es"] = "Los electromuelles";
      ["req"] = 10;
   };
   [3913] = {
      ["name_ru"] = "Замогильная история";
      ["type"] = "Solo";
      ["name_fr"] = "Une situation grave";
      ["next"] = 3914;
      ["name_de"] = "Grabesstille";
      ["name_cn"] = "?找墓碑";
      ["objective"] = "Resurrect, then look for the gravestone that Gaeriyan told you to find.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "A Grave Situation";
      ["prev"] = 3912;
      ["prequests"] = {
         [1] = 3912;
      };
      ["level"] = 52;
      ["name_es"] = "Una situacion mortal";
      ["req"] = 47;
   };
   [8603] = {
      ["name_ru"] = "Одежды Оракула";
      ["objective"] = "Bring the the Husk of the Old God, 2 Idols of Death, 5 Stone Scarabs and 5 Crystal Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神?者的外套";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les habits de l'Oracle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Gewander des Orakels";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21351;
      };
      ["name"] = "Vestments of the Oracle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las vestimentas del Oraculo";
      ["req"] = 60;
   };
   [8635] = {
      ["name_ru"] = "Предок Камнещеп";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Pierre-fendue";
      ["name_cn"] = "碎石?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Splitterfels";
      ["faction"] = "Horde";
      ["name"] = "Splitrock the Elder";
      ["level"] = 60;
      ["name_es"] = "Parterroca el Ancestro";
      ["req"] = 1;
   };
   [8667] = {
      ["name_ru"] = "Шлем сотворения";
      ["objective"] = "Bring Vek'lor's Diadem, 2 Idols of Life, 5 Gold Scarabs and 5 Clay Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "起源??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le casque de la genese";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Helm der Genesis";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21353;
      };
      ["name"] = "Genesis Helm";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El yelmo genesis";
      ["req"] = 60;
   };
   [8699] = {
      ["name_ru"] = "Кольцо Погребенных тайн";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Magisterial Ring, 2 Azure Idols, 5 Gold Scarabs and 5 Clay Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau des secrets scelles";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "魔法秘密之戒";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21414;
      };
      ["name_de"] = "Band der behuteten Geheimnisse";
      ["faction"] = "Horde";
      ["name"] = "Band of Vaulted Secrets";
      ["level"] = 60;
      ["name_es"] = "La sortija de secretos oscuros";
      ["req"] = 60;
   };
   [8731] = {
      ["name_ru"] = "Рутинное задание";
      ["type"] = "Group";
      ["objective"] = "Report to Krug Skullsplit at the Orgrimmar Legion post in front of Hive'Regal.  Prepare your Unsigned Field Duty Papers, obtain Signed Field Duty Papers and bring them to Windcaller Kaldon in Cenarion Hold.$B$BNote: Healing or casting beneficial spells on a member of the Orgrimmar Legion will flag you for PvP.";
      ["repgain"] = {
         [609] = 25;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Votre affectation";
      ["name_cn"] = "?地任?";
      ["reward"] = {
         [1] = 20808;
         [2] = 21266;
         [3] = 20809;
      };
      ["name_de"] = "Felddienst";
      ["faction"] = "Horde";
      ["name"] = "Field Duty";
      ["level"] = 60;
      ["name_es"] = "Servicio de campo";
      ["req"] = 60;
   };
   [8763] = {
      ["name_ru"] = "Герой дня";
      ["type"] = "Solo";
      ["name_fr"] = "Le heros du jour";
      ["name_de"] = "Der Held des Tages";
      ["reward"] = {
         [1] = 21213;
      };
      ["name_cn"] = "大英雄！";
      ["objective"] = "Bring 1 Deeprock Salt and 5 gold coins to any Holly Preserver machine, upon which you will receive 5 Preserved Holly.";
      ["faction"] = "Alliance";
      ["name"] = "The Hero of the Day";
      ["sort"] = "Hallow's End";
      ["prev"] = 8762;
      ["prequests"] = {
         [1] = 8762;
      };
      ["level"] = 60;
      ["name_es"] = "El heroe del dia";
      ["req"] = 40;
   };
   [8795] = {
      ["name_ru"] = "Альянсу нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Field Marshal Snowfall in Ironforge's Military Ward.";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要?的?助！";
      ["name_fr"] = "L'Alliance a besoin de votre aide !";
      ["name_de"] = "Die Allianz braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza te necesita!";
      ["req"] = 49;
   };
   [8827] = {
      ["name_ru"] = "Подарки Дедушки Зимы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter. He is located near the Smokywood Pastures vendor area in Ironforge.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天的礼物";
      ["name_fr"] = "Des cadeaux d'hiver";
      ["name_de"] = "Winters Geschenke";
      ["faction"] = "Alliance";
      ["name"] = "Winter's Presents";
      ["level"] = 1;
      ["name_es"] = "Regalos del invierno";
      ["req"] = 1;
   };
   [8859] = {
      ["name_ru"] = "Тайны колосса ? Зора";
      ["type"] = "Solo";
      ["objective"] = "Take the Colossus of Zora's Husk to Lord Maxwell Tyrosus at Light's Hope Chapel in the Eastern Plaguelands.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Les secrets du Colosse - Zora";
      ["name_cn"] = "巨像的秘密 - 佐拉";
      ["reward"] = {
         [1] = 21528;
      };
      ["name_de"] = "Geheimnisse des Kolosses - Zora";
      ["faction"] = "Horde";
      ["name"] = "Secrets of the Colossus - Zora";
      ["level"] = 60;
      ["name_es"] = "Los secretos de los Colosos: Zora";
      ["req"] = 51;
   };
   [2381] = {
      ["name_ru"] = "Грабь награбленное";
      ["type"] = "Solo";
      ["name_fr"] = "Piller les pilleurs";
      ["name_de"] = "Das Ausplundern der Plunderer";
      ["objective"] = "Bring the Southsea Treasure back to Wrenix the Wretched in Ratchet. Do not forget to get an E.C.A.C. and Thieves' Tools from Wrenix's Gizmotronic Apparatus. You will need both of these items to complete your mission.$B$BShould you be attacked by any unusually hostile parrots, use your E.C.A.C.!$B$B";
      ["reward"] = {
         [1] = 7676;
      };
      ["name_cn"] = "?劫海盗";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Plundering the Plunderers";
      ["sort"] = "Rogue";
      ["prev"] = 2382;
      ["prequests"] = {
         [1] = 2382;
      };
      ["level"] = 18;
      ["name_es"] = "Saquear a los saqueadores";
      ["req"] = 16;
   };
   [8923] = {
      ["name_ru"] = "Сверхъестественное устройство";
      ["type"] = "Solo";
      ["objective"] = "Take the Sealed Venom Container to Mux Manascrambler in Gadgetzan.";
      ["next"] = 8921;
      ["name_fr"] = "Un objet surnaturel";
      ["sort"] = "Tanaris";
      ["name_cn"] = "超自然的??";
      ["name"] = "A Supernatural Device";
      ["followup"] = 8921;
      ["name_de"] = "Ein ubernaturlicher Apparat";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8913;
         [2] = 8915;
         [3] = 8916;
         [4] = 8917;
         [5] = 8918;
         [6] = 8919;
         [7] = 8920;
         [8] = 8914;
      };
      ["level"] = 60;
      ["name_es"] = "Un artefacto sobrenatural";
      ["req"] = 58;
   };
   [8955] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Devout Sandals, Devout Skirt and Devout Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22084;
         [2] = 22085;
         [3] = 22082;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [6542] = {
      ["name_ru"] = "Донесение Кадраку";
      ["type"] = "Solo";
      ["objective"] = "Report to Kadrak at the watch tower in northern Barrens.";
      ["next"] = 6543;
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "向?德拉克?到";
      ["name_fr"] = "Rapport a Kadrak";
      ["name_de"] = "Meldung bei Kadrak";
      ["faction"] = "Horde";
      ["name"] = "Report to Kadrak";
      ["level"] = 19;
      ["name_es"] = "Presentate ante Kadrak";
      ["req"] = 17;
   };
   [9019] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Devout Sandals, Devout Skirt and Devout Mantle.";
      ["name_cn"] = "告?安泰恩";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22084;
         [2] = 22085;
         [3] = 22082;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [1644] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1780;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Bring 10 Linen Cloth to Stephanie Turner in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1643;
      ["prequests"] = {
         [1] = 1643;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [9083] = {
      ["name_ru"] = "Воинский пояс костяной косы";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make a Bonescythe Waistguard if you bring him the following: 1 Desecrated Waistguard, 8 Wartorn Leather Scraps, 5 Cured Rugged Hides, 1 Nexus Crystal and 15 gold pieces.";
      ["name_cn"] = "骨??腰";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La sangle de la faucheuse d'os";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Taillenschutz der Knochensense";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22482;
      };
      ["name"] = "Bonescythe Waistguard";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardarrenes Segahuesos";
      ["req"] = 60;
   };
   [6606] = {
      ["name_ru"] = "Немного удачи";
      ["type"] = "Solo";
      ["objective"] = "Speak with Witch Doctor Mau'ari in Everlook.";
      ["next"] = 969;
      ["sort"] = "Winterspring";
      ["name_cn"] = "一点?气";
      ["name_fr"] = "Un peu de chance";
      ["name_de"] = "Ein bisschen Gluck";
      ["faction"] = "Horde";
      ["name"] = "A Little Luck";
      ["level"] = 60;
      ["name_es"] = "Un poco de suerte";
      ["req"] = 55;
   };
   [6622] = {
      ["name_ru"] = "Очередь на медобслуживание";
      ["type"] = "Solo";
      ["objective"] = "Save patients by using Triage Bandages to tend to their wounds. You must save 15 patients before 6 of them die from their injuries.$B$BRemember the order of triage! Critically Injured Soldiers die the fastest followed by Badly Injured Soldiers. Injured Soldiers take the longest to die and should be saved AFTER your Critically Injured and Badly Injured Soldiers have been triaged.";
      ["sort"] = "First Aid";
      ["name_cn"] = "救死扶?";
      ["name_fr"] = "Triage";
      ["name_de"] = "Triage";
      ["faction"] = "Horde";
      ["name"] = "Triage";
      ["level"] = 45;
      ["name_es"] = "Orden de gravedad";
      ["req"] = 35;
   };
   [9179] = {
      ["name_ru"] = "Задание мастера: имперское зерцало";
      ["type"] = "Solo";
      ["objective"] = "Deliver 3 Imperial Plate Chests and the Craftsman's Writ - Imperial Plate Chest - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Pansieres imperiales";
      ["name_cn"] = "工匠文? - 君王板甲?胸";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Imperiale Plattenrustung";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Imperial Plate Chest";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: peto de placas imperiales";
      ["req"] = 55;
   };
   [9211] = {
      ["name_ru"] = "Ледяная защита";
      ["type"] = "Solo";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands wants 10 Insignia of the Crusade and 30 gold.";
      ["name_fr"] = "La Garde-glace";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "寒冰戒?";
      ["reward"] = {
         [1] = 22636;
      };
      ["name_de"] = "Der Eiswachter";
      ["faction"] = "Horde";
      ["name"] = "The Ice Guard";
      ["level"] = 60;
      ["name_es"] = "El guardahielo";
      ["req"] = 60;
   };
   [9243] = {
      ["name_ru"] = "Снежный мундир";
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres polaires";
      ["name_de"] = "Polartunika";
      ["reward"] = {
         [1] = 22661;
      };
      ["name_cn"] = "北?外套";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 8 Frozen Runes, 16 Enchanted Leathers, 5 Essences of Water, 5 Cured Rugged Hides and 300 gold. You must also be of Exalted reputation with the Argent Dawn.";
      ["faction"] = "Horde";
      ["name"] = "Polar Tunic";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "La guerrera polar";
      ["req"] = 60;
   };
   [8394] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 100;
      };
      ["name_fr"] = "La revendication du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "?争的?力";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["level"] = 49;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 40;
   };
   [6601] = {
      ["name_ru"] = "Вознесение";
      ["type"] = "Solo";
      ["name_fr"] = "Ascension...";
      ["next"] = 6602;
      ["name_de"] = "Aufstieg...";
      ["name_cn"] = "晋升……";
      ["objective"] = "It would appear as if the charade is over. You know that the Amulet of Draconic Subversion that Myranda the Hag created for you will not function inside Blackrock Spire. Perhaps you should find Rexxar and explain your predicament. Show him the Dull Drakefire Amulet. Hopefully he will know what to do next.";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "Ascension...";
      ["prev"] = 6585;
      ["prequests"] = {
         [1] = 6585;
      };
      ["level"] = 60;
      ["name_es"] = "El ascenso";
      ["req"] = 55;
   };
   [9339] = {
      ["name_ru"] = "Награда вора";
      ["type"] = "Solo";
      ["name_fr"] = "La recompense d'un voleur";
      ["sort"] = "Midsummer";
      ["name_cn"] = "盗?的?励";
      ["objective"] = "";
      ["name"] = "A Thief's Reward";
      ["reward"] = {
         [1] = 23323;
      };
      ["name_de"] = "Der Lohn des Diebes";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 9330;
         [2] = 9331;
         [3] = 9332;
      };
      ["level"] = 60;
      ["name_es"] = "Una recompensa de ladron";
      ["req"] = 50;
   };
   [1684] = {
      ["name_ru"] = "Эланария";
      ["type"] = "Solo";
      ["objective"] = "Speak with Elanaria.";
      ["next"] = 1683;
      ["sort"] = "Warrior";
      ["name_cn"] = "艾?娜瑞";
      ["name_fr"] = "Elanaria";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Elanaria";
      ["faction"] = "Alliance";
      ["name"] = "Elanaria";
      ["level"] = 10;
      ["name_es"] = "Elanaria";
      ["req"] = 10;
   };
   [1688] = {
      ["name_ru"] = "Сурена Каледон";
      ["type"] = "Solo";
      ["objective"] = "Retrieve Surena's Choker for Gakin the Darkbinder in Stormwind.";
      ["next"] = 1689;
      ["sort"] = "Warlock";
      ["name_cn"] = "??娜・???";
      ["name_fr"] = "Surena Caledon";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Surena Caledon";
      ["faction"] = "Alliance";
      ["name"] = "Surena Caledon";
      ["level"] = 10;
      ["name_es"] = "Surena Caledon";
      ["req"] = 10;
   };
   [1692] = {
      ["name_ru"] = "Кузнец Матиль";
      ["type"] = "Solo";
      ["name_fr"] = "Forgeron Mathiel";
      ["name_de"] = "Schmied Mathiel";
      ["objective"] = "Bring the Case of Elunite to Smith Mathiel. ";
      ["name_cn"] = "?匠?希?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Smith Mathiel";
      ["prev"] = 1686;
      ["prequests"] = {
         [1] = 1686;
      };
      ["level"] = 10;
      ["name_es"] = "Mathiel, el herrero";
      ["req"] = 10;
   };
   [6610] = {
      ["name_ru"] = "Мидии с сюрпризом";
      ["type"] = "Solo";
      ["objective"] = "Dirge Quikcleave wants you to get the following items:$B$B12 Giant Eggs. You will find those on the Rocs wandering Tanaris or any other species of large bird.$B$B10 pieces of Zesty Clam Meat. You can find those in clams, naturally!$B$B20 pieces of Alterac Swiss. Get thee to a cheesery!$B$BGather all of the items and return to Dirge.";
      ["name_fr"] = "Surprise de palourdes";
      ["sort"] = "Cooking";
      ["name_cn"] = "蚌肉大餐";
      ["reward"] = {
         [1] = 16971;
      };
      ["name_de"] = "Muschelette Surprise";
      ["faction"] = "Horde";
      ["name"] = "Clamlette Surprise";
      ["level"] = 45;
      ["name_es"] = "Sorpresa de almejate";
      ["req"] = 35;
   };
   [1700] = {
      ["name_ru"] = "Гриманд Элмор";
      ["type"] = "Solo";
      ["name_fr"] = "Grimand Elmore";
      ["next"] = 1705;
      ["name_de"] = "Grimand Elmore";
      ["objective"] = "Bring Furen's Notes to Grimand Elmore.";
      ["name_cn"] = "格瑞曼德・艾?默";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Grimand Elmore";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1701;
      ["prequests"] = {
         [1] = 1701;
      };
      ["level"] = 28;
      ["name_es"] = "Grimand Elmore";
      ["req"] = 20;
   };
   [1704] = {
      ["name_ru"] = "Клацморт Гайкокрут";
      ["type"] = "Solo";
      ["name_fr"] = "Plethorloge Cleventail";
      ["next"] = 1708;
      ["name_de"] = "Klockmort Spannsplint";
      ["objective"] = "Bring Furen's Notes to Klockmort Spannerspan.";
      ["name_cn"] = "科?莫特・?尺";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Klockmort Spannerspan";
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["prev"] = 1701;
      ["prequests"] = {
         [1] = 1701;
      };
      ["level"] = 28;
      ["name_es"] = "Klockmort Palmalicate";
      ["req"] = 20;
   };
   [1708] = {
      ["name_ru"] = "Железный коралл";
      ["type"] = "Solo";
      ["name_fr"] = "Le corail de fer";
      ["name_de"] = "Eisenkoralle";
      ["objective"] = "Bring 20 loads of Searing Coral to Klockmort Spannerspan in Ironforge.";
      ["name_cn"] = "?珊瑚";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Iron Coral";
      ["prev"] = 1704;
      ["prequests"] = {
         [1] = 1704;
      };
      ["level"] = 29;
      ["name_es"] = "Coral ferreo";
      ["req"] = 20;
   };
   [1712] = {
      ["name_ru"] = "Циклониан";
      ["type"] = "Solo";
      ["name_fr"] = "Cyclonien";
      ["next"] = 1713;
      ["name_de"] = "Cyclonian";
      ["objective"] = "Bring the items on Bath'rah's Parchment to Bath'rah the Windwatcher in Alterac.";
      ["name_cn"] = "塞克隆尼?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Cyclonian";
      ["prev"] = 1791;
      ["prequests"] = {
         [1] = 1791;
      };
      ["level"] = 40;
      ["name_es"] = "Ciclonio";
      ["req"] = 30;
   };
   [1716] = {
      ["name_ru"] = "Пожиратель Душ";
      ["type"] = "Solo";
      ["objective"] = "Speak with Takar the Seer in the Barrens.";
      ["next"] = 1738;
      ["sort"] = "Warlock";
      ["name_cn"] = "噬魂者";
      ["name_fr"] = "La devoreuse d'ames";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Verschlinger der Seelen";
      ["faction"] = "Alliance";
      ["name"] = "Devourer of Souls";
      ["level"] = 20;
      ["name_es"] = "Devoradora de almas";
      ["req"] = 20;
   };
   [1847] = {
      ["name_ru"] = "Набедренники Жестокости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Brutale Beinschutzer";
      ["name_fr"] = "Les garde-jambes de brutalite";
      ["name"] = "Brutal Legguards";
      ["name_cn"] = "野蛮腿甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7132;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1846;
      ["prequests"] = {
         [1] = 1846;
      };
      ["level"] = 30;
      ["name_es"] = "Musleras brutales";
      ["req"] = 20;
   };
   [6612] = {
      ["name_ru"] = "Я знаю одного парня...";
      ["type"] = "Solo";
      ["objective"] = "Travel to Gadgetzan in the Tanaris desert and speak with Dirge Quikcleave about advancing your cooking career.$B";
      ["next"] = 6610;
      ["sort"] = "Cooking";
      ["name_cn"] = "我??一个家?…";
      ["name_fr"] = "Je connais un gars...";
      ["name_de"] = "Ich kenne einen Typen...";
      ["faction"] = "Alliance";
      ["name"] = "I Know A Guy...";
      ["level"] = 45;
      ["name_es"] = "Conozco a un tio...";
      ["req"] = 35;
   };
   [4493] = {
      ["name_ru"] = "Нашествие силитидов";
      ["type"] = "Solo";
      ["objective"] = "Speak to Alchemist Pestlezugg in Gadgetzan.";
      ["next"] = 4496;
      ["sort"] = "Darnassus";
      ["name_cn"] = "??蝎的?征";
      ["name_fr"] = "La marche des silithides";
      ["name_de"] = "Der Marsch der Silithiden";
      ["faction"] = "Alliance";
      ["name"] = "March of the Silithid";
      ["level"] = 53;
      ["name_es"] = "La marcha de los silitidos";
      ["req"] = 50;
   };
   [4118] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [6942] = {
      ["name_ru"] = "Небо зовет ? флот Слидора";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 1;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille de Slidore";
      ["name_cn"] = "天空的召? - 斯里多?的空?";
      ["name_de"] = "Ruf der Lufte - Slidores Luftflotte";
      ["faction"] = "Alliance";
      ["name"] = "Call of Air - Slidore's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: la flota de Slidore";
      ["req"] = 51;
   };
   [1740] = {
      ["name_ru"] = "Шар Соран'рука";
      ["type"] = "Dungeon";
      ["objective"] = "Find 3 Soran'ruk Fragments and 1 Large Soran'ruk Fragment and return them to Doan Karhan in the Barrens.";
      ["name_fr"] = "L'Orbe de Soran'ruk";
      ["sort"] = "Warlock";
      ["name_cn"] = "索??克宝珠";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 6898;
         [2] = 15109;
      };
      ["name_de"] = "Die Kugel von Soran'ruk";
      ["faction"] = "Horde";
      ["name"] = "The Orb of Soran'ruk";
      ["level"] = 25;
      ["name_es"] = "El orbe de Soran'ruk";
      ["req"] = 20;
   };
   [9000] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Beaststalker's Cap and Beaststalker's Tunic.";
      ["reward"] = {
         [1] = 22013;
         [2] = 22060;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [6461] = {
      ["name_ru"] = "Кровопийцы";
      ["type"] = "Solo";
      ["objective"] = "Xen'zilla at Malaka'Jin needs you to kill 10 Deepmoss Creepers and 7 Deepmoss Venomspitters.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Suceurs de sang";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "盗窃的蜘蛛";
      ["name_de"] = "Blutfresser";
      ["faction"] = "Horde";
      ["name"] = "Blood Feeders";
      ["level"] = 19;
      ["name_es"] = "Chupasangres";
      ["req"] = 13;
   };
   [6661] = {
      ["name_ru"] = "Охота на крыс";
      ["type"] = "Solo";
      ["objective"] = "Capture 5 Deeprun Rats by using the Rat Catcher's Flute. Lead the rats back to Monty. Don't forget to turn in the flute when you're finished.";
      ["sort"] = "Deeprun Tram";
      ["name_cn"] = "捕捉?道老鼠";
      ["name_fr"] = "Chasse au rat dans les profondeurs";
      ["name_de"] = "Tiefenbahn-Ratten-Razzia";
      ["faction"] = "Alliance";
      ["name"] = "Deeprun Rat Roundup";
      ["level"] = 12;
      ["name_es"] = "A por las ratas del tranvia subterraneo";
      ["req"] = 10;
   };
   [7022] = {
      ["name_ru"] = "Здравствуй, Дедушка Зима!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter; he is located near the Smokywood Pastures vendor area in Ironforge.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天??来了！";
      ["name_fr"] = "Grandpere Hiver est ici?!";
      ["name_de"] = "Altvater Winter ist hier!";
      ["faction"] = "Alliance";
      ["name"] = "Greatfather Winter is Here!";
      ["level"] = 60;
      ["name_es"] = "!El Gran Padre Invierno esta aqui!";
      ["req"] = 10;
   };
   [6721] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dazalar in Dolanaar.";
      ["next"] = 6063;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [4290] = {
      ["name_ru"] = "Добыча Лар'корви";
      ["type"] = "Solo";
      ["objective"] = "Find the carcass of Lar'korwi's freshest kill and steal a Piece of Threshadon Carcass before returning to Torwa Pathfinder in Un'Goro Crater.";
      ["next"] = 4291;
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "拉克?的食物";
      ["name_fr"] = "La nourriture de Lar'korwi";
      ["name_de"] = "Lar'korwis Mahl";
      ["faction"] = "Horde";
      ["name"] = "The Fare of Lar'korwi";
      ["level"] = 53;
      ["name_es"] = "La comida de Lar'korwi";
      ["req"] = 48;
   };
   [7070] = {
      ["name_ru"] = "Фрагменты осколка сумрака";
      ["type"] = "Dungeon";
      ["objective"] = "Collect 10 Shadowshard Fragments from Maraudon and return them to Archmage Tervosh in Theramore on the coast of Dustwallow Marsh.";
      ["repgain"] = {
         [72] = 350;
      };
      ["sort"] = "Maraudon";
      ["name_fr"] = "Fragments d'Ombreclat";
      ["name_cn"] = "暗影残片";
      ["reward"] = {
         [1] = 17772;
         [2] = 17773;
      };
      ["name_de"] = "Schattensplitter";
      ["faction"] = "Alliance";
      ["name"] = "Shadowshard Fragments";
      ["level"] = 42;
      ["name_es"] = "Trozos Oscuros";
      ["req"] = 38;
   };
   [6722] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Dazalar in Dolanaar.";
      ["next"] = 6063;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [7102] = {
      ["name_ru"] = "Башни и бункеры";
      ["type"] = "PvP";
      ["objective"] = "Destroy the banner at an enemy tower or bunker, then return to Sergeant Durgen Stormpike in the Alterac Mountains.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "Tours et fortins";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "哨塔和?堡";
      ["name_de"] = "Turme und Bunker";
      ["faction"] = "Alliance";
      ["name"] = "Towers and Bunkers";
      ["level"] = 60;
      ["name_es"] = "Las torres y los bunkeres";
      ["req"] = 51;
   };
   [1780] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1781;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1644;
      ["prequests"] = {
         [1] = 1644;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1784] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1785;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Retrieve a Dark Iron Script from the Dark Iron dwarves near Helm's Bed, and return to Muiredon Battleforge in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1783;
      ["prequests"] = {
         [1] = 1783;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1788] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1787;
      ["prequests"] = {
         [1] = 1787;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [7166] = {
      ["name_ru"] = "Легендарные герои";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Legendare Helden";
      ["name_fr"] = "Heros de legende";
      ["name_cn"] = "??的英雄";
      ["name"] = "Legendary Heroes";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17908;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7165;
      ["prequests"] = {
         [1] = 7165;
      };
      ["level"] = 60;
      ["name_es"] = "Heroes legendarios";
      ["req"] = 51;
   };
   [1796] = {
      ["name_ru"] = "Материалы для зачарованного золотого кровавого одеяния";
      ["type"] = "Solo";
      ["objective"] = "Bring Robes of the Arcana to Menara Voidrender in the Barrens.";
      ["next"] = 4781;
      ["name_fr"] = "Les composants de la robe sanglante doree enchantee";
      ["sort"] = "Warlock";
      ["name_cn"] = "魔化金?血袍";
      ["series"] = 1;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Komponenten fur die verzauberte Goldblutrobe";
      ["faction"] = "Horde";
      ["name"] = "Components for the Enchanted Gold Bloodrobe";
      ["level"] = 31;
      ["name_es"] = "Los componentes para la toga de sangre dorada encantada";
      ["req"] = 31;
   };
   [1800] = {
      ["name_ru"] = "Тронный зал Лордерона";
      ["type"] = "Solo";
      ["name_fr"] = "La salle du trone de Lordaeron";
      ["name_de"] = "Der Thronsaal von Lordaeron";
      ["objective"] = "Take your ward to the old Lordaeron Throne Room that lies just before descending into the Undercity.$B";
      ["name_cn"] = "洛丹?的王座";
      ["sort"] = "Children's Week";
      ["faction"] = "Horde";
      ["name"] = "Lordaeron Throne Room";
      ["followup"] = 915;
      ["prev"] = 172;
      ["prequests"] = {
         [1] = 172;
      };
      ["level"] = 60;
      ["name_es"] = "Sala del Trono de Lordaeron";
      ["req"] = 10;
   };
   [1804] = {
      ["name_ru"] = "Фолиант заговора";
      ["objective"] = "Bring the Reconstructed Tome and 3 Rods of Channeling to Strahad Farsan in Ratchet.";
      ["name_cn"] = "??之?";
      ["sort"] = "Warlock";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Tome de la Cabale";
      ["next"] = 1795;
      ["name_de"] = "Foliant der Kabale";
      ["followup"] = 1795;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Tome of the Cabal";
      ["prev"] = 1802;
      ["prequests"] = {
         [1] = 1802;
      };
      ["series"] = 3;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [6762] = {
      ["name_ru"] = "Рабин Сатурна";
      ["objective"] = "Speak with Rabine Saturna in the village of Nighthaven, Moonglade.  Moonglade lies between Felwood and Winterspring, accessible through a path out of Timbermaw Hold.";
      ["name_cn"] = "拉比恩・???";
      ["sort"] = "Darnassus";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "Rabine Saturna";
      ["next"] = 1124;
      ["name_de"] = "Rabine Saturna";
      ["repgain"] = {
         [609] = 25;
      };
      ["followup"] = 1124;
      ["name"] = "Rabine Saturna";
      ["prev"] = 6761;
      ["prequests"] = {
         [1] = 6761;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Rabine Saturna";
      ["req"] = 54;
   };
   [8290] = {
      ["name_ru"] = "Долой захватчиков";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["repgain"] = {
         [890] = 500;
      };
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者！ (PvP)";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Horde";
      ["name"] = "Vanquish the Invaders";
      ["level"] = 15;
      ["name_es"] = "Expulsa al invasor";
      ["req"] = 10;
   };
   [4494] = {
      ["name_ru"] = "Нашествие силитидов";
      ["type"] = "Solo";
      ["objective"] = "Speak to Alchemist Pestlezugg in Gadgetzan.";
      ["next"] = 4496;
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "??蝎的?征";
      ["name_fr"] = "La marche des silithides";
      ["name_de"] = "Der Marsch der Silithiden";
      ["faction"] = "Horde";
      ["name"] = "March of the Silithid";
      ["level"] = 53;
      ["name_es"] = "La marcha de los silitidos";
      ["req"] = 50;
   };
   [1820] = {
      ["name_ru"] = "Разговор с Колманом";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Coleman";
      ["next"] = 1821;
      ["name_de"] = "Gesprach mit Coleman";
      ["objective"] = "Speak with Coleman Farthing.";
      ["name_cn"] = "?勒曼";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Speak with Coleman";
      ["prev"] = 1819;
      ["prequests"] = {
         [1] = 1819;
      };
      ["level"] = 10;
      ["name_es"] = "Habla con Coleman";
      ["req"] = 10;
   };
   [1824] = {
      ["name_ru"] = "Испытание на Полях Великанов";
      ["objective"] = "Bring 5 twitching antennae to Ruga Ragetotem at Camp Taurajo";
      ["name_cn"] = "巨人?野的??";
      ["sort"] = "Warrior";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve du Champ des geants";
      ["next"] = 1825;
      ["name_de"] = "Prufung auf dem Feld der Riesen";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7120;
      };
      ["name"] = "Trial at the Field of Giants";
      ["prev"] = 1823;
      ["prequests"] = {
         [1] = 1823;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Prueba en Tierra de Gigantes";
      ["req"] = 20;
   };
   [3085] = {
      ["name_ru"] = "Освященная табличка";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette benie";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Geheiligte Schrifttafel";
      ["objective"] = "Read the Hallowed Tablet and speak to Ken'jai outside the Den in the Valley of Trials.";
      ["name_cn"] = "神?石板";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Hallowed Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Tablilla sacralizada";
      ["req"] = 1;
   };
   [1138] = {
      ["name_ru"] = "Дары моря";
      ["type"] = "Solo";
      ["objective"] = "Collect 6 Fine Crab Chunks for Gubber Blump in Auberdine.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "Fruit de la mer";
      ["name_cn"] = "海中的水果";
      ["reward"] = {
         [1] = 15405;
         [2] = 15406;
      };
      ["name_de"] = "Meeresfruchte";
      ["faction"] = "Alliance";
      ["name"] = "Fruit of the Sea";
      ["level"] = 17;
      ["name_es"] = "Rico marisco";
      ["req"] = 15;
   };
   [7342] = {
      ["name_ru"] = "Стрелы ? для неженок!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ironforge";
      ["name_fr"] = "Les fleches, c'est pour les mauviettes";
      ["name_cn"] = "胆小鬼才用弓箭！";
      ["reward"] = {
         [1] = 18042;
      };
      ["name_de"] = "Pfeile sind was fur Memmen";
      ["faction"] = "Alliance";
      ["name"] = "Arrows Are For Sissies";
      ["level"] = 60;
      ["name_es"] = "Las flechas no valen para nada";
      ["req"] = 52;
   };
   [1840] = {
      ["name_ru"] = "Орм Каменное Копыто и шлем Жестокости";
      ["type"] = "Solo";
      ["name_fr"] = "Orm Sabot-de-pierre et le Camail de brutalite";
      ["next"] = 1844;
      ["name_de"] = "Orm Steinhuf und der brutale Helm";
      ["objective"] = "Speak with Orm Stonehoof in Thunder Bluff.";
      ["name_cn"] = "奥姆・石蹄和野蛮??";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Orm Stonehoof and the Brutal Helm";
      ["prev"] = 1838;
      ["prequests"] = {
         [1] = 1838;
      };
      ["level"] = 30;
      ["name_es"] = "Orm Pezuna Petrea y el yelmo brutal";
      ["req"] = 20;
   };
   [1844] = {
      ["name_ru"] = "Рог химеры";
      ["type"] = "Solo";
      ["name_fr"] = "La corne de chimere";
      ["name_de"] = "Schimarenhorn";
      ["objective"] = "Bring a Galvanized Horn to Orm Stonehoof in Thunder Bluff.";
      ["name_cn"] = "奇美拉之角";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Chimaeric Horn";
      ["prev"] = 1840;
      ["prequests"] = {
         [1] = 1840;
      };
      ["level"] = 30;
      ["name_es"] = "Cuerno de quimera";
      ["req"] = 20;
   };
   [1848] = {
      ["name_ru"] = "Хауберк жестокости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Brutale Halsberge";
      ["name_fr"] = "Le haubert de brutalite";
      ["name"] = "Brutal Hauberk";
      ["name_cn"] = "野蛮?甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7133;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1838;
      ["prequests"] = {
         [1] = 1838;
      };
      ["level"] = 30;
      ["name_es"] = "Camisote brutal";
      ["req"] = 20;
   };
   [6862] = {
      ["name_ru"] = "Портативный крошшер Зинфиззлекса";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["name_fr"] = "Le Dechiqueteur portable de Zinfizzlex";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "斯菲莱克斯的可携式伐木机";
      ["reward"] = {
         [1] = 17410;
      };
      ["name_de"] = "Zinnzischelix's tragbare Schreddereinheit";
      ["faction"] = "Alliance";
      ["name"] = "Zinfizzlex's Portable Shredder Unit";
      ["level"] = 60;
      ["name_es"] = "La unidad trituradora portatil de Zinfizzlex";
      ["req"] = 51;
   };
   [7422] = {
      ["name_ru"] = "Хоть шерсти клок...";
      ["type"] = "PvP";
      ["objective"] = "";
      ["name_cn"] = "踏平侏儒";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Mehr Gnomhaar";
      ["faction"] = "Horde";
      ["name"] = "Tuft it Out";
      ["level"] = 60;
      ["name_es"] = "Ve a por mas mechones";
      ["req"] = 55;
   };
   [1860] = {
      ["name_ru"] = "Поговорите с Джиннией";
      ["type"] = "Solo";
      ["objective"] = "Speak with Jennea Cannon in Stormwind.";
      ["next"] = 1861;
      ["name_de"] = "Gesprach mit Jennea";
      ["sort"] = "Mage";
      ["name_cn"] = "和詹??交?";
      ["name_fr"] = "Parler a Jennea";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Speak with Jennea";
      ["level"] = 10;
      ["name_es"] = "Habla con Jennea";
      ["req"] = 10;
   };
   [5726] = {
      ["name_ru"] = "Тайные враги";
      ["type"] = "Solo";
      ["name_fr"] = "Ennemis caches";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Verborgene Feinde";
      ["name_cn"] = "?藏的?人";
      ["objective"] = "Bring a Lieutenant's Insignia to Thrall in Orgrimmar.";
      ["next"] = 5727;
      ["sort"] = "Orgrimmar";
      ["name"] = "Hidden Enemies";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 12;
      ["name_es"] = "Enemigos ocultos";
      ["req"] = 9;
   };
   [1046] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["objective"] = "Bring Ran Bloodtooth's Skull and Dartol's Rod of Transformation to Raene Wolfrunner in Astranaar.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Die wahre Macht der Rute";
      ["reward"] = {
         [1] = 5815;
         [2] = 1116;
         [3] = 17046;
      };
      ["name_cn"] = "莱恩的?化";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["faction"] = "Alliance";
      ["name"] = "Raene's Cleansing";
      ["sort"] = "Ashenvale";
      ["prev"] = 1045;
      ["prequests"] = {
         [1] = 1045;
      };
      ["level"] = 30;
      ["name_es"] = "El verdadero poder de la vara";
      ["req"] = 18;
   };
   [7486] = {
      ["name_ru"] = "Награда для героя";
      ["type"] = "Solo";
      ["objective"] = "Claim your reward from Hydraxis' Coffer.";
      ["repgain"] = {
         [749] = 200;
      };
      ["name_de"] = "Die Belohnung eines Helden";
      ["reward"] = {
         [1] = 18399;
         [2] = 18398;
      };
      ["name_cn"] = "英雄的??";
      ["name_fr"] = "La recompense du heros";
      ["faction"] = "Horde";
      ["name"] = "A Hero's Reward";
      ["sort"] = "Azshara";
      ["prev"] = 6824;
      ["prequests"] = {
         [1] = 6824;
      };
      ["level"] = 60;
      ["name_es"] = "Una recompensa de heroe";
      ["req"] = 60;
   };
   [7502] = {
      ["name_ru"] = "Укрощая тени";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Controler les ombres";
      ["name_cn"] = "束?之影";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 18467;
      };
      ["name_de"] = "Schatten einspannen";
      ["faction"] = "Horde";
      ["name"] = "Harnessing Shadows";
      ["level"] = 60;
      ["name_es"] = "Sombras acechadoras";
      ["req"] = 54;
   };
   [1880] = {
      ["name_ru"] = "Маг-тастический гизмонитор";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bidulotron de youplala";
      ["name_de"] = "Magitastischer Gizmonitor";
      ["sort"] = "Mage";
      ["objective"] = "Bring Bink her Mage-tastic Gizmonitor.";
      ["name_cn"] = "法?文档存?器";
      ["name"] = "Mage-tastic Gizmonitor";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7507;
         [2] = 9514;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1879;
      ["prequests"] = {
         [1] = 1879;
      };
      ["level"] = 10;
      ["name_es"] = "Trastonitor maguitronic";
      ["req"] = 10;
   };
   [1884] = {
      ["name_ru"] = "Груды джуджу";
      ["type"] = "Solo";
      ["name_fr"] = "Les Tas de Ju-Ju";
      ["name_de"] = "Jujuhaufen";
      ["sort"] = "Mage";
      ["objective"] = "Destroy 4 Ju-Ju Heaps, then return to Un'thuwa in Sen'jin Village.";
      ["name_cn"] = "魂能骨堆";
      ["name"] = "Ju-Ju Heaps";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7508;
         [2] = 9513;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1883;
      ["prequests"] = {
         [1] = 1883;
      };
      ["level"] = 10;
      ["name_es"] = "Montones de Ju-Ju";
      ["req"] = 10;
   };
   [4511] = {
      ["name_ru"] = "Затишье перед бурей";
      ["objective"] = "Bring the Bank Voucher to Karus in the bank of Orgrimmar.";
      ["name_cn"] = "?危不惧";
      ["sort"] = "Orgrimmar";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Le calme avant la tempete";
      ["repgain"] = {
         [76] = 500;
         [68] = 500;
         [81] = 500;
         [530] = 500;
      };
      ["name_de"] = "Die Ruhe vor dem Sturm";
      ["reward"] = {
         [1] = 11870;
         [2] = 11871;
         [3] = 11872;
      };
      ["faction"] = "Horde";
      ["name"] = "Calm Before the Storm";
      ["prev"] = 4509;
      ["prequests"] = {
         [1] = 4509;
      };
      ["series"] = 2;
      ["name_es"] = "La calma que precede a la tormenta";
      ["req"] = 50;
   };
   [5511] = {
      ["name_ru"] = "Ключ от Некроситета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Schlussel zur Scholomance";
      ["name_fr"] = "La cle de Scholomance";
      ["name_cn"] = "通?学院的?匙";
      ["name"] = "The Key to Scholomance";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 13704;
      };
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5804;
      ["prequests"] = {
         [1] = 5804;
      };
      ["level"] = 60;
      ["name_es"] = "La llave de Scholomance";
      ["req"] = 55;
   };
   [7582] = {
      ["name_ru"] = "Тюремная камера";
      ["type"] = "Group";
      ["objective"] = "Travel to Darkwhisper Gorge in Winterspring and recover 5 Tears of the Hederine from the Hederine demons that occupy the gorge. Return to Daio in the Tainted Scar when you have completed this task.";
      ["next"] = 7583;
      ["sort"] = "Warlock";
      ["name_cn"] = "?牢之壁";
      ["name_fr"] = "Les parois de la prison";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 7583;
      ["name_de"] = "Die Gefangnishulle";
      ["faction"] = "Horde";
      ["name"] = "The Prison's Casing";
      ["level"] = 60;
      ["name_es"] = "El revestimiento de la prision";
      ["req"] = 60;
   };
   [8309] = {
      ["name_ru"] = "Поиски рун";
      ["type"] = "Group";
      ["name_fr"] = "A la poursuite des glyphes";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Glyphenjagd";
      ["followup"] = 8314;
      ["name_cn"] = "追?雕文";
      ["objective"] = "Rutgar Glyphshaper at Bronzebeard's Encampment in Silithus wants you to venture to Hive'Ashi, Hive'Zora, and Hive'Regal and recover Glyphed Rubbings from the Glyphed Crystals of each hive.$B$BUse the Geologist's Transcription Kit to make a reasonable facsimile of the ancient glyphs. Return to Rutgar Glyphshaper when you complete this task.";
      ["faction"] = "Horde";
      ["name"] = "Glyph Chasing";
      ["sort"] = "Silithus";
      ["prev"] = 8304;
      ["prequests"] = {
         [1] = 8304;
      };
      ["level"] = 60;
      ["name_es"] = "Los grabados de los glifos";
      ["req"] = 58;
   };
   [5046] = {
      ["name_ru"] = "Иглошкура";
      ["type"] = "Solo";
      ["name_fr"] = "Peau tranchante";
      ["sort"] = "The Barrens";
      ["name_cn"] = "野猪之皮";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Razorhide";
      ["name_de"] = "Klingenhaut";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "Ocultafilo";
      ["req"] = 14;
   };
   [7630] = {
      ["name_ru"] = "Арканит";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Arcanite Bar to Gorzeeki in the Burning Steppes.";
      ["name_fr"] = "L'arcanite";
      ["sort"] = "Warlock";
      ["name_cn"] = "奥金?";
      ["name"] = "Arcanite";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 7631;
      ["name_de"] = "Arkanit";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7626;
         [2] = 7627;
         [3] = 7628;
      };
      ["level"] = 60;
      ["name_es"] = "La arcanita";
      ["req"] = 60;
   };
   [7646] = {
      ["name_ru"] = "Магический кристалл";
      ["objective"] = "Bring an Azerothian Diamond and a Pristine Black Diamond to Lord Grayson Shadowbreaker in the Cathedral District of Stormwind.";
      ["name_cn"] = "?言水晶球";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Le Clairvoyant";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Das Orakel der Anrufung";
      ["next"] = 7647;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Divination Scryer";
      ["prev"] = 7644;
      ["prequests"] = {
         [1] = 7644;
      };
      ["followup"] = 7647;
      ["name_es"] = "El cristal de adivinacion";
      ["req"] = 60;
   };
   [7662] = {
      ["name_ru"] = "Новый кодо ? бирюзовый";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Un nouveau kodo bleu";
      ["name_cn"] = "?色科多?";
      ["reward"] = {
         [1] = 18794;
         [2] = 18795;
         [3] = 18793;
      };
      ["name_de"] = "Neuer Kodo - Graublauer";
      ["faction"] = "Horde";
      ["name"] = "New Kodo - Teal";
      ["level"] = 1;
      ["name_es"] = "Nuevo kodo: cerceta";
      ["req"] = 60;
   };
   [7678] = {
      ["name_ru"] = "Игреневый конь";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Elwynn Forest";
      ["name_fr"] = "Echange de palomino";
      ["name_cn"] = "更?褐色?";
      ["reward"] = {
         [1] = 18777;
         [2] = 18776;
         [3] = 18778;
      };
      ["name_de"] = "Austausch Eures Palominos";
      ["faction"] = "Alliance";
      ["name"] = "Palomino Exchange";
      ["level"] = 1;
      ["name_es"] = "Intercambio de palomino";
      ["req"] = 60;
   };
   [8589] = {
      ["name_ru"] = "Орде все еще не хватает толстой кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Heavy Leather to Skinner Jamani at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr schweres Leder!";
      ["name_fr"] = "La Horde a besoin de plus de cuir lourd?!";
      ["name_cn"] = "部落需要更多重皮！";
      ["name"] = "The Horde Needs More Heavy Leather!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21511;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8588;
      ["prequests"] = {
         [1] = 8588;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas cuero pesado!";
      ["req"] = 1;
   };
   [2947] = {
      ["name_ru"] = "Возвращение кольца";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le retour de l'anneau";
      ["next"] = 2948;
      ["name_de"] = "Die Ruckkehr des Rings";
      ["name_cn"] = "戒指?来";
      ["objective"] = " or perhaps the initials of the ring's crafter.  Keep the ring... or return it to this person.  Decisions";
      ["sort"] = "Gnomeregan";
      ["faction"] = "Alliance";
      ["name"] = "Return of the Ring";
      ["prev"] = 2945;
      ["prequests"] = {
         [1] = 2945;
      };
      ["level"] = 34;
      ["name_es"] = "La devolucion del anillo";
      ["req"] = 28;
   };
   [7726] = {
      ["name_ru"] = "Новая энергия для уменьшения";
      ["type"] = "Solo";
      ["name_fr"] = "Encore du carburant pour la zappette";
      ["repgain"] = {
         [21] = 25;
         [369] = 25;
         [577] = 25;
         [470] = 25;
      };
      ["name_de"] = "Neuer Treibstoff furs Schrumpfen";
      ["name_cn"] = "?充?力";
      ["name"] = "Refuel for the Zapping";
      ["objective"] = "Collect 6 Water Elemental Cores from the Sea Elementals and Sea Sprays along the Forgotten Coast of Feralas, and bring them back to Zorbin Fandazzle who is near the dock there.";
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 7721;
      ["prequests"] = {
         [1] = 7721;
      };
      ["level"] = 55;
      ["name_es"] = "Mas combustible para el Ultra-reductor";
      ["req"] = 45;
   };
   [7122] = {
      ["name_ru"] = "Захват рудника";
      ["type"] = "PvP";
      ["objective"] = "Capture a mine that the Stormpike does not control, then return to Sergeant Durgen Stormpike in the Alterac Mountains.";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_fr"] = "Prendre une mine";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "占??洞";
      ["name_de"] = "Eine Mine erobern";
      ["faction"] = "Alliance";
      ["name"] = "Capture a Mine";
      ["level"] = 60;
      ["name_es"] = "Capturar una mina";
      ["req"] = 51;
   };
   [1940] = {
      ["name_ru"] = "Безупречная паутина";
      ["type"] = "Solo";
      ["name_fr"] = "Soie d'araignee en parfait etat";
      ["name_de"] = "Makellose Spinnenseide";
      ["objective"] = "Bring 8 Pristine Spider Silk to Wynne Larson in Stormwind.";
      ["sort"] = "Mage";
      ["name_cn"] = "新?的蜘蛛?";
      ["name"] = "Pristine Spider Silk";
      ["classes"] = {
         [1] = "Mage";
      };
      ["followup"] = 1942;
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1938;
      ["prequests"] = {
         [1] = 1938;
      };
      ["level"] = 26;
      ["name_es"] = "Seda pristina de arana";
      ["req"] = 26;
   };
   [1944] = {
      ["name_ru"] = "Воды Ксавиана";
      ["type"] = "Solo";
      ["name_fr"] = "Les Eaux de Xavian";
      ["next"] = 1945;
      ["name_de"] = "Wasser von Xavian";
      ["objective"] = "Bring the Xavian Water Sample to Deino in Orgrimmar.";
      ["name_cn"] = "克???之水";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Waters of Xavian";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1943;
      ["prequests"] = {
         [1] = 1943;
      };
      ["level"] = 26;
      ["name_es"] = "Aguas de Xavian";
      ["req"] = 26;
   };
   [1948] = {
      ["name_ru"] = "Волшебные предметы";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Jade and the Bolt Charged Bramble to Tabetha in Dustwallow Marsh.";
      ["sort"] = "Mage";
      ["name_cn"] = "?大的物品";
      ["name_fr"] = "Les Objets de Puissance";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Gegenstande der Macht";
      ["faction"] = "Horde";
      ["name"] = "Items of Power";
      ["level"] = 40;
      ["name_es"] = "Objetos de poder";
      ["req"] = 30;
   };
   [7806] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 7805;
      ["prequests"] = {
         [1] = 7805;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [7822] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 150;
      };
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7823;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [7838] = {
      ["name_ru"] = "Великий повелитель арены";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Grosmeister der Arena";
      ["name_fr"] = "Grand maitre de l'arene";
      ["name_cn"] = "?技?大?";
      ["name"] = "Arena Grandmaster";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 19024;
      };
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 7810;
      ["prequests"] = {
         [1] = 7810;
      };
      ["level"] = 55;
      ["name_es"] = "El maestro mayor de la arena";
      ["req"] = 1;
   };
   [9186] = {
      ["name_ru"] = "Задание мастера: гибельный кожаный пояс";
      ["type"] = "Solo";
      ["objective"] = "Deliver 9 Wicked Leather Belts and the Craftsman's Writ - Wicked Leather Belt - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Ceintures corrompues en cui";
      ["name_cn"] = "工匠文? - 邪?皮甲腰?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Tuckischer Ledergurtel";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Wicked Leather Belt";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: cinturon de cuero maligno";
      ["req"] = 55;
   };
   [6384] = {
      ["name_ru"] = "Дорога до Оргриммара";
      ["type"] = "Solo";
      ["name_fr"] = "Trajet vers Orgrimmar";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_de"] = "Flug nach Orgrimmar";
      ["objective"] = "Buy a wind rider to Orgrimmar from the wind rider master Devrak, then bring Zargh's Meats to Gryshka in Orgrimmar.";
      ["name_cn"] = "?往奥格瑞?";
      ["next"] = 6385;
      ["sort"] = "The Barrens";
      ["name"] = "Ride to Orgrimmar";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["prev"] = 6365;
      ["prequests"] = {
         [1] = 6365;
      };
      ["level"] = 10;
      ["name_es"] = "Un viaje a Orgrimmar";
      ["req"] = 10;
   };
   [7886] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["name_fr"] = "Talismans de vaillance";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["objective"] = "You obtained a Silverwing Talisman of Merit for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Alliance";
      ["name"] = "Talismans of Merit";
      ["name_de"] = "Verdienstabzeichen";
      ["prev"] = 7873;
      ["prequests"] = {
         [1] = 7873;
      };
      ["level"] = 55;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 50;
   };
   [7902] = {
      ["name_ru"] = "Радужные перья";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Plumes vibrantes";
      ["name_cn"] = "??的羽毛";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Farbenprachtige Federbusche";
      ["faction"] = "Horde";
      ["name"] = "Vibrant Plumes";
      ["level"] = 60;
      ["name_es"] = "Pendolas vibrantes";
      ["req"] = 30;
   };
   [7222] = {
      ["name_ru"] = "Разговор с Воггой Смертобоем";
      ["type"] = "PvP";
      ["objective"] = "Speak with Voggah in Frostwolf Keep.";
      ["next"] = 7142;
      ["name_cn"] = "沃加・死爪";
      ["sort"] = "Alterac Valley";
      ["followup"] = 7142;
      ["name_de"] = "Sprecht mit Voggah Todesgriff";
      ["faction"] = "Horde";
      ["name"] = "Speak with Voggah Deathgrip";
      ["level"] = 60;
      ["name_es"] = "Habla con Voggah Agarre Letal";
      ["req"] = 51;
   };
   [7934] = {
      ["name_ru"] = "50 купонов ? ящик Новолуния";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "50 bons - Boite de rangement de Sombrelune";
      ["name_cn"] = "50??券 - 暗月?物箱";
      ["reward"] = {
         [1] = 19291;
      };
      ["name_de"] = "50 Lose - Dunkelmond-Lagerbehalter";
      ["faction"] = "Horde";
      ["name"] = "50 Tickets - Darkmoon Storage Box";
      ["level"] = 60;
      ["name_es"] = "50 vales: caja de almacenamiento de la Luna Negra";
      ["req"] = 6;
   };
   [5462] = {
      ["name_ru"] = "Рас Ледяной Шепот ? гибель";
      ["type"] = "Group";
      ["name_fr"] = "Le moribond, Ras Murmegivre";
      ["next"] = 5463;
      ["name_de"] = "Der Sterbende Ras Frostraunen";
      ["name_cn"] = "亡?莱斯・霜?";
      ["objective"] = "Travel to Light's Hope in Eastern Plaguelands and seek out Leonid Barthalomew the Revered. Show him the Keepsake of Remembrance and tell him all that you have discovered.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "The Dying, Ras Frostwhisper";
      ["prev"] = 5461;
      ["prequests"] = {
         [1] = 5461;
      };
      ["level"] = 60;
      ["name_es"] = "El moribundo, Ras Murmuhielo";
      ["req"] = 57;
   };
   [6462] = {
      ["name_ru"] = "Оберег троллей";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Troll Charms to Mitsuwa at the Zoram'gar Outpost.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Charme troll";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "巨魔符咒";
      ["name_de"] = "Trollglucksbringer";
      ["faction"] = "Horde";
      ["name"] = "Troll Charm";
      ["level"] = 24;
      ["name_es"] = "El talisman trol";
      ["req"] = 19;
   };
   [5527] = {
      ["name_ru"] = "Реликварий Чистоты";
      ["type"] = "Solo";
      ["objective"] = "Travel to Silithus and search for a Reliquary of Purity within the ruins of Southwind Village.  If you are able to find it, return with it to Rabine Saturna in Nighthaven, Moonglade.";
      ["next"] = 5526;
      ["name_fr"] = "Un reliquaire de purete";
      ["sort"] = "Moonglade";
      ["name_cn"] = "?化之匣";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Ein Reliquiar der Reinheit";
      ["faction"] = "Horde";
      ["name"] = "A Reliquary of Purity";
      ["level"] = 60;
      ["name_es"] = "Un relicario de Pureza";
      ["req"] = 56;
   };
   [3681] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["objective"] = "Speak with Duthorian Rall in Stormwind.";
      ["next"] = 1641;
      ["name_de"] = "Foliant der Offenbarung";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["name_fr"] = "Le Tome de divinite";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
      };
      ["name"] = "Tome of Divinity";
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [5930] = {
      ["name_ru"] = "Дух Великого Медведя";
      ["objective"] = "Seek out the Great Bear Spirit in northwestern Moonglade and learn what it has to share with you about the nature of the bear.  When finished, return to Dendrite Starblaze in Nighthaven, Moonglade.";
      ["name_cn"] = "巨熊之?";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Esprit du Grand ours";
      ["repgain"] = {
         [609] = 50;
      };
      ["name_de"] = "Groser Barengeist";
      ["next"] = 5932;
      ["classes"] = {
         [1] = "Druid";
      };
      ["sort"] = "Druid";
      ["name"] = "Great Bear Spirit";
      ["prev"] = 5922;
      ["prequests"] = {
         [1] = 5922;
      };
      ["followup"] = 5932;
      ["name_es"] = "Espiritu del gran oso";
      ["req"] = 10;
   };
   [7441] = {
      ["name_ru"] = "Пузиллин и старейшина Аж'Тордин";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Dire Maul and locate the Imp, Pusillin. Convince Pusillin to give you Azj'Tordin's Book of Incantations through any means necessary.$B$BReturn to Azj'Tordin at the Lariss Pavilion in Feralas should you recover the Book of Incantations.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Pusillin et l'Ancien Azj'Tordin";
      ["name_cn"] = "普希林和埃斯托?迪";
      ["reward"] = {
         [1] = 18411;
         [2] = 18410;
      };
      ["name_de"] = "Pusillin und der Alteste Azj'Tordin";
      ["faction"] = "Horde";
      ["name"] = "Pusillin and the Elder Azj'Tordin";
      ["level"] = 58;
      ["name_es"] = "Pusillin y el ancestro Azj'Tordin";
      ["req"] = 54;
   };
   [8046] = {
      ["name_ru"] = "Клеймо Язычника";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Das Emblem des Unglaubigen";
      ["name_fr"] = "La marque du paien";
      ["name"] = "The Heathen's Brand";
      ["name_cn"] = "?教徒的烙印";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19585;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8045;
      ["prequests"] = {
         [1] = 8045;
      };
      ["level"] = 60;
      ["name_es"] = "La Ensena del pagano";
      ["req"] = 60;
   };
   [8062] = {
      ["name_ru"] = "Знаки Силы: наручи хищника";
      ["type"] = "Raid";
      ["objective"] = "Bring the following Paragons of Power from Zul'Gurub to Falthir the Sightless: A Primal Hakkari Bindings.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BFalthir the Sightless is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les brassards de predateur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：捕?者?腕";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19833;
      };
      ["name_de"] = "Symbole der Macht: Die Armschienen des Raubtiers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Predator's Bracers";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazales de depredador";
      ["req"] = 60;
   };
   [8078] = {
      ["name_ru"] = "Знаки Силы: пояс воздаятеля";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker a Primal Hakkari Girdle.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance : la ceinture de redresseur de torts";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：??者腰?";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19823;
      };
      ["name_de"] = "Symbole der Macht: Der Gurtel des Vollstreckers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Vindicator's Belt";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Cinturon de vindicador";
      ["req"] = 60;
   };
   [8600] = {
      ["name_ru"] = "Орде нужна грубая кожа!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Rugged Leather to Doctor Serratus at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de cuir robuste !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要硬甲皮!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["name_de"] = "Die Horde braucht unverwustliches Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Rugged Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita pieles de cuero basto!";
      ["req"] = 55;
   };
   [8110] = {
      ["name_ru"] = "Зачарованные водоросли Южных морей";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le varech enchante des Mers du sud";
      ["name_cn"] = "南海魔化海藻";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19610;
      };
      ["name_de"] = "Verzauberter Sudmeertang";
      ["faction"] = "Horde";
      ["name"] = "Enchanted South Seas Kelp";
      ["level"] = 60;
      ["name_es"] = "Algas de los Mares del Sur encantadas";
      ["req"] = 60;
   };
   [4146] = {
      ["name_ru"] = "Питание для шокера";
      ["type"] = "Group";
      ["name_fr"] = "Carburant de baguette";
      ["name_de"] = "Treibstoff fur die Unkrautvernichtung";
      ["name_cn"] = "除草器的燃料";
      ["objective"] = "Deliver the Unloaded Zapper and 5 samples of Atal'ai Haze to Larion in Marshal's Refuge.";
      ["sort"] = "Sunken Temple";
      ["faction"] = "Horde";
      ["name"] = "Zapper Fuel";
      ["prev"] = 4147;
      ["prequests"] = {
         [1] = 4147;
      };
      ["level"] = 52;
      ["name_es"] = "Combustible de irradior";
      ["req"] = 47;
   };
   [8142] = {
      ["name_ru"] = "Зандаларский талисман Тени";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Zandalarischattentalisman";
      ["name_fr"] = "Talisman d'ombre zandalarien";
      ["name"] = "Zandalrian Shadow Talisman";
      ["name_cn"] = "??拉暗影??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19615;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8141;
      ["prequests"] = {
         [1] = 8141;
      };
      ["level"] = 60;
      ["name_es"] = "Dije Zandalar de las Sombras";
      ["req"] = 60;
   };
   [2040] = {
      ["name_ru"] = "Битва под землей";
      ["type"] = "Dungeon";
      ["objective"] = "Retrieve the Gnoam Sprecklesprocket from the Deadmines and return it to Shoni the Shilent in Stormwind.";
      ["repgain"] = {
         [469] = 500;
      };
      ["sort"] = "The Deadmines";
      ["name_fr"] = "Assaut souterrain";
      ["name_cn"] = "地底突?";
      ["reward"] = {
         [1] = 7606;
         [2] = 7607;
      };
      ["name_de"] = "Unterirdischer Angriff";
      ["faction"] = "Alliance";
      ["name"] = "Underground Assault";
      ["level"] = 20;
      ["name_es"] = "Asalto subterraneo";
      ["req"] = 15;
   };
   [6146] = {
      ["name_ru"] = "Уловка Натаноса";
      ["type"] = "Group";
      ["name_fr"] = "La ruse de Nathanos";
      ["next"] = 6147;
      ["name_de"] = "Nathanos' List";
      ["name_cn"] = "???斯的??";
      ["objective"] = "Travel to Tyr's Hand, southeast of the Marris Stead. Once there, take a bite of the Rotten Apple. While under the guise of the Scarlet Crusade, deliver the Grand Crusader's Command to Crusader Lord Valdelmar.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Nathanos' Ruse";
      ["prev"] = 6145;
      ["prequests"] = {
         [1] = 6145;
      };
      ["level"] = 60;
      ["name_es"] = "La estratagema de Nathanos";
      ["req"] = 56;
   };
   [8190] = {
      ["name_ru"] = "Наговор худу";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Le malefice porte-guigne";
      ["name_cn"] = "不祥的妖?";
      ["reward"] = {
         [1] = 19788;
      };
      ["name_de"] = "Verhexung des Hoodoo";
      ["faction"] = "Horde";
      ["name"] = "Hoodoo Hex";
      ["level"] = 60;
      ["name_es"] = "Maleficio hudu";
      ["req"] = 58;
   };
   [4111] = {
      ["name_ru"] = "Лекарство из оскверненных шкур";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Kurschnerei";
      ["name_fr"] = "Du baume contre des peaux";
      ["name_cn"] = "剥皮??膏";
      ["name"] = "Salve via Skinning";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4106;
      ["prequests"] = {
         [1] = 4106;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desuello";
      ["req"] = 48;
   };
   [8252] = {
      ["name_ru"] = "Кораллы сирен";
      ["type"] = "Solo";
      ["name_fr"] = "Le corail des sirenes";
      ["next"] = 8253;
      ["name_de"] = "Die Koralle der Sirenen";
      ["objective"] = "Collect 6 Enchanted Coral and return them to Archmage Xylem.";
      ["name_cn"] = "?迦的珊瑚";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "The Siren's Coral";
      ["prev"] = 8251;
      ["prequests"] = {
         [1] = 8251;
      };
      ["level"] = 52;
      ["name_es"] = "El coral de las sirenas";
      ["req"] = 50;
   };
   [4143] = {
      ["name_ru"] = "Туман зла";
      ["type"] = "Dungeon";
      ["name_fr"] = "Brouillard malefique";
      ["name_de"] = "Der Dunst des Bosen";
      ["name_cn"] = "邪?之?";
      ["objective"] = "Collect 5 samples of Atal'ai Haze, then return to Muigin in Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Alliance";
      ["name"] = "Haze of Evil";
      ["prev"] = 4142;
      ["prequests"] = {
         [1] = 4142;
      };
      ["level"] = 52;
      ["name_es"] = "Bruma del mal";
      ["req"] = 47;
   };
   [8316] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??物?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20699;
         [2] = 20710;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [8348] = {
      ["name_ru"] = "Перстень герцогов";
      ["type"] = "Group";
      ["objective"] = "Bring the Abyssal Signet to Bor Wildmane in Cenarion Hold.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_de"] = "Siegel der Fursten";
      ["reward"] = {
         [1] = 20601;
      };
      ["name_cn"] = "公爵的徽?";
      ["name_fr"] = "La chevaliere des ducs";
      ["faction"] = "Horde";
      ["name"] = "Signet of the Dukes";
      ["sort"] = "Silithus";
      ["prev"] = 8349;
      ["prequests"] = {
         [1] = 8349;
      };
      ["level"] = 60;
      ["name_es"] = "Sellos de los Duques";
      ["req"] = 60;
   };
   [8380] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??物?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20701;
         [2] = 20712;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [8412] = {
      ["name_ru"] = "Тотем духов";
      ["type"] = "Solo";
      ["name_fr"] = "Le totem des esprits";
      ["name_de"] = "Geistertotem";
      ["objective"] = "Bring the pieces for the spirit totem to Bath'rah the Windwatcher.";
      ["name_cn"] = "?魂??";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Spirit Totem";
      ["prev"] = 8410;
      ["prequests"] = {
         [1] = 8410;
      };
      ["level"] = 52;
      ["name_es"] = "Totem de espiritu";
      ["req"] = 50;
   };
   [4223] = {
      ["name_ru"] = "Подлинные хозяева";
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4224;
      ["name_de"] = "Die wahren Meister";
      ["name"] = "The True Masters";
      ["name_cn"] = "真正的主人";
      ["objective"] = "Speak with Marshal Maxwell in the Burning Steppes.";
      ["series"] = 5;
      ["faction"] = "Alliance";
      ["sort"] = "Burning Steppes";
      ["prev"] = 4186;
      ["prequests"] = {
         [1] = 4186;
      };
      ["level"] = 54;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [8926] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Wildheart Belt and a set of Wildheart Gloves Deliana in Ironforge.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22106;
         [2] = 22110;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8508] = {
      ["name_ru"] = "Бумаги о полевых обязанностях";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Silithus";
      ["name_fr"] = "La liste des affectations";
      ["name_cn"] = "?地任?文件";
      ["reward"] = {
         [1] = 20810;
      };
      ["name_de"] = "Felddienstpapiere";
      ["faction"] = "Alliance";
      ["name"] = "Field Duty Papers";
      ["level"] = 60;
      ["name_es"] = "Documentacion de instruccion de campo";
      ["req"] = 60;
   };
   [8540] = {
      ["name_ru"] = "Сапоги для стражей";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Ornate Mithril Boots to Vish Kozus, Captain of the Guard at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing II in order to complete this quest.";
      ["name_fr"] = "Des bottes pour la Garde";
      ["sort"] = "Silithus";
      ["name_cn"] = "?兵的靴子";
      ["reward"] = {
         [1] = 20800;
         [2] = 21132;
      };
      ["name_de"] = "Stiefel fur die Wache";
      ["faction"] = "Alliance";
      ["name"] = "Boots for the Guard";
      ["level"] = 60;
      ["name_es"] = "Botas para la guardia";
      ["req"] = 60;
   };
   [4287] = {
      ["name_ru"] = "Восточный пилон";
      ["type"] = "Solo";
      ["name_fr"] = "Le Pylone est";
      ["name_de"] = "Der Ostpylon";
      ["objective"] = "Discover the location of the Eastern Crystal Pylon in Un'Goro Crater.";
      ["name_cn"] = "?部水晶塔";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The Eastern Pylon";
      ["followup"] = 4321;
      ["prev"] = 4284;
      ["prequests"] = {
         [1] = 4284;
      };
      ["level"] = 53;
      ["name_es"] = "La Torre de cristal del Este";
      ["req"] = 47;
   };
   [8604] = {
      ["name_ru"] = "Орде не хватает шерстяных бинтов!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Wool Bandages to Healer Longrunner at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de bandages en laine?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要????！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["name_de"] = "Die Horde braucht Wollverbande!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Wool Bandages!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita vendas de lana!";
      ["req"] = 55;
   };
   [8636] = {
      ["name_ru"] = "Предок Скалогром";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Pierre-grondante";
      ["name_cn"] = "巨石?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Rumpelfels";
      ["faction"] = "Horde";
      ["name"] = "Rumblerock the Elder";
      ["level"] = 60;
      ["name_es"] = "Rocaestruendo el Ancestro";
      ["req"] = 1;
   };
   [8668] = {
      ["name_ru"] = "Брюки сотворения";
      ["objective"] = "Bring the Skin of the Great Sandworm, 2 Idols of War, 5 Stone Scarabs and 5 Crystal Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "起源??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les chausses de la genese";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Beinkleider der Genesis";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21356;
      };
      ["name"] = "Genesis Trousers";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Calzas genesis";
      ["req"] = 60;
   };
   [8700] = {
      ["name_ru"] = "Кольцо Бесконечной жизни";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Magisterial Ring, 2 Alabaster Idols, 5 Bronze Scarabs and 5 Ivory Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau de vie interminable";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "不?生命之戒";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21408;
      };
      ["name_de"] = "Band des endlosen Lebens";
      ["faction"] = "Horde";
      ["name"] = "Band of Unending Life";
      ["level"] = 60;
      ["name_es"] = "La sortija de vida inagotable";
      ["req"] = 60;
   };
   [8732] = {
      ["name_ru"] = "Бумаги о полевых обязанностях";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Silithus";
      ["name_fr"] = "La liste des affectations";
      ["name_cn"] = "?地任?文件";
      ["reward"] = {
         [1] = 20810;
      };
      ["name_de"] = "Felddienstpapiere";
      ["faction"] = "Horde";
      ["name"] = "Field Duty Papers";
      ["level"] = 60;
      ["name_es"] = "Documentacion de instruccion de campo";
      ["req"] = 60;
   };
   [4383] = {
      ["name_ru"] = "Кристалл-хранитель";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallbarriere";
      ["name_fr"] = "Cristal de protection";
      ["name_cn"] = "防御水晶";
      ["name"] = "Crystal Ward";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11564;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "Resguardo de cristal";
      ["req"] = 47;
   };
   [8796] = {
      ["name_ru"] = "Альянсу нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Field Marshal Snowfall in Ironforge's Military Ward.";
      ["name_cn"] = "?盟需要?的?助！";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_de"] = "Die Allianz braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza te necesita!";
      ["req"] = 1;
   };
   [8828] = {
      ["name_ru"] = "Подарки Дедушки Зимы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Great-father Winter. He is located near the Smokywood Pastures vendor area in Orgrimmar.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天的礼物";
      ["name_fr"] = "Des cadeaux d'hiver";
      ["name_de"] = "Winters Geschenke";
      ["faction"] = "Horde";
      ["name"] = "Winter's Presents";
      ["level"] = 1;
      ["name_es"] = "Regalos del invierno";
      ["req"] = 1;
   };
   [8860] = {
      ["name_ru"] = "Отмечаем Новый Год!";
      ["type"] = "Solo";
      ["objective"] = "Bring the Smokywood Supplies to Innkeeper Allison in Stormwind.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "Les fetes du Nouvel an !";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?祝新年！";
      ["name_de"] = "Neujahrsfeier!";
      ["faction"] = "Alliance";
      ["name"] = "New Year Celebrations!";
      ["level"] = 70;
      ["name_es"] = "!Las fiestas de Ano Nuevo!";
      ["req"] = 60;
   };
   [4447] = {
      ["name_ru"] = "Оскверненный ночной дракон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的夜?草";
      ["name_fr"] = "Dragon nocturne corrompu";
      ["name_de"] = "Verderbter Nachtdrache";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Night Dragon";
      ["level"] = 55;
      ["name_es"] = "Dragon nocturno corrupto";
      ["req"] = 48;
   };
   [4463] = {
      ["name_ru"] = "Манускрипт Размышления";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Burning Steppes";
      ["name_fr"] = "Libram de rumination";
      ["name_cn"] = "?思?典";
      ["reward"] = {
         [1] = 11622;
      };
      ["name_de"] = "Buchband des Nachsinnens";
      ["faction"] = "Horde";
      ["name"] = "Libram of Rumination";
      ["level"] = 55;
      ["name_es"] = "Tratado sobre Reflexion";
      ["req"] = 50;
   };
   [2240] = {
      ["name_ru"] = "Потайной чертог";
      ["type"] = "Dungeon";
      ["objective"] = "Read Baelog's Journal, explore the hidden chamber, then report to Prospector Stormpike.";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Die geheime Kammer";
      ["reward"] = {
         [1] = 9626;
         [2] = 9627;
      };
      ["name_cn"] = "密室";
      ["name_fr"] = "La Chambre secrete";
      ["faction"] = "Alliance";
      ["name"] = "The Hidden Chamber";
      ["sort"] = "Uldaman";
      ["prev"] = 2398;
      ["prequests"] = {
         [1] = 2398;
      };
      ["level"] = 40;
      ["name_es"] = "La camara oculta";
      ["req"] = 35;
   };
   [8988] = {
      ["name_ru"] = "Еще одна важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "D'autres composants importants";
      ["next"] = 8992;
      ["name_de"] = "Mehr Komponenten von groser Wichtigkeit";
      ["reward"] = {
         [1] = 22192;
         [2] = 22193;
      };
      ["name_cn"] = "更多重要的材料";
      ["objective"] = "Obtain Soul Ashes of the Banished and return them to Bodley inside Blackrock Mountain.";
      ["faction"] = "Horde";
      ["name"] = "More Components of Importance";
      ["sort"] = "Blackrock Mountain";
      ["prev"] = 8970;
      ["prequests"] = {
         [1] = 8970;
         [2] = 8963;
      };
      ["level"] = 60;
      ["name_es"] = "Mas componentes importantes";
      ["req"] = 58;
   };
   [9020] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of  Shadowcraft Boots, Shadowcraft Pants and Shadowcraft Spaulders.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22003;
         [2] = 22007;
         [3] = 22008;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [9052] = {
      ["name_ru"] = "Яд кровоцвета";
      ["objective"] = "Collect 8 Bloodcap and 8 Gorishi Stings, and return to Torwa Pathfinder in Un'Goro Crater.";
      ["name_cn"] = "血瓣毒?";
      ["sort"] = "Druid";
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Le poison de Petale-de-sang";
      ["next"] = 9051;
      ["name_de"] = "Blutblutengift";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 13446;
      };
      ["name"] = "Bloodpetal Poison";
      ["prev"] = 9063;
      ["prequests"] = {
         [1] = 9063;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Veneno de Sangrepetalo";
      ["req"] = 50;
   };
   [9084] = {
      ["name_ru"] = "Наручи костяной косы";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands will make Bonescythe Bracers if you bring him the following: 1 Desecrated Bracers, 6 Wartorn Leather Scraps, 1 Arcanite Bar, 2 Cured Rugged Hides and 10 gold pieces.";
      ["name_cn"] = "骨??腕";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les brassards de la faucheuse d'os";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Armschienen der Knochensense";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 22483;
      };
      ["name"] = "Bonescythe Bracers";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los brazales Segahuesos";
      ["req"] = 60;
   };
   [9116] = {
      ["name_ru"] = "Перчатки веры";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make Gloves of Faith if you bring him the following: 1 Desecrated Gloves, 8 Wartorn Cloth Scraps and 4 Mooncloth.$B";
      ["name_cn"] = "信仰手套";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les gants de foi";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handschuhe des Glaubens";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22517;
      };
      ["name"] = "Gloves of Faith";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guantes de fe";
      ["req"] = 60;
   };
   [5481] = {
      ["name_ru"] = "Задание Толстяка";
      ["type"] = "Solo";
      ["objective"] = "Collect 3 Gloom Weed and deliver them to Junior Apothecary Holland in the Brill graveyard.";
      ["next"] = 5482;
      ["name_fr"] = "La tache de Gordo";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "葛?多的任?";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Gordos Aufgabe";
      ["faction"] = "Horde";
      ["name"] = "Gordo's Task";
      ["level"] = 5;
      ["name_es"] = "La tarea de Gordo";
      ["req"] = 5;
   };
   [9362] = {
      ["name_ru"] = "Полководец Креллиан";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Prismatic Shell for Archmage Xylem.  The Archmage resides in a tower atop the cliffs of Azshara.";
      ["next"] = 9364;
      ["sort"] = "Mage";
      ["name_cn"] = "??克雷利安";
      ["name_fr"] = "Le seigneur de guerre Krellian";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Kriegsherr Krellian";
      ["faction"] = "Horde";
      ["name"] = "Warlord Krellian";
      ["level"] = 60;
      ["name_es"] = "Senor de la guerra Krellian";
      ["req"] = 60;
   };
   [8362] = {
      ["name_ru"] = "Талисманы Бездны";
      ["type"] = "Group";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Abyssische Wappen";
      ["name_fr"] = "Les blasons abyssaux";
      ["name_cn"] = "深渊?章";
      ["faction"] = "Horde";
      ["name"] = "Abyssal Crests";
      ["reward"] = {
         [1] = 20603;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8361;
      ["prequests"] = {
         [1] = 8361;
      };
      ["level"] = 60;
      ["name_es"] = "Blasones Abisales";
      ["req"] = 60;
   };
   [9244] = {
      ["name_ru"] = "Наручи из ледяной чешуи";
      ["type"] = "Raid";
      ["name_fr"] = "Les brassards glacecaille";
      ["name_de"] = "Eisschuppenarmschienen";
      ["reward"] = {
         [1] = 22665;
      };
      ["name_cn"] = "冰??腕";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 4 Frozen Runes, 16 Heavy Scorpid Scales, 5 Essences of Water, 3 Cured Rugged Hides and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Icy Scale Bracers";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los brazales de escamas heladas";
      ["req"] = 60;
   };
   [7362] = {
      ["name_ru"] = "Союзник тауренов";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing gnome players in Alterac Valley.$B$BKill a gnome and return to Ravak Grimtotem at Frostwolf Keep with a Tuft of Gnome Hair.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "牛?人的盟友";
      ["name_fr"] = "Allie des taurens";
      ["name_de"] = "Verbundeter der Tauren";
      ["faction"] = "Horde";
      ["name"] = "Ally of the Tauren";
      ["level"] = 60;
      ["name_es"] = "Aliado de los Tauren";
      ["req"] = 51;
   };
   [8265] = {
      ["name_ru"] = "Улучшенный полевой комплект Осквернителей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [510] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Le paquetage ameliore de Profanateur";
      ["name_cn"] = "?染者高?医?包";
      ["reward"] = {
         [1] = 20228;
      };
      ["name_de"] = "Verbessertes Uberlebenspaket der Entweihten";
      ["faction"] = "Horde";
      ["name"] = "Defiler's Advanced Care Package";
      ["level"] = 60;
      ["name_es"] = "Botiquin avanzado de Rapinador";
      ["req"] = 45;
   };
   [3090] = {
      ["name_ru"] = "Гниющий пергамент";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin contamine";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Besudeltes Pergament";
      ["name"] = "Tainted Parchment";
      ["name_cn"] = "被?染的羊皮?";
      ["objective"] = "Read the Tainted Parchment and speak to Nartok inside the Den in the Valley of Trials.";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["sort"] = "Warlock";
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Papiro corrupto";
      ["req"] = 1;
   };
   [7807] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7811;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [5090] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out Commander Ashlam Valorfist.  His base camp is located at Chillwind Camp, north of the Alterac Mountains.";
      ["next"] = 5092;
      ["sort"] = "Ironforge";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["followup"] = 5092;
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Alliance";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [2360] = {
      ["name_ru"] = "Матиас и Братство Справедливости";
      ["type"] = "Solo";
      ["objective"] = "Travel to Westfall and find Agent Kearnen for your debriefing.";
      ["next"] = 2359;
      ["sort"] = "Rogue";
      ["name_cn"] = "?迪?斯和迪菲?盗?";
      ["name_fr"] = "Mathias et les Defias";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name_de"] = "Mathias und die Defias";
      ["faction"] = "Alliance";
      ["name"] = "Mathias and the Defias";
      ["level"] = 20;
      ["name_es"] = "Mathias y los Defias";
      ["req"] = 20;
   };
   [4735] = {
      ["name_ru"] = "Сбор яиц";
      ["type"] = "Raid";
      ["name_fr"] = "La collecte d'oeufs";
      ["repgain"] = {
         [21] = 350;
         [369] = 350;
         [577] = 350;
         [470] = 350;
      };
      ["name_de"] = "Eiersammlung";
      ["name_cn"] = "收集?蛋";
      ["name"] = "Egg Collection";
      ["objective"] = "Bring 8 Collected Dragon Eggs and the Collectronic Module to Tinkee Steamboil at Flame Crest in the Burning Steppes.";
      ["faction"] = "Horde";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4734;
      ["prequests"] = {
         [1] = 4734;
      };
      ["level"] = 60;
      ["name_es"] = "La colecta de huevos";
      ["req"] = 57;
   };
   [6362] = {
      ["name_ru"] = "Дорога до Громового Утеса";
      ["type"] = "Solo";
      ["name_fr"] = "Voyage vers les Pitons du Tonnerre";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Flug nach Donnerfels";
      ["objective"] = "Buy a wind rider to Thunder Bluff from the wind rider master Devrak, then bring the Bundle of Hides to Ahanu in Thunder Bluff.";
      ["name_cn"] = "?往雷霆崖";
      ["next"] = 6363;
      ["sort"] = "The Barrens";
      ["name"] = "Ride to Thunder Bluff";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 6361;
      ["prequests"] = {
         [1] = 6361;
      };
      ["level"] = 10;
      ["name_es"] = "Un viaje a Cima del Trueno";
      ["req"] = 10;
   };
   [4767] = {
      ["name_ru"] = "Ветрокрыл";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Highperch Wyvern Eggs to Elu in Freewind Post.";
      ["repgain"] = {
         [81] = 150;
      };
      ["sort"] = "Thousand Needles";
      ["name_fr"] = "Le coursier du vent";
      ["name_cn"] = "??者";
      ["reward"] = {
         [1] = 4265;
      };
      ["name_de"] = "Windreiter";
      ["faction"] = "Horde";
      ["name"] = "Wind Rider";
      ["level"] = 29;
      ["name_es"] = "Jinete del viento";
      ["req"] = 25;
   };
   [4783] = {
      ["name_ru"] = "Материалы для зачарованного золотого кровавого одеяния";
      ["objective"] = "Bring 10 Vials of Hatefury Blood and 1 Lesser Infernal Stone to Menara Voidrender in the Barrens.";
      ["name_cn"] = "魔化金?血袍";
      ["sort"] = "Warlock";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Les composants de la robe sanglante doree enchantee";
      ["next"] = 4784;
      ["name_de"] = "Komponenten fur die verzauberte Goldblutrobe";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Components for the Enchanted Gold Bloodrobe";
      ["prev"] = 4782;
      ["prequests"] = {
         [1] = 4782;
      };
      ["series"] = 4;
      ["name_es"] = "Los componentes para la toga de sangre dorada encantada";
      ["req"] = 31;
   };
   [5674] = {
      ["name_ru"] = "Благодать Элуны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["name_de"] = "Elunes Anmut";
      ["sort"] = "Priest";
      ["name_cn"] = "艾露恩的?福";
      ["name_fr"] = "Grace d'Elune";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Elune's Grace";
      ["level"] = 20;
      ["name_es"] = "La Gracia de Elune";
      ["req"] = 20;
   };
   [4362] = {
      ["name_ru"] = "Судьба королевства";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le destin du Royaume";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Das Schicksal des Konigreichs";
      ["name"] = "The Fate of the Kingdom";
      ["name_cn"] = "王国的命?";
      ["objective"] = "Return to Blackrock Depths and rescue Princess Moira Bronzebeard from the evil clutches of Emperor Dagran Thaurissan.$B";
      ["next"] = 4363;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4361;
      ["prequests"] = {
         [1] = 4361;
      };
      ["level"] = 59;
      ["name_es"] = "El destino del reino";
      ["req"] = 50;
   };
   [1793] = {
      ["name_ru"] = "Фолиант Отваги";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["sort"] = "Paladin";
      ["name_cn"] = "勇气之?";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["name"] = "The Tome of Valor";
      ["reward"] = {
         [1] = 6776;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 20;
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [2924] = {
      ["name_ru"] = "Базовый элемент";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 12 Essential Artificials to Klockmort Spannerspan in Ironforge.";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_fr"] = "Les cerveaux mecaniques";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "基?模?";
      ["name_de"] = "Grundlegende Artifixe";
      ["faction"] = "Alliance";
      ["name"] = "Essential Artificials";
      ["level"] = 30;
      ["name_es"] = "Esencias artificiales";
      ["req"] = 24;
   };
   [4863] = {
      ["name_ru"] = "Разъяренные дикие совухи";
      ["type"] = "Solo";
      ["name_fr"] = "Les Indomptables enrages";
      ["next"] = 4864;
      ["name_de"] = "Wutende Wildekin";
      ["name"] = "Enraged Wildkin";
      ["name_cn"] = "被激怒的??";
      ["objective"] = "Find Jaron Stoneshaper's wrecked wagon.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Winterspring";
      ["prev"] = 4861;
      ["prequests"] = {
         [1] = 4861;
      };
      ["level"] = 59;
      ["name_es"] = "Lechucico salvaje iracundo";
      ["req"] = 53;
   };
   [2440] = {
      ["name_ru"] = "Платиновые диски";
      ["type"] = "Solo";
      ["objective"] = "Take the reward voucher to Bena Winterhoof in Thunder Bluff.";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Die Platinscheiben";
      ["reward"] = {
         [1] = 3928;
         [2] = 9587;
         [3] = 6149;
      };
      ["name_cn"] = "白金??";
      ["name_fr"] = "Les Disques de platine";
      ["faction"] = "Horde";
      ["name"] = "The Platinum Discs";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 2280;
      ["prequests"] = {
         [1] = 2280;
      };
      ["level"] = 47;
      ["name_es"] = "Los discos de platino";
      ["req"] = 40;
   };
   [1950] = {
      ["name_ru"] = "Волшебное слово";
      ["type"] = "Solo";
      ["name_fr"] = "Trouver le Scoop";
      ["next"] = 1951;
      ["name_de"] = "Der Knuller schlechthin";
      ["objective"] = "Find the phrase to Tirth's strongbox, then return to Tirth.";
      ["name_cn"] = "解封咒?";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Get the Scoop";
      ["prev"] = 1949;
      ["prequests"] = {
         [1] = 1949;
      };
      ["level"] = 30;
      ["name_es"] = "Santo y sena";
      ["req"] = 30;
   };
   [7645] = {
      ["name_ru"] = "Сытный манный лошадиный корм";
      ["type"] = "Solo";
      ["name_fr"] = "Fourrage enrichi en manne";
      ["name_de"] = "Mit Manna angereichertes Pferdefutter";
      ["name_cn"] = "魔法粮草";
      ["objective"] = "Retrieve 20 Enriched Manna Biscuits - the key ingredient in making Manna-Enriched Horse Feed - for Merideth Carlson at Southshore in the Hillsbrad Foothills.  The Argent Dawn is known as the sole purveyor of the biscuits.$B$BYou also need to give her 50 gold to soothe her ruffled sensibilities.";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "Manna-Enriched Horse Feed";
      ["reward"] = {
         [1] = 18775;
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["name_es"] = "Alimento para caballos enriquecido con mana";
      ["req"] = 60;
   };
   [4509] = {
      ["name_ru"] = "Затишье перед бурей";
      ["objective"] = "Bring Pestlezugg's Un'Goro Report to Zilzibin Drumlore in Orgrimmar.";
      ["name_cn"] = "?危不惧";
      ["sort"] = "Tanaris";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Le calme avant la tempete";
      ["next"] = 4511;
      ["name_de"] = "Die Ruhe vor dem Sturm";
      ["repgain"] = {
         [530] = 10;
      };
      ["faction"] = "Horde";
      ["name"] = "Calm Before the Storm";
      ["prev"] = 4507;
      ["prequests"] = {
         [1] = 4507;
      };
      ["series"] = 1;
      ["name_es"] = "La calma que precede a la tormenta";
      ["req"] = 50;
   };
   [9022] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Boots of Valor, Legplates of Valor and Spaulders of Valor.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 21995;
         [2] = 22000;
         [3] = 22001;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [2480] = {
      ["name_ru"] = "Помощь Хинотта";
      ["objective"] = "Wait for Serge Hinott to complete the cure.";
      ["name_cn"] = "希?特的?助";
      ["sort"] = "Rogue";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "L'aide d'Hinott";
      ["name_de"] = "Hinotts Hilfe";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 8095;
      };
      ["name"] = "Hinott's Assistance";
      ["prev"] = 2479;
      ["prequests"] = {
         [1] = 2479;
      };
      ["series"] = 2;
      ["name_es"] = "La ayuda de Hinott";
      ["req"] = 20;
   };
   [4975] = {
      ["name_ru"] = "Завершение шара Дар'орахила";
      ["type"] = "Solo";
      ["name_fr"] = "L'Orbe complet de Noh'Orahil";
      ["name_de"] = "Die fertiggestellte Kugel von Noh'Orahil";
      ["objective"] = "Wait for Menara Voidrender to complete the Orb of Noh'Orahil and then speak to her again.";
      ["reward"] = {
         [1] = 15107;
         [2] = 15105;
      };
      ["name_cn"] = "?奥拉赫宝珠";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Completed Orb of Noh'Orahil";
      ["sort"] = "Warlock";
      ["prev"] = 4976;
      ["prequests"] = {
         [1] = 4976;
      };
      ["level"] = 40;
      ["name_es"] = "El orbe completo de Noh'Orahil";
      ["req"] = 35;
   };
   [5509] = {
      ["name_ru"] = "Камни захватчиков Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Pierres du Fleau des envahisseurs";
      ["name_cn"] = "侵略者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Eindringlings";
      ["faction"] = "Horde";
      ["name"] = "Invader's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del invasor";
      ["req"] = 50;
   };
   [1656] = {
      ["name_ru"] = "Незаконченное задание";
      ["type"] = "Solo";
      ["objective"] = "Bring the Bundle of Furs to Innkeeper Kauth in Bloodhoof Village.";
      ["repgain"] = {
         [81] = 25;
      };
      ["sort"] = "Red Cloud Mesa";
      ["name_fr"] = "Une tache inachevee";
      ["name_cn"] = "未完的任?";
      ["reward"] = {
         [1] = 4540;
         [2] = 159;
      };
      ["name_de"] = "Eine unvollendete Aufgabe";
      ["faction"] = "Horde";
      ["name"] = "A Task Unfinished";
      ["level"] = 5;
      ["name_es"] = "Una tarea por terminar";
      ["req"] = 1;
   };
   [5023] = {
      ["name_ru"] = "Лучше поздно, чем никогда";
      ["type"] = "Solo";
      ["name_fr"] = "Mieux vaut tard que jamais";
      ["next"] = 5049;
      ["name_de"] = "Besser spat als nie";
      ["name_cn"] = "?到?比不到好";
      ["objective"] = "Check with the Royal Overseers of the Undercity to learn the whereabouts of a Jeremiah Felstone.  There is usually a census officer located near guild and tabard registration.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Better Late Than Never";
      ["prev"] = 5021;
      ["prequests"] = {
         [1] = 5021;
      };
      ["level"] = 52;
      ["name_es"] = "Mas vale tarde que nunca";
      ["req"] = 50;
   };
   [2520] = {
      ["name_ru"] = "Жертвоприношение Сатры";
      ["type"] = "Solo";
      ["objective"] = "Priestess A'moora wants you to place Lady Sathrah's silvery spinnerets at the fountain inside the temple, and then return to her.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Sathrahs Opferung";
      ["reward"] = {
         [1] = 9600;
         [2] = 9601;
      };
      ["name_cn"] = "??拉的祭品";
      ["name_fr"] = "Sacrifice de Sathrah";
      ["faction"] = "Alliance";
      ["name"] = "Sathrah's Sacrifice";
      ["sort"] = "Darnassus";
      ["prev"] = 2518;
      ["prequests"] = {
         [1] = 2518;
      };
      ["level"] = 12;
      ["name_es"] = "El Sacrificio de Sathrah";
      ["req"] = 5;
   };
   [5055] = {
      ["name_ru"] = "Хладнокрылая Брумеран";
      ["type"] = "Group";
      ["name_fr"] = "Brumeran des Noroit";
      ["next"] = 5056;
      ["name_de"] = "Brumeran von den Eiswindschimaren";
      ["name_cn"] = "冰?奇美拉布?米?";
      ["objective"] = "Storm Shadowhoof at Everlook in Winterspring wants you to kill Brumeran.";
      ["sort"] = "Winterspring";
      ["faction"] = "Horde";
      ["name"] = "Brumeran of the Chillwind";
      ["prev"] = 5054;
      ["prequests"] = {
         [1] = 5054;
      };
      ["level"] = 58;
      ["name_es"] = "Brumeran de los Orvallo";
      ["req"] = 53;
   };
   [3907] = {
      ["name_ru"] = "Дисгармония пламени";
      ["type"] = "Dungeon";
      ["objective"] = "Enter Blackrock Depths and track down Lord Incendius. Slay him and return any source of information you may find to Thunderheart.$B";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Disharmonie des Feuers";
      ["reward"] = {
         [1] = 12113;
         [2] = 12114;
         [3] = 12112;
         [4] = 12115;
      };
      ["name_cn"] = "不和?的火?";
      ["name_fr"] = "Discordance des flammes";
      ["faction"] = "Horde";
      ["name"] = "Disharmony of Fire";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 3906;
      ["prequests"] = {
         [1] = 3906;
      };
      ["level"] = 56;
      ["name_es"] = "La discordia del fuego";
      ["req"] = 48;
   };
   [5087] = {
      ["name_ru"] = "Гонцы Зимней Спячки";
      ["type"] = "Solo";
      ["name_fr"] = "Les messagers des Tombe-hiver";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Laufer der Winterfelle";
      ["name"] = "Winterfall Runners";
      ["name_cn"] = "冬泉信使";
      ["objective"] = "Find the Winterfall Runners and stop them from delivering their shipment to Winterfall Village.";
      ["next"] = 5121;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5086;
      ["prequests"] = {
         [1] = 5086;
      };
      ["level"] = 57;
      ["name_es"] = "Corredores Nevada";
      ["req"] = 52;
   };
   [5103] = {
      ["name_ru"] = "Смерть в огне";
      ["type"] = "Dungeon";
      ["objective"] = "Someone in this world must know what to do with these gauntlets. Good luck!";
      ["next"] = 5124;
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "火?的死亡";
      ["name_fr"] = "Mort brulante";
      ["name_de"] = "Heiser, feuriger Tod";
      ["faction"] = "Horde";
      ["name"] = "Hot Fiery Death";
      ["level"] = 60;
      ["name_es"] = "Muerte abrasadora";
      ["req"] = 60;
   };
   [5727] = {
      ["name_ru"] = "Тайные враги";
      ["objective"] = "Take the Lieutenant's Insignia to Neeru Fireblade and speak to him. Gauge if he believes you are a member of the Burning Blade and then return to Thrall in Orgrimmar.";
      ["name_cn"] = "?藏的?人";
      ["sort"] = "Orgrimmar";
      ["level"] = 12;
      ["type"] = "Solo";
      ["name_fr"] = "Ennemis caches";
      ["next"] = 5728;
      ["name_de"] = "Verborgene Feinde";
      ["repgain"] = {
         [76] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Hidden Enemies";
      ["prev"] = 5726;
      ["prequests"] = {
         [1] = 5726;
      };
      ["series"] = 2;
      ["name_es"] = "Enemigos ocultos";
      ["req"] = 9;
   };
   [1071] = {
      ["name_ru"] = "Отсрочка для гнома";
      ["type"] = "Solo";
      ["name_fr"] = "Du repit pour un gnome";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Der Aufschub des Gnoms";
      ["name_cn"] = "侏儒学者";
      ["name"] = "A Gnome's Respite";
      ["objective"] = "Kill 10 Venture Co. Loggers, and 10 Venture Co. Deforesters and return to Gaxim Rustfizzle in Stonetalon.";
      ["faction"] = "Alliance";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1085;
      ["prequests"] = {
         [1] = 1085;
      };
      ["level"] = 21;
      ["name_es"] = "Una tregua para el gnomo";
      ["req"] = 17;
   };
   [5151] = {
      ["name_ru"] = "Механизм гипервместимости";
      ["type"] = "Group";
      ["objective"] = "Slay the beast and bring back the Hypercapacitor Gizmo and Panther Cage Key to Wizlo Bearingshiner.";
      ["name_fr"] = "Hypercapaciteur bidulotron";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "超????";
      ["reward"] = {
         [1] = 15467;
      };
      ["name_de"] = "Hyperkondensator-Dingsda";
      ["faction"] = "Horde";
      ["name"] = "Hypercapacitor Gizmo";
      ["level"] = 30;
      ["name_es"] = "Hipercondensador";
      ["req"] = 24;
   };
   [5167] = {
      ["name_ru"] = "Ножные латы всецветного воина";
      ["type"] = "Group";
      ["name_fr"] = "Les cuissards de duelliste chromatique";
      ["name_de"] = "Beinplatten des chromatischen Widersetzers";
      ["reward"] = {
         [1] = 12903;
         [2] = 12945;
      };
      ["name_cn"] = "多彩挑?者腿甲";
      ["objective"] = "To forge the Legplates of the Chromatic Defier, you will be required to bring the following items to Jeziba the 'Sculptor':$B$B1 Chromatic Carapace.$B$B10 Brilliant Chromatic Scales.$B$B10 Blood of Heroes.$B$B5 Skin of Shadow.";
      ["faction"] = "Horde";
      ["name"] = "Legplates of the Chromatic Defier";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5164;
      ["prequests"] = {
         [1] = 5164;
      };
      ["level"] = 60;
      ["name_es"] = "Quijotes del desafiante cromatico";
      ["req"] = 57;
   };
   [1247] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1248;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Speak to Elling Trias in Stormwind.";
      ["series"] = 9;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1447;
      ["prequests"] = {
         [1] = 1447;
      };
      ["level"] = 31;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [5885] = {
      ["name_ru"] = "Лекарство из оскверненных шкур";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Kurschnerei";
      ["name_fr"] = "Du baume contre des peaux";
      ["name_cn"] = "剥皮??膏";
      ["name"] = "Salve via Skinning";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4102;
      ["prequests"] = {
         [1] = 4102;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desuello";
      ["req"] = 48;
   };
   [5215] = {
      ["name_ru"] = "Котлы Плети";
      ["type"] = "Solo";
      ["name_fr"] = "Les chaudrons du Fleau";
      ["repgain"] = {
         [72] = 10;
      };
      ["name_de"] = "Die Geiselkessel";
      ["name"] = "The Scourge Cauldrons";
      ["name_cn"] = "瘟疫之?";
      ["objective"] = "Speak with High Priestess MacDonnell at Chillwind Point, Western Plaguelands.";
      ["next"] = 5216;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5092;
      ["prequests"] = {
         [1] = 5092;
      };
      ["level"] = 53;
      ["name_es"] = "Las calderas de la Plaga";
      ["req"] = 50;
   };
   [5231] = {
      ["name_ru"] = "Цель: Слезы Далсона";
      ["objective"] = "Go to Dalson's Tears in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Dalson's Tears Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：??松之泪";
      ["sort"] = "Western Plaguelands";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: les Larmes de Dalson";
      ["next"] = 5232;
      ["name_de"] = "Ziel: Dalsons Tranenfeld";
      ["repgain"] = {
         [67] = 250;
         [529] = 250;
      };
      ["followup"] = 5232;
      ["name"] = "Target: Dalson's Tears";
      ["prev"] = 5230;
      ["prequests"] = {
         [1] = 5230;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Objetivo: Llanto de Dalson";
      ["req"] = 50;
   };
   [5247] = {
      ["name_ru"] = "Фрагменты прошлого";
      ["type"] = "Group";
      ["objective"] = "Bring an Enchanted Thorium Bar, 5 Crystal Restore, and a Vial of Dire Water to Aurora Skycaller near the Northpass Tower in Eastern Plaguelands.";
      ["repgain"] = {
         [69] = 25;
         [54] = 25;
         [72] = 25;
         [47] = 25;
      };
      ["name_de"] = "Fragmente der Vergangenheit";
      ["name"] = "Fragments of the Past";
      ["name_cn"] = "?史的残片";
      ["name_fr"] = "Fragments du passe";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5246;
      ["prequests"] = {
         [1] = 5246;
      };
      ["level"] = 57;
      ["name_es"] = "Trozos del pasado";
      ["req"] = 53;
   };
   [5263] = {
      ["name_ru"] = "Быстрее, выше, сильнее";
      ["type"] = "Dungeon";
      ["name_fr"] = "Au-dessus et au-dela";
      ["repgain"] = {
         [529] = 150;
      };
      ["name_de"] = "Ubertroffen";
      ["name_cn"] = "超越";
      ["name"] = "Above and Beyond";
      ["objective"] = "Venture to Stratholme and destroy Baron Rivendare. Take his head and return to Duke Nicholas Zverenhoff.$B";
      ["faction"] = "Horde";
      ["sort"] = "Stratholme";
      ["prev"] = 5262;
      ["prequests"] = {
         [1] = 5262;
      };
      ["level"] = 60;
      ["name_es"] = "Por encima y mas alla";
      ["req"] = 55;
   };
   [4184] = {
      ["name_ru"] = "Подлинные хозяева";
      ["objective"] = "Travel to Stormwind and deliver Solomon's Plea to Highlord Bolvar Fordragon.$B$BBolvar resides in Stormwind Keep. ";
      ["name_cn"] = "真正的主人";
      ["sort"] = "Burning Steppes";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4185;
      ["name_de"] = "Die wahren Meister";
      ["repgain"] = {
         [72] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The True Masters";
      ["prev"] = 4183;
      ["prequests"] = {
         [1] = 4183;
      };
      ["series"] = 2;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [8562] = {
      ["name_ru"] = "Кираса Завоевателя";
      ["objective"] = "Bring the the Carapace of the Old God, 2 Idols of War, 5 Silver Scarabs and 5 Bone Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "征服者的胸甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La cuirasse du Conquerant";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Brustplatte des Eroberers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21331;
      };
      ["name"] = "Conqueror's Breastplate";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La coraza de conquistador";
      ["req"] = 60;
   };
   [1511] = {
      ["name_ru"] = "Зелье Кен'зиглы";
      ["type"] = "Solo";
      ["name_fr"] = "Breuvage de Ken'zigla";
      ["next"] = 1515;
      ["name_de"] = "Ken'ziglas Trunk";
      ["objective"] = "Bring Ken'zigla's Draught to Grunt Logmar at Camp Taurajo.";
      ["name_cn"] = "肯?格拉的??";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Ken'zigla's Draught";
      ["prev"] = 1510;
      ["prequests"] = {
         [1] = 1510;
      };
      ["level"] = 20;
      ["name_es"] = "Jarabe de Ken'zigla";
      ["req"] = 20;
   };
   [7794] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Stormwind City";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7795;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [5343] = {
      ["name_ru"] = "Сокровище Баровых";
      ["type"] = "Dungeon";
      ["objective"] = "Venture to the Scholomance and recover the Barov family fortune. Four deeds make up this fortune: The Deed to Caer Darrow; The Deed to Brill; The Deed to Tarren Mill; and The Deed to Southshore. Return to Weldon Barov when you have completed this task.";
      ["next"] = 5344;
      ["sort"] = "Scholomance";
      ["name_cn"] = "巴?夫家族的宝藏";
      ["name_fr"] = "Fortune de la famille Barov";
      ["name_de"] = "Das Familienvermogen der Barovs";
      ["faction"] = "Alliance";
      ["name"] = "Barov Family Fortune";
      ["level"] = 60;
      ["name_es"] = "La fortuna de la familia Barov";
      ["req"] = 52;
   };
   [3562] = {
      ["name_ru"] = "Плата Магаты Джедиге";
      ["type"] = "Solo";
      ["name_fr"] = "Le paiement de Magatha a Jediga";
      ["name_de"] = "Magathas Bezahlung fur Jediga";
      ["name_cn"] = "?加?的?酬";
      ["objective"] = "Deliver Magatha's Note to Jediga in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Magatha's Payment to Jediga";
      ["prev"] = 3518;
      ["prequests"] = {
         [1] = 3518;
      };
      ["level"] = 52;
      ["name_es"] = "El pago de Magatha a Jediga";
      ["req"] = 45;
   };
   [6562] = {
      ["name_ru"] = "Угроза из Глубин";
      ["type"] = "Dungeon";
      ["objective"] = "Speak to Je'neu Sancrea in Ashenvale.";
      ["next"] = 6563;
      ["name_fr"] = "Problemes dans les profondeurs";
      ["sort"] = "Blackfathom Deeps";
      ["name_cn"] = "?助耶努?克雷";
      ["repgain"] = {
         [530] = 25;
      };
      ["name_de"] = "Arger in der Tiefe";
      ["faction"] = "Horde";
      ["name"] = "Trouble in the Deeps";
      ["level"] = 22;
      ["name_es"] = "Problemas en las profundidades";
      ["req"] = 17;
   };
   [7801] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Alliance";
      ["sort"] = "Darnassus";
      ["prev"] = 7800;
      ["prequests"] = {
         [1] = 7800;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [5407] = {
      ["name_ru"] = "Камни захватчиков Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des envahisseurs";
      ["name_cn"] = "侵略者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Eindringlings";
      ["faction"] = "Horde";
      ["name"] = "Invader's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del invasor";
      ["req"] = 50;
   };
   [8193] = {
      ["name_ru"] = "Лучший рыболов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Maitre pecheur";
      ["name_cn"] = "??大?";
      ["reward"] = {
         [1] = 19970;
         [2] = 19979;
      };
      ["name_de"] = "Die grose Beute";
      ["faction"] = "Horde";
      ["name"] = "Master Angler";
      ["level"] = 0;
      ["name_es"] = "Gran premio";
      ["req"] = 60;
   };
   [1127] = {
      ["name_ru"] = "\"Дурацкое Крепкое\"";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 of Zanzil's Mixture to Crank Fizzlebub in Booty Bay.";
      ["name_fr"] = "La biere du Sot";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "蠢人酒";
      ["reward"] = {
         [1] = 5806;
      };
      ["name_de"] = "Fools Starkbier";
      ["faction"] = "Horde";
      ["name"] = "Fool's Stout";
      ["level"] = 44;
      ["name_es"] = "Cerveza de tontos";
      ["req"] = 36;
   };
   [6284] = {
      ["name_ru"] = "Арахнофобия";
      ["type"] = "Group";
      ["objective"] = "Kill Besseleth and bring Besseleth's Fang to Maggran at Sun Rock Retreat.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Stonetalon Mountains";
      ["name_fr"] = "Arachnophobie";
      ["name_cn"] = "?瑟莱斯";
      ["reward"] = {
         [1] = 16891;
         [2] = 16894;
      };
      ["name_de"] = "Arachnophobie";
      ["faction"] = "Horde";
      ["name"] = "Arachnophobia";
      ["level"] = 21;
      ["name_es"] = "Aracnofobia";
      ["req"] = 15;
   };
   [8284] = {
      ["name_ru"] = "Сумеречная тайна";
      ["type"] = "Solo";
      ["objective"] = "Geologist Larksbane at Cenarion Hold in Silithus wants you to collect 8 Twilight Tablet Fragments.";
      ["next"] = 8285;
      ["name_fr"] = "Le mystere du Crepuscule";
      ["sort"] = "Silithus";
      ["name_cn"] = "暮光的秘密";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Das Geheimnis des Zwielichts";
      ["faction"] = "Horde";
      ["name"] = "The Twilight Mystery";
      ["level"] = 58;
      ["name_es"] = "El misterio Crepuscular";
      ["req"] = 54;
   };
   [2744] = {
      ["name_ru"] = "Охотник на демонов";
      ["type"] = "Solo";
      ["name_fr"] = "Le chasseur de demons";
      ["next"] = 3141;
      ["name_de"] = "Der Damonenjager";
      ["name_cn"] = "?魔?手";
      ["objective"] = "Speak with Loramus Thalipedes in Azshara.";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "The Demon Hunter";
      ["prev"] = 2743;
      ["prequests"] = {
         [1] = 2743;
      };
      ["level"] = 60;
      ["name_es"] = "El cazademonios";
      ["req"] = 45;
   };
   [5503] = {
      ["name_ru"] = "Жетон Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Brevet de l'Aube d'argent";
      ["name_cn"] = "?色黎明委任徽章";
      ["reward"] = {
         [1] = 12846;
      };
      ["name_de"] = "Anstecknadel der Argentumdammerung";
      ["faction"] = "Horde";
      ["name"] = "Argent Dawn Commission";
      ["level"] = 55;
      ["name_es"] = "Comision de El Alba Argenta";
      ["req"] = 50;
   };
   [2760] = {
      ["name_ru"] = "Орден Мифрила";
      ["type"] = "Solo";
      ["objective"] = "Speak with Galvan the Ancient in Stranglethorn Vale.$B";
      ["name_fr"] = "L'ordre du Mithril";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "秘?会";
      ["name"] = "The Mithril Order";
      ["name_de"] = "Der Mithrilorden";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2757;
         [2] = 2759;
      };
      ["level"] = 40;
      ["name_es"] = "La Orden del mitril";
      ["req"] = 40;
   };
   [2768] = {
      ["name_ru"] = "Изыскательский жезл";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the Divino-matic Rod to Chief Engineer Bilgewhizzle in Gadgetzan.";
      ["repgain"] = {
         [369] = 500;
      };
      ["sort"] = "Zul'Farrak";
      ["name_fr"] = "Le batonnet divino-matic";
      ["name_cn"] = "探水棒";
      ["reward"] = {
         [1] = 9533;
         [2] = 9534;
      };
      ["name_de"] = "Wunschel-mato-Rute";
      ["faction"] = "Horde";
      ["name"] = "Divino-matic Rod";
      ["level"] = 47;
      ["name_es"] = "Vara divinomatica";
      ["req"] = 40;
   };
   [8687] = {
      ["name_ru"] = "Цель: копатели из Улья Зора";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Zora Tunnelers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing VII in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les tunnelieres de la Ruche'Zora";
      ["name_cn"] = "目?：佐拉坑道蝎";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Tunnelgraber des Zoraschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Zora Tunnelers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los tuneladores de Colmen'Zora";
      ["req"] = 60;
   };
   [2784] = {
      ["name_ru"] = "Попавший в немилость";
      ["type"] = "Solo";
      ["objective"] = "Listen to the Fallen Hero of the Horde tell his story.";
      ["next"] = 2621;
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "失落的?耀";
      ["name_fr"] = "Perte d'honneur";
      ["name_de"] = "In Ungnade fallen";
      ["faction"] = "Horde";
      ["name"] = "Fall From Grace";
      ["level"] = 50;
      ["name_es"] = "Perdida de honor";
      ["req"] = 45;
   };
   [2871] = {
      ["name_ru"] = "Доставка реликвии";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Mysterious Relic to Vestia Moonspear in Feathermoon Stronghold.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Uberbringung des Relikts";
      ["reward"] = {
         [1] = 9663;
         [2] = 9664;
      };
      ["name_cn"] = "?送?物";
      ["name_fr"] = "Livraison de la relique";
      ["faction"] = "Alliance";
      ["name"] = "Delivering the Relic";
      ["sort"] = "Feralas";
      ["prev"] = 2870;
      ["prequests"] = {
         [1] = 2870;
      };
      ["level"] = 45;
      ["name_es"] = "Entrega la reliquia";
      ["req"] = 40;
   };
   [8709] = {
      ["name_ru"] = "Кинжал сокрытых теней";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Spiked Hilt, 2  Vermillion Idols, 5 Gold Scarabs and 5 Clay Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La dague des ombres voilees";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?罩?影匕首";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21404;
      };
      ["name_de"] = "Dolch der Schattenschleier";
      ["faction"] = "Horde";
      ["name"] = "Dagger of Veiled Shadows";
      ["level"] = 60;
      ["name_es"] = "La daga de las sombras ocultas";
      ["req"] = 60;
   };
   [7827] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7824;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [5631] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5647] = {
      ["name_ru"] = "Бесстрашие";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priest Rohan in Ironforge.";
      ["name_de"] = "Furchtlos";
      ["name_cn"] = "缺乏恐惧";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "A Lack of Fear";
      ["level"] = 20;
      ["name_es"] = "Sin miedo";
      ["req"] = 20;
   };
   [5663] = {
      ["name_ru"] = "Прикосновение слабости";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Beruhrung der Schwache";
      ["sort"] = "Priest";
      ["name_cn"] = "虚弱之触*";
      ["name_fr"] = "Toucher de faiblesse";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Touch of Weakness";
      ["level"] = 10;
      ["name_es"] = "Toque de debilidad";
      ["req"] = 10;
   };
   [5679] = {
      ["name_ru"] = "Всепожирающая чума";
      ["type"] = "Solo";
      ["objective"] = "Speak to Aelthalyste in the Undercity.";
      ["name_de"] = "Verschlingende Seuche";
      ["name_cn"] = "噬?瘟疫";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Devouring Plague";
      ["level"] = 20;
      ["name_es"] = "Peste devoradora";
      ["req"] = 20;
   };
   [2848] = {
      ["name_ru"] = "Дикарские кожаные наплечники";
      ["type"] = "Solo";
      ["name_fr"] = "Les epaulieres en cuir fauve";
      ["name_de"] = "Wildlederschultern";
      ["objective"] = "Bring 6 Thick Armor Kits and a Wildvine to Pratt McGrubben in Feathermoon Stronghold.";
      ["followup"] = 2853;
      ["name_cn"] = "蛮皮?肩";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Shoulders";
      ["reward"] = {
         [1] = 8403;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 45;
      ["name_es"] = "Sobrehombros de cuero salvaje";
      ["req"] = 30;
   };
   [2856] = {
      ["name_ru"] = "Дикарский кожаный жилет";
      ["type"] = "Solo";
      ["name_fr"] = "Le gilet en cuir fauve";
      ["name_de"] = "Wildlederweste";
      ["objective"] = "Bring 2 Turtle Scale Breastplates, 2 Turtle Scale Gloves, and a Wildvine to Jangdor Swiftstrider in Camp Mojache.";
      ["followup"] = 2860;
      ["name_cn"] = "蛮皮外衣";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Vest";
      ["reward"] = {
         [1] = 8404;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2854;
      ["prequests"] = {
         [1] = 2854;
      };
      ["level"] = 45;
      ["name_es"] = "El Jubon de cuero salvaje";
      ["req"] = 30;
   };
   [2864] = {
      ["name_ru"] = "Тран'рек";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Tran'rek in Gadgetzan.";
      ["next"] = 2865;
      ["name_fr"] = "Tran'rek";
      ["sort"] = "Zul'Farrak";
      ["name_cn"] = "特?雷克";
      ["repgain"] = {
         [369] = 25;
      };
      ["name_de"] = "Tran'rek";
      ["faction"] = "Horde";
      ["name"] = "Tran'rek";
      ["level"] = 45;
      ["name_es"] = "Tran'rek";
      ["req"] = 40;
   };
   [2872] = {
      ["name_ru"] = "Долг Столи";
      ["type"] = "Solo";
      ["objective"] = "Speak with Stoley in Steamwheedle Port.";
      ["next"] = 2873;
      ["sort"] = "Tanaris";
      ["name_cn"] = "斯杜雷的??";
      ["name_fr"] = "Les dettes de Stoley";
      ["name_de"] = "Stoleys Schuld";
      ["faction"] = "Horde";
      ["name"] = "Stoley's Debt";
      ["level"] = 45;
      ["name_es"] = "La deuda de Stoley";
      ["req"] = 40;
   };
   [2880] = {
      ["name_ru"] = "Ожерелья троллей";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Troll Tribal Necklaces to Fraggar Thundermantle in Aerie Peak.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "巨魔部族??";
      ["name_fr"] = "Chasse au collier troll";
      ["name_de"] = "Kopfgeld fur Trollhalsketten";
      ["faction"] = "Alliance";
      ["name"] = "Troll Necklace Bounty";
      ["level"] = 45;
      ["name_es"] = "Los collares de trols";
      ["req"] = 40;
   };
   [7847] = {
      ["name_ru"] = "Возвращение к старейшине племени Сломанного Клыка";
      ["type"] = "Group";
      ["name_fr"] = "Retourner voir l’Ainee Brocherompue";
      ["name_de"] = "Ruckkehr zu Ura Stumpfhauer";
      ["reward"] = {
         [1] = 19114;
         [2] = 19115;
      };
      ["name_cn"] = "向断?族??命";
      ["objective"] = "Elder Torntusk at Jintha'alor wants you to return to Primal Torntusk at Revantusk Village with news of his rescue.";
      ["faction"] = "Horde";
      ["name"] = "Return to Primal Torntusk";
      ["sort"] = "The Hinterlands";
      ["prev"] = 7846;
      ["prequests"] = {
         [1] = 7846;
      };
      ["level"] = 51;
      ["name_es"] = "Regresa junto a Primigenia Colmillopartido";
      ["req"] = 46;
   };
   [6161] = {
      ["name_ru"] = "Сокровища Ракмора";
      ["type"] = "Solo";
      ["objective"] = "Find Rackmore's Silver Key.  Find Rackmore's Golden Key.  Find and open Rackmore's Chest.";
      ["name_fr"] = "Revendiquer le tresor de Rackmore?!";
      ["sort"] = "Desolace";
      ["name_cn"] = "拉克摩?的?宝！";
      ["reward"] = {
         [1] = 16788;
         [2] = 16789;
      };
      ["name_de"] = "Nehmt Rackmores Schatz!";
      ["faction"] = "Horde";
      ["name"] = "Claim Rackmore's Treasure!";
      ["level"] = 36;
      ["name_es"] = "La busqueda del tesoro de Masatormento";
      ["req"] = 30;
   };
   [2904] = {
      ["name_ru"] = "Катавасия";
      ["type"] = "Dungeon";
      ["objective"] = "Escort Kernobee to the Clockwerk Run exit and then report to Scooty in Booty Bay.";
      ["name_fr"] = "Une jolie pagaille";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "一?混乱";
      ["reward"] = {
         [1] = 9535;
         [2] = 9536;
      };
      ["name_de"] = "Eine schone Bescherung";
      ["faction"] = "Horde";
      ["name"] = "A Fine Mess";
      ["level"] = 30;
      ["name_es"] = "Un buen lio";
      ["req"] = 24;
   };
   [1618] = {
      ["name_ru"] = "Экипирование Красногорья";
      ["type"] = "Solo";
      ["objective"] = "Tormus Deepforge  wants you to bring 4 Runed Copper Belts and 4 Heavy Copper Mauls to Verner Osgood in Redridge.";
      ["repgain"] = {
         [72] = 250;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Le reequipement des Carmines";
      ["name_cn"] = "赤脊山的??";
      ["reward"] = {
         [1] = 6735;
      };
      ["name_de"] = "Die Aufrustung im Rotkammgebirge";
      ["faction"] = "Alliance";
      ["name"] = "Gearing Redridge";
      ["level"] = 16;
      ["name_es"] = "Equipar Crestagrana";
      ["req"] = 1;
   };
   [2284] = {
      ["name_ru"] = "Пропавшее ожерелье, этап 2";
      ["type"] = "Dungeon";
      ["name_fr"] = "Reparer le Collier, deuxieme prise";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_de"] = "Wiederbeschaffung der Halskette, Teil 2";
      ["name"] = "Necklace Recovery, Take 2";
      ["name_cn"] = "搜???，再来一次";
      ["objective"] = "Find a clue as to the gems' whereabouts in the depths of Uldaman.";
      ["next"] = 2318;
      ["faction"] = "Horde";
      ["sort"] = "Uldaman";
      ["prev"] = 2283;
      ["prequests"] = {
         [1] = 2283;
      };
      ["level"] = 41;
      ["name_es"] = "La recuperacion del collar, 2a parte";
      ["req"] = 37;
   };
   [2928] = {
      ["name_ru"] = "Сооружение автогиробуророек";
      ["type"] = "Dungeon";
      ["objective"] = "Bring twenty-four Robo-mechanical Guts to Shoni in Stormwind.";
      ["repgain"] = {
         [54] = 250;
         [72] = 250;
      };
      ["sort"] = "Gnomeregan";
      ["name_fr"] = "Excavateurs gyrodrilmatiques";
      ["name_cn"] = "陀螺式?掘机";
      ["reward"] = {
         [1] = 9608;
         [2] = 9609;
      };
      ["name_de"] = "Gyrobohrmatische Exkavation";
      ["faction"] = "Alliance";
      ["name"] = "Gyrodrillmatic Excavationators";
      ["level"] = 30;
      ["name_es"] = "Excavadoras gyroagujereamaticas";
      ["req"] = 20;
   };
   [2936] = {
      ["name_ru"] = "Паучья богиня";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le dieu-araignee";
      ["repgain"] = {
         [530] = 350;
      };
      ["name_de"] = "Der Spinnengott";
      ["name"] = "The Spider God";
      ["name_cn"] = "蜘蛛之神";
      ["objective"] = "Read from the Tablet of Theka to learn the name of the Witherbark spider god, then return to Master Gadrin.";
      ["next"] = 2937;
      ["faction"] = "Horde";
      ["sort"] = "Zul'Farrak";
      ["prev"] = 2935;
      ["prequests"] = {
         [1] = 2935;
      };
      ["level"] = 45;
      ["name_es"] = "Diosa arana";
      ["req"] = 40;
   };
   [5887] = {
      ["name_ru"] = "Лекарство из охотничьих трофеев";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Jagd";
      ["name_fr"] = "Du baume en chassant";
      ["name_cn"] = "狩???膏";
      ["name"] = "Salve via Hunting";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 5882;
      ["prequests"] = {
         [1] = 5882;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por caza";
      ["req"] = 48;
   };
   [5903] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["objective"] = "Use the Empty Termite Jar on the Termite Mounds in Eastern Plaguelands. After you've gathered 100 Plagueland Termites, return to Nathaniel Dumah at Chillwind Camp in Western Plaguelands.";
      ["next"] = 5904;
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "瘟疫与?";
      ["series"] = 1;
      ["name_de"] = "Eine Plage komme uber Euch";
      ["faction"] = "Alliance";
      ["name"] = "A Plague Upon Thee";
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [3127] = {
      ["name_ru"] = "Уменьшенный горный великан";
      ["type"] = "Group";
      ["name_fr"] = "Geant des montagnes miniaturise";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Bergriesenmuisek";
      ["followup"] = 3129;
      ["name_cn"] = "山?巨人?魂精?";
      ["objective"] = "Kill 7 Land Walkers or Cliff Giants. Use the Muisek Vessel to shrink and capture the fallen Mountain Giants.";
      ["faction"] = "Horde";
      ["name"] = "Mountain Giant Muisek";
      ["sort"] = "Feralas";
      ["prev"] = 3126;
      ["prequests"] = {
         [1] = 3126;
      };
      ["level"] = 50;
      ["name_es"] = "Muisek de gigante montes";
      ["req"] = 40;
   };
   [2968] = {
      ["name_ru"] = "Новое задание";
      ["type"] = "Solo";
      ["name_fr"] = "Travail imminent";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Eine zukunftige Aufgabe";
      ["name_cn"] = "?一?的任?";
      ["name"] = "A Future Task";
      ["objective"] = "Speak with Sage Truthseeker in Thunder Bluff.";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 2967;
      ["prequests"] = {
         [1] = 2967;
      };
      ["level"] = 50;
      ["name_es"] = "Una tarea futura";
      ["req"] = 45;
   };
   [2976] = {
      ["name_ru"] = "Зловещее открытие";
      ["objective"] = "Bring the Crate of Grimtotem Horns to Belgrom Rockmaul in Orgrimmar.";
      ["name_cn"] = "可怕的??";
      ["sort"] = "Feralas";
      ["level"] = 45;
      ["type"] = "Solo";
      ["name_fr"] = "Une decouverte sinistre";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Eine grausige Entdeckung";
      ["reward"] = {
         [1] = 11858;
         [2] = 11859;
      };
      ["faction"] = "Horde";
      ["name"] = "A Grim Discovery";
      ["prev"] = 2974;
      ["prequests"] = {
         [1] = 2974;
      };
      ["series"] = 2;
      ["name_es"] = "Un descubrimiento siniestro";
      ["req"] = 37;
   };
   [2984] = {
      ["name_ru"] = "Зов Огня";
      ["type"] = "Solo";
      ["objective"] = "Find Kranal Fiss in the Barrens.";
      ["next"] = 1524;
      ["sort"] = "Shaman";
      ["name_cn"] = "火?的召?";
      ["name_fr"] = "L'appel du feu";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1524;
      ["name_de"] = "Ruf des Feuers";
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["level"] = 10;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [2992] = {
      ["name_ru"] = "Прорицание";
      ["type"] = "Solo";
      ["name_fr"] = "La Divination";
      ["repgain"] = {
         [47] = 25;
      };
      ["name_de"] = "Die Weissagung";
      ["name"] = "The Divination";
      ["name_cn"] = "占卜";
      ["objective"] = "Wait until Grimshade performs the ritual of divination.";
      ["next"] = 2993;
      ["faction"] = "Alliance";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2991;
      ["prequests"] = {
         [1] = 2991;
      };
      ["level"] = 47;
      ["name_es"] = "El ritual de adivinacion";
      ["req"] = 40;
   };
   [3000] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge.";
      ["next"] = 1645;
      ["name_de"] = "Foliant der Offenbarung";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["name_fr"] = "Le Tome de divinite";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "Tome of Divinity";
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [2862] = {
      ["name_ru"] = "Война с племенем Древолапов";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Woodpaw Gnoll Manes to Hadoken Swiftstrider in Camp Mojache.";
      ["next"] = 2863;
      ["name_fr"] = "La guerre avec les Griffebois";
      ["sort"] = "Feralas";
      ["name_cn"] = "与豺狼人??";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_de"] = "Krieg gegen die Waldpfoten";
      ["faction"] = "Horde";
      ["name"] = "War on the Woodpaw";
      ["level"] = 42;
      ["name_es"] = "En guerra con los Zarpalena";
      ["req"] = 39;
   };
   [6031] = {
      ["name_ru"] = "Руническая ткань";
      ["type"] = "Solo";
      ["objective"] = "Bring 30 Runecloth to Meilosh in Timbermaw Hold.";
      ["repgain"] = {
         [576] = 100;
      };
      ["sort"] = "Timbermaw Hold";
      ["name_fr"] = "L'etoffe runique";
      ["name_cn"] = "符文布";
      ["reward"] = {
         [1] = 15822;
         [2] = 15823;
      };
      ["name_de"] = "Runenstoff";
      ["faction"] = "Horde";
      ["name"] = "Runecloth";
      ["level"] = 55;
      ["name_es"] = "Pano runico";
      ["req"] = 50;
   };
   [4242] = {
      ["name_ru"] = "Утраченная надежда";
      ["type"] = "Dungeon";
      ["objective"] = "Give Marshal Maxwell the bad news.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Verlorene Hoffnung";
      ["reward"] = {
         [1] = 12018;
         [2] = 12021;
         [3] = 12041;
      };
      ["name_cn"] = "被?弃的希望";
      ["name_fr"] = "Espoir abandonne";
      ["faction"] = "Alliance";
      ["name"] = "Abandoned Hope";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4241;
      ["prequests"] = {
         [1] = 4241;
      };
      ["level"] = 54;
      ["name_es"] = "Esperanza perdida";
      ["req"] = 48;
   };
   [6063] = {
      ["name_ru"] = "Приручение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6101;
      ["name_de"] = "Die Zahmung der Bestie";
      ["name_cn"] = "?服野?";
      ["objective"] = "Use the Taming Rod to tame a Webwood Lurker. Practice your skills, then return the Taming Rod to Dazalar in Dolanaar.";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["series"] = 1;
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [6184] = {
      ["name_ru"] = "Флинт Тенемор";
      ["type"] = "Group";
      ["name_fr"] = "Flint Ombrelongue";
      ["next"] = 6185;
      ["name_de"] = "Flint Schattenmoor";
      ["name_cn"] = "弗林特・沙多摩?";
      ["objective"] = "Travel to Chillwind Camp in the Western Plaguelands and meet up with your contact, Flint Shadowmore.$B";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "Flint Shadowmore";
      ["prev"] = 6183;
      ["prequests"] = {
         [1] = 6183;
      };
      ["level"] = 60;
      ["name_es"] = "Flint Sombramas";
      ["req"] = 56;
   };
   [4293] = {
      ["name_ru"] = "Проба слизи...";
      ["type"] = "Solo";
      ["objective"] = "Gather Felwood Slime Samples from any of the slimes in Felwood. Then, using the Testing Equipment next to Chemist Fuely in Undercity, see which of your samples are the most corrupt. Bring 5 of the Corrupted Felwood Samples you find to Chemist Fuely.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Un echantillon de gelee...";
      ["sort"] = "Undercity";
      ["name_cn"] = "?泥怪的?本…";
      ["followup"] = 4642;
      ["name_de"] = "Eine Schleimprobe...";
      ["faction"] = "Horde";
      ["name"] = "A Sample of Slime...";
      ["level"] = 52;
      ["name_es"] = "Muestras de babosa...";
      ["req"] = 48;
   };
   [4681] = {
      ["name_ru"] = "Останки на берегу";
      ["objective"] = "Recover the Sea Turtle Remains from the Skeletal Sea Turtle in the waters west of Auberdine, and then speak with Gwennyth Bly'Leggonde back in Auberdine.";
      ["name_cn"] = "?浅的巨?";
      ["sort"] = "Darkshore";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Echouage";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "An Land gespult";
      ["reward"] = {
         [1] = 15398;
         [2] = 15399;
         [3] = 15400;
      };
      ["faction"] = "Alliance";
      ["name"] = "Washed Ashore";
      ["prev"] = 3524;
      ["prequests"] = {
         [1] = 3524;
      };
      ["series"] = 2;
      ["name_es"] = "Varado";
      ["req"] = 11;
   };
   [6127] = {
      ["name_ru"] = "Основной источник";
      ["objective"] = "Use the Empty Dreadmist Peak Sampler to draw a sample of water from a pool at the top of the peak.$B$BDeliver the Filled Dreadmist Peak Sampler to Tonga Runetotem at the Crossroads, Barrens.";
      ["name_cn"] = "毒水之源";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Le principe originel";
      ["next"] = 6128;
      ["name_de"] = "Die eigentliche Ursache";
      ["classes"] = {
         [1] = "Druid";
      };
      ["repgain"] = {
         [609] = 75;
      };
      ["name"] = "The Principal Source";
      ["prev"] = 6126;
      ["prequests"] = {
         [1] = 6126;
      };
      ["sort"] = "Druid";
      ["name_es"] = "La fuente del envenenamiento";
      ["req"] = 14;
   };
   [6143] = {
      ["name_ru"] = "Смерть земноводным!";
      ["type"] = "Solo";
      ["objective"] = "Slay 7 Slitherblade Myrmidon, 7 Slitherblade Naga, and 5 Slitherblade Sorceresses, and then talk to Drulzegar at Shadowprey in Desolace.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "D'autres poissons-chats a fouetter";
      ["sort"] = "Desolace";
      ["name_cn"] = "?一??";
      ["name_de"] = "Andere Fische zu grillen";
      ["faction"] = "Horde";
      ["name"] = "Other Fish to Fry ";
      ["level"] = 36;
      ["name_es"] = "Otros pescados para freir";
      ["req"] = 32;
   };
   [8221] = {
      ["name_ru"] = "Редкая рыба ? рыба-ангел Кифэра";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Poisson rare : le scalaire de Keefer";
      ["name_cn"] = "稀有?? - 基佛天使?";
      ["reward"] = {
         [1] = 19972;
      };
      ["name_de"] = "Besonderer Fisch - Kiefers Engelfisch";
      ["faction"] = "Horde";
      ["name"] = "Rare Fish - Keefer's Angelfish";
      ["level"] = 0;
      ["name_es"] = "Pez raro: pez angel de Keefer";
      ["req"] = 1;
   };
   [8253] = {
      ["name_ru"] = "Уничтожить Морфаза";
      ["type"] = "Dungeon";
      ["name_fr"] = "Detruire Morphaz";
      ["name_de"] = "Vernichtet Morphaz";
      ["objective"] = "Retrieve the Arcane Shard from Morphaz and return to Archmage Xylem.";
      ["reward"] = {
         [1] = 20035;
         [2] = 20037;
         [3] = 20036;
      };
      ["name_cn"] = "??摩弗拉斯";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Destroy Morphaz";
      ["sort"] = "Mage";
      ["prev"] = 8252;
      ["prequests"] = {
         [1] = 8252;
      };
      ["level"] = 52;
      ["name_es"] = "Destruye a Morphaz";
      ["req"] = 50;
   };
   [3096] = {
      ["name_ru"] = "Зашифрованный свиток";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin code";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Verschlusselte Rolle";
      ["objective"] = "Read the Encrypted Scroll and speak to David Trias in Deathknell.";
      ["name_cn"] = "密文卷?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Scroll";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 1;
      ["name_es"] = "Un pergamino codificado";
      ["req"] = 1;
   };
   [8317] = {
      ["name_ru"] = "Помощь по кухне";
      ["type"] = "Solo";
      ["name_fr"] = "Un coup de main a la cuisine";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Kuchengehilfe";
      ["name_cn"] = "下厨";
      ["name"] = "Kitchen Assistance";
      ["objective"] = "Calandrath at Cenarion Hold needs a batch of 10 Smoked Desert Dumplings.";
      ["faction"] = "Horde";
      ["sort"] = "Cooking";
      ["prev"] = 8313;
      ["prequests"] = {
         [1] = 8313;
      };
      ["level"] = 57;
      ["name_es"] = "Echar una mano en la cocina";
      ["req"] = 54;
   };
   [8349] = {
      ["name_ru"] = "Бор Буйногривый";
      ["type"] = "Group";
      ["name_fr"] = "Bor Crin-sauvage";
      ["next"] = 8348;
      ["name_de"] = "Bor Wildmahne";
      ["name_cn"] = "??・蛮?";
      ["objective"] = "Speak with Bor Wildmane in Cenarion Hold.";
      ["sort"] = "Silithus";
      ["faction"] = "Horde";
      ["name"] = "Bor Wildmane";
      ["prev"] = 8332;
      ["prequests"] = {
         [1] = 8332;
      };
      ["level"] = 60;
      ["name_es"] = "Bor Ferocrin";
      ["req"] = 60;
   };
   [3120] = {
      ["name_ru"] = "Зеленый знак";
      ["type"] = "Solo";
      ["name_fr"] = "Le cachet verdoyant";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Tiefgrunes Siegelzeichen";
      ["objective"] = "Read the Verdant Sigil and speak to Mardant Strongoak, in the tree Aldrassil in Shadowglen.";
      ["name_cn"] = "?色符?";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Verdant Sigil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 456;
      ["prequests"] = {
         [1] = 456;
      };
      ["level"] = 1;
      ["name_es"] = "El sigilo verdeante";
      ["req"] = 1;
   };
   [3128] = {
      ["name_ru"] = "Природные материалы";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Splintered Logs, 6 Encrusted Minerals, 20 pieces of Resilient Sinew, and 40 Metallic Fragments to Witch Doctor Uzer'i in Camp Mojache.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Materiaux naturels";
      ["sort"] = "Feralas";
      ["name_cn"] = "天然材料";
      ["followup"] = 3129;
      ["name_de"] = "Naturliche Materialien";
      ["faction"] = "Horde";
      ["name"] = "Natural Materials";
      ["level"] = 50;
      ["name_es"] = "Materiales naturales";
      ["req"] = 40;
   };
   [3141] = {
      ["name_ru"] = "Лорам";
      ["type"] = "Solo";
      ["name_fr"] = "Loramus";
      ["next"] = 3508;
      ["name_de"] = "Loramus";
      ["name_cn"] = "洛拉姆斯";
      ["objective"] = "Listen to Loramus Thalipedes tell his story.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Loramus";
      ["prev"] = 2744;
      ["prequests"] = {
         [1] = 2744;
      };
      ["level"] = 57;
      ["name_es"] = "Loramus";
      ["req"] = 45;
   };
   [8762] = {
      ["name_ru"] = "Метцен-северный олень";
      ["type"] = "Solo";
      ["objective"] = "Find Metzen the Reindeer.  Use the notes provided to you for clues as to where he is being held.$B$BWhen you find Metzen, have the Pouch of Reindeer Dust in your possession so you can sprinkle some of the dust on him; this should free Metzen from his bonds of captivity.$B$BReturn the Pouch of Reindeer Dust to Wulmort Jinglepocket in Ironforge once Metzen is freed.";
      ["repgain"] = {
         [169] = 500;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Metzen le renne";
      ["name_cn"] = "?鹿梅森";
      ["reward"] = {
         [1] = 21213;
      };
      ["name_de"] = "Metzen das Rentier";
      ["faction"] = "Alliance";
      ["name"] = "Metzen the Reindeer";
      ["level"] = 60;
      ["name_es"] = "Metzen el reno";
      ["req"] = 40;
   };
   [8509] = {
      ["name_ru"] = "Альянсу не хватает слез Артаса!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Arthas' Tears to Sergeant Major Germaine at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de larmes d'Arthas?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要阿??斯之泪！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_de"] = "Die Allianz braucht Arthas' Tranen!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Arthas' Tears!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita lagrimas de Arthas!";
      ["req"] = 34;
   };
   [8541] = {
      ["name_ru"] = "Шлифовальные камни";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Dense Grinding Stones, 10 Solid Grinding Stones and 10 Heavy Grinding Stones to Vish Kozus, Captain of the Guard at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing III in order to complete this quest.";
      ["name_fr"] = "Des silex a aiguiser pour la Garde";
      ["sort"] = "Silithus";
      ["name_cn"] = "?兵的磨刀石";
      ["reward"] = {
         [1] = 20800;
         [2] = 21132;
      };
      ["name_de"] = "Schleifsteine fur die Wache";
      ["faction"] = "Alliance";
      ["name"] = "Grinding Stones for the Guard";
      ["level"] = 60;
      ["name_es"] = "Piedra de pulir para la guardia";
      ["req"] = 60;
   };
   [8573] = {
      ["name_ru"] = "Броня защитника";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Cenarion Combat Badges, 20 Cenarion Logistics Badges, 20 Cenarion Tactical Badges and 1 Mark of Cenarius to Vargus at Cenarion Hold in Silithus.  You must also attain Exalted reputation with Cenarion Circle to be able to complete this quest.$B";
      ["name_fr"] = "Equipement de guerre de champion";
      ["sort"] = "Silithus";
      ["name_cn"] = "勇士的装?";
      ["reward"] = {
         [1] = 21188;
         [2] = 21190;
         [3] = 21180;
      };
      ["name_de"] = "Schlachtrustung des Feldherrn";
      ["faction"] = "Horde";
      ["name"] = "Champion's Battlegear";
      ["level"] = 60;
      ["name_es"] = "Equipamiento de Campeon";
      ["req"] = 60;
   };
   [8605] = {
      ["name_ru"] = "Орде все еще не хватает шерстяных бинтов!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Wool Bandages to Healer Longrunner at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Wollverbande!";
      ["name_fr"] = "La Horde a besoin de plus de bandages en laine !";
      ["name_cn"] = "部落需要更多????！";
      ["name"] = "The Horde Needs More Wool Bandages!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8604;
      ["prequests"] = {
         [1] = 8604;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas vendas de lana!";
      ["req"] = 1;
   };
   [8637] = {
      ["name_ru"] = "Сапоги торговца смертью";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of Strife, 5 Crystal Scarabs and 5 Bone Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "死亡?行者的?靴";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes du dispensateur de mort";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Stiefel des Todesboten";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21359;
      };
      ["name"] = "Deathdealer's Boots";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas de mortifero";
      ["req"] = 60;
   };
   [8669] = {
      ["name_ru"] = "Наплечные пластины сотворения";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of Strife, 5 Gold Scarabs and 5 Bone Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "起源?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le protege-epaules de la genese";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schulterpolster der Genesis";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21354;
      };
      ["name"] = "Genesis Shoulderpads";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las hombreras genesis";
      ["req"] = 60;
   };
   [8701] = {
      ["name_ru"] = "Кольцо сокрытых теней";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ceremonial Ring, 2 Onyx Idols, 5 Stone Scarabs and 5 Crystal Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau des ombres voilees";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?罩?影之戒";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21405;
      };
      ["name_de"] = "Band der Schattenschleier";
      ["faction"] = "Horde";
      ["name"] = "Band of Veiled Shadows";
      ["level"] = 60;
      ["name_es"] = "La sortija de las sombras ocultas";
      ["req"] = 60;
   };
   [8733] = {
      ["name_ru"] = "Эраникус, Тиран Сна";
      ["type"] = "Solo";
      ["objective"] = "Travel to the continent of Teldrassil and find Malfurion's agent somewhere outside the walls of Darnassus.$B";
      ["next"] = 8734;
      ["name_fr"] = "Eranikus, le tyran du Reve";
      ["sort"] = "Sunken Temple";
      ["name_cn"] = "伊?尼?斯，梦境之暴君";
      ["repgain"] = {
         [910] = 25;
         [609] = 25;
      };
      ["name_de"] = "Eranikus, der Tyrann des Traums";
      ["faction"] = "Horde";
      ["name"] = "Eranikus, Tyrant of the Dream";
      ["level"] = 60;
      ["name_es"] = "Eranikus, el Tirano del Sueno";
      ["req"] = 60;
   };
   [8765] = {
      ["name_ru"] = "Изменение пути ? уже не заклинатель";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "Changer de voie - adieu a l'Invocateur";
      ["name_cn"] = "??祈求者之路";
      ["reward"] = {
         [1] = 21200;
         [2] = 21205;
      };
      ["name_de"] = "Den Pfad wechseln - Kein Herbeirufer mehr";
      ["faction"] = "Horde";
      ["name"] = "The Changing of Paths - Invoker No More";
      ["level"] = 60;
      ["name_es"] = "Cambio de ruta: convocador, nunca mas";
      ["req"] = 60;
   };
   [8797] = {
      ["name_ru"] = "Альянсу нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Field Marshal Snowfall in Ironforge's Military Ward.";
      ["name_cn"] = "?盟需要?的?助！";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_de"] = "Die Allianz braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza te necesita!";
      ["req"] = 1;
   };
   [8829] = {
      ["name_ru"] = "Последняя хитрость";
      ["type"] = "Group";
      ["objective"] = "Bring a Skin of Shadow, 3 Frayed Abomination Stitchings and 1 Twilight Cultist Robe to Aurel Goldleaf at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing XI in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 100;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "L'ultime ruse";
      ["name_cn"] = "沙漠生存包";
      ["reward"] = {
         [1] = 21515;
      };
      ["name_de"] = "Die ultimative Tauschung";
      ["faction"] = "Horde";
      ["name"] = "The Ultimate Deception";
      ["level"] = 60;
      ["name_es"] = "El ultimo engano";
      ["req"] = 60;
   };
   [8861] = {
      ["name_ru"] = "Отмечаем Новый Год!";
      ["type"] = "Solo";
      ["objective"] = "Bring the Smokywood Supplies to Innkeeper Pala in Thunder Bluff.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Les fetes du Nouvel an !";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?祝新年！";
      ["name_de"] = "Neujahrsfeier!";
      ["faction"] = "Horde";
      ["name"] = "New Year Celebrations!";
      ["level"] = 70;
      ["name_es"] = "!Las fiestas de Ano Nuevo!";
      ["req"] = 60;
   };
   [8893] = {
      ["name_ru"] = "Супер Яйц-О-Матик";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Super-Ei-o-Mat";
      ["name_fr"] = "Le Super-Oeuf-O-Matic";
      ["name_cn"] = "超??蛋器";
      ["name"] = "The Super Egg-O-Matic";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 8647;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 2741;
      ["prequests"] = {
         [1] = 2741;
      };
      ["level"] = 47;
      ["name_es"] = "El Superhuevomatico";
      ["req"] = 42;
   };
   [8925] = {
      ["name_ru"] = "Портативный источник энергии";
      ["type"] = "Solo";
      ["name_fr"] = "Une source d’energie portable";
      ["next"] = 8928;
      ["name_de"] = "Eine portable Energiequelle";
      ["name_cn"] = "便携的能量源";
      ["objective"] = "Find Magma Lord Bokk in the Burning Steppes, obtain his Magma Core and bring it to Mux Manascrambler in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "A Portable Power Source";
      ["prev"] = 8924;
      ["prequests"] = {
         [1] = 8924;
      };
      ["level"] = 60;
      ["name_es"] = "Fuente de energia portatil";
      ["req"] = 58;
   };
   [8957] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Boots of Elements, Kilt of Elements and Pauldrons of Elements.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22096;
         [2] = 22100;
         [3] = 22101;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [8989] = {
      ["name_ru"] = "Правая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau droit de l'amulette du seigneur Valthal";
      ["next"] = 8994;
      ["name_de"] = "Das rechte Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Mor Grayhoof and slay him. Return to Bodley inside Blackrock Mountain with the recombined Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦?拉克?符的右半?";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "The Right Piece of Lord Valthalak's Amulet";
      ["followup"] = 8994;
      ["prev"] = 8986;
      ["prequests"] = {
         [1] = 8986;
      };
      ["level"] = 60;
      ["name_es"] = "La parte derecha del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [9021] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Mokvar in Orgimmar with a set of Dreadmist Sandals, Dreadmist Leggings and Dreadmist Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 9032;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 9032;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22076;
         [2] = 22072;
         [3] = 22073;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [9053] = {
      ["name_ru"] = "Лучший ингредиент";
      ["type"] = "Dungeon";
      ["name_fr"] = "Un meilleur ingredient";
      ["name_de"] = "Eine bessere Zutat";
      ["objective"] = "Retrieve a Putrid Vine from the guardian at the bottom of the Sunken Temple and return to Torwa Pathfinder.";
      ["reward"] = {
         [1] = 22274;
         [2] = 22272;
         [3] = 22458;
      };
      ["name_cn"] = "更好的材料";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "A Better Ingredient";
      ["sort"] = "Druid";
      ["prev"] = 9051;
      ["prequests"] = {
         [1] = 9051;
      };
      ["level"] = 52;
      ["name_es"] = "Un ingrediente mejor";
      ["req"] = 50;
   };
   [9085] = {
      ["name_ru"] = "Тени Рока";
      ["type"] = "Group";
      ["objective"] = "Go to a summoning circle and kill a Shadow of Doom, then return to Commander Thomas Helleran at Light's Hope Chapel in Eastern Plaguelands.";
      ["name_fr"] = "Les ombres du destin";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "末日之影";
      ["reward"] = {
         [1] = 23123;
         [2] = 23122;
      };
      ["name_de"] = "Schatten der Verdammnis";
      ["faction"] = "Horde";
      ["name"] = "Shadows of Doom";
      ["level"] = 60;
      ["name_es"] = "Sombras del Apocalipsis";
      ["req"] = 55;
   };
   [9117] = {
      ["name_ru"] = "Пояс веры";
      ["type"] = "Raid";
      ["name_fr"] = "La ceinture de foi";
      ["name_de"] = "Gurtel des Glaubens";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make a Belt of Faith if you bring him the following: 1 Desecrated Belt, 8 Wartorn Cloth Scraps, 2 Arcane Crystals and 2 Mooncloth.";
      ["reward"] = {
         [1] = 22518;
      };
      ["name_cn"] = "信仰腰?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Belt of Faith";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El cinturon de fe";
      ["req"] = 60;
   };
   [6623] = {
      ["name_ru"] = "Травматология";
      ["type"] = "Solo";
      ["objective"] = "Travel to Hammerfall in the Arathi Highlands and speak with Doctor Gregory Victor about joining the ranks of Horde Trauma.$B";
      ["next"] = 6622;
      ["sort"] = "First Aid";
      ["name_cn"] = "部落医??";
      ["name_fr"] = "Service de traumatologie de la Horde";
      ["name_de"] = "Traumachirurg der Horde";
      ["faction"] = "Horde";
      ["name"] = "Horde Trauma";
      ["level"] = 45;
      ["name_es"] = "Dispensario de la Horda";
      ["req"] = 35;
   };
   [9181] = {
      ["name_ru"] = "Задание мастера: вулканический молот";
      ["type"] = "Solo";
      ["objective"] = "Deliver 3 Volcanic Hammers and the Craftsman's Writ - Volcanic Hammer - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Marteaux volcaniques";
      ["name_cn"] = "工匠文? - 火山??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Vulkanischer Hammer";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Volcanic Hammer";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: martillo volcanico";
      ["req"] = 55;
   };
   [9213] = {
      ["name_ru"] = "Теневая защита";
      ["type"] = "Solo";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands wants 10 Insignia of the Crusade and 30 gold.";
      ["name_fr"] = "L'Ombregarde";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "暗影戒?";
      ["reward"] = {
         [1] = 22638;
      };
      ["name_de"] = "Der Schattenwachter";
      ["faction"] = "Horde";
      ["name"] = "The Shadow Guard";
      ["level"] = 60;
      ["name_es"] = "El guardasombras";
      ["req"] = 60;
   };
   [9245] = {
      ["name_ru"] = "Рукавицы из ледяной чешуи";
      ["type"] = "Raid";
      ["name_fr"] = "Les gantelets glacecaille";
      ["name_de"] = "Eisschuppenstulpen";
      ["reward"] = {
         [1] = 22666;
      };
      ["name_cn"] = "冰??手";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 5 Frozen Runes, 16 Heavy Scorpid Scale, 5 Essence of Water, 3 Cured Rugged Hides and 200 gold.";
      ["faction"] = "Horde";
      ["name"] = "Icy Scale Gauntlets";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "Los guanteletes de escamas heladas";
      ["req"] = 60;
   };
   [4762] = {
      ["name_ru"] = "Река Скалистая";
      ["type"] = "Solo";
      ["name_fr"] = "La Bondissante";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Der Klippenquell";
      ["name_cn"] = "壁泉河";
      ["name"] = "The Cliffspring River";
      ["objective"] = "Travel north of Auberdine to the first waterfall along the Cliffspring River and draw a sample from the pool there.$B$BReturn to Thundris Windweaver in Auberdine with the Cliffspring River Sample.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4761;
      ["prequests"] = {
         [1] = 4761;
      };
      ["level"] = 15;
      ["name_es"] = "El Rio Fonroca";
      ["req"] = 11;
   };
   [8354] = {
      ["name_ru"] = "Курочка с мятой";
      ["type"] = "Solo";
      ["objective"] = "Do a chicken emote at Innkeeper Norman, and in exchange you'll receive an Undercity Mint!";
      ["name_fr"] = "Caqueter pour un bonbon a la menthe";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "学小?，?糖果";
      ["reward"] = {
         [1] = 20491;
      };
      ["name_de"] = "Huhnchengegacker fur ein Pfefferminzbonbon";
      ["faction"] = "Horde";
      ["name"] = "Chicken Clucking for a Mint";
      ["level"] = 60;
      ["name_es"] = "Una menta por cacarear como un pollo";
      ["req"] = 10;
   };
   [9341] = {
      ["name_ru"] = "Гербовая накидка Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?色黎明?袍";
      ["reward"] = {
         [1] = 22999;
      };
      ["name_de"] = "Wappenrock der Argentumdammerung";
      ["faction"] = "Horde";
      ["name"] = "Tabard of the Argent Dawn";
      ["level"] = 0;
      ["name_es"] = "Tabardo de El Alba Argenta";
      ["req"] = 50;
   };
   [3368] = {
      ["name_ru"] = "Камни Сунтары";
      ["objective"] = "Take the Singed Letter to Thorius in Ironforge. He is in the Hall of Explorers.";
      ["name_cn"] = "?塔拉之石";
      ["sort"] = "Searing Gorge";
      ["level"] = 48;
      ["type"] = "Solo";
      ["name_fr"] = "Les pierres de Suntara";
      ["next"] = 3371;
      ["name_de"] = "Suntarasteine";
      ["repgain"] = {
         [47] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Suntara Stones";
      ["prev"] = 3367;
      ["prequests"] = {
         [1] = 3367;
      };
      ["series"] = 2;
      ["name_es"] = "Piedras de Suntara";
      ["req"] = 40;
   };
   [3376] = {
      ["name_ru"] = "Сразить Остроклыка!";
      ["type"] = "Solo";
      ["objective"] = "Bring the head of Chief Sharptusk Thornmantle to Brave Windfeather in Red Cloud Mesa.";
      ["repgain"] = {
         [81] = 500;
      };
      ["sort"] = "Red Cloud Mesa";
      ["name_fr"] = "La fin de Brochaigu?!";
      ["name_cn"] = "刺?酋?";
      ["reward"] = {
         [1] = 10635;
         [2] = 10636;
      };
      ["name_de"] = "Totet Spitzhauer!";
      ["faction"] = "Horde";
      ["name"] = "Break Sharptusk!";
      ["level"] = 5;
      ["name_es"] = "La cabeza de Cornapunta";
      ["req"] = 3;
   };
   [1951] = {
      ["name_ru"] = "Обряды власти";
      ["type"] = "Dungeon";
      ["name_fr"] = "Rituels du Pouvoir";
      ["name_de"] = "Rituale der Macht";
      ["objective"] = "Bring the book Rituals of Power to Tabetha in Dustwallow Marsh.";
      ["name_cn"] = "能量?祭";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Rituals of Power";
      ["prev"] = 1950;
      ["prequests"] = {
         [1] = 1950;
      };
      ["level"] = 40;
      ["name_es"] = "Rituales de poder";
      ["req"] = 30;
   };
   [1184] = {
      ["name_ru"] = "Части роя";
      ["objective"] = "Return to Belgrom Rockmaul in Orgrimmar.";
      ["name_cn"] = "虫群的消息";
      ["sort"] = "Thousand Needles";
      ["level"] = 35;
      ["type"] = "Solo";
      ["name_fr"] = "Des parties de l'Essaim";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Teile des Schwarms";
      ["reward"] = {
         [1] = 6737;
         [2] = 6738;
      };
      ["faction"] = "Horde";
      ["name"] = "Parts of the Swarm";
      ["prev"] = 1148;
      ["prequests"] = {
         [1] = 1148;
      };
      ["series"] = 2;
      ["name_es"] = "Pedazos del enjambre";
      ["req"] = 28;
   };
   [8900] = {
      ["name_ru"] = "Дорогая моя Эления!";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Slightly Creased Note to Elenia Haydon near the bank in the Undercity.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的艾琳娜";
      ["name_fr"] = "Tres chere Elenia,";
      ["name_de"] = "Liebste Elenia";
      ["faction"] = "Horde";
      ["name"] = "Dearest Elenia,";
      ["level"] = 70;
      ["name_es"] = "Queridisima Elenia:";
      ["req"] = 52;
   };
   [1507] = {
      ["name_ru"] = "Пожиратель Душ";
      ["type"] = "Solo";
      ["objective"] = "Speak with Cazul in the Cleft of Shadow.";
      ["next"] = 1508;
      ["sort"] = "Warlock";
      ["name_cn"] = "噬魂者";
      ["name_fr"] = "La devoreuse d'ames";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Verschlinger der Seelen";
      ["faction"] = "Horde";
      ["name"] = "Devourer of Souls";
      ["level"] = 20;
      ["name_es"] = "Devoradora de almas";
      ["req"] = 20;
   };
   [4507] = {
      ["name_ru"] = "Пешка берет королеву";
      ["type"] = "Solo";
      ["name_fr"] = "Le pion prend la reine";
      ["name_de"] = "Bauer schlagt Dame";
      ["name_cn"] = "捕捉皇后";
      ["objective"] = "Defeat the Gorishi Hive Queen once she is summoned.$B$BBring the Gorishi Queen's Brain to Alchemist Pestlezugg in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Pawn Captures Queen";
      ["prev"] = 4496;
      ["prequests"] = {
         [1] = 4496;
      };
      ["level"] = 54;
      ["name_es"] = "El senuelo atrapa a la reina";
      ["req"] = 50;
   };
   [6847] = {
      ["name_ru"] = "Всевидящее око мастера Рисона";
      ["type"] = "PvP";
      ["objective"] = "Recover Master Ryson's All Seeing Eye from the Winterax caves and return it to Master Ryson.$B$BBe warned, it is said that Master Ryson's All Seeing Eye carries with it a terrible curse!";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "雷?松的全?之眼";
      ["name_fr"] = "L'?il qui voit tout de maitre Ryson";
      ["name_de"] = "Meister Rysons Allsehendes Auge";
      ["faction"] = "Horde";
      ["name"] = "Master Ryson's All Seeing Eye";
      ["level"] = 60;
      ["name_es"] = "El ojo que todo lo ve del maestro Ryson";
      ["req"] = 51;
   };
   [5507] = {
      ["name_ru"] = "Оплечья Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Argent Dawn Valor Tokens to Quartermaster Lightspark at Chillwind Camp, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "黎明?肩";
      ["name_fr"] = "Les mantelets de l'aube";
      ["name_de"] = "Mantel der Dammerung";
      ["faction"] = "Alliance";
      ["name"] = "Mantles of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Mantos del Alba";
      ["req"] = 55;
   };
   [1246] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1447;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Speak to Dashel Stonefist in Stormwind.";
      ["series"] = 7;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1245;
      ["prequests"] = {
         [1] = 1245;
      };
      ["level"] = 31;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [3448] = {
      ["name_ru"] = "Передача поручения";
      ["type"] = "Solo";
      ["objective"] = "Speak to Tymor in Ironforge.";
      ["next"] = 3449;
      ["sort"] = "Ironforge";
      ["name_cn"] = "委以重任";
      ["name_fr"] = "La transmission du fardeau";
      ["name_de"] = "Die Burde weitergeben";
      ["faction"] = "Alliance";
      ["name"] = "Passing the Burden";
      ["level"] = 52;
      ["name_es"] = "Encargarse de la investigacion";
      ["req"] = 45;
   };
   [4131] = {
      ["name_ru"] = "Гноллы из стаи Древолапов";
      ["type"] = "Solo";
      ["name_fr"] = "Les gnolls Griffebois";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Die Waldpfotengnolle";
      ["name"] = "The Woodpaw Gnolls";
      ["name_cn"] = "木爪豺狼人";
      ["objective"] = " but something tells me that's not what occurred.  Still";
      ["next"] = 4135;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 4130;
      ["prequests"] = {
         [1] = 4130;
      };
      ["level"] = 44;
      ["name_es"] = "Los gnolls Zarpalena";
      ["req"] = 40;
   };
   [8246] = {
      ["name_ru"] = "Перстни Зандалара";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Cachets des Zandalar";
      ["name_cn"] = "??拉的徽?";
      ["reward"] = {
         [1] = 20077;
         [2] = 20076;
         [3] = 20078;
      };
      ["name_de"] = "Das Siegel der Zandalari";
      ["faction"] = "Horde";
      ["name"] = "Signets of the Zandalar";
      ["level"] = 60;
      ["name_es"] = "Las sortijas de Zandalar";
      ["req"] = 58;
   };
   [6943] = {
      ["name_ru"] = "Небо зовет ? флот Ромеона";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 5;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "L'appel des airs - l'escadrille d'Ichman";
      ["name_cn"] = "天空的召? - 艾克曼的空?";
      ["name_de"] = "Ruf der Lufte - Ichmans Luftflotte";
      ["faction"] = "Alliance";
      ["name"] = "Call of Air - Ichman's Fleet";
      ["level"] = 60;
      ["name_es"] = "La llamada del aire: la flota de Ichman";
      ["req"] = 51;
   };
   [8250] = {
      ["name_ru"] = "Магическое искусство";
      ["type"] = "Solo";
      ["objective"] = "Seek out Sanath Lim-yo and gain passage to see Archmage Xylem.";
      ["sort"] = "Mage";
      ["name_cn"] = "法?的会?";
      ["name_fr"] = "L'art du mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Geschick der Magier";
      ["faction"] = "Horde";
      ["name"] = "Magecraft";
      ["level"] = 52;
      ["name_es"] = "Pura magia";
      ["req"] = 50;
   };
   [2078] = {
      ["name_ru"] = "Месть Гиромачта";
      ["type"] = "Group";
      ["objective"] = "Find Gelkak's First Mate, the Threshwackonator 4100, and lead it back to Gelkak.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Gyromasts Rache";
      ["reward"] = {
         [1] = 5996;
      };
      ["name_cn"] = "基??克的??";
      ["name_fr"] = "La vengeance de Gyromast";
      ["faction"] = "Alliance";
      ["name"] = "Gyromast's Revenge";
      ["sort"] = "Darkshore";
      ["prev"] = 2098;
      ["prequests"] = {
         [1] = 2098;
      };
      ["level"] = 20;
      ["name_es"] = "La venganza de Gyromast";
      ["req"] = 14;
   };
   [2161] = {
      ["name_ru"] = "Ноша батрака";
      ["type"] = "Solo";
      ["objective"] = "Bring Ukor's Burden to Innkeeper Grosk in Razor Hill.";
      ["repgain"] = {
         [530] = 25;
         [76] = 25;
      };
      ["sort"] = "Durotar";
      ["name_fr"] = "Un Fardeau de Peon";
      ["name_cn"] = "苦工的重担";
      ["reward"] = {
         [1] = 4540;
         [2] = 159;
      };
      ["name_de"] = "Die Burde eines Peons";
      ["faction"] = "Horde";
      ["name"] = "A Peon's Burden";
      ["level"] = 5;
      ["name_es"] = "Un cargamento de peon";
      ["req"] = 1;
   };
   [3504] = {
      ["name_ru"] = "Предательница";
      ["type"] = "Solo";
      ["name_fr"] = "Trahison";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Verraten";
      ["name_cn"] = "叛徒";
      ["objective"] = "Deliver the Sealed Letter to Ag'tor Bloodfist in Azshara.";
      ["next"] = 3505;
      ["sort"] = "Orgrimmar";
      ["name"] = "Betrayed";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 53;
      ["name_es"] = "Traicion";
      ["req"] = 44;
   };
   [7023] = {
      ["name_ru"] = "Здравствуй, Дедушка Зима!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter; he is located near the Smokywood Pastures vendor area in Ironforge.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天??来了！";
      ["name_fr"] = "Grandpere Hiver est ici?!";
      ["name_de"] = "Altvater Winter ist hier!";
      ["faction"] = "Alliance";
      ["name"] = "Greatfather Winter is Here!";
      ["level"] = 60;
      ["name_es"] = "!El Gran Padre Invierno esta aqui!";
      ["req"] = 10;
   };
   [3520] = {
      ["name_ru"] = "Духи крикунов";
      ["type"] = "Solo";
      ["objective"] = "Capture the spirits of 3 screechers in Feralas, then return to Yeh'kinya in Steamwheedle Port.";
      ["next"] = 3527;
      ["sort"] = "Tanaris";
      ["name_cn"] = "尖?者的?魂";
      ["name_fr"] = "Esprits de Hurleurs";
      ["name_de"] = "Kreischergeister";
      ["faction"] = "Horde";
      ["name"] = "Screecher Spirits";
      ["level"] = 44;
      ["name_es"] = "Los espiritus de los estridadores";
      ["req"] = 40;
   };
   [3528] = {
      ["name_ru"] = "Бог Хаккар";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le dieu Hakkar";
      ["name_de"] = "Der Gott Hakkar";
      ["reward"] = {
         [1] = 10749;
         [2] = 10750;
         [3] = 10751;
      };
      ["name_cn"] = "神?哈?";
      ["objective"] = "Bring the Filled Egg of Hakkar to Yeh'kinya in Tanaris.";
      ["faction"] = "Horde";
      ["name"] = "The God Hakkar";
      ["sort"] = "Sunken Temple";
      ["prev"] = 4787;
      ["prequests"] = {
         [1] = 4787;
      };
      ["level"] = 53;
      ["name_es"] = "El dios Hakkar";
      ["req"] = 40;
   };
   [1396] = {
      ["name_ru"] = "Атака тварей";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Young Sawtooth Crocolisks, 10 Sorrow Spinners and 10 Swamp Jaguars then return to Watcher Biggs in the Swamp of Sorrows.";
      ["next"] = 1421;
      ["name_fr"] = "Des creatures sauvages rodent";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "逼近的野?";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Lauernde Tierwelt";
      ["faction"] = "Alliance";
      ["name"] = "Encroaching Wildlife";
      ["level"] = 37;
      ["name_es"] = "Contra la fauna feroz";
      ["req"] = 30;
   };
   [7641] = {
      ["name_ru"] = "Работа Гриманда Элмора";
      ["objective"] = "Speak with Grimand Elmore in Stormwind's Dwarven District.";
      ["name_cn"] = "格瑞曼德・艾?默";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "L'?uvre de Grimand Elmore";
      ["next"] = 7642;
      ["name_de"] = "Grimand Elmores Werk";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Work of Grimand Elmore";
      ["prev"] = 7640;
      ["prequests"] = {
         [1] = 7640;
      };
      ["followup"] = 7642;
      ["name_es"] = "El trabajo de Grimand Elmore";
      ["req"] = 60;
   };
   [7583] = {
      ["name_ru"] = "Заточение";
      ["type"] = "Group";
      ["name_fr"] = "Suppression";
      ["name_de"] = "Unterdruckung";
      ["objective"] = "Venture forth into the Tainted Scar and locate a Doomguard Commander.$B$BUse the Glowing Crystal Prison on the Doomguard Commander. Be prepared for a ferocious onslaught of attacks, as the demon attempts to escape capture.$B$BShould you succeed, return the Imprisoned Doomguard to Daio in the Tainted Scar.";
      ["name_cn"] = "?制";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 18602;
      };
      ["name"] = "Suppression";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7582;
         [2] = 7581;
      };
      ["level"] = 60;
      ["name_es"] = "Supresion";
      ["req"] = 60;
   };
   [1081] = {
      ["name_ru"] = "Приглашение от Тиранды";
      ["type"] = "Solo";
      ["objective"] = "Find Tyrande Whisperwind in Darnassus.";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 500;
      };
      ["name_de"] = "Tyrandes Empfang";
      ["reward"] = {
         [1] = 7334;
         [2] = 6678;
         [3] = 7335;
         [4] = 7336;
      };
      ["name_cn"] = "泰?德的接待";
      ["name_fr"] = "Reception par Tyrande";
      ["faction"] = "Alliance";
      ["name"] = "Reception from Tyrande";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1082;
      ["prequests"] = {
         [1] = 1082;
      };
      ["level"] = 28;
      ["name_es"] = "El recibimiento de Tyrande";
      ["req"] = 17;
   };
   [3568] = {
      ["name_ru"] = "Разносчик заразы";
      ["type"] = "Solo";
      ["objective"] = "Fill all 4 Empty Vials at the tide pools along the coast of the Ruins of Eldarath in Azshara before returning to Chemist Cuely.";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_fr"] = "Corruption Suintante";
      ["sort"] = "Undercity";
      ["name_cn"] = "堕落之水";
      ["name_de"] = "Verbreitete Verderbnis";
      ["faction"] = "Horde";
      ["name"] = "Seeping Corruption";
      ["level"] = 52;
      ["name_es"] = "La filtracion de la corrupcion";
      ["req"] = 45;
   };
   [4132] = {
      ["name_ru"] = "Операция: смерть Кузне Гнева";
      ["type"] = "Dungeon";
      ["name_fr"] = "Operation?: Mort a Forgehargne";
      ["name_de"] = "Operation: Tod dem Zornesschmied";
      ["reward"] = {
         [1] = 12059;
      };
      ["name_cn"] = "行?：?死安格弗将?";
      ["objective"] = "Travel to Blackrock Depths and slay General Angerforge! Return to Warlord Goretooth when the task is complete.";
      ["faction"] = "Horde";
      ["name"] = "Operation: Death to Angerforge";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4121;
      ["prequests"] = {
         [1] = 4121;
      };
      ["level"] = 58;
      ["name_es"] = "Operacion: muerte a Forjainquina";
      ["req"] = 52;
   };
   [7167] = {
      ["name_ru"] = "Око Командования";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Das Auge der Fuhrung";
      ["name_fr"] = "L'?il du commandement";
      ["name_cn"] = "命令之眼";
      ["name"] = "The Eye of Command";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17909;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7166;
      ["prequests"] = {
         [1] = 7166;
      };
      ["level"] = 60;
      ["name_es"] = "El ojo del orden";
      ["req"] = 51;
   };
   [8552] = {
      ["name_ru"] = "Кушак с монограммой";
      ["type"] = "Group";
      ["objective"] = "Return the Monogrammed Sash to its owner.";
      ["repgain"] = {
         [21] = 75;
      };
      ["name_fr"] = "L'echarpe a monogramme";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "刺着字母的腰?";
      ["name_de"] = "Die Scharpe mit Monogramm";
      ["faction"] = "Horde";
      ["name"] = "The Monogrammed Sash";
      ["level"] = 50;
      ["name_es"] = "La banda con monograma";
      ["req"] = 40;
   };
   [8800] = {
      ["name_ru"] = "Броня Кенария";
      ["type"] = "Solo";
      ["objective"] = "Talk to Vargus at Cenarion Hold in Silithus.";
      ["repgain"] = {
         [609] = 10;
      };
      ["name_fr"] = "La tenue de combat cenarienne";
      ["sort"] = "Silithus";
      ["name_cn"] = "塞?里奥的装?";
      ["name_de"] = "Schlachtrustung des Cenarius";
      ["faction"] = "Horde";
      ["name"] = "Cenarion Battlegear";
      ["level"] = 60;
      ["name_es"] = "Equipamiento de Cenarius";
      ["req"] = 60;
   };
   [2607] = {
      ["name_ru"] = "Прикосновение Занзила";
      ["type"] = "Solo";
      ["name_fr"] = "Le toucher de Zanzil";
      ["name_de"] = "Die Beruhrung von Zanzil";
      ["sort"] = "Rogue";
      ["objective"] = "Speak with Doc Mixilpixil in the cellar of the Barracks.";
      ["name_cn"] = "?吉?之触";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "The Touch of Zanzil";
      ["followup"] = 2608;
      ["prev"] = 2359;
      ["prequests"] = {
         [1] = 2359;
      };
      ["level"] = 20;
      ["name_es"] = "Toque de Zanzil";
      ["req"] = 20;
   };
   [3782] = {
      ["name_ru"] = "Изучение рассветницы";
      ["objective"] = "Take the Seed Voucher to Bashana Runetotem in Thunder Bluff.";
      ["name_cn"] = "晨光麦研究";
      ["sort"] = "Thunder Bluff";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "La recherche sur la Fibre d'aurore";
      ["next"] = 3786;
      ["name_de"] = "Morgenkornforschung";
      ["repgain"] = {
         [81] = 10;
      };
      ["reward"] = {
         [1] = 11022;
      };
      ["faction"] = "Horde";
      ["name"] = "Morrowgrain Research";
      ["prev"] = 3761;
      ["prequests"] = {
         [1] = 3761;
      };
      ["series"] = 1;
      ["name_es"] = "Investigar la managrana";
      ["req"] = 47;
   };
   [6607] = {
      ["name_ru"] = "Нат Пэгл, великий рыболов";
      ["type"] = "Solo";
      ["objective"] = "Nat Pagle wants you to catch the following fish:$B$BMisty Reed Mahi Mahi from the Misty Reed Strand in the Swamp of Sorrows.$B$BA Sar'theris Striker from the Sar'theris Strand in Desolace.$B$BFeralas Ahi from the Verdantis River of Feralas.$B$BSavage Coast Blue Sailfin from the Savage Coast of Stranglethorn Vale.$B$BReturn to Nat Pagle when you have reeled them all in!";
      ["sort"] = "Fishing";
      ["name_cn"] = "???家?特・?格";
      ["name_fr"] = "Nat Pagle, pecheur de l'extreme";
      ["name_de"] = "Nat Pagle, Extremangler";
      ["faction"] = "Horde";
      ["name"] = "Nat Pagle, Angler Extreme";
      ["level"] = 45;
      ["name_es"] = "Nat Pagle, pescador extremo";
      ["req"] = 35;
   };
   [3632] = {
      ["name_ru"] = "Гномское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Gnome Engineering, take the Manual of Engineering Disciplines to Tinkmaster Overspark in Ironforge.";
      ["sort"] = "Engineering";
      ["name_cn"] = "侏儒工程学";
      ["name_fr"] = "Ingenierie des gnomes";
      ["followup"] = 3640;
      ["name_de"] = "Gnomeningenieurskunst";
      ["faction"] = "Alliance";
      ["name"] = "Gnome Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria gnomica";
      ["req"] = 30;
   };
   [3640] = {
      ["name_ru"] = "Договор о неразглашении";
      ["type"] = "Solo";
      ["objective"] = "If you agree to become a Gnome Engineer, then right-click on the Pledge of Secrecy and speak once more with Tinkmaster Overspark in Ironforge.";
      ["next"] = 3641;
      ["name_fr"] = "Le V?u du secret";
      ["sort"] = "Engineering";
      ["name_cn"] = "保密??";
      ["name"] = "The Pledge of Secrecy";
      ["name_de"] = "Der Schwur der Geheimhaltung";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 3630;
         [2] = 3632;
         [3] = 3634;
      };
      ["level"] = 47;
      ["name_es"] = "La promesa del secreto";
      ["req"] = 30;
   };
   [6609] = {
      ["name_ru"] = "С меня больше нечего взять!";
      ["type"] = "Solo";
      ["objective"] = "Travel to Kalimdor, to the coastal city of Theramore. From there you must search for an island, south of the main town. Nat Pagle awaits your arrival!";
      ["sort"] = "Fishing";
      ["name_cn"] = "青出于?！";
      ["name_fr"] = "Il ne me reste rien?!";
      ["name_de"] = "Ich hab nix mehr!";
      ["faction"] = "Alliance";
      ["name"] = "I Got Nothin' Left!";
      ["level"] = 45;
      ["name_es"] = "!Me has dejado seco!";
      ["req"] = 35;
   };
   [8810] = {
      ["name_ru"] = "Запас бинтов";
      ["type"] = "Solo";
      ["objective"] = "Bring 30 Heavy Runecloth Bandages, 30 Heavy Silk Bandages and 30 Heavy Mageweave Bandages to Windcaller Proudhorn at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing X in order to complete this quest.";
      ["name_fr"] = "Des bandages pour la campagne";
      ["sort"] = "Silithus";
      ["name_cn"] = "??上的??";
      ["reward"] = {
         [1] = 20800;
         [2] = 21386;
      };
      ["name_de"] = "Verbande fur den Feldeinsatz";
      ["faction"] = "Horde";
      ["name"] = "Bandages for the Field";
      ["level"] = 60;
      ["name_es"] = "Vendas para el campo de batalla";
      ["req"] = 60;
   };
   [8962] = {
      ["name_ru"] = "Важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "Des composants importants";
      ["next"] = 8966;
      ["name_de"] = "Komponenten von groser Wichtigkeit";
      ["objective"] = "Acquire Druidical Remains and return them to Bodley inside Blackrock Mountain.";
      ["name_cn"] = "重要的材料";
      ["sort"] = "Blackrock Mountain";
      ["faction"] = "Horde";
      ["name"] = "Components of Importance";
      ["followup"] = 8987;
      ["prev"] = 8961;
      ["prequests"] = {
         [1] = 8961;
      };
      ["level"] = 60;
      ["name_es"] = "Componentes importantes";
      ["req"] = 58;
   };
   [4962] = {
      ["name_ru"] = "Осколок гончей Скверны";
      ["type"] = "Solo";
      ["objective"] = "Take the Felhas Ruby and use it on one of the Felhounds found in Desolace. After successful, bring the Felhas Ruby and the Imprisoned Felhound Spirit back to Menara Voidrender in the Barrens.";
      ["sort"] = "Warlock";
      ["name_cn"] = "地?犬的?魂";
      ["name_fr"] = "Un eclat de gangrechien";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Splitter eines Teufelshundes";
      ["faction"] = "Horde";
      ["name"] = "Shard of a Felhound";
      ["level"] = 40;
      ["name_es"] = "Fragmento de can manafago";
      ["req"] = 35;
   };
   [1643] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1644;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Search the Trade District of Stormwind for Stephanie Turner.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1642;
      ["prequests"] = {
         [1] = 1642;
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1962] = {
      ["name_ru"] = "Одеяние из огненной чароткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["races"] = {
         [1] = "Undead";
      };
      ["name_fr"] = "Robe du feu-sorcier";
      ["name"] = "Spellfire Robes";
      ["name_cn"] = "魔??袍";
      ["name_de"] = "Roben des Zauberfeuers";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7510;
      };
      ["sort"] = "Mage";
      ["prev"] = 1961;
      ["prequests"] = {
         [1] = 1961;
      };
      ["level"] = 15;
      ["name_es"] = "Toga de fuego de hechizo";
      ["req"] = 15;
   };
   [3962] = {
      ["name_ru"] = "Один в поле не воин";
      ["type"] = "Group";
      ["name_fr"] = "C'est dangereux d'y aller seul";
      ["name_de"] = "Allein ist es gefahrlich";
      ["reward"] = {
         [1] = 11902;
         [2] = 11905;
         [3] = 11904;
      };
      ["name_cn"] = "?伴而行";
      ["objective"] = "Travel to Fire Plume Ridge, south of Marshal's Refuge.$B$BFind Blazerunner and use the totem to remove his protective aura. Once he has been defeated, acquire the Golden Flame from the cave.";
      ["faction"] = "Horde";
      ["name"] = "It's Dangerous to Go Alone";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 3961;
      ["prequests"] = {
         [1] = 3961;
      };
      ["level"] = 56;
      ["name_es"] = "Ir solo es peligroso";
      ["req"] = 47;
   };
   [2962] = {
      ["name_ru"] = "Сильное зеленое свечение";
      ["type"] = "Dungeon";
      ["name_fr"] = "Encore plus de Lueur verte?!";
      ["name_de"] = "Das einzige Heilmittel ist mehr grunes Leuchten";
      ["name_cn"] = "更多的?射?！";
      ["objective"] = "Travel to Gnomeregan and bring back High Potency Radioactive Fallout. Be warned, the fallout is unstable and will collapse rather quickly.$B$BOzzie will also require your Heavy Leaden Collection Phial when the task is complete.$B";
      ["sort"] = "Gnomeregan";
      ["faction"] = "Alliance";
      ["name"] = "The Only Cure is More Green Glow";
      ["prev"] = 2926;
      ["prequests"] = {
         [1] = 2926;
      };
      ["level"] = 30;
      ["name_es"] = "Necesitamos mas material verdoso";
      ["req"] = 20;
   };
   [7423] = {
      ["name_ru"] = "Костяная лихорадка";
      ["type"] = "PvP";
      ["objective"] = "";
      ["name_cn"] = "更多的骨?";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Knochensplitterjagd";
      ["faction"] = "Horde";
      ["name"] = "I've Got A Fever For More Bone Chips";
      ["level"] = 60;
      ["name_es"] = "Mas esquirlas de huesos";
      ["req"] = 55;
   };
   [6341] = {
      ["name_ru"] = "Изобилие Тельдрассила";
      ["type"] = "Solo";
      ["name_fr"] = "Le don de Teldrassil";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Auf nach Darnassus";
      ["objective"] = "Bring Nessa's Collection to Vesprystus.";
      ["name_cn"] = "泰?希?的??";
      ["next"] = 6342;
      ["sort"] = "Darkshore";
      ["name"] = "The Bounty of Teldrassil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 6344;
      ["prequests"] = {
         [1] = 6344;
      };
      ["level"] = 10;
      ["name_es"] = "A Darnassus";
      ["req"] = 10;
   };
   [1055] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Raenes Sauberung";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Return to Shael'dryn at the moonwell.";
      ["next"] = 1029;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1028;
      ["prequests"] = {
         [1] = 1028;
      };
      ["level"] = 28;
      ["name_es"] = "La limpieza de Raene";
      ["req"] = 18;
   };
   [3641] = {
      ["name_ru"] = "Покажи свою работу";
      ["type"] = "Solo";
      ["name_fr"] = "Montrez votre travail";
      ["name_de"] = "Zeigt Eure Arbeit";
      ["reward"] = {
         [1] = 10790;
      };
      ["name_cn"] = "工作成果";
      ["objective"] = "Bring 6 Mithril Tubes, an Accurate Scope, and 2 Advanced Target Dummies to Tinkmaster Overspark in Ironforge.";
      ["faction"] = "Alliance";
      ["name"] = "Show Your Work";
      ["sort"] = "Engineering";
      ["prev"] = 3640;
      ["prequests"] = {
         [1] = 3640;
      };
      ["level"] = 47;
      ["name_es"] = "Muestra tu trabajo";
      ["req"] = 30;
   };
   [2202] = {
      ["name_ru"] = "В Ульдаман за реактивом";
      ["type"] = "Solo";
      ["objective"] = "Bring 12 Magenta Fungus Caps to Jarkal Mossmeld in Kargath.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Reagenzsuche in Uldaman";
      ["reward"] = {
         [1] = 9030;
      };
      ["name_cn"] = "奥?曼的?菇";
      ["name_fr"] = "Rechercher les composants a Uldaman";
      ["faction"] = "Horde";
      ["name"] = "Uldaman Reagent Run";
      ["sort"] = "Uldaman";
      ["prev"] = 2258;
      ["prequests"] = {
         [1] = 2258;
      };
      ["level"] = 42;
      ["name_es"] = "Componentes de Uldaman";
      ["req"] = 36;
   };
   [7503] = {
      ["name_ru"] = "Величайшая гонка охотников";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "La plus grande race de chasseurs";
      ["name_cn"] = "最?大的?手";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 18473;
      };
      ["name_de"] = "Das groste Volk von Jagern";
      ["faction"] = "Horde";
      ["name"] = "The Greatest Race of Hunters";
      ["level"] = 60;
      ["name_es"] = "La mejor raza de cazadores";
      ["req"] = 54;
   };
   [8266] = {
      ["name_ru"] = "Ленты жертвоприношения";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ribbons of Sacrifice to Captain Shatterskull so that the Outriders may reward you for acting on our behalf.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "奉献??";
      ["name_fr"] = "Les rubans de sacrifice";
      ["name_de"] = "Aufopferungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ribbons of Sacrifice";
      ["level"] = 39;
      ["name_es"] = "Galon de sacrificio";
      ["req"] = 10;
   };
   [8277] = {
      ["name_ru"] = "Смертельный яд";
      ["type"] = "Solo";
      ["objective"] = "Beetix Ficklespragg at Cenarion Hold in Silithus wants you to gather 8 Stonelash Scorpid Stingers and 8 Sand Skitterer Fangs. Return to her when you have completed the task.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_fr"] = "Venin mortel du desert";
      ["sort"] = "Silithus";
      ["name_cn"] = "沙漠中的?毒";
      ["name_de"] = "Todliches Wustengift";
      ["faction"] = "Horde";
      ["name"] = "Deadly Desert Venom";
      ["level"] = 55;
      ["name_es"] = "Veneno mortal del desierto";
      ["req"] = 54;
   };
   [1148] = {
      ["name_ru"] = "Части роя";
      ["type"] = "Solo";
      ["name_fr"] = "Des parties de l'essaim";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Teile des Schwarms";
      ["name_cn"] = "虫群的?本";
      ["objective"] = "Bring 1 Silithid Heart, 5 Silithid Talons, and 3 Intact Silithid Carapaces, to Korran at the Crossroads.";
      ["next"] = 1184;
      ["sort"] = "Thousand Needles";
      ["name"] = "Parts of the Swarm";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 35;
      ["name_es"] = "Pedazos del enjambre";
      ["req"] = 28;
   };
   [3784] = {
      ["name_ru"] = "Помощь верховному друиду Руническому Тотему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem in Thunder Bluff.";
      ["next"] = 3761;
      ["sort"] = "Undercity";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "L'aide a l'archidruide Totem-runique";
      ["name_de"] = "Erzdruide Runentotem helfen";
      ["faction"] = "Horde";
      ["name"] = "Assisting Arch Druid Runetotem";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Totem de Runa";
      ["req"] = 47;
   };
   [3792] = {
      ["name_ru"] = "Рассветница для Крепости Оперенной Луны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Morgenkorn fur die Mondfederfeste";
      ["name_fr"] = "De la Fibre d'aurore au bastion de Pennelune";
      ["name_cn"] = "羽月要塞的晨光麦";
      ["faction"] = "Alliance";
      ["name"] = "Morrowgrain to Feathermoon Stronghold";
      ["reward"] = {
         [1] = 11022;
      };
      ["sort"] = "Feathermoon Stronghold";
      ["prev"] = 3791;
      ["prequests"] = {
         [1] = 3791;
      };
      ["level"] = 55;
      ["name_es"] = "Managrana a Bastion Plumaluna";
      ["req"] = 47;
   };
   [4462] = {
      ["name_ru"] = "Оскверненный ночной дракон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的夜?草";
      ["name_fr"] = "Dragon nocturne corrompue";
      ["name_de"] = "Verderbter Nachtdrache";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Night Dragon";
      ["level"] = 55;
      ["name_es"] = "Dragon nocturno corrupto";
      ["req"] = 48;
   };
   [4186] = {
      ["name_ru"] = "Подлинные хозяева";
      ["objective"] = "Take Bolvar's Decree to Magistrate Solomon in Lakeshire.$B";
      ["name_cn"] = "真正的主人";
      ["sort"] = "Burning Steppes";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4223;
      ["name_de"] = "Die wahren Meister";
      ["repgain"] = {
         [72] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "The True Masters";
      ["prev"] = 4185;
      ["prequests"] = {
         [1] = 4185;
      };
      ["series"] = 4;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [7631] = {
      ["name_ru"] = "Зоротианский конь погибели";
      ["type"] = "Dungeon";
      ["objective"] = "Read Mor'zul's Instructions.  Summon a Xorothian Dreadsteed, defeat it, then bind its spirit to you.";
      ["name_fr"] = "Le destrier de l'effroi de Xoroth";
      ["sort"] = "Warlock";
      ["name_cn"] = "克索?斯恐惧??";
      ["name"] = "Dreadsteed of Xoroth";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Schreckensross von Xoroth";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7629;
         [2] = 7630;
      };
      ["level"] = 60;
      ["name_es"] = "Corcel nefasto xorothiano";
      ["req"] = 60;
   };
   [3824] = {
      ["name_ru"] = "Гор'теш Жестокий";
      ["type"] = "Solo";
      ["name_fr"] = "Le seigneur-brute Gor'tesh";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Gor'tesh der Schlager-Lord";
      ["name"] = "Gor'tesh the Brute Lord";
      ["name_cn"] = "蛮王戈泰什";
      ["objective"] = "Find Gor'tesh, somewhere to the west of Dreadmaul Rock. Kill Gor'tesh and then take Gor'tesh's Lopped Off Head back to Oralius in Burning Steppes.$B";
      ["next"] = 3825;
      ["faction"] = "Alliance";
      ["sort"] = "Burning Steppes";
      ["prev"] = 3823;
      ["prequests"] = {
         [1] = 3823;
      };
      ["level"] = 53;
      ["name_es"] = "Gor'tesh, el Senor de los toscos";
      ["req"] = 48;
   };
   [7663] = {
      ["name_ru"] = "Новый кодо ? зеленый";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Thunder Bluff";
      ["name_fr"] = "Un nouveau kodo vert";
      ["name_cn"] = "?色科多?";
      ["reward"] = {
         [1] = 18794;
         [2] = 18795;
         [3] = 18793;
      };
      ["name_de"] = "Neuer Kodo - Grun";
      ["faction"] = "Horde";
      ["name"] = "New Kodo - Green";
      ["level"] = 1;
      ["name_es"] = "Nuevo kodo: verde";
      ["req"] = 60;
   };
   [4262] = {
      ["name_ru"] = "Подчинитель Пирон";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Overmaster Pyron and return to Jalinda Sprig.$B$BYou recall Jalinda talking about Pyron guarding the quarry. Perhaps you should search there?";
      ["next"] = 4263;
      ["name_fr"] = "Grand seigneur Pyron";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "征服者派隆";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_de"] = "Ubermeister Pyron";
      ["faction"] = "Alliance";
      ["name"] = "Overmaster Pyron";
      ["level"] = 52;
      ["name_es"] = "Maestro supremo Pyron";
      ["req"] = 48;
   };
   [8163] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["faction"] = "Horde";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8160;
      ["prequests"] = {
         [1] = 8160;
      };
      ["level"] = 45;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 40;
   };
   [7201] = {
      ["name_ru"] = "Последний элемент";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Depths and recover 10 Essence of the Elements. Your first inclination is to search the golems and golem makers. You remember Vivian Lagrave also muttering something about elementals.$B";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Blackrock Depths";
      ["name_fr"] = "Le dernier element";
      ["name_cn"] = "最后的元素";
      ["reward"] = {
         [1] = 12038;
      };
      ["name_de"] = "Das letzte Element";
      ["faction"] = "Horde";
      ["name"] = "The Last Element";
      ["level"] = 54;
      ["name_es"] = "El ultimo elemento";
      ["req"] = 48;
   };
   [7727] = {
      ["name_ru"] = "Пламезавры? Ну и название...";
      ["type"] = "Solo";
      ["objective"] = "Hansel Heavyhands wants you to kill 20 Incendosaurs.$B$BYou will find Incendosaurs occupying the lava pools inside the Slag Pit. The Slag Pit can be found in the Cauldron of the Searing Gorge.$B$BReturn to Hansel Heavyhands in the Searing Gorge when you have killed enough Incendosaurs.";
      ["repgain"] = {
         [59] = 100;
      };
      ["sort"] = "Searing Gorge";
      ["name_fr"] = "Incendosaures?? N'importosaures, plutot";
      ["name_cn"] = "熏火?";
      ["reward"] = {
         [1] = 19141;
      };
      ["name_de"] = "Incendosaurier? Was-auch-immer-Saurier?";
      ["faction"] = "Horde";
      ["name"] = "Incendosaurs? Whateverosaur is More Like It";
      ["level"] = 49;
      ["name_es"] = "?Incendosaurio? Loqueseasaurio mas bien";
      ["req"] = 45;
   };
   [1073] = {
      ["name_ru"] = "Неумение + реактивы = потеха!";
      ["objective"] = "Bring 4 Minor Mana Potions and 2 Elixirs of Minor Fortitude to Lomac Gearstrip in Ironforge.";
      ["name_cn"] = "失?+??=快?";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 21;
      ["type"] = "Solo";
      ["name_fr"] = "Inaptitude + Produits chimiques = Rigolo";
      ["next"] = 1074;
      ["name_de"] = "Stumperhaftigkeit + Chemikalien = Riesenspas!";
      ["repgain"] = {
         [54] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Ineptitude + Chemicals = Fun";
      ["prev"] = 1072;
      ["prequests"] = {
         [1] = 1072;
      };
      ["series"] = 1;
      ["name_es"] = "Ineptitud + Productos quimicos = Diversion";
      ["req"] = 17;
   };
   [8158] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8155;
      ["prequests"] = {
         [1] = 8155;
      };
      ["level"] = 25;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 20;
   };
   [8227] = {
      ["name_ru"] = "Измерительная лента Ната";
      ["type"] = "Raid";
      ["objective"] = " Dustwallow Marsh.\"\"";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?特的卷尺";
      ["name_fr"] = "Le metre ruban de Nat";
      ["name_de"] = "Nats Masband";
      ["faction"] = "Horde";
      ["name"] = "Nat's Measuring Tape";
      ["level"] = 60;
      ["name_es"] = "Cinta metrica de Nat";
      ["req"] = 58;
   };
   [7791] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Stormwind City";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7795;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [3904] = {
      ["name_ru"] = "Урожай Милли";
      ["type"] = "Solo";
      ["name_fr"] = "Les vendanges de Milly";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Millys Ernte";
      ["name"] = "Milly's Harvest";
      ["name_cn"] = "米莉的葡萄";
      ["objective"] = "Bring 8 crates of Milly's Harvest to Milly Osworth at Northshire Abbey.";
      ["next"] = 3905;
      ["faction"] = "Alliance";
      ["sort"] = "Northshire Valley";
      ["prev"] = 3903;
      ["prequests"] = {
         [1] = 3903;
      };
      ["level"] = 4;
      ["name_es"] = "La cosecha de Milly";
      ["req"] = 2;
   };
   [3912] = {
      ["name_ru"] = "Встречаемся на кладбище";
      ["type"] = "Solo";
      ["name_fr"] = "Rendez-vous a la tombe";
      ["next"] = 3913;
      ["name_de"] = "Treffen am Grab";
      ["name_cn"] = "墓地相?";
      ["objective"] = " head due north until you reach the mountains. You'll find the one you need to speak with in one of the rocky crevices. His name is Gaeriyan.$B$BRemember";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Meet at the Grave";
      ["prev"] = 3909;
      ["prequests"] = {
         [1] = 3909;
      };
      ["level"] = 52;
      ["name_es"] = "Encuentro en la tumba";
      ["req"] = 47;
   };
   [7839] = {
      ["name_ru"] = "Хулиганы Порочной Ветви";
      ["type"] = "Solo";
      ["objective"] = "Smith Slagtree at Revantusk Village in the Hinterlands wants you to find Slagtree's Lost Tools. Return to him once this task is complete.$B$BYou recall Smith Slagtree mentioning that the tools might be at one of the Vilebranch temples in the northeastern region of the Hinterlands. You should also check Skulk Rock.";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "邪枝窃?";
      ["name_fr"] = "Les voyous Vilebranche";
      ["name_de"] = "Schlager der Blutfratzen";
      ["faction"] = "Horde";
      ["name"] = "Vilebranch Hooligans";
      ["level"] = 48;
      ["name_es"] = "Los vandalos de Vilrama";
      ["req"] = 44;
   };
   [8161] = {
      ["name_ru"] = "Перекрыть линии поставок Аратора";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "切断阿拉索???";
      ["name_fr"] = "Couper les voies de ravitaillement d'Arathor";
      ["name_de"] = "Zerschlagt die Versorgungslinien Arathors";
      ["faction"] = "Horde";
      ["name"] = "Cut Arathor Supply Lines";
      ["level"] = 35;
      ["name_es"] = "Cortale el suministro a la Liga de Arathor";
      ["req"] = 30;
   };
   [7871] = {
      ["name_ru"] = "Долой захватчиков!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者！ (PvP)";
      ["name_fr"] = "Triomphez des envahisseurs?!";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Alliance";
      ["name"] = "Vanquish the Invaders!";
      ["level"] = 35;
      ["name_es"] = "!Expulsa al invasor!";
      ["req"] = 30;
   };
   [7887] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["name_fr"] = "Talismans de vaillance";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["objective"] = "You obtained a Silverwing Talisman of Merit for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Alliance";
      ["name"] = "Talismans of Merit";
      ["name_de"] = "Verdienstabzeichen";
      ["prev"] = 7871;
      ["prequests"] = {
         [1] = 7871;
      };
      ["level"] = 35;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 30;
   };
   [7903] = {
      ["name_ru"] = "Глаза злобных летучих мышей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Yeux de chauve-souris malefique";
      ["name_cn"] = "邪?的蝙蝠眼";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Bose Fledermausaugen";
      ["faction"] = "Horde";
      ["name"] = "Evil Bat Eyes";
      ["level"] = 60;
      ["name_es"] = "Ojos de murcielago malignos";
      ["req"] = 40;
   };
   [8698] = {
      ["name_ru"] = "Кольцо Надвигающейся бури";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Magisterial Ring, 2 Vermillion Idols, 5 Silver Scarabs and 5 Bone Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau de la tempete imminente";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "聚集?暴之戒";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21399;
      };
      ["name_de"] = "Ring der aufziehenden Sturme";
      ["faction"] = "Horde";
      ["name"] = "Ring of the Gathering Storm";
      ["level"] = 60;
      ["name_es"] = "El anillo de la tormenta inminente";
      ["req"] = 60;
   };
   [7935] = {
      ["name_ru"] = "10 купонов ? прошлогодний окорок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "10 bons - Mouton du mois dernier";
      ["name_cn"] = "10??券 - 上个月的羊肉";
      ["reward"] = {
         [1] = 19292;
      };
      ["name_de"] = "10 Lose - Hammel des letzten Monats";
      ["faction"] = "Horde";
      ["name"] = "10 Tickets - Last Month's Mutton";
      ["level"] = 60;
      ["name_es"] = "10 vales: anojo del mes pasado";
      ["req"] = 25;
   };
   [5282] = {
      ["name_ru"] = "Мятущиеся души";
      ["type"] = "Dungeon";
      ["objective"] = "Use Egan's Blaster on the ghostly and spectral citizens of Stratholme. When the restless souls break free from their ghostly shells, use the blaster again - freedom will be theirs!$B$BFree 15 Restless Souls and return to Egan.";
      ["name_de"] = "Die ruhelosen Seelen";
      ["name_fr"] = "Ames tourmentees";
      ["reward"] = {
         [1] = 13315;
      };
      ["name_cn"] = "永不安息的?魂";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "The Restless Souls";
      ["sort"] = "Stratholme";
      ["prev"] = 5281;
      ["prequests"] = {
         [1] = 5281;
      };
      ["level"] = 60;
      ["name_es"] = "Espiritus inquietos";
      ["req"] = 55;
   };
   [1501] = {
      ["name_ru"] = "Создание Бездны";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Tablet of Verga for Gan'rul Bloodeye in Orgrimmar.";
      ["next"] = 1504;
      ["name_fr"] = "La creature du Vide";
      ["sort"] = "Warlock";
      ["name_cn"] = "虚空中的生物";
      ["name"] = "Creature of the Void";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Kreatur der Leere";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1506;
      };
      ["level"] = 11;
      ["name_es"] = "Criatura Abisal";
      ["req"] = 10;
   };
   [1598] = {
      ["name_ru"] = "Украденная книга";
      ["type"] = "Solo";
      ["objective"] = "Retrieve the Powers of the Void for Drusilla La Salle.";
      ["repgain"] = {
         [72] = 100;
      };
      ["name_fr"] = "Le Tome derobe";
      ["sort"] = "Warlock";
      ["name_cn"] = "失窃的典籍";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Der gestohlene Foliant";
      ["faction"] = "Alliance";
      ["name"] = "The Stolen Tome";
      ["level"] = 4;
      ["name_es"] = "El libro robado";
      ["req"] = 1;
   };
   [3461] = {
      ["name_ru"] = "Возвращение к Тимору";
      ["type"] = "Solo";
      ["objective"] = "Return Tymor's Drawing Kit to him in Ironforge.";
      ["repgain"] = {
         [47] = 500;
      };
      ["name_de"] = "Ruckkehr zu Magier Tymor";
      ["reward"] = {
         [1] = 10707;
         [2] = 10708;
      };
      ["name_cn"] = "向法?泰摩?回?";
      ["name_fr"] = "Le retour vers Tymor";
      ["faction"] = "Alliance";
      ["name"] = "Return to Tymor";
      ["sort"] = "Ironforge";
      ["prev"] = 3449;
      ["prequests"] = {
         [1] = 3449;
      };
      ["level"] = 52;
      ["name_es"] = "Regresa junto a Tymor";
      ["req"] = 45;
   };
   [2751] = {
      ["name_ru"] = "Варварские доспехи";
      ["type"] = "Solo";
      ["objective"] = "Bring two Patterned Bronze Bracers, two Bronze Greatswords, and two Sharp Claws to Orokk Omosh in Orgrimmar.$B";
      ["name_fr"] = "Remparts barbares";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "野人装甲";
      ["reward"] = {
         [1] = 7979;
      };
      ["name_de"] = "Barbarische Waffenschmiedekunst";
      ["faction"] = "Horde";
      ["name"] = "Barbaric Battlements";
      ["level"] = 32;
      ["name_es"] = "Almenas barbaricas";
      ["req"] = 32;
   };
   [8520] = {
      ["name_ru"] = "Альянсу не хватает шелковых бинтов!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de bandages en soie?!";
      ["name_de"] = "Die Allianz braucht Seidenverbande!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21511;
      };
      ["name_cn"] = "?盟需要????！";
      ["objective"] = "Bring 20 Silk Bandages to Nurse Stonefield at the Military Ward in Ironforge.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Silk Bandages!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita vendas de seda!";
      ["req"] = 43;
   };
   [8047] = {
      ["name_ru"] = "Клеймо Язычника";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Das Emblem des Unglaubigen";
      ["name_fr"] = "La marque du paien";
      ["name"] = "The Heathen's Brand";
      ["name_cn"] = "?教徒的烙印";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19586;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8046;
      ["prequests"] = {
         [1] = 8046;
      };
      ["level"] = 60;
      ["name_es"] = "La Ensena del pagano";
      ["req"] = 60;
   };
   [8063] = {
      ["name_ru"] = "Знаки Силы: наручи безумца";
      ["type"] = "Raid";
      ["objective"] = "Bring Falthir the Sightless a Primal Hakkari Armsplint.  You must also have a reputation equal to or greater than Friendly with the Zandalar Tribe.$B$BFalthir the Sightless is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: les brassards d'insense";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：狂妄者?腕";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19836;
      };
      ["name_de"] = "Symbole der Macht: Die Armschienen des Wildfangs";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Madcap's Bracers";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: los Brazales de sinconcierto";
      ["req"] = 60;
   };
   [8079] = {
      ["name_ru"] = "Знаки Силы: кираса воздаятеля";
      ["type"] = "Raid";
      ["objective"] = "Bring Jin'rokh the Breaker a Primal Hakkari Kossack.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BJin'rokh the Breaker is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la cuirasse de redresseur de torts";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：??者胸甲";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 19822;
      };
      ["name_de"] = "Symbole der Macht: Die Brustplatte des Vollstreckers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Vindicator's Breastplate";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: la coraza de vindicador";
      ["req"] = 60;
   };
   [8222] = {
      ["name_ru"] = "Светящаяся кровь скорпида";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Sang de scorpide luminescent";
      ["name_cn"] = "?光的蝎血";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Leuchtendes Skorpidblut";
      ["faction"] = "Horde";
      ["name"] = "Glowing Scorpid Blood";
      ["level"] = 60;
      ["name_es"] = "Sangre de escorpido resplandeciente";
      ["req"] = 40;
   };
   [8111] = {
      ["name_ru"] = "Зачарованные водоросли Южных морей";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Verzauberter Sudmeertang";
      ["name_fr"] = "Le varech enchante des Mers du sud";
      ["name"] = "Enchanted South Seas Kelp";
      ["name_cn"] = "南海魔化海藻";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19611;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8110;
      ["prequests"] = {
         [1] = 8110;
      };
      ["level"] = 60;
      ["name_es"] = "Algas de los Mares del Sur encantadas";
      ["req"] = 60;
   };
   [1203] = {
      ["name_ru"] = "Ярлу нужен клинок";
      ["type"] = "Solo";
      ["name_fr"] = "Jarl a besoin d'une epee";
      ["name_de"] = "Jarl braucht eine Klinge";
      ["reward"] = {
         [1] = 9622;
         [2] = 5016;
      };
      ["name_cn"] = "加?的?";
      ["objective"] = "Bring a Moonsteel Broadsword to Jarl in Dustwallow Marsh.";
      ["faction"] = "Horde";
      ["name"] = "Jarl Needs a Blade";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1206;
      ["prequests"] = {
         [1] = 1206;
      };
      ["level"] = 35;
      ["name_es"] = "Jarl necesita una hoja";
      ["req"] = 30;
   };
   [8143] = {
      ["name_ru"] = "Зандаларский талисман Тени";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Zandalarischattentalisman";
      ["name_fr"] = "Le Talisman d'ombre zandalarien";
      ["name"] = "Zandalrian Shadow Talisman";
      ["name_cn"] = "??拉暗影??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19616;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8142;
      ["prequests"] = {
         [1] = 8142;
      };
      ["level"] = 60;
      ["name_es"] = "Dije Zandalar de las Sombras";
      ["req"] = 60;
   };
   [8159] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8156;
      ["prequests"] = {
         [1] = 8156;
      };
      ["level"] = 35;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 30;
   };
   [8236] = {
      ["name_ru"] = "Лазурный ключ";
      ["objective"] = "Return the Azure Key to Lord Jorach Ravenholdt.";
      ["name_cn"] = "碧??匙";
      ["sort"] = "Rogue";
      ["level"] = 52;
      ["type"] = "Dungeon";
      ["name_fr"] = "La cle d’azur";
      ["repgain"] = {
         [349] = 350;
      };
      ["name_de"] = "Der azurblaue Schlussel";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 19984;
         [2] = 20255;
         [3] = 19982;
      };
      ["name"] = "The Azure Key";
      ["prev"] = 8235;
      ["prequests"] = {
         [1] = 8235;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La llave azur";
      ["req"] = 50;
   };
   [8191] = {
      ["name_ru"] = "Пророческая аура";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 100;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "L'aura prophetique";
      ["name_cn"] = "?言的光?";
      ["reward"] = {
         [1] = 19789;
      };
      ["name_de"] = "Prophetische Aura";
      ["faction"] = "Horde";
      ["name"] = "Prophetic Aura";
      ["level"] = 60;
      ["name_es"] = "Aura profetica";
      ["req"] = 58;
   };
   [4112] = {
      ["name_ru"] = "Лекарство из распыленных предметов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Entzauberung";
      ["name_fr"] = "Du baume contre des desenchantements";
      ["name_cn"] = "分解??膏";
      ["name"] = "Salve via Disenchanting";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4107;
      ["prequests"] = {
         [1] = 4107;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desencantamiento";
      ["req"] = 48;
   };
   [4128] = {
      ["name_ru"] = "Рагнар Громовар";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Ragnar Thunderbrew.";
      ["next"] = 4126;
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "拉格?・雷酒";
      ["name_fr"] = "Ragnar Tonnebiere";
      ["name_de"] = "Ragnar Donnerbrau";
      ["faction"] = "Alliance";
      ["name"] = "Ragnar Thunderbrew";
      ["level"] = 55;
      ["name_es"] = "Ragnar Cebatruenos";
      ["req"] = 50;
   };
   [4144] = {
      ["name_ru"] = "Побеги кровоцвета";
      ["type"] = "Solo";
      ["name_fr"] = "Les pousses de Petales-de-sang";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "血瓣花苗";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "Bloodpetal Sprouts";
      ["name_de"] = "Blutblutensprosslinge";
      ["prev"] = 4143;
      ["prequests"] = {
         [1] = 4143;
      };
      ["level"] = 53;
      ["name_es"] = "Brotes Sangrepetalo";
      ["req"] = 47;
   };
   [8318] = {
      ["name_ru"] = "Тайные послания";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Encrypted Twilight Texts to Bor Wildmane in Cenarion Hold.";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_fr"] = "Communications secretes";
      ["sort"] = "Silithus";
      ["name_cn"] = "秘密交流";
      ["name_de"] = "Geheime Nachrichten";
      ["faction"] = "Horde";
      ["name"] = "Secret Communication";
      ["level"] = 60;
      ["name_es"] = "Mensajes secretos";
      ["req"] = 57;
   };
   [8238] = {
      ["name_ru"] = "Монеты племен: Гурубаши, Порочная Ветвь и Сухокожие";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [270] = 25;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Pieces Gurubashi, Vilebranche et Fanecorce";
      ["name_cn"] = "古拉巴什、邪枝和枯木硬?";
      ["reward"] = {
         [1] = 19858;
      };
      ["name_de"] = "Munzen der Gurubashi, Blutfratzen und Bleichborken";
      ["faction"] = "Horde";
      ["name"] = "Gurubashi, Vilebranch, and Witherbark Coins";
      ["level"] = 60;
      ["name_es"] = "Las monedas Gurubashi, Vilrama y Secacorteza";
      ["req"] = 58;
   };
   [8382] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??之?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20704;
         [2] = 20714;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [8414] = {
      ["name_ru"] = "Борьба со злом";
      ["type"] = "Solo";
      ["name_fr"] = "La dissipation du mal";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_de"] = "Austreibung des Bosen";
      ["objective"] = "Collect 20 Minion's Scourgestones and bring them to High Priest Thel'danis in the Western Plaguelands.";
      ["name_cn"] = "?散邪?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Dispelling Evil";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 8415;
      ["prequests"] = {
         [1] = 8415;
      };
      ["level"] = 52;
      ["name_es"] = "Expulsion de los demonios";
      ["req"] = 50;
   };
   [4224] = {
      ["name_ru"] = "Подлинные хозяева";
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4241;
      ["name_de"] = "Die wahren Meister";
      ["name"] = "The True Masters";
      ["name_cn"] = "真正的主人";
      ["objective"] = "Speak with Ragged John to learn of Marshal Windsor's fate and return to Marshal Maxwell when you have completed this task.$B$BYou recall Marshal Maxwell telling you to search for him in a cave to the north.";
      ["series"] = 6;
      ["faction"] = "Alliance";
      ["sort"] = "Burning Steppes";
      ["prev"] = 4223;
      ["prequests"] = {
         [1] = 4223;
      };
      ["level"] = 54;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [3822] = {
      ["name_ru"] = "Кром'Грул";
      ["type"] = "Solo";
      ["objective"] = "Recover Sha'ni's Nose-Ring from Krom'Grul and return it to Thal'trak in Kargath. Search the various caves and mines in Dreadmaul Rock.$B";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Krom'Grul";
      ["reward"] = {
         [1] = 11869;
      };
      ["name_cn"] = "克?格??";
      ["name_fr"] = "Krom'Grul";
      ["faction"] = "Horde";
      ["name"] = "Krom'Grul";
      ["sort"] = "Burning Steppes";
      ["prev"] = 3821;
      ["prequests"] = {
         [1] = 3821;
      };
      ["level"] = 53;
      ["name_es"] = "Krom'Grul";
      ["req"] = 48;
   };
   [8510] = {
      ["name_ru"] = "Альянсу снова нужны слезы Артаса";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de larmes d'Arthas?!";
      ["name_de"] = "Die Allianz braucht mehr Arthas' Tranen!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_cn"] = "?盟需要更多阿??斯之泪！";
      ["objective"] = "Bring 20 Arthas' Tears to Sergeant Major Germaine at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Arthas' Tears!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8509;
      ["prequests"] = {
         [1] = 8509;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas lagrimas de Arthas!";
      ["req"] = 1;
   };
   [8542] = {
      ["name_ru"] = "Орде не хватает оловянных слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Tin Bars to Grunt Maug at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de barres d'etain?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要??！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["name_de"] = "Die Horde braucht Zinnbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Tin Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita lingotes de estano!";
      ["req"] = 54;
   };
   [4288] = {
      ["name_ru"] = "Западный пилон";
      ["type"] = "Solo";
      ["name_fr"] = "Le Pylone ouest";
      ["name_de"] = "Der Westpylon";
      ["objective"] = "Discover the location of the Western Crystal Pylon.";
      ["name_cn"] = "西部水晶塔";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The Western Pylon";
      ["followup"] = 4321;
      ["prev"] = 4284;
      ["prequests"] = {
         [1] = 4284;
      };
      ["level"] = 53;
      ["name_es"] = "La Torre de cristal del Oeste";
      ["req"] = 47;
   };
   [8606] = {
      ["name_ru"] = "Утка!";
      ["type"] = "Group";
      ["name_fr"] = "Un leurre?!";
      ["repgain"] = {
         [910] = 25;
      };
      ["name_de"] = "Lockvogel!";
      ["name"] = "Decoy!";
      ["name_cn"] = "螳螂捕蝉！";
      ["objective"] = "Narain Soothfancy in Tanaris wants you to travel to Winterspring and place the Bag of Gold at the drop off point documented by the booknappers.";
      ["next"] = 8620;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8598;
      ["prequests"] = {
         [1] = 8598;
      };
      ["level"] = 60;
      ["name_es"] = "!Senuelo!";
      ["req"] = 60;
   };
   [8638] = {
      ["name_ru"] = "Жилет торговца смертью";
      ["objective"] = "Bring the the Carapace of the Old God, 2 Idols of Strife, 5 Bronze Scarabs and 5 Ivory Scarabs to Vethsera inside Ahn'Qiraj.  You must also attain Honored reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "死亡?行者的胸甲";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le gilet du dispensateur de mort";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Weste des Todesboten";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21364;
      };
      ["name"] = "Deathdealer's Vest";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El jubon de mortifero";
      ["req"] = 60;
   };
   [8670] = {
      ["name_ru"] = "Предок Рунический Тотем";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Totem-runique";
      ["name_cn"] = "符文???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Runentotem";
      ["faction"] = "Horde";
      ["name"] = "Runetotem the Elder";
      ["level"] = 60;
      ["name_es"] = "Totem de Runa el Ancestro";
      ["req"] = 1;
   };
   [8702] = {
      ["name_ru"] = "Кольцо Неназванных Имен";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ceremonial Ring, 2 Jasper Idols, 5 Stone Scarabs and 5 Crystal Scarabs to Windcaller Yessendra  in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau des noms inexprimes";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "禁断邪?之戒";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21417;
      };
      ["name_de"] = "Ring der ungesagten Namen";
      ["faction"] = "Horde";
      ["name"] = "Ring of Unspoken Names";
      ["level"] = 60;
      ["name_es"] = "El anillo de los nombres prohibidos";
      ["req"] = 60;
   };
   [8734] = {
      ["name_ru"] = "Тиранда и Ремул";
      ["type"] = "Solo";
      ["name_fr"] = "Tyrande et Remulos";
      ["repgain"] = {
         [910] = 10;
         [609] = 150;
      };
      ["name_de"] = "Tyrande und Remulos";
      ["name"] = "Tyrande and Remulos";
      ["name_cn"] = "泰?德和雷姆洛斯";
      ["objective"] = "Travel to the Moonglade and speak to Keeper Remulos. ";
      ["next"] = 8735;
      ["faction"] = "Horde";
      ["sort"] = "Teldrassil";
      ["prev"] = 8733;
      ["prequests"] = {
         [1] = 8733;
      };
      ["level"] = 60;
      ["name_es"] = "Tyrande y Remulos";
      ["req"] = 60;
   };
   [8766] = {
      ["name_ru"] = "Изменение пути ? уже не победитель";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "Changer de voie - adieu au Conquerant";
      ["name_cn"] = "??征服者之路";
      ["reward"] = {
         [1] = 21200;
         [2] = 21210;
      };
      ["name_de"] = "Den Pfad wechseln - Kein Eroberer mehr";
      ["faction"] = "Horde";
      ["name"] = "The Changing of Paths - Conqueror No More";
      ["level"] = 60;
      ["name_es"] = "Cambio de ruta: conquistador, nunca mas";
      ["req"] = 60;
   };
   [8798] = {
      ["name_ru"] = "Твой собственный Йети";
      ["type"] = "Solo";
      ["name_fr"] = "Un yeti rien que pour vous";
      ["sort"] = "Winterspring";
      ["name_cn"] = "?自己的机械雪人";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "A Yeti of Your Own";
      ["name_de"] = "Euer eigener Yeti";
      ["prev"] = 5163;
      ["prequests"] = {
         [1] = 5163;
      };
      ["level"] = 60;
      ["name_es"] = "Un yeti propio";
      ["req"] = 55;
   };
   [8830] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8811;
      ["prequests"] = {
         [1] = 8811;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8862] = {
      ["name_ru"] = "Свеча Элуны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "La chandelle d'Elune";
      ["name_cn"] = "艾露恩的??";
      ["reward"] = {
         [1] = 21713;
         [2] = 21640;
      };
      ["name_de"] = "Elunes Kerze";
      ["faction"] = "Horde";
      ["name"] = "Elune's Candle";
      ["level"] = 60;
      ["name_es"] = "Vela de Elune";
      ["req"] = 10;
   };
   [4448] = {
      ["name_ru"] = "Оскверненный ночной дракон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的夜?草";
      ["name_fr"] = "Dragon nocturne corrompu";
      ["name_de"] = "Verderbter Nachtdrache";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Night Dragon";
      ["level"] = 55;
      ["name_es"] = "Dragon nocturno corrupto";
      ["req"] = 48;
   };
   [4464] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [8958] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Dreadmist Sandals, Dreadmist Leggings and Dreadmist Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22076;
         [2] = 22072;
         [3] = 22073;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [4496] = {
      ["name_ru"] = "Путаница в джунглях";
      ["type"] = "Solo";
      ["objective"] = "Bring a Gorishi Scent Gland and 5 Un'Goro Soil samples to Alchemist Pestlezugg in Gadgetzan.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "Fiasco dans la jungle";
      ["sort"] = "Tanaris";
      ["name_cn"] = "擒虫先擒王";
      ["name_de"] = "Dschungelei";
      ["faction"] = "Horde";
      ["name"] = "Bungle in the Jungle";
      ["level"] = 53;
      ["name_es"] = "Que jungla tan chunga";
      ["req"] = 50;
   };
   [4512] = {
      ["name_ru"] = "Долгий путь слизнюка";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Filled Cursed Ooze Jars and 6 Filled Tainted Ooze Jars to Laris Geardawdle in Ironforge.";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_fr"] = "Un grand periple pour une petite gelee";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?方的?泥怪";
      ["name_de"] = "Schlamm auf Abwegen";
      ["faction"] = "Alliance";
      ["name"] = "A Little Slime Goes a Long Way";
      ["level"] = 52;
      ["name_es"] = "Un largo camino para unas babosas";
      ["req"] = 48;
   };
   [9054] = {
      ["name_ru"] = "Мундир расхитителя гробниц";
      ["type"] = "Raid";
      ["name_fr"] = "La tunique de traqueur des cryptes";
      ["name_de"] = "Tunika des Gruftpirschers";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make a Cryptstalker Tunic if you bring him the following: 1 Desecrated Tunic, 25 Wartorn Chain Scraps, 4 Arcanite Bars and 3 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22436;
      };
      ["name_cn"] = "地穴追?者外套";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Cryptstalker Tunic";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La guerrera de acechacriptas";
      ["req"] = 60;
   };
   [9086] = {
      ["name_ru"] = "Мундир сновидца";
      ["type"] = "Raid";
      ["name_fr"] = "La tunique de marchereve";
      ["name_de"] = "Tunika des Traumwandlers";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make a Dreamwalker Tunic if you bring her the following: 1 Desecrated Tunic, 25 Wartorn Leather Scraps, 6 Cured Rugged Hides and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22488;
      };
      ["name_cn"] = "梦游者外套";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Dreamwalker Tunic";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La guerrera Caminasuenos";
      ["req"] = 60;
   };
   [9118] = {
      ["name_ru"] = "Наручники веры";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make Bindings of Faith if you bring him the following: 1 Desecrated Bindings, 6 Wartorn Cloth Scraps, 1 Arcane Crystal and 1 Nexus Crystal.";
      ["name_cn"] = "信仰腕?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les manchettes de foi";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Bindungen des Glaubens";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22519;
      };
      ["name"] = "Bindings of Faith";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las ataduras de fe";
      ["req"] = 60;
   };
   [8242] = {
      ["name_ru"] = "Пополнение запасов огненного плавня ? толстая кожа";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 25;
      };
      ["name_de"] = "Nachschub an feurigem Fluxus: Schweres Leder";
      ["name_cn"] = "??助熔?的??：重皮";
      ["name_fr"] = "Reapprovisionnement en flux embrase (Cuir lourd)";
      ["name"] = "Restoring Fiery Flux Supplies via Heavy Leather";
      ["faction"] = "Horde";
      ["sort"] = "Searing Gorge";
      ["prev"] = 7722;
      ["prequests"] = {
         [1] = 7722;
      };
      ["level"] = 60;
      ["name_es"] = "Fabricar flujo igneo con cuero pesado";
      ["req"] = 45;
   };
   [9182] = {
      ["name_ru"] = "Задание мастера: огромный ториевый боевой топор";
      ["type"] = "Solo";
      ["objective"] = "Deliver 3 Huge Thorium Battleaxes and the Craftsman's Writ - Huge Thorium Battleaxe - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Grandes haches en thorium";
      ["name_cn"] = "工匠文? - 巨型瑟??斧";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Gewaltige Thoriumstreitaxt";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Huge Thorium Battleaxe";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: hacha de batalla de torio enorme";
      ["req"] = 55;
   };
   [8249] = {
      ["name_ru"] = "Принести ларцы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [349] = 75;
      };
      ["sort"] = "Rogue";
      ["name_fr"] = "Demande de coffrets";
      ["name_cn"] = "??箱";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 20086;
      };
      ["name_de"] = "Plunderkisten benotigt";
      ["faction"] = "Horde";
      ["name"] = "Junkboxes Needed";
      ["level"] = 60;
      ["name_es"] = "Se necesitan cajas de trastos";
      ["req"] = 50;
   };
   [9246] = {
      ["name_ru"] = "Кираса из ледяной чешуи";
      ["type"] = "Raid";
      ["name_fr"] = "La cuirasse glacecaille";
      ["name_de"] = "Eisschuppenbrustplatte";
      ["reward"] = {
         [1] = 22664;
      };
      ["name_cn"] = "冰?胸甲";
      ["objective"] = "Craftsman Wilhelm at Light's Hope Chapel in the Eastern Plaguelands wants 8 Frozen Runes, 24 Heavy Scorpid Scale, 7 Essence of Water, 5 Cured Rugged Hides and 300 gold. You must also be of Exalted reputation with the Argent Dawn.";
      ["faction"] = "Horde";
      ["name"] = "Icy Scale Breastplate";
      ["sort"] = "Naxxramas";
      ["prev"] = 9233;
      ["prequests"] = {
         [1] = 9233;
      };
      ["level"] = 60;
      ["name_es"] = "La coraza de escamas heladas";
      ["req"] = 60;
   };
   [9185] = {
      ["name_ru"] = "Задание мастера: накладки из грубой кожи";
      ["type"] = "Solo";
      ["objective"] = "Deliver 25 Rugged Armor Kits and the Craftsman's Writ - Rugged Armor Kit - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.$B";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Renforts d'armure robustes";
      ["name_cn"] = "工匠文? - 毛皮?甲片";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Unverwustliches Rustungsset";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Rugged Armor Kit";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: refuerzo para armadura basto";
      ["req"] = 55;
   };
   [9310] = {
      ["name_ru"] = "Тусклый некротический кристалл";
      ["type"] = "Solo";
      ["objective"] = "Bring the Faint Necrotic Crystal to Lieutenant Rukag in the courtyard of the Undercity.";
      ["name_fr"] = "Cristal necrotique voile";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "暗淡的死?水晶";
      ["reward"] = {
         [1] = 23123;
         [2] = 23122;
      };
      ["name_de"] = "Schwacher nekrotischer Kristall";
      ["faction"] = "Horde";
      ["name"] = "Faint Necrotic Crystal";
      ["level"] = 60;
      ["name_es"] = "Cristal necrotico tenue";
      ["req"] = 60;
   };
   [6185] = {
      ["name_ru"] = "Чума на востоке";
      ["type"] = "Group";
      ["name_fr"] = "Les Maleterres de l'Est";
      ["next"] = 6186;
      ["name_de"] = "Die Ostlichen Pestlander";
      ["name_cn"] = "?部的瘟疫";
      ["objective"] = "Scour the Eastern Plaguelands for clues as to the Blightcaller\" and the missing SI:7 agents. If you find any SI:7 Insignias";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "The Eastern Plagues";
      ["prev"] = 6184;
      ["prequests"] = {
         [1] = 6184;
      };
      ["level"] = 60;
      ["name_es"] = "Las pestes del este";
      ["req"] = 56;
   };
   [6521] = {
      ["name_ru"] = "Нечестивый союз";
      ["type"] = "Dungeon";
      ["objective"] = "Bring Ambassador Malcin's Head to Varimathras in the Undercity.";
      ["name_de"] = "Eine unheilige Allianz";
      ["name_fr"] = "Une alliance impie";
      ["reward"] = {
         [1] = 17039;
         [2] = 17042;
         [3] = 17043;
      };
      ["name_cn"] = "邪?的盟友";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "An Unholy Alliance";
      ["sort"] = "Razorfen Downs";
      ["prev"] = 6522;
      ["prequests"] = {
         [1] = 6522;
      };
      ["level"] = 36;
      ["name_es"] = "Una alianza impia";
      ["req"] = 28;
   };
   [4185] = {
      ["name_ru"] = "Подлинные хозяева";
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4186;
      ["name_de"] = "Die wahren Meister";
      ["name"] = "The True Masters";
      ["name_cn"] = "真正的主人";
      ["objective"] = "Speak with Highlord Bolvar Fordragon after speaking with Lady Katrana Prestor.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Burning Steppes";
      ["prev"] = 4184;
      ["prequests"] = {
         [1] = 4184;
      };
      ["level"] = 54;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [5041] = {
      ["name_ru"] = "Снабжение Перекрестка";
      ["type"] = "Solo";
      ["objective"] = "Find and return Crossroads' Supply Crates to Thork in the Barrens.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "Ravitaillement pour la Croisee";
      ["sort"] = "The Barrens";
      ["name_cn"] = "十字路口的??品";
      ["name_de"] = "Vorrate fur das Wegekreuz";
      ["faction"] = "Horde";
      ["name"] = "Supplies for the Crossroads";
      ["level"] = 14;
      ["name_es"] = "Suministros para El Cruce";
      ["req"] = 9;
   };
   [4736] = {
      ["name_ru"] = "Поиски Менары Расщепительницы Бездны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1796;
      ["sort"] = "Warlock";
      ["name_cn"] = "?找梅?拉・沃?德";
      ["name_fr"] = "A la recherche de Menara Taillevide";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Auf der Suche nach Menara Leerbringer";
      ["faction"] = "Horde";
      ["name"] = "In Search of Menara Voidrender";
      ["level"] = 31;
      ["name_es"] = "Buscando a Menara Nadiz";
      ["req"] = 31;
   };
   [1185] = {
      ["name_ru"] = "А под хитином было...";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Unter dem Chitin war...";
      ["name_cn"] = "?中的?西…";
      ["name_fr"] = "Sous la chitine...";
      ["name"] = "Under the Chitin Was...";
      ["faction"] = "Horde";
      ["sort"] = "Moonglade";
      ["prev"] = 6845;
      ["prequests"] = {
         [1] = 6845;
      };
      ["level"] = 57;
      ["name_es"] = "Debajo de la quitina habia...";
      ["req"] = 54;
   };
   [4768] = {
      ["name_ru"] = "Табличка Темного Камня";
      ["type"] = "Raid";
      ["objective"] = "Bring the Darkstone Tablet to Shadow Mage Vivian Lagrave in Kargath.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Die Dunkelsteinschrifttafel";
      ["reward"] = {
         [1] = 15861;
         [2] = 15860;
      };
      ["name_cn"] = "黑暗石板";
      ["name_fr"] = "La tablette de Sombrepierre";
      ["faction"] = "Horde";
      ["name"] = "The Darkstone Tablet";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4769;
      ["prequests"] = {
         [1] = 4769;
      };
      ["level"] = 60;
      ["name_es"] = "La tablilla de Rocanegra";
      ["req"] = 57;
   };
   [4784] = {
      ["name_ru"] = "Материалы для зачарованного золотого кровавого одеяния";
      ["objective"] = "Bring some Fine Gold Thread, 2 Smoldering Coals, and a Soul Shard to Menara Voidrender in the Barrens.";
      ["name_cn"] = "魔化金?血袍";
      ["sort"] = "Warlock";
      ["level"] = 37;
      ["type"] = "Solo";
      ["name_fr"] = "Les composants de la robe sanglante doree enchantee";
      ["next"] = 4786;
      ["name_de"] = "Komponenten fur die verzauberte Goldblutrobe";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Components for the Enchanted Gold Bloodrobe";
      ["prev"] = 4783;
      ["prequests"] = {
         [1] = 4783;
      };
      ["series"] = 5;
      ["name_es"] = "Los componentes para la toga de sangre dorada encantada";
      ["req"] = 31;
   };
   [9003] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Devout Crown and Devout Robe.";
      ["reward"] = {
         [1] = 22080;
         [2] = 22083;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [8275] = {
      ["name_ru"] = "Отвоевание Силитуса";
      ["type"] = "Solo";
      ["objective"] = "Talk to Windcaller Proudhorn at Cenarion Hold in Silithus.";
      ["next"] = 8280;
      ["name_fr"] = "La reconquete de Silithus";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?回希利?斯";
      ["repgain"] = {
         [609] = 10;
      };
      ["name_de"] = "Die Ruckeroberung von Silithus";
      ["faction"] = "Alliance";
      ["name"] = "Taking Back Silithus";
      ["level"] = 55;
      ["name_es"] = "La reconquista de Silithus";
      ["req"] = 54;
   };
   [1201] = {
      ["name_ru"] = "Тераморские шпионы";
      ["type"] = "Solo";
      ["objective"] = "Kill 9 Theramore Infiltrators, then return to Nazeer Bloodpike in Brackenwall Village.";
      ["next"] = 1202;
      ["name_fr"] = "Les espions de Theramore";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "塞拉摩??";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Theramores Spione";
      ["faction"] = "Horde";
      ["name"] = "Theramore Spies";
      ["level"] = 35;
      ["name_es"] = "Los espias de Theramore";
      ["req"] = 30;
   };
   [8282] = {
      ["name_ru"] = "Потерянная сумка Ноггла";
      ["type"] = "Solo";
      ["objective"] = "Retrieve Noggle's Satchel from the mountains in the south of Silithus and return it to him at Cenarion Hold.";
      ["repgain"] = {
         [609] = 500;
      };
      ["name_de"] = "Noggles verlorener Ranzen";
      ["reward"] = {
         [1] = 13452;
         [2] = 13447;
      };
      ["name_cn"] = "?格的背包";
      ["name_fr"] = "La sacoche perdue de Noggle";
      ["faction"] = "Horde";
      ["name"] = "Noggle's Lost Satchel";
      ["sort"] = "Silithus";
      ["prev"] = 8278;
      ["prequests"] = {
         [1] = 8278;
      };
      ["level"] = 58;
      ["name_es"] = "La cartera perdida de Noggle";
      ["req"] = 54;
   };
   [4864] = {
      ["name_ru"] = "Разъяренные дикие совухи";
      ["type"] = "Solo";
      ["objective"] = "Pick up Jaron's Supplies from the snow, then find the wildkin that stole the amulet Jaron spoke of.$B$BBring Jaron's Supplies and the Blue-feathered Amulet to Jaron Stoneshaper at the lodge in Winterspring.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Wutende Wildekin";
      ["name"] = "Enraged Wildkin";
      ["name_cn"] = "被激怒的??";
      ["name_fr"] = "Les Indomptables enrages";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Winterspring";
      ["prev"] = 4863;
      ["prequests"] = {
         [1] = 4863;
      };
      ["level"] = 59;
      ["name_es"] = "Lechucico salvaje iracundo";
      ["req"] = 53;
   };
   [8285] = {
      ["name_ru"] = "Дезертир";
      ["type"] = "Solo";
      ["name_fr"] = "Le deserteur";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Der Deserteur";
      ["name"] = "The Deserter";
      ["name_cn"] = "沙漠?士";
      ["objective"] = "Take the restored tablet to Hermit Ortell in Silithus.$B";
      ["next"] = 8279;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8284;
      ["prequests"] = {
         [1] = 8284;
      };
      ["level"] = 59;
      ["name_es"] = "El desertor";
      ["req"] = 54;
   };
   [9210] = {
      ["name_ru"] = "Защита Джунглей ? Магический знак сосредоточения";
      ["type"] = "Raid";
      ["objective"] = "Zanza the Restless in Zul'Gurub wants an Arcanum of Focus.";
      ["repgain"] = {
         [270] = 200;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La Garde sauvage - Arcanum de focalisation";
      ["name_cn"] = "野性戒? - ?注秘?";
      ["reward"] = {
         [1] = 22635;
      };
      ["name_de"] = "Der Greuelwachter - Arkanum des Fokus";
      ["faction"] = "Horde";
      ["name"] = "The Savage Guard - Arcanum of Focus";
      ["level"] = 60;
      ["name_es"] = "La guardia salvaje: arcanum de enfoque";
      ["req"] = 60;
   };
   [3182] = {
      ["name_ru"] = "Доказательство собственности";
      ["type"] = "Group";
      ["name_fr"] = "Titre de propriete";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Besitznachweis";
      ["name_cn"] = "?明信";
      ["name"] = "Proof of Deed";
      ["objective"] = "Take Margol's Gigantic Horn to Curator Thorius in Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Loch Modan";
      ["prev"] = 3181;
      ["prequests"] = {
         [1] = 3181;
      };
      ["level"] = 48;
      ["name_es"] = "Certificado de autenticidad";
      ["req"] = 40;
   };
   [8298] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "More Resource Crates";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8297;
      ["prequests"] = {
         [1] = 8297;
      };
      ["level"] = 60;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 60;
   };
   [1642] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1643;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1641;
      ["prequests"] = {
         [1] = 1641;
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [5641] = {
      ["name_ru"] = "Бесстрашие";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priest Rohan in Ironforge.";
      ["sort"] = "Priest";
      ["name_fr"] = "Un manque de peur";
      ["name_cn"] = "毫无畏惧";
      ["name_de"] = "Furchtlos";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["name"] = "A Lack of Fear";
      ["level"] = 20;
      ["name_es"] = "Sin miedo";
      ["req"] = 20;
   };
   [4976] = {
      ["name_ru"] = "Возвращение к Менаре";
      ["type"] = "Solo";
      ["name_fr"] = "Rapporter l'Orbe purifie";
      ["name_de"] = "Ablieferung der gesauberten Kugel";
      ["objective"] = "Return the Cleansed Infernal Orb to Menara Voidrender in the Barrens.";
      ["name_cn"] = "???化?的宝珠";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Returning the Cleansed Orb";
      ["prev"] = 4961;
      ["prequests"] = {
         [1] = 4961;
      };
      ["level"] = 40;
      ["name_es"] = "Devolver el orbe purificado";
      ["req"] = 35;
   };
   [3923] = {
      ["name_ru"] = "Рилли Грязегоб";
      ["type"] = "Solo";
      ["name_fr"] = "Rilli Grassougob";
      ["repgain"] = {
         [470] = 25;
         [530] = 10;
         [81] = 10;
         [76] = 10;
      };
      ["name_de"] = "Rilli Schmierklump";
      ["name"] = "Rilli Greasygob";
      ["name_cn"] = "雷里・格里斯高布";
      ["objective"] = "Bring the Broken and Battered Samophlange to Rilli Greasygob in Orgrimmar.";
      ["next"] = 3924;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 3922;
      ["prequests"] = {
         [1] = 3922;
      };
      ["level"] = 18;
      ["name_es"] = "Rilli Gapegajoso";
      ["req"] = 10;
   };
   [2923] = {
      ["name_ru"] = "Мехмастер Замыкалец";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Tinkmaster Overspark in Ironforge.";
      ["next"] = 2922;
      ["name_fr"] = "Maitre-bricoleur Supretincelle";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "工匠大?欧沃斯巴克";
      ["repgain"] = {
         [54] = 25;
      };
      ["name_de"] = "Tuftlermeister Oberfunks";
      ["faction"] = "Alliance";
      ["name"] = "Tinkmaster Overspark";
      ["level"] = 26;
      ["name_es"] = "Maestro manitas Sobrechispa";
      ["req"] = 20;
   };
   [2098] = {
      ["name_ru"] = "Помощь Гиромачту";
      ["type"] = "Solo";
      ["objective"] = "Find and return the three pieces of Gelkak's Key to Gelkak Gyromast.";
      ["next"] = 2078;
      ["name_fr"] = "La recherche de Gyromast";
      ["sort"] = "Darkshore";
      ["name_cn"] = "基??克的?匙";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Gyromasts Rettung";
      ["faction"] = "Alliance";
      ["name"] = "Gyromast's Retrieval";
      ["level"] = 20;
      ["name_es"] = "La busqueda de Gyromast";
      ["req"] = 14;
   };
   [8306] = {
      ["name_ru"] = "В бездне безумия";
      ["type"] = "Group";
      ["objective"] = "Commander Mar'alith at Cenarion Hold in Silithus wants you to find his beloved Natalia. The information that you gathered points to Hive'Regal in the south as being the area in which you may find Mistress Natalia Mar'alith.$B$BDo not forget to visit the dwarves at Bronzebeard's camp before venturing into the hive. They might have some additional work and advice for you.$B$BAnd $N, remember the Commander's words: Do what you must...\"\"";
      ["repgain"] = {
         [609] = 200;
      };
      ["name_de"] = "Der Schlund des Wahnsinns";
      ["reward"] = {
         [1] = 20724;
      };
      ["name_cn"] = "深入?狂之口";
      ["name_fr"] = "L'antre de la folie";
      ["faction"] = "Horde";
      ["name"] = "Into The Maw of Madness";
      ["sort"] = "Silithus";
      ["prev"] = 8304;
      ["prequests"] = {
         [1] = 8304;
      };
      ["level"] = 60;
      ["name_es"] = "En las fauces de la locura";
      ["req"] = 58;
   };
   [5056] = {
      ["name_ru"] = "Ши-Ротам";
      ["type"] = "Group";
      ["name_fr"] = "Shy-Rotam";
      ["name_de"] = "Shy-Rotam";
      ["reward"] = {
         [1] = 15783;
         [2] = 15782;
      };
      ["name_cn"] = "希洛塔姆";
      ["objective"] = "Storm Shadowhoof at Everlook in Winterspring wants you to defeat Shy-Rotam.";
      ["faction"] = "Horde";
      ["name"] = "Shy-Rotam";
      ["sort"] = "Winterspring";
      ["prev"] = 5055;
      ["prequests"] = {
         [1] = 5055;
      };
      ["level"] = 60;
      ["name_es"] = "Shi-Rotam";
      ["req"] = 53;
   };
   [4285] = {
      ["name_ru"] = "Северный пилон";
      ["type"] = "Solo";
      ["name_fr"] = "Le Pylone nord";
      ["name_de"] = "Der Nordpylon";
      ["objective"] = "Discover the location of the Northern Crystal Pylon in Un'Goro Crater.";
      ["name_cn"] = "北部水晶塔";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The Northern Pylon";
      ["followup"] = 4321;
      ["prev"] = 4284;
      ["prequests"] = {
         [1] = 4284;
      };
      ["level"] = 53;
      ["name_es"] = "La Torre de cristal del Norte";
      ["req"] = 47;
   };
   [5088] = {
      ["name_ru"] = "Арикара";
      ["type"] = "Group";
      ["objective"] = "Slay Arikara. Bring her remains and the Incendia powder to Motega Firemane in Whitereach Post as proof of your deed.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Arikara";
      ["reward"] = {
         [1] = 15464;
         [2] = 15465;
         [3] = 15466;
      };
      ["name_cn"] = "阿利?拉";
      ["name_fr"] = "Arikara";
      ["faction"] = "Horde";
      ["name"] = "Arikara";
      ["sort"] = "Thousand Needles";
      ["prev"] = 5062;
      ["prequests"] = {
         [1] = 5062;
      };
      ["level"] = 28;
      ["name_es"] = "Arikara";
      ["req"] = 24;
   };
   [6641] = {
      ["name_ru"] = "Ворша Хлестунья";
      ["type"] = "Group";
      ["objective"] = "Keep Muglash safe as he travels to the brazier. Help him by putting the brazier out, then protect him as you fight against the Naga.$B$BIf you are successful, return to the Zoram'gar Outpost and inform the Warsong Runner of the death of Vorsha the Lasher.";
      ["name_fr"] = "Vorsha la Flagellante";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "鞭笞者沃?沙";
      ["reward"] = {
         [1] = 17692;
      };
      ["name_de"] = "Vorsha die Peitscherin";
      ["faction"] = "Horde";
      ["name"] = "Vorsha the Lasher";
      ["level"] = 23;
      ["name_es"] = "Vorsha la Azotadora";
      ["req"] = 20;
   };
   [4661] = {
      ["name_ru"] = "Проба ? образцы из Оскверненного леса";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Undercity";
      ["name_fr"] = "Test de corruption, Gangrebois";
      ["name_cn"] = "堕落?? - ?伍德森林";
      ["reward"] = {
         [1] = 15103;
      };
      ["name_de"] = "Test fur Verderbnis - Teufelswald";
      ["faction"] = "Horde";
      ["name"] = "Testing for Corruption - Felwood";
      ["level"] = 52;
      ["name_es"] = "Pruebas de Corrupcion: Frondavil";
      ["req"] = 48;
   };
   [8322] = {
      ["name_ru"] = "Тухлые яйца";
      ["type"] = "PvP";
      ["objective"] = "Place the Rotten Eggs in the main brew keg located inside the Southshore Inn.";
      ["next"] = 8409;
      ["name_fr"] = "Les ?ufs pourris";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "腐?的?蛋";
      ["repgain"] = {
         [76] = 25;
         [68] = 25;
         [81] = 25;
         [530] = 25;
      };
      ["name_de"] = "Faule Eier";
      ["faction"] = "Horde";
      ["name"] = "Rotten Eggs";
      ["level"] = 60;
      ["name_es"] = "Huevos podridos";
      ["req"] = 30;
   };
   [5152] = {
      ["name_ru"] = "Тетушка Марлен";
      ["type"] = "Solo";
      ["name_fr"] = "Tante Marlene";
      ["next"] = 5153;
      ["name_de"] = "Tante Marlene";
      ["name_cn"] = "?莱恩姑?";
      ["objective"] = "Speak with Marlene, south of the Ruins of Andorhal.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Auntie Marlene";
      ["prev"] = 5149;
      ["prequests"] = {
         [1] = 5149;
      };
      ["level"] = 56;
      ["name_es"] = "Tia Marlene";
      ["req"] = 50;
   };
   [5168] = {
      ["name_ru"] = "Герои Дарроушира";
      ["type"] = "Group";
      ["name_fr"] = "Les heros de Comte-de-Darrow";
      ["name_de"] = "Helden von Darroheim";
      ["objective"] = "Bring Davil's Libram and Redpath's Shield to Carlin Redpath.";
      ["name_cn"] = "?隆郡的英雄";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Heroes of Darrowshire";
      ["followup"] = 5206;
      ["prev"] = 5210;
      ["prequests"] = {
         [1] = 5210;
      };
      ["level"] = 56;
      ["name_es"] = "Los heroes de Villa Darrow";
      ["req"] = 50;
   };
   [9111] = {
      ["name_ru"] = "Одеяние веры";
      ["type"] = "Raid";
      ["name_fr"] = "La robe de foi";
      ["name_de"] = "Robe des Glaubens";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make a Robe of Faith if you bring him the following: 1 Desecrated Robe, 25 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22512;
      };
      ["name_cn"] = "信仰?袍";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Robe of Faith";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La toga de fe";
      ["req"] = 60;
   };
   [4510] = {
      ["name_ru"] = "Затишье перед бурей";
      ["objective"] = "Bring the Bank Voucher to Idriana in the bank of Darnassus.";
      ["name_cn"] = "?危不惧";
      ["sort"] = "Darnassus";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Le calme avant la tempete";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 500;
      };
      ["name_de"] = "Die Ruhe vor dem Sturm";
      ["reward"] = {
         [1] = 11870;
         [2] = 11871;
         [3] = 11872;
      };
      ["faction"] = "Alliance";
      ["name"] = "Calm Before the Storm";
      ["prev"] = 4508;
      ["prequests"] = {
         [1] = 4508;
      };
      ["series"] = 2;
      ["name_es"] = "La calma que precede a la tormenta";
      ["req"] = 50;
   };
   [5216] = {
      ["name_ru"] = "Цель: поле Джанис";
      ["objective"] = "Go to Felstone Field in Western Plaguelands to locate and defeat the Cauldron Lord present there.  It may have a key that will allow access to the cauldron.  You must have the Empty Felstone Field Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：??斯通??";
      ["sort"] = "Western Plaguelands";
      ["level"] = 53;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: le Champ de Gangrepierre";
      ["next"] = 5217;
      ["name_de"] = "Ziel: Teufelssteinfeld";
      ["repgain"] = {
         [469] = 250;
         [529] = 250;
      };
      ["followup"] = 5218;
      ["name"] = "Target: Felstone Field";
      ["prev"] = 5215;
      ["prequests"] = {
         [1] = 5215;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Objetivo: Campo de Piedramacula";
      ["req"] = 50;
   };
   [5232] = {
      ["name_ru"] = "Возвращение в Бастион";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a la Barricade";
      ["repgain"] = {
         [67] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Bollwerk";
      ["name"] = "Return to the Bulwark";
      ["name_cn"] = "返回亡?壁?";
      ["objective"] = "Bring the Filled Dalson's Tears Bottle to Shadow Priestess Vandis at the Bulwark, Western Plaguelands.";
      ["next"] = 5233;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5231;
      ["prequests"] = {
         [1] = 5231;
      };
      ["level"] = 55;
      ["name_es"] = "Regresa a El Baluarte";
      ["req"] = 50;
   };
   [5248] = {
      ["name_ru"] = "Измученный воспоминаниями о прошлом";
      ["type"] = "Solo";
      ["name_fr"] = "Tourmentee par le passe";
      ["repgain"] = {
         [69] = 25;
         [54] = 25;
         [72] = 25;
         [47] = 25;
      };
      ["name_de"] = "Gequalt von der Vergangenheit";
      ["name"] = "Tormented By the Past";
      ["name_cn"] = "??的折磨";
      ["objective"] = "Take the Crystal of Zin-Malor to Lake Kel'Theril in Winterspring and find a highborne spirit that will speak to you.";
      ["next"] = 5252;
      ["faction"] = "Alliance";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5247;
      ["prequests"] = {
         [1] = 5247;
      };
      ["level"] = 58;
      ["name_es"] = "Atormentados por el pasado";
      ["req"] = 53;
   };
   [5264] = {
      ["name_ru"] = "Лорд Максвелл Тиросс";
      ["type"] = "Group";
      ["name_fr"] = "Seigneur Maxwell Tyrosus";
      ["next"] = 5265;
      ["name_de"] = "Lord Maxwell Tyrosus";
      ["name_cn"] = "?克斯??・泰?索斯男爵";
      ["objective"] = "Speak with Lord Maxwell Tyrosus. He is inside the church.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Lord Maxwell Tyrosus";
      ["prev"] = 5263;
      ["prequests"] = {
         [1] = 5263;
      };
      ["level"] = 60;
      ["name_es"] = "Lord Maxwell Neofitus";
      ["req"] = 55;
   };
   [2981] = {
      ["name_ru"] = "Опасность в Фераласе";
      ["type"] = "Solo";
      ["objective"] = "Belgrom Rockmaul wants you to speak with Rok Orhan in Camp Mojache.";
      ["next"] = 2975;
      ["name_fr"] = "Menace sur Feralas";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "菲拉斯的危机";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Eine Bedrohung in Feralas";
      ["faction"] = "Horde";
      ["name"] = "A Threat in Feralas";
      ["level"] = 43;
      ["name_es"] = "Una amenaza en Feralas";
      ["req"] = 38;
   };
   [8360] = {
      ["name_ru"] = "Танец за марципан";
      ["type"] = "Solo";
      ["objective"] = "Do a dance emote at Innkeeper Pala, and in exchange you'll receive Thunder Bluff Marzipan!";
      ["name_fr"] = "Danser pour du massepain";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "跳跳舞，?糖果";
      ["reward"] = {
         [1] = 20497;
      };
      ["name_de"] = "Tanzen fur Marzipan";
      ["faction"] = "Horde";
      ["name"] = "Dancing for Marzipan";
      ["level"] = 60;
      ["name_es"] = "Bailando por mazapanes";
      ["req"] = 10;
   };
   [1074] = {
      ["name_ru"] = "Неумение + реактивы = потеха!";
      ["objective"] = "Bring the Nitromirglyceronium back to Gaxim Rustfizzle in Stonetalon.";
      ["name_cn"] = "失?+??=快?";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 21;
      ["type"] = "Solo";
      ["name_fr"] = "Inaptitude + Produits chimiques = Rigolo";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Stumperhaftigkeit + Chemikalien = Riesenspas!";
      ["followup"] = 1080;
      ["faction"] = "Alliance";
      ["name"] = "Ineptitude + Chemicals = Fun";
      ["prev"] = 1073;
      ["prequests"] = {
         [1] = 1073;
      };
      ["series"] = 2;
      ["name_es"] = "Ineptitud + Productos quimicos = Diversion";
      ["req"] = 17;
   };
   [4294] = {
      ["name_ru"] = "... и образцы слизнюков";
      ["type"] = "Solo";
      ["objective"] = "Gather Un'Goro Slime Samples from any of the slimes in Un'Goro Crater. Then, using the Testing Equipment next to Chemist Fuely in Undercity, see which of your samples are the most pure. Bring 5 of the Pure Un'Goro Samples you find to Chemist Fuely.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "... et une fournee de limon";
      ["sort"] = "Undercity";
      ["name_cn"] = "一大堆?泥怪";
      ["followup"] = 4642;
      ["name_de"] = "...und eine Menge Schlamm";
      ["faction"] = "Horde";
      ["name"] = "... and a Batch of Ooze";
      ["level"] = 56;
      ["name_es"] = "... y unos mocos";
      ["req"] = 48;
   };
   [5344] = {
      ["name_ru"] = "Последний из Баровых";
      ["type"] = "Group";
      ["name_fr"] = "Le dernier Barov";
      ["name_de"] = "Der letzte Barov";
      ["reward"] = {
         [1] = 14023;
      };
      ["name_cn"] = "巴?夫的?承人";
      ["objective"] = "Travel to the Bulwark - Horde territory - and assassinate Alexi Barov. Take his head and return to Weldon Barov.$B$BBe warned, Alexi will probably be well protected by Horde filth.";
      ["faction"] = "Alliance";
      ["name"] = "The Last Barov";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5343;
      ["prequests"] = {
         [1] = 5343;
      };
      ["level"] = 60;
      ["name_es"] = "El ultimo de los Barov";
      ["req"] = 52;
   };
   [8745] = {
      ["name_ru"] = "Сокровище Вневременного";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Der Schatz des Zeitlosen";
      ["name_fr"] = "Le tresor de l'Intemporel";
      ["name_cn"] = "永恒之宝的宝藏";
      ["faction"] = "Horde";
      ["name"] = "Treasure of the Timeless One";
      ["reward"] = {
         [1] = 21523;
         [2] = 21522;
         [3] = 21521;
         [4] = 21520;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8742;
      ["prequests"] = {
         [1] = 8742;
      };
      ["level"] = 60;
      ["name_es"] = "El tesoro del Atemporal";
      ["req"] = 60;
   };
   [4114] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [5761] = {
      ["name_ru"] = "Убить тварь";
      ["type"] = "Dungeon";
      ["objective"] = "Enter Ragefire Chasm and slay Taragaman the Hungerer, then bring his heart back to Neeru Fireblade in Orgrimmar.";
      ["sort"] = "Ragefire Chasm";
      ["name_cn"] = "??者塔拉加曼";
      ["name_fr"] = "Tuer la bete";
      ["name_de"] = "Vernichtung der Bestie";
      ["faction"] = "Horde";
      ["name"] = "Slaying the Beast";
      ["level"] = 16;
      ["name_es"] = "Matar a la bestia";
      ["req"] = 9;
   };
   [5408] = {
      ["name_ru"] = "Камни приспешников плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des serviteurs";
      ["name_cn"] = "爪牙的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Dieners";
      ["faction"] = "Horde";
      ["name"] = "Minion's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del esbirro";
      ["req"] = 50;
   };
   [8746] = {
      ["name_ru"] = "Метцен ? северный олень";
      ["type"] = "Solo";
      ["objective"] = "Find Metzen the Reindeer.  Use the notes provided to you for clues as to where he is being held.$B$BWhen you find Metzen, have the Pouch of Reindeer Dust in your possession so you can sprinkle some of the dust on him; this should free Metzen from his bonds of captivity.$B$BReturn the Pouch of Reindeer Dust to Kaymard Copperpinch in Orgrimmar once Metzen is freed.";
      ["repgain"] = {
         [169] = 500;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Metzen le renne";
      ["name_cn"] = "?鹿梅森";
      ["reward"] = {
         [1] = 21213;
      };
      ["name_de"] = "Metzen das Rentier";
      ["faction"] = "Horde";
      ["name"] = "Metzen the Reindeer";
      ["level"] = 60;
      ["name_es"] = "Metzen el reno";
      ["req"] = 40;
   };
   [4133] = {
      ["name_ru"] = "Вивиана Лягроб";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Shadowmaster Vivian Lagrave in Kargath.";
      ["next"] = 4134;
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "薇薇安・拉格雷";
      ["name_fr"] = "Vivian Lagrave";
      ["name_de"] = "Vivian Lagrave";
      ["faction"] = "Horde";
      ["name"] = "Vivian Lagrave";
      ["level"] = 55;
      ["name_es"] = "Vivian Lagrave";
      ["req"] = 50;
   };
   [8410] = {
      ["name_ru"] = "Покорение стихий";
      ["type"] = "Solo";
      ["objective"] = "Collect a sample of air, fire, earth and water for Bath'rah the Windwatcher.";
      ["next"] = 8412;
      ["sort"] = "Shaman";
      ["name_cn"] = "元素掌握";
      ["name_fr"] = "La maitrise des elements";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name_de"] = "Elementarbeherrschung";
      ["faction"] = "Horde";
      ["name"] = "Elemental Mastery";
      ["level"] = 50;
      ["name_es"] = "Maestria elemental";
      ["req"] = 50;
   };
   [8948] = {
      ["name_ru"] = "Старый приятель Антиона";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le vieil ami d'Anthion";
      ["next"] = 8949;
      ["name_de"] = "Anthions alter Freund";
      ["name_cn"] = "安泰恩的老朋友";
      ["objective"] = "Take the incomplete Banner of Provocation to Falrin Treeshaper at the library in Dire Maul.";
      ["sort"] = "Dire Maul";
      ["faction"] = "Horde";
      ["name"] = "Anthion's Old Friend";
      ["prev"] = 8947;
      ["prequests"] = {
         [1] = 8947;
      };
      ["level"] = 60;
      ["name_es"] = "Un viejo amigo de Anthion";
      ["req"] = 58;
   };
   [8401] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "自然屏障";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 49;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 40;
   };
   [5504] = {
      ["name_ru"] = "Оплечья Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Argent Dawn Valor Tokens to Quartermaster Hasana at the Bulwark, Western Plaguelands.";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_fr"] = "Les mantelets de l'Aube";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "黎明?肩";
      ["name_de"] = "Mantel der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Mantles of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Mantos del Alba";
      ["req"] = 55;
   };
   [5211] = {
      ["name_ru"] = "Защитники Дарроушира";
      ["type"] = "Solo";
      ["name_fr"] = "Les defenseurs de Comte-de-Darrow";
      ["name_de"] = "Verteidiger von Darroheim";
      ["name_cn"] = "?隆郡的保?者";
      ["objective"] = "Free 15 Darrowshire Spirits and return to Carlin Redpath.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Defenders of Darrowshire";
      ["prev"] = 5241;
      ["prequests"] = {
         [1] = 5241;
      };
      ["level"] = 55;
      ["name_es"] = "Los defensores de Villa Darrow";
      ["req"] = 50;
   };
   [5536] = {
      ["name_ru"] = "Земли, полные ненависти";
      ["type"] = "Solo";
      ["objective"] = "Kill 6 Haldarr Satyr, 2 Haldarr Tricksters, 2 Haldarr Felsworn and then return to Loh'atu on the border of Ashenvale.";
      ["sort"] = "Azshara";
      ["name_cn"] = "充?仇恨的土地";
      ["name_fr"] = "Un pays plein de haine";
      ["name_de"] = "Ein Land voller Hass";
      ["faction"] = "Horde";
      ["name"] = "A Land Filled with Hatred";
      ["level"] = 47;
      ["name_es"] = "Una tierra llena de odio";
      ["req"] = 45;
   };
   [9389] = {
      ["name_ru"] = "Мерцающие огни Восточных королевств";
      ["type"] = "Solo";
      ["objective"] = "Visit the bonfires within Hillsbrad Foothills, Silverpine Forest, Westfall, and the Wetlands, then speak with the Festival Flamekeeper.";
      ["sort"] = "Midsummer";
      ["name_cn"] = "?部王国的火?";
      ["reward"] = {
         [1] = 23435;
         [2] = 23327;
         [3] = 23326;
         [4] = 23211;
      };
      ["name_de"] = "Lodernde Flammen in den Ostlichen Konigreichen";
      ["faction"] = "Horde";
      ["name"] = "Flickering Flames in the Eastern Kingdoms";
      ["level"] = 25;
      ["name_es"] = "La oscilacion de las llamas de los Reinos del Este";
      ["req"] = 1;
   };
   [8389] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [889] = 50;
      };
      ["name_de"] = "Schlacht der Kriegshymnenschlucht";
      ["name_cn"] = "峡谷中的?斗";
      ["name_fr"] = "La bataille du goulet des Chanteguerres";
      ["name"] = "Battle of Warsong Gulch";
      ["faction"] = "Horde";
      ["sort"] = "Warsong Gulch";
      ["prev"] = 8368;
      ["prequests"] = {
         [1] = 8368;
      };
      ["level"] = 19;
      ["name_es"] = "La batalla por Garganta Grito de Guerra";
      ["req"] = 10;
   };
   [8418] = {
      ["name_ru"] = "Создание камня силы";
      ["objective"] = "Bring the voodoo feathers to Ashlam Valorfist.";
      ["name_cn"] = "?造力量之石";
      ["sort"] = "Paladin";
      ["level"] = 52;
      ["type"] = "Dungeon";
      ["name_fr"] = "Forger la pierre de pouvoir";
      ["repgain"] = {
         [529] = 150;
      };
      ["name_de"] = "Erschaffung des Steins der Macht";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Forging the Mightstone";
      ["prev"] = 8416;
      ["prequests"] = {
         [1] = 8416;
      };
      ["reward"] = {
         [1] = 20504;
         [2] = 20620;
         [3] = 20512;
         [4] = 20505;
      };
      ["name_es"] = "La forja de la piedra de poderio";
      ["req"] = 50;
   };
   [6389] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["name_de"] = "Eine Plage komme uber Euch";
      ["name"] = "A Plague Upon Thee";
      ["name_cn"] = "瘟疫与?";
      ["objective"] = "Release the Plagueland Termites in the Northridge Lumber Mill, then return with the Barrel of Plagueland Termites to Nathaniel Dumah at Chillwind Camp in Western Plaguelands.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5904;
      ["prequests"] = {
         [1] = 5904;
      };
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [6662] = {
      ["name_ru"] = "Братишка Нипси";
      ["type"] = "Solo";
      ["name_fr"] = "Mon frere, Nipsy";
      ["name_de"] = "Mein Bruder Nipsy...";
      ["reward"] = {
         [1] = 17119;
      };
      ["name_cn"] = "我的兄弟，尼普希";
      ["objective"] = "Take the Carton of Mystery Meat to Nipsy at the Stormwind Deeprun Tram Depot.";
      ["faction"] = "Alliance";
      ["name"] = "Me Brother, Nipsy";
      ["sort"] = "Deeprun Tram";
      ["prev"] = 6661;
      ["prequests"] = {
         [1] = 6661;
      };
      ["level"] = 12;
      ["name_es"] = "Mi hermano Niblis";
      ["req"] = 10;
   };
   [5632] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5648] = {
      ["name_ru"] = "Одеяния духовности";
      ["type"] = "Solo";
      ["name_fr"] = "Vetements de la spiritualite";
      ["name_de"] = "Gewander der Spiritualitat";
      ["sort"] = "Priest";
      ["objective"] = "Find Grunt Kor'ja and heal her wounds using Lesser Heal (Rank 2). Afterwards, grant her Power Word: Fortitude and then return to Tai'jin at Razor Hill.";
      ["name_cn"] = "?魂之衣";
      ["name"] = "Garments of Spirituality";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 16606;
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 5649;
      ["prequests"] = {
         [1] = 5649;
      };
      ["level"] = 4;
      ["name_es"] = "Prendas de espiritualidad";
      ["req"] = 5;
   };
   [5163] = {
      ["name_ru"] = "Йети где-то рядом...";
      ["objective"] = "Take Umi's Mechanical Yeti and scare her friends with it:$B$BLegacki in Everlook (Winterspring)$BSprinkle in Gadgetzan (Tanaris)$BQuixxil in Marshal's Refuge (Un'Goro Crater)$B$BWhen you are done, bring the Mechanical Yeti back to Umi.";
      ["name_cn"] = "雪怪??！";
      ["sort"] = "Winterspring";
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Yeti?? Y es-tu??";
      ["repgain"] = {
         [577] = 350;
      };
      ["name_de"] = "Sind wir endlich da, Yeti?";
      ["reward"] = {
         [1] = 15778;
      };
      ["faction"] = "Horde";
      ["name"] = "Are We There, Yeti?";
      ["prev"] = 977;
      ["prequests"] = {
         [1] = 977;
      };
      ["series"] = 3;
      ["name_es"] = "Yeti... ?ya hemos llegado?";
      ["req"] = 52;
   };
   [5680] = {
      ["name_ru"] = "Страж Тьмы";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Ogrimmar.";
      ["name_de"] = "Schattenwache";
      ["name_cn"] = "暗影守?";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Shadowguard";
      ["level"] = 20;
      ["name_es"] = "Guardia de las Sombras";
      ["req"] = 20;
   };
   [4142] = {
      ["name_ru"] = "Визит к Грегану";
      ["type"] = "Solo";
      ["name_fr"] = "Visite a Gregan";
      ["next"] = 4143;
      ["name_de"] = "Ein Besuch bei Gregan";
      ["name_cn"] = "造?格雷甘";
      ["objective"] = "Take a Bloodpetal to Gregan Brewspewer in Feralas.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Alliance";
      ["name"] = "A Visit to Gregan";
      ["prev"] = 4141;
      ["prequests"] = {
         [1] = 4141;
      };
      ["level"] = 52;
      ["name_es"] = "Visita a Gregan";
      ["req"] = 47;
   };
   [8994] = {
      ["name_ru"] = "Последние приготовления";
      ["type"] = "Raid";
      ["objective"] = "Gather 40 Blackrock Bracers and acquire a Flask of Supreme Power. Return them to Bodley inside Blackrock Mountain.";
      ["next"] = 8995;
      ["name_fr"] = "Derniers preparatifs";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "最后的准?";
      ["name"] = "Final Preparations";
      ["name_de"] = "Letzte Vorbereitungen";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8989;
         [2] = 8991;
         [3] = 8992;
         [4] = 8990;
      };
      ["level"] = 60;
      ["name_es"] = "Ultimos preparativos";
      ["req"] = 58;
   };
   [5728] = {
      ["name_ru"] = "Тайные враги";
      ["objective"] = "Kill Bazzalan and Jergosh the Invoker before returning to Thrall in Orgrimmar.";
      ["name_cn"] = "?藏的?人";
      ["sort"] = "Ragefire Chasm";
      ["level"] = 16;
      ["type"] = "Dungeon";
      ["name_fr"] = "Ennemis caches";
      ["next"] = 5729;
      ["name_de"] = "Verborgene Feinde";
      ["repgain"] = {
         [76] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "Hidden Enemies";
      ["prev"] = 5727;
      ["prequests"] = {
         [1] = 5727;
      };
      ["series"] = 3;
      ["name_es"] = "Enemigos ocultos";
      ["req"] = 9;
   };
   [8440] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 50;
      };
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["prev"] = 8436;
      ["prequests"] = {
         [1] = 8436;
      };
      ["level"] = 39;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 30;
   };
   [8442] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 50;
      };
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["prev"] = 8438;
      ["prequests"] = {
         [1] = 8438;
      };
      ["level"] = 59;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 50;
   };
   [9002] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Lightforge Helm and Lightforge Breastplate.";
      ["reward"] = {
         [1] = 22091;
         [2] = 22089;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [8528] = {
      ["name_ru"] = "Альянсу не хватает пятнистого желтохвоста!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Spotted Yellowtail to Huntress Swiftriver at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de jaune-queue tachete !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要斑点黄尾?！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_de"] = "Die Allianz braucht Tupfelgelbschwanze!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Spotted Yellowtail!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita serviolas moteadas!";
      ["req"] = 42;
   };
   [8484] = {
      ["name_ru"] = "Знак мира";
      ["type"] = "Solo";
      ["objective"] = "Bring the Timbermaw Offering of Peace to King Magni Bronzebeard in Ironforge.";
      ["repgain"] = {
         [469] = 500;
      };
      ["name_fr"] = "Negocier la paix";
      ["sort"] = "Timbermaw Hold";
      ["name_cn"] = "重?和平";
      ["name_de"] = "Das Bemuhen um Frieden";
      ["faction"] = "Alliance";
      ["name"] = "The Brokering of Peace";
      ["level"] = 60;
      ["name_es"] = "Negociar la paz";
      ["req"] = 45;
   };
   [1154] = {
      ["name_ru"] = "Испытание знаний";
      ["objective"] = "Find the Legacy of the Aspects and return it to Braug Dimspirit near the entrance to Talondeep Path in Stonetalon Mountains.";
      ["name_cn"] = "知???";
      ["sort"] = "Thousand Needles";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 6627;
      ["name_de"] = "Test der Lehre";
      ["repgain"] = {
         [81] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Test of Lore";
      ["prev"] = 1152;
      ["prequests"] = {
         [1] = 1152;
      };
      ["series"] = 2;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [4490] = {
      ["name_ru"] = "Призывание коня Скверны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in Ratchet to learn the ability to summon a Felsteed.";
      ["name_cn"] = "召?地???";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Teufelsross beschworen";
      ["faction"] = "Horde";
      ["name"] = "Summon Felsteed";
      ["level"] = 40;
      ["name_es"] = "Invoca un corcel vil";
      ["req"] = 40;
   };
   [6846] = {
      ["name_ru"] = "В атаку!";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Que l'attaque commence !";
      ["name_cn"] = "展?攻?！";
      ["name_de"] = "Der Angriff soll beginnen!";
      ["faction"] = "Alliance";
      ["name"] = "Begin the Attack!";
      ["level"] = 60;
      ["name_es"] = "!Al ataque!";
      ["req"] = 1;
   };
   [8289] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [890] = 75;
      };
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["name_de"] = "Verdienstabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Talismans of Merit";
      ["level"] = 15;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 10;
   };
   [5888] = {
      ["name_ru"] = "Лекарство из минералов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Bergbau";
      ["name_fr"] = "Du baume par la pioche";
      ["name_cn"] = "采???膏";
      ["name"] = "Salve via Mining";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 5883;
      ["prequests"] = {
         [1] = 5883;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por mineria";
      ["req"] = 48;
   };
   [5904] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["next"] = 6389;
      ["name_de"] = "Eine Plage komme uber Euch";
      ["name"] = "A Plague Upon Thee";
      ["name_cn"] = "瘟疫与?";
      ["objective"] = "Find someplace suitable in the center of the Northridge Lumber Mill in Western Plaguelands to place the Barrel of Plagueland Termites.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5903;
      ["prequests"] = {
         [1] = 5903;
      };
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [8498] = {
      ["name_ru"] = "Боевые приказы Сумеречного Молота";
      ["type"] = "Group";
      ["objective"] = "Obtain the Twilight Battle Orders and bring them Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Tactical Task Briefing X in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Les ordres de bataille du Crepuscule";
      ["name_cn"] = "暮光作?命令";
      ["reward"] = {
         [1] = 20801;
         [2] = 20809;
      };
      ["name_de"] = "Zwielichtschlachtbefehle";
      ["faction"] = "Horde";
      ["name"] = "Twilight Battle Orders";
      ["level"] = 60;
      ["name_es"] = "Ordenes de batalla Crepusculares";
      ["req"] = 60;
   };
   [6122] = {
      ["name_ru"] = "Основной источник";
      ["objective"] = "Use the Empty Cliffspring Falls Sampler to draw a sample of water from the mouth of the cave by the falls.$B$BDeliver the Filled Cliffspring Falls Sampler to Alanndarian Nightsong in Auberdine, Darkshore.";
      ["name_cn"] = "毒水之源";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Le principe originel";
      ["next"] = 6123;
      ["name_de"] = "Die eigentliche Ursache";
      ["classes"] = {
         [1] = "Druid";
      };
      ["repgain"] = {
         [609] = 150;
      };
      ["name"] = "The Principal Source";
      ["prev"] = 6121;
      ["prequests"] = {
         [1] = 6121;
      };
      ["sort"] = "Druid";
      ["name_es"] = "La fuente del envenenamiento";
      ["req"] = 14;
   };
   [4289] = {
      ["name_ru"] = "Обезьяны Ун'Горо";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Un'Goro Gorilla Pelts, 2 Un'Goro Stomper Pelts, and 2 Un'Goro Thunderer Pelts to Torwa Pathfinder at the entrance of Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "安戈洛的猩猩";
      ["name_fr"] = "Les gorilles d'Un'Goro";
      ["name_de"] = "Die Affen von Un'Goro";
      ["faction"] = "Horde";
      ["name"] = "The Apes of Un'Goro";
      ["level"] = 55;
      ["name_es"] = "Los simios de Un'Goro";
      ["req"] = 47;
   };
   [8506] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает лилового лотоса!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de lotus pourpre !";
      ["name_de"] = "Die Allianz braucht mehr lila Lotus!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_cn"] = "?盟需要更多紫?花！";
      ["objective"] = "Bring 20 purple lotus to Master Nightsong at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Purple Lotus!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8505;
      ["prequests"] = {
         [1] = 8505;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas lotos cardenos!";
      ["req"] = 1;
   };
   [3129] = {
      ["name_ru"] = "Оружие духа";
      ["type"] = "Solo";
      ["name_fr"] = "Armes de l'Esprit";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Waffen des Geistes";
      ["name_cn"] = "?魂武器";
      ["reward"] = {
         [1] = 9684;
         [2] = 9686;
         [3] = 9683;
         [4] = 10652;
      };
      ["objective"] = "Witch Doctor Uzer'i wants you to wait for a moment while he prepares the weapons.";
      ["name"] = "Weapons of Spirit";
      ["sort"] = "Feralas";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 3127;
         [2] = 3128;
      };
      ["level"] = 50;
      ["name_es"] = "Armas del espiritu";
      ["req"] = 40;
   };
   [9029] = {
      ["name_ru"] = "Бурлящий котел";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "薰炉";
      ["reward"] = {
         [1] = 22281;
         [2] = 22282;
         [3] = 22277;
         [4] = 22278;
         [5] = 22280;
         [6] = 22276;
      };
      ["name_de"] = "Ein blubbernder Kessel";
      ["faction"] = "Horde";
      ["name"] = "A Bubbling Cauldron";
      ["level"] = 60;
      ["name_es"] = "Una caldera burbujeante";
      ["req"] = 1;
   };
   [7003] = {
      ["name_ru"] = "Уменьшение великанов";
      ["type"] = "Solo";
      ["objective"] = "Use Zorbin's Ultra-Shrinker to zap any kind of giant found in Feralas into a more manageable form.  Bring 15 Miniaturization Residues found on the zapped versions of these giants to Zorbin Fandazzle at the docks of the Forgotten Coast, Feralas.";
      ["repgain"] = {
         [21] = 350;
         [369] = 350;
         [577] = 350;
         [470] = 350;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "Geants retrecis";
      ["name_cn"] = "被?小的巨人";
      ["reward"] = {
         [1] = 19040;
      };
      ["name_de"] = "Geschrumpfte Riesen";
      ["faction"] = "Horde";
      ["name"] = "Zapped Giants";
      ["level"] = 48;
      ["name_es"] = "Gigantes reducidos";
      ["req"] = 45;
   };
   [6032] = {
      ["name_ru"] = "Священная ткань";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Mooncloth to Meilosh in Timbermaw Hold.";
      ["repgain"] = {
         [576] = 100;
      };
      ["name_fr"] = "Le vetement sacre";
      ["sort"] = "Timbermaw Hold";
      ["name_cn"] = "神?的月布";
      ["name_de"] = "Hochheiliger Stoff";
      ["faction"] = "Horde";
      ["name"] = "Sacred Cloth";
      ["level"] = 55;
      ["name_es"] = "Tela sagrada";
      ["req"] = 50;
   };
   [5403] = {
      ["name_ru"] = "Камни захватчиков Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Pierres du Fleau des envahisseurs";
      ["name_cn"] = "侵略者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Eindringlings";
      ["faction"] = "Alliance";
      ["name"] = "Invader's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del invasor";
      ["req"] = 50;
   };
   [6064] = {
      ["name_ru"] = "Приручение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6084;
      ["name_de"] = "Die Zahmung der Bestie";
      ["name_cn"] = "?服野?";
      ["objective"] = "Use the Taming Rod to tame a Large Crag Boar. Practice your skills, then return the Taming Rod to Grif Wildheart in Kharanos.";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["series"] = 1;
      ["races"] = {
         [1] = "Dwarf";
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [1302] = {
      ["name_ru"] = "Джеймс Хьяль";
      ["type"] = "Solo";
      ["name_fr"] = "James Hyal";
      ["name_de"] = "James Hyal";
      ["name"] = "James Hyal";
      ["name_cn"] = "詹姆斯・海厄?";
      ["objective"] = "Speak with Clerk Lendry at Foothold Citadel in Theramore.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Wetlands";
      ["prev"] = 1301;
      ["prequests"] = {
         [1] = 1301;
      };
      ["level"] = 35;
      ["name_es"] = "James Hyal";
      ["req"] = 30;
   };
   [8522] = {
      ["name_ru"] = "Альянсу не хватает бинтов из рунической ткани!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Runecloth Bandages to Keeper Moonshade at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de bandages en etoffe runique?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要符文布??！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_de"] = "Die Allianz braucht Runenstoffverbande!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Runecloth Bandages!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita vendas de pano runico!";
      ["req"] = 56;
   };
   [5058] = {
      ["name_ru"] = "Дневник миссис Далсон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "??松夫人的日?";
      ["name_fr"] = "Journal de Mme Dalson";
      ["name_de"] = "Frau Dalsons Tagebuch";
      ["faction"] = "Horde";
      ["name"] = "Mrs. Dalson's Diary";
      ["level"] = 55;
      ["name_es"] = "El diario de la senorita Dalson";
      ["req"] = 52;
   };
   [6128] = {
      ["name_ru"] = "Сбор лекарственных ингредиентов";
      ["objective"] = "Bring 5 Earthroot and 5 Kodo Horns to Tonga Runetotem at the Crossroads so he may make a curative salve.";
      ["name_cn"] = "收集解?";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Rassembler les ingredients du remede";
      ["next"] = 6129;
      ["name_de"] = "Das Heilmittel sammeln";
      ["classes"] = {
         [1] = "Druid";
      };
      ["repgain"] = {
         [609] = 75;
      };
      ["name"] = "Gathering the Cure";
      ["prev"] = 6127;
      ["prequests"] = {
         [1] = 6127;
      };
      ["sort"] = "Druid";
      ["name_es"] = "Reunir los ingredientes del remedio";
      ["req"] = 14;
   };
   [6144] = {
      ["name_ru"] = "Приказ по армии";
      ["type"] = "Solo";
      ["objective"] = "Travel to the Undercity and speak with Varimathras.";
      ["next"] = 6145;
      ["name_fr"] = "L'appel du commandement";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "上?的命令";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Der Befehl";
      ["faction"] = "Horde";
      ["name"] = "The Call to Command";
      ["level"] = 60;
      ["name_es"] = "La llamada del teniente";
      ["req"] = 56;
   };
   [8223] = {
      ["name_ru"] = "Обмен: светящаяся кровь скорпида";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Encore du sang de scorpide luminescent";
      ["name_cn"] = "更多?光的蠍血";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mehr leuchtendes Skorpidblut";
      ["faction"] = "Horde";
      ["name"] = "More Glowing Scorpid Blood";
      ["level"] = 60;
      ["name_es"] = "Mas sangre de escorpido resplandeciente";
      ["req"] = 40;
   };
   [8255] = {
      ["name_ru"] = "Охота на беговых оленей";
      ["type"] = "Solo";
      ["name_fr"] = "Courser les coursiers";
      ["next"] = 8256;
      ["name_de"] = "Renner fur einen hoheren Zweck";
      ["objective"] = "Acquire 4 Healthy Courser Glands and bring them to Ogtinc in Azshara.  Ogtinc resides atop the cliffs northeast the Ruins of Eldarath.";
      ["name_cn"] = "苔蹄快?者";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "Of Coursers We Know";
      ["prev"] = 8254;
      ["prequests"] = {
         [1] = 8254;
      };
      ["level"] = 52;
      ["name_es"] = "Los trotadores Pezunamusgo";
      ["req"] = 50;
   };
   [8287] = {
      ["name_ru"] = "Ужасная цель";
      ["type"] = "Solo";
      ["name_fr"] = "Un terrible but";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Ein teuflischer Plan";
      ["name_cn"] = "?脱困境";
      ["name"] = "A Terrible Purpose";
      ["objective"] = "Take the Decoded Tablet Parchment to Commander Mar'alith.";
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8279;
      ["prequests"] = {
         [1] = 8279;
      };
      ["level"] = 60;
      ["name_es"] = "Un proposito terrible";
      ["req"] = 54;
   };
   [8319] = {
      ["name_ru"] = "Зашифрованные Сумеречные тексты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Verschlusselte Schattenhammertexte";
      ["name_cn"] = "暮光密文信";
      ["name_fr"] = "Les textes du crepuscule cryptes";
      ["name"] = "Encrypted Twilight Texts";
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8318;
      ["prequests"] = {
         [1] = 8318;
      };
      ["level"] = 60;
      ["name_es"] = "Textos Crepusculares codificados";
      ["req"] = 57;
   };
   [8351] = {
      ["name_ru"] = "Разговор с Бором";
      ["type"] = "Raid";
      ["name_fr"] = "Bor souhaite vous parler";
      ["next"] = 8352;
      ["name_de"] = "Bor mochte Euch sprechen";
      ["name_cn"] = "与????";
      ["objective"] = "Speak with Bor Wildmane in Cenarion Hold.";
      ["sort"] = "Silithus";
      ["faction"] = "Horde";
      ["name"] = "Bor Wishes to Speak";
      ["prev"] = 8341;
      ["prequests"] = {
         [1] = 8341;
      };
      ["level"] = 60;
      ["name_es"] = "Bor quiere hablar contigo";
      ["req"] = 60;
   };
   [8383] = {
      ["name_ru"] = "Помни Альтеракскую долину!";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [730] = 100;
      };
      ["name_de"] = "Vergesst das Alteractal nicht!";
      ["name_cn"] = "??奥特?克！";
      ["name_fr"] = "Souvenez-vous de la vallee d'Alterac?!";
      ["name"] = "Remember Alterac Valley!";
      ["faction"] = "Alliance";
      ["sort"] = "Alterac Valley";
      ["prev"] = 8375;
      ["prequests"] = {
         [1] = 8375;
      };
      ["level"] = 60;
      ["name_es"] = "!Recuerda el Valle de Alterac!";
      ["req"] = 51;
   };
   [8415] = {
      ["name_ru"] = "Лагерь Промозглого Ветра";
      ["type"] = "Solo";
      ["objective"] = "Speak to Commander Ashlam Valorfist at Chillwind Camp.";
      ["next"] = 8414;
      ["name_de"] = "Zugwindlager";
      ["sort"] = "Paladin";
      ["name_cn"] = "冰??";
      ["name_fr"] = "La pointe du Noroit";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Chillwind Point";
      ["level"] = 52;
      ["name_es"] = "Campamento del Orvallo";
      ["req"] = 50;
   };
   [8447] = {
      ["name_ru"] = "Пробуждение легенд";
      ["type"] = "Solo";
      ["name_fr"] = "L'eveil des legendes";
      ["name_de"] = "Legenden erwachen";
      ["reward"] = {
         [1] = 20600;
      };
      ["name_cn"] = "?醒??";
      ["objective"] = "Wait for Keeper Remulos at the Moonglade to cleanse the Nightmare Engulfed Object.";
      ["faction"] = "Horde";
      ["name"] = "Waking Legends";
      ["sort"] = "Epic";
      ["prev"] = 8446;
      ["prequests"] = {
         [1] = 8446;
      };
      ["level"] = 60;
      ["name_es"] = "Leyendas veraces";
      ["req"] = 60;
   };
   [9011] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Coif of Elements and Vest of Elements.";
      ["reward"] = {
         [1] = 22097;
         [2] = 22102;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [8511] = {
      ["name_ru"] = "Альянсу не хватает легкой кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Light Leather to Bonnie Stoneflayer at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de cuir leger?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要?皮！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_de"] = "Die Allianz braucht leichtes Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Light Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita cuero semipesado!";
      ["req"] = 50;
   };
   [8543] = {
      ["name_ru"] = "Орде все еще нужны оловянные слитки!";
      ["type"] = "Solo";
      ["name_fr"] = "La Horde a besoin de plus de barres d'etain !";
      ["name_de"] = "Die Horde braucht mehr Zinnbarren!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["name_cn"] = "部落需要更多??！";
      ["objective"] = "Bring 20 tin bars to Grunt Maug in Durotar.";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs More Tin Bars!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8542;
      ["prequests"] = {
         [1] = 8542;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas lingotes de estano!";
      ["req"] = 1;
   };
   [8575] = {
      ["name_ru"] = "Магическая книга Азурегоса";
      ["type"] = "Solo";
      ["objective"] = "Deliver Azuregos's Magical Ledger to Narain Soothfancy in Tanaris.";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_fr"] = "Le grand livre magique d'Azuregos";
      ["sort"] = "Azshara";
      ["name_cn"] = "艾索雷葛斯的魔法?本";
      ["name_de"] = "Azuregos' magisches Buch";
      ["faction"] = "Horde";
      ["name"] = "Azuregos's Magical Ledger";
      ["level"] = 60;
      ["name_es"] = "El libro de contabilidad magico de Azuregos";
      ["req"] = 60;
   };
   [8607] = {
      ["name_ru"] = "Орде не хватает бинтов из магической ткани!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Mageweave Bandages to Lady Callow at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de bandages en tisse-mage?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要魔?布??！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["name_de"] = "Die Horde braucht Magiestoffverbande!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Mageweave Bandages!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita vendas de tejido magico!";
      ["req"] = 57;
   };
   [8639] = {
      ["name_ru"] = "Шлем торговца смертью";
      ["objective"] = "Bring Vek'lor's Diadem, 2 Idols of the War, 5 Gold Scarabs and 5 Clay Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "死亡?行者的??";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le casque du dispensateur de mort";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Helm des Todesboten";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21360;
      };
      ["name"] = "Deathdealer's Helm";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El yelmo de mortifero";
      ["req"] = 60;
   };
   [8671] = {
      ["name_ru"] = "Предок Тотем Ярости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Totem-de-rage";
      ["name_cn"] = "暴怒???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Rachtotem";
      ["faction"] = "Horde";
      ["name"] = "Ragetotem the Elder";
      ["level"] = 60;
      ["name_es"] = "Totem de Ira el Ancestro";
      ["req"] = 1;
   };
   [8703] = {
      ["name_ru"] = "Кольцо Вечной справедливости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Magisterial Ring, 2 Vermillion Idols, 5 Silver Scarabs and 5 Bone Scarabs to Windcaller Yessendra  in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "L'anneau de justice eternelle";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "永恒公正之戒";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21396;
      };
      ["name_de"] = "Ring der ewigen Gerechtigkeit";
      ["faction"] = "Alliance";
      ["name"] = "Ring of Eternal Justice";
      ["level"] = 60;
      ["name_es"] = "El anillo de justicia eterna";
      ["req"] = 60;
   };
   [8735] = {
      ["name_ru"] = "Проклятие Кошмара";
      ["type"] = "Raid";
      ["name_fr"] = "La corruption du Cauchemar";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Die Verderbnis des Alptraums";
      ["name_cn"] = "腐?梦?";
      ["name"] = "The Nightmare's Corruption";
      ["objective"] = "Travel to the four Emerald Dream portals in Azeroth and collect a Fragment of the Nightmare's Corruption from each. Return to Keeper Remulos in the Moonglade when you have completed this task.$B";
      ["faction"] = "Horde";
      ["sort"] = "Moonglade";
      ["prev"] = 8734;
      ["prequests"] = {
         [1] = 8734;
      };
      ["level"] = 60;
      ["name_es"] = "La corrupcion de Pesadilla";
      ["req"] = 60;
   };
   [8767] = {
      ["name_ru"] = "Слегка помятый подарок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "???晃?的礼品";
      ["classes"] = {
         [1] = "Warrior";
         [2] = "Rogue";
         [3] = "Paladin";
         [4] = "Hunter";
         [5] = "Shaman";
      };
      ["reward"] = {
         [1] = 21270;
      };
      ["name_de"] = "Ein leicht geschutteltes Geschenk";
      ["faction"] = "Horde";
      ["name"] = "A Gently Shaken Gift";
      ["level"] = 1;
      ["name_es"] = "Un obsequio ligeramente agitado";
      ["req"] = 1;
   };
   [8799] = {
      ["name_ru"] = "Герой дня";
      ["type"] = "Solo";
      ["name_fr"] = "Le heros du jour";
      ["name_de"] = "Der Held des Tages";
      ["reward"] = {
         [1] = 21213;
      };
      ["name_cn"] = "大英雄！";
      ["objective"] = "Bring 1 Deeprock Salt and 5 gold coins to the Holly Preserver machine, upon which you will receive 5 Preserved Holly.";
      ["faction"] = "Horde";
      ["name"] = "The Hero of the Day";
      ["sort"] = "Hallow's End";
      ["prev"] = 8746;
      ["prequests"] = {
         [1] = 8746;
      };
      ["level"] = 60;
      ["name_es"] = "El heroe del dia";
      ["req"] = 40;
   };
   [8831] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8819;
      ["prequests"] = {
         [1] = 8819;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8863] = {
      ["name_ru"] = "Праздничные клецки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Des raviolis de fete";
      ["name_cn"] = "美味佳肴";
      ["reward"] = {
         [1] = 21537;
      };
      ["name_de"] = "Festtagsklose";
      ["faction"] = "Horde";
      ["name"] = "Festival Dumplings";
      ["level"] = 50;
      ["name_es"] = "Albondigas festivas";
      ["req"] = 1;
   };
   [4742] = {
      ["name_ru"] = "Печать Вознесения";
      ["type"] = "Dungeon";
      ["objective"] = "Find the three gemstones of command: The Gemstone of Smolderthorn, Gemstone of Spirestone, and Gemstone of Bloodaxe. Return them, along with the Unadorned Seal of Ascension, to Vaelan.$B$BThe Generals, as told to you by Vaelan, are: War Master Voone of the Smolderthorn; Highlord Omokk of the Spirestone; and Overlord Wyrmthalak  of the Bloodaxe.";
      ["next"] = 4743;
      ["name_fr"] = "Le sceau de l'ascension";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "晋升印章";
      ["series"] = 1;
      ["name_de"] = "Siegel des Aufstiegs";
      ["faction"] = "Horde";
      ["name"] = "Seal of Ascension";
      ["level"] = 60;
      ["name_es"] = "El sello de ascension";
      ["req"] = 57;
   };
   [8927] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Wildheart Belt and a set of Wildheart Gloves to Mokvar in Orgrimmar.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Orgrimmar";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8930;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8930;
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Horde";
      ["name"] = "Just Compensation";
      ["prev"] = 8978;
      ["prequests"] = {
         [1] = 8978;
      };
      ["reward"] = {
         [1] = 22106;
         [2] = 22110;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8959] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Boots of Valor, Legplates of Valor and Spaulders of Valor.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 21995;
         [2] = 22000;
         [3] = 22001;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [8991] = {
      ["name_ru"] = "Правая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau droit de l'amulette du seigneur Valthal";
      ["next"] = 8994;
      ["name_de"] = "Das rechte Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth Jarien and Sothos and slay them. Return to Bodley inside Blackrock Mountain with the recombined Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦塔拉克?品的右瓣";
      ["sort"] = "Stratholme";
      ["faction"] = "Horde";
      ["name"] = "The Right Piece of Lord Valthalak's Amulet";
      ["followup"] = 8994;
      ["prev"] = 8987;
      ["prequests"] = {
         [1] = 8987;
      };
      ["level"] = 60;
      ["name_es"] = "La parte derecha del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [9023] = {
      ["name_ru"] = "Идеальный яд";
      ["type"] = "Raid";
      ["objective"] = "Dirk Thunderwood at Cenarion Hold wants you to bring him Venoxis's Venom Sac and Kurinnaxx's Venom Sac.";
      ["repgain"] = {
         [609] = 250;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Le poison parfait";
      ["name_cn"] = "完美的毒?";
      ["reward"] = {
         [1] = 22378;
         [2] = 22379;
         [3] = 22377;
         [4] = 22348;
         [5] = 22347;
         [6] = 22380;
      };
      ["name_de"] = "Das perfekte Gift";
      ["faction"] = "Horde";
      ["name"] = "The Perfect Poison";
      ["level"] = 60;
      ["name_es"] = "El veneno perfecto";
      ["req"] = 60;
   };
   [9055] = {
      ["name_ru"] = "Набедренники расхитителя гробниц";
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-jambes de traqueur des cryptes";
      ["name_de"] = "Beinschutzer des Gruftpirschers";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make Cryptstalker Legguards if you bring him the following: 1 Desecrated Legguards, 20 Wartorn Chain Scraps, 3 Arcanite Bars and 5 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22437;
      };
      ["name_cn"] = "地穴追?者腿甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Cryptstalker Legguards";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las musleras de acechacriptas";
      ["req"] = 60;
   };
   [9087] = {
      ["name_ru"] = "Набедренники сновидца";
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-jambes de marchereve";
      ["name_de"] = "Beinschutzer des Traumwandlers";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make Dreamwalker Legguards if you bring her the following: 1 Desecrated Legguards, 20 Wartorn Leather Scraps, 8 Cured Rugged Hides and 1 Nexus Crystal.";
      ["reward"] = {
         [1] = 22489;
      };
      ["name_cn"] = "梦游者腿甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Dreamwalker Legguards";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las musleras Caminasuenos";
      ["req"] = 60;
   };
   [6608] = {
      ["name_ru"] = "Больше учить нечему";
      ["type"] = "Solo";
      ["objective"] = "You think Lumak is trying to tell you that he can no longer help you improve your fishing skill. You may want to try to find his friend, Nat Pagle, a human fishing off one of the islands south of Theramore (at least that's what you think Lumak said).";
      ["sort"] = "Fishing";
      ["name_cn"] = "?真棒！";
      ["name_fr"] = "Vous etes trop bon";
      ["name_de"] = "Ihr zu gut";
      ["faction"] = "Horde";
      ["name"] = "You Too Good!";
      ["level"] = 45;
      ["name_es"] = "!Que bueno eres!";
      ["req"] = 35;
   };
   [6624] = {
      ["name_ru"] = "Очередь на медобслуживание";
      ["type"] = "Solo";
      ["objective"] = "Save patients by using Triage Bandages to tend to their wounds. You must save 15 patients before 6 of them die from their injuries.$B$BRemember the order of triage! Critically Injured Soldiers die the fastest followed by Badly Injured Soldiers. Injured Soldiers take the longest to die and should be saved AFTER your Critically Injured and Badly Injured Soldiers have been triaged.";
      ["sort"] = "First Aid";
      ["name_cn"] = "救死扶?";
      ["name_fr"] = "Triage";
      ["name_de"] = "Triage";
      ["faction"] = "Alliance";
      ["name"] = "Triage";
      ["level"] = 45;
      ["name_es"] = "Orden de gravedad";
      ["req"] = 35;
   };
   [9183] = {
      ["name_ru"] = "Задание мастера: светозарный венец";
      ["type"] = "Solo";
      ["objective"] = "Deliver 3 Radiant Circlets and the Craftsman's Writ - Radiant Circlet - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Diademes radieux";
      ["name_cn"] = "工匠文? - ?光??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Strahlender Reif";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Radiant Circlet";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: aro radiante";
      ["req"] = 55;
   };
   [3903] = {
      ["name_ru"] = "Милли Осворт";
      ["type"] = "Solo";
      ["name_fr"] = "Milly Osworth";
      ["repgain"] = {
         [72] = 10;
      };
      ["name_de"] = "Milly Geltmark";
      ["name"] = "Milly Osworth";
      ["name_cn"] = "米莉・奥斯沃斯";
      ["objective"] = "Speak with Milly Osworth.";
      ["next"] = 3904;
      ["faction"] = "Alliance";
      ["sort"] = "Northshire Valley";
      ["prev"] = 33;
      ["prequests"] = {
         [1] = 33;
      };
      ["level"] = 4;
      ["name_es"] = "Milly Osworth";
      ["req"] = 2;
   };
   [9247] = {
      ["name_ru"] = "Зов Хранителя";
      ["type"] = "Solo";
      ["objective"] = "Take the Letter from the Keeper of the Rolls to him at Light's Hope Chapel in the Eastern Plaguelands.";
      ["name_fr"] = "L'appel du Gardien";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?光的召?";
      ["reward"] = {
         [1] = 23123;
         [2] = 23122;
      };
      ["name_de"] = "Der Ruf des Bewahrers";
      ["faction"] = "Horde";
      ["name"] = "The Keeper's Call";
      ["level"] = 60;
      ["name_es"] = "La llamada de los guardianes";
      ["req"] = 60;
   };
   [1111] = {
      ["name_ru"] = "Управляющий пристанью Головокружилкинс";
      ["type"] = "Solo";
      ["objective"] = "Bring Kravel's Parts Order to Wharfmaster Dizzywig in Ratchet.";
      ["next"] = 1112;
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "??管理?迪??格";
      ["name_fr"] = "Maitre des quais Tournoupette";
      ["name_de"] = "Werftmeister Flunkerblick";
      ["faction"] = "Horde";
      ["name"] = "Wharfmaster Dizzywig";
      ["level"] = 36;
      ["name_es"] = "Maestro de muelles Vertipeluca";
      ["req"] = 30;
   };
   [8554] = {
      ["name_ru"] = "Бой с Неголашем";
      ["type"] = "Group";
      ["objective"] = "Bring 10 Barbecued Buzzard Wings and 5 bottles of Junglevine Wine to Captain Smotts' Lifeboat.$B$BKill Negolash, and bring Smotts' Cutlass to Captain Smotts in Stranglethorn.";
      ["repgain"] = {
         [21] = 500;
      };
      ["name_de"] = "Negolash entgegentreten";
      ["reward"] = {
         [1] = 4130;
      };
      ["name_cn"] = "挑?奈古拉什";
      ["name_fr"] = "Face a Negolash";
      ["faction"] = "Horde";
      ["name"] = "Facing Negolash";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 8553;
      ["prequests"] = {
         [1] = 8553;
      };
      ["level"] = 50;
      ["name_es"] = "Enfrentate a Negolash";
      ["req"] = 40;
   };
   [9343] = {
      ["name_ru"] = "Гербовая накидка Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?色黎明?袍";
      ["reward"] = {
         [1] = 22999;
      };
      ["name_de"] = "Wappenrock der Argentumdammerung";
      ["faction"] = "Horde";
      ["name"] = "Tabard of the Argent Dawn";
      ["level"] = 0;
      ["name_es"] = "Tabardo de El Alba Argenta";
      ["req"] = 50;
   };
   [8555] = {
      ["name_ru"] = "Создание драконов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "Der Bund der Drachenschwarme";
      ["name_cn"] = "守?之?";
      ["name_fr"] = "Le fardeau des Vols draconiques";
      ["name"] = "The Charge of the Dragonflights";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8519;
      ["prequests"] = {
         [1] = 8519;
      };
      ["level"] = 60;
      ["name_es"] = "Encomienda a los Vuelos";
      ["req"] = 60;
   };
   [1792] = {
      ["name_ru"] = "Оружие вихря";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Wirbelwaffe";
      ["name_fr"] = "Arme Tourbillon";
      ["name"] = "Whirlwind Weapon";
      ["name_cn"] = "旋?武器";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6975;
         [2] = 6977;
         [3] = 6976;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1713;
      ["prequests"] = {
         [1] = 1713;
      };
      ["level"] = 40;
      ["name_es"] = "Arma torbellino";
      ["req"] = 30;
   };
   [3126] = {
      ["name_ru"] = "Уменьшенный древень";
      ["type"] = "Solo";
      ["name_fr"] = "Treant miniaturise";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Muisek von Treants";
      ["name"] = "Treant Muisek";
      ["name_cn"] = "?人?魂精?";
      ["objective"] = "Kill 3 Wandering Forest Walkers. Use the Muisek Vessel to shrink and capture the fallen Treants.";
      ["next"] = 3127;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 3125;
      ["prequests"] = {
         [1] = 3125;
      };
      ["level"] = 50;
      ["name_es"] = "Muisek de antarbol";
      ["req"] = 40;
   };
   [7282] = {
      ["name_ru"] = "Братская любовь";
      ["type"] = "PvP";
      ["objective"] = "Travel into Frostwolf territory and slay Commander Louis Philips. Return to Commander Karl Philips when the task is complete.$B";
      ["repgain"] = {
         [730] = 250;
         [469] = 250;
      };
      ["name_fr"] = "Amour fraternel";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "兄弟情深";
      ["name_de"] = "Bruderliebe";
      ["faction"] = "Horde";
      ["name"] = "Brotherly Love";
      ["level"] = 60;
      ["name_es"] = "Amor fraternal";
      ["req"] = 51;
   };
   [8574] = {
      ["name_ru"] = "Стойкая броня";
      ["type"] = "Solo";
      ["name_fr"] = "Equipement de guerre de fidele";
      ["name_de"] = "Schlachtrustung des Gefolgsmanns";
      ["reward"] = {
         [1] = 21184;
         [2] = 21185;
         [3] = 21186;
         [4] = 21189;
      };
      ["name_cn"] = "忠?者的装?";
      ["objective"] = "Bring 15 Cenarion Combat Badges, 20 Cenarion Logistics Badges, 17 Cenarion Tactical Badges and 1 Mark of Remulos to Vargus at Cenarion Hold in Silithus.  You must also attain Revered reputation with Cenarion Circle to be able to complete this quest.";
      ["faction"] = "Horde";
      ["name"] = "Stalwart's Battlegear";
      ["sort"] = "Silithus";
      ["prev"] = 8800;
      ["prequests"] = {
         [1] = 8800;
      };
      ["level"] = 60;
      ["name_es"] = "Equipamiento de adepto";
      ["req"] = 60;
   };
   [1082] = {
      ["name_ru"] = "Новости для часового Тенисил";
      ["type"] = "Solo";
      ["name_fr"] = "Une mise a jour pour la Sentinelle Thenysil";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Neuigkeiten fur Schildwache Thenysil";
      ["name_cn"] = "向塞恩希??告";
      ["objective"] = "Return to Sentinel Thenysil in Ashenvale.";
      ["next"] = 1081;
      ["sort"] = "Stonetalon Mountains";
      ["name"] = "Update for Sentinel Thenysil";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 1083;
         [2] = 1084;
      };
      ["level"] = 22;
      ["name_es"] = "Noticias para Centinela Thenysil";
      ["req"] = 17;
   };
   [8167] = {
      ["name_ru"] = "Битва за Низину Арати";
      ["type"] = "PvP";
      ["objective"] = "Assault the mine, the lumber mill, the blacksmith and the farm, then return to Field Marshal Oslight in Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地之?！";
      ["name_fr"] = "La bataille pour le bassin d'Arathi?!";
      ["name_de"] = "Die Schlacht um das Arathibecken!";
      ["faction"] = "Alliance";
      ["name"] = "The Battle for Arathi Basin!";
      ["level"] = 35;
      ["name_es"] = "La batalla por la Cuenca de Arathi";
      ["req"] = 30;
   };
   [6848] = {
      ["name_ru"] = "Всевидящее око мастера Рисона";
      ["type"] = "PvP";
      ["objective"] = "Recover Master Ryson's All Seeing Eye from the Winterax caves and return it to Master Ryson.$B$BBe warned, it is said that Master Ryson's All Seeing Eye carries with it a terrible curse!";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "雷?松的全?之眼";
      ["name_fr"] = "L'?il qui voit tout de maitre Ryson";
      ["name_de"] = "Meister Rysons Allsehendes Auge";
      ["faction"] = "Alliance";
      ["name"] = "Master Ryson's All Seeing Eye";
      ["level"] = 60;
      ["name_es"] = "El ojo que todo lo ve del maestro Ryson";
      ["req"] = 51;
   };
   [8580] = {
      ["name_ru"] = "Орде не хватает огнецвета!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Firebloom to Batrider Pele'keiki at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de fleur de feu !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要火?花！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21511;
      };
      ["name_de"] = "Die Horde braucht Feuerbluten!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Firebloom!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita flores de fuego!";
      ["req"] = 57;
   };
   [8582] = {
      ["name_ru"] = "Орде не хватает лилового лотоса!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Purple Lotus to Apothecary Jezel at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de lotus pourpre !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要紫?花！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["name_de"] = "Die Horde braucht lila Lotus!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Purple Lotus!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita lotos cardenos!";
      ["req"] = 50;
   };
   [1954] = {
      ["name_ru"] = "Сфера подземного огня";
      ["type"] = "Solo";
      ["name_fr"] = "L'orbe infernal";
      ["next"] = 1955;
      ["name_de"] = "Die Hollenkugel";
      ["objective"] = "Bring an Infernal Orb to Tabetha in Dustwallow Marsh.";
      ["name_cn"] = "地?火宝珠";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "The Infernal Orb";
      ["prev"] = 1953;
      ["prequests"] = {
         [1] = 1953;
      };
      ["level"] = 40;
      ["name_es"] = "El orbe infernal";
      ["req"] = 35;
   };
   [8592] = {
      ["name_ru"] = "Тиара Оракула";
      ["objective"] = "Bring Vek'nilash's Circlet, 2 Idols of the Sage, 5 Silver Scarabs and 5 Bone Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "神?者的皇冠";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La tiare de l'Oracle";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Tiara des Orakels";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21348;
      };
      ["name"] = "Tiara of the Oracle";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La tiara del Oraculo";
      ["req"] = 60;
   };
   [6382] = {
      ["name_ru"] = "Большая охота";
      ["type"] = "Solo";
      ["objective"] = "Speak with Senani Thunderheart at Splintertree Post, Ashenvale.";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_fr"] = "La Chasse d'Orneval";
      ["sort"] = "The Barrens";
      ["name_cn"] = "灰谷狩?";
      ["followup"] = 6383;
      ["name_de"] = "Die Jagd im Eschental";
      ["faction"] = "Horde";
      ["name"] = "The Ashenvale Hunt";
      ["level"] = 20;
      ["name_es"] = "La Caza de Vallefresno";
      ["req"] = 20;
   };
   [8514] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает средней кожи!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de cuir moyen?!";
      ["name_de"] = "Die Allianz braucht mehr mittleres Leder!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21510;
      };
      ["name_cn"] = "?盟需要更多中皮！";
      ["objective"] = "Bring 10 medium leather to Private Porter at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Medium Leather!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8513;
      ["prequests"] = {
         [1] = 8513;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas cuero medio!";
      ["req"] = 1;
   };
   [8610] = {
      ["name_ru"] = "Орде все еще не хватает бинтов из рунической ткани!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Runecloth Bandages to Stoneguard Clayhoof at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Runenstoffverbande!";
      ["name_fr"] = "La Horde a besoin de plus de bandages en etoffe runique?!";
      ["name_cn"] = "部落需要更多符文布??！";
      ["name"] = "The Horde Needs More Runecloth Bandages!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8609;
      ["prequests"] = {
         [1] = 8609;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas vendas de pano runico!";
      ["req"] = 1;
   };
   [2258] = {
      ["name_ru"] = "Пробежка по Бесплодным землям";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Buzzard Gizzards, 10 Crag Coyote Fangs, and  5 Rock Elemental Shards to Jarkal Mossmeld in Kargath, Badlands.";
      ["next"] = 2202;
      ["name_fr"] = "Les reactifs des Terres ingrates";
      ["sort"] = "Badlands";
      ["name_cn"] = "荒?之地的??";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Reagenziensuche im Odland";
      ["faction"] = "Horde";
      ["name"] = "Badlands Reagent Run";
      ["level"] = 39;
      ["name_es"] = "Componentes de Tierras Inhospitas";
      ["req"] = 36;
   };
   [1958] = {
      ["name_ru"] = "Небесная сила";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Himmlische Macht";
      ["name_fr"] = "L'energie celeste";
      ["name"] = "Celestial Power";
      ["name_cn"] = "?穹之力";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7515;
         [2] = 9517;
      };
      ["sort"] = "Mage";
      ["prev"] = 1957;
      ["prequests"] = {
         [1] = 1957;
      };
      ["level"] = 40;
      ["name_es"] = "Poder celestial";
      ["req"] = 35;
   };
   [3110] = {
      ["name_ru"] = "Благословенная руна";
      ["type"] = "Solo";
      ["name_fr"] = "Rune benie";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Geheiligte Rune";
      ["objective"] = "Read the Hallowed Rune and speak to Branstock Khalder in Anvilmar.";
      ["name_cn"] = "神?符文";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Hallowed Rune";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa sacralizada";
      ["req"] = 1;
   };
   [7024] = {
      ["name_ru"] = "Здравствуй, Дедушка Зима!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter; he is located near the Smokywood Pastures vendor area in Orgrimmar.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬天??来了！";
      ["name_fr"] = "Grand-pere Hiver est ici?!";
      ["name_de"] = "Altvater Winter ist hier!";
      ["faction"] = "Horde";
      ["name"] = "Great-father Winter is Here!";
      ["level"] = 60;
      ["name_es"] = "!El Gran Padre Invierno esta aqui!";
      ["req"] = 10;
   };
   [2952] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Der Funkelmat 5200!";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_cn"] = "超?清?器5200型！";
      ["name"] = "The Sparklematic 5200!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 2951;
      ["prequests"] = {
         [1] = 2951;
      };
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [7647] = {
      ["name_ru"] = "Суд и расплата";
      ["type"] = "Dungeon";
      ["name_fr"] = "Jugement et redemption";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Gerechtigkeit und Erlosung";
      ["objective"] = "Use the Divination Scryer in the heart of the Great Ossuary's basement in the Scholomance.  Doing so will bring forth the spirits you must judge.  Defeating these spirits will summon forth Death Knight Darkreaver.  Defeat him and reclaim the lost soul of the fallen charger.$B$BGive the Charger's Redeemed Soul and the Blessed Enchanted Barding to Darkreaver's Fallen Charger.";
      ["name_cn"] = "?判和救?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Judgment and Redemption";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 7646;
      ["prequests"] = {
         [1] = 7646;
      };
      ["level"] = 60;
      ["name_es"] = "Juzgar y redimir";
      ["req"] = 60;
   };
   [8305] = {
      ["name_ru"] = "Давно забытые воспоминания";
      ["type"] = "Solo";
      ["name_fr"] = "Des souvenirs oublies depuis longtemps";
      ["repgain"] = {
         [910] = 50;
      };
      ["name_de"] = "Lang Vergessenes";
      ["name"] = "Long Forgotten Memories";
      ["name_cn"] = "久?的??";
      ["objective"] = "Locate the Crystalline Tear in Silithus and gaze into its depths.";
      ["next"] = 8519;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8303;
      ["prequests"] = {
         [1] = 8303;
      };
      ["level"] = 60;
      ["name_es"] = "Recuerdos olvidados";
      ["req"] = 60;
   };
   [8634] = {
      ["name_ru"] = "Сапоги Таинства";
      ["objective"] = "Bring the Qiraji Bindings of Dominance, 2 Idols of the Sun, 5 Silver Scarabs and 5 Crystal Scarabs to Kandrostrasz in Ahn'Qiraj.  This quest also requires Neutral faction with the Brood of Nozdormu.";
      ["name_cn"] = "神秘?靴";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de l'enigme";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Stiefel des Mysteriums";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 21344;
      };
      ["name"] = "Enigma Boots";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas enigma";
      ["req"] = 60;
   };
   [7815] = {
      ["name_ru"] = "Хрустогрызы, чувак!";
      ["type"] = "Solo";
      ["objective"] = "Katoom the Angler at Revantusk Village in the Hinterlands wants you to kill 15 Saltwater Snapjaw turtles. Return to him when you have completed this task.";
      ["name_fr"] = "Les Gueules d'acier, l'ami?!";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "?嘴?！";
      ["reward"] = {
         [1] = 19022;
      };
      ["name_de"] = "Schnappkiefer, Alter!";
      ["faction"] = "Horde";
      ["name"] = "Snapjaws, Mon!";
      ["level"] = 50;
      ["name_es"] = "!Quijafortes, colega!";
      ["req"] = 44;
   };
   [8642] = {
      ["name_ru"] = "Предок Среброжил";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Veine-argent";
      ["name_cn"] = "?脉?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Silberader";
      ["faction"] = "Horde";
      ["name"] = "Silvervein the Elder";
      ["level"] = 60;
      ["name_es"] = "Venaplata el Ancestro";
      ["req"] = 1;
   };
   [3906] = {
      ["name_ru"] = "Дисгармония пламени";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to the quarry in Blackrock Mountain and slay Overmaster Pyron. Return to Thunderheart when you have completed this assignment.$B";
      ["next"] = 3907;
      ["name_fr"] = "Discordance des flammes";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "不和?的烈?";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Disharmonie der Flamme";
      ["faction"] = "Horde";
      ["name"] = "Disharmony of Flame";
      ["level"] = 52;
      ["name_es"] = "La discordia de las llamas";
      ["req"] = 48;
   };
   [1960] = {
      ["name_ru"] = "Лавка алхимика";
      ["type"] = "Solo";
      ["name_fr"] = "Enqueter dans le magasin de l'Alchimiste";
      ["next"] = 1961;
      ["name_de"] = "Untersuchungen im Alchemistenladen";
      ["objective"] = "Obtain a Cantation of Manifestation and a Chest of Containment Coffers from behind Anastasia Hartwell.  Bring 3 Filled Containment Coffers, the Chest of Containment Coffers and the Cantation of Manifestation to Anastasia in the Undercity.";
      ["name_cn"] = "???金店";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Investigate the Alchemist Shop";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1959;
      ["prequests"] = {
         [1] = 1959;
      };
      ["level"] = 16;
      ["name_es"] = "Investiga la tienda de alquimia";
      ["req"] = 15;
   };
   [7168] = {
      ["name_ru"] = "Награда найдет героя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Aufstieg und Anerkennung";
      ["name_fr"] = "Ascension et reconnaissance";
      ["name_cn"] = "?露?角";
      ["name"] = "Rise and Be Recognized";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17900;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7162;
      ["prequests"] = {
         [1] = 7162;
      };
      ["level"] = 60;
      ["name_es"] = "Ascender y darse a conocer";
      ["req"] = 51;
   };
   [4161] = {
      ["name_ru"] = "Калдорайский рецепт";
      ["type"] = "Solo";
      ["objective"] = " $N";
      ["repgain"] = {
         [0] = 69;
      };
      ["name_fr"] = "Une recette kaldorei";
      ["sort"] = "Cooking";
      ["name_cn"] = "?多雷的菜?";
      ["name_de"] = "Rezept der Kaldorei";
      ["faction"] = "Alliance";
      ["name"] = "Recipe of the Kaldorei";
      ["level"] = 7;
      ["name_es"] = "La receta de los kaldorei";
      ["req"] = 1;
   };
   [9113] = {
      ["name_ru"] = "Венец веры";
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe de foi";
      ["name_de"] = "Reif des Glaubens";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make a Circlet of Faith if you bring him the following: 1 Desecrated Circlet, 15 Wartorn Cloth Scraps, 3 Mooncloth and 3 Nexus Crystals.";
      ["reward"] = {
         [1] = 22514;
      };
      ["name_cn"] = "信仰??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Circlet of Faith";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El aro de fe";
      ["req"] = 60;
   };
   [8587] = {
      ["name_ru"] = "Возвращение к Нарайну";
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers Narain";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Ruckkehr zu Narain";
      ["name_cn"] = "向?瑞安回?";
      ["name"] = "Return to Narain";
      ["objective"] = "Deliver the 500 Pound Chicken to Narain Soothfancy in Tanaris.";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8586;
      ["prequests"] = {
         [1] = 8586;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Narain";
      ["req"] = 60;
   };
   [4113] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [1113] = {
      ["name_ru"] = "Сердца Доблести";
      ["type"] = "Solo";
      ["name_fr"] = "Des c?urs zeles";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Herzen des Eifers";
      ["name_cn"] = "狂?之心";
      ["name"] = "Hearts of Zeal";
      ["objective"] = "Master Apothecary Faranell in the Undercity wants 20 Hearts of Zeal.";
      ["faction"] = "Horde";
      ["sort"] = "Scarlet Monastery";
      ["prev"] = 1109;
      ["prequests"] = {
         [1] = 1109;
      };
      ["level"] = 33;
      ["name_es"] = "Corazones de fanatismo";
      ["req"] = 30;
   };
   [7782] = {
      ["name_ru"] = "Владыка Черной горы";
      ["objective"] = "Venture to the Valley of Heroes in Stormwind City and speak with Field Marshal Afrasiabi.";
      ["name_cn"] = "黑石之王";
      ["sort"] = "Stormwind City";
      ["level"] = 60;
      ["type"] = "Solo";
      ["name_fr"] = "Le seigneur de Rochenoire";
      ["repgain"] = {
         [69] = 500;
         [54] = 500;
         [72] = 500;
         [47] = 250;
      };
      ["name_de"] = "Der Herrscher des Schwarzfels";
      ["reward"] = {
         [1] = 19383;
         [2] = 19366;
         [3] = 19384;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Lord of Blackrock";
      ["prev"] = 7781;
      ["prequests"] = {
         [1] = 7781;
      };
      ["series"] = 2;
      ["name_es"] = "Senor de Roca Negra";
      ["req"] = 60;
   };
   [1197] = {
      ["name_ru"] = "Священное пламя";
      ["objective"] = "Retrieve the Cloven Hoof for Rau Cliffrunner at the Freewind Post.";
      ["name_cn"] = "神?之火";
      ["sort"] = "Thunder Bluff";
      ["level"] = 29;
      ["type"] = "Solo";
      ["name_fr"] = "La flamme sacree";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Die heilige Flamme";
      ["reward"] = {
         [1] = 6739;
         [2] = 6740;
      };
      ["faction"] = "Horde";
      ["name"] = "The Sacred Flame";
      ["prev"] = 1196;
      ["prequests"] = {
         [1] = 1196;
      };
      ["series"] = 3;
      ["name_es"] = "La llama sacra";
      ["req"] = 20;
   };
   [4115] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [2922] = {
      ["name_ru"] = "Промыть мозг Техботу";
      ["type"] = "Dungeon";
      ["name_fr"] = "Sauver le cerveau de Techbot?!";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_de"] = "Rettet Techbots Hirn!";
      ["name_cn"] = "拯救尖端机器人！";
      ["name"] = "Save Techbot's Brain!";
      ["objective"] = "Bring Techbot's Memory Core to Tinkmaster Overspark in Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Gnomeregan";
      ["prev"] = 2923;
      ["prequests"] = {
         [1] = 2923;
      };
      ["level"] = 26;
      ["name_es"] = "!Salva el cerebro de Tecnobot!";
      ["req"] = 20;
   };
   [1648] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1778;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Bring 10 Linen Cloth to John Turner in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1647;
      ["prequests"] = {
         [1] = 1647;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [9010] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Mokvar your Shadowcraft Cap and Shadowcraft Tunic.";
      ["reward"] = {
         [1] = 22005;
         [2] = 22009;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8998;
      ["prequests"] = {
         [1] = 8998;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [2205] = {
      ["name_ru"] = "Выход на ШРУ";
      ["type"] = "Solo";
      ["objective"] = "Deliver Keryn Sylvius's package to Master Mathias Shaw at the Stormwind Barracks.";
      ["sort"] = "Rogue";
      ["name_cn"] = "?情七?";
      ["name_fr"] = "Chercher le SI:7";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["followup"] = 2206;
      ["name_de"] = "Aufsuchen des SI:7";
      ["faction"] = "Alliance";
      ["name"] = "Seek out SI: 7";
      ["level"] = 10;
      ["name_es"] = "Busca el IV:7";
      ["req"] = 10;
   };
   [8413] = {
      ["name_ru"] = "Вуду";
      ["type"] = "Dungeon";
      ["name_fr"] = "Vaudou?!";
      ["name_de"] = "Die Macht des Voodoos";
      ["objective"] = "Bring the voodoo feathers to Bath'rah the Windwatcher.";
      ["reward"] = {
         [1] = 20369;
         [2] = 20503;
         [3] = 20556;
      };
      ["name_cn"] = "巫毒羽毛";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Da Voodoo";
      ["sort"] = "Shaman";
      ["prev"] = 8412;
      ["prequests"] = {
         [1] = 8412;
      };
      ["level"] = 52;
      ["name_es"] = "Vudu";
      ["req"] = 50;
   };
   [1947] = {
      ["name_ru"] = "Путь в болото";
      ["type"] = "Solo";
      ["objective"] = "Speak with Tabetha.";
      ["sort"] = "Mage";
      ["name_cn"] = "沼?之旅";
      ["name_fr"] = "Voyager vers le Marais";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Reise in die Marschen";
      ["faction"] = "Horde";
      ["name"] = "Journey to the Marsh";
      ["level"] = 38;
      ["name_es"] = "Viaje al pantano";
      ["req"] = 30;
   };
   [1599] = {
      ["name_ru"] = "В начале славных дел";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Feather Charms to Alamar Grimm in Anvilmar.";
      ["repgain"] = {
         [54] = 250;
      };
      ["name_fr"] = "Les debuts";
      ["sort"] = "Warlock";
      ["name_cn"] = "?端";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Anfange";
      ["faction"] = "Alliance";
      ["name"] = "Beginnings";
      ["level"] = 4;
      ["name_es"] = "Novato";
      ["req"] = 1;
   };
   [7424] = {
      ["name_ru"] = "Какое такое копыто?";
      ["type"] = "PvP";
      ["objective"] = "";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "牛?人的蹄子";
      ["name_fr"] = "Chasse aux sabots !";
      ["name_de"] = "Was zum Huf?";
      ["faction"] = "Alliance";
      ["name"] = "What the Hoof?";
      ["level"] = 60;
      ["name_es"] = "?Y la pezuna?";
      ["req"] = 55;
   };
   [5519] = {
      ["name_ru"] = "Броня огров Гордока";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [21] = 50;
         [369] = 50;
         [577] = 50;
         [470] = 50;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "La tenue d'ogre gordok";
      ["name_cn"] = "戈多克食人魔装*";
      ["reward"] = {
         [1] = 18258;
      };
      ["name_de"] = "Der Ogeranzug der Gordok";
      ["faction"] = "Horde";
      ["name"] = "The Gordok Ogre Suit";
      ["level"] = 60;
      ["name_es"] = "El disfraz de ogro Gordok";
      ["req"] = 56;
   };
   [1097] = {
      ["name_ru"] = "Просьба Элмора";
      ["type"] = "Solo";
      ["objective"] = "Speak with Grimand Elmore.";
      ["next"] = 353;
      ["sort"] = "Stormwind City";
      ["name_cn"] = "艾?默的任?";
      ["name_fr"] = "La quete d'Elmore";
      ["name_de"] = "Elmores Aufgabe";
      ["faction"] = "Alliance";
      ["name"] = "Elmore's Task";
      ["level"] = 15;
      ["name_es"] = "La tarea de Elmore";
      ["req"] = 9;
   };
   [4542] = {
      ["name_ru"] = "Письмо на Заставу Вольного Ветра";
      ["type"] = "Solo";
      ["objective"] = "Bring the Urgent Message to Cliffwatcher Longhorn at Freewind Post.";
      ["next"] = 4841;
      ["name_fr"] = "Un message pour le poste de Librevent";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "?乱??的?急信件";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_de"] = "Nachricht zum Freiwindposten";
      ["faction"] = "Horde";
      ["name"] = "Message to Freewind Post";
      ["level"] = 25;
      ["name_es"] = "Mensaje para el Poblado Viento Libre";
      ["req"] = 23;
   };
   [7488] = {
      ["name_ru"] = "Сеть Лефтендрис";
      ["type"] = "Dungeon";
      ["objective"] = "Bring Lethtendris' Web to Latronicus Moonspear at the Feathermoon Stronghold in Feralas.";
      ["repgain"] = {
         [69] = 350;
         [54] = 350;
         [72] = 350;
         [47] = 350;
      };
      ["name_de"] = "Lethtendris' Netz";
      ["reward"] = {
         [1] = 18491;
      };
      ["name_cn"] = "蕾瑟塔蒂?的网";
      ["name_fr"] = "Le filet de Lethtendris";
      ["faction"] = "Alliance";
      ["name"] = "Lethtendris's Web";
      ["sort"] = "Dire Maul";
      ["prev"] = 7494;
      ["prequests"] = {
         [1] = 7494;
      };
      ["level"] = 57;
      ["name_es"] = "La membrana de Lethtendris";
      ["req"] = 54;
   };
   [7504] = {
      ["name_ru"] = "Святая Болонья: О чем не говорит Свет";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 200;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Sainte Bolognaise?: Ce que la lumiere ne vous dit pas";
      ["name_cn"] = "光明不会告??的事情";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 18469;
      };
      ["name_de"] = "Heiliger Fleischklops: Was das Licht Dir nicht erzahlt";
      ["faction"] = "Horde";
      ["name"] = "Holy Bologna: What the Light Won't Tell You";
      ["level"] = 60;
      ["name_es"] = "Sagrada Bologna: lo que la Luz nunca te dira";
      ["req"] = 54;
   };
   [8674] = {
      ["name_ru"] = "Предок Заиндевевшее Копыто";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Sabot-d'hiver";
      ["name_cn"] = "冬蹄?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Winterhuf";
      ["faction"] = "Horde";
      ["name"] = "Winterhoof the Elder";
      ["level"] = 60;
      ["name_es"] = "Pezuna Invernal el Ancestro";
      ["req"] = 1;
   };
   [9105] = {
      ["name_ru"] = "Венец Проклятого Сердца";
      ["type"] = "Raid";
      ["name_fr"] = "Le diademe de pestecoeur";
      ["name_de"] = "Reif des verseuchten Herzens";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make a Plagueheart Circlet if you bring him the following: 1 Desecrated Circlet, 15 Wartorn Cloth Scraps, 3 Mooncloth and 3 Nexus Crystals.";
      ["reward"] = {
         [1] = 22506;
      };
      ["name_cn"] = "瘟疫之心??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Plagueheart Circlet";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El aro corazon de la peste";
      ["req"] = 60;
   };
   [3062] = {
      ["name_ru"] = "Темное сердце";
      ["type"] = "Group";
      ["objective"] = "Talo Thornhoof in Camp Mojache wants Edana Hatetalon's Dark Heart.";
      ["repgain"] = {
         [81] = 350;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "C?ur noir";
      ["name_cn"] = "黑暗之心";
      ["reward"] = {
         [1] = 9665;
         [2] = 9666;
      };
      ["name_de"] = "Dunkles Herz";
      ["faction"] = "Horde";
      ["name"] = "Dark Heart";
      ["level"] = 50;
      ["name_es"] = "Corazon oscuro";
      ["req"] = 45;
   };
   [1105] = {
      ["name_ru"] = "Крепкие панцири";
      ["type"] = "Solo";
      ["objective"] = "Bring 9 Hardened Tortoise Shells to Wizzle Brassbolts in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "硬化??";
      ["name_fr"] = "Les carapaces durcies";
      ["name_de"] = "Gehartete Schalen";
      ["faction"] = "Horde";
      ["name"] = "Hardened Shells";
      ["level"] = 30;
      ["name_es"] = "Caparazones endurecidos";
      ["req"] = 28;
   };
   [3105] = {
      ["name_ru"] = "Тайное письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre contaminee";
      ["repgain"] = {
         [72] = 50;
      };
      ["name_de"] = "Besudelter Brief";
      ["objective"] = "Read the Tainted Letter and speak to Drusilla La Salle next to Northshire Abbey.";
      ["name_cn"] = "被?染的信件";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Tainted Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta manchada";
      ["req"] = 1;
   };
   [1581] = {
      ["name_ru"] = "Эликсиры для клана Режущего Листа";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Elixirs of Lion's Strength and 2 Elixirs of Minor Defense to Syral Bladeleaf in Dolanaar.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Alchemy";
      ["name_fr"] = "Les elixirs pour les Feuillelame";
      ["name_cn"] = "刃叶的??";
      ["reward"] = {
         [1] = 2449;
         [2] = 785;
      };
      ["name_de"] = "Elixiere fur die Messerblatts";
      ["faction"] = "Horde";
      ["name"] = "Elixirs for the Bladeleafs";
      ["level"] = 8;
      ["name_es"] = "Elixires para Filohoja";
      ["req"] = 4;
   };
   [8313] = {
      ["name_ru"] = "Наделение знаниями";
      ["type"] = "Solo";
      ["name_fr"] = "Partager la connaissance";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Geteiltes Wissen";
      ["name"] = "Sharing the Knowledge";
      ["name_cn"] = "分享知?";
      ["objective"] = "Bring the Torn Recipe Page to Calandrath at the inn in Cenarion Hold.";
      ["next"] = 8317;
      ["faction"] = "Horde";
      ["sort"] = "Cooking";
      ["prev"] = 8307;
      ["prequests"] = {
         [1] = 8307;
      };
      ["level"] = 57;
      ["name_es"] = "Compartir el conocimiento";
      ["req"] = 54;
   };
   [7632] = {
      ["name_ru"] = "Древний лист";
      ["type"] = "Solo";
      ["objective"] = "Find the owner of the Ancient Petrified Leaf. Good luck, $N; It's a big world.";
      ["sort"] = "Hunter";
      ["name_cn"] = "?古石叶";
      ["name_fr"] = "La feuille ancienne";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name_de"] = "Das uralte Blatt";
      ["faction"] = "Horde";
      ["name"] = "The Ancient Leaf";
      ["level"] = 60;
      ["name_es"] = "La hoja antigua";
      ["req"] = 60;
   };
   [7648] = {
      ["name_ru"] = "Шедевр Гриманда";
      ["type"] = "Solo";
      ["name_fr"] = "Le chef d'?uvre de Grimand";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Grimands feinste Arbeit";
      ["objective"] = "Take the Arcanite Barding to Lord Grayson Shadowbreaker in Stormwind's Cathedral District for his inspection.";
      ["name_cn"] = "艾?默的手?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "Grimand's Finest Work";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 7642;
      ["prequests"] = {
         [1] = 7642;
      };
      ["level"] = 60;
      ["name_es"] = "Un trabajo bien hecho";
      ["req"] = 60;
   };
   [7664] = {
      ["name_ru"] = "Новый палевый ящер";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Durotar";
      ["name_fr"] = "Remplacement de raptor ivoire";
      ["name_cn"] = "白色迅猛?";
      ["reward"] = {
         [1] = 18788;
         [2] = 18789;
         [3] = 18790;
      };
      ["name_de"] = "Austausch Eures elfenbeinfarbigen Raptors";
      ["faction"] = "Horde";
      ["name"] = "Ivory Raptor Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de raptor marfil";
      ["req"] = 60;
   };
   [8682] = {
      ["name_ru"] = "Предок Небесный Провидец";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien ?il-des-cieux";
      ["name_cn"] = "星??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Himmelsdeuter";
      ["faction"] = "Horde";
      ["name"] = "Skyseer the Elder";
      ["level"] = 60;
      ["name_es"] = "Ancestro Vidente del Cielo";
      ["req"] = 1;
   };
   [9075] = {
      ["name_ru"] = "Накулачники Землекрушителя";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make Earthshatter Wristguards if you bring him the following: 1 Desecrated Wristguards, 6 Wartorn Chain Scraps, 1 Arcanite Bar and 2 Cured Rugged Hides.$B";
      ["name_cn"] = "碎地者?腕";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-poignets de Brise-terre";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handgelenksschutzer des Erdspalters";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22471;
      };
      ["name"] = "Earthshatter Wristguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardamunecas Rompeterra";
      ["req"] = 60;
   };
   [1251] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["objective"] = "Bring the Blackened Iron Shield to Krog in Brackenwall Village.";
      ["next"] = 1321;
      ["name_fr"] = "Le bouclier noir";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "黑色盾牌";
      ["series"] = 1;
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["faction"] = "Horde";
      ["name"] = "The Black Shield";
      ["level"] = 35;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [7728] = {
      ["name_ru"] = "УКРАДЕНО: фурма и подзорная труба наблюдателя";
      ["type"] = "Solo";
      ["objective"] = "Find and return the Smithing Tuyere and Lookout's Spyglass to Taskmaster Scrange in the Searing Gorge.$B$BThe only information you have about these items is the following: They were definitely stolen by Dark Iron dwarves. The Smithing Tuyere is a blacksmithing tool used by blacksmiths and the Lookout's Spyglass is an invaluable monitoring tool to lookouts. ";
      ["repgain"] = {
         [59] = 100;
      };
      ["sort"] = "Searing Gorge";
      ["name_fr"] = "OBJETS VOLES?: Tuyere et longue-vue";
      ["name_cn"] = "被盗：鼓?机和望??";
      ["reward"] = {
         [1] = 19124;
         [2] = 19123;
      };
      ["name_de"] = "GESTOHLEN: Schmiedewindform und ein Ausguckhandfernrohr";
      ["faction"] = "Horde";
      ["name"] = "STOLEN: Smithing Tuyere and Lookout's Spyglass";
      ["level"] = 48;
      ["name_es"] = "OBJETOS ROBADOS: Tobera y catalejo";
      ["req"] = 45;
   };
   [8684] = {
      ["name_ru"] = "Предок Толкователь Снов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien ?il-des-reves";
      ["name_cn"] = "梦言?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Traumdeuter";
      ["faction"] = "Horde";
      ["name"] = "Dreamseer the Elder";
      ["level"] = 60;
      ["name_es"] = "Visionirico el Ancestro";
      ["req"] = 1;
   };
   [1075] = {
      ["name_ru"] = "Свиток от Маурена";
      ["type"] = "Solo";
      ["name_fr"] = "Un parchemin de Collin Mauren";
      ["repgain"] = {
         [54] = 75;
         [72] = 75;
      };
      ["name_de"] = "Eine Rolle von Mauren";
      ["name"] = "A Scroll from Mauren";
      ["name_cn"] = "??的卷?";
      ["objective"] = "Find Collin Mauren in Stormwind.";
      ["next"] = 1076;
      ["faction"] = "Alliance";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1071;
      ["prequests"] = {
         [1] = 1071;
      };
      ["level"] = 21;
      ["name_es"] = "Un pergamino de Mauren";
      ["req"] = 17;
   };
   [8685] = {
      ["name_ru"] = "Предок Странница Туманов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Marche-brume";
      ["name_cn"] = "迷??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Nebelganger";
      ["faction"] = "Horde";
      ["name"] = "Mistwalker the Elder";
      ["level"] = 60;
      ["name_es"] = "Caminaniebla el Ancestro";
      ["req"] = 1;
   };
   [7792] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [69] = 150;
      };
      ["sort"] = "Darnassus";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7800;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [7808] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7811;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7824] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [76] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Orgrimmar";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7831;
         [2] = 7827;
         [3] = 7826;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [7840] = {
      ["name_ru"] = "Лярд потерял свой обед";
      ["type"] = "Solo";
      ["objective"] = "Lard at Revantusk Village in the Hinterlands wants you to find Lard's Lunch. Return to him when this task is complete.$B$BLard mentioned that he left it on the island to the north. Watch out for Vilebranch trolls.";
      ["name_fr"] = "Lard a perdu son dejeuner?!";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "拉?德的午餐";
      ["reward"] = {
         [1] = 19035;
      };
      ["name_de"] = "Lards vergessene Brotzeit";
      ["faction"] = "Horde";
      ["name"] = "Lard Lost His Lunch";
      ["level"] = 49;
      ["name_es"] = "Lard perdio su almuerzo";
      ["req"] = 44;
   };
   [8690] = {
      ["name_ru"] = "Плащ Надвигающейся бури";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Regal Drape, 2 Obsidian Idols, 5 Clay Scarabs and 5 Gold Scarabs to Keyl Swiftclaw in Silithus.  You must also obtain Revered reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La cape de la tempete imminente";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "聚集?暴披?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21400;
      };
      ["name_de"] = "Umhang der aufziehenden Sturme";
      ["faction"] = "Horde";
      ["name"] = "Cloak of the Gathering Storm";
      ["level"] = 60;
      ["name_es"] = "La capa de la tormenta inminente";
      ["req"] = 60;
   };
   [7872] = {
      ["name_ru"] = "Долой захватчиков!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者！ (PvP)";
      ["name_fr"] = "Triomphez des envahisseurs?!";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Alliance";
      ["name"] = "Vanquish the Invaders!";
      ["level"] = 45;
      ["name_es"] = "!Expulsa al invasor!";
      ["req"] = 40;
   };
   [7888] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["name_fr"] = "Talismans de vaillance";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["objective"] = "You obtained a Silverwing Talisman of Merit for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Alliance";
      ["name"] = "Talismans of Merit";
      ["name_de"] = "Verdienstabzeichen";
      ["prev"] = 7872;
      ["prequests"] = {
         [1] = 7872;
      };
      ["level"] = 45;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 40;
   };
   [7843] = {
      ["name_ru"] = "Последнее послание клану Громового Молота";
      ["type"] = "PvP";
      ["name_fr"] = "Le message final pour les Marteaux-hardis";
      ["name_de"] = "Die letzte Botschaft an die Wildhammer";
      ["reward"] = {
         [1] = 19119;
      };
      ["name_cn"] = "?蛮?部族的最后警告";
      ["objective"] = "Otho Moji'ko at Revantusk Village in the Hinterlands wants you to travel to Aerie Peak in the western region of the Hinterlands and place the Final Message to the Wildhammer by the well in the center of town. Return to him once this task is complete.$B$BBeware of angry Wildhammer dwarves and unruly members of the Alliance.";
      ["faction"] = "Horde";
      ["name"] = "The Final Message to the Wildhammer";
      ["sort"] = "The Hinterlands";
      ["prev"] = 7842;
      ["prequests"] = {
         [1] = 7842;
      };
      ["level"] = 50;
      ["name_es"] = "Un mensaje final para los Martillo Salvaje";
      ["req"] = 44;
   };
   [1086] = {
      ["name_ru"] = "Аэропорт ветролетов";
      ["type"] = "Solo";
      ["name_fr"] = "L'aeroport de la machine volante";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Der Flugapparathafen";
      ["name_cn"] = "地精空港";
      ["name"] = "The Flying Machine Airport";
      ["objective"] = "Bring the Toxic Fogger to the Venture Co. sky port, then return to Apothecary Zamah.";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1067;
      ["prequests"] = {
         [1] = 1067;
      };
      ["level"] = 23;
      ["name_es"] = "El aeropuerto";
      ["req"] = 13;
   };
   [7936] = {
      ["name_ru"] = "50 билетов ? прошлогодний окорок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "50 bons - Mouton de l'an dernier";
      ["name_cn"] = "50?彩票 - 去年的羊肉";
      ["reward"] = {
         [1] = 19293;
      };
      ["name_de"] = "50 Lose - Hammel des letzten Jahres";
      ["faction"] = "Horde";
      ["name"] = "50 Tickets - Last Year's Mutton";
      ["level"] = 60;
      ["name_es"] = "50 vales: anojo del ano pasado";
      ["req"] = 45;
   };
   [1151] = {
      ["name_ru"] = "Испытание силы";
      ["type"] = "Group";
      ["name_fr"] = "L'epreuve de la Force";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Test der Kraft";
      ["name"] = "Test of Strength";
      ["name_cn"] = "力量的??";
      ["objective"] = "Bring Fragments of Rok'Alim to Dorn Plainstalker in Thousand Needles.";
      ["next"] = 1152;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1150;
      ["prequests"] = {
         [1] = 1150;
      };
      ["level"] = 30;
      ["name_es"] = "Prueba de fuerza";
      ["req"] = 25;
   };
   [7823] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Thunder Bluff";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 7820;
         [2] = 7821;
         [3] = 7822;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [1091] = {
      ["name_ru"] = "Новости для Каэлы";
      ["type"] = "Solo";
      ["name_fr"] = "Des nouvelles pour Kaela";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_cn"] = "向?拉回?";
      ["name_de"] = "Kaelas Update";
      ["objective"] = "Bring the Venture Co. Letters to Kaela Shadowspear.";
      ["sort"] = "Stonetalon Mountains";
      ["name"] = "Kaela's Update";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 1080;
         [2] = 1079;
      };
      ["level"] = 22;
      ["name_es"] = "Noticias para Kaela";
      ["req"] = 17;
   };
   [1119] = {
      ["name_ru"] = "Смесь Занзила и \"Дурацкое Крепкое\"";
      ["type"] = "Solo";
      ["objective"] = "Bring the Fool's Stout back to Kravel in the Shimmering Flats.";
      ["name_fr"] = "La mixture de Zanzil et la biere brune du Sot";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "?吉?的??和蠢人酒";
      ["name"] = "Zanzil's Mixture and a Fool's Stout";
      ["name_de"] = "Zanzils Mixtur und Fools Starkbier";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 621;
         [2] = 1118;
      };
      ["level"] = 44;
      ["name_es"] = "La mezcla de Zanzil y la cerveza de tontos";
      ["req"] = 35;
   };
   [4401] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [5203] = {
      ["name_ru"] = "Спасение из Джеденара";
      ["type"] = "Solo";
      ["name_fr"] = "Sauvetage a Jaedenar";
      ["next"] = 5204;
      ["name_de"] = "Rettung aus Jaedenar";
      ["name_cn"] = "逃出加德??";
      ["objective"] = "Escort Arko'narin to where Lightforge and her equipment are being held, and then protect her as you escape Shadow Hold. Afterwards, seek out Jessir Moonbow in Felwood to let her know what's happened to her friends.";
      ["sort"] = "Felwood";
      ["faction"] = "Horde";
      ["name"] = "Rescue From Jaedenar";
      ["prev"] = 5202;
      ["prequests"] = {
         [1] = 5202;
      };
      ["level"] = 55;
      ["name_es"] = "El rescate en Jaedenar";
      ["req"] = 49;
   };
   [8048] = {
      ["name_ru"] = "Печать героя";
      ["objective"] = "";
      ["name_cn"] = "英雄的烙印";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La marque du heros";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Das Emblem des Helden";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["faction"] = "Alliance";
      ["name"] = "The Hero's Brand";
      ["prev"] = 8047;
      ["prequests"] = {
         [1] = 8047;
      };
      ["reward"] = {
         [1] = 19588;
      };
      ["name_es"] = "La Ensena del heroe";
      ["req"] = 60;
   };
   [8064] = {
      ["name_ru"] = "Знаки Силы: пояс гаруспика";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Sash.  Maywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale. You must also be Honored with Zandalar.";
      ["name_fr"] = "Parangons de puissance?: la ceinture d'haruspice";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：占卜?腰?";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19839;
      };
      ["name_de"] = "Symbole der Macht: Der Haruspexgurtel";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Haruspex's Belt";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Cinturon de haruspex";
      ["req"] = 60;
   };
   [8080] = {
      ["name_ru"] = "Ресурсы Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地的?源!";
      ["name_fr"] = "Les ressources du bassin d'Arathi";
      ["name_de"] = "Die Ressourcen des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Arathi Basin Resources!";
      ["level"] = 55;
      ["name_es"] = "Los recursos de la Cuenca de Arathi";
      ["req"] = 50;
   };
   [5535] = {
      ["name_ru"] = "Беспокойные духи";
      ["type"] = "Solo";
      ["objective"] = "Destroy 6 Highborne Apparitions and 6 Highborne Lichlings before returning to Loh'atu in Azshara.";
      ["sort"] = "Azshara";
      ["name_cn"] = "永不安息的?魂";
      ["name_fr"] = "Agitation spirituelle";
      ["name_de"] = "Spirituelle Unruhe";
      ["faction"] = "Horde";
      ["name"] = "Spiritual Unrest";
      ["level"] = 47;
      ["name_es"] = "Agitacion espiritual";
      ["req"] = 45;
   };
   [8112] = {
      ["name_ru"] = "Зачарованные водоросли Южных морей";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Verzauberter Sudmeertang";
      ["name_fr"] = "Le varech enchante des Mers du sud";
      ["name"] = "Enchanted South Seas Kelp";
      ["name_cn"] = "南海魔化海藻";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19612;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8111;
      ["prequests"] = {
         [1] = 8111;
      };
      ["level"] = 60;
      ["name_es"] = "Algas de los Mares del Sur encantadas";
      ["req"] = 60;
   };
   [1084] = {
      ["name_ru"] = "Раны Дерев";
      ["type"] = "Solo";
      ["name_fr"] = "Les Anciens blesses";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Verletzte Urtume";
      ["followup"] = 1082;
      ["name_cn"] = "受?的古?";
      ["objective"] = "Bring a piece of Corroded Shrapnel to Kaela Shadowspear in Stonetalon.";
      ["faction"] = "Alliance";
      ["name"] = "Wounded Ancients";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1091;
      ["prequests"] = {
         [1] = 1091;
      };
      ["level"] = 28;
      ["name_es"] = "Los antarboles corruptos";
      ["req"] = 22;
   };
   [8144] = {
      ["name_ru"] = "Зандаларский талисман Власти над Тенями";
      ["objective"] = "";
      ["name_cn"] = "??拉暗影大???";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le talisman de maitrise de l'ombre zandalarien";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Zandalarischattentalisman der Beherrschung";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Zandalrian Shadow Mastery Talisman";
      ["prev"] = 8143;
      ["prequests"] = {
         [1] = 8143;
      };
      ["reward"] = {
         [1] = 19617;
      };
      ["name_es"] = "Dije Zandalar de maestria de las Sombras";
      ["req"] = 60;
   };
   [8160] = {
      ["name_ru"] = "Перекрыть линии поставок Аратора";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "切断阿拉索???";
      ["name_fr"] = "Couper les voies de ravitaillement d'Arathor";
      ["name_de"] = "Zerschlagt die Versorgungslinien Arathors";
      ["faction"] = "Horde";
      ["name"] = "Cut Arathor Supply Lines";
      ["level"] = 45;
      ["name_es"] = "Cortale el suministro a la Liga de Arathor";
      ["req"] = 40;
   };
   [1957] = {
      ["name_ru"] = "Волнолов маны";
      ["type"] = "Solo";
      ["name_fr"] = "Les eruptions de mana";
      ["name_de"] = "Manawogen";
      ["objective"] = "Kill 12 Mana Surges in the allowed time limit.";
      ["name_cn"] = "法力怒?";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Mana Surges";
      ["prev"] = 1956;
      ["prequests"] = {
         [1] = 1956;
      };
      ["level"] = 40;
      ["name_es"] = "Oleadas de mana";
      ["req"] = 35;
   };
   [8192] = {
      ["name_ru"] = "Прикосновение анимиста";
      ["type"] = "Raid";
      ["objective"] = "Bring me thise things and I will create a powerful enchantment for you! $BPrimal Hakkari Idol$BPunctured Voodoo Doll";
      ["repgain"] = {
         [270] = 250;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La caresse de l'animiste";
      ["name_cn"] = "?魂的安?";
      ["reward"] = {
         [1] = 19790;
      };
      ["name_de"] = "Liebkosung des Animisten";
      ["faction"] = "Horde";
      ["name"] = "Animist's Caress";
      ["level"] = 60;
      ["name_es"] = "Caricia del animista";
      ["req"] = 58;
   };
   [8224] = {
      ["name_ru"] = "Редкая рыба ? дезийская ставрида";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Poisson rare : le talang dezien";
      ["name_cn"] = "稀有?? - 迪森皇后?";
      ["reward"] = {
         [1] = 19971;
      };
      ["name_de"] = "Besonderer Fisch - Dezianischer Koniginnenfisch";
      ["faction"] = "Horde";
      ["name"] = "Rare Fish - Dezian Queenfish";
      ["level"] = 0;
      ["name_es"] = "Pez raro: pez reina de Dezian";
      ["req"] = 1;
   };
   [8256] = {
      ["name_ru"] = "Лимфа нежити";
      ["type"] = "Solo";
      ["name_fr"] = "L'ichor de non-mort";
      ["next"] = 8257;
      ["name_de"] = "Sekret des Untodes";
      ["objective"] = "Acquire an Ichor of Undeath for Ogtinc in Azshara.  Ogtinc resides atop the cliffs northeast the Ruins of Eldarath.";
      ["name_cn"] = "亡?的腐液";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "The Ichor of Undeath";
      ["prev"] = 8255;
      ["prequests"] = {
         [1] = 8255;
      };
      ["level"] = 52;
      ["name_es"] = "El icor de los no-muertos";
      ["req"] = 50;
   };
   [4145] = {
      ["name_ru"] = "Ларион и Муиджин";
      ["type"] = "Solo";
      ["objective"] = "Hunt 5 Bloodpetal Lashers, 5 Bloodpetal Threshers, 5 Bloodpetal Flayers and 5 Bloodpetal Trappers for Larion at Marshal's Refuge.";
      ["next"] = 4147;
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "拉瑞安和穆?金";
      ["name_fr"] = "Larion et Muigin";
      ["name_de"] = "Larion und Muigin";
      ["faction"] = "Horde";
      ["name"] = "Larion and Muigin";
      ["level"] = 52;
      ["name_es"] = "Larion y Muigin";
      ["req"] = 47;
   };
   [8320] = {
      ["name_ru"] = "Геолорды из культа Сумеречного Молота";
      ["type"] = "Solo";
      ["objective"] = "Kill 10 Twilight Geolords, then return to Huum Wildmane in Cenarion Hold.";
      ["next"] = 8321;
      ["name_fr"] = "Les geoseigneurs du crepuscule";
      ["sort"] = "Silithus";
      ["name_cn"] = "暮光地王";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Geolords des Schattenhammers";
      ["faction"] = "Horde";
      ["name"] = "Twilight Geolords";
      ["level"] = 60;
      ["name_es"] = "Geosenores Crepusculares";
      ["req"] = 60;
   };
   [8352] = {
      ["name_ru"] = "Скипетр Совета";
      ["type"] = "Raid";
      ["objective"] = "Bring an Abyssal Scepter to Bor Wildmane in Cenarion Hold.";
      ["repgain"] = {
         [609] = 200;
      };
      ["name_de"] = "Szepter des Rates";
      ["reward"] = {
         [1] = 20602;
      };
      ["name_cn"] = "?会的?杖";
      ["name_fr"] = "Le sceptre du Conseil";
      ["faction"] = "Horde";
      ["name"] = "Scepter of the Council";
      ["sort"] = "Silithus";
      ["prev"] = 8351;
      ["prequests"] = {
         [1] = 8351;
      };
      ["level"] = 60;
      ["name_es"] = "Cetro del Consejo";
      ["req"] = 60;
   };
   [8384] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 50;
      };
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["prev"] = 8374;
      ["prequests"] = {
         [1] = 8374;
      };
      ["level"] = 29;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8416] = {
      ["name_ru"] = "Бездействующие камни Плети";
      ["objective"] = "Bring the Inert Scourgestone to Commander Ashlan Valorfist in Chillwind Point.";
      ["name_cn"] = "惰性天?石";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 52;
      ["type"] = "Solo";
      ["name_fr"] = "Pierres du Fleau inertes";
      ["next"] = 8418;
      ["name_de"] = "Gereinigte Geiselsteine";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["repgain"] = {
         [529] = 75;
      };
      ["name"] = "Inert Scourgestones";
      ["prev"] = 8414;
      ["prequests"] = {
         [1] = 8414;
      };
      ["sort"] = "Paladin";
      ["name_es"] = "Piedras de la Plaga inertes";
      ["req"] = 50;
   };
   [1109] = {
      ["name_ru"] = "Груды гуано";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 1 pile of Kraul Guano to Master Apothecary Faranell in the Undercity.";
      ["next"] = 1113;
      ["name_fr"] = "Corvee de guano";
      ["sort"] = "Razorfen Kraul";
      ["name_cn"] = "蝙蝠的?便";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Go, Go, Guano!";
      ["faction"] = "Horde";
      ["name"] = "Going, Going, Guano!";
      ["level"] = 33;
      ["name_es"] = "Guano del Horado";
      ["req"] = 30;
   };
   [4241] = {
      ["name_ru"] = "Маршал Винздор";
      ["type"] = "Dungeon";
      ["name_fr"] = "Marechal Windsor";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Marschall Windsor";
      ["name"] = "Marshal Windsor";
      ["name_cn"] = "温德索?元?";
      ["objective"] = "Travel to Blackrock Mountain in the northwest and enter Blackrock Depths. Find out what became of Marshal Windsor.$B$BYou recall Ragged John talking about Windsor being dragged off to a prison.";
      ["next"] = 4242;
      ["faction"] = "Alliance";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4224;
      ["prequests"] = {
         [1] = 4224;
      };
      ["level"] = 54;
      ["name_es"] = "El mariscal Windsor";
      ["req"] = 48;
   };
   [8512] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает легкой кожи!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de cuir leger?!";
      ["name_de"] = "Die Allianz braucht mehr leichtes Leder!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_cn"] = "?盟需要更多?皮！";
      ["objective"] = "Bring 10 light leather to Bonnie Stoneflayer at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Light Leather!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8511;
      ["prequests"] = {
         [1] = 8511;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas cuero semipesado!";
      ["req"] = 1;
   };
   [8544] = {
      ["name_ru"] = "Наплеч Завоевателя";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of Night, 5 Stone Scarabs and 5 Clay Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "征服者的肩?";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres du Conquerant";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schiftung des Eroberers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 21330;
      };
      ["name"] = "Conqueror's Spaulders";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las bufas de conquistador";
      ["req"] = 60;
   };
   [8576] = {
      ["name_ru"] = "Перевод книги";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "Ubersetzung des Buchs";
      ["name_cn"] = "翻???";
      ["name_fr"] = "La traduction du grand livre";
      ["name"] = "Translating the Ledger";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8575;
      ["prequests"] = {
         [1] = 8575;
      };
      ["level"] = 60;
      ["name_es"] = "La traduccion del libro de contabilidad";
      ["req"] = 60;
   };
   [8608] = {
      ["name_ru"] = "Орде опять не хватает бинтов из магической ткани!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Mageweave Bandages to Lady Callow at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Magiestoffverbande!";
      ["name_fr"] = "La Horde a besoin de plus de bandages en tisse-mage?!";
      ["name_cn"] = "部落需要更多魔?布??！";
      ["name"] = "The Horde Needs More Mageweave Bandages!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8607;
      ["prequests"] = {
         [1] = 8607;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas vendas de tejido magico!";
      ["req"] = 1;
   };
   [8640] = {
      ["name_ru"] = "Поножи торговца смертью";
      ["objective"] = "Bring Ouro's Intact Hide, 2 Idols of Night, 5 Stone Scarabs and 5 Crystal Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "死亡?行者的?腿";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres du dispensateur de mort";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Gamaschen des Todesboten";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21362;
      };
      ["name"] = "Deathdealer's Leggings";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los leotardos de mortifero";
      ["req"] = 60;
   };
   [8672] = {
      ["name_ru"] = "Предок Каменное Копье";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Cime-de-pierre";
      ["name_cn"] = "石塔?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Steinkeil";
      ["faction"] = "Horde";
      ["name"] = "Stonespire the Elder";
      ["level"] = 60;
      ["name_es"] = "Picopiedra el Ancestro";
      ["req"] = 1;
   };
   [8704] = {
      ["name_ru"] = "Перстень Незримого пути";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ceremonial Ring, 2 Amber Idols, 5 Gold Scarabs and 5 Clay Scarabs to Windcaller Yessendra in Silithus.  You must also attain Honored reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La chevaliere du sentier invisible";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "?秘通途之戒";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21402;
      };
      ["name_de"] = "Siegel des unsichtbaren Pfads";
      ["faction"] = "Horde";
      ["name"] = "Signet of the Unseen Path";
      ["level"] = 60;
      ["name_es"] = "El sello de la senda oculta";
      ["req"] = 60;
   };
   [8736] = {
      ["name_ru"] = "Явление Кошмара";
      ["type"] = "Raid";
      ["objective"] = "Defend Nighthaven from Eranikus. Do not let Keeper Remulos perish. Do not slay Eranikus. Defend yourself. Await Tyrande.$B";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Der Alptraum offenbart sich";
      ["reward"] = {
         [1] = 21531;
         [2] = 21532;
      };
      ["name_cn"] = "?梦??";
      ["name_fr"] = "Le Cauchemar se manifeste";
      ["faction"] = "Horde";
      ["name"] = "The Nightmare Manifests";
      ["sort"] = "Moonglade";
      ["prev"] = 8735;
      ["prequests"] = {
         [1] = 8735;
      };
      ["level"] = 60;
      ["name_es"] = "La Pesadilla se manifiesta";
      ["req"] = 60;
   };
   [8768] = {
      ["name_ru"] = "Подарок в яркой упаковке";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un cadeau a l'emballage multicolore";
      ["name_cn"] = "??的礼物";
      ["reward"] = {
         [1] = 21310;
      };
      ["name_de"] = "Ein frohlich verpacktes Geschenk";
      ["faction"] = "Horde";
      ["name"] = "A Gaily Wrapped Present";
      ["level"] = 20;
      ["name_es"] = "Un presente con envoltorio alegre";
      ["req"] = 20;
   };
   [2201] = {
      ["name_ru"] = "Время собирать камни";
      ["type"] = "Dungeon";
      ["name_fr"] = "Trouver les gemmes";
      ["next"] = 2204;
      ["name_de"] = "Suche nach den Edelsteinen";
      ["name_cn"] = "?找宝石";
      ["objective"] = "Find the ruby, sapphire, and topaz that are scattered throughout Uldaman.  Once acquired, contact Talvash del Kissel remotely by using the Phial of Scrying he previously gave you.$B$BFrom the journal, you know...$B* The ruby has been stashed in a barricaded Shadowforge area.$B* The topaz has been hidden in an urn in one of the Trogg areas, near some Alliance dwarves.$B$B* The sapphire has been claimed by Grimlok, the trogg leader.";
      ["sort"] = "Uldaman";
      ["faction"] = "Alliance";
      ["name"] = "Find the Gems";
      ["prev"] = 2200;
      ["prequests"] = {
         [1] = 2200;
      };
      ["level"] = 43;
      ["name_es"] = "Encuentra las gemas";
      ["req"] = 40;
   };
   [8832] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8815;
      ["prequests"] = {
         [1] = 8815;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8864] = {
      ["name_ru"] = "Платья Лунного фестиваля";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les robes de la fete lunaire";
      ["name_cn"] = "???裙";
      ["reward"] = {
         [1] = 21157;
         [2] = 21640;
         [3] = 21538;
         [4] = 21539;
      };
      ["name_de"] = "Festtagskleider des Mondfests";
      ["faction"] = "Horde";
      ["name"] = "Festive Lunar Dresses";
      ["level"] = 60;
      ["name_es"] = "Vestidos para el Festival Lunar";
      ["req"] = 1;
   };
   [4449] = {
      ["name_ru"] = "Попался!";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Dark Iron Geologists and bring 15 pieces of Silk Cloth to the person locked in the outhouse in Searing Gorge.";
      ["next"] = 4450;
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "被?起来的矮人";
      ["name_fr"] = "Piege?!";
      ["name_de"] = "Eingesperrt!";
      ["faction"] = "Horde";
      ["name"] = "Caught!";
      ["level"] = 45;
      ["name_es"] = "Atrapado";
      ["req"] = 43;
   };
   [4465] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [2241] = {
      ["name_ru"] = "Катись, яблочко...";
      ["type"] = "Solo";
      ["objective"] = "Take Jannok's Rose to Syurna in Darnassus.";
      ["sort"] = "Rogue";
      ["name_cn"] = "詹?克的花";
      ["name_fr"] = "Pomme d'amour";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["followup"] = 2242;
      ["name_de"] = "Der Apfel fallt";
      ["faction"] = "Alliance";
      ["name"] = "The Apple Falls";
      ["level"] = 10;
      ["name_es"] = "Cuando cae la manzana";
      ["req"] = 10;
   };
   [8992] = {
      ["name_ru"] = "Правая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau droit de l'amulette du seigneur Valthal";
      ["next"] = 8994;
      ["name_de"] = "Das rechte Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Kormok and slay him. Return to Bodley inside Blackrock Mountain with the recombined Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦?拉克?符的右半?";
      ["sort"] = "Scholomance";
      ["faction"] = "Horde";
      ["name"] = "The Right Piece of Lord Valthalak's Amulet";
      ["followup"] = 8994;
      ["prev"] = 8988;
      ["prequests"] = {
         [1] = 8988;
      };
      ["level"] = 60;
      ["name_es"] = "La parte derecha del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [4513] = {
      ["name_ru"] = "Долгий путь слизнюка";
      ["type"] = "Solo";
      ["objective"] = " Laris?\" I'm not sure. I do know that these are corrupt... just like Felwood. Which is what makes my realization so important. The oozes seem to adapt... to take on the aspects of the area they're in. I'll need to find samples that haven't been polluted. But where? Where?!$B$BBah! $N";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_de"] = "Schlamm auf Abwegen";
      ["reward"] = {
         [1] = 12050;
         [2] = 12051;
      };
      ["name_cn"] = "?方的?泥怪";
      ["name_fr"] = "Un grand periple pour une petite Gelee";
      ["faction"] = "Alliance";
      ["name"] = "A Little Slime Goes a Long Way";
      ["sort"] = "Ironforge";
      ["prev"] = 4512;
      ["prequests"] = {
         [1] = 4512;
      };
      ["level"] = 54;
      ["name_es"] = "Un largo camino para unas babosas";
      ["req"] = 48;
   };
   [9056] = {
      ["name_ru"] = "Головной убор расхитителя гробниц";
      ["type"] = "Raid";
      ["name_fr"] = "Le couvre-chef de traqueur des cryptes";
      ["name_de"] = "Kopfstuck des Gruftpirschers";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make a Cryptstalker Headpiece if you bring him the following: 1 Desecrated Headpiece, 15 Wartorn Chain Scraps, 4 Arcanite Bars and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22438;
      };
      ["name_cn"] = "地穴追?者??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Cryptstalker Headpiece";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La celada de acechacriptas";
      ["req"] = 60;
   };
   [9088] = {
      ["name_ru"] = "Головной убор сновидца";
      ["type"] = "Raid";
      ["name_fr"] = "Le couvre-chef de marchereve";
      ["name_de"] = "Kopfstuck des Traumwandlers";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make a Dreamwalker Headpiece if you bring her the following: 1 Desecrated Headpiece, 15 Wartorn Leather Scraps, 6 Cured Rugged Hides and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22490;
      };
      ["name_cn"] = "梦游者??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Dreamwalker Headpiece";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La celada Caminasuenos";
      ["req"] = 60;
   };
   [2281] = {
      ["name_ru"] = "Встречи в Красногорье";
      ["type"] = "Solo";
      ["objective"] = "Venture forth to Lakeshire in the Redridge Mountains and speak with Lucius.$B";
      ["next"] = 2282;
      ["sort"] = "Rogue";
      ["name_cn"] = "赤脊山的???";
      ["name_fr"] = "Le Rendez-vous des Carmines";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name_de"] = "Rendezvous im Rotkammgebirge";
      ["faction"] = "Alliance";
      ["name"] = "Redridge Rendezvous";
      ["level"] = 16;
      ["name_es"] = "Cita en Crestagrana";
      ["req"] = 16;
   };
   [4267] = {
      ["name_ru"] = "Возвышение силитидов";
      ["type"] = "Solo";
      ["name_fr"] = "L'ascension des silithides";
      ["repgain"] = {
         [69] = 350;
         [54] = 350;
         [47] = 350;
         [369] = 350;
      };
      ["name_de"] = "Aufstieg der Silithiden";
      ["name_cn"] = "??蝎的崛起";
      ["name"] = "Rise of the Silithid";
      ["objective"] = "Bring Raschal's Report to Gracina Spiritmight in Darnassus.";
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 4266;
      ["prequests"] = {
         [1] = 4266;
      };
      ["level"] = 46;
      ["name_es"] = "La sublevacion de los silitidos";
      ["req"] = 40;
   };
   [9184] = {
      ["name_ru"] = "Задание мастера: гибельная кожаная головная повязка";
      ["type"] = "Solo";
      ["objective"] = "Deliver 10 Wicked Leather Headbands and the Craftsman's Writ - Wicked Leather Headband - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.$B";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Bandeaux corrompus en cuir";
      ["name_cn"] = "工匠文? - 邪?皮甲??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Tuckisches Lederstirnband";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Wicked Leather Headband";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: cinta de cuero maligno";
      ["req"] = 55;
   };
   [1275] = {
      ["name_ru"] = "Исследование порчи";
      ["type"] = "Dungeon";
      ["objective"] = "Gershala Nightwhisper in Auberdine wants 8 Corrupt Brain stems.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Erforschung der Verderbnis";
      ["reward"] = {
         [1] = 7003;
         [2] = 7004;
      };
      ["name_cn"] = "研究堕落";
      ["name_fr"] = "Recherches sur la corruption";
      ["faction"] = "Alliance";
      ["name"] = "Researching the Corruption";
      ["sort"] = "Blackfathom Deeps";
      ["prev"] = 3765;
      ["prequests"] = {
         [1] = 3765;
      };
      ["level"] = 24;
      ["name_es"] = "Investigaciones acerca de la corrupcion";
      ["req"] = 18;
   };
   [9248] = {
      ["name_ru"] = "Скромный подарок";
      ["type"] = "Solo";
      ["objective"] = "Aurel Goldleaf at Cenarion Hold in Silithus wants you to bring her 1 Abyssal Scepter. You must also be Honored with the Cenarion Circle.";
      ["repgain"] = {
         [609] = 200;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Une humble offrande";
      ["name_cn"] = "?卑的??";
      ["reward"] = {
         [1] = 22725;
      };
      ["name_de"] = "Eine bescheidene Darbringung";
      ["faction"] = "Horde";
      ["name"] = "A Humble Offering";
      ["level"] = 60;
      ["name_es"] = "Una humilde ofrenda";
      ["req"] = 58;
   };
   [4641] = {
      ["name_ru"] = "Твое место в мире";
      ["type"] = "Solo";
      ["name_fr"] = "Votre place en ce monde";
      ["repgain"] = {
         [530] = 75;
         [76] = 75;
      };
      ["name_cn"] = "起点";
      ["name_de"] = "Euer Platz in der Welt";
      ["objective"] = "Speak with Gornek. You recall Kaltunk marking your map with his location and mentioning that Gornek resided in the Den, a building to the west. \
\
";
      ["next"] = 788;
      ["name"] = "Your Place In The World";
      ["sort"] = "Valley of Trials";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 1;
      ["name_es"] = "Tu lugar en el mundo";
      ["req"] = 1;
   };
   [4021] = {
      ["name_ru"] = "Контратака!";
      ["type"] = "Group";
      ["name_fr"] = "La contre-attaque?!";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Gegenangriff!";
      ["name_cn"] = "人?无双！";
      ["name"] = "Counterattack!";
      ["objective"] = "Bring a Piece of Krom'zar's Banner to Regthar Deathgate, west of the Crossroads.";
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 852;
      ["prequests"] = {
         [1] = 852;
      };
      ["level"] = 20;
      ["name_es"] = "!Contraataca!";
      ["req"] = 11;
   };
   [1196] = {
      ["name_ru"] = "Священное пламя";
      ["objective"] = "Deliver the Filled Etched Phial to Rau Cliffrunner at the Freewind Post.";
      ["name_cn"] = "神?之火";
      ["sort"] = "Thunder Bluff";
      ["level"] = 29;
      ["type"] = "Solo";
      ["name_fr"] = "La flamme sacree";
      ["next"] = 1197;
      ["name_de"] = "Die heilige Flamme";
      ["repgain"] = {
         [81] = 25;
      };
      ["faction"] = "Horde";
      ["name"] = "The Sacred Flame";
      ["prev"] = 1195;
      ["prequests"] = {
         [1] = 1195;
      };
      ["series"] = 2;
      ["name_es"] = "La llama sacra";
      ["req"] = 20;
   };
   [6543] = {
      ["name_ru"] = "Отчет Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "Open the Bundle of Reports.  Take the Warsong Reports to the Warsong Scout, Warsong Runner, and Warsong Outrider. Bring back the updates they give you to Kadrak at the northern watch tower in the barrens.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_fr"] = "Les rapports Chanteguerre";
      ["sort"] = "The Barrens";
      ["name_cn"] = "?歌?告";
      ["name_de"] = "Die Berichte des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "The Warsong Reports";
      ["level"] = 19;
      ["name_es"] = "Los informes Grito de Guerra";
      ["req"] = 17;
   };
   [8150] = {
      ["name_ru"] = "Почести герою";
      ["type"] = "Solo";
      ["objective"] = "Travel to Grom's Monument in the Demon Fall Canyon of Ashenvale and use Grom's Tribute at the base of the monument.  Return to Javnir Nashak outside Orgrimmar before the Harvest Festival is over.";
      ["repgain"] = {
         [0] = 68;
         [530] = 250;
         [76] = 250;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "En l'honneur d'un heros";
      ["name_cn"] = "??英雄";
      ["reward"] = {
         [1] = 20010;
      };
      ["name_de"] = "Die Ehrung eines Helden";
      ["faction"] = "Horde";
      ["name"] = "Honoring a Hero";
      ["level"] = 60;
      ["name_es"] = "En honor a un heroe";
      ["req"] = 30;
   };
   [2361] = {
      ["name_ru"] = "Восстановление ожерелья";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 500;
      };
      ["name_de"] = "Restaurierung der Halskette";
      ["name_fr"] = "Reparer le Collier";
      ["name_cn"] = "修???";
      ["faction"] = "Alliance";
      ["name"] = "Restoring the Necklace";
      ["reward"] = {
         [1] = 7673;
      };
      ["sort"] = "Uldaman";
      ["prev"] = 2204;
      ["prequests"] = {
         [1] = 2204;
      };
      ["level"] = 44;
      ["name_es"] = "Restaurar el collar";
      ["req"] = 37;
   };
   [4737] = {
      ["name_ru"] = "Поиски Менары Расщепительницы Бездны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1796;
      ["sort"] = "Warlock";
      ["name_cn"] = "?找梅?拉・沃?德";
      ["name_fr"] = "A la recherche de Menara Taillevide";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Auf der Suche nach Menara Leerbringer";
      ["faction"] = "Alliance";
      ["name"] = "In Search of Menara Voidrender";
      ["level"] = 31;
      ["name_es"] = "Buscando a Menara Nadiz";
      ["req"] = 31;
   };
   [4561] = {
      ["name_ru"] = "Образцы на пробу из кратера Ун'Горо";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Undercity";
      ["name_fr"] = "Test pour impuretes, le Cratere d'Un'Goro";
      ["name_cn"] = "???? - 安戈洛?形山";
      ["reward"] = {
         [1] = 15102;
      };
      ["name_de"] = "Test auf Unreinheiten - Krater von Un'Goro";
      ["faction"] = "Horde";
      ["name"] = "Testing for Impurities - Un'Goro Crater";
      ["level"] = 52;
      ["name_es"] = "Pruebas de impureza: Crater de Un'Goro";
      ["req"] = 48;
   };
   [4769] = {
      ["name_ru"] = "Вивиан Лягроб и табличка Темного Камня";
      ["type"] = "Raid";
      ["objective"] = "Speak with Shadowmage Vivian Lagrave.";
      ["next"] = 4768;
      ["name_fr"] = "Vivian Lagrave et la tablette de Sombrepierre";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "薇薇安・拉格雷和黑暗石板";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Vivian Lagrave und die Dunkelsteinschrifttafel";
      ["faction"] = "Horde";
      ["name"] = "Vivian Lagrave and the Darkstone Tablet";
      ["level"] = 60;
      ["name_es"] = "Vivian Lagrave y la tablilla de Rocanegra";
      ["req"] = 57;
   };
   [4785] = {
      ["name_ru"] = "Нить из чистого золота";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Feiner Goldfaden";
      ["name_fr"] = "Fil d'or fin";
      ["name"] = "Fine Gold Thread";
      ["name_cn"] = "??金?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 12293;
      };
      ["sort"] = "Warlock";
      ["prev"] = 4783;
      ["prequests"] = {
         [1] = 4783;
      };
      ["level"] = 37;
      ["name_es"] = "Hilo de oro refinado";
      ["req"] = 31;
   };
   [4801] = {
      ["name_ru"] = "Э'ко ледопардов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Frostsabler";
      ["name_fr"] = "L'E'ko des sabres-de-givre";
      ["name_cn"] = "霜刃魂精";
      ["name"] = "Frostsaber E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12450;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko de sable de hielo";
      ["req"] = 55;
   };
   [2623] = {
      ["name_ru"] = "Болотный говорун";
      ["type"] = "Solo";
      ["name_fr"] = "Le Parleur des marecages";
      ["name_de"] = "Der Sumpfredner";
      ["objective"] = "Retrieve the Warchief's Orders and return them to the Fallen Hero of the Horde.";
      ["name_cn"] = "沼?空?者";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "The Swamp Talker";
      ["followup"] = 2801;
      ["prev"] = 2622;
      ["prequests"] = {
         [1] = 2622;
      };
      ["level"] = 55;
      ["name_es"] = "La voz del pantano";
      ["req"] = 45;
   };
   [9664] = {
      ["name_ru"] = "Новые форпосты";
      ["type"] = "PvP";
      ["objective"] = "Capture Crown Guard Tower, Eastwall Tower, Northpass Tower and Plaguewood Tower in the Eastern Plaguelands, then return to Emmisary Whitebeard at Light's Hope Chapel.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "建立新据点";
      ["name_fr"] = "Fonder de nouveaux avant-postes";
      ["name_de"] = "Mehr Befestigungen";
      ["faction"] = "Alliance";
      ["name"] = "Establishing New Outposts";
      ["level"] = 60;
      ["name_es"] = "Nuevas avanzadas";
      ["req"] = 55;
   };
   [5901] = {
      ["name_ru"] = "Чума на вашу лесопилку!";
      ["type"] = "Solo";
      ["objective"] = "Use the Empty Termite Jar on the Termite Mounds in Eastern Plaguelands. After you've gathered 100 Plagueland Termites, return to Mickey Levine at the Bulwark in Tirisfal Glades.";
      ["next"] = 5902;
      ["name_fr"] = "Une Plaie sur la Croisade";
      ["sort"] = "Tirisfal Glades";
      ["name_cn"] = "瘟疫与?";
      ["series"] = 1;
      ["name_de"] = "Eine Plage komme uber Euch";
      ["faction"] = "Horde";
      ["name"] = "A Plague Upon Thee";
      ["level"] = 55;
      ["name_es"] = "Una Peste en la Cruzada";
      ["req"] = 48;
   };
   [4865] = {
      ["name_ru"] = "Змеиная дикость";
      ["type"] = "Solo";
      ["name_fr"] = "Serpent sauvage";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Wilde Schlange";
      ["name"] = "Serpent Wild";
      ["name_cn"] = "狂?之蛇";
      ["objective"] = "Report your findings to Motega Firemane.";
      ["next"] = 5062;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 4821;
      ["prequests"] = {
         [1] = 4821;
      };
      ["level"] = 26;
      ["name_es"] = "Venganza";
      ["req"] = 24;
   };
   [4881] = {
      ["name_ru"] = "Убийственный заговор";
      ["type"] = "Solo";
      ["objective"] = "Warn Kanati Greycloud at Whitereach Post of the plot to kill him.";
      ["next"] = 4966;
      ["name_fr"] = "Complot d'assassinat";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "暗???";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Auftragsmordplan";
      ["faction"] = "Horde";
      ["name"] = "Assassination Plot";
      ["level"] = 28;
      ["name_es"] = "Complot de asesinato";
      ["req"] = 23;
   };
   [5802] = {
      ["name_ru"] = "Кузня Пламенного хребта";
      ["type"] = "Solo";
      ["name_fr"] = "Forgee dans la Fournaise";
      ["next"] = 5804;
      ["name_de"] = "Feuersaulen geschmiedet";
      ["name_cn"] = "火羽山";
      ["objective"] = "Take the Skeleton Key Mold and 2 Thorium Bars to the top of Fire Plume Ridge in Un'Goro Crater.  Use the Skeleton Key Mold by the lava lake to forge the Unfinished Skeleton Key.$B$BBring the Unfinished Skeleton Key to Apothecary Dithers at the Bulwark, Western Plaguelands.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Fire Plume Forged";
      ["prev"] = 5514;
      ["prequests"] = {
         [1] = 5514;
      };
      ["level"] = 57;
      ["name_es"] = "La forja del Penacho en Llamas";
      ["req"] = 55;
   };
   [6083] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Surf Crawler. Practice your skills, then return the Taming Rod to Thotar at Razor Hill.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6082;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6062;
      ["prequests"] = {
         [1] = 6062;
      };
      ["series"] = 2;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [1117] = {
      ["name_ru"] = "Сплетни для Крейвела";
      ["type"] = "Solo";
      ["name_fr"] = "Des rumeurs pour Kravel";
      ["name_de"] = "Geruchte fur Kravel";
      ["name_cn"] = "地精的?言";
      ["objective"] = "Bring the Goblin Rumors to Kravel Koalbeard in the Shimmering Flats.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Rumors for Kravel";
      ["prev"] = 1116;
      ["prequests"] = {
         [1] = 1116;
      };
      ["level"] = 36;
      ["name_es"] = "Rumores para Kravel";
      ["req"] = 30;
   };
   [9154] = {
      ["name_ru"] = "Часовня Последней Надежды";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Call to Arms Announcement to the Keeper of the Rolls at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?光之愿礼拜堂";
      ["name_de"] = "Kapelle des Hoffnungsvollen Lichts";
      ["faction"] = "Horde";
      ["name"] = "Light's Hope Chapel";
      ["level"] = 0;
      ["name_es"] = "Capilla de la Esperanza de la Luz";
      ["req"] = 50;
   };
   [4961] = {
      ["name_ru"] = "Очищение шара Орахила";
      ["objective"] = "Kill the Demon of the Orb, then speak with Tabetha.";
      ["name_cn"] = "奥拉赫宝珠的?化";
      ["sort"] = "Warlock";
      ["level"] = 40;
      ["type"] = "Group";
      ["name_fr"] = "La purification de l'Orbe d'Orahil";
      ["next"] = 4976;
      ["name_de"] = "Die Sauberung der Kugel von Orahil";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 12642;
      };
      ["name"] = "Cleansing of the Orb of Orahil";
      ["prev"] = 1799;
      ["prequests"] = {
         [1] = 1799;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La purificacion del orbe de Orahil";
      ["req"] = 35;
   };
   [1183] = {
      ["name_ru"] = "Гоблинская поддержка";
      ["type"] = "Solo";
      ["name_fr"] = "Mecenat gobelin";
      ["next"] = 1186;
      ["name_de"] = "Goblinsponsoring";
      ["name"] = "Goblin Sponsorship";
      ["name_cn"] = "地精?助商";
      ["objective"] = "Deliver the Fuel Regulator Blueprints to Pozzik on the Shimmering Flats.";
      ["series"] = 5;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1182;
      ["prequests"] = {
         [1] = 1182;
      };
      ["level"] = 37;
      ["name_es"] = "Patrocinio goblin";
      ["req"] = 29;
   };
   [5713] = {
      ["name_ru"] = "Каждый выстрел ? в цель";
      ["type"] = "Solo";
      ["objective"] = "Protect Sentinel Aynasha, then speak with Onaeya at Maestra's Post in Ashenvale.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_fr"] = "Un tir. Un tue.";
      ["sort"] = "Darkshore";
      ["name_cn"] = "一?必?";
      ["name_de"] = "Ein Schuss, ein Treffer";
      ["faction"] = "Alliance";
      ["name"] = "One Shot. One Kill.";
      ["level"] = 15;
      ["name_es"] = "Un disparo, una baja";
      ["req"] = 10;
   };
   [2523] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的?歌花";
      ["name_fr"] = "La fleur-de-chant corrompue";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [3523] = {
      ["name_ru"] = "Плеть в холмах";
      ["type"] = "Dungeon";
      ["objective"] = "If you agree to aid Belnistrasz, speak with him again and hand the Oathstone he gave you back to him.";
      ["next"] = 3525;
      ["sort"] = "Razorfen Downs";
      ["name_cn"] = "剃刀高地的亡?天?";
      ["name_fr"] = "Le Fleau des Souilles";
      ["name_de"] = "Geisel der Hugel";
      ["faction"] = "Horde";
      ["name"] = "Scourge of the Downs";
      ["level"] = 37;
      ["name_es"] = "La plaga de la Zahurda";
      ["req"] = 32;
   };
   [2521] = {
      ["name_ru"] = "Служба для Кум'иша";
      ["type"] = "Solo";
      ["objective"] = "In your journeys throughout the Blasted Lands, should you ever come across a Flawless Draenethyst Sphere, take the item back to Kum'isha the Collector.$B$BBe warned, this gem is one of the most rare crystals in all of Azeroth. Any creature in these lands could be holding a Flawless Draenethyst Sphere.$B$BYou will be rewarded for each Flawless Draenethyst Sphere you have collected.";
      ["name_fr"] = "Au service de Kum'isha";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "??米沙效力";
      ["reward"] = {
         [1] = 10752;
      };
      ["name_de"] = "Ein Dienst fur Kum'isha";
      ["faction"] = "Horde";
      ["name"] = "To Serve Kum'isha";
      ["level"] = 55;
      ["name_es"] = "Al servicio de Kum'isha";
      ["req"] = 45;
   };
   [5057] = {
      ["name_ru"] = "Прежние свершения";
      ["type"] = "Solo";
      ["objective"] = "Bring Storm Shadowhoof's Marker to Melor Stonehoof in Thunder Bluff.";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Fruhere Abenteuer";
      ["reward"] = {
         [1] = 15704;
      };
      ["name_cn"] = "以往的努力";
      ["name_fr"] = "Essais passes";
      ["faction"] = "Horde";
      ["name"] = "Past Endeavors";
      ["sort"] = "Winterspring";
      ["prev"] = 5056;
      ["prequests"] = {
         [1] = 5056;
      };
      ["level"] = 60;
      ["name_es"] = "Esfuerzos del pasado";
      ["req"] = 53;
   };
   [6523] = {
      ["name_ru"] = "Защита Кайи";
      ["type"] = "Solo";
      ["objective"] = "Escort Kaya Flathoof to Camp Aparaje, and then return to Makaba Flathoof near the southeastern edge of Stonetalon.$B";
      ["next"] = 6401;
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "保??雅";
      ["name_fr"] = "Proteger Kaya";
      ["name_de"] = "Schutzt Kaya";
      ["faction"] = "Horde";
      ["name"] = "Protect Kaya";
      ["level"] = 18;
      ["name_es"] = "Protege a Kaya";
      ["req"] = 12;
   };
   [5089] = {
      ["name_ru"] = "Приказ генерала Драккисата";
      ["type"] = "Dungeon";
      ["objective"] = "Take General Drakkisath's Command to Marshal Maxwell in Burning Steppes.";
      ["next"] = 5102;
      ["name_fr"] = "Ordres du general Drakkisath";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "?基?斯将?的命令";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "General Drakkisaths Befehl";
      ["faction"] = "Alliance";
      ["name"] = "General Drakkisath's Command";
      ["level"] = 60;
      ["name_es"] = "Orden del general Drakkisath";
      ["req"] = 55;
   };
   [8523] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает бинтов из рунической ткани!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de bandages en etoffe runique !";
      ["name_de"] = "Die Allianz braucht mehr Runenstoffverbande!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21513;
      };
      ["name_cn"] = "?盟需要更多符文布??！";
      ["objective"] = "Bring 20 runecloth bandages to Keeper Moonshade at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Runecloth Bandages!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8522;
      ["prequests"] = {
         [1] = 8522;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas vendas de pano runico!";
      ["req"] = 1;
   };
   [2561] = {
      ["name_ru"] = "Друид-медведь";
      ["type"] = "Solo";
      ["objective"] = "Oben Rageclaw wants you to kill his soulless body, and then use the Voodoo Charm.";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Druide der Klaue";
      ["reward"] = {
         [1] = 9598;
         [2] = 18957;
      };
      ["name_cn"] = "利爪德?伊";
      ["name_fr"] = "Le druide de la Griffe";
      ["faction"] = "Alliance";
      ["name"] = "Druid of the Claw";
      ["sort"] = "Teldrassil";
      ["prev"] = 2541;
      ["prequests"] = {
         [1] = 2541;
      };
      ["level"] = 10;
      ["name_es"] = "El druida de la Zarpa";
      ["req"] = 3;
   };
   [8754] = {
      ["name_ru"] = "Путь победителя";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Pfad des Eroberers";
      ["name_fr"] = "La voie du Conquerant";
      ["name_cn"] = "征服者之路";
      ["name"] = "The Path of the Conqueror";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21203;
      };
      ["sort"] = "Tanaris";
      ["prev"] = 8753;
      ["prequests"] = {
         [1] = 8753;
      };
      ["level"] = 60;
      ["name_es"] = "El camino del conquistador";
      ["req"] = 60;
   };
   [5153] = {
      ["name_ru"] = "Странный историк";
      ["type"] = "Group";
      ["name_fr"] = "Un etrange historien";
      ["next"] = 5154;
      ["name_de"] = "Ein seltsamer Historiker";
      ["name_cn"] = "古怪的?史学家";
      ["objective"] = "Bring Joseph's Wedding Ring to Chromie.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "A Strange Historian";
      ["prev"] = 5152;
      ["prequests"] = {
         [1] = 5152;
      };
      ["level"] = 56;
      ["name_es"] = "Una extrana historiadora";
      ["req"] = 50;
   };
   [2585] = {
      ["name_ru"] = "Решительный удар";
      ["type"] = "Solo";
      ["objective"] = "Bring three Scorpok Pincers, two Vulture Gizzards, and one Blasted Boar Lung to Bloodmage Drazial.$B";
      ["name_fr"] = "Le coup decisif";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "决定性的打?";
      ["reward"] = {
         [1] = 8412;
      };
      ["name_de"] = "Der Entscheidungsschlag";
      ["faction"] = "Horde";
      ["name"] = "The Decisive Striker";
      ["level"] = 50;
      ["name_es"] = "El golpe decisivo";
      ["req"] = 45;
   };
   [6385] = {
      ["name_ru"] = "Укротитель ветрокрылов Дорас";
      ["type"] = "Solo";
      ["name_fr"] = "Doras, le maitre des coursiers du vent";
      ["repgain"] = {
         [530] = 25;
         [76] = 25;
      };
      ["name_de"] = "Doras der Windreitermeister";
      ["objective"] = "Bring Gryshka's Letter to Doras in Orgrimmar.";
      ["name_cn"] = "双足??管理?多拉斯";
      ["next"] = 6386;
      ["sort"] = "The Barrens";
      ["name"] = "Doras the Wind Rider Master";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["prev"] = 6384;
      ["prequests"] = {
         [1] = 6384;
      };
      ["level"] = 10;
      ["name_es"] = "Doras, maestro de jinetes del viento";
      ["req"] = 10;
   };
   [2601] = {
      ["name_ru"] = "Укус василиска";
      ["type"] = "Solo";
      ["objective"] = "Bring ten Basilisk Brains and two Vulture Gizzards to Bloodmage Lynnore.$B";
      ["name_fr"] = "La morsure du basilic";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "石化蜥蜴的大?";
      ["reward"] = {
         [1] = 8423;
      };
      ["name_de"] = "Der Biss des Basilisken";
      ["faction"] = "Horde";
      ["name"] = "The Basilisk's Bite";
      ["level"] = 50;
      ["name_es"] = "El bocado de basilisco";
      ["req"] = 45;
   };
   [5217] = {
      ["name_ru"] = "Возвращение в Лагерь Промозглого Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au camp du Noroit";
      ["repgain"] = {
         [469] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Zugwindlager";
      ["name"] = "Return to Chillwind Camp";
      ["name_cn"] = "返回冰??";
      ["objective"] = "Bring the Filled Felstone Field Bottle to High Priestess MacDonnell at Chillwind Camp, Western Plaguelands.";
      ["next"] = 5219;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5216;
      ["prequests"] = {
         [1] = 5216;
      };
      ["level"] = 53;
      ["name_es"] = "Regresa al Campamento del Orvallo";
      ["req"] = 50;
   };
   [5233] = {
      ["name_ru"] = "Цель: Удел Страданий";
      ["objective"] = "Go to the Writhing Haunt in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Writhing Haunt Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：?哭鬼屋";
      ["sort"] = "Western Plaguelands";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: le Repaire putride";
      ["next"] = 5234;
      ["name_de"] = "Ziel: Das Trostlose Feld";
      ["repgain"] = {
         [67] = 250;
         [529] = 250;
      };
      ["followup"] = 5234;
      ["name"] = "Target: Writhing Haunt";
      ["prev"] = 5232;
      ["prequests"] = {
         [1] = 5232;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Objetivo: El Tormento";
      ["req"] = 50;
   };
   [5249] = {
      ["name_ru"] = "В Зимние Ключи!";
      ["type"] = "Solo";
      ["objective"] = "Find Starfall Village in Winterspring and speak with Wynd Nightchaser.";
      ["next"] = 5244;
      ["name_fr"] = "Au Berceau-de-l'Hiver";
      ["sort"] = "Felwood";
      ["name_cn"] = "前往冬泉谷！";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Nach Winterquell!";
      ["faction"] = "Alliance";
      ["name"] = "To Winterspring!";
      ["level"] = 56;
      ["name_es"] = "!A la Cuna del Invierno!";
      ["req"] = 53;
   };
   [5265] = {
      ["name_ru"] = "Серебряный Оплот";
      ["type"] = "Group";
      ["objective"] = "Open the Argent Hold and claim your reward.";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Der Argentumtresor";
      ["reward"] = {
         [1] = 13246;
         [2] = 13243;
         [3] = 13249;
      };
      ["name_cn"] = "?色黎明宝箱";
      ["name_fr"] = "Siege de l’Aube d'argent";
      ["faction"] = "Horde";
      ["name"] = "The Argent Hold";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 5264;
      ["prequests"] = {
         [1] = 5264;
      };
      ["level"] = 60;
      ["name_es"] = "El Bastion Argenta";
      ["req"] = 55;
   };
   [2641] = {
      ["name_ru"] = "Маленький секрет Поливалки";
      ["type"] = "Solo";
      ["name_fr"] = "L'ingredient secret de Saupoudr";
      ["repgain"] = {
         [0] = 369;
      };
      ["name_de"] = "Sprinkels Geheimzutat";
      ["name_cn"] = "斯普琳科的秘密佐料";
      ["name"] = "Sprinkle's Secret Ingredient";
      ["objective"] = " and... WOW! It tastes great!$B$BWhat is it";
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 2606;
      ["prequests"] = {
         [1] = 2606;
      };
      ["level"] = 49;
      ["name_es"] = "El ingrediente secreto de Roxio";
      ["req"] = 44;
   };
   [8385] = {
      ["name_ru"] = "В едином порыве";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Mark of Honor, 3 Arathi Basin Mark of Honor and 3 Warsong Gulch Mark of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
         [730] = 150;
         [509] = 100;
      };
      ["name_de"] = "Gemeinsames Bestreben";
      ["name_cn"] = "共同的努力";
      ["name_fr"] = "Des efforts concertes";
      ["name"] = "Concerted Efforts";
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 8371;
      ["prequests"] = {
         [1] = 8371;
      };
      ["level"] = 60;
      ["name_es"] = "Esfuerzos concertados";
      ["req"] = 51;
   };
   [6584] = {
      ["name_ru"] = "Черепа: Хроналис";
      ["type"] = "Raid";
      ["name_fr"] = "L'epreuve des cranes, Chronalis";
      ["name_de"] = "Die Prufung der Schadel, Chronalis";
      ["objective"] = "Guarding the Caverns of Time in the Tanaris Desert is Chronalis, child of Nozdormu. Destroy him and return his skull to Emberstrife.";
      ["name_cn"] = "?骨??，克??里斯";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "The Test of Skulls, Chronalis";
      ["followup"] = 6585;
      ["prev"] = 6570;
      ["prequests"] = {
         [1] = 6570;
      };
      ["level"] = 60;
      ["name_es"] = "La prueba de los craneos, Chronalis";
      ["req"] = 55;
   };
   [8764] = {
      ["name_ru"] = "Изменение пути ? уже не защитник";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Tanaris";
      ["name_fr"] = "Changer de voie - adieu au Protecteur";
      ["name_cn"] = "??保?者之路";
      ["reward"] = {
         [1] = 21210;
         [2] = 21205;
      };
      ["name_de"] = "Den Pfad wechseln - Kein Beschutzer mehr";
      ["faction"] = "Horde";
      ["name"] = "The Changing of Paths - Protector No More";
      ["level"] = 60;
      ["name_es"] = "Cambio de ruta: protector, nunca mas";
      ["req"] = 60;
   };
   [1650] = {
      ["name_ru"] = "Фолиант Отваги";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["sort"] = "Paladin";
      ["objective"] = "Find Daphne Stilwell in Westfall.";
      ["name_cn"] = "勇气之?";
      ["series"] = 2;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Valor";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 1649;
      ["prequests"] = {
         [1] = 1649;
      };
      ["level"] = 23;
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [2681] = {
      ["name_ru"] = "Камни, что связывают нас";
      ["type"] = "Solo";
      ["name_fr"] = "Les pierres qui nous lient";
      ["next"] = 2702;
      ["name_de"] = "Die Steine, die uns binden";
      ["name_cn"] = "禁?我?的石?";
      ["objective"] = "Free nine Servants of Razelikh, three Servants of Sevine, three Servants of Allistarj, and three Servants of Grol. Return to the Fallen Hero when your task is complete. You must remain within close proximity of the stones or the process will fail.";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "The Stones That Bind Us";
      ["prev"] = 2801;
      ["prequests"] = {
         [1] = 2801;
      };
      ["level"] = 57;
      ["name_es"] = "Las piedras que nos vinculan";
      ["req"] = 45;
   };
   [1472] = {
      ["name_ru"] = "Пожиратель Душ";
      ["type"] = "Solo";
      ["objective"] = "Speak with Godrick Farsan in the Temple of the Damned.";
      ["next"] = 1476;
      ["sort"] = "Warlock";
      ["name_cn"] = "噬魂者";
      ["name_fr"] = "La devoreuse d'ames";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Verschlinger der Seelen";
      ["faction"] = "Horde";
      ["name"] = "Devourer of Souls";
      ["level"] = 20;
      ["name_es"] = "Devoradora de almas";
      ["req"] = 20;
   };
   [1846] = {
      ["name_ru"] = "Берцовые кости";
      ["type"] = "Solo";
      ["name_fr"] = "Les tibias de Gueule-de-dragon";
      ["name_de"] = "Schienbeinknochen der Drachenmalorcs";
      ["objective"] = "Bring 8 Sturdy Dragonmaw Shinbones to Velora Nitely in the Undercity.";
      ["name_cn"] = "?喉?骨";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Dragonmaw Shinbones";
      ["prev"] = 1841;
      ["prequests"] = {
         [1] = 1841;
      };
      ["level"] = 30;
      ["name_es"] = "Tibias de Faucedraco";
      ["req"] = 20;
   };
   [1385] = {
      ["name_ru"] = "Политика силы";
      ["type"] = "Solo";
      ["objective"] = "Gain a Friendly reputation with the Magram, then speak with Warug.";
      ["next"] = 1386;
      ["name_fr"] = "Une violente politique";
      ["sort"] = "Desolace";
      ["name_cn"] = "野蛮外交";
      ["repgain"] = {
         [93] = 250;
      };
      ["name_de"] = "Brutale Politik";
      ["faction"] = "Alliance";
      ["name"] = "Brutal Politics";
      ["level"] = 35;
      ["name_es"] = "Politicas brutales";
      ["req"] = 30;
   };
   [4385] = {
      ["name_ru"] = "Обжигающий кристалл";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallsprengladung";
      ["name_fr"] = "Cristal d'explosion";
      ["name_cn"] = "爆炸水晶";
      ["name"] = "Crystal Charge";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11566;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "Carga de cristal";
      ["req"] = 47;
   };
   [2721] = {
      ["name_ru"] = "Кирит";
      ["type"] = "Group";
      ["name_fr"] = "Kirith";
      ["next"] = 2743;
      ["name_de"] = "Kirith";
      ["name_cn"] = "基利斯";
      ["objective"] = "Find out what became of Lieutenant Kirith.";
      ["sort"] = "Blasted Lands";
      ["faction"] = "Horde";
      ["name"] = "Kirith";
      ["prev"] = 2701;
      ["prequests"] = {
         [1] = 2701;
      };
      ["level"] = 58;
      ["name_es"] = "Kirith";
      ["req"] = 45;
   };
   [2280] = {
      ["name_ru"] = "Платиновые диски";
      ["objective"] = "Take the miniature version of the Discs of Norgannon to the one of the sages in Thunder Bluff.";
      ["name_cn"] = "白金??";
      ["sort"] = "Uldaman";
      ["level"] = 47;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les Disques de platine";
      ["next"] = 2440;
      ["name_de"] = "Die Platinscheiben";
      ["repgain"] = {
         [81] = 350;
      };
      ["followup"] = 2439;
      ["name"] = "The Platinum Discs";
      ["prev"] = 2278;
      ["prequests"] = {
         [1] = 2278;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los discos de platino";
      ["req"] = 40;
   };
   [6569] = {
      ["name_ru"] = "Иллюзии ока";
      ["type"] = "Raid";
      ["name_fr"] = "Illusions d'Occulus";
      ["next"] = 6570;
      ["name_de"] = "Oculus-Illusionen";
      ["name_cn"] = "黑?幻象";
      ["objective"] = "Travel to Blackrock Spire and collect 20 Black Dragonspawn Eyes. Return to Myranda the Hag when the task is complete.";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "Oculus Illusions";
      ["prev"] = 6568;
      ["prequests"] = {
         [1] = 6568;
      };
      ["level"] = 60;
      ["name_es"] = "Ilusiones oculares";
      ["req"] = 55;
   };
   [2745] = {
      ["name_ru"] = "Проникновение в крепость";
      ["type"] = "Solo";
      ["name_fr"] = "En infiltrant le chateau";
      ["next"] = 2746;
      ["name_de"] = "Eindringen ins Schloss";
      ["name_cn"] = "潜入城堡";
      ["objective"] = "Speak to Tyrion in Stormwind Castle.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "Infiltrating the Castle";
      ["prev"] = 350;
      ["prequests"] = {
         [1] = 350;
      };
      ["level"] = 31;
      ["name_es"] = "Infiltrate en el castillo";
      ["req"] = 16;
   };
   [5505] = {
      ["name_ru"] = "Ключ от Некроситета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Der Schlussel zur Scholomance";
      ["name_fr"] = "La cle de Scholomance";
      ["name_cn"] = "通?学院的?匙";
      ["name"] = "The Key to Scholomance";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 13704;
      };
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5803;
      ["prequests"] = {
         [1] = 5803;
      };
      ["level"] = 60;
      ["name_es"] = "La llave de Scholomance";
      ["req"] = 55;
   };
   [2761] = {
      ["name_ru"] = "Плавим, не плавим, плавим, не плавим...";
      ["type"] = "Solo";
      ["name_fr"] = "Ca fond, ca ne fond pas";
      ["name_de"] = "Hier verhutten, da verhutten";
      ["objective"] = "Bring forty Mithril Bars and forty Iron Bars to Galvan the Ancient in Stranglethorn.";
      ["followup"] = 2765;
      ["name_cn"] = "?匠必修?";
      ["faction"] = "Horde";
      ["name"] = "Smelt On, Smelt Off";
      ["reward"] = {
         [1] = 7983;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "Funde o no funde";
      ["req"] = 40;
   };
   [2769] = {
      ["name_ru"] = "Братья Медноштиф";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Wizzle Brassbolts in the Shimmering Flats.";
      ["next"] = 2770;
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "?栓兄弟";
      ["name_fr"] = "Les freres Zeboulon";
      ["name_de"] = "Die Bruder Kupferbolz";
      ["faction"] = "Alliance";
      ["name"] = "The Brassbolts Brothers";
      ["level"] = 46;
      ["name_es"] = "Los hermanos Pernolaton";
      ["req"] = 40;
   };
   [3802] = {
      ["name_ru"] = "Наследие Черного Железа";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Fineous Darkvire and recover the great hammer, Ironfel. Take Ironfel to the Shrine of Thaurissan and place it on the statue of Franclorn Forgewright.";
      ["name_de"] = "Dunkeleisenerbe";
      ["name_fr"] = "Heritage Sombrefer";
      ["reward"] = {
         [1] = 11000;
      };
      ["name_cn"] = "黑?的??";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "Dark Iron Legacy";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 3801;
      ["prequests"] = {
         [1] = 3801;
      };
      ["level"] = 52;
      ["name_es"] = "El legado de los Hierro Negro";
      ["req"] = 48;
   };
   [7810] = {
      ["name_ru"] = "Повелитель арены";
      ["type"] = "PvP";
      ["objective"] = "Speak with Short John Mithril in the Stranglethorn Arena.";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "?技?高手";
      ["name_fr"] = "Le maitre de l'arene";
      ["followup"] = 7838;
      ["name_de"] = "Meister der Arena";
      ["faction"] = "Horde";
      ["name"] = "Arena Master";
      ["level"] = 55;
      ["name_es"] = "El maestro de la arena";
      ["req"] = 1;
   };
   [2946] = {
      ["name_ru"] = "Посмотрим, что будет дальше";
      ["type"] = "Group";
      ["name_fr"] = "Questions sans reponses";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Mal sehen, was passiert...";
      ["followup"] = 2954;
      ["name_cn"] = "拭目以待";
      ["objective"] = "Bring the miniature platinum discs to the gates of Uldum in Tanaris and look for clues as to the connection between the two.";
      ["faction"] = "Alliance";
      ["name"] = "Seeing What Happens";
      ["sort"] = "Ironforge";
      ["prev"] = 2963;
      ["prequests"] = {
         [1] = 2963;
      };
      ["level"] = 50;
      ["name_es"] = "A ver que pasa";
      ["req"] = 45;
   };
   [2801] = {
      ["name_ru"] = "Печальная история";
      ["type"] = "Solo";
      ["objective"] = "Listen to the Fallen Hero of the Horde tell his story.";
      ["next"] = 2681;
      ["name_fr"] = "Une histoire de chagrin";
      ["sort"] = "Blasted Lands";
      ["name_cn"] = "悲?的故事";
      ["name"] = "A Tale of Sorrow";
      ["name_de"] = "Eine Geschichte voller Leid";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2783;
         [2] = 2623;
      };
      ["level"] = 57;
      ["name_es"] = "Una historia triste";
      ["req"] = 45;
   };
   [9006] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Helm of Valor and Breastplate of Valor.";
      ["reward"] = {
         [1] = 21999;
         [2] = 21997;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [5633] = {
      ["name_ru"] = "Возвращение домой";
      ["type"] = "Solo";
      ["objective"] = "Speak to Priestess Alathea in Darnassus.";
      ["next"] = 5627;
      ["name_de"] = "Heimkehr";
      ["sort"] = "Priest";
      ["name_cn"] = "回家*";
      ["name_fr"] = "Retour a la maison";
      ["classes"] = {
         [1] = "Priest";
      };
      ["followup"] = 5627;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Returning Home";
      ["level"] = 10;
      ["name_es"] = "La vuelta a casa";
      ["req"] = 10;
   };
   [5649] = {
      ["name_ru"] = "В пользу духовности";
      ["type"] = "Solo";
      ["objective"] = "Speak to Tai'jin in Durotar.";
      ["next"] = 5648;
      ["name_de"] = "Der Spiritualitat geneigt";
      ["sort"] = "Priest";
      ["name_cn"] = "部族的??";
      ["name_fr"] = "Au service de la spiritualite";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "In Favor of Spirituality";
      ["level"] = 4;
      ["name_es"] = "Al servicio de la espiritualidad";
      ["req"] = 5;
   };
   [4485] = {
      ["name_ru"] = "Фолиант благородства";
      ["type"] = "Solo";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_de"] = "Der Foliant des Adels";
      ["sort"] = "Paladin";
      ["name_cn"] = "高?之?";
      ["name_fr"] = "Le Tome de noblesse";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "The Tome of Nobility";
      ["level"] = 40;
      ["name_es"] = "Escrito sobre nobleza";
      ["req"] = 40;
   };
   [2841] = {
      ["name_ru"] = "Техновойны";
      ["type"] = "Dungeon";
      ["objective"] = "Retrieve the Rig Blueprints and Thermaplugg's Safe Combination from Gnomeregan and bring them to Nogg in Orgrimmar.$B";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Gnomeregan";
      ["name_fr"] = "Guerre des plates-formes";
      ["name_cn"] = "??之?";
      ["reward"] = {
         [1] = 9623;
         [2] = 9624;
         [3] = 9625;
      };
      ["name_de"] = "Maschinenkriege";
      ["faction"] = "Horde";
      ["name"] = "Rig Wars";
      ["level"] = 35;
      ["name_es"] = "Las guerras de la plataforma";
      ["req"] = 25;
   };
   [2849] = {
      ["name_ru"] = "Дикарский кожаный жилет";
      ["type"] = "Solo";
      ["name_fr"] = "Le gilet en cuir fauve";
      ["name_de"] = "Wildlederweste";
      ["objective"] = "Bring 2 Turtle Scale Breastplates, 2 Turtle Scale Gloves, and a Wildvine to Pratt McGrubben in Feathermoon Stronghold.";
      ["followup"] = 2853;
      ["name_cn"] = "蛮皮外衣";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Vest";
      ["reward"] = {
         [1] = 8404;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 45;
      ["name_es"] = "El Jubon de cuero salvaje";
      ["req"] = 30;
   };
   [2857] = {
      ["name_ru"] = "Дикарский кожаный шлем";
      ["type"] = "Solo";
      ["name_fr"] = "Le casque en cuir fauve";
      ["name_de"] = "Wildlederhelm";
      ["objective"] = "Bring 2 Nightscape Tunics, 2 Nightscape Headbands, and a Wildvine to Jangdor Swiftstrider in Camp Mojache.";
      ["followup"] = 2860;
      ["name_cn"] = "蛮皮??";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Helmet";
      ["reward"] = {
         [1] = 8405;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2854;
      ["prequests"] = {
         [1] = 2854;
      };
      ["level"] = 45;
      ["name_es"] = "Casco de cuero salvaje";
      ["req"] = 30;
   };
   [5729] = {
      ["name_ru"] = "Тайные враги";
      ["type"] = "Solo";
      ["name_fr"] = "Ennemis caches";
      ["next"] = 5730;
      ["name_de"] = "Verborgene Feinde";
      ["name"] = "Hidden Enemies";
      ["name_cn"] = "?藏的?人";
      ["objective"] = "Speak to Neeru Fireblade in Orgrimmar.";
      ["series"] = 4;
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 5728;
      ["prequests"] = {
         [1] = 5728;
      };
      ["level"] = 15;
      ["name_es"] = "Enemigos ocultos";
      ["req"] = 9;
   };
   [2873] = {
      ["name_ru"] = "Посылка Столи";
      ["type"] = "Solo";
      ["name_fr"] = "La cargaison de Stoley";
      ["next"] = 2874;
      ["name_de"] = "Stoleys Lieferung";
      ["name_cn"] = "斯杜雷的?物";
      ["objective"] = " to settle a bet";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Stoley's Shipment";
      ["prev"] = 2872;
      ["prequests"] = {
         [1] = 2872;
      };
      ["level"] = 45;
      ["name_es"] = "El envio de Stoley";
      ["req"] = 40;
   };
   [2881] = {
      ["name_ru"] = "Ожерелья троллей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [471] = 25;
      };
      ["name_de"] = "Kopfgeld fur Trollhalsketten";
      ["name_cn"] = "巨魔部族??";
      ["name_fr"] = "Chasse aux colliers trolls";
      ["name"] = "Troll Necklace Bounty";
      ["faction"] = "Alliance";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2880;
      ["prequests"] = {
         [1] = 2880;
      };
      ["level"] = 45;
      ["name_es"] = "Los collares de trols";
      ["req"] = 40;
   };
   [4604] = {
      ["name_ru"] = "Работа для Чистера";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Funkelmatastisch";
      ["name_fr"] = "Le Brille-o-Matic decape encore";
      ["name_cn"] = "再次使用超?清?器";
      ["name"] = "More Sparklematic Action";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 4606;
      ["prequests"] = {
         [1] = 4606;
      };
      ["level"] = 30;
      ["name_es"] = "El Destellamatic en accion";
      ["req"] = 25;
   };
   [8785] = {
      ["name_ru"] = "Амулеты для легиона Оргриммара";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Powerful Mojo, 6 Flasks of Big Mojo and 8 Oils of Immolation to Shadow Priestess Shai near Hive'Regal in Silithus.  You must also bring Logistics Task Briefing IV in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "La legion d'Orgrimmar a besoin de mojo !";
      ["name_cn"] = "奥格瑞???需要魔精！";
      ["reward"] = {
         [1] = 20800;
         [2] = 21386;
      };
      ["name_de"] = "Die Orgrimmarlegion braucht Mojo!";
      ["faction"] = "Horde";
      ["name"] = "The Orgrimmar Legion Needs Mojo!";
      ["level"] = 60;
      ["name_es"] = "!La Legion de Orgrimmar necesita mojo!";
      ["req"] = 60;
   };
   [2203] = {
      ["name_ru"] = "Пробежка по Бесплодным землям-2";
      ["type"] = "Group";
      ["name_fr"] = "Les reactifs des Terres ingrates II";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Reagenziensuche im Odland II";
      ["name_cn"] = "荒?之地的材料 II";
      ["name"] = "Badlands Reagent Run II";
      ["objective"] = "Use the empty thaumaturgy vessels on scorched guardian dragons found in the Badlands.  Once you have them filled, bring them to Jarkal Mossmeld in Kargath.";
      ["faction"] = "Horde";
      ["sort"] = "Badlands";
      ["prev"] = 2202;
      ["prequests"] = {
         [1] = 2202;
      };
      ["level"] = 44;
      ["name_es"] = "Componentes de Tierras Inhospitas II";
      ["req"] = 40;
   };
   [8787] = {
      ["name_ru"] = "Комплекты брони";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Rugged Armor Kits and 8 Heavy Armor Kits to Merok Longstride near Hive'Regal.  You must also bring Logistics Task Briefing VII in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Des renforts d'armure pour le champ de bataille";
      ["name_cn"] = "??上的?甲片";
      ["reward"] = {
         [1] = 20800;
         [2] = 21386;
      };
      ["name_de"] = "Rustungssets fur den Feldeinsatz";
      ["faction"] = "Horde";
      ["name"] = "Armor Kits for the Field";
      ["level"] = 60;
      ["name_es"] = "Refuerzos para armadura para el campo de batalla";
      ["req"] = 60;
   };
   [5841] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue?!";
      ["name_cn"] = "?迎!*";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Coldridge Valley Gift Voucher to Yori Crackhelm.";
      ["sort"] = "Coldridge Valley";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [2929] = {
      ["name_ru"] = "Великое предательство";
      ["type"] = "Dungeon";
      ["objective"] = "Venture to Gnomeregan and kill Mekgineer Thermaplugg. Return to High Tinker Mekkatorque when the task is complete.";
      ["repgain"] = {
         [54] = 250;
      };
      ["sort"] = "Gnomeregan";
      ["name_fr"] = "La grande trahison";
      ["name_cn"] = "大叛徒";
      ["reward"] = {
         [1] = 9623;
         [2] = 9624;
         [3] = 9625;
      };
      ["name_de"] = "Der grose Verrat";
      ["faction"] = "Alliance";
      ["name"] = "The Grand Betrayal";
      ["level"] = 35;
      ["name_es"] = "La gran traicion";
      ["req"] = 25;
   };
   [2937] = {
      ["name_ru"] = "Призыв Шадры";
      ["type"] = "Group";
      ["name_fr"] = "L'invocation de Shadra";
      ["repgain"] = {
         [68] = 500;
      };
      ["name_de"] = "Die Beschworung von Shadra";
      ["name_cn"] = "召?沙德拉";
      ["name"] = "Summoning Shadra";
      ["objective"] = "Defeat Shadra at the altar of Shadra'Alor, then bring her venom to Apothecary Lydon in Tarren Mill.";
      ["faction"] = "Horde";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2936;
      ["prequests"] = {
         [1] = 2936;
      };
      ["level"] = 55;
      ["name_es"] = "Invocar a Shadra";
      ["req"] = 40;
   };
   [2945] = {
      ["name_ru"] = "Кольцо, покрытое грязью";
      ["type"] = "Dungeon";
      ["objective"] = "Figure out a way to remove the grime from the Grime-Encrusted Ring.";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "?兮兮的戒指";
      ["name_fr"] = "Anneau sali";
      ["name_de"] = "Schmutzverkrusteter Ring";
      ["faction"] = "Horde";
      ["name"] = "Grime-Encrusted Ring";
      ["level"] = 34;
      ["name_es"] = "Un anillo sucio";
      ["req"] = 28;
   };
   [2953] = {
      ["name_ru"] = "Работа для Чистера";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Funkelmatastisch";
      ["name_fr"] = "Le Brille-o-Matic decape encore";
      ["name_cn"] = "再次使用超?清?器";
      ["name"] = "More Sparklematic Action";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 9363;
      };
      ["sort"] = "Gnomeregan";
      ["prev"] = 2952;
      ["prequests"] = {
         [1] = 2952;
      };
      ["level"] = 30;
      ["name_es"] = "El Destellamatic en accion";
      ["req"] = 25;
   };
   [5921] = {
      ["name_ru"] = "Лунная поляна";
      ["type"] = "Solo";
      ["objective"] = "Use the spell Teleport: Moonglade\" to travel to Moonglade.  When you arrive";
      ["next"] = 5929;
      ["name_de"] = "Mondlichtung";
      ["sort"] = "Druid";
      ["name_cn"] = "月光林地";
      ["name_fr"] = "Reflet-de-Lune";
      ["classes"] = {
         [1] = "Druid";
      };
      ["followup"] = 5929;
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Moonglade";
      ["level"] = 10;
      ["name_es"] = "Claro de la Luna";
      ["req"] = 10;
   };
   [2969] = {
      ["name_ru"] = "Свободу всем живым существам!";
      ["type"] = "Solo";
      ["objective"] = "Using the Bamboo Cage Key, free the Sprite Darters from the pen in the Grimtotem camp. At least 6 Sprite Darters and Kindal Moonweaver must survive.$B$BYou have 6 minutes before Kindal decides it is time to retreat and you fail the quest.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_fr"] = "Liberte pour toutes les creatures";
      ["sort"] = "Feralas";
      ["name_cn"] = "精??的自由";
      ["name_de"] = "Freiheit fur alle Kreaturen";
      ["faction"] = "Alliance";
      ["name"] = "Freedom for All Creatures";
      ["level"] = 47;
      ["name_es"] = "Libertad para todas las criaturas";
      ["req"] = 38;
   };
   [2977] = {
      ["name_ru"] = "Возвращение в Стальгорн";
      ["type"] = "Group";
      ["name_fr"] = "Retour a Forgefer";
      ["repgain"] = {
         [47] = 10;
      };
      ["name_de"] = "Ruckkehr nach Eisenschmiede";
      ["name"] = "Return to Ironforge";
      ["name_cn"] = "返回?炉堡";
      ["objective"] = "Speak with Historian Karnik in Ironforge.";
      ["next"] = 2964;
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 2954;
      ["prequests"] = {
         [1] = 2954;
      };
      ["level"] = 50;
      ["name_es"] = "Regresa a Forjaz";
      ["req"] = 45;
   };
   [2985] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["objective"] = "Find Islen Waterseer in the Barrens.";
      ["next"] = 1530;
      ["sort"] = "Shaman";
      ["name_cn"] = "水之召?";
      ["name_fr"] = "L'appel de l'eau";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1530;
      ["name_de"] = "Ruf des Wassers";
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["level"] = 20;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [2993] = {
      ["name_ru"] = "Назад во Внутренние земли";
      ["type"] = "Group";
      ["name_fr"] = "Retour dans les Hinterlands";
      ["next"] = 2994;
      ["name_de"] = "Ruckkehr ins Hinterland";
      ["name_cn"] = "返回辛特?";
      ["objective"] = "Speak with Gryphon Master Talonaxe.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Alliance";
      ["name"] = "Return to the Hinterlands";
      ["prev"] = 2992;
      ["prequests"] = {
         [1] = 2992;
      };
      ["level"] = 47;
      ["name_es"] = "Regresa a las Tierras del Interior";
      ["req"] = 40;
   };
   [3001] = {
      ["name_ru"] = "В поисках Страхада";
      ["type"] = "Solo";
      ["objective"] = "Find Strahad Farsan in Ratchet.";
      ["sort"] = "Warlock";
      ["name_cn"] = "?找斯坦哈德";
      ["name_fr"] = "A la recherche de Strahad";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Die Suche nach Strahad";
      ["faction"] = "Horde";
      ["name"] = "Seeking Strahad";
      ["level"] = 30;
      ["name_es"] = "Buscando a Strahad";
      ["req"] = 30;
   };
   [8792] = {
      ["name_ru"] = "Орде нужна твоя помощь!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Warlord Gorchuk in Orgrimmar's Valley of Spirits.";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要?的?助！";
      ["name_fr"] = "La Horde a besoin de votre aide?!";
      ["name_de"] = "Die Horde braucht Euch!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Your Help!";
      ["level"] = 60;
      ["name_es"] = "!La Horda te necesita!";
      ["req"] = 10;
   };
   [2757] = {
      ["name_ru"] = "Вперед, в Пиратскую Бухту!";
      ["type"] = "Solo";
      ["name_fr"] = "Baie-du-Butin ou la mort?!";
      ["next"] = 2760;
      ["name_de"] = "Auf nach Beutebucht!";
      ["objective"] = "Speak with McGavan in Booty Bay.";
      ["name_cn"] = "藏宝海湾之旅！";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Horde";
      ["name"] = "Booty Bay or Bust!";
      ["followup"] = 2760;
      ["prev"] = 2756;
      ["prequests"] = {
         [1] = 2756;
      };
      ["level"] = 40;
      ["name_es"] = "!Bahia del Botin o nada!";
      ["req"] = 40;
   };
   [2039] = {
      ["name_ru"] = "Найти Бинглза";
      ["type"] = "Solo";
      ["objective"] = "Find Bingles Blastenheimer in Loch Modan.";
      ["next"] = 2038;
      ["name_fr"] = "Trouvez Bingles";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?找?格斯";
      ["repgain"] = {
         [54] = 25;
      };
      ["name_de"] = "Sucht Bingles";
      ["faction"] = "Alliance";
      ["name"] = "Find Bingles";
      ["level"] = 15;
      ["name_es"] = "Encuentra a Bingles";
      ["req"] = 12;
   };
   [6065] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Yaw Sharpmane in Bloodhoof Village.";
      ["next"] = 6061;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6081] = {
      ["name_ru"] = "Обучение зверя";
      ["type"] = "Solo";
      ["name_fr"] = "Entrainer la bete";
      ["name_de"] = "Die Ausbildung des Tiers";
      ["objective"] = "Speak with Ormak Grimshot in Orgrimmar.";
      ["name_cn"] = "??野?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Training the Beast";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["prev"] = 6082;
      ["prequests"] = {
         [1] = 6082;
      };
      ["level"] = 10;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [1079] = {
      ["name_ru"] = "Секретная операция ? Альфа";
      ["type"] = "Solo";
      ["name_fr"] = "Operations secretes ? Plan A";
      ["repgain"] = {
         [54] = 350;
      };
      ["name_de"] = "Geheimoperation Alpha";
      ["followup"] = 1091;
      ["name_cn"] = "?秘行?：A";
      ["objective"] = "Retrieve the Venture Co.'s Engineering Plans from the lumber mill in Windshear Crag.";
      ["faction"] = "Alliance";
      ["name"] = "Covert Ops - Alpha";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1074;
      ["prequests"] = {
         [1] = 1074;
         [2] = 1077;
      };
      ["level"] = 22;
      ["name_es"] = "Operaciones secretas: plan A";
      ["req"] = 17;
   };
   [7850] = {
      ["name_ru"] = "Темные сосуды";
      ["type"] = "Group";
      ["objective"] = "Primal Torntusk at Revantusk Village in the Hinterlands wants you to recover 10 Vessels of Tainted Blood from Jintha'alor. Return to Primal Torntusk when this task is complete.";
      ["name_fr"] = "Les calices tenebreux";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "黑暗之瓶";
      ["reward"] = {
         [1] = 19118;
      };
      ["name_de"] = "Dunkle Gefase";
      ["faction"] = "Horde";
      ["name"] = "Dark Vessels";
      ["level"] = 50;
      ["name_es"] = "Vasijas oscuras";
      ["req"] = 46;
   };
   [3065] = {
      ["name_ru"] = "Простая табличка";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette simple";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Einfache Schrifttafel";
      ["objective"] = "Read the Simple Tablet and speak to Frang in the Valley of Trials.";
      ["name_cn"] = "普通石板";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Tablilla simple";
      ["req"] = 1;
   };
   [6145] = {
      ["name_ru"] = "Курьер из Багрового Легиона";
      ["type"] = "Group";
      ["name_fr"] = "Le messager cramoisi";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Der Purpurrote Kurier";
      ["name"] = "The Crimson Courier";
      ["name_cn"] = "?衣信使";
      ["objective"] = "Return to Eastern Plaguelands and track down the Crimson Courier. Kill the Courier and recover the Grand Crusader's Command.$B$BTake the command to Nathanos Blightcaller for further instruction.";
      ["next"] = 6146;
      ["faction"] = "Horde";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6144;
      ["prequests"] = {
         [1] = 6144;
      };
      ["level"] = 60;
      ["name_es"] = "El mensajero carmesi";
      ["req"] = 56;
   };
   [8225] = {
      ["name_ru"] = "Редкая рыба ? синий полосатик Браунелла";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Poisson rare?: le tassergal a dos raye";
      ["name_cn"] = "稀有?? - 布隆奈??斑?";
      ["reward"] = {
         [1] = 19969;
      };
      ["name_de"] = "Besonderer Fisch - Braunells blaugestreifter Flitzerfisch";
      ["faction"] = "Horde";
      ["name"] = "Rare Fish - Brownell's Blue Striped Racer";
      ["level"] = 0;
      ["name_es"] = "Pez raro: corredor a rayas azules de Brownell";
      ["req"] = 1;
   };
   [8257] = {
      ["name_ru"] = "Кровь Морфаза";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le sang de Morphaz";
      ["name_de"] = "Morphaz' Blut";
      ["objective"] = "Kill Morphaz in the sunken temple of Atal'Hakkar, and return his blood to Greta Mosshoof in Felwood.  The entrance to the sunken temple can be found in the Swamp of Sorrows.";
      ["reward"] = {
         [1] = 19990;
         [2] = 20082;
         [3] = 20006;
      };
      ["name_cn"] = "摩弗拉斯之血";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Blood of Morphaz";
      ["sort"] = "Priest";
      ["prev"] = 8256;
      ["prequests"] = {
         [1] = 8256;
      };
      ["level"] = 52;
      ["name_es"] = "La sangre de Morphaz";
      ["req"] = 50;
   };
   [3097] = {
      ["name_ru"] = "Священный свиток";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin beni";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Geheiligte Rolle";
      ["objective"] = "Read the Hallowed Scroll and speak to Dark Cleric Duesten in the church in Deathknell.";
      ["name_cn"] = "神?卷?";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Hallowed Scroll";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 1;
      ["name_es"] = "Un pergamino sacralizado";
      ["req"] = 1;
   };
   [8321] = {
      ["name_ru"] = "Вайрал Подлый";
      ["type"] = "Solo";
      ["objective"] = "Bring Vyral's Signet Ring to Huum Wildmane in Cenarion Hold.";
      ["repgain"] = {
         [609] = 150;
      };
      ["name_de"] = "Vyral der Uble";
      ["reward"] = {
         [1] = 20650;
         [2] = 20649;
      };
      ["name_cn"] = "邪?的?拉?";
      ["name_fr"] = "Vyral le Vil";
      ["faction"] = "Horde";
      ["name"] = "Vyral the Vile";
      ["sort"] = "Silithus";
      ["prev"] = 8320;
      ["prequests"] = {
         [1] = 8320;
      };
      ["level"] = 60;
      ["name_es"] = "Vyral el Vil";
      ["req"] = 60;
   };
   [8353] = {
      ["name_ru"] = "Курочка с мятой";
      ["type"] = "Solo";
      ["objective"] = "Do a chicken emote at Innkeeper Firebrew, and in exchange you'll receive an Ironforge Mint!";
      ["name_fr"] = "Caqueter pour un bonbon a la menthe";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "学小?，?糖果";
      ["reward"] = {
         [1] = 20490;
      };
      ["name_de"] = "Huhnchengegacker fur ein Pfefferminzbonbon";
      ["faction"] = "Alliance";
      ["name"] = "Chicken Clucking for a Mint";
      ["level"] = 60;
      ["name_es"] = "Una menta por cacarear como un pollo";
      ["req"] = 10;
   };
   [3121] = {
      ["name_ru"] = "Странная просьба";
      ["type"] = "Solo";
      ["objective"] = "Take the Shrunken Head to Neeru Fireblade in Orgrimmar.";
      ["next"] = 3122;
      ["name_fr"] = "Une Requete etrange";
      ["sort"] = "Feralas";
      ["name_cn"] = "奇怪的要求";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Eine seltsame Bitte";
      ["faction"] = "Horde";
      ["name"] = "A Strange Request";
      ["level"] = 45;
      ["name_es"] = "Una extrana peticion";
      ["req"] = 40;
   };
   [8417] = {
      ["name_ru"] = "Неупокоенный дух";
      ["type"] = "Solo";
      ["objective"] = "Speak with the Fallen Hero of the Horde at the entrance to the Blasted Lands.";
      ["next"] = 8423;
      ["sort"] = "Warrior";
      ["name_cn"] = "困?的?魂";
      ["name_fr"] = "Un esprit trouble";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Ein geplagter Geist";
      ["faction"] = "Horde";
      ["name"] = "A Troubled Spirit";
      ["level"] = 50;
      ["name_es"] = "Un espiritu afligido";
      ["req"] = 50;
   };
   [8802] = {
      ["name_ru"] = "Спаситель Калимдора";
      ["type"] = "Solo";
      ["objective"] = "Take the Eye of C'Thun to Anachronos at the Caverns of Time.";
      ["repgain"] = {
         [609] = 200;
      };
      ["name_de"] = "Der Retter von Kalimdor";
      ["reward"] = {
         [1] = 21712;
         [2] = 21710;
         [3] = 21709;
      };
      ["name_cn"] = "?林多的救星";
      ["name_fr"] = "Le sauveur de Kalimdor";
      ["faction"] = "Horde";
      ["name"] = "The Savior of Kalimdor";
      ["sort"] = "Ahn'Qiraj";
      ["prev"] = 8801;
      ["prequests"] = {
         [1] = 8801;
      };
      ["level"] = 60;
      ["name_es"] = "La salvacion de Kalimdor";
      ["req"] = 60;
   };
   [8481] = {
      ["name_ru"] = "Корень всех зол";
      ["type"] = "Group";
      ["objective"] = "Plant the Demon Summoning Torch in the mouth of High Chief Winterfall's cave in the Winterfall furbolg village.  Defeat the demon and retrieve the Essence of Xandivious for Gorn One Eye in Timbermaw Hold.";
      ["repgain"] = {
         [576] = 500;
      };
      ["sort"] = "Timbermaw Hold";
      ["name_fr"] = "La racine du mal";
      ["name_cn"] = "万?之源";
      ["reward"] = {
         [1] = 21326;
      };
      ["name_de"] = "Die Wurzel alles Bosen";
      ["faction"] = "Horde";
      ["name"] = "The Root of All Evil";
      ["level"] = 60;
      ["name_es"] = "La raiz de todos los males";
      ["req"] = 45;
   };
   [8513] = {
      ["name_ru"] = "Альянсу не хватает средней кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Medium Leather to Private Porter at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de cuir moyen?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要中皮!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21510;
      };
      ["name_de"] = "Die Allianz braucht mittleres Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Medium Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita cuero medio!";
      ["req"] = 52;
   };
   [6321] = {
      ["name_ru"] = "Поставка оружия";
      ["type"] = "Solo";
      ["name_fr"] = "Approvisionner le Sepulcre";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_cn"] = "瑟伯切?的??";
      ["name_de"] = "Nachschub fur Brill";
      ["objective"] = "Bring Podrig's Order to Karos Razok.";
      ["next"] = 6323;
      ["name"] = "Supplying the Sepulcher";
      ["sort"] = "Silverpine Forest";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 10;
      ["name_es"] = "Suministros para El Remol";
      ["req"] = 10;
   };
   [8577] = {
      ["name_ru"] = "Тушеный Лис, БЛД";
      ["type"] = "Solo";
      ["name_fr"] = "Stewvul, ex-M.A.P.V.";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "Stewvul, ehemals allerbester Freund";
      ["name"] = "Stewvul, Ex-B.F.F.";
      ["name_cn"] = "斯?沃?，前任死党";
      ["objective"] = "Narain Soothfancy wants you to find his ex-best friend forever (BFF), Stewvul, and take back the scrying goggles that Stewvul stole from him.";
      ["next"] = 8578;
      ["faction"] = "Horde";
      ["sort"] = "Tanaris";
      ["prev"] = 8576;
      ["prequests"] = {
         [1] = 8576;
      };
      ["level"] = 60;
      ["name_es"] = "Guison, ex mejor amigo";
      ["req"] = 60;
   };
   [8609] = {
      ["name_ru"] = "Орде не хватает бинтов из рунической ткани!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Runecloth Bandages to Stoneguard Clayhoof at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de bandages en etoffe runique?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要符文布??!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["name_de"] = "Die Horde braucht Runenstoffverbande!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Runecloth Bandages!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita vendas de pano runico!";
      ["req"] = 59;
   };
   [8641] = {
      ["name_ru"] = "Наплеч торговца смертью";
      ["objective"] = "Bring the Qiraji Bindings of Command, 2 Idols of the Sun, 5 Silver Scarabs and 5 Clay Scarabs to Andorgos in Ahn'Qiraj.  You must also attain Neutral reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "死亡?行者的?肩";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres du dispensateur de mort";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Schiftung des Todesboten";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 21361;
      };
      ["name"] = "Deathdealer's Spaulders";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las bufas de mortifero";
      ["req"] = 60;
   };
   [8673] = {
      ["name_ru"] = "Предок Кровавое Копыто";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Sabot-de-sang";
      ["name_cn"] = "血蹄?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Bluthuf";
      ["faction"] = "Horde";
      ["name"] = "Bloodhoof the Elder";
      ["level"] = 60;
      ["name_es"] = "Pezuna de Sangre el Ancestro";
      ["req"] = 1;
   };
   [8705] = {
      ["name_ru"] = "Чекан Беспредельной мудрости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ornate Hilt, 2  Lambent Idols, 5 Bronze Scarabs and 5 Ivory Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le marteau de sagesse infinie";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "无尽智慧之?";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 21410;
      };
      ["name_de"] = "Hammer der unendlichen Weisheit";
      ["faction"] = "Horde";
      ["name"] = "Gavel of Infinite Wisdom";
      ["level"] = 60;
      ["name_es"] = "El mazo de sabiduria infinita";
      ["req"] = 60;
   };
   [8737] = {
      ["name_ru"] = "Лазурный храмовник";
      ["type"] = "Group";
      ["objective"] = "Summon and slay an Azure Templar and report back to Bor Wildmane in Cenarion Hold.  You must also bring Tactical Task Briefing I in order to complete this quest.";
      ["name_fr"] = "Le templier d'azur";
      ["sort"] = "Silithus";
      ["name_cn"] = "灰?公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 21133;
      };
      ["name_de"] = "Azurblauer Templer";
      ["faction"] = "Horde";
      ["name"] = "Azure Templar";
      ["level"] = 60;
      ["name_es"] = "Templario azur";
      ["req"] = 60;
   };
   [8769] = {
      ["name_ru"] = "Тикающий подарок";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un cadeau tic-taquant";
      ["name_cn"] = "条?礼物盒";
      ["reward"] = {
         [1] = 21327;
      };
      ["name_de"] = "Ein tickendes Geschenk";
      ["faction"] = "Horde";
      ["name"] = "A Ticking Present";
      ["level"] = 40;
      ["name_es"] = "Un presente que hace tic tac";
      ["req"] = 40;
   };
   [8801] = {
      ["name_ru"] = "Наследие К'Туна";
      ["type"] = "Solo";
      ["objective"] = "Take the Eye of C'Thun to Caelastrasz in the Temple of Ahn'Qiraj.";
      ["next"] = 8802;
      ["name_fr"] = "L'heritage de C'Thun";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "克?恩的??";
      ["repgain"] = {
         [609] = 200;
      };
      ["name_de"] = "C'Thuns Vermachtnis";
      ["faction"] = "Horde";
      ["name"] = "C'Thun's Legacy";
      ["level"] = 60;
      ["name_es"] = "El legado de C'Thun";
      ["req"] = 60;
   };
   [8833] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8823;
      ["prequests"] = {
         [1] = 8823;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [6481] = {
      ["name_ru"] = "Пробуждение земельника";
      ["type"] = "Group";
      ["objective"] = "Open the Resonite cask with the Enchanted Resonite Crystal, and then slay Goggeroc. Return to Mor'rogal with the news and Enchanted Resonite Crystal.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Der Irdene erhebt sich";
      ["reward"] = {
         [1] = 16981;
         [2] = 1306;
      };
      ["name_cn"] = "土?的?醒";
      ["name_fr"] = "Un Terrestre se leve";
      ["faction"] = "Horde";
      ["name"] = "Earthen Arise";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 6421;
      ["prequests"] = {
         [1] = 6421;
      };
      ["level"] = 20;
      ["name_es"] = "El despertar del terraneo";
      ["req"] = 14;
   };
   [8897] = {
      ["name_ru"] = "Дорогая моя Колара!";
      ["type"] = "Solo";
      ["objective"] = "Deliver Lieutenant Heldric's Carefully Penned Note to Colara Dean outside the bank in Stormwind.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的科?拉";
      ["name_fr"] = "Tres chere Colara,";
      ["name_de"] = "Liebste Colara";
      ["faction"] = "Alliance";
      ["name"] = "Dearest Colara,";
      ["level"] = 60;
      ["name_es"] = "Queridisima Colara:";
      ["req"] = 60;
   };
   [8929] = {
      ["name_ru"] = "В поисках Антиона";
      ["type"] = "Solo";
      ["objective"] = "Use the Extra-Dimensional Ghost Revealer at the entrance to Stratholme and speak with the ghost of Anthion Harmon.";
      ["next"] = 8945;
      ["name_fr"] = "A la recherche d'Anthion";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?找安泰恩";
      ["name"] = "In Search of Anthion";
      ["followup"] = 8945;
      ["name_de"] = "Suche nach Anthion";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 8936;
         [2] = 8937;
         [3] = 8926;
         [4] = 8931;
         [5] = 8932;
         [6] = 8933;
         [7] = 8934;
         [8] = 8935;
      };
      ["level"] = 60;
      ["name_es"] = "Buscando a Anthion";
      ["req"] = 58;
   };
   [8961] = {
      ["name_ru"] = "Три властелина огня";
      ["type"] = "Raid";
      ["objective"] = "Gather the Incendicite of Incendius, the Ember of Emberseer and the Cinder of Cynders, along with a Hallowed Brazier, and return them to Bodley inside Blackrock Mountain.";
      ["name_fr"] = "Les trois rois des flammes";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "烈?之王";
      ["name"] = "Three Kings of Flame";
      ["name_de"] = "Die drei Konige der Flammen";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 9032;
         [2] = 8960;
      };
      ["level"] = 60;
      ["name_es"] = "Tres reyes de Fuego";
      ["req"] = 58;
   };
   [6545] = {
      ["name_ru"] = "Сведения гонца клана Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Mise a jour du Messager Chanteguerre";
      ["name_cn"] = "?歌信使的?告";
      ["reward"] = {
         [1] = 16763;
      };
      ["name_de"] = "Aktualisierter Bericht des Laufers des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "Warsong Runner Update";
      ["level"] = 19;
      ["name_es"] = "Novedades de corredor Grito de Guerra";
      ["req"] = 17;
   };
   [3281] = {
      ["name_ru"] = "Похищенное серебро";
      ["type"] = "Solo";
      ["objective"] = "Bring the Stolen Silver to Gazrog in the Crossroads.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Gestohlenes Silber";
      ["reward"] = {
         [1] = 11853;
         [2] = 2694;
      };
      ["name_cn"] = "被?走的??";
      ["name_fr"] = "Argent vole";
      ["faction"] = "Horde";
      ["name"] = "Stolen Silver";
      ["sort"] = "The Barrens";
      ["prev"] = 869;
      ["prequests"] = {
         [1] = 869;
      };
      ["level"] = 18;
      ["name_es"] = "La plata robada";
      ["req"] = 9;
   };
   [9057] = {
      ["name_ru"] = "Наплеч расхитителя гробниц";
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres de traqueur des cryptes";
      ["name_de"] = "Schiftung des Gruftpirschers";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make Cryptstalker Spaulders if you bring him the following: 1 Desecrated Spaulders, 12 Wartorn Chain Scraps, 2 Arcanite Bars and 3 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22439;
      };
      ["name_cn"] = "地穴追?者肩?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Cryptstalker Spaulders";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las bufas de acechacriptas";
      ["req"] = 60;
   };
   [9089] = {
      ["name_ru"] = "Наплеч сновидца";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make Dreamwalker Spaulders if you bring her the following: 1 Desecrated Spaulders, 12 Wartorn Leather Scraps, 5 Cured Rugged Hides and 1 Nexus Crystal.";
      ["name_cn"] = "梦游者肩?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les spallieres de marchereve";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Schiftung des Traumwandlers";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22491;
      };
      ["name"] = "Dreamwalker Spaulders";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las bufas Caminasuenos";
      ["req"] = 60;
   };
   [9121] = {
      ["name_ru"] = "Цитадель ужаса ? Наксрамас";
      ["type"] = "Solo";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands wants 5 Arcane Crystals, 2 Nexus Crystals, 1 Righteous Orb and 60 gold pieces. You must also be Honored with the Argent Dawn.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["name_fr"] = "Naxxramas, la citadelle de l'effroi";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "恐怖之城，?克??斯";
      ["followup"] = 9033;
      ["name_de"] = "Die Zitadelle des Schreckens - Naxxramas";
      ["faction"] = "Horde";
      ["name"] = "The Dread Citadel - Naxxramas";
      ["level"] = 60;
      ["name_es"] = "La ciudadela del terror: Naxxramas";
      ["req"] = 60;
   };
   [6625] = {
      ["name_ru"] = "Травматологи Альянса";
      ["type"] = "Solo";
      ["objective"] = "Travel to Theramore in the Dustwallow Marsh and speak with Doctor Gustaf VanHowzen about joining the ranks of Alliance Trauma.";
      ["next"] = 6624;
      ["sort"] = "First Aid";
      ["name_cn"] = "?盟医??";
      ["name_fr"] = "Service de traumatologie de l'Alliance";
      ["name_de"] = "Traumachirurg der Allianz";
      ["faction"] = "Alliance";
      ["name"] = "Alliance Trauma";
      ["level"] = 45;
      ["name_es"] = "El Dispensario de la Alianza";
      ["req"] = 35;
   };
   [3321] = {
      ["name_ru"] = "Не ее ли ищете?";
      ["type"] = "Solo";
      ["name_fr"] = "Est-ce que ceci est a vous??";
      ["name_de"] = "Habt Ihr das verloren?";
      ["name_cn"] = "秘?会的?可";
      ["objective"] = "Wait for Trenton to finish his work.";
      ["sort"] = "Blacksmithing";
      ["reward"] = {
         [1] = 10418;
      };
      ["name"] = "Did You Lose This?";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2773;
         [2] = 2771;
         [3] = 2772;
      };
      ["level"] = 50;
      ["name_es"] = "?Has perdido esto?";
      ["req"] = 40;
   };
   [8865] = {
      ["name_ru"] = "Костюмы Лунного фестиваля";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les habits de la fete lunaire";
      ["name_cn"] = "???装";
      ["reward"] = {
         [1] = 21541;
         [2] = 21640;
         [3] = 21544;
         [4] = 21543;
      };
      ["name_de"] = "Festliche Hosenanzuge des Mondfests";
      ["faction"] = "Horde";
      ["name"] = "Festive Lunar Pant Suits";
      ["level"] = 60;
      ["name_es"] = "Trajes pantalon para el Festival Lunar";
      ["req"] = 1;
   };
   [1068] = {
      ["name_ru"] = "Механические измельчители";
      ["type"] = "Solo";
      ["name_fr"] = "Les machines a dechiqueter";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Schreddermaschinen";
      ["name_cn"] = "伐木机";
      ["name"] = "Shredding Machines";
      ["objective"] = "Kill the shredders XT:4 and XT:9, then return to Seereth Stonebreak at the border of the Stonetalon Mountains and the Barrens.";
      ["faction"] = "Horde";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1062;
      ["prequests"] = {
         [1] = 1062;
      };
      ["level"] = 23;
      ["name_es"] = "Las sierras XT:4 y XT:9";
      ["req"] = 13;
   };
   [5321] = {
      ["name_ru"] = "Спящий пробудился";
      ["type"] = "Solo";
      ["objective"] = "Escort Kerlonian Evershade to Liladris Moonriver at Maestra's Post in Ashenvale.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "Le dormeur s'est eveille";
      ["name_cn"] = "昏昏欲睡";
      ["reward"] = {
         [1] = 15205;
         [2] = 15206;
         [3] = 15207;
      };
      ["name_de"] = "Der Schlafer ist erwacht";
      ["faction"] = "Alliance";
      ["name"] = "The Sleeper Has Awakened";
      ["level"] = 20;
      ["name_es"] = "El despertar";
      ["req"] = 17;
   };
   [8826] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["name_fr"] = "Dix chevalieres de merite";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["faction"] = "Horde";
      ["name"] = "Ten Commendation Signets";
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [3361] = {
      ["name_ru"] = "Беда беженца";
      ["type"] = "Solo";
      ["objective"] = "Bring Felix's Box, Felix's Chest and Felix's Bucket of Bolts to Felix Whindlebolt in Anvilmar.";
      ["repgain"] = {
         [54] = 250;
         [47] = 250;
      };
      ["name_fr"] = "Les malheurs d'un refugie";
      ["sort"] = "Coldridge Valley";
      ["name_cn"] = "逃?者的困境";
      ["name_de"] = "Dilemma eines Fluchtlings";
      ["faction"] = "Alliance";
      ["name"] = "A Refugee's Quandary";
      ["level"] = 3;
      ["name_es"] = "Las penurias de un refugiado";
      ["req"] = 3;
   };
   [3369] = {
      ["name_ru"] = "Кошмары";
      ["type"] = "Solo";
      ["objective"] = "Bring the Nightmare Shard to Hamuul Runetotem on Elder Rise.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Alptraum";
      ["reward"] = {
         [1] = 10657;
         [2] = 10658;
      };
      ["name_cn"] = "在?梦中";
      ["name_fr"] = "Au coeur des cauchemars";
      ["faction"] = "Horde";
      ["name"] = "In Nightmares";
      ["sort"] = "The Barrens";
      ["prev"] = 6981;
      ["prequests"] = {
         [1] = 6981;
      };
      ["level"] = 25;
      ["name_es"] = "En las pesadillas";
      ["req"] = 15;
   };
   [3377] = {
      ["name_ru"] = "Молитва Элуне";
      ["type"] = "Solo";
      ["objective"] = "Hear Zamael tell his tale.";
      ["next"] = 3378;
      ["name_fr"] = "Priere a Elune";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "艾露恩祷言";
      ["series"] = 1;
      ["name_de"] = "Gebet an Elune";
      ["faction"] = "Alliance";
      ["name"] = "Prayer to Elune";
      ["level"] = 50;
      ["name_es"] = "El rezo a Elune";
      ["req"] = 40;
   };
   [3385] = {
      ["name_ru"] = "Черный рынок";
      ["objective"] = "Slay Trade Master Kovic and his minion Clunk. Retrieve the Trader's Satchel from his corpse and return it to Nilith.$B";
      ["name_cn"] = "黑市交易";
      ["sort"] = "Tailoring";
      ["level"] = 50;
      ["type"] = "Group";
      ["name_fr"] = "Le Sous-marche";
      ["next"] = 3402;
      ["name_de"] = "Der Untermarkt";
      ["reward"] = {
         [1] = 10462;
         [2] = 10479;
      };
      ["faction"] = "Horde";
      ["name"] = "The Undermarket";
      ["prev"] = 3379;
      ["prequests"] = {
         [1] = 3379;
      };
      ["series"] = 1;
      ["name_es"] = "El Mercado Negro";
      ["req"] = 46;
   };
   [8947] = {
      ["name_ru"] = "Странная просьба Антиона";
      ["type"] = "Solo";
      ["name_fr"] = "L'etonnante requete d'Anthion";
      ["next"] = 8948;
      ["name_de"] = "Anthions merkwurdige Anforderung";
      ["name_cn"] = "安泰恩的奇怪?求";
      ["objective"] = "Bring 3 Dark Iron Bars, 20 Enchanted Leather, 3 Mooncloth and 4 Cured Rugged Hides to Anthion Harmon in the Eastern Plaguelands.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Anthion's Strange Request";
      ["prev"] = 8946;
      ["prequests"] = {
         [1] = 8946;
      };
      ["level"] = 60;
      ["name_es"] = "La extrana peticion de Anthion";
      ["req"] = 58;
   };
   [6801] = {
      ["name_ru"] = "Локолар Владыка Льда";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 10;
         [729] = 1;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Lokholar le Seigneur des Glaces";
      ["name_cn"] = "冰雪之王洛克霍拉";
      ["name_de"] = "Lokholar der Eislord";
      ["faction"] = "Horde";
      ["name"] = "Lokholar the Ice Lord";
      ["level"] = 60;
      ["name_es"] = "Lokholar, el Senor del Hielo";
      ["req"] = 51;
   };
   [5943] = {
      ["name_ru"] = "Караван Гизлтона";
      ["type"] = "Solo";
      ["objective"] = "Escort the Gizelton Caravan through Mannoroc Coven. Talk with Smeed at Scrabblescrew's Camp for your reward.";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "La caravane de Gizelton";
      ["name_cn"] = "基?????";
      ["reward"] = {
         [1] = 15691;
         [2] = 15692;
         [3] = 15695;
      };
      ["name_de"] = "Gizeltons Karawane";
      ["faction"] = "Horde";
      ["name"] = "Gizelton Caravan";
      ["level"] = 38;
      ["name_es"] = "La caravana Gizelton";
      ["req"] = 32;
   };
   [1168] = {
      ["name_ru"] = "Армия Черного дракона";
      ["type"] = "Solo";
      ["objective"] = "Tharg in Brackenwall Village wants you to kill 10 Firemane Scouts, 10 Firemane Ash Tails, and 5 Firemane Scalebanes.";
      ["name_fr"] = "L'armee des dragons noirs";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "黑???";
      ["reward"] = {
         [1] = 9705;
         [2] = 9706;
      };
      ["name_de"] = "Armee des schwarzen Grosdrachen";
      ["faction"] = "Horde";
      ["name"] = "Army of the Black Dragon";
      ["level"] = 43;
      ["name_es"] = "El ejercito de los dragones Negros";
      ["req"] = 38;
   };
   [8446] = {
      ["name_ru"] = "Под покровом кошмара";
      ["type"] = "Solo";
      ["objective"] = "Find someone capable of deciphering the meaning behind the Nightmare Engulfed Object.$B$BPerhaps a druid of great power could assist you.";
      ["next"] = 8447;
      ["name_fr"] = "Voile par le cauchemar";
      ["sort"] = "Epic";
      ["name_cn"] = "梦?的??";
      ["repgain"] = {
         [609] = 500;
      };
      ["name_de"] = "Eingehullt in Alptraume";
      ["faction"] = "Horde";
      ["name"] = "Shrouded in Nightmare";
      ["level"] = 60;
      ["name_es"] = "Inundacion de Pesadilla";
      ["req"] = 60;
   };
   [8842] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8817;
      ["prequests"] = {
         [1] = 8817;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [6881] = {
      ["name_ru"] = "Ивус Лесной Властелин";
      ["type"] = "PvP";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 10;
         [730] = 1;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Ivus le Seigneur des forets";
      ["name_cn"] = "森林之王伊弗斯";
      ["name_de"] = "Ivus der Waldfurst";
      ["faction"] = "Alliance";
      ["name"] = "Ivus the Forest Lord";
      ["level"] = 60;
      ["name_es"] = "Ivus, el Senor del Bosque";
      ["req"] = 51;
   };
   [3449] = {
      ["name_ru"] = "Чародейские руны";
      ["type"] = "Solo";
      ["name_fr"] = "Les runes des arcanes";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Arkane Runen";
      ["name"] = "Arcane Runes";
      ["name_cn"] = "奥?符文";
      ["objective"] = "Using the Drawing Kit, make rubbings of the Rune of Beth'Amara, the Rune of Jin'yael, the Rune of Markri, and the Rune of Sael'hai before heading to the small island off of the southern peninsula of Azshara and signaling Pilot Xiggs Fuselighter to pick them up.";
      ["next"] = 3461;
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 3448;
      ["prequests"] = {
         [1] = 3448;
      };
      ["level"] = 52;
      ["name_es"] = "Runas Arcanas";
      ["req"] = 45;
   };
   [5401] = {
      ["name_ru"] = "Жетон Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Brevet de l'Aube d'argent";
      ["name_cn"] = "?色黎明委任徽章";
      ["reward"] = {
         [1] = 12846;
      };
      ["name_de"] = "Anstecknadel der Argentumdammerung";
      ["faction"] = "Alliance";
      ["name"] = "Argent Dawn Commission";
      ["level"] = 55;
      ["name_es"] = "Comision de El Alba Argenta";
      ["req"] = 50;
   };
   [5126] = {
      ["name_ru"] = "История Лоракса";
      ["type"] = "Solo";
      ["objective"] = "Speak with Lorax. Listen to what he has to say.$B";
      ["sort"] = "Winterspring";
      ["name_cn"] = "?拉克斯的故事";
      ["name_fr"] = "L'histoire de Lorax";
      ["name_de"] = "Lorax' Geschichte";
      ["faction"] = "Horde";
      ["name"] = "Lorax's Tale";
      ["level"] = 60;
      ["name_es"] = "La historia de Lorax";
      ["req"] = 55;
   };
   [1152] = {
      ["name_ru"] = "Испытание знаний";
      ["objective"] = "Find Braug Dimspirit near the entrance to Talondeep Path in Stonetalon Mountains.";
      ["name_cn"] = "知???";
      ["sort"] = "Thousand Needles";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 1154;
      ["name_de"] = "Test der Lehre";
      ["repgain"] = {
         [81] = 75;
      };
      ["faction"] = "Horde";
      ["name"] = "Test of Lore";
      ["prev"] = 1151;
      ["prequests"] = {
         [1] = 1151;
      };
      ["series"] = 1;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [6961] = {
      ["name_ru"] = "Здравствуй, Дедушка Зима!";
      ["type"] = "Solo";
      ["objective"] = "Speak with Greatfather Winter; he is located near the Smokywood Pastures vendor area in Orgrimmar.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?无内容";
      ["name_fr"] = "Grand-pere Hiver est ici?!";
      ["name_de"] = "Altvater Winter ist hier!";
      ["faction"] = "Horde";
      ["name"] = "Great-father Winter is Here!";
      ["level"] = 60;
      ["name_es"] = "!El Gran Padre Invierno esta aqui!";
      ["req"] = 10;
   };
   [8280] = {
      ["name_ru"] = "Надежные поставки";
      ["type"] = "Solo";
      ["objective"] = "Windcaller Proudhorn at Cenarion Hold in Silithus wants you to kill 15 Dredge Strikers.";
      ["next"] = 8281;
      ["sort"] = "Silithus";
      ["name_cn"] = "保????";
      ["name_fr"] = "Securiser les lignes d'approvisionnement";
      ["followup"] = 8281;
      ["name_de"] = "Sicherung der Versorgungslinien";
      ["faction"] = "Horde";
      ["name"] = "Securing the Supply Lines";
      ["level"] = 55;
      ["name_es"] = "Asegurar las rutas de suministros";
      ["req"] = 54;
   };
   [8546] = {
      ["name_ru"] = "Орде все еще не хватает мифриловых слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Mithril Bars to Senior Sergeant T'kelah at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Mithrilbarren!";
      ["name_fr"] = "La Horde a besoin de plus de barres de mithril !";
      ["name_cn"] = "部落需要更多秘??！";
      ["name"] = "The Horde Needs More Mithril Bars!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8545;
      ["prequests"] = {
         [1] = 8545;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas barras de mitril!";
      ["req"] = 1;
   };
   [3505] = {
      ["name_ru"] = "Предательница";
      ["objective"] = "Kill 10 Blood Elf Reclaimers, and 10 Blood Elf Surveyors before seeking out Magus Rimtori's camp. Once you've found it, look for something that might be important to her that can be used to draw her into a fight.";
      ["name_cn"] = "叛徒";
      ["sort"] = "Orgrimmar";
      ["level"] = 53;
      ["type"] = "Solo";
      ["name_fr"] = "Trahison";
      ["next"] = 3506;
      ["name_de"] = "Verraten";
      ["repgain"] = {
         [76] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Betrayed";
      ["prev"] = 3504;
      ["prequests"] = {
         [1] = 3504;
      };
      ["series"] = 2;
      ["name_es"] = "Traicion";
      ["req"] = 44;
   };
   [7025] = {
      ["name_ru"] = "Угощение для Дедушки Зимы";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Gingerbread Cookies and an Ice Cold Milk to Greatfather Winter in Ironforge.";
      ["repgain"] = {
         [21] = 25;
         [369] = 25;
         [577] = 25;
         [470] = 25;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Des friandises pour Grandpere Hiver";
      ["name_cn"] = "冬幕?的礼物";
      ["reward"] = {
         [1] = 17727;
      };
      ["name_de"] = "Leckereien fur Altvater Winter";
      ["faction"] = "Alliance";
      ["name"] = "Treats for Greatfather Winter";
      ["level"] = 60;
      ["name_es"] = "Golosinas para el Gran Padre Invierno";
      ["req"] = 10;
   };
   [7041] = {
      ["name_ru"] = "Скверна Злоязыкого";
      ["type"] = "Dungeon";
      ["objective"] = "Fill the Coated Cerulean Vial at the orange crystal pool in Maraudon.$B$BUse the Filled Cerulean Vial on the Vylestem Vines to force the corrupted Noxxious Scion to emerge.$B$BHeal 8 plants by killing these Noxxious Scion, then return to Talendria in Nijel's Point.";
      ["name_fr"] = "La corruption de Vylelangue";
      ["sort"] = "Maraudon";
      ["name_cn"] = "?利塔恩的?染";
      ["reward"] = {
         [1] = 17768;
         [2] = 17778;
         [3] = 17770;
      };
      ["name_de"] = "Schlangenzunges Verderbnis";
      ["faction"] = "Alliance";
      ["name"] = "Vyletongue Corruption";
      ["level"] = 47;
      ["name_es"] = "La corrupcion de Lenguavil";
      ["req"] = 41;
   };
   [3082] = {
      ["name_ru"] = "Каменная табличка";
      ["type"] = "Solo";
      ["name_fr"] = "Tablette gravee";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Geatzte Schrifttafel";
      ["objective"] = "Speak to Jen'shan in the Valley of Trials.";
      ["name_cn"] = "??石板";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Etched Tablet";
      ["races"] = {
         [1] = "Troll";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Tablilla con grabados";
      ["req"] = 1;
   };
   [1645] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?*";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Der Foliant der Offenbarung";
      ["name"] = "The Tome of Divinity";
      ["reward"] = {
         [1] = 6916;
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [6546] = {
      ["name_ru"] = "Сведения всадника из клана Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Mise a jour du voltigeur Chanteguerre";
      ["name_cn"] = "?歌侍从的?告";
      ["reward"] = {
         [1] = 16765;
      };
      ["name_de"] = "Aktualisierter Bericht der Vorhut des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "Warsong Outrider Update";
      ["level"] = 25;
      ["name_es"] = "Novedades de escolta Grito de Guerra";
      ["req"] = 17;
   };
   [2206] = {
      ["name_ru"] = "Держи-хватай!";
      ["type"] = "Solo";
      ["name_fr"] = "Effraction";
      ["name_de"] = "Schneller Eingriff";
      ["objective"] = "Find the Defias Dockmaster and recover the Shipping Schedule for Master Mathias Shaw.$B";
      ["name_cn"] = "????";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["reward"] = {
         [1] = 7298;
      };
      ["name"] = "Snatch and Grab";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 2205;
      };
      ["level"] = 10;
      ["name_es"] = "El robo";
      ["req"] = 10;
   };
   [3561] = {
      ["name_ru"] = "Доставка верховному магу Ксилему";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison a l'archimage Xylem";
      ["next"] = 3565;
      ["name_de"] = "Lieferung fur Erzmagier Xylem";
      ["name_cn"] = "大法?克希雷姆的石版";
      ["objective"] = "Bring the Tablet of Sael'hai to Archmage Xylem in Azshara.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Delivery to Archmage Xylem";
      ["prev"] = 3517;
      ["prequests"] = {
         [1] = 3517;
      };
      ["level"] = 52;
      ["name_es"] = "Entrega al archimago Xylem";
      ["req"] = 45;
   };
   [3569] = {
      ["name_ru"] = "Разносчик заразы";
      ["type"] = "Solo";
      ["name_fr"] = "Corruption Suintante";
      ["name_de"] = "Verbreitete Verderbnis";
      ["name_cn"] = "堕落之水";
      ["objective"] = "Give Cuely's Elixir to Thersa Windsong in Undercity.";
      ["sort"] = "Undercity";
      ["faction"] = "Horde";
      ["name"] = "Seeping Corruption";
      ["prev"] = 3568;
      ["prequests"] = {
         [1] = 3568;
      };
      ["level"] = 52;
      ["name_es"] = "La filtracion de la corrupcion";
      ["req"] = 45;
   };
   [3093] = {
      ["name_ru"] = "Руническая записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note runique";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Mit Runen beschriftete Notiz";
      ["objective"] = "Read the Rune-Inscribed Note and speak to Meela Dawnstrider in Camp Narache.";
      ["name_cn"] = "符文便?";
      ["sort"] = "Shaman";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name"] = "Rune-Inscribed Note";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 747;
      ["prequests"] = {
         [1] = 747;
      };
      ["level"] = 1;
      ["name_es"] = "La nota con runas grabadas";
      ["req"] = 1;
   };
   [7169] = {
      ["name_ru"] = "Уважение Стражи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [47] = 250;
         [730] = 250;
      };
      ["name_de"] = "Ehre innerhalb der Garde";
      ["name_fr"] = "Honore au sein de la Garde";
      ["name_cn"] = "?兵的尊敬";
      ["faction"] = "Horde";
      ["name"] = "Honored Amongst the Guard";
      ["reward"] = {
         [1] = 17901;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7168;
      ["prequests"] = {
         [1] = 7168;
      };
      ["level"] = 60;
      ["name_es"] = "Honorable con la guardia";
      ["req"] = 51;
   };
   [6585] = {
      ["name_ru"] = "Черепа: Акстроз";
      ["type"] = "Raid";
      ["objective"] = "Travel to Grim Batol and track down Axtroz, drake champion of the Red Flight. Destroy him and take his skull. Return the skull to Emberstrife.";
      ["next"] = 6601;
      ["name_fr"] = "L'epreuve des cranes, Axtroz";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?骨??，埃克托?";
      ["name"] = "The Test of Skulls, Axtroz";
      ["name_de"] = "Die Prufung der Schadel, Axtroz";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 6582;
         [2] = 6584;
         [3] = 6583;
      };
      ["level"] = 60;
      ["name_es"] = "La prueba de los craneos, Axtroz";
      ["req"] = 55;
   };
   [3601] = {
      ["name_ru"] = "Оскорбленный Ким'джаель";
      ["type"] = "Solo";
      ["objective"] = " but of course";
      ["repgain"] = {
         [3] = 21;
      };
      ["name_fr"] = "Kim'jael evidemment?!";
      ["sort"] = "Azshara";
      ["name_cn"] = "我就是基姆加?！";
      ["name_de"] = "Kim'jael, furwahr!";
      ["faction"] = "Horde";
      ["name"] = "Kim'jael Indeed!";
      ["level"] = 53;
      ["name_es"] = "!Kim'jael, claro!";
      ["req"] = 47;
   };
   [4384] = {
      ["name_ru"] = "Кристалл-губитель";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallschwacher";
      ["name_fr"] = "Cristal de reduction";
      ["name_cn"] = "破甲水晶";
      ["name"] = "Crystal Yield";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11565;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "Reduccion de cristal";
      ["req"] = 47;
   };
   [5241] = {
      ["name_ru"] = "Дядюшка Карлин";
      ["type"] = "Solo";
      ["name_fr"] = "Oncle Carlin";
      ["next"] = 5211;
      ["name_de"] = "Onkel Carlin";
      ["name_cn"] = "?林叔叔";
      ["objective"] = "Find Carlin Redpath.";
      ["sort"] = "Eastern Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "Uncle Carlin";
      ["prev"] = 5149;
      ["prequests"] = {
         [1] = 5149;
      };
      ["level"] = 56;
      ["name_es"] = "Tio Carlin";
      ["req"] = 50;
   };
   [3625] = {
      ["name_ru"] = "Зачарованное азшаритовое оружие, отравленное Скверной";
      ["type"] = "Solo";
      ["name_fr"] = "Armes Fel en Azsharite enchantee";
      ["next"] = 3626;
      ["name_de"] = "Verzauberte Azsharitteufelswaffe";
      ["reward"] = {
         [1] = 10697;
         [2] = 10698;
         [3] = 10696;
      };
      ["name_cn"] = "魔化艾?拉水晶武器";
      ["objective"] = "Wait for Galvan to finish forging the weaponry.";
      ["faction"] = "Horde";
      ["name"] = "Enchanted Azsharite Fel Weaponry";
      ["sort"] = "Stranglethorn Valley";
      ["prev"] = 3621;
      ["prequests"] = {
         [1] = 3621;
      };
      ["level"] = 58;
      ["name_es"] = "Armas Fel en Azsharita encantada";
      ["req"] = 45;
   };
   [3633] = {
      ["name_ru"] = "Гоблинское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Goblin Engineering, take the Manual of Engineering Disciplines to Nixx Sprocketspring in Gadgetzan.";
      ["sort"] = "Engineering";
      ["name_cn"] = "地精工程学";
      ["name_fr"] = "Ingenierie des gobelins";
      ["followup"] = 3638;
      ["name_de"] = "Gobliningenieurskunst";
      ["faction"] = "Horde";
      ["name"] = "Goblin Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria goblin";
      ["req"] = 30;
   };
   [7281] = {
      ["name_ru"] = "Братская любовь";
      ["type"] = "PvP";
      ["objective"] = "Travel into Stormpike territory and slay Commander Karl Philips. Return to Commander Louis Philips when the task is complete.$B";
      ["repgain"] = {
         [67] = 250;
         [729] = 250;
      };
      ["name_fr"] = "Amour fraternel";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "兄弟情深";
      ["name_de"] = "Bruderliebe";
      ["faction"] = "Horde";
      ["name"] = "Brotherly Love";
      ["level"] = 60;
      ["name_es"] = "Amor fraternal";
      ["req"] = 51;
   };
   [8867] = {
      ["name_ru"] = "Лунный фейерверк";
      ["type"] = "Solo";
      ["objective"] = "Launch 8 Lunar Fireworks and 2 Cluster Fireworks and return to a Lunar Festival Harbinger at any capital city.";
      ["next"] = 8883;
      ["name_fr"] = "Le feu d'artifice lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?烟花";
      ["reward"] = {
         [1] = 21711;
      };
      ["name_de"] = "Mondfeuerwerk";
      ["faction"] = "Horde";
      ["name"] = "Lunar Fireworks";
      ["level"] = 60;
      ["name_es"] = "Fuegos artificiales lunares";
      ["req"] = 1;
   };
   [4521] = {
      ["name_ru"] = "Одичавшие стражи";
      ["type"] = "Solo";
      ["name_fr"] = "Gardiens sauvages";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Wilde Wachter";
      ["name_cn"] = "冬泉谷的??";
      ["objective"] = "Trull Failbane in Felwood wants you to kill 15 Raging Owlbeasts and 15 Ragged Owlbeasts.";
      ["next"] = 4741;
      ["sort"] = "Felwood";
      ["name"] = "Wild Guardians";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 56;
      ["name_es"] = "Guardianes salvajes";
      ["req"] = 52;
   };
   [8081] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["faction"] = "Alliance";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8080;
      ["prequests"] = {
         [1] = 8080;
      };
      ["level"] = 55;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 50;
   };
   [1384] = {
      ["name_ru"] = "Набег на племя Колкар";
      ["type"] = "Solo";
      ["name_fr"] = "Raid sur les Kolkar";
      ["next"] = 1370;
      ["name_de"] = "Uberfall auf die Kolkar";
      ["objective"] = "Maintain your reputation with the Gelkis, and bring 10 Crude Charms to Uthek the Wise in the Gelkis Village in Desolace.";
      ["name_cn"] = "突?科??";
      ["sort"] = "Desolace";
      ["faction"] = "Alliance";
      ["name"] = "Raid on the Kolkar";
      ["followup"] = 1370;
      ["prev"] = 1382;
      ["prequests"] = {
         [1] = 1382;
      };
      ["level"] = 32;
      ["name_es"] = "Asalta a los Kolkar";
      ["req"] = 30;
   };
   [7361] = {
      ["name_ru"] = "Благосклонность клана Черного Копья";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing night elf players in Alterac Valley.$B$BKill a night elf and return to Najak Hexxen at Frostwolf Keep with a Severed Night Elf Head.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "暗矛的青?";
      ["name_fr"] = "En faveur aupres des Sombrelances";
      ["name_de"] = "Die Gunst der Dunkelspeere";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Darkspear";
      ["level"] = 60;
      ["name_es"] = "Favor entre los Lanza Negra";
      ["req"] = 51;
   };
   [8874] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger in the entrance to the Undercity.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Horde";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [1508] = {
      ["name_ru"] = "Слепой Казул";
      ["type"] = "Solo";
      ["name_fr"] = "Cazul l'aveugle";
      ["next"] = 1509;
      ["name_de"] = "Der blinde Cazul";
      ["objective"] = "Speak with Zankaja in Orgrimmar.";
      ["name_cn"] = "盲眼?祖?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Blind Cazul";
      ["prev"] = 1507;
      ["prequests"] = {
         [1] = 1507;
      };
      ["level"] = 20;
      ["name_es"] = "Cazul, el ciego";
      ["req"] = 20;
   };
   [8882] = {
      ["name_ru"] = "Пусковая установка для связок фейерверков";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Le lanceur de chapelets";
      ["name_cn"] = "烟花束?射器";
      ["reward"] = {
         [1] = 21737;
         [2] = 21640;
      };
      ["name_de"] = "Zunder fur Raketenbundel";
      ["faction"] = "Horde";
      ["name"] = "Cluster Launcher";
      ["level"] = 60;
      ["name_es"] = "Lanzatracas";
      ["req"] = 55;
   };
   [7425] = {
      ["name_ru"] = "Амулеты для Оленьего Шлема";
      ["type"] = "PvP";
      ["objective"] = "";
      ["name_cn"] = "鹿?的魔精??";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Hirschhaupts Mojo-Fete";
      ["faction"] = "Alliance";
      ["name"] = "Staghelm's Mojo Jamboree";
      ["level"] = 60;
      ["name_es"] = "Colecta de mojo de Corzocelada";
      ["req"] = 55;
   };
   [3721] = {
      ["name_ru"] = "Собственный КПХ";
      ["type"] = "Solo";
      ["name_fr"] = "Un OOX rien que pour vous";
      ["repgain"] = {
         [21] = 500;
      };
      ["sort"] = "Booty Bay";
      ["name_cn"] = "?自己的OOX";
      ["objective"] = "";
      ["name"] = "An OOX of Your Own";
      ["reward"] = {
         [1] = 10398;
      };
      ["name_de"] = "Ein eigener OOX";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 648;
         [2] = 836;
         [3] = 2767;
      };
      ["level"] = 50;
      ["name_es"] = "Tu propio OOX";
      ["req"] = 45;
   };
   [8898] = {
      ["name_ru"] = "Дорогая моя Колара!";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Creased Letter to Colara Dean outside the bank in Stormwind.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的科?拉";
      ["name_fr"] = "Tres chere Colara,";
      ["name_de"] = "Liebste Colara";
      ["faction"] = "Alliance";
      ["name"] = "Dearest Colara,";
      ["level"] = 70;
      ["name_es"] = "Queridisima Colara:";
      ["req"] = 47;
   };
   [9120] = {
      ["name_ru"] = "Падение Кел'Тузада";
      ["type"] = "Solo";
      ["objective"] = "Take the Phylactery of Kel'Thuzad to Light's Hope Chapel in the Eastern Plaguelands.";
      ["name_fr"] = "La chute de Kel'Thuzad";
      ["sort"] = "Naxxramas";
      ["name_cn"] = "克??加德的末日";
      ["reward"] = {
         [1] = 23206;
         [2] = 23207;
      };
      ["name_de"] = "Der Niedergang Kel'Thuzads";
      ["faction"] = "Horde";
      ["name"] = "The Fall of Kel'Thuzad";
      ["level"] = 60;
      ["name_es"] = "La caida de Kel'Thuzad";
      ["req"] = 60;
   };
   [7489] = {
      ["name_ru"] = "Сеть Лефтендрис";
      ["type"] = "Dungeon";
      ["objective"] = "Bring Lethtendris's Web to Talo Thornhoof at Camp Mojache in Feralas.";
      ["repgain"] = {
         [76] = 350;
         [68] = 350;
         [81] = 350;
         [530] = 350;
      };
      ["name_de"] = "Lethtendris' Netz";
      ["reward"] = {
         [1] = 18491;
      };
      ["name_cn"] = "蕾瑟塔蒂?的网";
      ["name_fr"] = "Le filet de Lethtendris";
      ["faction"] = "Horde";
      ["name"] = "Lethtendris's Web";
      ["sort"] = "Dire Maul";
      ["prev"] = 7492;
      ["prequests"] = {
         [1] = 7492;
      };
      ["level"] = 57;
      ["name_es"] = "La membrana de Lethtendris";
      ["req"] = 54;
   };
   [7505] = {
      ["name_ru"] = "Ледяной шок и вы";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 200;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Le Horion de givre et vous";
      ["name_cn"] = "?与冰霜震?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 18471;
      };
      ["name_de"] = "Frostschock und Du";
      ["faction"] = "Horde";
      ["name"] = "Frost Shock and You";
      ["level"] = 60;
      ["name_es"] = "El choque de Escarcha y tu";
      ["req"] = 54;
   };
   [3761] = {
      ["name_ru"] = "Почва Ун'Горо";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Un'Goro Soil samples to Ghede on the Elder Rise of Thunder Bluff.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "La terre d'Un'Goro";
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "安戈洛的泥土";
      ["name_de"] = "Erde von Un'Goro";
      ["faction"] = "Horde";
      ["name"] = "Un'Goro Soil";
      ["level"] = 50;
      ["name_es"] = "Tierra de Un'Goro";
      ["req"] = 47;
   };
   [8909] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with 1 set of Devout Bracers to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22079;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [4484] = {
      ["name_ru"] = "Манускрипт Ненасытности";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Burning Steppes";
      ["name_fr"] = "Libram de voracite";
      ["name_cn"] = "?婪?典";
      ["reward"] = {
         [1] = 11647;
         [2] = 11648;
         [3] = 11649;
         [4] = 11645;
         [5] = 11646;
      };
      ["name_de"] = "Buchband der Gier";
      ["faction"] = "Horde";
      ["name"] = "Libram of Voracity";
      ["level"] = 55;
      ["name_es"] = "Tratado sobre Voracidad";
      ["req"] = 50;
   };
   [3785] = {
      ["name_ru"] = "Изучение рассветницы";
      ["objective"] = "Use an Evergreen Pouch with a Packet of Tharlendis Seeds and two Un'Goro Soil samples to try and cultivate samples of Morrowgrain.$B$BBring 10 Morrowgrain to Mathrengyl Bearwalker in Darnassus.";
      ["name_cn"] = "晨光麦研究";
      ["sort"] = "Darnassus";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "Recherches sur la fibre d'aurore";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Morgenkornforschung";
      ["followup"] = 3803;
      ["reward"] = {
         [1] = 11887;
      };
      ["faction"] = "Alliance";
      ["name"] = "Morrowgrain Research";
      ["prev"] = 3781;
      ["prequests"] = {
         [1] = 3781;
      };
      ["series"] = 2;
      ["name_es"] = "Investigar la managrana";
      ["req"] = 47;
   };
   [6501] = {
      ["name_ru"] = "Око дракона";
      ["type"] = "Raid";
      ["name_fr"] = "L'?il de dragon";
      ["next"] = 6502;
      ["name_de"] = "Das Grosdrachenauge";
      ["name_cn"] = "巨?之眼";
      ["objective"] = "You must search the world for a being capable of restoring the power to the Fragment of the Dragon's Eye. The only information you possess about such a being is that they exist.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "The Dragon's Eye";
      ["prev"] = 6403;
      ["prequests"] = {
         [1] = 6403;
      };
      ["level"] = 60;
      ["name_es"] = "El Ojo del Dragon";
      ["req"] = 50;
   };
   [7601] = {
      ["name_ru"] = "Что хочет Ниби";
      ["type"] = "Solo";
      ["objective"] = "Speak with Impsy in Felwood.";
      ["next"] = 7602;
      ["sort"] = "Warlock";
      ["name_cn"] = "尼比的助手";
      ["name_fr"] = "Les Commandements de Niby";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Nibys Anweisungen";
      ["faction"] = "Horde";
      ["name"] = "What Niby Commands";
      ["level"] = 50;
      ["name_es"] = "La orden de Niby";
      ["req"] = 50;
   };
   [8914] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Silithus Venom Samples and 20 gold and bring them along with a set of Beaststalker's Bindings to Mokvar in Orgrimmar.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8923;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22011;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Horde";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [7633] = {
      ["name_ru"] = "Посвящение";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hunter";
      ["name_cn"] = "介?";
      ["name_fr"] = "Une rencontre";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name_de"] = "Eine Einfuhrung";
      ["faction"] = "Horde";
      ["name"] = "An Introduction";
      ["level"] = 60;
      ["name_es"] = "Una presentacion";
      ["req"] = 60;
   };
   [3825] = {
      ["name_ru"] = "Голова огра на палочке = вечеринка";
      ["type"] = "Solo";
      ["objective"] = "Take Gor'tesh's Lopped Off Head and place it at the top of Dreadmaul Rock. Look for a soft dirt mound to plant the pike.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Ogerkopf auf einem Pfahl = Party";
      ["reward"] = {
         [1] = 11867;
         [2] = 11868;
      };
      ["name_cn"] = "?首示?";
      ["name_fr"] = "Une tete d'ogre au bout d'une pique = une fete";
      ["faction"] = "Alliance";
      ["name"] = "Ogre Head On A Stick = Party";
      ["sort"] = "Burning Steppes";
      ["prev"] = 3824;
      ["prequests"] = {
         [1] = 3824;
      };
      ["level"] = 53;
      ["name_es"] = "Una cabeza ogro empalada = FIESTA";
      ["req"] = 48;
   };
   [7665] = {
      ["name_ru"] = "Новый красный ящер";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Durotar";
      ["name_fr"] = "Remplacement de raptor rouge";
      ["name_cn"] = "?色迅猛?";
      ["reward"] = {
         [1] = 18788;
         [2] = 18789;
         [3] = 18790;
      };
      ["name_de"] = "Austausch Eures roten Raptors";
      ["faction"] = "Horde";
      ["name"] = "Red Raptor Replacement";
      ["level"] = 1;
      ["name_es"] = "Sustitucion de raptor rojo";
      ["req"] = 60;
   };
   [3841] = {
      ["name_ru"] = "Бездомный сиротка";
      ["type"] = "Solo";
      ["name_fr"] = "Un orphelin a la recherche d'un foyer";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Waise sucht Zuhause";
      ["name"] = "An Orphan Looking For a Home";
      ["name_cn"] = "??孤儿";
      ["objective"] = "Speak to Quentin in Thousand Needles.";
      ["next"] = 3842;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2972;
      ["prequests"] = {
         [1] = 2972;
      };
      ["level"] = 47;
      ["name_es"] = "Un huerfano que busca un hogar";
      ["req"] = 38;
   };
   [1242] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1243;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Delivery Jorgen's Sealed Note to Elling Trias in Stormwind City.";
      ["series"] = 3;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1241;
      ["prequests"] = {
         [1] = 1241;
      };
      ["level"] = 28;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [8371] = {
      ["name_ru"] = "В едином порыве";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Mark of Honor, 3 Arathi Basin Mark of Honor and 3 Warsong Gulch Mark of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 150;
         [730] = 200;
         [509] = 150;
      };
      ["name_fr"] = "Des efforts concertes";
      ["sort"] = "Ironforge";
      ["name_cn"] = "共同的努力";
      ["name_de"] = "Gemeinsames Bestreben";
      ["faction"] = "Alliance";
      ["name"] = "Concerted Efforts";
      ["level"] = 60;
      ["name_es"] = "Esfuerzos concertados";
      ["req"] = 51;
   };
   [7729] = {
      ["name_ru"] = "ВАКАНСИЯ: устранитель конкурентов";
      ["type"] = "Solo";
      ["objective"] = "Slay 15 Dark Iron Taskmasters and 15 Dark Iron Slavers. Return to Taskmaster Scrange in the Searing Gorge once you have accomplished this task.";
      ["repgain"] = {
         [59] = 100;
      };
      ["name_fr"] = "OFFRE D'EMPLOI?: Reduire la concurrence";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "工作机会：?清?争?手";
      ["name_de"] = "STELLE ZU VERGEBEN: Erledige die Konkurrenz";
      ["faction"] = "Horde";
      ["name"] = "JOB OPPORTUNITY: Culling the Competition";
      ["level"] = 48;
      ["name_es"] = "OPORTUNIDAD LABORAL: Acabar con la competencia";
      ["req"] = 45;
   };
   [1532] = {
      ["name_ru"] = "Зов Воздуха";
      ["type"] = "Solo";
      ["objective"] = "Find Prate Cloudseer in Thousand Needles.";
      ["name_fr"] = "L'appel de l'air";
      ["sort"] = "Shaman";
      ["name_cn"] = "空气的召?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 5178;
      };
      ["name_de"] = "Ruf der Luft";
      ["faction"] = "Horde";
      ["name"] = "Call of Air";
      ["level"] = 30;
      ["name_es"] = "La llamada del aire";
      ["req"] = 30;
   };
   [7761] = {
      ["name_ru"] = "Приказ Чернорука";
      ["type"] = "Dungeon";
      ["objective"] = "That is one stupid orc. It would appear as if you need to find this brand and gain the Mark of Drakkisath in order to access the Orb of Command.$B$BThe letter indicates that General Drakkisath guards the brand. Perhaps you should investigate.";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "黑手的命令";
      ["name_fr"] = "Les ordres de Main-noire";
      ["name_de"] = "Schwarzfausts Befehl";
      ["faction"] = "Horde";
      ["name"] = "Blackhand's Command";
      ["level"] = 60;
      ["name_es"] = "Orden de Puno Negro";
      ["req"] = 55;
   };
   [1371] = {
      ["name_ru"] = "Игрушка для Варуга";
      ["type"] = "Solo";
      ["name_fr"] = "Un bidule pour Warug";
      ["name_de"] = "Gizmo fur Warug";
      ["name_cn"] = "瓦?格的玩具";
      ["objective"] = "Maintain your reputation with the Magram, and bring an Advanced Target Dummy to Warug in the Magram Village in Desolace.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "Gizmo for Warug";
      ["prev"] = 1369;
      ["prequests"] = {
         [1] = 1369;
      };
      ["level"] = 35;
      ["name_es"] = "Un cacharro para Warug";
      ["req"] = 30;
   };
   [7793] = {
      ["name_ru"] = "Пожертвование ? шелк";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [72] = 150;
      };
      ["sort"] = "Stormwind City";
      ["name_fr"] = "Un don de soie";
      ["name_cn"] = "捐献??";
      ["followup"] = 7795;
      ["name_de"] = "Spendet Seide";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Silk";
      ["level"] = 60;
      ["name_es"] = "Un donativo de seda";
      ["req"] = 26;
   };
   [7809] = {
      ["name_ru"] = "Пожертвование ? магическая ткань";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [54] = 150;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "Un don de tisse-mage";
      ["name_cn"] = "捐献魔?布";
      ["followup"] = 7811;
      ["name_de"] = "Spendet Magiestoff";
      ["faction"] = "Alliance";
      ["name"] = "A Donation of Mageweave";
      ["level"] = 60;
      ["name_es"] = "Un donativo de tejido magico";
      ["req"] = 40;
   };
   [7825] = {
      ["name_ru"] = "Больше рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [81] = 50;
      };
      ["name_de"] = "Noch mehr Runenstoff";
      ["name_cn"] = "更多的符文布";
      ["name_fr"] = "Encore de l'etoffe runique";
      ["name"] = "Additional Runecloth";
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 7823;
      ["prequests"] = {
         [1] = 7823;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo extra de pano runico";
      ["req"] = 50;
   };
   [3921] = {
      ["name_ru"] = "Венаки Бенике";
      ["type"] = "Solo";
      ["name_fr"] = "Wenikee Bakaboulon";
      ["repgain"] = {
         [470] = 75;
         [530] = 25;
         [81] = 25;
         [76] = 25;
      };
      ["name_de"] = "Wenikee Kubelbolz";
      ["name"] = "Wenikee Boltbucket";
      ["name_cn"] = "??・布特巴克";
      ["objective"] = "Bring the Broken Samophlange to Wenikee Boltbucket.";
      ["next"] = 3922;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 902;
      ["prequests"] = {
         [1] = 902;
      };
      ["level"] = 14;
      ["name_es"] = "Wenikee Tuercasmil";
      ["req"] = 10;
   };
   [8254] = {
      ["name_ru"] = "Помощь Кенарию";
      ["type"] = "Solo";
      ["objective"] = "Seek out Ogtinc in Azshara.";
      ["next"] = 8255;
      ["sort"] = "Priest";
      ["name_cn"] = "塞?里奥?会的求助";
      ["name_fr"] = "Aider le Cercle";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name_de"] = "Cenarische Hilfe";
      ["faction"] = "Horde";
      ["name"] = "Cenarion Aid";
      ["level"] = 52;
      ["name_es"] = "Ayuda a Cenarion";
      ["req"] = 50;
   };
   [7873] = {
      ["name_ru"] = "Долой захватчиков!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者！ (PvP)";
      ["name_fr"] = "Triomphez des envahisseurs?!";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Alliance";
      ["name"] = "Vanquish the Invaders!";
      ["level"] = 55;
      ["name_es"] = "!Expulsa al invasor!";
      ["req"] = 50;
   };
   [7889] = {
      ["name_ru"] = "Зернистое грузило";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 100;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "La pierre de lest grossiere";
      ["name_cn"] = "粗制平衡石";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Grober Gewichtsstein";
      ["faction"] = "Horde";
      ["name"] = "Coarse Weightstone";
      ["level"] = 60;
      ["name_es"] = "Contrapeso burdo";
      ["req"] = 1;
   };
   [7905] = {
      ["name_ru"] = "Ярмарка Новолуния";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Free Ticket Voucher to Gelvas Grimgate, located inside the Darkmoon Faire carnival.";
      ["repgain"] = {
         [909] = 75;
      };
      ["sort"] = "Ironforge";
      ["name_fr"] = "La foire de Sombrelune";
      ["name_cn"] = "暗月???";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Der Dunkelmond-Jahrmarkt";
      ["faction"] = "Alliance";
      ["name"] = "The Darkmoon Faire";
      ["level"] = 60;
      ["name_es"] = "La Feria de la Luna Negra";
      ["req"] = 6;
   };
   [7921] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["name_fr"] = "Talismans de vaillance";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["objective"] = "You obtained a Silverwing Talisman of Merit for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Alliance";
      ["name"] = "Talismans of Merit";
      ["name_de"] = "Verdienstabzeichen";
      ["prev"] = 7788;
      ["prequests"] = {
         [1] = 7788;
      };
      ["level"] = 25;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 20;
   };
   [7937] = {
      ["name_ru"] = "Ты найдешь свою удачу...";
      ["type"] = "Solo";
      ["objective"] = " you see an image of the Eastvale Logging Camp in Elwynn Forest.  Focusing closer in on the image";
      ["repgain"] = {
         [909] = 75;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Une surprise vous attend...";
      ["name_cn"] = "?富在等着?……";
      ["reward"] = {
         [1] = 19425;
      };
      ["name_de"] = "Euer Schicksal erwartet Euch...";
      ["faction"] = "Horde";
      ["name"] = "Your Fortune Awaits You...";
      ["level"] = 60;
      ["name_es"] = "La Fortuna te espera...";
      ["req"] = 10;
   };
   [3371] = {
      ["name_ru"] = "Правосудие дворфов";
      ["type"] = "Solo";
      ["name_fr"] = "La justice des nains";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Zwergengerechtigkeit";
      ["name"] = "Dwarven Justice";
      ["name_cn"] = "矮人的正?";
      ["objective"] = "Return to the Searing Gorge and find Dorius's archaeology unit. ";
      ["next"] = 3372;
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 3368;
      ["prequests"] = {
         [1] = 3368;
      };
      ["level"] = 55;
      ["name_es"] = "La justicia de los enanos";
      ["req"] = 40;
   };
   [8924] = {
      ["name_ru"] = "В поисках эктоплазмы";
      ["type"] = "Solo";
      ["name_fr"] = "La chasse aux ectoplasmes";
      ["next"] = 8925;
      ["name_de"] = "Ektoplasmajagd";
      ["name_cn"] = "?取??";
      ["objective"] = "Use the Ectoplasmic Distiller near incorporeal undead to collect 12 Scorched Ectoplasms in Silithus, 12 Frozen Ectoplasms in Winterspring and 12 Stable Ectoplasms in the Eastern Plaguelands.  Bring them along with the Ectoplasmic Distiller back to Mux Manascrambler in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Hunting for Ectoplasm";
      ["prev"] = 8921;
      ["prequests"] = {
         [1] = 8921;
      };
      ["level"] = 60;
      ["name_es"] = "Caza de ectoplasmas";
      ["req"] = 58;
   };
   [4024] = {
      ["name_ru"] = "Вкус пламени";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Depths and slay Bael'Gar.$B$BYou only know that the giant resides inside Blackrock Depths. Remember to use the Altered Black Dragonflight Molt on Bael'Gar's remains to capture the Fiery Essence.$B$BReturn the Encased Fiery Essence to Cyrus Therepentous.$B$B";
      ["name_de"] = "Eine Kostprobe der Flamme";
      ["name_fr"] = "Un gout de flammes";
      ["reward"] = {
         [1] = 12066;
         [2] = 12082;
         [3] = 12083;
      };
      ["name_cn"] = "烈?精?";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "A Taste of Flame";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4023;
      ["prequests"] = {
         [1] = 4023;
         [2] = 4022;
      };
      ["level"] = 58;
      ["name_es"] = "Un sabor a llamarada";
      ["req"] = 52;
   };
   [4001] = {
      ["name_ru"] = "Что происходит?";
      ["objective"] = "Speak with Kharan Mighthammer and gather information about Princess Moira Bronzebeard's kidnapping. Take that information to Thrall in Orgrimmar.$B$BYou recall Gor'shak mentioning that Kharan is being held in a cell nearby.$B";
      ["name_cn"] = "出了什?事？";
      ["sort"] = "Blackrock Depths";
      ["level"] = 54;
      ["type"] = "Dungeon";
      ["name_fr"] = "Que se passe-t-il??";
      ["next"] = 4002;
      ["name_de"] = "Was ist los?";
      ["repgain"] = {
         [76] = 350;
      };
      ["faction"] = "Horde";
      ["name"] = "What Is Going On?";
      ["prev"] = 3982;
      ["prequests"] = {
         [1] = 3982;
      };
      ["series"] = 2;
      ["name_es"] = "?Que pasa?";
      ["req"] = 48;
   };
   [9032] = {
      ["name_ru"] = "Злосчастная доля Бодли";
      ["type"] = "Solo";
      ["objective"] = "Travel to Blackrock Mountain and use the Extra-Dimensional Ghost Revealer to find Bodley near Blackrock Spire.";
      ["next"] = 8961;
      ["name_fr"] = "Le triste destin de Bodley";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "布德利不幸的命?";
      ["name"] = "Bodley's Unfortunate Fate";
      ["followup"] = 8961;
      ["name_de"] = "Bodleys trauriges Schicksal";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 9016;
         [2] = 9017;
         [3] = 9018;
         [4] = 9019;
         [5] = 9020;
         [6] = 9022;
         [7] = 8957;
         [8] = 9021;
      };
      ["level"] = 60;
      ["name_es"] = "El triste destino de Bodley";
      ["req"] = 58;
   };
   [4130] = {
      ["name_ru"] = "Сверхзнание";
      ["type"] = "Solo";
      ["name_fr"] = "La lecture psychometrique";
      ["next"] = 4131;
      ["name_de"] = "Psychometrie-Sitzung";
      ["name_cn"] = "心?占卜?";
      ["objective"] = "Speak with Ginro Hearthkindle in Feathermoon Stronghold.";
      ["sort"] = "Feralas";
      ["faction"] = "Alliance";
      ["name"] = "Psychometric Reading";
      ["prev"] = 4129;
      ["prequests"] = {
         [1] = 4129;
      };
      ["level"] = 44;
      ["name_es"] = "Lectura psicometrica";
      ["req"] = 40;
   };
   [8049] = {
      ["name_ru"] = "Око Зулдазара";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "L'?il de Zuldazar";
      ["name_cn"] = "祖??之眼";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19591;
      };
      ["name_de"] = "Das Auge von Zuldazar";
      ["faction"] = "Horde";
      ["name"] = "The Eye of Zuldazar";
      ["level"] = 60;
      ["name_es"] = "El ojo de Zuldazar";
      ["req"] = 60;
   };
   [8065] = {
      ["name_ru"] = "Знаки Силы: мундир гаруспика";
      ["type"] = "Raid";
      ["objective"] = "Bring Maywiki of Zuldazar a Primal Hakkari Tabard.  Maywiki of Zuldazar is located on Yojamba Isle, Stranglethorn Vale. You must also be Revered with Zandalar.";
      ["name_fr"] = "Parangons de puissance?: la tunique d'haruspice";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：占卜?外套";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 19838;
      };
      ["name_de"] = "Symbole der Macht: Die Haruspextunika";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Haruspex's Tunic";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: la guerrera de haruspex";
      ["req"] = 60;
   };
   [4041] = {
      ["name_ru"] = "Эликсир Видере";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Feralas";
      ["name_fr"] = "L'elixir de Videre";
      ["name_cn"] = "????";
      ["reward"] = {
         [1] = 11243;
      };
      ["name_de"] = "Das Videre-Elixier";
      ["faction"] = "Horde";
      ["name"] = "The Videre Elixir";
      ["level"] = 52;
      ["name_es"] = "El Elixir de Videre";
      ["req"] = 47;
   };
   [1301] = {
      ["name_ru"] = "Джеймс Хьяль";
      ["type"] = "Solo";
      ["objective"] = "Speak with Vincent Hyal in Menethil Harbor.";
      ["next"] = 1302;
      ["name_fr"] = "James Hyal";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "詹姆斯・海厄?";
      ["series"] = 1;
      ["name_de"] = "James Hyal";
      ["faction"] = "Alliance";
      ["name"] = "James Hyal";
      ["level"] = 35;
      ["name_es"] = "James Hyal";
      ["req"] = 30;
   };
   [8113] = {
      ["name_ru"] = "Безупречные зачарованные водоросли Южных морей";
      ["objective"] = "";
      ["name_cn"] = "原始南海魔化海藻";
      ["sort"] = "Zul'Gurub";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le varech enchante des Mers du sud en parfait etat";
      ["repgain"] = {
         [270] = 100;
      };
      ["name_de"] = "Reiner verzauberter Sudmeertang";
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Horde";
      ["name"] = "Pristine Enchanted South Seas Kelp";
      ["prev"] = 8112;
      ["prequests"] = {
         [1] = 8112;
      };
      ["reward"] = {
         [1] = 19613;
      };
      ["name_es"] = "Algas de los Mares del Sur encantadas pristinas";
      ["req"] = 60;
   };
   [5042] = {
      ["name_ru"] = "Сила Агамаггана";
      ["type"] = "Solo";
      ["name_fr"] = "La force d’Agammagan";
      ["sort"] = "The Barrens";
      ["name_cn"] = "阿迦?甘的力量";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Agamaggan's Strength";
      ["name_de"] = "Agamaggans Kraft";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "La fuerza de Agamaggan";
      ["req"] = 14;
   };
   [8145] = {
      ["name_ru"] = "Нить Водоворота";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Les Vrilles du maelstrom";
      ["name_cn"] = "??之藤";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19618;
      };
      ["name_de"] = "Die Mahlstromranke";
      ["faction"] = "Horde";
      ["name"] = "The Maelstrom's Tendril";
      ["level"] = 60;
      ["name_es"] = "Zarcillo de La Voragine";
      ["req"] = 60;
   };
   [4081] = {
      ["name_ru"] = "УНИЧТОЖИТЬ НА МЕСТЕ: Дворфы Черного Железа";
      ["type"] = "Dungeon";
      ["objective"] = "Venture to Blackrock Depths and destroy the vile aggressors!$B$BWarlord Goretooth wants you to kill 15 Anvilrage Guardsmen, 10 Anvilrage Wardens and 5 Anvilrage Footmen. Return to him once your task is complete.$B$B";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "TUER A VUE?: nains Sombrefer";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "格?勿?：黑?矮人";
      ["name_de"] = "SOFORT TOTEN: Dunkeleisenzwerge";
      ["faction"] = "Horde";
      ["name"] = "KILL ON SIGHT: Dark Iron Dwarves";
      ["level"] = 52;
      ["name_es"] = "MATAR INMEDIATAMENTE: enanos Hierro Negro";
      ["req"] = 48;
   };
   [4110] = {
      ["name_ru"] = "Лекарство из оскверненных трав";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Sammlung";
      ["name_fr"] = "Du baume contre une recolte";
      ["name_cn"] = "采集??膏";
      ["name"] = "Salve via Gathering";
      ["faction"] = "Alliance";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 4105;
      ["prequests"] = {
         [1] = 4105;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por recoleccion";
      ["req"] = 48;
   };
   [1025] = {
      ["name_ru"] = "Лучшая защита ? нападение";
      ["type"] = "Solo";
      ["objective"] = "Kill 1 Den Watcher, 2 Ursas, 10 Totemics, and 12 Warriors of the Foulweald tribe, and then return to Raene Wolfrunner in Astranaar.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Eine aggressive Verteidigung";
      ["reward"] = {
         [1] = 4542;
         [2] = 1205;
      };
      ["name_cn"] = "先?制人";
      ["name_fr"] = "Une defense agressive";
      ["faction"] = "Alliance";
      ["name"] = "An Aggressive Defense";
      ["sort"] = "Ashenvale";
      ["prev"] = 1023;
      ["prequests"] = {
         [1] = 1023;
      };
      ["level"] = 24;
      ["name_es"] = "Una defensa agresiva";
      ["req"] = 18;
   };
   [1029] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Ruckkehr zu Raene";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Return to Raene Wolfrunner in Astranaar.";
      ["next"] = 1030;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1055;
      ["prequests"] = {
         [1] = 1055;
      };
      ["level"] = 28;
      ["name_es"] = "Regresa con Raene";
      ["req"] = 18;
   };
   [1033] = {
      ["name_ru"] = "Слеза Элуны";
      ["type"] = "Solo";
      ["name_fr"] = "Larme d'Elune";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Elunes Trane";
      ["name_cn"] = "月神之泪";
      ["name"] = "Elune's Tear";
      ["objective"] = "Bring Elune's Tear to Pelturas in Astranaar.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1020;
      ["prequests"] = {
         [1] = 1020;
      };
      ["level"] = 22;
      ["name_es"] = "Lagrima de Elune";
      ["req"] = 20;
   };
   [1037] = {
      ["name_ru"] = "Велинда Песнь Звезд";
      ["type"] = "Solo";
      ["name_fr"] = "Velinde Chantetoile";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_de"] = "Velinde Sternensang";
      ["name"] = "Velinde Starsong";
      ["name_cn"] = "?琳德・星歌";
      ["objective"] = "Speak with Thyn'tel Bladeweaver at the Warrior's Terrace in Darnassus.";
      ["next"] = 1038;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1022;
      ["prequests"] = {
         [1] = 1022;
      };
      ["level"] = 30;
      ["name_es"] = "Velinde Cantoestelar";
      ["req"] = 25;
   };
   [1041] = {
      ["name_ru"] = "Путь каравана";
      ["type"] = "Solo";
      ["name_fr"] = "La route de la caravane";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Die Karawanenstrase";
      ["name"] = "The Caravan Road";
      ["name_cn"] = "商?通路";
      ["objective"] = "Speak with Clerk Daltry in Darkshire.";
      ["next"] = 1042;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1040;
      ["prequests"] = {
         [1] = 1040;
      };
      ["level"] = 30;
      ["name_es"] = "La ruta de la caravana";
      ["req"] = 25;
   };
   [1045] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Eine neue Verzierung";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Kill Ran Bloodtooth and 4 Bloodtooth Guards and return to Krolg near Lake Mystral.";
      ["next"] = 1046;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1030;
      ["prequests"] = {
         [1] = 1030;
      };
      ["level"] = 30;
      ["name_es"] = "Un nuevo adorno";
      ["req"] = 18;
   };
   [1049] = {
      ["name_ru"] = "\"Компендиум павших\"";
      ["type"] = "Dungeon";
      ["objective"] = "Retrieve the Compendium of the Fallen from the Monastery in Tirisfal Glades and return to Sage Truthseeker in Thunder Bluff.";
      ["repgain"] = {
         [81] = 350;
      };
      ["sort"] = "Scarlet Monastery";
      ["name_fr"] = "Compendium des Dechus";
      ["name_cn"] = "堕落者?要";
      ["reward"] = {
         [1] = 7747;
         [2] = 17508;
         [3] = 7749;
      };
      ["name_de"] = "Kompendium der Gefallenen";
      ["faction"] = "Horde";
      ["name"] = "Compendium of the Fallen";
      ["level"] = 38;
      ["name_es"] = "El Compendio de los Caidos";
      ["req"] = 28;
   };
   [1053] = {
      ["name_ru"] = "Во имя Света!";
      ["type"] = "Dungeon";
      ["objective"] = "Kill High Inquisitor Whitemane, Scarlet Commander Mograine,  Herod, the Scarlet Champion and Houndmaster Loksey and then report back to Raleigh the Devout in Southshore.";
      ["repgain"] = {
         [72] = 500;
      };
      ["name_de"] = "Im Namen des Lichts";
      ["reward"] = {
         [1] = 6829;
         [2] = 6830;
         [3] = 6831;
         [4] = 11262;
      };
      ["name_cn"] = "以?光之名";
      ["name_fr"] = "Au nom de la Lumiere";
      ["faction"] = "Alliance";
      ["name"] = "In the Name of the Light";
      ["sort"] = "Scarlet Monastery";
      ["prev"] = 1052;
      ["prequests"] = {
         [1] = 1052;
      };
      ["level"] = 40;
      ["name_es"] = "En el nombre de la Luz";
      ["req"] = 34;
   };
   [1057] = {
      ["name_ru"] = "Возвращение Обугленной долины";
      ["type"] = "Solo";
      ["name_fr"] = "A la reconquete du Val calcine";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Die Ruckeroberung des Verbrannten Tals";
      ["name_cn"] = "?回焦炭谷";
      ["objective"] = "Keeper Albagorm on Stonetalon Peak wants you to slay 7 Bloodfury Harpies, 7 Bloodfury Ambushers, 7 Bloodfury Slayers and 7 Bloodfury Roguefeathers.";
      ["next"] = 1059;
      ["sort"] = "Stonetalon Mountains";
      ["name"] = "Reclaiming the Charred Vale";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 27;
      ["name_es"] = "La reconquista de La Vega Carbonizada";
      ["req"] = 20;
   };
   [1061] = {
      ["name_ru"] = "Духи Каменного Когтя";
      ["type"] = "Solo";
      ["objective"] = "Speak with Seereth Stonebreak in the Stonetalon Mountains.";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_fr"] = "Les esprits des Serres-Rocheuses";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "石爪之?";
      ["name_de"] = "Die Geister des Steinkrallengebirges";
      ["faction"] = "Horde";
      ["name"] = "The Spirits of Stonetalon";
      ["level"] = 17;
      ["name_es"] = "Los espiritus del Espolon";
      ["req"] = 13;
   };
   [1065] = {
      ["name_ru"] = "Путешествие на Мельницу Таррен";
      ["type"] = "Solo";
      ["name_fr"] = "Un voyage vers Moulin-de-Tarren";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Reise nach Tarrens Muhle";
      ["name"] = "Journey to Tarren Mill";
      ["name_cn"] = "塔?米?之旅";
      ["objective"] = "Bring Zamah's Note to Apothecary Lydon in Tarren Mill.";
      ["next"] = 1066;
      ["faction"] = "Horde";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 1064;
      ["prequests"] = {
         [1] = 1064;
      };
      ["level"] = 18;
      ["name_es"] = "Viaja a Molino Tarren";
      ["req"] = 13;
   };
   [1069] = {
      ["name_ru"] = "Яйца мохового паука";
      ["type"] = "Solo";
      ["objective"] = "Bring 15 Deepmoss Eggs to Mebok Mizzyrix in Ratchet.";
      ["repgain"] = {
         [470] = 350;
      };
      ["name_fr"] = "Omelette a la mousse profonde";
      ["sort"] = "The Barrens";
      ["name_cn"] = "深苔蜘蛛的卵";
      ["name_de"] = "Eier der Kluftmoosspinnen";
      ["faction"] = "Horde";
      ["name"] = "Deepmoss Spider Eggs";
      ["level"] = 20;
      ["name_es"] = "Huevos de aranas Musgondo";
      ["req"] = 15;
   };
   [8578] = {
      ["name_ru"] = "Гадальные очки? Без проблем!";
      ["type"] = "Raid";
      ["objective"] = "Find Narain's Scrying Goggles and return them to Narain Soothfancy in Tanaris.";
      ["repgain"] = {
         [910] = 10;
      };
      ["name_de"] = "Wahrsagerbrille? Kein Problem!";
      ["reward"] = {
         [1] = 18253;
      };
      ["name_cn"] = "占卜眼?？没??！";
      ["name_fr"] = "Des lunettes d'observation?? Aucun probleme?!";
      ["faction"] = "Horde";
      ["name"] = "Scrying Goggles? No Problem!";
      ["sort"] = "Molten Core";
      ["prev"] = 8577;
      ["prequests"] = {
         [1] = 8577;
      };
      ["level"] = 60;
      ["name_es"] = "?Unas gafas? !Sin problemas!";
      ["req"] = 60;
   };
   [1077] = {
      ["name_ru"] = "Особая посылка для Гаксима";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison speciale pour Gaxim";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Speziallieferung fur Gaxim";
      ["followup"] = 1079;
      ["name_cn"] = "?加克希姆的特快??";
      ["objective"] = "Bring the Scroll of Messaging to Gaxim Rustfizzle in Stonetalon.";
      ["faction"] = "Alliance";
      ["name"] = "Special Delivery for Gaxim";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1076;
      ["prequests"] = {
         [1] = 1076;
      };
      ["level"] = 21;
      ["name_es"] = "Entrega especial para Gaxim";
      ["req"] = 17;
   };
   [4322] = {
      ["name_ru"] = "Побег!";
      ["objective"] = "Help Marshal Windsor get his gear back and free his friends. Return to Marshal Maxwell if you succeed.";
      ["name_cn"] = "冲破牢?！";
      ["sort"] = "Blackrock Depths";
      ["level"] = 58;
      ["type"] = "Dungeon";
      ["name_fr"] = "Evasion?!";
      ["next"] = 6402;
      ["name_de"] = "Gefangnisausbruch!";
      ["repgain"] = {
         [72] = 350;
      };
      ["reward"] = {
         [1] = 12061;
         [2] = 12065;
         [3] = 12062;
      };
      ["name"] = "Jail Break!";
      ["prev"] = 4282;
      ["prequests"] = {
         [1] = 4282;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "La fuga de la prision";
      ["req"] = 50;
   };
   [1085] = {
      ["name_ru"] = "На страже в Когтистых горах";
      ["type"] = "Solo";
      ["objective"] = "Speak to Gaxim.";
      ["next"] = 1071;
      ["name_fr"] = "De garde dans les Serres-Rocheuses";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "守?石爪山";
      ["repgain"] = {
         [54] = 25;
      };
      ["name_de"] = "Wache halten im Steinkrallengebirge";
      ["faction"] = "Alliance";
      ["name"] = "On Guard in Stonetalon";
      ["level"] = 21;
      ["name_es"] = "Estar de guardia en Espolon";
      ["req"] = 17;
   };
   [8706] = {
      ["name_ru"] = "Молот Надвигающейся бури";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Spiked Hilt, 2  Amber Idols, 5 Ivory Scarabs and 5 Bronze Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le marteau de la tempete imminente";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "聚集?暴之?";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 21398;
      };
      ["name_de"] = "Hammer der aufziehenden Sturme";
      ["faction"] = "Horde";
      ["name"] = "Hammer of the Gathering Storm";
      ["level"] = 60;
      ["name_es"] = "El martillo de la tormenta inminente";
      ["req"] = 60;
   };
   [1093] = {
      ["name_ru"] = "Супер-дровосек 6000";
      ["type"] = "Solo";
      ["objective"] = "Get the Super Reaper 6000 Blueprints for Ziz Fizziks in the Stonetalon Mountains.";
      ["next"] = 1094;
      ["name_fr"] = "Super-Decoupeur 6000";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "超?收割机6000";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Superschnitter 6000";
      ["faction"] = "Horde";
      ["name"] = "Super Reaper 6000";
      ["level"] = 21;
      ["name_es"] = "Super Segadora 6000";
      ["req"] = 16;
   };
   [8770] = {
      ["name_ru"] = "Цель: защитники из Улья Аши";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Ashi Defenders and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing I in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif : les defenseurs de la Ruche'Ashi";
      ["name_cn"] = "目?：?什工蝎";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Verteidiger des Ashischwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Ashi Defenders";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los defensores Colmen'Ashi";
      ["req"] = 60;
   };
   [4402] = {
      ["name_ru"] = "Кактусовый десерт Галгара";
      ["type"] = "Solo";
      ["objective"] = "Bring Galgar 10 Cactus Apples. You remember him saying that they could be found near cactuses.";
      ["repgain"] = {
         [530] = 500;
         [76] = 500;
      };
      ["name_de"] = "Galgars Kaktusapfel Surprise";
      ["reward"] = {
         [1] = 11584;
      };
      ["name_cn"] = "戈加?的清凉果";
      ["name_fr"] = "Surprise aux pommes de cactus de Galgar";
      ["faction"] = "Horde";
      ["name"] = "Galgar's Cactus Apple Surprise";
      ["sort"] = "Valley of Trials";
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 3;
      ["name_es"] = "Sorpresa de manzanas de cactus de Galgar";
      ["req"] = 1;
   };
   [8834] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8812;
      ["prequests"] = {
         [1] = 8812;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8866] = {
      ["name_ru"] = "Предок Бронзобород";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Barbe-de-bronze";
      ["name_cn"] = "???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Bronzebart";
      ["faction"] = "Horde";
      ["name"] = "Bronzebeard the Elder";
      ["level"] = 60;
      ["name_es"] = "Barbabronce el Ancestro";
      ["req"] = 1;
   };
   [4450] = {
      ["name_ru"] = "Учетная книга из Танариса";
      ["type"] = "Solo";
      ["objective"] = "Take the copy of Goodsteel's Ledger and then find the items listed in it before seeking Krinkle Goodsteel in Tanaris.";
      ["repgain"] = {
         [369] = 350;
      };
      ["name_de"] = "Geschaftsbuch aus Tanaris";
      ["reward"] = {
         [1] = 11860;
         [2] = 11861;
      };
      ["name_cn"] = "塔?利斯的?本";
      ["name_fr"] = "Grand livre de Tanaris";
      ["faction"] = "Horde";
      ["name"] = "Ledger from Tanaris";
      ["sort"] = "Searing Gorge";
      ["prev"] = 4449;
      ["prequests"] = {
         [1] = 4449;
      };
      ["level"] = 46;
      ["name_es"] = "El libro de contabilidad de Tanaris";
      ["req"] = 43;
   };
   [4466] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [1121] = {
      ["name_ru"] = "Напоить гоблинов";
      ["type"] = "Solo";
      ["name_fr"] = "Saoulez les gobelins";
      ["name_de"] = "Die Goblins betrunken machen";
      ["objective"] = "Bring the Fool's Stout to the Goblin Pit Boss.";
      ["name_cn"] = "灌醉地精";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Get the Goblins Drunk";
      ["followup"] = 1122;
      ["prev"] = 1119;
      ["prequests"] = {
         [1] = 1119;
      };
      ["level"] = 44;
      ["name_es"] = "Emborrachar a los goblins";
      ["req"] = 35;
   };
   [1125] = {
      ["name_ru"] = "Духи Южного Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "Les esprits de Sudevent";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Die Geister vom Sudwindposten";
      ["name"] = "The Spirits of Southwind";
      ["name_cn"] = "南?村的?魂";
      ["objective"] = "Free the spirits of 8 Tortured Druids and 8 Tortured Sentinels in Southwind Village, and then return to Layo Starstrike at the Valor's Rest graveyard of Silithus.";
      ["next"] = 1126;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 1124;
      ["prequests"] = {
         [1] = 1124;
      };
      ["level"] = 55;
      ["name_es"] = "Los espiritus de Viento del Sur";
      ["req"] = 54;
   };
   [9026] = {
      ["name_ru"] = "Поиск источника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Innkeeper Allison at The Gilded Rose in Stormwind's Trade District.";
      ["next"] = 9027;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "追??源";
      ["name_fr"] = "Remonter a la source";
      ["name_de"] = "Verfolgung der Spur";
      ["faction"] = "Horde";
      ["name"] = "Tracing the Source";
      ["level"] = 0;
      ["name_es"] = "Rastrear la fuente";
      ["req"] = 18;
   };
   [1133] = {
      ["name_ru"] = "Путешествие в Астранаар";
      ["type"] = "Solo";
      ["name_fr"] = "Le voyage vers Astranaar";
      ["name_de"] = "Reise nach Astranaar";
      ["name_cn"] = "通往阿斯特??的旅途";
      ["objective"] = "Speak with Shindrell Swiftfire in Astranaar.";
      ["sort"] = "Darkshore";
      ["faction"] = "Alliance";
      ["name"] = "Journey to Astranaar";
      ["prev"] = 1132;
      ["prequests"] = {
         [1] = 1132;
      };
      ["level"] = 20;
      ["name_es"] = "Viaje a Astranaar";
      ["req"] = 18;
   };
   [1137] = {
      ["name_ru"] = "Новости для Пшикса";
      ["type"] = "Solo";
      ["name_fr"] = "Des nouvelles pour Feplouf";
      ["name_de"] = "Neuigkeiten fur Fizzel";
      ["reward"] = {
         [1] = 6729;
         [2] = 6732;
      };
      ["name_cn"] = "回?菲??";
      ["objective"] = "Speak with Fizzle Brassbolts in the Shimmering Flats.";
      ["faction"] = "Horde";
      ["name"] = "News for Fizzle";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1108;
      ["prequests"] = {
         [1] = 1108;
      };
      ["level"] = 38;
      ["name_es"] = "Noticias para Fizzle";
      ["req"] = 28;
   };
   [1141] = {
      ["name_ru"] = "Семья и рыболовная удочка";
      ["type"] = "Solo";
      ["objective"] = "Catch 6 Darkshore Grouper for Gubber Blump in Auberdine.";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "La famille a la canne a peche";
      ["name_cn"] = "??世家";
      ["reward"] = {
         [1] = 12225;
      };
      ["name_de"] = "Die Familie und die Angelrute";
      ["faction"] = "Alliance";
      ["name"] = "The Family and the Fishing Pole";
      ["level"] = 14;
      ["name_es"] = "La familia y la cana de pescar";
      ["req"] = 10;
   };
   [1145] = {
      ["name_ru"] = "Рой растет";
      ["type"] = "Solo";
      ["name_fr"] = "L'essaim s'agrandit";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Der Schwarm wachst";
      ["name_cn"] = "?狂的虫群";
      ["objective"] = "Deliver Korran's Sealed Note to Belgrom Rockmaul in Orgrimmar.";
      ["next"] = 1146;
      ["sort"] = "The Barrens";
      ["name"] = "The Swarm Grows";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 33;
      ["name_es"] = "El enjambre crece";
      ["req"] = 29;
   };
   [1149] = {
      ["name_ru"] = "Испытание веры";
      ["type"] = "Solo";
      ["objective"] = "If you have faith, leap from the planks overlooking Thousand Needles.";
      ["next"] = 1150;
      ["name_fr"] = "L'epreuve de la Foi";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "信仰的??";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Test des Glaubens";
      ["faction"] = "Horde";
      ["name"] = "Test of Faith";
      ["level"] = 26;
      ["name_es"] = "Prueba de fe";
      ["req"] = 25;
   };
   [1153] = {
      ["name_ru"] = "Образец новой руды";
      ["type"] = "Solo";
      ["objective"] = "Find an Unrefined Ore Sample on a Gravelsnout Digger or Surveyor and bring it to Tatternack Steelforge at Camp Taurajo in the Barrens.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Eine neue Erzprobe";
      ["reward"] = {
         [1] = 6741;
      };
      ["name_cn"] = "新的?石?本";
      ["name_fr"] = "Un nouveau minerai";
      ["faction"] = "Horde";
      ["name"] = "A New Ore Sample";
      ["sort"] = "The Barrens";
      ["prev"] = 893;
      ["prequests"] = {
         [1] = 893;
      };
      ["level"] = 29;
      ["name_es"] = "Una nueva muestra de mineral";
      ["req"] = 25;
   };
   [9250] = {
      ["name_ru"] = "Основа Атиеша";
      ["type"] = "Raid";
      ["objective"] = "Find someone that will help you in recovering the last two pieces of the staff and ridding it of evil.";
      ["next"] = 9251;
      ["sort"] = "Legendary";
      ["name_cn"] = "埃提耶什之杖";
      ["name_fr"] = "La hampe d'Atiesh";
      ["name_de"] = "Grundstab von Atiesh";
      ["faction"] = "Horde";
      ["name"] = "Frame of Atiesh";
      ["level"] = 60;
      ["name_es"] = "Cuerpo de Atiesh";
      ["req"] = 60;
   };
   [4642] = {
      ["name_ru"] = "Слияние";
      ["type"] = "Solo";
      ["name_fr"] = "Trafic d'influences";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Vereinigung von Einflussen";
      ["name_cn"] = "融合?泥怪";
      ["reward"] = {
         [1] = 15702;
         [2] = 15703;
      };
      ["objective"] = "Bring a Merged Ooze Sample to Chemist Fuely in Undercity.";
      ["name"] = "Melding of Influences";
      ["sort"] = "Undercity";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 4293;
         [2] = 4294;
      };
      ["level"] = 55;
      ["name_es"] = "Fusion de influencias";
      ["req"] = 48;
   };
   [3124] = {
      ["name_ru"] = "Уменьшенный гиппогриф";
      ["type"] = "Solo";
      ["name_fr"] = "L'hippogriffe miniaturise";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Muisek von Hippogryphen";
      ["name"] = "Hippogryph Muisek";
      ["name_cn"] = "角???魂精?";
      ["objective"] = "Kill 10 Frayfeather Hippogryphs of any type, then use the Muisek Vessel to shrink and capture them.";
      ["next"] = 3125;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 3123;
      ["prequests"] = {
         [1] = 3123;
      };
      ["level"] = 47;
      ["name_es"] = "Muisek de hipogrifo";
      ["req"] = 40;
   };
   [1169] = {
      ["name_ru"] = "Корни угрозы";
      ["type"] = "Solo";
      ["objective"] = "Draz'Zilb in Brackenwall Village would like you to bring him 15 Searing Tongues and 15 Searing Hearts.";
      ["next"] = 1170;
      ["name_fr"] = "Identification de la portee";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "群?之首";
      ["reward"] = {
         [1] = 9703;
         [2] = 9704;
      };
      ["name_de"] = "[DEPRECATED] Die Brut identifizieren";
      ["faction"] = "Horde";
      ["name"] = "Identifying the Brood";
      ["level"] = 43;
      ["name_es"] = "Identifica a los cachorros";
      ["req"] = 38;
   };
   [1173] = {
      ["name_ru"] = "Вызов властителю Мок'Морокку";
      ["type"] = "Group";
      ["name_fr"] = "Defier le Seigneur Mok'Morokk";
      ["name_de"] = "[DEPRECATED] Fordert Oberanfuhrer Mok'Morokk heraus";
      ["reward"] = {
         [1] = 10703;
         [2] = 10704;
      };
      ["name_cn"] = "挑?莫格穆洛克";
      ["objective"] = "Defeat Mok'Morokk and report the news to Draz'Zilb in Brackenwall Village.";
      ["faction"] = "Horde";
      ["name"] = "Challenge Overlord Mok'Morokk";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1172;
      ["prequests"] = {
         [1] = 1172;
      };
      ["level"] = 45;
      ["name_es"] = "Desafiar al senor supremo Mok'Morokk";
      ["req"] = 38;
   };
   [1177] = {
      ["name_ru"] = "Моя голодный!";
      ["type"] = "Solo";
      ["objective"] = "Mudcrush Durtfeet in northern Dustwallow wants 8 Mirefin Heads.";
      ["name_fr"] = "Faim?!";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?！";
      ["reward"] = {
         [1] = 9518;
         [2] = 9519;
      };
      ["name_de"] = "Hunger!";
      ["faction"] = "Horde";
      ["name"] = "Hungry!";
      ["level"] = 36;
      ["name_es"] = "!Que hambre!";
      ["req"] = 32;
   };
   [1181] = {
      ["name_ru"] = "Гоблинская поддержка";
      ["type"] = "Solo";
      ["name_fr"] = "Mecenat gobelin";
      ["next"] = 1182;
      ["name_de"] = "Goblinsponsoring";
      ["name"] = "Goblin Sponsorship";
      ["name_cn"] = "地精?助商";
      ["objective"] = "Speak with Baron Revilgaz in Booty Bay.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1180;
      ["prequests"] = {
         [1] = 1180;
      };
      ["level"] = 37;
      ["name_es"] = "Patrocinio goblin";
      ["req"] = 29;
   };
   [4738] = {
      ["name_ru"] = "Поиски Менары Расщепительницы Бездны";
      ["type"] = "Solo";
      ["objective"] = "Speak with Menara Voidrender in the Barrens.";
      ["next"] = 1796;
      ["sort"] = "Warlock";
      ["name_cn"] = "?找梅?拉・沃?德";
      ["name_fr"] = "A la recherche de Menara Taillevide";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Auf der Suche nach Menara Leerbringer";
      ["faction"] = "Alliance";
      ["name"] = "In Search of Menara Voidrender";
      ["level"] = 31;
      ["name_es"] = "Buscando a Menara Nadiz";
      ["req"] = 31;
   };
   [1189] = {
      ["name_ru"] = "Безопасность превыше всего";
      ["objective"] = "Return the Modified Seaforium Booster to Razzeric on the Shimmering Flats.";
      ["name_cn"] = "安全第一";
      ["sort"] = "Thousand Needles";
      ["level"] = 41;
      ["type"] = "Solo";
      ["name_fr"] = "La securite d'abord";
      ["repgain"] = {
         [470] = 25;
      };
      ["name_de"] = "Sicherheit zuerst";
      ["reward"] = {
         [1] = 6726;
         [2] = 6727;
      };
      ["faction"] = "Horde";
      ["name"] = "Safety First";
      ["prev"] = 1188;
      ["prequests"] = {
         [1] = 1188;
      };
      ["series"] = 2;
      ["name_es"] = "La seguridad primero";
      ["req"] = 29;
   };
   [4770] = {
      ["name_ru"] = "Путь домой";
      ["type"] = "Solo";
      ["objective"] = "Escort Pao'ka Swiftmountain from Highperch, and then talk to Motega Firemane in Whitereach Post.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Vers le pays natal";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "回家";
      ["name_de"] = "Auf der Heimreise";
      ["faction"] = "Horde";
      ["name"] = "Homeward Bound";
      ["level"] = 29;
      ["name_es"] = "De vuelta a casa";
      ["req"] = 25;
   };
   [4786] = {
      ["name_ru"] = "Завершенное одеяние";
      ["type"] = "Solo";
      ["name_fr"] = "La Robe terminee";
      ["name_de"] = "Die fertiggestellte Robe";
      ["objective"] = "Wait for Menara Voidrender to complete your robe and then speak to her again.";
      ["reward"] = {
         [1] = 6900;
      };
      ["name_cn"] = "完成金?血袍";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Completed Robe";
      ["sort"] = "Warlock";
      ["prev"] = 4784;
      ["prequests"] = {
         [1] = 4784;
      };
      ["level"] = 38;
      ["name_es"] = "Toga terminada";
      ["req"] = 31;
   };
   [4802] = {
      ["name_ru"] = "Э'ко фурболгов племени Зимней Спячки";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Winterfelle";
      ["name_fr"] = "L'E'ko des Tombe-hiver";
      ["name_cn"] = "寒水魂精";
      ["name"] = "Winterfall E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12451;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko Nevada";
      ["req"] = 55;
   };
   [1205] = {
      ["name_ru"] = "Зыбун";
      ["type"] = "Solo";
      ["objective"] = "Bring Deadmire's Tooth to Melor in Thunder Bluff.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_fr"] = "Mortebourbe";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "死沼巨?";
      ["name_de"] = "Schlammwuhler";
      ["faction"] = "Horde";
      ["name"] = "Deadmire";
      ["level"] = 45;
      ["name_es"] = "Lodomuerto";
      ["req"] = 35;
   };
   [7401] = {
      ["name_ru"] = "Разыскиваются: ДВОРФЫ!";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing Dwarf players in Alterac Valley.$B$BKill a Dwarf and rip out their spine. Take the Dwarf Spine to Sergeant Yazra Bloodsnarl at Frostwolf Keep.";
      ["repgain"] = {
         [530] = 250;
      };
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "通?：矮人！";
      ["name_de"] = "GESUCHT: ZWERGE!";
      ["faction"] = "Horde";
      ["name"] = "Wanted: DWARVES!";
      ["level"] = 60;
      ["name_es"] = "Se buscan: !ENANOS!";
      ["req"] = 51;
   };
   [1124] = {
      ["name_ru"] = "Пустошь";
      ["type"] = "Solo";
      ["name_fr"] = "La devastation";
      ["repgain"] = {
         [609] = 75;
      };
      ["name_de"] = "Einode";
      ["name_cn"] = "?土";
      ["objective"] = "Speak with Layo Starstrike near the Valor's Rest graveyard of Silithus, showing him Rabine's Letter.";
      ["next"] = 1125;
      ["sort"] = "Moonglade";
      ["name"] = "Wasteland";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 6762;
         [2] = 1123;
      };
      ["level"] = 55;
      ["name_es"] = "Paramo";
      ["req"] = 54;
   };
   [4866] = {
      ["name_ru"] = "Материнское молоко";
      ["type"] = "Dungeon";
      ["objective"] = "In the heart of Blackrock Spire you will find Mother Smolderweb. Engage her and get her to poison you. Chances are good that you will have to kill her as well. Return to Ragged John when you are poisoned so that he can 'milk' you.";
      ["name_fr"] = "Le lait matriarcal";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "蛛后的乳汁";
      ["reward"] = {
         [1] = 15873;
      };
      ["name_de"] = "Muttermilch";
      ["faction"] = "Horde";
      ["name"] = "Mother's Milk";
      ["level"] = 60;
      ["name_es"] = "La leche de la madre";
      ["req"] = 55;
   };
   [1221] = {
      ["name_ru"] = "Корни Синелиста";
      ["type"] = "Dungeon";
      ["objective"] = "Grab a Crate with Holes.$BGrab a Snufflenose Command Stick.$BGrab and read the Snufflenose Owner's Manual.$B$BIn Razorfen Kraul, use the Crate with Holes to summon a Snufflenose Gopher, and use the Command Stick on the gopher to make it search for Tubers.$B$BBring 6 Blueleaf Tubers, the Snufflenose Command Stick and the Crate with Holes to Mebok Mizzyrix in Ratchet.";
      ["repgain"] = {
         [470] = 250;
      };
      ["sort"] = "Razorfen Kraul";
      ["name_fr"] = "Racines de Feuillebleue";
      ["name_cn"] = "?叶薯";
      ["reward"] = {
         [1] = 6755;
      };
      ["name_de"] = "Blaulaubknollen";
      ["faction"] = "Horde";
      ["name"] = "Blueleaf Tubers";
      ["level"] = 26;
      ["name_es"] = "Los tuberculos hojazul";
      ["req"] = 20;
   };
   [8952] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Beaststalker's Boots, Beaststalker's Pants and Beaststalker's Mantle.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22061;
         [2] = 22017;
         [3] = 22016;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [6183] = {
      ["name_ru"] = "Поминовение усопших";
      ["type"] = "Group";
      ["name_fr"] = "Honorer la mort";
      ["repgain"] = {
         [72] = 1;
      };
      ["name_de"] = "Ehret die Toten";
      ["name"] = "Honor the Dead";
      ["name_cn"] = "逝者的?耀";
      ["objective"] = " and \"Blightcaller.\"$B$BI do not have the available manpower to continue this investigation and Ravenholdt will not assist us. We must get to the bottom of this; if only to provide closure to the families of the deceased. Will you help?\"";
      ["next"] = 6184;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 6182;
      ["prequests"] = {
         [1] = 6182;
      };
      ["level"] = 60;
      ["name_es"] = "Honra a los muertos";
      ["req"] = 56;
   };
   [1649] = {
      ["name_ru"] = "Фолиант Отваги";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["next"] = 1650;
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["name_cn"] = "勇气之?";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Tome of Valor";
      ["series"] = 1;
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 20;
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [2766] = {
      ["name_ru"] = "Найти КПХ-22/FE!";
      ["type"] = "Solo";
      ["objective"] = " and my homing robot has crashed!  I will reward you for its recovery; please take this beacon to the robot!\"$B$B\"I now have computed the coordinates of the robot for you; it is in a cave near Feral Scar Vale!\"\"";
      ["next"] = 2767;
      ["name_fr"] = "Trouvez OOX-22/FE?!";
      ["sort"] = "Feralas";
      ["name_cn"] = "?找OOX-22/FE！";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Findet OOX-22/FE!";
      ["faction"] = "Horde";
      ["name"] = "Find OOX-22/FE!";
      ["level"] = 45;
      ["name_es"] = "!Encuentra a OOX-22/FE!";
      ["req"] = 40;
   };
   [1241] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1242;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Find Jorgen in Stormwind City.";
      ["series"] = 2;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1274;
      ["prequests"] = {
         [1] = 1274;
      };
      ["level"] = 28;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1245] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1246;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Bring the Defias Docket to Elling Trias in Stormwind.";
      ["series"] = 6;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1244;
      ["prequests"] = {
         [1] = 1244;
      };
      ["level"] = 30;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1249] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["objective"] = "Subdue Tapoke Jahn before he escapes, and then return to Mikhail in Menethil.";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["name_fr"] = "Un diplomate a disparu";
      ["series"] = 11;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1248;
      ["prequests"] = {
         [1] = 1248;
      };
      ["level"] = 33;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1253] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["objective"] = "Bring the Blackened Iron Shield to Captain Garran Vimes in Theramore.";
      ["next"] = 1319;
      ["name_fr"] = "Le Bouclier noir";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "黑色盾牌";
      ["series"] = 1;
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["faction"] = "Alliance";
      ["name"] = "The Black Shield";
      ["level"] = 35;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [8960] = {
      ["name_ru"] = "Злосчастная доля Бодли";
      ["type"] = "Solo";
      ["objective"] = "Travel to Blackrock Mountain and use the Extra-Dimensional Ghost Revealer to find Bodley near Blackrock Spire.";
      ["next"] = 8961;
      ["name_fr"] = "Le triste destin de Bodley";
      ["sort"] = "Blackrock Mountain";
      ["name_cn"] = "伯德雷的不幸";
      ["name"] = "Bodley's Unfortunate Fate";
      ["followup"] = 8961;
      ["name_de"] = "Bodleys trauriges Schicksal";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 8951;
         [2] = 8953;
         [3] = 8954;
         [4] = 8955;
         [5] = 8958;
         [6] = 8959;
         [7] = 8952;
         [8] = 8956;
      };
      ["level"] = 60;
      ["name_es"] = "El triste destino de Bodley";
      ["req"] = 58;
   };
   [1261] = {
      ["name_ru"] = "Марг говорит";
      ["type"] = "Solo";
      ["name_fr"] = "Marg parle";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Marg spricht";
      ["name"] = "Marg Speaks";
      ["name_cn"] = "??格的嘱托";
      ["objective"] = "Bring the Jeweled Pendant to Nazeer in Brackenwall Village.";
      ["next"] = 1262;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1240;
      ["prequests"] = {
         [1] = 1240;
      };
      ["level"] = 40;
      ["name_es"] = "Las declaraciones de Marg";
      ["req"] = 30;
   };
   [1265] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1266;
      ["name_de"] = "Der vermisste Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Search Sentry Point for any sign of Private Hendel.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "The Missing Diplomat";
      ["prev"] = 1264;
      ["prequests"] = {
         [1] = 1264;
      };
      ["level"] = 35;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1269] = {
      ["name_ru"] = "Лейтенант Павал Рит";
      ["type"] = "Solo";
      ["objective"] = "Bring Reethe's Badge to Krog in Brackenwall Village.";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "?瓦?・雷瑟上尉";
      ["name_fr"] = "Lieutenant Paval Reethe";
      ["name_de"] = "Leutnant Paval Reethe";
      ["faction"] = "Horde";
      ["name"] = "Lieutenant Paval Reethe";
      ["level"] = 37;
      ["name_es"] = "Teniente Paval Reethe";
      ["req"] = 30;
   };
   [1273] = {
      ["name_ru"] = "Допрос Рита";
      ["type"] = "Solo";
      ["name_fr"] = "Questionner Reethe";
      ["name_de"] = "Befragt Reethe";
      ["reward"] = {
         [1] = 6797;
         [2] = 6798;
      };
      ["name_cn"] = "??雷瑟";
      ["objective"] = "Go with Ogron to speak with Reethe, then return to Krog in Brackenwall Village.";
      ["faction"] = "Horde";
      ["name"] = "Questioning Reethe";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1269;
      ["prequests"] = {
         [1] = 1269;
      };
      ["level"] = 37;
      ["name_es"] = "El interrogatorio de Reethe";
      ["req"] = 30;
   };
   [8964] = {
      ["name_ru"] = "Важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "Des composants importants";
      ["next"] = 8968;
      ["name_de"] = "Komponenten von groser Wichtigkeit";
      ["objective"] = "Retrieve a Brilliant Sword of Zealotry and return it to Bodley inside Blackrock Mountain.";
      ["name_cn"] = "重要的材料";
      ["sort"] = "Blackrock Mountain";
      ["faction"] = "Horde";
      ["name"] = "Components of Importance";
      ["followup"] = 8985;
      ["prev"] = 8961;
      ["prequests"] = {
         [1] = 8961;
      };
      ["level"] = 60;
      ["name_es"] = "Componentes importantes";
      ["req"] = 58;
   };
   [5122] = {
      ["name_ru"] = "Медальон веры";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["sort"] = "Stratholme";
      ["name_cn"] = "信仰?章";
      ["name_fr"] = "Le medaillon de foi";
      ["followup"] = 5125;
      ["name_de"] = "Das Medaillon des Glaubens";
      ["faction"] = "Horde";
      ["name"] = "The Medallion of Faith";
      ["level"] = 60;
      ["name_es"] = "El medallon de Fe";
      ["req"] = 55;
   };
   [1285] = {
      ["name_ru"] = "Солдаты Даэлина";
      ["type"] = "Solo";
      ["name_fr"] = "Les hommes de Daelin";
      ["next"] = 1286;
      ["name_de"] = "Daelins Manner";
      ["name_cn"] = "戴林的下属";
      ["objective"] = "Return the information about Reethe to Captain Garran Vimes in Theramore.";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Alliance";
      ["name"] = "Daelin's Men";
      ["prev"] = 1259;
      ["prequests"] = {
         [1] = 1259;
      };
      ["level"] = 38;
      ["name_es"] = "Los hombres de Daelin";
      ["req"] = 30;
   };
   [5154] = {
      ["name_ru"] = "Анналы Дарроушира";
      ["type"] = "Solo";
      ["name_fr"] = "Les annales de Comte-de-Darrow";
      ["name_de"] = "Die Annalen von Darroheim";
      ["objective"] = "Bring the Annals of Darrowshire to Chromie in Andorhal.";
      ["name_cn"] = "?隆郡的?史";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Horde";
      ["name"] = "The Annals of Darrowshire";
      ["followup"] = 5210;
      ["prev"] = 5153;
      ["prequests"] = {
         [1] = 5153;
      };
      ["level"] = 56;
      ["name_es"] = "Las Cronicas de Villa Darrow";
      ["req"] = 50;
   };
   [4286] = {
      ["name_ru"] = "Хороший товар";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Blackrock Depths and recover 20 Dark Iron Fanny Packs. Return to Oralius when you have completed this task. You assume that the Dark Iron dwarves inside Blackrock Depths carry these 'fanny pack' contraptions.$B";
      ["repgain"] = {
         [47] = 250;
      };
      ["sort"] = "Blackrock Depths";
      ["name_fr"] = "Du beau materiel";
      ["name_cn"] = "好?西";
      ["reward"] = {
         [1] = 11883;
      };
      ["name_de"] = "Das gute Zeug";
      ["faction"] = "Alliance";
      ["name"] = "The Good Stuff";
      ["level"] = 56;
      ["name_es"] = "Buena mercancia";
      ["req"] = 50;
   };
   [8970] = {
      ["name_ru"] = "Я вижу в твоем будущем остров Алькац...";
      ["type"] = "Group";
      ["objective"] = "Gather 20 Bloodkelp from the Strashaz naga and then return to Bodley inside Blackrock Mountain.";
      ["name_fr"] = "Votre avenir passe par l'ile d'Alcaz";
      ["sort"] = "Alcaz Island";
      ["name_cn"] = "奥???在?前方……";
      ["name"] = "I See Alcaz Island In Your Future...";
      ["name_de"] = "Ich sehe die Insel Alcaz in Eurer Zukunft";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8968;
         [2] = 8969;
         [3] = 8966;
         [4] = 8967;
      };
      ["level"] = 60;
      ["name_es"] = "En tu destino veo la Isla de Alcaz...";
      ["req"] = 58;
   };
   [5202] = {
      ["name_ru"] = "Странный красный ключ";
      ["type"] = "Solo";
      ["objective"] = "Search through Jaedenar to discover what the Blood Red Key is used for.";
      ["sort"] = "Felwood";
      ["name_cn"] = "奇怪的??匙";
      ["name_fr"] = "Une etrange cle rouge";
      ["name_de"] = "Ein merkwurdiger roter Schlussel";
      ["faction"] = "Horde";
      ["name"] = "A Strange Red Key";
      ["level"] = 55;
      ["name_es"] = "Una extrana llave roja";
      ["req"] = 49;
   };
   [5218] = {
      ["name_ru"] = "Котел поля Джанис";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["name_de"] = "Der Kessel des Teufelssteinfelds";
      ["name_cn"] = "??斯通??的瘟疫之?";
      ["name_fr"] = "Le chaudron du champ de Gangrepierre";
      ["name"] = "Felstone Field Cauldron";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5237;
      ["prequests"] = {
         [1] = 5237;
         [2] = 5229;
         [3] = 5216;
      };
      ["level"] = 53;
      ["name_es"] = "La caldera del Campo de Piedramacula";
      ["req"] = 50;
   };
   [5234] = {
      ["name_ru"] = "Возвращение в Бастион";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a la Barricade";
      ["repgain"] = {
         [67] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Bollwerk";
      ["name"] = "Return to the Bulwark";
      ["name_cn"] = "返回亡?壁?";
      ["objective"] = "Bring the Filled Writhing Haunt Bottle to Shadow Priestess Vandis at The Bulwark, Western Plaguelands.";
      ["next"] = 5235;
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5233;
      ["prequests"] = {
         [1] = 5233;
      };
      ["level"] = 55;
      ["name_es"] = "Regresa a El Baluarte";
      ["req"] = 50;
   };
   [5250] = {
      ["name_ru"] = "Звездопад";
      ["type"] = "Solo";
      ["objective"] = "Find Starfall in Winterspring and speak with Wynd Nightchaser.";
      ["next"] = 5244;
      ["name_fr"] = "Pluie-d'Etoiles";
      ["sort"] = "Rut'theran Village";
      ["name_cn"] = "?星村";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Sternfall";
      ["faction"] = "Alliance";
      ["name"] = "Starfall";
      ["level"] = 56;
      ["name_es"] = "Estrella Fugaz";
      ["req"] = 53;
   };
   [8985] = {
      ["name_ru"] = "Еще одна важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "D'autres composants importants";
      ["next"] = 8990;
      ["name_de"] = "Mehr Komponenten von groser Wichtigkeit";
      ["reward"] = {
         [1] = 22192;
         [2] = 22193;
      };
      ["name_cn"] = "更多重要的材料";
      ["objective"] = "Acquire a Starbreeze Village Relic and return it to Bodley inside Blackrock Mountain.";
      ["faction"] = "Horde";
      ["name"] = "More Components of Importance";
      ["sort"] = "Blackrock Mountain";
      ["prev"] = 8970;
      ["prequests"] = {
         [1] = 8970;
         [2] = 8964;
      };
      ["level"] = 60;
      ["name_es"] = "Mas componentes importantes";
      ["req"] = 58;
   };
   [1321] = {
      ["name_ru"] = "Черный щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["next"] = 1322;
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name"] = "The Black Shield";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Show the Blackened Iron Shield to Do'gol in Brackenwall Village.";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Dustwallow Marsh";
      ["prev"] = 1251;
      ["prequests"] = {
         [1] = 1251;
      };
      ["level"] = 35;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [1471] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Runes of Summoning, summon and subdue a voidwalker, then return the Runes of Summoning to Carendin Halgar in the Magic Quarter of the Undercity.";
      ["name_cn"] = "誓?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Binding";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1473;
      ["prequests"] = {
         [1] = 1473;
      };
      ["level"] = 10;
      ["name_es"] = "El vinculo";
      ["req"] = 10;
   };
   [6646] = {
      ["name_ru"] = "Покровительство братства, кровь горы";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["sort"] = "Molten Core";
      ["name_fr"] = "Faveur aupres de la Confrerie, Sang de la montagne";
      ["name_cn"] = "兄弟会的好感 - 山脉之血";
      ["name_de"] = "Gunst der Bruderschaft, Blut des Berges";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Brotherhood, Blood of the Mountain";
      ["level"] = 60;
      ["name_es"] = "El favor de la Hermandad, gota de sangre de la montana";
      ["req"] = 60;
   };
   [8987] = {
      ["name_ru"] = "Еще одна важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "D'autres composants importants";
      ["next"] = 8991;
      ["name_de"] = "Mehr Komponenten von groser Wichtigkeit";
      ["reward"] = {
         [1] = 22192;
         [2] = 22193;
      };
      ["name_cn"] = "更多重要的材料";
      ["objective"] = "Retrieve a Brilliant Sword of Zealotry and return it to Bodley inside Blackrock Mountain.";
      ["faction"] = "Horde";
      ["name"] = "More Components of Importance";
      ["sort"] = "Blackrock Mountain";
      ["prev"] = 8970;
      ["prequests"] = {
         [1] = 8970;
         [2] = 8962;
      };
      ["level"] = 60;
      ["name_es"] = "Mas componentes importantes";
      ["req"] = 58;
   };
   [1646] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1647;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1645;
      ["prequests"] = {
         [1] = 1645;
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [3201] = {
      ["name_ru"] = "Наконец-то!";
      ["type"] = "Group";
      ["objective"] = "Take the Proof of Deed back to Mountaineer Pebblebitty.";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Endlich!";
      ["reward"] = {
         [1] = 5396;
      };
      ["name_cn"] = "??的?明！";
      ["name_fr"] = "Enfin?!";
      ["faction"] = "Alliance";
      ["name"] = "At Last!";
      ["sort"] = "Ironforge";
      ["prev"] = 3182;
      ["prequests"] = {
         [1] = 3182;
      };
      ["level"] = 48;
      ["name_es"] = "!Al fin!";
      ["req"] = 40;
   };
   [4201] = {
      ["name_ru"] = "Приворотное зелье";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 4 Gromsblood, 10 Giant Silver Veins and Nagmara's Filled Vial to Mistress Nagmara in Blackrock Depths.";
      ["name_fr"] = "Le philtre d'amour";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "?情?水";
      ["reward"] = {
         [1] = 11962;
         [2] = 11866;
      };
      ["name_de"] = "Der Liebestrank";
      ["faction"] = "Horde";
      ["name"] = "The Love Potion";
      ["level"] = 54;
      ["name_es"] = "La pocion de enamoramiento";
      ["req"] = 50;
   };
   [5201] = {
      ["name_ru"] = "Вторжение племени Зимней Спячки";
      ["type"] = "Solo";
      ["objective"] = "Rivern Frostwind wants you to slay 5 Winterfall Shaman and 5 Winterfall Ursa.";
      ["repgain"] = {
         [589] = 50;
      };
      ["name_fr"] = "L'incursion des Tombe-hiver";
      ["sort"] = "Winterspring";
      ["name_cn"] = "冬泉熊怪的侵?";
      ["name_de"] = "Eindringlinge der Winterfelle";
      ["faction"] = "Alliance";
      ["name"] = "Winterfall Intrusion";
      ["level"] = 60;
      ["name_es"] = "Intrusion Nevada";
      ["req"] = 58;
   };
   [4446] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [6544] = {
      ["name_ru"] = "Налет Торека";
      ["type"] = "Solo";
      ["objective"] = "Escort Torek on his attack against Silverwing Outpost and Duriel Moonfire, then report to Ertog Ragetusk at Splintertree Post.";
      ["repgain"] = {
         [76] = 350;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "L'assaut de Torek";
      ["name_cn"] = "托雷克的突?";
      ["reward"] = {
         [1] = 16889;
         [2] = 16890;
      };
      ["name_de"] = "Toreks Angriff";
      ["faction"] = "Horde";
      ["name"] = "Torek's Assault";
      ["level"] = 24;
      ["name_es"] = "El asalto de Torek";
      ["req"] = 20;
   };
   [1361] = {
      ["name_ru"] = "Регтар Врата Смерти";
      ["type"] = "Solo";
      ["objective"] = "Speak with Regthar Deathgate.";
      ["next"] = 1362;
      ["name_fr"] = "Regthar Seuil-de-mort";
      ["sort"] = "Desolace";
      ["name_cn"] = "雷戈?・死?";
      ["repgain"] = {
         [76] = 25;
      };
      ["name_de"] = "Regthar Totenfurt";
      ["faction"] = "Horde";
      ["name"] = "Regthar Deathgate";
      ["level"] = 32;
      ["name_es"] = "Regthar Portamorta";
      ["req"] = 30;
   };
   [1365] = {
      ["name_ru"] = "Вождь Дез'хеп";
      ["type"] = "Solo";
      ["objective"] = "Bring Khan Dez'hepah's Head to Felgur Twocuts in Desolace.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_fr"] = "Khan Dez'hepah";
      ["sort"] = "Desolace";
      ["name_cn"] = "戴??可汗";
      ["name_de"] = "Khan Dez'hepah";
      ["faction"] = "Horde";
      ["name"] = "Khan Dez'hepah";
      ["level"] = 35;
      ["name_es"] = "Khan Dez'hepah";
      ["req"] = 30;
   };
   [1369] = {
      ["name_ru"] = "Россыпи Слез";
      ["type"] = "Solo";
      ["objective"] = "Maintain your reputation with the Magram, and bring 3 Broken Tears to Warug in the Magram Village.";
      ["next"] = 1371;
      ["name_fr"] = "Larmes brisees";
      ["sort"] = "Desolace";
      ["name_cn"] = "破碎之泪";
      ["name"] = "Broken Tears";
      ["name_de"] = "Zerbrochene Tranen";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 1367;
         [2] = 1386;
      };
      ["level"] = 33;
      ["name_es"] = "Lagrimas rotas";
      ["req"] = 30;
   };
   [1373] = {
      ["name_ru"] = "Онгеку";
      ["type"] = "Solo";
      ["name_fr"] = "Ongeku";
      ["next"] = 1374;
      ["name_de"] = "Ongeku";
      ["name_cn"] = "?格??";
      ["objective"] = "Maintain your reputation with the Gelkis, and bring a Draenethyst Shard to Uthek the Wise in the Gelkis Village in Desolace.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "Ongeku";
      ["prev"] = 1370;
      ["prequests"] = {
         [1] = 1370;
      };
      ["level"] = 37;
      ["name_es"] = "Ongeku";
      ["req"] = 30;
   };
   [1101] = {
      ["name_ru"] = "Хозяйка Лабиринтов";
      ["type"] = "Dungeon";
      ["name_fr"] = "La megere du Kraal";
      ["name_de"] = "Die Greisin des Krals";
      ["reward"] = {
         [1] = 4197;
         [2] = 6742;
         [3] = 6725;
      };
      ["name_cn"] = "??加・刺肋";
      ["objective"] = "Bring Razorflank's Medallion to Falfindel Waywarder in Thalanaar.";
      ["faction"] = "Alliance";
      ["name"] = "The Crone of the Kraul";
      ["sort"] = "Razorfen Kraul";
      ["prev"] = 1100;
      ["prequests"] = {
         [1] = 1100;
      };
      ["level"] = 34;
      ["name_es"] = "La bruja del Horado";
      ["req"] = 29;
   };
   [1381] = {
      ["name_ru"] = "Вождь Храта";
      ["type"] = "Group";
      ["name_fr"] = "Khan Hratha";
      ["name_de"] = "Khan Hratha";
      ["reward"] = {
         [1] = 6788;
         [2] = 6789;
      };
      ["name_cn"] = "赫??可汗";
      ["objective"] = "Maintain your Magram reputation, and bring the Maraudine Key Fragment to Warug in the Magram Village in Desolace.";
      ["faction"] = "Horde";
      ["name"] = "Khan Hratha";
      ["sort"] = "Desolace";
      ["prev"] = 1375;
      ["prequests"] = {
         [1] = 1375;
      };
      ["level"] = 42;
      ["name_es"] = "Khan Hratha";
      ["req"] = 30;
   };
   [5538] = {
      ["name_ru"] = "Форма денег стоит";
      ["type"] = "Solo";
      ["name_fr"] = "A la peche au moule…";
      ["next"] = 5801;
      ["name_de"] = "Sold reimt sich auf...";
      ["name_cn"] = "昂?的模具";
      ["objective"] = "Bring the Imbued Skeletal Fragments and 15 gold coins to Krinkle Goodsteel in Gadgetzan.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "Mold Rhymes With...";
      ["prev"] = 5537;
      ["prequests"] = {
         [1] = 5537;
      };
      ["level"] = 57;
      ["name_es"] = "Molde rima con... ?oro?";
      ["req"] = 55;
   };
   [1389] = {
      ["name_ru"] = "Кристаллы дренетиста";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Draenethyst crystals to Magtoor at The Harborage in the Swamp of Sorrows.";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "德莱尼水晶";
      ["name_fr"] = "Les cristaux de draenethyste";
      ["name_de"] = "Draenethystkristalle";
      ["faction"] = "Horde";
      ["name"] = "Draenethyst Crystals";
      ["level"] = 35;
      ["name_es"] = "Cristales draenetistas";
      ["req"] = 30;
   };
   [1393] = {
      ["name_ru"] = "Побег Галена";
      ["type"] = "Solo";
      ["objective"] = "Escort Galen out of danger, then find his camp in the Swamp of Sorrows and open his strongbox.";
      ["name_fr"] = "L'evasion de Galen";
      ["sort"] = "Swamp of Sorrows";
      ["name_cn"] = "加林的逃亡";
      ["reward"] = {
         [1] = 6828;
      };
      ["name_de"] = "Galens Flucht";
      ["faction"] = "Horde";
      ["name"] = "Galen's Escape";
      ["level"] = 38;
      ["name_es"] = "La huida de Galen";
      ["req"] = 30;
   };
   [9034] = {
      ["name_ru"] = "Кираса неустрашимости";
      ["type"] = "Raid";
      ["name_fr"] = "Cuirasse de cuirassier";
      ["name_de"] = "Brustplatte des Schreckenspanzers";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make a Dreadnaught Breastplate if you bring him the following items: 1 Desecrated Breastplate, 25 Wartorn Plate Scraps, 4 Arcanite Bars and 2 Nexus Crystals.$B";
      ["reward"] = {
         [1] = 22416;
      };
      ["name_cn"] = "无畏胸甲";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Dreadnaught Breastplate";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La coraza acorator";
      ["req"] = 60;
   };
   [8997] = {
      ["name_ru"] = "Круг замкнулся";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au commencement";
      ["name_de"] = "Zuruck zum Anfang";
      ["name_cn"] = "回到原点";
      ["objective"] = "Speak with Deliana at The High Seat in Ironforge.";
      ["sort"] = "Ironforge";
      ["faction"] = "Alliance";
      ["name"] = "Back to the Beginning";
      ["prev"] = 8996;
      ["prequests"] = {
         [1] = 8996;
      };
      ["level"] = 60;
      ["name_es"] = "Regreso al principio";
      ["req"] = 58;
   };
   [1842] = {
      ["name_ru"] = "Копыта сатиров";
      ["type"] = "Solo";
      ["name_fr"] = "Les sabots de satyre";
      ["name_de"] = "Satyrhufe";
      ["objective"] = "Bring 7 Uncloven Satyr Hooves to Ula'elek at Sen'jin Village in Durotar.";
      ["name_cn"] = "?特之蹄";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Satyr Hooves";
      ["prev"] = 1839;
      ["prequests"] = {
         [1] = 1839;
      };
      ["level"] = 30;
      ["name_es"] = "Pezunas de satiro";
      ["req"] = 20;
   };
   [5634] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["name_cn"] = "?望祷言";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [5650] = {
      ["name_ru"] = "Одеяния Тьмы";
      ["type"] = "Solo";
      ["name_fr"] = "Vetements des tenebres";
      ["name_de"] = "Gewander der Dunkelheit";
      ["sort"] = "Priest";
      ["objective"] = "Find Deathguard Kel and heal his wounds using Lesser Heal (Rank 2). Afterwards, grant him Power Word: Fortitude and then return to Dark Cleric Beryl in Brill.";
      ["name_cn"] = "黑暗之衣";
      ["name"] = "Garments of Darkness";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 16607;
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 5651;
      ["prequests"] = {
         [1] = 5651;
      };
      ["level"] = 4;
      ["name_es"] = "Las prendas de la Oscuridad";
      ["req"] = 5;
   };
   [6642] = {
      ["name_ru"] = "Покровительство братства, черное железо";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 50;
      };
      ["sort"] = "Molten Core";
      ["name_fr"] = "Faveur aupres de la Confrerie, Minerai de sombrefer";
      ["name_cn"] = "兄弟会的好感 - 黑??石";
      ["name_de"] = "Gunst der Bruderschaft, Dunkeleisenerz";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Brotherhood, Dark Iron Ore";
      ["level"] = 60;
      ["name_es"] = "El favor de la Hermandad, mena de hierro negro";
      ["req"] = 60;
   };
   [1421] = {
      ["name_ru"] = "Пропавший караван";
      ["type"] = "Solo";
      ["name_fr"] = "Le chariot perdu";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Die verlorene Karawane";
      ["name"] = "The Lost Caravan";
      ["name_cn"] = "?失的?物";
      ["objective"] = "Find the Caravan Chest in the Fallow Sanctuary, obtain the Wizards' Reagents and bring to Watcher Biggs.";
      ["next"] = 1398;
      ["faction"] = "Alliance";
      ["sort"] = "Swamp of Sorrows";
      ["prev"] = 1396;
      ["prequests"] = {
         [1] = 1396;
      };
      ["level"] = 35;
      ["name_es"] = "La caravana perdida";
      ["req"] = 30;
   };
   [1425] = {
      ["name_ru"] = "Доставка груза";
      ["type"] = "Solo";
      ["name_fr"] = "La remise du chargement";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_de"] = "Uberbringen der Lieferung";
      ["name_cn"] = "?送?物";
      ["name"] = "Deliver the Shipment";
      ["objective"] = "Bring the Shipment to Nethergarde to Quartermaster Lungertz in Nethergarde Keep.";
      ["faction"] = "Alliance";
      ["sort"] = "Swamp of Sorrows";
      ["prev"] = 1398;
      ["prequests"] = {
         [1] = 1398;
      };
      ["level"] = 42;
      ["name_es"] = "Envio de suministros";
      ["req"] = 30;
   };
   [1429] = {
      ["name_ru"] = "Изгнанник Атал'ай";
      ["type"] = "Solo";
      ["name_fr"] = "L'Exile atal'ai";
      ["next"] = 1444;
      ["name_de"] = "Der Verbannte der Atal'ai";
      ["name_cn"] = "阿塔莱流放者";
      ["objective"] = "Bring the Bundle of Atal'ai Artifacts to the Atal'ai Exile in the Hinterlands.";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "The Atal'ai Exile";
      ["prev"] = 1424;
      ["prequests"] = {
         [1] = 1424;
      };
      ["level"] = 44;
      ["name_es"] = "El exiliado Atal'ai";
      ["req"] = 38;
   };
   [1433] = {
      ["name_ru"] = "Отношения с Альянсом";
      ["type"] = "Solo";
      ["name_fr"] = "Les relations de l'Alliance";
      ["next"] = 1435;
      ["name_de"] = "Allianzbeziehungen";
      ["name_cn"] = "?盟?系";
      ["objective"] = "Speak to Maurin Bonesplitter in Desolace.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "Alliance Relations";
      ["prev"] = 1432;
      ["prequests"] = {
         [1] = 1432;
      };
      ["level"] = 33;
      ["name_es"] = "Las relaciones de la Alianza";
      ["req"] = 30;
   };
   [1437] = {
      ["name_ru"] = "Расследование Валарриэля";
      ["type"] = "Solo";
      ["name_fr"] = "La recherche de Vahlarriel";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Vahlarriels Suche";
      ["name_cn"] = "瓦拉里?的搜?";
      ["objective"] = "Find and search Tyranis and Dalinda Malem's wagon in Desolace.";
      ["next"] = 1465;
      ["sort"] = "Desolace";
      ["name"] = "Vahlarriel's Search";
      ["faction"] = "Alliance";
      ["series"] = 1;
      ["level"] = 33;
      ["name_es"] = "Buscando para Vahlarriel";
      ["req"] = 30;
   };
   [5762] = {
      ["name_ru"] = "Хеминг Эрнестуэй";
      ["type"] = "Solo";
      ["objective"] = "Take Kravel's Crate to Hemet Nesingwary in Stranglethorn.";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "赫米特・奈辛瓦里二世";
      ["name_fr"] = "Hemet Nesingwary junior";
      ["name_de"] = "Hemet Nesingwary Jr.";
      ["faction"] = "Horde";
      ["name"] = "Hemet Nesingwary";
      ["level"] = 31;
      ["name_es"] = "Hemet Nesingwary Jr.";
      ["req"] = 28;
   };
   [1445] = {
      ["name_ru"] = "Храм Атал'Хаккара";
      ["type"] = "Dungeon";
      ["objective"] = "Collect 20 Fetishes of Hakkar and bring them to Fel'Zerul in Stonard.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Der Tempel von Atal'Hakkar";
      ["reward"] = {
         [1] = 1490;
      };
      ["name_cn"] = "阿塔哈?神?";
      ["name_fr"] = "Le temple d'Atal'Hakkar";
      ["faction"] = "Horde";
      ["name"] = "The Temple of Atal'Hakkar";
      ["sort"] = "Sunken Temple";
      ["prev"] = 1444;
      ["prequests"] = {
         [1] = 1444;
      };
      ["level"] = 50;
      ["name_es"] = "El Templo de Atal'Hakkar";
      ["req"] = 38;
   };
   [1449] = {
      ["name_ru"] = "Во Внутренние земли";
      ["type"] = "Solo";
      ["name_fr"] = "Vers les Hinterlands";
      ["next"] = 1450;
      ["name_de"] = "Ins Hinterland";
      ["name_cn"] = "去辛特?的旅程";
      ["objective"] = "Speak with High Thane Falstad Wildhammer at Aerie Peak in the Hinterlands.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "To The Hinterlands";
      ["prev"] = 1448;
      ["prequests"] = {
         [1] = 1448;
      };
      ["level"] = 43;
      ["name_es"] = "A las Tierras del Interior";
      ["req"] = 38;
   };
   [1453] = {
      ["name_ru"] = "Дела Поисковой корпорации в Пустошах";
      ["type"] = "Solo";
      ["objective"] = "Speak to Kreldig Ungor in Desolace.";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_fr"] = "Les affaires de Recuperateurs en Desolace";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?物公司的??";
      ["name_de"] = "Die Geschafte der Wiederholer in Desolace";
      ["faction"] = "Alliance";
      ["name"] = "Reclaimers' Business in Desolace";
      ["level"] = 33;
      ["name_es"] = "Los negocios de los Recuperadores en Desolace";
      ["req"] = 30;
   };
   [1457] = {
      ["name_ru"] = "Пожитки Карнитола";
      ["objective"] = "Bring Karnitol's Satchel to Roetten Stonehammer in Ironforge.";
      ["name_cn"] = "?尼托的背包";
      ["sort"] = "Desolace";
      ["level"] = 39;
      ["type"] = "Solo";
      ["name_fr"] = "L'epave de Karnitol";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Karnitols Schiffbruch";
      ["reward"] = {
         [1] = 6791;
         [2] = 6792;
      };
      ["faction"] = "Alliance";
      ["name"] = "The Karnitol Shipwreck";
      ["prev"] = 1456;
      ["prequests"] = {
         [1] = 1456;
      };
      ["series"] = 4;
      ["name_es"] = "El naufragio de Karnitol";
      ["req"] = 30;
   };
   [5842] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue?!";
      ["name_cn"] = "?迎!*";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Shadowglen Gift Voucher to Orenthil Whisperwind.";
      ["sort"] = "Shadowglen";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [1465] = {
      ["name_ru"] = "Расследование Валарриэля";
      ["objective"] = "Return the Malem Pendant to Vahlarriel Demonslayer in Desolace.";
      ["name_cn"] = "瓦拉里?的搜?";
      ["sort"] = "Desolace";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "La recherche de Vahlarriel";
      ["next"] = 1438;
      ["name_de"] = "Vahlarriels Suche";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "Vahlarriel's Search";
      ["prev"] = 1437;
      ["prequests"] = {
         [1] = 1437;
      };
      ["series"] = 2;
      ["name_es"] = "Buscando para Vahlarriel";
      ["req"] = 30;
   };
   [1469] = {
      ["name_ru"] = "Рапсодия о болоте";
      ["type"] = "Solo";
      ["name_fr"] = "L'histoire de Rhapsody";
      ["repgain"] = {
         [47] = 150;
      };
      ["name_de"] = "Rhapsodies Geschichte";
      ["name"] = "Rhapsody's Tale";
      ["name_cn"] = "拉普索迪的故事";
      ["objective"] = "Bring the Atal'ai Tablet Fragment to Brohann Caskbelly in Stormwind.";
      ["next"] = 1475;
      ["faction"] = "Alliance";
      ["sort"] = "The Hinterlands";
      ["prev"] = 1452;
      ["prequests"] = {
         [1] = 1452;
      };
      ["level"] = 43;
      ["name_es"] = "El relato de Rapsodio";
      ["req"] = 38;
   };
   [5890] = {
      ["name_ru"] = "Лекарство из оскверненных шкур";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Kurschnerei";
      ["name_fr"] = "Du baume contre des peaux";
      ["name_cn"] = "剥皮??膏";
      ["name"] = "Salve via Skinning";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 5885;
      ["prequests"] = {
         [1] = 5885;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desuello";
      ["req"] = 48;
   };
   [1477] = {
      ["name_ru"] = "Важные поставки";
      ["type"] = "Solo";
      ["objective"] = "Speak with Watchmaster Sorigal.";
      ["next"] = 1395;
      ["name_fr"] = "Fournitures vitales";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "重要的??";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Uberaus wichtige Vorrate";
      ["faction"] = "Alliance";
      ["name"] = "Vital Supplies";
      ["level"] = 45;
      ["name_es"] = "Suministros de vital importancia";
      ["req"] = 40;
   };
   [1481] = {
      ["name_ru"] = "Осквернитель душ";
      ["objective"] = "Bring a Shadowstalker Scalp to Maurin Bonesplitter in Desolace.";
      ["name_cn"] = "堕落者";
      ["sort"] = "Desolace";
      ["level"] = 33;
      ["type"] = "Solo";
      ["name_fr"] = "Le corrupteur";
      ["next"] = 1482;
      ["name_de"] = "Der Verderber";
      ["repgain"] = {
         [68] = 250;
      };
      ["faction"] = "Horde";
      ["name"] = "The Corrupter";
      ["prev"] = 1480;
      ["prequests"] = {
         [1] = 1480;
      };
      ["series"] = 2;
      ["name_es"] = "El corruptor";
      ["req"] = 25;
   };
   [1485] = {
      ["name_ru"] = "Злобные фамильяры";
      ["type"] = "Solo";
      ["objective"] = "Bring 6 Vile Familiar Heads to Ruzan.";
      ["next"] = 1499;
      ["name_fr"] = "Les vils quasits";
      ["sort"] = "Warlock";
      ["name_cn"] = "邪?劣魔";
      ["series"] = 1;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Uble Familiare";
      ["faction"] = "Horde";
      ["name"] = "Vile Familiars";
      ["level"] = 4;
      ["name_es"] = "Familiares viles";
      ["req"] = 1;
   };
   [1489] = {
      ["name_ru"] = "Хамуул Рунический Тотем";
      ["type"] = "Solo";
      ["name_fr"] = "Hamuul Totem-runique";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_de"] = "Hamuul Runentotem";
      ["name"] = "Hamuul Runetotem";
      ["name_cn"] = "哈??・符文??";
      ["objective"] = "Speak with Hamuul Runetotem.";
      ["next"] = 1490;
      ["faction"] = "Horde";
      ["sort"] = "Wailing Caverns";
      ["prev"] = 880;
      ["prequests"] = {
         [1] = 880;
      };
      ["level"] = 16;
      ["name_es"] = "Hamuul Totem de Runa";
      ["req"] = 12;
   };
   [1030] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Dartols Rute";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Find an uncorrupted furbolg, and using the power of Dartol's Rod of Transformation, speak to him.";
      ["next"] = 1045;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1029;
      ["prequests"] = {
         [1] = 1029;
      };
      ["level"] = 28;
      ["name_es"] = "La vara de Dartol";
      ["req"] = 18;
   };
   [8677] = {
      ["name_ru"] = "Предок Темный Рог";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Sombre-corne";
      ["name_cn"] = "暗角?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Dunkelhorn";
      ["faction"] = "Horde";
      ["name"] = "Darkhorn the Elder";
      ["level"] = 60;
      ["name_es"] = "Astaoscura el Ancestro";
      ["req"] = 1;
   };
   [6002] = {
      ["name_ru"] = "Тело и дух";
      ["type"] = "Solo";
      ["name_fr"] = "Corps et c?ur";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Korper und Herz";
      ["objective"] = "Use the Cenarion Lunardust on the Moonkin Stone between Mulgore and the Barrens to bring forth Lunaclaw.  From there, you must face Lunaclaw and earn the strength of body and heart it possesses.$B$BSpeak with Turak Runetotem in Thunder Bluff when you are done.";
      ["name_cn"] = "身心之力";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Body and Heart";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 5932;
      ["prequests"] = {
         [1] = 5932;
      };
      ["level"] = 10;
      ["name_es"] = "Cuerpo y corazon";
      ["req"] = 10;
   };
   [1505] = {
      ["name_ru"] = "Ветеран Уззек";
      ["type"] = "Solo";
      ["objective"] = "Speak with Uzzek at Far Watch Post.";
      ["next"] = 1498;
      ["sort"] = "Warrior";
      ["name_cn"] = "老兵犹塞克";
      ["name_fr"] = "Le veteran Uzzek";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Veteran Uzzek";
      ["faction"] = "Horde";
      ["name"] = "Veteran Uzzek";
      ["level"] = 10;
      ["name_es"] = "Uzzek, el veterano";
      ["req"] = 10;
   };
   [1509] = {
      ["name_ru"] = "Вести о Догране";
      ["objective"] = "Speak with Gazrog at the Crossroads.";
      ["name_cn"] = "多格?的消息";
      ["sort"] = "Warlock";
      ["level"] = 20;
      ["type"] = "Solo";
      ["name_fr"] = "Des nouvelles de Dogran";
      ["next"] = 1510;
      ["name_de"] = "Neuigkeiten von Dogran";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "News of Dogran";
      ["prev"] = 1508;
      ["prequests"] = {
         [1] = 1508;
      };
      ["series"] = 1;
      ["name_es"] = "Noticias de Dogran";
      ["req"] = 20;
   };
   [1513] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using Dogran's Pendant, summon and subdue a succubus, then return Dogran's Pendant to Gan'rul Bloodeye in Orgrimmar.";
      ["reward"] = {
         [1] = 22243;
      };
      ["name_cn"] = "誓?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Binding";
      ["sort"] = "Warlock";
      ["prev"] = 1512;
      ["prequests"] = {
         [1] = 1512;
      };
      ["level"] = 20;
      ["name_es"] = "El vinculo";
      ["req"] = 20;
   };
   [1517] = {
      ["name_ru"] = "Зов Земли";
      ["objective"] = "Find Spirit Rock and drink the Earth Sapta.";
      ["name_cn"] = "大地的召?";
      ["sort"] = "Shaman";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de la terre";
      ["next"] = 1518;
      ["name_de"] = "Ruf der Erde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Earth";
      ["prev"] = 1516;
      ["prequests"] = {
         [1] = 1516;
      };
      ["series"] = 2;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [1521] = {
      ["name_ru"] = "Зов Земли";
      ["objective"] = "Bring the Rough Quartz to Seer Ravenfeather in Camp Narache.";
      ["name_cn"] = "大地的召?";
      ["sort"] = "Shaman";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de la terre";
      ["name_de"] = "Ruf der Erde";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 5175;
      };
      ["name"] = "Call of Earth";
      ["prev"] = 1520;
      ["prequests"] = {
         [1] = 1520;
      };
      ["series"] = 3;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [1525] = {
      ["name_ru"] = "Зов Огня";
      ["objective"] = "Bring 1 Fire Tar and 1 Reagent Pouch to Telf Joolam in Durotar.";
      ["name_cn"] = "火?的召?";
      ["sort"] = "Shaman";
      ["level"] = 12;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du feu";
      ["next"] = 1526;
      ["name_de"] = "Ruf des Feuers";
      ["reward"] = {
         [1] = 6636;
      };
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["prev"] = 1524;
      ["prequests"] = {
         [1] = 1524;
      };
      ["series"] = 2;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [1529] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["objective"] = "Find Islen Waterseer in the Barrens.";
      ["next"] = 1530;
      ["sort"] = "Shaman";
      ["name_cn"] = "水之召?";
      ["name_fr"] = "L'appel de l'eau";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1530;
      ["name_de"] = "Ruf des Wassers";
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["level"] = 20;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [6130] = {
      ["name_ru"] = "Власть над ядом";
      ["type"] = "Solo";
      ["name_fr"] = "Pouvoir contre le poison";
      ["repgain"] = {
         [609] = 100;
      };
      ["name_de"] = "Macht uber Gift";
      ["objective"] = "Return to Turak Runetotem on the Elder Rise, Thunder Bluff.";
      ["name_cn"] = "解毒之?";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Power over Poison";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 6129;
      ["prequests"] = {
         [1] = 6129;
      };
      ["level"] = 14;
      ["name_es"] = "Poder contra el veneno";
      ["req"] = 14;
   };
   [8195] = {
      ["name_ru"] = "Монеты племен: Зулиан, Раззаши и Хаккари";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [270] = 25;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Pieces zuliennes, razzashi et hakkari";
      ["name_cn"] = "祖利安、拉扎什和哈?莱硬?";
      ["reward"] = {
         [1] = 19858;
      };
      ["name_de"] = "Munzen der Razzashi, Hakkari und zulianische Munzen";
      ["faction"] = "Horde";
      ["name"] = "Zulian, Razzashi, and Hakkari Coins";
      ["level"] = 60;
      ["name_es"] = "Las monedas Zulian, Razzashi y Hakkari";
      ["req"] = 58;
   };
   [6162] = {
      ["name_ru"] = "Последняя битва супруга";
      ["type"] = "Solo";
      ["objective"] = "Kill Overlord Ror and return his claw to Dreka'Sur at Bloodvenom Post in Felwood.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_fr"] = "La derniere bataille d'un mari";
      ["sort"] = "Felwood";
      ["name_cn"] = "最后一?";
      ["name_de"] = "Eines Ehemanns letzter Kampf";
      ["faction"] = "Horde";
      ["name"] = "A Husband's Last Battle";
      ["level"] = 51;
      ["name_es"] = "La ultima batalla de un marido";
      ["req"] = 46;
   };
   [9024] = {
      ["name_ru"] = "Подозрения Аристана";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Cologne Bottle and 1 Perfume Bottle to Morgan Pestle in the Trade District of Stormwind.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "阿瑞斯坦的?感";
      ["name_fr"] = "L'intuition d'Aristan";
      ["name_de"] = "Aristans Verdacht";
      ["faction"] = "Alliance";
      ["name"] = "Aristan's Hunch";
      ["level"] = 70;
      ["name_es"] = "El presentimiento de Aristan";
      ["req"] = 18;
   };
   [8291] = {
      ["name_ru"] = "Долой захватчиков!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Horde, obtain a Warsong Gulch Mark of Honor, and return to Sentinel Farsong at the Silverwing Grove.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "??入侵者!";
      ["name_fr"] = "Triomphez des envahisseurs !";
      ["name_de"] = "Besiegt die Eindringlinge!";
      ["faction"] = "Alliance";
      ["name"] = "Vanquish the Invaders!";
      ["level"] = 60;
      ["name_es"] = "!Expulsa al invasor!";
      ["req"] = 60;
   };
   [8323] = {
      ["name_ru"] = "Истинно верующие";
      ["type"] = "Solo";
      ["name_fr"] = "Les vrais croyants";
      ["name_de"] = "Wahrer Glauben";
      ["name_cn"] = "真正的信徒";
      ["objective"] = "Hermit Ortell wants you to bring him 10 Encrypted Twilight Texts";
      ["sort"] = "Silithus";
      ["faction"] = "Horde";
      ["name"] = "True Believers";
      ["prev"] = 8279;
      ["prequests"] = {
         [1] = 8279;
      };
      ["level"] = 59;
      ["name_es"] = "El creyente verdadero";
      ["req"] = 54;
   };
   [8355] = {
      ["name_ru"] = "Плата за леденцы";
      ["type"] = "Solo";
      ["objective"] = "Do a train emote at Talvash del Kissel, and in exchange you'll receive a Gnomeregan Gumdrop!";
      ["name_fr"] = "Boule de gomme en approche";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "学火?，?糖果";
      ["reward"] = {
         [1] = 20494;
      };
      ["name_de"] = "Kaugummikugelexpress";
      ["faction"] = "Alliance";
      ["name"] = "Incoming Gumdrop";
      ["level"] = 60;
      ["name_es"] = "!Truco o trato!";
      ["req"] = 10;
   };
   [8387] = {
      ["name_ru"] = "Вторжение в Альтеракскую долину";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [729] = 100;
      };
      ["name_de"] = "Die Invasoren des Alteractals";
      ["name_cn"] = "奥特?克的入侵者";
      ["name_fr"] = "Les envahisseurs de la vallee d'Alterac";
      ["name"] = "Invaders of Alterac Valley";
      ["faction"] = "Horde";
      ["sort"] = "Alterac Valley";
      ["prev"] = 8369;
      ["prequests"] = {
         [1] = 8369;
      };
      ["level"] = 60;
      ["name_es"] = "Invasores del Valle de Alterac";
      ["req"] = 51;
   };
   [8419] = {
      ["name_ru"] = "Просьба беса";
      ["type"] = "Solo";
      ["objective"] = "Bring a piece of felcloth to Impsy in Felwood.";
      ["next"] = 8421;
      ["sort"] = "Warlock";
      ["name_cn"] = "小鬼的要求";
      ["name_fr"] = "La demande d'un diablotin";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 8421;
      ["name_de"] = "Die Bitte eines Wichtels";
      ["faction"] = "Horde";
      ["name"] = "An Imp's Request";
      ["level"] = 52;
      ["name_es"] = "Pedido de un diablillo";
      ["req"] = 50;
   };
   [9025] = {
      ["name_ru"] = "Открытие Моргана";
      ["type"] = "Solo";
      ["objective"] = "Return to Aristan Mottar outside the bank in Stormwind's Trade District.";
      ["next"] = 9026;
      ["name_fr"] = "La decouverte de Morgan";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "摩根的??";
      ["reward"] = {
         [1] = 21812;
         [2] = 22218;
      };
      ["name_de"] = "Morgans Entdeckung";
      ["faction"] = "Alliance";
      ["name"] = "Morgan's Discovery";
      ["level"] = 0;
      ["name_es"] = "El descubrimiento de Morgan";
      ["req"] = 18;
   };
   [2991] = {
      ["name_ru"] = "Медальон Некрума";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le medaillon de Nekrum";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Nekrums Medaillon";
      ["name"] = "Nekrum's Medallion";
      ["name_cn"] = "耐克?姆的徽章";
      ["objective"] = "Bring Nekrum's Medallion to Thadius Grimshade in the Blasted Lands.";
      ["next"] = 2992;
      ["faction"] = "Alliance";
      ["sort"] = "Zul'Farrak";
      ["prev"] = 2990;
      ["prequests"] = {
         [1] = 2990;
      };
      ["level"] = 47;
      ["name_es"] = "Medallon de Nekrum";
      ["req"] = 40;
   };
   [8515] = {
      ["name_ru"] = "Альянсу не хватает плотной кожи!";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Leather to Marta Finespindle at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de cuir epais?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要厚皮!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_de"] = "Die Allianz braucht dickes Leder!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Thick Leather!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita cuero grueso!";
      ["req"] = 44;
   };
   [6322] = {
      ["name_ru"] = "Майкл Гарретт";
      ["type"] = "Solo";
      ["name_fr"] = "Michael Garrett";
      ["repgain"] = {
         [68] = 25;
      };
      ["name_de"] = "Michael Garrett";
      ["objective"] = "Bring Gordon's Crate to Michael Garrett.";
      ["name_cn"] = "?克?・加勒特";
      ["next"] = 6324;
      ["sort"] = "Silverpine Forest";
      ["name"] = "Michael Garrett";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 6323;
      ["prequests"] = {
         [1] = 6323;
      };
      ["level"] = 10;
      ["name_es"] = "Michael Garrett";
      ["req"] = 10;
   };
   [8579] = {
      ["name_ru"] = "Поборники правого дела из числа смертных";
      ["type"] = "Raid";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 500;
         [609] = 100;
      };
      ["sort"] = "Ahn'Qiraj";
      ["name_fr"] = "Champions mortels";
      ["name_cn"] = "凡人中的勇士";
      ["name_de"] = "Sterbliche Helden";
      ["faction"] = "Horde";
      ["name"] = "Mortal Champions";
      ["level"] = 60;
      ["name_es"] = "Campeones mortales";
      ["req"] = 60;
   };
   [8611] = {
      ["name_ru"] = "Орде не хватает постных стейков из волчатины!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Lean Wolf Steaks to Bloodguard Rawtar at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de steaks de loup !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要?狼排!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["name_de"] = "Die Horde braucht magere Wolfsteaks!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Lean Wolf Steaks!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita filetes de lobo magro!";
      ["req"] = 49;
   };
   [8643] = {
      ["name_ru"] = "Предок Крутой Утес";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Haut-pic";
      ["name_cn"] = "雪峰?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Hohengipfel";
      ["faction"] = "Horde";
      ["name"] = "Highpeak the Elder";
      ["level"] = 60;
      ["name_es"] = "Altacumbre el Ancestro";
      ["req"] = 1;
   };
   [6386] = {
      ["name_ru"] = "Возвращение на Перекресток";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a la Croisee";
      ["repgain"] = {
         [530] = 350;
         [76] = 350;
      };
      ["name_de"] = "Kehrt nach Klingenhugel zuruck";
      ["name_cn"] = "返回十字路口";
      ["objective"] = "Buy a wind rider to the Crossroads from the wind rider master Doras, then bring Gryshka's Letter to Zargh at the Crossroads.";
      ["sort"] = "The Barrens";
      ["name"] = "Return to the Crossroads.";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["prev"] = 6385;
      ["prequests"] = {
         [1] = 6385;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa a Cerrotajo";
      ["req"] = 10;
   };
   [6402] = {
      ["name_ru"] = "Встреча в Штормграде";
      ["type"] = "Raid";
      ["name_fr"] = "Le rendez-vous a Hurlevent";
      ["name_de"] = "Treffen in Sturmwind";
      ["name_cn"] = "集合在暴?城";
      ["objective"] = "Travel to Stormwind City and venture to the city gates. Speak with Squire Rowe so that he may let Marshal Windsor know that you have arrived.";
      ["sort"] = "Stormwind City";
      ["faction"] = "Alliance";
      ["name"] = "Stormwind Rendezvous";
      ["prev"] = 4322;
      ["prequests"] = {
         [1] = 4322;
      };
      ["level"] = 60;
      ["name_es"] = "Tienes una cita en Ventormenta";
      ["req"] = 50;
   };
   [8739] = {
      ["name_ru"] = "Донесение разведчика из Улья Аши";
      ["type"] = "Group";
      ["objective"] = "Contact Cenarion Scout Jalia inside Hive'Ashi and return the Hive'Ashi Scout Report to Windcaller Proudhorn at Cenarion Hold.  You must also bring Tactical Task Briefing VIII in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Rapport de reconnaissance de la Ruche'Ashi";
      ["name_cn"] = "灰?公爵";
      ["reward"] = {
         [1] = 20801;
         [2] = 20809;
      };
      ["name_de"] = "Spaherbericht des Ashischwarms";
      ["faction"] = "Horde";
      ["name"] = "Hive'Ashi Scout Report";
      ["level"] = 60;
      ["name_es"] = "Informe de exploracion de Colmen'Ashi";
      ["req"] = 60;
   };
   [8771] = {
      ["name_ru"] = "Цель: пескоходы из Улья Аши";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Ashi Sandstalkers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing II in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les traqueuses des sables de la Ruche'Ashi";
      ["name_cn"] = "目?：?什沙行者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Sandpirscher des Ashischwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Ashi Sandstalkers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los acecharenas Colmen'Ashi";
      ["req"] = 60;
   };
   [8803] = {
      ["name_ru"] = "Подарок в разноцветной упаковке";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Un cadeau de fete";
      ["name_cn"] = "?日礼物";
      ["reward"] = {
         [1] = 21363;
      };
      ["name_de"] = "Ein Festtagsgeschenk";
      ["faction"] = "Horde";
      ["name"] = "A Festive Gift";
      ["level"] = 10;
      ["name_es"] = "Un obsequio festivo";
      ["req"] = 10;
   };
   [8835] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8820;
      ["prequests"] = {
         [1] = 8820;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [6482] = {
      ["name_ru"] = "Свободу Руулу!";
      ["type"] = "Solo";
      ["objective"] = "Escort Ruul, then speak with Yama Snowhoof in Splintertree Post.";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_fr"] = "Liberte pour Ruul";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "??的自由";
      ["name_de"] = "Freiheit fur Ruul";
      ["faction"] = "Horde";
      ["name"] = "Freedom to Ruul";
      ["level"] = 24;
      ["name_es"] = "Liberar a Ruul";
      ["req"] = 19;
   };
   [8899] = {
      ["name_ru"] = "Дорогая моя Колара!";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Immaculate Letter to Colara Dean outside the bank in Stormwind.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的科?拉";
      ["name_fr"] = "Tres chere Colara,";
      ["name_de"] = "Liebste Colara";
      ["faction"] = "Alliance";
      ["name"] = "Dearest Colara,";
      ["level"] = 70;
      ["name_es"] = "Queridisima Colara:";
      ["req"] = 56;
   };
   [8931] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Beaststalker's Belt and a set of Beaststalker's Gloves to Deliana in Ironforge.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22010;
         [2] = 22015;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8963] = {
      ["name_ru"] = "Важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "Des composants importants";
      ["next"] = 8967;
      ["name_de"] = "Komponenten von groser Wichtigkeit";
      ["objective"] = "Acquire a Starbreeze Village Relic and return it to Bodley inside Blackrock Mountain.";
      ["name_cn"] = "重要的材料";
      ["sort"] = "Blackrock Mountain";
      ["faction"] = "Horde";
      ["name"] = "Components of Importance";
      ["followup"] = 8988;
      ["prev"] = 8961;
      ["prequests"] = {
         [1] = 8961;
      };
      ["level"] = 60;
      ["name_es"] = "Componentes importantes";
      ["req"] = 58;
   };
   [8995] = {
      ["name_ru"] = "Mea Culpa, Лорд Вальтхалак";
      ["type"] = "Raid";
      ["name_fr"] = "Mea culpa, seigneur Valthalak";
      ["next"] = 8996;
      ["name_de"] = "Mea Culpa, Lord Valthalak";
      ["name_cn"] = "瓦塔拉克公爵";
      ["objective"] = "Use the Brazier of Beckoning to summon Lord Valthalak. Dispatch him, and use Lord Valthalak's Amulet on the corpse. Then, return Lord Valthalak's Amulet to the Spirit of Lord Valthalak.";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "Mea Culpa, Lord Valthalak";
      ["prev"] = 8994;
      ["prequests"] = {
         [1] = 8994;
      };
      ["level"] = 60;
      ["name_es"] = "Mea Culpa, Lord Valthalak";
      ["req"] = 58;
   };
   [1641] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["sort"] = "Paladin";
      ["name_cn"] = "??之?";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Der Foliant der Offenbarung";
      ["name"] = "The Tome of Divinity";
      ["reward"] = {
         [1] = 6775;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["level"] = 12;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [9059] = {
      ["name_ru"] = "Боевые рукавицы Расхитителя гробниц";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make Cryptstalker Handguards if you bring him the following: 1 Desecrated Handguards, 8 Wartorn Chain Scraps, 1 Arcanite Bar and 5 Cured Rugged Hides.";
      ["name_cn"] = "地穴追?者?手";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-mains de traqueur des cryptes";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handschutzer des Gruftpirschers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22441;
      };
      ["name"] = "Cryptstalker Handguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las manoplas de acechacriptas";
      ["req"] = 60;
   };
   [9091] = {
      ["name_ru"] = "Боевые рукавицы сновидца";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make Dreamwalker Handguards if you bring her the following: 1 Desecrated Handguards, 8 Wartorn Leather Scraps, 5 Cured Rugged Hides and 1 Nexus Crystal.";
      ["name_cn"] = "梦游者?手";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-mains de marchereve";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handschutzer des Traumwandlers";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22493;
      };
      ["name"] = "Dreamwalker Handguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las manoplas Caminasuenos";
      ["req"] = 60;
   };
   [9123] = {
      ["name_ru"] = "Цитадель ужаса ? Наксрамас";
      ["type"] = "Solo";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will grant you Arcane Cloaking at no cost. You must be Exalted with the Argent Dawn.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "可怕的堡? - ?克??斯";
      ["name_fr"] = "Naxxramas, la citadelle de l'effroi";
      ["followup"] = 9033;
      ["name_de"] = "Die Zitadelle des Schreckens - Naxxramas";
      ["faction"] = "Horde";
      ["name"] = "The Dread Citadel - Naxxramas";
      ["level"] = 60;
      ["name_es"] = "La ciudadela del terror: Naxxramas";
      ["req"] = 60;
   };
   [6626] = {
      ["name_ru"] = "Воинство зла";
      ["type"] = "Dungeon";
      ["objective"] = "Kill 8 Razorfen Battleguard, 8 Razorfen Thornweavers, and 8 Death's Head Cultists and return to Myriam Moonsinger near the entrance to Razorfen Downs.";
      ["sort"] = "Razorfen Downs";
      ["name_cn"] = "邪?之地";
      ["name_fr"] = "L'hote du mal";
      ["name_de"] = "Ein Hort des Bosen";
      ["faction"] = "Horde";
      ["name"] = "A Host of Evil";
      ["level"] = 35;
      ["name_es"] = "Un anfitrion del mal";
      ["req"] = 28;
   };
   [9187] = {
      ["name_ru"] = "Задание мастера: рунические кожаные штаны";
      ["type"] = "Solo";
      ["objective"] = "Deliver 4 Runic Leather Pants and the Craftsman's Writ - Runic Leather Pants - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Pantalons runiques en cuir";
      ["name_cn"] = "工匠令状 - 符文皮甲短?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Runenverzierte Lederhose";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Runic Leather Pants";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pantalones de cuero runico";
      ["req"] = 55;
   };
   [1665] = {
      ["name_ru"] = "Кружка Бартлби";
      ["type"] = "Solo";
      ["name_fr"] = "Tasse de Bartleby";
      ["name_de"] = "Bartlebys Becher";
      ["objective"] = "Bring Bartleby's Mug to Burlguard";
      ["name_cn"] = "巴特莱比的酒杯";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Bartleby's Mug";
      ["prev"] = 1640;
      ["prequests"] = {
         [1] = 1640;
      };
      ["level"] = 10;
      ["name_es"] = "La jarra de Bartleby";
      ["req"] = 10;
   };
   [9251] = {
      ["name_ru"] = "Атиеш, оскверненный посох";
      ["type"] = "Raid";
      ["name_fr"] = "Atiesh, le grand baton souille";
      ["name_de"] = "Atiesh, der korrumpierte Hohestab";
      ["name_cn"] = "埃提耶什，被??的??之杖";
      ["objective"] = "Anachronos at the Caverns of Time in Tanaris wants the Staff Head of Atiesh and the Base of Atiesh.";
      ["sort"] = "Legendary";
      ["faction"] = "Horde";
      ["name"] = "Atiesh, the Befouled Greatstaff";
      ["prev"] = 9250;
      ["prequests"] = {
         [1] = 9250;
      };
      ["level"] = 60;
      ["name_es"] = "Atiesh, el gran baculo maligno";
      ["req"] = 60;
   };
   [9037] = {
      ["name_ru"] = "Полный шлем неустрашимости";
      ["type"] = "Raid";
      ["name_fr"] = "Casque de cuirassier";
      ["name_de"] = "Helm des Schreckenspanzers";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make a Dreadnaught Helmet if you bring him the following items: 1 Desecrated Helmet, 15 Wartorn Plate Scraps, 5 Arcanite Bars and 1 Nexus Crystal.";
      ["reward"] = {
         [1] = 22418;
      };
      ["name_cn"] = "无畏??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Dreadnaught Helmet";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "El casco acorator";
      ["req"] = 60;
   };
   [9042] = {
      ["name_ru"] = "Наручи неустрашимости";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands will make Dreadnaught Bracers if you bring him the following items: 1 Desecrated Bracers, 6 Wartorn Plate Scraps, 1 Arcanite Bar and 1 Nexus Crystal.";
      ["name_cn"] = "无畏?腕";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Brassards de cuirassier";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Armschienen des Schreckenspanzers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 22423;
      };
      ["name"] = "Dreadnaught Bracers";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los brazales acorator";
      ["req"] = 60;
   };
   [1681] = {
      ["name_ru"] = "Мастерская Сталекрута";
      ["type"] = "Solo";
      ["name_fr"] = "Base de Baguefer";
      ["next"] = 1682;
      ["name_de"] = "Eisenbands Truppenlager";
      ["objective"] = "Bring a load of Umbral Ore to Tormus Deepforge in Ironforge.";
      ["name_cn"] = "???地";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Ironband's Compound";
      ["prev"] = 1680;
      ["prequests"] = {
         [1] = 1680;
      };
      ["level"] = 11;
      ["name_es"] = "Complejo Vetaferro";
      ["req"] = 10;
   };
   [1685] = {
      ["name_ru"] = "Приглашение Гакина";
      ["type"] = "Solo";
      ["objective"] = "Report to Gakin the Darkbinder in the Mage Quarter of Stormwind.";
      ["next"] = 1688;
      ["sort"] = "Warlock";
      ["name_cn"] = "加科因的召?";
      ["name_fr"] = "Convocation de Gakin";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Gakins Beschworung";
      ["faction"] = "Alliance";
      ["name"] = "Gakin's Summons";
      ["level"] = 10;
      ["name_es"] = "La invocacion de Gakin";
      ["req"] = 10;
   };
   [1689] = {
      ["name_ru"] = "Оковы";
      ["type"] = "Solo";
      ["name_fr"] = "Le lien";
      ["name_de"] = "Die Bindung";
      ["objective"] = "Using the Bloodstone Choker, summon and subdue a voidwalker, then return the Bloodstone Choker to Gakin the Darkbinder in Stormwind.";
      ["name_cn"] = "誓?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Alliance";
      ["name"] = "The Binding";
      ["prev"] = 1688;
      ["prequests"] = {
         [1] = 1688;
      };
      ["level"] = 10;
      ["name_es"] = "El vinculo";
      ["req"] = 10;
   };
   [1693] = {
      ["name_ru"] = "Оружие из элунита";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Waffen aus Elunit";
      ["name_fr"] = "Armes en elunite";
      ["name"] = "Weapons of Elunite";
      ["name_cn"] = "月神武器";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6966;
         [2] = 6968;
         [3] = 6969;
         [4] = 6967;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1692;
      ["prequests"] = {
         [1] = 1692;
      };
      ["level"] = 10;
      ["name_es"] = "Armas de Elunita";
      ["req"] = 10;
   };
   [3512] = {
      ["name_ru"] = "Судя по словам Эраникуса...";
      ["type"] = "Solo";
      ["name_fr"] = "Par les mots d'Eranikus";
      ["name_de"] = "Mit Eranikus' eigenen Worten";
      ["name_cn"] = "?助伊?尼?斯";
      ["objective"] = "Travel to the eastern part of Winterspring and speak with Umbranse the Spiritspeaker.";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "In Eranikus' Own Words";
      ["prev"] = 3374;
      ["prequests"] = {
         [1] = 3374;
      };
      ["level"] = 55;
      ["name_es"] = "Como diria Eranikus...";
      ["req"] = 48;
   };
   [1701] = {
      ["name_ru"] = "Закаленный доспех";
      ["type"] = "Group";
      ["name_fr"] = "Une cotte de mailles en acier trempe";
      ["name_de"] = "Feuergeharteter Panzer";
      ["objective"] = "Gather the materials Furen Longbeard requires, and bring them to him in Stormwind.";
      ["name_cn"] = "弗?的?甲";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Fire Hardened Mail";
      ["prev"] = 1702;
      ["prequests"] = {
         [1] = 1702;
      };
      ["level"] = 28;
      ["name_es"] = "Armadura de malla endurecida con fuego";
      ["req"] = 20;
   };
   [1705] = {
      ["name_ru"] = "Пылающая кровь";
      ["type"] = "Solo";
      ["name_fr"] = "Le sang ardent";
      ["name_de"] = "Brennendes Blut";
      ["objective"] = "Bring 20 vials of Burning Blood and 1 Burning Rock to Grimand Elmore in Stormwind.";
      ["name_cn"] = "燃?之血";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Burning Blood";
      ["prev"] = 1700;
      ["prequests"] = {
         [1] = 1700;
      };
      ["level"] = 28;
      ["name_es"] = "Sangre ardiente";
      ["req"] = 20;
   };
   [1709] = {
      ["name_ru"] = "Творение Клацморта";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Klockmorts Kreation";
      ["name_fr"] = "La creation de Plethorloge";
      ["name"] = "Klockmort's Creation";
      ["name_cn"] = "科?莫特的成果";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6974;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1708;
      ["prequests"] = {
         [1] = 1708;
      };
      ["level"] = 30;
      ["name_es"] = "La creacion de Klockmort";
      ["req"] = 20;
   };
   [1713] = {
      ["name_ru"] = "Призыв";
      ["type"] = "Group";
      ["name_fr"] = "L'invocation";
      ["name_de"] = "Die Beschworung";
      ["objective"] = "Bring the Whirlwind Heart to Bath'rah Windwatcher.";
      ["name_cn"] = "召?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "The Summoning";
      ["prev"] = 1712;
      ["prequests"] = {
         [1] = 1712;
      };
      ["level"] = 40;
      ["name_es"] = "La invocacion";
      ["req"] = 30;
   };
   [1717] = {
      ["name_ru"] = "Приглашение Гакина";
      ["type"] = "Solo";
      ["objective"] = "Report to Gakin the Darkbinder in the Mage Quarter of Stormwind.";
      ["next"] = 1716;
      ["sort"] = "Warlock";
      ["name_cn"] = "加科因的召?";
      ["name_fr"] = "Convocation de Gakin";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Gakins Beschworung";
      ["faction"] = "Alliance";
      ["name"] = "Gakin's Summons";
      ["level"] = 20;
      ["name_es"] = "La invocacion de Gakin";
      ["req"] = 20;
   };
   [9050] = {
      ["name_ru"] = "Накулачники Искупления";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands will make Redemption Wristguards if you bring him the following: 1 Desecrated Wristguards, 6 Wartorn Plate Scraps, 1 Arcanite Bar and 2 Cured Rugged Hides.";
      ["name_cn"] = "救??腕";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-poignets de redemption";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handgelenksschutzer der Erlosung";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 22424;
      };
      ["name"] = "Redemption Wristguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardamunecas de redencion";
      ["req"] = 60;
   };
   [9051] = {
      ["name_ru"] = "Испытание яда";
      ["type"] = "Group";
      ["name_fr"] = "Test de toxicite";
      ["next"] = 9053;
      ["name_de"] = "Giftexperiment";
      ["objective"] = "Stab a Devilsaur with the Devilsaur Barb. Return to Torwa Pathfinder in Un'Goro Crater when you have completed this task.";
      ["name_cn"] = "毒性??";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["faction"] = "Horde";
      ["name"] = "Toxic Test";
      ["prev"] = 9052;
      ["prequests"] = {
         [1] = 9052;
      };
      ["level"] = 52;
      ["name_es"] = "Prueba de toxicidad";
      ["req"] = 50;
   };
   [7842] = {
      ["name_ru"] = "Еще одно послание клану Громового Молота";
      ["type"] = "PvP";
      ["name_fr"] = "Encore un message pour les Marteaux-hardis";
      ["next"] = 7843;
      ["name_de"] = "Eine weitere Botschaft an die Wildhammer";
      ["name_cn"] = "又一个?蛮?部族的警告";
      ["objective"] = "Otho Moji'ko at Revantusk Village in the Hinterlands wants you to bring him 10 Long Elegant Feathers from the gryphons that inhabit the Hinterlands. Return to him once this task is complete.$B$BGryphons are known to inhabit every region of the Hinterlands.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Horde";
      ["name"] = "Another Message to the Wildhammer";
      ["prev"] = 7841;
      ["prequests"] = {
         [1] = 7841;
      };
      ["level"] = 48;
      ["name_es"] = "Un nuevo mensaje para los Martillo Salvaje";
      ["req"] = 44;
   };
   [1919] = {
      ["name_ru"] = "Задание Джиннии";
      ["type"] = "Solo";
      ["name_fr"] = "Rendre compte a Jennea";
      ["repgain"] = {
         [72] = 1;
      };
      ["name_de"] = "Meldung bei Jennea";
      ["name_cn"] = "向詹???告";
      ["objective"] = "Speak with Jennea Cannon in Stormwind.";
      ["classes"] = {
         [1] = "Mage";
      };
      ["next"] = 1920;
      ["name"] = "Report to Jennea";
      ["sort"] = "Mage";
      ["races"] = {
         [1] = "Human";
      };
      ["level"] = 15;
      ["name_es"] = "Presentate ante Jennea";
      ["req"] = 15;
   };
   [8724] = {
      ["name_ru"] = "Предок Утренняя Роса";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Rosee-du-matin";
      ["name_cn"] = "晨露?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Morgentau";
      ["faction"] = "Horde";
      ["name"] = "Morningdew the Elder";
      ["level"] = 60;
      ["name_es"] = "Albarrocio el Ancestro";
      ["req"] = 1;
   };
   [6962] = {
      ["name_ru"] = "Угощение для Дедушки Зимы";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Gingerbread Cookies and an Ice Cold Milk to Great-father Winter in Orgrimmar.";
      ["repgain"] = {
         [21] = 25;
         [369] = 25;
         [577] = 25;
         [470] = 25;
      };
      ["sort"] = "Hallow's End";
      ["name_fr"] = "Des friandises pour Grand-pere Hiver";
      ["name_cn"] = "冬幕?的礼物";
      ["reward"] = {
         [1] = 17727;
      };
      ["name_de"] = "Leckereien fur Altvater Winter";
      ["faction"] = "Horde";
      ["name"] = "Treats for Great-father Winter";
      ["level"] = 60;
      ["name_es"] = "Golosinas para el Gran Padre Invierno";
      ["req"] = 10;
   };
   [1123] = {
      ["name_ru"] = "Рабин Сатурна";
      ["type"] = "Solo";
      ["objective"] = "Speak with Rabine Saturna in the village of Nighthaven, Moonglade.  Moonglade lies between Felwood and Winterspring, accessible through a path out of Timbermaw Hold.";
      ["next"] = 1124;
      ["name_fr"] = "Rabine Saturna";
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "拉比恩・???";
      ["followup"] = 1124;
      ["repgain"] = {
         [609] = 25;
      };
      ["name_de"] = "Rabine Saturna";
      ["faction"] = "Horde";
      ["name"] = "Rabine Saturna";
      ["level"] = 55;
      ["name_es"] = "Rabine Saturna";
      ["req"] = 54;
   };
   [6022] = {
      ["name_ru"] = "Преднамеренное убийство";
      ["type"] = "Solo";
      ["objective"] = "Travel to Corin's Crossing to the east and slaughter the Scourge that inhabit the town. Collect 7 pieces of Living Rot in under 10 minutes. Use the Mortar and Pestle to grind the Living Rot into Coagulated Rot.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Tuer utile";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?戮的理由";
      ["name_de"] = "Toten zu einem bestimmten Zweck";
      ["faction"] = "Horde";
      ["name"] = "To Kill With Purpose";
      ["level"] = 58;
      ["name_es"] = "Matar con un proposito";
      ["req"] = 54;
   };
   [8377] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??物?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20702;
         [2] = 20713;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [7026] = {
      ["name_ru"] = "Упряжь ездовых баранов";
      ["type"] = "PvP";
      ["objective"] = "null";
      ["repgain"] = {
         [47] = 10;
         [730] = 2;
      };
      ["sort"] = "Alterac Valley";
      ["name_fr"] = "Harnais pour beliers";
      ["name_cn"] = "山羊坐具";
      ["name_de"] = "Widderzaumzeug";
      ["faction"] = "Alliance";
      ["name"] = "Ram Riding Harnesses";
      ["level"] = 60;
      ["name_es"] = "Arneses de pellejo de carnero";
      ["req"] = 51;
   };
   [7042] = {
      ["name_ru"] = "Пропавшее угощение Зимнего Покрова";
      ["type"] = "Solo";
      ["objective"] = "Locate the Smokywood Pastures investigator that has gone missing in the snowy regions of the Alterac Mountains.";
      ["next"] = 7043;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "被?走的冬幕?礼物";
      ["name_fr"] = "Friandises volees de la fete du Voile d'hiver";
      ["name_de"] = "Gestohlene Winterhauchleckereien";
      ["faction"] = "Alliance";
      ["name"] = "Stolen Winter Veil Treats";
      ["level"] = 60;
      ["name_es"] = "El robo de las golosinas del Festival de Invierno";
      ["req"] = 30;
   };
   [4602] = {
      ["name_ru"] = "Чистер 5200!";
      ["type"] = "Dungeon";
      ["objective"] = " followed by some text:$B$B\"Grime and residue ruining your sparklies?  The Sparklematic 5200 puts the shine back in shine-tastic!  Insert the item you wish to clean and deposit three silver coins in the coin slot.  Give the Sparklematic 5200 a moment for operation";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "超?清?器5200型！";
      ["name_fr"] = "Le Brille-o-Matic 5200?!";
      ["name_de"] = "Der Funkelmat 5200!";
      ["faction"] = "Horde";
      ["name"] = "The Sparklematic 5200!";
      ["level"] = 30;
      ["name_es"] = "!El Destellamatic 5200!";
      ["req"] = 25;
   };
   [2609] = {
      ["name_ru"] = "Прикосновение Занзила";
      ["type"] = "Solo";
      ["name_fr"] = "Le toucher de Zanzil";
      ["name_de"] = "Die Beruhrung von Zanzil";
      ["objective"] = "Bring Doc Mixilpixil one bundle of Simple Wildflowers, one Leaded Vial, one Bronze Tube, and one Spool of Light Chartreuse Silk Thread. The 'itis' doesn't cure itself, young $g fella:lady;. ";
      ["reward"] = {
         [1] = 8432;
      };
      ["name_cn"] = "?吉?之触";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "The Touch of Zanzil";
      ["sort"] = "Rogue";
      ["prev"] = 2608;
      ["prequests"] = {
         [1] = 2608;
      };
      ["level"] = 20;
      ["name_es"] = "Toque de Zanzil";
      ["req"] = 20;
   };
   [9074] = {
      ["name_ru"] = "Ремень Землекрушителя";
      ["objective"] = "Rimblat Earthshatter at Light's Hope Chapel in the Eastern Plaguelands will make an Earthshatter Girdle if you bring him the following: 1 Desecrated Girdle, 8 Wartorn Chain Scraps, 1 Arcanite Bar and 3 Nexus Crystals.";
      ["name_cn"] = "碎地者束腰";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le ceinturon de Brise-terre";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gurt des Erdspalters";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 22470;
      };
      ["name"] = "Earthshatter Girdle";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La faja Rompeterra";
      ["req"] = 60;
   };
   [2759] = {
      ["name_ru"] = "В поисках Гальвана";
      ["type"] = "Solo";
      ["name_fr"] = "A la recherche de Galvan";
      ["next"] = 2760;
      ["name_de"] = "Auf der Suche nach Galvan";
      ["objective"] = "Speak with McGavan in Booty Bay.";
      ["name_cn"] = "?找加?文";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Alliance";
      ["name"] = "In Search of Galvan";
      ["followup"] = 2760;
      ["prev"] = 2758;
      ["prequests"] = {
         [1] = 2758;
      };
      ["level"] = 40;
      ["name_es"] = "Buscando a Galvan";
      ["req"] = 40;
   };
   [1781] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1786;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Take the Symbol of Life to Gazin Tenorm in Stormwind.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1780;
      ["prequests"] = {
         [1] = 1780;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1785] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Speak to Tiza Battleforge in Ironforge.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 1784;
      ["prequests"] = {
         [1] = 1784;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [1789] = {
      ["name_ru"] = "Знак Жизни";
      ["type"] = "Solo";
      ["name_fr"] = "Le Symbole de vie";
      ["sort"] = "Paladin";
      ["name_cn"] = "生命符?";
      ["objective"] = "";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name_de"] = "Das Symbol des Lebens";
      ["name"] = "The Symbol of Life";
      ["reward"] = {
         [1] = 6866;
      };
      ["races"] = {
         [1] = "Dwarf";
      };
      ["level"] = 12;
      ["name_es"] = "El Simbolo de la Vida";
      ["req"] = 12;
   };
   [7170] = {
      ["name_ru"] = "Заслуженное почтение";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Verdiente Ehrerbietung";
      ["name_fr"] = "Montee en grade";
      ["name_cn"] = "?得尊敬";
      ["name"] = "Earned Reverence";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17902;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7169;
      ["prequests"] = {
         [1] = 7169;
      };
      ["level"] = 60;
      ["name_es"] = "Ganarse una reverencia";
      ["req"] = 51;
   };
   [9027] = {
      ["name_ru"] = "Поиск источника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Evert Sorisam at The Finest Thread along Stormwind's Canals.";
      ["next"] = 9028;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "追??源";
      ["name_fr"] = "Remonter a la source";
      ["name_de"] = "Verfolgung der Spur";
      ["faction"] = "Alliance";
      ["name"] = "Tracing the Source";
      ["level"] = 70;
      ["name_es"] = "Rastrear la fuente";
      ["req"] = 56;
   };
   [7202] = {
      ["name_ru"] = "Коррак Кровопуск";
      ["type"] = "Raid";
      ["objective"] = "According to legend, the leader of the mighty Winterax trolls appears at will to wreak havoc on the denizens of Alterac Valley.$B$BShould Korrak make himself known, destroy him and return to Lieutenant Haggerdin in the Alterac Mountains.";
      ["name_fr"] = "Korrak le Ragesang";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "血怒者科?拉克";
      ["reward"] = {
         [1] = 19107;
         [2] = 18150;
         [3] = 19106;
         [4] = 19108;
      };
      ["name_de"] = "Korrak der Blutrunstige";
      ["faction"] = "Alliance";
      ["name"] = "Korrak the Bloodrager";
      ["level"] = 60;
      ["name_es"] = "Korrak el Sanguinario";
      ["req"] = 51;
   };
   [1805] = {
      ["name_ru"] = "Фолиант заговора";
      ["objective"] = "Bring the Reconstructed Tome and 3 Rods of Channeling to Strahad Farsan in Ratchet.";
      ["name_cn"] = "??之?";
      ["sort"] = "Warlock";
      ["level"] = 30;
      ["type"] = "Solo";
      ["name_fr"] = "Tome de la Cabale";
      ["next"] = 1795;
      ["name_de"] = "Foliant der Kabale";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Tome of the Cabal";
      ["prev"] = 1803;
      ["prequests"] = {
         [1] = 1803;
      };
      ["series"] = 3;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [1652] = {
      ["name_ru"] = "Фолиант Отваги";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_cn"] = "勇气之?";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["level"] = 25;
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["next"] = 1653;
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["sort"] = "Paladin";
      ["name"] = "The Tome of Valor";
      ["prev"] = 1651;
      ["prequests"] = {
         [1] = 1651;
      };
      ["reward"] = {
         [1] = 9607;
      };
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [9090] = {
      ["name_ru"] = "Сапоги сновидца";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make Dreamwalker Boots if you bring her the following: 1 Desecrated Boots, 12 Wartorn Leather Scraps, 3 Mooncloth and 2 Cured Rugged Hides.";
      ["name_cn"] = "梦游者?靴";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les bottes de marchereve";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Stiefel des Traumwandlers";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22492;
      };
      ["name"] = "Dreamwalker Boots";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las botas Caminasuenos";
      ["req"] = 60;
   };
   [8288] = {
      ["name_ru"] = "Кто будет избран?";
      ["type"] = "Raid";
      ["name_fr"] = "Il ne peut y en avoir qu'un";
      ["repgain"] = {
         [910] = 200;
      };
      ["name_de"] = "Nur einer kann sich erheben";
      ["name"] = "Only One May Rise";
      ["name_cn"] = "唯一的?袖";
      ["objective"] = "Return the Head of the Broodlord Lashlayer to Baristolth of the Shifting Sands at Cenarion Hold in Silithus.";
      ["next"] = 8301;
      ["faction"] = "Horde";
      ["sort"] = "Blackwing Lair";
      ["prev"] = 8286;
      ["prequests"] = {
         [1] = 8286;
      };
      ["level"] = 60;
      ["name_es"] = "Solo uno puede alzarse";
      ["req"] = 60;
   };
   [1821] = {
      ["name_ru"] = "Наследие Агамондов";
      ["type"] = "Solo";
      ["name_fr"] = "L'heritage des Agamand";
      ["next"] = 1822;
      ["name_de"] = "Agamand-Erbstucke";
      ["objective"] = "Bring Coleman Farthing the Agamand Family Axe, the Agamand Family Sword, the Agamand Family Mace and the Agamand Family dagger.";
      ["name_cn"] = "阿加曼德家?武器";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Agamand Heirlooms";
      ["prev"] = 1820;
      ["prequests"] = {
         [1] = 1820;
      };
      ["level"] = 11;
      ["name_es"] = "Reliquias Agamand";
      ["req"] = 10;
   };
   [1825] = {
      ["name_ru"] = "Разговор с Тун'гримом";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Thun'grim";
      ["next"] = 1838;
      ["name_de"] = "Gesprach mit Thun'grim";
      ["objective"] = "Speak with Thun'grim Firegaze in the Barrens.";
      ["name_cn"] = "和索恩格瑞姆交?";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Speak with Thun'grim";
      ["prev"] = 1824;
      ["prequests"] = {
         [1] = 1824;
      };
      ["level"] = 20;
      ["name_es"] = "Habla con Thun'grim";
      ["req"] = 20;
   };
   [5925] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mathrengyl Bearwalker in the Cenarion Enclave, Darnassus.";
      ["next"] = 5921;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "??召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [8907] = {
      ["name_ru"] = "Серьезное предложение";
      ["type"] = "Dungeon";
      ["objective"] = "Acquire 15 Winterspring Blood Samples and 20 gold and bring them along with a set of Magister's Bindings to Deliana in Ironforge.";
      ["name_fr"] = "Une proposition serieuse";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?心的建?";
      ["followup"] = 8922;
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 22063;
      };
      ["name_de"] = "Ein aufrichtiges Angebot";
      ["faction"] = "Alliance";
      ["name"] = "An Earnest Proposition";
      ["level"] = 60;
      ["name_es"] = "Una propuesta seria";
      ["req"] = 58;
   };
   [8680] = {
      ["name_ru"] = "Предок Тотем Ветра";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Totem-de-vent";
      ["name_cn"] = "?之???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Windtotem";
      ["faction"] = "Horde";
      ["name"] = "Windtotem the Elder";
      ["level"] = 60;
      ["name_es"] = "Totem de Viento el Ancestro";
      ["req"] = 1;
   };
   [1841] = {
      ["name_ru"] = "Велора Нители и Набедренники Жестокости";
      ["type"] = "Solo";
      ["name_fr"] = "Velora Nitely et les garde-jambes de brutalite";
      ["next"] = 1846;
      ["name_de"] = "Velora Nachtens und die brutalen Beinschutzer";
      ["objective"] = "Speak with Velora Nitely in the Undercity.";
      ["name_cn"] = "??拉・奈特雷和野蛮腿甲";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "Velora Nitely and the Brutal Legguards";
      ["prev"] = 1838;
      ["prequests"] = {
         [1] = 1838;
      };
      ["level"] = 30;
      ["name_es"] = "Velora Noctis y las musleras brutal";
      ["req"] = 20;
   };
   [1845] = {
      ["name_ru"] = "Шлем Жестокости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Brutaler Helm";
      ["name_fr"] = "Camail de brutalite";
      ["name"] = "Brutal Helm";
      ["name_cn"] = "野蛮??";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 7130;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1844;
      ["prequests"] = {
         [1] = 1844;
      };
      ["level"] = 30;
      ["name_es"] = "Yelmo brutal";
      ["req"] = 20;
   };
   [9106] = {
      ["name_ru"] = "Наплечные пластины Проклятого Сердца";
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-epaules de pestecoeur";
      ["name_de"] = "Schulterpolster des verseuchten Herzens";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make Plagueheart Shoulderpads if you bring him the following: 1 Desecrated Shoulderpads, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.";
      ["reward"] = {
         [1] = 22507;
      };
      ["name_cn"] = "瘟疫之心肩?";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Plagueheart Shoulderpads";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Las hombreras corazon de la peste";
      ["req"] = 60;
   };
   [9112] = {
      ["name_ru"] = "Поножи веры";
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres de foi";
      ["name_de"] = "Gamaschen des Glaubens";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make Leggings of Faith if you bring him the following: 1 Desecrated Leggings, 20 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22513;
      };
      ["name_cn"] = "信仰?腿";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["name"] = "Leggings of Faith";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Los leotardos de fe";
      ["req"] = 60;
   };
   [7426] = {
      ["name_ru"] = "Любовь к ближнему";
      ["type"] = "PvP";
      ["objective"] = "";
      ["name_cn"] = "光明的??";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Die Liebe eines Mannes";
      ["faction"] = "Horde";
      ["name"] = "One Man's Love";
      ["level"] = 60;
      ["name_es"] = "El amor de un hombre";
      ["req"] = 55;
   };
   [1861] = {
      ["name_ru"] = "Зеркальное озеро";
      ["type"] = "Solo";
      ["name_fr"] = "Le lac Miroir";
      ["name_de"] = "Spiegelsee";
      ["sort"] = "Mage";
      ["objective"] = "Bring a Mirror Lake sample to Jennea Cannon in Stormwind.";
      ["name_cn"] = "明?湖";
      ["name"] = "Mirror Lake";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7508;
         [2] = 9513;
      };
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1860;
      ["prequests"] = {
         [1] = 1860;
      };
      ["level"] = 10;
      ["name_es"] = "Lago Espejo";
      ["req"] = 10;
   };
   [4121] = {
      ["name_ru"] = "Опасное положение";
      ["type"] = "Dungeon";
      ["name_fr"] = "Situation precaire";
      ["name_de"] = "Gefahrliche Zwickmuhle";
      ["name_cn"] = "押送囚徒";
      ["objective"] = "Escort your prisoner, Grark Lorkrub, through Burning Steppes and through Blackrock Mountain to the Searing Gorge.$B$BYou recall Lexlort mentioning that he would have his men waiting on the other side to take Grark into custody.$B$BYou will also be required to hand over your Thorium Shackles to Lexlort.";
      ["sort"] = "Blackrock Depths";
      ["faction"] = "Horde";
      ["name"] = "Precarious Predicament";
      ["prev"] = 4122;
      ["prequests"] = {
         [1] = 4122;
      };
      ["level"] = 58;
      ["name_es"] = "!Estas en un aprieto!";
      ["req"] = 52;
   };
   [4129] = {
      ["name_ru"] = "Тайна ножа";
      ["type"] = "Solo";
      ["name_fr"] = "Le couteau revele";
      ["next"] = 4130;
      ["name_de"] = "Das wieder aufgetauchte Messer";
      ["name_cn"] = "奎恩提斯的技?";
      ["objective"] = "Take the Discarded Knife to Quintis Jonespyre in Feathermoon Stronghold.";
      ["sort"] = "Feralas";
      ["faction"] = "Alliance";
      ["name"] = "The Knife Revealed";
      ["prev"] = 4127;
      ["prequests"] = {
         [1] = 4127;
      };
      ["level"] = 44;
      ["name_es"] = "La revelacion del cuchillo";
      ["req"] = 40;
   };
   [7490] = {
      ["name_ru"] = "Победа Орды";
      ["type"] = "Solo";
      ["objective"] = "Take the Head of Onyxia to Thrall in Orgrimmar.";
      ["next"] = 7491;
      ["name_fr"] = "Victoire pour la Horde?!";
      ["sort"] = "Orgrimmar";
      ["name_cn"] = "部落的?利";
      ["repgain"] = {
         [76] = 500;
      };
      ["name_de"] = "Sieg fur die Horde";
      ["faction"] = "Horde";
      ["name"] = "Victory for the Horde";
      ["level"] = 60;
      ["name_es"] = "Victoria para la Horda";
      ["req"] = 60;
   };
   [7506] = {
      ["name_ru"] = "Изумрудный Сон";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Dire Maul";
      ["name_fr"] = "Le Reve d'Emeraude…";
      ["name_cn"] = "翡翠梦境……";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 18470;
      };
      ["name_de"] = "Der Smaragdgrune Traum";
      ["faction"] = "Horde";
      ["name"] = "The Emerald Dream...";
      ["level"] = 60;
      ["name_es"] = "El Sueno Esmeralda";
      ["req"] = 54;
   };
   [1881] = {
      ["name_ru"] = "Разговор с Анастасией";
      ["type"] = "Solo";
      ["objective"] = "Speak with Anastasia Hartwell.";
      ["next"] = 1882;
      ["name_de"] = "Gesprach mit Anastasia";
      ["sort"] = "Mage";
      ["name_cn"] = "安娜斯塔西?";
      ["name_fr"] = "Parler a Anastasia";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Speak with Anastasia";
      ["level"] = 10;
      ["name_es"] = "Habla con Anastasia";
      ["req"] = 10;
   };
   [1885] = {
      ["name_ru"] = "Меннит Каркад";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mennet Carkad in the Rogues' Quarter of the Undercity.";
      ["next"] = 1886;
      ["name_de"] = "Mennet Carkad";
      ["sort"] = "Rogue";
      ["name_cn"] = "米奈特・?加德";
      ["name_fr"] = "Mennet Carkad";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Mennet Carkad";
      ["level"] = 10;
      ["name_es"] = "Mennet Carkad";
      ["req"] = 10;
   };
   [8286] = {
      ["name_ru"] = "Что ждет нас завтра";
      ["type"] = "Solo";
      ["objective"] = " he said";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_fr"] = "Ce que demain apportera";
      ["sort"] = "Silithus";
      ["name_cn"] = "明天的希望";
      ["name_de"] = "Was uns morgen erwartet";
      ["faction"] = "Horde";
      ["name"] = "What Tomorrow Brings";
      ["level"] = 60;
      ["name_es"] = "Lo que nos depara el futuro";
      ["req"] = 60;
   };
   [9114] = {
      ["name_ru"] = "Наплечные пластины веры";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make Shoulderpads of Faith if you bring him the following: 1 Desecrated Shoulderpads, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.";
      ["name_cn"] = "信仰肩?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le protege-epaules de foi";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Schulterpolster des Glaubens";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22515;
      };
      ["name"] = "Shoulderpads of Faith";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Las hombreras de fe";
      ["req"] = 60;
   };
   [9115] = {
      ["name_ru"] = "Сандалии веры";
      ["objective"] = "Father Inigo Montoy at Light's Hope Chapel in the Eastern Plaguelands will make Sandals of Faith if you bring him the following: 1 Desecrated Sandals, 12 Wartorn Cloth Scraps, 2 Mooncloth and 3 Cured Rugged Hides.$B";
      ["name_cn"] = "信仰便鞋";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les sandales de foi";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Sandalen des Glaubens";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 22516;
      };
      ["name"] = "Sandals of Faith";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los botines de fe";
      ["req"] = 60;
   };
   [7602] = {
      ["name_ru"] = "Безупречная субстанция Скверны";
      ["type"] = "Solo";
      ["name_fr"] = "La gangressence parfaite";
      ["next"] = 7603;
      ["name_de"] = "Reine Teufelsessenz";
      ["objective"] = "Impsy in Felwood has asked that you bring him three Flawless Fel Essences originating from three distinct locations.$B$BThe Legashi Satyrs of Azshara hold the Flawless Fel Essence of their region. The Jaedenar Legionnaires of Jaedenar hold the Flawless Fel Essence of their region. The Felguard Sentries of the Blasted Lands hold the Flawless Fel Essence of their region.$B$BRecover the Flawless Fel Essences and return  to Impsy in Felwood.";
      ["name_cn"] = "无暇的?魔精?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Flawless Fel Essence";
      ["prev"] = 7601;
      ["prequests"] = {
         [1] = 7601;
      };
      ["level"] = 55;
      ["name_es"] = "Esencia de energia vil pura";
      ["req"] = 50;
   };
   [3117] = {
      ["name_ru"] = "Выгравированный знак";
      ["type"] = "Solo";
      ["name_fr"] = "Le cachet grave";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Geatztes Siegelzeichen";
      ["objective"] = "Read the Etched Sigil and speak to Ayanna Everstride at the top of Aldrassil in Shadowglen.";
      ["name_cn"] = "?化符?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Etched Sigil";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 457;
      ["prequests"] = {
         [1] = 457;
      };
      ["level"] = 1;
      ["name_es"] = "El sigilo con grabados";
      ["req"] = 1;
   };
   [7634] = {
      ["name_ru"] = "Перетянутый жилами лист древня";
      ["type"] = "Raid";
      ["name_fr"] = "Feuille d'Ancien cousue de tendons";
      ["name_de"] = "Uraltes in Sehnen eingewickeltes Laminablatt";
      ["objective"] = "Hastat the Ancient has asked that you bring him a Mature Blue Dragon Sinew. Should you find this sinew, return it to Hastat in Felwood.";
      ["reward"] = {
         [1] = 18714;
      };
      ["name_cn"] = "?筋箭袋";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Ancient Sinew Wrapped Lamina";
      ["sort"] = "Hunter";
      ["prev"] = 7632;
      ["prequests"] = {
         [1] = 7632;
      };
      ["level"] = 60;
      ["name_es"] = "Carcaj antiguo cosido con tendon";
      ["req"] = 60;
   };
   [7650] = {
      ["name_ru"] = "\"Зачарованная ториевая броня\", том II";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Les plates en thorium enchante - Volume II";
      ["name_cn"] = "魔化瑟?板甲：第二卷";
      ["reward"] = {
         [1] = 12726;
      };
      ["name_de"] = "Verzauberter Thoriumplattenpanzer: Band II";
      ["faction"] = "Horde";
      ["name"] = "Enchanted Thorium Platemail: Volume II";
      ["level"] = 60;
      ["name_es"] = "Las mallas de placas en torio encantado: volumen II";
      ["req"] = 60;
   };
   [7666] = {
      ["name_ru"] = "Возвращение в Главный склеп";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name_fr"] = "Retour au Grand ossuaire";
      ["name"] = "Again Into the Great Ossuary";
      ["name_cn"] = "重回尸骨?藏所";
      ["name_de"] = "Erneut im Grosen Ossuarium";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 18746;
      };
      ["sort"] = "Paladin";
      ["prev"] = 7647;
      ["prequests"] = {
         [1] = 7647;
      };
      ["level"] = 60;
      ["name_es"] = "El regreso a El Gran Osario";
      ["req"] = 60;
   };
   [1921] = {
      ["name_ru"] = "Сбор материалов";
      ["type"] = "Solo";
      ["name_fr"] = "Rassembler les materiaux";
      ["name_de"] = "Materialsammlung";
      ["objective"] = "Bring 10 Linen Cloth and the 6 Charged Rift Gems to Wynne Larson in Stormwind.";
      ["name_cn"] = "收集原料";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Gathering Materials";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1920;
      ["prequests"] = {
         [1] = 1920;
      };
      ["level"] = 15;
      ["name_es"] = "Recoleccion de materiales";
      ["req"] = 15;
   };
   [4481] = {
      ["name_ru"] = "Манускрипт Здоровья";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Burning Steppes";
      ["name_fr"] = "Libram de constitution";
      ["name_cn"] = "体??典";
      ["reward"] = {
         [1] = 11642;
      };
      ["name_de"] = "Buchband der Konstitution";
      ["faction"] = "Horde";
      ["name"] = "Libram of Constitution";
      ["level"] = 55;
      ["name_es"] = "Tratado sobre Constitucion";
      ["req"] = 50;
   };
   [8956] = {
      ["name_ru"] = "Прощальные слова Антиона";
      ["objective"] = "Return to Deliana in Ironforge with a set of Shadowcraft Boots, Shadowcraft Pants and Shadowcraft Spaulders.";
      ["name_cn"] = "安希恩的??感言";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Les adieux d'Anthion";
      ["next"] = 8960;
      ["name_de"] = "Anthions Abschiedsworte";
      ["followup"] = 8960;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Anthion's Parting Words";
      ["prev"] = 9015;
      ["prequests"] = {
         [1] = 9015;
      };
      ["reward"] = {
         [1] = 22003;
         [2] = 22007;
         [3] = 22008;
      };
      ["name_es"] = "La despedida de Anthion";
      ["req"] = 58;
   };
   [7730] = {
      ["name_ru"] = "Вторжение улья Цуккаш";
      ["type"] = "Solo";
      ["name_fr"] = "Infestation de Zukk'ash";
      ["repgain"] = {
         [76] = 250;
         [68] = 250;
         [81] = 250;
         [530] = 250;
      };
      ["name_de"] = "Zukk'ash-Plage";
      ["followup"] = 7732;
      ["name_cn"] = "祖?什的入侵";
      ["objective"] = "Bring 20 Zukk'ash Carapaces to Hadoken Swiftstrider at Camp Mojache, Feralas.";
      ["faction"] = "Horde";
      ["name"] = "Zukk'ash Infestation";
      ["sort"] = "Feralas";
      ["prev"] = 2903;
      ["prequests"] = {
         [1] = 2903;
      };
      ["level"] = 45;
      ["name_es"] = "Infestacion de Zukk'ash";
      ["req"] = 39;
   };
   [8526] = {
      ["name_ru"] = "Альянсу не хватает жареного мяса ящера!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Roast Raptor to Sarah Sadwhistle at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de rotis de raptor !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要?迅猛?肉！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21511;
      };
      ["name_de"] = "Die Allianz braucht gerostete Raptoren!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Roast Raptor!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita raptor asado!";
      ["req"] = 33;
   };
   [1941] = {
      ["name_ru"] = "Одеяние из ткани маны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["races"] = {
         [1] = "Human";
      };
      ["name_fr"] = "La robe de tisse-mana";
      ["name"] = "Manaweave Robe";
      ["name_cn"] = "法??袍";
      ["name_de"] = "Managewirkte Robe";
      ["classes"] = {
         [1] = "Mage";
      };
      ["reward"] = {
         [1] = 7509;
      };
      ["sort"] = "Mage";
      ["prev"] = 1921;
      ["prequests"] = {
         [1] = 1921;
      };
      ["level"] = 15;
      ["name_es"] = "Toga Tejemana";
      ["req"] = 15;
   };
   [1945] = {
      ["name_ru"] = "Смеющиеся сестры";
      ["type"] = "Solo";
      ["name_fr"] = "Les s?urs rieuses";
      ["name_de"] = "Lachende Schwestern";
      ["objective"] = "Bring 12 Laughing Sister's Hairs to Kil'hala at the Crossroads.";
      ["name_cn"] = "?笑的姐妹";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Laughing Sisters";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1944;
      ["prequests"] = {
         [1] = 1944;
      };
      ["level"] = 26;
      ["name_es"] = "Hermanas sonrientes";
      ["req"] = 26;
   };
   [1949] = {
      ["name_ru"] = "Великие тайны";
      ["type"] = "Solo";
      ["name_fr"] = "Des secrets caches";
      ["next"] = 1950;
      ["name_de"] = "Verborgene Geheimnisse";
      ["objective"] = "Speak with Magus Tirth in the Shimmering Flats.";
      ["name_cn"] = "?藏的秘密";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Horde";
      ["name"] = "Hidden Secrets";
      ["prev"] = 1947;
      ["prequests"] = {
         [1] = 1947;
      };
      ["level"] = 38;
      ["name_es"] = "Secretos escondidos";
      ["req"] = 30;
   };
   [1953] = {
      ["name_ru"] = "Возвращение на болота";
      ["type"] = "Solo";
      ["objective"] = "Speak with Tabetha.";
      ["next"] = 1954;
      ["sort"] = "Mage";
      ["name_cn"] = "返回沼?";
      ["name_fr"] = "Retourner dans le Marais";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name_de"] = "Ruckkehr in die Marschen";
      ["faction"] = "Horde";
      ["name"] = "Return to the Marsh";
      ["level"] = 40;
      ["name_es"] = "Regresa a la Marisma";
      ["req"] = 35;
   };
   [7826] = {
      ["name_ru"] = "Пожертвование ? шерсть";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [76] = 150;
      };
      ["sort"] = "Orgrimmar";
      ["name_fr"] = "Un don de laine";
      ["name_cn"] = "捐献毛料";
      ["followup"] = 7824;
      ["name_de"] = "Spendet Wolle";
      ["faction"] = "Horde";
      ["name"] = "A Donation of Wool";
      ["level"] = 60;
      ["name_es"] = "Un donativo de lana";
      ["req"] = 12;
   };
   [1961] = {
      ["name_ru"] = "Сбор материалов";
      ["type"] = "Solo";
      ["name_fr"] = "Rassembler les materiaux";
      ["name_de"] = "Materialsammlung";
      ["objective"] = "Bring 10 Linen Cloth and 6 Dalaran Mana Gems to Josef Gregorian.";
      ["name_cn"] = "收集原料";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Gathering Materials";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 1960;
      ["prequests"] = {
         [1] = 1960;
      };
      ["level"] = 15;
      ["name_es"] = "Recoleccion de materiales";
      ["req"] = 15;
   };
   [4281] = {
      ["name_ru"] = "Посылка в Таланаар";
      ["type"] = "Solo";
      ["objective"] = "Bring the Undelivered Parcel to Falfindel Waywarder in Thalanaar.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_fr"] = "La livraison a Thalanaar";
      ["sort"] = "Feralas";
      ["name_cn"] = "????的?物";
      ["name_de"] = "Thalanaar-Lieferung";
      ["faction"] = "Alliance";
      ["name"] = "Thalanaar Delivery";
      ["level"] = 44;
      ["name_es"] = "Una entrega en Thalanaar";
      ["req"] = 40;
   };
   [7874] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_fr"] = "Ecrasez les usurpateurs d'Aile-argent";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 35;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 30;
   };
   [7890] = {
      ["name_ru"] = "Тяжелый точильный камень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Silex a aiguiser lourd";
      ["name_cn"] = "重砂?";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Schwerer Schleifstein";
      ["faction"] = "Horde";
      ["name"] = "Heavy Grinding Stone";
      ["level"] = 60;
      ["name_es"] = "Piedra de pulir pesada";
      ["req"] = 10;
   };
   [9108] = {
      ["name_ru"] = "Перчатки Проклятого Сердца";
      ["type"] = "Raid";
      ["name_fr"] = "Les gants de pestecoeur";
      ["name_de"] = "Handschuhe des verseuchten Herzens";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make Plagueheart Gloves if you bring him the following: 1 Desecrated Gloves, 8 Wartorn Cloth Scraps and 4 Mooncloth.";
      ["reward"] = {
         [1] = 22509;
      };
      ["name_cn"] = "瘟疫之心手套";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Plagueheart Gloves";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "Los guantes corazon de la peste";
      ["req"] = 60;
   };
   [7922] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["name_fr"] = "Marque d'honneur";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["objective"] = "You obtained a Warsong Mark of Honor for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["name_de"] = "Ehrenabzeichen";
      ["prev"] = 7876;
      ["prequests"] = {
         [1] = 7876;
      };
      ["level"] = 55;
      ["name_es"] = "Marca de Honor";
      ["req"] = 50;
   };
   [7938] = {
      ["name_ru"] = "Ты найдешь свою удачу...";
      ["type"] = "Solo";
      ["objective"] = " you see an image of the Deadmines inside Westfall's ruined hamlet of Moonbrook.  Focusing closer in on the image";
      ["repgain"] = {
         [909] = 75;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Une surprise vous attend...";
      ["name_cn"] = "?富在等着?……";
      ["reward"] = {
         [1] = 19425;
      };
      ["name_de"] = "Euer Schicksal erwartet Euch...";
      ["faction"] = "Horde";
      ["name"] = "Your Fortune Awaits You...";
      ["level"] = 60;
      ["name_es"] = "La Fortuna te espera...";
      ["req"] = 10;
   };
   [6344] = {
      ["name_ru"] = "Несса Песня Теней";
      ["type"] = "Solo";
      ["name_fr"] = "Nessa Chantelombre";
      ["repgain"] = {
         [69] = 25;
      };
      ["name_cn"] = "尼莎・影歌";
      ["name_de"] = "Andenken an Zuhause";
      ["objective"] = "Speak with Nessa Shadowsong.";
      ["next"] = 6341;
      ["name"] = "Nessa Shadowsong";
      ["sort"] = "Darnassus";
      ["races"] = {
         [1] = "NightElf";
      };
      ["level"] = 10;
      ["name_es"] = "Recuerdos nostalgicos";
      ["req"] = 10;
   };
   [1150] = {
      ["name_ru"] = "Испытание выносливости";
      ["type"] = "Group";
      ["name_fr"] = "L’epreuve de l’Endurance";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Test der Belastbarkeit";
      ["name"] = "Test of Endurance";
      ["name_cn"] = "耐力的??";
      ["objective"] = "Bring Grenka's Claw to Dorn Plainstalker in Thousand Needles.";
      ["next"] = 1151;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1149;
      ["prequests"] = {
         [1] = 1149;
      };
      ["level"] = 30;
      ["name_es"] = "Prueba de resistencia";
      ["req"] = 25;
   };
   [3181] = {
      ["name_ru"] = "Рог чудовища";
      ["type"] = "Group";
      ["objective"] = "Take Margol's Gigantic Horn to Mountaineer Pebblebitty.$B";
      ["next"] = 3182;
      ["name_fr"] = "La corne de la bete";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "??戈的巨角";
      ["repgain"] = {
         [47] = 350;
      };
      ["name_de"] = "Das Horn der Bestie";
      ["faction"] = "Alliance";
      ["name"] = "The Horn of the Beast";
      ["level"] = 48;
      ["name_es"] = "El cuerno de la bestia";
      ["req"] = 40;
   };
   [4321] = {
      ["name_ru"] = "Давай-ка разберемся";
      ["type"] = "Solo";
      ["name_fr"] = "Ceci explique cela";
      ["name_de"] = "Die Sache verstehen";
      ["name_cn"] = "分析水晶塔";
      ["objective"] = "Speak with J.D. Collie in a moment.";
      ["sort"] = "Un'Goro Crater";
      ["reward"] = {
         [1] = 11482;
      };
      ["name"] = "Making Sense of It";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 4287;
         [2] = 4288;
         [3] = 4285;
      };
      ["level"] = 53;
      ["name_es"] = "Entender el significado";
      ["req"] = 47;
   };
   [2204] = {
      ["name_ru"] = "Восстановление ожерелья";
      ["type"] = "Dungeon";
      ["name_fr"] = "Reparer le Collier";
      ["name_de"] = "Restaurierung der Halskette";
      ["name_cn"] = "修???";
      ["objective"] = " and Uldaman is probably the best place for it";
      ["sort"] = "Uldaman";
      ["faction"] = "Alliance";
      ["name"] = "Restoring the Necklace";
      ["prev"] = 2201;
      ["prequests"] = {
         [1] = 2201;
      };
      ["level"] = 44;
      ["name_es"] = "Restaurar el collar";
      ["req"] = 37;
   };
   [9131] = {
      ["name_ru"] = "Броня неустрашимости";
      ["type"] = "Solo";
      ["objective"] = "Korfax at Light's Hope Chapel in the Eastern Plaguelands wants 30 Dark Iron Scraps.";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Armer un cuirassier";
      ["name_cn"] = "无畏?甲的材料";
      ["reward"] = {
         [1] = 22523;
      };
      ["name_de"] = "Bindung des Schreckenspanzers";
      ["faction"] = "Horde";
      ["name"] = "Binding the Dreadnaught";
      ["level"] = 60;
      ["name_es"] = "Armar la acorator";
      ["req"] = 55;
   };
   [8050] = {
      ["name_ru"] = "Око Зулдазара";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Das Auge von Zuldazar";
      ["name_fr"] = "L'?il de Zuldazar";
      ["name"] = "The Eye of Zuldazar";
      ["name_cn"] = "祖??之眼";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19592;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8049;
      ["prequests"] = {
         [1] = 8049;
      };
      ["level"] = 60;
      ["name_es"] = "El ojo de Zuldazar";
      ["req"] = 60;
   };
   [8066] = {
      ["name_ru"] = "Знаки Силы: пояс хищника";
      ["type"] = "Raid";
      ["objective"] = "Bring the following Paragons of Power from Zul'Gurub to Falthir the Sightless: A Primal Hakkari Shawl.  You must also have a reputation equal to or greater than Honored with the Zandalar Tribe.$B$BFalthir the Sightless is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: la ceinture de predateur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：捕?者腰?";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19832;
      };
      ["name_de"] = "Symbole der Macht: Der Gurtel des Raubtiers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Predator's Belt";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Cinturon de depredador";
      ["req"] = 60;
   };
   [3221] = {
      ["name_ru"] = "Беседа с Ренферрелом";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Renferrel";
      ["repgain"] = {
         [68] = 10;
      };
      ["name_de"] = "Sprecht mit Renferrel";
      ["name"] = "Speak with Renferrel";
      ["name_cn"] = "与?弗利?会面";
      ["objective"] = "Speak with Apothecary Renferrel at the Sepulcher.";
      ["next"] = 1359;
      ["faction"] = "Horde";
      ["sort"] = "Silverpine Forest";
      ["prev"] = 449;
      ["prequests"] = {
         [1] = 449;
      };
      ["level"] = 12;
      ["name_es"] = "Habla con Renferrel";
      ["req"] = 10;
   };
   [9153] = {
      ["name_ru"] = "Под тенью";
      ["type"] = "Solo";
      ["objective"] = "Check your map to find an area under Scourge attack. Go there and damage a necropolis by defeating the Scourge around them. Return 10 of their Necrotic Runes to Commander Thomas Helleran at Light's Hope Chapel in the Eastern Plaguelands.";
      ["name_fr"] = "Sous les ombres";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "?影之下";
      ["reward"] = {
         [1] = 23123;
         [2] = 23122;
      };
      ["name_de"] = "Bedrohliche Schatten";
      ["faction"] = "Horde";
      ["name"] = "Under the Shadow";
      ["level"] = 60;
      ["name_es"] = "Bajo la Sombra";
      ["req"] = 58;
   };
   [8114] = {
      ["name_ru"] = "Контроль над четырьмя базами";
      ["type"] = "PvP";
      ["objective"] = "Enter Arathi Basin, capture and control four bases at the same time, and then return to Field Marshal Oslight at Refuge Pointe.";
      ["repgain"] = {
         [509] = 1000;
      };
      ["name_fr"] = "Controler quatre bases";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "控制四座基地";
      ["name_de"] = "Kontrolliert vier Stutzpunkte";
      ["faction"] = "Alliance";
      ["name"] = "Control Four Bases";
      ["level"] = 60;
      ["name_es"] = "Controla cuatro bases";
      ["req"] = 60;
   };
   [6504] = {
      ["name_ru"] = "Утраченные страницы";
      ["type"] = "Solo";
      ["objective"] = "Find the 12 missing pages of the Shredder Operating Manual, and put them together to form Chapters 1, 2, and 3. Return the pages to Gurda Ragescar near Splintertree Post.$B";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Les pages perdues";
      ["name_cn"] = "?失的??";
      ["reward"] = {
         [1] = 16740;
         [2] = 16741;
      };
      ["name_de"] = "Die verlorenen Seiten";
      ["faction"] = "Horde";
      ["name"] = "The Lost Pages";
      ["level"] = 30;
      ["name_es"] = "Las paginas perdidas";
      ["req"] = 23;
   };
   [8146] = {
      ["name_ru"] = "Нить Водоворота";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Die Mahlstromranke";
      ["name_fr"] = "Les Vrilles du maelstrom";
      ["name"] = "The Maelstrom's Tendril";
      ["name_cn"] = "??之藤";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19619;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8145;
      ["prequests"] = {
         [1] = 8145;
      };
      ["level"] = 60;
      ["name_es"] = "Zarcillo de La Voragine";
      ["req"] = 60;
   };
   [8162] = {
      ["name_ru"] = "Перекрыть линии поставок Аратора";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "切断阿拉索???";
      ["name_fr"] = "Couper les voies de ravitaillement d'Arathor";
      ["name_de"] = "Zerschlagt die Versorgungslinien Arathors";
      ["faction"] = "Horde";
      ["name"] = "Cut Arathor Supply Lines";
      ["level"] = 25;
      ["name_es"] = "Cortale el suministro a la Liga de Arathor";
      ["req"] = 20;
   };
   [3261] = {
      ["name_ru"] = "Джорн Заклинатель Небес";
      ["type"] = "Solo";
      ["name_fr"] = "Jorn ?il-des-cieux";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_de"] = "Jorn Himmelsdeuter";
      ["name"] = "Jorn Skyseer";
      ["name_cn"] = "?恩・星眼";
      ["objective"] = "Speak with Jorn Skyseer at Camp Taurajo.";
      ["next"] = 882;
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 905;
      ["prequests"] = {
         [1] = 905;
      };
      ["level"] = 18;
      ["name_es"] = "Jorn Vidente del Cielo";
      ["req"] = 10;
   };
   [8196] = {
      ["name_ru"] = "Экстракт манго";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "Essence Mangoes";
      ["name_cn"] = "芒果精?";
      ["reward"] = {
         [1] = 20031;
      };
      ["name_de"] = "Essenzmangos";
      ["faction"] = "Horde";
      ["name"] = "Essence Mangoes";
      ["level"] = 60;
      ["name_es"] = "Mangos de esencia";
      ["req"] = 58;
   };
   [8228] = {
      ["name_ru"] = "Приглашение на рыбалку";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Puis-je avoir un prospectus sur la peche??";
      ["name_cn"] = "能?我一?宣???？";
      ["reward"] = {
         [1] = 19978;
      };
      ["name_de"] = "Konnte ich einen Flugzettel fur den Angelwettbewerb bekommen?";
      ["faction"] = "Horde";
      ["name"] = "Could I get a Fishing Flier?";
      ["level"] = 60;
      ["name_es"] = "?Puedo tener un folleto de pesca?";
      ["req"] = 55;
   };
   [8260] = {
      ["name_ru"] = "Полевой комплект Лиги Аратора";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [509] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Paquetage de base d'Arathor";
      ["name_cn"] = "阿拉索基本医?包";
      ["reward"] = {
         [1] = 20233;
      };
      ["name_de"] = "Basisuberlebenspaket von Arathor";
      ["faction"] = "Alliance";
      ["name"] = "Arathor Basic Care Package";
      ["level"] = 34;
      ["name_es"] = "Botiquin basico de Arathor";
      ["req"] = 25;
   };
   [4147] = {
      ["name_ru"] = "Мастерская Марвона";
      ["type"] = "Solo";
      ["name_fr"] = "Atelier de Marvon";
      ["next"] = 4146;
      ["name_de"] = "Marvons Werkstatt";
      ["name_cn"] = "???的??";
      ["objective"] = "Travel to Marvon Rivetseeker's workshop in Ratchet.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Marvon's Workshop";
      ["prev"] = 4145;
      ["prequests"] = {
         [1] = 4145;
      };
      ["level"] = 52;
      ["name_es"] = "El taller de Marvon";
      ["req"] = 47;
   };
   [8324] = {
      ["name_ru"] = "Не теряя веры";
      ["type"] = "Solo";
      ["name_fr"] = "Je crois encore…";
      ["sort"] = "Silithus";
      ["name_cn"] = "更多的?物";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Still Believing";
      ["name_de"] = "Fester Glauben";
      ["prev"] = 8323;
      ["prequests"] = {
         [1] = 8323;
      };
      ["level"] = 59;
      ["name_es"] = "Seguir creyendo";
      ["req"] = 54;
   };
   [8356] = {
      ["name_ru"] = "Поиграй мускулами!";
      ["type"] = "Solo";
      ["objective"] = "Do a flex emote at Innkeeper Allison, and in exchange you'll receive Stormwind Nougat!$B";
      ["name_fr"] = "Montrer ses muscles pour du nougat";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?肌肉，?糖果";
      ["reward"] = {
         [1] = 20492;
      };
      ["name_de"] = "Muskelspiel fur Nugat";
      ["faction"] = "Alliance";
      ["name"] = "Flexing for Nougat";
      ["level"] = 60;
      ["name_es"] = "Saca musculo a cambio de almendrados";
      ["req"] = 10;
   };
   [8388] = {
      ["name_ru"] = "Великая честь";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Alterac Valley Marks of Honor, 3 Arathi Basin Marks of Honor and 3 Warsong Gulch Marks of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
         [729] = 150;
         [889] = 100;
      };
      ["name_de"] = "Grose Ehre";
      ["name_cn"] = "无上的?耀";
      ["name_fr"] = "Pour un grand honneur";
      ["name"] = "For Great Honor";
      ["faction"] = "Horde";
      ["sort"] = "Orgrimmar";
      ["prev"] = 8367;
      ["prequests"] = {
         [1] = 8367;
      };
      ["level"] = 60;
      ["name_es"] = "Cuestion de honor";
      ["req"] = 51;
   };
   [8420] = {
      ["name_ru"] = "Пробирает!";
      ["type"] = "Solo";
      ["objective"] = "Bring a piece of felcloth to Impsy in Felwood.";
      ["next"] = 8421;
      ["sort"] = "Warlock";
      ["name_cn"] = "灼?的疼痛";
      ["name_fr"] = "Chaud et piquant";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 8421;
      ["name_de"] = "Heis und brennend";
      ["faction"] = "Horde";
      ["name"] = "Hot and Itchy";
      ["level"] = 52;
      ["name_es"] = "Caliente y picante";
      ["req"] = 50;
   };
   [4505] = {
      ["name_ru"] = "Источник порчи";
      ["type"] = "Solo";
      ["objective"] = "Collect a sample of corrupted water from the Jadefire Satyrs' moonwell and bring it to Winna Hazzard at Bloodvenom Post.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_fr"] = "Puits de la corruption";
      ["sort"] = "Felwood";
      ["name_cn"] = "腐化之井";
      ["name_de"] = "Brunnen der Verderbnis";
      ["faction"] = "Horde";
      ["name"] = "Well of Corruption";
      ["level"] = 54;
      ["name_es"] = "El pozo de la corrupcion";
      ["req"] = 49;
   };
   [4243] = {
      ["name_ru"] = "В поисках Чи-Та 3";
      ["type"] = "Solo";
      ["objective"] = "Find A-Me 01 in Un'Goro Crater.";
      ["next"] = 4244;
      ["name_fr"] = "A la poursuite d'A-mi 01";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "找回A-Me 01";
      ["series"] = 1;
      ["name_de"] = "Chasing A-Me 01";
      ["faction"] = "Horde";
      ["name"] = "Chasing A-Me 01";
      ["level"] = 53;
      ["name_es"] = "Buscando a Memo 01";
      ["req"] = 48;
   };
   [8516] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает плотной кожи!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de cuir epais !";
      ["name_de"] = "Die Allianz braucht mehr dickes Leder!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21512;
      };
      ["name_cn"] = "?盟需要更多厚皮！";
      ["objective"] = "Bring 10 thick leather to Marta Finespindle at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Thick Leather!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8515;
      ["prequests"] = {
         [1] = 8515;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas cuero grueso!";
      ["req"] = 1;
   };
   [8548] = {
      ["name_ru"] = "Броня добровольца";
      ["type"] = "Solo";
      ["objective"] = "Bring 5 Cenarion Combat Badges, 3 Cenarion Logistics Badges and 7 Cenarion Tactical Badges to Vargus at Cenarion Hold in Silithus.  You must also attain Friendly reputation with Cenarion Circle to be able to complete this quest.";
      ["name_fr"] = "L'equipement de guerre des volontaires";
      ["sort"] = "Silithus";
      ["name_cn"] = "志愿兵的装?";
      ["reward"] = {
         [1] = 21178;
         [2] = 21179;
         [3] = 21187;
      };
      ["name_de"] = "Schlachtrustung des Kriegsfreiwilligen";
      ["faction"] = "Horde";
      ["name"] = "Volunteer's Battlegear";
      ["level"] = 60;
      ["name_es"] = "Equipamiento de Voluntario";
      ["req"] = 60;
   };
   [4291] = {
      ["name_ru"] = "Запах Лар'корви";
      ["type"] = "Solo";
      ["name_fr"] = "Un parfum pour Lar'korwi";
      ["next"] = 4292;
      ["name_de"] = "Lar'korwis Fahrte";
      ["name_cn"] = "拉克?的气味";
      ["objective"] = "Bring 2 Ravasaur Pheromone Glands to Torwa Pathfinder near the entrance to Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The Scent of Lar'korwi";
      ["prev"] = 4290;
      ["prequests"] = {
         [1] = 4290;
      };
      ["level"] = 53;
      ["name_es"] = "Un aroma irresistible para Lar'korwi";
      ["req"] = 48;
   };
   [8612] = {
      ["name_ru"] = "Орде все еще не хватает постных стейков из волчатины!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Lean Wolf Steaks to Bloodguard Rawtar at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr magere Wolfsteaks!";
      ["name_fr"] = "La Horde a besoin de plus de steaks de loup !";
      ["name_cn"] = "部落需要更多?狼排！";
      ["name"] = "The Horde Needs More Lean Wolf Steaks!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21510;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8611;
      ["prequests"] = {
         [1] = 8611;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas filetes de lobo magro!";
      ["req"] = 1;
   };
   [8644] = {
      ["name_ru"] = "Предок Камнеград";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Fort-de-pierre";
      ["name_cn"] = "石??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Steinwehr";
      ["faction"] = "Horde";
      ["name"] = "Stonefort the Elder";
      ["level"] = 60;
      ["name_es"] = "Petraforte el Ancestro";
      ["req"] = 1;
   };
   [8676] = {
      ["name_ru"] = "Предок Буйногривая";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancienne Crin-sauvage";
      ["name_cn"] = "蛮??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahnin Wildmahne";
      ["faction"] = "Horde";
      ["name"] = "Wildmane the Elder";
      ["level"] = 60;
      ["name_es"] = "Ferocrin el Ancestro";
      ["req"] = 1;
   };
   [8708] = {
      ["name_ru"] = "Палица Бесконечной жизни";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ornate Hilt, 2  Jasper Idols, 5 Crystal Scarabs and 5 Stone Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La masse de vie interminable";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "不?生命之?";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 21407;
      };
      ["name_de"] = "Streitkolben des endlosen Lebens";
      ["faction"] = "Horde";
      ["name"] = "Mace of Unending Life";
      ["level"] = 60;
      ["name_es"] = "La maza de vida inagotable";
      ["req"] = 60;
   };
   [8740] = {
      ["name_ru"] = "Сумеречные мародеры";
      ["type"] = "Group";
      ["objective"] = "Slay Twilight Marauder Morna and 5 Twilight Marauders.  Report to Windcaller Proudhorn when your task is finished.  You must also bring Tactical Task Briefing IX in order to complete this quest.";
      ["name_fr"] = "Les maraudeurs du crepuscule";
      ["sort"] = "Silithus";
      ["name_cn"] = "?殿?士";
      ["reward"] = {
         [1] = 20801;
         [2] = 21133;
      };
      ["name_de"] = "Marodeure des Schattenhammers";
      ["faction"] = "Horde";
      ["name"] = "Twilight Marauders";
      ["level"] = 60;
      ["name_es"] = "Los merodeadores Crepusculares";
      ["req"] = 60;
   };
   [8772] = {
      ["name_ru"] = "Цель: стражи дорог из Улья Зора";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Zora Waywatchers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing VI in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les patrouilleuses de la Ruche'Zora";
      ["name_cn"] = "目?：佐拉守?";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Wegbehuter des Zoraschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Zora Waywatchers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los oteadores de Colmen'Zora";
      ["req"] = 60;
   };
   [8804] = {
      ["name_ru"] = "Неприкосновенный запас";
      ["type"] = "Solo";
      ["objective"] = "Bring 4 Globes of Water, 4 Powerful Anti-Venom and 4 Smoked Desert Dumplings to Calandrath at the inn in Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing I in order to complete this quest.";
      ["name_fr"] = "Survivre dans le desert";
      ["sort"] = "Silithus";
      ["name_cn"] = "沙漠生存包";
      ["reward"] = {
         [1] = 20800;
         [2] = 21266;
      };
      ["name_de"] = "Wustenuberlebenspaket";
      ["faction"] = "Horde";
      ["name"] = "Desert Survival Kits";
      ["level"] = 60;
      ["name_es"] = "Material de supervivencia en el desierto";
      ["req"] = 55;
   };
   [8836] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8813;
      ["prequests"] = {
         [1] = 8813;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8868] = {
      ["name_ru"] = "Благословение Элуны";
      ["type"] = "Raid";
      ["objective"] = "Summon Omen, defeat him and gain Elune's Blessing.  Return to Valadar Starsong in Nighthaven";
      ["name_fr"] = "La benediction d'Elune";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "艾露恩的祝福";
      ["reward"] = {
         [1] = 21540;
         [2] = 21640;
         [3] = 7912;
      };
      ["name_de"] = "Elunes Segen";
      ["faction"] = "Horde";
      ["name"] = "Elune's Blessing";
      ["level"] = 60;
      ["name_es"] = "La bendicion de Elune";
      ["req"] = 40;
   };
   [4451] = {
      ["name_ru"] = "Ключ к свободе";
      ["type"] = "Solo";
      ["objective"] = "Search Searing Gorge and find a use for the Grimesilt Outhouse Key you have found.";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "自由的?匙";
      ["name_fr"] = "La Cle de la liberte";
      ["name_de"] = "Der Schlussel zur Freiheit";
      ["faction"] = "Horde";
      ["name"] = "The Key to Freedom";
      ["level"] = 47;
      ["name_es"] = "La llave de la libertad";
      ["req"] = 43;
   };
   [8932] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Magister's Belt and a set of Magister's Gloves to Deliana in Ironforge.$B";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Mage";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22062;
         [2] = 22066;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [4483] = {
      ["name_ru"] = "Манускрипт Устойчивости";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Burning Steppes";
      ["name_fr"] = "Libram de resilience";
      ["name_cn"] = "恢??典";
      ["reward"] = {
         [1] = 11644;
      };
      ["name_de"] = "Buchband der Abhartung";
      ["faction"] = "Horde";
      ["name"] = "Libram of Resilience";
      ["level"] = 55;
      ["name_es"] = "Tratado sobre Resistencia";
      ["req"] = 50;
   };
   [8996] = {
      ["name_ru"] = "Возвращение к Бодли";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir Bodley";
      ["name_de"] = "Ruckkehr zu Bodley";
      ["reward"] = {
         [1] = 22057;
         [2] = 22344;
      };
      ["name_cn"] = "回到布德利那里";
      ["objective"] = "Return to Bodley inside Blackrock Mountain and give him the Brazier of Beckoning.";
      ["faction"] = "Horde";
      ["name"] = "Return to Bodley";
      ["sort"] = "Blackrock Mountain";
      ["prev"] = 8995;
      ["prequests"] = {
         [1] = 8995;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Bodley";
      ["req"] = 58;
   };
   [9028] = {
      ["name_ru"] = "Источник обнаружен";
      ["type"] = "Solo";
      ["name_fr"] = "La source est decouverte?!";
      ["name_de"] = "Luftung des Geheimnisses";
      ["name_cn"] = "水落石出";
      ["objective"] = "Find Apothecary Staffron Lerent in the Hillsbrad Foothills behind Ravenholdt Manor.";
      ["sort"] = "Hallow's End";
      ["faction"] = "Alliance";
      ["name"] = "The Source Revealed";
      ["prev"] = 9027;
      ["prequests"] = {
         [1] = 9027;
      };
      ["level"] = 70;
      ["name_es"] = "El descubrimiento de la fuente";
      ["req"] = 53;
   };
   [9060] = {
      ["name_ru"] = "Ремень расхитителя гробниц";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make a Cryptstalker Girdle if you bring him the following: 1 Desecrated Girdle, 8 Wartorn Chain Scraps, 1 Arcanite Bar and 3 Nexus Crystals.$B";
      ["name_cn"] = "地穴追?者束?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le ceinturon de traqueur des cryptes";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gurt des Gruftpirschers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22442;
      };
      ["name"] = "Cryptstalker Girdle";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La faja de acechacriptas";
      ["req"] = 60;
   };
   [9092] = {
      ["name_ru"] = "Ремень сновидца";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make a Dreamwalker Girdle if you bring her the following: 1 Desecrated Girdle, 8 Wartorn Leather Scraps, 3 Mooncloth and 2 Cured Rugged Hides.";
      ["name_cn"] = "梦游者束?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Le ceinturon de marchereve";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gurt des Traumwandlers";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22494;
      };
      ["name"] = "Dreamwalker Girdle";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La faja Caminasuenos";
      ["req"] = 60;
   };
   [9124] = {
      ["name_ru"] = "Доспехи расхитителя гробниц на дороге не валяются...";
      ["type"] = "Solo";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands wants 30 Crypt Fiend Parts.";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "L'armure de traqueur des cryptes ne se fabrique pas toute seule";
      ["name_cn"] = "地穴追?者?甲的材料……";
      ["reward"] = {
         [1] = 22524;
      };
      ["name_de"] = "Was man fur Gruftpirscherrustung braucht...";
      ["faction"] = "Horde";
      ["name"] = "Cryptstalker Armor Doesn't Make Itself...";
      ["level"] = 60;
      ["name_es"] = "La armadura de acechacriptas no se hace sola...";
      ["req"] = 55;
   };
   [1651] = {
      ["name_ru"] = "Фолиант Отваги";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de la bravoure";
      ["next"] = 1652;
      ["name_de"] = "Der Foliant der Tapferkeit";
      ["objective"] = "Defend Daphne Stilwell from the Defias attack.$B$BNeither of your spirits must be released from their mortal coils if you wish to succeed.$B$BAfter you are successful, speak to Daphne Stilwell again.";
      ["name_cn"] = "勇气之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Valor";
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["prev"] = 1650;
      ["prequests"] = {
         [1] = 1650;
      };
      ["level"] = 25;
      ["name_es"] = "Escrito sobre valor";
      ["req"] = 20;
   };
   [9188] = {
      ["name_ru"] = "Задание мастера: штаны из яркой ткани";
      ["type"] = "Solo";
      ["objective"] = "Deliver 6 Brightcloth Pants and the Craftsman's Writ - Brightcloth Pants - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Pantalons en etoffe lumineuse";
      ["name_cn"] = "工匠文? - 亮布短?";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Hellstoffhose";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Brightcloth Pants";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: pantalones de pano brillante";
      ["req"] = 55;
   };
   [1657] = {
      ["name_ru"] = "Чем пахнет в Южнобережье";
      ["type"] = "PvP";
      ["objective"] = "Toss three Forsaken Stink Bombs into the heart of Southshore in Hillsbrad, and return to Darkcaller Yanka at the Wickerman Festival in Tirisfal Glade.";
      ["name_fr"] = "Empuantir Austrivage";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "臭气熏天的南海?";
      ["reward"] = {
         [1] = 20557;
      };
      ["name_de"] = "Die Verpestung von Suderstade";
      ["faction"] = "Horde";
      ["name"] = "Stinking Up Southshore";
      ["level"] = 60;
      ["name_es"] = "Apesta Costasur";
      ["req"] = 25;
   };
   [1661] = {
      ["name_ru"] = "Фолиант благородства";
      ["type"] = "Solo";
      ["objective"] = "Speak to Duthorian Rall in Stormwind.";
      ["name_de"] = "Der Foliant des Adels";
      ["sort"] = "Paladin";
      ["name_cn"] = "高?之?";
      ["name_fr"] = "Le Tome de noblesse";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "The Tome of Nobility";
      ["level"] = 40;
      ["name_es"] = "Escrito sobre nobleza";
      ["req"] = 40;
   };
   [1667] = {
      ["name_ru"] = "Джек Мертвозуб";
      ["type"] = "Solo";
      ["name_fr"] = "Jack Dent-Morte";
      ["name_de"] = "Stumpfzahn Jack";
      ["objective"] = "Retrieve Haggard's Badge from Dead-tooth Jack's camp, and return to Marshal Haggard.";
      ["reward"] = {
         [1] = 6979;
         [2] = 6983;
         [3] = 6980;
         [4] = 6985;
      };
      ["name_cn"] = "?牙杰克";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Dead-tooth Jack";
      ["sort"] = "Warrior";
      ["prev"] = 1666;
      ["prequests"] = {
         [1] = 1666;
      };
      ["level"] = 10;
      ["name_es"] = "Jack Dentomuerto";
      ["req"] = 10;
   };
   [3341] = {
      ["name_ru"] = "Да сгинет Хладовей";
      ["type"] = "Dungeon";
      ["objective"] = "Andrew Brownell wants you to kill Amnennar the Coldbringer and return his skull.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Razorfen Downs";
      ["name_fr"] = "L'aneantissement";
      ["name_cn"] = "寒冰之王";
      ["reward"] = {
         [1] = 10823;
         [2] = 10824;
      };
      ["name_de"] = "Das Ende bringen";
      ["faction"] = "Horde";
      ["name"] = "Bring the End";
      ["level"] = 42;
      ["name_es"] = "Acaba con la amenaza";
      ["req"] = 37;
   };
   [2338] = {
      ["name_ru"] = "Трудности перевода";
      ["type"] = "Dungeon";
      ["objective"] = "Let Jarkal borrow the necklace.  In exchange, he will translate the journal for you.";
      ["repgain"] = {
         [530] = 10;
      };
      ["name_de"] = "Ubersetzung des Tagebuchs";
      ["name"] = "Translating the Journal";
      ["name_cn"] = "翻?日?";
      ["name_fr"] = "La traduction du Journal";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Uldaman";
      ["prev"] = 2318;
      ["prequests"] = {
         [1] = 2318;
      };
      ["level"] = 42;
      ["name_es"] = "La traduccion del diario";
      ["req"] = 37;
   };
   [4721] = {
      ["name_ru"] = "Одичавшие стражи";
      ["type"] = "Solo";
      ["objective"] = "Trull Failbane in Felwood wants you to hunt 10 Berserk Owlbeasts in Winterspring.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Wilde Wachter";
      ["name"] = "Wild Guardians";
      ["name_cn"] = "冬泉谷的??";
      ["name_fr"] = "Les gardiens sauvages";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 4741;
      ["prequests"] = {
         [1] = 4741;
      };
      ["level"] = 59;
      ["name_es"] = "Guardianes salvajes";
      ["req"] = 52;
   };
   [3441] = {
      ["name_ru"] = "Божественное воздаяние";
      ["type"] = "Solo";
      ["objective"] = "Listen as Kalaran Windblade tells his story.";
      ["sort"] = "Searing Gorge";
      ["name_cn"] = "神?的?戒";
      ["name_fr"] = "Chatiment divin";
      ["name_de"] = "Gottliche Vergeltung";
      ["faction"] = "Horde";
      ["name"] = "Divine Retribution";
      ["level"] = 48;
      ["name_es"] = "Castigo divino";
      ["req"] = 40;
   };
   [4723] = {
      ["name_ru"] = "Останки морской твари";
      ["type"] = "Solo";
      ["name_fr"] = "La creature marine echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meereskreatur";
      ["name_cn"] = "?浅的海洋生物";
      ["name"] = "Beached Sea Creature";
      ["objective"] = "Take the Sea Creature Bones to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 13;
      ["name_es"] = "Criatura marina varada";
      ["req"] = 11;
   };
   [4739] = {
      ["name_ru"] = "Поиски Менары Расщепительницы Бездны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Menara Voidrender in the Barrens.";
      ["next"] = 1796;
      ["sort"] = "Warlock";
      ["name_cn"] = "?找梅?拉・沃?德";
      ["name_fr"] = "A la recherche de Menara Taillevide";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Auf der Suche nach Menara Leerbringer";
      ["faction"] = "Horde";
      ["name"] = "In Search of Menara Voidrender";
      ["level"] = 31;
      ["name_es"] = "Buscando a Menara Nadiz";
      ["req"] = 31;
   };
   [2378] = {
      ["name_ru"] = "Поиски Изувеченной Длани";
      ["type"] = "Solo";
      ["objective"] = "Journey to Orgrimmar and speak with Shenthul at the Cleft of Shadow.$B$B$B$B";
      ["next"] = 2379;
      ["sort"] = "Rogue";
      ["name_cn"] = "?找碎手氏族";
      ["name_fr"] = "Trouver la Main brisee";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["followup"] = 2379;
      ["name_de"] = "Suche nach der Zerschmetterten Hand";
      ["faction"] = "Horde";
      ["name"] = "Find the Shattered Hand";
      ["level"] = 16;
      ["name_es"] = "Encuentra a los Mano Destrozada";
      ["req"] = 16;
   };
   [4771] = {
      ["name_ru"] = "Рассветный гамбит";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le gambit de l'aube";
      ["name_de"] = "Dammerungstrickfalle";
      ["reward"] = {
         [1] = 15853;
         [2] = 15854;
      };
      ["name_cn"] = "黎明先?";
      ["objective"] = " with a little luck";
      ["faction"] = "Horde";
      ["name"] = "Dawn's Gambit";
      ["sort"] = "Scholomance";
      ["prev"] = 5531;
      ["prequests"] = {
         [1] = 5531;
      };
      ["level"] = 60;
      ["name_es"] = "Gambito del Alba";
      ["req"] = 57;
   };
   [4787] = {
      ["name_ru"] = "Древнее яйцо";
      ["type"] = "Group";
      ["name_fr"] = "L'?uf antique";
      ["next"] = 3528;
      ["name_de"] = "Das uralte Ei";
      ["name_cn"] = "?古之卵";
      ["objective"] = "Bring the Ancient Egg to Yeh'kinya in Tanaris.";
      ["sort"] = "The Hinterlands";
      ["faction"] = "Horde";
      ["name"] = "The Ancient Egg";
      ["prev"] = 3527;
      ["prequests"] = {
         [1] = 3527;
      };
      ["level"] = 50;
      ["name_es"] = "El huevo antiguo";
      ["req"] = 40;
   };
   [4803] = {
      ["name_ru"] = "Э'ко щербозубов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko eines Splitterzahns";
      ["name_fr"] = "L'E'ko des Crocs aceres";
      ["name_cn"] = "碎?魂精";
      ["name"] = "Shardtooth E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12455;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko Dentoesquirla";
      ["req"] = 55;
   };
   [3481] = {
      ["name_ru"] = "Безделушки...";
      ["type"] = "Solo";
      ["name_fr"] = "Bibelots...";
      ["name_de"] = "Plunder...";
      ["reward"] = {
         [1] = 10569;
      };
      ["name_cn"] = "打?箱子…";
      ["objective"] = "Open the chest.";
      ["faction"] = "Horde";
      ["name"] = "Trinkets...";
      ["sort"] = "Searing Gorge";
      ["prev"] = 3463;
      ["prequests"] = {
         [1] = 3463;
      };
      ["level"] = 50;
      ["name_es"] = "Abalorios...";
      ["req"] = 40;
   };
   [2418] = {
      ["name_ru"] = "Силовые камни";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Dentrium Power Stones and 8 An'Alleum Power Stones to Rigglefuzz in the Badlands.";
      ["repgain"] = {
         [21] = 350;
      };
      ["sort"] = "Uldaman";
      ["name_fr"] = "Les pierres de puissance";
      ["name_cn"] = "能量石";
      ["reward"] = {
         [1] = 9522;
         [2] = 10358;
         [3] = 10359;
      };
      ["name_de"] = "Kraftsteine";
      ["faction"] = "Horde";
      ["name"] = "Power Stones";
      ["level"] = 36;
      ["name_es"] = "Las piedras de energia";
      ["req"] = 30;
   };
   [9191] = {
      ["name_ru"] = "Задание мастера: сумка из рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "Deliver 8 Runecloth Bags and the Craftsman's Writ - Runecloth Bag - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Sacs en etoffe runique";
      ["name_cn"] = "工匠文? - 符文布背包";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Runenstofftasche";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Runecloth Bag";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: bolsa de pano runico";
      ["req"] = 55;
   };
   [4867] = {
      ["name_ru"] = "Аррок Смертный Вопль";
      ["type"] = "Dungeon";
      ["objective"] = "Read Warosh's Scroll.  Bring Warosh's Mojo to Warosh.";
      ["name_fr"] = "Urok Hurleruine";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "?洛克";
      ["reward"] = {
         [1] = 15867;
      };
      ["name_de"] = "Urok Schreckensbote";
      ["faction"] = "Horde";
      ["name"] = "Urok Doomhowl";
      ["level"] = 60;
      ["name_es"] = "Urok Aullasino";
      ["req"] = 55;
   };
   [4883] = {
      ["name_ru"] = "Умение хранить секреты";
      ["objective"] = "Take the Blue-feathered Necklace to Nara Wildmane.";
      ["name_cn"] = "守?秘密";
      ["sort"] = "Winterspring";
      ["level"] = 59;
      ["type"] = "Solo";
      ["name_fr"] = "Secrets gardes";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Geheimnisse bewahren";
      ["reward"] = {
         [1] = 15796;
         [2] = 15797;
      };
      ["faction"] = "Horde";
      ["name"] = "Guarding Secrets";
      ["prev"] = 4882;
      ["prequests"] = {
         [1] = 4882;
      };
      ["series"] = 2;
      ["name_es"] = "Guardar un secreto";
      ["req"] = 52;
   };
   [3513] = {
      ["name_ru"] = "Свиток с рунами";
      ["type"] = "Solo";
      ["objective"] = "Take the Runed Scroll to the northern guard tower in the Barrens.";
      ["next"] = 3514;
      ["name_fr"] = "Le Parchemin runique";
      ["sort"] = "The Barrens";
      ["name_cn"] = "符文卷?";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Die runenverzierte Rolle";
      ["faction"] = "Horde";
      ["name"] = "The Runed Scroll";
      ["level"] = 25;
      ["name_es"] = "El pergamino runico";
      ["req"] = 15;
   };
   [2458] = {
      ["name_ru"] = "Надежное прикрытие";
      ["type"] = "Solo";
      ["name_fr"] = "Sous le couvert de la nuit";
      ["name_de"] = "Undercover";
      ["objective"] = "Travel to the Venture Co. Tower, north of the Sludge Fen and contact the Shattered Hand's covert operative, Taskmaster Fizzule.$B$BWhen the tower is in sight, use the Flare Gun to signal your arrival to Taskmaster Fizzule. Fire off TWO flares, then approach Taskmaster Fizzule and perform the Shattered /Salute.$B$BThese actions must be performed in the correct order, as Fizzule will attack and terminate any person he does not recognize.";
      ["reward"] = {
         [1] = 8066;
      };
      ["name_cn"] = "?底密探";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Deep Cover";
      ["sort"] = "Rogue";
      ["prev"] = 2460;
      ["prequests"] = {
         [1] = 2460;
      };
      ["level"] = 20;
      ["name_es"] = "Agente encubierto";
      ["req"] = 20;
   };
   [3521] = {
      ["name_ru"] = "Противоядие для Иверрона";
      ["objective"] = "Collect 7 Hyacinth Mushrooms, 4 Moonpetal Lilies, and 1 Webwood Ichor for Dirania Silveshine in Shadowglen.";
      ["name_cn"] = "埃沃隆的解?";
      ["sort"] = "Shadowglen";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'antidote d'Iverron";
      ["next"] = 3522;
      ["name_de"] = "Iverrons Gegengift";
      ["repgain"] = {
         [69] = 250;
      };
      ["faction"] = "Alliance";
      ["name"] = "Iverron's Antidote";
      ["prev"] = 3519;
      ["prequests"] = {
         [1] = 3519;
      };
      ["series"] = 1;
      ["name_es"] = "El antidoto de Iverron";
      ["req"] = 2;
   };
   [1267] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["name_de"] = "Der vermisste Diplomat";
      ["reward"] = {
         [1] = 6757;
      };
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Speak to Jaina Proudmore in Dustwallow Swamp.";
      ["faction"] = "Alliance";
      ["name"] = "The Missing Diplomat";
      ["sort"] = "Stormwind City";
      ["prev"] = 1324;
      ["prequests"] = {
         [1] = 1324;
      };
      ["level"] = 38;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [4963] = {
      ["name_ru"] = "Осколок инфернала";
      ["type"] = "Solo";
      ["objective"] = "Take the Infus Emerald and use it on one of the Infernals found in Desolace. After successful, bring the Infus Emerald and the Imprisoned Infernal Spirit back to Menara Voidrender in the Barrens.";
      ["sort"] = "Warlock";
      ["name_cn"] = "地?火的?魂";
      ["name_fr"] = "Un eclat d'infernal";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Splitter einer Hollenbestie";
      ["faction"] = "Horde";
      ["name"] = "Shard of an Infernal";
      ["level"] = 40;
      ["name_es"] = "Fragmento de infernal";
      ["req"] = 35;
   };
   [3541] = {
      ["name_ru"] = "Доставка Джес'римону";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison pour Jes'rimon";
      ["next"] = 3563;
      ["name_de"] = "Lieferung an Jes'rimon";
      ["name_cn"] = "杰斯雷蒙的石版";
      ["objective"] = "Bring the Tablet of Jin'yael to Jes'rimon in Orgrimmar.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Delivery to Jes'rimon";
      ["prev"] = 3517;
      ["prequests"] = {
         [1] = 3517;
      };
      ["level"] = 52;
      ["name_es"] = "Entrega a Jes'rimon";
      ["req"] = 45;
   };
   [2498] = {
      ["name_ru"] = "Возвращение к Деналану";
      ["type"] = "Solo";
      ["name_fr"] = "Retour vers Denalan";
      ["repgain"] = {
         [69] = 10;
      };
      ["name_de"] = "Ruckkehr zu Denalan";
      ["name"] = "Return to Denalan";
      ["name_cn"] = "向德??回?";
      ["objective"] = "Rellian Greenspyre wants you to speak with Denalan at Lake Al'Ameth.";
      ["next"] = 2499;
      ["faction"] = "Alliance";
      ["sort"] = "Teldrassil";
      ["prev"] = 923;
      ["prequests"] = {
         [1] = 923;
      };
      ["level"] = 9;
      ["name_es"] = "Regresa junto a Denalan";
      ["req"] = 4;
   };
   [7121] = {
      ["name_ru"] = "Интендант";
      ["type"] = "PvP";
      ["objective"] = "Speak with the Stormpike Quartermaster.";
      ["repgain"] = {
         [47] = 10;
         [730] = 10;
      };
      ["name_fr"] = "L'intendant";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "?需官";
      ["name_de"] = "Der Rustmeister";
      ["faction"] = "Alliance";
      ["name"] = "The Quartermaster";
      ["level"] = 60;
      ["name_es"] = "El intendente";
      ["req"] = 51;
   };
   [5081] = {
      ["name_ru"] = "Миссия Максвелла";
      ["type"] = "Dungeon";
      ["name_fr"] = "Mission de Maxwell";
      ["name_de"] = "Maxwells Mission";
      ["reward"] = {
         [1] = 13958;
         [2] = 13959;
         [3] = 13961;
         [4] = 13962;
         [5] = 13963;
      };
      ["name_cn"] = "麦克斯??的任?";
      ["objective"] = "Travel to Blackrock Spire and destroy War Master Voone, Highlord Omokk, and Overlord Wyrmthalak. Return to Marshal Maxwell when the job is done.";
      ["faction"] = "Alliance";
      ["name"] = "Maxwell's Mission";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 5002;
      ["prequests"] = {
         [1] = 5002;
      };
      ["level"] = 60;
      ["name_es"] = "La mision de Maxwell";
      ["req"] = 55;
   };
   [5043] = {
      ["name_ru"] = "Ловкость Агамаггана";
      ["type"] = "Solo";
      ["name_fr"] = "L'agilite d'Agammagan";
      ["sort"] = "The Barrens";
      ["name_cn"] = "阿迦?甘的敏捷";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Agamaggan's Agility";
      ["name_de"] = "Agamaggans Beweglichkeit";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "La agilidad de Agamaggan";
      ["req"] = 14;
   };
   [5059] = {
      ["name_ru"] = "Под замком";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "被?起来的?夫";
      ["name_fr"] = "Enferme";
      ["name_de"] = "Weggeschlossen";
      ["faction"] = "Horde";
      ["name"] = "Locked Away";
      ["level"] = 55;
      ["name_es"] = "Encierro";
      ["req"] = 52;
   };
   [1791] = {
      ["name_ru"] = "Страж Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "La vigie des vents";
      ["next"] = 1712;
      ["name_de"] = "Der Windbehuter";
      ["objective"] = "Speak with Bath'rah the Windwatcher.";
      ["name_cn"] = "捕?者";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Horde";
      ["name"] = "The Windwatcher";
      ["prev"] = 1719;
      ["prequests"] = {
         [1] = 1719;
      };
      ["level"] = 30;
      ["name_es"] = "El Vigia del viento";
      ["req"] = 30;
   };
   [5091] = {
      ["name_ru"] = "Призыв к оружию: Чумные земли!";
      ["type"] = "Solo";
      ["objective"] = "Seek out Commander Ashlam Valorfist.  His base camp is located at Chillwind Camp, north of the Alterac Mountains.";
      ["next"] = 5092;
      ["sort"] = "Darnassus";
      ["name_cn"] = "?斗的号角：瘟疫之地！";
      ["name_fr"] = "Un appel aux armes?: les Maleterres";
      ["followup"] = 5092;
      ["name_de"] = "Der Ruf zu den Waffen: Die Pestlander!";
      ["faction"] = "Alliance";
      ["name"] = "A Call to Arms: The Plaguelands!";
      ["level"] = 50;
      ["name_es"] = "Un llamamiento a las armas: las Tierras de la Peste";
      ["req"] = 50;
   };
   [5121] = {
      ["name_ru"] = "Верховный вождь племени Зимней Спячки";
      ["type"] = "Group";
      ["objective"] = "Donova Snowden in Winterspring wants you to defeat High Chief Winterfall.";
      ["repgain"] = {
         [577] = 250;
      };
      ["name_de"] = "Oberhauptling der Winterfelle";
      ["reward"] = {
         [1] = 15784;
         [2] = 15786;
         [3] = 15787;
      };
      ["name_cn"] = "冬泉酋?";
      ["name_fr"] = "Le grand chef Tombe-hiver";
      ["faction"] = "Horde";
      ["name"] = "High Chief Winterfall";
      ["sort"] = "Winterspring";
      ["prev"] = 5087;
      ["prequests"] = {
         [1] = 5087;
      };
      ["level"] = 59;
      ["name_es"] = "Gran Jefe Nevada";
      ["req"] = 52;
   };
   [5123] = {
      ["name_ru"] = "Последний фрагмент мозаики";
      ["type"] = "Solo";
      ["name_fr"] = "Le dernier morceau";
      ["repgain"] = {
         [577] = 75;
      };
      ["name_de"] = "Das letzte Stuck";
      ["name_cn"] = "最后一片";
      ["name"] = "The Final Piece";
      ["objective"] = "Bring the Crudely-written Log to Donova Snowden in Winterspring.";
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5087;
      ["prequests"] = {
         [1] = 5087;
      };
      ["level"] = 59;
      ["name_es"] = "La pieza final";
      ["req"] = 52;
   };
   [5161] = {
      ["name_ru"] = "Гнев синих драконов";
      ["type"] = "Solo";
      ["name_fr"] = "La colere du vol bleu";
      ["next"] = 5162;
      ["name_de"] = "Der Zorn des blauen Drachenschwarms";
      ["name"] = "Wrath of the Blue Flight";
      ["name_cn"] = "??之怒";
      ["objective"] = "Speak with Haleh if you wish to continue.";
      ["series"] = 1;
      ["faction"] = "Horde";
      ["sort"] = "Winterspring";
      ["prev"] = 5160;
      ["prequests"] = {
         [1] = 5160;
      };
      ["level"] = 60;
      ["name_es"] = "La colera del Vuelo Azul";
      ["req"] = 57;
   };
   [5155] = {
      ["name_ru"] = "Силы Джеденара";
      ["type"] = "Solo";
      ["objective"] = "Enter Jaedenar and slay 4 Jaedenar Hounds, 4 Jaedenar Guardsmen, 6 Jaedenar Adepts, and 6 Jaedenar Cultists before returning to Greta Mosshoof in Felwood.";
      ["next"] = 5157;
      ["sort"] = "Felwood";
      ["name_cn"] = "加德??的?力";
      ["name_fr"] = "Les forces de Jaedenar";
      ["name_de"] = "Streitmacht von Jaedenar";
      ["faction"] = "Horde";
      ["name"] = "Forces of Jaedenar";
      ["level"] = 51;
      ["name_es"] = "Las fuerzas de Jaedenar";
      ["req"] = 48;
   };
   [2586] = {
      ["name_ru"] = "Скорпоковая соль";
      ["type"] = "Solo";
      ["name_fr"] = "Le sel de scorpok";
      ["name_de"] = "Salz der Skorpok";
      ["reward"] = {
         [1] = 8412;
      };
      ["name_cn"] = "厚甲蝎?";
      ["objective"] = "Bring three Scorpok Pincers, two Vulture Gizzards, and one Blasted Boar Lung to Bloodmage Drazial.";
      ["faction"] = "Horde";
      ["name"] = "Salt of the Scorpok";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2585;
      ["prequests"] = {
         [1] = 2585;
      };
      ["level"] = 50;
      ["name_es"] = "La sal del Scorpok";
      ["req"] = 45;
   };
   [3621] = {
      ["name_ru"] = "Создание отравы Скверны";
      ["type"] = "Solo";
      ["name_fr"] = "La Formation de Felbane";
      ["next"] = 3625;
      ["name_de"] = "Die Herstellung von Teufelsbann";
      ["name_cn"] = "武器的?造";
      ["objective"] = "Take the Shipment to Galvan the Ancient in Stranglethorn Vale.";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "The Formation of Felbane";
      ["prev"] = 3602;
      ["prequests"] = {
         [1] = 3602;
      };
      ["level"] = 58;
      ["name_es"] = "La formacion de Aterravil";
      ["req"] = 45;
   };
   [2602] = {
      ["name_ru"] = "Непогрешимый разум";
      ["type"] = "Solo";
      ["name_fr"] = "Un esprit infaillible";
      ["name_de"] = "Unfehlbare Gedanken";
      ["reward"] = {
         [1] = 8423;
      };
      ["name_cn"] = "清晰的思想";
      ["objective"] = "Bring ten Basilisk Brains and two Vulture Gizzards to Bloodmage Lynnore.";
      ["faction"] = "Horde";
      ["name"] = "Infallible Mind";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2601;
      ["prequests"] = {
         [1] = 2601;
      };
      ["level"] = 50;
      ["name_es"] = "La mente infalible";
      ["req"] = 45;
   };
   [5219] = {
      ["name_ru"] = "Цель: Слезы Далсона";
      ["objective"] = "Go to Dalson's Tears in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Dalson's Tears Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：??松之泪";
      ["sort"] = "Western Plaguelands";
      ["level"] = 55;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: les Larmes de Dalson";
      ["next"] = 5220;
      ["name_de"] = "Ziel: Dalsons Tranenfeld";
      ["repgain"] = {
         [469] = 250;
         [529] = 250;
      };
      ["followup"] = 5220;
      ["name"] = "Target: Dalson's Tears";
      ["prev"] = 5217;
      ["prequests"] = {
         [1] = 5217;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Objetivo: Llanto de Dalson";
      ["req"] = 50;
   };
   [5235] = {
      ["name_ru"] = "Цель: пустошь Гаррона";
      ["objective"] = "Go to Gahrron's Withering in Western Plaguelands to locate and defeat the Cauldron Lord present there, and use its key to gain access to the cauldron.  You must have the Empty Gahrron's Withering Bottle with you to secure a sample of the poisons used inside the cauldron.";
      ["name_cn"] = "目?：盖?恩??";
      ["sort"] = "Western Plaguelands";
      ["level"] = 58;
      ["type"] = "Solo";
      ["name_fr"] = "Cible?: la Fletrissure de Gahrron";
      ["next"] = 5236;
      ["name_de"] = "Ziel: Gahrrons Trauerfeld";
      ["repgain"] = {
         [67] = 250;
         [529] = 250;
      };
      ["followup"] = 5227;
      ["name"] = "Target: Gahrron's Withering";
      ["prev"] = 5234;
      ["prequests"] = {
         [1] = 5234;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Objetivo: Gangrena de Gahrron";
      ["req"] = 50;
   };
   [5251] = {
      ["name_ru"] = "Архивариус";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme and find Archivist Galford of the Scarlet Crusade. Destroy him and burn down the Scarlet Archive.";
      ["repgain"] = {
         [529] = 150;
      };
      ["name_fr"] = "L'archiviste";
      ["sort"] = "Stratholme";
      ["name_cn"] = "档案管理?";
      ["name_de"] = "Der Archivar";
      ["faction"] = "Horde";
      ["name"] = "The Archivist";
      ["level"] = 60;
      ["name_es"] = "El archivista";
      ["req"] = 55;
   };
   [5281] = {
      ["name_ru"] = "Мятущиеся души";
      ["type"] = "Dungeon";
      ["objective"] = "Find Egan. You only know that he was last seen around Stratholme.";
      ["next"] = 5282;
      ["name_fr"] = "Ames tourmentees";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "永不安息的?魂";
      ["series"] = 1;
      ["name_de"] = "Die ruhelosen Seelen";
      ["faction"] = "Horde";
      ["name"] = "The Restless Souls";
      ["level"] = 60;
      ["name_es"] = "Espiritus inquietos";
      ["req"] = 55;
   };
   [5283] = {
      ["name_ru"] = "Искусство изготовления брони";
      ["type"] = "Solo";
      ["objective"] = "To become an Armorsmith, you must make the following items and return them to Grumnus: 4 Ornate Mithril Helms, 2 Ornate Mithril Boots, 1 Ornate Mithril Breastplate.";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "?造?甲的??";
      ["name_fr"] = "L'art de l'armurier";
      ["name_de"] = "Die Kunst des Rustungsschmiedes";
      ["faction"] = "Alliance";
      ["name"] = "The Art of the Armorsmith";
      ["level"] = 40;
      ["name_es"] = "El arte del forjador de armaduras";
      ["req"] = 40;
   };
   [9208] = {
      ["name_ru"] = "Защита Джунглей ? Магический знак защиты";
      ["type"] = "Raid";
      ["objective"] = "Zanza the Restless in Zul'Gurub wants an Arcanum of Protection.";
      ["repgain"] = {
         [270] = 200;
      };
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La Garde sauvage - Arcanum de protection";
      ["name_cn"] = "野性戒? - 防?秘?";
      ["reward"] = {
         [1] = 22635;
      };
      ["name_de"] = "Der Greuelwachter - Arkanum des Schutzes";
      ["faction"] = "Horde";
      ["name"] = "The Savage Guard - Arcanum of Protection";
      ["level"] = 60;
      ["name_es"] = "La guardia salvaje: arcanum de proteccion";
      ["req"] = 60;
   };
   [3114] = {
      ["name_ru"] = "Таинственная записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note de service glyphee";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Glyphenmemorandum";
      ["objective"] = "Read the Glyphic Memorandum and speak to Marryk Nurribit inside Anvilmar above Coldridge Valley.";
      ["name_cn"] = "雕文?忘?";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Glyphic Memorandum";
      ["races"] = {
         [1] = "Gnome";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Memorandum glifico";
      ["req"] = 1;
   };
   [5361] = {
      ["name_ru"] = "Семейное древо";
      ["type"] = "Solo";
      ["objective"] = "Deliver Cliffwatcher Longhorn Report to Nataka Longhorn at Ghost Walker Post in Desolace.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Arbre familial";
      ["sort"] = "Thousand Needles";
      ["name_cn"] = "兄弟";
      ["name_de"] = "Stammbaum";
      ["faction"] = "Horde";
      ["name"] = "Family Tree";
      ["level"] = 35;
      ["name_es"] = "Arbol genealogico";
      ["req"] = 32;
   };
   [8524] = {
      ["name_ru"] = "Альянсу не хватает радужного тунца!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Rainbow Fin Albacore to Slicky Gastronome at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de thon arc-en-ciel !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要彩??！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_de"] = "Die Allianz braucht Regenbogenflossenthunfisch!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Rainbow Fin Albacore!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita atun blanco arco iris!";
      ["req"] = 54;
   };
   [3741] = {
      ["name_ru"] = "Ожерелье Хилари";
      ["type"] = "Solo";
      ["objective"] = "Find Hilary's Necklace, and return it to Hilary in Lakeshire.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_fr"] = "Le collier d'Hilary";
      ["sort"] = "Redridge Mountains";
      ["name_cn"] = "希拉里的??";
      ["name_de"] = "Hilarys Halskette";
      ["faction"] = "Horde";
      ["name"] = "Hilary's Necklace";
      ["level"] = 15;
      ["name_es"] = "El collar de Hilary";
      ["req"] = 12;
   };
   [5521] = {
      ["name_ru"] = "Многоцветное оплечье Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 25 Argent Dawn Valor Tokens to Quartermaster Lightspark at Chillwind Camp, Western Plaguelands.";
      ["name_fr"] = "Le mantelet de l'Aube chromatique";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "多彩黎明?肩";
      ["reward"] = {
         [1] = 18182;
      };
      ["name_de"] = "Der Chromatische Mantel der Dammerung";
      ["faction"] = "Alliance";
      ["name"] = "Chromatic Mantle of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Manto del Alba cromatico";
      ["req"] = 55;
   };
   [5529] = {
      ["name_ru"] = "Зачумленные детеныши дракона";
      ["type"] = "Dungeon";
      ["objective"] = "Kill 20 Plagued Hatchlings, then return to Betina Bigglezink at the Light's Hope Chapel.";
      ["repgain"] = {
         [529] = 250;
      };
      ["name_fr"] = "Portee contaminee";
      ["sort"] = "Scholomance";
      ["name_cn"] = "瘟疫之?";
      ["name_de"] = "Verseuchte Jungtiere";
      ["faction"] = "Horde";
      ["name"] = "Plagued Hatchlings";
      ["level"] = 58;
      ["name_es"] = "Crias de dragon apestadas";
      ["req"] = 55;
   };
   [5537] = {
      ["name_ru"] = "Фрагменты скелетов";
      ["type"] = "Solo";
      ["name_fr"] = "Fragments de squelette";
      ["next"] = 5538;
      ["name_de"] = "Skelettfragmente";
      ["name_cn"] = "骸骨碎片";
      ["objective"] = "Bring 15 Skeletal Fragments to Alchemist Arbington at Chillwind Point, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["faction"] = "Alliance";
      ["name"] = "Skeletal Fragments";
      ["prev"] = 5533;
      ["prequests"] = {
         [1] = 5533;
      };
      ["level"] = 57;
      ["name_es"] = "Trozos esqueleticos";
      ["req"] = 55;
   };
   [5545] = {
      ["name_ru"] = "Тридцать три несчастья";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Bundles of Wood to Raelen at the Eastvale Logging Camp.";
      ["sort"] = "Elwynn Forest";
      ["name_cn"] = "木材危机";
      ["name_fr"] = "Un sac d'embrouilles";
      ["name_de"] = "Ein Bundel Probleme";
      ["faction"] = "Alliance";
      ["name"] = "A Bundle of Trouble";
      ["level"] = 9;
      ["name_es"] = "El cumplimiento del plazo";
      ["req"] = 5;
   };
   [3801] = {
      ["name_ru"] = "Наследие Черного Железа";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Franclorn Forgewright if you are interested in obtaining a key to the city major.";
      ["next"] = 3802;
      ["name_fr"] = "Heritage Sombrefer";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "黑?的??";
      ["series"] = 1;
      ["name_de"] = "Dunkeleisenerbe";
      ["faction"] = "Horde";
      ["name"] = "Dark Iron Legacy";
      ["level"] = 52;
      ["name_es"] = "El legado de los Hierro Negro";
      ["req"] = 48;
   };
   [5561] = {
      ["name_ru"] = "Отлов кодо";
      ["type"] = "Solo";
      ["objective"] = "Bring five Tamed Kodos and the Kodo Kombobulator back to Smeed Scrabblescrew at Scrabblescrew's Camp.";
      ["repgain"] = {
         [470] = 150;
      };
      ["sort"] = "Desolace";
      ["name_fr"] = "Le rassemblement des kodos";
      ["name_cn"] = "?捕科多?";
      ["reward"] = {
         [1] = 15697;
         [2] = 15698;
      };
      ["name_de"] = "Kodozusammentrieb";
      ["faction"] = "Horde";
      ["name"] = "Kodo Roundup";
      ["level"] = 34;
      ["name_es"] = "El rodeo kodo";
      ["req"] = 30;
   };
   [2608] = {
      ["name_ru"] = "Прикосновение Занзила";
      ["type"] = "Solo";
      ["name_fr"] = "Le toucher de Zanzil";
      ["name_de"] = "Die Beruhrung von Zanzil";
      ["sort"] = "Rogue";
      ["objective"] = "/Lay down to be examined by Doc Mixilpixil. How can he find the cure if he can't find the cause?$B";
      ["name_cn"] = "?吉?之触";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "The Touch of Zanzil";
      ["followup"] = 2609;
      ["prev"] = 2607;
      ["prequests"] = {
         [1] = 2607;
      };
      ["level"] = 20;
      ["name_es"] = "Toque de Zanzil";
      ["req"] = 20;
   };
   [2746] = {
      ["name_ru"] = "Все по порядку";
      ["type"] = "Solo";
      ["name_fr"] = "Des objets d’une certaine importance";
      ["repgain"] = {
         [72] = 25;
      };
      ["name_de"] = "Nicht unwichtige Gegenstande";
      ["name_cn"] = "必?物品";
      ["name"] = "Items of Some Consequence";
      ["objective"] = "Bring 3 Silk Cloth and 2 of Clara's Fresh Apples to Tyrion in Stormwind.";
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 2745;
      ["prequests"] = {
         [1] = 2745;
      };
      ["level"] = 31;
      ["name_es"] = "Objetos importantes";
      ["req"] = 16;
   };
   [2754] = {
      ["name_ru"] = "Рога безумия";
      ["type"] = "Solo";
      ["name_fr"] = "Les cornes de Frenesie";
      ["name_de"] = "Horner der Raserei";
      ["reward"] = {
         [1] = 7980;
      };
      ["name_cn"] = "?狂之角";
      ["objective"] = "Bring two Solid Iron Mauls, two Silvered Bronze Boots, and two Silvered Bronze Gauntlets to Orokk Omosh in Orgrimmar.";
      ["faction"] = "Horde";
      ["name"] = "Horns of Frenzy";
      ["sort"] = "Blacksmithing";
      ["prev"] = 2753;
      ["prequests"] = {
         [1] = 2753;
      };
      ["level"] = 36;
      ["name_es"] = "Cuernos de frenesi";
      ["req"] = 32;
   };
   [2762] = {
      ["name_ru"] = "Обманное серебро";
      ["type"] = "Solo";
      ["name_fr"] = "Le vif-argent n’est pas de l'argent";
      ["name_de"] = "Der grose silberne Betruger";
      ["objective"] = "Bring forty Mithril Bars and five Truesilver Bars to Galvan the Ancient in Stranglethorn.";
      ["followup"] = 2765;
      ["name_cn"] = "白花花的?子";
      ["faction"] = "Horde";
      ["name"] = "The Great Silver Deceiver";
      ["reward"] = {
         [1] = 7984;
      };
      ["sort"] = "Blacksmithing";
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "La veraplata no es veridica";
      ["req"] = 40;
   };
   [2770] = {
      ["name_ru"] = "Газ'рилла";
      ["type"] = "Dungeon";
      ["objective"] = "Bring Gahz'rilla's Electrified Scale to Wizzle Brassbolts in the Shimmering Flats.";
      ["name_fr"] = "Gahz'rilla";
      ["sort"] = "Zul'Farrak";
      ["name_cn"] = "加?瑞拉";
      ["reward"] = {
         [1] = 11122;
      };
      ["name_de"] = "Gahz'rilla";
      ["faction"] = "Horde";
      ["name"] = "Gahz'rilla";
      ["level"] = 50;
      ["name_es"] = "Gahz'rilla";
      ["req"] = 40;
   };
   [3905] = {
      ["name_ru"] = "Уведомление о поставке винограда";
      ["type"] = "Solo";
      ["objective"] = "Bring the Grape Manifest to Brother Neals in Northshire Abbey.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Traubenliste";
      ["reward"] = {
         [1] = 11475;
         [2] = 2690;
      };
      ["name_cn"] = "葡萄出??";
      ["name_fr"] = "Manifeste des vendanges";
      ["faction"] = "Alliance";
      ["name"] = "Grape Manifest";
      ["sort"] = "Northshire Valley";
      ["prev"] = 3904;
      ["prequests"] = {
         [1] = 3904;
      };
      ["level"] = 4;
      ["name_es"] = "Informe de la vendimia";
      ["req"] = 2;
   };
   [3909] = {
      ["name_ru"] = "Эликсир Видере";
      ["type"] = "Solo";
      ["name_fr"] = "L'elixir de Videre";
      ["next"] = 3912;
      ["name_de"] = "Das Videre-Elixier";
      ["name_cn"] = "????";
      ["objective"] = "Seek out Gregan Brewspewer in northern Feralas. From him, learn how you may acquire the Videre Elixir, then return to Donova Snowden in Winterspring.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "The Videre Elixir";
      ["prev"] = 3908;
      ["prequests"] = {
         [1] = 3908;
      };
      ["level"] = 52;
      ["name_es"] = "El Elixir de Videre";
      ["req"] = 47;
   };
   [3941] = {
      ["name_ru"] = "Помощь гномов";
      ["type"] = "Solo";
      ["name_fr"] = "Un gnome dans le besoin";
      ["next"] = 3942;
      ["name_de"] = "Die Hilfe des Gnoms";
      ["name_cn"] = "侏儒的援助";
      ["objective"] = "Find J.D. Collie in the cave at Marshal's Refuge.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "A Gnome's Assistance";
      ["prev"] = 3914;
      ["prequests"] = {
         [1] = 3914;
      };
      ["level"] = 52;
      ["name_es"] = "La ayuda de una gnoma";
      ["req"] = 47;
   };
   [9033] = {
      ["name_ru"] = "Отголоски войны";
      ["type"] = "Raid";
      ["objective"] = "Commander Eligor Dawnbringer at Light's Hope Chapel in the Eastern Plaguelands wants you to slay 5 Living Monstrosities, 5 Stoneskin Gargoyles, 8 Deathknight Captains and 3 Venom Stalkers.";
      ["name_fr"] = "Les echos de la guerre";
      ["sort"] = "Naxxramas";
      ["name_cn"] = "?争的回?";
      ["name"] = "Echoes of War";
      ["name_de"] = "Echo des Krieges";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 9121;
         [2] = 9123;
         [3] = 9122;
      };
      ["level"] = 60;
      ["name_es"] = "Ecos de Guerra";
      ["req"] = 60;
   };
   [3961] = {
      ["name_ru"] = "Приключения Линкена";
      ["type"] = "Solo";
      ["name_fr"] = "L'aventure de Linken";
      ["next"] = 3962;
      ["name_de"] = "Linkens Abenteuer";
      ["name_cn"] = "林克的冒?";
      ["objective"] = "Take the Silver Totem of Aquementas to Linken in Marshal's Refuge.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Linken's Adventure";
      ["prev"] = 4005;
      ["prequests"] = {
         [1] = 4005;
      };
      ["level"] = 54;
      ["name_es"] = "La aventura de Linken";
      ["req"] = 47;
   };
   [5635] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["sort"] = "Priest";
      ["name_cn"] = "?望祷言";
      ["name_fr"] = "Priere du desespoir";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [5651] = {
      ["name_ru"] = "Во славу Тьмы";
      ["type"] = "Solo";
      ["name_fr"] = "Au service des tenebres";
      ["repgain"] = {
         [68] = 60;
      };
      ["name_de"] = "Der Dunkelheit geneigt";
      ["name_cn"] = "黑暗的恩?";
      ["objective"] = "Speak to Dark Cleric Beryl in Tirisfal Glades.";
      ["classes"] = {
         [1] = "Priest";
      };
      ["next"] = 5650;
      ["name"] = "In Favor of Darkness";
      ["sort"] = "Priest";
      ["races"] = {
         [1] = "Undead";
      };
      ["level"] = 4;
      ["name_es"] = "Al servicio de la Oscuridad";
      ["req"] = 5;
   };
   [4061] = {
      ["name_ru"] = "Восстание машин";
      ["type"] = "Solo";
      ["name_fr"] = "La revolte des machines";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Aufstieg der Maschinen";
      ["name_cn"] = "机器的崛起";
      ["objective"] = "Venture to the Burning Steppes and recover 10 Fractured Elemental Shards for Hierophant Theodora Mulvadania.$B$BYou recall Theodora mentioning the golems and elementals of that region as being a source for these shards.";
      ["next"] = 4062;
      ["sort"] = "Burning Steppes";
      ["name"] = "The Rise of the Machines";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 54;
      ["name_es"] = "La revuelta de las maquinas";
      ["req"] = 52;
   };
   [2842] = {
      ["name_ru"] = "Главный инженер Скути";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Scooty in Booty Bay.";
      ["next"] = 2843;
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "主工程?斯?提";
      ["name_fr"] = "L'ingenieur en chef Scooty";
      ["name_de"] = "Chefingenieur Scooty";
      ["faction"] = "Horde";
      ["name"] = "Chief Engineer Scooty";
      ["level"] = 35;
      ["name_es"] = "Scooty, ingeniero jefe";
      ["req"] = 25;
   };
   [2850] = {
      ["name_ru"] = "Дикарский кожаный шлем";
      ["type"] = "Solo";
      ["name_fr"] = "Le casque en cuir fauve";
      ["name_de"] = "Wildlederhelm";
      ["objective"] = "Bring 2 Nightscape Tunics, 2 Nightscape Headbands, and a Wildvine to Pratt McGrubben in Feathermoon Stronghold.";
      ["followup"] = 2853;
      ["name_cn"] = "蛮皮??";
      ["faction"] = "Alliance";
      ["name"] = "Wild Leather Helmet";
      ["reward"] = {
         [1] = 8405;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2847;
      ["prequests"] = {
         [1] = 2847;
      };
      ["level"] = 45;
      ["name_es"] = "Casco de cuero salvaje";
      ["req"] = 30;
   };
   [2858] = {
      ["name_ru"] = "Дикарские кожаные сапоги";
      ["type"] = "Solo";
      ["name_fr"] = "Les bottes en cuir fauve";
      ["name_de"] = "Wildlederstiefel";
      ["objective"] = "Bring 2 Nightscape Pants, 2 Nightscape Boots, and 2 Wildvines to Jangdor Swiftstrider in Camp Mojache.";
      ["followup"] = 2860;
      ["name_cn"] = "蛮皮?靴";
      ["faction"] = "Horde";
      ["name"] = "Wild Leather Boots";
      ["reward"] = {
         [1] = 8406;
      };
      ["sort"] = "Leatherworking";
      ["prev"] = 2854;
      ["prequests"] = {
         [1] = 2854;
      };
      ["level"] = 48;
      ["name_es"] = "Botas de cuero salvaje";
      ["req"] = 30;
   };
   [2866] = {
      ["name_ru"] = "Руины Соларсаля";
      ["type"] = "Solo";
      ["objective"] = "Explore the Ruins of Solarsal and investigate the presence of the naga there.";
      ["next"] = 2867;
      ["name_fr"] = "Les ruines de Solarsal";
      ["sort"] = "Feralas";
      ["name_cn"] = "索????墟";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Die Ruinen von Solarsal";
      ["faction"] = "Alliance";
      ["name"] = "The Ruins of Solarsal ";
      ["level"] = 43;
      ["name_es"] = "Las Ruinas de Solarsal";
      ["req"] = 40;
   };
   [2874] = {
      ["name_ru"] = "Ром для Маккинли";
      ["type"] = "Solo";
      ["name_fr"] = "Livraison a MacKinley";
      ["name_de"] = "Lieferung fur MacKinley";
      ["reward"] = {
         [1] = 9636;
         [2] = 9637;
      };
      ["name_cn"] = "??克基雷的?物";
      ["objective"] = "Bring Stoley's Bottle to Sea Wolf\" MacKinley in Booty Bay.\"";
      ["faction"] = "Horde";
      ["name"] = "Deliver to MacKinley";
      ["sort"] = "Tanaris";
      ["prev"] = 2873;
      ["prequests"] = {
         [1] = 2873;
      };
      ["level"] = 45;
      ["name_es"] = "Un envio para MacKinley";
      ["req"] = 40;
   };
   [5763] = {
      ["name_ru"] = "Охота в Тернистой долине";
      ["type"] = "Solo";
      ["objective"] = "Bring Roon's Kodo Horn to Hemet Nesingwary in Stranglethorn.";
      ["sort"] = "Desolace";
      ["name_cn"] = "?棘谷狩?";
      ["name_fr"] = "Chasse a Strangleronce";
      ["name_de"] = "Jagd im Schlingendorntal";
      ["faction"] = "Horde";
      ["name"] = "Hunting in Stranglethorn";
      ["level"] = 31;
      ["name_es"] = "La caza en Tuercespina";
      ["req"] = 28;
   };
   [2041] = {
      ["name_ru"] = "Разговор с Шони";
      ["type"] = "Solo";
      ["objective"] = "Speak with Shoni the Shilent in Stormwind.";
      ["next"] = 2040;
      ["name_fr"] = "Allez voir Shoni";
      ["sort"] = "Ironforge";
      ["name_cn"] = "?默的舒尼";
      ["repgain"] = {
         [54] = 25;
      };
      ["name_de"] = "Sprecht mit Shoni";
      ["faction"] = "Alliance";
      ["name"] = "Speak with Shoni";
      ["level"] = 15;
      ["name_es"] = "Habla con Shoni";
      ["req"] = 15;
   };
   [6129] = {
      ["name_ru"] = "Исцеление больных";
      ["objective"] = "Use the Curative Animal Salve on 10 Sickly Gazelles that are located throughout the northern part of the Barrens; doing so should cure them.  Sickly Gazelles have been reported north of the east-west road that runs through the Crossroads.";
      ["name_cn"] = "消除疾病";
      ["sort"] = "Druid";
      ["level"] = 14;
      ["type"] = "Solo";
      ["name_fr"] = "Soigner la maladie";
      ["next"] = 6130;
      ["name_de"] = "Heilung der Kranken";
      ["repgain"] = {
         [609] = 75;
      };
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Curing the Sick";
      ["prev"] = 6128;
      ["prequests"] = {
         [1] = 6128;
      };
      ["reward"] = {
         [1] = 15866;
      };
      ["name_es"] = "Curar la dolencia";
      ["req"] = 14;
   };
   [8292] = {
      ["name_ru"] = "Талисманы заслуг";
      ["type"] = "PvP";
      ["name_fr"] = "Les talismans de vaillance";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "功??章";
      ["objective"] = "You obtained a Silverwing Talisman of Merit for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Alliance";
      ["name"] = "Talismans of Merit";
      ["name_de"] = "Verdienstabzeichen";
      ["prev"] = 8291;
      ["prequests"] = {
         [1] = 8291;
      };
      ["level"] = 60;
      ["name_es"] = "Talismanes del merito";
      ["req"] = 60;
   };
   [9665] = {
      ["name_ru"] = "Укрепим оборону";
      ["type"] = "PvP";
      ["objective"] = "Capture Crown Guard Tower, Eastwall Tower, Northpass Tower and Plaguewood Tower in the Eastern Plaguelands, then return to Emmisary Gormok at Light's Hope Chapel.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "加?防御";
      ["name_fr"] = "Renforcer nos defenses";
      ["name_de"] = "Verstarkung der Verteidigung";
      ["faction"] = "Horde";
      ["name"] = "Bolstering Our Defenses";
      ["level"] = 60;
      ["name_es"] = "Fortalecimiento de nuestras defensas";
      ["req"] = 55;
   };
   [5843] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue?!";
      ["name_cn"] = "?迎!*";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Valley of Trials Gift Voucher to Magga.";
      ["sort"] = "Valley of Trials";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [2930] = {
      ["name_ru"] = "Спасение данных";
      ["type"] = "Dungeon";
      ["objective"] = "Bring a Prismatic Punch Card to Master Mechanic Castpipe in Ironforge.";
      ["repgain"] = {
         [54] = 500;
      };
      ["sort"] = "Gnomeregan";
      ["name_fr"] = "Sauvetage de donnees";
      ["name_cn"] = "?救数据";
      ["reward"] = {
         [1] = 9605;
         [2] = 9604;
      };
      ["name_de"] = "Datenrettung";
      ["faction"] = "Alliance";
      ["name"] = "Data Rescue";
      ["level"] = 30;
      ["name_es"] = "Rescatar los datos";
      ["req"] = 25;
   };
   [2938] = {
      ["name_ru"] = "Яд в Подгород";
      ["type"] = "Solo";
      ["objective"] = "Bring Faranell's Parcel to Master Apothecary Faranell in the Undercity.";
      ["repgain"] = {
         [68] = 500;
      };
      ["name_de"] = "Gift fur Unterstadt";
      ["reward"] = {
         [1] = 9649;
         [2] = 9650;
         [3] = 10686;
      };
      ["name_cn"] = "送往幽暗城的毒?";
      ["name_fr"] = "Du venin pour Fossoyeuse";
      ["faction"] = "Horde";
      ["name"] = "Venom to the Undercity";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2937;
      ["prequests"] = {
         [1] = 2937;
      };
      ["level"] = 55;
      ["name_es"] = "Veneno para Entranas";
      ["req"] = 40;
   };
   [5891] = {
      ["name_ru"] = "Лекарство из распыленных предметов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Salbe durch Entzauberung";
      ["name_fr"] = "Du baume contre des desenchantements";
      ["name_cn"] = "分解??膏";
      ["name"] = "Salve via Disenchanting";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11516;
      };
      ["sort"] = "Felwood";
      ["prev"] = 5886;
      ["prequests"] = {
         [1] = 5886;
      };
      ["level"] = 55;
      ["name_es"] = "Balsamo por desencantamiento";
      ["req"] = 48;
   };
   [2954] = {
      ["name_ru"] = "Каменный Страж";
      ["type"] = "Group";
      ["objective"] = " I will not allow for entry into the Uldum compound.\"$B$BThe appearance of the Stone Watcher of Norgannon must be the reaction that was hoped for in sending you out to the Tanaris desert with the platinum discs.  As instructed";
      ["name_fr"] = "Le Gardien des pierres";
      ["sort"] = "Tanaris";
      ["name_cn"] = "石??士";
      ["name"] = "The Stone Watcher";
      ["name_de"] = "Der Steinbehuter";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 2946;
         [2] = 2966;
      };
      ["level"] = 50;
      ["name_es"] = "El vigia de piedra";
      ["req"] = 45;
   };
   [5923] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mathrengyl Bearwalker in the Cenarion Enclave, Darnassus.";
      ["next"] = 5921;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "??召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [2970] = {
      ["name_ru"] = "Небольшое возмездие";
      ["type"] = "Solo";
      ["name_fr"] = "Justice de chatiment";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_de"] = "Gerechtigkeit uben";
      ["name_cn"] = "菲拉斯的正?";
      ["name"] = "Doling Justice";
      ["objective"] = "Kill 12 Grimtotem Naturalists, 10 Grimtotem Raiders, and 6 Grimtotem Shamans before returning to Jer'kai Moonweaver in Feralas.";
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2969;
      ["prequests"] = {
         [1] = 2969;
      };
      ["level"] = 47;
      ["name_es"] = "La justicia del castigo";
      ["req"] = 38;
   };
   [2978] = {
      ["name_ru"] = "Свиток Гордунни";
      ["type"] = "Solo";
      ["objective"] = "Bring the Gordunni Scroll to Rok Orhan in Camp Mojache.";
      ["next"] = 2979;
      ["name_fr"] = "Le parchemin gordunni";
      ["sort"] = "Feralas";
      ["name_cn"] = "戈杜尼卷?";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Die Gordunnischriftrolle";
      ["faction"] = "Horde";
      ["name"] = "The Gordunni Scroll";
      ["level"] = 43;
      ["name_es"] = "El pergamino Gordunni";
      ["req"] = 38;
   };
   [2986] = {
      ["name_ru"] = "Зов Воды";
      ["type"] = "Solo";
      ["objective"] = "Find Islen Waterseer in the Barrens.";
      ["next"] = 1530;
      ["sort"] = "Shaman";
      ["name_cn"] = "水之召?";
      ["name_fr"] = "L'appel de l'eau";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["followup"] = 1530;
      ["name_de"] = "Ruf des Wassers";
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["level"] = 20;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [2994] = {
      ["name_ru"] = "Спасение Остроклюва";
      ["type"] = "Group";
      ["name_fr"] = "Sauver Bec-tranchant";
      ["name_de"] = "Scharfschnabels Rettung";
      ["reward"] = {
         [1] = 9651;
         [2] = 9652;
      };
      ["name_cn"] = "拯救沙普比克";
      ["objective"] = "Fight to the top of Jintha'Alor, kill Vile Priestess Hexx for the key to Sharpbeak's cage, and save Sharpbeak.";
      ["faction"] = "Alliance";
      ["name"] = "Saving Sharpbeak";
      ["sort"] = "The Hinterlands";
      ["prev"] = 2993;
      ["prequests"] = {
         [1] = 2993;
      };
      ["level"] = 53;
      ["name_es"] = "Salvar a Picoafilado";
      ["req"] = 40;
   };
   [3002] = {
      ["name_ru"] = "Сфера Гордунни";
      ["type"] = "Solo";
      ["name_fr"] = "L'Orbe Gordunni";
      ["repgain"] = {
         [530] = 75;
      };
      ["name_de"] = "Die Gordunnikugel";
      ["name_cn"] = "戈杜尼宝珠";
      ["name"] = "The Gordunni Orb";
      ["objective"] = "Bring the Gordunni Orb to Uthel'nay in the Darkbriar Lodge in Orgrimmar.";
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 2979;
      ["prequests"] = {
         [1] = 2979;
      };
      ["level"] = 47;
      ["name_es"] = "El orbe Gordunni";
      ["req"] = 38;
   };
   [6361] = {
      ["name_ru"] = "Связка шкур";
      ["type"] = "Solo";
      ["name_fr"] = "Un tas de peaux";
      ["repgain"] = {
         [81] = 25;
      };
      ["name_cn"] = "一??皮";
      ["name_de"] = "Ein Bundel Balge";
      ["objective"] = "Bring the Bundle of Hides to the wind rider master Devrak in the Crossroads.";
      ["next"] = 6362;
      ["name"] = "A Bundle of Hides";
      ["sort"] = "The Barrens";
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 10;
      ["name_es"] = "Un fardo de pellejos";
      ["req"] = 10;
   };
   [2178] = {
      ["name_ru"] = "Спокойная жизнь долгоногов";
      ["type"] = "Solo";
      ["objective"] = "Bring back 5 Strider Meat to Alanndarian Nightsong in Auberdine.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Cooking";
      ["name_fr"] = "Brouet de trotteur";
      ["name_cn"] = "??行?";
      ["reward"] = {
         [1] = 5486;
         [2] = 5477;
      };
      ["name_de"] = "Schreitereintopf";
      ["faction"] = "Alliance";
      ["name"] = "Easy Strider Living";
      ["level"] = 12;
      ["name_es"] = "Guiso de zancudo";
      ["req"] = 9;
   };
   [4386] = {
      ["name_ru"] = "Кристальная спираль";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Kristallspitze";
      ["name_fr"] = "Cristal de retribution";
      ["name_cn"] = "尖刺水晶";
      ["name"] = "Crystal Spire";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11567;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4321;
      ["prequests"] = {
         [1] = 4321;
      };
      ["level"] = 53;
      ["name_es"] = "Aguja de cristal";
      ["req"] = 47;
   };
   [6067] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Yaw Sharpmane in Bloodhoof Village.";
      ["next"] = 6061;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [3042] = {
      ["name_ru"] = "Троллье месиво";
      ["type"] = "Dungeon";
      ["objective"] = "Bring 20 Vials of Troll Temper to Trenton Lighthammer in Gadgetzan.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "Agent durcissant troll";
      ["sort"] = "Zul'Farrak";
      ["name_cn"] = "巨魔?和?";
      ["name_de"] = "Trollausharter";
      ["faction"] = "Horde";
      ["name"] = "Troll Temper";
      ["level"] = 45;
      ["name_es"] = "Temple trol";
      ["req"] = 40;
   };
   [8880] = {
      ["name_ru"] = "Сигнальные ракеты";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "Les chapelets de cometes";
      ["name_cn"] = "烟花束";
      ["reward"] = {
         [1] = 21741;
         [2] = 21640;
      };
      ["name_de"] = "Raketenbundel";
      ["faction"] = "Horde";
      ["name"] = "Cluster Rockets";
      ["level"] = 60;
      ["name_es"] = "Tracas de cohetes";
      ["req"] = 45;
   };
   [8268] = {
      ["name_ru"] = "Ленты жертвоприношения";
      ["type"] = "Solo";
      ["objective"] = "Bring the Ribbons of Sacrifice to Sentinel Farsong so that the Sentinels may reward you for acting on our behalf.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "奉献??";
      ["name_fr"] = "Les rubans de sacrifice";
      ["name_de"] = "Aufopferungsabzeichen";
      ["faction"] = "Alliance";
      ["name"] = "Ribbons of Sacrifice";
      ["level"] = 39;
      ["name_es"] = "Galon de sacrificio";
      ["req"] = 10;
   };
   [8928] = {
      ["name_ru"] = "Сомнительный торговец";
      ["type"] = "Group";
      ["name_fr"] = "Un marchand a eclipses";
      ["name_de"] = "Ein verschlagener Handler";
      ["name_cn"] = "小巧的商人";
      ["objective"] = "Search for an imp inside a cave at the entrance of Darkwhisper Gorge in southern Winterspring, purchase a Fel Elemental Rod and return to Mux Manascrambler in Gadgetzan.";
      ["sort"] = "Tanaris";
      ["faction"] = "Horde";
      ["name"] = "A Shifty Merchant";
      ["prev"] = 8925;
      ["prequests"] = {
         [1] = 8925;
      };
      ["level"] = 60;
      ["name_es"] = "Un mercader sospechoso";
      ["req"] = 58;
   };
   [6147] = {
      ["name_ru"] = "Назад к Натаносу";
      ["type"] = "Group";
      ["name_fr"] = "Retourner voir Nathanos";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Kehrt zu Nathanos zuruck.";
      ["name"] = "Return to Nathanos";
      ["name_cn"] = "向???斯?命";
      ["objective"] = "Return to Nathanos Blightcaller with the new information.$B";
      ["next"] = 6148;
      ["faction"] = "Horde";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6146;
      ["prequests"] = {
         [1] = 6146;
      };
      ["level"] = 60;
      ["name_es"] = "Regresa junto a Nathanos";
      ["req"] = 56;
   };
   [8229] = {
      ["name_ru"] = "Приглашение на рыбалку";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_fr"] = "Puis-je avoir un prospectus sur la peche??";
      ["name_cn"] = "能?我一?宣???？";
      ["reward"] = {
         [1] = 19978;
      };
      ["name_de"] = "Konnte ich einen Flugzettel fur den Angelwettbewerb bekommen?";
      ["faction"] = "Alliance";
      ["name"] = "Could I get a Fishing Flier?";
      ["level"] = 60;
      ["name_es"] = "?Puedo tener un folleto de pesca?";
      ["req"] = 55;
   };
   [8261] = {
      ["name_ru"] = "Стандартный полевой комплект Лиги Аратора";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [509] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Paquetage ordinaire d'Arathor";
      ["name_cn"] = "阿拉索?准医?包";
      ["reward"] = {
         [1] = 20236;
      };
      ["name_de"] = "Standarduberlebenspaket von Arathor";
      ["faction"] = "Alliance";
      ["name"] = "Arathor Standard Care Package";
      ["level"] = 44;
      ["name_es"] = "Botiquin normal de Arathor";
      ["req"] = 35;
   };
   [3098] = {
      ["name_ru"] = "Свиток, покрытый письменами";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin glyphe";
      ["repgain"] = {
         [68] = 75;
      };
      ["name_de"] = "Glyphenrolle";
      ["objective"] = "Read the Glyphic Scroll and speak to Isabella in the church in Deathknell.";
      ["name_cn"] = "雕文卷?";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Glyphic Scroll";
      ["races"] = {
         [1] = "Undead";
      };
      ["prev"] = 364;
      ["prequests"] = {
         [1] = 364;
      };
      ["level"] = 1;
      ["name_es"] = "Un pergamino glifico";
      ["req"] = 1;
   };
   [3106] = {
      ["name_ru"] = "Простая руна";
      ["type"] = "Solo";
      ["name_fr"] = "Rune simple";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Einfache Rune";
      ["objective"] = "Read the Simple Rune and speak to Thran Khorman in Coldridge Valley.";
      ["name_cn"] = "?易符文";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name"] = "Simple Rune";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa simple";
      ["req"] = 1;
   };
   [8357] = {
      ["name_ru"] = "Танец за марципан";
      ["type"] = "Solo";
      ["objective"] = "Do a dance emote at Innkeeper Saelienne, and in exchange you'll receive Darnassus Marzipan!";
      ["name_fr"] = "Danser pour du massepain";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "跳跳舞，?糖果";
      ["reward"] = {
         [1] = 20496;
      };
      ["name_de"] = "Tanzen fur Marzipan";
      ["faction"] = "Alliance";
      ["name"] = "Dancing for Marzipan";
      ["level"] = 60;
      ["name_es"] = "Bailando por mazapanes";
      ["req"] = 10;
   };
   [3122] = {
      ["name_ru"] = "Возвращение к знахарю Узер'и";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner voir le sorcier-docteur Uzer'i";
      ["repgain"] = {
         [530] = 25;
      };
      ["name_de"] = "Kehrt zu Hexendoktor Uzer'i zuruck";
      ["name_cn"] = "向巫医尤克里回?";
      ["name"] = "Return to Witch Doctor Uzer'i";
      ["objective"] = "Deliver Neeru's Herb Pouch to Witch Doctor Uzer'i in Feralas.";
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 3121;
      ["prequests"] = {
         [1] = 3121;
      };
      ["level"] = 45;
      ["name_es"] = "Regresa junto al medico brujo Uzer'i";
      ["req"] = 40;
   };
   [8421] = {
      ["name_ru"] = "Бросовый материал";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Rotting Wood and 4 Bloodvenom Essence to Impsy in Felwood.";
      ["next"] = 8422;
      ["name_fr"] = "L'anti-etoffe des heros";
      ["sort"] = "Warlock";
      ["name_cn"] = "奇怪的材料";
      ["name"] = "The Wrong Stuff";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Das richtige Zeug";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8419;
         [2] = 8420;
      };
      ["level"] = 52;
      ["name_es"] = "La mercancia equivocada";
      ["req"] = 50;
   };
   [4482] = {
      ["name_ru"] = "Манускрипт упорства";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Burning Steppes";
      ["name_fr"] = "Libram de tenacite";
      ["name_cn"] = "???契*";
      ["reward"] = {
         [1] = 11643;
      };
      ["name_de"] = "Buchband der Hartnackigkeit";
      ["faction"] = "Horde";
      ["name"] = "Libram of Tenacity";
      ["level"] = 55;
      ["name_es"] = "Tratado sobre Tenacidad";
      ["req"] = 50;
   };
   [8485] = {
      ["name_ru"] = "Знак мира";
      ["type"] = "Solo";
      ["objective"] = "Bring the Timbermaw Offering of Peace to Thrall in Orgrimmar.";
      ["sort"] = "Timbermaw Hold";
      ["name_cn"] = "重?和平";
      ["name_fr"] = "Negocier la paix";
      ["name_de"] = "Das Bemuhen um Frieden";
      ["faction"] = "Horde";
      ["name"] = "The Brokering of Peace";
      ["level"] = 60;
      ["name_es"] = "Negociar la paz";
      ["req"] = 45;
   };
   [8517] = {
      ["name_ru"] = "Альянсу не хватает льняных бинтов!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Linen Bandages to Sentinel Silversky at the Military Ward in Ironforge.";
      ["name_fr"] = "L'Alliance a besoin de bandages en lin?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "?盟需要?麻??！";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_de"] = "Die Allianz braucht Leinenverbande!";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs Linen Bandages!";
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita vendas de lino!";
      ["req"] = 51;
   };
   [8549] = {
      ["name_ru"] = "Орде не хватает мироцвета!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Peacebloom to Herbalist Proudfeather at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de pacifique !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要?神花！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21509;
      };
      ["name_de"] = "Die Horde braucht Friedensblumen!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Peacebloom!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita flores de paz!";
      ["req"] = 54;
   };
   [8581] = {
      ["name_ru"] = "Орде все еще не хватает огнецвета!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Firebloom to Batrider Pele'keiki at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Feuerbluten!";
      ["name_fr"] = "La Horde a besoin de plus de fleur de feu !";
      ["name_cn"] = "部落需要更多火?花！";
      ["name"] = "The Horde Needs More Firebloom!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21511;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8580;
      ["prequests"] = {
         [1] = 8580;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas flores de fuego!";
      ["req"] = 1;
   };
   [8613] = {
      ["name_ru"] = "Орде не хватает пятнистого желтохвоста!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Spotted Yellowtail to Fisherman Lin'do at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de jaunes-queues tachetes !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要斑点黄尾?!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["name_de"] = "Die Horde braucht Tupfelgelbschwanze!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Spotted Yellowtail!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita serviolas moteadas!";
      ["req"] = 52;
   };
   [8645] = {
      ["name_ru"] = "Предок Обсидиан";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Obsidien";
      ["name_cn"] = "黑曜石?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Obsidian";
      ["faction"] = "Horde";
      ["name"] = "Obsidian the Elder";
      ["level"] = 60;
      ["name_es"] = "Obsidiano el Ancestro";
      ["req"] = 1;
   };
   [6387] = {
      ["name_ru"] = "Награды ученикам";
      ["type"] = "Solo";
      ["name_fr"] = "L'honneur des etudiants";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_cn"] = "?誉学?";
      ["name_de"] = "Ehrenlehrlinge";
      ["objective"] = "Bring Brock's List to Thorgrum Borrelson in Thelsamar.";
      ["next"] = 6391;
      ["name"] = "Honor Students";
      ["sort"] = "Loch Modan";
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["level"] = 10;
      ["name_es"] = "Estudiantes de honor";
      ["req"] = 10;
   };
   [6403] = {
      ["name_ru"] = "Великий Маскарад";
      ["type"] = "Raid";
      ["name_fr"] = "La grande mascarade";
      ["repgain"] = {
         [469] = 125;
      };
      ["name_de"] = "Die grose Maskerade";
      ["name"] = "The Great Masquerade";
      ["name_cn"] = "潜藏者";
      ["objective"] = "Follow Reginald Windsor through Stormwind. Protect him from harm!";
      ["next"] = 6501;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 6402;
      ["prequests"] = {
         [1] = 6402;
      };
      ["level"] = 60;
      ["name_es"] = "La gran farsa";
      ["req"] = 50;
   };
   [8741] = {
      ["name_ru"] = "Возвращение победителя";
      ["type"] = "Solo";
      ["name_fr"] = "Le retour du champion";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Der Held kehrt zuruck";
      ["followup"] = 8742;
      ["name_cn"] = "冠?的回?";
      ["objective"] = "Take the Green Scepter Shard to Anachronos at the Caverns of Time in Tanaris.$B";
      ["faction"] = "Horde";
      ["name"] = "The Champion Returns";
      ["sort"] = "Moonglade";
      ["prev"] = 8736;
      ["prequests"] = {
         [1] = 8736;
      };
      ["level"] = 60;
      ["name_es"] = "El regreso del Campeon";
      ["req"] = 60;
   };
   [8773] = {
      ["name_ru"] = "Цель: разрушители из Улья Зора";
      ["type"] = "Group";
      ["objective"] = "Slay 30 Hive'Zora Reavers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing IV in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les saccageuses de la Ruche'Zora";
      ["name_cn"] = "目?：佐拉掠?者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Hascher des Zoraschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Zora Reavers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los atracadores de Colmen'Zora";
      ["req"] = 60;
   };
   [8805] = {
      ["name_ru"] = "Сапоги для стражей";
      ["type"] = "Solo";
      ["objective"] = "Bring 3 Ornate Mithril Boots to Vish Kozus, Captain of the Guard at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing II in order to complete this quest.";
      ["name_fr"] = "Des bottes pour la garde";
      ["sort"] = "Silithus";
      ["name_cn"] = "?兵的?甲片";
      ["reward"] = {
         [1] = 20800;
         [2] = 21266;
      };
      ["name_de"] = "Stiefel fur die Wache";
      ["faction"] = "Horde";
      ["name"] = "Boots for the Guard";
      ["level"] = 60;
      ["name_es"] = "Botas para la guardia";
      ["req"] = 60;
   };
   [8837] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8821;
      ["prequests"] = {
         [1] = 8821;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8869] = {
      ["name_ru"] = "Секрет безмятежности";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme and kill the Crimson Hammersmith. Recover the Crimson Hammersmith's Apron and return to Lilith.";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "甜蜜的?静";
      ["reward"] = {
         [1] = 12824;
      };
      ["name_de"] = "Suse Beschaulichkeit";
      ["faction"] = "Horde";
      ["name"] = "Sweet Serenity";
      ["level"] = 60;
      ["name_es"] = "Dulce serenidad";
      ["req"] = 50;
   };
   [8901] = {
      ["name_ru"] = "Дорогая моя Эления!";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Carefully Written Letter to Elenia Haydon near the bank in the Undercity.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的艾琳娜";
      ["name_fr"] = "Tres chere Elenia,";
      ["name_de"] = "Liebste Elenia";
      ["faction"] = "Horde";
      ["name"] = "Dearest Elenia,";
      ["level"] = 70;
      ["name_es"] = "Queridisima Elenia:";
      ["req"] = 57;
   };
   [8933] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Lightforge Belt and a set of Lightforge Gauntlets to Deliana in Ironforge.$B";
      ["name_cn"] = "小小的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Paladin";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22086;
         [2] = 22090;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8965] = {
      ["name_ru"] = "Важная составляющая заклинания";
      ["type"] = "Group";
      ["name_fr"] = "Des composants importants";
      ["next"] = 8969;
      ["name_de"] = "Komponenten von groser Wichtigkeit";
      ["objective"] = "Obtain Soul Ashes of the Banished and return them to Bodley inside Blackrock Mountain.";
      ["name_cn"] = "重要的材料";
      ["sort"] = "Blackrock Mountain";
      ["faction"] = "Horde";
      ["name"] = "Components of Importance";
      ["followup"] = 8986;
      ["prev"] = 8961;
      ["prequests"] = {
         [1] = 8961;
      };
      ["level"] = 60;
      ["name_es"] = "Componentes importantes";
      ["req"] = 58;
   };
   [6547] = {
      ["name_ru"] = "Сведения разведчика клана Песни Войны";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Mise a jour de l'Eclaireur Chanteguerre";
      ["name_cn"] = "?歌斥候的?告";
      ["reward"] = {
         [1] = 16764;
      };
      ["name_de"] = "Aktualisierter Bericht des Spahers des Kriegshymnenklans";
      ["faction"] = "Horde";
      ["name"] = "Warsong Scout Update";
      ["level"] = 21;
      ["name_es"] = "Novedades de explorador Grito de Guerra";
      ["req"] = 17;
   };
   [6563] = {
      ["name_ru"] = "Сущность Аку'май";
      ["type"] = "Dungeon";
      ["name_fr"] = "L'Essence d'Aku'Mai";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_de"] = "Die Essenz von Aku'mai";
      ["name_cn"] = "阿?麦?水晶";
      ["name"] = "The Essence of Aku'Mai";
      ["objective"] = "Bring 20 Sapphires of Aku'Mai to Je'neu Sancrea in Ashenvale.";
      ["faction"] = "Horde";
      ["sort"] = "Blackfathom Deeps";
      ["prev"] = 6562;
      ["prequests"] = {
         [1] = 6562;
      };
      ["level"] = 22;
      ["name_es"] = "La esencia de Aku'Mai";
      ["req"] = 17;
   };
   [9061] = {
      ["name_ru"] = "Накулачники расхитителя гробниц";
      ["objective"] = "Huntsman Leopold at Light's Hope Chapel in the Eastern Plaguelands will make Cryptstalker Wristguards if you bring him the following: 1 Desecrated Wristguards, 6 Wartorn Chain Scraps, 1 Arcanite Bar and 2 Cured Rugged Hides.";
      ["name_cn"] = "地穴追?者腕甲";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-poignets de traqueur des cryptes";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handgelenksschutzer des Gruftpirschers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 22443;
      };
      ["name"] = "Cryptstalker Wristguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardamunecas de acechacriptas";
      ["req"] = 60;
   };
   [9093] = {
      ["name_ru"] = "Накулачники сновидца";
      ["objective"] = "Rayne at Light's Hope Chapel in the Eastern Plaguelands will make Dreamwalker Wristguards if you bring her the following: 1 Desecrated Wristguards, 6 Wartorn Leather Scraps, 1 Arcane Crystal and 2 Cured Rugged Hides.";
      ["name_cn"] = "梦游者腕甲";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les protege-poignets de marchereve";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Handgelenksschutzer des Traumwandlers";
      ["classes"] = {
         [1] = "Druid";
      };
      ["reward"] = {
         [1] = 22495;
      };
      ["name"] = "Dreamwalker Wristguards";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los guardamunecas Caminasuenos";
      ["req"] = 60;
   };
   [9125] = {
      ["name_ru"] = "Конечности и панцири некрорахнидов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Teile einer Gruftbestie";
      ["name_fr"] = "Des morceaux de demon des cryptes";
      ["name_cn"] = "地穴魔的碎?";
      ["faction"] = "Horde";
      ["name"] = "Crypt Fiend Parts";
      ["reward"] = {
         [1] = 22524;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9124;
      ["prequests"] = {
         [1] = 9124;
      };
      ["level"] = 60;
      ["name_es"] = "Trozos de maligno de cripta";
      ["req"] = 55;
   };
   [6627] = {
      ["name_ru"] = "Испытание знаний";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 1159;
      ["name_de"] = "Test der Lehre";
      ["name"] = "Test of Lore";
      ["name_cn"] = "知???";
      ["objective"] = "Answer Braug Dimspirit's question successfully and then speak to him again. He will remain in Stonetalon Mountains when you are ready.";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1154;
      ["prequests"] = {
         [1] = 1154;
      };
      ["level"] = 30;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [6643] = {
      ["name_ru"] = "Покровительство братства, огненное ядро";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["sort"] = "Molten Core";
      ["name_fr"] = "Faveur aupres de la Confrerie, Noyau de feu";
      ["name_cn"] = "兄弟会的好感 - ??之核";
      ["name_de"] = "Gunst der Bruderschaft, Feuerkern";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Brotherhood, Fiery Core";
      ["level"] = 60;
      ["name_es"] = "El favor de la Hermandad, nucleos igneos";
      ["req"] = 60;
   };
   [9221] = {
      ["name_ru"] = "Превосходное боевое снаряжениее ? Друг Рассвета";
      ["type"] = "Solo";
      ["objective"] = "For 30 Insignias of the Dawn and 30 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.$B";
      ["name_fr"] = "Armes de bataille excellentes - Ami de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "精良的作?装? - ?色黎明友善";
      ["reward"] = {
         [1] = 22681;
         [2] = 22680;
         [3] = 22688;
         [4] = 22679;
         [5] = 22690;
         [6] = 22689;
      };
      ["name_de"] = "Uberragende Kampfausrustung - Freund der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Superior Armaments of Battle - Friend of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento superior de batalla: amistoso con El Alba";
      ["req"] = 55;
   };
   [2138] = {
      ["name_ru"] = "Избавление от заразы";
      ["type"] = "Solo";
      ["name_fr"] = "Nettoyage de l'infection";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Ausrottung der Infizierten";
      ["name_cn"] = "清除疫病";
      ["name"] = "Cleansing of the Infected";
      ["objective"] = "Cleanse the forest of 20 Rabid Thistle Bears and return to Tharnariun Treetender in Darkshore.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 2118;
      ["prequests"] = {
         [1] = 2118;
      };
      ["level"] = 16;
      ["name_es"] = "La limpieza de la infeccion";
      ["req"] = 10;
   };
   [6681] = {
      ["name_ru"] = "Поместье, Черный Ворон";
      ["type"] = "Solo";
      ["objective"] = "Take the Seal of Ravenholdt to Fahrad at Ravenholdt Manor, hidden away in the hills of Hillsbrad.$B$BYour cunning will be tested along the way. Be prepared.";
      ["repgain"] = {
         [349] = 250;
      };
      ["name_fr"] = "Ravenholdt, le manoir";
      ["sort"] = "Rogue";
      ["name_cn"] = "拉文霍德庄?";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["followup"] = 6701;
      ["name_de"] = "Das Anwesen, Rabenholdt";
      ["faction"] = "Horde";
      ["name"] = "The Manor, Ravenholdt";
      ["level"] = 24;
      ["name_es"] = "Mansion Ravenholdt";
      ["req"] = 24;
   };
   [9317] = {
      ["name_ru"] = "Освященное точило";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_fr"] = "Pierre a aiguiser consacree";
      ["name_cn"] = "神?的磨刀石";
      ["reward"] = {
         [1] = 23122;
      };
      ["name_de"] = "Geweihte Wetzsteine";
      ["faction"] = "Horde";
      ["name"] = "Consecrated Sharpening Stones";
      ["level"] = 60;
      ["name_es"] = "Piedras de afilar consagradas";
      ["req"] = 58;
   };
   [3362] = {
      ["name_ru"] = "Долина Кактусов";
      ["type"] = "Solo";
      ["objective"] = "Tran'rek in Gadgetzan wants you to kill 8 Gnarled Thistleshrubs and 8 Thistleshrub Rootshapers.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "La vallee des Chardonniers";
      ["sort"] = "Tanaris";
      ["name_cn"] = "灌木谷";
      ["name_de"] = "Disteltal";
      ["faction"] = "Horde";
      ["name"] = "Thistleshrub Valley";
      ["level"] = 50;
      ["name_es"] = "El Valle Cardizal";
      ["req"] = 45;
   };
   [3370] = {
      ["name_ru"] = "Кошмары";
      ["type"] = "Solo";
      ["objective"] = "Bring the Nightmare Shard to Mathrengyl Bearwalker in Darnassus.";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Alptraum";
      ["reward"] = {
         [1] = 10657;
         [2] = 10658;
      };
      ["name_cn"] = "在?梦中";
      ["name_fr"] = "Au c?ur des cauchemars";
      ["faction"] = "Alliance";
      ["name"] = "In Nightmares";
      ["sort"] = "The Barrens";
      ["prev"] = 6981;
      ["prequests"] = {
         [1] = 6981;
      };
      ["level"] = 25;
      ["name_es"] = "En las pesadillas";
      ["req"] = 15;
   };
   [3378] = {
      ["name_ru"] = "Молитва Элуне";
      ["objective"] = "Find the Prayer to Elune and take it to Astarii Starseeker in Darnassus.$B";
      ["name_cn"] = "艾露恩祷言";
      ["sort"] = "Searing Gorge";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "Priere a Elune";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Gebet an Elune";
      ["reward"] = {
         [1] = 10745;
         [2] = 10746;
      };
      ["faction"] = "Alliance";
      ["name"] = "Prayer to Elune";
      ["prev"] = 3377;
      ["prequests"] = {
         [1] = 3377;
      };
      ["series"] = 2;
      ["name_es"] = "El rezo a Elune";
      ["req"] = 40;
   };
   [4722] = {
      ["name_ru"] = "Останки морской черепахи";
      ["type"] = "Solo";
      ["name_fr"] = "La tortue de mer echouee";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Gestrandete Meeresschildkrote";
      ["name_cn"] = "?浅的海?";
      ["name"] = "Beached Sea Turtle";
      ["objective"] = "Take the Sea Turtle Remains to Gwennyth Bly'Leggonde in Auberdine.";
      ["faction"] = "Alliance";
      ["sort"] = "Darkshore";
      ["prev"] = 4681;
      ["prequests"] = {
         [1] = 4681;
      };
      ["level"] = 13;
      ["name_es"] = "Tortuga marina varada";
      ["req"] = 11;
   };
   [2382] = {
      ["name_ru"] = "Реникс из Кабестана";
      ["type"] = "Solo";
      ["name_fr"] = "Wrenix de Cabestan";
      ["next"] = 2381;
      ["name_de"] = "Wrenix aus Ratschet";
      ["objective"] = "Travel to Ratchet and speak with Wrenix the Wretched.";
      ["name_cn"] = "棘?城的?尼克斯";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Horde";
      ["name"] = "Wrenix of Ratchet";
      ["prev"] = 2379;
      ["prequests"] = {
         [1] = 2379;
      };
      ["level"] = 16;
      ["name_es"] = "Desdio de Trinquete";
      ["req"] = 16;
   };
   [3402] = {
      ["name_ru"] = "Черный рынок";
      ["type"] = "Solo";
      ["objective"] = "Speak with Vizzklick in Gadgetzan.$B";
      ["name_de"] = "Der Untermarkt";
      ["name_fr"] = "Le Sous-marche";
      ["reward"] = {
         [1] = 10463;
      };
      ["name_cn"] = "黑市交易";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["name"] = "The Undermarket";
      ["sort"] = "Tailoring";
      ["prev"] = 3385;
      ["prequests"] = {
         [1] = 3385;
      };
      ["level"] = 50;
      ["name_es"] = "El Mercado Negro";
      ["req"] = 43;
   };
   [6001] = {
      ["name_ru"] = "Тело и дух";
      ["type"] = "Solo";
      ["name_fr"] = "Corps et c?ur";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Korper und Herz";
      ["objective"] = "Use the Cenarion Moondust on the Moonkin Stone of Auberdine to bring forth Lunaclaw.  From there, you must face Lunaclaw and earn the strength of body and heart it possesses.$B$BSpeak with Mathrengyl Bearwalker in Darnassus when you are done.";
      ["name_cn"] = "身心之力";
      ["sort"] = "Druid";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Body and Heart";
      ["races"] = {
         [1] = "NightElf";
      };
      ["prev"] = 5931;
      ["prequests"] = {
         [1] = 5931;
      };
      ["level"] = 10;
      ["name_es"] = "Cuerpo y corazon";
      ["req"] = 10;
   };
   [5001] = {
      ["name_ru"] = "Вещи Блестяшки";
      ["type"] = "Dungeon";
      ["objective"] = "Find Bijou's Belongings and return them to her. Good luck!$B";
      ["next"] = 5002;
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "比修的装置";
      ["name_fr"] = "Les effets de Bijou";
      ["name_de"] = "Bijous Habseligkeiten";
      ["faction"] = "Alliance";
      ["name"] = "Bijou's Belongings";
      ["level"] = 59;
      ["name_es"] = "Las pertenencias de Bijou";
      ["req"] = 55;
   };
   [4295] = {
      ["name_ru"] = "Эль для Камнеузла";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["sort"] = "Blackrock Depths";
      ["name_cn"] = "?克?特的麦酒";
      ["name_fr"] = "La biere de Rochenoeud";
      ["name_de"] = "Rocknots Bier";
      ["faction"] = "Horde";
      ["name"] = "Rocknot's Ale";
      ["level"] = 1;
      ["name_es"] = "La cerveza de Sinroca";
      ["req"] = 1;
   };
   [4882] = {
      ["name_ru"] = "Умение хранить секреты";
      ["type"] = "Solo";
      ["name_fr"] = "Secrets gardes";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Geheimnisse bewahren";
      ["name_cn"] = "守?秘密";
      ["objective"] = "Take the Blue-feathered Necklace to Trull Failbane at Bloodvenom Post.";
      ["next"] = 4883;
      ["sort"] = "Winterspring";
      ["name"] = "Guarding Secrets";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 59;
      ["name_es"] = "Guardar un secreto";
      ["req"] = 52;
   };
   [3442] = {
      ["name_ru"] = "Неугасимое пламя";
      ["type"] = "Solo";
      ["name_fr"] = "La flamme parfaite";
      ["next"] = 3443;
      ["name_de"] = "Die fehlerlose Flamme";
      ["name_cn"] = "无瑕之?";
      ["objective"] = "Collect 4 Hearts of Flame and 4 globes of Golem Oil and return the items to Kalaran Windblade.";
      ["sort"] = "Searing Gorge";
      ["faction"] = "Horde";
      ["name"] = "The Flawless Flame";
      ["prev"] = 3441;
      ["prequests"] = {
         [1] = 3441;
      };
      ["level"] = 48;
      ["name_es"] = "La llama pura";
      ["req"] = 40;
   };
   [3450] = {
      ["name_ru"] = "Легкая доставка";
      ["type"] = "Solo";
      ["name_fr"] = "Une collecte facile";
      ["next"] = 3451;
      ["name_de"] = "Eine einfache Ladung";
      ["name_cn"] = "??的接收任?";
      ["objective"] = "Speak to Xiggs Fuselighter in Ironforge.";
      ["sort"] = "Ironforge";
      ["faction"] = "Alliance";
      ["name"] = "An Easy Pickup";
      ["prev"] = 3448;
      ["prequests"] = {
         [1] = 3448;
      };
      ["level"] = 52;
      ["name_es"] = "Un simple envio";
      ["req"] = 45;
   };
   [9109] = {
      ["name_ru"] = "Пояс Проклятого Сердца";
      ["objective"] = "Mataus the Wrathcaster at Light's Hope Chapel in the Eastern Plaguelands will make a Plagueheart Belt if you bring him the following: 1 Desecrated Belt, 8 Wartorn Cloth Scraps, 2 Arcane Crystals and 2 Mooncloth.";
      ["name_cn"] = "瘟疫之心腰?";
      ["sort"] = "Naxxramas";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "La ceinture de pestecoeur";
      ["repgain"] = {
         [529] = 200;
      };
      ["name_de"] = "Gurtel des verseuchten Herzens";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 22510;
      };
      ["name"] = "Plagueheart Belt";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["faction"] = "Horde";
      ["name_es"] = "El cinturon corazon de la peste";
      ["req"] = 60;
   };
   [4970] = {
      ["name_ru"] = "Накормить ледопардов";
      ["type"] = "Solo";
      ["objective"] = "Collect 5 Shardtooth Meats and 5 Chillwind Meats for Rivern Frostwind in Winterspring.";
      ["repgain"] = {
         [589] = 50;
      };
      ["name_fr"] = "Provisions de sabres-de-givre";
      ["sort"] = "Winterspring";
      ["name_cn"] = "霜刃豹的食物";
      ["name_de"] = "Frostsablerverpflegung";
      ["faction"] = "Alliance";
      ["name"] = "Frostsaber Provisions";
      ["level"] = 60;
      ["name_es"] = "Provisiones de sable de hielo";
      ["req"] = 58;
   };
   [2522] = {
      ["name_ru"] = "Попытки Кум'иша";
      ["type"] = "Solo";
      ["name_fr"] = "Les efforts de Kum'isha";
      ["name_de"] = "Kum'ishas Bemuhungen";
      ["reward"] = {
         [1] = 10752;
      };
      ["name_cn"] = "?米沙的努力";
      ["objective"] = "Find and return a Flawless Draenethyst Sphere to Kum'isha the Collector.";
      ["faction"] = "Horde";
      ["name"] = "Kum'isha's Endeavors";
      ["sort"] = "Blasted Lands";
      ["prev"] = 2521;
      ["prequests"] = {
         [1] = 2521;
      };
      ["level"] = 55;
      ["name_es"] = "Los esfuerzos de Kum'isha";
      ["req"] = 45;
   };
   [6963] = {
      ["name_ru"] = "Пропавшее угощение Зимнего Покрова";
      ["type"] = "Solo";
      ["objective"] = "Locate the Smokywood Pastures investigator that has gone missing in the snowy regions of the Alterac Mountains.";
      ["next"] = 6983;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "被?走的冬幕?礼物";
      ["name_fr"] = "Friandises volees de la fete du Voile d'hiver";
      ["name_de"] = "Gestohlene Winterhauchleckereien";
      ["faction"] = "Horde";
      ["name"] = "Stolen Winter Veil Treats";
      ["level"] = 60;
      ["name_es"] = "El robo de las golosinas del Festival de Invierno";
      ["req"] = 30;
   };
   [1959] = {
      ["name_ru"] = "Задание Анастасии";
      ["type"] = "Solo";
      ["objective"] = "Speak with Anastasia Hartwell.";
      ["next"] = 1960;
      ["name_de"] = "Meldung bei Anastasia";
      ["sort"] = "Mage";
      ["name_cn"] = "向安娜斯塔西??告";
      ["name_fr"] = "Rendre compte a Anastasia";
      ["classes"] = {
         [1] = "Mage";
      };
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Report to Anastasia";
      ["level"] = 15;
      ["name_es"] = "Presentate ante Anastasia";
      ["req"] = 15;
   };
   [2966] = {
      ["name_ru"] = "Посмотрим, что будет дальше";
      ["type"] = "Group";
      ["name_fr"] = "Questions sans reponses";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Mal sehen, was passiert...";
      ["followup"] = 2954;
      ["name_cn"] = "拭目以待";
      ["objective"] = "Bring the miniature platinum discs to the gates of Uldum in Tanaris and look for clues as to the connection between the two.";
      ["faction"] = "Horde";
      ["name"] = "Seeing What Happens";
      ["sort"] = "Thunder Bluff";
      ["prev"] = 2965;
      ["prequests"] = {
         [1] = 2965;
      };
      ["level"] = 50;
      ["name_es"] = "A ver que pasa";
      ["req"] = 45;
   };
   [3506] = {
      ["name_ru"] = "Предательница";
      ["objective"] = "Destroy the arcane focusing crystal tied to Magus Rimtori and then slay her. Afterwards, take the Head of Magus Rimtori to Ag'tor Bloodfist in Azshara.";
      ["name_cn"] = "叛徒";
      ["sort"] = "Orgrimmar";
      ["level"] = 56;
      ["type"] = "Solo";
      ["name_fr"] = "Trahison";
      ["next"] = 3507;
      ["name_de"] = "Verraten";
      ["repgain"] = {
         [76] = 150;
      };
      ["faction"] = "Horde";
      ["name"] = "Betrayed";
      ["prev"] = 3505;
      ["prequests"] = {
         [1] = 3505;
      };
      ["series"] = 3;
      ["name_es"] = "Traicion";
      ["req"] = 44;
   };
   [3514] = {
      ["name_ru"] = "Мощь Орды";
      ["type"] = "Group";
      ["objective"] = "Kill the leader of the Talon Den, Rynthariel the Keymaster.";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Hordenprasenz";
      ["reward"] = {
         [1] = 10653;
         [2] = 10654;
      };
      ["name_cn"] = "部落的示威";
      ["name_fr"] = "Presence de la Horde";
      ["faction"] = "Horde";
      ["name"] = "Horde Presence";
      ["sort"] = "The Barrens";
      ["prev"] = 3513;
      ["prequests"] = {
         [1] = 3513;
      };
      ["level"] = 29;
      ["name_es"] = "La presencia de la Horda";
      ["req"] = 15;
   };
   [7043] = {
      ["name_ru"] = "Прохладное чувство юмора";
      ["type"] = "Group";
      ["name_fr"] = "La mechancete vous habite…";
      ["next"] = 7045;
      ["name_de"] = "So was Gemeines...";
      ["name_cn"] = "天寒地?";
      ["objective"] = " $N.  Be c-c-careful though!  He is t-t-the one who turned me into this s-s-snowy mess!$B$BYou're g-g-gonna need some help in f-f-facing him.  I've seen him w-w-wander all around where the y-y-yeti are; he's s-s-surely here s-s-somewhere!  F-f-find the treats $N";
      ["sort"] = "Hallow's End";
      ["faction"] = "Alliance";
      ["name"] = "You're a Mean One...";
      ["prev"] = 7042;
      ["prequests"] = {
         [1] = 7042;
      };
      ["level"] = 35;
      ["name_es"] = "!Que ruin!";
      ["req"] = 30;
   };
   [8465] = {
      ["name_ru"] = "Разговор с Сальфой";
      ["type"] = "Solo";
      ["name_fr"] = "Parler a Salfa";
      ["repgain"] = {
         [576] = 25;
      };
      ["name_de"] = "Sprecht mit Salfa";
      ["name_cn"] = "与??法交?";
      ["name"] = "Speak to Salfa";
      ["objective"] = "Travel through Timbermaw Hold and exit into Winterspring.  Speak with Salfa, who stands guard outside the entrance to Timbermaw Hold.";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 8461;
      ["prequests"] = {
         [1] = 8461;
      };
      ["level"] = 55;
      ["name_es"] = "Habla con Salfa";
      ["req"] = 45;
   };
   [8545] = {
      ["name_ru"] = "Орде не хватает мифриловых слитков!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Mithril Bars to Senior Sergeant T'kelah at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de barres de mithril?!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要秘??！";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["name_de"] = "Die Horde braucht Mithrilbarren!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Mithril Bars!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita barras de mitril!";
      ["req"] = 52;
   };
   [8379] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??之?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20707;
         [2] = 20717;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [5466] = {
      ["name_ru"] = "Рас Ледяной Шепот ? лич";
      ["type"] = "Dungeon";
      ["name_fr"] = "La Liche, Ras Murmegivre";
      ["name_de"] = "Der Lich Ras Frostraunen";
      ["reward"] = {
         [1] = 13982;
         [2] = 14002;
         [3] = 13986;
         [4] = 13984;
      };
      ["name_cn"] = "巫妖莱斯・霜?";
      ["objective"] = "Find Ras Frostwhisper in the Scholomance. When you have found him, use the Soulbound Keepsake on his undead visage. Should you succeed in reverting him to a mortal, strike him down and recover the Human Head of Ras Frostwhisper. Take the head back to Magistrate Marduke.";
      ["faction"] = "Horde";
      ["name"] = "The Lich, Ras Frostwhisper";
      ["sort"] = "Scholomance";
      ["prev"] = 5465;
      ["prequests"] = {
         [1] = 5465;
      };
      ["level"] = 60;
      ["name_es"] = "El exanime, Ras Murmuhielo";
      ["req"] = 57;
   };
   [7123] = {
      ["name_ru"] = "Разговор с интендантом";
      ["type"] = "PvP";
      ["objective"] = "Speak with the Frostwolf Quartermaster.";
      ["repgain"] = {
         [76] = 10;
         [729] = 10;
      };
      ["name_fr"] = "Parlez a notre Intendant";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "霜狼?需官";
      ["name_de"] = "Sprecht mit unserem Rustmeister";
      ["faction"] = "Horde";
      ["name"] = "Speak with our Quartermaster";
      ["level"] = 60;
      ["name_es"] = "Habla con nuestro intendente";
      ["req"] = 51;
   };
   [3570] = {
      ["name_ru"] = "Разносчик заразы";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Verbreitete Verderbnis";
      ["name_cn"] = "堕落之水";
      ["name_fr"] = "Corruption Suintante";
      ["name"] = "Seeping Corruption";
      ["faction"] = "Horde";
      ["sort"] = "Undercity";
      ["prev"] = 3569;
      ["prequests"] = {
         [1] = 3569;
      };
      ["level"] = 52;
      ["name_es"] = "La filtracion de la corrupcion";
      ["req"] = 45;
   };
   [5522] = {
      ["name_ru"] = "Леонид Барталомей";
      ["type"] = "Dungeon";
      ["name_fr"] = "Leonid Barthalomew";
      ["repgain"] = {
         [529] = 75;
      };
      ["name_de"] = "Leonidas Bartholomaus";
      ["name"] = "Leonid Barthalomew";
      ["name_cn"] = "莱尼德・巴??梅";
      ["objective"] = "Bring the Frozen Eggs to Leonid Barthalomew in the Eastern Plaguelands.";
      ["next"] = 5531;
      ["faction"] = "Horde";
      ["sort"] = "Burning Steppes";
      ["prev"] = 4734;
      ["prequests"] = {
         [1] = 4734;
      };
      ["level"] = 60;
      ["name_es"] = "Leonid Barthalomew";
      ["req"] = 57;
   };
   [7171] = {
      ["name_ru"] = "Легендарные герои";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Legendare Helden";
      ["name_fr"] = "Heros de legende";
      ["name_cn"] = "??的英雄";
      ["name"] = "Legendary Heroes";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 17903;
      };
      ["sort"] = "Alterac Valley";
      ["prev"] = 7170;
      ["prequests"] = {
         [1] = 7170;
      };
      ["level"] = 60;
      ["name_es"] = "Heroes legendarios";
      ["req"] = 51;
   };
   [1679] = {
      ["name_ru"] = "Марен Грозовая Вершина";
      ["type"] = "Solo";
      ["objective"] = "Speak with Muren Stormpike.";
      ["next"] = 1678;
      ["sort"] = "Warrior";
      ["name_cn"] = "穆?・雷矛";
      ["name_fr"] = "Muren Foudrepique";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Muren Sturmlanze";
      ["faction"] = "Alliance";
      ["name"] = "Muren Stormpike";
      ["level"] = 10;
      ["name_es"] = "Muren Pico Tormenta";
      ["req"] = 10;
   };
   [3602] = {
      ["name_ru"] = "Азшарит";
      ["type"] = "Group";
      ["name_fr"] = "Azsharite";
      ["name_de"] = "Azsharit";
      ["name_cn"] = "艾?拉水晶";
      ["objective"] = "Recover twenty Crystallized Azsharite from southern Azshara. You may use the Felhound to assist you in 'sniffing' out the location of cleverly hidden deposits.$B$BReturn to Loramus when the task is complete.$B";
      ["sort"] = "Azshara";
      ["faction"] = "Horde";
      ["name"] = "Azsharite";
      ["prev"] = 3511;
      ["prequests"] = {
         [1] = 3511;
      };
      ["level"] = 58;
      ["name_es"] = "Azsharita";
      ["req"] = 45;
   };
   [7649] = {
      ["name_ru"] = "\"Зачарованная ториевая броня\", том I";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Les plates en thorium enchante - Volume I";
      ["name_cn"] = "魔化瑟?板甲：第一卷";
      ["reward"] = {
         [1] = 12727;
      };
      ["name_de"] = "Verzauberter Thoriumplattenpanzer: Band I";
      ["faction"] = "Horde";
      ["name"] = "Enchanted Thorium Platemail: Volume I";
      ["level"] = 60;
      ["name_es"] = "Las mallas de placas en torio encantado: volumen I";
      ["req"] = 60;
   };
   [2822] = {
      ["name_ru"] = "Знак качества";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Thick Yeti Hides to Jangdor Swiftstrider in Camp Mojache.";
      ["repgain"] = {
         [81] = 250;
      };
      ["sort"] = "Feralas";
      ["name_fr"] = "La marque de la qualite";
      ["name_cn"] = "?量的保?";
      ["reward"] = {
         [1] = 9633;
         [2] = 9632;
      };
      ["name_de"] = "Das Zeichen der Qualitat";
      ["faction"] = "Horde";
      ["name"] = "The Mark of Quality";
      ["level"] = 46;
      ["name_es"] = "La marca de la calidad";
      ["req"] = 40;
   };
   [3626] = {
      ["name_ru"] = "Возвращение в Выжженные земли";
      ["type"] = "Solo";
      ["name_fr"] = "Retour aux Terres foudroyees";
      ["next"] = 3627;
      ["name_de"] = "Ruckkehr in die Verwusteten Lande";
      ["name_cn"] = "返回?咒之地";
      ["objective"] = "Return to the Fallen Hero of the Horde.";
      ["sort"] = "Stranglethorn Valley";
      ["faction"] = "Horde";
      ["name"] = "Return to the Blasted Lands";
      ["prev"] = 3625;
      ["prequests"] = {
         [1] = 3625;
      };
      ["level"] = 58;
      ["name_es"] = "Regresa a Las Tierras Devastadas";
      ["req"] = 45;
   };
   [3634] = {
      ["name_ru"] = "Гномское инженерное дело";
      ["type"] = "Solo";
      ["objective"] = "If you wish to learn more about Gnome Engineering, take the Manual of Engineering Disciplines to Tinkmaster Overspark in Ironforge.";
      ["sort"] = "Engineering";
      ["name_cn"] = "侏儒工程学";
      ["name_fr"] = "Ingenierie des gnomes";
      ["followup"] = 3640;
      ["name_de"] = "Gnomeningenieurskunst";
      ["faction"] = "Alliance";
      ["name"] = "Gnome Engineering";
      ["level"] = 47;
      ["name_es"] = "Ingenieria gnomica";
      ["req"] = 30;
   };
   [3642] = {
      ["name_ru"] = "Договор о неразглашении";
      ["type"] = "Solo";
      ["objective"] = "If you agree to become a Gnome Engineer, then right-click on the Pledge of Secrecy and speak once more with Oglethrope Obnoticus in Booty bay.";
      ["next"] = 3643;
      ["name_fr"] = "Le V?u du secret";
      ["sort"] = "Engineering";
      ["name_cn"] = "保密??";
      ["name"] = "The Pledge of Secrecy";
      ["name_de"] = "Der Schwur der Geheimhaltung";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 3635;
         [2] = 3637;
      };
      ["level"] = 47;
      ["name_es"] = "La promesa del secreto";
      ["req"] = 30;
   };
   [5722] = {
      ["name_ru"] = "В поисках потерянного ранца";
      ["type"] = "Dungeon";
      ["objective"] = "Search Ragefire Chasm for Maur Grimtotem's corpse and search it for any items of interest.";
      ["next"] = 5724;
      ["sort"] = "Ragefire Chasm";
      ["name_cn"] = "?找背包";
      ["name_fr"] = "A la recherche de la sacoche perdue";
      ["name_de"] = "Die Suche nach dem verloren gegangenen Ranzen";
      ["faction"] = "Horde";
      ["name"] = "Searching for the Lost Satchel";
      ["level"] = 16;
      ["name_es"] = "Buscando la cartera perdida";
      ["req"] = 9;
   };
   [2882] = {
      ["name_ru"] = "Золото Куэрго";
      ["type"] = "Solo";
      ["objective"] = "Find Cuergo's gold!";
      ["name_fr"] = "L'or de Cuergo";
      ["sort"] = "Treasure Map";
      ["name_cn"] = "科?戈的黄金";
      ["reward"] = {
         [1] = 9265;
      };
      ["name_de"] = "Cuergos Gold";
      ["faction"] = "Horde";
      ["name"] = "Cuergo's Gold";
      ["level"] = 45;
      ["name_es"] = "El oro de Cuergo";
      ["req"] = 40;
   };
   [7841] = {
      ["name_ru"] = "Послание клану Громового Молота";
      ["type"] = "PvP";
      ["objective"] = "Otho Moji'ko at Revantusk Village in the Hinterlands wants you to slaughter 15 Highvale Outrunners, 15 Highvale Scouts, 15 Highvale Marksman and 15 Highvale Rangers. Return to him when this task is complete.$B$BYou can find the Highvale high elves at the Quel'Danil Lodge in the northwestern region of the Hinterlands.";
      ["next"] = 7842;
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "?蛮?部族的警告";
      ["name_fr"] = "Un message pour les Marteaux-hardis";
      ["name_de"] = "Eine Botschaft an die Wildhammer";
      ["faction"] = "Horde";
      ["name"] = "Message to the Wildhammer";
      ["level"] = 48;
      ["name_es"] = "Un mensaje para los Martillo Salvaje";
      ["req"] = 44;
   };
   [2902] = {
      ["name_ru"] = "Разведка планов Древолапов";
      ["type"] = "Solo";
      ["name_fr"] = "Enquete chez les Griffebois";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Waldpfotennachforschung";
      ["name"] = "Woodpaw Investigation";
      ["name_cn"] = "??木爪?";
      ["objective"] = "Find the gnoll battle plans somewhere in the gnoll camps to the south of Camp Mojache.";
      ["next"] = 2903;
      ["faction"] = "Horde";
      ["sort"] = "Feralas";
      ["prev"] = 2863;
      ["prequests"] = {
         [1] = 2863;
      };
      ["level"] = 43;
      ["name_es"] = "Investiga a los Zarpalena";
      ["req"] = 39;
   };
   [7363] = {
      ["name_ru"] = "Человечья жизнь";
      ["type"] = "PvP";
      ["objective"] = "You have been tasked with slaying opposing human players in Alterac Valley.$B$BKill a human and return to Commander Louis Philips (who wanders between the front lines and Frostwolf keep) with a  Human Bone Chip.$B$BA cure for the human condition is close at hand!";
      ["name_cn"] = "人?的病?";
      ["sort"] = "Alterac Valley";
      ["name_de"] = "Die menschliche Existenz";
      ["faction"] = "Horde";
      ["name"] = "The Human Condition";
      ["level"] = 60;
      ["name_es"] = "La condicion humana";
      ["req"] = 51;
   };
   [6365] = {
      ["name_ru"] = "Мясные продукты в Оргриммар";
      ["type"] = "Solo";
      ["name_fr"] = "De la viande pour Orgrimmar";
      ["repgain"] = {
         [530] = 25;
         [76] = 25;
      };
      ["name_cn"] = "送往奥格瑞?的肉";
      ["name_de"] = "Fleisch fur Orgrimmar";
      ["objective"] = "Bring Zargh's Meats to Devrak in the Crossroads.";
      ["next"] = 6384;
      ["name"] = "Meats to Orgrimmar";
      ["sort"] = "The Barrens";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 10;
      ["name_es"] = "Entrega de carne a Orgrimmar";
      ["req"] = 10;
   };
   [6568] = {
      ["name_ru"] = "Мастерица обмана";
      ["type"] = "Solo";
      ["name_fr"] = "Maitresse en tromperie";
      ["next"] = 6569;
      ["name_de"] = "Meisterin der Illusionen";
      ["name_cn"] = "幻?的欺?";
      ["objective"] = "Deliver Rexxar's Letter to Myranda the Hag in the Western Plaguelands.";
      ["sort"] = "Desolace";
      ["faction"] = "Horde";
      ["name"] = "The Testament of Rexxar";
      ["prev"] = 6567;
      ["prequests"] = {
         [1] = 6567;
      };
      ["level"] = 60;
      ["name_es"] = "Profesora del engano";
      ["req"] = 55;
   };
   [5922] = {
      ["name_ru"] = "Лунная поляна";
      ["type"] = "Solo";
      ["objective"] = "Use the spell Teleport: Moonglade\" to travel to Moonglade.  When you arrive";
      ["next"] = 5930;
      ["name_de"] = "Mondlichtung";
      ["sort"] = "Druid";
      ["name_cn"] = "月光林地";
      ["name_fr"] = "Reflet-de-Lune";
      ["classes"] = {
         [1] = "Druid";
      };
      ["followup"] = 5930;
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "Moonglade";
      ["level"] = 10;
      ["name_es"] = "Claro de la Luna";
      ["req"] = 10;
   };
   [7427] = {
      ["name_ru"] = "Разыскивается: БОЛЬШЕ ДВОРФОВ!";
      ["type"] = "PvP";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "通?：更多矮人！";
      ["name"] = "Wanted: MORE DWARVES!";
      ["name_de"] = "GESUCHT: MEHR ZWERGE";
      ["prev"] = 7401;
      ["prequests"] = {
         [1] = 7401;
      };
      ["level"] = 60;
      ["name_es"] = "Se buscan: !MAS ENANOS!";
      ["req"] = 55;
   };
   [6066] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Yaw Sharpmane in Bloodhoof Village.";
      ["next"] = 6061;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6082] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame an Armored Scorpid. Practice your skills, then return to Thotar at Razor Hill.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6081;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6083;
      ["prequests"] = {
         [1] = 6083;
      };
      ["series"] = 3;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [8194] = {
      ["name_ru"] = "Начинающий рыболов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Fishing";
      ["name_cn"] = "??学徒";
      ["name_fr"] = "Apprenti pecheur";
      ["name_de"] = "Anglerlehrling";
      ["faction"] = "Horde";
      ["name"] = "Apprentice Angler";
      ["level"] = 0;
      ["name_es"] = "Aprendiz pescador";
      ["req"] = 10;
   };
   [7491] = {
      ["name_ru"] = "На виду у всех";
      ["type"] = "Solo";
      ["objective"] = "Seek out Overlord Runthak in the Valley of Strength.";
      ["repgain"] = {
         [76] = 500;
      };
      ["name_de"] = "Fur alle sichtbar";
      ["reward"] = {
         [1] = 18406;
         [2] = 18403;
         [3] = 18404;
      };
      ["name_cn"] = "万?敬仰";
      ["name_fr"] = "Pour que tous voient";
      ["faction"] = "Horde";
      ["name"] = "For All To See";
      ["sort"] = "Orgrimmar";
      ["prev"] = 7490;
      ["prequests"] = {
         [1] = 7490;
      };
      ["level"] = 60;
      ["name_es"] = "Para que todos lo vean";
      ["req"] = 60;
   };
   [7507] = {
      ["name_ru"] = "Справочник Форора";
      ["type"] = "Dungeon";
      ["objective"] = "Return Foror's Compendium of Dragon Slaying to the Athenaeum.";
      ["repgain"] = {
         [809] = 200;
      };
      ["name_fr"] = "Le guide de Dagharn";
      ["sort"] = "Dire Maul";
      ["name_cn"] = "弗洛?的屠?技??要";
      ["name_de"] = "Forors Kompendium";
      ["faction"] = "Horde";
      ["name"] = "Foror's Compendium";
      ["level"] = 60;
      ["name_es"] = "Compendio de Foror";
      ["req"] = 60;
   };
   [3762] = {
      ["name_ru"] = "Помощь верховному друиду Руническому Тотему";
      ["type"] = "Solo";
      ["objective"] = "Speak with Arch Druid Hamuul Runetotem in Thunder Bluff.";
      ["next"] = 3761;
      ["sort"] = "Thunder Bluff";
      ["name_cn"] = "?助大德?伊";
      ["name_fr"] = "L'aide a l'archidruide Totem-runique";
      ["name_de"] = "Erzdruide Runentotem helfen";
      ["faction"] = "Horde";
      ["name"] = "Assisting Arch Druid Runetotem";
      ["level"] = 50;
      ["name_es"] = "Ayuda al archidruida Totem de Runa";
      ["req"] = 47;
   };
   [8370] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 100;
      };
      ["name_fr"] = "La conquete du bassin d'Arathi";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "征服阿拉希盆地";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["level"] = 29;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8402] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 100;
      };
      ["name_fr"] = "La lutte pour le goulet des Chanteguerres";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["level"] = 59;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 50;
   };
   [3786] = {
      ["name_ru"] = "Изучение рассветницы";
      ["objective"] = "Use an Evergreen Pouch with a Packet of Tharlendis Seeds and two Un'Goro Soil samples to try and cultivate samples of Morrowgrain.$B$BBring 10 Morrowgrain to Bashana Runetotem in Thunder Bluff.";
      ["name_cn"] = "晨光麦研究";
      ["sort"] = "Thunder Bluff";
      ["level"] = 50;
      ["type"] = "Solo";
      ["name_fr"] = "Recherches sur la Fibre d'aurore";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Morgenkornforschung";
      ["followup"] = 3804;
      ["reward"] = {
         [1] = 11887;
      };
      ["faction"] = "Horde";
      ["name"] = "Morrowgrain Research";
      ["prev"] = 3782;
      ["prequests"] = {
         [1] = 3782;
      };
      ["series"] = 2;
      ["name_es"] = "Investigar la managrana";
      ["req"] = 47;
   };
   [3130] = {
      ["name_ru"] = "Борьба с Гребнем Ненависти";
      ["objective"] = "Report to Latronicus Moonspear in Feathermoon Stronghold.";
      ["name_cn"] = "憎世?迦之?";
      ["sort"] = "Feralas";
      ["level"] = 43;
      ["type"] = "Solo";
      ["name_fr"] = "Contre les Hainecrete";
      ["next"] = 2869;
      ["name_de"] = "Gegen die Hasskamme";
      ["repgain"] = {
         [69] = 25;
      };
      ["faction"] = "Alliance";
      ["name"] = "Against the Hatecrest";
      ["prev"] = 2867;
      ["prequests"] = {
         [1] = 2867;
      };
      ["series"] = 1;
      ["name_es"] = "En contra de los Crestafuria";
      ["req"] = 40;
   };
   [7603] = {
      ["name_ru"] = "Огненное ядро Крошиуса";
      ["type"] = "Group";
      ["name_fr"] = "Le noyau infernal de Kroshius";
      ["name_de"] = "Kroshius Hollenbestienkern";
      ["objective"] = "Search Shatter Scar Vale in Felwood for the remains of Kroshius. When you locate the remains, use the Fel Fire near them and await Kroshius' return. When the infernal has awoken, slay him and take from his corpse Kroshius' Infernal Core.$B$BReturn Kroshius' Infernal Core to Niby the Almighty in Felwood.";
      ["reward"] = {
         [1] = 18762;
      };
      ["name_cn"] = "克??斯的?魔之核";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Kroshius' Infernal Core";
      ["sort"] = "Warlock";
      ["prev"] = 7602;
      ["prequests"] = {
         [1] = 7602;
      };
      ["level"] = 55;
      ["name_es"] = "El nucleo infernal de Kroshius";
      ["req"] = 50;
   };
   [8466] = {
      ["name_ru"] = "Перья для Гразла";
      ["type"] = "Solo";
      ["objective"] = "Some of the Deadwood furbolgs wear a distinctive headdress that may be used as a means of proof in thinning their numbers. Bring me a feather from any headdresses you acquire; for every set of five you bring me, you will earn recognition amongst the Timbermaw.";
      ["repgain"] = {
         [576] = 75;
      };
      ["name_de"] = "Federn fur Grazle";
      ["name_cn"] = "?格拉?的羽毛";
      ["name_fr"] = "Des plumes pour Grifleur";
      ["name"] = "Feathers for Grazle";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 8460;
      ["prequests"] = {
         [1] = 8460;
      };
      ["level"] = 55;
      ["name_es"] = "Plumas para Grazle";
      ["req"] = 45;
   };
   [7635] = {
      ["name_ru"] = "Подходящая тетива";
      ["type"] = "Raid";
      ["name_fr"] = "La bonne corde";
      ["name_de"] = "Die passende Sehne";
      ["objective"] = "Stoma the Ancient has asked that you bring him a Mature Black Dragon Sinew. Should you find this sinew, return it to Stoma in Felwood.";
      ["reward"] = {
         [1] = 18724;
      };
      ["name_cn"] = "合?的弓弦";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "A Proper String";
      ["sort"] = "Hunter";
      ["prev"] = 7632;
      ["prequests"] = {
         [1] = 7632;
      };
      ["level"] = 60;
      ["name_es"] = "La cuerda adecuada";
      ["req"] = 60;
   };
   [7651] = {
      ["name_ru"] = "\"Зачарованная ториевая броня\", том III";
      ["type"] = "Dungeon";
      ["objective"] = "Return the book to its rightful owners.";
      ["repgain"] = {
         [809] = 500;
      };
      ["sort"] = "Blacksmithing";
      ["name_fr"] = "Les plates en thorium enchante - Volume III";
      ["name_cn"] = "魔化瑟?板甲第三卷";
      ["reward"] = {
         [1] = 12725;
      };
      ["name_de"] = "Verzauberter Thoriumplattenpanzer: Band III";
      ["faction"] = "Horde";
      ["name"] = "Enchanted Thorium Platemail: Volume III";
      ["level"] = 60;
      ["name_es"] = "Las mallas de placas en torio encantado: volumen III";
      ["req"] = 55;
   };
   [7667] = {
      ["name_ru"] = "Существенная помощь";
      ["type"] = "Solo";
      ["objective"] = "If you are interested in helping Sagorne Crestrider in Orgrimmar's Valley of Wisdom, bring him an Azerothian Diamond and a Pristine Black Diamond.";
      ["next"] = 8258;
      ["name_fr"] = "Assistance materielle";
      ["sort"] = "Shaman";
      ["name_cn"] = "收集材料";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["repgain"] = {
         [76] = 350;
         [68] = 350;
         [81] = 350;
         [530] = 350;
      };
      ["name_de"] = "Materielle Unterstutzung";
      ["faction"] = "Horde";
      ["name"] = "Material Assistance";
      ["level"] = 60;
      ["name_es"] = "Asistencia material";
      ["req"] = 58;
   };
   [3842] = {
      ["name_ru"] = "Инкубатор";
      ["type"] = "Solo";
      ["name_fr"] = "Une courte incubation";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Kurz vor dem Schlupfen";
      ["name_cn"] = "即将孵化";
      ["name"] = "A Short Incubation";
      ["objective"] = "Bring 2 Elixir of Fortitudes to Quentin in Thousand Needles.";
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 3841;
      ["prequests"] = {
         [1] = 3841;
      };
      ["level"] = 47;
      ["name_es"] = "Una corta incubacion";
      ["req"] = 38;
   };
   [5165] = {
      ["name_ru"] = "Погасить Пламя Защиты";
      ["type"] = "Solo";
      ["name_fr"] = "Eteindre les flammes de protection";
      ["name_de"] = "Ubergiesen der Flammen des Schutzes";
      ["name_cn"] = "熄?火?";
      ["objective"] = "Using the Purified Moon Well Water, douse the flames of the four braziers of protection within Shadow Hold in Felwood, then return to Greta Mosshoof in the Emerald Sanctuary.";
      ["sort"] = "Felwood";
      ["faction"] = "Horde";
      ["name"] = "Dousing the Flames of Protection";
      ["prev"] = 5159;
      ["prequests"] = {
         [1] = 5159;
      };
      ["level"] = 55;
      ["name_es"] = "Sofocar las llamas de proteccion";
      ["req"] = 48;
   };
   [8658] = {
      ["name_ru"] = "Поножи Бойца";
      ["objective"] = "Bring the Skin of the Great Sandworm, 2 Idols of the Sun, 5 Silver Scarabs and 5 Bone Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "攻?者的?腿";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les jambieres du Frappeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Gamaschen des Hetzers";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 21368;
      };
      ["name"] = "Striker's Leggings";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Horde";
      ["name_es"] = "Los leotardos de asediador";
      ["req"] = 60;
   };
   [7731] = {
      ["name_ru"] = "Жалохвост";
      ["type"] = "Solo";
      ["name_fr"] = "Fouet-cuisant";
      ["repgain"] = {
         [76] = 350;
         [68] = 350;
         [81] = 350;
         [530] = 350;
      };
      ["name_de"] = "Zornstachel";
      ["followup"] = 7732;
      ["name_cn"] = "毒刺鞭笞者";
      ["objective"] = "Defeat Stinglasher in the Writhing Deep, bringing its glands back to Hadoken Swiftstrider at Camp Mojache, Feralas.";
      ["faction"] = "Horde";
      ["name"] = "Stinglasher";
      ["sort"] = "Feralas";
      ["prev"] = 2903;
      ["prequests"] = {
         [1] = 2903;
      };
      ["level"] = 47;
      ["name_es"] = "Latigador con aguijon";
      ["req"] = 39;
   };
   [8386] = {
      ["name_ru"] = "Битва за Ущелье Песни Войны";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Warsong Gulch Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [890] = 50;
      };
      ["name_cn"] = "?歌峡谷之?";
      ["name_de"] = "Kampf um die Kriegshymnenschlucht";
      ["sort"] = "Warsong Gulch";
      ["faction"] = "Alliance";
      ["name"] = "Fight for Warsong Gulch";
      ["prev"] = 8372;
      ["prequests"] = {
         [1] = 8372;
      };
      ["level"] = 19;
      ["name_es"] = "Lucha por Garganta Grito de Guerra";
      ["req"] = 10;
   };
   [3882] = {
      ["name_ru"] = "Игра в кости";
      ["type"] = "Solo";
      ["objective"] = "Bring 8 Dinosaur Bones to Spark Nilminer in Un'Goro Crater.";
      ["name_fr"] = "Faites rouler les os";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "?骨?";
      ["reward"] = {
         [1] = 11908;
         [2] = 11909;
      };
      ["name_de"] = "Knochenklappern";
      ["faction"] = "Horde";
      ["name"] = "Roll the Bones";
      ["level"] = 51;
      ["name_es"] = "Choca esos huesos";
      ["req"] = 49;
   };
   [8738] = {
      ["name_ru"] = "Донесение разведчика из Улья Регал";
      ["type"] = "Group";
      ["objective"] = "Contact Cenarion Scout Landion inside Hive'Regal and return the Hive'Regal Scout Report to Windcaller Proudhorn at Cenarion Hold.  You must also bring Tactical Task Briefing VII in order to complete this quest.";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Rapport de reconnaissance de la Ruche'Regal";
      ["name_cn"] = "雷戈虫????告";
      ["reward"] = {
         [1] = 20801;
         [2] = 21133;
      };
      ["name_de"] = "Spaherbericht des Regalschwarms";
      ["faction"] = "Horde";
      ["name"] = "Hive'Regal Scout Report";
      ["level"] = 60;
      ["name_es"] = "Informe de exploracion de Colmen'Regal";
      ["req"] = 60;
   };
   [7795] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [72] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Stormwind City";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 7794;
         [2] = 7791;
         [3] = 7793;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [7811] = {
      ["name_ru"] = "Пожертвование ? руническая ткань";
      ["type"] = "Solo";
      ["name_fr"] = "Un don d'etoffe runique";
      ["repgain"] = {
         [54] = 150;
      };
      ["name_cn"] = "捐献符文布";
      ["sort"] = "Ironforge";
      ["objective"] = "";
      ["name"] = "A Donation of Runecloth";
      ["name_de"] = "Spendet Runenstoff";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 7807;
         [2] = 7808;
         [3] = 7809;
      };
      ["level"] = 60;
      ["name_es"] = "Un donativo de pano runico";
      ["req"] = 50;
   };
   [3914] = {
      ["name_ru"] = "Меч Линкена";
      ["type"] = "Solo";
      ["name_fr"] = "L'epee de Linken";
      ["next"] = 3941;
      ["name_de"] = "Linkens Schwert";
      ["name_cn"] = "林克的?";
      ["objective"] = "Deliver Linken's Superior Sword to Linken in Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["faction"] = "Horde";
      ["name"] = "Linken's Sword";
      ["prev"] = 3913;
      ["prequests"] = {
         [1] = 3913;
      };
      ["level"] = 52;
      ["name_es"] = "La Espada de Linken";
      ["req"] = 47;
   };
   [3922] = {
      ["name_ru"] = "Металлические заготовки";
      ["type"] = "Solo";
      ["name_fr"] = "Les Petites pieces";
      ["repgain"] = {
         [470] = 250;
         [530] = 75;
         [81] = 75;
         [76] = 75;
      };
      ["name_de"] = "Schraubnieten";
      ["name_cn"] = "高?度??";
      ["name"] = "Nugget Slugs";
      ["objective"] = "Bring 15 Nugget Slugs to Wenikee Boltbucket in the Barrens.";
      ["faction"] = "Horde";
      ["sort"] = "The Barrens";
      ["prev"] = 3921;
      ["prequests"] = {
         [1] = 3921;
      };
      ["level"] = 15;
      ["name_es"] = "Engranajes";
      ["req"] = 10;
   };
   [4403] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [7875] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_fr"] = "Ecrasez les usurpateurs d'Aile-argent";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 45;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 40;
   };
   [7891] = {
      ["name_ru"] = "Зеленые железные наручи";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [909] = 250;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Bracelets en fer emeraude";
      ["name_cn"] = "???腕";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Grune Eisenarmschienen";
      ["faction"] = "Horde";
      ["name"] = "Green Iron Bracers";
      ["level"] = 60;
      ["name_es"] = "Brazales de hierro verdes";
      ["req"] = 20;
   };
   [7907] = {
      ["name_ru"] = "Колода карт Новолуния: Звери";
      ["type"] = "Solo";
      ["objective"] = " so you will have to wait until they are here next.\"";
      ["repgain"] = {
         [909] = 150;
      };
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Suite de Fauves de Sombrelune";
      ["name_cn"] = "暗月野?套牌";
      ["reward"] = {
         [1] = 19288;
      };
      ["name_de"] = "Bestienkartenset des Dunkelmond-Jahrmarkts";
      ["faction"] = "Horde";
      ["name"] = "Darkmoon Beast Deck";
      ["level"] = 55;
      ["name_es"] = "La baraja de Bestias de la Luna Negra";
      ["req"] = 1;
   };
   [7923] = {
      ["name_ru"] = "Почетный знак";
      ["type"] = "PvP";
      ["name_fr"] = "Marque d'honneur";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "?誉?章";
      ["objective"] = "You obtained a Warsong Mark of Honor for your last task, talk to me again, and you gain your reward.";
      ["faction"] = "Horde";
      ["name"] = "Mark of Honor";
      ["name_de"] = "Ehrenabzeichen";
      ["prev"] = 7875;
      ["prequests"] = {
         [1] = 7875;
      };
      ["level"] = 45;
      ["name_es"] = "Marca de Honor";
      ["req"] = 40;
   };
   [7939] = {
      ["name_ru"] = "Обмен: увесистые точильные камни";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Darkmoon Faire";
      ["name_fr"] = "Plus de silex a aiguiser denses";
      ["name_cn"] = "更多致密砂?";
      ["reward"] = {
         [1] = 19182;
      };
      ["name_de"] = "Mehr verdichtete Schleifsteine";
      ["faction"] = "Horde";
      ["name"] = "More Dense Grinding Stones";
      ["level"] = 60;
      ["name_es"] = "Mas piedras de pulir densas";
      ["req"] = 40;
   };
   [8930] = {
      ["name_ru"] = "В поисках Антиона";
      ["type"] = "Solo";
      ["objective"] = "Use the Extra-Dimensional Ghost Revealer at the entrance to Stratholme and speak with the ghost of Anthion Harmon.";
      ["next"] = 8945;
      ["name_fr"] = "A la recherche d'Anthion";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "?找安泰恩";
      ["name"] = "In Search of Anthion";
      ["followup"] = 8945;
      ["name_de"] = "Suche nach Anthion";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8938;
         [2] = 8939;
         [3] = 8940;
         [4] = 8941;
         [5] = 8942;
         [6] = 8943;
         [7] = 8944;
         [8] = 8927;
      };
      ["level"] = 60;
      ["name_es"] = "Buscando a Anthion";
      ["req"] = 58;
   };
   [4491] = {
      ["name_ru"] = "Дружеская помощь";
      ["type"] = "Solo";
      ["name_fr"] = "Un peu d'aide de mes amis";
      ["name_de"] = "Etwas Hilfe von guten Freunden";
      ["reward"] = {
         [1] = 11910;
         [2] = 11911;
         [3] = 11913;
      };
      ["name_cn"] = "朋友的?助";
      ["objective"] = "Lead Ringo to Spraggle Frock at Marshal's Refuge.$B$BIf Ringo faints, use Spraggle's Canteen to revive him.";
      ["faction"] = "Horde";
      ["name"] = "A Little Help From My Friends";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4492;
      ["prequests"] = {
         [1] = 4492;
      };
      ["level"] = 55;
      ["name_es"] = "Un poco de ayuda de mis amigos";
      ["req"] = 50;
   };
   [6570] = {
      ["name_ru"] = "Огнебор";
      ["type"] = "Group";
      ["name_fr"] = "Brandeguerre";
      ["name_de"] = "Aschenschwinge";
      ["name_cn"] = "埃博斯塔夫";
      ["objective"] = "Travel to the Wyrmbog in Dustwallow Marsh and seek out Emberstrife's Den. Once inside, wear the Amulet of Draconic Subversion and speak with Emberstrife.$B";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "Emberstrife";
      ["prev"] = 6569;
      ["prequests"] = {
         [1] = 6569;
      };
      ["level"] = 60;
      ["name_es"] = "Brasaliza";
      ["req"] = 55;
   };
   [4002] = {
      ["name_ru"] = "Восточные королевства";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les Royaumes de l'est";
      ["next"] = 4003;
      ["name_de"] = "Die Ostlichen Konigreiche";
      ["name_cn"] = "?部王国";
      ["objective"] = "Speak with Thrall if you are prepared to take on the mission he has planned.";
      ["sort"] = "Blackrock Depths";
      ["faction"] = "Horde";
      ["name"] = "The Eastern Kingdom";
      ["prev"] = 4001;
      ["prequests"] = {
         [1] = 4001;
      };
      ["level"] = 54;
      ["name_es"] = "Los Reinos del Este";
      ["req"] = 48;
   };
   [4765] = {
      ["name_ru"] = "Доставить Риджвеллу";
      ["type"] = "Solo";
      ["objective"] = "Bring Ridgewell's Crate to Remington Ridgewell in Stormwind.";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_de"] = "Lieferung an Kronenbrunn";
      ["reward"] = {
         [1] = 15861;
         [2] = 15860;
      };
      ["name_cn"] = "瑞治??的箱子";
      ["name_fr"] = "La livraison a Ridgewell";
      ["faction"] = "Alliance";
      ["name"] = "Delivery to Ridgewell";
      ["sort"] = "Blackrock Spire";
      ["prev"] = 4764;
      ["prequests"] = {
         [1] = 4764;
      };
      ["level"] = 60;
      ["name_es"] = "Entrega a Bonacresta";
      ["req"] = 57;
   };
   [9122] = {
      ["name_ru"] = "Цитадель ужаса ? Наксрамас";
      ["type"] = "Solo";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands wants 2 Arcane Crystals, 1 Nexus Crystal and 30 gold pieces. You must also be Revered with the Argent Dawn.";
      ["repgain"] = {
         [529] = 500;
      };
      ["name_fr"] = "Naxxramas, la citadelle de l'effroi";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "恐怖之城，?克??斯";
      ["followup"] = 9033;
      ["name_de"] = "Die Zitadelle des Schreckens - Naxxramas";
      ["faction"] = "Horde";
      ["name"] = "The Dread Citadel - Naxxramas";
      ["level"] = 60;
      ["name_es"] = "La ciudadela del terror: Naxxramas";
      ["req"] = 60;
   };
   [8051] = {
      ["name_ru"] = "Око Зулдазара";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Das Auge von Zuldazar";
      ["name_fr"] = "L'?il de Zuldazar";
      ["name"] = "The Eye of Zuldazar";
      ["name_cn"] = "祖??之眼";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Priest";
      };
      ["reward"] = {
         [1] = 19593;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8050;
      ["prequests"] = {
         [1] = 8050;
      };
      ["level"] = 60;
      ["name_es"] = "El ojo de Zuldazar";
      ["req"] = 60;
   };
   [8067] = {
      ["name_ru"] = "Знаки Силы: оплечье хищника";
      ["type"] = "Raid";
      ["objective"] = "Bring the following Paragons of Power from Zul'Gurub to Falthir the Sightless: A Primal Hakkari Aegis.  You must also have a reputation equal to or greater than Revered with the Zandalar Tribe.$B$BFalthir the Sightless is located on Yojamba Isle, Stranglethorn Vale.";
      ["name_fr"] = "Parangons de puissance?: le mantelet de predateur";
      ["sort"] = "Zul'Gurub";
      ["name_cn"] = "?力珍宝：捕?者?肩";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19831;
      };
      ["name_de"] = "Symbole der Macht: Der Mantel des Raubtiers";
      ["faction"] = "Horde";
      ["name"] = "Paragons of Power: The Predator's Mantle";
      ["level"] = 60;
      ["name_es"] = "Dechados de Poder: el Manto de depredador";
      ["req"] = 60;
   };
   [1473] = {
      ["name_ru"] = "Создание Бездны";
      ["type"] = "Solo";
      ["name_fr"] = "La creature du Vide";
      ["next"] = 1471;
      ["name_de"] = "Kreatur der Leere";
      ["name_cn"] = "虚空中的生物";
      ["objective"] = "Recover Egalin's Grimoire and bring it to Carendin Halgar in the Temple of the Damned.";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["sort"] = "Warlock";
      ["races"] = {
         [1] = "Undead";
      };
      ["name"] = "Creature of the Void";
      ["prequests"] = {
         [1] = 1478;
      };
      ["level"] = 10;
      ["name_es"] = "Criatura Abisal";
      ["req"] = 10;
   };
   [9266] = {
      ["name_ru"] = "Восстановление добрых отношений";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [21] = 250;
         [369] = 250;
         [577] = 500;
         [470] = 250;
      };
      ["sort"] = "Winterspring";
      ["name_fr"] = "Faire amende honorable";
      ["name_cn"] = "重修旧好";
      ["name_de"] = "Wiedergutmachung";
      ["faction"] = "Horde";
      ["name"] = "Making Amends";
      ["level"] = 60;
      ["name_es"] = "Enmendar los errores";
      ["req"] = 40;
   };
   [8115] = {
      ["name_ru"] = "Контроль над пятью базами";
      ["type"] = "PvP";
      ["objective"] = "Control 5 bases in Arathi Basin at the same time, then return to Field Marshal Oslight at Refuge Pointe.";
      ["name_fr"] = "Prendre cinq bases";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "控制五座基地";
      ["reward"] = {
         [1] = 20132;
      };
      ["name_de"] = "Kontrolliert funf Stutzpunkte";
      ["faction"] = "Alliance";
      ["name"] = "Control Five Bases";
      ["level"] = 60;
      ["name_es"] = "Controla cinco bases";
      ["req"] = 60;
   };
   [5725] = {
      ["name_ru"] = "Силы разрушения...";
      ["type"] = "Dungeon";
      ["objective"] = "Bring the books Spells of Shadow and Incantations from the Nether to Varimathras in Undercity.";
      ["repgain"] = {
         [68] = 350;
      };
      ["sort"] = "Ragefire Chasm";
      ["name_fr"] = "Le pouvoir de detruire...";
      ["name_cn"] = "??之力";
      ["reward"] = {
         [1] = 15449;
         [2] = 15450;
         [3] = 15451;
      };
      ["name_de"] = "Die Macht zu Zerstoren...";
      ["faction"] = "Horde";
      ["name"] = "The Power to Destroy...";
      ["level"] = 16;
      ["name_es"] = "Poder destructivo";
      ["req"] = 9;
   };
   [8147] = {
      ["name_ru"] = "Нить Водоворота";
      ["type"] = "Raid";
      ["objective"] = "";
      ["name_de"] = "Die Mahlstromranke";
      ["name_fr"] = "Les Vrilles du maelstrom";
      ["name"] = "The Maelstrom's Tendril";
      ["name_cn"] = "??之藤";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["reward"] = {
         [1] = 19620;
      };
      ["sort"] = "Zul'Gurub";
      ["prev"] = 8146;
      ["prequests"] = {
         [1] = 8146;
      };
      ["level"] = 60;
      ["name_es"] = "Zarcillo de La Voragine";
      ["req"] = 60;
   };
   [4082] = {
      ["name_ru"] = "УНИЧТОЖИТЬ НА МЕСТЕ: Высокопоставленные чины Черного Железа";
      ["type"] = "Dungeon";
      ["name_fr"] = "TUER A VUE?: Officiers de haut rang Sombrefer";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "SOFORT TOTEN: Hochrangige Fuhrungskrafte der Dunkeleisenzwerge";
      ["name_cn"] = "格?勿?：高?黑??官";
      ["name"] = "KILL ON SIGHT: High Ranking Dark Iron Officials";
      ["objective"] = "Venture to Blackrock Depths and destroy the vile aggressors!$B$BWarlord Goretooth wants you to kill 10 Anvilrage Medics, 10 Anvilrage Soldiers and 10 Anvilrage Officers. Return to him once your task is complete.";
      ["faction"] = "Horde";
      ["sort"] = "Blackrock Depths";
      ["prev"] = 4081;
      ["prequests"] = {
         [1] = 4081;
      };
      ["level"] = 54;
      ["name_es"] = "MATAR INMEDIATAMENTE: oficiales Hierro Negro de alto rango";
      ["req"] = 50;
   };
   [4467] = {
      ["name_ru"] = "Оскверненный ветроцвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的迎?花";
      ["name_fr"] = "La fleur-de-vent corrompue";
      ["name_de"] = "Verderbte Windblute";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Windblossom";
      ["level"] = 55;
      ["name_es"] = "Flor del viento corrupta";
      ["req"] = 48;
   };
   [8365] = {
      ["name_ru"] = "Пиратские шляпы";
      ["type"] = "Solo";
      ["objective"] = "Haughty Modiste wants you to collect 20 Southsea Pirate Hats and return them to her at Steamwheedle Port in Tanaris.";
      ["repgain"] = {
         [369] = 250;
      };
      ["name_fr"] = "Ohe, des chapeaux de pirate?!";
      ["sort"] = "Tanaris";
      ["name_cn"] = "海盗的帽子！";
      ["name_de"] = "Piratenhute Ahoy!";
      ["faction"] = "Horde";
      ["name"] = "Pirate Hats Ahoy!";
      ["level"] = 45;
      ["name_es"] = "!Sombreros de pirata a babor!";
      ["req"] = 40;
   };
   [4116] = {
      ["name_ru"] = "Оскверненный песнецвет";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_cn"] = "被腐化的?歌花";
      ["sort"] = "Felwood";
      ["name_de"] = "Verderbte Liedblume";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Songflower";
      ["level"] = 55;
      ["name_es"] = "Melodia corrupta";
      ["req"] = 48;
   };
   [8262] = {
      ["name_ru"] = "Улучшенный полевой комплект Лиги Аратора";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [509] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Paquetage ameliore d'Arathor";
      ["name_cn"] = "阿拉索高?医?包";
      ["reward"] = {
         [1] = 20231;
      };
      ["name_de"] = "Verbessertes Uberlebenspaket von Arathor";
      ["faction"] = "Alliance";
      ["name"] = "Arathor Advanced Care Package";
      ["level"] = 60;
      ["name_es"] = "Botiquin avanzado de Arathor";
      ["req"] = 45;
   };
   [8294] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_fr"] = "Ecrasez les usurpateurs d'Aile-argent";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 60;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 60;
   };
   [3522] = {
      ["name_ru"] = "Противоядие для Иверрона";
      ["objective"] = "Bring Iverron's Antidote to Iverron before the time limit is up. Iverron can be found by the cave to the north.";
      ["name_cn"] = "埃沃隆的解?";
      ["sort"] = "Shadowglen";
      ["level"] = 4;
      ["type"] = "Solo";
      ["name_fr"] = "L'antidote d'Iverron";
      ["repgain"] = {
         [69] = 350;
      };
      ["name_de"] = "Iverrons Gegengift";
      ["reward"] = {
         [1] = 10655;
         [2] = 10656;
      };
      ["faction"] = "Alliance";
      ["name"] = "Iverron's Antidote";
      ["prev"] = 3521;
      ["prequests"] = {
         [1] = 3521;
      };
      ["series"] = 2;
      ["name_es"] = "El antidoto de Iverron";
      ["req"] = 2;
   };
   [8358] = {
      ["name_ru"] = "Плата за леденцы";
      ["type"] = "Solo";
      ["objective"] = "Do a train emote at Kali Remik, and in exchange you'll receive a Darkspear Gumdrop!";
      ["name_fr"] = "Boule de gomme en approche";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "学火?，?糖果";
      ["reward"] = {
         [1] = 20495;
      };
      ["name_de"] = "Kaugummikugelexpress";
      ["faction"] = "Horde";
      ["name"] = "Incoming Gumdrop";
      ["level"] = 60;
      ["name_es"] = "!Truco o trato!";
      ["req"] = 10;
   };
   [8390] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Mark of Honor to a Horde Warbringer outside the battlegrounds.";
      ["repgain"] = {
         [510] = 50;
      };
      ["name_cn"] = "?源??";
      ["name_de"] = "Eroberung des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Horde";
      ["name"] = "Conquering Arathi Basin";
      ["prev"] = 8370;
      ["prequests"] = {
         [1] = 8370;
      };
      ["level"] = 29;
      ["name_es"] = "La conquista de la Cuenca de Arathi";
      ["req"] = 20;
   };
   [8422] = {
      ["name_ru"] = "Тролли Пера";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les trolls d'un meme plumage…";
      ["name_de"] = "Federn von Trollen";
      ["objective"] = "Bring a total of 6 Voodoo Feathers from the trolls in sunken temple.";
      ["reward"] = {
         [1] = 20536;
         [2] = 20534;
         [3] = 20530;
      };
      ["name_cn"] = "巨魔的羽毛";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Trolls of a Feather";
      ["sort"] = "Warlock";
      ["prev"] = 8421;
      ["prequests"] = {
         [1] = 8421;
      };
      ["level"] = 52;
      ["name_es"] = "Plumas de trol";
      ["req"] = 50;
   };
   [5243] = {
      ["name_ru"] = "Святая вода";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Stratholme, in the north. Search the supply crates that litter the city and recover 5 Stratholme Holy Water. Return to Leonid Barthalomew the Revered when you have collected enough of the blessed fluid.";
      ["repgain"] = {
         [529] = 250;
      };
      ["sort"] = "Stratholme";
      ["name_fr"] = "Les demeures du Sacre";
      ["name_cn"] = "神?之屋";
      ["reward"] = {
         [1] = 13216;
         [2] = 3928;
         [3] = 13217;
         [4] = 6149;
      };
      ["name_de"] = "Hauser der Heiligen";
      ["faction"] = "Horde";
      ["name"] = "Houses of the Holy";
      ["level"] = 60;
      ["name_es"] = "Las casas de lo sagrado";
      ["req"] = 55;
   };
   [4244] = {
      ["name_ru"] = "В поисках Чи-Та 3";
      ["type"] = "Solo";
      ["name_fr"] = "A la poursuite d'A-mi 01";
      ["name_de"] = "Chasing A-Me 01";
      ["name"] = "Chasing A-Me 01";
      ["name_cn"] = "找回A-Me 01";
      ["objective"] = " you wonder if it'll be that simple to fix A-Me 01 and get her back to Karna Remtravel near Marshall's Refuge.$B$BOnly trying it will tell.\"";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4243;
      ["prequests"] = {
         [1] = 4243;
      };
      ["level"] = 53;
      ["name_es"] = "Buscando a Memo 01";
      ["req"] = 48;
   };
   [8518] = {
      ["name_ru"] = "Альянсу по-прежнему не хватает льняных бинтов!";
      ["type"] = "Solo";
      ["name_fr"] = "L'Alliance a besoin de plus de bandages en lin?!";
      ["name_de"] = "Die Allianz braucht mehr Leinenverbande!";
      ["reward"] = {
         [1] = 21436;
         [2] = 21509;
      };
      ["name_cn"] = "?盟需要更多?麻??！";
      ["objective"] = "Bring 20 linen bandages to Sentinel Silversky at the airfield in Dun Morogh.";
      ["faction"] = "Horde";
      ["name"] = "The Alliance Needs More Linen Bandages!";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8517;
      ["prequests"] = {
         [1] = 8517;
      };
      ["level"] = 60;
      ["name_es"] = "!La Alianza necesita mas vendas de lino!";
      ["req"] = 1;
   };
   [8550] = {
      ["name_ru"] = "Орде все еще не хватает мироцвета!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Peacebloom to Herbalist Proudfeather at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Friedensblumen!";
      ["name_fr"] = "La Horde a besoin de plus de pacifique !";
      ["name_cn"] = "部落需要更多?神花！";
      ["name"] = "The Horde Needs Peacebloom!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21509;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8549;
      ["prequests"] = {
         [1] = 8549;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas flores de paz!";
      ["req"] = 1;
   };
   [4292] = {
      ["name_ru"] = "Приманка для Лар'корви";
      ["type"] = "Solo";
      ["name_fr"] = "Un appat pour Lar'korwi";
      ["name_de"] = "Ein Koder fur Lar'korwi";
      ["reward"] = {
         [1] = 11876;
         [2] = 11882;
      };
      ["name_cn"] = "拉克?的??";
      ["objective"] = "Using the contents of Torwa's Pouch, summon Lar'korwi and defeat him. Then bring Lar'korwi's Head to Torwa Pathfinder near the entrance to Un'Goro Crater.";
      ["faction"] = "Horde";
      ["name"] = "The Bait for Lar'korwi";
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4291;
      ["prequests"] = {
         [1] = 4291;
      };
      ["level"] = 56;
      ["name_es"] = "El cebo para Lar'korwi";
      ["req"] = 48;
   };
   [8614] = {
      ["name_ru"] = "Орде все еще не хватает пятнистого желтохвоста!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Spotted Yellowtail to Fisherman Lin'do at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr Tupfelgelbschwanze!";
      ["name_fr"] = "La Horde a besoin de plus de jaunes-queues tachetes !";
      ["name_cn"] = "部落需要更多斑点黄尾?！";
      ["name"] = "The Horde Needs More Spotted Yellowtail!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8613;
      ["prequests"] = {
         [1] = 8613;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas serviolas moteadas!";
      ["req"] = 1;
   };
   [8646] = {
      ["name_ru"] = "Предок Молотозвон";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Cri-du-marteau";
      ["name_cn"] = "雷??者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Hammerklang";
      ["faction"] = "Horde";
      ["name"] = "Hammershout the Elder";
      ["level"] = 60;
      ["name_es"] = "Rugidomazo el Ancestro";
      ["req"] = 1;
   };
   [8678] = {
      ["name_ru"] = "Предок Кривой рог";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Corne-fiere";
      ["name_cn"] = "傲角?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Weizhuf";
      ["faction"] = "Horde";
      ["name"] = "Proudhorn the Elder";
      ["level"] = 60;
      ["name_es"] = "Ancestro Pezuna de Trigo";
      ["req"] = 1;
   };
   [8710] = {
      ["name_ru"] = "Крис Неназванных имен";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Ornate Hilt, 2  Onyx Idols, 5 Gold Scarabs and 5 Clay Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "Le kriss des noms inexprimes";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "禁断邪?短?";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["reward"] = {
         [1] = 21416;
      };
      ["name_de"] = "Kris der ungesagten Namen";
      ["faction"] = "Horde";
      ["name"] = "Kris of Unspoken Names";
      ["level"] = 60;
      ["name_es"] = "Kris de los nombres prohibidos";
      ["req"] = 60;
   };
   [8742] = {
      ["name_ru"] = "Армия Калимдора";
      ["type"] = "Solo";
      ["name_fr"] = "La puissance de Kalimdor";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_cn"] = "?利姆多的威力";
      ["sort"] = "Tanaris";
      ["objective"] = "";
      ["name"] = "The Might of Kalimdor";
      ["name_de"] = "Die Macht von Kalimdor";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 8729;
         [2] = 8730;
         [3] = 8741;
      };
      ["level"] = 60;
      ["name_es"] = "El poder de Kalimdor";
      ["req"] = 60;
   };
   [8774] = {
      ["name_ru"] = "Цель: стерегущие из Улья Регал";
      ["type"] = "Group";
      ["objective"] = "Kill 30 Hive'Regal Ambushers and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing VIII in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les embusquees de la Ruche'Regal";
      ["name_cn"] = "目?：雷戈伏?者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Wegelagerer des Regalschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Regal Ambushers";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los emboscadores Colmen'Regal";
      ["req"] = 60;
   };
   [8806] = {
      ["name_ru"] = "Шлифовальные камни";
      ["type"] = "Solo";
      ["objective"] = "Bring 10 Dense Grinding Stones, 10 Solid Grinding Stones and 10 Heavy Grinding Stones to Vish Kozus, Captain of the Guard at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing III in order to complete this quest.";
      ["name_fr"] = "Des silex a aiguiser pour la Garde";
      ["sort"] = "Silithus";
      ["name_cn"] = "?兵的磨刀石";
      ["reward"] = {
         [1] = 20800;
         [2] = 21266;
      };
      ["name_de"] = "Schleifsteine fur die Wache";
      ["faction"] = "Horde";
      ["name"] = "Grinding Stones for the Guard";
      ["level"] = 60;
      ["name_es"] = "Piedra de pulir para la guardia";
      ["req"] = 60;
   };
   [8838] = {
      ["name_ru"] = "Один рекомендательный жетон";
      ["type"] = "Solo";
      ["name_fr"] = "Une chevaliere de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "一枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "One Commendation Signet";
      ["name_de"] = "Ein Belobigungsabzeichen";
      ["prev"] = 8814;
      ["prequests"] = {
         [1] = 8814;
      };
      ["level"] = 60;
      ["name_es"] = "Un sello de honor";
      ["req"] = 1;
   };
   [8870] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger in the Mystic Ward of Ironforge.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Alliance";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [8902] = {
      ["name_ru"] = "Дорогая моя Эления!";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Lovingly Composed Letter to Elenia Haydon near the bank in the Undercity.";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "??的艾琳娜";
      ["name_fr"] = "Tres chere Elenia,";
      ["name_de"] = "Liebste Elenia";
      ["faction"] = "Horde";
      ["name"] = "Dearest Elenia,";
      ["level"] = 70;
      ["name_es"] = "Queridisima Elenia:";
      ["req"] = 58;
   };
   [8934] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Devout Belt and a set of Devout Gloves to Deliana in Ironforge.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Priest";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22078;
         [2] = 22081;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8966] = {
      ["name_ru"] = "Левая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau gauche de l'amulette du seigneur Valthalak";
      ["next"] = 8970;
      ["name_de"] = "Das linke Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Mor Grayhoof and slay him. Return to Bodley inside Blackrock Mountain with the Left Piece of Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦?拉克?符的左半?";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "The Left Piece of Lord Valthalak's Amulet";
      ["followup"] = 8970;
      ["prev"] = 8962;
      ["prequests"] = {
         [1] = 8962;
      };
      ["level"] = 60;
      ["name_es"] = "La parte izquierda del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [8998] = {
      ["name_ru"] = "Круг замкнулся";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au commencement";
      ["name_de"] = "Zuruck zum Anfang";
      ["name_cn"] = "回到原点";
      ["objective"] = "Speak with Mokvar at Grommash Hold in Orgrimmar's Valley of Wisdom.";
      ["sort"] = "Orgrimmar";
      ["faction"] = "Horde";
      ["name"] = "Back to the Beginning";
      ["prev"] = 8996;
      ["prequests"] = {
         [1] = 8996;
      };
      ["level"] = 60;
      ["name_es"] = "Regreso al principio";
      ["req"] = 58;
   };
   [8381] = {
      ["name_ru"] = "Оружие войны";
      ["objective"] = "";
      ["name_cn"] = "??物?";
      ["sort"] = "Silithus";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Armes de guerre";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Kriegsausrustung";
      ["classes"] = {
         [1] = "Mage";
         [2] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Armaments of War";
      ["prev"] = 8315;
      ["prequests"] = {
         [1] = 8315;
      };
      ["reward"] = {
         [1] = 20705;
         [2] = 20716;
      };
      ["name_es"] = "Armamentos de guerra";
      ["req"] = 58;
   };
   [3902] = {
      ["name_ru"] = "Поиски старой одежды";
      ["type"] = "Solo";
      ["objective"] = "Search Deathknell and the vicinity for 6 pieces of Scavenged Goods, and return them to Deathguard Saltain.";
      ["repgain"] = {
         [68] = 350;
      };
      ["name_de"] = "Beutesuche in Todesend";
      ["reward"] = {
         [1] = 11848;
         [2] = 11849;
         [3] = 11850;
      };
      ["name_cn"] = "?破?";
      ["name_fr"] = "La chasse aux tresors";
      ["faction"] = "Horde";
      ["name"] = "Scavenging Deathknell";
      ["sort"] = "Deathknell";
      ["prev"] = 376;
      ["prequests"] = {
         [1] = 376;
      };
      ["level"] = 3;
      ["name_es"] = "Hurgar en Camposanto";
      ["req"] = 2;
   };
   [9094] = {
      ["name_ru"] = "Перчатки Серебряного Рассвета";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_fr"] = "Les gants de l'Aube d'argent";
      ["name_cn"] = "?色黎明手套";
      ["reward"] = {
         [1] = 23084;
         [2] = 23081;
         [3] = 23082;
         [4] = 23078;
      };
      ["name_de"] = "Handschuhe der Argentumdammerung";
      ["faction"] = "Alliance";
      ["name"] = "Argent Dawn Gloves";
      ["level"] = 60;
      ["name_es"] = "Guantes de El Alba Argenta";
      ["req"] = 55;
   };
   [9126] = {
      ["name_ru"] = "Копи костяной косы";
      ["type"] = "Solo";
      ["objective"] = "Rohan the Assassin at Light's Hope Chapel in the Eastern Plaguelands wants 30 Bone Fragments.$B";
      ["repgain"] = {
         [529] = 500;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Des morceaux pour la faucheuse d'os";
      ["name_cn"] = "骨?的材料";
      ["reward"] = {
         [1] = 22524;
      };
      ["name_de"] = "Knochensensenjagd";
      ["faction"] = "Horde";
      ["name"] = "Bonescythe Digs";
      ["level"] = 60;
      ["name_es"] = "Excavaciones para la armadura Segahuesos";
      ["req"] = 55;
   };
   [5142] = {
      ["name_ru"] = "Малышка Памела";
      ["type"] = "Solo";
      ["objective"] = "Find Pamela Redpath.";
      ["next"] = 5149;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "小?米拉";
      ["name_fr"] = "La petite Pamela";
      ["followup"] = 5149;
      ["name_de"] = "Klein-Pamela";
      ["faction"] = "Horde";
      ["name"] = "Little Pamela";
      ["level"] = 55;
      ["name_es"] = "La pequena Pamela";
      ["req"] = 50;
   };
   [9190] = {
      ["name_ru"] = "Задание мастера: сапоги из рунической ткани";
      ["type"] = "Solo";
      ["objective"] = "Deliver 8 Runecloth Boots and the Craftsman's Writ - Runecloth Boots - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Bottes en etoffe runique";
      ["name_cn"] = "工匠文? - 符文布靴";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Runenstoffstiefel";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Runecloth Boots";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: botas de pano runico";
      ["req"] = 55;
   };
   [9222] = {
      ["name_ru"] = "Легендарное боевое снаряжение ? Друг Рассвета";
      ["type"] = "Solo";
      ["objective"] = "For 110 Insignias of the Dawn and 110 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille epiques - Ami de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "史??的作?装? - ?色黎明友善";
      ["reward"] = {
         [1] = 22657;
         [2] = 22667;
         [3] = 22668;
         [4] = 22659;
         [5] = 22678;
         [6] = 22656;
      };
      ["name_de"] = "Epische Kampfausrustung - Freund der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Epic Armaments of Battle - Friend of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento epico de batalla: amistoso con El Alba";
      ["req"] = 55;
   };
   [6381] = {
      ["name_ru"] = "Новая жизнь";
      ["type"] = "Solo";
      ["objective"] = "Plant 10 Gaea Seeds in Gaea Dirt Mounds, and then return the remaining Enchanted Gaea Seeds to Tammra at Sun Rock Retreat.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Neues Leben";
      ["reward"] = {
         [1] = 16985;
         [2] = 16986;
      };
      ["name_cn"] = "新的生命";
      ["name_fr"] = "Nouvelle vie";
      ["faction"] = "Horde";
      ["name"] = "New Life";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 6301;
      ["prequests"] = {
         [1] = 6301;
      };
      ["level"] = 25;
      ["name_es"] = "Nueva vida";
      ["req"] = 17;
   };
   [8990] = {
      ["name_ru"] = "Правая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau droit de l'amulette du seigneur Valthal";
      ["next"] = 8994;
      ["name_de"] = "Das rechte Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Isalien and slay her. Return to Bodley inside Blackrock Mountain with the recombined Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦塔拉克?品的右瓣";
      ["sort"] = "Dire Maul";
      ["faction"] = "Horde";
      ["name"] = "The Right Piece of Lord Valthalak's Amulet";
      ["followup"] = 8994;
      ["prev"] = 8985;
      ["prequests"] = {
         [1] = 8985;
      };
      ["level"] = 60;
      ["name_es"] = "La parte derecha del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [9318] = {
      ["name_ru"] = "Благословенное волшебное масло";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Scourge Invasion";
      ["name_cn"] = "神?巫?之油";
      ["reward"] = {
         [1] = 23123;
      };
      ["name_de"] = "Gesegnetes Zauberol";
      ["faction"] = "Horde";
      ["name"] = "Blessed Wizard Oil";
      ["level"] = 0;
      ["name_es"] = "Aceite de zahori bendito";
      ["req"] = 50;
   };
   [4022] = {
      ["name_ru"] = "Вкус пламени";
      ["type"] = "Solo";
      ["name_fr"] = "Un gout de flammes";
      ["next"] = 4024;
      ["name_de"] = "Eine Kostprobe der Flamme";
      ["objective"] = "Show Cyrus Therepentous the Black Dragonflight Molt you received from Kalaran Windblade.$B";
      ["name_cn"] = "烈?精?";
      ["sort"] = "Burning Steppes";
      ["faction"] = "Horde";
      ["name"] = "A Taste of Flame";
      ["followup"] = 4024;
      ["prev"] = 3481;
      ["prequests"] = {
         [1] = 3481;
      };
      ["level"] = 54;
      ["name_es"] = "Un sabor a llamarada";
      ["req"] = 52;
   };
   [1126] = {
      ["name_ru"] = "Улей в башне";
      ["type"] = "Solo";
      ["name_fr"] = "Une ruche dans la tour";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Schwarmbau im Turm";
      ["name"] = "Hive in the Tower";
      ["name_cn"] = "塔中之?";
      ["objective"] = "Scale the tower of Southwind Village and locate a means to stir the silithid hive into activity.  Bring back anything unusual you may uncover when doing so to Layo Starstrike at the Valor's Rest graveyard of Silithus.";
      ["next"] = 6844;
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 1125;
      ["prequests"] = {
         [1] = 1125;
      };
      ["level"] = 57;
      ["name_es"] = "Una colmena en la torre";
      ["req"] = 54;
   };
   [4062] = {
      ["name_ru"] = "Восстание машин";
      ["type"] = "Solo";
      ["name_fr"] = "La revolte des machines";
      ["next"] = 4063;
      ["name_de"] = "Aufstieg der Maschinen";
      ["name"] = "The Rise of the Machines";
      ["name_cn"] = "机器的崛起";
      ["objective"] = "Take the Elemental Shard Sample to Lotwil Veriatus.$B$BYou recall Theodora saying that Lotwil was stationed in a camp to the east.$B";
      ["series"] = 2;
      ["faction"] = "Horde";
      ["sort"] = "Badlands";
      ["prev"] = 4061;
      ["prequests"] = {
         [1] = 4061;
      };
      ["level"] = 54;
      ["name_es"] = "La revuelta de las maquinas";
      ["req"] = 52;
   };
   [4724] = {
      ["name_ru"] = "Праматерь стаи";
      ["type"] = "Dungeon";
      ["objective"] = "Slay Halycon, pack mistress of the Bloodaxe worg.";
      ["repgain"] = {
         [76] = 250;
      };
      ["sort"] = "Blackrock Spire";
      ["name_fr"] = "La maitresse de meute";
      ["name_cn"] = "座狼的首?";
      ["reward"] = {
         [1] = 15824;
         [2] = 15825;
         [3] = 15827;
      };
      ["name_de"] = "Die Herrin der Meute";
      ["faction"] = "Horde";
      ["name"] = "The Pack Mistress";
      ["level"] = 59;
      ["name_es"] = "La maestra de la manada";
      ["req"] = 55;
   };
   [4740] = {
      ["name_ru"] = "РАЗЫСКИВАЕТСЯ: Глубомрак!";
      ["type"] = "Solo";
      ["objective"] = " and is suspected of causing the sinking of at least two cargo vessels in the waters off Darkshore!$B$BMurkdeep was last spotted at a hutted murloc camp south of Auberdine";
      ["repgain"] = {
         [69] = 350;
      };
      ["sort"] = "Darkshore";
      ["name_fr"] = "On recherche?: Fondeboue?!";
      ["name_cn"] = "通?：莫克迪普！";
      ["reward"] = {
         [1] = 5315;
         [2] = 15403;
         [3] = 15404;
      };
      ["name_de"] = "GESUCHT: Gurgelbacke!";
      ["faction"] = "Alliance";
      ["name"] = "WANTED: Murkdeep!";
      ["level"] = 18;
      ["name_es"] = "SE BUSCA: !Viscoso!";
      ["req"] = 15;
   };
   [1026] = {
      ["name_ru"] = "Раэна ? санитар Ясеневого леса";
      ["type"] = "Solo";
      ["name_fr"] = "Le nettoyage selon Raene";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Durchsucht den Baumstamm";
      ["name"] = "Raene's Cleansing";
      ["name_cn"] = "莱恩的?化";
      ["objective"] = "Find the Wooden Key and a piece of Dartol's Rod before returning to Shael'dryn at the moonwell.";
      ["next"] = 1027;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1024;
      ["prequests"] = {
         [1] = 1024;
      };
      ["level"] = 27;
      ["name_es"] = "?Donde estan las llaves?";
      ["req"] = 18;
   };
   [1034] = {
      ["name_ru"] = "Руины Звездной Пыли";
      ["type"] = "Solo";
      ["name_fr"] = "Les ruines de Chimetoile";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Die Sternenstaubruinen";
      ["name_cn"] = "星??墟";
      ["name"] = "The Ruins of Stardust";
      ["objective"] = "Bring 5 Handfuls of Stardust to Pelturas in Astranaar.";
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1033;
      ["prequests"] = {
         [1] = 1033;
      };
      ["level"] = 23;
      ["name_es"] = "Las Ruinas del Polvo Estelar";
      ["req"] = 20;
   };
   [4788] = {
      ["name_ru"] = "Последние таблички";
      ["type"] = "Dungeon";
      ["name_fr"] = "Les dernieres tablettes";
      ["name_de"] = "Die letzten Schrifttafeln";
      ["name_cn"] = "最后的石板";
      ["objective"] = "Bring the Fifth and Sixth Mosh'aru Tablets to Prospector Ironboot in Tanaris.";
      ["sort"] = "Blackrock Spire";
      ["faction"] = "Horde";
      ["name"] = "The Final Tablets";
      ["prev"] = 5065;
      ["prequests"] = {
         [1] = 5065;
      };
      ["level"] = 58;
      ["name_es"] = "Las ultimas tablillas";
      ["req"] = 40;
   };
   [4804] = {
      ["name_ru"] = "Э'ко хладнокрылов";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "E'ko der Eiswindschimaren";
      ["name_fr"] = "L'E'ko de Noroit";
      ["name_cn"] = "冰?魂精";
      ["name"] = "Chillwind E'ko";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 12457;
      };
      ["sort"] = "Winterspring";
      ["prev"] = 975;
      ["prequests"] = {
         [1] = 975;
      };
      ["level"] = 60;
      ["name_es"] = "E'ko Orvallo";
      ["req"] = 55;
   };
   [6187] = {
      ["name_ru"] = "Порядок должен быть восстановлен";
      ["type"] = "Raid";
      ["name_fr"] = "L'ordre doit etre retabli";
      ["name_de"] = "Ordnung muss wiederhergestellt werden";
      ["reward"] = {
         [1] = 16996;
         [2] = 16997;
         [3] = 16998;
      };
      ["name_cn"] = "重?秩序";
      ["objective"] = "Assemble an army and travel to the Eastern Plaguelands. Launch a full assault on Nathanos Blightcaller and any Horde filth that may attempt to protect him.$B$BKeep your wits about you, $N. The Horde will defend the ranger lord with their very lives.";
      ["faction"] = "Alliance";
      ["name"] = "Order Must Be Restored";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6186;
      ["prequests"] = {
         [1] = 6186;
      };
      ["level"] = 60;
      ["name_es"] = "Restaurar el orden";
      ["req"] = 56;
   };
   [4148] = {
      ["name_ru"] = "Антикровоцветный шокер";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["name_de"] = "Blutblutenvernichter";
      ["name_fr"] = "La baguette Petale-de-sang";
      ["name_cn"] = "血瓣花除草器";
      ["name"] = "Bloodpetal Zapper";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 11320;
      };
      ["sort"] = "Un'Goro Crater";
      ["prev"] = 4146;
      ["prequests"] = {
         [1] = 4146;
      };
      ["level"] = 53;
      ["name_es"] = "Liquidador de Sangrepetalo";
      ["req"] = 47;
   };
   [1040] = {
      ["name_ru"] = "Дорога до Пиратской бухты";
      ["type"] = "Solo";
      ["name_fr"] = "Passage a Baie-du-Butin";
      ["repgain"] = {
         [21] = 25;
      };
      ["name_de"] = "Passage nach Beutebucht";
      ["name"] = "Passage to Booty Bay";
      ["name_cn"] = "藏宝海湾的航道";
      ["objective"] = "Take a boat to Booty Bay and speak with Caravaneer Ruzzgot.";
      ["next"] = 1041;
      ["faction"] = "Alliance";
      ["sort"] = "Ashenvale";
      ["prev"] = 1039;
      ["prequests"] = {
         [1] = 1039;
      };
      ["level"] = 30;
      ["name_es"] = "Pasaje a Bahia del Botin";
      ["req"] = 25;
   };
   [1048] = {
      ["name_ru"] = "В монастырь Алого ордена";
      ["type"] = "Dungeon";
      ["objective"] = "Kill High Inquisitor Whitemane, Scarlet Commander Mograine, Herod, the Scarlet Champion and Houndmaster Loksey and then report back to Varimathras in the Undercity.";
      ["repgain"] = {
         [68] = 500;
      };
      ["sort"] = "Scarlet Monastery";
      ["name_fr"] = "Au monastere ecarlate";
      ["name_cn"] = "深入血色修道院";
      ["reward"] = {
         [1] = 6802;
         [2] = 6803;
         [3] = 10711;
      };
      ["name_de"] = "In das Scharlachrote Kloster";
      ["faction"] = "Horde";
      ["name"] = "Into The Scarlet Monastery";
      ["level"] = 42;
      ["name_es"] = "En el Monasterio Escarlata";
      ["req"] = 33;
   };
   [1054] = {
      ["name_ru"] = "Устранение угрозы";
      ["type"] = "Solo";
      ["objective"] = "Bring Dal Bloodclaw's Skull to Raene Wolfrunner in Astranaar.";
      ["repgain"] = {
         [69] = 250;
      };
      ["sort"] = "Ashenvale";
      ["name_fr"] = "Diminution de la menace";
      ["name_cn"] = "解除威?";
      ["reward"] = {
         [1] = 1970;
      };
      ["name_de"] = "Die Auswahl der Bedrohung";
      ["faction"] = "Alliance";
      ["name"] = "Culling the Threat";
      ["level"] = 25;
      ["name_es"] = "Matanza selectiva";
      ["req"] = 18;
   };
   [1056] = {
      ["name_ru"] = "Путешествие к Пику Каменного Когтя";
      ["type"] = "Solo";
      ["objective"] = "Travel to Keeper Albagorm on Stonetalon Peak.";
      ["next"] = 1057;
      ["name_fr"] = "Voyage au pic des Serres-Rocheuses";
      ["sort"] = "Ashenvale";
      ["name_cn"] = "石爪峰之旅";
      ["repgain"] = {
         [69] = 75;
      };
      ["name_de"] = "Reise zum Steinkrallengipfel";
      ["faction"] = "Alliance";
      ["name"] = "Journey to Stonetalon Peak";
      ["level"] = 18;
      ["name_es"] = "Viaje a Cima del Espolon";
      ["req"] = 18;
   };
   [1072] = {
      ["name_ru"] = "Старый коллега";
      ["type"] = "Solo";
      ["name_fr"] = "Un vieux collegue";
      ["repgain"] = {
         [54] = 75;
      };
      ["name_de"] = "Ein alter Kollege";
      ["name"] = "An Old Colleague";
      ["name_cn"] = "老同事";
      ["objective"] = "Speak to Lomac Gearstrip in Ironforge.";
      ["next"] = 1073;
      ["faction"] = "Alliance";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1071;
      ["prequests"] = {
         [1] = 1071;
      };
      ["level"] = 21;
      ["name_es"] = "Un viejo colega";
      ["req"] = 17;
   };
   [1076] = {
      ["name_ru"] = "Демоны в Западном Крае";
      ["type"] = "Solo";
      ["name_fr"] = "Des diables dans la marche de l'Ouest";
      ["repgain"] = {
         [54] = 250;
         [72] = 250;
      };
      ["name_de"] = "Teufel in Westfall";
      ["name_cn"] = "西部荒野中的?魔";
      ["name"] = "Devils in Westfall";
      ["objective"] = "Bring Dust Devil Debris to Collin Mauren in Stormwind.";
      ["faction"] = "Alliance";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1075;
      ["prequests"] = {
         [1] = 1075;
      };
      ["level"] = 21;
      ["name_es"] = "Demonios en los Paramos de Poniente";
      ["req"] = 17;
   };
   [2159] = {
      ["name_ru"] = "Посылка в Доланаар";
      ["type"] = "Solo";
      ["objective"] = "Bring the Dolanaar Delivery to Innkeeper Keldamyr.";
      ["repgain"] = {
         [69] = 25;
      };
      ["sort"] = "Teldrassil";
      ["name_fr"] = "Livraison a Dolanaar";
      ["name_cn"] = "多???的?物";
      ["reward"] = {
         [1] = 2070;
         [2] = 159;
      };
      ["name_de"] = "Lieferung fur Dolanaar";
      ["faction"] = "Alliance";
      ["name"] = "Dolanaar Delivery";
      ["level"] = 5;
      ["name_es"] = "Paquete de Dolanaar";
      ["req"] = 1;
   };
   [4964] = {
      ["name_ru"] = "Завершение шара Дар'орахила";
      ["type"] = "Solo";
      ["name_fr"] = "L'Orbe complet de Dar'Orahil";
      ["name_de"] = "Die fertiggestellte Kugel von Dar'Orahil";
      ["objective"] = "Wait for Menara Voidrender to complete the Orb of Dar'Orahil and then speak to her again.";
      ["reward"] = {
         [1] = 15108;
         [2] = 15106;
      };
      ["name_cn"] = "?奥拉赫宝珠";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "The Completed Orb of Dar'Orahil";
      ["sort"] = "Warlock";
      ["prev"] = 4976;
      ["prequests"] = {
         [1] = 4976;
      };
      ["level"] = 40;
      ["name_es"] = "El orbe completo de Dar'Orahil";
      ["req"] = 35;
   };
   [1092] = {
      ["name_ru"] = "Приказы Геренцо";
      ["objective"] = "Deliver the Unidentified Ore to Ziz Fizziks in the Stonetalon Mountains.";
      ["name_cn"] = "格雷?的要求";
      ["sort"] = "Stonetalon Mountains";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "Les ordres de Gerenzo";
      ["repgain"] = {
         [470] = 150;
      };
      ["name_de"] = "Gerenzos Befehle";
      ["reward"] = {
         [1] = 6666;
      };
      ["faction"] = "Horde";
      ["name"] = "Gerenzo's Orders";
      ["prev"] = 1090;
      ["prequests"] = {
         [1] = 1090;
      };
      ["series"] = 2;
      ["name_es"] = "Ordenes de Gerenzo";
      ["req"] = 17;
   };
   [1096] = {
      ["name_ru"] = "Геренцо Терминатрикс";
      ["type"] = "Solo";
      ["objective"] = "Bring Gerenzo Wrenchwhistle's Mechanical Arm to Ziz Fizziks in the Stonetalon Mountains.";
      ["repgain"] = {
         [470] = 250;
      };
      ["name_de"] = "Gerenzo Pfeifzang";
      ["reward"] = {
         [1] = 6667;
         [2] = 6668;
      };
      ["name_cn"] = "格雷?";
      ["name_fr"] = "Gerenzo Siffleclef";
      ["faction"] = "Horde";
      ["name"] = "Gerenzo Wrenchwhistle";
      ["sort"] = "Stonetalon Mountains";
      ["prev"] = 1095;
      ["prequests"] = {
         [1] = 1095;
      };
      ["level"] = 27;
      ["name_es"] = "Gerenzo Silbillave";
      ["req"] = 16;
   };
   [1098] = {
      ["name_ru"] = "Пропавшие стражи смерти";
      ["type"] = "Dungeon";
      ["objective"] = "Find the Deathstalker Adamant and Deathstalker Vincent.";
      ["repgain"] = {
         [68] = 250;
      };
      ["sort"] = "Shadowfang Keep";
      ["name_fr"] = "Des necrotraqueurs a Ombrecroc";
      ["name_cn"] = "影牙城堡里的亡?哨兵";
      ["reward"] = {
         [1] = 3324;
      };
      ["name_de"] = "Todespirscher in Burg Schattenfang";
      ["faction"] = "Horde";
      ["name"] = "Deathstalkers in Shadowfang";
      ["level"] = 25;
      ["name_es"] = "Mortacechadores en Colmillo Oscuro";
      ["req"] = 18;
   };
   [1108] = {
      ["name_ru"] = "Индарилий";
      ["type"] = "Solo";
      ["name_fr"] = "Indurium";
      ["name_de"] = "Indurium";
      ["name_cn"] = "精?碎片";
      ["objective"] = "Bring 10 Indurium Flakes to Martek the Exiled in the Badlands.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Indurium";
      ["prev"] = 1106;
      ["prequests"] = {
         [1] = 1106;
      };
      ["level"] = 39;
      ["name_es"] = "Indurio";
      ["req"] = 28;
   };
   [5044] = {
      ["name_ru"] = "Мудрость Агамаггана";
      ["type"] = "Solo";
      ["name_fr"] = "La sagesse d'Agammagan";
      ["sort"] = "The Barrens";
      ["name_cn"] = "阿迦?甘的智慧";
      ["objective"] = "";
      ["faction"] = "Horde";
      ["name"] = "Wisdom of Agamaggan";
      ["name_de"] = "Weisheit von Agamaggan";
      ["prev"] = 5052;
      ["prequests"] = {
         [1] = 5052;
      };
      ["level"] = 20;
      ["name_es"] = "La sabiduria de Agamaggan";
      ["req"] = 14;
   };
   [5060] = {
      ["name_ru"] = "Под замком";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Enferme";
      ["name_cn"] = "被?起来的?夫";
      ["reward"] = {
         [1] = 13474;
         [2] = 13475;
      };
      ["name_de"] = "Weggeschlossen";
      ["faction"] = "Horde";
      ["name"] = "Locked Away";
      ["level"] = 55;
      ["name_es"] = "Encierro";
      ["req"] = 52;
   };
   [1116] = {
      ["name_ru"] = "Сонная пыль в болоте";
      ["type"] = "Solo";
      ["name_fr"] = "De la poussiere de reve dans les marecages";
      ["next"] = 1117;
      ["name_de"] = "Traumstaub im Sumpf";
      ["name_cn"] = "沼?中的梦境粉?";
      ["objective"] = "Bring 10 Specks of Dream Dust to Krazek in Booty Bay.  Dream Dust is gathered from the dragon whelps of the Swamp of Sorrows.";
      ["sort"] = "Swamp of Sorrows";
      ["faction"] = "Horde";
      ["name"] = "Dream Dust in the Swamp";
      ["prev"] = 1115;
      ["prequests"] = {
         [1] = 1115;
      };
      ["level"] = 36;
      ["name_es"] = "Polvo onirico en el pantano";
      ["req"] = 30;
   };
   [5092] = {
      ["name_ru"] = "Зачистка территории";
      ["type"] = "Solo";
      ["name_fr"] = "Nettoyer le passage";
      ["repgain"] = {
         [72] = 250;
      };
      ["name_cn"] = "?清道路";
      ["name_de"] = "Den Weg raumen";
      ["objective"] = "Kill 10 Skeletal Flayers and 10 Slavering Ghouls in Sorrow Hill.$B$BReturn to Commander Ashlam Valorfist at Chillwind Camp, Western Plaguelands.";
      ["sort"] = "Western Plaguelands";
      ["name"] = "Clear the Way";
      ["faction"] = "Alliance";
      ["prequests"] = {
         [1] = 5066;
         [2] = 5090;
         [3] = 5091;
      };
      ["level"] = 52;
      ["name_es"] = "Despejar el camino";
      ["req"] = 50;
   };
   [8281] = {
      ["name_ru"] = "Обеспечение безопасности";
      ["type"] = "Solo";
      ["name_fr"] = "Ameliorer la securite";
      ["repgain"] = {
         [609] = 250;
      };
      ["name_de"] = "Verstarkte Sicherheit";
      ["name_cn"] = "?保安全";
      ["name"] = "Stepping Up Security";
      ["objective"] = "Windcaller Proudhorn at Cenarion Hold in Silithus wants you to slay 20 Dredge Crushers.";
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8280;
      ["prequests"] = {
         [1] = 8280;
      };
      ["level"] = 57;
      ["name_es"] = "Intensificar la seguridad";
      ["req"] = 54;
   };
   [5124] = {
      ["name_ru"] = "Огненные латные рукавицы";
      ["type"] = "Group";
      ["name_fr"] = "Gantelets en plaque de feu";
      ["name_de"] = "Feurige Plattenstulpen";
      ["reward"] = {
         [1] = 12699;
         [2] = 12631;
      };
      ["name_cn"] = "??板甲?手";
      ["objective"] = "Bring Malyfous Darkhammer 6 Enchanted Thorium Bars, 2 Essence of Fire, and 4 Star Rubies. You will also need to turn in your Unfired Plate Gauntlets.";
      ["faction"] = "Horde";
      ["name"] = "Fiery Plate Gauntlets";
      ["sort"] = "Winterspring";
      ["prev"] = 5103;
      ["prequests"] = {
         [1] = 5103;
      };
      ["level"] = 60;
      ["name_es"] = "Guanteletes de placas igneas";
      ["req"] = 55;
   };
   [9204] = {
      ["name_ru"] = "Задание мастера: каменный угорь";
      ["type"] = "Solo";
      ["objective"] = "Deliver 40 Stonescale Eel and the Craftsman's Writ - Stonescale Eel - to Packmaster Stonebruiser at Light's Hope Chapel in the Eastern Plaguelands.";
      ["repgain"] = {
         [529] = 50;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Commission d'artisan - Anguilles pierre-ecaille";
      ["name_cn"] = "工匠文? - 石??";
      ["reward"] = {
         [1] = 22524;
         [2] = 22523;
      };
      ["name_de"] = "Handwerksverfugung - Steinschuppenaal";
      ["faction"] = "Horde";
      ["name"] = "Craftsman's Writ - Stonescale Eel";
      ["level"] = 60;
      ["name_es"] = "Libranza del artesano: anguila escama petrea";
      ["req"] = 55;
   };
   [5156] = {
      ["name_ru"] = "Проверка на порчу";
      ["type"] = "Group";
      ["objective"] = "Seek out and destroy 2 Entropic Beasts and 2 Entropic Horrors while exploring Shatter Scar Vale. After checking to see if the craters there are still filled with corrupt fel water, return to Taronn Redfeather in Felwood.";
      ["sort"] = "Felwood";
      ["name_cn"] = "??腐?";
      ["name_fr"] = "Enquete sur la corruption";
      ["name_de"] = "Die Verderbnis uberprufen";
      ["faction"] = "Horde";
      ["name"] = "Verifying the Corruption";
      ["level"] = 54;
      ["name_es"] = "Investigacion acerca de la corrupcion";
      ["req"] = 48;
   };
   [4495] = {
      ["name_ru"] = "Добрый друг";
      ["type"] = "Solo";
      ["objective"] = "Find Iverron by the cave to the north.";
      ["repgain"] = {
         [69] = 150;
      };
      ["name_fr"] = "Un bon ami";
      ["sort"] = "Shadowglen";
      ["name_cn"] = "好朋友";
      ["followup"] = 3519;
      ["name_de"] = "Ein guter Freund";
      ["faction"] = "Alliance";
      ["name"] = "A Good Friend";
      ["level"] = 4;
      ["name_es"] = "Un buen amigo";
      ["req"] = 2;
   };
   [1166] = {
      ["name_ru"] = "Заботы властителя Мок'Морокка";
      ["type"] = "Group";
      ["objective"] = "Overlord Mok'Morokk in Brackenwall Village wants you to retrieve his grog, snuff and strongbox in Dustwallow Swamp.";
      ["name_fr"] = "Les soucis du Seigneur Mok'Morokk";
      ["sort"] = "Dustwallow Marsh";
      ["name_cn"] = "莫格穆洛克的任?";
      ["reward"] = {
         [1] = 10702;
      };
      ["name_de"] = "[DEPRECATED] Oberanfuhrer Mok'Morokks Sorgen";
      ["faction"] = "Horde";
      ["name"] = "Overlord Mok'Morokk's Concern";
      ["level"] = 43;
      ["name_es"] = "Las pertenencias del senor supremo Mok'Morokk";
      ["req"] = 38;
   };
   [5204] = {
      ["name_ru"] = "Возмездие Света";
      ["type"] = "Solo";
      ["name_fr"] = "Le chatiment de la Lumiere";
      ["next"] = 5385;
      ["name_de"] = "Vergeltung des Lichts";
      ["reward"] = {
         [1] = 13562;
      };
      ["name_cn"] = "光明的?戒";
      ["objective"] = "Return to Jaedenar and kill the succubus Rakaiah before finding the Remains of Trey Lightforge.";
      ["faction"] = "Horde";
      ["name"] = "Retribution of the Light";
      ["sort"] = "Felwood";
      ["prev"] = 5203;
      ["prequests"] = {
         [1] = 5203;
      };
      ["level"] = 57;
      ["name_es"] = "La reprension de la Luz";
      ["req"] = 49;
   };
   [5220] = {
      ["name_ru"] = "Возвращение в Лагерь Промозглого Ветра";
      ["type"] = "Solo";
      ["name_fr"] = "Retour au camp du Noroit";
      ["repgain"] = {
         [469] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Zugwindlager";
      ["name"] = "Return to Chillwind Camp";
      ["name_cn"] = "返回冰??";
      ["objective"] = "Bring the Filled Dalson's Tears Bottle to High Priestess MacDonnell at Chillwind Camp, Western Plaguelands.";
      ["next"] = 5222;
      ["faction"] = "Alliance";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5219;
      ["prequests"] = {
         [1] = 5219;
      };
      ["level"] = 55;
      ["name_es"] = "Regresa al Campamento del Orvallo";
      ["req"] = 50;
   };
   [5236] = {
      ["name_ru"] = "Возвращение в Бастион";
      ["type"] = "Solo";
      ["name_fr"] = "Retour a la Barricade";
      ["repgain"] = {
         [67] = 75;
         [529] = 75;
      };
      ["name_de"] = "Ruckkehr zum Bollwerk";
      ["name_cn"] = "返回亡?壁?";
      ["name"] = "Return to the Bulwark";
      ["objective"] = "Bring the Filled Gahrron's Withering Bottle to Shadow Priestess Vandis at the Bulwark, Western Plaguelands.";
      ["faction"] = "Horde";
      ["sort"] = "Western Plaguelands";
      ["prev"] = 5235;
      ["prequests"] = {
         [1] = 5235;
      };
      ["level"] = 58;
      ["name_es"] = "Regresa a El Baluarte";
      ["req"] = 50;
   };
   [5252] = {
      ["name_ru"] = "Раскаявшийся высокорожденный";
      ["type"] = "Solo";
      ["name_fr"] = "Une Bien-nee pleine de remords";
      ["repgain"] = {
         [69] = 25;
         [54] = 25;
         [72] = 25;
         [47] = 25;
      };
      ["name_de"] = "Reuevolle Hochgeborene";
      ["name"] = "Remorseful Highborne";
      ["name_cn"] = "悔恨的上?精?";
      ["objective"] = "Speak with Wynd Nightchaser in Starfall Village, and ask about the proper place for the Crystal of Zin-Malor.";
      ["next"] = 5253;
      ["faction"] = "Alliance";
      ["sort"] = "Winterspring";
      ["prev"] = 5248;
      ["prequests"] = {
         [1] = 5248;
      };
      ["level"] = 58;
      ["name_es"] = "Altonato arrepentido";
      ["req"] = 53;
   };
   [1206] = {
      ["name_ru"] = "Ярлу нужны глаза";
      ["type"] = "Solo";
      ["name_fr"] = "Jarl a besoin d’yeux";
      ["next"] = 1203;
      ["name_de"] = "Jarl braucht Augen";
      ["name_cn"] = "加?和蜘蛛眼";
      ["objective"] = "Bring 20 Unpopped Darkmist Eyes to Swamp Eye\" Jarl at the Swamplight Manor.\"";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "Jarl Needs Eyes";
      ["prev"] = 1218;
      ["prequests"] = {
         [1] = 1218;
      };
      ["level"] = 35;
      ["name_es"] = "Jarl necesita ojos";
      ["req"] = 30;
   };
   [5284] = {
      ["name_ru"] = "Путь оружейника";
      ["type"] = "Solo";
      ["objective"] = "To become a Weaponsmith, you must make the following items and return them to Ironus: 4 Moonsteel Broadswords, 4 Massive Iron Axes, 2 Heavy Mithril Axes, and 2 Big Black Maces.$B";
      ["sort"] = "Blacksmithing";
      ["name_cn"] = "武器?造?之道";
      ["name_fr"] = "La voie du Forgeron d'armes";
      ["name_de"] = "Der Weg des Waffenschmieds...";
      ["faction"] = "Alliance";
      ["name"] = "The Way of the Weaponsmith";
      ["level"] = 40;
      ["name_es"] = "El arte del forjador de armas";
      ["req"] = 40;
   };
   [1244] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["next"] = 1245;
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Find the Defias Docket and return it to Watcher Backus in Duskwood.";
      ["series"] = 5;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1243;
      ["prequests"] = {
         [1] = 1243;
      };
      ["level"] = 30;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [5441] = {
      ["name_ru"] = "Ленивые батраки";
      ["type"] = "Solo";
      ["objective"] = "Use the Foreman's Blackjack on Lazy Peons when they're sleeping.  Wake up 5 peons, then return the Foreman's Blackjack to Foreman Thazz'ril in the Valley of Trials.";
      ["next"] = 6394;
      ["name_fr"] = "Les peons paresseux";
      ["sort"] = "Valley of Trials";
      ["name_cn"] = "?惰的苦工";
      ["repgain"] = {
         [530] = 350;
         [76] = 350;
      };
      ["name_de"] = "Faule Peons";
      ["faction"] = "Horde";
      ["name"] = "Lazy Peons";
      ["level"] = 4;
      ["name_es"] = "Peones vagos";
      ["req"] = 3;
   };
   [1264] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["name_fr"] = "Un diplomate a disparu";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Der vermisste Diplomat";
      ["name"] = "The Missing Diplomat";
      ["name_cn"] = "失踪的使?";
      ["objective"] = "Find Commander Samaul in Dustwallow Marsh.";
      ["next"] = 1265;
      ["faction"] = "Alliance";
      ["sort"] = "Stormwind City";
      ["prev"] = 1250;
      ["prequests"] = {
         [1] = 1250;
      };
      ["level"] = 33;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1274] = {
      ["name_ru"] = "Пропавший дипломат";
      ["type"] = "Solo";
      ["objective"] = "Find Bishop DeLavey in Stormwind Keep.";
      ["next"] = 1241;
      ["name_fr"] = "Un diplomate a disparu";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "失踪的使?";
      ["series"] = 1;
      ["name_de"] = "Der vermisste Diplomat";
      ["faction"] = "Alliance";
      ["name"] = "The Missing Diplomat";
      ["level"] = 28;
      ["name_es"] = "El diplomatico desaparecido";
      ["req"] = 28;
   };
   [1276] = {
      ["name_ru"] = "Черный Щит";
      ["type"] = "Solo";
      ["name_fr"] = "Le Bouclier noir";
      ["name_de"] = "[DEPRECATED] Der schwarze Schild";
      ["name_cn"] = "黑色盾牌";
      ["objective"] = "Show the Blackened Iron Shield to Mosarn in Thunder Bluff.";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "The Black Shield";
      ["prev"] = 1323;
      ["prequests"] = {
         [1] = 1323;
      };
      ["level"] = 37;
      ["name_es"] = "El escudo negro";
      ["req"] = 30;
   };
   [5601] = {
      ["name_ru"] = "Сестренка Памела";
      ["type"] = "Solo";
      ["objective"] = "Find Pamela Redpath in Darrowshire.";
      ["next"] = 5149;
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "小妹妹?米拉";
      ["name_fr"] = "Pamela, ma s?ur";
      ["followup"] = 5149;
      ["name_de"] = "Schwester Pamela";
      ["faction"] = "Horde";
      ["name"] = "Sister Pamela";
      ["level"] = 55;
      ["name_es"] = "Pamela, mi hermana";
      ["req"] = 50;
   };
   [8469] = {
      ["name_ru"] = "Бусы для Сальфы";
      ["type"] = "Solo";
      ["objective"] = "The Winterfall are known to carry spirit beads to ward against foul spirits. These beads have clearly failed in their purpose, as the Winterfall themselves are the agents of corruption. Bring to me these spirit beads from fallen Winterfall furbolgs; for every set of five you bring me, you will earn recognition amongst the Timbermaw.";
      ["repgain"] = {
         [576] = 50;
      };
      ["name_de"] = "Perlen fur Salfa";
      ["name_cn"] = "???法的珠串";
      ["name_fr"] = "Des perles pour Salfa";
      ["name"] = "Beads for Salfa";
      ["faction"] = "Horde";
      ["sort"] = "Felwood";
      ["prev"] = 8464;
      ["prequests"] = {
         [1] = 8464;
      };
      ["level"] = 56;
      ["name_es"] = "Cuentas para Salfa";
      ["req"] = 50;
   };
   [1801] = {
      ["name_ru"] = "Фолиант заговора";
      ["type"] = "Solo";
      ["objective"] = "Speak with Jorah Annison in the Undercity.";
      ["next"] = 1803;
      ["name_fr"] = "Tome de la Cabale";
      ["sort"] = "Warlock";
      ["name_cn"] = "??之?";
      ["series"] = 1;
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Foliant der Kabale";
      ["faction"] = "Horde";
      ["name"] = "Tome of the Cabal";
      ["level"] = 30;
      ["name_es"] = "Libro del conciliabulo";
      ["req"] = 30;
   };
   [8629] = {
      ["name_ru"] = "Набедренники Мстителя";
      ["objective"] = "Bring the Skin of the Great Sandworm, 2 Idols of Strife, 5 Bronze Scarabs and 5 Ivory Scarabs to Kandrostrasz inside Ahn'Qiraj. You must also attain Friendly reputation with the Brood of Nozdormu to complete this quest.";
      ["name_cn"] = "?仇者的?腿";
      ["sort"] = "Ahn'Qiraj";
      ["level"] = 60;
      ["type"] = "Raid";
      ["name_fr"] = "Les garde-jambes du Vengeur";
      ["repgain"] = {
         [910] = 250;
      };
      ["name_de"] = "Beinschutzer des Rachers";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21390;
      };
      ["name"] = "Avenger's Legguards";
      ["prev"] = 8579;
      ["prequests"] = {
         [1] = 8579;
      };
      ["faction"] = "Alliance";
      ["name_es"] = "Las musleras del Vengador";
      ["req"] = 60;
   };
   [3881] = {
      ["name_ru"] = "Спасение экспедиции";
      ["type"] = "Solo";
      ["objective"] = "Bring a Crate of Foodstuffs and Research Equipment to Williden Marshal in Un'Goro Crater.";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "?救物?";
      ["name_fr"] = "Le sauvetage de l'expedition";
      ["name_de"] = "Rettungsexpedition";
      ["faction"] = "Horde";
      ["name"] = "Expedition Salvation";
      ["level"] = 53;
      ["name_es"] = "Salvar a la expedicion";
      ["req"] = 48;
   };
   [1386] = {
      ["name_ru"] = "Нападение на племя Колкар";
      ["type"] = "Solo";
      ["name_fr"] = "Assaut sur les Kolkar";
      ["next"] = 1369;
      ["name_de"] = "Angriff auf die Kolkar";
      ["objective"] = "Maintain your reputation with the Magram. Kill 12 Kolkar Centaurs, 12 Kolkar Scouts and 6 Kolkar Maulers, then return to Warug in the Magram Village in Desolace.";
      ["name_cn"] = "突?科??部族";
      ["sort"] = "Desolace";
      ["faction"] = "Alliance";
      ["name"] = "Assault on the Kolkar";
      ["followup"] = 1369;
      ["prev"] = 1385;
      ["prequests"] = {
         [1] = 1385;
      };
      ["level"] = 32;
      ["name_es"] = "Ataca a los Kolkar";
      ["req"] = 30;
   };
   [1382] = {
      ["name_ru"] = "Странный союз";
      ["type"] = "Solo";
      ["objective"] = "Gain a Friendly reputation with the Gelkis, then speak with Uthek the Wise.";
      ["next"] = 1384;
      ["name_fr"] = "Une etrange alliance";
      ["sort"] = "Desolace";
      ["name_cn"] = "奇怪的?盟";
      ["repgain"] = {
         [92] = 250;
      };
      ["name_de"] = "Seltsame Allianz";
      ["faction"] = "Alliance";
      ["name"] = "Strange Alliance";
      ["level"] = 35;
      ["name_es"] = "Extrana alianza";
      ["req"] = 30;
   };
   [2767] = {
      ["name_ru"] = "Спасти КПХ-22/FE!";
      ["objective"] = " safe place so it can begin a lengthy take-off procedure.  It has built-in cloaking";
      ["name_cn"] = "拯救OOX-22/FE！";
      ["sort"] = "Feralas";
      ["level"] = 45;
      ["type"] = "Solo";
      ["name_fr"] = "A la rescousse de OOX-22/FE?!";
      ["repgain"] = {
         [0] = 21;
      };
      ["name_de"] = "Rettet OOX-22/FE";
      ["followup"] = 3721;
      ["faction"] = "Horde";
      ["name"] = "Rescue OOX-22/FE!";
      ["prev"] = 2766;
      ["prequests"] = {
         [1] = 2766;
      };
      ["reward"] = {
         [1] = 1;
         [2] = 1;
      };
      ["name_es"] = "!Escolta a OOX-22/FE!";
      ["req"] = 40;
   };
   [5508] = {
      ["name_ru"] = "Камни осквернителей Плети";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 25;
      };
      ["sort"] = "Eastern Plaguelands";
      ["name_fr"] = "Pierres du Fleau des corrupteurs";
      ["name_cn"] = "堕落者的天?石";
      ["reward"] = {
         [1] = 12844;
      };
      ["name_de"] = "Geiselsteine des Verderbers";
      ["faction"] = "Horde";
      ["name"] = "Corruptor's Scourgestones";
      ["level"] = 55;
      ["name_es"] = "Piedras de la Plaga del corruptor";
      ["req"] = 50;
   };
   [5524] = {
      ["name_ru"] = "Многоцветное оплечье Рассвета";
      ["type"] = "Solo";
      ["objective"] = "Bring 25 Argent Dawn Valor Tokens to Quartermaster Hasana at the Bulwark, Western Plaguelands.";
      ["repgain"] = {
         [529] = 350;
      };
      ["sort"] = "Western Plaguelands";
      ["name_fr"] = "Le mantelet de l'Aube chromatique";
      ["name_cn"] = "多彩黎明?肩";
      ["reward"] = {
         [1] = 18182;
      };
      ["name_de"] = "Der Chromatische Mantel der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Chromatic Mantle of the Dawn";
      ["level"] = 60;
      ["name_es"] = "Manto del Alba cromatico";
      ["req"] = 55;
   };
   [1436] = {
      ["name_ru"] = "Отношения с Альянсом";
      ["type"] = "Solo";
      ["objective"] = "Speak to Keldran in Orgrimmar.";
      ["repgain"] = {
         [76] = 250;
      };
      ["name_de"] = "Allianzbeziehungen";
      ["reward"] = {
         [1] = 6744;
         [2] = 6745;
      };
      ["name_cn"] = "?盟?系";
      ["name_fr"] = "Les relations de l'Alliance";
      ["faction"] = "Horde";
      ["name"] = "Alliance Relations";
      ["sort"] = "Orgrimmar";
      ["prev"] = 1435;
      ["prequests"] = {
         [1] = 1435;
      };
      ["level"] = 33;
      ["name_es"] = "Las relaciones de la Alianza";
      ["req"] = 30;
   };
   [2903] = {
      ["name_ru"] = "Планы битвы";
      ["type"] = "Solo";
      ["objective"] = "Bring the Woodpaw Battle Plans to Hadoken Swiftstrider in Camp Mojache.";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Die Schlachtplane";
      ["reward"] = {
         [1] = 9661;
         [2] = 9662;
      };
      ["name_cn"] = "作???";
      ["name_fr"] = "Les plans de bataille";
      ["faction"] = "Horde";
      ["name"] = "The Battle Plans";
      ["sort"] = "Feralas";
      ["prev"] = 2902;
      ["prequests"] = {
         [1] = 2902;
      };
      ["level"] = 43;
      ["name_es"] = "Los planes de batalla";
      ["req"] = 39;
   };
   [2198] = {
      ["name_ru"] = "Рассыпавшееся ожерелье";
      ["type"] = "Dungeon";
      ["objective"] = " you will need to learn about its origins.  Perhaps the seal and the initials are a start...\"";
      ["next"] = 2199;
      ["sort"] = "Uldaman";
      ["name_cn"] = "破碎的??";
      ["name_fr"] = "Le Collier brise";
      ["name_de"] = "Die zerrissene Halskette";
      ["faction"] = "Alliance";
      ["name"] = "The Shattered Necklace";
      ["level"] = 41;
      ["name_es"] = "El collar hecho anicos";
      ["req"] = 37;
   };
   [2931] = {
      ["name_ru"] = "Поручение Чугонотрубза";
      ["type"] = "Dungeon";
      ["objective"] = "Speak with Master Mechanic Castpipe in Ironforge.";
      ["next"] = 2930;
      ["name_fr"] = "Du travail pour Fontuyau";
      ["sort"] = "Gnomeregan";
      ["name_cn"] = "?斯派普的任?";
      ["repgain"] = {
         [54] = 10;
      };
      ["name_de"] = "Gussmuffs Auftrag";
      ["faction"] = "Alliance";
      ["name"] = "Castpipe's Task";
      ["level"] = 28;
      ["name_es"] = "Trabajar para Funditubo";
      ["req"] = 25;
   };
   [1476] = {
      ["name_ru"] = "Чистые сердца";
      ["type"] = "Solo";
      ["name_fr"] = "Des c?urs purs";
      ["next"] = 1474;
      ["name_de"] = "Herzen der Reinen";
      ["objective"] = "Bring the hearts of Dalin Forgewright and Comar Villard to Carendin Halgar in the Temple of the Damned.";
      ["name_cn"] = "??者之心";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["faction"] = "Horde";
      ["name"] = "Hearts of the Pure";
      ["prev"] = 1472;
      ["prequests"] = {
         [1] = 1472;
      };
      ["level"] = 20;
      ["name_es"] = "Corazones puros";
      ["req"] = 20;
   };
   [5881] = {
      ["name_ru"] = "Смена караула";
      ["type"] = "Solo";
      ["objective"] = "Maggran wishes you to deliver a letter to Grish Longrunner at the Great Lift in the Barrens.";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_fr"] = "Puiser dans les reserves";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "召回?兵";
      ["name_de"] = "Hinzurufen der Reserve";
      ["faction"] = "Horde";
      ["name"] = "Calling in the Reserves";
      ["level"] = 28;
      ["name_es"] = "La sustitucion";
      ["req"] = 23;
   };
   [5636] = {
      ["name_ru"] = "Молитва отчаяния";
      ["type"] = "Solo";
      ["objective"] = "Speak to High Priestess Laurena in Stormwind.";
      ["name_de"] = "Verzweifeltes Gebet";
      ["sort"] = "Priest";
      ["name_cn"] = "?望祷言";
      ["name_fr"] = "Priere du desespoir";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Human";
         [2] = "Dwarf";
      };
      ["name"] = "Desperate Prayer";
      ["level"] = 10;
      ["name_es"] = "Oracion desesperada";
      ["req"] = 10;
   };
   [5652] = {
      ["name_ru"] = "Обессиливающий сглаз";
      ["type"] = "Solo";
      ["objective"] = "Speak to Ur'kyo in Orgrimmar.";
      ["name_de"] = "Verhexung der Schwache";
      ["name_cn"] = "虚弱妖?";
      ["sort"] = "Priest";
      ["classes"] = {
         [1] = "Priest";
      };
      ["races"] = {
         [1] = "Troll";
      };
      ["name"] = "Hex of Weakness";
      ["level"] = 10;
      ["name_es"] = "Maleficio de Debilidad";
      ["req"] = 10;
   };
   [1516] = {
      ["name_ru"] = "Зов Земли";
      ["type"] = "Solo";
      ["objective"] = "Bring 2 Felstalker Hooves to Canaga Earthcaller in the Valley of Trials.";
      ["next"] = 1517;
      ["name_fr"] = "L'appel de la terre";
      ["sort"] = "Shaman";
      ["name_cn"] = "大地的召?";
      ["series"] = 1;
      ["classes"] = {
         [1] = "Shaman";
      };
      ["name_de"] = "Ruf der Erde";
      ["faction"] = "Horde";
      ["name"] = "Call of Earth";
      ["level"] = 4;
      ["name_es"] = "La llamada de la tierra";
      ["req"] = 4;
   };
   [7581] = {
      ["name_ru"] = "Тюремные кандалы";
      ["type"] = "Dungeon";
      ["objective"] = "Travel to Dire Maul in Feralas and recover 15 Satyr Blood from the Wildspawn Satyr that inhabit the Warpwood Quarter. Return to Daio in the Tainted Scar when this is done.$B";
      ["next"] = 7583;
      ["sort"] = "Warlock";
      ["name_cn"] = "?牢之?";
      ["name_fr"] = "Les ancrages de la prison";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["followup"] = 7583;
      ["name_de"] = "Das Fundament des Gefangnisses";
      ["faction"] = "Horde";
      ["name"] = "The Prison's Bindings";
      ["level"] = 60;
      ["name_es"] = "Las selladuras de la prision";
      ["req"] = 60;
   };
   [1526] = {
      ["name_ru"] = "Зов Огня";
      ["objective"] = "Defeat the Minor Manifestation of Fire, and place the Glowing Ember in the brazier atop the Shrine of Eternal Flame.";
      ["name_cn"] = "火?的召?";
      ["sort"] = "Shaman";
      ["level"] = 13;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel du feu";
      ["next"] = 1527;
      ["name_de"] = "Ruf des Feuers";
      ["reward"] = {
         [1] = 6654;
      };
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Fire";
      ["prev"] = 1525;
      ["prequests"] = {
         [1] = 1525;
      };
      ["series"] = 3;
      ["name_es"] = "La llamada del fuego";
      ["req"] = 10;
   };
   [3063] = {
      ["name_ru"] = "Месть стае Студеных Ключей";
      ["type"] = "Solo";
      ["objective"] = "Talo Thornhoof wants you to kill 4 Northspring Harpies, 4 Northspring Roguefeathers, 4 Northspring Windcallers, and 4 Northspring Slayers.";
      ["repgain"] = {
         [81] = 150;
      };
      ["name_fr"] = "Se venger des Ruissenord";
      ["sort"] = "Feralas";
      ["name_cn"] = "??身人的?仇";
      ["name_de"] = "Rache an den Nordschwingen";
      ["faction"] = "Horde";
      ["name"] = "Vengeance on the Northspring";
      ["level"] = 50;
      ["name_es"] = "Venganza contra Nortearroyo";
      ["req"] = 45;
   };
   [1534] = {
      ["name_ru"] = "Зов Воды";
      ["objective"] = "Fill the Empty Blue Waterskin at the Ruins of Stardust in Ashenvale and return to Brine in the Barrens.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["level"] = 23;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 220;
      ["name_de"] = "Ruf des Wassers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 1536;
      ["prequests"] = {
         [1] = 1536;
      };
      ["series"] = 4;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [1536] = {
      ["name_ru"] = "Зов Воды";
      ["objective"] = "Fill the Empty Red Waterskin at the well in Tarren Mill and return to Brine in the Barrens.";
      ["name_cn"] = "水之召?";
      ["sort"] = "Shaman";
      ["level"] = 22;
      ["type"] = "Solo";
      ["name_fr"] = "L'appel de l'eau";
      ["next"] = 1534;
      ["name_de"] = "Ruf des Wassers";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["faction"] = "Horde";
      ["name"] = "Call of Water";
      ["prev"] = 1535;
      ["prequests"] = {
         [1] = 1535;
      };
      ["series"] = 3;
      ["name_es"] = "La llamada del agua";
      ["req"] = 20;
   };
   [3631] = {
      ["name_ru"] = "Призывание коня Скверны";
      ["type"] = "Solo";
      ["objective"] = "Speak to Strahad Farsan in the Barrens.";
      ["next"] = 4490;
      ["name_cn"] = "召?地???";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name_de"] = "Teufelsross beschworen";
      ["faction"] = "Horde";
      ["name"] = "Summon Felsteed";
      ["level"] = 40;
      ["name_es"] = "Invoca un corcel vil";
      ["req"] = 40;
   };
   [4117] = {
      ["name_ru"] = "Оскверненный кнутокорень";
      ["type"] = "Solo";
      ["objective"] = "";
      ["sort"] = "Felwood";
      ["name_cn"] = "被腐化的鞭根草";
      ["name_fr"] = "La navetille corrompue";
      ["name_de"] = "Verderbte Peitscherwurzel";
      ["faction"] = "Horde";
      ["name"] = "Corrupted Whipper Root";
      ["level"] = 55;
      ["name_es"] = "Blancoria corrupta";
      ["req"] = 48;
   };
   [1558] = {
      ["name_ru"] = "Каменная плотина";
      ["type"] = "Solo";
      ["name_fr"] = "Le barrage de Formepierre";
      ["repgain"] = {
         [469] = 75;
      };
      ["name_de"] = "Der Steinwerkdamm";
      ["name_cn"] = "巨石水?";
      ["name"] = "The Stonewrought Dam";
      ["objective"] = "Take the orphan to the Stonewrought Dam in Loch Modan.  You should take him to the middle of the dam so he can see out over the giant waterfall.";
      ["faction"] = "Alliance";
      ["sort"] = "Children's Week";
      ["prev"] = 1468;
      ["prequests"] = {
         [1] = 1468;
      };
      ["level"] = 60;
      ["name_es"] = "Presa de las Tres Cabezas";
      ["req"] = 10;
   };
   [6364] = {
      ["name_ru"] = "Возвращение к Джахану";
      ["type"] = "Solo";
      ["name_fr"] = "Retourner vers Jahan";
      ["repgain"] = {
         [81] = 350;
      };
      ["name_de"] = "Ruckkehr zu Varg";
      ["name_cn"] = "向加翰回?";
      ["objective"] = "Buy a wind rider to the Crossroads from the wind rider master Tal, then bring Ahanu's Leather Goods to Jahan Hawkwing.";
      ["sort"] = "The Barrens";
      ["name"] = "Return to Jahan";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 6363;
      ["prequests"] = {
         [1] = 6363;
      };
      ["level"] = 10;
      ["name_es"] = "Regresa junto a Varg";
      ["req"] = 10;
   };
   [6388] = {
      ["name_ru"] = "Грит Турден";
      ["type"] = "Solo";
      ["name_fr"] = "Gryth Thurden";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["name_de"] = "Gryth Thurden";
      ["objective"] = "Bring the Honorary Picks to Gryth Thurden in Ironforge.";
      ["name_cn"] = "格莱斯・瑟登";
      ["next"] = 6392;
      ["sort"] = "Loch Modan";
      ["name"] = "Gryth Thurden";
      ["races"] = {
         [1] = "Dwarf";
         [2] = "Gnome";
      };
      ["prev"] = 6391;
      ["prequests"] = {
         [1] = 6391;
      };
      ["level"] = 10;
      ["name_es"] = "Gryth Thurden";
      ["req"] = 10;
   };
   [5844] = {
      ["name_ru"] = "Добро пожаловать!";
      ["type"] = "Solo";
      ["name_fr"] = "Bienvenue !";
      ["name_cn"] = "?迎!*";
      ["name_de"] = "Willkommen!";
      ["objective"] = "Bring the Camp Narache Gift Voucher to Vorn Skyseer.";
      ["sort"] = "Camp Narache";
      ["name"] = "Welcome!";
      ["reward"] = {
         [1] = 13584;
         [2] = 13583;
         [3] = 13582;
      };
      ["races"] = {
         [1] = "Tauren";
      };
      ["level"] = 1;
      ["name_es"] = "!Te damos la bienvenida!";
      ["req"] = 1;
   };
   [4421] = {
      ["name_ru"] = "Порча Нефритового Пламени";
      ["type"] = "Solo";
      ["objective"] = "Kill 11 Jadefire Felsworns, 9 Jadefire Shadowstalkers, 9 Jadefire Rogues, and Xavathras. Return to Eridan Bluewind in Felwood when the task has been completed.";
      ["sort"] = "Felwood";
      ["name_cn"] = "碧火?特";
      ["name_fr"] = "La corruption des Jadefeu";
      ["name_de"] = "[DEPRECATED] Die Verderbnis der Jadefeuer";
      ["faction"] = "Alliance";
      ["name"] = "The Corruption of the Jadefire";
      ["level"] = 54;
      ["name_es"] = "La corrupcion de los Fuego de Jade";
      ["req"] = 49;
   };
   [2298] = {
      ["name_ru"] = "Королевская облава";
      ["type"] = "Solo";
      ["name_fr"] = "Kingly Shakedown";
      ["name_de"] = "Konigliche Erpressung";
      ["objective"] = "Travel to Stormwind and seek out Renzik The Shiv.\"\"";
      ["name_cn"] = "国王的搜?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Kingly Shakedown";
      ["prev"] = 2299;
      ["prequests"] = {
         [1] = 2299;
      };
      ["level"] = 16;
      ["name_es"] = "Una regia sacudida";
      ["req"] = 16;
   };
   [5892] = {
      ["name_ru"] = "Припасы Железного рудника";
      ["type"] = "PvP";
      ["objective"] = "Bring 10 Irondeep Supplies to the Alliance Quartermaster in Dun Baldar.";
      ["repgain"] = {
         [47] = 25;
         [730] = 2;
      };
      ["name_fr"] = "Fournitures de Gouffrefer";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "深??洞的??";
      ["name_de"] = "Vorrate der Eisenschachtmine";
      ["faction"] = "Alliance";
      ["name"] = "Irondeep Supplies";
      ["level"] = 60;
      ["name_es"] = "Suministros de Ferrohondo";
      ["req"] = 51;
   };
   [1640] = {
      ["name_ru"] = "Побить Бартлби";
      ["type"] = "Solo";
      ["name_fr"] = "Battre Bartleby";
      ["next"] = 1665;
      ["name_de"] = "Besiegt Bartleby";
      ["objective"] = "Beat Bartleby, then talk to him.";
      ["name_cn"] = "??巴特莱比";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Beat Bartleby";
      ["prev"] = 1639;
      ["prequests"] = {
         [1] = 1639;
      };
      ["level"] = 10;
      ["name_es"] = "Vence a Bartleby";
      ["req"] = 10;
   };
   [5924] = {
      ["name_ru"] = "Голос Природы";
      ["type"] = "Solo";
      ["objective"] = "Speak with Mathrengyl Bearwalker in the Cenarion Enclave, Darnassus.";
      ["next"] = 5921;
      ["name_de"] = "Dem Ruf folgen";
      ["sort"] = "Druid";
      ["name_cn"] = "回?召?";
      ["name_fr"] = "Ecouter l'appel";
      ["classes"] = {
         [1] = "Druid";
      };
      ["races"] = {
         [1] = "NightElf";
      };
      ["name"] = "Heeding the Call";
      ["level"] = 10;
      ["name_es"] = "Escucha la llamada";
      ["req"] = 10;
   };
   [2260] = {
      ["name_ru"] = "Директива Эриона";
      ["type"] = "Solo";
      ["name_fr"] = "L'ordre d'Erion";
      ["name_de"] = "Erions Befehl";
      ["objective"] = "Travel to Stormwind City and seek council with Renzik The Shiv.\"$B\"";
      ["name_cn"] = "艾瑞安的命令";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Erion's Behest";
      ["prev"] = 2259;
      ["prequests"] = {
         [1] = 2259;
      };
      ["level"] = 16;
      ["name_es"] = "La orden de Erion";
      ["req"] = 16;
   };
   [4621] = {
      ["name_ru"] = "Стой, Адмирал!";
      ["type"] = "Solo";
      ["objective"] = "Slay Fleet Master Seahorn and Baron Revilgaz of Booty Bay, and then return to Fleet Master Firallon aboard the Crimson Veil off the coast of Stranglethorn Vale.";
      ["name_fr"] = "En avant toute, amiral !";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "敬礼，??司令！";
      ["reward"] = {
         [1] = 12185;
      };
      ["name_de"] = "Segel setzen, Admiral!";
      ["faction"] = "Horde";
      ["name"] = "Avast Ye, Admiral!";
      ["level"] = 60;
      ["name_es"] = "!Adelante, almirante!";
      ["req"] = 55;
   };
   [1678] = {
      ["name_ru"] = "Веджрек";
      ["type"] = "Solo";
      ["name_fr"] = "Vejrek";
      ["next"] = 1680;
      ["name_de"] = "Vejrek";
      ["objective"] = "Bring Vejrek's Head to Muren Stormpike in Ironforge.";
      ["name_cn"] = "?吉雷克";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Vejrek";
      ["prev"] = 1679;
      ["prequests"] = {
         [1] = 1679;
      };
      ["level"] = 11;
      ["name_es"] = "Vejrek";
      ["req"] = 10;
   };
   [1680] = {
      ["name_ru"] = "Тормус Подземная Кузня";
      ["type"] = "Solo";
      ["name_fr"] = "Tormus Forge-profonde";
      ["next"] = 1681;
      ["name_de"] = "Tormus Tiefenschmied";
      ["objective"] = "Speak with Tormus Deepforge.";
      ["name_cn"] = "托姆斯・深炉";
      ["sort"] = "Warrior";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["faction"] = "Alliance";
      ["name"] = "Tormus Deepforge";
      ["prev"] = 1678;
      ["prequests"] = {
         [1] = 1678;
      };
      ["level"] = 11;
      ["name_es"] = "Tormus Forjahonda";
      ["req"] = 10;
   };
   [6004] = {
      ["name_ru"] = "Неоконченное дело";
      ["type"] = "Solo";
      ["objective"] = "Kill 2 Scarlet Medics, 2 Scarlet Hunters, 2 Scarlet Magi and 2 Scarlet Knights before returning to Kirsta Deepshadow in Western Plaguelands.";
      ["next"] = 6023;
      ["name_fr"] = "Un travail inacheve";
      ["sort"] = "Western Plaguelands";
      ["name_cn"] = "未竟的事?";
      ["series"] = 1;
      ["name_de"] = "Offene Rechnungen";
      ["faction"] = "Horde";
      ["name"] = "Unfinished Business";
      ["level"] = 56;
      ["name_es"] = "Negocios inconclusos";
      ["req"] = 50;
   };
   [2964] = {
      ["name_ru"] = "Новое задание";
      ["type"] = "Solo";
      ["name_fr"] = "Travail imminent";
      ["repgain"] = {
         [47] = 250;
      };
      ["name_de"] = "Eine zukunftige Aufgabe";
      ["name_cn"] = "?一?的任?";
      ["name"] = "A Future Task";
      ["objective"] = "Speak with High Explorer Magellas in Ironforge.";
      ["faction"] = "Alliance";
      ["sort"] = "Ironforge";
      ["prev"] = 2977;
      ["prequests"] = {
         [1] = 2977;
      };
      ["level"] = 50;
      ["name_es"] = "Una tarea futura";
      ["req"] = 45;
   };
   [1706] = {
      ["name_ru"] = "Доспехи Гриманда";
      ["type"] = "Solo";
      ["objective"] = "";
      ["name_de"] = "Grimands Rustung";
      ["name_fr"] = "L'armure de Grimand";
      ["name"] = "Grimand's Armor";
      ["name_cn"] = "格瑞曼德的?甲";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["reward"] = {
         [1] = 6971;
      };
      ["sort"] = "Warrior";
      ["prev"] = 1705;
      ["prequests"] = {
         [1] = 1705;
      };
      ["level"] = 30;
      ["name_es"] = "La armadura de Grimand";
      ["req"] = 20;
   };
   [3451] = {
      ["name_ru"] = "Сигнал \"Взять на борт!\"";
      ["type"] = "Solo";
      ["name_fr"] = "Signal de la recuperation";
      ["name_de"] = "Signal zum Abholen";
      ["reward"] = {
         [1] = 10444;
      };
      ["name_cn"] = "信号?射器";
      ["objective"] = "Speak to Xiggs Fuselighter and get a Standard Issue Flare Gun from him in Ironforge.";
      ["faction"] = "Alliance";
      ["name"] = "Signal for Pickup";
      ["sort"] = "Ironforge";
      ["prev"] = 3450;
      ["prequests"] = {
         [1] = 3450;
      };
      ["level"] = 52;
      ["name_es"] = "Una senal para el envio";
      ["req"] = 45;
   };
   [6068] = {
      ["name_ru"] = "Путь охотника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Thotar at Razor Hill.";
      ["next"] = 6062;
      ["name_de"] = "Der Weg des Jagers";
      ["sort"] = "Hunter";
      ["name_cn"] = "?人之道";
      ["name_fr"] = "La voie du chasseur";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["races"] = {
         [1] = "Orc";
         [2] = "Troll";
      };
      ["name"] = "The Hunter's Path";
      ["level"] = 10;
      ["name_es"] = "El camino del cazador";
      ["req"] = 10;
   };
   [6084] = {
      ["name_ru"] = "Приручение зверя";
      ["objective"] = "Use the Taming Rod to tame a Snow Leopard. Practice your skills, then return to Grif Wildheart in Kharanos.";
      ["name_cn"] = "?服野?";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["level"] = 10;
      ["type"] = "Solo";
      ["name_fr"] = "Dompter la bete";
      ["next"] = 6085;
      ["name_de"] = "Die Zahmung der Bestie";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["sort"] = "Hunter";
      ["name"] = "Taming the Beast";
      ["prev"] = 6064;
      ["prequests"] = {
         [1] = 6064;
      };
      ["series"] = 2;
      ["name_es"] = "Domesticar la bestia";
      ["req"] = 10;
   };
   [2944] = {
      ["name_ru"] = "Супер-щелк FX";
      ["type"] = "Group";
      ["name_fr"] = "Le Preneur d'images FX";
      ["repgain"] = {
         [69] = 250;
      };
      ["name_de"] = "Der Superschnapper FX";
      ["name"] = "The Super Snapper FX";
      ["name_cn"] = "超??影器FX";
      ["objective"] = "Use the Super Snapper FX to take a snapshot of Gammerita, then return to Daryn Lightwind in Rut'theran Village.";
      ["next"] = 2943;
      ["faction"] = "Alliance";
      ["sort"] = "Feralas";
      ["prev"] = 2941;
      ["prequests"] = {
         [1] = 2941;
      };
      ["level"] = 48;
      ["name_es"] = "La Superinstantanea FX";
      ["req"] = 42;
   };
   [1786] = {
      ["name_ru"] = "Фолиант Божественности";
      ["type"] = "Solo";
      ["name_fr"] = "Le Tome de divinite";
      ["next"] = 1787;
      ["name_de"] = "Der Foliant der Offenbarung";
      ["objective"] = "Take the Symbol of Life and resurrect Henze Faulk in Elwynn.";
      ["name_cn"] = "??之?";
      ["sort"] = "Paladin";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["name"] = "The Tome of Divinity";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1781;
      ["prequests"] = {
         [1] = 1781;
      };
      ["level"] = 13;
      ["name_es"] = "Escrito sobre divinidad";
      ["req"] = 12;
   };
   [6132] = {
      ["name_ru"] = "Вытащи меня отсюда!";
      ["type"] = "Solo";
      ["objective"] = "Escort Melizza Brimbuzzle, then speak with Hornizz Brimbuzzle at the Kodo Graveyard in Desolace.";
      ["sort"] = "Desolace";
      ["name_cn"] = "救我出去！";
      ["name_fr"] = "Faites-moi sortir de la?!";
      ["name_de"] = "Holt mich hier raus!";
      ["faction"] = "Horde";
      ["name"] = "Get Me Out of Here!";
      ["level"] = 39;
      ["name_es"] = "!Sacame de aqui!";
      ["req"] = 34;
   };
   [6148] = {
      ["name_ru"] = "Алый Оракул Деметрия";
      ["type"] = "Group";
      ["name_fr"] = "L'Oracle ecarlate, Demetria";
      ["name_de"] = "Das scharlachrote Orakel Demetria";
      ["reward"] = {
         [1] = 16996;
         [2] = 16997;
         [3] = 16998;
      };
      ["name_cn"] = "血色十字??者，德米提雅";
      ["objective"] = "The Scarlet Crusade is on the move. Somewhere along the road from Tyr's Hand to Stratholme you will find the Oracle, Demetria, and her entourage. Hunt her down and slay her. Return to Nathanos Blightcaller should you succeed.";
      ["faction"] = "Horde";
      ["name"] = "The Scarlet Oracle, Demetria";
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 6147;
      ["prequests"] = {
         [1] = 6147;
      };
      ["level"] = 60;
      ["name_es"] = "El Oraculo Escarlata, Demetria";
      ["req"] = 56;
   };
   [8231] = {
      ["name_ru"] = "Охота на волношлепа";
      ["type"] = "Solo";
      ["name_fr"] = "Vandales des flots";
      ["next"] = 8232;
      ["name_de"] = "Wellenjagd";
      ["objective"] = "Bring 6 Wavethrasher Scales to Ogtinc in Azshara.  Ogtinc resides atop the cliffs northeast the Ruins of Eldarath.";
      ["name_cn"] = "碎浪多?怪";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["faction"] = "Horde";
      ["name"] = "Wavethrashing";
      ["prev"] = 8153;
      ["prequests"] = {
         [1] = 8153;
      };
      ["level"] = 52;
      ["name_es"] = "Los vandalos marinos";
      ["req"] = 50;
   };
   [8263] = {
      ["name_ru"] = "Полевой комплект Осквернителей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [510] = 10;
      };
      ["sort"] = "Arathi Basin";
      ["name_fr"] = "Le paquetage de base de Profanateur";
      ["name_cn"] = "?染者基本医?包";
      ["reward"] = {
         [1] = 20229;
      };
      ["name_de"] = "Basisuberlebenspaket der Entweihten";
      ["faction"] = "Horde";
      ["name"] = "Defiler's Basic Care Package";
      ["level"] = 34;
      ["name_es"] = "Botiquin basico de Rapinador";
      ["req"] = 25;
   };
   [8295] = {
      ["name_ru"] = "Громи захватчиков-Среброкрылых!";
      ["type"] = "PvP";
      ["objective"] = "Enter Warsong Gulch and defeat the Alliance, gain a Warsong Gulch Mark of Honor, and bring it to Captain Shatterskull at the Mor'shan Base Camp.";
      ["repgain"] = {
         [889] = 500;
      };
      ["sort"] = "Warsong Gulch";
      ["name_cn"] = "???翼部?";
      ["name_de"] = "Bezwingt die Eindringlinge der Silberschwingen";
      ["faction"] = "Horde";
      ["name"] = "Quell the Silverwing Usurpers";
      ["level"] = 15;
      ["name_es"] = "Acaba con los usurpadores Ala de Plata";
      ["req"] = 10;
   };
   [5730] = {
      ["name_ru"] = "Тайные враги";
      ["objective"] = "Speak to Thrall in Orgrimmar and tell him what you've learned.";
      ["name_cn"] = "?藏的?人";
      ["sort"] = "Orgrimmar";
      ["level"] = 16;
      ["type"] = "Solo";
      ["name_fr"] = "Ennemis caches";
      ["repgain"] = {
         [76] = 350;
      };
      ["name_de"] = "Verborgene Feinde";
      ["reward"] = {
         [1] = 15443;
         [2] = 15445;
         [3] = 15424;
         [4] = 15444;
      };
      ["faction"] = "Horde";
      ["name"] = "Hidden Enemies";
      ["prev"] = 5729;
      ["prequests"] = {
         [1] = 5729;
      };
      ["series"] = 5;
      ["name_es"] = "Enemigos ocultos";
      ["req"] = 9;
   };
   [8359] = {
      ["name_ru"] = "Поиграй мускулами!";
      ["type"] = "Solo";
      ["objective"] = "Do a flex emote at Innkeeper Gryshka, and in exchange you'll receive Orgrimmar Nougat!";
      ["name_fr"] = "Montrer ses muscles pour du nougat";
      ["sort"] = "Hallow's End";
      ["name_cn"] = "?肌肉，?糖果";
      ["reward"] = {
         [1] = 20493;
      };
      ["name_de"] = "Muskelspiel fur Nugat";
      ["faction"] = "Horde";
      ["name"] = "Flexing for Nougat";
      ["level"] = 60;
      ["name_es"] = "Saca musculo a cambio de almendrados";
      ["req"] = 10;
   };
   [8391] = {
      ["name_ru"] = "Завоевание Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Bring 3 Arathi Basin Marks of Honor to an Alliance Brigadier General outside the battlegrounds.";
      ["repgain"] = {
         [509] = 50;
      };
      ["name_cn"] = "占?阿拉希盆地";
      ["name_de"] = "Inbesitznahme des Arathibeckens";
      ["sort"] = "Arathi Basin";
      ["faction"] = "Alliance";
      ["name"] = "Claiming Arathi Basin";
      ["prev"] = 8393;
      ["prequests"] = {
         [1] = 8393;
      };
      ["level"] = 39;
      ["name_es"] = "Reclamo por la Cuenca de Arathi";
      ["req"] = 30;
   };
   [8423] = {
      ["name_ru"] = "Воинское испытание";
      ["type"] = "Solo";
      ["objective"] = "Kill 7 Helboar in the Blasted Lands and return to the Fallen Hero of the Horde.";
      ["next"] = 8424;
      ["sort"] = "Warrior";
      ["name_cn"] = "?士的血脉";
      ["name_fr"] = "Fraternite entre guerriers";
      ["classes"] = {
         [1] = "Warrior";
      };
      ["name_de"] = "Kriegerverwandtschaft";
      ["faction"] = "Horde";
      ["name"] = "Warrior Kinship";
      ["level"] = 52;
      ["name_es"] = "Parentesco guerrero";
      ["req"] = 50;
   };
   [8258] = {
      ["name_ru"] = "Угроза Темного Губителя";
      ["objective"] = "Use the Divination Scryer in the heart of the Great Ossuary's basement in the Scholomance.  Doing so will bring forth spirits you must fight.  Defeating these spirits will summon forth Death Knight Darkreaver; defeat him.$B$BBring Darkreaver's Head to Sagorne Creststrider in the Valley of Wisdom, Orgrimmar.";
      ["name_cn"] = "?克雷?的威?";
      ["sort"] = "Shaman";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "La menace de Ravassombre";
      ["repgain"] = {
         [76] = 500;
         [68] = 500;
         [81] = 500;
         [530] = 500;
      };
      ["name_de"] = "Die Bedrohung durch Schattensichel";
      ["classes"] = {
         [1] = "Shaman";
      };
      ["reward"] = {
         [1] = 20134;
      };
      ["name"] = "The Darkreaver Menace";
      ["prev"] = 7667;
      ["prequests"] = {
         [1] = 7667;
      };
      ["faction"] = "Horde";
      ["name_es"] = "La amenaza de Atracoscuro";
      ["req"] = 60;
   };
   [5062] = {
      ["name_ru"] = "Священное пламя";
      ["type"] = "Solo";
      ["name_fr"] = "Feu sacre";
      ["name_de"] = "Hochheiliges Feuer";
      ["name_cn"] = "神?之火";
      ["objective"] = "Gather 10 bushels of Incendia Agave, and then consult Magatha Grimtotem on Elder Rise in Thunderbluff.";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Sacred Fire";
      ["prev"] = 4865;
      ["prequests"] = {
         [1] = 4865;
      };
      ["level"] = 27;
      ["name_es"] = "El fuego Sagrado";
      ["req"] = 24;
   };
   [8519] = {
      ["name_ru"] = "Пешка на Доске Вечности";
      ["type"] = "Solo";
      ["name_fr"] = "Un pion sur l'Echiquier eternel";
      ["repgain"] = {
         [910] = 200;
      };
      ["name_de"] = "Eine Spielfigur auf dem Schachbrett der Ewigkeit";
      ["name_cn"] = "往日的回?";
      ["name"] = "A Pawn on the Eternal Board";
      ["objective"] = "Learn all that you can of the past, then speak with Anachronos at the Caverns of Time in Tanaris.$B";
      ["faction"] = "Horde";
      ["sort"] = "Silithus";
      ["prev"] = 8305;
      ["prequests"] = {
         [1] = 8305;
      };
      ["level"] = 60;
      ["name_es"] = "Un peon en el ajedrez de la vida";
      ["req"] = 60;
   };
   [8551] = {
      ["name_ru"] = "Сундук капитана";
      ["type"] = "Group";
      ["objective"] = "Bring Smotts' Chest to Hecklebury Smotts in Booty Bay.";
      ["name_fr"] = "Le coffre du capitaine";
      ["sort"] = "Stranglethorn Valley";
      ["name_cn"] = "船?的箱子";
      ["reward"] = {
         [1] = 11469;
      };
      ["name_de"] = "Die Truhe des Kapitans";
      ["faction"] = "Horde";
      ["name"] = "The Captain's Chest";
      ["level"] = 47;
      ["name_es"] = "El cofre del Capitan";
      ["req"] = 40;
   };
   [8583] = {
      ["name_ru"] = "Орде все еще не хватает лилового лотоса!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Purple Lotus to Apothecary Jezel at the Valley of Spirits in Orgrimmar.";
      ["name_de"] = "Die Horde braucht mehr lila Lotus!";
      ["name_fr"] = "La Horde a besoin de plus de lotus pourpre !";
      ["name_cn"] = "部落需要更多紫?花！";
      ["name"] = "The Horde Needs More Purple Lotus!";
      ["faction"] = "Horde";
      ["reward"] = {
         [1] = 21438;
         [2] = 21512;
      };
      ["sort"] = "Ahn'Qiraj War Effort";
      ["prev"] = 8582;
      ["prequests"] = {
         [1] = 8582;
      };
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita mas lotos cardenos!";
      ["req"] = 1;
   };
   [8615] = {
      ["name_ru"] = "Орде не хватает запеченного лосося!";
      ["type"] = "Solo";
      ["objective"] = "Bring 20 Baked Salmon to Chief Sharpclaw at the Valley of Spirits in Orgrimmar.";
      ["name_fr"] = "La Horde a besoin de pains de saumon !";
      ["sort"] = "Ahn'Qiraj War Effort";
      ["name_cn"] = "部落需要???!";
      ["reward"] = {
         [1] = 21438;
         [2] = 21513;
      };
      ["name_de"] = "Die Horde braucht gebackenen Lachs!";
      ["faction"] = "Horde";
      ["name"] = "The Horde Needs Baked Salmon!";
      ["level"] = 60;
      ["name_es"] = "!La Horda necesita salmon asado!";
      ["req"] = 20;
   };
   [8647] = {
      ["name_ru"] = "Предок Грозояр";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Soufflet-de-rage";
      ["name_cn"] = "?怒?者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Heulwut";
      ["faction"] = "Horde";
      ["name"] = "Bellowrage the Elder";
      ["level"] = 60;
      ["name_es"] = "Bramira el Ancestro";
      ["req"] = 1;
   };
   [8679] = {
      ["name_ru"] = "Предок Зловещий Тотем";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [67] = 75;
         [469] = 75;
      };
      ["sort"] = "Lunar Festival";
      ["name_fr"] = "L'Ancien Totem-sinistre";
      ["name_cn"] = "恐怖???者";
      ["reward"] = {
         [1] = 21100;
      };
      ["name_de"] = "Urahne Grimmtotem";
      ["faction"] = "Horde";
      ["name"] = "Grimtotem the Elder";
      ["level"] = 60;
      ["name_es"] = "Totem Siniestro el Ancestro";
      ["req"] = 1;
   };
   [8711] = {
      ["name_ru"] = "Клинок Вечной справедливости";
      ["type"] = "Raid";
      ["objective"] = "Bring 1 Qiraji Spiked Hilt, 2  Amber Idols, 5 Bronze Scarabs and 5 Ivory Scarabs to Warden Haro in Silithus.  You must also attain Exalted reputation with Cenarion Circle to complete this quest.";
      ["name_fr"] = "La lame de justice eternelle";
      ["sort"] = "Ahn'Qiraj";
      ["name_cn"] = "永恒公正??";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 21395;
      };
      ["name_de"] = "Klinge der ewigen Gerechtigkeit";
      ["faction"] = "Alliance";
      ["name"] = "Blade of Eternal Justice";
      ["level"] = 60;
      ["name_es"] = "La hoja de Justicia eterna";
      ["req"] = 60;
   };
   [8743] = {
      ["name_ru"] = "Бей в гонг!";
      ["type"] = "World Event";
      ["objective"] = "";
      ["repgain"] = {
         [910] = 500;
      };
      ["name_de"] = "Schlagt den Gong!";
      ["name_fr"] = "Faites resonner le gong?!";
      ["name_cn"] = "?！";
      ["faction"] = "Horde";
      ["name"] = "Bang a Gong!";
      ["reward"] = {
         [1] = 21176;
      };
      ["sort"] = "Silithus";
      ["prev"] = 8742;
      ["prequests"] = {
         [1] = 8742;
      };
      ["level"] = 60;
      ["name_es"] = "Golpear el gong";
      ["req"] = 60;
   };
   [8775] = {
      ["name_ru"] = "Цель: злюки из Улья Регал";
      ["type"] = "Group";
      ["objective"] = "Kill 30 Hive'Regal Spitfires and report back to Commander Mar'alith at Cenarion Hold in Silithus.  You must also bring Combat Task Briefing IX in order to complete this quest.$B";
      ["repgain"] = {
         [609] = 50;
      };
      ["sort"] = "Silithus";
      ["name_fr"] = "Objectif?: les crache-feu de la Ruche'Regal";
      ["name_cn"] = "目?：雷戈?毒者";
      ["reward"] = {
         [1] = 20802;
      };
      ["name_de"] = "Ziel: Feuerspucker des Regalschwarms";
      ["faction"] = "Horde";
      ["name"] = "Target: Hive'Regal Spitfires";
      ["level"] = 60;
      ["name_es"] = "Objetivo: los escupefuegos Colmen'Regal";
      ["req"] = 60;
   };
   [8807] = {
      ["name_ru"] = "Материалы для гадания";
      ["type"] = "Solo";
      ["objective"] = "Bring 1 Large Brilliant Shard, 1 Large Radiant Shard and 1 Huge Emerald to Geologist Larksbane at Cenarion Hold in Silithus.  You must also bring Logistics Task Briefing V in order to complete this quest.";
      ["name_fr"] = "Le materiel de divination";
      ["sort"] = "Silithus";
      ["name_cn"] = "研究材料";
      ["reward"] = {
         [1] = 20800;
         [2] = 21386;
      };
      ["name_de"] = "Magische Materialien";
      ["faction"] = "Horde";
      ["name"] = "Scrying Materials";
      ["level"] = 60;
      ["name_es"] = "Materiales de vision";
      ["req"] = 60;
   };
   [8839] = {
      ["name_ru"] = "Десять рекомендательных жетонов";
      ["type"] = "Solo";
      ["name_fr"] = "Dix chevalieres de merite";
      ["sort"] = "Reputation";
      ["name_cn"] = "十枚?誉徽章";
      ["objective"] = "";
      ["faction"] = "Alliance";
      ["name"] = "Ten Commendation Signets";
      ["name_de"] = "Zehn Belobigungsabzeichen";
      ["prev"] = 8822;
      ["prequests"] = {
         [1] = 8822;
      };
      ["level"] = 60;
      ["name_es"] = "Diez sellos de honor";
      ["req"] = 1;
   };
   [8871] = {
      ["name_ru"] = "Лунный фестиваль";
      ["type"] = "Solo";
      ["objective"] = "Talk to the Lunar Festival Harbinger in the Park District in Stormwind.  You can also talk to Lunar Festival Harbingers in other capital cities.";
      ["next"] = 8867;
      ["name_fr"] = "La fete lunaire";
      ["sort"] = "Lunar Festival";
      ["name_cn"] = "春?将至！";
      ["repgain"] = {
         [609] = 5;
      };
      ["name_de"] = "Das Mondfest";
      ["faction"] = "Alliance";
      ["name"] = "The Lunar Festival";
      ["level"] = 60;
      ["name_es"] = "El Festival Lunar";
      ["req"] = 1;
   };
   [8903] = {
      ["name_ru"] = "Опасная любовь";
      ["type"] = "Solo";
      ["objective"] = "Get a Stormwind Guard's Card and return it to Aristan Mottar in Stormwind.";
      ["next"] = 9024;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "危?的?情";
      ["name_fr"] = "Les perils de l'amour";
      ["name_de"] = "Gefahrliche Liebschaft";
      ["faction"] = "Alliance";
      ["name"] = "Dangerous Love";
      ["level"] = 70;
      ["name_es"] = "Amor peligroso";
      ["req"] = 10;
   };
   [8935] = {
      ["name_ru"] = "Справедливое вознаграждение";
      ["objective"] = "Bring a Shadowcraft Belt and a set of Shadowcraft Gloves to Deliana in Ironforge.";
      ["name_cn"] = "公平的??";
      ["sort"] = "Ironforge";
      ["level"] = 60;
      ["type"] = "Dungeon";
      ["name_fr"] = "Une juste compensation";
      ["next"] = 8929;
      ["name_de"] = "Die angemessene Entlohnung";
      ["followup"] = 8929;
      ["classes"] = {
         [1] = "Rogue";
      };
      ["faction"] = "Alliance";
      ["name"] = "Just Compensation";
      ["prev"] = 8977;
      ["prequests"] = {
         [1] = 8977;
      };
      ["reward"] = {
         [1] = 22002;
         [2] = 22006;
      };
      ["name_es"] = "Una compensacion justa";
      ["req"] = 58;
   };
   [8967] = {
      ["name_ru"] = "Левая часть амулета Лорда Вальтхалака";
      ["type"] = "Dungeon";
      ["name_fr"] = "Le morceau gauche de l'amulette du seigneur Valthalak";
      ["next"] = 8970;
      ["name_de"] = "Das linke Stuck von Lord Valthalaks Amulett";
      ["objective"] = "Use the Brazier of Beckoning to summon forth the spirit of Isalien and slay her. Return to Bodley inside Blackrock Mountain with the Left Piece of Lord Valthalak's Amulet and the Brazier of Beckoning.";
      ["name_cn"] = "瓦塔拉克?品的左瓣";
      ["sort"] = "Dire Maul";
      ["faction"] = "Horde";
      ["name"] = "The Left Piece of Lord Valthalak's Amulet";
      ["followup"] = 8970;
      ["prev"] = 8963;
      ["prequests"] = {
         [1] = 8963;
      };
      ["level"] = 60;
      ["name_es"] = "La parte izquierda del amuleto de Lord Valthalak";
      ["req"] = 58;
   };
   [8999] = {
      ["name_ru"] = "Сладкое ? на закуску";
      ["type"] = "Dungeon";
      ["name_fr"] = "Garder le meilleur pour la fin";
      ["name_de"] = "Das Beste gibt's zum Schluss";
      ["objective"] = "Give Deliana your Wildheart Cowl and Wildheart Vest.";
      ["reward"] = {
         [1] = 22109;
         [2] = 22113;
      };
      ["name_cn"] = "最后的??";
      ["faction"] = "Alliance";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name"] = "Saving the Best for Last";
      ["sort"] = "Ironforge";
      ["prev"] = 8997;
      ["prequests"] = {
         [1] = 8997;
      };
      ["level"] = 60;
      ["name_es"] = "Guardar lo mejor para el final";
      ["req"] = 58;
   };
   [6564] = {
      ["name_ru"] = "Верность Древним богам";
      ["type"] = "Dungeon";
      ["name_fr"] = "Allegeance aux Dieux tres anciens";
      ["repgain"] = {
         [530] = 150;
      };
      ["name_de"] = "Treue zu den Alten Gottern";
      ["name_cn"] = "上古之神的仆从";
      ["objective"] = " tell all the priestesses to bring the crystals to me. The water elemental spirits are strong within them and they will aid our aquamancers greatly in their own summonings.$B$BBy controlling the power within the crystals";
      ["next"] = 6565;
      ["sort"] = "Blackfathom Deeps";
      ["name"] = "Allegiance to the Old Gods";
      ["faction"] = "Horde";
      ["series"] = 1;
      ["level"] = 22;
      ["name_es"] = "Lealtad a los dioses antiguos";
      ["req"] = 17;
   };
   [9063] = {
      ["name_ru"] = "Землепроходец Торва";
      ["type"] = "Solo";
      ["objective"] = "Speak with Torwa Pathfinder in Un'Goro Crater.";
      ["next"] = 9052;
      ["sort"] = "Druid";
      ["name_cn"] = "托?瓦・?路者";
      ["name_fr"] = "Torwa le Guide";
      ["classes"] = {
         [1] = "Druid";
      };
      ["name_de"] = "Torwa Pfadfinder";
      ["faction"] = "Horde";
      ["name"] = "Torwa Pathfinder";
      ["level"] = 52;
      ["name_es"] = "Torwa Abrecaminos";
      ["req"] = 50;
   };
   [9095] = {
      ["name_ru"] = "Одеяние ледяного огня";
      ["type"] = "Raid";
      ["name_fr"] = "La robe de givrefeu";
      ["name_de"] = "Frostfeuerrobe";
      ["objective"] = "Archmage Angela Dosantos at Light's Hope Chapel in the Eastern Plaguelands will make a Frostfire Robe if you bring her the following: 1 Desecrated Robe, 25 Wartorn Cloth Scraps, 4 Mooncloth and 2 Nexus Crystals.";
      ["reward"] = {
         [1] = 22496;
      };
      ["name_cn"] = "霜火?袍";
      ["faction"] = "Horde";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Frostfire Robe";
      ["sort"] = "Naxxramas";
      ["prev"] = 9033;
      ["prequests"] = {
         [1] = 9033;
      };
      ["level"] = 60;
      ["name_es"] = "La toga de Fuego de Escarcha";
      ["req"] = 60;
   };
   [9127] = {
      ["name_ru"] = "Обломки костей";
      ["type"] = "Solo";
      ["objective"] = "";
      ["repgain"] = {
         [529] = 10;
      };
      ["name_de"] = "Knochenfragmente";
      ["name_fr"] = "Des fragments d'os";
      ["name_cn"] = "白骨碎片";
      ["faction"] = "Horde";
      ["name"] = "Bone Fragments";
      ["reward"] = {
         [1] = 22524;
      };
      ["sort"] = "Eastern Plaguelands";
      ["prev"] = 9126;
      ["prequests"] = {
         [1] = 9126;
      };
      ["level"] = 60;
      ["name_es"] = "Trozos de hueso";
      ["req"] = 55;
   };
   [6628] = {
      ["name_ru"] = "Испытание знаний";
      ["type"] = "Solo";
      ["name_fr"] = "L'epreuve de la Connaissance";
      ["next"] = 1394;
      ["name_de"] = "Test der Lehre";
      ["name"] = "Test of Lore";
      ["name_cn"] = "知???";
      ["objective"] = "Answer Parqual Fintallas' question successfully and then speak to him again. He will remain in the Undercity until you are ready.";
      ["series"] = 6;
      ["faction"] = "Horde";
      ["sort"] = "Thousand Needles";
      ["prev"] = 1160;
      ["prequests"] = {
         [1] = 1160;
      };
      ["level"] = 30;
      ["name_es"] = "Prueba de conocimiento";
      ["req"] = 25;
   };
   [6644] = {
      ["name_ru"] = "Покровительство братства, ядро лавы";
      ["type"] = "Dungeon";
      ["objective"] = "";
      ["repgain"] = {
         [59] = 200;
      };
      ["sort"] = "Molten Core";
      ["name_fr"] = "Faveur aupres de la Confrerie, Noyau de lave";
      ["name_cn"] = "兄弟会的好感 - 熔岩之核";
      ["name_de"] = "Gunst der Bruderschaft, Lavakern";
      ["faction"] = "Horde";
      ["name"] = "Favor Amongst the Brotherhood, Lava Core";
      ["level"] = 60;
      ["name_es"] = "El favor de la Hermandad, nucleo de lava";
      ["req"] = 60;
   };
   [9223] = {
      ["name_ru"] = "Превосходное боевое снаряжение ? Уважаемый Рассветом";
      ["type"] = "Solo";
      ["objective"] = "For 20 Insignias of the Dawn and 20 Insignias of the Crusade you may choose an item from the Argent Dawn's treasure cache.";
      ["name_fr"] = "Armes de bataille excellentes - Honore aupres de l'Aube";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "精良的作?装? - ?色黎明尊敬";
      ["reward"] = {
         [1] = 22681;
         [2] = 22680;
         [3] = 22688;
         [4] = 22679;
         [5] = 22690;
         [6] = 22689;
      };
      ["name_de"] = "Uberragende Kampfausrustung - Wohlwollen der Dammerung";
      ["faction"] = "Horde";
      ["name"] = "Superior Armaments of Battle - Honored Amongst the Dawn";
      ["level"] = 60;
      ["name_es"] = "Armamento superior de batalla: honorable con El Alba";
      ["req"] = 55;
   };
   [4766] = {
      ["name_ru"] = "Майра Светлое Крыло";
      ["type"] = "Raid";
      ["objective"] = "Speak with Mayara Brightwing in the Burning Steppes.";
      ["next"] = 4764;
      ["name_fr"] = "Mayara Luisaile";
      ["sort"] = "Blackrock Spire";
      ["name_cn"] = "??拉・布莱特文";
      ["repgain"] = {
         [72] = 10;
      };
      ["name_de"] = "Mayara Wolkenglanz";
      ["faction"] = "Alliance";
      ["name"] = "Mayara Brightwing";
      ["level"] = 60;
      ["name_es"] = "Mayara Alasol";
      ["req"] = 57;
   };
   [1120] = {
      ["name_ru"] = "Напоить гномов";
      ["type"] = "Solo";
      ["name_fr"] = "Saoulez les gnomes";
      ["name_de"] = "Die Gnome betrunken machen";
      ["objective"] = "Bring the Fool's Stout to the Gnome Pit Boss.";
      ["name_cn"] = "灌醉侏儒";
      ["sort"] = "Thousand Needles";
      ["faction"] = "Horde";
      ["name"] = "Get the Gnomes Drunk";
      ["followup"] = 1122;
      ["prev"] = 1119;
      ["prequests"] = {
         [1] = 1119;
      };
      ["level"] = 44;
      ["name_es"] = "Emborrachar a los gnomos";
      ["req"] = 35;
   };
   [9319] = {
      ["name_ru"] = "Свет в темных местах";
      ["type"] = "Solo";
      ["objective"] = "Find and touch the bonfires located within Blackrock Spire, Dire Maul, Scholomance, and Stratholme, then return to the Festival Flamekeeper.";
      ["name_fr"] = "Une lumiere au sein des ombres";
      ["sort"] = "Midsummer";
      ["name_cn"] = "黑暗中的光明";
      ["reward"] = {
         [1] = 23083;
         [2] = 23247;
      };
      ["name_de"] = "Licht im Dunkeln";
      ["faction"] = "Alliance";
      ["name"] = "A Light in Dark Places";
      ["level"] = 60;
      ["name_es"] = "Una luz en la oscuridad";
      ["req"] = 50;
   };
   [8233] = {
      ["name_ru"] = "Приглашение";
      ["type"] = "Solo";
      ["objective"] = "Speak with Lord Jorach Ravenholdt in Ravenholdt Manor.";
      ["next"] = 8234;
      ["name_fr"] = "Une requete toute simple";
      ["sort"] = "Rogue";
      ["name_cn"] = "??的要求";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["repgain"] = {
         [349] = 10;
      };
      ["name_de"] = "Ein simples Anliegen";
      ["faction"] = "Horde";
      ["name"] = "A Simple Request";
      ["level"] = 52;
      ["name_es"] = "Un pedido sencillo";
      ["req"] = 50;
   };
   [8297] = {
      ["name_ru"] = "Ресурсы Низины Арати";
      ["type"] = "PvP";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Sergeant Maclear at Refuge Pointe.";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "阿拉希盆地的?源!";
      ["name_fr"] = "Les ressources du bassin d'Arathi";
      ["name_de"] = "Die Ressourcen des Arathibeckens";
      ["faction"] = "Alliance";
      ["name"] = "Arathi Basin Resources!";
      ["level"] = 60;
      ["name_es"] = "Los recursos de la Cuenca de Arathi";
      ["req"] = 60;
   };
   [9415] = {
      ["name_ru"] = "Маршал Синяя Синестен";
      ["type"] = "Solo";
      ["objective"] = "Speak with Marshal Bluewall at the Alliance encampment near Hive'Zora.";
      ["next"] = 9419;
      ["sort"] = "Silithus";
      ["name_cn"] = "向布?沃?元??告";
      ["name_fr"] = "Se presenter au marechal Murbleu";
      ["name_de"] = "Meldung bei Marschall Himmelswand";
      ["faction"] = "Alliance";
      ["name"] = "Report to Marshal Bluewall";
      ["level"] = 60;
      ["name_es"] = "Presentate ante el alguacil Murazul";
      ["req"] = 53;
   };
   [2772] = {
      ["name_ru"] = "Мир у твоих ног";
      ["type"] = "Solo";
      ["name_fr"] = "Le monde a vos pieds";
      ["name_de"] = "Die Welt zu Euren Fusen";
      ["objective"] = "Bring two Heavy Mithril Boots and one Ornate Mithril Pants to Trenton Lighthammer.$B";
      ["name_cn"] = "世界在?脚下";
      ["sort"] = "Blacksmithing";
      ["faction"] = "Horde";
      ["name"] = "The World At Your Feet";
      ["followup"] = 3321;
      ["prev"] = 2760;
      ["prequests"] = {
         [1] = 2760;
      };
      ["level"] = 45;
      ["name_es"] = "El mundo a tus pies";
      ["req"] = 40;
   };
   [2932] = {
      ["name_ru"] = "Предупреждение";
      ["type"] = "Solo";
      ["objective"] = "Gather Witherbark Skulls and place on Nimboya's Pike.  Place Nimboya's Laden Pike at one of the Witherbark Villages in the Hinterlands, then return to Nimboya in Stranglethorn.";
      ["repgain"] = {
         [530] = 250;
      };
      ["name_fr"] = "Sinistre message";
      ["sort"] = "The Hinterlands";
      ["name_cn"] = "可怕的消息";
      ["name_de"] = "Grausige Botschaft";
      ["faction"] = "Horde";
      ["name"] = "Grim Message";
      ["level"] = 42;
      ["name_es"] = "Un mensaje siniestro";
      ["req"] = 35;
   };
   [6804] = {
      ["name_ru"] = "Отравленная вода";
      ["type"] = "Solo";
      ["objective"] = "Use the Aspect of Neptulon on poisoned elementals of Eastern Plaguelands.  Bring 12 Discordant Bracers and the Aspect of Neptulon to Duke Hydraxis in Azshara.";
      ["repgain"] = {
         [76] = 250;
         [68] = 250;
         [81] = 250;
         [530] = 250;
      };
      ["name_fr"] = "Eau empoisonnee";
      ["sort"] = "Azshara";
      ["name_cn"] = "被囚禁的水元素";
      ["followup"] = 6821;
      ["name_de"] = "Vergiftetes Wasser";
      ["faction"] = "Horde";
      ["name"] = "Poisoned Water";
      ["level"] = 56;
      ["name_es"] = "Agua envenenada";
      ["req"] = 55;
   };
   [8045] = {
      ["name_ru"] = "Клеймо язычника";
      ["type"] = "Raid";
      ["objective"] = "";
      ["sort"] = "Zul'Gurub";
      ["name_fr"] = "La marque du paien";
      ["name_cn"] = "?教徒的烙印";
      ["classes"] = {
         [1] = "Paladin";
      };
      ["reward"] = {
         [1] = 19579;
      };
      ["name_de"] = "Das Emblem des Unglaubigen";
      ["faction"] = "Alliance";
      ["name"] = "The Heathen's Brand";
      ["level"] = 60;
      ["name_es"] = "La Ensena del pagano";
      ["req"] = 60;
   };
   [1482] = {
      ["name_ru"] = "Осквернитель душ";
      ["type"] = "Solo";
      ["objective"] = "Bring an Oracle Crystal to Maurin Bonesplitter in Desolace.";
      ["repgain"] = {
         [68] = 250;
      };
      ["name_de"] = "Der Verderber";
      ["name"] = "The Corrupter";
      ["name_cn"] = "堕落者";
      ["name_fr"] = "Le corrupteur";
      ["series"] = 3;
      ["faction"] = "Horde";
      ["sort"] = "Desolace";
      ["prev"] = 1481;
      ["prequests"] = {
         [1] = 1481;
      };
      ["level"] = 35;
      ["name_es"] = "El corruptor";
      ["req"] = 25;
   };
   [8165] = {
      ["name_ru"] = "Новые ящики с ресурсами";
      ["type"] = "PvP";
      ["name_fr"] = "D'autres caisses de ressources";
      ["sort"] = "Arathi Basin";
      ["name_cn"] = "更多的?源";
      ["objective"] = "Win the battle for Arathi Basin, get an Arathi Resource Crate, and return it to Deathstalker Mortis at Hammerfall.";
      ["faction"] = "Horde";
      ["name"] = "More Resource Crates";
      ["name_de"] = "Noch mehr Vorratskisten";
      ["prev"] = 8162;
      ["prequests"] = {
         [1] = 8162;
      };
      ["level"] = 25;
      ["name_es"] = "Mas cajas de suministros";
      ["req"] = 20;
   };
   [3088] = {
      ["name_ru"] = "Исписанный пергамент";
      ["type"] = "Solo";
      ["name_fr"] = "Parchemin code";
      ["repgain"] = {
         [76] = 75;
      };
      ["name_de"] = "Verschlusseltes Pergament";
      ["objective"] = "Read the Encrypted Parchment and speak to Rwag in the Valley of Trials.";
      ["name_cn"] = "密文羊皮?";
      ["sort"] = "Rogue";
      ["classes"] = {
         [1] = "Rogue";
      };
      ["name"] = "Encrypted Parchment";
      ["races"] = {
         [1] = "Orc";
      };
      ["prev"] = 788;
      ["prequests"] = {
         [1] = 788;
      };
      ["level"] = 1;
      ["name_es"] = "Papiro encriptado";
      ["req"] = 1;
   };
   [6182] = {
      ["name_ru"] = "Первый и последний";
      ["type"] = "Group";
      ["objective"] = "Speak with Mathias Shaw in Old Town Stormwind. He resides in the Barracks.";
      ["next"] = 6183;
      ["name_fr"] = "Le premier et le dernier";
      ["sort"] = "Stormwind City";
      ["name_cn"] = "第一个和最后一个";
      ["repgain"] = {
         [72] = 1;
      };
      ["name_de"] = "Der Erste und Letzte";
      ["faction"] = "Alliance";
      ["name"] = "The First and the Last";
      ["level"] = 60;
      ["name_es"] = "El primero y el ultimo";
      ["req"] = 56;
   };
   [3104] = {
      ["name_ru"] = "Символьное письмо";
      ["type"] = "Solo";
      ["name_fr"] = "Lettre glyphee";
      ["repgain"] = {
         [72] = 75;
      };
      ["name_de"] = "Glyphenbrief";
      ["objective"] = "Read the Glyphic Letter and speak to Khelden Bremen inside Northshire Abbey.";
      ["name_cn"] = "雕文信件";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Glyphic Letter";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 7;
      ["prequests"] = {
         [1] = 7;
      };
      ["level"] = 1;
      ["name_es"] = "Una carta glifica";
      ["req"] = 1;
   };
   [3108] = {
      ["name_ru"] = "Чеканная руна";
      ["type"] = "Solo";
      ["name_fr"] = "Rune gravee";
      ["repgain"] = {
         [47] = 75;
      };
      ["name_de"] = "Geatzte Rune";
      ["objective"] = "Read the Etched Rune and speak to Thorgas Grimson in Coldridge Valley.";
      ["name_cn"] = "??符文";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Etched Rune";
      ["races"] = {
         [1] = "Dwarf";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa con grabados";
      ["req"] = 1;
   };
   [3115] = {
      ["name_ru"] = "Гниющая записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note de service contaminee";
      ["repgain"] = {
         [54] = 50;
      };
      ["name_de"] = "Besudelte Rune";
      ["objective"] = "Read the Tainted Memorandum and speak to Alamar Grimm inside Anvilmar above Coldridge Valley.";
      ["name_cn"] = "被?染的?忘?";
      ["sort"] = "Warlock";
      ["classes"] = {
         [1] = "Warlock";
      };
      ["name"] = "Tainted Memorandum";
      ["races"] = {
         [1] = "Gnome";
      };
      ["prev"] = 179;
      ["prequests"] = {
         [1] = 179;
      };
      ["level"] = 1;
      ["name_es"] = "Runa corrupta";
      ["req"] = 1;
   };
   [6548] = {
      ["name_ru"] = "Отомсти за мою деревню";
      ["type"] = "Solo";
      ["objective"] = "Kill 8 Grimtotem Ruffians and 6 Grimtotem Mercenaries, and then return to Makaba Flathoof near the southeastern edge of Stonetalon.$B";
      ["next"] = 6629;
      ["name_fr"] = "Vengez mon village?!";
      ["sort"] = "Stonetalon Mountains";
      ["name_cn"] = "?我的村庄?仇";
      ["repgain"] = {
         [81] = 250;
      };
      ["name_de"] = "Racht mein Dorf";
      ["faction"] = "Horde";
      ["name"] = "Avenge My Village";
      ["level"] = 18;
      ["name_es"] = "Venga mi aldea";
      ["req"] = 12;
   };
   [6964] = {
      ["name_ru"] = "Повод для праздника";
      ["type"] = "Solo";
      ["objective"] = "Speak with Sagorne Creststrider in the Valley of Wisdom of Orgrimmar about the Feast of Winter Veil.";
      ["next"] = 7061;
      ["sort"] = "Hallow's End";
      ["name_cn"] = "冬幕?的意?";
      ["name_fr"] = "L'esprit de cette fete";
      ["name_de"] = "Der Anlass fur die Feiertage";
      ["faction"] = "Horde";
      ["name"] = "The Reason for the Season";
      ["level"] = 60;
      ["name_es"] = "El espiritu de esta fiesta";
      ["req"] = 10;
   };
   [4503] = {
      ["name_ru"] = "Крылолет Шиззла";
      ["type"] = "Solo";
      ["objective"] = "Collect 8 Webbed Diemetradon Scales and 8 Webbed Pterrordax Scales for Shizzle in Marshal's Refuge.";
      ["name_fr"] = "La machine volante de Shizzle";
      ["sort"] = "Un'Goro Crater";
      ["name_cn"] = "希??的?行器";
      ["reward"] = {
         [1] = 11915;
         [2] = 11916;
         [3] = 11917;
      };
      ["name_de"] = "Sappalots Flieger";
      ["faction"] = "Horde";
      ["name"] = "Shizzle's Flyer";
      ["level"] = 51;
      ["name_es"] = "El aparato volador de Shizzle";
      ["req"] = 49;
   };
   [1920] = {
      ["name_ru"] = "Синий Отшельник";
      ["type"] = "Solo";
      ["name_fr"] = "Trouver le Solitaire bleu";
      ["next"] = 1921;
      ["name_de"] = "Untersuchungen im Blauen Eremiten";
      ["objective"] = "Obtain a Cantation of Manifestation and a Chest of Containment coffers from behind Jennea Cannon.  Bring 3 Filled Containment Coffers to Jennea at the Wizard's Sanctum.";
      ["name_cn"] = "???色?士";
      ["sort"] = "Mage";
      ["classes"] = {
         [1] = "Mage";
      };
      ["name"] = "Investigate the Blue Recluse";
      ["races"] = {
         [1] = "Human";
      };
      ["prev"] = 1919;
      ["prequests"] = {
         [1] = 1919;
      };
      ["level"] = 16;
      ["name_es"] = "Investiga lo que pasa en El Ermitano Taciturno";
      ["req"] = 15;
   };
   [2160] = {
      ["name_ru"] = "Припасы для Таннока";
      ["type"] = "Solo";
      ["objective"] = "Deliver the Crate of Inn Supplies to Tannok Frosthammer in Kharanos.";
      ["repgain"] = {
         [54] = 25;
         [47] = 25;
      };
      ["sort"] = "Dun Morogh";
      ["name_fr"] = "Des provisions pour Tannok";
      ["name_cn"] = "塔?克的??品";
      ["reward"] = {
         [1] = 117;
         [2] = 159;
      };
      ["name_de"] = "Vorrate fur Tannok";
      ["faction"] = "Alliance";
      ["name"] = "Supplies to Tannok";
      ["level"] = 5;
      ["name_es"] = "Suministros para Tannok";
      ["req"] = 1;
   };
   [7028] = {
      ["name_ru"] = "Хрустальные орнаменты";
      ["type"] = "Dungeon";
      ["objective"] = "Collect 15 Theradric Crystal Carvings for Willow in Desolace.";
      ["name_fr"] = "Forces malefiques retorses";
      ["sort"] = "Maraudon";
      ["name_cn"] = "?曲的邪?";
      ["reward"] = {
         [1] = 17775;
         [2] = 17776;
         [3] = 17777;
         [4] = 17779;
      };
      ["name_de"] = "Dunkles Boses";
      ["faction"] = "Horde";
      ["name"] = "Twisted Evils";
      ["level"] = 47;
      ["name_es"] = "Los males de Maraudon";
      ["req"] = 41;
   };
   [7044] = {
      ["name_ru"] = "Легенды Мародона";
      ["type"] = "Dungeon";
      ["objective"] = "Recover the two parts of the Scepter of Celebras: the Celebrian Rod and the Celebrian Diamond.$B$BFind a way to speak with Celebras.";
      ["sort"] = "Maraudon";
      ["name_cn"] = "?拉?的??";
      ["name_fr"] = "Legendes de Maraudon";
      ["name_de"] = "Legenden von Maraudon";
      ["faction"] = "Horde";
      ["name"] = "Legends of Maraudon";
      ["level"] = 49;
      ["name_es"] = "Leyendas de Maraudon";
      ["req"] = 41;
   };
   [8572] = {
      ["name_ru"] = "Броня ветерана";
      ["type"] = "Solo";
      ["objective"] = "Bring 7 Cenarion Combat Badges, 4 Cenarion Logistics Badges and 4 Cenarion Tactical Badges to Vargus at Cenarion Hold in Silithus.  You must also attain Honored reputation with Cenarion Circle to be able to complete this quest.$B";
      ["name_fr"] = "La tenue de combat de veteran";
      ["sort"] = "Silithus";
      ["name_cn"] = "精兵的装?";
      ["reward"] = {
         [1] = 21181;
         [2] = 21182;
         [3] = 21183;
      };
      ["name_de"] = "Schlachtrustung des Veteranen";
      ["faction"] = "Horde";
      ["name"] = "Veteran's Battlegear";
      ["level"] = 60;
      ["name_es"] = "Equipamiento de Veterano";
      ["req"] = 60;
   };
   [3092] = {
      ["name_ru"] = "Нацарапанная записка";
      ["type"] = "Solo";
      ["name_fr"] = "Note gravee";
      ["repgain"] = {
         [81] = 75;
      };
      ["name_de"] = "Geatzte Notiz";
      ["objective"] = "Read the Etched Note and speak to Lanka Farshot in Red Cloud Mesa.";
      ["name_cn"] = "?化便?";
      ["sort"] = "Hunter";
      ["classes"] = {
         [1] = "Hunter";
      };
      ["name"] = "Etched Note";
      ["races"] = {
         [1] = "Tauren";
      };
      ["prev"] = 747;
      ["prequests"] = {
         [1] = 747;
      };
      ["level"] = 1;
      ["name_es"] = "La nota con grabados";
      ["req"] = 1;
   };
   [4183] = {
      ["name_ru"] = "Подлинные хозяева";
      ["objective"] = "Travel to Lakeshire and deliver Helendis Riverhorn's Letter to Magistrate Solomon. ";
      ["name_cn"] = "真正的主人";
      ["sort"] = "Burning Steppes";
      ["level"] = 54;
      ["type"] = "Solo";
      ["name_fr"] = "Les veritables maitres";
      ["next"] = 4184;
      ["name_de"] = "Die wahren Meister";
      ["repgain"] = {
         [69] = 150;
      };
      ["faction"] = "Alliance";
      ["name"] = "The True Masters";
      ["prev"] = 4182;
      ["prequests"] = {
         [1] = 4182;
      };
      ["series"] = 1;
      ["name_es"] = "Los verdaderos maestros";
      ["req"] = 48;
   };
   [6164] = {
      ["name_ru"] = "Книга рецептов Августа";
      ["type"] = "Solo";
      ["objective"] = "Bring Augustus' Receipt Book to Augustus the Touched in Terrordale.";
      ["sort"] = "Eastern Plaguelands";
      ["name_cn"] = "奥古斯?斯的收据册";
      ["name_fr"] = "Le livre de compte d'Augustus";
      ["name_de"] = "Augustus' Quittungsbuch";
      ["faction"] = "Horde";
      ["name"] = "Augustus' Receipt Book";
      ["level"] = 55;
      ["name_es"] = "Libro de entradas de Augustus";
      ["req"] = 50;
   };
   [7124] = {
      ["name_ru"] = "Захват рудника";
      ["type"] = "PvP";
      ["objective"] = "Capture a mine, then return to Corporal Teeka Bloodsnarl in the Alterac Mountains.";
      ["sort"] = "Alterac Valley";
      ["name_cn"] = "占??洞";
      ["name_fr"] = "Prendre une mine";
      ["name_de"] = "Eine Mine erobern";
      ["faction"] = "Horde";
      ["name"] = "Capture a Mine";
      ["level"] = 60;
      ["name_es"] = "Capturar una mina";
      ["req"] = 51;
   };
   [6383] = {
      ["name_ru"] = "Большая охота";
      ["type"] = "Solo";
      ["name_fr"] = "La Chasse d'Orneval";
      ["repgain"] = {
         [81] = 10;
      };
      ["name_cn"] = "灰谷狩?";
      ["sort"] = "Ashenvale";
      ["objective"] = "";
      ["name"] = "The Ashenvale Hunt";
      ["name_de"] = "Die Jagd im Eschental";
      ["faction"] = "Horde";
      ["prequests"] = {
         [1] = 235;
         [2] = 742;
         [3] = 6382;
      };
      ["level"] = 20;
      ["name_es"] = "La Caza de Vallefresno";
      ["req"] = 20;
   };
   [6583] = {
      ["name_ru"] = "Черепа: Сомнус";
      ["type"] = "Raid";
      ["name_fr"] = "L'epreuve des cranes, Somnus";
      ["name_de"] = "Die Prufung der Schadel, Somnus";
      ["objective"] = "Destroy the drake champion of the Green Flight, Somnus. Take his skull and return it to Emberstrife.";
      ["name_cn"] = "?骨??，索姆努斯";
      ["sort"] = "Dustwallow Marsh";
      ["faction"] = "Horde";
      ["name"] = "The Test of Skulls, Somnus";
      ["followup"] = 6585;
      ["prev"] = 6570;
      ["prequests"] = {
         [1] = 6570;
      };
      ["level"] = 60;
      ["name_es"] = "La prueba de los craneos, Somnus";
      ["req"] = 55;
   };
};
